; -*- Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  2 7/4/97   akh  see below
;;  17 1/22/97 akh  front-window returns first found rather than groveling whole window lis
;;  12 5/20/96 akh  windows - (find-class 'window) if arg is 'window
;;  11 4/24/96 akh  bill's fix for view-mouse-position
;;  8 3/9/96   akh  fixes for call-with-focused-view and call-with-port
;;  5 12/1/95  akh  %i+
;;  4 11/9/95  akh  add inverse-style-arg fix
;;  2 10/17/95 akh  merge patches
;;  11 6/6/95  akh  window-title and set-window-title deal with system script
;;  9 5/1/95   akh  remove misleading extended-character-p from do keydown-event
;;  8 4/28/95  akh  fix def-ccl-pointers fonts to be explicit about script
;;                  add a comment re: do-key-down-event is broken
;;  7 4/28/95  akh  probably no change
;;  3 4/10/95  akh  content-color initarg
;;  13 3/22/95 akh  fix stream-force-output for window
;;  12 3/20/95 akh  fix brain dead stream-force-output for window
;;  11 3/20/95 akh  dont remember
;;  10 3/14/95 akh  dont remember
;;  9 2/24/95  slh  window autopositioning!
;;  8 2/17/95  akh  change *window-object-alist* to a hash table
;;  7 2/9/95   akh  probably no change
;;  6 1/30/95  akh  incorporate kalmans patch to call-with-focused-view
;;  4 1/25/95  akh  windows get back-color initarg
;;  3 1/17/95  akh  use without-event-processing
;;  (do not edit before this line!!)

;; L1-windows.lisp
; Copyright 1985-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995-2000 Digitool, Inc.

;; Modification History
;
; add stuff for modified dot in close bubble - osx requires godawful kludge - thank you Takehiko Abe!
; -------- 5.0b5 or 6
; view-deactivate-event-handler ((w window)) - don't clear bubbles if collapsed
; akh new-new-window deals with equivalents of :tool and :no-border-box - from Walker Sigismund
; --------- 5.0b4
; 12-24-2002 ss window-event: don't flash window to front when a behind window's close bubble is clicked in OSX.
;               Ignore *disable-bubbles-on-inactive-windows* in view-activate-event-handler to ensure frontmost
;               bubbles are always active even if user changes *disable-bubbles-on-inactive-windows* mid-session.
; akh export *disable-bubbles...
; ----- 5.0b3
; collapse-bubble enabled in some cases when grow-icon-p is nil and close-box-p is true(??)
; add some stuff for close, collapse, and zoom bubbles - disable bubbles when window inactive
;  if you dont like it set ccl::*disable-bubbles-on-inactive-windows* to nil
; front-window may deem collapsed same as invisible
; wptr-color-p is real rather than always true
; view-mouse-position nil uses #_getglobalmouse rather than messing with %original-temp-port%
; %temp-port% and %original-temp-port% are at 0,0 vs 10,10 - don't ask me
; use get-osx-font-list always if carbon
; ------- 4.4b5
; window-update-event-handler from Shannon Spires
;; -------- 4.4b4
; 05/31/02 add theme-background to window-make-parts
; 05/20/02 fix set-window-layer for modal-dialog in presence of windoid. From Brendan Burns
; 04/13/02 view-deactivate-event-handler :before for OSX
;------------ 4.4b3
; 03/03/02 window-make-parts - setwindowclass always, not just if drag-receiver (fer OSX)
; 02/15/02 fix sys-font-spec to not cons in usual case
; 02/14/02 better end test in get-osx-font-list
; 12/07/01 fix new-new-window for $dboxproc
;;------------ 4.4b2
; 09/02/01 akh another osx-p fix in window-bring-to-front, use new-new-window from John M. if osx-p
; 09/01/01 akh use showwindow/hidewindow vs. showhide if osx-p
; 08/06/01 akh more crap in window-make-parts for IFT
; 07/23/01 akh initialize *script-list* in def-ccl-pointers fonts
; 06/06/01 akh much better *font-list* for OSX
; 05/15/01 akh funcall-with-foreign-window does set-cursor if osx-p
; 05/09/01 window-close-internal disposes window NOW if osx-p - maybe fix window whose in front problem?
; 05/09/01 see %new-window for disgusting OSX crock
; 04/15/01 akh valid-window-rect was wrong
; 04/11/01 akh set-view-font-codes for carbon
; 04/09/01 akh see get-the-current-window-drag-rect
; 03/31/01 akh see set-wptr-font-codes call to with-port - which is really supposed to be a wptr
; 01/15/01 akh window-close da-window does #_disposewindow (for Console that is busted anyway)
; akh window-make-parts no longer errors if window aint windoid, does change-class instead
; akh ignore-errors in print-object window
; 08/02/00 akh see window-make-parts for carbon
; 04/28/00 akh  window-select different for carbon. Fixes very weird behavior when windoids exist.
; ... #_SendBehind and some others (e.g. #_NewCWindow) have a concept of "classes" and should only specify windows
; ... of the same class. See also window-show-internal, window-send-behind.
; lots more carbon-compat for refs to windowrecord.xxx
; carbon-compat in %new-window
; carbon accessor-calls junk
; ----------- 4.3.1b1 ??
; 02/01/99 akh window-drag-event-handler - don't do getwmgrport if carbon
; 12/18/99 akh pop-up-path-menu actually does something - choose-file-dialog
; 07/20/99 akh window-under deal with no wptr
; ---------- 4.3f1c1
; 05/15/99 akh window-make-parts allows non windoid types for windoid - e.g. gc-thermometer
; --------------- 4.3b2
; 03/14/99 akh window-drag-event-handler mods for horizontal or vertical only from Toomas Altosaar
; 03/14/99 akh window-drag-event-handler deals with possible screen resolution change - request from Toomas Altosaar.
; 03/14/99 akh window-make-parts errors if windoid and window-type is not a windoid type
; 03/14/99 akh window-default-zoom-position and size - use true values for borders
; --------------- 4.3b1
; 02/14/99 akh edit-select-file deals with possible list from choose-file-dialog
; 11/18/98 akh windoid title defaults to ""
; 11/o6/98 akh set-view-font-codes - forget %ilogior etal
; 10/25/98 akh funcall-with-foreign-window - deactivate the loathsome windoids too - NOPE
; 10/12/98 *window-type-procid-alist* etc know about windoids as does window-make-parts - no more home grown windoids
; 09/28/98 akh def-ccl-pointers - set *sys-font-codes* to nil
; 07/26/98 akh window-title-height tells the truth as best it can
; 01/23/97 bill %new-window uses new add-points-16 instead of add-points to
;               prevent overflowing the range representable by a 32-bit integer.
; ------------- 4.0
; 12/08/96 akh  front-window returns first found rather than groveling whole window list
;  9/11/96 slh  window-save method (see comment)
; 08/27/96 bill funcall-with-foreign-window
; ------------- 4.0b1
; 07/30/96 gb   typo in (window-close (da-window).  Pass update events
;               to #_SystemEvent, since something else didn't.
; 05/17/96 bill (method view-activate-event-handler (window)) doesn't deactivate
;               any (transitive) container of the current-key-handler.
; ------------- MCL-PPC 3.9
; 03/28/96 bill (require-trap #_LM...) in do-wptrs & menubar-height
; 03/26/96  gb  lowmem accessors.
; 01/09/96 bill  %new-window passes the window-type value, not :window-type, to report-bad-arg
; 12/13/95 slh   pop-up-path-menu: use %local-to-global
; 12/11/95 slh   find-window: CmpString -> IUMagIDPString
; 11/08/95 bill  #_getenvirons -> #_GetScriptManagerVariable
;  5/19/95 slh   windoid show-on-resume-p slot
;  4/26/95 slh   call-with-focused-view, set-gworld, window-show: use ok-wptr
;                try Bill's window-close patch (kill process earlier)
;  4/21/95 slh   window-bring-to-front: check (and w wptr) - can go nil unexpectedly
;  4/20/95 slh   window-close: send whostate "Closed"
;  4/03/95 slh   moved windoid methods to windoid module; moved get-window-event-handler,
;                window-under here
;-------------- 3.0d18
;  2/24/95 slh   window class :auto-position initarg & autoposition method; menubar-height macro
;-------------- 3.0d17
; 01/13/95 alice set-window-layer check wptr and be woi
;  forget limiting menu-item title length in *windows-menu* -  cf  window-menu-item
;  find-window somewhat closer to documentation - still unreliable xabc = abc, works for fat strings
;  in/validate-control not used or exported
;  limit menu-item title length in *windows-menu* since window-title no longer limited - nah
;  window-draw-controls and window-invalidate-controls also dead code
;  define color-or-gray-p (view), window-activate/deactivate-controls are dead code
;  control-key in drag brings all windows of class of w near top
;--------------
;07/16/93 bill  do-keydown-event now handles 2-byte characters
;-------------- 3.0d11
;06/24/93 alice sys-font-spec does not cons when system font is constant.
;		Should be used for menu & item titles and window titles from pathnames.
;06/19/93 alice pop-up-path-menu uses sysfont not chicago 12
;05/05/93 bill  in pop-up-path-menu - make-menu-item takes two args
;04/29/93 bill  window-close-kills-process-p
;04/23/93 bill  map-windows now works independently of how the user
;               function rearranges the windows.
;04/21/93 bill  no args to event-dispatch - new *idle* handling
;04/15/93 bill  get rid of flashing caused by window-send-behind in
;               System 7. This still needs to be tested in System 6.
;04/06/93 bill  in window-send-behind: do nothing if the window is already where
;               it belongs. This eliminates inappropriate erasure in the
;               (new) front window when a modal dialog closes and there is a windoid
;               on the screen.
;-------------- 2.1d5
;04/17/93 alice added a path "menu" when command-click in title of window having a window-filename
;-------------- 2.1d4
;03/21/93 alice view-activate-event-handler (window) deactivates non-current-key-handlers
;02/21/93 alice new zoom size and position from Oliver (Thanks Oliver)
;02/15/93 alice window-select use (edit-menu) not *edit-menu*
;02/06/93 alice style-arg can be a number too
;02/04/93 alice instance-initialize for simple-view - set font before calling view-default-size
;01/28/93 alice added view-font-line-height cause view-font conses
;10/15/92 alice window-close-event-handler - CONTROL not COMMAND hides because
;		this is now called by the menu-item and command-w
;10/08/92 alice - let command key thru to view-key-event-handler;
; 03/24/93 bill killing of window-process moved to (method window-close :around (window))
;               so that the window will be completely closed if the call happens
;               in the window's process
; 03/23/93 bill (method call-with-focused-view :around (t t)) calls
;               window-process-enqueue-with-abort to ensure that the
;               *event-processor* never gets stuck waiting for a lock.
; 02/11/93 bill invalidate-grow-icon is now a generic function, and its
;               third argument is no more. validate-grow-icon is no more; it
;               had no callers.
; 02/04/93 bill window-event passes keydwn & autokey events to
;               *application* if the window is not active.
; 02/03/93 bill window-close-internal doesn't kill the *event-processor*
; 01/12/93 bill window-close-internal kills the window-process
; 01/08/93 bill window-lock
; 12/14/92 bill (method windoid-p (window)) -> (method windoid-p (t))
; 12/08/92 bill (method window-menu-item (window)) enables the menu
;               for the front window if it is not window-active-p
; 11/23/92 bill call window-size-parts later in the initialization sequence
;               (just before window-show)
; 11/12/92 bill add :movable-dialog to *window-type-procid-alist* and *window-type-foos*
; 11/11/92 bill The :COLOR-P initarg for the WINDOW class defaults to T.
; 09/14/92 bill windoid :window-type defaults to :windoid.
; 09/10/92 bill window-close-internal comes out of line from
;               (method window-close (window)).
; 09/08/92 bill (method instance-initialize :after (window)) now calls
;               window-show instead of window-select so that the :window-layer
;               initarg will work.
;               (method window-show-internal (window t)) is more likely to call
;               window-select.
;               (method set-window-layer (windoid t)) correctly handles a layer
;               of 0 for an invisible windoid.
;               New gf:  default-window-layer
; 09/03/92 bill window-event no longer sends mouse up, key up, null, or
;               key down events to inactive windows.
; 09/02/92 bill reselect-windows no longer calls view-activate-event-handler
;               on windows that are already active-p
; 09/01/92 bill clicking in a deactivated front window now reactivates it.
;               Before it simply called view-click-event-handler
; 08/24/92 bill in window-close-event-handler: window-close -> window-close-nicely
; 05/01/92 bill call-with-focused-view becomes a generic funtion for Engber.
; 11/20/92 gb   Don't say "'WINDOID" (tree shaker.)  Do say "process, lock".
;-------------- 2.0
; 03/15/92 bill Move the default VIEW-SIZE of the WINDOID class from
;               a default initarg of the class to a VIEW-DEFAULT-SIZE method.
;               This makes user VIEW-DEFAULT-SIZE methods be called.
;-------------- 2.0f3
; 02/24/92 bill (style-arg '(:bold)) no longer returns (%ilogior nil 1)
; 01/07/92 gb   don't require RECORDS.
; 12/27/91 bill (method set-view-font-codes (window)) now returns the
;               font codes instead of NIL.
; ------------- 2.0b4
; 11/08/91 gb   revert TARGET, fix compiler.
; 10/30/91 bill remove -iv on the end of slot names
; 10/28/91 bill %new-window detects %null-ptr-p values from #_NewWindow
; 10/24/91 bill In window-draw-event-handler, don't change the port before
;               calling SET-VIEW-POSITION.
; 10/21/91 bill stop TARGET from consing.
; 10/15/91 bill eradicate window-font & set-window-font
;               :erase-anonymous-invalidations initarg to the WINDOW class.
;               Remove consing from (in)validate-control, window-draw-grow-icon,
;               window-drag-event-handler
; 10/29/91 alice def-load-pointers => def-ccl-pointers
; 09/23/91 bill #'(setf view-nick-name) -> #'set-view-nick-name
; 09/13/91 bill with-focused-font-view -> with-font-focused-view
; 09/09/91 bill #_SelectWindow -> window-bring-to-front
;               Add #_ActivatePalette to window-select
; 09/21/91 bills fix to stream-write-string ((v simple-view)
;---------- 2.0b3
; 09/03/91 bill Startup initialization of *setgworld-available?*.  Rest is in l1;sysutils.lisp
;               fix (method initialize-instance (da-window))
; 08/30/91 alice window-select does (menu-update *edit-menu*)
; 08/26/91 bill to support sheet-view: view-window becomes generic, set-gworld, get-gworld, call-with-port
;               Unbogosify (method stream-force-output (window))
; 08/24/91 gb   use new trap syntax.
; 08/06/91 bill call-with-focused-view no longer defaults the font-view parameter
; 07/26/91 bill call view-default-size & view-default-position for views
;               other than windows and dialog-items.
; 07/25/91 bill prevent memory leak in (method initialize-instance (da-window))
;               Add window-invalid-region to make back patterns function correctly
; 07/21/91 gb   use DYNAMIC-EXTENT vice evil DOWNWARD-FUNCTION.
; 07/05/91 bill *last-null-event-time* checking moves to do-event
; 06/17/91 bill *current-font-view* handled by call-with-focused-view
;               focus-view takes a new optional font-view parameter.
;               call-with-focused-view's function takes one arg, the view.
;               *grow-bm* is no longer used.
;               set-view-size of a window sets the 'view-size slot too.
; 06/07/91 bill simple-view takes a :help-spec initarg
;-------------- 2.0b2
; 05/13/91 bill sort *font-list*
; 03/29/91 bill clear *last-mouse-click-window* in window-close
; 03/25/91 bill option-click on a window's title bar now sends it to the back
;               whether or not it was in the front.
; 03/22/91 bill window-draw-grow-icon calls _DrawGrowIcon
; 03/05/91 bill handle mac windows not in *window-object-alist* a bit better
; 02/07/91 bill (method window-filename (window)) => (method window-filename (stream))
;03/05/91 alice report-bad-arg gets 2 (args that is)
;----------- 2.0b1
; 01/29/91 bill fix window-make-parts & window-event to allow a window with
;               a zoom box, but no grow box.  I inadvertently removed this
;               possibility on 12/13.
; 01/18/91 bill set-view-container-slot => (setf view-container-slot)
;               set-wptr => (setf wptr-slot)
;               Both due to reversal of args in :writer methods.
; 01/16/91 bill (slot-value w 'window-grow-rect) -> (window-grow-rect w)
; 01/10/91 gb   window-null-event-handler - force-output iff *terminal-io* is a stream
; 01/03/91 bill remove :parent keyword from map-windows, windows, front-window
; 12/13/90 bill in window-make-parts: window-type & grow-icon-p need to interact
; 12/12/90 bill (slot-value w 'grow-icon-p) -> (window-grow-icon-p w)
; 12/07/90 bill option-click in close box closes only windows of the same
;               class as the one clicked on vice all windows that inherit from
;               that class.
; 11/05/90 bill gcable-wptr-p.  Do not allocate a clip-region or erase-region
;               for DA-WINDOW's
;               Process menu key events in DO-EVENT vice WINDOW-EVENT
;               Only call window-null-event once a tick to speed up
;               real-time stuff
;               In window-update-event-handler: Erase visrgn if back-color not white.
;               Fix window-zoom-event-handler
; 11/01/90 bill view-default-font
; 10/30/90 bill window-title uses slot-value-if-bound to avoid errors
;               during window creation (before WPTR is bound)
; 10/25/90 bill color-green, color-blue, color-red for bootstrapping.
; 10/23/90 bill set-view-container-slot, remove (defun wptr ...), replace with reader.
;10/18/90 bill If a default-button closed a window before it was activated,
;              The null wptr was sometimes referenced by the
;              view-activate-event-handler code.
;10/04/90 bill window-update-event-handler binds *processing-events* true.
;10/03/90 bill %class-cpl -> %inited-class-cpl
;09/21/90 bill add new-window-title to window-make-parts
;09/20/90 bill da-window's default view-font is NIL: let the DA decide.
;10/16/90 gb   no more %str-length.
;08/29/90 joe  added *window-default-position*, *window-default-size*
;              *window-default-zoom-position*, *window-default-zoom-size*
;              and window-default-zoom-size, window-default-zoom-position methods.
;              Removed the slots for above & changed def-load-pointers,
;              view-default-position & size to reflect above.
;              window-zoom-event-handler now uses window-zoom-size correctly
;              window-drag-event-handler now uses drag-rect correctly
;08/20/90 bill Add :class in windows, map-windows, front-window
;08/13/90 bill (method stream-force-output (window))
;08/10/90 bill Hide windows when user <Command>-clicks close box.
;              display-in-windows-menu to decide whether to display hidden windows.
;08/09/90 bill store window font-codes in the alist.  If they are stored only
;              in the wptr, then we sometimes see with-font-codes values.
;08/03/90 bill new view-valid slot.
;08/01/90 bill set-view-size-internal no longer invalidates controls.
;07/24/90 bill in window-event: ignore command keys that have no menu item.
;07/23/90 bill Eliminate duplicate fonts in *font-list*
;07/06/90 bill Remove color-window-mixin from window-color-p
;07/05/90 bill map-windows, windows, & front-window take keyword args now.
;              nix wptr-if-bound & color-window-mixin.
;06/25/90 bill add :procid keyword to window-make-parts
;06/22/90 bill :window-font -> :view-font
;              def-aux-init-functions for window class.
;06/21/90 bill ed-select-file calls #'fred instead of make-instance directly.
;06/19/90 bill (set-view-position window :centered) now works.
;06/13/90 bill windoid built on lisp-wdef-mixin
;06/07/90 gb   print-unreadable-object :identity vice :id.
;06/05/90 bill call-with-focused-view
;05/30/90 gb   use print-unreadable-object.
;05/29/90 bill Move %temp-port% def & initialization from sysutils.
;05/24/90 bill window-(de)activate-event-handler -> view-(de)activate-event-handler
;              window-draw-contents -> view-draw-contents
;              window-click-event-handler -> view-click-event-handler
;              window-position -> view-position, window-size -> view-size
;              Move *color-available* test to inside of %new-window
;05/23/90 bill (with-focused-font-view v ...) -> (with-focused-font-view (v v) ...)
;05/05/90 bill new scrap handler.
;05/04/90 bill window-draw-grow-icon: draw outline when window not highlighted.
;05/03/90 bill window-activate-event-handler does nothing if Lisp is in background.
;04/30/90 gb   Still in late April: use downward functions.  Set the wayback
;              machine for the late 20th century.  %iasr.
;04/24/90 bill view-window looks up the view hierarchy if it can't find the
;              window in the *window-alist*
;04/23/90 bill window-zoom-position & window-zoom-size now look in
;              view-alist first.  set-xxx puts value there.
;              Add invalidate-view to window-zoom-event-handler
;04/19/90 bill grow-icon-corners, and erase-p arg to invalidate-grow-icon & use it.
;04/18/90 bill grafport-write-string
;04/17/90 bill wptr-font-codes, set-wptr-font-codes.
;04/16/90 bill remove consing from stream-line-length.
;04/13/90 bill stream-tyo, stream-write-string, view-terpri now specialize
;              on simple-view instead on window.
;04/10/90 bill set-window-font returns the font. steam-write-string for window
;04/10/90  gz  view fonts.
;04/07/90 bill view-put doesn't add a property for a vlaue of NIL
;03/20/90 bill initialize-instance => instance-initialize
;03/15/90  gz  Do more stuff in the interim focus-view, otherwise fred-window
;              window-update breaks in various subtle ways in a level-1 lisp.
;              Made WPTR and #'(SETF WPTR) be smarter.
;03/13/90 bill in window-close: don't _DisposWindow %temp-port%,
;              window-type, window-color-p
;05/06/90 bill view-get & friends specialize on simple-view not window.
;03/05/90 bill stream-tyo passed too many args to window-terpri.
;              center-window bombed if position arg was malformed.
;              window-key-event-handler => view-key-event-handler.
;02/28/90 bill Add color-p initarg to window: call _NewCWindow in %new-window
;02/26/90 bill without-interrupts is now implicit in with-port.
;02/23/90 bill No without-interrupts around window-update-event-handler
;02/21/90 bill Make window-show deactivate *selected-window* before showing
;              a modal dialog.
;02/20/90 bill window-hide before removing subviews in window-close
;02/15/90 bill window-get & friends => view-get & friends.
;01/26/90 bill Add window-alist, window-get, window-put, window-remprop
;01/04/90 bill Add windoids.
;12/26/89 bill map-windows added, used for windows, front-window, find-window.
;12/23/89 bill Clicking inDrag with the command key down does NOT select the window,
;              moves it in its layer.
;11/13/89 bill Add optional first arg to edit-select-file.
;10/4/89  gz NEW-install-window-object -> install-window-object.
;09/27/89 gb simple-string -> ensure-simple-string.
;09/16/89 bill Removed the last vestiges of object-lisp windows.
;09/13/89 bill Make edit-select-file create a CLOS fred-window if it can
;09/12/89 bill Make window-make-parts use set-window-title to set the title.
;              Fred depends on this.
;              Remove the title from %new-window & initialize-window
;09/12/89 bill Add window-title initarg to window-make-parts
;09/06/89 bill add print-object for window.
;              window-title (window): prevent error if wptr slot unbound.
;09/05/89 bill window-close-event-handler: update to work with option key again
;09/05/89 bill Make initialize-instance for window a primary method instead
;              of an :after method. Some user's of it needed this.
;08/30/89 blll window-event: (_ask nil ...) as some dialog functions are now both
;              obfuns and methods (kluge, kluge)
;08/25/89 bill window-menu-item: change to CLOS menus.
;08/25/89 bill (defmethod clos-window-update-cursor ...) & (def_obfun window-update-cursor ...)
;          ==> (defmethod window-update-cursor ...) & (def_obfun window-object-update-cursor ...)
;07/18/89 bill window-title: add comments.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


#|
(in-package :traps)
;; in newest c interfaces for 1.1d12 but not here yet - HERE NOW
(eval-when (:compile-toplevel :execute) 
(deftrap-inline "_SetWindowClass" 
      ((a (:pointer :windowrecord)) (v  :unsigned-long) )
  :osstatus
   () ))
|#

(in-package :ccl)
(eval-when (:compile-toplevel :execute)
  ;; somebody seems to be confused about boolean
  (deftrap-inline "_SetWindowModified" 
      ((window (:pointer :windowrecord)) (modified :uint8)) 
  :osstatus
   () ))

;; use this if you want to say t or nil
(defun set-wptr-modified (wptr what)
  (#_setwindowmodified wptr (if (or (null what)(eq what 0)) 0 1)))

#|
;; modified/not modified is indicated on OS9 by dimming/undimming this frob in the title bar
(#_SetWindowProxyCreatorAndType (wptr (target)) :|CCL2| :|TEXT| #$kOnSystemDisk)
|#



#+carbon-compat
(defun getwindowclass (wptr)
  (rlet ((cls :unsigned-long))
    (#_getwindowclass wptr cls)
    (%get-unsigned-long cls)))

;To do: Change window-object to just search all objects if not found in alist.


(defvar *font-list* ())
(defvar *big-rgn* nil)
(defvar *big-rect* nil)
;(defvar *grow-bm* nil)
(defvar %temp-port%)
(defvar %original-temp-port%)
(defvar *grow-icon-rgn*)
(export '(inval-window-rect valid-window-rect valid-window-rgn inval-window-rgn)
        (find-package :ccl))

(defun inval-window-rect (wptr rect)
  (declare (ignore-if-unused wptr))
  (declare (optimize (speed 3)(safety 0)))
  #+carbon-compat
  (#_invalwindowrect wptr rect)
  #-carbon-compat
  (#_invalrect rect))

(defun valid-window-rect (wptr rect)
  (declare (ignore-if-unused wptr))
  (declare (optimize (speed 3)(safety 0)))
  #+carbon-compat
  (#_validwindowrect wptr rect)
  #-carbon-compat
  (#_validrect rect))

(defun valid-window-rgn (wptr rgn)
  (declare (ignore-if-unused wptr))
  (declare (optimize (speed 3)(safety 0)))
  #+carbon-compat
  (#_validwindowrgn wptr rgn)
  #-carbon-compat
  (#_validrgn rgn))

(defun inval-window-rgn (wptr rgn)
  (declare (ignore-if-unused wptr))
  (declare (optimize (speed 3)(safety 0)))
  #+carbon-compat
  (#_invalwindowrgn wptr rgn)
  #-carbon-compat
  (#_invalrgn rgn))

#+carbon-compat
(progn 
;; this one appears to have problems
(defun get-window-updatergn (wptr rgn)
  (#_getwindowregion wptr #$kWindowUpdateRgn rgn)
  rgn)

(defun get-window-strucrgn (wptr rgn)
  (#_getwindowregion wptr #$kWindowStructureRgn rgn)
  rgn)


#| ;; NO SUCH THING
(defun set-window-strucrgn (wptr rgn)
  (#_setwindowregion wptr #$kWindowStructureRgn rgn)
  rgn)
|#

(defun get-window-contrgn (wptr rgn)
  (#_getwindowregion wptr #$kWindowContentRgn rgn)
  rgn)



(defun get-window-visrgn (wptr rgn)
  (with-macptrs ((port (#_getwindowport wptr))) ;; its really just wptr today    
    (#_getportvisibleregion port rgn)
    rgn))

(defun get-window-cliprgn (wptr rgn)
  (if (#_isvalidwindowptr wptr)
    (with-macptrs ((port (#_getwindowport wptr)))
      (#_getportclipregion port rgn))
    (#_getportclipregion wptr rgn))
    rgn)

(defun set-window-cliprgn (wptr rgn)
  (if (#_isvalidwindowptr wptr)
    (with-macptrs ((port (#_getwindowport wptr)))
      (#_setportclipregion port rgn))
    (#_setportclipregion wptr rgn))
    rgn)

(defun set-window-visrgn (wptr rgn)
  (with-macptrs ((port (#_getwindowport wptr)))
    (#_setportvisibleregion port rgn)
    rgn))

(defun get-window-pnloc (wptr)
  (with-macptrs ((port (#_getwindowport wptr)))
    (rlet ((point :point))
      (#_getportpenlocation port point)
      (%get-long point))))  
  

(defun get-port-visrgn (port rgn)
  (#_getportvisibleRegion port rgn)
  rgn)
)
  





(defun simple-string< (a b)
  (let ((la (length a))
        (lb (length b)))
    (dotimes (i (min la lb) (< la lb))
      (let ((ca (%scharcode a i))
            (cb (%scharcode b i)))
      (if (< ca cb)(return t)
          (if (/= ca cb) (return nil)))))))

(defun simple-string= (a b)
  (let ((la (length a)))
    (when (= la (length b))
      (dotimes (i la t)
        (when (/= (%scharcode a i)(%scharcode b i))
          (return nil))))))




#-carbon-compat  ;; dont make no sense but avoids udf compiler warning
(defun get-osx-font-list ()
  ;; there is some hairy assed way to find the fonts under OSX - for now lets assume these exist
  (let ((a (list "Chicago" "Courier" "Geneva" "Helvetica" "Monaco" "Times")))
    (%sort-list-no-key (pushnew (car (sys-font-spec)) a :test #'equalp) #'simple-string<)))


#+carbon-compat
(defmethod dummy-menu-install ((menu menu))
  (unless (slot-value menu 'menu-handle)
    ;(dbg 16)
    (init-menu-id menu)
    (with-pstrs ((tp (slot-value menu 'title)))
      (#_InsertMenu  ;; whats that do 
       (setf (slot-value menu 'menu-handle)
             (#_NewMenu (slot-value menu 'menu-id) tp))
       -1))))

#+carbon-compat
(defun nuke-menu (menu &aux mh md)
  (when (setq md (slot-value menu 'menu-id))
    (deallocate-menu-id md)
    (setf (slot-value menu 'menu-id) nil))
  (when (setq mh (slot-value menu 'menu-handle))
    (#_DeleteMenu md)
    (#_DisposeMenu mh)
    (setf (slot-value menu 'menu-handle) nil)))

#+carbon-compat
(defun get-osx-font-list ()  
  (let* ((menu (make-instance 'menu))
         (res nil))
    (dummy-menu-install menu)
    (let ((handle (menu-handle menu)))
      (rlet ((foo :unsigned-long))
        ;; what a load of fonts
        (let ((err (#_CreateStandardFontMenu handle 0 0 0 foo)))
          (declare (ignore err))
          ;(setq poop (%get-long foo)) ;; what isit
          ))
      (let ((itemnum 1)
            (nitems (#_CountMenuItems handle))) 
        (loop
          (rlet ((fam :signed-integer)
                 (style :signed-integer))
            (when (> itemnum nitems) (return))
            (let ((err (#_GetFontFamilyFromMenuSelection handle itemnum fam style)))
              (if (or (eq err #$menuItemNotFoundErr)(eq err #$paramerr)) ;; what the hell is the end test??
                (return)
                (let ((family (%get-signed-word fam)))
                  (incf itemnum)                  
                  (without-interrupts
                   (let* ((script (#_FontToScript family)))
                     (when (not (memq script *script-list*))
                       (let ((flag (#_getscriptmanagervariable #$smdefault)))
                         (when (eq flag 0) (push script *script-list*))))))
                  (%stack-block ((str 256))
                    (#_getfontname family str)
                    (let ((name (%get-string str)))
                      (push name res)
                      )))))))
        (nuke-menu menu)
        (nreverse res)))))

(def-ccl-pointers fonts ()  
  (rlet ((r :rect :topleft #-carbon-compat #@(10 10) #+carbon-compat #@(0 0) 
            :bottomright #-carbon-compat #@(110 110) #+carbon-compat #@(100 100))  ;; huh
         (tp (:string 2)))
    (%put-word tp #x0120) ;; vs random junk ?? 
    (setq %temp-port%
          (#-CARBON-COMPAT #_NewWindow #+Carbon-compat #_NewCWindow 
           (%null-ptr)
           r                            ; bounds
           tp                           ; blank title
           nil                          ; invisible
           4                            ; procid: document
           #-carbon-compat
           (%int-to-ptr -1)             ; behind
           #+carbon-compat
           (%null-ptr)
           nil                          ; no goAwayFlag
           4                            ; refCon
           )))
  (setq %original-temp-port% %temp-port%)
  (setq *sys-font-codes* nil *sys-font-spec* nil)
  (let* ((script (#_GetScriptManagerVariable  #$smSysScript)))
    (setq *script-list* (list script))
    (setq *grow-icon-rgn*  (#_NewRgn))
    (setq
     *font-list*
     (if #-carbon-compat t #+carbon-compat nil
       (%sort-list-no-key
        (unwind-protect
          (%stack-block ((ip 2) (tp 4) (np 256))
            (#_SetResLoad nil)
            (do* ((index (#_CountResources "FOND") (1- index))
                  (ret nil))
                 ((eq index 0) ret)
              (#_GetResInfo (#_GetIndResource "FOND" index) ip tp np)
              (let ((f (%get-word ip)))
                (without-interrupts
                 (let* ((script (#_FontToScript f)))
                   (when (not (memq script *script-list*))
                     (let ((flag (#_getscriptmanagervariable #$smdefault)))
                       (when (eq flag 0) (push script *script-list*))))))) ; flag false if installed
              
              (let ((s (%get-string np 0 script)))
                (unless (member s ret :test #'simple-string=)
                  (push s ret)))))
          (#_SetResLoad t))
        #'simple-string<)
       ;; there is some other hairy assed way to find the fonts under OSX
       (get-osx-font-list)))
    (setq *big-rgn* (#_NewRgn))
    (#_SetRectRgn *big-rgn* -32768 -32768 32767 32767)
    ;; aint used
    #|
    (setq *big-rect* (#_NewPtr 8))
    (#_SetRect *big-rect* -32768 -32768 32767 32767)
     |#
    #|
  (setq *grow-bm* (#_NewPtr :errchk 78))
  (%put-ptr *grow-bm* (%inc-ptr *grow-bm* 14)) ;BaseAddr
  (%put-word *grow-bm* 2 4) ;rowbytes
  (%put-long *grow-bm* 0 6)
  (%put-long *grow-bm* #x100010 10)
  (with-pstrs ((s1 "FFFF800080009FE09020903E90229022902290229FE284028402840287FE8000"))
    (#_StuffHex (%inc-ptr *grow-bm* 14) s1))
|#
    ))
  

(eval-when (:execute :compile-toplevel)
  (defconstant $noAutoCenter #x0000)
  (defconstant $centerMainScreen #x280a)
  (defconstant $alertPositionMainScreen #x300a)
  (defconstant $staggerMainScreen #x380a)
  (defconstant $centerParentWindow #xa80a)
  (defconstant $alertPositionParentWindow #xb00a)
  (defconstant $staggerParentWindow #xb80a)
  (defconstant $centerParentWindowScreen #x680a)
  (defconstant $alertPositionParentWindowScreen #x700a)
  (defconstant $staggerParentWindowScreen #x780a))

(eval-when (:execute :compile-toplevel)
  ; :noAutoCenter must be first (see autoposition)
  (defconstant autopos-constraints
    `((:noAutoCenter . (nil nil #.$noAutoCenter))
      (:centerMainScreen . (:center :main-screen #.$centerMainScreen))
      (:alertPositionMainScreen . (:alert-pos :main-screen #.$alertPositionMainScreen))
      (:staggerMainScreen . (:stagger :main-screen #.$staggerMainScreen))
      (:centerParentWindow . (:center :parent-window #.$centerParentWindow))
      (:alertPositionParentWindow . (:alert-pos :parent-window #.$alertPositionParentWindow))
      (:staggerParentWindow . (:stagger :parent-window #.$staggerParentWindow))
      (:centerParentWindowScreen . (:center :parent-window-screen #.$centerParentWindowScreen))
      (:alertPositionParentWindowScreen . (:alert-pos :parent-window-screen #.$alertPositionParentWindowScreen))
      (:staggerParentWindowScreen . (:stagger :parent-window-screen #.$staggerParentWindowScreen))))
  
  (defmacro autopos-placement (key)
    `(cadr (assoc ,key autopos-constraints)))
  
  (defmacro autopos-bounds (key)
    `(caddr (assoc ,key autopos-constraints)))
  
  (defmacro autopos-id (key)
    `(cadddr (assoc ,key autopos-constraints))))

#-carbon-compat
(defmacro do-wptrs (wptr &body body)
  (let ((next-wptr (gensym)))
    `(with-macptrs ((,wptr #-carbon-compat (require-trap #_LMGetWindowList)
                           #+carbon-compat (require-trap #_GetWindowList))
                    ,next-wptr)
       (do () ((%null-ptr-p ,wptr))
         (%setf-macptr ,next-wptr (rref ,wptr windowrecord.nextwindow))
         ,@body
         (%setf-macptr ,wptr ,next-wptr)))))

#+carbon-compat
(defmacro do-wptrs (wptr &body body)
  (let ((next-wptr (gensym)))
    `(with-macptrs ((,wptr (require-trap #_GetWindowList))
                    ,next-wptr)
       (do () ((%null-ptr-p ,wptr))
         (%setf-macptr ,next-wptr (require-trap #_getnextwindow ,wptr))
         ,@body
         (%setf-macptr ,wptr ,next-wptr)))))

(defmacro do-all-windows (w &body body)
  (let ((wptr (gensym)))
    `(do-wptrs ,wptr
      (let ((,w (window-object ,wptr)))
        (when ,w
          ,@body)))))

(defmacro menubar-height ()
  `(require-trap #_GetMBarHeight))

(defun class-inherit-from-p (class parent-class)
  (flet ((get-class (value)
           (if (symbolp value) (find-class value nil) value)))
    (let ((pclass (get-class parent-class)))
      (memq pclass
            (%inited-class-cpl (get-class class))))))

(defun windows (&key class include-invisibles include-windoids)
  (cond ((eq class 'window)
         (setq class nil))
        ((and class (symbolp class))
         (setq class (find-class class))))
  (when (and class (class-inherit-from-p class (find-class 'windoid)))
    (setq include-windoids t))
  (let ((windows nil))
    (without-interrupts
     (do-wptrs wptr
       (let ((wob (window-object wptr)))
         (when (and wob
                    (or include-windoids
                        (not (windoid-p wob)))
                    (or (not class)(inherit-from-p wob class))
                    (or include-invisibles #-carbon-compat (rref wptr windowrecord.visible)
                                           #+carbon-compat (#_iswindowvisible wptr)))
           (setq windows (cheap-cons wob windows))))))
    (nreverse windows)))

(defun map-windows (function &key class include-invisibles include-windoids)
  (let ((windows (windows :class class
                          :include-invisibles include-invisibles
                          :include-windoids include-windoids)))
    (unwind-protect
      (dolist (w windows)
        (funcall function w))
      (cheap-free-list windows))
    nil))

(defun front-window (&key class include-invisibles include-windoids)
  (when class 
    (when (symbolp class)(setq class (find-class class))) 
    (when (class-inherit-from-p class (find-class 'windoid))
      (setq include-windoids t)))
  (do-wptrs wptr
    (let ((wob (window-object wptr)))
      (and wob
           (or include-windoids
               (not (windoid-p wob)))
           (or (not class)(inherit-from-p wob class))
           
           (or include-invisibles 
               #-carbon-compat (rref wptr windowrecord.visible) 
               #+carbon-compat (and (#_iswindowvisible wptr)(or (not (osx-p)) ;; or always ?
                                                                (not (#_iswindowcollapsed wptr)))))
           (return wob)))))


(defun target ()
  (let* ((first? nil)
         (temp #'(lambda (w)
                   (if first?
                     (return-from target w)
                     (setq first? t)))))
    (declare (dynamic-extent temp))
    (map-windows temp)))

(defun find-window (title &optional class)
  (with-pstrs ((tp title))
    (let* ((len   (%get-byte tp 0))
           (len+1 (%i+ len 1)))
      (%stack-block ((np 256))
        (with-macptrs ((tp1 (%inc-ptr tp 1))
                       (np1 (%inc-ptr np 1))
                       (np2 (%inc-ptr np 2)))
          (let* ((mapper #'(lambda (w)
                             (#_GetWTitle (wptr w) np)
                             (let ((tlen (%get-byte np)))
                               (when (or (and (eql tlen len)
                                              #-carbon-compat
                                              (%izerop (#_IUMagIDPString np1 tp1 len len (%null-ptr)))
                                              #+carbon-compat
                                               (%izerop (#_Identicaltext np1 tp1 len len (%null-ptr))))
                                         (and (eql tlen len+1)
                                              #-carbon-compat
                                              (%izerop (#_IUMagIDPString np2 tp1 len len (%null-ptr)))
                                              #+carbon-compat
                                              (%izerop (#_IdenticalText np2 tp1 len len (%null-ptr)))))
                                 (return-from find-window w))))))
            (declare (dynamic-extent mapper))
            (map-windows mapper
                         :class class
                         :include-windoids t)))))))

(defun hilite-wptr (wptr hilite?)
  (when wptr                            ; may have disappeared.
    (unless (eq hilite? #-carbon-compat (rref wptr windowrecord.hilited) #+carbon-compat (#_iswindowhilited wptr))
      (#_HiliteWindow wptr hilite?)
      t)))

; Nobody actually calls this, but it shows how to maintain the
; state of the window hiliting and activation correctly.
(defun fix-windows ()
  (if (da-or-modal-dialog-on-top-p)
    (unselect-windows t)
    (reselect-windows)))

(defun da-or-modal-dialog-on-top-p ()
  (or *modal-dialog-on-top* (typep *selected-window* 'da-window)))

; Unhilite & deactivate all the windows.
; Leave the first one alone if skip-first? is true
(defun unselect-windows (&optional skip-first?)
  (with-macptrs ((wptr #-carbon-compat (#_LMGetWindowList)
                       #+carbon-compat (#_GetWindowList)))
    (when skip-first?
      (unless (%null-ptr-p wptr)
        (setq wptr #-carbon-compat (rref wptr windowrecord.nextwindow) #+carbon-compat (#_getnextwindow wptr))))
    (until (%null-ptr-p wptr)
      (when #-carbon-compat (rref wptr windowrecord.visible) #+carbon-compat (#_iswindowvisible wptr)
        (let ((wob (window-object wptr)))
          (if (and wob (typep (wptr wob) 'macptr))
            (view-deactivate-event-handler wob)
            (hilite-wptr wptr nil))))
      (%setf-macptr wptr #-carbon-compat (rref wptr windowrecord.nextwindow) #+carbon-compat (#_getnextwindow wptr)))))

(defvar *last-windoid* nil)

; Hilite & activate the windows.
; Move windoids to the front.
; If *selected-window* is a DA, pick a non-DA to select.
; If *selected-window* is nil, leave it that way.
; Update *last-windoid* and *windoid-count*
(defun reselect-windows ()
  (let ((selected *selected-window*)
        last-windoid
        found-non-windoid?
        (da-before-selected? :maybe)
        (windoid-count 0))
    (if (typep selected 'da-window)
      (setq selected nil))
    (do-wptrs wptr
      (when #-carbon-compat (rref wptr windowrecord.visible) #+carbon-compat (#_iswindowvisible wptr)
        (let ((wob (window-object wptr)))
          (cond ((or (null wob) (not (typep (wptr wob) 'macptr)))
                 (hilite-wptr wptr nil))
                ((windoid-p wob)
                 (if found-non-windoid?
                   (if last-windoid
                     (window-send-behind wptr (wptr last-windoid) t)
                     (window-bring-to-front wob wptr)))
                 (setq last-windoid wob)
                 (unless (window-active-p wob)
                   (view-activate-event-handler wob))
                 (setq windoid-count (%i+ windoid-count 1)))
                (t
                 (setq found-non-windoid? t)
                 (if (typep wob 'da-window) 
                   (if (eq :maybe da-before-selected?)
                     (setq da-before-selected? t))
                   (if (and (eq wob (or selected (setq selected wob)))
                            (eq :maybe da-before-selected?))
                     (setq da-before-selected? nil))))))))
    (setq *windoid-count* windoid-count
          *last-windoid* last-windoid)
    (when *selected-window*           ; maybe nobody is selected
      (setq *selected-window* selected)
      (when (eq t da-before-selected?)
        (if last-windoid
          (window-send-behind (wptr selected) (wptr last-windoid) t)
          (window-bring-to-front selected)))
      (unless (window-active-p selected)
        (view-activate-event-handler selected)))))

(defun fix-window-hiliting ()
  (let* ((first-window? nil)
         (temp #'(lambda (w)
                   (let ((wptr (wptr w)))
                     (if (typep w 'windoid)
                       (hilite-wptr wptr t)
                       (if first-window?
                         (hilite-wptr wptr nil)
                         (progn
                           (hilite-wptr wptr t)
                           (setq first-window? t))))))))
    (declare (dynamic-extent temp))   
    (map-windows
     temp
     ;:class 'window
     :include-invisibles nil
     :include-windoids t)))

(defun edit-select-file (&optional w &aux (name (choose-file-dialog
                                                :mac-file-type "TEXT")))
  (declare (ignore w))                  ; called from a comtab sometimes.
  (when name
    (fred (if (consp name)(car name) name))))

(defun style-arg (arg &aux val (ret 0))
  (if (symbolp arg)
    (if (setq ret (%cdr (assq arg *style-alist*)))
      ret
      (%err-disp $err-bad-input arg))
    (dolist (sym arg ret)
      (if (setq val (%cdr (assq sym *style-alist*)))
        (setq ret (%ilogior2 ret val))
        (%err-disp $err-bad-input sym)))))

(defun inverse-style-arg (arg)  
  (if (eq 0 arg)
    (dolist (e *style-alist* nil)
      (if (eq 0 (cdr e))(return (car e))))
    (let ((val))
      (dotimes (i 7)
        (when (logbitp i arg)
          (let* ((n (ash 1 i))
                 (it (dolist (e *style-alist* nil)
                       (if (eq n (cdr e))(return (car e))))))
            (when it (if (consp val)
                       (push it val)
                       (if val
                         (setq val (list it val))
                         (setq val it)))))))
      (or val
          (%err-disp $err-bad-input arg)))))
      

(defun make-style (num &aux ret)
 (dolist (elt *style-alist* ret)
  (if (eq num (%cdr elt)) (return-from make-style (%car elt)))
  (if (neq 0 (%ilogand2 num (%cdr elt))) (setq ret (cons (%car elt) ret)))))
#|
(defun get-window-control (wptr ctype &optional (hCtl (%null-ptr)))
  (%setf-macptr hCtl (rref wptr windowrecord.ControlList))
  (until (%null-ptr-p hCtl)
    (if (eq ctype (rref hCtl controlrecord.contrlrfcon))
      (return-from get-window-control hCtl)
      (%setf-macptr hCtl (rref hCtl controlrecord.nextcontrol))))
  nil)
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                              view                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Note: Most of the view code is in lib;views.lisp: not in level 1.

; a simple-view is used for dialog-items.  It cannot have subviews.
(defclass simple-view (output-stream)
  ((view-container :initform nil 
                   :reader view-container)
   (wptr :initarg :wptr :initform nil :reader wptr)
   (view-position :initform #@(0 0) :initarg :view-position :reader view-position)
   (view-size :initform #@(100 100) :initarg :view-size :reader view-size)
   (view-nick-name :initform nil :initarg :view-nick-name :reader view-nick-name)
   (view-alist :initform nil :accessor view-alist)
   ))

(defmethod view-default-size ((view simple-view)) #@(100 100))
(defmethod view-default-position ((view simple-view)) #@(0 0))

(defmethod set-view-container-slot ((view simple-view) value)
  (setf (slot-value view 'view-container) value))

(defmethod set-wptr ((view simple-view) value)
  (setf (slot-value view 'wptr) value))

(defmethod set-view-nick-name ((view simple-view) new-name)
  (setf (slot-value view 'view-nick-name) new-name))

(defclass view (simple-view)
  ((view-valid :initform nil :accessor view-valid)   ; for lazy clip-region updating.
   (view-scroll-position :initform #@(0 0) :initarg :view-scroll-position
                         :accessor view-scroll-position)
   (view-origin :initform #@(0 0) :accessor view-origin-slot)
   (view-subviews :initform (make-array 1 :adjustable t :fill-pointer 0)
                  :reader view-subviews)
   (view-clip-region :initform nil :accessor view-clip-region-slot)))

(defmethod (setf wptr) (wptr (v simple-view))
  (setf (slot-value v 'wptr) (and wptr (require-type wptr 'macptr))))

(defmethod initialize-instance ((view simple-view) &rest initargs &key
                                (view-font (view-default-font view)))
  (declare (dynamic-extent initargs))
  (apply #'call-next-method
         view
         :view-font view-font
         initargs))

(defmethod instance-initialize :after ((view simple-view) &key
                                       view-container view-font help-spec
                                       (view-size nil vsp)
                                       (view-position nil vpp))
  (declare (ignore view-size view-position))
  (when (and view-font (not (typep view 'window)))
    (set-initial-view-font view view-font))
  (when help-spec
    (setf (view-get view :help-spec) help-spec))
  (unless vsp (setf (slot-value view 'view-size) (view-default-size view)))
  (unless vpp (setf (slot-value view 'view-position)(view-default-position view)))
  (when view-container
    (set-view-container view view-container)))

(defmethod instance-initialize :after ((v view) &key view-subviews)
  (dolist (subview view-subviews)
    (set-view-container subview v)))

(defmethod view-contains-p ((view view) contained-view)
  (let ((container (view-container contained-view)))
    (while container
      (if (eq container view)
        (return-from view-contains-p t))
      (setq container (view-container container)))))

(defmethod view-contains-p ((view null) contained-view)
  (declare (ignore contained-view))
  nil)

(defmethod view-font ((view simple-view))
  (multiple-value-bind (ff ms) (view-font-codes view)
    (font-spec ff ms)))


(defmethod view-font-line-height ((view simple-view))
  (multiple-value-bind (a d w l) (view-font-codes-info view)
    (declare (ignore w))
    (%i+ a d l)))

(defmethod view-font-codes-info ((view simple-view))
  (multiple-value-call #'font-codes-info (view-font-codes view)))

(defmethod set-view-font ((view simple-view) font-spec)
  (multiple-value-bind (ff ms) (view-font-codes view)
    (multiple-value-bind (ff ms) (font-codes font-spec ff ms)
      (set-view-font-codes view ff ms)))
  font-spec)

(defmethod set-initial-view-font ((view simple-view) font-spec)
  (set-view-font view font-spec))

(defmethod view-font-codes ((view simple-view))
  (let ((codes (view-get view 'view-font-codes)))
    (if codes
      (values (car codes) (%cdr codes))
      (let ((container (view-container view)))
        (and container (view-font-codes container))))))

(defmethod set-view-font-codes ((view simple-view) ff ms &optional ff-mask ms-mask)
  (let ((codes (view-get view 'view-font-codes)))
    (if codes
      (let ((old-ff (car codes))
            (old-ms (%cdr codes)))
        (if ff-mask
          (setq ff (logior (logand ff ff-mask) 
                           (logand old-ff (lognot ff-mask)))))
        (if ms-mask
          (setq ms (logior (logand ms ms-mask) 
                           (logand old-ms (lognot ms-mask)))))
        (%rplacd (rplaca codes ff) ms))
      (view-put view 'view-font-codes (cons ff ms)))
    (values ff ms)))

(defvar *quieted-view* nil)

(defmacro with-quieted-view-if (view predicate &body body)
  (let ((view-var (gensym)))
  `(let* ((,view-var ,view)             ; make sure we eval the view form
          (*quieted-view* *quieted-view*))
     (when (and ,predicate (not (view-contains-p *quieted-view* ,view-var)))
       (setq *quieted-view* ,view-var))
     ,@body)))

(defmacro with-quieted-view (view &body body)
  `(with-quieted-view-if ,view t ,@body))

(defun view-quieted-p (view)
  (let ((qv *quieted-view*))
    (and qv (or (eq view qv) (view-contains-p qv view)))))

; Toggle blinkers is so that user windoid code can make fred-dialog-items blink
; at the proper time.
(defmethod toggle-blinkers ((item simple-view) on-p)
  (declare (ignore on-p)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                             window                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defclass window (view)
  ((window-cursor :allocation :class :reader window-cursor)
   (window-grow-rect :allocation :class :reader window-grow-rect)
   (window-drag-rect :allocation :class :reader window-drag-rect)

   (color-list :initform nil :reader window-color-list)
   (back-color :initform nil)
   (object-name :initform nil)
   (my-item :initform nil)
   (grow-icon-p :initform nil :reader window-grow-icon-p)
   (window-do-first-click :initform nil :accessor window-do-first-click
                          :initarg :window-do-first-click)
   (window-active-p :initform nil :accessor window-active-p)
   (window-erase-region :initform (#_NewRgn) :accessor window-erase-region)
   (window-invalid-region :initform nil :accessor window-invalid-region)
   (process :initform nil :initarg :process :accessor window-process)
   (queue :initform (make-process-queue "Window") :reader window-process-queue)
   (auto-position :initarg :auto-position :initform :noAutoCenter)))

(defmethod initialize-instance ((w window) &rest initargs &key auto-position)
  (declare (dynamic-extent initargs))
  (if (and auto-position
           (null (assq auto-position autopos-constraints)))
    (error "~S must be one of ~S" auto-position
           (mapcar #'car (cdr autopos-constraints)))
    (apply #'call-next-method w :auto-position auto-position initargs)))

(defmethod windoid-p (w)
  (declare (ignore w))
  nil)

(defmethod view-default-font ((window window))
  *fred-default-font-spec*)

(defmethod view-default-font ((view simple-view))
  nil)

(defmethod window-zoom-position ((w window))
  (or (view-get w 'window-zoom-position)
      (window-default-zoom-position w)))

(defmethod set-window-zoom-position ((w window) h &optional v)
  (if h
    (setf (view-get w 'window-zoom-position) (make-point h v))
    (view-remprop w 'window-zoom-position)))

(defmethod window-zoom-size ((w window))
  (or (view-get w 'window-zoom-size)
      (window-default-zoom-size w)))

(defmethod set-window-zoom-size ((w window) h &optional v)
  (if h
    (setf (view-get w 'window-zoom-size) (make-point h v))
    (view-remprop w 'window-zoom-size)))
#|
(defmethod window-default-zoom-position ((w window))
  *window-default-zoom-position*)

(defmethod window-default-zoom-size ((w window))
  *window-default-zoom-size*)
|#

(defconstant $window-zoom-border 2 "Leave this much border around the zoomed window.")

(defun get-struc-and-cont-rects (wptr strucrect contrect)
  (declare (ignore-if-unused wptr strucrect contrect))
    #+carbon-compat
    (progn
      (#_getwindowbounds wptr #$kwindowstructurergn strucrect) ;; its defined but not found in libs
      (#_getwindowbounds wptr #$kwindowcontentrgn contrect))
    #-carbon-compat
    (error "shouldn't"))

(defun get-cont-rect (wptr contrect)
  (declare (ignore-if-unused wptr contrect))
  #+carbon-compat
  (progn    
    (#_getwindowbounds wptr #$kwindowcontentrgn contrect))
  #-carbon-compat
  (error "shouldn't"))
  

(defmethod window-title-height ((window window))
  (let ((wptr (wptr window)))
    (if (not (window-shown-p window))
      (window-type-title-height (window-type window))
        #+carbon-compat
        (rlet ((strucrect :rect)
               (contrect :rect))
          (get-struc-and-cont-rects wptr strucrect contrect)
          (- (pref contrect :rect.top)(pref strucrect :rect.top)))
        #-carbon-compat
        (with-macptrs ((struc (pref wptr windowrecord.strucrgn))
                       (cont (pref wptr windowrecord.contrgn)))
          (- (href cont region.rgnbbox.top)(href struc region.rgnbbox.top))))))

(defmethod window-border-width ((window window))
  (let ((wptr (wptr window)))
    (if (not (window-shown-p window))
      (window-type-border-width (window-type window))
        #+carbon-compat
        (rlet ((strucrect :rect)
               (contrect :rect))
          (get-struc-and-cont-rects wptr strucrect contrect)
          (- (pref contrect :rect.left)(pref strucrect :rect.left)))
        #-carbon-compat
        (with-macptrs ((struc (pref wptr windowrecord.strucrgn))
                       (cont (pref wptr windowrecord.contrgn)))
          (- (href cont region.rgnbbox.left)(href struc region.rgnbbox.left))))))

(defmethod window-right-border-width ((window window))
  (let ((wptr (wptr window)))
    (if (not (window-shown-p window))
      (window-type-border-width (window-type window))
        #+carbon-compat
        (rlet ((strucrect :rect)
               (contrect :rect))
          (get-struc-and-cont-rects wptr strucrect contrect)
          (- (pref strucrect :rect.right)(pref contrect :rect.right)))
        #-carbon-compat
        (with-macptrs ((struc (pref wptr windowrecord.strucrgn))
                       (cont (pref wptr windowrecord.contrgn)))
          (- (href struc region.rgnbbox.right)(href cont region.rgnbbox.right))))))

(defmethod window-bottom-border-width ((window window))
  (let ((wptr (wptr window)))
    (if (not (window-shown-p window))
      (window-type-border-width (window-type window))
        #+carbon-compat
        (rlet ((strucrect :rect)
               (contrect :rect))
          (get-struc-and-cont-rects wptr strucrect contrect)
          (- (pref strucrect :rect.bottom)(pref contrect :rect.bottom)))
        #-carbon-compat
        (with-macptrs ((struc (pref wptr windowrecord.strucrgn))
                       (cont (pref wptr windowrecord.contrgn)))
          (- (href struc region.rgnbbox.bottom)(href cont region.rgnbbox.bottom))))))

(defun window-type-border-width (type)
  (case type
    ((:shadow-edge-box :single-edge-box) 1)
    (:double-edge-box 8)
    (t 6)))
  

(defun window-type-title-height (type)
  (case type
    ((:shadow-edge-box :single-edge-box) 1)
    (:double-edge-box 8)
    (:movable-dialog 23)
    (t (if (and (fboundp 'appearance-available-p)(appearance-available-p)) 22 19))))
    

;; Find the screen that overlaps most of the window (or the main screen, if the
;; window doesn't overlap any screens), and return the bounds of the part of that
;; screen that is usable.  This is the entire screen bounds, unless the screen
;; is the main screen, in which case the top portion is consumed by the menubar.
(defun window-preferred-screen-bounds (window &aux (mbar-height (menubar-height)))
  (if *color-available*
    (rlet ((rect :rect :topLeft #@(0 0) :bottomRight (view-size window)))
      (#_OffsetRect :pointer rect :longint (view-position window))
      (let* ((main (#_GetMainDevice))
             (best -1)
             st sl sb sr)
        (flet ((set-to-device-bounds (devicePtr main-device-p)
                 (setf sl (pref devicePtr GDevice.gdRect.left)
                       st (+ (pref devicePtr GDevice.gdRect.top)
                             (if main-device-p mbar-height 0))
                       sr (pref devicePtr GDevice.gdRect.right)
                       sb (pref devicePtr GDevice.gdRect.bottom))))
          (do ((device (#_GetDeviceList) (#_GetNextDevice device)))
              ((%null-ptr-p device))
            (with-dereferenced-handles ((devicePtr device))
              (rlet ((intersection :rect))
                (#_SectRect rect (pref devicePtr GDevice.gdRect) intersection)
                (let ((area (* (- (pref intersection rect.bottom) (pref intersection rect.top))
                               (- (pref intersection rect.right) (pref intersection rect.left)))))
                  (when (> area best)
                    (setf best area)
                    (set-to-device-bounds devicePtr (eql device main)))))))
          (unless sl
            (with-dereferenced-handles ((devicePtr main))
              (set-to-device-bounds devicePtr t))))
        (values sl st sr sb)))
    (values 0 mbar-height *screen-width* *screen-height*)))


;; The window's new position.  If its origin remains on the same screen, and its
;; old position and new size allow it to fit entirely on that screen, leave it
;; where it is, otherwise move it.
#|
(defmethod window-default-zoom-position ((window window))
  (multiple-value-bind (sl st sr sb) (window-preferred-screen-bounds window)
    (let* ((pos (view-position window))
           (current-h (point-h pos))
           (current-v (point-v pos))
           (size (window-default-zoom-size window))
           (new-width (point-h size))
           (new-height (point-v size))
           (moved-h (+ sl $window-zoom-border))
           (moved-v (+ st $window-zoom-border (window-title-height window))))
      ;; If origin of the window is still on the same screen...
      (if (and (<= sl current-h (1- sr))
               (<= st current-v (1- sb)))
        ;; ...then keep the same coordinates where they allow the window to remain
        ;; wholly on the screen, and use the new ones where the old ones don't...
        (make-point (if (< (+ current-h new-width $window-zoom-border) sr) current-h moved-h)
                    (if (< (+ current-v new-height $window-zoom-border) sb) current-v moved-v))
        ;; otherwise go ahead and move the window.
        (make-point moved-h moved-v)))))
|#

(defmethod window-default-zoom-position ((window window))
  (multiple-value-bind (sl st sr sb) (window-preferred-screen-bounds window)
    (let* ((pos (view-position window))
           (current-h (point-h pos))
           (current-v (point-v pos))
           (size (window-default-zoom-size window))
           (new-width (point-h size))
           (new-height (point-v size))
           (left-border (window-border-width window))
           ;(bottom-border (window-bottom-border-width window))
           (moved-h (+ sl left-border 1))
           (moved-v (+ st 2 (window-title-height window))))
      ;; If origin of the window is still on the same screen...
      (if (and (<= sl current-h (1- sr))
               (<= st current-v (1- sb)))
        ;; ...then keep the same coordinates where they allow the window to remain
        ;; wholly on the screen, and use the new ones where the old ones don't...
        (make-point (if (< (+ current-h new-width left-border 1) sr) current-h moved-h)
                    (if (< (+ current-v new-height 2) sb) current-v moved-v))
        ;; otherwise go ahead and move the window.
        (make-point moved-h moved-v)))))


;; The minimum of the window's preferred size and the usable window area
;; of the window's preferred screen.
#|
(defmethod window-default-zoom-size ((window window))
  (multiple-value-bind (sl st sr sb) (window-preferred-screen-bounds window)
    (let* ((psize (view-preferred-size window))
           (ph (min (point-h psize) (- sr sl
                                       $window-zoom-border $window-zoom-border)))
           (pv (min (point-v psize) (- sb st (window-title-height window)
                                       $window-zoom-border $window-zoom-border))))
      (make-point ph pv))))
|#

(defmethod window-default-zoom-size ((window window))
  (multiple-value-bind (sl st sr sb) (window-preferred-screen-bounds window)
    (let* ((left-border (window-border-width window))
           (right-border (window-right-border-width window))
           (bottom-border (window-bottom-border-width window))
           (psize (view-preferred-size window))
           (ph (min (point-h psize) (- sr sl
                                       left-border right-border 1)))
           (pv (min (point-v psize) (- sb st (window-title-height window)
                                       bottom-border 2)))) ;; huh?
      (make-point ph pv))))

(defmethod view-preferred-size ((w window))
  #@(3000 3000))
  

(defmethod view-valid-p ((view simple-view)) t)

(defmethod view-valid-p ((view view))
  (not (memq nil (view-valid view))))

(defmethod make-view-valid ((view simple-view) &optional dont-inval-subviews)
  (declare (ignore dont-inval-subviews))
  view)

(defmethod make-view-valid ((view view) &optional dont-inval-subviews)
  (let ((valid (view-valid view)))
    (unless (or (null valid) (car valid))
      (setf (%car valid) t)
      (unless dont-inval-subviews
        (dovector (subview (view-subviews view))
          (make-view-invalid subview)))))
  view)

(defmethod make-view-invalid ((view simple-view)) view)

(defmethod make-view-invalid ((view view))
  (let ((valid (view-valid view)))
    (when (and valid (car valid))
      (setf (%car valid) nil)))
  view)

(defmethod view-allocate-clip-region ((view view))
  (let ((rgn (view-clip-region view)))
    (or rgn
        (setf (view-clip-region-slot view) (#_NewRgn)))))

(defmethod view-clip-region ((view view))
  (let ((rgn (view-clip-region-slot view)))
    (unless (or (null rgn) (view-valid-p view))
      (let ((container (view-container view)))
        (compute-view-origin view container)
        (make-view-valid view)
        (compute-view-region view rgn container)))
    rgn))

(defmethod compute-view-region ((view window) rgn container)
  (declare (ignore container))
  (when rgn
    (let* ((topleft (view-origin view))
           (botright (add-points topleft (view-size view))))
      (#_SetRectRgn rgn (point-h topleft) (point-v topleft) (point-h botright) (point-v botright))))
  rgn)

(defmethod compute-view-origin ((view view) container)
  (setf (view-origin-slot view)
        (if container
          (add-points (subtract-points (view-scroll-position view)
                                       (view-position view))
                      (view-origin container))
          (view-scroll-position view))))

(defmethod view-origin ((view view))
  (if (view-valid-p view)
    (view-origin-slot view)
    (let ((container (view-container view)))
      (prog1
        (compute-view-origin view container)
        (make-view-valid view)
        (compute-view-region view (view-clip-region-slot view) container)))))
  
(defmethod window-event-handler ((w window))
  w)

; what if there are no windows
(defmethod window-event-handler (( w t))())

(defmethod toggle-blinkers ((w window) on-p)
  (let ((key-handler (current-key-handler w)))
    (when key-handler
      (toggle-blinkers key-handler on-p))))


(defclass da-window (window)
  ())

(defmethod view-default-font ((window da-window))
  nil)

; This class is here to remove the lisp wdef from a window's wptr on window-close.
; _DisposWindow calls the wdef from inside the GC, so it can't be in Lisp at that time.
(defclass lisp-wdef-mixin () ())

(defclass windoid (window lisp-wdef-mixin) 
  ((show-on-resume-p :initform nil))
  (:default-initargs
    :window-title ""
    :window-do-first-click t
    :window-type :windoid))

(defun get-window-event-handler ()
  (window-event-handler (front-window :include-windoids t)))

(defvar *windoid-count* 0)

(def-ccl-pointers clos-window ()
  (let ((window (find-class 'window)))
    (set-class-slot-value window 'window-cursor *arrow-cursor*)
    (let ((rect (#_NewPtr 8)))
      (#_SetRect rect 32 32 32767 32767)
      (set-class-slot-value window 'window-grow-rect rect))
    (let ((rect (#_NewPtr 8)))
      #-carbon-compat
      (#_BlockMove (rref (%getport) grafport.portbits.bounds) rect 8)
      #+carbon-compat
      (with-macptrs ((port (%getport))
                     (pixmap (#_getportpixmap port)))
        (setf (pref rect :rect.topleft) (href pixmap :pixmap.bounds.topleft))
        (setf (pref rect :rect.botright)(href pixmap :pixmap.bounds.botright)))
      (#_InsetRect rect 4 4)
      (set-class-slot-value window 'window-drag-rect rect)))
  ; Initialized for real in sysutils
  (setq *setgworld-available?* nil *screen-gdevice* nil))


(defun get-the-current-window-drag-rect (w)
  (let* ((window (find-class 'window))
         (now-rect (window-drag-rect w)))
    (with-macptrs ((rect (#_newptr 8)))
      #-carbon-compat
      (#_BlockMoveData (rref (%getport) grafport.portbits.bounds) rect 8)
      #+carbon-compat
      (with-port-macptr port
        (with-macptrs ((pixmap (#_getportpixmap port)))
          (setf (pref rect :rect.topleft) (href pixmap :pixmap.bounds.topleft))
          (setf (pref rect :rect.botright)(href pixmap :pixmap.bounds.botright))))
      (#_insetrect rect 4 4)
      (if (or (not (eql (rref now-rect :rect.botright) (rref rect :rect.botright)))
              (not (eql (rref now-rect :rect.topleft)(rref rect :rect.topleft))))
        (let ((new-rect (#_newptr 8)))
          (#_blockmovedata rect new-rect 8)
          (set-class-slot-value window 'window-drag-rect new-rect)
          (get-current-screen-size)
          new-rect)
        now-rect))))

    
    

(defmethod print-object ((w window) stream)
  (print-unreadable-object (w stream :identity t)
    (format stream "~a ~s"
            (class-name (class-of w)) 
            (ignore-errors (window-title w)))))

(defmethod view-get ((w simple-view) key &optional default)
  (let ((cell (assq key (view-alist w))))
    (if cell
      (cdr cell)
      default)))

(defmethod view-put ((w simple-view) key value)
  (let ((cell (assq key (view-alist w))))
    (if cell
      (setf (cdr cell) value)
      (unless (null value)
        (push (cons key value) (view-alist w))))
    value))

(defmethod (setf view-get) (value (w simple-view) key)
  (view-put w key value))

(defmethod view-remprop ((w simple-view) key)
  (setf (view-alist w)
        (delete key (view-alist w) :test #'(lambda (x y) (eq x (car y))))))

(defmethod set-view-container ((w window) container)
  (unless (null container)
    (error "Container must always be ~s for windows." nil)))

; Note: this can't be an :after method because some of its user's change
; its args and I'm avoiding :around methods.
(defmethod instance-initialize ((window window) &rest initargs &key
                                (erase-anonymous-invalidations t))
  (declare (dynamic-extent initargs))
  (setf (view-valid window) (list nil))
  (view-allocate-clip-region window)
  (when erase-anonymous-invalidations
    (setf (window-invalid-region window) (#_newrgn)))
  (call-next-method)
  (without-interrupts
   (let* ((wptr (wptr window)))
     (unwind-protect
       (progn
         (apply #'window-make-parts window initargs)
         (install-window-object window)
         (apply #'initialize-window window initargs)
         (setq wptr t))
       (if (null wptr)
         (window-close window))))))

; This is an after method so that the subviews will get added before the window
; is shown.
(defmethod instance-initialize :after ((window window) &key (window-show t))
  (window-size-parts window)
  (when window-show
    (window-show window)))
#|
(defconstant $documentProc 0)
(defconstant $dBoxProc 1)
(defconstant $plainDBox 2)
(defconstant $altDBoxProc 3)
(defconstant $noGrowDocProc 4)
(defconstant $movableDBoxProc 5)
(defconstant $zoomDocProc 8)
(defconstant $zoomNoGrow 12)
(defconstant $rDocProc 16)
;  floating window defproc ids 
(defconstant $floatProc 1985)
(defconstant $floatGrowProc 1987)  :windoid-with-grow
(defconstant $floatZoomProc 1989)  :windoid-with-zoom
(defconstant  1991) :windoid-with-zoom-grow
(defconstant $floatSideProc 1993)  :windoid-side
(defconstant $floatSideGrowProc 1995)
(defconstant $floatSideZoomProc 1997)
(defconstant $floatSideZoomGrowProc 1999)
|#

(defparameter *window-type-procid-alist*
 `((:document . ,#$nogrowdocproc)
   (:movable-dialog . ,#$movabledboxproc)
   (:document-with-grow . ,#$documentproc)
   (:document-with-zoom . ,#$zoomdocproc)
   (:document-with-zoom-no-grow . ,#$zoomnogrow)
   (:no-border-box . ,#$kWindowSimpleProc)
   (:tool . ,#$rdocproc)
   (:double-edge-box . ,#$dboxproc)
   (:single-edge-box . ,#$plaindbox)
   (:shadow-edge-box . ,#$altdboxproc)
   ;(:windoid . 32)  ;; huh
   (:windoid . ,#$floatProc)
   (:windoid-with-grow . ,#$floatGrowProc)
   (:windoid-with-zoom . ,#$floatZoomProc)
   (:windoid-with-zoom-grow . ,#$floatZoomGrowProc)
   (:windoid-side . ,#$floatSideProc)
   (:windoid-side-with-grow . ,#$floatSideGrowProc)
   (:windoid-side-with-zoom . ,#$floatSideZoomProc)
   (:windoid-side-with-zoom-grow . ,#$floatSideZoomGrowProc)))
   

(defparameter *window-type-foos* 
  '(member :document :movable-dialog :document-with-grow :document-with-zoom :document-with-zoom-no-grow
    :tool :double-edge-box :single-edge-box :shadow-edge-box :windoid
    :windoid-with-grow
   :windoid-with-zoom
   :windoid-with-zoom-grow
   :windoid-side
   :windoid-side-with-grow
   :windoid-side-with-zoom
   :windoid-side-with-zoom-grow
    ))

(defparameter *grow-procids*
  (list #$documentProc #$zoomDocProc #$floatGrowProc #$floatZoomGrowProc #$floatSideGrowProc #$floatSideZoomGrowProc))

(defparameter *dialog-procids*
  (list #$movabledboxproc #$rdocproc #$dboxproc #$plaindbox #$altdboxproc))

(defun wptr-dialog-p (wptr)
  (ignore-errors (not (null (member (#_getwrefcon wptr) *dialog-procids* :test #'eql )))))

(defparameter *windoid-types*
  '(:windoid
    :windoid-with-grow
    :windoid-with-zoom
    :windoid-with-zoom-grow
    :windoid-side
    :windoid-side-with-grow
    :windoid-side-with-zoom
    :windoid-side-with-zoom-grow))



(defmethod window-make-parts ((window window)
                              &key (view-position (view-default-position window) pos-p)
                              (view-size (view-default-size window) size-p)
                              (window-type :document-with-zoom wtype-p)
                              back-color
                              content-color
                              theme-background
                              procid
                              (window-title  "Untitled")
                              (close-box-p t)
                              (color-p t)
                              (grow-icon-p nil gip?))
  (unless (wptr window)
    (if procid (setq gip? nil grow-icon-p nil))
    (when gip?
      (if grow-icon-p
        (cond ((eq window-type :document) (setq window-type :document-with-grow))
              ((eq window-type :windoid) (setq window-type :windoid-with-grow))
              ((eq window-type :windoid-side)(setq window-type :windoid-side-with-grow))
              ((eq window-type :windoid-with-zoom)(setq window-type :windoid-with-zoom-grow))
              ((eq window-type :windoid-side-with-zoom)(setq window-type :windoid-side-with-zoom-grow))
              ((not (memq  window-type '(:document-with-grow :document-with-zoom
                                         :windoid-with-grow :windoid-with-zoom-grow :windoid-side-with-grow
                                         :windoid-side-with-zoom-grow)))
               (setq gip? nil grow-icon-p nil)))
        (cond ((eq window-type :document-with-grow) (setq window-type :document))
              ((eq window-type :document-with-zoom) (setq window-type :document-with-zoom-no-grow))
              ((eq window-type :windoid-with-grow) (setq window-type :windoid))
              ((eq window-type :windoid-side-with-grow)(setq window-type :windoid-side))
              ((eq window-type :windoid-side-with-zoom-grow)(setq window-type :windoid-side-with-zoom))
              ;; this is wrong?
              ((not (memq window-type '(:document :document-with-zoom)))
               (setq gip? nil grow-icon-p nil)))))
    (when wtype-p
      (when (and (not (typep window 'windoid)) (memq window-type *windoid-types*))
        ;(error "Need to make a windoid for window-type ~s." window-type)
        (change-class window 'windoid)        
        (when (not pos-p)(setq view-position (view-default-position window)))
        (when (not size-p)(setq view-size (view-default-size window)))
        )
      (when nil ;(and (typep window 'windoid)(not (memq window-type *windoid-types*)))
        (report-bad-arg window-type (cons 'member *windoid-types*))))
    (let* ((wptr (%new-window (or procid window-type)
                              view-position
                              view-size
                              close-box-p
                              nil
                              color-p))
           (procid #-carbon-compat (rref wptr windowrecord.refCon) #+carbon-compat (#_getwrefcon wptr)))   ; %new-window leaves it there
      (setf (wptr window) wptr)      
      #+ignore ;; - too slow
      (when (and nil (not pos-p) (eql view-position *window-default-position*))
        (set-view-position window #@(-3000 -3000))
        (window-show window)
        (let ((left-border (window-border-width window))
              (title-height (window-title-height window)))
          (window-hide window)
          (set-view-position window (make-point (max (1+ left-border)(point-h view-position))
                                                (max (+ title-height 2 (menubar-height)) (point-v view-position))))))
      (set-window-title window window-title)
      (setf (slot-value window 'grow-icon-p)
            (if gip? grow-icon-p (memq procid  *grow-procids*)))
      (when content-color  ;; is this used for anything?
        (set-part-color window :content content-color)
        ;(set-part-color window :title-bar *white-color*) doesnt help
        )
      (when back-color
        (setf (slot-value window 'back-color) back-color)  ; <<
        (set-back-color window back-color))
      (when (and theme-background (osx-p))
        (view-put window 'theme-background 
                  (if (eq theme-background t)
                    (setq theme-background #$kThemeBrushModelessDialogBackgroundActive)
                    theme-background))
        (#_SetThemeWindowBackground wptr theme-background t))
      (when (and (osx-p)
                 close-box-p
                 (not (typep window 'windoid))
                 (not (slot-value window 'grow-icon-p))
                 (not (wptr-dialog-p wptr)))
        (Set-bubble-attributes window #$kWindowCollapseBoxAttribute))
        
      #+carbon-compat
      (if (typep window 'windoid)
        (#_setwindowclass wptr #$kFloatingWindowClass )
        (when (and (wptr-dialog-p wptr)) ;(find-class 'drag-receiver-dialog nil)(typep window 'drag-receiver-dialog))
          ; make it non-modal till actually used modally - for IFT or for everybody
          (#_setwindowclass wptr #$kDocumentWindowClass )  ;; do we really need both of these?
          (setwindowmodality wptr #$kWindowModalityNone)
          )))))

#+carbon-compat
(defun setwindowmodality (wptr mode)
  (rlet ((dumdum :windowrecord))
    (#_SetWindowModality wptr mode dumdum)))

(defmethod view-default-position ((w window))
  *window-default-position*)

(defmethod view-default-size ((w window))
  *window-default-size*)

; Same as add-points, but limits the resulting dimensions
; to (signed-byte 16) range, similar to what the old add-points used to do.
(defun add-points-16 (pt1 pt2)
  (let ((h (+ (point-h pt1) (point-h pt2)))
        (v (+ (point-v pt1) (point-v pt2))))
    (make-point
     (min (max h -32768) 32767)
     (min (max v -32768) 32767))))
#|
(defconstant $kFirstWindowOfClass -1)
(defconstant $kLastWindowOfClass 0)
|#

#+ignore
(defun poop (position size close-box-p type)
  (rlet ((rect :rect :topleft position :bottomright (add-points-16 position size))
         (res :ptr))
    (#_createnewwindow
     #$kDocumentWindowClass
     (if close-box-p #$kWindowCloseBoxAttribute 0)
     rect
     res)
    (let ((wptr (%get-ptr res)))
      (#_movewindow wptr (point-h position)(point-v position) #$false)
      (#_setwrefcon wptr type)
      (ed-beep)
      wptr)))

(defun new-new-window (type position size close-box-p visible-p)

  (let ((wclass nil) (wattrs 0) (the-window nil) (err nil))
   
    ;; decode the type to calculate class and attributes
    
    (case type
      ((#.#$documentProc #.#$rdocproc)
       (setf wclass #$kDocumentWindowClass
             wattrs (logior #$kWindowResizableAttribute #$kWindowCollapseBoxAttribute )))
      (#.#$dBoxProc
       (setf wclass #$kAlertWindowClass
             wattrs 0))
      ((#.#$plainDBox #.#$kWindowSimpleProc)
       (setf wclass #$kAlertWindowClass
             wattrs 0))
      (#.#$altDBoxProc
       (setf wclass #$kAlertWindowClass
             wattrs 0))
      (#.#$noGrowDocProc
       (setf wclass #$kDocumentWindowClass
             wattrs 0))
      (#.#$movableDBoxProc
       (setf wclass #$kMovableAlertWindowClass ; doesn't work - err -5601 see fix below
             wattrs 0))
      (#.#$zoomDocProc
       (setf wclass #$kDocumentWindowClass
             wattrs (logior #$kWindowResizableAttribute
                            #$kWindowCollapseBoxAttribute
                            #$kWindowFullZoomAttribute)))
      (#.#$zoomNoGrow
       (setf wclass #$kDocumentWindowClass
             wattrs #$kWindowFullZoomAttribute))
      (#.#$floatProc
       (setf wclass #$kFloatingWindowClass
             wattrs 0))
      (#.#$floatGrowProc
       (setf wclass #$kFloatingWindowClass
             wattrs #$kWindowResizableAttribute))
      (#.#$floatZoomProc
       (setf wclass #$kFloatingWindowClass
             wattrs #$kWindowFullZoomAttribute))
      (#.#$floatZoomGrowProc
       (setf wclass #$kFloatingWindowClass
             wattrs (logior #$kWindowResizableAttribute
                            #$kWindowFullZoomAttribute)))
      (#.#$floatSideProc
       (setf wclass #$kFloatingWindowClass
             wattrs #$kWindowSideTitlebarAttribute))
      (#.#$floatSideGrowProc
       (setf wclass #$kFloatingWindowClass
             wattrs (logior #$kWindowSideTitlebarAttribute
                            #$kWindowResizableAttribute)))
      (#.#$floatSideZoomProc
       (setf wclass #$kFloatingWindowClass
             wattrs (logior #$kWindowSideTitlebarAttribute
                            #$kWindowFullZoomAttribute)))
      (#.#$floatSideZoomGrowProc
       (setf wclass #$kFloatingWindowClass
             wattrs (logior #$kWindowSideTitlebarAttribute
                            #$kWindowResizableAttribute
                            #$kWindowFullZoomAttribute))))
    ;(print (list wclass type))
    (when (null wclass)
      (error "unknown window class ~D" type))

    (when (and close-box-p 
               (not (memq type *dialog-procids*))) ;'#.(list #$movabledboxproc #$dboxproc))))
      (setf wattrs (logior wattrs #$kWindowCloseBoxAttribute)))
   
    (rlet ((wrect :rect :topleft 0 :bottomright size)
           (low-window :Ptr))
     
      ;; create the window
      (setf err (#_CreateNewWindow wclass wattrs wrect low-window))
      (unless (zerop err)
        (error "error ~D creating window" err))

      (setf the-window (%get-ptr low-window))
     
      ;; set onscreen position
      (#_MoveWindow the-window (point-h position) (point-v position) #$false)
     
      ;; show, if needed - I think visible-p is always nil
      (when visible-p
        (#_ShowWindow the-window)
        (#_SelectWindow the-window)))
    (set-wptr-modified the-window nil)

    (#_SetWRefCon the-window type)

    the-window))

(defun %new-window (type position size close-box-p visible-p color-p)
  ;Leaves the procid in RefCon.
  (unless (fixnump type)
    (setq type (or (cdr (assoc type *window-type-procid-alist*))
                   (report-bad-arg type *window-type-foos*))))
  (setq position (center-window size position))
  (if (not (osx-p))
    (rlet ((wrect :rect :topleft position :bottomright (add-points-16 position size))
           (tp (:string 2)))
      (%put-word tp #x0120)
      (let ((res (if (and color-p *color-available*)
                   (#_NewCWindow 
                    (%null-ptr)
                    wrect                            ; bounds
                    tp                               ; blank title
                    visible-p                        ; visible
                    type                             ; procid
                    #-carbon-compat  ;; i dont think this is necessary - well if window isn't going to be shown it is, and elsewise doesn't hurt
                    (%int-to-ptr -1)                 ; behind  -1 means firstwindowofclass, 0 aka null-ptr means last
                    #+carbon-compat                  
                    (%null-ptr)
                    close-box-p                      ; goAwayFlag
                    type                             ; refCon
                    )
                   (#_NewWindow
                    (%null-ptr) 
                    wrect                            ; bounds
                    tp                               ; blank title
                    visible-p                        ; visible
                    type                             ; procid
                    #-carbon-compat
                    (%int-to-ptr -1)                 ; behind
                    #+carbon-compat
                    (%null-ptr)
                    close-box-p                      ; goAwayFlag
                    type                             ; refCon
                    ))))
        (if (%null-ptr-p res)
          (%err-disp #$MemFullErr)
          (progn (set-wptr-modified res nil)
                 res))))
    #-ignore
    (new-new-window type position size close-box-p visible-p)
    #+ignore
    (prog ((tries 0)
           (got-pos))  ;; this is too disgusting to believe
      (declare (ignore-if-unused tries))
      again
      (rlet ((wrect :rect :topleft position :bottomright (add-points-16 position size))
             (tp (:string 2)))
        (%put-word tp #x0120)
        (let ((res (if (and color-p *color-available*)
                     (#_NewCWindow 
                      (%null-ptr)
                      wrect                            ; bounds
                      tp                               ; blank title
                      visible-p                        ; visible
                      type                             ; procid
                      #-carbon-compat  ;; i dont think this is necessary - well if window isn't going to be shown it is, and elsewise doesn't hurt
                      (%int-to-ptr -1)                 ; behind  -1 means firstwindowofclass, 0 aka null-ptr means last
                      #+carbon-compat                  
                      (%null-ptr)
                      close-box-p                      ; goAwayFlag
                      type                             ; refCon
                      )
                     (error "shouldnt"))))
          (if (%null-ptr-p res)
            (%err-disp #$MemFullErr))        
          (rlet ((contrect :rect))
            (get-cont-rect res contrect)
            (setq got-pos (pref contrect :rect.topleft)))
          ;; if its not where we requested, dump it and try again, for awhile anyway (problem specific to OSX native)
          (if (not (eql got-pos position))  ;; trying this instead
            (#_movewindow res (point-h position)(point-v position) nil))
          (return  res)
          #+ignore
          (if (or (eql got-pos position)(> tries 4)) (return res)
              (progn (incf tries)(#_disposewindow res)(go again)))
          )))))
  

(defmethod default-window-layer ((w window))
  *windoid-count*)

;This is invoked with window already created but still invisible.
(defmethod initialize-window ((window window) &key view-font window-layer)
  (when view-font
    (set-initial-view-font window view-font))
  (set-window-layer window (or window-layer (default-window-layer window)))
  (window-size-parts window))

(def-aux-init-functions window #'initialize-window #'window-make-parts)

; Get back the :window-type initarg
; Doesn't work for windoids. - well sometimes it does
(defmethod window-type ((window window))
  (if (wptr window)
    (let ((procid #-carbon-compat (rref (wptr window) :windowrecord.refcon) #+carbon-compat (#_getwrefcon (wptr window))))
      (dolist (pair *window-type-procid-alist* procid)
        (if (eq procid (cdr pair))
          (return (car pair)))))
    ;; punt
    :document))

;; only called by vdc of pop-up-menu and then only after calling color-or-gray-p of menu
;; also called by ift
(defmethod window-color-p ((window window))
  (or (wptr-color-p (wptr window))))

; seems to return t always?
#-carbon-compat
(defun wptr-color-p (wptr)
  (let ((rowbytes (rref wptr :grafport.portbits.rowbytes)))
    (and (%ilogbitp 15 rowbytes)    ; see IM V-49,50,52
         (%ilogbitp 14 rowbytes))))

#+carbon-compat
;; only called by window-color-p - see above
(defun wptr-color-p (wptr)
  (#_IsPortColor (#_getwindowport wptr)))


(defun color-or-gray-p (view)
  (when *color-available*
    (let* ((w (view-window view))
           (pos (view-position view))
           (c (view-container view)))
      (when c
        (setq pos (add-points (view-position w) (convert-coordinates pos c w))))
      (with-macptrs (ptr) (find-screen pos ptr)
        (when (not (%null-ptr-p ptr))
          (> (screen-bits ptr) 1))))))

(defmethod window-menu-item ((w window) &aux (name (window-title w)))
  (when (null (slot-value w 'my-item))
    (setf (slot-value w 'my-item) 
          (make-instance 'windows-menu-menu-item :window w)))
  (let* ((enable (and (window-shown-p w)
                      (or (neq w (front-window))
                          (not (window-active-p w))))))
    (with-slot-values (my-item) w
      (when (> (length name) 60) ; chosen at random sort of - doesnt send it left on powerbook
        (setq name (%str-cat (%substr name 0 60) (string #\311))))
      (set-menu-item-title my-item name)
      (if enable (menu-item-enable my-item) (menu-item-disable my-item))
      my-item)))

(defmethod window-menu-item ((w da-window))
  nil)

(defun center-window (size position)
  (if (numberp position)
    position
    (let* ((pos-h (%iasr 1 (%i- *screen-width*
                                (point-h size))))
           (pos-v (%iasr 1 (%i- *screen-height*
                                (point-v size)))))
      (cond ((eq position :centered)
             (make-point pos-h pos-v))
             (t (let* ((constraint (pop position))
                      (amount (or (pop position) 0)))
                 (case constraint
                   (:top
                    (make-point pos-h amount))
                   (:bottom
                    (make-point pos-h (- (- *screen-height*
                                            amount)
                                         (point-v size))))
                   (:left
                    (make-point amount pos-v))
                   (:right
                    (make-point (- (- *screen-width*
                                      amount)
                                   (point-h size))
                                pos-v))
                   (otherwise
                    (report-bad-arg constraint '(member :top :bottom :left :right))))))))))

; Method for general views is in lib;views.lisp
(defmethod remove-view-from-window ((view simple-view))
  (setf (wptr view) nil))

(defvar *last-mouse-click-window* nil)

(defmethod window-close ((w window))
  (window-close-internal w))

(defmethod window-close :around ((w window))
  ; Killing the process may attempt to output on its window.
  ; This prevents deadlock due to the *event-processor* holding
  ; the window-process-queue during window-close.
  (setf (slot-value w 'queue) nil)
  (let ((p (window-process w)))
    (cond ((or (null p)
               (not (window-close-kills-process-p w p)))
           (call-next-method))
          (t (setf (window-process w) nil)
             (cond ((eq p *current-process*)
                    (process-interrupt *initial-process* #'finish-window-close w p)
                    (suspend-current-process))
                   (t (process-kill-and-wait p)
                      (call-next-method)))))))

(defun finish-window-close (w p)
  (process-kill-and-wait p)
  (window-close w))

#| trying Bill's version above
;(defmethod window-close :around ((w window))
  (call-next-method)
  ; Killing the process may attempt to output on its window.
  ; This prevents deadlock due to the *event-processor* holding
  ; the window-process-queue during window-close.
  (setf (slot-value w 'queue) nil)
  (let ((p (window-process w)))
    (when p
      (setf (window-process w) nil)
      (cond ((not (window-close-kills-process-p w p)))
            ((eq p *current-process*)
             (process-interrupt *initial-process* #'process-kill-and-wait p)
             (suspend-current-process "Closed"))
            (t (process-kill-and-wait p))))))
|#

(defmethod window-close-kills-process-p :around ((window window) process)
  (and process
       (neq process *event-processor*)
       (neq process *initial-process*)
       (call-next-method)))

(defmethod window-close-kills-process-p ((window window) process)
  (declare (ignore process))
  t)

(defun window-close-internal (w &aux (wptr (wptr w)))
  (when (eq w *last-mouse-click-window*)
    (setq *last-mouse-click-window* nil))
  (when wptr
    (window-hide w)
    (without-interrupts
     (when (eq w *current-view*)
       (focus-view nil))
     (when (eq w *selected-window*)
       (setq *selected-window* nil))
     (remove-window-object wptr)
     (remove-view-from-window w)
     (let ((rgn (window-erase-region w)))
       (when rgn
         (setf (window-erase-region w) nil)
         (#_DisposeRgn rgn)))
     (let ((rgn (window-invalid-region w)))
       (when rgn
         (setf (window-invalid-region w) nil)
         (#_DisposeRgn rgn)))
     (unless (%ptr-eql wptr %temp-port%)
       (with-port wptr
         #-carbon-compat         
         (#_ValidRect (rref wptr windowrecord.portrect))
         #+carbon-compat
         (rlet ((rect :rect))
           (valid-window-rect wptr (#_getwindowportbounds wptr rect)))))
     ; _DisposeWindow is done by the GC. 
     #+carbon-compat ;; I dunno why
     ;; screw the gc if osx-p - maybe fixes SendBehind failures - nope
     (when (or (osx-p)(typep w 'windoid))
       (set-macptr-flags wptr $flags_Normal)
       (#_disposewindow wptr))
     (when (null *selected-window*)
       (window-select (front-window)))))
  nil)

#|
(defmethod view-size ((w window) &aux (wptr (wptr w)))
  (subtract-points 
   (rref wptr windowrecord.portrect.bottomright)
   (rref wptr windowrecord.portrect.topleft)))
|#

(defmethod view-size ((w window) &aux (wptr (wptr w)))
    #+carbon-compat
    (rlet ((rect :rect))
      (#_getwindowportbounds wptr rect)
      (subtract-points (pref rect :rect.botright)(pref rect :rect.topleft)))
    #-carbon-compat
    (subtract-points 
     (rref wptr windowrecord.portrect.bottomright)
     (rref wptr windowrecord.portrect.topleft)))

; Overwritten by lib;views.lisp
(when (NOT (fboundp 'window-size-parts))
  (defmethod window-size-parts ((w window)) ()))

; Real version in views.lisp
(when (not (fboundp 'set-view-size))
  (defmethod set-view-size ((w window) h &optional v)
    (set-view-size-internal w h v)))

(defmethod set-view-size-internal ((w window) h &optional v &aux
                                     (wptr (wptr w)))
  (setq h (make-point h v))
  (without-interrupts
   (with-focused-view w
     (invalidate-grow-icon w t)
     (#_SizeWindow wptr (point-h h) (point-v h) t)
     (setf (slot-value w 'view-size) h)
     (window-size-parts w)
     (invalidate-grow-icon w)))
  h)

(defmethod view-window ((view simple-view))
  (or
   (let ((wptr (wptr view)))
     (and wptr (window-object wptr)))
   ; During initialize-instance the window may not be on the *window-alist*
   (let ((w view))
     (loop
       (if (or (null w) (typep w 'window))
         (return w)
         (setq w (view-container w)))))))

(defmethod window-zoom-event-handler ((w window) msgw &aux
                                      (wptr (wptr w)))
  (without-interrupts
   (with-macptrs #-carbon-compat ((wstate (pref wptr windowrecord.datahandle))) #+carbon-compat nil ;; wtf is this
     ;  (%hput-long wstate (objvar window-zoom-position) 8)
     ;  (%hput-long wstate (objvar window-zoom-size) 12))
     (let* ((zoom-position (window-zoom-position w))
            (br (add-points zoom-position (window-zoom-size w))))
       #-carbon-compat
       (progn
         (%hput-long wstate zoom-position 8)
         (%hput-long wstate br 12))
       #+carbon-compat
       (rlet ((rect :rect :topleft zoom-position :botright br))
         (#_setwindowstandardstate wptr rect)))
     (with-port wptr
       #-carbon-compat
       (#_EraseRect (rref wptr :windowrecord.portRect))
       #+carbon-compat
       (rlet ((rect :rect))
         (#_getwindowportbounds wptr rect)
         (#_eraserect rect))
       (#_ZoomWindow wptr msgw nil))
     (compute-view-region w (view-clip-region-slot w) nil)
     (window-size-parts w)
     nil)))

#|
(defmethod window-drag-event-handler ((w window) where)
  (#_DragWindow (wptr w) where (window-drag-rect w))
  (set-view-position w (view-position w)))
|#



(defun window-drag-sub (w where)
  #+carbon-compat
    (progn
      ;; we lose some features here
      (#_DragWindow (wptr w) where (window-drag-rect w))
      (set-view-position w (view-position w)))
    #-carbon-compat
    (progn
      (let ((wp (wptr w))
            result rgn)
        (when (#_WaitMouseUp)
          (with-macptrs ((wm (#_LMGetWMgrPort))
                         (grayrgn (#_GetGrayRgn)))
            (with-port wm
              (#_SetClip grayrgn)
              (#_ClipAbove wp)
              (setq rgn *grow-icon-rgn*)
              (#_CopyRgn (rref wp windowrecord.strucRgn) rgn)
              (let ((drag-rect (get-the-current-window-drag-rect w))
                    (code (cond ((command-key-p) 1) ; horizontal drag only
                                ((shift-key-p) 2) ; vertical drag only
                                (t 0))))
                (setq result (#_DragGrayRgn rgn where drag-rect drag-rect code (%null-ptr)))))
            (when (neq -32768 (point-h result))
              (set-view-position
               w
               (add-points result (view-position w)))))))))

#|
(defun window-drag-sub (w where)
  #+carbon-compat
    (progn
      (let ((wp (wptr w))
            result rgn)
        (when (#_WaitMouseUp)
          (with-macptrs ((grayrgn (#_GetGrayRgn)))
            (with-port screen-GRAFPORT ;; WEIRD
              (#_SetClip grayrgn)
              (#_ClipAbove wp)
              (setq rgn *grow-icon-rgn*)
              (get-window-strucrgn wp rgn)
              (let ((drag-rect (get-the-current-window-drag-rect w))
                    (code (cond ((command-key-p) 1) ; horizontal drag only
                                ((shift-key-p) 2) ; vertical drag only
                                (t 0))))
                (setq result (#_DragGrayRgn rgn where drag-rect drag-rect code (%null-ptr)))))
            (when (neq -32768 (point-h result))
              (set-view-position
               w
               (add-points result (view-position w))))))))
    #-carbon-compat
    (progn
      (let ((wp (wptr w))
            result rgn)
        (when (#_WaitMouseUp)
          (with-macptrs ((wm (#_LMGetWMgrPort))
                         (grayrgn (#_LMGetGrayRgn)))
            (with-port wm
              (#_SetClip grayrgn)
              (#_ClipAbove wp)
              (setq rgn *grow-icon-rgn*)
              (#_CopyRgn (rref wp windowrecord.strucRgn) rgn)
              (let ((drag-rect (get-the-current-window-drag-rect w))
                    (code (cond ((command-key-p) 1) ; horizontal drag only
                                ((shift-key-p) 2) ; vertical drag only
                                (t 0))))
                (setq result (#_DragGrayRgn rgn where drag-rect drag-rect code (%null-ptr)))))
            (when (neq -32768 (point-h result))
              (set-view-position
               w
               (add-points result (view-position w)))))))))
|#

      
    
    

(defmethod window-drag-event-handler ((w window) where)
  (if (and (command-key-p) (pop-up-path-menu w where))
    nil
    (if (option-key-p)
      (if (windoid-p w)
        (set-window-layer w (1- *windoid-count*))
        (set-window-layer w 9999))
      (progn
        (window-drag-sub w where)
        (when (control-key-p)
          (let* ((windows (windows :class (class-of w)))
                 (n 1))
            (dolist (win windows)
              (when (neq win w)(set-window-layer win n)(incf n)))))))))
            

(defparameter *sys-font-codes* nil)
(defparameter *sys-font-spec* nil)

(defun sys-font-spec ()
  (let* ((font (#_LMGetSysFontFam))
         (ms (#_LMGetSysFontSize)))
    (when (zerop ms)(setq ms 12))
    (if (not *sys-font-codes*)
      (let ((ff (ash font 16)))
        (setq *sys-font-codes* (cons ff ms) *sys-font-spec* (font-spec ff ms)))
      (if (and (eql (ash  (car *sys-font-codes*)  -16) font)
               (eql (cdr *sys-font-codes*) ms))
        *sys-font-spec*
        (progn
          (let ((ff (ash font 16)))
            (rplacd (rplaca *sys-font-codes* ff) ms)
            (setq *sys-font-spec* (font-spec ff ms))))))))


(defun sys-font-codes ()
  (sys-font-spec)  ;; assure inited and currently valid
  (values (car *sys-font-codes*) (cdr *sys-font-codes*)))


(defun pop-up-path-menu (w where)
  (let* ((file (window-filename w))
         (local-where (%global-to-local (wptr w) where))
         (x (point-h local-where)))
    (when file
      (let* ((title (window-title w))
             (sys-font (sys-font-spec))
             (twidth (+ 16 (string-width title sys-font)))
             (wwidth (point-h (view-size w)))
             (xtra (max 26 (floor (- wwidth twidth) 2)))
             (title-max (min (- wwidth 26) (+ xtra twidth))))
        (when (< xtra x title-max)
          (let* ((file (pathname file))
                 (dir (cons (file-namestring file)
                            (reverse (cdr (pathname-directory file)))))
                 (host (pathname-host file)))
            (when (and host (neq host :unspecific))
              (setq dir (nconc dir (list host))))
            (let ((menu (make-instance 'pull-down-menu
                          :menu-title ""
                          :view-size #@(0 0)
                          :view-container w 
                          :view-font sys-font
                          :view-position (make-point x -16) ;local-where ; (make-point (- xtra 5) -16)
                          :menu-items (mapcar #'make-menu-item dir))))
              (let* ((n 0))
                (dolist (item (cdr (menu-items menu))) 
                  (incf n)                  
                  (let ((item-dir
                         (make-pathname :host host :directory (butlast (pathname-directory file) (1- n))
                                        :defaults nil)))
                    (set-menu-item-action-function
                     item 
                     #'(lambda ()(let ((res (catch-cancel (choose-file-dialog 
                                                           :directory item-dir
                                                           :mac-file-type "TEXT"))))
                                   (when (neq res :cancel)(fred res))))))))
              (menu-select menu 0)
              t)))))))
      

(defmethod window-grow-event-handler ((w window) where)
  (let ((new-size (#_GrowWindow (wptr w) where (window-grow-rect w))))
    (unless (%izerop new-size)
      (set-view-size w new-size))))

(defmethod window-close-event-handler ((w window))
  (cond ((option-key-p)
         (let ((class (class-of w)))
           (dolist (w (nreverse (windows :class class :include-invisibles t)))
             (if (eq (class-of w) class)
               (window-close-nicely w)))))
        ((control-key-p)
         (view-put w :display-in-menu-when-hidden t)
         (window-hide w))
        (t (window-close w))))

(defmethod display-in-windows-menu ((w window))
  (or (window-shown-p w) (view-get w :display-in-menu-when-hidden)))

(defvar *da-window-on-top* nil)

;;old function was susceptible to abort between setting wptr and getting ff and ms;
;;would restore NIL instead of correct font codes
;;Also don't have to refocus if view is same and font-view is nil -- Klmn
(defmethod call-with-focused-view (view function &optional font-view)
  (let* ((old-view *current-view*)
         (old-font-view *current-font-view*)
         wptr ff ms old-fonts)
    (if (and (eq view old-view)
             (or (null font-view)
                 (eq font-view old-font-view)))
      (funcall function view)
      (unwind-protect
        (progn
          (when (and view (null old-font-view) font-view (setq wptr (wptr view)))
            (multiple-value-setq (ff ms) (wptr-font-codes wptr))
            (setq old-fonts t))
          (focus-view view font-view)
          (funcall function view))
        (when (and (ok-wptr wptr) old-fonts)
          (set-wptr-font-codes wptr ff ms))
        (focus-view old-view old-font-view)))))

(defmethod call-with-focused-view :around (view function &optional font-view)
  (declare (ignore function font-view)
           (dynamic-extent #'call-next-method))
  (let* ((window (and view (view-window view)))
         (queue (and window (window-process-queue window)))
         (*current-view* *current-view*)
         (*current-font-view* *current-font-view*))
    (if (and queue (neq *current-process* (process-queue-locker queue)))
      (if (eq *current-process* *event-processor*)
        (unwind-protect
          (progn 
            (unless (window-process-enqueue-with-abort *application* view queue)
              (error "Couldn't process-enqueue"))
            (call-next-method))
          (process-dequeue queue nil nil))
        (with-process-enqueued (queue nil nil nil)
          (call-next-method)))
      (call-next-method))))

; We need some way to allow the *event-processor* to usurp a window lock.
; Otherwise, if some process holds onto a window lock for too long,
; the machine will lock up.
; Every 15 ticks, we look for an abort event. If we find one,
; we attempt to abort the offending process. If that doesn't work, we
; usurp the lock.
; I don't know that it will ever be useful for someone to specialize
; these methods, though I can imagine that a debugged application
; would want to just process-enqueue with no abort.
(defmethod window-process-enqueue-with-abort (application view queue &optional
                                                (timeout 15))
  (let ((tried-abort-p nil))
    (loop
      (when (process-enqueue-with-timeout queue timeout)
        (return t))
      (let ((locker (process-queue-locker queue)))
        (when locker
          (when (eq tried-abort-p locker)
            (return (window-process-enqueue-usurping application view queue)))
          (when (abort-event-pending-p)
            (#_FlushEvents #x003F 0)
            (setq tried-abort-p locker)
            (interactive-abort-in-process locker)))))))        

(defmethod window-process-enqueue-usurping (application view queue)
  (declare (ignore application view))
  (process-enqueue-with-timeout queue :usurp))

; These two methods are redefined in "ccl:lib;views.lisp"

(when (not (fboundp 'focus-view))
  (defmethod focus-view ((view null) &optional font-view)
    (declare (ignore font-view))
    (set-gworld %temp-port%)
    (setq *current-view* nil))
  
  
  
  ;; this is replaced in views.lisp
  (defmethod focus-view ((view simple-view) &optional font-view)
    (declare (ignore font-view))
    (without-interrupts
     (let* ((wptr (wptr view)))
       (if wptr
         (progn
           (set-gworld wptr)
           (#_SetOrigin 0 0)
           #-carbon-compat
           (#_ClipRect (rref wptr windowrecord.portrect))
           #+carbon-compat
           (rlet ((rect :rect))
             (#_ClipRect(#_getwindowportbounds wptr rect)))
           (setq *current-view* view))
         (focus-view nil)))))
)





; Initialized in ccl:lib;views.lisp
(defvar *screen-gdevice* nil)
(defvar *setgworld-available?* nil)

; Destructively modifies the two macptr args
(defun get-gworld (port gdh)
  (if *setgworld-available?*
    (rlet ((portp :ptr)
           (gdhp :ptr))
      (#_GetGworld portp gdhp)
      (%setf-macptr port (%get-ptr portp))
      (%setf-macptr gdh (%get-ptr gdhp)))
    (%setf-macptr port (%getport))))

(defun set-gworld (port &optional (device *screen-gdevice*))
  (when (ok-wptr port)
    (if *setgworld-available?*
      (#_SetGWorld port device)
      (%setport port))))

(defun set-gworld-from-wptr (wptr &optional (device *screen-gdevice*))
  #-carbon-compat
  (set-gworld wptr device)
  #+carbon-compat
  (with-macptrs ((port (#_getwindowport wptr)))
    (set-gworld port device)))

; WITH-PORT expands into a call to this function
(defun call-with-port (port thunk)
  (with-macptrs (saved-port saved-device)
    (without-interrupts
     (unwind-protect
       (let ((%temp-port% port)  ;; why do this?
             (*current-view* nil)
             (*current-font-view* nil))
         (get-gworld saved-port saved-device)
         (set-gworld-from-wptr port)  ;; is it a port or a window?
         (funcall thunk))
       (set-gworld saved-port saved-device)))))

(defmethod view-activate-event-handler ((v simple-view)))


(export '(*disable-bubbles-on-inactive-windows*) :ccl)
(defvar *disable-bubbles-on-inactive-windows* t
  "Controls whether close, minimize, and zoom
bubbles work in inactive windows. T for OS9
behavior, nil for OSX behavior. Takes
effect only after windows have been
deactivated.")

(defmethod clear-bubble-attributes ((w window) &optional (attributes (logior #$kWindowCollapseBoxAttribute
                                                                             #$kWindowCloseBoxAttribute
                                                                             #$kWindowFullZoomAttribute)))
  (let ((wptr (wptr w)))
    (when wptr 
      (#_changewindowattributes wptr 0 attributes))))

(defmethod set-bubble-attributes ((w window) &optional (attributes (logior #$kWindowCollapseBoxAttribute
                                                                           #$kWindowCloseBoxAttribute
                                                                           #$kWindowFullZoomAttribute)))
  (let ((wptr (wptr w)))
    (when wptr 
      (#_changewindowattributes wptr attributes 0))))

#|
(defmethod get-bubble-attributes ((w window))
  ;we have $kWindowCanZoom #x2)
  ; $kWindowCanCollapse #x4)
  ; $kWindowIsModal #x8)
  (let ((wptr (wptr w)))
    (when wptr
      (rlet ((fp :unsigned-long))  ;; seems to lie re zoom on OSX
        (#_getwindowfeatures wptr fp)
        (let ((features (%get-long fp))
              (attrs 0))
          (when (neq 0 (logand features #$kWindowCanZoom))
            (setq attrs (logior attrs #$kWindowFullZoomAttribute)))
          (when (neq 0 (logand features #$kWindowCanCollapse))
            (setq attrs (logior attrs #$kWindowCollapseBoxAttribute)))
          (when (eq 0  (logand features #$kWindowIsModal)) ;; is this the best we can do?            
            (setq attrs (logior attrs #$kWindowCloseBoxAttribute)))
          attrs)))))
|#

(defmethod get-bubble-attributes ((w window))
  (let ((wptr (wptr w)))
    (when wptr
      (rlet ((fp :unsigned-long))
        (#_GETWINDOWATTRIBUTES wptr fp)
        (logand (%get-long fp) (logior #$kWindowCollapseBoxAttribute
                                       #$kWindowCloseBoxAttribute
                                       #$kWindowFullZoomAttribute))))))

          

; This is a :before method to make it unlikely to be user-shadowed.
(defmethod view-activate-event-handler :before ((w window))
  (view-remprop w :display-in-menu-when-hidden)
  (when *foreground*
    (hilite-wptr (wptr w) t)
    (window-draw-grow-icon w)))

(defmethod view-activate-event-handler ((w window))
  (setq *da-window-on-top* nil)
  (unless (or (not *foreground*) (window-active-p w))
    (setf (window-active-p w) t)
    (when (and (osx-p) (not (typep w 'windoid)))
      (let ((attrs (view-get w 'bubble-attrs)))
        (when attrs
          (set-bubble-attributes w attrs))))
    (call-next-method)
    (let ((key (current-key-handler w)))
      (when key
        (dolist (v (key-handler-list w))
          (when (and (neq v key)
                     (not (view-contains-p v key)))
            (view-deactivate-event-handler v)))))))
#|
(defmethod window-activate-controls ((w window))
  (with-macptrs ((hCtl (rref (wptr w) windowrecord.controllist)))
    (until (%null-ptr-p hCtl)
      (#_ShowControl hCtl)
      (%setf-macptr hCtl (rref hCtl controlrecord.nextcontrol)))))
|#

(defmethod view-deactivate-event-handler ((v simple-view)))

; This is a :before method to make it unlikely to be user-shadowed.
(defmethod view-deactivate-event-handler :before ((w window))
  (let ((wptr (wptr w)))
    (when wptr
      (when (not (osx-p))(hilite-wptr wptr nil)) ; remove this reduces flashies on OSX ???
      (window-draw-grow-icon w))))

(defmethod view-deactivate-event-handler ((w window))
  (let ((wptr (wptr w)))
    (when wptr
      (when (window-active-p w)
        (setf (window-active-p w) nil)
        (when (and (osx-p)(not (typep w 'windoid)) *disable-bubbles-on-inactive-windows*)
          (let ((attrs (get-bubble-attributes w)))
            (view-put w 'bubble-attrs attrs)
            ;; if is collapsed, leave bubble so will uncollapse
            (if (not (#_iswindowcollapsed wptr))
              (clear-bubble-attributes w))))
        (call-next-method)))))          ; deactivate subviews


#|
(defun funcall-with-foreign-window (thunk)
  (without-event-processing
    (let ((w *selected-window*)
          (loathsome-windoids nil))
      (when w
        (view-deactivate-event-handler w))
      (when (osx-p) (set-cursor *arrow-cursor*))
      ;(map-windows #'(lambda (w) (view-deactivate-event-handler w)(push w loathsome-windoids)) :class 'windoid) 
      (unwind-protect
        (funcall thunk)
        (when (setq w *selected-window*)
          (view-activate-event-handler w))
        (when loathsome-windoids (dolist (w loathsome-windoids) (view-activate-event-handler w)))))))
|#

(defun funcall-with-foreign-window (thunk)
  (without-event-processing
    (let ((w *selected-window*))
      (when w
        (view-deactivate-event-handler w))
      (unwind-protect
        (if (osx-p)
          (with-cursor *arrow-cursor*
            (funcall thunk))
          (funcall thunk))
        (when (setq w *selected-window*)
              (view-activate-event-handler w))))))

#|
(defmethod window-deactivate-controls ((w window))
  (with-macptrs ((hCtl (rref (wptr w) windowrecord.controllist)))
    (until (%null-ptr-p hCtl)
      (#_HideControl hCtl)
      (%setf-macptr hCtl (rref hCtl controlrecord.nextcontrol)))))
|#

(declaim (special *window-update-wptr*))

(unless (fboundp 'get-back-color)
  ; Overwritten by color.lisp
  (defmethod get-back-color ((w window)) nil))

(unless (fboundp 'set-back-color)
  ; Overwritten by color.lisp
  (defmethod set-back-color ((w window) c &optional d)(declare (ignore c d)) nil))

#+ignore
(defmethod window-update-event-handler ((w window) &aux (wp (wptr w)))
  (without-event-processing ;(let-globally ((*processing-events* *current-process*))       ; uninterruptable by events
    (with-focused-view w
      (let ((rgn (window-erase-region w))
            (invalid-rgn (window-invalid-region w)))
        (when rgn
          #-carbon-compat
          (#_InvalRgn rgn)
          #+carbon-compat
          (inval-window-rgn wp rgn))
        (when *window-update-wptr*
          (#_EndUpdate *window-update-wptr*)
          (setq *window-update-wptr* nil))
        (unwind-protect
          (progn
            (#_BeginUpdate wp)
            (setq *window-update-wptr* wp)
            (when invalid-rgn
              #+carbon-compat
              (let ((rgn3 *temp-rgn-3*))
                (get-window-visrgn wp rgn3)
                (#_diffrgn rgn3 invalid-rgn invalid-rgn))
              #-carbon-compat
              (#_DiffRgn (rref wp :windowrecord.visRgn) invalid-rgn invalid-rgn)
              (if rgn
                (progn
                  (#_UnionRgn rgn invalid-rgn rgn)
                  (#_SetEmptyRgn invalid-rgn))
                (setq rgn invalid-rgn)))
            (when rgn 
              (#_EraseRgn rgn)
              (#_SetEmptyRgn rgn))
            (view-draw-contents w))
          (when (setq wp *window-update-wptr*)
            (setq *window-update-wptr* nil)
            (#_EndUpdate wp)))))))

; In MCL 4.4b3,
; I had some problems with errors that occurred when progress-step was called on a window
;   that was gone. I think it had to do with the time delay between when window-update-event-handler
;   grabbed the wp and the later time when with-focused-view finally called its queued update
;   function, at which time the window was already gone. This seems to fix the problem.


(defmethod window-update-event-handler ((w window) ) ;&aux (wp (wptr w)))
  (without-event-processing ;(let-globally ((*processing-events* *current-process*))       ; uninterruptable by events
    (with-focused-view w
      (let ((wp (wptr w)))
        (when wp
          (let ((rgn (window-erase-region w))
                (invalid-rgn (window-invalid-region w)))
            (when rgn
              #-carbon-compat
              (#_InvalRgn rgn)
              #+carbon-compat
              (inval-window-rgn wp rgn))
            (when *window-update-wptr*
              (#_EndUpdate *window-update-wptr*)
              (setq *window-update-wptr* nil))
            (unwind-protect
              (progn
                (#_BeginUpdate wp)
                (setq *window-update-wptr* wp)
                (when invalid-rgn
                  #+carbon-compat
                  (let ((rgn3 *temp-rgn-3*))
                    (get-window-visrgn wp rgn3)
                    (#_diffrgn rgn3 invalid-rgn invalid-rgn))
                  #-carbon-compat
                  (#_DiffRgn (rref wp :windowrecord.visRgn) invalid-rgn invalid-rgn)
                  (if rgn
                    (progn
                      (#_UnionRgn rgn invalid-rgn rgn)
                      (#_SetEmptyRgn invalid-rgn))
                    (setq rgn invalid-rgn)))
                (when rgn 
                  (#_EraseRgn rgn)
                  (#_SetEmptyRgn rgn))
                (view-draw-contents w))
              (when (setq wp *window-update-wptr*)
                (setq *window-update-wptr* nil)
                (#_EndUpdate wp)))))))))
  

#|
(defun get-rect (h)
  (with-dereferenced-handles ((p h))
    (let ((r (pref p region.rgnbbox)))
      (list (pref r rect.top)
            (pref r rect.left)
            (pref r rect.bottom)
            (pref r rect.right)))))
|#

(defmethod view-draw-contents ((v simple-view)))

(defmethod view-draw-contents :before ((w window))
    (window-draw-grow-icon w))
#|
(defmethod window-draw-controls ((w window) &aux (wptr (wptr w)))
  (when wptr
    (with-focused-view w
      (#_DrawControls wptr)
      (with-macptrs ((hCtl (rref wptr windowrecord.controllist)))
        (until (%null-ptr-p hCtl)
          (validate-control hCtl)
          (%setf-macptr hCtl (rref hCtl controlrecord.nextcontrol)))))))
|#

; Overwritten by color.lisp
(when (not (fboundp 'color-green))
  (defun color-green (color)
    (declare (ignore color))
    0)
  
  (defun color-blue (color)
    (declare (ignore color))
    0)
  
  (defun color-red (color)
    (declare (ignore color))
    0))


; We don't draw anything but the little square in the lower-right-hand corner.
#-carbon-compat
(defmethod window-draw-grow-icon ((w window) &aux (wptr (wptr w)))
  (when (and wptr (window-grow-icon-p w))
    (without-interrupts
     (let* ((cliprgn (rref wptr :windowrecord.cliprgn))
            (save-rgn *grow-icon-rgn*))
       (declare (dynamic-extent cliprgn)
                (type macptr cliprgn))
       (multiple-value-bind (tl br) (grow-icon-corners w)
         (declare (dynamic-extent cliprgn))
         (#_CopyRgn cliprgn save-rgn)
         (unwind-protect
           (progn
             (#_SetRectRgn cliprgn (point-h tl) (point-v tl) (point-h br) (point-v br))
             (#_DrawGrowIcon wptr))
           (#_CopyRgn save-rgn cliprgn)))))))

#+carbon-compat
(defmethod window-draw-grow-icon ((w window) &aux (wptr (wptr w)))
  (when (and wptr (window-grow-icon-p w))
    (without-interrupts
     (let* ((cliprgn *temp-rgn-3*)
            (save-rgn *grow-icon-rgn*))
       (declare (dynamic-extent cliprgn)
                (type macptr cliprgn))
       (multiple-value-bind (tl br) (grow-icon-corners w)
         (get-window-cliprgn wptr cliprgn) 
         (#_CopyRgn cliprgn save-rgn)
         (unwind-protect
           (progn
             (#_SetRectRgn cliprgn (point-h tl) (point-v tl) (point-h br) (point-v br))
             (set-window-cliprgn wptr cliprgn)
             (#_DrawGrowIcon wptr))
           (set-window-cliprgn wptr save-rgn)))))))

#|
; Surround by with-port or with-focused-view or you will lose.
(defmethod window-invalidate-controls ((w window) &aux (wptr (wptr w)))
  ;;Invalidates any control rectangles in a window
  (invalidate-grow-icon w t)
  (with-macptrs ((hCtl (rref wptr windowrecord.controllist)))
    (until (%null-ptr-p hCtl)
      (invalidate-control hCtl t)
      (%setf-macptr hCtl (rref hCtl controlrecord.nextcontrol)))))
|#

#|
(defun control-rect (control &optional (rect (make-record :rect)))
  (rset rect rect.topleft (rref control controlrecord.contrlrect.topleft))
  (rset rect rect.bottomright (rref control controlrecord.contrlrect.bottomright))
  rect)
|#

#|
;; Must surround this with a with-port or you will lose badly.
(defun invalidate-control (control &optional erase-p)
  (let* ((port (%getport))
        (w (window-object port)))
    (declare (dynamic-extent port))
    (if w
      (invalidate-corners w
                          (rref control :controlrecord.contrlrect.topleft)
                          (rref control :controlrecord.contrlrect.bottomright)
                          erase-p)
      (rlet ((rect :rect))
        (control-rect control rect)
        (if erase-p (#_EraseRect rect))
        (#_InvalRect rect)))))

; ditto
(defun validate-control (control)
  (let* ((port (%getport))
        (w (window-object port)))
    (declare (dynamic-extent port))
    (if w
      (validate-corners w 
                        (rref control :controlrecord.contrlrect.topleft)
                        (rref control :controlrecord.contrlrect.bottomright))
      (rlet ((rect :rect))
        (control-rect control rect)
        (#_ValidRect rect)))))
|#

; Overwritten by views.lisp
(when (not (fboundp 'invalidate-corners))
(defmethod invalidate-corners ((view simple-view) topleft bottomright &optional 
                               erase-p)
  (declare (ignore erase-p))
  (rlet ((rect :rect :topleft topleft :bottomright bottomright))
    (INVAL-WINDOW-RECT (WPTR VIEW) RECT))))

; Also overwritten
(when (not (fboundp 'validate-corners))
(defmethod validate-corners ((view simple-view) topleft bottomright)
  (rlet ((rect :rect :topleft topleft :bottomright bottomright))
    (valid-window-rect (wptr view) rect))))

#|
(defun grow-icon-rect (w &optional (rect (make-record :rect)))
  (multiple-value-bind (top-left bot-right) (grow-icon-corners w)
    (rset rect rect.bottomright bot-right)
    (rset rect rect.topleft top-left)
    rect))
|#

(defun grow-icon-corners (w)
  (let ((wptr (wptr w)))
    #-carbon-compat
    (let ((bot-right (rref wptr windowrecord.portrect.bottomright)))
      (values (subtract-points bot-right #@(15 15))
              bot-right))
    #+carbon-compat
    (rlet ((rect :rect))
      (#_getwindowportbounds wptr rect)
      (let ((bot-right (rref rect :rect.bottomright)))
        (values (subtract-points bot-right #@(15 15))
                bot-right)))))

(defmethod invalidate-grow-icon ((w window) &optional erase-p)
  (when (window-grow-icon-p w)
    (with-focused-view w
      (multiple-value-bind (topleft botright) (grow-icon-corners w)
        (invalidate-corners w topleft botright erase-p)))))

; overwritten by lib;dialogs.
(defmethod view-key-event-handler ((w window) char)
  (let ((w *top-listener*))
    (when w
      (view-key-event-handler *top-listener* char))))

(defmethod view-click-event-handler ((view simple-view) where)
  (declare (ignore where))
  view)

(defmethod stream-tyo ((v simple-view) char)
  (if (eq char #\Return)
    (view-terpri v)
    (with-font-focused-view v
      (#_DrawChar char))))

(defun grafport-write-long-string (string start end)
  (let* ((chunk (if (extended-string-p string) 127 255))
         (n (ceiling (- end start) chunk)))
    (dotimes (i n)
      (with-pstr (pstr string start (min end (+ start chunk)))
        (#_drawstring pstr))
      (setq start (+ start chunk)))))

(defmacro grafport-write-string (string start end)
  (let ((pstr (gensym)))
    `(if (> (byte-length ,string nil ,start ,end) 255)
       (grafport-write-long-string ,string ,start ,end)
       (with-pstr (,pstr ,string ,start ,end)
         (require-trap #_DrawString ,pstr)))))

(defmethod stream-write-string ((v simple-view) string start end)
  (multiple-value-bind (string offset) (array-data-and-offset string)
    (declare (fixnum offset))
    (let ((start (+ offset (require-type start 'fixnum)))
          (end (+ offset (require-type end 'fixnum)))
          middle)
      (declare (fixnum start end))
      (with-font-focused-view v
        (loop
          (setq middle (%str-member #\newline string start end))
          (grafport-write-string string start (or middle end))
          (if middle
            (progn
              (view-terpri v)
              (setq start (1+ middle)))
            (return)))))))

(defmethod view-terpri ((v simple-view))
  "does the best it can at doing a generic carriage return"
  (with-font-focused-view v
    (let* ((wptr (wptr v))
           (cur-pos #-carbon-compat (rref wptr windowrecord.pnloc) #+carbon-compat (get-window-pnloc wptr))) ;; where t.f. is that
      (multiple-value-bind (ascent descent widmax leading) (font-info)
        (declare (ignore widmax))
        (#_Moveto 5 (+ (point-v cur-pos)
                       ascent descent leading))))))

(defmethod stream-force-output ((w window))
  (let ((key (current-key-handler w)))
    (when key (stream-force-output key))))

(defmethod view-mouse-position ((v simple-view))
  (with-focused-view v
    (%stack-block ((pt 4))
      (#_GetMouse pt)
      (%get-long pt))))

(defmethod view-mouse-position ((v null))
  #+carbon-compat
  (%stack-block ((pt 4))
    (#_getglobalmouse pt)
    (%get-long pt))
  #-carbon-compat
  (with-port %original-temp-port%
    (%stack-block ((pt 4))
      (#_GetMouse pt)
      (%get-long pt))))

; double-click-patch.lisp
(defmethod window-select-event-handler ((w window))
  (unless (window-do-first-click w)
    (setq *last-mouse-down-time* 0))
  (window-select w))

(defmethod window-select ((w null))
  ; Sometimes (front-window) is nil
  (let ((w (front-window)))
    (if w
      (window-select w)
      (progn
        (setq w *selected-window*)
        (when w
          (view-deactivate-event-handler w)
          (setq *selected-window* nil))))))

(defmethod window-select ((w window))
  (setq *last-mouse-click-window* w)
  (if (eq w *selected-window*)
    (unless (window-active-p w)
      (view-activate-event-handler w))
    (let ((wptr (wptr w)))
      (when *selected-window*        
        (view-deactivate-event-handler *selected-window*)        
        )
      (autoposition-show w wptr)
      (setq *selected-window* nil)
      (reselect-windows)
      (if #-carbon-compat *last-windoid* #+carbon-compat nil
        (window-send-behind wptr (wptr *last-windoid*) t)
        (window-bring-to-front w))
      (setq *selected-window* w)
      (view-activate-event-handler w)
      (when (getf *environs* :color-quickdraw)
        (#_ActivatePalette wptr))       ; #_SelectWindow does this
      (menu-update (edit-menu)))))

(defmethod window-select ((w da-window))
  (let ((selected *selected-window*)
        (wptr (wptr w)))
    (unless (eq w selected)
      (autoposition-show w wptr)
      (setq *selected-window* w)
      (#_SelectWindow wptr)
      (unselect-windows t)))
  w)

(defun window-bring-to-front (w &optional (wptr (wptr w)))
  (when (and w wptr)
    (if (or (osx-p)(typep (front-window :include-windoids t) 'da-window)) ;; added osx-p - fixes grow box and title bar in 5g15 seed
      (#_SelectWindow wptr)
      (#_BringToFront wptr))))
        
(defmethod window-layer ((w window) &optional include-invisibles)
  (without-interrupts
   (let* ((wp (wptr w)) (count 0))
     (when wp
       (do-wptrs w
         (when (%ptr-eql w wp) (return))
         (when (or include-invisibles #-carbon-compat (rref w windowrecord.visible) #+carbon-compat (#_iswindowvisible w))
           (setq count (%i+ count 1))))
       count))))

(defmethod set-window-layer ((w window) new-layer &optional include-invisibles)
  (without-interrupts
   (let* ((wptr (wptr w)))    
     (when wptr
      (let* ((visible? #-carbon-compat (rref wptr windowrecord.visible) #+carbon-compat (#_iswindowvisible wptr)))
        (if (<= new-layer 0)
          (with-macptrs ((fw #-carbon-compat (#_FrontWindow)
                             #+carbon-compat (#_FrontNonFloatingWindow)))   ; this is the modal dialog case  - was FrontWindow - fix from Brendan Burns
            (unless (%ptr-eql wptr fw)
              (window-bring-to-front w wptr)
              (when visible?
                (unselect-windows t)
                (setq *selected-window* w)
                (view-activate-event-handler w))))
          (let ((selected *selected-window*))
            (if (set-window-layer-internal 
                 w (max *windoid-count* new-layer) include-invisibles)
              (when (eq w selected)
                (let ((new-selected (front-window)))
                  (unless (eq w new-selected)
                    (view-deactivate-event-handler w)
                    (setq *selected-window* new-selected)
                    (view-activate-event-handler new-selected))))
              (unless (or (not visible?) (eq w selected))
                (view-deactivate-event-handler selected)
                (setq *selected-window* w)
                (view-activate-event-handler w))))))))))

; selects a da if it is briught in front of all non-windoids.
; This 
(defmethod set-window-layer ((w da-window) new-layer &optional include-invisibles)
  (if (and (<= new-layer *windoid-count*) (window-shown-p w))
    (progn (window-select w) 0)
    (progn
      (if (eq w *selected-window*)
        (reselect-windows))
      (set-window-layer-internal w new-layer include-invisibles)
      new-layer)))


; Will fail on trying to set the layer to 0.
; Returns nil unless this window was sent behind the selected-window
(defun set-window-layer-internal (w new-layer include-invisibles)
  (let ((layer 0)
        (wptr (wptr w))
        (closerp t)
        (selected-wptr (and *selected-window* (wptr *selected-window*)))
        behind-selected?)
    (with-macptrs ((wp #-carbon-compat (#_LMGetWindowList) #+carbon-compat (#_getwindowlist))
                   last-wp)
      (do () ((%null-ptr-p wp))
        (if (and selected-wptr (%ptr-eql wp selected-wptr))
          (setq behind-selected? t))
        (if (%ptr-eql wptr wp)
          (setq closerp nil)
          (progn
            (%setf-macptr last-wp wp)
            (when (or include-invisibles #-carbon-compat (rref wp windowrecord.visible) #+carbon-compat (#_iswindowvisible wp))
              (when (>= (incf layer) new-layer)
                (return)))))            ; return from do.
        (%setf-macptr wp #-carbon-compat (rref wp windowrecord.nextwindow) #+carbon-compat (#_getnextwindow wp)))
      (unless (or (%null-ptr-p last-wp)
                  (%ptr-eql wptr #-carbon-compat (rref last-wp windowrecord.nextwindow)
                                 #+carbon-compat (#_getnextwindow last-wp)))
        (window-send-behind wptr last-wp closerp)))
    behind-selected?))

;(defvar puke 0)
(defun window-send-behind (wptr behind-wptr closerp &aux rgn)
  (declare (ignore-if-unused closerp rgn))
  (with-macptrs ((behind-behind-wptr #-carbon-compat (pref behind-wptr :windowRecord.NextWindow) #+carbon-compat (#_getnextwindow behind-wptr)))
    (unless (eql wptr behind-behind-wptr)
      (if (and #+carbon-compat nil
               (not *help-manager-present*)     ; system 7 does this for us.
               closerp)
        (with-focused-view nil            ; _PaintOne plays with the origin.
          (setq rgn *grow-icon-rgn*)
          #-carbon-compat
          (#_CopyRgn (rref wptr windowrecord.visrgn) rgn)
          #+carbon-compat
          (get-window-visrgn wptr rgn)
          (let* ((topleft (rref (rref wptr windowrecord.contrgn) region.rgnbbox.topleft))) ;; we assume this never happens??
            (#_OffsetRgn :ptr rgn :long topleft))
          (#_DiffRgn  (rref wptr windowrecord.strucrgn) rgn rgn)
          (#_SendBehind wptr behind-wptr)
          (#_CalcVisBehind wptr rgn)
          (#_PaintOne wptr rgn))
        (progn          
          (unless #+carbon-compat (AND (typep (window-object behind-wptr) 'windoid)
                                       (not (typep (window-object wptr) 'windoid)))
                  #-carbon-compat nil
                  (#_SendBehind wptr behind-wptr)
                  #+ignore ;; looking for the bring to front problem - this ain't it
                  (when (osx-p)
                    (do-wptrs a-wptr
                      (if (%ptr-eql a-wptr behind-wptr)
                        (incf puke)
                        (if (%ptr-eql a-wptr wptr)
                          (return)))))))))))


(defun autoposition-show (w wptr)
  (autoposition w)
  (if (osx-p) 
    (progn (#_showwindow wptr))
    (#_ShowHide wptr t)))

(defmethod autoposition ((w window))
  (unless (window-shown-p w)
    (let ((info (cdr (assq (slot-value w 'auto-position)
                           (cdr autopos-constraints)))))
      (when info
        (let ((front-window (front-window)))
          (multiple-value-bind (parent-size parent-pos screen-p)
                               (case (second info)
                                 (:main-screen (values *screen-size* #@(0 0) t))
                                 (:parent-window (if front-window
                                                   (values (view-size front-window)
                                                           (view-position front-window))
                                                   (values *screen-size* #@(0 0))))
                                 (:parent-window-screen (if front-window
                                                          (let ((screen (window-screen front-window)))
                                                            (values (screen-size screen)
                                                                    (screen-position screen)
                                                                    t))
                                                          (values *screen-size* #@(0 0) t))))
            (let* ((our-size      (view-size w))
                   (our-height    (point-v our-size))
                   (parent-width  (point-h parent-size))
                   (parent-height (point-v parent-size))
                   (parent-h      (point-h parent-pos))
                   (parent-v      (point-v parent-pos))
                   (pos-h (max parent-h
                               (%i+ parent-h (%iasr 1 (%i- parent-width
                                                           (point-h our-size))))))
                   (pos-v (%i+ parent-v (%iasr 1 (%i- parent-height
                                                      our-height)))))
              (set-view-position
               w (case (first info)
                   (:stagger
                    (cond ((not screen-p)
                           (add-points #@(10 10) parent-pos))
                          ((and front-window
                                (memq (slot-value front-window 'auto-position)
                                      '(:staggerMainScreen
                                        :staggerParentWindow
                                        :staggerParentWindowScreen)))
                           (add-points #@(10 10) (view-position front-window)))
                          (t (add-points parent-pos
                                         (make-point 2 (%i+ (menubar-height)
                                                            (window-title-height w)))))))
                   
                   (:center
                    (make-point pos-h (max parent-v pos-v)))
                   (:alert-pos
                    (make-point pos-h
                                (max parent-v
                                     (%i+ parent-v
                                          (round (%i- parent-height our-height)
                                                 5))))))))))))))

(defmethod window-screen ((w window))
  (let ((position (view-position w)))
    (rlet ((rect :rect :topleft position
                 :bottomright (add-points position (view-size w))))
      (#_GetMaxDevice rect))))

(defmethod window-show ((w window))
  (let ((wptr (wptr w)))
    (when (and (ok-wptr wptr)
               (not #-carbon-compat (rref wptr windowrecord.visible) #+carbon-compat (#_iswindowvisible wptr)))
      (window-show-internal w wptr)))
  w)



(defmethod window-show-internal ((w window) wptr)
  (let ((selected *selected-window*))
    ;; windows are in a different order when carbon and windoid present    
    
    (cond     
     ((or (null selected) #+carbon-compat (> *WINDOID-COUNT* 0)
          (wptr-behind-p (wptr selected) wptr))  ;; IS SELECTED BEHIND THIS - WEIRD?
      (cond ((and (> *windoid-count* 0)                       
                  (do-wptrs w
                    (return (%ptr-eql w wptr))))
             ;(PUSH (LIST 'CASE1 W) barf)
             (unselect-windows t)
             (autoposition-show w wptr)
             (setq *selected-window* w)
             (view-activate-event-handler w))
            ;; seems like we want this case most of the time
            (t ;(PUSH (LIST 'CASE2 W) barf)
               (window-select w))))
     (t ;(PUSH (LIST 'CASE3 W) barf)
        (autoposition-show w wptr)))))

(defmethod window-hide ((w window))
  (if (not (osx-p))
    (#_ShowHide (wptr w) nil)
    (#_hidewindow (wptr w)))
  (when (eq w *selected-window*)
    (window-select (front-window))))

; True if wptr is behind behind
(defun wptr-behind-p (wptr behind)
  (with-macptrs ((w #-carbon-compat (rref behind windowrecord.nextwindow) #+carbon-compat (#_getnextwindow behind)))
    (do () ((%null-ptr-p w) nil)
      (if (%ptr-eql wptr w) (return t))
      (%setf-macptr w #-carbon-compat (rref w windowrecord.nextwindow) #+carbon-compat (#_getnextwindow w)))))

(defmethod window-shown-p ((w window) &aux wptr)
  (and (setq wptr (wptr w))
       #-carbon-compat (rref wptr windowrecord.visible) #+carbon-compat (#_iswindowvisible wptr)))

(defmethod view-position ((w window) &aux (wptr (wptr w)))
  #-carbon-compat
  (%local-to-global wptr (rref wptr windowrecord.portrect.topleft))
  #+carbon-compat
  (rlet ((rect :rect))
    (#_getwindowportbounds wptr rect)
    (%local-to-global wptr (pref rect :rect.topleft))))

(defmethod set-view-position ((w window) h &optional v)
  (cond ((numberp h)
         (setq h (make-point h v))
         (#_MoveWindow (wptr w) (point-h h) (point-v h) nil)
         h)
        (t (set-view-position w (center-window (view-size w) h)))))
#|
(defmethod window-title ((w window) &aux wptr)
;Note - the stuff below compares the window's Pascal title string with
;it's object-name slot.  If they are identical strings, it returns the 
;object-name string.  This avoids consing and makes the result of window-title
;eq to the object-name. Seems silly to me. 
  (or (and (setq wptr (slot-value-if-bound w 'wptr))
           (or 
            (let ((title (slot-value w 'object-name)))
              (and title
                   ; what if its in some weird script - fred-window method deals with script
                   (with-macptrs ((wtitle (pref wptr windowrecord.titlehandle)))
                     (let ((len (length title)))
                       (if (neq len (%hget-byte wtitle 0))
                         nil 
                         (dotimes (i len title)
                           (when (not (eql (%scharcode title i)(%hget-byte wtitle (+ 1 i))))
                             (return nil))))))))
            (rlet ((tp (:string 255)))
                 (#_GetWTitle  wptr tp)
                 (%get-string tp))))
      "<No title>"))
|#
; nearly same as for fred-window
(defmethod window-title ((w window) &aux wptr nm)
  (or (slot-value w 'object-name)
      (and (setq wptr (wptr w))
           (let* ()
             (%stack-block ((np 256))
               (#_getWTitle wptr np)
               (setq nm
                     (%str-from-ptr-in-script  (%inc-ptr np 1) (%get-byte np 0)))
               (setf (slot-value w 'object-name) nm))))
      "<No title>" ))

(defmethod set-window-title ((w window) new-title)
  (let ((wptr (wptr w)))
    (setq new-title (ensure-simple-string (string-arg new-title)))
    (%stack-block ((np 256))
      (let* ((script (#_GetScriptManagerVariable #$smSysScript))
             (n (byte-length new-title script)))
        (when (%i> n 255)
          (error "Title ~S too long"  new-title))
        (with-pointer (p np 1)
          (%put-string-contents p new-title 255 script))
        (%put-byte np n 0)
        (#_SetWTitle wptr np)
        (setf (slot-value w 'object-name) new-title)))
    new-title))

#|
(defmethod set-window-title ((w window) new-title)
  (with-pstrs ((np (setq new-title (ensure-simple-string new-title))))
    (#_SetWTitle (wptr w) np)
    (setf (slot-value w 'object-name) new-title)))
|#

#|
(defmethod view-font-codes ((w window))
  (wptr-font-codes (wptr w)))
|#

(defmethod set-view-font-codes ((w window) ff ms &optional ff-mask ms-mask)
  (declare (ignore ff ms ff-mask ms-mask))
  (multiple-value-bind (new-ff new-ms) (call-next-method)
    (let ((wptr (wptr w)))
      #-carbon-compat
      (when wptr
        (%put-long wptr new-ff 68)
        (%put-long wptr new-ms 72))
      #+carbon-compat
      (when wptr
        (set-wptr-font-codes wptr new-ff new-ms))
      )
    (values new-ff new-ms)))

(defun wptr-font-codes (wptr)
  #-carbon-compat
  (values (%get-long wptr 68) (%get-long wptr 72))
  #+carbon-compat
  (with-macptrs ((port (#_getwindowport wptr)))
    (grafport-font-codes-from-port port)))

#+carbon-compat
(defun grafport-font-codes-from-port (port)
  (let ((font (#_getporttextfont port))
        (face (#_getporttextface port))
        (mode (#_getporttextmode port))
        (size (#_getporttextsize port)))
    (values (logior (ash font 16) (ash face 8))
            (logior (ash mode 16) size))))

(defun grafport-font-codes ()
  (with-port-macptr port
    
    #-carbon-compat
    (values (%get-long port 68) (%get-long port 72))
    #+carbon-compat
    (grafport-font-codes-from-port port)))

;; assume wptr is windowrecord
(defun set-wptr-font-codes (wptr ff ms &optional ff-mask ms-mask)
  (when (or ff-mask ms-mask)
    #-carbon-compat
    (progn
      (if ff-mask
        (setq ff  (%ilogior2 (%ilogand2 ff ff-mask) 
                         (%ilogand2 (%get-long wptr 68) (%ilognot ff-mask)))))
      (if ms-mask
        (setq ms (%ilogior2 (%ilogand2 ms ms-mask) 
                        (%ilogand2 (%get-long wptr 72) (%ilognot ms-mask))))))
    #+carbon-compat
    (multiple-value-bind (port-ff port-ms)(wptr-font-codes wptr)
      (if ff-mask
        (setq ff  (%ilogior2 (%ilogand2 ff ff-mask) 
                         (%ilogand2 port-ff (%ilognot ff-mask)))))
      (if ms-mask
        (setq ms (%ilogior2 (%ilogand2 ms ms-mask) 
                        (%ilogand2 port-ms (%ilognot ms-mask)))))))
      
      
  #-carbon-compat
  (progn
    (%put-long wptr ff 68)
    (%put-long wptr ms 72))
  #+carbon-compat ;; what?  this doesnt ref the port or anything - brain death
  ;; and wptr maybe a port or it may be a windowrecord
  (with-port wptr ;(#_getwindowport wptr) ; 03/31/01
    (progn
      (let ((font (ash ff -16))
            (face (logand (ash ff -8) #xff))
            (mode (ash ms -16))
            (size (logand ms #xffff)))
        (#_textfont font)
        (#_textface face)
        (#_textmode mode)
        (#_textsize size))))   
  (values ff ms))

#+carbon-compat
(defun get-port-ff (port)
  (logior (ash (#_getporttextfont port) 16)(ash (#_getporttextface port) 8)))

#+carbon-compat
(defun get-port-ms (port)
  (logior (ash (#_getporttextmode port) 16)(#_getporttextsize port)))
 
#+carbon-compat ;;  - assume port is set??
(defun set-port-font-codes (port ff ms &optional ff-mask ms-mask)
   (if ff-mask
    (setq ff  (%ilogior2 (%ilogand2 ff ff-mask) 
                         (%ilogand2 (get-port-ff port) (%ilognot ff-mask)))))
   (if ms-mask
    (setq ms (%ilogior2 (%ilogand2 ms ms-mask) 
                        (%ilogand2 (get-port-ms port) (%ilognot ms-mask)))))
   
  (progn
      (let ((font (ash ff -16))
            (face (logand (ash ff -8) #xff))
            (mode (ash ms -16))
            (size (logand ms #xffff)))
        (#_textfont font)
        (#_textface face)
        (#_textmode mode)
        (#_textsize size))))

#|
(deftrap-inline "_GetPortTextFont" 
      ((port (:pointer :cgrafport))) 
  :signed-integer
   () )
(deftrap-inline "_GetPortTextFace" 
      ((port (:pointer :cgrafport))) 
  :style
   () )
(deftrap-inline "_GetPortTextMode" 
      ((port (:pointer :cgrafport))) 
  :signed-integer
   () )
(deftrap-inline "_GetPortTextSize" 
      ((port (:pointer :cgrafport))) 
  :signed-integer
   () )
|#

(defun set-grafport-font-codes (ff ms &optional ff-mask ms-mask)
  (with-port-macptr wptr
    
    #-carbon-compat
    (set-wptr-font-codes wptr ff ms ff-mask ms-mask)
    #+carbon-compat
    (set-port-font-codes wptr ff ms ff-mask ms-mask)))

(defmethod stream-line-length ((v simple-view))
  (multiple-value-bind (ascent descent widmax)
                       (font-info (view-font v))
    (declare (ignore ascent descent))
    (floor (- (point-h (view-size v)) 20) ;always assumes that there is a 
                                        ;scroll bar. Not always correct
                                        ;but little harm done if there isn't
           widmax)))

(defmethod window-filename ((w stream)) (stream-filename w))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                            DA-window                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod initialize-instance ((w da-window) &key)
  (call-next-method)
  (let ((rgn (window-erase-region w)))
    (when rgn
      (setf (window-erase-region w) nil)
      (#_DisposeRgn rgn))
    (when (setq rgn (window-invalid-region w))
      (setf (window-invalid-region w) nil)
      (#_DisposeRgn rgn))))

(defmethod gcable-wptr-p ((w window))
  t)

(defmethod gcable-wptr-p ((w da-window))
  nil)

(defmethod view-clip-region ((w da-window))
  *big-rgn*)

(defmethod view-allocate-clip-region ((w da-window))
  *big-rgn*)

#-carbon-compat ;; no desk accessories in carbon??
(progn
(defmethod Undo ((w da-window))
  (#_SystemEdit 0))

(defmethod Cut ((w da-window))
  (#_SystemEdit 2))

(defmethod Copy ((w da-window))
  (#_SystemEdit 3))

(defmethod Paste ((w da-window))
  (put-external-scrap)
  (#_SystemEdit 4))

(defmethod Clear ((w da-window))
  (#_SystemEdit 5))
)

; since save-menu-item-update enables the item for any window with a
; key handler, all windows should delegate the command
(defmethod window-save ((w window))
  (let ((handler (window-key-handler w)))
    (when handler
      (window-save handler))))


(defmethod window-close ((w da-window) &aux refnum wptr)  
  (when (setq wptr (wptr w))
    #-carbon-compat
    (setq refnum (rref wptr windowrecord.windowKind))
    #+carbon-compat
    (setq refnum (#_getwindowkind wptr))
    (flet ((do-it (wptr w)
             (if (eq refnum #-carbon-compat (rref wptr windowrecord.windowKind) #+carbon-compat (#_getwindowkind wptr))
               (progn
                 (remove-window-object wptr)
                 (setf (wptr w) nil)
                 (window-close w)))))             
    (without-interrupts ; oh puke
     (if  nil ;*window-object-hash*
       (maphash #'do-it *window-object-hash*)       
       (dolist (elt *window-object-alist*)
         (do-it (%car elt)(%cdr elt)))))
     #-carbon-compat ;; ???
     (#_CloseDeskAcc refnum)
     #+carbon-compat
     (#_DisposeWindow wptr))))

;;
(defmethod window-null-event-handler ((w da-window))
  (unless *da-window-on-top*
    (put-external-scrap)
    (setq *da-window-on-top* t))
  (let-globally ((*cursorhook* #'(lambda ())))
    (call-next-method))
  #-carbon-compat ;; ??
  (#_systemtask))

;;;;;;;;;;;;;;;;

(defmethod window-event ((w window))
  ;Change part code to be an argument instead of stashing it away in the event record.
  (let* ((event *current-event*)
         (evtype (rref event eventrecord.what))
         (where (rref event eventrecord.where))
         (mods (rref event eventrecord.modifiers))
         (part (%get-word event $evtPartCode))
         (wptr (wptr w))
         (active-p (window-active-p w)))
    (when (typep wptr 'macptr)
      (with-focused-view w
        (with-font-codes nil nil         ; preserve the font codes.
          (cond
           ((eq evtype $MButDwnEvt)
            (setq *last-mouse-click-window* w)
            (when (or (and active-p
                           (or (%ptr-eql wptr (#_FrontWindow))
                               (eq w (front-window))))
                      (eq part $inGoAway) ; never seems to happen in OS9 unless window is frontmost, so no need to check for OSX
                      (or (eq part $inZoomIn) (eq part $inZoomOut)) ; ditto
                      (and (eq part $inDrag)
                           (or (%ilogbitp $cmdkey mods)
                               (%ilogbitp $optionkey mods)))
                      (progn (window-select-event-handler w)
                             (window-do-first-click w)))
              (cond ((eq part $inGoAway)
                     (when (#_TrackGoAway wptr where)
                       (window-close-event-handler w)))
                    ((or (eq part $inZoomIn) (eq part $inZoomOut))
                     (when (#_TrackBox wptr where part)
                       (without-interrupts
                        (window-zoom-event-handler w part))))
                    ((or (eq part $inContent)
                         (and (eq part $inGrow) (not (window-grow-icon-p w))))
                     (view-click-event-handler w (%global-to-local wptr where)))
                    ((eq part $inDrag)
                     (window-drag-event-handler w where))
                    ((eq part $inGrow)
                     (window-grow-event-handler w where))
                    )))
           ((eq evtype $UpdatEvt) (unless #-carbon-compat (#_SystemEvent event) #+carbon-compat nil (window-update-event-handler w)))
           (active-p
            (cond ((eq evtype $nullEvt) (window-null-event-handler w))
                  ((eq evtype $mButUpEvt) (window-mouse-up-event-handler w))
                  ((eq evtype $keyUpEvt) (window-key-up-event-handler w))
                  ((or (eq evtype $KeyDwnEvt) (eq evtype $AutoKeyEvt))
                   (do-keydown-event w event mods))))
           ((windoid-p w)
            (let ((window-under (window-under w nil nil)))
              (when window-under
                (window-event window-under))))
           ((or (eq evtype $keyDwnEvt) (eq evtype $AutoKeyEvt))
            (do-keydown-event *application* event mods))))))))

(defun window-under (w &optional include-invisibles (include-inactives t))  
  (when (wptr w)
    (with-macptrs ((wptr (%null-ptr)))
      (%setf-macptr wptr (wptr w))
      (loop
        (%setf-macptr wptr #-carbon-compat (rref wptr :windowrecord.nextWindow) #+carbon-compat (#_getnextwindow wptr))
        (when (%null-ptr-p wptr) (return nil))
        (when (or include-invisibles #-carbon-compat (rref wptr :windowRecord.visible) #+carbon-compat (#_iswindowvisible wptr))
          (let ((res (window-object wptr)))
            (when (and res (or include-inactives (window-active-p res)))
              (return res))))))))

(defvar *bufferred-char* nil)

(defun do-keydown-event (w event &optional mods) ;(mods (pref event :eventRecord.modifiers)))
  (declare (ignore mods))
  (let ((char (%get-byte event $evtMessage-b))
        (bc *bufferred-char*))
    (if bc
      (setq *bufferred-char* nil
            char (+ (ash bc 8) char))
      (progn ;unless (extended-character-p char)  ; this cant be right - itsa byte
        (let ((table (get-char-byte-table (get-key-script))))
          (when (and table (eql 1 (aref table char)))
            (setq *bufferred-char* char)
            (return-from do-keydown-event)))))
    (view-key-event-handler w (%code-char char))))
  
(defmethod window-null-event-handler ((w window))
  (update-cursor)
  ;;;;  _WaitNextEvent does _SystemTask for us
  ;(#_SystemTask)
  )

(defmethod window-mouse-up-event-handler ((w window)) ())

(defmethod window-key-up-event-handler ((w window)) ())

(defmethod view-cursor ((w window) point)
  (declare (ignore point))
  (window-cursor w))

; Overwritten in views
(when (not (fboundp 'window-update-cursor))
  (defmethod window-update-cursor ((w window) point)
    (set-cursor (view-cursor w point)))
  
  (defmethod window-update-cursor ((w null) point)
    (declare (ignore point))
    (set-cursor *arrow-cursor*)))

#|
	Change History (most recent last):
	2	12/27/94	akh	merge with d13
|# ;(do not edit past this line!!)
