(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AIFF.p"
; at Wednesday May 1,2002 2:39:35 pm.
; 
;      File:       AIFF.p
;  
;      Contains:   Definition of AIFF file format components.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __AIFF__
; $SETC __AIFF__ := 1

; $I+
; $SETC AIFFIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $AIFFID :|AIFF|)
(defconstant $AIFCID :|AIFC|)
(defconstant $FormatVersionID :|FVER|)
(defconstant $CommonID :|COMM|)
(defconstant $FORMID :|FORM|)
(defconstant $SoundDataID :|SSND|)
(defconstant $MarkerID :|MARK|)
(defconstant $InstrumentID :|INST|)
(defconstant $MIDIDataID :|MIDI|)
(defconstant $AudioRecordingID :|AESD|)
(defconstant $ApplicationSpecificID :|APPL|)
(defconstant $CommentID :|COMT|)
(defconstant $NameID :|NAME|)
(defconstant $AuthorID :|AUTH|)
(defconstant $CopyrightID :|(c) |)
(defconstant $AnnotationID :|ANNO|)

(defconstant $NoLooping 0)
(defconstant $ForwardLooping 1)
(defconstant $ForwardBackwardLooping 2)

;   AIFF-C Versions  
(defconstant $AIFCVersion1 #xA2805140)

; 	 Compression Names 	
(defconstant $NoneName "not compressed")
(defconstant $ACE2to1Name "ACE 2-to-1")
(defconstant $ACE8to3Name "ACE 8-to-3")
(defconstant $MACE3to1Name "MACE 3-to-1")
(defconstant $MACE6to1Name "MACE 6-to-1")
;   Compression Types  
(defconstant $NoneType :|NONE|)
(defconstant $ACE2Type :|ACE2|)
(defconstant $ACE8Type :|ACE8|)
(defconstant $MACE3Type :|MAC3|)
(defconstant $MACE6Type :|MAC6|)

#|
; Warning: Patching def of type ID from translator table: was :unsigned-long, is now :ostype
|#
(def-mactype :id (find-mactype :ostype))
#| 
(def-mactype :id (find-mactype ':unsigned-long)) |#
(def-mactype :markeridtype (find-mactype ':signed-integer))
(def-mactype :chunkheaderptr (find-mactype '(:pointer :chunkheader)))
(defrecord ChunkHeader 
   (ckID :ostype)
   (ckSize :signed-long)
   )

(def-mactype :containerchunkptr (find-mactype '(:pointer :containerchunk)))
(defrecord ContainerChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (formType :ostype)
   )

(def-mactype :formatversionchunkptr (find-mactype '(:pointer :formatversionchunk)))
(defrecord FormatVersionChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (timestamp :unsigned-long)
   )

(def-mactype :commonchunkptr (find-mactype '(:pointer :commonchunk)))
(defrecord CommonChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (numChannels :signed-integer)
   (numSampleFrames :unsigned-long)
   (sampleSize :signed-integer)
   (sampleRate :float80)
   )

(def-mactype :extcommonchunkptr (find-mactype '(:pointer :extcommonchunk)))
(defrecord ExtCommonChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (numChannels :signed-integer)
   (numSampleFrames :unsigned-long)
   (sampleSize :signed-integer)
   (sampleRate :float80)
   (compressionType :ostype)
   (compressionName :signed-byte)               ;   variable length array, Pascal string  
   )

(def-mactype :sounddatachunkptr (find-mactype '(:pointer :sounddatachunk)))
(defrecord SoundDataChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (offset :unsigned-long)
   (blockSize :unsigned-long)
   )

(def-mactype :markerptr (find-mactype '(:pointer :marker)))
(defrecord Marker 
   (id :signed-integer)
   (position :unsigned-long)
   (markerName (:string 255))
   )

(def-mactype :markerchunkptr (find-mactype '(:pointer :markerchunk)))
(defrecord MarkerChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (numMarkers :unsigned-integer)
   (Markers (:array :marker 1))                 ;   variable length array  
   )

(def-mactype :aiffloopptr (find-mactype '(:pointer :aiffloop)))
(defrecord AIFFLoop 
   (playMode :signed-integer)
   (beginLoop :signed-integer)
   (endLoop :signed-integer)
   )

(def-mactype :instrumentchunkptr (find-mactype '(:pointer :instrumentchunk)))
(defrecord InstrumentChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (baseFrequency :unsigned-byte)
   (detune :unsigned-byte)
   (lowFrequency :unsigned-byte)
   (highFrequency :unsigned-byte)
   (lowVelocity :unsigned-byte)
   (highVelocity :unsigned-byte)
   (gain :signed-integer)
   (sustainLoop :aiffloop)
   (releaseLoop :aiffloop)
   )

(def-mactype :mididatachunkptr (find-mactype '(:pointer :mididatachunk)))
(defrecord MIDIDataChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (MIDIdata :signed-byte)                      ;   variable length array  
   )

(def-mactype :audiorecordingchunkptr (find-mactype '(:pointer :audiorecordingchunk)))
(defrecord AudioRecordingChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (AESChannelStatus (:array :unsigned-byte 24 :packed))
   )

(def-mactype :applicationspecificchunkptr (find-mactype '(:pointer :applicationspecificchunk)))
(defrecord ApplicationSpecificChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (applicationSignature :ostype)
   (data :signed-byte)                          ;   variable length array  
   )

(def-mactype :commentptr (find-mactype '(:pointer :comment)))
(defrecord Comment 
   (timeStamp :unsigned-long)
   (marker :signed-integer)
   (count :unsigned-integer)
   (text :signed-byte)                          ;   variable length array, Pascal string  
   )

(def-mactype :commentschunkptr (find-mactype '(:pointer :commentschunk)))
(defrecord CommentsChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (numComments :unsigned-integer)
   (comments (:array :comment 1))               ;   variable length array  
   )

(def-mactype :textchunkptr (find-mactype '(:pointer :textchunk)))
(defrecord TextChunk 
   (ckID :ostype)
   (ckSize :signed-long)
   (text :signed-byte)                          ;   variable length array, Pascal string  
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AIFFIncludes

; $ENDC                                         ; __AIFF__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AIFF)