(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ATSLayoutTypes.p"
; at Wednesday May 1,2002 2:40:28 pm.
; 
;      File:       ATSLayoutTypes.p
;  
;      Contains:   Apple Type Services layout public structures and constants.
;  
;      Version:    Technology: Mac OS 9/Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ATSLAYOUTTYPES__
; $SETC __ATSLAYOUTTYPES__ := 1

; $I+
; $SETC ATSLayoutTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __SFNTLAYOUTTYPES__

(require-interface 'SFNTLayoutTypes)            ; $I SFNTLayoutTypes.p
; $ENDC

#|                                              ; $IFC UNDEFINED __ATSTYPES__
|#

(require-interface 'ATSTypes)
#|                                              ; $I ATSTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  --------------------------------------------------------------------------- 
;  CONSTANTS and related scalar types 
;  --------------------------------------------------------------------------- 
;  Miscellaneous constants 

(defconstant $kATSUseLineHeight #x7FFFFFFF)     ;   assignment to use natural line ascent/descent values  
(defconstant $kATSNoTracking #x80000000)        ;   negativeInfinity  

(def-mactype :atslinelayoutoptions (find-mactype ':unsigned-long))

(defconstant $kATSLineNoLayoutOptions #x0)      ;   no options  
(defconstant $kATSLineIsDisplayOnly #x1)        ;   specifies to optimize for displaying text only  
(defconstant $kATSLineHasNoHangers #x2)         ;   specifies that no hangers to be formed on the line  
(defconstant $kATSLineHasNoOpticalAlignment #x4);   specifies that no optical alignment to be performed on the line  
(defconstant $kATSLineKeepSpacesOutOfMargin #x8);   specifies that space charcters should not be treated as hangers  
(defconstant $kATSLineNoSpecialJustification #x10);   specifies no post-compensation justification is to be performed  
(defconstant $kATSLineLastNoJustification #x20) ;   specifies that if the line is the last of a paragraph, it will not get justified  
(defconstant $kATSLineFractDisable #x40)        ;   specifies that the displayed line glyphs will adjust for device metrics  
(defconstant $kATSLineImposeNoAngleForEnds #x80);   specifies that the carets at the ends of the line will be guarenteed to be perpendicular to the baseline  
(defconstant $kATSLineFillOutToWidth #x100)     ;   highlights for the line end characters will be extended to 0 and the specified line width  
(defconstant $kATSLineTabAdjustEnabled #x200)   ;   specifies that the tab character width will be automatically adjusted to fit the specified line width  
(defconstant $kATSLineIgnoreFontLeading #x400)  ;   specifies that any leading value specified by a font will be ignored  
(defconstant $kATSLineAppleReserved #xFFFFF800) ;   these bits are reserved by Apple and will result in a invalid value error if attemped to set  

(def-mactype :atsstylerenderingoptions (find-mactype ':unsigned-long))

(defconstant $kATSStyleNoOptions #x0)           ;   no options  
(defconstant $kATSStyleApplyHints #x1)          ;   specifies that ATS produce "hinted" glyph outlines (default is on)  
;      kATSStyleApplyAntiAliasing           = 0x00000002L,  /* specifies that ATS produce antialiased glyph images (default is on) future feature */ 
(defconstant $kATSStyleAppleReserved #xFFFFFFFE);   these bits are reserved by Apple and will result in a invalid value error if attemped to set  

; 	 For accessing glyph bounds 	
(defconstant $kATSUseCaretOrigins 0)
(defconstant $kATSUseDeviceOrigins 1)
(defconstant $kATSUseFractionalOrigins 2)
(defconstant $kATSUseOriginFlags 3)

; 	 --------------------------------------------------------------------------- 	
; 	 STRUCTURED TYPES and related constants 	
; 	 --------------------------------------------------------------------------- 	

; 	
; 	    The ATSTrapezoid structure supplies a convenient container
; 	    for glyph bounds in trapezoidal form.
; 		

(def-mactype :atstrapezoidptr (find-mactype '(:pointer :atstrapezoid)))
(defrecord ATSTrapezoid 
   (upperLeft :fixedpoint)
   (upperRight :fixedpoint)
   (lowerRight :fixedpoint)
   (lowerLeft :fixedpoint)
   )

; 	
; 	    The JustWidthDeltaEntryOverride structure specifies values for the grow and shrink case during
; 	    justification, both on the left and on the right. It also contains flags.  This particular structure
; 	    is used for passing justification overrides to LLC.  For further sfnt resource 'just' table
; 	    constants and structures, see SFNTLayoutTypes.h.
; 		
(def-mactype :atsjustwidthdeltaentryoverrideptr (find-mactype '(:pointer :atsjustwidthdeltaentryoverride)))
(defrecord ATSJustWidthDeltaEntryOverride 
   (beforeGrowLimit :signed-long)               ;   ems AW can grow by at most on LT  
   (beforeShrinkLimit :signed-long)             ;   ems AW can shrink by at most on LT  
   (afterGrowLimit :signed-long)                ;   ems AW can grow by at most on RB  
   (afterShrinkLimit :signed-long)              ;   ems AW can shrink by at most on RB  
   (growFlags :unsigned-integer)                ;   flags controlling grow case  
   (shrinkFlags :unsigned-integer)              ;   flags controlling shrink case  
   )

; 	 The JustPriorityOverrides type is an array of 4 width delta records, one per priority level override. 	
(defrecord ATSJustPriorityWidthDeltaOverrides (array (:array :atsjustwidthdeltaentryoverride 4)))
; 	 --------------------------------------------------------------------------- 	
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ATSLayoutTypesIncludes

; $ENDC                                         ; __ATSLAYOUTTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ATSLayoutTypes)