(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AVComponents.p"
; at Wednesday May 1,2002 2:40:52 pm.
; 
;      File:       AVComponents.p
;  
;      Contains:   Standard includes for standard AV panels
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __AVCOMPONENTS__
; $SETC __AVCOMPONENTS__ := 1

; $I+
; $SETC AVComponentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __VIDEO__
|#

(require-interface 'Video)
#|                                              ; $I Video.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DISPLAYS__
|#

(require-interface 'Displays)
#|                                              ; $I Displays.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     The subtypes listed here are for example only.  The display manager will find _all_ panels
;     with the appropriate types.  These panels return class information that is used to devide them
;     up into groups to be displayed in the AV Windows (class means "geometry" or "color" or other groupings
;     like that.
; 

(defconstant $kAVPanelType :|avpc|)             ;   Panel subtypes         
(defconstant $kBrightnessPanelSubType :|brit|)
(defconstant $kContrastPanelSubType :|cont|)
(defconstant $kBitDepthPanelSubType :|bitd|)
(defconstant $kAVEngineType :|avec|)            ;   Engine subtypes           
(defconstant $kBrightnessEngineSubType :|brit|)
(defconstant $kContrastEngineSubType :|cont|)   ;      kBitDepthEngineSubType     = 'bitd',       // Not used               
(defconstant $kAVPortType :|avdp|)              ;   subtypes are defined in each port's public .h file  
(defconstant $kAVUtilityType :|avuc|)
(defconstant $kAVBackChannelSubType :|avbc|)
(defconstant $kAVCommunicationType :|avcm|)
(defconstant $kAVDialogType :|avdg|)

; 	 PortComponent subtypes are up to the port and display manager does not use the subtype
; 	    to find port components.  Instead, display manager uses an internal cache to search for portcompoennts.
; 	    It turns out to be useful to have a unique subtype so that engines can see if they should apply themselves to
; 	    a particular port component.
; 	  
; 	   PortKinds are the "class" of port.  When a port is registered with display manager (creating a display ID), the
; 	    caller of DMNewDisplayIDByPortComponent passes a portKind.  Ports of this type are returned by
; 	    DMNewDevicePortList.
; 	  
; 	   PortKinds are NOT subtypes of components
; 	   PortKinds ARE used to register and find port components with Display Manager.  Here are the basic port kinds:
; 	  
; 	   Video displays are distinct from video out because there are some video out ports that are not actaully displays.
; 	    if EZAV is looking to configure displays, it needs to look for kAVVideoDisplayPortKind not kAVVideoOutPortKind.
; 		
(defconstant $kAVVideoDisplayPortKind :|pkdo|)  ;   Video Display (CRT or panel display)           
(defconstant $kAVVideoOutPortKind :|pkvo|)      ;   Video out port (camera output).                 
(defconstant $kAVVideoInPortKind :|pkvi|)       ;   Video in port (camera input)                
(defconstant $kAVSoundOutPortKind :|pkso|)      ;   Sound out port (speaker or speaker jack)       
(defconstant $kAVSoundInPortKind :|pksi|)       ;   Sound in port (microphone or microphone jack)   
(defconstant $kAVDeviceType :|avdc|)            ;   Device Component subtypes are up to the manufacturor since each device may contain multiple function types (eg telecaster)  
(defconstant $kAVDisplayDeviceKind :|dkvo|)     ;   Display device 
;   Device Component subtypes are up to the manufacturor since each device may contain multiple function types (eg telecaster) 
(defconstant $kAVCategoryType :|avcc|)
(defconstant $kAVSoundInSubType :|avao|)
(defconstant $kAVSoundOutSubType :|avai|)
(defconstant $kAVVideoInSubType :|vdin|)
(defconstant $kAVVideoOutSubType :|vdou|)
(defconstant $kAVInvalidType :|badt|)           ;   Some calls return a component type, in case of errors, these types are set to kAVInvalidComponentType  

; 
; 	   Interface Signatures are used to identify what kind of component
; 	   calls can be made for a given component. Today this applies only
; 	   to ports, but could be applied to other components as well.
; 	
(defconstant $kAVGenericInterfaceSignature :|dmgr|)
(defconstant $kAVAppleVisionInterfaceSignature :|avav|)

; 	 =============================                    	
; 	 Panel Class Constants                            	
; 	 =============================                    	
(defconstant $kAVPanelClassDisplayDefault :|cdsp|)
(defconstant $kAVPanelClassColor :|cclr|)
(defconstant $kAVPanelClassGeometry :|cgeo|)
(defconstant $kAVPanelClassSound :|csnd|)
(defconstant $kAVPanelClassPreferences :|cprf|)
(defconstant $kAVPanelClassLCD :|clcd|)
(defconstant $kAVPanelClassMonitorSound :|cres|)
(defconstant $kAVPanelClassAlert :|calr|)
(defconstant $kAVPanelClassExtras :|cext|)
(defconstant $kAVPanelClassRearrange :|crea|)

; 	 =============================                    	
; 	 AV Notification Types                            	
; 	 =============================                    	
; 
; 	   This notification will be sent whenever a
; 	   device has been reset, for whatever reason.
; 	
(defconstant $kAVNotifyDeviceReset :|rset|)

; 	 =============================                    	
; 	 Component interface revision levels and history  	
; 	 =============================                    	
(defconstant $kAVPanelComponentInterfaceRevOne 1)
(defconstant $kAVPanelComponentInterfaceRevTwo 2)
(defconstant $kAVEngineComponentInterfaceRevOne 1)
(defconstant $kAVPortComponentInterfaceRevOne 1)
(defconstant $kAVDeviceComponentInterfaceRevOne 1)
(defconstant $kAVUtilityComponentInterfaceRevOne 1)

; 	 =============================                    	
; 	 Adornment Constants                              	
; 	 =============================                    	
(defconstant $kAVPanelAdornmentNoBorder 0)
(defconstant $kAVPanelAdornmentStandardBorder 1)

(defconstant $kAVPanelAdornmentNoName 0)
(defconstant $kAVPanelAdornmentStandardName 1)

; 	 =============================                    	
; 	 Selector Ranges                                  	
; 	 =============================                    	
(defconstant $kBaseAVComponentSelector 256)     ;   First apple-defined selector for AV components  
(defconstant $kAppleAVComponentSelector 512)    ;   First apple-defined type-specific selector for AV components  

; 	 =============================                	
; 	 Panel Standard component selectors           	
; 	 =============================                	
(defconstant $kAVPanelFakeRegisterSelect -5)    ;   -5  
(defconstant $kAVPanelSetCustomDataSelect 0)
(defconstant $kAVPanelGetDitlSelect 1)
(defconstant $kAVPanelGetTitleSelect 2)
(defconstant $kAVPanelInstallSelect 3)
(defconstant $kAVPanelEventSelect 4)
(defconstant $kAVPanelItemSelect 5)
(defconstant $kAVPanelRemoveSelect 6)
(defconstant $kAVPanelValidateInputSelect 7)
(defconstant $kAVPanelGetSettingsIdentifiersSelect 8)
(defconstant $kAVPanelGetSettingsSelect 9)
(defconstant $kAVPanelSetSettingsSelect 10)
(defconstant $kAVPanelSelectorGetFidelitySelect 256)
(defconstant $kAVPanelSelectorTargetDeviceSelect 257)
(defconstant $kAVPanelSelectorGetPanelClassSelect 258)
(defconstant $kAVPanelSelectorGetPanelAdornmentSelect 259)
(defconstant $kAVPanelSelectorGetBalloonHelpStringSelect 260)
(defconstant $kAVPanelSelectorAppleGuideRequestSelect 261)
(defconstant $kAVPanelSelectorGetFocusStatusSelect 262)
(defconstant $kAVPanelSelectorSetFocusStatusSelect 263)

; 	 =============================                	
; 	 Engine Standard component selectors          	
; 	 =============================                	
(defconstant $kAVEngineGetEngineFidelitySelect 256)
(defconstant $kAVEngineTargetDeviceSelect 257)

; 	 =============================                    	
; 	 Video Port Specific calls                        	
; 	 =============================                    	
(defconstant $kAVPortCheckTimingModeSelect 0)
(defconstant $kAVPortReserved1Select 1)         ;   Reserved 
(defconstant $kAVPortReserved2Select 2)         ;   Reserved 
(defconstant $kAVPortGetDisplayTimingInfoSelect 512)
(defconstant $kAVPortGetDisplayProfileCountSelect 513)
(defconstant $kAVPortGetIndexedDisplayProfileSelect 514)
(defconstant $kAVPortGetDisplayGestaltSelect 515)
(defconstant $kAVPortGetDisplayTimingCountSelect 516)
(defconstant $kAVPortGetIndexedDisplayTimingSelect 517)
(defconstant $kAVPortGetDisplayTimingRangeCountSelect 518)
(defconstant $kAVPortGetIndexedDisplayTimingRangeSelect 519)

; 	 =============================                    	
; 	 AV Port Specific calls                           	
; 	 =============================                    	
(defconstant $kAVPortGetAVDeviceFidelitySelect 256);   Port Standard Component selectors  
(defconstant $kAVPortGetWiggleSelect 257)
(defconstant $kAVPortSetWiggleSelect 258)
(defconstant $kAVPortGetNameSelect 259)
(defconstant $kAVPortGetGraphicInfoSelect 260)
(defconstant $kAVPortSetActiveSelect 261)
(defconstant $kAVPortGetActiveSelect 262)
(defconstant $kAVPortUnsed1Select 263)          ;   Selector removed as part of API change.  We don't want to mess up the following selectors, so we put in this spacer (ie kPadSelector).  
(defconstant $kAVPortGetAVIDSelect 264)
(defconstant $kAVPortSetAVIDSelect 265)
(defconstant $kAVPortSetDeviceAVIDSelect 266)   ;   For registrar to set device (instead of hitting global directly) -- should only be called once  
(defconstant $kAVPortGetDeviceAVIDSelect 267)   ;   Called by display mgr for generic ports  
(defconstant $kAVPortGetPowerStateSelect 268)
(defconstant $kAVPortSetPowerStateSelect 269)
(defconstant $kAVPortGetMakeAndModelSelect 270) ;   Get Make and model information 
(defconstant $kAVPortGetInterfaceSignatureSelect 271);   To determine what VideoPort-specific calls can be made 
(defconstant $kAVPortReserved3Select 272)       ;   Reserved 
(defconstant $kAVPortGetManufactureInfoSelect 273);   Get more Make and model information   

; 	 =============================                    	
; 	 Device Component Standard Component selectors    	
; 	 =============================                    	
(defconstant $kAVDeviceGetNameSelect 256)
(defconstant $kAVDeviceGetGraphicInfoSelect 257)
(defconstant $kAVDeviceGetPowerStateSelect 258)
(defconstant $kAVDeviceSetPowerStateSelect 259)
(defconstant $kAVDeviceGetAVIDSelect 260)
(defconstant $kAVDeviceSetAVIDSelect 261)

; 	 =============================                    	
; 	 AV Back-Channel Selectors                        	
; 	 =============================                    	
(defconstant $kAVBackChannelReservedSelector 1)
(defconstant $kAVBackChannelPreModalFilterSelect 2)
(defconstant $kAVBackChannelModalFilterSelect 3)
(defconstant $kAVBackChannelAppleGuideLaunchSelect 4)

; 	 =============================                	
; 	 Engine Standard component selectors          	
; 	 =============================                	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  AVEngineComponentGetFidelity()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_AVEngineComponentGetFidelity" 
      ((engineComponent (:pointer :componentinstancerecord)) (displayID :unsigned-long) (engineFidelity (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 engineComponent displayID engineFidelity ((+ (ash 8 16) 256) :signed-longint)))

; 
;  *  AVEngineComponentTargetDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVEngineComponentTargetDevice" 
      ((engineComponent (:pointer :componentinstancerecord)) (displayID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 engineComponent displayID ((+ (ash 4 16) 257) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  =============================                
;  Panel Standard Component calls               
;  =============================                
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AVPanelFakeRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelFakeRegister" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ((+ (ash 0 16) 65531) :signed-longint)))

; 
;  *  AVPanelSetCustomData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelSetCustomData" 
      ((ci (:pointer :componentinstancerecord)) (theCustomData :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci theCustomData ((+ (ash 4 16) 0) :signed-longint)))

; 
;  *  AVPanelGetDitl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelGetDitl" 
      ((ci (:pointer :componentinstancerecord)) (ditl (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ditl ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  AVPanelGetTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelGetTitle" 
      ((ci (:pointer :componentinstancerecord)) (title (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci title ((+ (ash 4 16) 2) :signed-longint)))

; 
;  *  AVPanelInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelInstall" 
      ((ci (:pointer :componentinstancerecord)) (dialog (:pointer :grafport)) (itemOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci dialog itemOffset ((+ (ash 8 16) 3) :signed-longint)))

; 
;  *  AVPanelEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelEvent" 
      ((ci (:pointer :componentinstancerecord)) (dialog (:pointer :grafport)) (itemOffset :signed-long) (event (:pointer :eventrecord)) (itemHit (:pointer :signed-integer)) (handled (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci dialog itemOffset event itemHit handled ((+ (ash 20 16) 4) :signed-longint)))

; 
;  *  AVPanelItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelItem" 
      ((ci (:pointer :componentinstancerecord)) (dialog (:pointer :grafport)) (itemOffset :signed-long) (itemNum :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci dialog itemOffset itemNum ((+ (ash 10 16) 5) :signed-longint)))

; 
;  *  AVPanelRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelRemove" 
      ((ci (:pointer :componentinstancerecord)) (dialog (:pointer :grafport)) (itemOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci dialog itemOffset ((+ (ash 8 16) 6) :signed-longint)))

; 
;  *  AVPanelValidateInput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelValidateInput" 
      ((ci (:pointer :componentinstancerecord)) (ok (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ok ((+ (ash 4 16) 7) :signed-longint)))

; 
;  *  AVPanelGetSettingsIdentifiers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelGetSettingsIdentifiers" 
      ((ci (:pointer :componentinstancerecord)) (theID (:pointer :signed-integer)) (theType (:pointer :ostype)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci theID theType ((+ (ash 8 16) 8) :signed-longint)))

; 
;  *  AVPanelGetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelGetSettings" 
      ((ci (:pointer :componentinstancerecord)) (userDataHand (:pointer :handle)) (flags :signed-long) (theDialog (:pointer :grafport)) (itemsOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci userDataHand flags theDialog itemsOffset ((+ (ash 16 16) 9) :signed-longint)))

; 
;  *  AVPanelSetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelSetSettings" 
      ((ci (:pointer :componentinstancerecord)) (userDataHand :handle) (flags :signed-long) (theDialog (:pointer :grafport)) (itemsOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci userDataHand flags theDialog itemsOffset ((+ (ash 16 16) 10) :signed-longint)))

; 
;  *  AVPanelGetFidelity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelGetFidelity" 
      ((panelComponent (:pointer :componentinstancerecord)) (displayID :unsigned-long) (panelFidelity (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent displayID panelFidelity ((+ (ash 8 16) 256) :signed-longint)))

; 
;  *  AVPanelComponentTargetDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentTargetDevice" 
      ((panelComponent (:pointer :componentinstancerecord)) (displayID :unsigned-long) (theDialog (:pointer :grafport)) (itemsOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent displayID theDialog itemsOffset ((+ (ash 12 16) 257) :signed-longint)))

; 
;  *  AVPanelComponentGetPanelClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentGetPanelClass" 
      ((panelComponent (:pointer :componentinstancerecord)) (panelClass (:pointer :ostype)) (subClass (:pointer :ostype)) (reserved1 :pointer) (reserved2 :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent panelClass subClass reserved1 reserved2 ((+ (ash 16 16) 258) :signed-longint)))

; 
;  *  AVPanelComponentGetPanelAdornment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentGetPanelAdornment" 
      ((panelComponent (:pointer :componentinstancerecord)) (panelBorderType (:pointer :signed-long)) (panelNameType (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent panelBorderType panelNameType ((+ (ash 8 16) 259) :signed-longint)))

; 
;  *  AVPanelComponentGetBalloonHelpString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentGetBalloonHelpString" 
      ((panelComponent (:pointer :componentinstancerecord)) (item :signed-integer) (balloonString (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent item balloonString ((+ (ash 6 16) 260) :signed-longint)))

; 
;  *  AVPanelComponentAppleGuideRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentAppleGuideRequest" 
      ((panelComponent (:pointer :componentinstancerecord)) (agSelector :ostype) (agDataReply :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent agSelector agDataReply ((+ (ash 8 16) 261) :signed-longint)))

; 
;  *  AVPanelComponentGetFocusStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentGetFocusStatus" 
      ((panelComponent (:pointer :componentinstancerecord)) (hasFocus (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent hasFocus ((+ (ash 4 16) 262) :signed-longint)))

; 
;  *  AVPanelComponentSetFocusStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPanelComponentSetFocusStatus" 
      ((panelComponent (:pointer :componentinstancerecord)) (theDialog (:pointer :grafport)) (itemOffset :signed-long) (gettingFocus :boolean) (tookFocus (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 panelComponent theDialog itemOffset gettingFocus tookFocus ((+ (ash 14 16) 263) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  =============================                
;  Port Component Standard Component selectors  
;  =============================                
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AVPortGetAVDeviceFidelity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetAVDeviceFidelity" 
      ((portComponent (:pointer :componentinstancerecord)) (deviceAVID :unsigned-long) (portFidelity (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent deviceAVID portFidelity ((+ (ash 8 16) 256) :signed-longint)))

; 
;  *  AVPortGetWiggle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetWiggle" 
      ((portComponent (:pointer :componentinstancerecord)) (wiggleDevice (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent wiggleDevice ((+ (ash 4 16) 257) :signed-longint)))

; 
;  *  AVPortSetWiggle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortSetWiggle" 
      ((portComponent (:pointer :componentinstancerecord)) (wiggleDevice :boolean))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent wiggleDevice ((+ (ash 2 16) 258) :signed-longint)))

; 
;  *  AVPortGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetName" 
      ((portComponent (:pointer :componentinstancerecord)) (portName (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent portName ((+ (ash 4 16) 259) :signed-longint)))

; 
;  *  AVPortGetGraphicInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetGraphicInfo" 
      ((portComponent (:pointer :componentinstancerecord)) (thePict (:pointer (:handle :picture))) (theIconSuite (:pointer :handle)) (theLocation (:pointer :avlocationrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent thePict theIconSuite theLocation ((+ (ash 12 16) 260) :signed-longint)))

; 
;  *  AVPortSetActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortSetActive" 
      ((portComponent (:pointer :componentinstancerecord)) (setActive :boolean))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent setActive ((+ (ash 2 16) 261) :signed-longint)))

; 
;  *  AVPortGetActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetActive" 
      ((portComponent (:pointer :componentinstancerecord)) (isPortActive (:pointer :boolean)) (portCanBeActivated (:pointer :boolean)) (reserved :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent isPortActive portCanBeActivated reserved ((+ (ash 12 16) 262) :signed-longint)))

; 
;  *  AVPortGetAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetAVID" 
      ((portComponent (:pointer :componentinstancerecord)) (avPortID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent avPortID ((+ (ash 4 16) 264) :signed-longint)))

; 
;  *  AVPortSetAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortSetAVID" 
      ((portComponent (:pointer :componentinstancerecord)) (avPortID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent avPortID ((+ (ash 4 16) 265) :signed-longint)))

; 
;  *  AVPortSetDeviceAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortSetDeviceAVID" 
      ((portComponent (:pointer :componentinstancerecord)) (avDeviceID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent avDeviceID ((+ (ash 4 16) 266) :signed-longint)))

; 
;  *  AVPortGetDeviceAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDeviceAVID" 
      ((portComponent (:pointer :componentinstancerecord)) (avDeviceID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent avDeviceID ((+ (ash 4 16) 267) :signed-longint)))

; 
;  *  AVPortGetPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetPowerState" 
      ((portComponent (:pointer :componentinstancerecord)) (getPowerState (:pointer :vdpowerstaterec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent getPowerState ((+ (ash 4 16) 268) :signed-longint)))

; 
;  *  AVPortSetPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortSetPowerState" 
      ((portComponent (:pointer :componentinstancerecord)) (setPowerState (:pointer :vdpowerstaterec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent setPowerState ((+ (ash 4 16) 269) :signed-longint)))

; 
;  *  AVPortGetMakeAndModel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetMakeAndModel" 
      ((portComponent (:pointer :componentinstancerecord)) (theDisplayID :unsigned-long) (manufacturer (:pointer :ostype)) (model (:pointer :unsigned-long)) (serialNumber (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent theDisplayID manufacturer model serialNumber ((+ (ash 16 16) 270) :signed-longint)))

; 
;  *  AVPortGetInterfaceSignature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetInterfaceSignature" 
      ((portComponent (:pointer :componentinstancerecord)) (interfaceSignature (:pointer :ostype)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent interfaceSignature ((+ (ash 4 16) 271) :signed-longint)))

; 
;  *  AVPortGetManufactureInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetManufactureInfo" 
      ((portComponent (:pointer :componentinstancerecord)) (theDisplayID :unsigned-long) (theMakeAndModel (:pointer :dmmakeandmodelrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 portComponent theDisplayID theMakeAndModel ((+ (ash 8 16) 273) :signed-longint)))

;  =============================                
;  Video Out Port Component Selectors           
;  =============================                
; 
;  *  AVPortCheckTimingMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortCheckTimingMode" 
      ((displayComponent (:pointer :componentinstancerecord)) (theDisplayID :unsigned-long) (connectInfo (:pointer :vddisplayconnectinforec)) (modeTiming (:pointer :vdtiminginforec)) (theDetailedTiming (:pointer :vddetailedtimingrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent theDisplayID connectInfo modeTiming theDetailedTiming ((+ (ash 16 16) 0) :signed-longint)))

; 
;  *  AVPortGetDisplayTimingInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDisplayTimingInfo" 
      ((displayComponent (:pointer :componentinstancerecord)) (modeTiming (:pointer :vdtiminginforec)) (requestedVersion :unsigned-long) (modeInfo (:pointer :dmdisplaytiminginforec)) (theDetailedTiming (:pointer :vddetailedtimingrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent modeTiming requestedVersion modeInfo theDetailedTiming ((+ (ash 16 16) 512) :signed-longint)))

; 
;  *  AVPortGetDisplayProfileCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDisplayProfileCount" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :unsigned-long) (profileCount (:pointer :unsigned-long)) (profileSeed (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved profileCount profileSeed ((+ (ash 12 16) 513) :signed-longint)))

; 
;  *  AVPortGetIndexedDisplayProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetIndexedDisplayProfile" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :unsigned-long) (profileIndex :unsigned-long) (profileSeed :unsigned-long) (indexedProfile (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved profileIndex profileSeed indexedProfile ((+ (ash 16 16) 514) :signed-longint)))

; 
;  *  AVPortGetDisplayGestalt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDisplayGestalt" 
      ((displayComponent (:pointer :componentinstancerecord)) (displayGestaltSelector :ostype) (displayGestaltResponse (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent displayGestaltSelector displayGestaltResponse ((+ (ash 8 16) 515) :signed-longint)))

; 
;  *  AVPortGetDisplayTimingCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDisplayTimingCount" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :pointer) (timingCount (:pointer :unsigned-long)) (timingsSeed (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved timingCount timingsSeed ((+ (ash 12 16) 516) :signed-longint)))

; 
;  *  AVPortGetIndexedDisplayTiming()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetIndexedDisplayTiming" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :pointer) (timingIndex :unsigned-long) (timingsSeed :unsigned-long) (indexedTiming (:pointer :vddetailedtimingrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved timingIndex timingsSeed indexedTiming ((+ (ash 16 16) 517) :signed-longint)))

; 
;  *  AVPortGetDisplayTimingRangeCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetDisplayTimingRangeCount" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :pointer) (rangeCount (:pointer :unsigned-long)) (rangeSeed (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved rangeCount rangeSeed ((+ (ash 12 16) 518) :signed-longint)))

; 
;  *  AVPortGetIndexedDisplayTimingRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVPortGetIndexedDisplayTimingRange" 
      ((displayComponent (:pointer :componentinstancerecord)) (reserved :pointer) (rangeIndex :unsigned-long) (rangeSeed :unsigned-long) (indexedRange (:pointer :vddisplaytimingrangerec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 displayComponent reserved rangeIndex rangeSeed indexedRange ((+ (ash 16 16) 519) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  =============================                
;  AV Device Component Selectors                
;  =============================                
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AVDeviceGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceGetName" 
      ((deviceComponent (:pointer :componentinstancerecord)) (portName (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent portName ((+ (ash 4 16) 256) :signed-longint)))

; 
;  *  AVDeviceGetGraphicInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceGetGraphicInfo" 
      ((deviceComponent (:pointer :componentinstancerecord)) (thePict (:pointer (:handle :picture))) (theIconSuite (:pointer :handle)) (theLocation (:pointer :avlocationrec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent thePict theIconSuite theLocation ((+ (ash 12 16) 257) :signed-longint)))

; 
;  *  AVDeviceGetPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceGetPowerState" 
      ((deviceComponent (:pointer :componentinstancerecord)) (getPowerState (:pointer :vdpowerstaterec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent getPowerState ((+ (ash 4 16) 258) :signed-longint)))

; 
;  *  AVDeviceSetPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceSetPowerState" 
      ((deviceComponent (:pointer :componentinstancerecord)) (setPowerState (:pointer :vdpowerstaterec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent setPowerState ((+ (ash 4 16) 259) :signed-longint)))

; 
;  *  AVDeviceGetAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceGetAVID" 
      ((deviceComponent (:pointer :componentinstancerecord)) (avDeviceID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent avDeviceID ((+ (ash 4 16) 260) :signed-longint)))

; 
;  *  AVDeviceSetAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVDeviceSetAVID" 
      ((deviceComponent (:pointer :componentinstancerecord)) (avDeviceID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 deviceComponent avDeviceID ((+ (ash 4 16) 261) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  =============================                
;  AV BackChannel Component Selectors           
;  =============================                
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AVBackChannelPreModalFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVBackChannelPreModalFilter" 
      ((compInstance (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 compInstance ((+ (ash 0 16) 2) :signed-longint)))

; 
;  *  AVBackChannelModalFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVBackChannelModalFilter" 
      ((compInstance (:pointer :componentinstancerecord)) (theEvent (:pointer :eventrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 compInstance theEvent ((+ (ash 4 16) 3) :signed-longint)))

; 
;  *  AVBackChannelAppleGuideLaunch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVBackChannelAppleGuideLaunch" 
      ((compInstance (:pointer :componentinstancerecord)) (theSubject (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 compInstance theSubject ((+ (ash 4 16) 4) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AVComponentsIncludes

; $ENDC                                         ; __AVCOMPONENTS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AVComponents)