(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AVLTree.p"
; at Wednesday May 1,2002 2:40:10 pm.
; 
;      File:       AVLTree.p
;  
;      Contains:   Prototypes for routines which create, destroy, allow for
;  
;      Version:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __AVLTREE__
; $SETC __AVLTREE__ := 1

; $I+
; $SETC AVLTreeIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :avlflags (find-mactype ':unsigned-long))

(defconstant $kAVLFlagUseHandleForDataStorageMask #x1)

; 	 The visit stage for AVLWalk() walkProcs 	

(def-mactype :avlvisitstage (find-mactype ':unsigned-integer))

(defconstant $kAVLPreOrder 0)
(defconstant $kAVLInOrder 1)
(defconstant $kAVLPostOrder 2)

; 	 The order the tree is walked or disposed of. 	

(def-mactype :avlorder (find-mactype ':unsigned-integer))

(defconstant $kAVLLeftToRight 0)
(defconstant $kAVLRightToLeft 1)

; 	 The type of the node being passed to a callback proc. 	

(def-mactype :avlnodetype (find-mactype ':unsigned-integer))

(defconstant $kAVLIsTree 0)
(defconstant $kAVLIsLeftBranch 1)
(defconstant $kAVLIsRightBranch 2)
(defconstant $kAVLIsLeaf 3)
(defconstant $kAVLNullNode 4)

(defconstant $errItemAlreadyInTree -960)
(defconstant $errNotValidTree -961)
(defconstant $errItemNotFoundInTree -962)
(defconstant $errCanNotInsertWhileWalkProcInProgress -963)
(defconstant $errTreeIsLocked -964)
(defconstant $errTreeIsCorrupt -965)

;    The structure of a tree.  It's opaque; don't assume it's 52 bytes in size. 

(def-mactype :avltreestructptr (find-mactype '(:pointer :avltreestruct)))
(defrecord AVLTreeStruct 
   (signature :ostype)
   (privateStuff (:array :unsigned-long 12))
   )

(def-mactype :avltreeptr (find-mactype '(:pointer :avltreestruct)))
; 
; 	    Every tree must have a function which compares the data for two items and returns < 0, 0, or >0
; 	    for the items - < 0 if the first item is 'before' the second item according to some criteria,
; 	    == 0 if the two items are identical according to the criteria, or > 0 if the first item is
; 	    'after' the second item according to the criteria.  The comparison function is also passed the
; 	    node type, but most of the time this can be ignored.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AVLCompareItemsProcPtr = FUNCTION(tree: AVLTreePtr; i1: UNIV Ptr; i2: UNIV Ptr; nd_typ: AVLNodeType): SInt32;

|#
 |#                                             ; $ELSEC
(def-mactype :avlcompareitemsprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	    Every tree must have a itemSizeProc; this routine gets passed a pointer to the item's data and
; 	    returns the size of the data.  If a tree contains records of a fixed size, this function can
; 	    just return sizeof( that-struct ); otherwise it should calculate the size of the item based on
; 	    the data for the item.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AVLItemSizeProcPtr = FUNCTION(tree: AVLTreePtr; itemPtr: UNIV Ptr): UInt32;

|#
 |#                                             ; $ELSEC
(def-mactype :avlitemsizeprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	    A tree may have an optional disposeItemProc, which gets called whenever an item is removed
; 	    from the tree ( via AVLRemove() or when AVLDispose() deletes all of the items in the tree ).
; 	    This might be useful if the nodes in the tree own 'resources'  ( like, open files ) which
; 	    should be released before the item is removed.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AVLDisposeItemProcPtr = PROCEDURE(tree: AVLTreePtr; dataP: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :avldisposeitemprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	    The common way to iterate across all of the items in a tree is via AVLWalk(), which takes
; 	    a walkProcPtr.  This function will get called for every item in the tree three times, as
; 	    the tree is being walked across.  First, the walkProc will get called with visitStage ==
; 	    kAVLPreOrder, at which point internally the node of the tree for the given data has just
; 	    been reached.  Later, this function will get called with visitStage == kAVLInOrder, and
; 	    lastly this function will get called with visitStage == kAVLPostOrder.
; 	    The 'minimum' item in the tree will get called with visitStage == kInOrder first, followed
; 	    by the 'next' item in the tree, up until the last item in the tree structure is called.
; 	    In general, you'll only care about calls to this function when visitStage == kAVLInOrder.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AVLWalkProcPtr = FUNCTION(tree: AVLTreePtr; dataP: UNIV Ptr; visitStage: AVLVisitStage; node: AVLNodeType; level: UInt32; balance: SInt32; refCon: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :avlwalkprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :avlcompareitemsupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :avlcompareitemsupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :avlitemsizeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :avlitemsizeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :avldisposeitemupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :avldisposeitemupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :avlwalkupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :avlwalkupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppAVLCompareItemsProcInfo #x2FF0)
(defconstant $uppAVLItemSizeProcInfo #x3F0)
(defconstant $uppAVLDisposeItemProcInfo #x3C0)
(defconstant $uppAVLWalkProcInfo #xFEBE0)
; 
; 	 *  NewAVLCompareItemsUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewAVLCompareItemsProc 
(deftrap "_NewAVLCompareItemsUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAVLItemSizeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewAVLItemSizeProc 
(deftrap "_NewAVLItemSizeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAVLDisposeItemUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewAVLDisposeItemProc 
(deftrap "_NewAVLDisposeItemUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAVLWalkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewAVLWalkProc 
(deftrap "_NewAVLWalkUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAVLCompareItemsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAVLCompareItemsUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAVLItemSizeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAVLItemSizeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAVLDisposeItemUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAVLDisposeItemUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAVLWalkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAVLWalkUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAVLCompareItemsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAVLCompareItemsProc 
(deftrap-inline "_InvokeAVLCompareItemsUPP" 
      ((tree (:pointer :avltreestruct)) (i1 :pointer) (i2 :pointer) (nd_typ :unsigned-integer) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeAVLItemSizeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAVLItemSizeProc 
(deftrap-inline "_InvokeAVLItemSizeUPP" 
      ((tree (:pointer :avltreestruct)) (itemPtr :pointer) (userRoutine :pointer)) 
  :unsigned-long
   (#x205F #x4E90) )

; 
;  *  InvokeAVLDisposeItemUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAVLDisposeItemProc 
(deftrap-inline "_InvokeAVLDisposeItemUPP" 
      ((tree (:pointer :avltreestruct)) (dataP :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeAVLWalkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAVLWalkProc 
(deftrap-inline "_InvokeAVLWalkUPP" 
      ((tree (:pointer :avltreestruct)) (dataP :pointer) (visitStage :unsigned-integer) (node :unsigned-integer) (level :unsigned-long) (balance :signed-long) (refCon :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;     Create an AVL tree.  The compareItemsProc and the sizeItemProc are required; disposeItemProc is
;     optional and can be nil.  The refCon is stored with the list, and is passed back to the
;     compareItemsProc, sizeItemProc, and disposeItemsProc calls.  The allocation of the tree ( and all
;     nodes later added to the list with AVLInsert ) will be created in what is the current zone at the
;     time AVLInit() is called.  Always call AVLDispose() to dispose of a list created with AVLInit().
; 
; 
;  *  AVLInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLInit" 
      ((flags :unsigned-long) (compareItemsProc :pointer) (sizeItemProc :pointer) (disposeItemProc :pointer) (refCon :pointer) (tree (:pointer (:pointer :avltreestruct))))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 3073 flags compareItemsProc sizeItemProc disposeItemProc refCon tree))

; 
;     Dispose of an AVL tree.  This will dispose of each item in the tree in the order specified,
;     call the tree's disposeProc proc for each item, and then dispose of the space allocated for
;     the tree itself.
; 
; 
;  *  AVLDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLDispose" 
      ((tree (:pointer (:pointer :avltreestruct))) (order :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 770 tree order))

; 
;     Iterate across all of the items in the tree, in the order specified.  kLeftToRight is
;     basically lowest-to-highest order, kRightToLeft is highest-to-lowest order.  For each
;     node in the tree, it will call the walkProc with three messages ( at the appropriate 
;     time ).  First, with kAVLPreOrder when the walking gets to this node in the tree,
;     before handling either the left or right subtree, secondly, with kAVLInOrder after
;     handling one subtree but before handling the other, and lastly with kAVLPostOrder after
;     handling both subtrees.  If you want to handle items in order, then only do something
;     if the visit stage is kAVLInOrder.  You can only call AVLRemove() from inside a walkProc
;     if visit stage is kAVLPostOrder ( because if you remove a node during the pre or in order
;     stages you will corrupt the list ) OR if you return a non-zero result from the walkProc
;     call which called AVLRemove() to immediately terminate the walkProc.  Do not call AVLInsert()
;     to insert a node into the tree from inside a walkProc.
;     The walkProc function gets called with the AVLTreePtr, a pointer to the data for the
;     current node ( which you can change in place as long as you do not affect the order within
;     the tree ), the visit stage, the type of the current node ( leaf node, right or left branch,
;     or full tree ), the level within the tree ( the root is level 1 ), the balance for the
;     current node, and the refCon passed to AVLWalk().  This refCon is different from the one passed
;     into AVLInit(); use AVLGetRefCon() to get that refCon if you want it inside a walkProc.
;     ( Most walkProcs will not care about the values for node type, level, or balance. )
; 
; 
;  *  AVLWalk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLWalk" 
      ((tree (:pointer :avltreestruct)) (walkProc :pointer) (order :unsigned-integer) (walkRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 1795 tree walkProc order walkRefCon))

;    Return  the number of items in the given tree. 
; 
;  *  AVLCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLCount" 
      ((tree (:pointer :avltreestruct)) (count (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 2052 tree count))

; 
;     Return the one-based index-th item from the tree by putting it's data at dataPtr
;     if dataPtr is non-nil, and it's size into *itemSize if itemSize is non-nil.
;     If index is out of range, return errItemNotFoundInTree.  ( Internally, this does
;     an AVLWalk(), so the tree can not be modified while this call is in progress ).
; 
; 
;  *  AVLGetIndItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLGetIndItem" 
      ((tree (:pointer :avltreestruct)) (index :unsigned-long) (dataPtr :pointer) (itemSize (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 2053 tree index dataPtr itemSize))

; 
;     Insert the given item into the tree.  This will call the tree's sizeItemProc
;     to determine how big the item at data is, and then will make a copy of the
;     item and insert it into the tree in the appropriate place.  If an item already
;     exists in the tree with the same key ( so that the compareItemsUPP returns 0
;     when asked to compare this item to an existing one ), then it will return
;     errItemNotFoundInTree.
; 
; 
;  *  AVLInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLInsert" 
      ((tree (:pointer :avltreestruct)) (data :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 1030 tree data))

; 
;     Remove any item from the tree with the given key.  If dataPtr != nil, then
;     copy the item's data to dataPtr before removing it from the tree.  Before
;     removing the item, call the tree's disposeItemProc to let it release anything
;     used by the data in the tree.  It is not necessary to fill in a complete
;     record for key, only that the compareItemsProc return 0 when asked to compare
;     the data at key with the node in the tree to be deleted.  If the item cannot
;     be found in the tree, this will return errItemNotFoundInTree.
; 
; 
;  *  AVLRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLRemove" 
      ((tree (:pointer :avltreestruct)) (key :pointer) (dataPtr :pointer) (itemSize (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 2055 tree key dataPtr itemSize))

; 
;     Find the item in the tree with the given key, and return it's data in
;     dataPtr ( if dataPtr != nil ), and it's size in *itemSize ( if itemSize
;     != nil ).  It is not necessary to fill in a complete record for key,
;     only that the compareItemsProc return 0 when asked to compare the data
;     at key with the node in the tree to be deleted.  If the item cannot
;     be found in the tree, this will return errItemNotFoundInTree.
; 
; 
;  *  AVLFind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLFind" 
      ((tree (:pointer :avltreestruct)) (key :pointer) (dataPtr :pointer) (itemSize (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 2056 tree key dataPtr itemSize))

; 
;     Get the refCon for the given tree ( set in AVLInit ) and return it.
;     If the given tree is invalid, then return nil.
; 
; 
;  *  AVLGetRefcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AVLGetRefcon" 
      ((tree (:pointer :avltreestruct)) (refCon (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 1033 tree refCon))

; 
;     Get the refCon for the given tree ( set in AVLInit ) and return it.
;     If the given tree is invalid, then return nil.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AVLLockTree()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVLLockTree" 
      ((tree (:pointer :avltreestruct)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 522 tree))

; 
;     Get the refCon for the given tree ( set in AVLInit ) and return it.
;     If the given tree is invalid, then return nil.
; 
; 
;  *  AVLUnlockTree()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVLUnlockTree" 
      ((tree (:pointer :avltreestruct)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 523 tree))

; 
;     Get the refCon for the given tree ( set in AVLInit ) and return it.
;     If the given tree is invalid, then return nil.
; 
; 
;  *  AVLCheckTree()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AVLCheckTree" 
      ((tree (:pointer :avltreestruct)))
   (:stack :signed-integer)
   (:stack-trap #xAA80 :d0 524 tree))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AVLTreeIncludes

; $ENDC                                         ; __AVLTREE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'AVLTree)