(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Aliases.p"
; at Wednesday May 1,2002 2:39:35 pm.
; 
;      File:       Aliases.p
;  
;      Contains:   Alias Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ALIASES__
; $SETC __ALIASES__ := 1

; $I+
; $SETC AliasesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $rAliasType :|alis|)               ;   Aliases are stored as resources of this type  

;   define alias resolution action rules mask  
(defconstant $kARMMountVol #x1)                 ;   mount the volume automatically  
(defconstant $kARMNoUI #x2)                     ;   no user interface allowed during resolution  
(defconstant $kARMMultVols #x8)                 ;   search on multiple volumes  
(defconstant $kARMSearch #x100)                 ;   search quickly  
(defconstant $kARMSearchMore #x200)             ;   search further  
(defconstant $kARMSearchRelFirst #x400)         ;   search target on a relative path first  

;   define alias record information types  
(defconstant $asiZoneName -3)                   ;   get zone name  
(defconstant $asiServerName -2)                 ;   get server name  
(defconstant $asiVolumeName -1)                 ;   get volume name  
(defconstant $asiAliasName 0)                   ;   get aliased file/folder/volume name  
(defconstant $asiParentName 1)                  ;   get parent folder name  

; 	 ResolveAliasFileWithMountFlags options 	
(defconstant $kResolveAliasFileNoUI #x1)        ;   no user interaction during resolution  

; 	 define the alias record that will be the blackbox for the caller 	

(def-mactype :aliasrecordptr (find-mactype '(:pointer :aliasrecord)))
(defrecord (AliasRecord :handle) 
   (userType :ostype)                           ;   appl stored type like creator type  
   (aliasSize :unsigned-integer)                ;   alias record size in bytes, for appl usage  
   )

(def-mactype :aliasptr (find-mactype '(:pointer :aliasrecord)))
(def-mactype :aliashandle (find-mactype '(:handle :aliasrecord)))
; 	 alias record information type 	
(def-mactype :aliasinfotype (find-mactype ':signed-integer))
; 
; 	 *  NewAlias()
; 	 *  
; 	 *  Summary:
; 	 *    create a new alias between fromFile and target, returns alias
; 	 *    record handle
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; Const                                         ; CONST
(deftrap "_NewAlias" 
      ((fromFile (:pointer :fsspec)) (target (:pointer :fsspec)) (alias (:pointer (:handle :aliasrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 2 fromFile target alias))

; 
;  *  NewAliasMinimal()
;  *  
;  *  Summary:
;  *    create a minimal new alias for a target and return alias record
;  *    handle
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_NewAliasMinimal" 
      ((target (:pointer :fsspec)) (alias (:pointer (:handle :aliasrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 8 target alias))

; 
;  *  NewAliasMinimalFromFullPath()
;  *  
;  *  Summary:
;  *    create a minimal new alias from a target fullpath (optional zone
;  *    and server name) and return alias record handle
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewAliasMinimalFromFullPath" 
      ((fullPathLength :signed-integer) (fullPath :pointer) (zoneName (:string 32)) (serverName (:string 31)) (alias (:pointer (:handle :aliasrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 9 fullPathLength fullPath zoneName serverName alias))

; 
;  *  ResolveAlias()
;  *  
;  *  Summary:
;  *    given an alias handle and fromFile, resolve the alias, update the
;  *    alias record and return aliased filename and wasChanged flag.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_ResolveAlias" 
      ((fromFile (:pointer :fsspec)) (alias (:handle :aliasrecord)) (target (:pointer :fsspec)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 3 fromFile alias target wasChanged))

; 
;  *  GetAliasInfo()
;  *  
;  *  Summary:
;  *    given an alias handle and an index specifying requested alias
;  *    information type, return the information from alias record as a
;  *    string.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetAliasInfo" 
      ((alias (:handle :aliasrecord)) (index :signed-integer) (theString (:pointer (:string 63))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 7 alias index theString))

; 
;  *  IsAliasFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_IsAliasFile" 
      ((fileFSSpec (:pointer :fsspec)) (aliasFileFlag (:pointer :boolean)) (folderFlag (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 42 fileFSSpec aliasFileFlag folderFlag))

; 
;  *  ResolveAliasWithMountFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_ResolveAliasWithMountFlags" 
      ((fromFile (:pointer :fsspec)) (alias (:handle :aliasrecord)) (target (:pointer :fsspec)) (wasChanged (:pointer :boolean)) (mountFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 43 fromFile alias target wasChanged mountFlags))

; 
;  *  ResolveAliasFile()
;  *  
;  *  Summary:
;  *    Given a file spec, return target file spec if input file spec is
;  *    an alias. It resolves the entire alias chain or one step of the
;  *    chain.  It returns info about whether the target is a folder or
;  *    file; and whether the input file spec was an alias or not.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ResolveAliasFile" 
      ((theSpec (:pointer :fsspec)) (resolveAliasChains :boolean) (targetIsFolder (:pointer :boolean)) (wasAliased (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 12 theSpec resolveAliasChains targetIsFolder wasAliased))

; 
;  *  ResolveAliasFileWithMountFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ResolveAliasFileWithMountFlags" 
      ((theSpec (:pointer :fsspec)) (resolveAliasChains :boolean) (targetIsFolder (:pointer :boolean)) (wasAliased (:pointer :boolean)) (mountFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 41 theSpec resolveAliasChains targetIsFolder wasAliased mountFlags))

; 
;  *  FollowFinderAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_FollowFinderAlias" 
      ((fromFile (:pointer :fsspec)) (alias (:handle :aliasrecord)) (logon :boolean) (target (:pointer :fsspec)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 15 fromFile alias logon target wasChanged))

;  
;    Low Level Routines 
; 
; 
;  *  UpdateAlias()
;  *  
;  *  Summary:
;  *    given a fromFile-target pair and an alias handle, update the
;  *    alias record pointed to by alias handle to represent target as
;  *    the new alias.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const                                         ; CONST
(deftrap "_UpdateAlias" 
      ((fromFile (:pointer :fsspec)) (target (:pointer :fsspec)) (alias (:handle :aliasrecord)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 6 fromFile target alias wasChanged))

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AliasFilterProcPtr = FUNCTION(cpbPtr: CInfoPBPtr; VAR quitFlag: BOOLEAN; myDataPtr: Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :aliasfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aliasfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aliasfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppAliasFilterProcInfo #xFD0)
; 
; 	 *  NewAliasFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewAliasFilterProc 
(deftrap "_NewAliasFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAliasFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAliasFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAliasFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAliasFilterProc 
(deftrap-inline "_InvokeAliasFilterUPP" 
      ((cpbPtr (:pointer :cinfopbrec)) (quitFlag (:pointer :boolean)) (myDataPtr :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  MatchAlias()
;  *  
;  *  Summary:
;  *    Given an alias handle and fromFile, match the alias and return
;  *    aliased filename(s) and needsUpdate flag
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_MatchAlias" 
      ((fromFile (:pointer :fsspec)) (rulesMask :unsigned-long) (alias (:handle :aliasrecord)) (aliasCount (:pointer :signed-integer)) (aliasList (:pointer :fsspecarray)) (needsUpdate (:pointer :boolean)) (aliasFilter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 5 fromFile rulesMask alias aliasCount aliasList needsUpdate aliasFilter yourDataPtr))

; 
;  *  ResolveAliasFileWithMountFlagsNoUI()
;  *  
;  *  Summary:
;  *    variation on ResolveAliasFile that does not prompt user with a
;  *    dialog
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  MatchAliasNoUI()
;  *  
;  *  Summary:
;  *    variation on MatchAlias that does not prompt user with a dialog
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ResolveAliasFileWithMountFlagsNoUI" 
      ((theSpec (:pointer :fsspec)) (resolveAliasChains :boolean) (targetIsFolder (:pointer :boolean)) (wasAliased (:pointer :boolean)) (mountFlags :unsigned-long)) 
  :signed-integer
   () )                                         ; Const; 
;  *  FSNewAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_MatchAliasNoUI" 
      ((fromFile (:pointer :fsspec)) (rulesMask :unsigned-long) (alias (:handle :aliasrecord)) (aliasCount (:pointer :signed-integer)) (aliasList (:pointer :fsspecarray)) (needsUpdate (:pointer :boolean)) (aliasFilter :pointer) (yourDataPtr :pointer)) 
  :signed-integer
   () )                                         ; Const; CONST
(deftrap "_FSNewAlias" 
      ((fromFile (:pointer :fsref)) (target (:pointer :fsref)) (inAlias (:pointer (:handle :aliasrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 54 fromFile target inAlias))

; 
;  *  FSNewAliasMinimal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSNewAliasMinimal" 
      ((target (:pointer :fsref)) (inAlias (:pointer (:handle :aliasrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 55 target inAlias))

; 
;  *  FSIsAliasFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSIsAliasFile" 
      ((fileRef (:pointer :fsref)) (aliasFileFlag (:pointer :boolean)) (folderFlag (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 56 fileRef aliasFileFlag folderFlag))

; 
;  *  FSResolveAliasWithMountFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_FSResolveAliasWithMountFlags" 
      ((fromFile (:pointer :fsref)) (inAlias (:handle :aliasrecord)) (target (:pointer :fsref)) (wasChanged (:pointer :boolean)) (mountFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 57 fromFile inAlias target wasChanged mountFlags))

; 
;  *  FSResolveAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_FSResolveAlias" 
      ((fromFile (:pointer :fsref)) (alias (:handle :aliasrecord)) (target (:pointer :fsref)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 58 fromFile alias target wasChanged))

; 
;  *  FSResolveAliasFileWithMountFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FSResolveAliasFileWithMountFlags" 
      ((theRef (:pointer :fsref)) (resolveAliasChains :boolean) (targetIsFolder (:pointer :boolean)) (wasAliased (:pointer :boolean)) (mountFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 59 theRef resolveAliasChains targetIsFolder wasAliased mountFlags))

; 
;  *  FSResolveAliasFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FSResolveAliasFile" 
      ((theRef (:pointer :fsref)) (resolveAliasChains :boolean) (targetIsFolder (:pointer :boolean)) (wasAliased (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 60 theRef resolveAliasChains targetIsFolder wasAliased))

; 
;  *  FSFollowFinderAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FSFollowFinderAlias" 
      ((fromFile (:pointer :fsref)) (alias (:handle :aliasrecord)) (logon :boolean) (target (:pointer :fsref)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 61 fromFile alias logon target wasChanged))

; 
;  *  FSUpdateAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const                                         ; CONST
(deftrap "_FSUpdateAlias" 
      ((fromFile (:pointer :fsref)) (target (:pointer :fsref)) (alias (:handle :aliasrecord)) (wasChanged (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 62 fromFile target alias wasChanged))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AliasesIncludes

; $ENDC                                         ; __ALIASES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Aliases)