(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AppleDiskPartitions.p"
; at Wednesday May 1,2002 2:39:54 pm.
; 
;      File:       AppleDiskPartitions.p
;  
;      Contains:   The Apple disk partition scheme as defined in Inside Macintosh: Volume V.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __APPLEDISKPARTITIONS__
; $SETC __APPLEDISKPARTITIONS__ := 1

; $I+
; $SETC AppleDiskPartitionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Block 0 Definitions 

(defconstant $sbSIGWord #x4552)                 ;   signature word for Block 0 ('ER')  
(defconstant $sbMac 1)                          ;   system type for Mac  

; 	 Partition Map Signatures 	
(defconstant $pMapSIG #x504D)                   ;   partition map signature ('PM')  
(defconstant $pdSigWord #x5453)                 ;   partition map signature ('TS')  
(defconstant $oldPMSigWord #x5453)
(defconstant $newPMSigWord #x504D)

; 	 Driver Descriptor Map 	

(def-mactype :block0ptr (find-mactype '(:pointer :block0)))
(defrecord Block0 
   (sbSig :unsigned-integer)                    ;   unique value for SCSI block 0  
   (sbBlkSize :unsigned-integer)                ;   block size of device  
   (sbBlkCount :unsigned-long)                  ;   number of blocks on device  
   (sbDevType :unsigned-integer)                ;   device type  
   (sbDevId :unsigned-integer)                  ;   device id  
   (sbData :unsigned-long)                      ;   not used  
   (sbDrvrCount :unsigned-integer)              ;   driver descriptor count  
   (ddBlock :unsigned-long)                     ;   1st driver's starting block  
   (ddSize :unsigned-integer)                   ;   size of 1st driver (512-byte blks)  
   (ddType :unsigned-integer)                   ;   system type (1 for Mac+)  
   (ddPad (:array :unsigned-integer 243))       ;   ARRAY[0..242] OF INTEGER; not used  
   )

; 	 Driver descriptor 	
(def-mactype :ddmapptr (find-mactype '(:pointer :ddmap)))
(defrecord DDMap 
   (ddBlock :unsigned-long)                     ;   1st driver's starting block  
   (ddSize :unsigned-integer)                   ;   size of 1st driver (512-byte blks)  
   (ddType :unsigned-integer)                   ;   system type (1 for Mac+)  
   )

; 	 Constants for the ddType field of the DDMap structure. 	

(defconstant $kDriverTypeMacSCSI #x1)
(defconstant $kDriverTypeMacATA #x701)
(defconstant $kDriverTypeMacSCSIChained #xFFFF)
(defconstant $kDriverTypeMacATAChained #xF8FF)

; 	 Partition Map Entry 	

(def-mactype :partitionptr (find-mactype '(:pointer :partition)))
(defrecord Partition 
   (pmSig :unsigned-integer)                    ;   unique value for map entry blk  
   (pmSigPad :unsigned-integer)                 ;   currently unused  
   (pmMapBlkCnt :unsigned-long)                 ;   # of blks in partition map  
   (pmPyPartStart :unsigned-long)               ;   physical start blk of partition  
   (pmPartBlkCnt :unsigned-long)                ;   # of blks in this partition  
   (pmPartName (:array :unsigned-byte 32 :packed));   ASCII partition name  
   (pmParType (:array :unsigned-byte 32 :packed));   ASCII partition type  
   (pmLgDataStart :unsigned-long)               ;   log. # of partition's 1st data blk  
   (pmDataCnt :unsigned-long)                   ;   # of blks in partition's data area  
   (pmPartStatus :unsigned-long)                ;   bit field for partition status  
   (pmLgBootStart :unsigned-long)               ;   log. blk of partition's boot code  
   (pmBootSize :unsigned-long)                  ;   number of bytes in boot code  
   (pmBootAddr :unsigned-long)                  ;   memory load address of boot code  
   (pmBootAddr2 :unsigned-long)                 ;   currently unused  
   (pmBootEntry :unsigned-long)                 ;   entry point of boot code  
   (pmBootEntry2 :unsigned-long)                ;   currently unused  
   (pmBootCksum :unsigned-long)                 ;   checksum of boot code  
   (pmProcessor (:array :unsigned-byte 16 :packed));   ASCII for the processor type  
   (pmPad (:array :unsigned-integer 188))       ;   ARRAY[0..187] OF INTEGER; not used  
   )

; 	 Flags for the pmPartStatus field of the Partition data structure. 	

(defconstant $kPartitionAUXIsValid #x1)
(defconstant $kPartitionAUXIsAllocated #x2)
(defconstant $kPartitionAUXIsInUse #x4)
(defconstant $kPartitionAUXIsBootValid #x8)
(defconstant $kPartitionAUXIsReadable #x10)
(defconstant $kPartitionAUXIsWriteable #x20)
(defconstant $kPartitionAUXIsBootCodePositionIndependent #x40)
(defconstant $kPartitionIsWriteable #x20)
(defconstant $kPartitionIsMountedAtStartup #x40000000)
(defconstant $kPartitionIsStartup #x80000000)
(defconstant $kPartitionIsChainCompatible #x100)
(defconstant $kPartitionIsRealDeviceDriver #x200)
(defconstant $kPartitionCanChainToNext #x400)

; 	 Well known driver signatures, stored in the first four byte of pmPad. 	
(defconstant $kPatchDriverSignature :|ptDR|)    ;   SCSI and ATA[PI] patch driver     
(defconstant $kSCSIDriverSignature #x10600)     ;   SCSI  hard disk driver            
(defconstant $kATADriverSignature :|wiki|)      ;   ATA   hard disk driver            
(defconstant $kSCSICDDriverSignature :|CDvr|)   ;   SCSI  CD-ROM    driver            
(defconstant $kATAPIDriverSignature :|ATPI|)    ;   ATAPI CD-ROM    driver            
(defconstant $kDriveSetupHFSSignature :|DSU1|)  ;   Drive Setup HFS partition         

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AppleDiskPartitionsIncludes

; $ENDC                                         ; __APPLEDISKPARTITIONS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AppleDiskPartitions)