(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMAcceleration.p"
; at Wednesday May 1,2002 2:41:13 pm.
; 
;      File:       CMAcceleration.p
;  
;      Contains:   ColorSync Acceleration Component API
;  
;      Version:    Technology: ColorSync 2.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CMACCELERATION__
; $SETC __CMACCELERATION__ := 1

; $I+
; $SETC CMAccelerationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;    version info  

(defconstant $cmAccelerationInterfaceVersion 1)

;    Component Type  
(defconstant $cmAccelerationComponentType :|csac|)

;    Required Component function selectors  
(defconstant $cmLoadTables 0)
(defconstant $cmCalculateData 1)

;    table data for acceleration component  

(def-mactype :cmaccelerationtabledataptr (find-mactype '(:pointer :cmaccelerationtabledata)))
(defrecord CMAccelerationTableData 
   (inputLutEntryCount :signed-long)            ;   count of entries for input lut for one dimension 
   (inputLutWordSize :signed-long)              ;   count of bits of each entry ( e.g. 16 for WORD ) 
   (inputLut :handle)                           ;   handle to input lut 
   (outputLutEntryCount :signed-long)           ;   count of entries for output lut for one dimension   
   (outputLutWordSize :signed-long)             ;   count of bits of each entry ( e.g. 8 for BYTE ) 
   (outputLut :handle)                          ;   handle to output lut 
   (colorLutInDim :signed-long)                 ;   input dimension  ( e.g. 3 for LAB ; 4 for CMYK ) 
   (colorLutOutDim :signed-long)                ;   output dimension ( e.g. 3 for LAB ; 4 for CMYK ) 
   (colorLutGridPoints :signed-long)            ;   count of gridpoints for color lut ( for one Dimension )     
   (colorLutWordSize :signed-long)              ;   count of bits of each entry ( e.g. 8 for BYTE ) 
   (colorLut :handle)                           ;   handle to color lut 
   (inputColorSpace :unsigned-long)             ;   packing info for input 
   (outputColorSpace :unsigned-long)            ;   packing info for output 
   (userData :pointer)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   (reserved4 :unsigned-long)
   (reserved5 :unsigned-long)
   )

(def-mactype :cmaccelerationtabledatahdl (find-mactype '(:handle :cmaccelerationtabledata)))
;    calc data for acceleration component  
(def-mactype :cmaccelerationcalcdataptr (find-mactype '(:pointer :cmaccelerationcalcdata)))
(defrecord CMAccelerationCalcData 
   (pixelCount :signed-long)                    ;   count of input pixels 
   (inputData :pointer)                         ;   input array 
   (outputData :pointer)                        ;   output array 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :cmaccelerationcalcdatahdl (find-mactype '(:handle :cmaccelerationcalcdata)))
; 
; 	    
; 	                A c c e l e r a t i o n   C o m p o n e n t   I n t e r f a c e s
; 	    
; 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CMAccelerationLoadTables()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_CMAccelerationLoadTables" 
      ((CMSession (:pointer :componentinstancerecord)) (tableData (:pointer :cmaccelerationtabledata)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 CMSession tableData ((+ (ash 4 16) 0) :signed-longint)))

; 
;  *  CMAccelerationCalculateData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMAccelerationCalculateData" 
      ((CMSession (:pointer :componentinstancerecord)) (calcData (:pointer :cmaccelerationcalcdata)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 CMSession calcData ((+ (ash 4 16) 1) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMAccelerationIncludes

; $ENDC                                         ; __CMACCELERATION__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CMAcceleration)