(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CarbonEvents.p"
; at Wednesday May 1,2002 2:40:36 pm.
; 
;      File:       CarbonEvents.p
;  
;      Contains:   Carbon Event Manager
;  
;      Version:    Technology: CarbonLib 1.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
;
; hand edited for  e.g. #$kEventDurationSecond/1000 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CARBONEVENTS__
; $SETC __CARBONEVENTS__ := 1

; $I+
; $SETC CarbonEventsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONTROLS__
|#

(require-interface 'Controls)
#|                                              ; $I Controls.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACWINDOWS__
|#

(require-interface 'MacWindows)
#|                                              ; $I MacWindows.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEREGISTRY__
|#

(require-interface 'AERegistry)
#|                                              ; $I AERegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ======================================================================================
;   EVENT COMMON                                                                        
; ======================================================================================

; 
;  *  Discussion:
;  *    The following are all errors which can be returned from the
;  *    routines contained in this file.
;  

(defconstant $eventAlreadyPostedErr -9860)
(defconstant $eventTargetBusyErr -9861)
(defconstant $eventClassInvalidErr -9862)
(defconstant $eventClassIncorrectErr -9864)
(defconstant $eventHandlerAlreadyInstalledErr -9866)
(defconstant $eventInternalErr -9868)
(defconstant $eventKindIncorrectErr -9869)
(defconstant $eventParameterNotFoundErr -9870)
(defconstant $eventNotHandledErr -9874)
(defconstant $eventLoopTimedOutErr -9875)
(defconstant $eventLoopQuitErr -9876)
(defconstant $eventNotInQueueErr -9877)
(defconstant $eventHotKeyExistsErr -9878)
(defconstant $eventHotKeyInvalidErr -9879)

; 	======================================================================================	
; 	  EVENT CORE                                                                          	
; 	======================================================================================	
; 		
; 	   Event Flags, options                                                              	
; 		

; 
; 	 *  EventPriority
; 	 *  
; 	 *  Discussion:
; 	 *    These values define the relative priority of an event, and are
; 	 *    used when posting events with PostEventToQueue. In general events
; 	 *    are pulled from the queue in order of first posted to last
; 	 *    posted. These priorities are a way to alter that when posting
; 	 *    events. You can post a standard priority event and then a high
; 	 *    priority event and the high priority event will be pulled from
; 	 *    the queue first.
; 	 	

(def-mactype :eventpriority (find-mactype ':signed-integer))

(defconstant $kEventPriorityLow 0)
(defconstant $kEventPriorityStandard 1)
(defconstant $kEventPriorityHigh 2)

(defconstant $kEventLeaveInQueue #$false)
(defconstant $kEventRemoveFromQueue #$true)

; 		
; 	  Event Times                                                                        	
; 	                                                                                      	
; 	 EventTime is in seconds since boot. Use the constants to make life easy.             	
; 		

(def-mactype :eventtime (find-mactype ':double-float))
(def-mactype :eventtimeout (find-mactype ':double-float))
(def-mactype :eventtimerinterval (find-mactype ':double-float))

(defconstant $kEventDurationSecond 1.0)
#|
(defconstant $kEventDurationMillisecond #$kEventDurationSecond/1000)
(defconstant $kEventDurationMicrosecond #$kEventDurationSecond/1000000)
(defconstant $kEventDurationNanosecond #$kEventDurationSecond/1000000000)
|#

(defconstant $kEventDurationMillisecond (/ #$kEventDurationSecond 1000))
(defconstant $kEventDurationMicrosecond (/ #$kEventDurationSecond 1000000))
(defconstant $kEventDurationNanosecond (/ #$kEventDurationSecond 1000000000))
(defconstant $kEventDurationMinute (* #$kEventDurationSecond 60))
(defconstant $kEventDurationHour (* #$kEventDurationMinute 60))
(defconstant $kEventDurationDay (* #$kEventDurationHour 24))
(defconstant $kEventDurationNoWait 0.0)
(defconstant $kEventDurationForever -1)

; 		
; 	 EventTypeSpec structure                                                              	
; 	                                                                                      	
; 	 This structure is used in many routines to pass a list of event types to a function. 	
; 	 You typically would declare a const array of these types to pass in.                 	
; 		

; 
; 	 *  EventTypeSpec
; 	 *  
; 	 *  Discussion:
; 	 *    This structure is used to specify an event. Typically, a static
; 	 *    array of EventTypeSpecs are passed into functions such as
; 	 *    InstallEventHandler, as well as routines such as
; 	 *    FlushEventsMatchingListFromQueue.
; 	 	

(def-mactype :eventtypespecptr (find-mactype '(:pointer :eventtypespec)))
(defrecord EventTypeSpec 
   (eventClass :unsigned-long)
   (eventKind :unsigned-long)
   )

; 
; 	 *  Discussion:
; 	 *    These are returned from calls to TrackMouseLocation and
; 	 *    TrackMouseRegion. Those routines are designed as replacements to
; 	 *    calls such as StillDown and WaitMouseUp. The advantage over those
; 	 *    routines is that TrackMouseLocation and TrackMouseRegion will
; 	 *    block if the user is not moving the mouse, whereas mouse tracking
; 	 *    loops based on StillDown and WaitMouseUp will spin, chewing up
; 	 *    valuable CPU time that could be better spent elsewhere. It is
; 	 *    highly recommended that any tracking loops in your application
; 	 *    stop using StillDown and WaitMouseUp and start using
; 	 *    TrackMouseLocation/Region. See the notes on those routines for
; 	 *    more information.
; 	 	

(defconstant $kTrackMouseLocationOptionDontConsumeMouseUp #x1)

(def-mactype :mousetrackingresult (find-mactype ':unsigned-integer))

(defconstant $kMouseTrackingMouseDown 1)
(defconstant $kMouseTrackingMouseUp 2)
(defconstant $kMouseTrackingMouseExited 3)
(defconstant $kMouseTrackingMouseEntered 4)
(defconstant $kMouseTrackingMouseDragged 5)
(defconstant $kMouseTrackingKeyModifiersChanged 6)
(defconstant $kMouseTrackingUserCancelled 7)
(defconstant $kMouseTrackingTimedOut 8)

(def-mactype :eventparamname (find-mactype ':ostype))
(def-mactype :eventparamtype (find-mactype ':ostype))
; 		
; 	   EventLoop                                                                         	
; 		

; 
; 	 *  EventLoopRef
; 	 *  
; 	 *  Discussion:
; 	 *    An EventLoopRef represents an 'event loop', which is the
; 	 *    conceptual entity that you 'run' to fetch events from hardware
; 	 *    and other sources and also fires timers that might be installed
; 	 *    with InstallEventLoopTimer. The term 'run' is a bit of a
; 	 *    misnomer, as the event loop's goal is to stay as blocked as
; 	 *    possible to minimize CPU usage for the current application. The
; 	 *    event loop is run implicitly thru APIs like ReceiveNextEvent,
; 	 *    RunApplicationEventLoop, or even WaitNextEvent. It can also be
; 	 *    run explicitly thru a call to RunCurrentEventLoop. Each
; 	 *    preemptive thread can have an event loop. Cooperative threads
; 	 *    share the main thread's event loop.
; 	 	
(def-mactype :eventloopref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventlooprefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventLoopRef parameter can be nil, it is changed to xx: EventLoopRefPtr 
; 
; 	 *  GetCurrentEventLoop()
; 	 *  
; 	 *  Discussion:
; 	 *    Returns the current event loop for the current thread. If the
; 	 *    current thread is a cooperative thread, the main event loop is
; 	 *    returned.
; 	 *  
; 	 *  Result:
; 	 *    An event loop reference.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetMainEventLoop()
;  *  
;  *  Discussion:
;  *    Returns the event loop object for the main application thread.
;  *  
;  *  Result:
;  *    An event loop reference.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCurrentEventLoop" 
      () 
  :pointer
   () )                                         ; 
;  *  RunCurrentEventLoop()
;  *  
;  *  Discussion:
;  *    This routine 'runs' the event loop, returning only if aborted or
;  *    the timeout specified is reached. The event loop is mostly
;  *    blocked while in this function, occasionally waking up to fire
;  *    timers or pick up events. The typical use of this function is to
;  *    cause the current thread to wait for some operation to complete,
;  *    most likely on another thread of execution.
;  *  
;  *  Parameters:
;  *    
;  *    inTimeout:
;  *      The time to wait until returning (can be kEventDurationForever).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMainEventLoop" 
      () 
  :pointer
   () )                                         ; 
;  *  QuitEventLoop()
;  *  
;  *  Discussion:
;  *    Causes a specific event loop to terminate. Usage of this is
;  *    similar to WakeUpProcess, in that it causes the eventloop
;  *    specified to return immediately (as opposed to timing out).
;  *    Typically this call is used in conjunction with
;  *    RunCurrentEventLoop.
;  *  
;  *  Parameters:
;  *    
;  *    inEventLoop:
;  *      The event loop to terminate.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RunCurrentEventLoop" 
      ((inTimeout :double-float)) 
  :osstatus
   () )                                         ; 
;  *  GetCFRunLoopFromEventLoop()
;  *  
;  *  Discussion:
;  *    Returns the corresponding CFRunLoopRef for the given EventLoop.
;  *    This is not necessarily a one-to-one mapping, hence the need for
;  *    this function. In Carbon, all cooperative threads use the same
;  *    run loop under the covers, so using CFRunLoopGetCurrent might
;  *    yield the wrong result. In general, you would only need to use
;  *    this function if you wished to add your own sources to the run
;  *    loop. If you don't know what I'm talking about, then you probably
;  *    don't need to use this.
;  *  
;  *  Parameters:
;  *    
;  *    inEventLoop:
;  *      The event loop to get the CFRunLoop for.
;  *  
;  *  Result:
;  *    The CFRunLoopRef for inEventLoop.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_QuitEventLoop" 
      ((inEventLoop :pointer)) 
  :osstatus
   () )
(deftrap-inline "_GetCFRunLoopFromEventLoop" 
      ((inEventLoop :pointer)) 
  :pointer
   () )

; 
;    Low-level event fetching                                                          
; 
; 
;  *  ReceiveNextEvent()
;  *  
;  *  Discussion:
;  *    This routine tries to fetch the next event of a specified type.
;  *    If no events in the event queue match, this routine will run the
;  *    current event loop until an event that matches arrives, or the
;  *    timeout expires. Except for timers firing, your application is
;  *    blocked waiting for events to arrive when inside this function.
;  *  
;  *  Parameters:
;  *    
;  *    inNumTypes:
;  *      The number of event types we are waiting for (0 if any event
;  *      should cause this routine to return).
;  *    
;  *    inList:
;  *      The list of event types we are waiting for (pass NULL if any
;  *      event should cause this routine to return).
;  *    
;  *    inTimeout:
;  *      The time to wait (passing kEventDurationForever is preferred).
;  *    
;  *    inPullEvent:
;  *      Pass true for this parameter to actually remove the next
;  *      matching event from the queue.
;  *    
;  *    outEvent:
;  *      The next event that matches the list passed in. If inPullEvent
;  *      is true, the event is owned by you, and you will need to
;  *      release it when done.
;  *  
;  *  Result:
;  *    A result indicating whether an event was received, the timeout
;  *    expired, or the current event loop was quit.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; ;    Core event lifetime APIs                                                          ; 
(deftrap-inline "_ReceiveNextEvent" 
      ((inNumTypes :unsigned-long) (inList (:pointer :eventtypespec)) (inTimeout :double-float) (inPullEvent :boolean) (outEvent (:pointer :pointer))) 
  :osstatus
   () )
(def-mactype :eventattributes (find-mactype ':unsigned-long))

(defconstant $kEventAttributeNone 0)
(defconstant $kEventAttributeUserEvent #x1)

; 
; 	 *  [Mac]CreateEvent()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  CopyEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateEvent" 
      ((inAllocator :pointer) (inClassID :unsigned-long) (kind :unsigned-long) (when :double-float) (flags :unsigned-long) (outEvent (:pointer :pointer))) 
  :signed-long
   () )                                         ; 
;  *  RetainEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyEvent" 
      ((inOther :pointer)) 
  :pointer
   () )                                         ; 
;  *  GetEventRetainCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RetainEvent" 
      ((inEvent :pointer)) 
  :pointer
   () )                                         ; 
;  *  ReleaseEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetEventRetainCount" 
      ((inEvent :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  SetEventParameter()
;  *  
;  *  Discussion:
;  *    Sets a piece of data for the given event.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event to set the data for.
;  *    
;  *    inName:
;  *      The symbolic name of the parameter.
;  *    
;  *    inType:
;  *      The symbolic type of the parameter.
;  *    
;  *    inSize:
;  *      The size of the parameter data.
;  *    
;  *    inDataPtr:
;  *      The pointer to the parameter data.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ReleaseEvent" 
      ((inEvent :pointer)) 
  nil
   () )                                         ; 
;  *  GetEventParameter()
;  *  
;  *  Discussion:
;  *    Gets a piece of data from the given event, if it exists.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event to get the parameter from.
;  *    
;  *    inName:
;  *      The symbolic name of the parameter.
;  *    
;  *    inDesiredType:
;  *      The desired type of the parameter. At present we do not support
;  *      coercion, so this parameter must be the actual type of data
;  *      stored in the event, or an error will be returned.
;  *    
;  *    outActualType:
;  *      The actual type of the parameter, can be NULL if you are not
;  *      interested in receiving this information.
;  *    
;  *    inBufferSize:
;  *      The size of the output buffer specified by ioBuffer.
;  *    
;  *    outActualSize:
;  *      The actual size of the data, or NULL if you don't want this
;  *      information.
;  *    
;  *    outData:
;  *      The pointer to the buffer which will receive the parameter data.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetEventParameter" 
      ((inEvent :pointer) (inName :ostype) (inType :ostype) (inSize :unsigned-long) (inDataPtr :pointer)) 
  :osstatus
   () )                                         ; ;    Getters for 'base-class' event info                                               ; ; 
;  *  GetEventClass()
;  *  
;  *  Discussion:
;  *    Returns the class of the given event, such as mouse, keyboard,
;  *    etc.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event in question.
;  *  
;  *  Result:
;  *    The class ID of the event.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetEventParameter" 
      ((inEvent :pointer) (inName :ostype) (inDesiredType :ostype) (outActualType (:pointer :ostype)) (inBufferSize :unsigned-long) (outActualSize (:pointer :unsigned-long)) (outData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetEventKind()
;  *  
;  *  Discussion:
;  *    Returns the kind of the given event (mousedown, etc.). Event
;  *    kinds overlap between event classes, e.g. kEventMouseDown and
;  *    kEventAppActivated have the same value (1). The combination of
;  *    class and kind is what determines an event signature.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event in question.
;  *  
;  *  Result:
;  *    The kind of the event.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetEventClass" 
      ((inEvent :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  GetEventTime()
;  *  
;  *  Discussion:
;  *    Returns the time the event specified occurred, specified in
;  *    EventTime, which is a floating point number representing seconds
;  *    since the last system startup.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event in question.
;  *  
;  *  Result:
;  *    The time the event occurred.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetEventKind" 
      ((inEvent :pointer)) 
  :unsigned-long
   () )                                         ; ;    Setters for 'base-class' event info                                               ; ; 
;  *  SetEventTime()
;  *  
;  *  Discussion:
;  *    This routine allows you to set the time of a given event, if you
;  *    so desire. In general, you would never use this routine, except
;  *    for those special cases where you reuse an event from time to
;  *    time instead of creating a new event each time.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event in question.
;  *    
;  *    inTime:
;  *      The new time.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetEventTime" 
      ((inEvent :pointer)) 
  :double-float
   () )                                         ; ;    Event Queue routines (posting, finding, flushing)                                 ; 
(deftrap-inline "_SetEventTime" 
      ((inEvent :pointer) (inTime :double-float)) 
  :osstatus
   () )
(def-mactype :eventqueueref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventqueuerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventQueueRef parameter can be nil, it is changed to xx: EventQueueRefPtr 
; 
; 	 *  GetCurrentEventQueue()
; 	 *  
; 	 *  Discussion:
; 	 *    Returns the current event queue for the current thread. If the
; 	 *    current thread is a cooperative thread, the main event queue is
; 	 *    returned.
; 	 *  
; 	 *  Result:
; 	 *    An event queue reference.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetMainEventQueue()
;  *  
;  *  Discussion:
;  *    Returns the event queue object for the main application thread.
;  *  
;  *  Result:
;  *    An event queue reference.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCurrentEventQueue" 
      () 
  :pointer
   () )                                         ; 
;  *  EventComparatorProcPtr
;  *  
;  *  Discussion:
;  *    Type of a callback function used by queue searches.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event to compare.
;  *    
;  *    inCompareData:
;  *      The data used to compare the event.
;  *  
;  *  Result:
;  *    A boolean value indicating whether the event matches (true) or
;  *    not (false).
;  
(deftrap-inline "_GetMainEventQueue" 
      () 
  :pointer
   () )
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EventComparatorProcPtr = FUNCTION(inEvent: EventRef; inCompareData: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :eventcomparatorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :eventcomparatorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :eventcomparatorupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppEventComparatorProcInfo #x3D0)
; 
; 	 *  NewEventComparatorUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewEventComparatorProc 
(deftrap "_NewEventComparatorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeEventComparatorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeEventComparatorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeEventComparatorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallEventComparatorProc 
(deftrap-inline "_InvokeEventComparatorUPP" 
      ((inEvent :pointer) (inCompareData :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  PostEventToQueue()
;  *  
;  *  Discussion:
;  *    Posts an event to the queue specified. This automatically wakes
;  *    up the event loop of the thread the queue belongs to. After
;  *    posting the event, you should release the event. The event queue
;  *    retains it.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to post the event onto.
;  *    
;  *    inEvent:
;  *      The event to post.
;  *    
;  *    inPriority:
;  *      The priority of the event.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  FlushEventsMatchingListFromQueue()
;  *  
;  *  Discussion:
;  *    Flushes events matching a specified list of classes and kinds
;  *    from an event queue.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to flush events from.
;  *    
;  *    inNumTypes:
;  *      The number of event kinds to flush.
;  *    
;  *    inList:
;  *      The list of event classes and kinds to flush from the queue.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PostEventToQueue" 
      ((inQueue :pointer) (inEvent :pointer) (inPriority :signed-integer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  FlushSpecificEventsFromQueue()
;  *  
;  *  Discussion:
;  *    Flushes events that match a comparator function.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to flush events from.
;  *    
;  *    inComparator:
;  *      The comparison function to invoke for each event in the queue.
;  *    
;  *    inCompareData:
;  *      The data you wish to pass to your comparison function.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FlushEventsMatchingListFromQueue" 
      ((inQueue :pointer) (inNumTypes :unsigned-long) (inList (:pointer :eventtypespec))) 
  :osstatus
   () )                                         ; 
;  *  FlushEventQueue()
;  *  
;  *  Discussion:
;  *    Flushes all events from an event queue.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to flush.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FlushSpecificEventsFromQueue" 
      ((inQueue :pointer) (inComparator :pointer) (inCompareData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  FindSpecificEventInQueue()
;  *  
;  *  Discussion:
;  *    Returns the first event that matches a comparator function, or
;  *    NULL if no events match.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to search.
;  *    
;  *    inComparator:
;  *      The comparison function to invoke for each event in the queue.
;  *    
;  *    inCompareData:
;  *      The data you wish to pass to your comparison function.
;  *  
;  *  Result:
;  *    An event reference.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FlushEventQueue" 
      ((inQueue :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetNumEventsInQueue()
;  *  
;  *  Discussion:
;  *    Returns the number of events in an event queue.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The event queue to query.
;  *  
;  *  Result:
;  *    The number of items in the queue.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FindSpecificEventInQueue" 
      ((inQueue :pointer) (inComparator :pointer) (inCompareData :pointer)) 
  :pointer
   () )                                         ; 
;  *  RemoveEventFromQueue()
;  *  
;  *  Discussion:
;  *    Removes the given event from the queue which it was posted. When
;  *    you call this function, the event ownership is transferred to
;  *    you, the caller, at no charge. You must release the event when
;  *    you are through with it.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The queue to remove the event from.
;  *    
;  *    inEvent:
;  *      The event to remove.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetNumEventsInQueue" 
      ((inQueue :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  IsEventInQueue()
;  *  
;  *  Discussion:
;  *    Returns true if the specified event is posted to a queue.
;  *  
;  *  Parameters:
;  *    
;  *    inQueue:
;  *      The queue to check.
;  *    
;  *    inEvent:
;  *      The event in question.
;  *  
;  *  Result:
;  *    A boolean value.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveEventFromQueue" 
      ((inQueue :pointer) (inEvent :pointer)) 
  :osstatus
   () )                                         ; ;    Helpful utilities                                                                 ; ; 
;  *  GetCurrentEventTime()
;  *  
;  *  Discussion:
;  *    Returns the current time since last system startup in seconds.
;  *  
;  *  Result:
;  *    EventTime.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsEventInQueue" 
      ((inQueue :pointer) (inEvent :pointer)) 
  :boolean
   () )                                         ; 
;  *  IsUserCancelEventRef()
;  *  
;  *  Discussion:
;  *    Tests the event given to see whether the event represents a 'user
;  *    cancel' event. Currently this is defined to be either the escape
;  *    key being pressed, or command-period being pressed.
;  *  
;  *  Result:
;  *    A boolean value indicating whether the event is a user cancel
;  *    event.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCurrentEventTime" 
      () 
  :double-float
   () )                                         ; 
;  *  TrackMouseLocation()
;  *  
;  *  Discussion:
;  *    Once entered, this routine waits for certain mouse events (move,
;  *    mouse down, mouse up). When one of these events occurs, the
;  *    function returns and tells the caller what happened and where the
;  *    mouse is currently located. While there is no activity, the
;  *    current event loop is run, effectively blocking the current
;  *    thread (save for any timers that fire). This helps to minimize
;  *    CPU usage when there is nothing going on.
;  *  
;  *  Parameters:
;  *    
;  *    inPort:
;  *      The grafport to consider for mouse coordinates. You can pass
;  *      NULL for this parameter to indicate the current port. The mouse
;  *      location is returned in terms of local coordinates of this port.
;  *    
;  *    outPt:
;  *      On exit, this parameter receives the mouse location from the
;  *      last mouse event that caused this function to exit.
;  *    
;  *    outResult:
;  *      On exit, this parameter receives a value representing what kind
;  *      of event was received that cause the function to exit, such as
;  *      kMouseTrackingMouseReleased.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsUserCancelEventRef" 
      ((event :pointer)) 
  :boolean
   () )                                         ; 
;  *  TrackMouseLocationWithOptions()
;  *  
;  *  Discussion:
;  *    Once entered, this routine waits for certain mouse events (move,
;  *    mouse down, mouse up). When one of these events occurs, the
;  *    function returns and tells the caller what happened and where the
;  *    mouse is currently located. While there is no activity, the
;  *    current event loop is run, effectively blocking the current
;  *    thread (save for any timers that fire). This helps to minimize
;  *    CPU usage when there is nothing going on.
;  *  
;  *  Parameters:
;  *    
;  *    inPort:
;  *      The grafport to consider for mouse coordinates. You can pass
;  *      NULL for this parameter to indicate the current port. The mouse
;  *      location is returned in terms of local coordinates of this port.
;  *    
;  *    inOptions:
;  *      The only option supported by this routine at present is the
;  *      option to have the toolbox leave mouse up events in the queue,
;  *      rather than pulling them (which is the default).
;  *    
;  *    inTimeout:
;  *      The amount of time to wait for an event. If no events arrive
;  *      within this time, kMouseTrackingTimedOut is returned in
;  *      outResult.
;  *    
;  *    outPt:
;  *      On exit, this parameter receives the mouse location from the
;  *      last mouse event that caused this function to exit. If a
;  *      timeout or key modifiers changed event caused this function to
;  *      exit, the current mouse position at the time is returned.
;  *    
;  *    outModifiers:
;  *      On exit, this parameter receives the most recent state of the
;  *      keyboard modifiers.
;  *    
;  *    outResult:
;  *      On exit, this parameter receives a value representing what kind
;  *      of event was received that cause the function to exit, such as
;  *      kMouseTrackingMouseReleased.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TrackMouseLocation" 
      ((inPort (:pointer :grafport)) (outPt (:pointer :point)) (outResult (:pointer :unsigned-integer))) 
  :osstatus
   () )
(deftrap-inline "_TrackMouseLocationWithOptions" 
      ((inPort (:pointer :grafport)) (inOptions :unsigned-long) (inTimeout :double-float) (outPt (:pointer :point)) (outModifiers (:pointer :unsigned-long)) (outResult (:pointer :unsigned-integer))) 
  :osstatus
   () )

; 
;  *  TrackMouseRegion()
;  *  
;  *  Discussion:
;  *    This routine is largely identical to TrackMouseLocation. Please
;  *    read the notes on that function as well. The difference between
;  *    TrackMouseLocation and TrackMouseRegion is that TrackMouseRegion
;  *    only returns when the mouse enters or exits a specified region
;  *    that you pass in to the function, as opposed to whenever the
;  *    mouse moves (it also returns for mouse up/down events). This is
;  *    useful if you don't need to know intermediate mouse events, but
;  *    rather just if the mouse enters or leaves an area.
;  *  
;  *  Parameters:
;  *    
;  *    inPort:
;  *      The grafport to consider for mouse coordinates. You can pass
;  *      NULL for this parameter to indicate the current port.
;  *    
;  *    inRegion:
;  *      The region to consider. This should be in the coordinates of
;  *      the port you passed to inPort.
;  *    
;  *    ioWasInRgn:
;  *      On enter, this parameter should be set to true if the mouse is
;  *      currently inside the region passed in inRegion, or false if the
;  *      mouse is currently outside the region. On exit, this parameter
;  *      is updated to reflect the current reality, e.g. if the
;  *      outResult parameter returns kMouseTrackingMouseExited,
;  *      ioWasInRgn will be set to false when this function exits.
;  *      Because it is updated from within, you should only need to set
;  *      this yourself before the first call to this function in your
;  *      tracking loop.
;  *    
;  *    outResult:
;  *      On exit, this parameter receives a value representing what kind
;  *      of event was received that cause the function to exit, such as
;  *      kMouseTrackingMouseEntered.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  ConvertEventRefToEventRecord()
;  *  
;  *  Discussion:
;  *    This is a convenience routine to help you if there are places in
;  *    your application where you need an EventRecord and all you have
;  *    is an EventRef. If the event can be converted, outEvent is filled
;  *    in and the function returns true. If not, false is returned and
;  *    outEvent will contain a nullEvent.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The EventRef to convert into an EventRecord.
;  *    
;  *    outEvent:
;  *      The EventRecord to fill out.
;  *  
;  *  Result:
;  *    A boolean indicating if the conversion was successful (true) or
;  *    not (false).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TrackMouseRegion" 
      ((inPort (:pointer :grafport)) (inRegion (:handle :macregion)) (ioWasInRgn (:pointer :boolean)) (outResult (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  IsEventInMask()
;  *  
;  *  Discussion:
;  *    This is a companion function for ConvertEventRefToEventRecord,
;  *    and is provided as a convenience routine to help you if there are
;  *    places in your application where you want to check an EventRef to
;  *    see if it matches a classic EventMask bitfield. If the event
;  *    matches, the function returns true.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The EventRef to convert into an EventRecord.
;  *    
;  *    inMask:
;  *      The mask to consider.
;  *  
;  *  Result:
;  *    A boolean indicating if the event was considered to be in the
;  *    mask provided.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertEventRefToEventRecord" 
      ((inEvent :pointer) (outEvent (:pointer :eventrecord))) 
  :boolean
   () )                                         ; 
;  *  GetLastUserEventTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsEventInMask" 
      ((inEvent :pointer) (inMask :unsigned-integer)) 
  :boolean
   () )                                         ; ;    Mouse Coalescing                                                                  ; ; 
;  *  IsMouseCoalescingEnabled()
;  *  
;  *  Discussion:
;  *    Returns true if mouse coalescing is current enabled. When
;  *    enabled, we coalesce mouse moved and mouse dragged events. By
;  *    default, coalescing is on, but you can use
;  *    SetMouseCoalescingEnabled to disable it if you want finer-grained
;  *    mouse movement events, which is useful for drawing with tablets.
;  *  
;  *  Result:
;  *    A boolean indicating if coalescing is enabled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_GetLastUserEventTime" 
      () 
  :double-float
   () )
(deftrap-inline "_IsMouseCoalescingEnabled" 
      () 
  :boolean
   () )

; 
;  *  SetMouseCoalescingEnabled()
;  *  
;  *  Discussion:
;  *    Allows you to set mouse move/drag event coalescing on or off. By
;  *    default, coalescing is on, but you can use this function to
;  *    disable it if you want finer-grained mouse movement events, which
;  *    is useful for drawing with tablets.
;  *  
;  *  Parameters:
;  *    
;  *    inNewState:
;  *      A boolean indicating if coalescing should be enabled (true) or
;  *      disabled (false).
;  *    
;  *    outOldState:
;  *      A boolean which receives the prior state of mouse coalescing
;  *      for restoration later. You can pass NULL for this parameter if
;  *      you don't care.
;  *  
;  *  Result:
;  *    An operating system status result.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_SetMouseCoalescingEnabled" 
      ((inNewState :boolean) (outOldState (:pointer :boolean))) 
  :osstatus
   () )

; 
;    Timers                                                                            
; 

; 
;  *  EventLoopTimerRef
;  *  
;  *  Discussion:
;  *    An EventLoopTimerRef represents what we term a 'timer'. A timer
;  *    is a function that is called either once or at regular intervals.
;  *    It executes at task level and should not be confused with Time
;  *    Manager Tasks or any other interrupt-level callback. This means
;  *    you can call Toolbox routines, allocate memory and draw. When a
;  *    timer 'fires', it calls a callback that you specify when the
;  *    timer is installed. Timers in general have two uses - as a
;  *    timeout mechanism and as a periodic task. An everyday example of
;  *    using a timer for a timeout might be a light that goes out if no
;  *    motion is detected in a room for 5 minutes. For this, you might
;  *    install a timer which will fire in 5 minutes. If motion is
;  *    detected, you would reset the timer fire time and let the clock
;  *    start over. If no motion is detected for the full 5 minutes, the
;  *    timer will fire and you could power off the light. A periodic
;  *    timer is one that fires at regular intervals (say every second or
;  *    so). You might use such a timer to blink the insertion point in
;  *    your editor, etc. One advantage of timers is that you can install
;  *    the timer right from the code that wants the time. For example,
;  *    the standard Toolbox Edit Text control can install a timer to
;  *    blink the cursor when it's active, meaning that IdleControls is a
;  *    no-op for that control and doesn't need to be called. When the
;  *    control is inactive, it removes its timer and doesn't waste CPU
;  *    time in that state. NOTE: Currently, if you do decide to draw
;  *    when your timer is called, be sure to save and restore the
;  *    current port so that calling your timer doesn't inadvertently
;  *    change the port out from under someone.
;  

(def-mactype :eventlooptimerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventlooptimerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventLoopTimerRef parameter can be nil, it is changed to xx: EventLoopTimerRefPtr 

; 
; 	 *  EventLoopTimerProcPtr
; 	 *  
; 	 *  Discussion:
; 	 *    Called when a timer fires.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inTimer:
; 	 *      The timer that fired.
; 	 *    
; 	 *    inUserData:
; 	 *      The data passed into InstallEventLoopTimer.
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EventLoopTimerProcPtr = PROCEDURE(inTimer: EventLoopTimerRef; inUserData: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :eventlooptimerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :eventlooptimerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :eventlooptimerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppEventLoopTimerProcInfo #x3C0)
; 
; 	 *  NewEventLoopTimerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewEventLoopTimerProc 
(deftrap "_NewEventLoopTimerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeEventLoopTimerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeEventLoopTimerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeEventLoopTimerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallEventLoopTimerProc 
(deftrap-inline "_InvokeEventLoopTimerUPP" 
      ((inTimer :pointer) (inUserData :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InstallEventLoopTimer()
;  *  
;  *  Discussion:
;  *    Installs a timer onto the event loop specified. The timer can
;  *    either fire once or repeatedly at a specified interval depending
;  *    on the parameters passed to this function.
;  *  
;  *  Parameters:
;  *    
;  *    inEventLoop:
;  *      The event loop to add the timer.
;  *    
;  *    inFireDelay:
;  *      The delay before first firing this timer (can be 0, to request
;  *      that the timer be fired as soon as control returns to your
;  *      event loop). In Mac OS X and CarbonLib 1.5 and later, you may
;  *      pass kEventDurationForever to stop the timer from firing at all
;  *      until SetEventLoopTimerNextFireTime is used to start it; in
;  *      earlier CarbonLibs, to achieve the same effect, just pass zero
;  *      and then immediately call SetEventLoopTimerNextFireTime( timer,
;  *      kEventDurationForever ) before returning control to your event
;  *      loop.
;  *    
;  *    inInterval:
;  *      The timer interval (pass 0 for a one-shot timer, which executes
;  *      once but does not repeat). In Mac OS X and CarbonLib 1.5 and
;  *      later, you may also pass kEventDurationForever to create a
;  *      one-shot timer.
;  *    
;  *    inTimerProc:
;  *      The routine to call when the timer fires.
;  *    
;  *    inTimerData:
;  *      Data to pass to the timer proc when called.
;  *    
;  *    outTimer:
;  *      A reference to the newly installed timer.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  RemoveEventLoopTimer()
;  *  
;  *  Discussion:
;  *    Removes a timer that was previously installed by a call to
;  *    InstallEventLoopTimer. You call this function when you are done
;  *    using a timer.
;  *  
;  *  Parameters:
;  *    
;  *    inTimer:
;  *      The timer to remove.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InstallEventLoopTimer" 
      ((inEventLoop :pointer) (inFireDelay :double-float) (inInterval :double-float) (inTimerProc :pointer) (inTimerData :pointer) (outTimer (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  SetEventLoopTimerNextFireTime()
;  *  
;  *  Discussion:
;  *    This routine is used to 'reset' a timer. It controls the next
;  *    time the timer fires. This will override any interval you might
;  *    have set. For example, if you have a timer that fires every
;  *    second, and you call this function setting the next time to five
;  *    seconds from now, the timer will sleep for five seconds, then
;  *    fire. It will then resume its one-second interval after that. It
;  *    is as if you removed the timer and reinstalled it with a new
;  *    first-fire delay.
;  *  
;  *  Parameters:
;  *    
;  *    inTimer:
;  *      The timer to adjust
;  *    
;  *    inNextFire:
;  *      The interval from the current time to wait until firing the
;  *      timer again. You may pass kEventDurationForever to stop the
;  *      timer from firing at all.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveEventLoopTimer" 
      ((inTimer :pointer)) 
  :osstatus
   () )                                         ; ======================================================================================;   EVENT CLASSES                                                                       ; ======================================================================================; 
;  *  Discussion:
;  *    Event classes
;  
(deftrap-inline "_SetEventLoopTimerNextFireTime" 
      ((inTimer :pointer) (inNextFire :double-float)) 
  :osstatus
   () )
(defconstant $kEventClassMouse :|mous|)
(defconstant $kEventClassKeyboard :|keyb|)
(defconstant $kEventClassTextInput :|text|)
(defconstant $kEventClassApplication :|appl|)
(defconstant $kEventClassAppleEvent :|eppc|)
(defconstant $kEventClassMenu :|menu|)
(defconstant $kEventClassWindow :|wind|)
(defconstant $kEventClassControl :|cntl|)
(defconstant $kEventClassCommand :|cmds|)
(defconstant $kEventClassTablet :|tblt|)
(defconstant $kEventClassVolume :|vol |)
(defconstant $kEventClassAppearance :|appm|)
(defconstant $kEventClassService :|serv|)

; 		
; 	 Mouse Events                                                                         	
; 		
; 	 Mouse Events 	

; 
; 	 *  Discussion:
; 	 *    Mouse events (kEventClassMouse)
; 	 	
(defconstant $kEventMouseDown 1)
(defconstant $kEventMouseUp 2)
(defconstant $kEventMouseMoved 5)
(defconstant $kEventMouseDragged 6)
(defconstant $kEventMouseWheelMoved 10)

; 
; 	 *  HIPoint
; 	 *  
; 	 *  Discussion:
; 	 *    HIPoint is a new, floating point-based type to help express
; 	 *    coordinates in a much richer fashion than the classic QuickDraw
; 	 *    points. It will, in time, be more heavily used throughout the
; 	 *    Toolbox. For now, it is replacing our use of typeQDPoint in mouse
; 	 *    events. This is to better support sub-pixel tablet coordinates.
; 	 *    If you ask for a mouse location with typeQDPoint, and the point
; 	 *    is actually stored as typeHIPoint, it will automatically be
; 	 *    coerced to typeQDPoint for you, so this change should be largely
; 	 *    transparent to applications. HIPoints are in screen space, i.e.
; 	 *    the top left of the screen is 0, 0.
; 	 	

(def-mactype :hipointptr (find-mactype '(:pointer :hipoint)))
(defrecord HIPoint 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
   )

; 	
; 	    Parameters for mouse events:
; 	
; 	    kEventMouseDown
; 	        -->     kEventParamMouseLocation    typeHIPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamMouseButton      typeMouseButton
; 	        -->     kEventParamClickCount       typeUInt32
; 	        -->     kEventParamMouseChord       typeUInt32  (Mac OS X only)
; 	        -->     kEventParamTabletEventType  typeUInt32  (Mac OS X 10.1, CarbonLib 1.5, and later)
; 	        -->     kEventParamTabletPointRec   typeTabletPointRec          (if kEventParamTabletEventType is kEventTabletPoint)
; 	        -->     kEventParamTabletProximityRec typeTabletProximityRec    (if kEventParamTabletEventType is kEventTabletProximity)
; 	        
; 	    kEventMouseUp
; 	        -->     kEventParamMouseLocation    typeHIPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamMouseButton      typeMouseButton
; 	        -->     kEventParamClickCount       typeUInt32
; 	        -->     kEventParamMouseChord       typeUInt32  (Mac OS X only)
; 	        -->     kEventParamTabletEventType  typeUInt32  (Mac OS X 10.1, CarbonLib 1.5, and later)
; 	        -->     kEventParamTabletPointRec   typeTabletPointRec          (if kEventParamTabletEventType is kEventTabletPoint)
; 	        -->     kEventParamTabletProximityRec typeTabletProximityRec    (if kEventParamTabletEventType is kEventTabletProximity)
; 	
; 	    kEventMouseMoved
; 	        -->     kEventParamMouseLocation    typeHIPoint
; 	        -->     kEventParamMouseDelta       typeHIPoint (Mac OS X only)
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamTabletEventType  typeUInt32  (Mac OS X 10.1, CarbonLib 1.5, and later)
; 	        -->     kEventParamTabletPointRec   typeTabletPointRec          (if kEventParamTabletEventType is kEventTabletPoint)
; 	        -->     kEventParamTabletProximityRec typeTabletProximityRec    (if kEventParamTabletEventType is kEventTabletProximity)
; 	
; 	    kEventMouseDragged
; 	        -->     kEventParamMouseLocation    typeHIPoint
; 	        -->     kEventParamMouseDelta       typeHIPoint (Mac OS X only)
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamMouseButton      typeMouseButton
; 	        -->     kEventParamMouseChord       typeUInt32  (Mac OS X only)
; 	        -->     kEventParamTabletEventType  typeUInt32  (Mac OS X 10.1, CarbonLib 1.5, and later)
; 	        -->     kEventParamTabletPointRec   typeTabletPointRec          (if kEventParamTabletEventType is kEventTabletPoint)
; 	        -->     kEventParamTabletProximityRec typeTabletProximityRec    (if kEventParamTabletEventType is kEventTabletProximity)
; 	
; 	    kEventMouseWheelMoved
; 	        -->     kEventParamMouseLocation    typeHIPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamMouseWheelAxis   typeMouseWheelAxis
; 	        -->     kEventParamMouseWheelDelta  typeLongInteger
; 		

; 
; 	 *  EventMouseButton
; 	 *  
; 	 	
(def-mactype :eventmousebutton (find-mactype ':unsigned-integer))

(defconstant $kEventMouseButtonPrimary 1)
(defconstant $kEventMouseButtonSecondary 2)
(defconstant $kEventMouseButtonTertiary 3)

; 
; 	 *  EventMouseWheelAxis
; 	 *  
; 	 	

(def-mactype :eventmousewheelaxis (find-mactype ':unsigned-integer))

(defconstant $kEventMouseWheelAxisX 0)
(defconstant $kEventMouseWheelAxisY 1)

; 		
; 	 Text Input Events                                                                    	
; 		

; 
; 	 *  Summary:
; 	 *    Text input events (kEventClassTextInput)
; 	 *  
; 	 *  Discussion:
; 	 *    The following TextInput events reimplement the AppleEvents
; 	 *    defined in Inside Mac Text - Text Services Manager, and provide
; 	 *    the benefits of Carbon Event targeting, dispatching and
; 	 *    propagation to applications that have formerly handled the TSM
; 	 *    suite of AppleEvents. TextInput handlers may be installed on
; 	 *    controls, windows, or the application event target (equivalent to
; 	 *    AppleEvent-based handling). In all cases, if a given TextInput
; 	 *    handler is not installed, TSM will convert that TextInput to an
; 	 *    AppleEvent and redispatch via AESend to the current process,
; 	 *    making adoption as gradual as is desired.
; 	 	
(defconstant $kEventTextInputUpdateActiveInputArea 1)
(defconstant $kEventTextInputUnicodeForKeyEvent 2)
(defconstant $kEventTextInputOffsetToPos 3)
(defconstant $kEventTextInputPosToOffset 4)
(defconstant $kEventTextInputShowHideBottomWindow 5)
(defconstant $kEventTextInputGetSelectedText 6)

; 	
; 	    Parameters for TextInput events:
; 	    
; 	    kEventTextInputUpdateActiveInputArea
; 	        Required parameters:
; 	        -->     kEventParamTextInputSendComponentInstance           typeComponentInstance
; 	        -->     kEventParamTextInputSendRefCon                      typeLongInteger
; 	        -->     kEventParamTextInputSendSLRec                       typeIntlWritingCode
; 	        -->     kEventParamTextInputSendFixLen                      typeLongInteger
; 	        -->     kEventParamTextInputSendText                        typeUnicodeText, typeChar
; 	                    (data type depends on TSMDocument type created via NewTSMDocument...
; 	                     typeChar for kTextService document, typeUnicodeText for kUnicodeDocument)
; 	        
; 	        Optional parameters:
; 	        -->     kEventParamTextInputSendUpdateRng                   typeTextRangeArray
; 	        -->     kEventParamTextInputSendHiliteRng                   typeTextRangeArray
; 	        -->     kEventParamTextInputSendClauseRng                   typeOffsetArray
; 	        -->     kEventParamTextInputSendPinRng                      typeTextRange
; 	        -->     kEventParamTextInputSendPinRng                      typeTextRange
; 	        -->     kEventParamTextInputSendTextServiceEncoding         typeUInt32
; 	        -->     kEventParamTextInputSendTextServiceMacEncoding      typeUInt32
; 	        
; 	    kEventTextInputUnicodeForKeyEvent
; 	        Required parameters:
; 	        -->     kEventParamTextInputSendComponentInstance           typeComponentInstance
; 	        -->     kEventParamTextInputSendRefCon                      typeLongInteger
; 	        -->     kEventParamTextInputSendSLRec                       typeIntlWritingCode
; 	        -->     kEventParamTextInputSendText                        typeUnicodeText
; 	        -->     kEventParamTextInputSendKeyboardEvent               typeEventRef
; 	                    (This parameter is the original raw keyboard event that produced the
; 	                     text.  It enables access to kEventParamKeyModifiers and 
; 	                     kEventParamKeyCode parameters.
; 	                     You can also extract from this event either Unicodes or Mac encoding
; 	                     characters as follows:
; 	                            kEventParamKeyUnicodes              typeUnicodeText
; 	                            kEventParamKeyMacCharCodes          typeChar (if available)
; 	                     The kEventParamKeyUnicodes parameter of the raw keyboard event is
; 	                     identical to the TextInput event's kEventParamTextInputSendText
; 	                     parameter.  Note that when contents of TSM's bottom-line input
; 	                     window (i.e. during typing Chinese, Korean, or Japanese) are confirmed,
; 	                     the raw keyboard event's keyCode and modifiers are set to default values.)
; 	
; 	    kEventTextInputOffsetToPos
; 	        Required parameters:
; 	        -->     kEventParamTextInputSendComponentInstance           typeComponentInstance
; 	        -->     kEventParamTextInputSendRefCon                      typeLongInteger
; 	        -->     kEventParamTextInputSendTextOffset                  typeLongInteger
; 	        <--     kEventParamTextInputReplyPoint                      typeQDPoint
; 	        
; 	        Optional parameters:
; 	        -->     kEventParamTextInputSendSLRec                       typeIntlWritingCode
; 	        -->     kEventParamTextInputSendLeadingEdge                 typeBoolean
; 	        <--     kEventParamTextInputReplySLRec                      typeIntlWritingCode
; 	        <--     kEventParamTextInputReplyFont                       typeLongInteger
; 	        <--     kEventParamTextInputReplyFMFont                     typeUInt32
; 	        <--     kEventParamTextInputReplyPointSize                  typeFixed
; 	        <--     kEventParamTextInputReplyLineHeight                 typeShortInteger
; 	        <--     kEventParamTextInputReplyLineAscent                 typeShortIn
; 		
; 	 Raw Keyboard Events                                                                  	
; 		

; 
; 	 *  Summary:
; 	 *    Keyboard events (kEventClassKeyboard)
; 	 *  
; 	 *  Discussion:
; 	 *    These events are the lowest-level keyboard events.
; 	 	
(defconstant $kEventRawKeyDown 1)               ;   hardware-level events 
(defconstant $kEventRawKeyRepeat 2)
(defconstant $kEventRawKeyUp 3)
(defconstant $kEventRawKeyModifiersChanged 4)
(defconstant $kEventHotKeyPressed 5)
(defconstant $kEventHotKeyReleased 6)           ;   Mac OS X only 

; 
; 	 *  Summary:
; 	 *    Key modifier change event bits and masks
; 	 *  
; 	 *  Discussion:
; 	 *    From bit 8, cmdKeyBit, to bit 15, rightControlKeyBit, are
; 	 *    compatible with Event Manager modifiers.
; 	 	
(defconstant $kEventKeyModifierNumLockBit 16)   ;   Num Lock is on? (Mac OS X only) 
(defconstant $kEventKeyModifierFnBit 17)        ;   Fn key is down? (Mac OS X only) 

(defconstant $kEventKeyModifierNumLockMask #x10000)
(defconstant $kEventKeyModifierFnMask #x20000)

; 	
; 	    Parameters for keyboard events:
; 	
; 	    kEventRawKeyDown
; 	        -->     kEventParamKeyMacCharCodes  typeChar
; 	        -->     kEventParamKeyCode          typeUInt32
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamKeyboardType     typeUInt32
; 	
; 	    kEventRawKeyRepeat
; 	        -->     kEventParamKeyMacCharCodes  typeChar
; 	        -->     kEventParamKeyCode          typeUInt32
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamKeyboardType     typeUInt32
; 	
; 	    kEventRawKeyUp
; 	        -->     kEventParamKeyMacCharCodes  typeChar
; 	        -->     kEventParamKeyCode          typeUInt32
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamKeyboardType     typeUInt32
; 	
; 	    kEventRawKeyModifiersChanged
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	
; 	    kEventHotKeyPressed
; 	        -->     kEventParamDirectObject     typeEventHotKeyID
; 	
; 	    kEventHotKeyReleased
; 	        -->     kEventParamDirectObject     typeEventHotKeyID
; 		

; 		
; 	 Application Events                                                                   	
; 		

; 
; 	 *  Summary:
; 	 *    Application events (kEventClassApplication)
; 	 	
(defconstant $kEventAppActivated 1)
(defconstant $kEventAppDeactivated 2)
(defconstant $kEventAppQuit 3)
(defconstant $kEventAppLaunchNotification 4)
(defconstant $kEventAppLaunched 5)
(defconstant $kEventAppTerminated 6)
(defconstant $kEventAppFrontSwitched 7)
(defconstant $kEventAppGetDockTileMenu 20)

; 	
; 	    Parameters for application events:
; 	
; 	    kEventAppActivated
; 	        -->     kEventParamWindowRef    typeWindowRef
; 	    
; 	    kEventAppDeactivated
; 	        (no parameters)
; 	    
; 	    kEventAppQuit
; 	        (no parameters)
; 	    
; 	    kEventAppLaunchNotification
; 	        -->     kEventParamProcessID    typeProcessSerialNumber
; 	        -->     kEventParamLaunchRefCon typeUInt32
; 	        -->     kEventParamLaunchErr    typeOSStatus
; 	        
; 	    kEventAppLaunched
; 	        -->     kEventParamProcessID    typeProcessSerialNumber
; 	        
; 	    kEventAppTerminated
; 	        -->     kEventParamProcessID    typeProcessSerialNumber
; 	        
; 	    kEventAppFrontSwitched
; 	        -->     kEventParamProcessID    typeProcessSerialNumber
; 	        
; 	    kEventAppGetDockTileMenu
; 	        <--     kEventParamMenuRef      typeMenuRef
; 		
; 		
; 	  Apple Events                                                                        	
; 		

; 
; 	 *  Summary:
; 	 *    Apple events (kEventClassAppleEvent)
; 	 	
(defconstant $kEventAppleEvent 1)

; 	
; 	    Parameters for Apple events:
; 	
; 	    kEventAppleEvent
; 	        -->     kEventParamAEEventClass     typeType        // the eventClass of the Apple event
; 	        -->     kEventParamAEEventID        typeType        // the eventID of the Apple event
; 		
; 		
; 	  Window Events                                                                       	
; 		

; 
; 	 *  Summary:
; 	 *    Window refresh events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Events related to drawing a window's content.
; 	 	
(defconstant $kEventWindowUpdate 1)
(defconstant $kEventWindowDrawContent 2)

; 	
; 	    Parameters for window refresh events:
; 	
; 	    kEventWindowUpdate
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowDrawContent
; 	        -->     kEventParamDirectObject     typeWindowRef
; 		

; 
; 	 *  Summary:
; 	 *    Window activation events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Events related to activating and deactivating a window.
; 	 	
(defconstant $kEventWindowActivated 5)
(defconstant $kEventWindowDeactivated 6)
(defconstant $kEventWindowGetClickActivation 7)

; 	
; 	    Parameters for window activation events:
; 	
; 	    kEventWindowActivated
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowDeactivated
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowGetClickActivation
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	        -->     kEventParamWindowDefPart    typeWindowDefPartCode
; 	        -->     kEventParamControlRef       typeControlRef (only present if the click was on a control)
; 	        <--     kEventParamClickActivation  typeClickActivationResult
; 		

; 
; 	 *  Summary:
; 	 *    Window state change events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Events that notify of a change in the window's state. These
; 	 *    events are sent to all windows, regardless of whether the window
; 	 *    has the standard handler installed.
; 	 	
(defconstant $kEventWindowShowing 22)
(defconstant $kEventWindowHiding 23)
(defconstant $kEventWindowShown 24)
(defconstant $kEventWindowHidden 25)
(defconstant $kEventWindowBoundsChanging 26)
(defconstant $kEventWindowBoundsChanged 27)
(defconstant $kEventWindowResizeStarted 28)
(defconstant $kEventWindowResizeCompleted 29)
(defconstant $kEventWindowDragStarted 30)
(defconstant $kEventWindowDragCompleted 31)

; 
; 	 *  Summary:
; 	 *    Window bounds change event attributes
; 	 *  
; 	 *  Discussion:
; 	 *    When the toolbox sends out a kEventWindowBoundsChanging or
; 	 *    kEventWindowBoundsChanged event, it also sends along a parameter
; 	 *    containing attributes of the event. These attributes can be used
; 	 *    to determine what aspect of the window changed (origin, size, or
; 	 *    both), and whether or not some user action is driving the change
; 	 *    (drag or resize).
; 	 	
(defconstant $kWindowBoundsChangeUserDrag #x1)
(defconstant $kWindowBoundsChangeUserResize #x2)
(defconstant $kWindowBoundsChangeSizeChanged #x4)
(defconstant $kWindowBoundsChangeOriginChanged #x8)

; 	
; 	    Parameters for window state change events:
; 	    
; 	    kEventWindowShowing
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowHiding
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	    
; 	    kEventWindowShown
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowHidden
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	    
; 	    kEventWindowBoundsChanging
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	        -->     kEventParamAttributes       typeUInt32
; 	        -->     kEventParamOriginalBounds   typeQDRectangle
; 	        -->     kEventParamPreviousBounds   typeQDRectangle
; 	        <->     kEventParamCurrentBounds    typeQDRectangle
; 	        
; 	    kEventWindowBoundsChanged
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	        -->     kEventParamAttributes       typeUInt32
; 	        -->     kEventParamOriginalBounds   typeQDRectangle
; 	        -->     kEventParamPreviousBounds   typeQDRectangle
; 	        -->     kEventParamCurrentBounds    typeQDRectangle
; 	    
; 	    kEventWindowResizeStarted
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowResizeCompleted
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	    
; 	    kEventWindowDragStarted
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowDragCompleted
; 	        -->     kEventParamDirectObject     typeWindowRef
; 		

; 
; 	 *  Summary:
; 	 *    Window click events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Low-level events which generate higher-level action events.
; 	 *    These events are only generated for windows with the standard
; 	 *    window handler installed. Most clients should allow the standard
; 	 *    handler to implement these events. Window click events are
; 	 *    generated from lower-level kEventMouseDown events by copying the
; 	 *    mouse event and changing the class and kind, so window click
; 	 *    events will have all of the parameters of the mouse down event,
; 	 *    in addition to those parameters documented here that are specific
; 	 *    to the window events.
; 	 	
(defconstant $kEventWindowClickDragRgn 32)
(defconstant $kEventWindowClickResizeRgn 33)
(defconstant $kEventWindowClickCollapseRgn 34)
(defconstant $kEventWindowClickCloseRgn 35)
(defconstant $kEventWindowClickZoomRgn 36)
(defconstant $kEventWindowClickContentRgn 37)
(defconstant $kEventWindowClickProxyIconRgn 38)
(defconstant $kEventWindowClickToolbarButtonRgn 41)
(defconstant $kEventWindowClickStructureRgn 42)

; 
; 	 *  Summary:
; 	 *    Window cursor change events (kEventClassWindow)
; 	 	
(defconstant $kEventWindowCursorChange 40)

; 	
; 	    Parameters for window cursor change events:
; 	    
; 	    kEventWindowCursorChange
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 		

; 
; 	 *  Summary:
; 	 *    Window action events
; 	 *  
; 	 *  Discussion:
; 	 *    Events which indicate that certain changes have been made to the
; 	 *    window. These events have greater semantic meaning than the
; 	 *    low-level window click events and are usually prefered for
; 	 *    overriding.
; 	 	
(defconstant $kEventWindowCollapse 66)
(defconstant $kEventWindowCollapsed 67)
(defconstant $kEventWindowCollapseAll 68)
(defconstant $kEventWindowExpand 69)
(defconstant $kEventWindowExpanded 70)
(defconstant $kEventWindowExpandAll 71)
(defconstant $kEventWindowClose 72)
(defconstant $kEventWindowClosed 73)
(defconstant $kEventWindowCloseAll 74)
(defconstant $kEventWindowZoom 75)
(defconstant $kEventWindowZoomed 76)
(defconstant $kEventWindowZoomAll 77)
(defconstant $kEventWindowContextualMenuSelect 78)
(defconstant $kEventWindowPathSelect 79)
(defconstant $kEventWindowGetIdealSize 80)
(defconstant $kEventWindowGetMinimumSize 81)
(defconstant $kEventWindowGetMaximumSize 82)
(defconstant $kEventWindowConstrain 83)
(defconstant $kEventWindowHandleContentClick 85)
(defconstant $kEventWindowProxyBeginDrag 128)
(defconstant $kEventWindowProxyEndDrag 129)
(defconstant $kEventWindowToolbarSwitchMode 150)

; 	
; 	    Parameters for window action events:
; 	    
; 	    kEventWindowCollapse
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowCollapsed
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowCollapseAll
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowExpand
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowExpanded
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowExpandAll
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowClose
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowClosed
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowCloseAll
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowZoom
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowZoomed
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowZoomAll
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowContextualMenuSelect
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowPathSelect
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowGetIdealSize
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        <-- kEventParamDimensions       typeQDPoint
; 	        
; 	    kEventWindowGetMinimumSize
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        <-- kEventParamDimensions       typeQDPoint
; 	        
; 	    kEventWindowGetMaximumSize
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        <-- kEventParamDimensions       typeQDPoint
; 	    
; 	    kEventWindowConstrain
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        --> kEventParamAvailableBounds  typeQDRectangle
; 	        --> kEventParamAttributes       typeUInt32 (optional; available in Mac OS X after 10.1)
; 	        --> kEventParamWindowRegionCode typeWindowRegionCode (optional; available in Mac OS X after 10.1)
; 	        --> kEventParamRgnHandle        typeQDRgnHandle (optional; available in Mac OS X after 10.1)
; 	    
; 	    kEventWindowHandleContentClick
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        --> [other parameters from kEventMouseDown]
; 	
; 	    kEventWindowProxyBeginDrag
; 	        --> kEventParamDirectObject     typeWindowRef
; 	        
; 	    kEventWindowProxyEndDrag
; 	        --> kEventParamDirectObject     typeWindowRef
; 		

; 
; 	 *  Summary:
; 	 *    Window focus events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Events related to focus changes between windows. These events are
; 	 *    generated by SetUserFocusWindow; since that API is only called by
; 	 *    default by the standard window handler, these events are normally
; 	 *    only sent to windows with the standard handler installed.
; 	 	
(defconstant $kEventWindowFocusAcquired 200)
(defconstant $kEventWindowFocusRelinquish 201)

; 	
; 	    Parameters for window focus events:
; 	    
; 	    kEventWindowFocusAcquire
; 	        -->     kEventParamDirectObject     typeWindowRef
; 	
; 	    kEventWindowFocusRelinquish
; 	        -->     kEventParamDirectObject     typeWindowRef
; 		

; 
; 	 *  Summary:
; 	 *    Window definition events (kEventClassWindow)
; 	 *  
; 	 *  Discussion:
; 	 *    Events that correspond to WDEF messages. Sent to all windows,
; 	 *    regardless of whether they have the standard window handler
; 	 *    installed.
; 	 	
(defconstant $kEventWindowDrawFrame 1000)
(defconstant $kEventWindowDrawPart 1001)
(defconstant $kEventWindowGetRegion 1002)
(defconstant $kEventWindowHitTest 1003)
(defconstant $kEventWindowInit 1004)
(defconstant $kEventWindowDispose 1005)
(defconstant $kEventWindowDragHilite 1006)
(defconstant $kEventWindowModified 1007)
(defconstant $kEventWindowSetupProxyDragImage 1008)
(defconstant $kEventWindowStateChanged 1009)
(defconstant $kEventWindowMeasureTitle 1010)
(defconstant $kEventWindowDrawGrowBox 1011)
(defconstant $kEventWindowGetGrowImageRegion 1012)
(defconstant $kEventWindowPaint 1013)

; 	
; 	    Parameters for window definition events:
; 	    
; 	    kEventWindowDrawFrame
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	
; 	    kEventWindowDrawPart
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	        -->     kEventParamWindowDefPart    typeWindowDefPartCode       the part to draw
; 	
; 	    kEventWindowGetRegion
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	        -->     kEventParamWindowRegionCode typeWindowRegionCode        the region to get
; 	        -->     kEventParamRgnHandle        typeQDRgnHandle             the region to munge
; 	
; 	    kEventWindowHitTest
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	        -->     kEventParamMouseLocation    typeQDPoint                 the mouse location
; 	        <--     kEventParamWindowDefPart    typeWindowDefPartCode       the part hit
; 	
; 	    kEventWindowInit
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	        <--     kEventParamWindowFeatures   typeUInt32                  the window features
; 	
; 	    kEventWindowDispose
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	
; 	    kEventWindowDragHilite
; 	        -->     kEventParamDirectObject             typeWindowRef       the window
; 	        -->     kEventParamWindowDragHiliteFlag     typeBoolean         whether to draw (true) or
; 	                                                                        erase (false) the hilite
; 	
; 	    kEventWindowModified
; 	        -->     kEventParamDirectObject             typeWindowRef       the window
; 	        -->     kEventParamWindowModifiedFlag       typeBoolean         the new modified state
; 	
; 	    kEventWindowSetupProxyDragImage
; 	        -->     kEventParamDirectObject             typeWindowRef       the window
; 	        -->     kEventParamWindowProxyImageRgn      typeQDRgnHandle     the region you modify
; 	                                                                        to contain the clip
; 	                                                                        region for the GWorld.
; 	        -->     kEventParamWindowProxyOutlineRgn    typeQDRgnHandle     the region you modify
; 	                                                                        to contain the drag
; 	                                                                        outline used when the
; 	                                                                        GWorld cannot be used.
; 	        <--     kEventParamWindowProxyGWorldPtr     typeGWorldPtr       a GWorld you allocate
; 	                                                                        which contains the
; 	                                                                        drag image.
; 	
; 	    kEventWindowStateChanged
; 	        -->     kEventParamDirectObject             typeWindowRef       the window
; 	        -->     kEventParamWindowStateChangedFlags  typeUInt32          the state change flags
; 	
; 	    kEventWindowMeasureTitle
; 	        -->     kEventParamDirectObject             typeWindowRef       the window
; 	        <--     kEventParamWindowTitleFullWidth     typeSInt16          the length of the whole title area
; 	        <--     kEventParamWindowTitleTextWidth     typeSInt16          the length just the title text
; 	
; 	    kEventWindowDrawGrowBox
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	
; 	    kEventWindowGetGrowImageRegion
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 	        -->     kEventParamWindowGrowRect   typeQDRectangle             the global rect
; 	        -->     kEventParamRgnHandle        typeQDRgnHandle             the region to modify
; 	
; 	    kEventWindowPaint
; 	        -->     kEventParamDirectObject     typeWindowRef               the window
; 		
; 		
; 	  Menu Events                                                                         	
; 		

; 
; 	 *  Summary:
; 	 *    Menu events (kEventClassMenu)
; 	 	
(defconstant $kEventMenuBeginTracking 1)
(defconstant $kEventMenuEndTracking 2)
(defconstant $kEventMenuChangeTrackingMode 3)
(defconstant $kEventMenuOpening 4)
(defconstant $kEventMenuClosed 5)
(defconstant $kEventMenuTargetItem 6)
(defconstant $kEventMenuMatchKey 7)
(defconstant $kEventMenuEnableItems 8)
(defconstant $kEventMenuPopulate 9)
(defconstant $kEventMenuMeasureItemWidth 100)
(defconstant $kEventMenuMeasureItemHeight 101)
(defconstant $kEventMenuDrawItem 102)
(defconstant $kEventMenuDrawItemContent 103)
(defconstant $kEventMenuDispose 1001)

; 
; 	 *  Discussion:
; 	 *    Menu context flags indicate the context or usage of a
; 	 *    menu-related Carbon event.
; 	 	
;   menu location 
(defconstant $kMenuContextMenuBar #x1)          ;   menu type 
(defconstant $kMenuContextPullDown #x100)
(defconstant $kMenuContextPopUp #x200)
(defconstant $kMenuContextSubmenu #x400)        ;   menu usage 
(defconstant $kMenuContextMenuBarTracking #x10000)
(defconstant $kMenuContextPopUpTracking #x20000)
(defconstant $kMenuContextKeyMatching #x40000)
(defconstant $kMenuContextMenuEnabling #x80000)

; 	
; 	    Parameters for menu events:
; 	    
; 	    kEventMenuBeginTracking
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamCurrentMenuTrackingMode  typeMenuTrackingMode
; 	        -->     kEventParamMenuContext              typeUInt32 (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        
; 	    kEventMenuEndTracking
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuContext              typeUInt32 (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        
; 	    kEventMenuChangeTrackingMode
; 	        -->     kEventParamCurrentMenuTrackingMode  typeMenuTrackingMode
; 	        -->     kEventParamNewMenuTrackingMode      typeMenuTrackingMode
; 	        -->     kEventParamMenuContext              typeUInt32
; 	    
; 	    kEventMenuOpening
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuFirstOpen            typeBoolean
; 	        -->     kEventParamMenuContext              typeUInt32 (in CarbonLib 1.5 and later)
; 	        
; 	    kEventMenuClosed
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuContext              typeUInt32 (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        
; 	    kEventMenuTargetItem
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuItemIndex            typeMenuItemIndex
; 	        -->     kEventParamMenuCommand              typeMenuCommand
; 	        -->     kEventParamMenuContext              typeUInt32 (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	    
; 	    kEventMenuMatchKey
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamEventRef                 typeEventRef
; 	        -->     kEventParamMenuEventOptions         typeMenuEventOptions
; 	        -->     kEventParamMenuContext              typeUInt32 (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        <--     kEventParamMenuItemIndex            typeMenuItemIndex
; 	        
; 	    kEventMenuEnableItems
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamEnableMenuForKeyEvent    typeBoolean
; 	        -->     kEventParamMenuContext              typeUInt32 (in CarbonLib 1.3.1 and later)
; 	        
; 	    kEventMenuPopulate (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuContext              typeUInt32
; 	        
; 	    kEventMenuMeasureItemWidth (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuItemIndex            typeMenuItemIndex
; 	        <--     kEventParamMenuItemWidth            typeShortInteger
; 	    
; 	    kEventMenuMeasureItemHeight (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamMenuItemIndex            typeMenuItemIndex
; 	        <--     kEventParamMenuItemHeight           typeShortInteger
; 	
; 	    kEventMenuDrawItem (on Mac OS X 10.1 and later, and CarbonLib 1.5 and later)
; 	        -->     kEventParamDirectObject             typeMenuRef
; 	        -->     kEventParamCurrentBounds            typeQDRectangle
; 	        -->     kEventParamMenuItemIndex            typeMenuItemIndex
; 	        -->     kEventParamMenuItemBounds           typeQDRectangle
; 	        -->     kEventParamMenuVirtualTop           typeLongInteger
; 	        -->     kEventParamMenuVirtualBottom        typeLongInteger
; 	        -->     kEventParamMenuDrawState            typeThemeMenuState
; 	        -->     kEventParamMenuItemType             typeThemeMenuItemType
; 	        -->     kEventParamCGContextRef             typeCGContextRef
; 	        <--     kEventParamMenuMarkBounds           typeQDRectangle (added to e
; 		
; 	  Command Events                                                                      	
; 		

; 
; 	 *  Summary:
; 	 *    Command events (kEventClassCommand)
; 	 	
(defconstant $kEventProcessCommand 1)
(defconstant $kEventCommandProcess 1)
(defconstant $kEventCommandUpdateStatus 2)

; 	
; 	    Parameters for command events:
; 	
; 	    kEventCommandProcess
; 	        -->     kEventParamDirectObject     typeHICommand
; 	        -->     kEventParamKeyModifiers     typeUInt32 (optional)
; 	
; 	    kEventCommandUpdateStatus
; 	        -->     kEventParamDirectObject     typeHICommand
; 	        -->     kEventParamMenuContext      typeUInt32
; 		
; 	 HI Commands 	

; 
; 	 *  Summary:
; 	 *    Common command IDs
; 	 	
(defconstant $kHICommandOK :|ok  |)
(defconstant $kHICommandCancel :|not!|)
(defconstant $kHICommandQuit :|quit|)
(defconstant $kHICommandUndo :|undo|)
(defconstant $kHICommandRedo :|redo|)
(defconstant $kHICommandCut :|cut |)
(defconstant $kHICommandCopy :|copy|)
(defconstant $kHICommandPaste :|past|)
(defconstant $kHICommandClear :|clea|)
(defconstant $kHICommandSelectAll :|sall|)
(defconstant $kHICommandHide :|hide|)
(defconstant $kHICommandHideOthers :|hido|)
(defconstant $kHICommandShowAll :|shal|)
(defconstant $kHICommandPreferences :|pref|)
(defconstant $kHICommandZoomWindow :|zoom|)
(defconstant $kHICommandMinimizeWindow :|mini|)
(defconstant $kHICommandMinimizeAll :|mina|)
(defconstant $kHICommandMaximizeWindow :|maxi|)
(defconstant $kHICommandMaximizeAll :|maxa|)
(defconstant $kHICommandArrangeInFront :|frnt|)
(defconstant $kHICommandBringAllToFront :|bfrt|)
(defconstant $kHICommandWindowListSeparator :|wldv|)
(defconstant $kHICommandWindowListTerminator :|wlst|)
(defconstant $kHICommandSelectWindow :|swin|)
(defconstant $kHICommandAbout :|abou|)
(defconstant $kHICommandNew :|new |)
(defconstant $kHICommandOpen :|open|)
(defconstant $kHICommandClose :|clos|)
(defconstant $kHICommandSave :|save|)
(defconstant $kHICommandSaveAs :|svas|)
(defconstant $kHICommandRevert :|rvrt|)
(defconstant $kHICommandPrint :|prnt|)
(defconstant $kHICommandPageSetup :|page|)
(defconstant $kHICommandAppHelp :|ahlp|)

(defconstant $kHICommandFromMenu #x1)

(def-mactype :hicommandptr (find-mactype '(:pointer :hicommand)))
(defrecord HICommand 
   (attributes :unsigned-long)
   (commandID :unsigned-long)
   (MenuRef (:handle :menuinfo))
   (MenuItemIndex :unsigned-integer)
   )

; 		
; 	  Control Events                                                                      	
; 		

; 
; 	 *  Summary:
; 	 *    Control events (kEventClassControl)
; 	 	

(defconstant $kEventControlInitialize 1000)
(defconstant $kEventControlDispose 1001)
(defconstant $kEventControlGetOptimalBounds 1003)
(defconstant $kEventControlDefInitialize 1000)
(defconstant $kEventControlDefDispose 1001)
(defconstant $kEventControlHit 1)
(defconstant $kEventControlSimulateHit 2)
(defconstant $kEventControlHitTest 3)
(defconstant $kEventControlDraw 4)
(defconstant $kEventControlApplyBackground 5)
(defconstant $kEventControlApplyTextColor 6)
(defconstant $kEventControlSetFocusPart 7)
(defconstant $kEventControlGetFocusPart 8)
(defconstant $kEventControlActivate 9)
(defconstant $kEventControlDeactivate 10)
(defconstant $kEventControlSetCursor 11)
(defconstant $kEventControlContextualMenuClick 12)
(defconstant $kEventControlClick 13)
(defconstant $kEventControlTrack 51)
(defconstant $kEventControlGetScrollToHereStartPoint 52)
(defconstant $kEventControlGetIndicatorDragConstraint 53)
(defconstant $kEventControlIndicatorMoved 54)
(defconstant $kEventControlGhostingFinished 55)
(defconstant $kEventControlGetActionProcPart 56)
(defconstant $kEventControlGetPartRegion 101)
(defconstant $kEventControlGetPartBounds 102)
(defconstant $kEventControlSetData 103)
(defconstant $kEventControlGetData 104)
(defconstant $kEventControlValueFieldChanged 151)
(defconstant $kEventControlAddedSubControl 152)
(defconstant $kEventControlRemovingSubControl 153)
(defconstant $kEventControlBoundsChanged 154)
(defconstant $kEventControlOwningWindowChanged 159)
(defconstant $kEventControlArbitraryMessage 201)

; 
; 	 *  Summary:
; 	 *    Control bounds change event attributes
; 	 *  
; 	 *  Discussion:
; 	 *    When the toolbox sends out a kEventControlBoundsChanged event, it
; 	 *    also sends along a parameter containing attributes of the event.
; 	 *    These attributes can be used to determine what aspect of the
; 	 *    control changed (position, size, or both).
; 	 	
(defconstant $kControlBoundsChangeSizeChanged #x4)
(defconstant $kControlBoundsChangePositionChanged #x8)

; 	
; 	    Parameters for control events:
; 	
; 	    kEventControlInitialize
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamInitCollection   typeCollection
; 	        <--     kEventParamControlFeatures  typeUInt32
; 	        
; 	    kEventControlDispose
; 	        -->     kEventParamDirectObject     typeControlRef
; 	
; 	    kEventControlGetOptimalBounds
; 	        Required parameters:
; 	        -->     kEventParamDirectObject                     typeControlRef
; 	        <--     kEventParamControlOptimalBounds             typeQDRectangle
; 	        
; 	        Optional parameters:
; 	        <--     kEventParamControlOptimalBaselineOffset     typeShortInteger (optional)
; 	        
; 	    kEventControlHit
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamControlPart      typeControlPartCode
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	
; 	    kEventControlSimulateHit
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        
; 	    kEventControlHitTest
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	        <--     kEventParamControlPart      typeControlPartCode
; 	        
; 	    kEventControlDraw
; 	        Required parameters:
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        
; 	        Optional parameters:
; 	        -->     kEventParamControlPart      typeControlPartCode
; 	                    (draw the entire control if kEventParamControlPart is not present)
; 	        -->     kEventParamGrafPort         typeGrafPtr
; 	                    (draw into the current port if kEventParamGrafPort is not present)
; 	
; 	    kEventControlApplyBackground
; 	        Required parameters:
; 	        -->     kEventParamDirectObject         typeControlRef
; 	        -->     kEventParamControlSubControl    typeControlRef
; 	        -->     kEventParamControlDrawDepth     typeShortInteger
; 	        -->     kEventParamControlDrawInColor   typeBoolean
; 	        
; 	        Optional parameters:
; 	        -->     kEventParamGrafPort             typeGrafPtr
; 	                    (apply to the current port if kEventParamGrafPort is not present)
; 	
; 	    kEventControlApplyTextColor
; 	        Required parameters:
; 	        -->     kEventParamDirectObject         typeControlRef
; 	        -->     kEventParamControlSubControl    typeControlRef
; 	        -->     kEventParamControlDrawDepth     typeShortInteger
; 	        -->     kEventParamControlDrawInColor   typeBoolean
; 	        
; 	        Optional parameters:
; 	        -->     kEventParamCGContextRef         typeCGContextRef
; 	        -->     kEventParamGrafPort             typeGrafPtr
; 	                    (apply to the current port if kEventParamGrafPort is not present)
; 	
; 	    kEventControlSetFocusPart
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        <->     kEventParamControlPart      typeControlPartCode
; 	
; 	    kEventControlGetFocusPart
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        <--     kEventParamControlPart      typeControlPartCode
; 	
; 	    kEventControlActivate
; 	        -->     kEventParamDirectObject     typeControlRef
; 	
; 	    kEventControlDeactivate
; 	        -->     kEventParamDirectObject     typeControlRef
; 	
; 	    kEventControlSetCursor
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	        -->     kEventParamKeyModifiers     typeUInt32
; 	
; 	    kEventControlContextualMenuClick
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	
; 	    kEventControlClick
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     [other parameters from kEventMouseDown]
; 	
; 	    kEventControlTrack
; 	        -->     kEventParamDirectObject     typeControlRef
; 	        -->     kEventParamMouseLocation    typeQDPoint
; 	    
; 		
; 	  Tablet Events (and tablet data in mouse events)                                     	
; 		

; 
; 	 *  Summary:
; 	 *    Tablet events (kEventClassTablet)
; 	 	
(defconstant $kEventTabletPoint 1)
(defconstant $kEventTabletProximity 2)
(defconstant $kEventTabletPointer 1)            ;   deprecated form for compatibility only, use kEventTabletPoint 

(def-mactype :tabletpointrecptr (find-mactype '(:pointer :tabletpointrec)))
(defrecord TabletPointRec 
   (absX :signed-long)                          ;   absolute x coordinate in tablet space at full tablet resolution  
   (absY :signed-long)                          ;   absolute y coordinate in tablet space at full tablet resolution  
   (absZ :signed-long)                          ;   absolute z coordinate in tablet space at full tablet resolution  
   (buttons :unsigned-integer)                  ;   one bit per button - bit 0 is first button - 1 = closed  
   (pressure :unsigned-integer)                 ;   scaled pressure value; MAXPRESSURE=(2^16)-1, MINPRESSURE=0  
   (tiltX :signed-integer)                      ;   scaled tilt x value; range is -((2^15)-1) to (2^15)-1 (-32767 to 32767)  
   (tiltY :signed-integer)                      ;   scaled tilt y value; range is -((2^15)-1) to (2^15)-1 (-32767 to 32767)  
   (rotation :unsigned-integer)                 ;   Fixed-point representation of device rotation in a 10.6 format  
   (tangentialPressure :signed-integer)         ;   tangential pressure on the device; range same as tilt  
   (deviceID :unsigned-integer)                 ;   system-assigned unique device ID - matches to deviceID field in proximity event  
   (vendor1 :signed-integer)                    ;   vendor-defined signed 16-bit integer  
   (vendor2 :signed-integer)                    ;   vendor-defined signed 16-bit integer  
   (vendor3 :signed-integer)                    ;   vendor-defined signed 16-bit integer  
   )

(%define-record :tabletpointerrec (find-record-descriptor :tabletpointrec))
(def-mactype :tabletpointerrecptr (find-mactype '(:pointer :tabletpointrec)))
(def-mactype :tabletproximityrecptr (find-mactype '(:pointer :tabletproximityrec)))
(defrecord TabletProximityRec 
   (vendorID :unsigned-integer)                 ;   vendor-defined ID - typically will be USB vendor ID  
   (tabletID :unsigned-integer)                 ;   vendor-defined tablet ID - typically will be USB product ID for the tablet  
   (pointerID :unsigned-integer)                ;   vendor-defined ID of the specific pointing device  
   (deviceID :unsigned-integer)                 ;   system-assigned unique device ID - matches to deviceID field in tablet event  
   (systemTabletID :unsigned-integer)           ;   system-assigned unique tablet ID  
   (vendorPointerType :unsigned-integer)        ;   vendor-defined pointer type  
   (pointerSerialNumber :unsigned-long)         ;   vendor-defined serial number of the specific pointing device  
   (uniqueID :unsignedwide)                     ;   vendor-defined unique ID for this pointer  
   (capabilityMask :unsigned-long)              ;   mask representing the capabilities of the device  
   (pointerType :signed-byte)                   ;   type of pointing device - enum to be defined  
   (enterProximity :signed-byte)                ;   non-zero = entering; zero = leaving  
   )

; 		
; 	 Volume Events                                                                        	
; 		

; 
; 	 *  Summary:
; 	 *    Volume events (kEventClassVolume)
; 	 	

(defconstant $kEventVolumeMounted 1)            ;   new volume mounted 
(defconstant $kEventVolumeUnmounted 2)          ;   volume has been ejected or unmounted 

; 	
; 	    Parameters for volume events:
; 	
; 	    kEventVolumeMounted
; 	        -->     kEventParamDirectObject     typeFSVolumeRefNum
; 	    
; 	    kEventVolumeUnmounted
; 	        -->     kEventParamDirectObject     typeFSVolumeRefNum
; 		

;   types for volume events 

(defconstant $typeFSVolumeRefNum :|voln|)       ;   FSVolumeRefNum 

; 		
; 	 Appearance Events                                                                    	
; 		
; 	 Appearance Events 	

; 
; 	 *  Discussion:
; 	 *    Appearance events (kEventClassAppearance)
; 	 	
(defconstant $kEventAppearanceScrollBarVariantChanged 1)

; 	
; 	    Parameters for appearance events:
; 	
; 	    kEventAppearanceScrollBarVariantChanged
; 	        -->     kEventParamNewScrollBarVariant      typeShortInteger
; 		
; 		
; 	  Services Events                                                                     	
; 		

; 
; 	 *  Summary:
; 	 *    Services events (kEventClassService)
; 	 *  
; 	 *  Discussion:
; 	 *    Services are a feature by which applications can communicate with
; 	 *    one another to request and provide services. This communication
; 	 *    happens through the Scrap Manager. When an event is sent that
; 	 *    requires communication for processing or servicing a request, you
; 	 *    will need to use the scrap that is given in the
; 	 *    kEventParamScrapRef parameter of the event in order to
; 	 *    communicate. When your app requests a service, it is usually
; 	 *    acting on data that is currently selected or in focus. Therefore
; 	 *    all of the Services events are sent to the UserFocus event
; 	 *    target. Service events are available on Mac OS X 10.1 and later.
; 	 	
(defconstant $kEventServiceCopy 1)
(defconstant $kEventServicePaste 2)
(defconstant $kEventServiceGetTypes 3)
(defconstant $kEventServicePerform 4)

; 	
; 	    Parameters for service events:
; 	    
; 	    kEventServiceCopy
; 	        -->     kEventParamScrapRef                 typeScrapRef
; 	    
; 	    kEventServicePaste
; 	        -->     kEventParamScrapRef                 typeScrapRef
; 	        
; 	    kEventServiceGetTypes
; 	        -->     kEventParamServiceCopyTypes         typeCFMutableArrayRef of CFStringRefs
; 	        -->     kEventParamServicePasteTypes        typeCFMutableArrayRef of CFStringRefs
; 	        
; 	    kEventServicePerform
; 	        -->     kEventParamScrapRef                 typeScrapRef
; 	        -->     kEventParamServiceMessageName       typeCFStringRef
; 	        -->     kEventParamServiceUserData          typeCFStringRef
; 		
; 
; 	 *  CreateTypeStringWithOSType()
; 	 *  
; 	 *  Discussion:
; 	 *    This routine is used to convert an OSType to a CFStringRef that
; 	 *    Services will understand.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inType:
; 	 *      The OSType that needs to be converted to a CFString.
; 	 *  
; 	 *  Result:
; 	 *    A CFStringRef that contains the string that corresponds to the
; 	 *    given OSType. This follows CoreFoundation semantics in that it
; 	 *    will return NULL for failure, and because it is a "Create"
; 	 *    function you will need to CFRelease() this string when it is no
; 	 *    longer needed.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
; 	 *    Mac OS X:         in version 10.1 and later
; 	 	
; ;  Parameter names and types                                                            ; 
(deftrap-inline "_CreateTypeStringWithOSType" 
      ((inType :ostype)) 
  :pointer
   () )
(defconstant $kEventParamDirectObject :|----|)  ;   type varies depending on event 

;   Generic toolbox parameters and types 

(defconstant $kEventParamWindowRef :|wind|)     ;   typeWindowRef 
(defconstant $kEventParamGrafPort :|graf|)      ;   typeGrafPtr 
(defconstant $kEventParamDragRef :|drag|)       ;   typeDragRef 
(defconstant $kEventParamMenuRef :|menu|)       ;   typeMenuRef 
(defconstant $kEventParamEventRef :|evnt|)      ;   typeEventRef 
(defconstant $kEventParamControlRef :|ctrl|)    ;   typeControlRef 
(defconstant $kEventParamRgnHandle :|rgnh|)     ;   typeQDRgnHandle 
(defconstant $kEventParamEnabled :|enab|)       ;   typeBoolean 
(defconstant $kEventParamDimensions :|dims|)    ;   typeQDPoint 
(defconstant $kEventParamAvailableBounds :|avlb|);   typeQDRectangle 
(defconstant $kEventParamAEEventID :|evti|)     ;   typeType 
(defconstant $kEventParamAEEventClass :|evcl|)  ;   typeType 
(defconstant $kEventParamCGContextRef :|cntx|)  ;   typeCGContextRef 
(defconstant $kEventParamDeviceDepth :|devd|)   ;   typeShortInteger 
(defconstant $kEventParamDeviceColor :|devc|)   ;   typeBoolean 
(defconstant $typeWindowRef :|wind|)            ;   WindowRef 
(defconstant $typeGrafPtr :|graf|)              ;   CGrafPtr 
(defconstant $typeGWorldPtr :|gwld|)            ;   GWorldPtr 
(defconstant $typeDragRef :|drag|)              ;   DragRef 
(defconstant $typeMenuRef :|menu|)              ;   MenuRef 
(defconstant $typeControlRef :|ctrl|)           ;   ControlRef 
(defconstant $typeCollection :|cltn|)           ;   Collection 
(defconstant $typeQDRgnHandle :|rgnh|)          ;   RgnHandle 
(defconstant $typeOSStatus :|osst|)             ;   OSStatus 
(defconstant $typeCFStringRef :|cfst|)          ;   CFStringRef 
(defconstant $typeCGContextRef :|cntx|)         ;   CGContextRef 
(defconstant $typeHIPoint :|hipt|)              ;   HIPoint 

;   Mouse event parameters and types 

(defconstant $kEventParamMouseLocation :|mloc|) ;   typeQDPoint 
(defconstant $kEventParamMouseButton :|mbtn|)   ;   typeMouseButton 
(defconstant $kEventParamClickCount :|ccnt|)    ;   typeUInt32 
(defconstant $kEventParamMouseWheelAxis :|mwax|);   typeMouseWheelAxis 
(defconstant $kEventParamMouseWheelDelta :|mwdl|);   typeSInt32 
(defconstant $kEventParamMouseDelta :|mdta|)    ;   typeQDPoint 
(defconstant $kEventParamMouseChord :|chor|)    ;   typeUInt32 
(defconstant $kEventParamTabletEventType :|tblt|);   typeUInt32 
(defconstant $typeMouseButton :|mbtn|)          ;   EventMouseButton 
(defconstant $typeMouseWheelAxis :|mwax|)       ;   EventMouseWheelAxis 

;   Keyboard event parameter and types 

(defconstant $kEventParamKeyCode :|kcod|)       ;   typeUInt32 
(defconstant $kEventParamKeyMacCharCodes :|kchr|);   typeChar 
(defconstant $kEventParamKeyModifiers :|kmod|)  ;   typeUInt32 
(defconstant $kEventParamKeyUnicodes :|kuni|)   ;   typeUnicodeText 
(defconstant $kEventParamKeyboardType :|kbdt|)  ;   typeUInt32 
(defconstant $typeEventHotKeyID :|hkid|)        ;   EventHotKeyID 

;   TextInput event parameters 

(defconstant $kEventParamTextInputSendRefCon :|tsrc|);      typeLongInteger 
(defconstant $kEventParamTextInputSendComponentInstance :|tsci|);      typeComponentInstance 
(defconstant $kEventParamTextInputSendSLRec :|tssl|);      typeIntlWritingCode 
(defconstant $kEventParamTextInputReplySLRec :|trsl|);      typeIntlWritingCode 
(defconstant $kEventParamTextInputSendText :|tstx|);      typeUnicodeText (if TSMDocument is Unicode), otherwise typeChar 
(defconstant $kEventParamTextInputReplyText :|trtx|);      typeUnicodeText (if TSMDocument is Unicode), otherwise typeChar 
(defconstant $kEventParamTextInputSendUpdateRng :|tsup|);      typeTextRangeArray 
(defconstant $kEventParamTextInputSendHiliteRng :|tshi|);      typeTextRangeArray 
(defconstant $kEventParamTextInputSendClauseRng :|tscl|);      typeOffsetArray 
(defconstant $kEventParamTextInputSendPinRng :|tspn|);      typeTextRange 
(defconstant $kEventParamTextInputSendFixLen :|tsfx|);      typeLongInteger 
(defconstant $kEventParamTextInputSendLeadingEdge :|tsle|);      typeBoolean 
(defconstant $kEventParamTextInputReplyLeadingEdge :|trle|);      typeBoolean 
(defconstant $kEventParamTextInputSendTextOffset :|tsto|);      typeLongInteger 
(defconstant $kEventParamTextInputReplyTextOffset :|trto|);      typeLongInteger 
(defconstant $kEventParamTextInputReplyRegionClass :|trrg|);      typeLongInteger 
(defconstant $kEventParamTextInputSendCurrentPoint :|tscp|);      typeQDPoint 
(defconstant $kEventParamTextInputSendDraggingMode :|tsdm|);      typeBoolean 
(defconstant $kEventParamTextInputReplyPoint :|trpt|);      typeQDPoint 
(defconstant $kEventParamTextInputReplyFont :|trft|);      typeLongInteger 
(defconstant $kEventParamTextInputReplyFMFont :|trfm|);      typeUInt32 
(defconstant $kEventParamTextInputReplyPointSize :|trpz|);      typeFixed 
(defconstant $kEventParamTextInputReplyLineHeight :|trlh|);      typeShortInteger 
(defconstant $kEventParamTextInputReplyLineAscent :|trla|);      typeShortInteger 
(defconstant $kEventParamTextInputReplyTextAngle :|trta|);      typeFixed 
(defconstant $kEventParamTextInputSendShowHide :|tssh|);      typeBoolean 
(defconstant $kEventParamTextInputReplyShowHide :|trsh|);      typeBoolean 
(defconstant $kEventParamTextInputSendKeyboardEvent :|tske|);      typeEventRef 
(defconstant $kEventParamTextInputSendTextServiceEncoding :|tsse|);      typeUInt32 
(defconstant $kEventParamTextInputSendTextServiceMacEncoding :|tssm|);      typeUInt32 

;   Command event parameters and types 

(defconstant $kEventParamHICommand :|hcmd|)     ;   typeHICommand 
(defconstant $typeHICommand :|hcmd|)            ;   HICommand 

;   Window event parameters and types 

(defconstant $kEventParamWindowFeatures :|wftr|);   typeUInt32 
(defconstant $kEventParamWindowDefPart :|wdpc|) ;   typeWindowDefPartCode 
(defconstant $kEventParamCurrentBounds :|crct|) ;   typeQDRectangle 
(defconstant $kEventParamOriginalBounds :|orct|);   typeQDRectangle 
(defconstant $kEventParamPreviousBounds :|prct|);   typeQDRectangle 
(defconstant $kEventParamClickActivation :|clac|);   typeClickActivationResult 
(defconstant $kEventParamWindowRegionCode :|wshp|);   typeWindowRegionCode 
(defconstant $kEventParamWindowDragHiliteFlag :|wdhf|);   typeBoolean 
(defconstant $kEventParamWindowModifiedFlag :|wmff|);   typeBoolean 
(defconstant $kEventParamWindowProxyGWorldPtr :|wpgw|);   typeGWorldPtr 
(defconstant $kEventParamWindowProxyImageRgn :|wpir|);   typeQDRgnHandle 
(defconstant $kEventParamWindowProxyOutlineRgn :|wpor|);   typeQDRgnHandle 
(defconstant $kEventParamWindowStateChangedFlags :|wscf|);   typeUInt32  
(defconstant $kEventParamWindowTitleFullWidth :|wtfw|);   typeSInt16 
(defconstant $kEventParamWindowTitleTextWidth :|wttw|);   typeSInt16 
(defconstant $kEventParamWindowGrowRect :|grct|);   typeQDRectangle 
(defconstant $kEventParamAttributes :|attr|)    ;   typeUInt32 
(defconstant $typeWindowRegionCode :|wshp|)     ;   WindowRegionCode 
(defconstant $typeWindowDefPartCode :|wdpt|)    ;   WindowDefPartCode 
(defconstant $typeClickActivationResult :|clac|);   ClickActivationResult 

;   Control event parameters and types 

(defconstant $kEventParamControlPart :|cprt|)   ;   typeControlPartCode 
(defconstant $kEventParamInitCollection :|icol|);   typeCollection 
(defconstant $kEventParamControlMessage :|cmsg|);   typeShortInteger 
(defconstant $kEventParamControlParam :|cprm|)  ;   typeLongInteger 
(defconstant $kEventParamControlResult :|crsl|) ;   typeLongInteger 
(defconstant $kEventParamControlRegion :|crgn|) ;   typeQDRgnHandle 
(defconstant $kEventParamControlAction :|caup|) ;   typeControlActionUPP 
(defconstant $kEventParamControlIndicatorDragConstraint :|cidc|);   typeIndicatorDragConstraint 
(defconstant $kEventParamControlIndicatorRegion :|cirn|);   typeQDRgnHandle 
(defconstant $kEventParamControlIsGhosting :|cgst|);   typeBoolean 
(defconstant $kEventParamControlIndicatorOffset :|ciof|);   typeQDPoint 
(defconstant $kEventParamControlClickActivationResult :|ccar|);   typeClickActivationResult 
(defconstant $kEventParamControlSubControl :|csub|);   typeControlRef 
(defconstant $kEventParamControlOptimalBounds :|cobn|);   typeQDRectangle 
(defconstant $kEventParamControlOptimalBaselineOffset :|cobo|);   typeShortInteger 
(defconstant $kEventParamControlDataTag :|cdtg|);   typeEnumeration 
(defconstant $kEventParamControlDataBuffer :|cdbf|);   typePtr 
(defconstant $kEventParamControlDataBufferSize :|cdbs|);   typeLongInteger 
(defconstant $kEventParamControlDrawDepth :|cddp|);   typeShortInteger 
(defconstant $kEventParamControlDrawInColor :|cdic|);   typeBoolean 
(defconstant $kEventParamControlFeatures :|cftr|);   typeUInt32 
(defconstant $kEventParamControlPartBounds :|cpbd|);   typeQDRectangle 
(defconstant $kEventParamControlOriginalOwningWindow :|coow|);   typeWindowRef 
(defconstant $kEventParamControlCurrentOwningWindow :|ccow|);   typeWindowRef 
(defconstant $typeControlActionUPP :|caup|)     ;   ControlActionUPP 
(defconstant $typeIndicatorDragConstraint :|cidc|);   IndicatorDragConstraint 
(defconstant $typeControlPartCode :|cprt|)      ;   ControlPartCode 

;   Menu event parameters and types 

(defconstant $kEventParamCurrentMenuTrackingMode :|cmtm|);   typeMenuTrackingMode 
(defconstant $kEventParamNewMenuTrackingMode :|nmtm|);   typeMenuTrackingMode 
(defconstant $kEventParamMenuFirstOpen :|1sto|) ;   typeBoolean 
(defconstant $kEventParamMenuItemIndex :|item|) ;   typeMenuItemIndex 
(defconstant $kEventParamMenuCommand :|mcmd|)   ;   typeMenuCommand 
(defconstant $kEventParamEnableMenuForKeyEvent :|fork|);   typeBoolean 
(defconstant $kEventParamMenuEventOptions :|meop|);   typeMenuEventOptions 
(defconstant $kEventParamMenuContext :|mctx|)   ;   typeUInt32 
(defconstant $kEventParamMenuItemBounds :|mitb|);   typeQDRectangle 
(defconstant $kEventParamMenuMarkBounds :|mmkb|);   typeQDRectangle 
(defconstant $kEventParamMenuIconBounds :|micb|);   typeQDRectangle 
(defconstant $kEventParamMenuTextBounds :|mtxb|);   typeQDRectangle 
(defconstant $kEventParamMenuTextBaseline :|mtbl|);   typeShortInteger 
(defconstant $kEventParamMenuCommandKeyBounds :|mcmb|);   typeQDRectangle 
(defconstant $kEventParamMenuVirtualTop :|mvrt|);   typeLongInteger 
(defconstant $kEventParamMenuVirtualBottom :|mvrb|);   typeLongInteger 
(defconstant $kEventParamMenuDrawState :|mdrs|) ;   typeThemeDrawState 
(defconstant $kEventParamMenuItemType :|mitp|)  ;   typeThemeMenuItemType 
(defconstant $kEventParamMenuItemWidth :|mitw|) ;   typeShortInteger 
(defconstant $kEventParamMenuItemHeight :|mith|);   typeShortInteger 
(defconstant $typeMenuItemIndex :|midx|)        ;   MenuItemIndex 
(defconstant $typeMenuCommand :|mcmd|)          ;   MenuCommand 
(defconstant $typeMenuTrackingMode :|mtmd|)     ;   MenuTrackingMode 
(defconstant $typeMenuEventOptions :|meop|)     ;   MenuEventOptions 
(defconstant $typeThemeMenuState :|tmns|)       ;   ThemeMenuState 
(defconstant $typeThemeMenuItemType :|tmit|)    ;   ThemeMenuItemType 

;   Application event parameters 

(defconstant $kEventParamProcessID :|psn |)     ;   typeProcessSerialNumber 
(defconstant $kEventParamLaunchRefCon :|lref|)  ;   typeUInt32 
(defconstant $kEventParamLaunchErr :|err |)     ;   typeOSStatus 

;   Tablet event parameters and types 

(defconstant $kEventParamTabletPointRec :|tbrc|);   typeTabletPointRec 
(defconstant $kEventParamTabletProximityRec :|tbpx|);   typeTabletProximityRec 
(defconstant $typeTabletPointRec :|tbrc|)       ;   kEventParamTabletPointRec 
(defconstant $typeTabletProximityRec :|tbpx|)   ;   kEventParamTabletProximityRec 
(defconstant $kEventParamTabletPointerRec :|tbrc|);   typeTabletPointerRec      -- deprecated, for compatibility only 
(defconstant $typeTabletPointerRec :|tbrc|)     ;   kEventParamTabletPointerRec    -- deprecated, for compatibility only 

;   Appearance event parameters 

(defconstant $kEventParamNewScrollBarVariant :|nsbv|);   typeShortInteger 

;   Service event parameters 

(defconstant $kEventParamScrapRef :|scrp|)      ;      typeScrapRef 
(defconstant $kEventParamServiceCopyTypes :|svsd|);      typeCFMutableArrayRef 
(defconstant $kEventParamServicePasteTypes :|svpt|);      typeCFMutableArrayRef 
(defconstant $kEventParamServiceMessageName :|svmg|);      typeCFStringRef 
(defconstant $kEventParamServiceUserData :|svud|);      typeCFStringRef 
(defconstant $typeScrapRef :|scrp|)             ;      ScrapRef 
(defconstant $typeCFMutableArrayRef :|cfma|)    ;      CFMutableArrayRef 

; 	======================================================================================	
; 	  EVENT HANDLERS                                                                      	
; 	======================================================================================	

(def-mactype :eventhandlerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventhandlerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventHandlerRef parameter can be nil, it is changed to xx: EventHandlerRefPtr 
(def-mactype :eventhandlercallref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventhandlercallrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventHandlerCallRef parameter can be nil, it is changed to xx: EventHandlerCallRefPtr 

; 		
; 	   EventHandler specification                                                        	
; 		

; 
; 	 *  EventHandlerProcPtr
; 	 *  
; 	 *  Discussion:
; 	 *    Callback for receiving events sent to a target this callback is
; 	 *    installed on.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inHandlerCallRef:
; 	 *      A reference to the current handler call chain. This is sent to
; 	 *      your handler so that you can call CallNextEventHandler if you
; 	 *      need to.
; 	 *    
; 	 *    inEvent:
; 	 *      The Event.
; 	 *    
; 	 *    inUserData:
; 	 *      The app-specified data you passed in a call to
; 	 *      InstallEventHandler.
; 	 *  
; 	 *  Result:
; 	 *    An operating system result code. Returning noErr indicates you
; 	 *    handled the event. Returning eventNotHandledErr indicates you did
; 	 *    not handle the event and perhaps the toolbox should take other
; 	 *    action.
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EventHandlerProcPtr = FUNCTION(inHandlerCallRef: EventHandlerCallRef; inEvent: EventRef; inUserData: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :eventhandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :eventhandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :eventhandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppEventHandlerProcInfo #xFF0)
; 
; 	 *  NewEventHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewEventHandlerProc 
(deftrap "_NewEventHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeEventHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeEventHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeEventHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallEventHandlerProc 
(deftrap-inline "_InvokeEventHandlerUPP" 
      ((inHandlerCallRef :pointer) (inEvent :pointer) (inUserData :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;    Installing Event Handlers                                                         
;                                                                                       
;  Use these routines to install event handlers for a specific toolbox object. You may  
;  pass zero for inNumTypes and NULL for inList if you need to be in a situation where  
;  you know you will be receiving events, but not exactly which ones at the time you    
;  are installing the handler. Later, your application can call the Add/Remove routines 
;  listed below this section.                                                           
;                                                                                       
;  You can only install a specific handler once. The combination of inHandler and       
;  inUserData is considered the 'signature' of a handler. Any attempt to install a new  
;  handler with the same proc and user data as an already-installed handler will result 
;  in eventHandlerAlreadyInstalledErr. Installing the same proc and user data on a      
;  different object is legal.                                                           
;                                                                                       
;  Upon successful completion of this routine, you are returned an EventHandlerRef,     
;  which you can use in various other calls, and is passed to your event handler. You   
;  use it to extract information about the handler, such as the target (window, etc.)   
;  if you have the same handler installed for different objects and need to perform     
;  actions on the current target (say, call a window manager function).                 
; 

(def-mactype :eventtargetref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventtargetrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventTargetRef parameter can be nil, it is changed to xx: EventTargetRefPtr 
; 
; 	 *  GetWindowEventTarget()
; 	 *  
; 	 *  Discussion:
; 	 *    Returns the EventTargetRef for the specified window. Once you
; 	 *    obtain this reference, you can send events to the target and
; 	 *    install an event handler on it.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inWindow:
; 	 *      The window to return the target for.
; 	 *  
; 	 *  Result:
; 	 *    An EventTargetRef.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetControlEventTarget()
;  *  
;  *  Discussion:
;  *    Returns the EventTargetRef for the specified control. Once you
;  *    obtain this reference, you can send events to the target and
;  *    install event handler on it.
;  *  
;  *  Parameters:
;  *    
;  *    inControl:
;  *      The control to return the target for.
;  *  
;  *  Result:
;  *    An EventTargetRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowEventTarget" 
      ((inWindow (:pointer :windowrecord))) 
  :pointer
   () )                                         ; 
;  *  GetMenuEventTarget()
;  *  
;  *  Discussion:
;  *    Returns the EventTargetRef for the specified menu. Once you
;  *    obtain this reference, you can send events to the target and
;  *    install event handler on it.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu to return the target for.
;  *  
;  *  Result:
;  *    An EventTargetRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlEventTarget" 
      ((inControl (:handle :controlrecord))) 
  :pointer
   () )                                         ; 
;  *  GetApplicationEventTarget()
;  *  
;  *  Discussion:
;  *    Returns the EventTargetRef for the application. Once you obtain
;  *    this reference, you can send events to the target and install
;  *    event handler on it.
;  *  
;  *  Result:
;  *    An EventTargetRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuEventTarget" 
      ((inMenu (:handle :menuinfo))) 
  :pointer
   () )                                         ; 
;  *  GetUserFocusEventTarget()
;  *  
;  *  Discussion:
;  *    Returns the EventTargetRef for the current user focus at the time
;  *    of the call. Keyboard events are always sent to this target.
;  *  
;  *  Result:
;  *    An EventTargetRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetApplicationEventTarget" 
      () 
  :pointer
   () )                                         ; 
;  *  GetEventDispatcherTarget()
;  *  
;  *  Discussion:
;  *    Returns the EventTargetRef for the standard toolbox dispatcher.
;  *    You typically would never need to use this, but there are some
;  *    exotic apps that need to pick events off the event queue and call
;  *    the dispatcher themselves. This allows you to do just that
;  *    instead of calling RunApplicationEventLoop to handle it all.
;  *  
;  *  Result:
;  *    An EventTargetRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetUserFocusEventTarget" 
      () 
  :pointer
   () )
(deftrap-inline "_GetEventDispatcherTarget" 
      () 
  :pointer
   () )

; 
;  *  InstallEventHandler()
;  *  
;  *  Discussion:
;  *    Installs an event handler on a specified target. Your handler
;  *    proc will be called with the events you registered with when an
;  *    event of the corresponding type and class are send to the target
;  *    you are installing your handler on.
;  *  
;  *  Parameters:
;  *    
;  *    inTarget:
;  *      The target to register your handler with.
;  *    
;  *    inHandler:
;  *      A pointer to your handler function.
;  *    
;  *    inNumTypes:
;  *      The number of events you are registering for.
;  *    
;  *    inList:
;  *      A pointer to an array of EventTypeSpec entries representing the
;  *      events you are interested in.
;  *    
;  *    inUserData:
;  *      The value passed in this parameter is passed on to your event
;  *      handler proc when it is called.
;  *    
;  *    outRef:
;  *      Receives an EventHandlerRef, which you can use later to remove
;  *      the handler. You can pass null if you don't want the reference
;  *      - when the target is disposed, the handler will be disposed as
;  *      well.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  InstallStandardEventHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InstallEventHandler" 
      ((inTarget :pointer) (inHandler :pointer) (inNumTypes :unsigned-long) (inList (:pointer :eventtypespec)) (inUserData :pointer) (outRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  RemoveEventHandler()
;  *  
;  *  Discussion:
;  *    Removes an event handler from the target it was bound to.
;  *  
;  *  Parameters:
;  *    
;  *    inHandlerRef:
;  *      The handler ref to remove (returned in a call to
;  *      InstallEventHandler). After you call this function, the handler
;  *      ref is considered to be invalid and can no longer be used.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InstallStandardEventHandler" 
      ((inTarget :pointer)) 
  :osstatus
   () )                                         ; ;    Adjusting set of event types after a handler is created                           ;                                                                                       ;  After installing a handler with the routine above, you can adjust the event type     ;  list telling the toolbox what events to send to that handler by calling the two      ;  routines below. If you add an event type twice for the same handler, your handler    ;  will only be called once, but it will take two RemoveEventType calls to stop your    ;  handler from being called with that event type. In other words, the install count    ;  for each event type is maintained by the toolbox. This might allow you, for example  ;  to have subclasses of a window object register for types without caring if the base  ;  class has already registered for that type. When the subclass removes its types, it  ;  can successfully do so without affecting the base class's reception of its event     ;  types, yielding eternal bliss.                                                       ; ; 
;  *  AddEventTypesToHandler()
;  *  
;  *  Discussion:
;  *    Adds additional events to an event handler that has already been
;  *    installed.
;  *  
;  *  Parameters:
;  *    
;  *    inHandlerRef:
;  *      The event handler to add the additional events to.
;  *    
;  *    inNumTypes:
;  *      The number of events to add.
;  *    
;  *    inList:
;  *      A pointer to an array of EventTypeSpec entries.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveEventHandler" 
      ((inHandlerRef :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  RemoveEventTypesFromHandler()
;  *  
;  *  Discussion:
;  *    Removes events from an event handler that has already been
;  *    installed.
;  *  
;  *  Parameters:
;  *    
;  *    inHandlerRef:
;  *      The event handler to remove the events from.
;  *    
;  *    inNumTypes:
;  *      The number of events to remove.
;  *    
;  *    inList:
;  *      A pointer to an array of EventTypeSpec entries.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AddEventTypesToHandler" 
      ((inHandlerRef :pointer) (inNumTypes :unsigned-long) (inList (:pointer :eventtypespec))) 
  :osstatus
   () )                                         ; CONST; ;    Explicit Propogation                                                              ;                                                                                       ;   CallNextEventHandler can be used to call thru to all handlers below the current     ;   handler being called. You pass the EventHandlerCallRef passed to your EventHandler  ;   into this call so that we know how to properly forward the event. The result of     ;   this function should normally be the result of your own handler that you called     ;   this API from. The typical use of this routine would be to allow the toolbox to do  ;   its standard processing and then follow up with some type of embellishment.         ; ; 
;  *  CallNextEventHandler()
;  *  
;  *  Discussion:
;  *    Calls thru to the event handlers below you in the event handler
;  *    stack of the target to which your handler is bound. You might use
;  *    this to call thru to the default toolbox handling in order to
;  *    post-process the event. You can only call this routine from
;  *    within an event handler.
;  *  
;  *  Parameters:
;  *    
;  *    inCallRef:
;  *      The event handler call ref passed into your event handler.
;  *    
;  *    inEvent:
;  *      The event to pass thru.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveEventTypesFromHandler" 
      ((inHandlerRef :pointer) (inNumTypes :unsigned-long) (inList (:pointer :eventtypespec))) 
  :osstatus
   () )                                         ; ;    Sending Events                                                                    ; ; 
;  *  SendEventToEventTarget()
;  *  
;  *  Discussion:
;  *    Sends an event to the specified event target.
;  *  
;  *  Parameters:
;  *    
;  *    inEvent:
;  *      The event to send.
;  *    
;  *    inTarget:
;  *      The target to send it to.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CallNextEventHandler" 
      ((inCallRef :pointer) (inEvent :pointer)) 
  :osstatus
   () )                                         ; ======================================================================================;   EVENT-BASED OBJECT CLASSES                                                          ;                                                                                       ;   Here it is - the replacement for classic defprocs. This is also a convenient way    ;   to create toolbox objects (windows, etc.) that have a specific behavior without     ;   installing handlers on each instance of the object. With a toolbox object class,    ;   you register your class, then use special creation routines to create objects of    ;   that class. The event handlers are automatically installed and ready to go.         ; ======================================================================================
(deftrap-inline "_SendEventToEventTarget" 
      ((inEvent :pointer) (inTarget :pointer)) 
  :osstatus
   () )
(def-mactype :toolboxobjectclassref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :toolboxobjectclassrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ToolboxObjectClassRef parameter can be nil, it is changed to xx: ToolboxObjectClassRefPtr 

; 
; 	 *  RegisterToolboxObjectClass()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; 
;  *  UnregisterToolboxObjectClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RegisterToolboxObjectClass" 
      ((inClassID :pointer) (inBaseClass :pointer) (inNumEvents :unsigned-long) (inEventList (:pointer :eventtypespec)) (inEventHandler :pointer) (inEventHandlerData :pointer) (outClassRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; ======================================================================================;    Command Routines                                                                  ; ======================================================================================; 
;  *  ProcessHICommand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_UnregisterToolboxObjectClass" 
      ((inClassRef :pointer)) 
  :osstatus
   () )                                         ; CONST; ;    Event Loop Routines                                                               ; ; 
;  *  RunApplicationEventLoop()
;  *  
;  *  Discussion:
;  *    This routine is used as the main event loop for a Carbon
;  *    Event-based application. Once entered, this function waits for
;  *    events to arrive and dispatches them to your event handlers
;  *    automatically.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ProcessHICommand" 
      ((inCommand (:pointer :hicommand))) 
  :osstatus
   () )                                         ; 
;  *  QuitApplicationEventLoop()
;  *  
;  *  Discussion:
;  *    This routine is used to quit the RunApplicationEventLoop
;  *    function. Typically, your application doesn't need to call this.
;  *    If your application has the Quit menu item tagged with the
;  *    kHICommandQuit Menu Command ID, the toolbox will automatically
;  *    call this for your application, automatically terminating your
;  *    event loop. If your application wants to do pre-processing before
;  *    the event loop exits, it should intercept either the
;  *    kHICommandQuit menu command, or the kEventApplicationQuit event.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RunApplicationEventLoop" 
      () 
  nil
   () )                                         ; ;    Event Modality routines                                                           ; ; 
;  *  RunAppModalLoopForWindow()
;  *  
;  *  Discussion:
;  *    This routine is used as a replacement to ModalDialog to drive a
;  *    Carbon Event-based modal dialog. Once called, this routine will
;  *    not exit until QuitAppModalLoopForWindow is called. In Mac OS X
;  *    10.0.x, RunAppModalLoopForWindow will fail to re-enable the
;  *    menubar before exiting if you dispose of the window during the
;  *    modal loop (for example, from a Carbon event handler). You can
;  *    work around this bug by retaining the window before calling
;  *    RunAppModalLoopForWindow, and releasing it afterwards.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window you wish to behave modally.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_QuitApplicationEventLoop" 
      () 
  nil
   () )
(deftrap-inline "_RunAppModalLoopForWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; 
;  *  QuitAppModalLoopForWindow()
;  *  
;  *  Discussion:
;  *    This routine is used to quit a currently running call to
;  *    RunAppModalLoopForWindow, i.e. it terminates a modal loop.
;  *    Typically this would be called from a handler you have installed
;  *    on the modal window in question when the user clicks the
;  *    appropriate button, etc.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window for which to quit the modal state.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QuitAppModalLoopForWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; 
;  *  BeginAppModalStateForWindow()
;  *  
;  *  Discussion:
;  *    This routine is a lower level routine than
;  *    RunAppModalLoopForWindow. It can be used if you wish to enter an
;  *    app modal state for a window, but need to control the event loop
;  *    yourself for whatever reason. In most cases, you would use
;  *    RunAppModalLoopForWindow. Once you begin your app modal state,
;  *    the menu bar will disable and prepare for the modal situation.
;  *    The window must be visible when calling
;  *    BeginAppModalStateForWindow; otherwise, windowWrongStateErr is
;  *    returned. In Mac OS 10.0.x and CarbonLib 1.3.1,
;  *    BeginAppModalStateForWindow can only be called on a window once;
;  *    future calls will return an error. This bug is fixed in Mac OS
;  *    10.1 and CarbonLib 1.4.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window you wish to behave modally.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BeginAppModalStateForWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; 
;  *  EndAppModalStateForWindow()
;  *  
;  *  Discussion:
;  *    This routine ends an app modal state started with
;  *    BeginAppModalStateForWindow.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window you wish to stop acting as app modal.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_EndAppModalStateForWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; 
;    User Focus                                                                        
;                                                                                       
;  The 'user focus' is where keyboard input goes. We also use the term 'key' applied    
;  to windows to mean this. The user focus window is normally the active non-floating   
;  window or dialog. It is possible to make a floater get the focus, however, by calling
;  SetUserFocusWindow. After that call, the event model will automatically route key    
;  input to the active keyboard focus of that window, if any. Passing kUserFocusAuto    
;  into the window parameter tells the toolbox to pick what it considers to be the best 
;  candidate for focus. You should call this to restore focus, rather than getting the  
;  focus, setting it to a special window, and then restoring to the saved focus. There  
;  are cases, however, when you might want to restore to an explicit window, but the    
;  typical usage should just be to restore to the kUserFocusAuto focus.                 
;                                                                                       
;  Keep in mind that setting the focus will only last until you restore focus, or the   
;  user starts clicking in other windows. When that happens, the toolbox will auto-     
;  redirect the user focus to a newly selected window.                                  
; 

(defconstant $kUserFocusAuto -1)

; 
; 	 *  SetUserFocusWindow()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetUserFocusWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetUserFocusWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; ;    Default/Cancel buttons                                                            ;                                                                                       ;  In our quest to eliminate the need for dialogs when using the new event model, we    ;  have added the following routines which add dialog-like button control to normal     ;  windows. With these routines, you can set the default and cancel buttons for a       ;  window; these work just like the corresponding concepts in dialogs, and when         ;  present, the standard toolbox handlers will handle keyboard input mapping to these   ;  buttons. This means that pressing return or enter will 'press' the default button    ;  and escape or command-period will 'press' the cancel button.                         ; ; 
;  *  SetWindowDefaultButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetUserFocusWindow" 
      () 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  SetWindowCancelButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowDefaultButton" 
      ((inWindow (:pointer :windowrecord)) (inControl (:handle :controlrecord))) 
  :osstatus
   () )                                         ; 
;  *  GetWindowDefaultButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowCancelButton" 
      ((inWindow (:pointer :windowrecord)) (inControl (:handle :controlrecord))) 
  :osstatus
   () )                                         ; 
;  *  GetWindowCancelButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowDefaultButton" 
      ((inWindow (:pointer :windowrecord)) (outControl (:pointer (:handle :controlrecord)))) 
  :osstatus
   () )                                         ; ;    Global HotKey API                                                                 ; 
(deftrap-inline "_GetWindowCancelButton" 
      ((inWindow (:pointer :windowrecord)) (outControl (:pointer (:handle :controlrecord)))) 
  :osstatus
   () )
(def-mactype :eventhotkeyidptr (find-mactype '(:pointer :eventhotkeyid)))
(defrecord EventHotKeyID 
   (signature :ostype)
   (id :unsigned-long)
   )

(def-mactype :eventhotkeyref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventhotkeyrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventHotKeyRef parameter can be nil, it is changed to xx: EventHotKeyRefPtr 
; 
; 	 *  RegisterEventHotKey()
; 	 *  
; 	 *  Discussion:
; 	 *    Registers a global hot key based on the virtual key code and
; 	 *    modifiers you pass in. Only one such combination can exist for
; 	 *    the current application, i.e. multiple entities in the same
; 	 *    application cannot register for the same hot key combination. The
; 	 *    same hot key can, however, be registered by multiple
; 	 *    applications. This means that multiple applications can
; 	 *    potentially be notified when a particular hot key is requested.
; 	 *    This might not necessarily be desirable, but it is how it works
; 	 *    at present.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inHotKeyCode:
; 	 *      The virtual key code of the key to watch
; 	 *    
; 	 *    inHotKeyModifiers:
; 	 *      The keyboard modifiers to look for. There must be a modifier
; 	 *      specified, or this function will return paramErr.
; 	 *    
; 	 *    inHotKeyID:
; 	 *      The application-specified hot key ID. You will receive this in
; 	 *      the kEventHotKeyPressed event as the direct object parameter.
; 	 *    
; 	 *    inTarget:
; 	 *      The target to notify when the hot key is pressed.
; 	 *    
; 	 *    inOptions:
; 	 *      Currently unused. Pass 0 or face the consequences.
; 	 *    
; 	 *    outRef:
; 	 *      The EventHotKeyRef that represents your new, shiny hot key. You
; 	 *      need this if you later wish to unregister it.
; 	 *  
; 	 *  Result:
; 	 *    An operating system status code.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_RegisterEventHotKey" 
      ((inHotKeyCode :unsigned-long) (inHotKeyModifiers :unsigned-long) (inHotKeyID :eventhotkeyid) (inTarget :pointer) (inOptions :unsigned-long) (outRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  UnregisterEventHotKey()
;  *  
;  *  Discussion:
;  *    Unregisters a global hot key that was previously registered with
;  *    the RegisterEventHotKey API. You do not need to unregister a hot
;  *    key when your application terminates, the system will take care
;  *    of that for you. This would be used if the user changes a hot key
;  *    for something in your application - you would unregister the
;  *    previous key and register your new key.
;  *  
;  *  Parameters:
;  *    
;  *    inHotKey:
;  *      The EventHotKeyRef to unregister.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UnregisterEventHotKey" 
      ((inHotKey :pointer)) 
  :osstatus
   () )

;   OBSOLETE CONSTANTS 

(defconstant $kMouseTrackingMousePressed 1)
(defconstant $kMouseTrackingMouseReleased 2)
(defconstant $kMouseTrackingMouseMoved 5)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CarbonEventsIncludes

; $ENDC                                         ; __CARBONEVENTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CarbonEvents)