(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CardServices.p"
; at Wednesday May 1,2002 2:41:12 pm.
; 
;      File:       CardServices.p
;  
;      Contains:   The client interface to Card and Socket Services.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc. All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CARDSERVICES__
; $SETC __CARDSERVICES__ := 1

; $I+
; $SETC CardServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __PCCARDTUPLES__

(require-interface 'PCCardTuples)               ; $I PCCardTuples.p
; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;    miscellaneous 

(defconstant $CS_MAX_SOCKETS 32)                ;   a long is used as a socket bitmap 

;   Will move to <Traps.h> 
(defconstant _PCCardDispatch #xAAF0)            ;   Card Services entry trap 

;   Will move to <Errors.h> 

;    result codes 

(defconstant $kCSBadAdapterErr -9050)           ;   invalid adapter number 
(defconstant $kCSBadAttributeErr -9051)         ;   specified attributes field value is invalid 
(defconstant $kCSBadBaseErr -9052)              ;   specified base system memory address is invalid 
(defconstant $kCSBadEDCErr -9053)               ;   specified EDC generator specified is invalid 
(defconstant $kCSBadIRQErr -9054)               ;   specified IRQ level is invalid 
(defconstant $kCSBadOffsetErr -9055)            ;   specified PC card memory array offset is invalid 
(defconstant $kCSBadPageErr -9056)              ;   specified page is invalid 
(defconstant $kCSBadSizeErr -9057)              ;   specified size is invalid 
(defconstant $kCSBadSocketErr -9058)            ;   specified logical or physical socket number is invalid 
(defconstant $kCSBadTypeErr -9059)              ;   specified window or interface type is invalid 
(defconstant $kCSBadVccErr -9060)               ;   specified Vcc power level index is invalid 
(defconstant $kCSBadVppErr -9061)               ;   specified Vpp1 or Vpp2 power level index is invalid 
(defconstant $kCSBadWindowErr -9062)            ;   specified window is invalid 
(defconstant $kCSBadArgLengthErr -9063)         ;   ArgLength argument is invalid 
(defconstant $kCSBadArgsErr -9064)              ;   values in argument packet are invalid 
(defconstant $kCSBadHandleErr -9065)            ;   clientHandle is invalid 
(defconstant $kCSBadCISErr -9066)               ;   CIS on card is invalid 
(defconstant $kCSBadSpeedErr -9067)             ;   specified speed is unavailable 
(defconstant $kCSReadFailureErr -9068)          ;   unable to complete read request 
(defconstant $kCSWriteFailureErr -9069)         ;   unable to complete write request 
(defconstant $kCSGeneralFailureErr -9070)       ;   an undefined error has occurred 
(defconstant $kCSNoCardErr -9071)               ;   no PC card in the socket 
(defconstant $kCSUnsupportedFunctionErr -9072)  ;   function is not supported by this implementation 
(defconstant $kCSUnsupportedModeErr -9073)      ;   mode is not supported 
(defconstant $kCSBusyErr -9074)                 ;   unable to process request at this time - try later 
(defconstant $kCSWriteProtectedErr -9075)       ;   media is write-protected 
(defconstant $kCSConfigurationLockedErr -9076)  ;   a configuration has already been locked 
(defconstant $kCSInUseErr -9077)                ;   requested resource is being used by a client 
(defconstant $kCSNoMoreItemsErr -9078)          ;   there are no more of the requested item 
(defconstant $kCSOutOfResourceErr -9079)        ;   Card Services has exhausted the resource 

;    messages sent to client's event handler 

(defconstant $kCSNullMessage #x0)               ;   no messages pending (not sent to clients) 
(defconstant $kCSCardInsertionMessage #x1)      ;   card has been inserted into the socket 
(defconstant $kCSCardRemovalMessage #x2)        ;   card has been removed from the socket 
(defconstant $kCSCardLockMessage #x3)           ;   card is locked into the socket with a mechanical latch 
(defconstant $kCSCardUnlockMessage #x4)         ;   card is no longer locked into the socket 
(defconstant $kCSCardReadyMessage #x5)          ;   card is ready to be accessed 
(defconstant $kCSCardResetMessage #x6)          ;   physical reset has completed 
(defconstant $kCSInsertionRequestMessage #x7)   ;   request to insert a card using insertion motor 
(defconstant $kCSInsertionCompleteMessage #x8)  ;   insertion motor has finished inserting a card 
(defconstant $kCSEjectionRequestMessage #x9)    ;   user or other client is requesting a card ejection 
(defconstant $kCSEjectionFailedMessage #xA)     ;   eject failure due to electrical/mechanical problems 
(defconstant $kCSPMResumeMessage #xB)           ;   power management resume (TBD) 
(defconstant $kCSPMSuspendMessage #xC)          ;   power management suspend (TBD) 
(defconstant $kCSResetPhysicalMessage #xD)      ;   physical reset is about to occur on this card 
(defconstant $kCSResetRequestMessage #xE)       ;   physical reset has been requested by a client 
(defconstant $kCSResetCompleteMessage #xF)      ;   ResetCard() background reset has completed 
(defconstant $kCSBatteryDeadMessage #x10)       ;   battery is no longer useable, data will be lost 
(defconstant $kCSBatteryLowMessage #x11)        ;   battery is weak and should be replaced 
(defconstant $kCSWriteProtectMessage #x12)      ;   card is now write protected 
(defconstant $kCSWriteEnabledMessage #x13)      ;   card is now write enabled 
(defconstant $kCSClientInfoMessage #x14)        ;   client is to return client information 
(defconstant $kCSSSUpdatedMessage #x15)         ;   AddSocketServices/ReplaceSocket services has changed SS support 
(defconstant $kCSFunctionInterruptMessage #x16) ;   card function interrupt 
(defconstant $kCSAccessErrorMessage #x17)       ;   client bus errored on access to socket 
(defconstant $kCSCardUnconfiguredMessage #x18)  ;   a CARD_READY was delivered to all clients and no client  
;      requested a configuration for the socket 
(defconstant $kCSStatusChangedMessage #x19)     ;   status change for cards in I/O mode 

; 	
; 	    The following is a mapping of the PCMCIA name space to the Macintosh name space.
; 	    These two enum lists will be removed and given to developers as a separate file.
; 		
(defconstant $SUCCESS 0)
(defconstant $BAD_ADAPTER -9050)
(defconstant $BAD_ATTRIBUTE -9051)
(defconstant $BAD_BASE -9052)
(defconstant $BAD_EDC -9053)
(defconstant $BAD_IRQ -9054)
(defconstant $BAD_OFFSET -9055)
(defconstant $BAD_PAGE -9056)
(defconstant $BAD_SIZE -9057)
(defconstant $BAD_SOCKET -9058)
(defconstant $BAD_TYPE -9059)
(defconstant $BAD_VCC -9060)
(defconstant $BAD_VPP -9061)
(defconstant $BAD_WINDOW -9062)
(defconstant $BAD_ARG_LENGTH -9063)
(defconstant $BAD_ARGS -9064)
(defconstant $BAD_HANDLE -9065)
(defconstant $BAD_CIS -9066)
(defconstant $BAD_SPEED -9067)
(defconstant $READ_FAILURE -9068)
(defconstant $WRITE_FAILURE -9069)
(defconstant $GENERAL_FAILURE -9070)
(defconstant $NO_CARD -9071)
(defconstant $UNSUPPORTED_FUNCTION -9072)
(defconstant $UNSUPPORTED_MODE -9073)
(defconstant $BUSY -9074)
(defconstant $WRITE_PROTECTED -9075)
(defconstant $CONFIGURATION_LOCKED -9076)
(defconstant $IN_USE -9077)
(defconstant $NO_MORE_ITEMS -9078)
(defconstant $OUT_OF_RESOURCE -9079)

;    messages sent to client's event handler 

(defconstant $NULL_MESSAGE #x0)
(defconstant $CARD_INSERTION #x1)
(defconstant $CARD_REMOVAL #x2)
(defconstant $CARD_LOCK #x3)
(defconstant $CARD_UNLOCK #x4)
(defconstant $CARD_READY #x5)
(defconstant $CARD_RESET #x6)
(defconstant $INSERTION_REQUEST #x7)
(defconstant $INSERTION_COMPLETE #x8)
(defconstant $EJECTION_REQUEST #x9)
(defconstant $EJECTION_FAILED #xA)
(defconstant $PM_RESUME #xB)
(defconstant $PM_SUSPEND #xC)
(defconstant $RESET_PHYSICAL #xD)
(defconstant $RESET_REQUEST #xE)
(defconstant $RESET_COMPLETE #xF)
(defconstant $BATTERY_DEAD #x10)
(defconstant $BATTERY_LOW #x11)
(defconstant $WRITE_PROTECT #x12)
(defconstant $WRITE_ENABLED #x13)
(defconstant $CLIENT_INFO #x14)
(defconstant $SS_UPDATED #x15)
(defconstant $FUNCTION_INTERRUPT #x16)
(defconstant $ACCESS_ERROR #x17)
(defconstant $CARD_UNCONFIGURED #x18)
(defconstant $STATUS_CHANGED #x19)

;  ----------------      CSAccessConfigurationRegister   ---------------- 

(def-mactype :accessconfigurationregisterpbptr (find-mactype '(:pointer :accessconfigurationregisterpb)))
(defrecord AccessConfigurationRegisterPB 
   (socket :unsigned-integer)                   ;    -> global socket number 
   (action :signed-byte)                        ;    -> read/write 
   (offset :signed-byte)                        ;    -> offset from config register base 
   (value :signed-byte)                         ;   <-> value to read/write 
   (padding :signed-byte)                       ;    
   )

;    action field values 

(defconstant $kCSReadConfigRegister #x0)
(defconstant $kCSWriteConfigRegister #x1)

;  ----------------      CSGetCardServicesInfo           ---------------- 

(def-mactype :getcardservicesinfopbptr (find-mactype '(:pointer :getcardservicesinfopb)))
(defrecord GetCardServicesInfoPB 
   (signature (:array :unsigned-byte 2 :packed));   <-  two ascii chars 'CS' 
   (count :unsigned-integer)                    ;   <-  total number of sockets installed 
   (revision :unsigned-integer)                 ;   <-  BCD 
   (csLevel :unsigned-integer)                  ;   <-  BCD 
   (reserved :unsigned-integer)                 ;    -> zero 
   (vStrLen :unsigned-integer)                  ;   <-> in: client's buffer size, out: vendor string length 
   (vendorString :pointer)                      ;   <-> in: pointer to buffer to hold CS vendor string (zero-terminated) 
;      out: CS vendor string copied to buffer 
   )

;  ----------------      CSGetClientInfo                 ---------------- 

;   upper byte of attributes is kCSClientInfoSubfunction 
(def-mactype :clientinfoparamptr (find-mactype '(:pointer :clientinfoparam)))
(defrecord ClientInfoParam 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (attributes :unsigned-integer)               ;   <-> subfunction + bitmapped client attributes 
   (revision :unsigned-integer)                 ;   <-  BCD value of client's revision 
   (csLevel :unsigned-integer)                  ;   <-  BCD value of CS release 
   (revDate :unsigned-integer)                  ;   <-  revision date: y[15-9], m[8-5], d[4-0] 
   (nameLen :signed-integer)                    ;   <-> in: max length of client name string, out: actual length 
   (vStringLen :signed-integer)                 ;   <-> in: max length of vendor string, out: actual length 
   (nameString :pointer)                        ;   <-  pointer to client name string (zero-terminated) 
   (vendorString :pointer)                      ;   <-  pointer to vendor string (zero-terminated) 
   )

; 
; 	   upper byte of attributes is kCSCardNameSubfunction,
; 	                               kCSCardTypeSubfunction,
; 	                               kCSHelpStringSubfunction
; 	
(def-mactype :alternatetextstringparamptr (find-mactype '(:pointer :alternatetextstringparam)))
(defrecord AlternateTextStringParam 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (attributes :unsigned-integer)               ;   <-> subfunction + bitmapped client attributes 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (reserved :unsigned-integer)                 ;    -> zero 
   (length :signed-integer)                     ;   <-> in: max length of string, out: actual length 
   (text :pointer)                              ;   <-  pointer to string (zero-terminated) 
   )

;   upper byte of attributes is kCSCardIconSubfunction 
(def-mactype :alternatecardiconparamptr (find-mactype '(:pointer :alternatecardiconparam)))
(defrecord AlternateCardIconParam 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (attributes :unsigned-integer)               ;   <-> subfunction + bitmapped client attributes 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (iconSuite :handle)                          ;   <-  handle to icon suite containing all icons 
   )

;   upper byte of attributes is kCSActionProcSubfunction 
(def-mactype :customactionprocparamptr (find-mactype '(:pointer :customactionprocparam)))
(defrecord CustomActionProcParam 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (attributes :unsigned-integer)               ;   <-> subfunction + bitmapped client attributes 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   )

(def-mactype :getclientinfopbptr (find-mactype '(:pointer :getclientinfopb)))
(defrecord GetClientInfoPB 
   (:variant 
      (
      (clientInfo :clientinfoparam)
      )
      (
      (alternateTextString :alternatetextstringparam)
      )
      (
      (alternateIcon :alternatecardiconparam)
      )
      (
      (customActionProc :customactionprocparam)
      )
      )
   )

;    attributes field values 

(defconstant $kCSMemoryClient #x1)
(defconstant $kCSIOClient #x4)
(defconstant $kCSClientTypeMask #x7)
(defconstant $kCSShareableCardInsertEvents #x8)
(defconstant $kCSExclusiveCardInsertEvents #x10)
(defconstant $kCSInfoSubfunctionMask #xFF00)
(defconstant $kCSClientInfoSubfunction #x0)
(defconstant $kCSCardNameSubfunction #x8000)
(defconstant $kCSCardTypeSubfunction #x8100)
(defconstant $kCSHelpStringSubfunction #x8200)
(defconstant $kCSCardIconSubfunction #x8300)
(defconstant $kCSActionProcSubfunction #x8400)

; 
; 	  ----------------      CSGetConfigurationInfo          ----------------
; 	  ----------------      CSModifyConfiguration           ----------------
; 	  ----------------      CSRequestConfiguration          ----------------
; 	

(def-mactype :getmodrequestconfiginfopbptr (find-mactype '(:pointer :getmodrequestconfiginfopb)))
(defrecord GetModRequestConfigInfoPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (attributes :unsigned-integer)               ;   <-> bitmap of configuration attributes 
   (vcc :signed-byte)                           ;   <-> Vcc setting 
   (vpp1 :signed-byte)                          ;   <-> Vpp1 setting 
   (vpp2 :signed-byte)                          ;   <-> Vpp2 setting 
   (intType :signed-byte)                       ;   <-> interface type (memory or memory+I/O) 
   (configBase :unsigned-long)                  ;   <-> card base address of configuration registers 
   (status :signed-byte)                        ;   <-> card status register setting, if present 
   (pin :signed-byte)                           ;   <-> card pin register setting, if present 
   (copy :signed-byte)                          ;   <-> card socket/copy register setting, if present 
   (configIndex :signed-byte)                   ;   <-> card option register setting, if present 
   (present :signed-byte)                       ;   <-> bitmap of which configuration registers are present 
   (firstDevType :signed-byte)                  ;   <-  from DeviceID tuple 
   (funcCode :signed-byte)                      ;   <-  from FuncID tuple 
   (sysInitMask :signed-byte)                   ;   <-  from FuncID tuple 
   (manufCode :unsigned-integer)                ;   <-  from ManufacturerID tuple 
   (manufInfo :unsigned-integer)                ;   <-  from ManufacturerID tuple 
   (cardValues :signed-byte)                    ;   <-  valid card register values 
   (padding :signed-byte)                       ;    
   )

;    attributes field values 

(defconstant $kCSExclusivelyUsed #x1)
(defconstant $kCSEnableIREQs #x2)
(defconstant $kCSVccChangeValid #x4)
(defconstant $kCSVpp1ChangeValid #x8)
(defconstant $kCSVpp2ChangeValid #x10)
(defconstant $kCSValidClient #x20)
(defconstant $kCSSleepPower #x40)               ;   request that power be applied to socket during Sleep 
(defconstant $kCSLockSocket #x80)
(defconstant $kCSTurnOnInUse #x100)

;    intType field values 

(defconstant $kCSMemoryInterface #x1)
(defconstant $kCSMemory_And_IO_Interface #x2)

;    present field values 

(defconstant $kCSOptionRegisterPresent #x1)
(defconstant $kCSStatusRegisterPresent #x2)
(defconstant $kCSPinReplacementRegisterPresent #x4)
(defconstant $kCSCopyRegisterPresent #x8)

;    cardValues field values 

(defconstant $kCSOptionValueValid #x1)
(defconstant $kCSStatusValueValid #x2)
(defconstant $kCSPinReplacementValueValid #x4)
(defconstant $kCSCopyValueValid #x8)

; 
; 	  ----------------      CSGetClientEventMask            ----------------
; 	  ----------------      CSSetClientEventMask            ----------------
; 	

(def-mactype :getsetclienteventmaskpbptr (find-mactype '(:pointer :getsetclienteventmaskpb)))
(defrecord GetSetClientEventMaskPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (attributes :unsigned-integer)               ;   <-> bitmap of attributes 
   (eventMask :unsigned-integer)                ;   <-> bitmap of events to be passed to client for this socket 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   )

;    attributes field values 

(defconstant $kCSEventMaskThisSocketOnly #x1)

;    eventMask field values 

(defconstant $kCSWriteProtectEvent #x1)
(defconstant $kCSCardLockChangeEvent #x2)
(defconstant $kCSEjectRequestEvent #x4)
(defconstant $kCSInsertRequestEvent #x8)
(defconstant $kCSBatteryDeadEvent #x10)
(defconstant $kCSBatteryLowEvent #x20)
(defconstant $kCSReadyChangeEvent #x40)
(defconstant $kCSCardDetectChangeEvent #x80)
(defconstant $kCSPMChangeEvent #x100)
(defconstant $kCSResetEvent #x200)
(defconstant $kCSSSUpdateEvent #x400)
(defconstant $kCSFunctionInterrupt #x800)
(defconstant $kCSAllEvents #xFFFF)

; 
; 	  ----------------      CSGetFirstClient                ----------------
; 	  ----------------      CSGetNextClient                 ----------------
; 	

(def-mactype :getclientpbptr (find-mactype '(:pointer :getclientpb)))
(defrecord GetClientPB 
   (clientHandle :unsigned-long)                ;   <-  clientHandle for this client 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (attributes :unsigned-integer)               ;    -> bitmap of attributes 
   )

;    attributes field values 

(defconstant $kCSClientsForAllSockets #x0)
(defconstant $kCSClientsThisSocketOnly #x1)

; 
; 	  ----------------      CSGetFirstTuple                 ----------------
; 	  ----------------      CSGetNextTuple                  ----------------
; 	  ----------------      CSGetTupleData                  ----------------
; 	

(def-mactype :gettuplepbptr (find-mactype '(:pointer :gettuplepb)))
(defrecord GetTuplePB 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (attributes :unsigned-integer)               ;    -> bitmap of attributes 
   (desiredTuple :signed-byte)                  ;    -> desired tuple code value, or $FF for all 
   (tupleOffset :signed-byte)                   ;    -> offset into tuple from link byte 
   (flags :unsigned-integer)                    ;   <-> internal use 
   (linkOffset :unsigned-long)                  ;   <-> internal use 
   (cisOffset :unsigned-long)                   ;   <-> internal use 
   (:variant 
      (
      (tupleCode :signed-byte)                  ;   <-  tuple code found 
      (tupleLink :signed-byte)                  ;   <-  link value for tuple found 
      )
      (
      (tupleDataMax :unsigned-integer)          ;    -> maximum size of tuple data area 
      (tupleDataLen :unsigned-integer)          ;   <-  number of bytes in tuple body 
      (tupleData :tuplebody)                    ;   <-  tuple data 
      )
      )
   )

;    attributes field values 

(defconstant $kCSReturnLinkTuples #x1)

; 
; 	  ----------------      CSRequestSocketMask             ----------------
; 	  ----------------      CSReleaseSocketMask             ----------------
; 	

(def-mactype :reqrelsocketmaskpbptr (find-mactype '(:pointer :reqrelsocketmaskpb)))
(defrecord ReqRelSocketMaskPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (socket :unsigned-integer)                   ;    -> logical socket 
   (eventMask :unsigned-integer)                ;    -> bitmap of events to be passed to client for this socket 
   )

;    eventMask field values (see above for Get/SetClientEventMask 

;  ----------------      CSGetStatus                     ---------------- 

(def-mactype :getstatuspbptr (find-mactype '(:pointer :getstatuspb)))
(defrecord GetStatusPB 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (cardState :unsigned-integer)                ;   <-  current state of installed card 
   (socketState :unsigned-integer)              ;   <-  current state of the socket 
   )

;    cardState field values 

(defconstant $kCSWriteProtected #x1)
(defconstant $kCSCardLocked #x2)
(defconstant $kCSEjectRequest #x4)
(defconstant $kCSInsertRequest #x8)
(defconstant $kCSBatteryDead #x10)
(defconstant $kCSBatteryLow #x20)
(defconstant $kCSReady #x40)
(defconstant $kCSCardDetected #x80)

;    socketState field values 

(defconstant $kCSWriteProtectChanged #x1)
(defconstant $kCSCardLockChanged #x2)
(defconstant $kCSEjectRequestPending #x4)
(defconstant $kCSInsertRequestPending #x8)
(defconstant $kCSBatteryDeadChanged #x10)
(defconstant $kCSBatteryLowChanged #x20)
(defconstant $kCSReadyChanged #x40)
(defconstant $kCSCardDetectChanged #x80)

; 
; 	  ----------------      CSModifyWindow                  ----------------
; 	  ----------------      CSReleaseWindow                 ----------------
; 	  ----------------      CSRequestWindow                 ----------------
; 	

(def-mactype :reqmodrelwindowpbptr (find-mactype '(:pointer :reqmodrelwindowpb)))
(defrecord ReqModRelWindowPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (windowHandle :unsigned-long)                ;   <-> window descriptor 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (attributes :unsigned-integer)               ;    -> window attributes (bitmap) 
   (base :unsigned-long)                        ;   <-> system base address 
   (size :unsigned-long)                        ;   <-> memory window size 
   (accessSpeed :signed-byte)                   ;    -> window access speed (bitmap) 
;         (not applicable for I/O mode) 
   (padding :signed-byte)                       ;    
   )

;    attributes field values 

(defconstant $kCSMemoryWindow #x1)
(defconstant $kCSIOWindow #x2)
(defconstant $kCSAttributeWindow #x4)           ;   not normally used by Card Services clients 
(defconstant $kCSWindowTypeMask #x7)
(defconstant $kCSEnableWindow #x8)
(defconstant $kCSAccessSpeedValid #x10)
(defconstant $kCSLittleEndian #x20)             ;   configure socket for little endianess 
(defconstant $kCS16BitDataPath #x40)
(defconstant $kCSWindowPaged #x80)              ;    
(defconstant $kCSWindowShared #x100)
(defconstant $kCSWindowFirstShared #x200)       ;    
(defconstant $kCSWindowProgrammable #x400)      ;    

;    accessSpeed field values 

(defconstant $kCSDeviceSpeedCodeMask #x7)
(defconstant $kCSSpeedExponentMask #x7)
(defconstant $kCSSpeedMantissaMask #x78)
(defconstant $kCSUseWait #x80)
(defconstant $kCSAccessSpeed250nsec #x1)
(defconstant $kCSAccessSpeed200nsec #x2)
(defconstant $kCSAccessSpeed150nsec #x3)
(defconstant $kCSAccessSpeed100nsec #x4)
(defconstant $kCSExtAccSpeedMant1pt0 #x1)
(defconstant $kCSExtAccSpeedMant1pt2 #x2)
(defconstant $kCSExtAccSpeedMant1pt3 #x3)
(defconstant $kCSExtAccSpeedMant1pt5 #x4)
(defconstant $kCSExtAccSpeedMant2pt0 #x5)
(defconstant $kCSExtAccSpeedMant2pt5 #x6)
(defconstant $kCSExtAccSpeedMant3pt0 #x7)
(defconstant $kCSExtAccSpeedMant3pt5 #x8)
(defconstant $kCSExtAccSpeedMant4pt0 #x9)
(defconstant $kCSExtAccSpeedMant4pt5 #xA)
(defconstant $kCSExtAccSpeedMant5pt0 #xB)
(defconstant $kCSExtAccSpeedMant5pt5 #xC)
(defconstant $kCSExtAccSpeedMant6pt0 #xD)
(defconstant $kCSExtAccSpeedMant7pt0 #xE)
(defconstant $kCSExtAccSpeedMant8pt0 #xF)
(defconstant $kCSExtAccSpeedExp1ns #x0)
(defconstant $kCSExtAccSpeedExp10ns #x1)
(defconstant $kCSExtAccSpeedExp100ns #x2)
(defconstant $kCSExtAccSpeedExp1us #x3)
(defconstant $kCSExtAccSpeedExp10us #x4)
(defconstant $kCSExtAccSpeedExp100us #x5)
(defconstant $kCSExtAccSpeedExp1ms #x6)
(defconstant $kCSExtAccSpeedExp10ms #x7)

; 
; 	  ----------------      CSRegisterClient                ----------------
; 	  ----------------      CSDeregisterClient              ----------------
; 	

(def-mactype :clientcallbackpbptr (find-mactype '(:pointer :clientcallbackpb)))
(defrecord ClientCallbackPB 
   (message :unsigned-integer)                  ;    -> which event this is 
   (socket :unsigned-integer)                   ;    -> logical socket number 
   (info :unsigned-integer)                     ;    -> function-specific 
   (misc :unsigned-integer)                     ;    -> function-specific 
   (reserved :pointer)                          ;    -> pointer to MTD request block 
   (buffer :pointer)                            ;    -> function-specific 
   (clientData :pointer)                        ;    -> pointer to client's data (from RegisterClient) 
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PCCardCSClientProcPtr = FUNCTION(ccPBPtr: ClientCallbackPBPtr): UInt16;

|#
 |#                                             ; $ELSEC
(def-mactype :pccardcsclientprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :pccardcsclientupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :pccardcsclientupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPCCardCSClientProcInfo #xE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPCCardCSClientUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPCCardCSClientProc 
(deftrap "_NewPCCardCSClientUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePCCardCSClientUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePCCardCSClientUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePCCardCSClientUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPCCardCSClientProc 
(deftrap-inline "_InvokePCCardCSClientUPP" 
      ((ccPBPtr (:pointer :clientcallbackpb)) (userRoutine :pointer)) 
  :unsigned-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :registerclientpbptr (find-mactype '(:pointer :registerclientpb)))
(defrecord RegisterClientPB 
   (clientHandle :unsigned-long)                ;   <-  client descriptor 
   (clientEntry :pointer)                       ;    -> universal procPtr to client's event handler 
   (attributes :unsigned-integer)               ;    -> bitmap of client attributes 
   (eventMask :unsigned-integer)                ;    -> bitmap of events to notify client 
   (clientData :pointer)                        ;    -> pointer to client's data 
   (version :unsigned-integer)                  ;    -> Card Services version this client expects 
   )

;    attributes field values (see GetClientInfo) 
; 
; 	    kCSMemoryClient                 = 0x0001,
; 	    kCSIOClient                     = 0x0004,
; 	    kCSShareableCardInsertEvents    = 0x0008,
; 	    kCSExclusiveCardInsertEvents    = 0x0010
; 	

;  ----------------      CSReleaseConfiguration          ---------------- 

(def-mactype :releaseconfigurationpbptr (find-mactype '(:pointer :releaseconfigurationpb)))
(defrecord ReleaseConfigurationPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (socket :unsigned-integer)                   ;    ->  
   )

;  ----------------      CSResetCard                     ---------------- 

(def-mactype :resetcardpbptr (find-mactype '(:pointer :resetcardpb)))
(defrecord ResetCardPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (socket :unsigned-integer)                   ;    ->  
   (attributes :unsigned-integer)               ;    -> xxx 
   )

;  ----------------      CSValidateCIS                   ---------------- 

(def-mactype :validatecispbptr (find-mactype '(:pointer :validatecispb)))
(defrecord ValidateCISPB 
   (socket :unsigned-integer)                   ;    ->  
   (chains :unsigned-integer)                   ;    -> whether link/null tuples should be included 
   )

; 
; 	  ----------------      CSRequestIO                     ----------------
; 	  ----------------      CSReleaseIO                     ----------------
; 	

(def-mactype :reqreliopbptr (find-mactype '(:pointer :reqreliopb)))
(defrecord ReqRelIOPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (socket :unsigned-integer)                   ;    -> socket number 
   (reserved :unsigned-integer)
   (basePort1 :unsigned-integer)                ;      -> base I/O port for range 
   (numPorts1 :signed-byte)                     ;      -> number of ports (e.g., bytes). 
   (attributes1 :signed-byte)                   ;      -> attributes 
   (basePort2 :unsigned-integer)                ;      -> base I/O port for range 
   (numPorts2 :signed-byte)                     ;      -> number of ports 
   (attributes2 :signed-byte)                   ;      -> attributes 
   (ioAddrLines :signed-byte)                   ;      -> number of I/O lines decoded by card 
   (reserved1 :signed-byte)
   )

;  ----------------      CSVendorSpecific                ---------------- 
(def-mactype :vendorspecificpbptr (find-mactype '(:pointer :vendorspecificpb)))
(defrecord VendorSpecificPB 
   (clientHandle :unsigned-long)                ;    -> clientHandle returned by RegisterClient 
   (vsCode :unsigned-integer)
   (socket :unsigned-integer)
   (dataLen :unsigned-long)                     ;    -> length of buffer pointed to by vsDataPtr 
   (vsDataPtr :pointer)                         ;    -> Card Services version this client expects 
   )

;    vsCode field values 

(defconstant $vsAppleReserved #x0)
(defconstant $vsEjectCard #x1)
(defconstant $vsGetCardInfo #x2)
(defconstant $vsEnableSocketEvents #x3)
(defconstant $vsGetCardLocationIcon #x4)
(defconstant $vsGetCardLocationText #x5)
(defconstant $vsGetAdapterInfo #x6)

; 
; 	  ///////////////////////////////////////////////////////////////////////////////////////
; 	    GetAdapterInfo parameter block (vendor-specific call #6)
; 	

(def-mactype :getadapterinfopbptr (find-mactype '(:pointer :getadapterinfopb)))
(defrecord GetAdapterInfoPB 
   (attributes :unsigned-long)                  ;   <-  capabilties of socket's adapter 
   (revision :unsigned-integer)                 ;   <-  id of adapter 
   (reserved :unsigned-integer)                 ;    
   (numVoltEntries :unsigned-integer)           ;   <-  number of valid voltage values 
   (voltages :pointer)                          ;   <-> array of BCD voltage values 
   )

;    attributes field values 

(defconstant $kCSLevelModeInterrupts #x1)
(defconstant $kCSPulseModeInterrupts #x2)
(defconstant $kCSProgrammableWindowAddr #x4)
(defconstant $kCSProgrammableWindowSize #x8)
(defconstant $kCSSocketSleepPower #x10)
(defconstant $kCSSoftwareEject #x20)
(defconstant $kCSLockableSocket #x40)
(defconstant $kCSInUseIndicator #x80)

; 
; 	  ///////////////////////////////////////////////////////////////////////////////////////
; 	    GetCardInfo parameter block (vendor-specific call #2)
; 	

(def-mactype :getcardinfopbptr (find-mactype '(:pointer :getcardinfopb)))
(defrecord GetCardInfoPB 
   (cardType :signed-byte)                      ;   <-  type of card in this socket (defined at top of file) 
   (subType :signed-byte)                       ;   <-  more detailed card type (defined at top of file) 
   (reserved :unsigned-integer)                 ;   <-> reserved (should be set to zero) 
   (cardNameLen :unsigned-integer)              ;    -> maximum length of card name to be returned 
   (vendorNameLen :unsigned-integer)            ;    -> maximum length of vendor name to be returned 
   (cardName :pointer)                          ;    -> pointer to card name string (read from CIS), or nil 
   (vendorName :pointer)                        ;    -> pointer to vendor name string (read from CIS), or nil 
   )

;    GetCardInfo card types 

(defconstant $kCSUnknownCardType 0)
(defconstant $kCSMultiFunctionCardType 1)
(defconstant $kCSMemoryCardType 2)
(defconstant $kCSSerialPortCardType 3)
(defconstant $kCSSerialOnlyType 0)
(defconstant $kCSDataModemType 1)
(defconstant $kCSFaxModemType 2)
(defconstant $kCSFaxAndDataModemMask 3)
(defconstant $kCSVoiceEncodingType 4)
(defconstant $kCSParallelPortCardType 4)
(defconstant $kCSFixedDiskCardType 5)
(defconstant $kCSUnknownFixedDiskType 0)
(defconstant $kCSATAInterface 1)
(defconstant $kCSRotatingDevice #x0)
(defconstant $kCSSiliconDevice #x80)
(defconstant $kCSVideoAdaptorCardType 6)
(defconstant $kCSNetworkAdaptorCardType 7)
(defconstant $kCSAIMSCardType 8)
(defconstant $kCSNumCardTypes 9)

; $IFC UNDEFINED __PCCARDENABLERPLUGIN__ 
; 	
; 	    NOTE: These prototypes conflict with PCCardEnablerPlugin.
; 	          You cannot use both PCCardEnablerPlugin.h and CardServices.h
; 	          
; 		
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CSVendorSpecific()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_CSVendorSpecific" 
      ((pb (:pointer :vendorspecificpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 0 pb))

; 
;  *  CSRegisterClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSRegisterClient" 
      ((pb (:pointer :registerclientpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 1 pb))

; 
;  *  CSDeregisterClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSDeregisterClient" 
      ((pb (:pointer :registerclientpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 2 pb))

; 
;  *  CSGetFirstTuple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetFirstTuple" 
      ((pb (:pointer :gettuplepb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 3 pb))

; 
;  *  CSGetNextTuple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetNextTuple" 
      ((pb (:pointer :gettuplepb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 4 pb))

; 
;  *  CSGetTupleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetTupleData" 
      ((pb (:pointer :gettuplepb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 5 pb))

; 
;  *  CSGetConfigurationInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetConfigurationInfo" 
      ((pb (:pointer :getmodrequestconfiginfopb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 6 pb))

; 
;  *  CSGetCardServicesInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetCardServicesInfo" 
      ((pb (:pointer :getcardservicesinfopb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 7 pb))

; 
;  *  CSGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetStatus" 
      ((pb (:pointer :getstatuspb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 8 pb))

; 
;  *  CSValidateCIS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSValidateCIS" 
      ((pb (:pointer :validatecispb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 9 pb))

; 
;  *  CSGetFirstClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetFirstClient" 
      ((pb (:pointer :getclientpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 15 pb))

; 
;  *  CSGetNextClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetNextClient" 
      ((pb (:pointer :getclientpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 16 pb))

; 
;  *  CSGetClientInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetClientInfo" 
      ((pb (:pointer :getclientinfopb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 17 pb))

; 
;  *  CSResetCard()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSResetCard" 
      ((pb (:pointer :resetcardpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 18 pb))

; 
;  *  CSRequestWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSRequestWindow" 
      ((pb (:pointer :reqmodrelwindowpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 19 pb))

; 
;  *  CSModifyWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSModifyWindow" 
      ((pb (:pointer :reqmodrelwindowpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 20 pb))

; 
;  *  CSReleaseWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSReleaseWindow" 
      ((pb (:pointer :reqmodrelwindowpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 21 pb))

; 
;  *  CSRequestConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSRequestConfiguration" 
      ((pb (:pointer :getmodrequestconfiginfopb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 27 pb))

; 
;  *  CSModifyConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSModifyConfiguration" 
      ((pb (:pointer :getmodrequestconfiginfopb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 28 pb))

; 
;  *  CSAccessConfigurationRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSAccessConfigurationRegister" 
      ((pb (:pointer :accessconfigurationregisterpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 29 pb))

; 
;  *  CSReleaseConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSReleaseConfiguration" 
      ((pb (:pointer :releaseconfigurationpb)))
   (:stack :osstatus)
   (:stack-trap #xAAF0 :d0 30 pb))

; 
;  *  CSGetClientEventMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSGetClientEventMask" 
      ((pb (:pointer :getsetclienteventmaskpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 31 pb))

; 
;  *  CSSetClientEventMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSSetClientEventMask" 
      ((pb (:pointer :getsetclienteventmaskpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 32 pb))

; 
;  *  CSRequestSocketMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSRequestSocketMask" 
      ((pb (:pointer :reqrelsocketmaskpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 33 pb))

; 
;  *  CSReleaseSocketMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSReleaseSocketMask" 
      ((pb (:pointer :reqrelsocketmaskpb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 34 pb))

; 
;     Additional calls which are required for all I/O clients when running on
;     systems which do not reserve dedicated I/O-spaces for each PC Card.
; 

; 
;  *  CSRequestIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSRequestIO" 
      ((pb (:pointer :reqreliopb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 37 pb))

; 
;  *  CSReleaseIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCardLib 1.0 thru 2.0
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSReleaseIO" 
      ((pb (:pointer :reqreliopb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 38 pb))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CardServicesIncludes

; $ENDC                                         ; __CARDSERVICES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CardServices)