(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ColorPicker.p"
; at Wednesday May 1,2002 2:41:08 pm.
; 
;      File:       ColorPicker.p
;  
;      Contains:   Color Picker package Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __COLORPICKER__
; $SETC __COLORPICKER__ := 1

; $I+
; $SETC ColorPickerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Maximum small fract value, as long 
(defconstant $kMaximumSmallFract #xFFFF)

(defconstant $kDefaultColorPickerWidth 383)
(defconstant $kDefaultColorPickerHeight 238)

(def-mactype :dialogplacementspec (find-mactype ':signed-integer))

(defconstant $kAtSpecifiedOrigin 0)
(defconstant $kDeepestColorScreen 1)
(defconstant $kCenterOnMainScreen 2)

; 	 These are for the flags field in the structs below (for example ColorPickerInfo). 	
(defconstant $kColorPickerDialogIsMoveable 1)
(defconstant $kColorPickerDialogIsModal 2)
(defconstant $kColorPickerCanModifyPalette 4)
(defconstant $kColorPickerCanAnimatePalette 8)
(defconstant $kColorPickerAppIsColorSyncAware 16)
(defconstant $kColorPickerInSystemDialog 32)
(defconstant $kColorPickerInApplicationDialog 64)
(defconstant $kColorPickerInPickerDialog 128)
(defconstant $kColorPickerDetachedFromChoices 256)
(defconstant $kColorPickerCallColorProcLive 512)

; $IFC OLDROUTINENAMES 
;  Maximum small fract value, as long 
(defconstant $MaxSmallFract #xFFFF)

(defconstant $kDefaultWidth 383)
(defconstant $kDefaultHeight 238)

; 	 These are for the flags field in the structs below (for example ColorPickerInfo). 	
(defconstant $DialogIsMoveable 1)
(defconstant $DialogIsModal 2)
(defconstant $CanModifyPalette 4)
(defconstant $CanAnimatePalette 8)
(defconstant $AppIsColorSyncAware 16)
(defconstant $InSystemDialog 32)
(defconstant $InApplicationDialog 64)
(defconstant $InPickerDialog 128)
(defconstant $DetachedFromChoices 256)
(defconstant $CallColorProcLive 512)

; $ENDC                                         ; OLDROUTINENAMES

; 	 A SmallFract value is just the fractional part of a Fixed number,
; 	which is the low order word.  SmallFracts are used to save room,
; 	and to be compatible with Quickdraw's RGBColor.  They can be
; 	assigned directly to and from INTEGERs. 	
; 	 Unsigned fraction between 0 and 1 	

(def-mactype :smallfract (find-mactype ':unsigned-integer))
; 	 For developmental simplicity in switching between the HLS and HSV
; 	models, HLS is reordered into HSL. Thus both models start with
; 	hue and saturation values; value/lightness/brightness is last. 	

(def-mactype :hsvcolorptr (find-mactype '(:pointer :hsvcolor)))
(defrecord HSVColor 
   (hue :unsigned-integer)                      ;  Fraction of circle, red at 0 
   (saturation :unsigned-integer)               ;  0-1, 0 for gray, 1 for pure color 
   (value :unsigned-integer)                    ;  0-1, 0 for black, 1 for max intensity 
   )

(def-mactype :hslcolorptr (find-mactype '(:pointer :hslcolor)))
(defrecord HSLColor 
   (hue :unsigned-integer)                      ;  Fraction of circle, red at 0 
   (saturation :unsigned-integer)               ;  0-1, 0 for gray, 1 for pure color 
   (lightness :unsigned-integer)                ;  0-1, 0 for black, 1 for white 
   )

(def-mactype :cmycolorptr (find-mactype '(:pointer :cmycolor)))
(defrecord CMYColor 
   (cyan :unsigned-integer)
   (magenta :unsigned-integer)
   (yellow :unsigned-integer)
   )

(def-mactype :pmcolorptr (find-mactype '(:pointer :pmcolor)))
(defrecord PMColor 
   (profile (:handle :cmprofile))
   (color :cmcolor)
   )

(def-mactype :npmcolorptr (find-mactype '(:pointer :npmcolor)))
(defrecord NPMColor 
   (profile :pointer)
   (color :cmcolor)
   )

(def-mactype :picker (find-mactype ':pointer))  ;  an opaque 32-bit type 
(def-mactype :pickerptr (find-mactype '(:pointer :pointer)));  when a VAR xx:Picker parameter can be nil, it is changed to xx: PickerPtr 
(def-mactype :pickermenuiteminfoptr (find-mactype '(:pointer :pickermenuiteminfo)))
(defrecord PickerMenuItemInfo 
   (editMenuID :signed-integer)
   (cutItem :signed-integer)
   (copyItem :signed-integer)
   (pasteItem :signed-integer)
   (clearItem :signed-integer)
   (undoItem :signed-integer)
   )

; 	 Structs related to deprecated API's have been pulled from this file. 	
; 	 Those structs necessary for developers writing their own color pickers... 	
; 	 have been moved to ColorPickerComponents.h. 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ColorChangedProcPtr = PROCEDURE(userData: LONGINT; VAR newColor: PMColor);

|#
 |#                                             ; $ELSEC
(def-mactype :colorchangedprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NColorChangedProcPtr = PROCEDURE(userData: LONGINT; VAR newColor: NPMColor);

|#
 |#                                             ; $ELSEC
(def-mactype :ncolorchangedprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UserEventProcPtr = FUNCTION(VAR event: EventRecord): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :usereventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :colorchangedupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :colorchangedupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :ncolorchangedupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :ncolorchangedupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :usereventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :usereventupp (find-mactype ':pointer))
; $ENDC
(def-mactype :colorpickerinfoptr (find-mactype '(:pointer :colorpickerinfo)))
(defrecord ColorPickerInfo 
   (theColor :pmcolor)
   (dstProfile (:handle :cmprofile))
   (flags :unsigned-long)
   (placeWhere :signed-integer)
   (dialogOrigin :point)
   (pickerType :ostype)
   (eventProc :pointer)
   (colorProc :pointer)
   (colorProcData :unsigned-long)
   (prompt (:string 255))
   (mInfo :pickermenuiteminfo)
   (newColorChosen :boolean)
   (filler :signed-byte)
   )

(def-mactype :ncolorpickerinfoptr (find-mactype '(:pointer :ncolorpickerinfo)))
(defrecord NColorPickerInfo 
   (theColor :npmcolor)
   (dstProfile :pointer)
   (flags :unsigned-long)
   (placeWhere :signed-integer)
   (dialogOrigin :point)
   (pickerType :ostype)
   (eventProc :pointer)
   (colorProc :pointer)
   (colorProcData :unsigned-long)
   (prompt (:string 255))
   (mInfo :pickermenuiteminfo)
   (newColorChosen :boolean)
   (reserved :signed-byte)                      ;  Must be 0 
   )

;    Below are the color conversion routines. 
; 
; 	 *  Fix2SmallFract()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_Fix2SmallFract" 
      ((f :signed-long))
   (:stack :unsigned-integer)
   (:stack-trap #xA82E f (1 :signed-integer)))

; 
;  *  SmallFract2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_SmallFract2Fix" 
      ((s :unsigned-integer))
   (:stack :fixed)
   (:stack-trap #xA82E s (2 :signed-integer)))

; 
;  *  CMY2RGB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_CMY2RGB" 
      ((cColor (:pointer :cmycolor)) (rColor (:pointer :rgbcolor)))
   nil
   (:stack-trap #xA82E cColor rColor (3 :signed-integer)))

; 
;  *  RGB2CMY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_RGB2CMY" 
      ((rColor (:pointer :rgbcolor)) (cColor (:pointer :cmycolor)))
   nil
   (:stack-trap #xA82E rColor cColor (4 :signed-integer)))

; 
;  *  HSL2RGB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_HSL2RGB" 
      ((hColor (:pointer :hslcolor)) (rColor (:pointer :rgbcolor)))
   nil
   (:stack-trap #xA82E hColor rColor (5 :signed-integer)))

; 
;  *  RGB2HSL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_RGB2HSL" 
      ((rColor (:pointer :rgbcolor)) (hColor (:pointer :hslcolor)))
   nil
   (:stack-trap #xA82E rColor hColor (6 :signed-integer)))

; 
;  *  HSV2RGB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_HSV2RGB" 
      ((hColor (:pointer :hsvcolor)) (rColor (:pointer :rgbcolor)))
   nil
   (:stack-trap #xA82E hColor rColor (7 :signed-integer)))

; 
;  *  RGB2HSV()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_RGB2HSV" 
      ((rColor (:pointer :rgbcolor)) (hColor (:pointer :hsvcolor)))
   nil
   (:stack-trap #xA82E rColor hColor (8 :signed-integer)))

;    GetColor() works with or without the Color Picker extension. 
; 
;  *  GetColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_GetColor" 
      ((where :point) (prompt (:string 255)) (inColor (:pointer :rgbcolor)) (outColor (:pointer :rgbcolor)))
   (:stack :boolean)
   (:stack-trap #xA82E where prompt inColor outColor (9 :signed-integer)))

;    PickColor() requires the Color Picker extension (version 2.0 or greater). 
; 
;  *  PickColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorPickerLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_PickColor" 
      ((theColorInfo (:pointer :colorpickerinfo)))
   (:stack :signed-integer)
   (:stack-trap #xA82E theColorInfo (531 :signed-integer)))

;    NPickColor() requires the Color Picker extension (version 2.1 or greater). 
; 
;  *  NPickColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorPickerLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_NPickColor" 
      ((theColorInfo (:pointer :ncolorpickerinfo)))
   (:stack :signed-integer)
   (:stack-trap #xA82E theColorInfo (551 :signed-integer)))

;  A suite of mid-level API calls have been deprecated.  Likely you never...  
;  used them anyway.  They were removed from this file and should not be... 
;  used in the future as they are not gauranteed to be supported. 

(defconstant $uppColorChangedProcInfo #x3C0)
(defconstant $uppNColorChangedProcInfo #x3C0)
(defconstant $uppUserEventProcInfo #xD0)
; 
; 	 *  NewColorChangedUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewColorChangedProc 
(deftrap "_NewColorChangedUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNColorChangedUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was NewNColorChangedProc 
(deftrap "_NewNColorChangedUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewUserEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was NewUserEventProc 
(deftrap "_NewUserEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeColorChangedUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeColorChangedUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNColorChangedUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeNColorChangedUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeUserEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeUserEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeColorChangedUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was CallColorChangedProc 
(deftrap-inline "_InvokeColorChangedUPP" 
      ((userData :signed-long) (newColor (:pointer :pmcolor)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeNColorChangedUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was CallNColorChangedProc 
(deftrap-inline "_InvokeNColorChangedUPP" 
      ((userData :signed-long) (newColor (:pointer :npmcolor)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeUserEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was CallUserEventProc 
(deftrap-inline "_InvokeUserEventUPP" 
      ((event (:pointer :eventrecord)) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ColorPickerIncludes

; $ENDC                                         ; __COLORPICKER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ColorPicker)