(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Controls.p"
; at Wednesday May 1,2002 2:39:47 pm.
; 
;      File:       Controls.p
;  
;      Contains:   Control Manager interfaces
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CONTROLS__
; $SETC __CONTROLS__ := 1

; $I+
; $SETC ControlsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTEDIT__
|#

(require-interface 'TextEdit)
#|                                              ; $I TextEdit.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DRAG__
|#

(require-interface 'Drag)
#|                                              ; $I Drag.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ICONS__
|#

(require-interface 'Icons)
#|                                              ; $I Icons.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COLLECTIONS__
|#

(require-interface 'Collections)
#|                                              ; $I Collections.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    Resource Types                                                                                    
; 

(defconstant $kControlDefProcType :|CDEF|)
(defconstant $kControlTemplateResourceType :|CNTL|)
(defconstant $kControlColorTableResourceType :|cctb|)
(defconstant $kControlDefProcResourceType :|CDEF|)

; 		
; 	   Format of a CNTL resource                                                                       	
; 		

(def-mactype :controltemplateptr (find-mactype '(:pointer :controltemplate)))
(defrecord ControlTemplate 
   (controlRect :rect)
   (controlValue :signed-integer)
   (controlVisible :boolean)
   (fill :signed-byte)
   (controlMaximum :signed-integer)
   (controlMinimum :signed-integer)
   (controlDefProcID :signed-integer)
   (controlReference :signed-long)
   (controlTitle (:string 255))
   )

(def-mactype :controltemplatehandle (find-mactype '(:handle :controltemplate)))

#|                                              ; $IFC NOT TARGET_OS_MAC 
; 
; 	  
; 	    NON-MAC COMPATIBILITY CODES (QuickTime 3.0)
; 	  
; 	
(def-mactype :controlnotification (find-mactype ':unsigned-long))

(defconstant $controlNotifyNothing :|nada|)     ;   No (null) notification 
(defconstant $controlNotifyClick :|clik|)       ;   Control was clicked 
(defconstant $controlNotifyFocus :|focu|)       ;   Control got keyboard focus 
(defconstant $controlNotifyKey :|key |)         ;   Control got a keypress 

(def-mactype :controlcapabilities (find-mactype ':unsigned-long))

(defconstant $kControlCanAutoInvalidate #x1)    ;   Control component automatically invalidates areas left behind after hide/move operation. 

;   procID's for our added "controls" 
(defconstant $staticTextProc 256)               ;   static text 
(defconstant $editTextProc 272)                 ;   editable text 
(defconstant $iconProc 288)                     ;   icon 
(defconstant $userItemProc 304)                 ;   user drawn item 
(defconstant $pictItemProc 320)                 ;   pict 

 |#                                             ; $ENDC

; 
;    ControlRef                                                                                        
; 
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 

(def-mactype :controlrecordptr (find-mactype '(:pointer :controlrecord)))
(def-mactype :controlptr (find-mactype '(:pointer :controlrecord)))
(def-mactype :controlref (find-mactype '(:handle :controlrecord)))
#|                                              ; $ELSEC

(def-mactype :controlref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :controlrefptr (find-mactype '(:pointer (:handle :controlrecord))));  when a VAR xx:ControlRef parameter can be nil, it is changed to xx: ControlRefPtr 
 |#                                             ; $ENDC

;   ControlHandle is obsolete. Use ControlRef. 
(def-mactype :controlhandle (find-mactype '(:handle :controlrecord)))
(def-mactype :controlpartcode (find-mactype ':signed-integer))
; 		
; 	  Control ActionProcPtr                                                                              	
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlActionProcPtr = PROCEDURE(theControl: ControlRef; partCode: ControlPartCode);

|#
 |#                                             ; $ELSEC
(def-mactype :controlactionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controlactionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controlactionupp (find-mactype ':pointer))
; $ENDC
; 		
; 	   ControlRecord                                                                                     	
; 		
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(defrecord (ControlRecord :handle) 
   (nextControl (:handle :controlrecord))       ;   in Carbon use embedding heirarchy functions 
   (contrlOwner (:pointer :windowrecord))       ;   in Carbon use GetControlOwner or EmbedControl 
   (contrlRect :rect)                           ;   in Carbon use Get/SetControlBounds 
   (contrlVis :unsigned-byte)                   ;   in Carbon use IsControlVisible, SetControlVisibility 
   (contrlHilite :unsigned-byte)                ;   in Carbon use GetControlHilite, HiliteControl 
   (contrlValue :signed-integer)                ;   in Carbon use Get/SetControlValue, Get/SetControl32BitValue 
   (contrlMin :signed-integer)                  ;   in Carbon use Get/SetControlMinimum, Get/SetControl32BitMinimum 
   (contrlMax :signed-integer)                  ;   in Carbon use Get/SetControlMaximum, Get/SetControl32BitMaximum 
   (contrlDefProc :handle)                      ;   not supported in Carbon 
   (contrlData :handle)                         ;   in Carbon use Get/SetControlDataHandle 
   (contrlAction :pointer)                      ;   in Carbon use Get/SetControlAction 
   (contrlRfCon :signed-long)                   ;   in Carbon use Get/SetControlReference 
   (contrlTitle (:string 255))                  ;   in Carbon use Get/SetControlTitle 
   )

; $ENDC

; 		
; 	  Control ActionProcPtr : Epilogue                                                                   	
; 		

(defconstant $uppControlActionProcInfo #x2C0)
; 
; 	 *  NewControlActionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewControlActionProc 
(deftrap "_NewControlActionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlActionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControlActionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlActionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallControlActionProc 
(deftrap-inline "_InvokeControlActionUPP" 
      ((theControl (:handle :controlrecord)) (partCode :signed-integer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;    Control Color Table                                                                               
; 

(defconstant $cFrameColor 0)
(defconstant $cBodyColor 1)
(defconstant $cTextColor 2)
(defconstant $cThumbColor 3)
(defconstant $kNumberCtlCTabEntries 4)

(def-mactype :ctlctabptr (find-mactype '(:pointer :ctlctab)))
(defrecord (CtlCTab :handle) 
   (ccSeed :signed-long)
   (ccRider :signed-integer)
   (ctSize :signed-integer)
   (ctTable (:array :colorspec 4))
   )

(def-mactype :cctabptr (find-mactype '(:pointer :ctlctab)))
(def-mactype :cctabhandle (find-mactype '(:handle :ctlctab)))
; 		
; 	   Auxiliary Control Record                                                                          	
; 		
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :auxctlrecptr (find-mactype '(:pointer :auxctlrec)))
(defrecord (AuxCtlRec :handle) 
   (acNext :handle)                             ;   not supported in Carbon 
   (acOwner (:handle :controlrecord))           ;   not supported in Carbon 
   (acCTable (:handle :ctlctab))                ;   not supported in Carbon 
   (acFlags :signed-integer)                    ;   not supported in Carbon 
   (acReserved :signed-long)                    ;   not supported in Carbon 
   (acRefCon :signed-long)                      ;   in Carbon use Get/SetControlProperty if you need more refCons 
   )

(def-mactype :auxctlptr (find-mactype '(:pointer :auxctlrec)))
(def-mactype :auxctlhandle (find-mactype '(:handle :auxctlrec)))
; $ENDC

; 		
; 	   Control Variants                                                                  	
; 		
(def-mactype :controlvariant (find-mactype ':signed-integer))

(defconstant $kControlNoVariant 0)              ;   No variant 
(defconstant $kControlUsesOwningWindowsFontVariant #x8);   Control uses owning windows font to display text 

; 		
; 	   Control Part Codes                                                                	
; 		
; 	 Basic part codes 	
(defconstant $kControlNoPart 0)
(defconstant $kControlIndicatorPart 129)
(defconstant $kControlDisabledPart 254)
(defconstant $kControlInactivePart 255)

; 	 Use this constant in Get/SetControlData when the data referred to is not         	
; 	 specific to a part, but rather the entire control, e.g. the list handle of a     	
; 	 list box control.                                                                	
(defconstant $kControlEntireControl 0)

; 	  Meta-Parts                                                                          	
; 	                                                                                      	
; 	  If you haven't guessed from looking at other toolbox headers. We like the word      	
; 	  'meta'. It's cool. So here's one more for you. A meta-part is a part used in a call 	
; 	  to the GetControlRegion API. These parts are parts that might be defined by a       	
; 	  control, but should not be returned from calls like TestControl, et al. They define 	
; 	  a region of a control, presently the structure and the content region. The content  	
; 	  region is only defined by controls that can embed other controls. It is the area    	
; 	  that embedded content can live.                                                     	
; 	                                                                                      	
; 	  Along with these parts, you can also pass in normal part codes to get the regions   	
; 	  of the parts. Not all controls fully support this at the time this was written.     	
(defconstant $kControlStructureMetaPart -1)
(defconstant $kControlContentMetaPart -2)

; 	 focusing part codes 	
(defconstant $kControlFocusNoPart 0)            ;   tells control to clear its focus 
(defconstant $kControlFocusNextPart -1)         ;   tells control to focus on the next part 
(defconstant $kControlFocusPrevPart -2)         ;   tells control to focus on the previous part 

(def-mactype :controlfocuspart (find-mactype ':signed-integer))
; 		
; 	   Control Collection Tags                                                                           	
; 		
; 	  These are standard tags that you will find in the initial data Collection that is passed in the     	
; 	  'param' parameter to the initCntl message (Carbon only).                                            	
; 	                                                                                                      	
; 	  All tags at ID zero in a Control's Collection are reserved for Control Manager use.                 	
; 	  Custom control definitions should use other IDs.                                                    	
; 	                                                                                                      	
; 	  Most of these tags are interpreted when you call CreateCustomControl; the Control Manager will      	
; 	  put value in the right place before calling the Control Definition with the initialization message. 	

(defconstant $kControlCollectionTagBounds :|boun|);   Rect - the bounding rectangle 
(defconstant $kControlCollectionTagValue :|valu|);   SInt32 - the value 
(defconstant $kControlCollectionTagMinimum :|min |);   SInt32 - the minimum 
(defconstant $kControlCollectionTagMaximum :|max |);   SInt32 - the maximum 
(defconstant $kControlCollectionTagViewSize :|view|);   SInt32 - the view size 
(defconstant $kControlCollectionTagVisibility :|visi|);   Boolean - the visible state 
(defconstant $kControlCollectionTagRefCon :|refc|);   SInt32 - the refCon 
(defconstant $kControlCollectionTagTitle :|titl|);   arbitrarily sized character array - the title 
(defconstant $kControlCollectionTagUnicodeTitle :|uttl|);   bytes as received via CFStringCreateExternalRepresentation 
(defconstant $kControlCollectionTagIDSignature :|idsi|);   OSType - the ControlID signature 
(defconstant $kControlCollectionTagIDID :|idid|);   SInt32 - the ControlID id 
(defconstant $kControlCollectionTagCommand :|cmd |);   UInt32 - the command 
(defconstant $kControlCollectionTagVarCode :|varc|);   SInt16 - the variant 

; 		
; 	   Control Image Content                                                                             	
; 		
(defconstant $kControlContentTextOnly 0)
(defconstant $kControlNoContent 0)
(defconstant $kControlContentIconSuiteRes 1)
(defconstant $kControlContentCIconRes 2)
(defconstant $kControlContentPictRes 3)
(defconstant $kControlContentICONRes 4)
(defconstant $kControlContentIconSuiteHandle 129)
(defconstant $kControlContentCIconHandle 130)
(defconstant $kControlContentPictHandle 131)
(defconstant $kControlContentIconRef 132)
(defconstant $kControlContentICON 133)

(def-mactype :controlcontenttype (find-mactype ':signed-integer))
(def-mactype :controlbuttoncontentinfoptr (find-mactype '(:pointer :controlbuttoncontentinfo)))
(defrecord ControlButtonContentInfo 
   (contentType :signed-integer)
   (:variant 
      (
      (resID :signed-integer)
      )
      (
      (CIconHandle (:handle :cicon))
      )
      (
      (iconSuite :handle)
      )
      (
      (IconRef :pointer)
      )
      (
      (picture (:handle :picture))
      )
      (
      (ICONHandle :handle)
      )
      )
   )

(%define-record :controlimagecontentinfo (find-record-descriptor :controlbuttoncontentinfo))
(def-mactype :controlimagecontentinfoptr (find-mactype '(:pointer :controlbuttoncontentinfo)))
; 		
; 	   Control Key Script Behavior                                                                       	
; 		

(defconstant $kControlKeyScriptBehaviorAllowAnyScript :|any |);   leaves the current keyboard alone and allows user to change the keyboard. 
(defconstant $kControlKeyScriptBehaviorPrefersRoman :|prmn|);   switches the keyboard to roman, but allows them to change it as desired. 
(defconstant $kControlKeyScriptBehaviorRequiresRoman :|rrmn|);   switches the keyboard to roman and prevents the user from changing it. 

(def-mactype :controlkeyscriptbehavior (find-mactype ':unsigned-long))
; 		
; 	   Control Font Style                                                                                	
; 		
; 	    SPECIAL FONT USAGE NOTES: You can specify the font to use for many control types.
; 	    The constants below are meta-font numbers which you can use to set a particular
; 	    control's font usage. There are essentially two modes you can use: 1) default,
; 	    which is essentially the same as it always has been, i.e. it uses the system font, unless
; 	    directed to use the window font via a control variant. 2) you can specify to use
; 	    the big or small system font in a generic manner. The Big system font is the font
; 	    used in menus, etc. Chicago has filled that role for some time now. Small system
; 	    font is currently Geneva 10. The meta-font number implies the size and style.
; 	
; 	    NOTE:       Not all font attributes are used by all controls. Most, in fact, ignore
; 	                the fore and back color (Static Text is the only one that does, for
; 	                backwards compatibility). Also size, face, and addFontSize are ignored
; 	                when using the meta-font numbering.
; 		
; 	 Meta-font numbering - see note above 	

(defconstant $kControlFontBigSystemFont -1)     ;   force to big system font 
(defconstant $kControlFontSmallSystemFont -2)   ;   force to small system font 
(defconstant $kControlFontSmallBoldSystemFont -3);   force to small bold system font 
(defconstant $kControlFontViewSystemFont -4)    ;   force to views system font (DataBrowser control only) 

; 	 Add these masks together to set the flags field of a ControlFontStyleRec 	
; 	 They specify which fields to apply to the text. It is important to make  	
; 	 sure that you specify only the fields that you wish to set.              	
(defconstant $kControlUseFontMask #x1)
(defconstant $kControlUseFaceMask #x2)
(defconstant $kControlUseSizeMask #x4)
(defconstant $kControlUseForeColorMask #x8)
(defconstant $kControlUseBackColorMask #x10)
(defconstant $kControlUseModeMask #x20)
(defconstant $kControlUseJustMask #x40)
(defconstant $kControlUseAllMask #xFF)
(defconstant $kControlAddFontSizeMask #x100)

; 	 AddToMetaFont indicates that we want to start with a standard system     	
; 	 font, but then we'd like to add the other attributes. Normally, the meta 	
; 	 font ignores all other flags                                             	
(defconstant $kControlAddToMetaFontMask #x200)  ;   Available in Appearance 1.1 or later 

; 	 UseThemeFontID indicates that the font field of the ControlFontStyleRec  	
; 	 should be interpreted as a ThemeFontID (see Appearance.h). In all other  	
; 	 ways, specifying a ThemeFontID is just like using one of the control     	
; 	 meta-fonts IDs.                                                          	
(defconstant $kControlUseThemeFontIDMask #x80)  ;   Available in Mac OS X or later 

(def-mactype :controlfontstylerecptr (find-mactype '(:pointer :controlfontstylerec)))
(defrecord ControlFontStyleRec 
   (flags :signed-integer)
   (font :signed-integer)
   (size :signed-integer)
   (style :signed-integer)
   (mode :signed-integer)
   (just :signed-integer)
   (foreColor :rgbcolor)
   (backColor :rgbcolor)
   )

(def-mactype :controlfontstyleptr (find-mactype '(:pointer :controlfontstylerec)))
; 		
; 	   Click Activation Results                                                                          	
; 		
; 	  These are for use with GetControlClickActivation. The enumerated values should be pretty            	
; 	  self-explanatory, but just in case:                                                                 	
; 	   Activate/DoNotActivate indicates whether or not to change the owning window's z-ordering before   	
; 	      processing the click. If activation is requested, you may also want to immediately redraw the   	
; 	      newly exposed portion of the window.                                                            	
; 	   Ignore/Handle Click indicates whether or not to call an appropriate click handling API (like      	
; 	      HandleControlClick) in respose to the event.                                                    	

(defconstant $kDoNotActivateAndIgnoreClick 0)   ;   probably never used. here for completeness. 
(defconstant $kDoNotActivateAndHandleClick 1)   ;   let the control handle the click while the window is still in the background. 
(defconstant $kActivateAndIgnoreClick 2)        ;   control doesn't want to respond directly to the click, but window should still be brought forward. 
(defconstant $kActivateAndHandleClick 3)        ;   control wants to respond to the click, but only after the window has been activated. 

(def-mactype :clickactivationresult (find-mactype ':unsigned-long))
; 		
; 	   Common data tags for Get/SetControlData                                                           	
; 		

; 
; 	 *  Discussion:
; 	 *    Get/SetControlData Common Tags
; 	 	

(defconstant $kControlFontStyleTag :|font|)
(defconstant $kControlKeyFilterTag :|fltr|)
(defconstant $kControlKindTag :|kind|)
(defconstant $kControlSizeTag :|size|)

; 		
; 	   Control Feature Bits                                                                              	
; 		
;   Control feature bits - returned by GetControlFeatures  
(defconstant $kControlSupportsGhosting #x1)
(defconstant $kControlSupportsEmbedding #x2)
(defconstant $kControlSupportsFocus #x4)
(defconstant $kControlWantsIdle #x8)
(defconstant $kControlWantsActivate #x10)
(defconstant $kControlHandlesTracking #x20)
(defconstant $kControlSupportsDataAccess #x40)
(defconstant $kControlHasSpecialBackground #x80)
(defconstant $kControlGetsFocusOnClick #x100)
(defconstant $kControlSupportsCalcBestRect #x200)
(defconstant $kControlSupportsLiveFeedback #x400)
(defconstant $kControlHasRadioBehavior #x800)   ;   Available in Appearance 1.0.1 or later 
(defconstant $kControlSupportsDragAndDrop #x1000);   Available in Carbon 
(defconstant $kControlAutoToggles #x4000)       ;   Available in Appearance 1.1 or later 
(defconstant $kControlSupportsGetRegion #x20000);   Available in Appearance 1.1 or later 
(defconstant $kControlSupportsFlattening #x80000);   Available in Carbon 
(defconstant $kControlSupportsSetCursor #x100000);   Available in Carbon 
(defconstant $kControlSupportsContextualMenus #x200000);   Available in Carbon 
(defconstant $kControlSupportsClickActivation #x400000);   Available in Carbon 
(defconstant $kControlIdlesWithTimer #x800000)  ;   Available in Carbon - this bit indicates that the control animates automatically 

; 		
; 	   Control Messages                                                                                  	
; 		
(defconstant $drawCntl 0)
(defconstant $testCntl 1)
(defconstant $calcCRgns 2)
(defconstant $initCntl 3)                       ;   Param is Collection, result is OSStatus 
(defconstant $dispCntl 4)
(defconstant $posCntl 5)
(defconstant $thumbCntl 6)
(defconstant $dragCntl 7)
(defconstant $autoTrack 8)
(defconstant $calcCntlRgn 10)
(defconstant $calcThumbRgn 11)
(defconstant $drawThumbOutline 12)
(defconstant $kControlMsgDrawGhost 13)
(defconstant $kControlMsgCalcBestRect 14)       ;   Calculate best fitting rectangle for control 
(defconstant $kControlMsgHandleTracking 15)
(defconstant $kControlMsgFocus 16)              ;   param indicates action. 
(defconstant $kControlMsgKeyDown 17)
(defconstant $kControlMsgIdle 18)
(defconstant $kControlMsgGetFeatures 19)
(defconstant $kControlMsgSetData 20)
(defconstant $kControlMsgGetData 21)
(defconstant $kControlMsgActivate 22)
(defconstant $kControlMsgSetUpBackground 23)
(defconstant $kControlMsgCalcValueFromPos 26)
(defconstant $kControlMsgTestNewMsgSupport 27)  ;   See if this control supports new messaging 
(defconstant $kControlMsgSubValueChanged 25)    ;   Available in Appearance 1.0.1 or later 
(defconstant $kControlMsgSubControlAdded 28)    ;   Available in Appearance 1.0.1 or later 
(defconstant $kControlMsgSubControlRemoved 29)  ;   Available in Appearance 1.0.1 or later 
(defconstant $kControlMsgApplyTextColor 30)     ;   Available in Appearance 1.1 or later 
(defconstant $kControlMsgGetRegion 31)          ;   Available in Appearance 1.1 or later 
(defconstant $kControlMsgFlatten 32)            ;   Available in Carbon. Param is Collection. 
(defconstant $kControlMsgSetCursor 33)          ;   Available in Carbon. Param is ControlSetCursorRec 
(defconstant $kControlMsgDragEnter 38)          ;   Available in Carbon. Param is DragRef, result is boolean indicating acceptibility of drag. 
(defconstant $kControlMsgDragLeave 39)          ;   Available in Carbon. As above. 
(defconstant $kControlMsgDragWithin 40)         ;   Available in Carbon. As above. 
(defconstant $kControlMsgDragReceive 41)        ;   Available in Carbon. Param is DragRef, result is OSStatus indicating success/failure. 
(defconstant $kControlMsgDisplayDebugInfo 46)   ;   Available in Carbon on X. 
(defconstant $kControlMsgContextualMenuClick 47);   Available in Carbon. Param is ControlContextualMenuClickRec 
(defconstant $kControlMsgGetClickActivation 48) ;   Available in Carbon. Param is ControlClickActivationRec 

(def-mactype :controldefprocmessage (find-mactype ':signed-integer))
; 		
; 	   Control Sizes                                                                     	
; 		

(defconstant $kControlSizeNormal 0)
(defconstant $kControlSizeSmall 1)
(defconstant $kControlSizeLarge 2)
(defconstant $kControlSizeAuto #xFFFF)

(def-mactype :controlsize (find-mactype ':unsigned-integer))
; 		
; 	   Constants for drawCntl message (passed in param)                                  	
; 		

(defconstant $kDrawControlEntireControl 0)
(defconstant $kDrawControlIndicatorOnly 129)

; 		
; 	   Constants for dragCntl message (passed in param)                                  	
; 		
(defconstant $kDragControlEntireControl 0)
(defconstant $kDragControlIndicator 1)

; 		
; 	   Drag Constraint Structure for thumbCntl message (passed in param)                 	
; 		

(def-mactype :indicatordragconstraintptr (find-mactype '(:pointer :indicatordragconstraint)))
(defrecord IndicatorDragConstraint 
   (limitRect :rect)
   (slopRect :rect)
   (axis :unsigned-integer)
   )

; 		
; 	  CDEF should return as result of kControlMsgTestNewMsgSupport                        	
; 		

(defconstant $kControlSupportsNewMessages :| ok |)

; 		
; 	  This structure is passed into a CDEF when called with the kControlMsgHandleTracking 	
; 	  message                                                                             	
; 		

(def-mactype :controltrackingrecptr (find-mactype '(:pointer :controltrackingrec)))
(defrecord ControlTrackingRec 
   (startPt :point)
   (modifiers :unsigned-integer)
   (action :pointer)
   )

(def-mactype :controltrackingptr (find-mactype '(:pointer :controltrackingrec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlMsgKeyDown message 	
; 		
(def-mactype :controlkeydownrecptr (find-mactype '(:pointer :controlkeydownrec)))
(defrecord ControlKeyDownRec 
   (modifiers :unsigned-integer)
   (keyCode :signed-integer)
   (charCode :signed-integer)
   )

(def-mactype :controlkeydownptr (find-mactype '(:pointer :controlkeydownrec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlMsgGetData or      	
; 	 kControlMsgSetData message                                                           	
; 		
(def-mactype :controldataaccessrecptr (find-mactype '(:pointer :controldataaccessrec)))
(defrecord ControlDataAccessRec 
   (tag :ostype)
   (part :ostype)
   (Size :signed-long)
   (dataPtr :pointer)
   )

(def-mactype :controldataaccessptr (find-mactype '(:pointer :controldataaccessrec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlCalcBestRect msg   	
; 		
(def-mactype :controlcalcsizerecptr (find-mactype '(:pointer :controlcalcsizerec)))
(defrecord ControlCalcSizeRec 
   (height :signed-integer)
   (width :signed-integer)
   (baseLine :signed-integer)
   )

(def-mactype :controlcalcsizeptr (find-mactype '(:pointer :controlcalcsizerec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlMsgSetUpBackground 	
; 	 message is sent                                                                      	
; 		
(def-mactype :controlbackgroundrecptr (find-mactype '(:pointer :controlbackgroundrec)))
(defrecord ControlBackgroundRec 
   (depth :signed-integer)
   (colorDevice :boolean)
   )

(def-mactype :controlbackgroundptr (find-mactype '(:pointer :controlbackgroundrec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlMsgApplyTextColor  	
; 	 message is sent                                                                      	
; 		
(def-mactype :controlapplytextcolorrecptr (find-mactype '(:pointer :controlapplytextcolorrec)))
(defrecord ControlApplyTextColorRec 
   (depth :signed-integer)
   (colorDevice :boolean)
   (active :boolean)
   )

(def-mactype :controlapplytextcolorptr (find-mactype '(:pointer :controlapplytextcolorrec)))
; 		
; 	 This structure is passed into a CDEF when called with the kControlMsgGetRegion       	
; 	 message is sent                                                                      	
; 		
(def-mactype :controlgetregionrecptr (find-mactype '(:pointer :controlgetregionrec)))
(defrecord ControlGetRegionRec 
   (region (:handle :macregion))
   (part :signed-integer)
   )

(def-mactype :controlgetregionptr (find-mactype '(:pointer :controlgetregionrec)))
; 		
; 	 This structure is passed into a CDEF when the kControlMsgSetCursor message is sent   	
; 	 Only sent on Carbon                                                                  	
; 		
(def-mactype :controlsetcursorrecptr (find-mactype '(:pointer :controlsetcursorrec)))
(defrecord ControlSetCursorRec 
   (localPoint :point)
   (modifiers :unsigned-integer)
   (cursorWasSet :boolean)                      ;   your CDEF must set this to true if you set the cursor, or false otherwise 
   )

(def-mactype :controlsetcursorptr (find-mactype '(:pointer :controlsetcursorrec)))
; 		
; 	 This structure is passed into a CDEF when the kControlMsgContextualMenuClick message 	
; 	 is sent                                                                              	
; 	 Only sent on Carbon                                                                  	
; 		
(def-mactype :controlcontextualmenuclickrecptr (find-mactype '(:pointer :controlcontextualmenuclickrec)))
(defrecord ControlContextualMenuClickRec 
   (localPoint :point)
   (menuDisplayed :boolean)                     ;   your CDEF must set this to true if you displayed a menu, or false otherwise 
   )

(def-mactype :controlcontextualmenuclickptr (find-mactype '(:pointer :controlcontextualmenuclickrec)))
; 		
; 	 This structure is passed into a CDEF when the kControlMsgGetClickActivation message  	
; 	 is sent                                                                              	
; 	 Only sent on Carbon                                                                  	
; 		
(def-mactype :controlclickactivationrecptr (find-mactype '(:pointer :controlclickactivationrec)))
(defrecord ControlClickActivationRec 
   (localPoint :point)
   (modifiers :unsigned-integer)
   (result :unsigned-long)                      ;   your CDEF must pass the desired result back 
   )

(def-mactype :controlclickactivationptr (find-mactype '(:pointer :controlclickactivationrec)))
; 		
; 	   CDEF entrypoint                                                                 	
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlDefProcPtr = FUNCTION(varCode: SInt16; theControl: ControlRef; message: ControlDefProcMessage; param: SInt32): SInt32;

|#
 |#                                             ; $ELSEC
(def-mactype :controldefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controldefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controldefupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppControlDefProcInfo #x3BB0)
; 
; 	 *  NewControlDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewControlDefProc 
(deftrap "_NewControlDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControlDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallControlDefProc 
(deftrap-inline "_InvokeControlDefUPP" 
      ((varCode :signed-integer) (theControl (:handle :controlrecord)) (message :signed-integer) (param :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;   Control Key Filter                                                                  
; 
;  Certain controls can have a keyfilter attached to them.                              
;  Definition of a key filter for intercepting and possibly changing keystrokes         
;  which are destined for a control.                                                    
;  Key Filter Result Codes                                                          
;  The filter proc should return one of the two constants below. If                 
;  kKeyFilterBlockKey is returned, the key is blocked and never makes it to the     
;  control. If kKeyFilterPassKey is returned, the control receives the keystroke.   

(defconstant $kControlKeyFilterBlockKey 0)
(defconstant $kControlKeyFilterPassKey 1)

(def-mactype :controlkeyfilterresult (find-mactype ':signed-integer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlKeyFilterProcPtr = FUNCTION(theControl: ControlRef; VAR keyCode: SInt16; VAR charCode: SInt16; VAR modifiers: EventModifiers): ControlKeyFilterResult;

|#
 |#                                             ; $ELSEC
(def-mactype :controlkeyfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controlkeyfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controlkeyfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppControlKeyFilterProcInfo #x3FE0)
; 
; 	 *  NewControlKeyFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewControlKeyFilterProc 
(deftrap "_NewControlKeyFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlKeyFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControlKeyFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlKeyFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallControlKeyFilterProc 
(deftrap-inline "_InvokeControlKeyFilterUPP" 
      ((theControl (:handle :controlrecord)) (keyCode (:pointer :signed-integer)) (charCode (:pointer :signed-integer)) (modifiers (:pointer :unsigned-integer)) (userRoutine :pointer)) 
  :controlkeyfilterresult
   (#x205F #x4E90) )

; 
;    DragGrayRgn Constatns                                                             
;                                                                                       
;    For DragGrayRgnUPP used in TrackControl()                                          
; 

(defconstant $noConstraint 0)
(defconstant $hAxisOnly 1)
(defconstant $vAxisOnly 2)

; 		
; 	   Control Creation/Deletion/Persistence                                             	
; 		
; 	  CreateCustomControl is only available as part of Carbon                             	
(defconstant $kControlDefProcPtr 0)             ;   raw proc-ptr based access 
(defconstant $kControlDefObjectClass 1)         ;   event-based definition (Mac OS X only) 

(def-mactype :controldeftype (find-mactype ':unsigned-long))
(def-mactype :controldefspecptr (find-mactype '(:pointer :controldefspec)))
(defrecord ControlDefSpec 
   (defType :unsigned-long)
   (:variant 
      (
      (defProc :pointer)
      )
      (
      (classRef :pointer)
      )
      )
   )

; 
; 	 *  CreateCustomControl()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; CONST; 
;  *  NewControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateCustomControl" 
      ((owningWindow (:pointer :windowrecord)) (contBounds (:pointer :rect)) (def (:pointer :controldefspec)) (initData :pointer) (outControl (:pointer (:handle :controlrecord)))) 
  :osstatus
   () )                                         ; CONST
(deftrap "_NewControl" 
      ((owningWindow (:pointer :windowrecord)) (boundsRect (:pointer :rect)) (controlTitle (:string 255)) (initiallyVisible :boolean) (initialValue :signed-integer) (minimumValue :signed-integer) (maximumValue :signed-integer) (procID :signed-integer) (controlReference :signed-long))
   (:stack (:handle :controlrecord))
   (:stack-trap #xA954))

; 
;  *  GetNewControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNewControl" 
      ((resourceID :signed-integer) (owningWindow (:pointer :windowrecord)))
   (:stack (:handle :controlrecord))
   (:stack-trap #xA9BE))

; 
;  *  DisposeControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControl" 
      ((theControl (:handle :controlrecord)))
   nil
   (:stack-trap #xA955))

; 
;  *  KillControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_KillControls" 
      ((theWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xA956))

; 
;    Control Definition Registration                                                   
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlCNTLToCollectionProcPtr = FUNCTION({CONST}VAR bounds: Rect; value: SInt16; visible: BOOLEAN; max: SInt16; min: SInt16; procID: SInt16; refCon: SInt32; title: Str255; collection: Collection): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :controlcntltocollectionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controlcntltocollectionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controlcntltocollectionupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppControlCNTLToCollectionProcInfo #xFEA6F0)
; 
; 	 *  NewControlCNTLToCollectionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewControlCNTLToCollectionProc 
(deftrap "_NewControlCNTLToCollectionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlCNTLToCollectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControlCNTLToCollectionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlCNTLToCollectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallControlCNTLToCollectionProc 
(deftrap-inline "_InvokeControlCNTLToCollectionUPP" 
      ((bounds (:pointer :rect)) (value :signed-integer) (visible :boolean) (max :signed-integer) (min :signed-integer) (procID :signed-integer) (refCon :signed-long) (title (:string 255)) (Collection :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  RegisterControlDefinition()
;  *  
;  *  Summary:
;  *    Associates or dissociates a control definition with a virtual
;  *    CDEF resource ID.
;  *  
;  *  Discussion:
;  *    In GetNewControl or NewControl on Carbon, the Control Manager
;  *    needs to know how to map the procID to a ControlDefSpec. With
;  *    RegisterControlDefinition, your application can inform the
;  *    Control Manager which ControlDefSpec to call when it sees a
;  *    request to use a 'CDEF' of a particular resource ID. Since custom
;  *    control definitions receive their initialization data in a
;  *    Collection passed in the 'param' parameter, you must also provide
;  *    a procedure to convert the bounds, min, max, and other parameters
;  *    to NewControl into a Collection. If you don't provide a
;  *    conversion proc, your control will receive an empty collection
;  *    when it is sent the initialization message. If you want the
;  *    value, min, visibility, etc. to be given to the control, you must
;  *    add the appropriate tagged data to the collection. See the
;  *    Control Collection Tags above. If you want to unregister a
;  *    ControlDefSpec that you have already registered, call
;  *    RegisterControlDefinition with the same CDEF resource ID, but
;  *    pass NULL for the inControlDef parameter. In this situation,
;  *    inConversionProc is effectively ignored.
;  *  
;  *  Parameters:
;  *    
;  *    inCDEFResID:
;  *      The virtual CDEF resource ID to which you'd like to associate
;  *      or dissociate the control definition.
;  *    
;  *    inControlDef:
;  *      A pointer to a ControlDefSpec which represents the control
;  *      definition you want to register, or NULL if you are attempting
;  *      to unregister a control definition.
;  *    
;  *    inConversionProc:
;  *      The conversion proc which will translate the NewControl
;  *      parameters into a Collection.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; ;    Control Visible State                                                             ; ; 
;  *  HiliteControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RegisterControlDefinition" 
      ((inCDEFResID :signed-integer) (inControlDef (:pointer :controldefspec)) (inConversionProc :pointer)) 
  :osstatus
   () )
(deftrap "_HiliteControl" 
      ((theControl (:handle :controlrecord)) (hiliteState :signed-integer))
   nil
   (:stack-trap #xA95D))

; 
;  *  ShowControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ShowControl" 
      ((theControl (:handle :controlrecord)))
   nil
   (:stack-trap #xA957))

; 
;  *  HideControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HideControl" 
      ((theControl (:handle :controlrecord)))
   nil
   (:stack-trap #xA958))

;   following state routines available only with Appearance 1.0 and later 
; 
;  *  IsControlActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsControlActive" 
      ((inControl (:handle :controlrecord)))
   (:stack :boolean)
   (:stack-trap #xAA73 :d0 5 inControl))

; 
;  *  IsControlVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsControlVisible" 
      ((inControl (:handle :controlrecord)))
   (:stack :boolean)
   (:stack-trap #xAA73 :d0 6 inControl))

; 
;  *  ActivateControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ActivateControl" 
      ((inControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 7 inControl))

; 
;  *  DeactivateControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeactivateControl" 
      ((inControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 8 inControl))

; 
;  *  SetControlVisibility()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlVisibility" 
      ((inControl (:handle :controlrecord)) (inIsVisible :boolean) (inDoDraw :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 30 inControl inIsVisible inDoDraw))

;   following state routines available only on Mac OS X and later 
; 
;  *  IsControlEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  EnableControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsControlEnabled" 
      ((inControl (:handle :controlrecord))) 
  :boolean
   () )                                         ; 
;  *  DisableControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EnableControl" 
      ((inControl (:handle :controlrecord))) 
  :osstatus
   () )                                         ; ;    Control Imaging                                                                   ; ; 
;  *  DrawControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableControl" 
      ((inControl (:handle :controlrecord))) 
  :osstatus
   () )
(deftrap "_DrawControls" 
      ((theWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xA969))

; 
;  *  Draw1Control()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Draw1Control" 
      ((theControl (:handle :controlrecord)))
   nil
   (:stack-trap #xA96D))

; 
;  *  UpdateControls()
;  *  
;  *  Summary:
;  *    Redraws the controls that intersect a specified region in a
;  *    window.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose controls to redraw.
;  *    
;  *    inUpdateRegion:
;  *      The region (in local coordinates) describing which controls to
;  *      redraw. In Mac OS 10.1 and later, and in CarbonLib 1.5 and
;  *      later, you may pass NULL for this parameter to redraw the
;  *      controls intersecting the visible region of the window.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UpdateControls" 
      ((inWindow (:pointer :windowrecord)) (inUpdateRegion (:handle :macregion)))
   nil
   (:stack-trap #xA953))

;   following imaging routines available only with Appearance 1.0 and later 
; 
;  *  GetBestControlRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetBestControlRect" 
      ((inControl (:handle :controlrecord)) (outRect (:pointer :rect)) (outBaseLineOffset (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 27 inControl outRect outBaseLineOffset))

; 
;  *  SetControlFontStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SetControlFontStyle" 
      ((inControl (:handle :controlrecord)) (inStyle (:pointer :controlfontstylerec)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 28 inControl inStyle))

; 
;  *  DrawControlInCurrentPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawControlInCurrentPort" 
      ((inControl (:handle :controlrecord)))
   nil
   (:stack-trap #xAA73 :d0 24 inControl))

; 
;  *  SetUpControlBackground()
;  *  
;  *  Summary:
;  *    Applies the proper background color for the given control to the
;  *    current port.
;  *  
;  *  Discussion:
;  *    An embedding-savvy control which erases before drawing must
;  *    ensure that its background color properly matches the body color
;  *    of any parent controls on top of which it draws. This routine
;  *    asks the Control Manager to determine and apply the proper
;  *    background color to the current port. If a ControlColorProc has
;  *    been provided for the given control, the proc will be called to
;  *    set up the background color. If no proc exists, or if the proc
;  *    returns a value other than noErr, the Control Manager ascends the
;  *    parent chain for the given control looking for a control which
;  *    has a special background (see the kControlHasSpecialBackground
;  *    feature bit). The first such parent is asked to set up the
;  *    background color (see the kControlMsgSetUpBackground message). If
;  *    no such parent exists, the Control Manager applies any ThemeBrush
;  *    which has been associated with the owning window (see
;  *    SetThemeWindowBackground). Available in Appearance 1.0 (Mac OS
;  *    8), CarbonLib 1.0, Mac OS X, and later.
;  *  
;  *  Parameters:
;  *    
;  *    inControl:
;  *      The ControlRef that wants to erase.
;  *    
;  *    inDepth:
;  *      A short integer indicating the color depth of the device onto
;  *      which drawing will take place.
;  *    
;  *    inIsColorDevice:
;  *      A Boolean indicating whether the draw device is a color device.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure. The most likely
;  *    error is a controlHandleInvalidErr, resulting from a bad
;  *    ControlRef. Any non-noErr result indicates that the color set up
;  *    failed, and that the caller should probably give up its attempt
;  *    to draw.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetUpControlBackground" 
      ((inControl (:handle :controlrecord)) (inDepth :signed-integer) (inIsColorDevice :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 29 inControl inDepth inIsColorDevice))

; 
;  *  SetUpControlTextColor()
;  *  
;  *  Summary:
;  *    Applies the proper text color for the given control to the
;  *    current port.
;  *  
;  *  Discussion:
;  *    An embedding-savvy control which draws text must ensure that its
;  *    text color properly contrasts the background on which it draws.
;  *    This routine asks the Control Manager to determine and apply the
;  *    proper text color to the current port. If a ControlColorProc has
;  *    been provided for the given control, the proc will be called to
;  *    set up the text color. If no proc exists, or if the proc returns
;  *    a value other than noErr, the Control Manager ascends the parent
;  *    chain for the given control looking for a control which has a
;  *    special background (see the kControlHasSpecialBackground feature
;  *    bit). The first such parent is asked to set up the text color
;  *    (see the kControlMsgApplyTextColor message). If no such parent
;  *    exists, the Control Manager chooses a text color which contrasts
;  *    any ThemeBrush which has been associated with the owning window
;  *    (see SetThemeWindowBackground). Available in Appearance 1.1 (Mac
;  *    OS 8.5), CarbonLib 1.0, Mac OS X, and later.
;  *  
;  *  Parameters:
;  *    
;  *    inControl:
;  *      The ControlRef that wants to draw text.
;  *    
;  *    inDepth:
;  *      A short integer indicating the color depth of the device onto
;  *      which drawing will take place.
;  *    
;  *    inIsColorDevice:
;  *      A Boolean indicating whether the draw device is a color device.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure. The most likely
;  *    error is a controlHandleInvalidErr, resulting from a bad
;  *    ControlRef. Any non-noErr result indicates that the color set up
;  *    failed, and that the caller should probably give up its attempt
;  *    to draw.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  ControlColorProcPtr
;  *  
;  *  Discussion:
;  *    Callback allowing clients to specify/override the background
;  *    color and text color that a Control will use during drawing. Your
;  *    procedure should make the color changes to the current port. See
;  *    SetControlColorProc, SetUpControlBackground, and
;  *    SetUpControlTextColor for more information. Available on Mac OS
;  *    8.5, CarbonLib 1.1, Mac OS X, and later.
;  *  
;  *  Parameters:
;  *    
;  *    inControl:
;  *      A reference to the Control for whom your proc is setting up
;  *      colors.
;  *    
;  *    inMessage:
;  *      A ControlDefProcMessage indicating what sort of color your
;  *      procedure should set up. It will be either
;  *      kControlMsgApplyTextColor or kControlMsgSetUpBackground.
;  *      kControlMsgApplyTextColor is a request to set up the
;  *      appropriate text color (by setting the current port's
;  *      foreground color, pen information, etc.).
;  *      kControlMsgSetUpBackground is a request to set up the
;  *      appropriate background color (the current port's background
;  *      color, pattern, etc.).
;  *    
;  *    inDrawDepth:
;  *      A short integer indicating the bit depth of the device into
;  *      which the Control is drawing. The bit depth is typically passed
;  *      in as a result of someone someone trying to draw properly
;  *      across multiple monitors with different bit depths. If your
;  *      procedure wants to handle proper color set up based on bit
;  *      depth, it should use this parameter to help decide what color
;  *      to apply.
;  *    
;  *    inDrawInColor:
;  *      A Boolean indicating whether or not the device that the Control
;  *      is drawing into is a color device. The value is typically
;  *      passed in as a result of someone trying to draw properly across
;  *      multiple monitors which may or may not be color devices. If
;  *      your procedure wants to handle proper color set up for both
;  *      color and grayscale devices, it should use this parameter to
;  *      help decide what color to apply.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure. Returning noErr
;  *    is an indication that your proc completely handled the color set
;  *    up. If you return any other value, the Control Manager will fall
;  *    back to the normal color set up mechanism.
;  
(deftrap-inline "_SetUpControlTextColor" 
      ((inControl (:handle :controlrecord)) (inDepth :signed-integer) (inIsColorDevice :boolean)) 
  :signed-integer
   () )
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlColorProcPtr = FUNCTION(inControl: ControlRef; inMessage: SInt16; inDrawDepth: SInt16; inDrawInColor: BOOLEAN): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :controlcolorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controlcolorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controlcolorupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppControlColorProcInfo #x1AF0)
; 
; 	 *  NewControlColorUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewControlColorProc 
(deftrap "_NewControlColorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlColorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeControlColorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlColorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallControlColorProc 
(deftrap-inline "_InvokeControlColorUPP" 
      ((inControl (:handle :controlrecord)) (inMessage :signed-integer) (inDrawDepth :signed-integer) (inDrawInColor :boolean) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  SetControlColorProc()
;  *  
;  *  Summary:
;  *    Associates a ControlColorUPP with a given Control, thereby
;  *    allowing you to bypass the embedding hierarchy-based color setup
;  *    of SetUpControlBackground/SetUpControlTextColor and replace it
;  *    with your own.
;  *  
;  *  Discussion:
;  *    Before an embedded Control can erase, it calls
;  *    SetUpControlBackground to have its background color set up by any
;  *    parent controls. Similarly, any Control which draws text calls
;  *    SetUpControlTextColor to have the appropriate text color set up.
;  *    This allows certain controls (such as Tabs and Placards) to offer
;  *    special backgrounds and text colors for any child controls. By
;  *    default, the SetUp routines only move up the Control Manager
;  *    embedding hierarchy looking for a parent which has a special
;  *    background. This is fine in a plain vanilla embedding case, but
;  *    many application frameworks find it troublesome; if there are
;  *    interesting views between two Controls in the embedding
;  *    hierarchy, the framework needs to be in charge of the background
;  *    and text colors, otherwise drawing defects will occur. You can
;  *    only associate a single color proc with a given ControlRef.
;  *    Available on Mac OS 8.5, CarbonLib 1.1, Mac OS X, and later.
;  *  
;  *  Parameters:
;  *    
;  *    inControl:
;  *      The ControlRef with whom the color proc should be associated.
;  *    
;  *    inProc:
;  *      The color proc to associate with the ControlRef. If you pass
;  *      NULL, the ControlRef will be dissociated from any previously
;  *      installed color proc.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure. The most likely
;  *    error is a controlHandleInvalidErr resulting from a bad
;  *    ControlRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; ;    Control Mousing                                                                   ; ; 
;     NOTE ON CONTROL ACTION PROCS
; 
;     When using the TrackControl() call when tracking an indicator, the actionProc parameter
;     (type ControlActionUPP) should be replaced by a parameter of type DragGrayRgnUPP
;     (see Quickdraw.h).
; 
;     If, however, you are using the live feedback variants of scroll bars or sliders, you
;     must pass a ControlActionUPP in when tracking the indicator as well. This functionality
;     is available in Appearance 1.0 or later.
;                                               ; 
;  *  TrackControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlColorProc" 
      ((inControl (:handle :controlrecord)) (inProc :pointer)) 
  :osstatus
   () )
(deftrap "_TrackControl" 
      ((theControl (:handle :controlrecord)) (startPoint :point) (actionProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA968))

; 
;  *  DragControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_DragControl" 
      ((theControl (:handle :controlrecord)) (startPoint :point) (limitRect (:pointer :rect)) (slopRect (:pointer :rect)) (axis :unsigned-integer))
   nil
   (:stack-trap #xA967))

; 
;  *  TestControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TestControl" 
      ((theControl (:handle :controlrecord)) (testPoint :point))
   (:stack :signed-integer)
   (:stack-trap #xA966))

; 
;  *  FindControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindControl" 
      ((testPoint :point) (theWindow (:pointer :windowrecord)) (theControl (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA96C))

;  The following mousing routines available only with Appearance 1.0 and later  
;                                                                               
;  HandleControlClick is preferable to TrackControl when running under          
;  Appearance 1.0 as you can pass in modifiers, which some of the new controls  
;  use, such as edit text and list boxes.                                       
; 
;  *  FindControlUnderMouse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindControlUnderMouse" 
      ((inWhere :point) (inWindow (:pointer :windowrecord)) (outPart (:pointer :signed-integer)))
   (:stack (:handle :controlrecord))
   (:stack-trap #xAA73 :d0 9 inWhere inWindow outPart))

; 
;  *  HandleControlClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HandleControlClick" 
      ((inControl (:handle :controlrecord)) (inWhere :point) (inModifiers :unsigned-integer) (inAction :pointer))
   (:stack :controlpartcode)
   (:stack-trap #xAA73 :d0 10 inControl inWhere inModifiers inAction))

;  Contextual Menu support in the Control Manager is only available on Carbon.  
;  If the control didn't display a contextual menu (possibly because the point  
;  was in a non-interesting part), the menuDisplayed output parameter will be   
;  false. If the control did display a menu, menuDisplayed will be true.        
;  This in on Carbon only                                                       
; 
;  *  HandleControlContextualMenuClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Some complex controls (like Data Browser) require proper sequencing of       ;  window activation and click processing. In some cases, the control might     ;  want the window to be left inactive yet still handle the click, or vice-     ;  versa. The GetControlClickActivation routine lets a control client ask the   ;  control how it wishes to behave for a particular click.                      ;  This in on Carbon only.                                                      ; 
;  *  GetControlClickActivation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HandleControlContextualMenuClick" 
      ((inControl (:handle :controlrecord)) (inWhere :point) (menuDisplayed (:pointer :boolean))) 
  :osstatus
   () )                                         ; ;    Control Events (available only with Appearance 1.0 and later)                     ; ; 
;  *  HandleControlKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlClickActivation" 
      ((inControl (:handle :controlrecord)) (inWhere :point) (inModifiers :unsigned-integer) (outResult (:pointer :unsigned-long))) 
  :osstatus
   () )
(deftrap "_HandleControlKey" 
      ((inControl (:handle :controlrecord)) (inKeyCode :signed-integer) (inCharCode :signed-integer) (inModifiers :unsigned-integer))
   (:stack :controlpartcode)
   (:stack-trap #xAA73 :d0 11 inControl inKeyCode inCharCode inModifiers))

; 
;  *  IdleControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IdleControls" 
      ((inWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xAA73 :d0 12 inWindow))

; 
;   Control Mouse Tracking (available with Carbon)                                     
; 
;  The HandleControlSetCursor routine requests that a given control set the cursor to   
;  something appropriate based on the mouse location.                                   
;  If the control didn't want to set the cursor (because the point was in a             
;  non-interesting part), the cursorWasSet output parameter will be false. If the       
;  control did set the cursor, cursorWasSet will be true.                               
;  Carbon only.                                                                         
; 
;  *  HandleControlSetCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; ;    Control Positioning                                                               ; ; 
;  *  MoveControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HandleControlSetCursor" 
      ((control (:handle :controlrecord)) (localPoint :point) (modifiers :unsigned-integer) (cursorWasSet (:pointer :boolean))) 
  :osstatus
   () )
(deftrap "_MoveControl" 
      ((theControl (:handle :controlrecord)) (h :signed-integer) (v :signed-integer))
   nil
   (:stack-trap #xA959))

; 
;  *  SizeControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SizeControl" 
      ((theControl (:handle :controlrecord)) (w :signed-integer) (h :signed-integer))
   nil
   (:stack-trap #xA95C))

; 
;    Control Title                                                                     
; 
; 
;  *  SetControlTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlTitle" 
      ((theControl (:handle :controlrecord)) (title (:string 255)))
   nil
   (:stack-trap #xA95F))

; 
;  *  GetControlTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlTitle" 
      ((theControl (:handle :controlrecord)) (title (:pointer (:string 255))))
   nil
   (:stack-trap #xA95E))

; 
;  *  SetControlTitleWithCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  CopyControlTitleAsCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlTitleWithCFString" 
      ((inControl (:handle :controlrecord)) (inString :pointer)) 
  :osstatus
   () )                                         ; ;    Control Value                                                                     ; ; 
;  *  GetControlValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyControlTitleAsCFString" 
      ((inControl (:handle :controlrecord)) (outString (:pointer :pointer))) 
  :osstatus
   () )
(deftrap "_GetControlValue" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA960))

; 
;  *  SetControlValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlValue" 
      ((theControl (:handle :controlrecord)) (newValue :signed-integer))
   nil
   (:stack-trap #xA963))

; 
;  *  GetControlMinimum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlMinimum" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA961))

; 
;  *  SetControlMinimum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlMinimum" 
      ((theControl (:handle :controlrecord)) (newMinimum :signed-integer))
   nil
   (:stack-trap #xA964))

; 
;  *  GetControlMaximum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlMaximum" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA962))

; 
;  *  SetControlMaximum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlMaximum" 
      ((theControl (:handle :controlrecord)) (newMaximum :signed-integer))
   nil
   (:stack-trap #xA965))

;   proportional scrolling/32-bit value support is new with Appearance 1.1 

; 
;  *  GetControlViewSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  SetControlViewSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlViewSize" 
      ((theControl (:handle :controlrecord))) 
  :signed-long
   () )                                         ; 
;  *  GetControl32BitValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlViewSize" 
      ((theControl (:handle :controlrecord)) (newViewSize :signed-long)) 
  nil
   () )                                         ; 
;  *  SetControl32BitValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControl32BitValue" 
      ((theControl (:handle :controlrecord))) 
  :signed-long
   () )                                         ; 
;  *  GetControl32BitMaximum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControl32BitValue" 
      ((theControl (:handle :controlrecord)) (newValue :signed-long)) 
  nil
   () )                                         ; 
;  *  SetControl32BitMaximum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControl32BitMaximum" 
      ((theControl (:handle :controlrecord))) 
  :signed-long
   () )                                         ; 
;  *  GetControl32BitMinimum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControl32BitMaximum" 
      ((theControl (:handle :controlrecord)) (newMaximum :signed-long)) 
  nil
   () )                                         ; 
;  *  SetControl32BitMinimum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControl32BitMinimum" 
      ((theControl (:handle :controlrecord))) 
  :signed-long
   () )                                         ; 
;     IsValidControlHandle will tell you if the handle you pass in belongs to a control
;     the Control Manager knows about. It does not sanity check the data in the control.
;                                               ; 
;  *  IsValidControlHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControl32BitMinimum" 
      ((theControl (:handle :controlrecord)) (newMinimum :signed-long)) 
  nil
   () )                                         ; ;   Control IDs                                                                        ;  Carbon only.                                                                         ; 
(deftrap-inline "_IsValidControlHandle" 
      ((theControl (:handle :controlrecord))) 
  :boolean
   () )
(def-mactype :controlidptr (find-mactype '(:pointer :controlid)))
(defrecord ControlID 
   (signature :ostype)
   (id :signed-long)
   )

; 
; 	 *  SetControlID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; 
;  *  GetControlID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlID" 
      ((inControl (:handle :controlrecord)) (inID (:pointer :controlid))) 
  :osstatus
   () )                                         ; 
;  *  GetControlByID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlID" 
      ((inControl (:handle :controlrecord)) (outID (:pointer :controlid))) 
  :osstatus
   () )                                         ; CONST; ;   Control Command IDs                                                                    ;  Carbon only.                                                                         ; ; 
;  *  SetControlCommandID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlByID" 
      ((inWindow (:pointer :windowrecord)) (inID (:pointer :controlid)) (outControl (:pointer (:handle :controlrecord)))) 
  :osstatus
   () )                                         ; 
;  *  GetControlCommandID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlCommandID" 
      ((inControl (:handle :controlrecord)) (inCommandID :unsigned-long)) 
  :osstatus
   () )                                         ; ;   Control Identification                                                             ;  Carbon only.                                                                         ; 
(deftrap-inline "_GetControlCommandID" 
      ((inControl (:handle :controlrecord)) (outCommandID (:pointer :unsigned-long))) 
  :osstatus
   () )
(def-mactype :controlkindptr (find-mactype '(:pointer :controlkind)))
(defrecord ControlKind 
   (signature :ostype)
   (kind :ostype)
   )

; 
; 	 *  Discussion:
; 	 *    Control signature kind
; 	 	

(defconstant $kControlKindSignatureApple :|appl|)

; 
; 	 *  GetControlKind()
; 	 *  
; 	 *  Summary:
; 	 *    Returns the kind of the given control.
; 	 *  
; 	 *  Discussion:
; 	 *    GetControlKind allows you to query the kind of any control. This
; 	 *    function is only available in Mac OS X.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inControl:
; 	 *      The ControlRef to find the kind of.
; 	 *    
; 	 *    outControlKind:
; 	 *      On successful exit, this will contain the control signature and
; 	 *      kind. See ControlDefinitions.h for the kinds of each system
; 	 *      control.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.5 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; ;   Properties                                                                         ; 
(deftrap-inline "_GetControlKind" 
      ((inControl (:handle :controlrecord)) (outControlKind (:pointer :controlkind))) 
  :osstatus
   () )
(defconstant $kControlPropertyPersistent #x1)   ;   whether this property gets saved when flattening the control 

; 
; 	 *  GetControlProperty()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ControlsLib 8.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetControlPropertySize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlProperty" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype) (bufferSize :unsigned-long) (actualSize (:pointer :unsigned-long)) (propertyBuffer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SetControlProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlPropertySize" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype) (size (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  RemoveControlProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlProperty" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype) (propertySize :unsigned-long) (propertyData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetControlPropertyAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveControlProperty" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype)) 
  :osstatus
   () )                                         ; 
;  *  ChangeControlPropertyAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlPropertyAttributes" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype) (attributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; ;    Control Regions (Appearance 1.1 or later)                                         ;                                                                                       ;   See the discussion on meta-parts in this header for more information                ; ; 
;  *  GetControlRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeControlPropertyAttributes" 
      ((control (:handle :controlrecord)) (propertyCreator :ostype) (propertyTag :ostype) (attributesToSet :unsigned-long) (attributesToClear :unsigned-long)) 
  :osstatus
   () )                                         ; ;    Control Variant                                                                   ; ; 
;  *  GetControlVariant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlRegion" 
      ((inControl (:handle :controlrecord)) (inPart :signed-integer) (outRegion (:handle :macregion))) 
  :osstatus
   () )
(deftrap "_GetControlVariant" 
      ((theControl (:handle :controlrecord)))
   (:stack :controlvariant)
   (:stack-trap #xA809))

; 
;    Control Action                                                                    
; 
; 
;  *  SetControlAction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlAction" 
      ((theControl (:handle :controlrecord)) (actionProc :pointer))
   nil
   (:stack-trap #xA96B))

; 
;  *  GetControlAction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlAction" 
      ((theControl (:handle :controlrecord)))
   (:stack :pointer)
   (:stack-trap #xA96A))

; 
;   Control Accessors                                                                  
; 
; 
;  *  SetControlReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlReference" 
      ((theControl (:handle :controlrecord)) (data :signed-long))
   nil
   (:stack-trap #xA95B))

; 
;  *  GetControlReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlReference" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-long)
   (:stack-trap #xA95A))

; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetAuxiliaryControlRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetAuxiliaryControlRecord" 
      ((theControl (:handle :controlrecord)) (acHndl (:pointer (:handle :auxctlrec))))
   (:stack :boolean)
   (:stack-trap #xAA44))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetControlColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetControlColor" 
      ((theControl (:handle :controlrecord)) (newColorTable (:handle :ctlctab)))
   nil
   (:stack-trap #xAA43))

; 
;    Control Hierarchy (Appearance 1.0 and later only)                                 
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SendControlMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SendControlMessage" 
      ((inControl (:handle :controlrecord)) (inMessage :signed-integer) (inParam :pointer))
   (:stack :signed-long)
   (:stack-trap #xAA73 :d0 65534 inControl inMessage inParam))

; 
;  *  DumpControlHierarchy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DumpControlHierarchy" 
      ((inWindow (:pointer :windowrecord)) (inDumpFile (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 65535 inWindow inDumpFile))

; 
;  *  CreateRootControl()
;  *  
;  *  Summary:
;  *    Creates a new root control for a window.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window for which to create a root control.
;  *    
;  *    outControl:
;  *      On exit, contains the window's root control. In Mac OS 10.1 and
;  *      CarbonLib 1.5 and later, this parameter may be NULL if you
;  *      don't need the ControlRef.
;  *  
;  *  Result:
;  *    A result code indicating success or failure. errRootAlreadyExists
;  *    is returned if the window already has a root control.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CreateRootControl" 
      ((inWindow (:pointer :windowrecord)) (outControl (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 1 inWindow outControl))

; 
;  *  GetRootControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetRootControl" 
      ((inWindow (:pointer :windowrecord)) (outControl (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 2 inWindow outControl))

; 
;  *  EmbedControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EmbedControl" 
      ((inControl (:handle :controlrecord)) (inContainer (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 3 inControl inContainer))

; 
;  *  AutoEmbedControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AutoEmbedControl" 
      ((inControl (:handle :controlrecord)) (inWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 4 inControl inWindow))

; 
;  *  GetSuperControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSuperControl" 
      ((inControl (:handle :controlrecord)) (outParent (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 21 inControl outParent))

; 
;  *  CountSubControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountSubControls" 
      ((inControl (:handle :controlrecord)) (outNumChildren (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 22 inControl outNumChildren))

; 
;  *  GetIndexedSubControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndexedSubControl" 
      ((inControl (:handle :controlrecord)) (inIndex :unsigned-integer) (outSubControl (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 23 inControl inIndex outSubControl))

; 
;  *  SetControlSupervisor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlSupervisor" 
      ((inControl (:handle :controlrecord)) (inBoss (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 26 inControl inBoss))

; 
;    Keyboard Focus (available only with Appearance 1.0 and later)                     
; 
; 
;  *  GetKeyboardFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetKeyboardFocus" 
      ((inWindow (:pointer :windowrecord)) (outControl (:pointer (:handle :controlrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 13 inWindow outControl))

; 
;  *  SetKeyboardFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetKeyboardFocus" 
      ((inWindow (:pointer :windowrecord)) (inControl (:handle :controlrecord)) (inPart :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 14 inWindow inControl inPart))

; 
;  *  AdvanceKeyboardFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AdvanceKeyboardFocus" 
      ((inWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 15 inWindow))

; 
;  *  ReverseKeyboardFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReverseKeyboardFocus" 
      ((inWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 16 inWindow))

; 
;  *  ClearKeyboardFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ClearKeyboardFocus" 
      ((inWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 25 inWindow))

; 
;    Control Data (available only with Appearance 1.0 and later)                       
; 

; 
;  *  GetControlFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlFeatures" 
      ((inControl (:handle :controlrecord)) (outFeatures (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 17 inControl outFeatures))

; 
;  *  SetControlData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetControlData" 
      ((inControl (:handle :controlrecord)) (inPart :signed-integer) (inTagName :ostype) (inSize :signed-long) (inData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 18 inControl inPart inTagName inSize inData))

; 
;  *  GetControlData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlData" 
      ((inControl (:handle :controlrecord)) (inPart :signed-integer) (inTagName :ostype) (inBufferSize :signed-long) (inBuffer :pointer) (outActualSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 19 inControl inPart inTagName inBufferSize inBuffer outActualSize))

; 
;  *  GetControlDataSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetControlDataSize" 
      ((inControl (:handle :controlrecord)) (inPart :signed-integer) (inTagName :ostype) (outMaxSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA73 :d0 20 inControl inPart inTagName outMaxSize))

; 
;    Control Drag & Drop                                                               
;       Carbon only.                                                                    
; 
;   some simple redefinitions of the similar values found in the Drag header 

(defconstant $kDragTrackingEnterControl 2)
(defconstant $kDragTrackingInControl 3)
(defconstant $kDragTrackingLeaveControl 4)

; 
; 	 *  HandleControlDragTracking()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ControlsLib 9.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  HandleControlDragReceive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HandleControlDragTracking" 
      ((inControl (:handle :controlrecord)) (inMessage :signed-integer) (inDrag :signed-long) (outLikesDrag (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  SetControlDragTrackingEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HandleControlDragReceive" 
      ((inControl (:handle :controlrecord)) (inDrag :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  IsControlDragTrackingEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlDragTrackingEnabled" 
      ((theControl (:handle :controlrecord)) (tracks :boolean)) 
  :osstatus
   () )                                         ; 
;  *  SetAutomaticControlDragTrackingEnabledForWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsControlDragTrackingEnabled" 
      ((theControl (:handle :controlrecord)) (tracks (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  IsAutomaticControlDragTrackingEnabledForWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlsLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetAutomaticControlDragTrackingEnabledForWindow" 
      ((theWindow (:pointer :windowrecord)) (tracks :boolean)) 
  :osstatus
   () )
#|                                              ; $IFC NOT TARGET_OS_MAC ; ;    QuickTime 3.0 Win32/unix notification mechanism                                   ; ;   Proc used to notify window that something happened to the control 
(deftrap-inline "_IsAutomaticControlDragTrackingEnabledForWindow" 
      ((theWindow (:pointer :windowrecord)) (tracks (:pointer :boolean))) 
  :osstatus
   () )
; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlNotificationProcPtr = PROCEDURE(theWindow: WindowRef; theControl: ControlRef; notification: ControlNotification; param1: LONGINT; param2: LONGINT); C;

|#                                              ; $ELSEC
(def-mactype :controlnotificationprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   Proc used to prefilter events before handled by control.  A client of a control calls
; 	   CTRLSetPreFilterProc() to have the control call this proc before handling the event.
; 	   If the proc returns TRUE, the control can go ahead and handle the event.
; 	
; $IFC TYPED_FUNCTION_POINTERS
#|
	PreFilterEventProc = FUNCTION(theControl: ControlRef; VAR theEvent: EventRecord): BOOLEAN; C;

|#                                              ; $ELSEC
(def-mactype :prefiltereventproc (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GetControlComponentInstance()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_GetControlComponentInstance" 
      ((theControl (:handle :controlrecord))) 
  :signed-long
   () )

; 
;  *  GetControlHandleFromCookie()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetControlHandleFromCookie" 
      ((cookie :signed-long)) 
  (:handle :controlrecord)
   () )

; 
;  *  SetControlDefProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetControlDefProc" 
      ((resID :signed-integer) (proc :pointer)) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :controlnotificationupp (find-mactype ':controlnotificationprocptr))
 |#                                             ; $ENDC

; $IFC OLDROUTINENAMES 
; 
;    OLDROUTINENAMES                                                                   
; 

(defconstant $useWFont #x8)

(defconstant $inThumb 129)
(defconstant $kNoHiliteControlPart 0)
(defconstant $kInIndicatorControlPart 129)
(defconstant $kReservedControlPart 254)
(defconstant $kControlInactiveControlPart 255)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SetCTitle()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_SetCTitle" 
      ((theControl (:handle :controlrecord)) (title (:string 255)))
   nil
   (:stack-trap #xA95F))

; 
;  *  GetCTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCTitle" 
      ((theControl (:handle :controlrecord)) (title (:pointer (:string 255))))
   nil
   (:stack-trap #xA95E))

; 
;  *  UpdtControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UpdtControl" 
      ((theWindow (:pointer :windowrecord)) (updateRgn (:handle :macregion)))
   nil
   (:stack-trap #xA953))

; 
;  *  SetCtlValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCtlValue" 
      ((theControl (:handle :controlrecord)) (theValue :signed-integer))
   nil
   (:stack-trap #xA963))

; 
;  *  GetCtlValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCtlValue" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA960))

; 
;  *  SetCtlMin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCtlMin" 
      ((theControl (:handle :controlrecord)) (minValue :signed-integer))
   nil
   (:stack-trap #xA964))

; 
;  *  GetCtlMin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCtlMin" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA961))

; 
;  *  SetCtlMax()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCtlMax" 
      ((theControl (:handle :controlrecord)) (maxValue :signed-integer))
   nil
   (:stack-trap #xA965))

; 
;  *  GetCtlMax()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCtlMax" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA962))

; 
;  *  SetCRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCRefCon" 
      ((theControl (:handle :controlrecord)) (data :signed-long))
   nil
   (:stack-trap #xA95B))

; 
;  *  GetCRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCRefCon" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-long)
   (:stack-trap #xA95A))

; 
;  *  SetCtlAction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCtlAction" 
      ((theControl (:handle :controlrecord)) (actionProc :pointer))
   nil
   (:stack-trap #xA96B))

; 
;  *  GetCtlAction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCtlAction" 
      ((theControl (:handle :controlrecord)))
   (:stack :pointer)
   (:stack-trap #xA96A))

; 
;  *  SetCtlColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetCtlColor" 
      ((theControl (:handle :controlrecord)) (newColorTable (:handle :ctlctab)))
   nil
   (:stack-trap #xAA43))

; 
;  *  GetCVariant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCVariant" 
      ((theControl (:handle :controlrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA809))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $IFC ACCESSOR_CALLS_ARE_FUNCTIONS 
;  Getters 
; 
;  *  GetControlBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  IsControlHilited()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlBounds" 
      ((control (:handle :controlrecord)) (bounds (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  GetControlHilite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsControlHilited" 
      ((control (:handle :controlrecord))) 
  :boolean
   () )                                         ; 
;  *  GetControlOwner()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlHilite" 
      ((control (:handle :controlrecord))) 
  :unsigned-integer
   () )                                         ; 
;  *  GetControlDataHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlOwner" 
      ((control (:handle :controlrecord))) 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  GetControlPopupMenuHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlDataHandle" 
      ((control (:handle :controlrecord))) 
  :handle
   () )                                         ; 
;  *  GetControlPopupMenuID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlPopupMenuHandle" 
      ((control (:handle :controlrecord))) 
  (:handle :menuinfo)
   () )                                         ;  Setters ; 
;  *  SetControlDataHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetControlPopupMenuID" 
      ((control (:handle :controlrecord))) 
  :signed-integer
   () )                                         ; 
;  *  SetControlBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlDataHandle" 
      ((control (:handle :controlrecord)) (dataHandle :handle)) 
  nil
   () )                                         ; CONST; 
;  *  SetControlPopupMenuHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlBounds" 
      ((control (:handle :controlrecord)) (bounds (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  SetControlPopupMenuID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetControlPopupMenuHandle" 
      ((control (:handle :controlrecord)) (popupMenu (:handle :menuinfo))) 
  nil
   () )
(deftrap-inline "_SetControlPopupMenuID" 
      ((control (:handle :controlrecord)) (menuID :signed-integer)) 
  nil
   () )                                         ; $ENDC; ACCESSOR_CALLS_ARE_FUNCTIONS

#|                                              ; $IFC NOT OPAQUE_TOOLBOX_STRUCTS AND NOT ACCESSOR_CALLS_ARE_FUNCTIONS 
 |#                                             ; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ControlsIncludes

; $ENDC                                         ; __CONTROLS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Controls)#|
; Warning: Did not recognize these types or records: (controlnotificationprocptr)
|#