(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CursorDevices.p"
; at Wednesday May 1,2002 2:41:17 pm.
; 
;      File:       CursorDevices.p
;  
;      Contains:   Cursor Devices (mouse/trackball/etc) Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CURSORDEVICES__
; $SETC __CURSORDEVICES__ := 1

; $I+
; $SETC CursorDevicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;                         * * *  I M P O R T A N T  * * * 
; 
;             You will need CursorDevicesGlue.o to use CDM from PowerPC
; 
; 
;     In order to use the Cursor Devices Manager (CDM) on PowerPC systems, you must 
;     link with the file CursorDevicesGlue.o and InterfaceLib 1.1.3.  This is necessary
;     because the original MixedMode transition code for CDM in InterfaceLib in ROM
;     was wrong.  The code in CursorDevicesGlue.o will check to see if the ROM has
;     been fixed and calls through to it if so.  If it detects that the ROM has not
;     been fixed, it uses its own implementation of the CDM MixedMode transition 
;     routines. 
;     
; 

(def-mactype :buttonopcode (find-mactype ':signed-integer))
; 	 ButtonOpcodes 	

(defconstant $kButtonNoOp 0)                    ;   No action for this button  
(defconstant $kButtonSingleClick 1)             ;   Normal mouse button  
(defconstant $kButtonDoubleClick 2)             ;   Click-release-click when pressed  
(defconstant $kButtonClickLock 3)               ;   Click on press, release on next press  

(defconstant $kButtonCustom 6)                  ;   Custom behavior, data = CursorDeviceCustomButtonUPP  

; 	 Device Classes 	
(defconstant $kDeviceClassAbsolute 0)           ;   a flat-response device  
(defconstant $kDeviceClassMouse 1)              ;   mechanical or optical mouse  
(defconstant $kDeviceClassTrackball 2)          ;   trackball  
(defconstant $kDeviceClassTrackPad 3)

(defconstant $kDeviceClass3D 6)                 ;   a 3D pointing device  

; 	 Structures used in Cursor Device Manager calls 	

(def-mactype :cursordataptr (find-mactype '(:pointer :cursordata)))
(defrecord CursorData 
   (nextCursorData (:pointer :cursordata))      ;   next in global list  
   (displayInfo :pointer)                       ;   unused (reserved for future)  
   (whereX :signed-long)                        ;   horizontal position  
   (whereY :signed-long)                        ;   vertical position  
   (where :point)                               ;   the pixel position  
   (isAbs :boolean)                             ;   has been stuffed with absolute coords  
   (buttonCount :signed-byte)                   ;   number of buttons currently pressed  
   (screenRes :signed-long)                     ;   pixels per inch on the current display  
   (privateFields (:array :signed-integer 22))  ;   fields use internally by CDM  
   )

(def-mactype :cursordeviceptr (find-mactype '(:pointer :cursordevice)))
(defrecord CursorDevice 
   (nextCursorDevice (:pointer :cursordevice))  ;   pointer to next record in linked list  
   (whichCursor (:pointer :cursordata))         ;   pointer to data for target cursor  
   (refCon :signed-long)                        ;   application-defined  
   (unused :signed-long)                        ;   reserved for future  
   (devID :ostype)                              ;   device identifier (from ADB reg 1)  
   (resolution :signed-long)                    ;   units/inch (orig. from ADB reg 1)  
   (devClass :signed-byte)                      ;   device class (from ADB reg 1)  
   (cntButtons :signed-byte)                    ;   number of buttons (from ADB reg 1)  
   (filler1 :signed-byte)                       ;   reserved for future  
   (buttons :signed-byte)                       ;   state of all buttons  
   (buttonOp (:array :unsigned-byte 8 :packed)) ;   action performed per button  
   (buttonTicks (:array :unsigned-long 8))      ;   ticks when button last went up (for debounce)  
   (buttonData (:array :signed-long 8))         ;   data for the button operation  
   (doubleClickTime :unsigned-long)             ;   device-specific double click speed  
   (acceleration :signed-long)                  ;   current acceleration  
   (privateFields (:array :signed-integer 15))  ;   fields used internally to CDM  
   )

; 	 for use with CursorDeviceButtonOp when opcode = kButtonCustom 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CursorDeviceCustomButtonProcPtr = PROCEDURE(ourDevice: CursorDevicePtr; button: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :cursordevicecustombuttonprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cursordevicecustombuttonupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cursordevicecustombuttonupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppCursorDeviceCustomButtonProcInfo #xED802)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewCursorDeviceCustomButtonUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewCursorDeviceCustomButtonProc 
(deftrap "_NewCursorDeviceCustomButtonUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeCursorDeviceCustomButtonUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeCursorDeviceCustomButtonUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeCursorDeviceCustomButtonUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallCursorDeviceCustomButtonProc 
(deftrap-inline "_InvokeCursorDeviceCustomButtonUPP" 
      ((ourDevice (:pointer :cursordevice)) (button :signed-integer) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CursorDeviceMove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceMove" 
      ((ourDevice (:pointer :cursordevice)) (deltaX :signed-long) (deltaY :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 0 ourDevice deltaX deltaY))

; 
;  *  CursorDeviceMoveTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceMoveTo" 
      ((ourDevice (:pointer :cursordevice)) (absX :signed-long) (absY :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 1 ourDevice absX absY))

; 
;  *  CursorDeviceFlush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceFlush" 
      ((ourDevice (:pointer :cursordevice)))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 2 ourDevice))

; 
;  *  CursorDeviceButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceButtons" 
      ((ourDevice (:pointer :cursordevice)) (buttons :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 3 ourDevice buttons))

; 
;  *  CursorDeviceButtonDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceButtonDown" 
      ((ourDevice (:pointer :cursordevice)))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 4 ourDevice))

; 
;  *  CursorDeviceButtonUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceButtonUp" 
      ((ourDevice (:pointer :cursordevice)))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 5 ourDevice))

; 
;  *  CursorDeviceButtonOp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceButtonOp" 
      ((ourDevice (:pointer :cursordevice)) (buttonNumber :signed-integer) (opcode :signed-integer) (data :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 6 ourDevice buttonNumber opcode data))

; 
;  *  CursorDeviceSetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceSetButtons" 
      ((ourDevice (:pointer :cursordevice)) (numberOfButtons :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 7 ourDevice numberOfButtons))

; 
;  *  CursorDeviceSetAcceleration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceSetAcceleration" 
      ((ourDevice (:pointer :cursordevice)) (acceleration :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 8 ourDevice acceleration))

; 
;  *  CursorDeviceDoubleTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceDoubleTime" 
      ((ourDevice (:pointer :cursordevice)) (durationTicks :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 9 ourDevice durationTicks))

; 
;  *  CursorDeviceUnitsPerInch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceUnitsPerInch" 
      ((ourDevice (:pointer :cursordevice)) (resolution :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 10 ourDevice resolution))

; 
;  *  CursorDeviceNextDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceNextDevice" 
      ((ourDevice (:pointer (:pointer :cursordevice))))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 11 ourDevice))

; 
;  *  CursorDeviceNewDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceNewDevice" 
      ((ourDevice (:pointer (:pointer :cursordevice))))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 12 ourDevice))

; 
;  *  CursorDeviceDisposeDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CursorDeviceDisposeDevice" 
      ((ourDevice (:pointer :cursordevice)))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 13 ourDevice))

; 
;                        * * *  W A R N I N G  * * * 
;                 
;     The routines CrsrDevMoveTo and CrsrDevNextDevice are no longer needed.
;     They were added as a work around until the glue code CursorDevicesGlue.o
;     was created.  Please use the functions CursorDeviceMoveTo and
;     CursorDeviceNextDevice instead.
; 
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CrsrDevMoveTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CrsrDevMoveTo" 
      ((ourDevice (:pointer :cursordevice)) (absX :signed-long) (absY :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 1 ourDevice absX absY))

; 
;  *  CrsrDevNextDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CrsrDevNextDevice" 
      ((ourDevice (:pointer (:pointer :cursordevice))))
   (:stack :signed-integer)
   (:stack-trap #xAADB :d0 11 ourDevice))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CursorDevicesIncludes

; $ENDC                                         ; __CURSORDEVICES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CursorDevices)