(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DatabaseAccess.p"
; at Wednesday May 1,2002 2:41:18 pm.
; 
;      File:       DatabaseAccess.p
;  
;      Contains:   Database Access Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DATABASEACCESS__
; $SETC __DATABASEACCESS__ := 1

; $I+
; $SETC DatabaseAccessIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __RESOURCES__
|#

(require-interface 'Resources)
#|                                              ; $I Resources.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  data type codes 

(defconstant $typeNone :|none|)
(defconstant $typeDate :|date|)
(defconstant $typeTime :|time|)
(defconstant $typeTimeStamp :|tims|)
(defconstant $typeDecimal :|deci|)
(defconstant $typeMoney :|mone|)
(defconstant $typeVChar :|vcha|)
(defconstant $typeVBin :|vbin|)
(defconstant $typeLChar :|lcha|)
(defconstant $typeLBin :|lbin|)
(defconstant $typeDiscard :|disc|)              ;   "dummy" types for DBResultsToText  
(defconstant $typeUnknown :|unkn|)
(defconstant $typeColBreak :|colb|)
(defconstant $typeRowBreak :|rowb|)             ;   pass this in to DBGetItem for any data type  
(defconstant $typeAnyType 0)

; 	 infinite timeout value for DBGetItem 	
;   messages for status functions for DBStartQuery  
(defconstant $kDBUpdateWind 0)
(defconstant $kDBAboutToInit 1)
(defconstant $kDBInitComplete 2)
(defconstant $kDBSendComplete 3)
(defconstant $kDBExecComplete 4)
(defconstant $kDBStartQueryComplete 5)

;   messages for status functions for DBGetQueryResults  
(defconstant $kDBGetItemComplete 6)
(defconstant $kDBGetQueryResultsComplete 7)
(defconstant $kDBWaitForever -1)

;    flags for DBGetItem   
(defconstant $kDBLastColFlag #x1)
(defconstant $kDBNullFlag #x4)

(def-mactype :dbtype (find-mactype ':ostype))
(def-mactype :dbasyncparamblockrecptr (find-mactype '(:pointer :dbasyncparamblockrec)))
(def-mactype :dbasyncparmblkptr (find-mactype '(:pointer :dbasyncparamblockrec)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DBCompletionProcPtr = PROCEDURE(pb: DBAsyncParmBlkPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :dbcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dbcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dbcompletionupp (find-mactype ':pointer))
; $ENDC
; 	 structure for asynchronous parameter block 	
(defrecord DBAsyncParamBlockRec 
   (completionProc :pointer)                    ;   pointer to completion routine  
   (result :signed-integer)                     ;   result of call  
   (userRef :signed-long)                       ;   for application's use  
   (ddevRef :signed-long)                       ;   for ddev's use  
   (reserved :signed-long)                      ;   for internal use  
   )

; 	 structure for resource list in QueryRecord 	
(def-mactype :reslistelemptr (find-mactype '(:pointer :reslistelem)))
(defrecord ResListElem 
   (theType :ostype)                            ;   resource type  
   (id :signed-integer)                         ;   resource id  
   )

(def-mactype :reslistptr (find-mactype '(:pointer :reslistelem)))
(def-mactype :reslisthandle (find-mactype '(:handle :reslistelem)))
; 	 structure for query list in QueryRecord 	
(defrecord (QueryArray :handle) (array (:array :handle 256)))
(def-mactype :querylistptr (find-mactype '(:pointer :queryarray)))
(def-mactype :querylisthandle (find-mactype '(:handle :queryarray)))
(def-mactype :queryrecordptr (find-mactype '(:pointer :queryrecord)))
(defrecord (QueryRecord :handle) 
   (version :signed-integer)                    ;   version  
   (id :signed-integer)                         ;   id of 'qrsc' this came from  
   (queryProc :handle)                          ;   handle to query def proc  
   (ddevName (:string 63))                      ;   ddev name  
   (host (:string 255))                         ;   host name  
   (user (:string 255))                         ;   user name  
   (password (:string 255))                     ;   password  
   (connStr (:string 255))                      ;   connection string  
   (currQuery :signed-integer)                  ;   index of current query  
   (numQueries :signed-integer)                 ;   number of queries in list  
   (queryList (:handle :queryarray))            ;   handle to array of handles to text  
   (numRes :signed-integer)                     ;   number of resources in list  
   (resList (:handle :reslistelem))             ;   handle to array of resource list elements  
   (dataHandle :handle)                         ;   for use by query def proc  
   (refCon :signed-long)                        ;   for use by application  
   )

(def-mactype :queryptr (find-mactype '(:pointer :queryrecord)))
(def-mactype :queryhandle (find-mactype '(:handle :queryrecord)))
; 	 structure of column types array in ResultsRecord 	
(defrecord (ColTypesArray :handle) (array (:array :ostype 256)))
(def-mactype :coltypesptr (find-mactype '(:pointer :coltypesarray)))
(def-mactype :coltypeshandle (find-mactype '(:handle :coltypesarray)))
; 	 structure for column info in ResultsRecord 	
(def-mactype :dbcolinforecordptr (find-mactype '(:pointer :dbcolinforecord)))
(defrecord DBColInfoRecord 
   (len :signed-integer)
   (places :signed-integer)
   (flags :signed-integer)
   )

(defrecord (ColInfoArray :handle) (array (:array :dbcolinforecord 256)))
(def-mactype :colinfoptr (find-mactype '(:pointer :colinfoarray)))
(def-mactype :colinfohandle (find-mactype '(:handle :colinfoarray)))
; 	 structure of results returned by DBGetResults 	
(def-mactype :resultsrecordptr (find-mactype '(:pointer :resultsrecord)))
(defrecord ResultsRecord 
   (numRows :signed-integer)                    ;   number of rows in result  
   (numCols :signed-integer)                    ;   number of columns per row  
   (colTypes (:handle :coltypesarray))          ;   data type array  
   (colData :handle)                            ;   actual results  
   (colInfo (:handle :colinfoarray))            ;   DBColInfoRecord array  
   )

;   messages sent to a 'ddev' 
(defconstant $kDBInit 0)
(defconstant $kDBEnd 1)
(defconstant $kDBGetConnInfo 2)
(defconstant $kDBGetSessionNum 3)
(defconstant $kDBSend 4)
(defconstant $kDBSendItem 5)
(defconstant $kDBExec 6)
(defconstant $kDBState 7)
(defconstant $kDBGetErr 8)
(defconstant $kDBBreak 9)
(defconstant $kDBGetItem 10)
(defconstant $kDBUngetItem 11)
(defconstant $kDBKill 12)
(defconstant $kDBOpen 100)
(defconstant $kDBClose 101)
(defconstant $kDBIdle 102)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DBQueryDefProcPtr = FUNCTION(VAR sessID: LONGINT; query: QueryHandle): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dbquerydefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DBStatusProcPtr = FUNCTION(message: INTEGER; result: OSErr; dataLen: INTEGER; dataPlaces: INTEGER; dataFlags: INTEGER; dataType: DBType; dataPtr: Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :dbstatusprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DBResultHandlerProcPtr = FUNCTION(dataType: DBType; theLen: INTEGER; thePlaces: INTEGER; theFlags: INTEGER; theData: Ptr; theText: Handle): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dbresulthandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dbquerydefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dbquerydefupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dbstatusupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dbstatusupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dbresulthandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dbresulthandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDBCompletionProcInfo #xB802)
(defconstant $uppDBQueryDefProcInfo #x3E0)
(defconstant $uppDBStatusProcInfo #xFAA90)
(defconstant $uppDBResultHandlerProcInfo #x3EAE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewDBCompletionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewDBCompletionProc 
(deftrap "_NewDBCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDBQueryDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDBQueryDefProc 
(deftrap "_NewDBQueryDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDBStatusUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDBStatusProc 
(deftrap "_NewDBStatusUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDBResultHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDBResultHandlerProc 
(deftrap "_NewDBResultHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDBCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDBCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDBQueryDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDBQueryDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDBStatusUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDBStatusUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDBResultHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDBResultHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDBCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDBCompletionProc            ; 
;  *  InvokeDBQueryDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeDBCompletionUPP" 
      ((pb (:pointer :dbasyncparamblockrec)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallDBQueryDefProc 
(deftrap-inline "_InvokeDBQueryDefUPP" 
      ((sessID (:pointer :signed-long)) (query (:handle :queryrecord)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeDBStatusUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDBStatusProc 
(deftrap-inline "_InvokeDBStatusUPP" 
      ((message :signed-integer) (result :signed-integer) (dataLen :signed-integer) (dataPlaces :signed-integer) (dataFlags :signed-integer) (dataType :ostype) (dataPtr :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeDBResultHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDBResultHandlerProc 
(deftrap-inline "_InvokeDBResultHandlerUPP" 
      ((dataType :ostype) (theLen :signed-integer) (thePlaces :signed-integer) (theFlags :signed-integer) (theData :pointer) (theText :handle) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitDBPack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InitDBPack" 
      () 
  :signed-integer
   (#x3F3C #x4 #x303C #x100 #xA82F) )

; 
;  *  DBInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBInit" 
      ((sessID (:pointer :signed-long)) (ddevName (:string 63)) (host (:string 255)) (user (:string 255)) (passwd (:string 255)) (connStr (:string 255)) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 3586 sessID ddevName host user passwd connStr asyncPB))

; 
;  *  DBEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBEnd" 
      ((sessID :signed-long) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1027 sessID asyncPB))

; 
;  *  DBGetConnInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetConnInfo" 
      ((sessID :signed-long) (sessNum :signed-integer) (returnedID (:pointer :signed-long)) (version (:pointer :signed-long)) (ddevName (:pointer (:string 63))) (host (:pointer (:string 255))) (user (:pointer (:string 255))) (network (:pointer (:string 255))) (connStr (:pointer (:string 255))) (start (:pointer :signed-long)) (state (:pointer :signed-integer)) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 5892 sessID sessNum returnedID version ddevName host user network connStr start state asyncPB))

; 
;  *  DBGetSessionNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetSessionNum" 
      ((sessID :signed-long) (sessNum (:pointer :signed-integer)) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1541 sessID sessNum asyncPB))

; 
;  *  DBSend()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBSend" 
      ((sessID :signed-long) (text :pointer) (len :signed-integer) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1798 sessID text len asyncPB))

; 
;  *  DBSendItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBSendItem" 
      ((sessID :signed-long) (dataType :ostype) (len :signed-integer) (places :signed-integer) (flags :signed-integer) (buffer :pointer) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 2823 sessID dataType len places flags buffer asyncPB))

; 
;  *  DBExec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBExec" 
      ((sessID :signed-long) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1032 sessID asyncPB))

; 
;  *  DBState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBState" 
      ((sessID :signed-long) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1033 sessID asyncPB))

; 
;  *  DBGetErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetErr" 
      ((sessID :signed-long) (err1 (:pointer :signed-long)) (err2 (:pointer :signed-long)) (item1 (:pointer (:string 255))) (item2 (:pointer (:string 255))) (errorMsg (:pointer (:string 255))) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 3594 sessID err1 err2 item1 item2 errorMsg asyncPB))

; 
;  *  DBBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBBreak" 
      ((sessID :signed-long) (abort :boolean) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1291 sessID abort asyncPB))

; 
;  *  DBGetItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetItem" 
      ((sessID :signed-long) (timeout :signed-long) (dataType (:pointer :ostype)) (len (:pointer :signed-integer)) (places (:pointer :signed-integer)) (flags (:pointer :signed-integer)) (buffer :pointer) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 4108 sessID timeout dataType len places flags buffer asyncPB))

; 
;  *  DBUnGetItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBUnGetItem" 
      ((sessID :signed-long) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1037 sessID asyncPB))

; 
;  *  DBKill()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBKill" 
      ((asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 526 asyncPB))

; 
;  *  DBGetNewQuery()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetNewQuery" 
      ((queryID :signed-integer) (query (:pointer (:handle :queryrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 783 queryID query))

; 
;  *  DBDisposeQuery()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBDisposeQuery" 
      ((query (:handle :queryrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 528 query))

; 
;  *  DBStartQuery()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBStartQuery" 
      ((sessID (:pointer :signed-long)) (query (:handle :queryrecord)) (statusProc :pointer) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 2065 sessID query statusProc asyncPB))

; 
;  *  DBGetQueryResults()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetQueryResults" 
      ((sessID :signed-long) (results (:pointer :resultsrecord)) (timeout :signed-long) (statusProc :pointer) (asyncPB (:pointer :dbasyncparamblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 2578 sessID results timeout statusProc asyncPB))

; 
;  *  DBResultsToText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBResultsToText" 
      ((results (:pointer :resultsrecord)) (theText (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1043 results theText))

; 
;  *  DBInstallResultHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBInstallResultHandler" 
      ((dataType :ostype) (theHandler :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1300 dataType theHandler isSysHandler))

; 
;  *  DBRemoveResultHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBRemoveResultHandler" 
      ((dataType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 533 dataType))

; 
;  *  DBGetResultHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBGetResultHandler" 
      ((dataType :ostype) (theHandler (:pointer :pointer)) (getSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 1302 dataType theHandler getSysHandler))

; 
;  *  DBIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DBIdle" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA82F :d0 255))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DatabaseAccessIncludes

; $ENDC                                         ; __DATABASEACCESS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DatabaseAccess)