(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DateTimeUtils.p"
; at Wednesday May 1,2002 2:38:47 pm.
; 
;      File:       DateTimeUtils.p
;  
;      Contains:   International Date and Time Interfaces (previously in TextUtils)
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DATETIMEUTILS__
; $SETC __DATETIMEUTILS__ := 1

; $I+
; $SETC DateTimeUtilsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
; 
;     Here are the current routine names and the translations to the older forms.
;     Please use the newer forms in all new code and migrate the older names out of existing
;     code as maintainance permits.
;     
;     New Name                    Old Name(s)
;     
;     DateString                  IUDatePString IUDateString 
;     InitDateCache
;     LongDateString              IULDateString
;     LongTimeString              IULTimeString
;     StringToDate                String2Date
;     StringToTime                                
;     TimeString                  IUTimeString IUTimePString
;     LongDateToSeconds           LongDate2Secs
;     LongSecondsToDate           LongSecs2Date
;     DateToSeconds               Date2Secs
;     SecondsToDate               Secs2Date
; 
; 
;     Carbon only supports the new names.  The old names are undefined for Carbon targets.
;     This is true for C, Assembly and Pascal.
;     
;     InterfaceLib always has exported the old names.  For C macros have been defined to allow
;     the use of the new names.  For Pascal and Assembly using the new names will result
;     in link errors. 
;     
; 

(def-mactype :toggleresults (find-mactype ':signed-integer))

;   Toggle results  
(defconstant $toggleUndefined 0)
(defconstant $toggleOK 1)
(defconstant $toggleBadField 2)
(defconstant $toggleBadDelta 3)
(defconstant $toggleBadChar 4)
(defconstant $toggleUnknown 5)
(defconstant $toggleBadNum 6)
(defconstant $toggleOutOfRange 7)               ;  synonym for toggleErr3 
(defconstant $toggleErr3 7)
(defconstant $toggleErr4 8)
(defconstant $toggleErr5 9)

;   Date equates  
(defconstant $smallDateBit 31)                  ;  Restrict valid date/time to range of Time global 
(defconstant $togChar12HourBit 30)              ;  If toggling hour by char, accept hours 1..12 only 
(defconstant $togCharZCycleBit 29)              ;  Modifier for togChar12HourBit: accept hours 0..11 only 
(defconstant $togDelta12HourBit 28)             ;  If toggling hour up/down, restrict to 12-hour range (am/pm) 
(defconstant $genCdevRangeBit 27)               ;  Restrict date/time to range used by genl CDEV 
(defconstant $validDateFields -1)
(defconstant $maxDateField 10)

(defconstant $eraMask #x1)
(defconstant $yearMask #x2)
(defconstant $monthMask #x4)
(defconstant $dayMask #x8)
(defconstant $hourMask #x10)
(defconstant $minuteMask #x20)
(defconstant $secondMask #x40)
(defconstant $dayOfWeekMask #x80)
(defconstant $dayOfYearMask #x100)
(defconstant $weekOfYearMask #x200)
(defconstant $pmMask #x400)
(defconstant $dateStdMask #x7F)                 ;  default for ValidDate flags and ToggleDate TogglePB.togFlags 

(def-mactype :longdatefield (find-mactype ':signed-byte))

(defconstant $eraField 0)
(defconstant $yearField 1)
(defconstant $monthField 2)
(defconstant $dayField 3)
(defconstant $hourField 4)
(defconstant $minuteField 5)
(defconstant $secondField 6)
(defconstant $dayOfWeekField 7)
(defconstant $dayOfYearField 8)
(defconstant $weekOfYearField 9)
(defconstant $pmField 10)
(defconstant $res1Field 11)
(defconstant $res2Field 12)
(defconstant $res3Field 13)

(def-mactype :dateform (find-mactype ':signed-byte))

(defconstant $shortDate 0)
(defconstant $longDate 1)
(defconstant $abbrevDate 2)

;   StringToDate status values  
(defconstant $fatalDateTime #x8000)             ;   StringToDate and String2Time mask to a fatal error  
(defconstant $longDateFound 1)                  ;   StringToDate mask to long date found  
(defconstant $leftOverChars 2)                  ;   StringToDate & Time mask to warn of left over characters  
(defconstant $sepNotIntlSep 4)                  ;   StringToDate & Time mask to warn of non-standard separators  
(defconstant $fieldOrderNotIntl 8)              ;   StringToDate & Time mask to warn of non-standard field order  
(defconstant $extraneousStrings 16)             ;   StringToDate & Time mask to warn of unparsable strings in text  
(defconstant $tooManySeps 32)                   ;   StringToDate & Time mask to warn of too many separators  
(defconstant $sepNotConsistent 64)              ;   StringToDate & Time mask to warn of inconsistent separators  
(defconstant $tokenErr #x8100)                  ;   StringToDate & Time mask for 'tokenizer err encountered'  
(defconstant $cantReadUtilities #x8200)
(defconstant $dateTimeNotFound #x8400)
(defconstant $dateTimeInvalid #x8800)

(def-mactype :stringtodatestatus (find-mactype ':signed-integer))
(def-mactype :string2datestatus (find-mactype ':signed-integer))
(def-mactype :datecacherecordptr (find-mactype '(:pointer :datecacherecord)))
(defrecord DateCacheRecord 
   (hidden (:array :signed-integer 256))        ;   only for temporary use  
   )

(def-mactype :datecacheptr (find-mactype '(:pointer :datecacherecord)))
(def-mactype :datetimerecptr (find-mactype '(:pointer :datetimerec)))
(defrecord DateTimeRec 
   (year :signed-integer)
   (month :signed-integer)
   (day :signed-integer)
   (hour :signed-integer)
   (minute :signed-integer)
   (second :signed-integer)
   (dayOfWeek :signed-integer)
   )

(%define-record :longdatetime (find-record-descriptor :wide))
(def-mactype :longdatetimeptr (find-mactype '(:pointer :wide)))
(def-mactype :longdatecvtptr (find-mactype '(:pointer :longdatecvt)))
(defrecord LongDateCvt 
   (:variant 
      (
      (c :wide)
      )
      (
      (lHigh :unsigned-long)
      (lLow :unsigned-long)
      )
      )
   )

(def-mactype :longdaterecptr (find-mactype '(:pointer :longdaterec)))
(defrecord LongDateRec 
   (:variant 
      (
      (era :signed-integer)
      (year :signed-integer)
      (month :signed-integer)
      (day :signed-integer)
      (hour :signed-integer)
      (minute :signed-integer)
      (second :signed-integer)
      (dayOfWeek :signed-integer)
      (dayOfYear :signed-integer)
      (weekOfYear :signed-integer)
      (pm :signed-integer)
      (res1 :signed-integer)
      (res2 :signed-integer)
      (res3 :signed-integer)
      )
      (
      (list (:array :signed-integer 14))        ;  Index by LongDateField! 
      )
      (
      (eraAlt :signed-integer)
      (oldDate :datetimerec)
      )
      )
   )

(def-mactype :datedelta (find-mactype ':signed-byte))
(def-mactype :togglepbptr (find-mactype '(:pointer :togglepb)))
(defrecord TogglePB 
   (togFlags :signed-long)                      ;  caller normally sets low word to dateStdMask=$7F 
   (amChars :ostype)                            ;  from 'itl0', but uppercased 
   (pmChars :ostype)                            ;  from 'itl0', but uppercased 
   (reserved (:array :signed-long 4))
   )

; 	
; 	    These routine are available in Carbon with their new name
; 		
; 
; 	 *  DateString()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_DateString" 
      ((dateTime :signed-long) (longFlag :signed-byte) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime longFlag result intlHandle (14 :signed-integer)))

; 
;  *  TimeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TimeString" 
      ((dateTime :signed-long) (wantSeconds :boolean) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime wantSeconds result intlHandle (16 :signed-integer)))

; 
;  *  LongDateString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_LongDateString" 
      ((dateTime (:pointer :wide)) (longFlag :signed-byte) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime longFlag result intlHandle (20 :signed-integer)))

; 
;  *  LongTimeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_LongTimeString" 
      ((dateTime (:pointer :wide)) (wantSeconds :boolean) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime wantSeconds result intlHandle (22 :signed-integer)))

; 
;     These routine are available in Carbon and InterfaceLib with their new name
; 
; 
;  *  InitDateCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InitDateCache" 
      ((theCache (:pointer :datecacherecord)))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 theCache ((+ (ash 33284 16) 65528) :signed-longint)))

; 
;  *  StringToDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StringToDate" 
      ((textPtr :pointer) (textLen :signed-long) (theCache (:pointer :datecacherecord)) (lengthUsed (:pointer :signed-long)) (dateTime (:pointer :longdaterec)))
   (:stack :stringtodatestatus)
   (:stack-trap #xA8B5 textPtr textLen theCache lengthUsed dateTime ((+ (ash 33300 16) 65526) :signed-longint)))

; 
;  *  StringToTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StringToTime" 
      ((textPtr :pointer) (textLen :signed-long) (theCache (:pointer :datecacherecord)) (lengthUsed (:pointer :signed-long)) (dateTime (:pointer :longdaterec)))
   (:stack :stringtodatestatus)
   (:stack-trap #xA8B5 textPtr textLen theCache lengthUsed dateTime ((+ (ash 33300 16) 65524) :signed-longint)))

; 
;  *  LongDateToSeconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_LongDateToSeconds" 
      ((lDate (:pointer :longdaterec)) (lSecs (:pointer :wide)))
   nil
   (:stack-trap #xA8B5 lDate lSecs ((+ (ash 32776 16) 65522) :signed-longint)))

; 
;  *  LongSecondsToDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_LongSecondsToDate" 
      ((lSecs (:pointer :wide)) (lDate (:pointer :longdaterec)))
   nil
   (:stack-trap #xA8B5 lSecs lDate ((+ (ash 32776 16) 65520) :signed-longint)))

; 
;  *  ToggleDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ToggleDate" 
      ((lSecs (:pointer :wide)) (field :signed-byte) (delta :signed-byte) (ch :signed-integer) (params (:pointer :togglepb)))
   (:stack :toggleresults)
   (:stack-trap #xA8B5 lSecs field delta ch params ((+ (ash 33294 16) 65518) :signed-longint)))

; 
;  *  ValidDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ValidDate" 
      ((vDate (:pointer :longdaterec)) (flags :signed-long) (newSecs (:pointer :wide)))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 vDate flags newSecs ((+ (ash 33292 16) 65508) :signed-longint)))

; 
;  *  ReadDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReadDateTime" 
      ((time (:pointer :unsigned-long)))
   (:d0 :signed-integer)
   (:register-trap #xA039 :a0 time))

; 
;  *  GetDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetDateTime" 
      ((secs (:pointer :unsigned-long))) 
  nil
   (#x205F #x20B8 #x20C) )

; 
;  *  SetDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDateTime" 
      ((time :unsigned-long))
   (:d0 :signed-integer)
   (:register-trap #xA03A :d0 time))

; 
;  *  SetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_SetTime" 
      ((d (:pointer :datetimerec))) 
  nil
   (#x205F #xA9C7 #xA03A) )

; 
;  *  GetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetTime" 
      ((d (:pointer :datetimerec))) 
  nil
   (#x205F #x2038 #x20C #xA9C6) )

; 
;  *  DateToSeconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  SecondsToDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DateToSeconds" 
      ((d (:pointer :datetimerec)) (secs (:pointer :unsigned-long))) 
  nil
   () )
(deftrap-inline "_SecondsToDate" 
      ((secs :unsigned-long) (d (:pointer :datetimerec))) 
  nil
   (#x205F #x201F #xA9C6) )

; 
;     These routine are available in InterfaceLib using their old name.
;     Macros allow using the new names in all source code.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  IUDateString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_IUDateString" 
      ((dateTime :signed-long) (longFlag :signed-byte) (result (:pointer (:string 255)))) 
  nil
   (#x4267 #xA9ED) )

; 
;  *  IUTimeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUTimeString" 
      ((dateTime :signed-long) (wantSeconds :boolean) (result (:pointer (:string 255))))
   nil
   (:stack-trap #xA9ED dateTime wantSeconds result (2 :signed-integer)))

; 
;  *  IUDatePString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUDatePString" 
      ((dateTime :signed-long) (longFlag :signed-byte) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime longFlag result intlHandle (14 :signed-integer)))

; 
;  *  IUTimePString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUTimePString" 
      ((dateTime :signed-long) (wantSeconds :boolean) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime wantSeconds result intlHandle (16 :signed-integer)))

; 
;  *  IULDateString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IULDateString" 
      ((dateTime (:pointer :wide)) (longFlag :signed-byte) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime longFlag result intlHandle (20 :signed-integer)))

; 
;  *  IULTimeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IULTimeString" 
      ((dateTime (:pointer :wide)) (wantSeconds :boolean) (result (:pointer (:string 255))) (intlHandle :handle))
   nil
   (:stack-trap #xA9ED dateTime wantSeconds result intlHandle (22 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LongDate2Secs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_LongDate2Secs" 
      ((lDate (:pointer :longdaterec)) (lSecs (:pointer :wide)))
   nil
   (:stack-trap #xA8B5 lDate lSecs ((+ (ash 32776 16) 65522) :signed-longint)))

; 
;  *  LongSecs2Date()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LongSecs2Date" 
      ((lSecs (:pointer :wide)) (lDate (:pointer :longdaterec)))
   nil
   (:stack-trap #xA8B5 lSecs lDate ((+ (ash 32776 16) 65520) :signed-longint)))

; 
;  *  Date2Secs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; 
;  *  Secs2Date()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Date2Secs" 
      ((d (:pointer :datetimerec)) (secs (:pointer :unsigned-long))) 
  nil
   () )
(deftrap-inline "_Secs2Date" 
      ((secs :unsigned-long) (d (:pointer :datetimerec))) 
  nil
   (#x205F #x201F #xA9C6) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DateTimeUtilsIncludes

; $ENDC                                         ; __DATETIMEUTILS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'DateTimeUtils)