(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DesktopPrinting.p"
; at Wednesday May 1,2002 2:41:18 pm.
; 
;      File:       DesktopPrinting.p
;  
;      Contains:   Print driver declarations for classic PrintMonitor and Desktop PrintMonitor
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DESKTOPPRINTING__
; $SETC __DESKTOPPRINTING__ := 1

; $I+
; $SETC DesktopPrintingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PRINTING__
|#

(require-interface 'Printing)
#|                                              ; $I Printing.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

;   PrGeneral opcodes for desktop printng 
;   DTP printer types (address types) 

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kDTPUnknownPrinterType -1)        ;   unknown address type 
(defconstant $kDTPSerialPrinterType 0)          ;   serial printer 
(defconstant $kDTPAppleTalkPrinterType 1)       ;   AppleTalk printer 
(defconstant $kDTPTCPIPPrinterType 2)           ;   TCP/IP printer 
(defconstant $kDTPSCSIPrinterType 3)            ;   SCSI printer 
(defconstant $kDTPUSBPrinterType 4)             ;   USB printer 

;   serial ports 
(defconstant $kDTPUnknownPort -1)               ;   for drivers that support serial connection by the  
;   Comm Toolbox other than modem and printer port 
(defconstant $kDTPPrinterPort 0)                ;   printer port 
(defconstant $kDTPModemPort 1)                  ;   modem port 

;   PrGeneral opcodes 
(defconstant $kDTPGetPrinterInfo 23)
(defconstant $kDTPIsSamePrinterInfo 24)
(defconstant $kDTPSetDefaultPrinterInfo 25)

;   serial printer address 

(def-mactype :dtpserialaddressptr (find-mactype '(:pointer :dtpserialaddress)))
(defrecord DTPSerialAddress 
   (port :signed-integer)                       ;   kDTPPrinterPort, kDTPModemPort or kDTPUnknownPort 
   (portName (:string 31))                      ;   name of the port specified in the port field 
   )

;   AppleTalk printer address 
(def-mactype :dtpappletalkaddressptr (find-mactype '(:pointer :dtpappletalkaddress)))
(defrecord DTPAppleTalkAddress 
   (nbpName (:string 32))
   (nbpZone (:string 32))
   (nbpType (:string 32))
   )

;   TCP/IP printer address 
(def-mactype :dtptcpipaddressptr (find-mactype '(:pointer :dtptcpipaddress)))
(defrecord DTPTCPIPAddress 
   (TCPIPAddress (:string 255))
   (queueName (:string 255))
   )

;   SCSI printer address 
(def-mactype :dtpscsiaddressptr (find-mactype '(:pointer :dtpscsiaddress)))
(defrecord DTPSCSIAddress 
   (id :signed-integer)                         ;   SCSI id 
   )

;   USB printer address 
(def-mactype :dtpusbaddressptr (find-mactype '(:pointer :dtpusbaddress)))
(defrecord DTPUSBAddress 
   (name (:string 255))                         ;   printer name 
   )

;   data passed into the PrGeneral calls 
(def-mactype :dtpprinterinfoptr (find-mactype '(:pointer :dtpprinterinfo)))
(defrecord DTPPrinterInfo 
   (dtpDefaultName (:string 31))                ;   default name for the desktop printer. 
   (printerType :signed-integer)                ;   kDTPSerialPrinterType, kDTPAppleTalkPrinterType, kDTPTCPIPPrinterType, 
;   kDTPSCSIPrinterType, kDTPUSBPrinterType or kDTPUnknownPrinterType 
;   Info specific to each type of printers 
   (:variant 
      (
      (serial :dtpserialaddress)
      )
      (
      (appleTalk :dtpappletalkaddress)
      )
      (
      (tcpip :dtptcpipaddress)
      )
      (
      (scsi :dtpscsiaddress)
      )
      (
      (usb :dtpusbaddress)
      )
;   optional driver-specific information can be appended here 
      )
   )

(def-mactype :dtpprinterinfohandle (find-mactype '(:handle :dtpprinterinfo)))
(def-mactype :tdtpprgeneraldataptr (find-mactype '(:pointer :tdtpprgeneraldata)))
(defrecord TDTPPrGeneralData 
   (iOpCode :signed-integer)                    ;   kDTPGetPrinterInfo, kDTPIsSamePrinterInfo or kDTPSetDefaultPrinterInfo 
   (iError :signed-integer)
   (iCommand :signed-long)
   (printerInfo (:handle :dtpprinterinfo))
   )

;   desktop printer info resource 

(defconstant $kDTPInfoResType :|dtpi|)
(defconstant $kDTPInfoResID -8192)

;   connection types supported 
(defconstant $kDTPUnknownConnection #x0)        ;   unknown connection type 
(defconstant $kDTPSerialConnection #x1)         ;   serial connection 
(defconstant $kDTPSCSIConnection #x2)           ;   SCSI connection 
(defconstant $kDTPAppleTalkConnection #x4)      ;   AppleTalk connection 
(defconstant $kDTPTCPIPConnection #x8)          ;   TCP/IP connection 
(defconstant $kDTPUSBConnection #x10)           ;   USB connection 

;   dtp extra features supported 
(defconstant $kDTPBasicFeatures #x0)            ;   only basic dtp funtionalities are supported 

(def-mactype :dtpinforesourceptr (find-mactype '(:pointer :dtpinforesource)))
(defrecord DTPInfoResource 
   (features :signed-long)                      ;   kDTPBasicFeatures (only basic features are supported for MacOS 8.5) 
   (connectionType :signed-long)                ;   can be kDTPUnknownConnection or any combination of kDTPSerialConnection,  
;   kDTPSCSIConnection, kDTPAppleTalkConnection, kDTPTCPIPConnection and kDTPUSBConnection 
   )

;   GestaltDTPInfoRec.version 
(defconstant $kDTPGestaltStructVersion2 #x2008000);   version 2.0f0 (for Mac OS 8.0, 8.1 and 7.x) 
(defconstant $kDTPGestaltStructVersion3 #x3000000);   version 3.0 (for Mac OS 8.5) 

;   DTPInfo 

(def-mactype :dtpinfoptr (find-mactype '(:pointer :dtpinfo)))
(defrecord DTPInfo 
   (vRefNum :signed-integer)                    ;   vRefNum of the DTP folder 
   (dirID :signed-long)                         ;   directory ID of the DTP folder 
   (dtpName (:string 31))                       ;   name of the DTP folder 
   (driverType :ostype)                         ;   creator type of the print driver for this DTP 
   (current :boolean)                           ;   is this DTP currently the default printer? 
   (printerName (:string 32))                   ;   name of the acutal printer on the net (only for LaserWriter 8 dtps) 
   (zoneName (:string 32))                      ;   zone where this printer resides (only for LaserWriter 8 dtps) 
   )

;   data associated with the desktop printer info gestalt 
(def-mactype :gestaltdtpinforecptr (find-mactype '(:pointer :gestaltdtpinforec)))
(defrecord GestaltDTPInfoRec 
   (version :signed-long)                       ;   kDTPGestaltStructVersion3 or kDTPGestaltStructVersion2 
   (numDTPs :signed-integer)                    ;   number of the active dtps 
   (theDTPList :handle)                         ;   handle to a list of DTPInfo for the active dtps 
   (theDTPDriverList :handle)                   ;   handle to a list of print driver file specs for each of the active dtp in theDTPList 
   (reserved :signed-long)
   )

(def-mactype :gestaltdtpinfoptr (find-mactype '(:pointer :gestaltdtpinforec)))
(def-mactype :gestaltdtpinfohdle (find-mactype '(:handle :gestaltdtpinforec)))
;   AppleEvents  

(defconstant $kDTPSignature :|dtpx|)

(defconstant $aeDTPSetDefaultEventType :|pfsd|) ;   for setting a desktop printer to be the default 
(defconstant $aeDTPSyncEventType :|pfsc|)       ;   for notifying Desktop PrintMonitor of a new spool file created in a desktop printer folder 

;   event data 

(def-mactype :dtpappleeventdataptr (find-mactype '(:pointer :dtpappleeventdata)))
(defrecord DTPAppleEventData 
   (dtpSignature :ostype)                       ;   kDTPSignature 
   (dtpEventType :ostype)                       ;   aeDTPSetDefaultEventType or aeDTPSyncEventType 
   (dtpSpec :fsspec)                            ;   the file spec of the target dtp 
   )

;   Notification during de-spooling 
;   DTPAsyncErrorNotificationUPP 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DTPAsyncErrorNotificationProcPtr = PROCEDURE(errStr: StringHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :dtpasyncerrornotificationprocptr (find-mactype ':pointer))
; $ENDC

;   DTPEndNotificationUPP 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DTPEndNotificationProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :dtpendnotificationprocptr (find-mactype ':pointer))
; $ENDC

;   DTPInForegroundUPP 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DTPInForegroundProcPtr = FUNCTION: BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :dtpinforegroundprocptr (find-mactype ':pointer))
; $ENDC

;   DTPStatusMessageUPP 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DTPStatusMessageProcPtr = PROCEDURE(statusStr: StringHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :dtpstatusmessageprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dtpasyncerrornotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dtpasyncerrornotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dtpendnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dtpendnotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dtpinforegroundupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dtpinforegroundupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dtpstatusmessageupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dtpstatusmessageupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDTPAsyncErrorNotificationProcInfo #xC0)
(defconstant $uppDTPEndNotificationProcInfo #x0)
(defconstant $uppDTPInForegroundProcInfo #x10)
(defconstant $uppDTPStatusMessageProcInfo #xC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewDTPAsyncErrorNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewDTPAsyncErrorNotificationProc 
(deftrap "_NewDTPAsyncErrorNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDTPEndNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDTPEndNotificationProc 
(deftrap "_NewDTPEndNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDTPInForegroundUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDTPInForegroundProc 
(deftrap "_NewDTPInForegroundUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDTPStatusMessageUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDTPStatusMessageProc 
(deftrap "_NewDTPStatusMessageUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDTPAsyncErrorNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDTPAsyncErrorNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDTPEndNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDTPEndNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDTPInForegroundUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDTPInForegroundUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDTPStatusMessageUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDTPStatusMessageUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDTPAsyncErrorNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDTPAsyncErrorNotificationProc 
(deftrap-inline "_InvokeDTPAsyncErrorNotificationUPP" 
      ((errStr (:handle (:string 255))) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDTPEndNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDTPEndNotificationProc 
(deftrap "_InvokeDTPEndNotificationUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; 
;  *  InvokeDTPInForegroundUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDTPInForegroundProc 
(deftrap-inline "_InvokeDTPInForegroundUPP" 
      ((userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeDTPStatusMessageUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDTPStatusMessageProc 
(deftrap-inline "_InvokeDTPStatusMessageUPP" 
      ((statusStr (:handle (:string 255))) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   PrGeneral call that PrintMonitor/Desktop PrintMonitor use to set up the notification procs 

(defconstant $kPrintMonitorPrGeneral -3)

; 
; 	   TPrintMonitorPrintingData:
; 	   for classic background printing and desktop printing that does not support third-party drivers 
; 	

(def-mactype :tprintmonitorprintingdataptr (find-mactype '(:pointer :tprintmonitorprintingdata)))
(defrecord TPrintMonitorPrintingData 
   (iOpCode :signed-integer)                    ;   kPrintMonitorPrGeneral 
   (iError :signed-integer)
   (iReserved :signed-long)                     ;   0 - classic PrintMonitor is running 
   (hPrint (:handle :tprint))
   (noProcs :signed-integer)                    ;   number of notification procs 
   (iReserved2 :signed-long)
   (pAsyncNotificationProc :pointer)            ;   UPP to put up a notification 
   (pAsyncEndnotifyProc :pointer)               ;   UPP to take down the notification 
   (pDTPInForegroundProc :pointer)              ;   UPP to check if PrintMonitor is in foreground 
   )

; 
; 	   TDesktopPrintMonitorPrintingData:
; 	   for desktop printing that supports third-party print drivers
; 	
(def-mactype :tdesktopprintmonitorprintingdataptr (find-mactype '(:pointer :tdesktopprintmonitorprintingdata)))
(defrecord TDesktopPrintMonitorPrintingData 
   (iOpCode :signed-integer)                    ;   kPrintMonitorPrGeneral 
   (iError :signed-integer)
   (iReserved :signed-long)                     ;   1 - Desktop PrintMonitor is running 
   (hPrint (:handle :tprint))
   (noProcs :signed-integer)                    ;   number of notification procs 
   (iReserved2 :signed-long)
   (pAsyncNotificationProc :pointer)            ;   UPP to put up a notification 
   (pAsyncEndnotifyProc :pointer)               ;   UPP to take down the notification 
   (pInForegroundProc :pointer)                 ;   UPP to check if desktop printing is in foreground 
   (pStatusMessageProc :pointer)                ;   UPP to update the printing status message in the desktop printer window 
   )

;   Spool file data 

;   spool file data fork 
(def-mactype :spoolfileheaderptr (find-mactype '(:pointer :spoolfileheader)))
(defrecord SpoolFileHeader 
   (version :signed-integer)                    ;   should always be 1 
   (fileLen :signed-long)                       ;   length of the spool file including the spool file header 
   (fileFlags :signed-long)                     ;   should always be 0 
   (numPages :signed-integer)                   ;   total number of pages in the spool file 
   (printRecord :tprint)                        ;   used only if PREC 3 can't be read 
   )

(def-mactype :spoolfileheaderhandle (find-mactype '(:handle :spoolfileheader)))
(def-mactype :spoolpageptr (find-mactype '(:pointer :spoolpage)))
(defrecord SpoolPage 
   (pictFlags :signed-long)                     ;   should always be 0 
   (thePict :picture)                           ;   variable length 
   (pageOffset :signed-long)                    ;   offset to the beginning of this page's PICT 
   )

; 
; 	   spool file resource fork
; 	   PREC 126
; 	
(def-mactype :spoolprec126recordptr (find-mactype '(:pointer :spoolprec126record)))
(defrecord SpoolPREC126Record 
   (version :signed-integer)                    ;   always 1 
   (flags :signed-integer)                      ;   always 0 
   (numPages :signed-integer)                   ;   total number of pages in the spool file 
   (numCopies :signed-integer)                  ;   total number of copies for the spool file 
   (creator :ostype)                            ;   the creator type of the print driver that creates the spool file 
   (appName (:string 31))                       ;   the name of the application used to create the spool file 
   )

(def-mactype :spoolprec126ptr (find-mactype '(:pointer :spoolprec126record)))
(def-mactype :spoolprec126handle (find-mactype '(:handle :spoolprec126record)))
;   PINX -8200 (page index resource) 
(def-mactype :spoolpageindexptr (find-mactype '(:pointer :spoolpageindex)))
(defrecord SpoolPageIndex 
   (count :signed-integer)                      ;   number of elements in the pageOffset array 
   (pageOffset (:array :signed-long 1))         ;   the offset from the beginning of the file to the page record 
;   e.g. it would be sizeof(SpoolFileHeader) for the first page. 
   )

(def-mactype :spoolpageindexhandle (find-mactype '(:handle :spoolpageindex)))
; 
; 	   jobi 1 (DTP print job information resource)
; 	   print priorities
; 	

(defconstant $kDTPPrintJobUrgent #x1)
(defconstant $kDTPPrintJobAtTime #x2)
(defconstant $kDTPPrintJobNormal #x3)
(defconstant $kDTPPrintJobHolding #x1003)

(def-mactype :dtpprintjobinfoptr (find-mactype '(:pointer :dtpprintjobinfo)))
(defrecord DTPPrintJobInfo 
   (firstPageToPrint :signed-integer)           ;   first page in the spool file to print 
   (priority :signed-integer)                   ;   print priority (eg kDTPPrintJobNormal) 
   (numCopies :signed-integer)                  ;   total number of copies 
   (numPages :signed-integer)                   ;   total number of pages in the spool file 
   (timeToPrint :unsigned-long)                 ;   time to print (in seconds) when priority is kDTPPrintJobAtTime 
   (documentName (:string 31))                  ;   name of the document 
   (applicationName (:string 31))               ;   name of the application that's used to create this spool file 
   (printerName (:string 32))                   ;   name of the target printer (should be the same as what's in PREC 124) 
   )

(def-mactype :dtpprintjobinfohandle (find-mactype '(:handle :dtpprintjobinfo)))
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DesktopPrintingIncludes

; $ENDC                                         ; __DESKTOPPRINTING__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DesktopPrinting)