(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Disks.p"
; at Wednesday May 1,2002 2:40:01 pm.
; 
;      File:       Disks.p
;  
;      Contains:   Disk Driver Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DISKS__
; $SETC __DISKS__ := 1

; $I+
; $SETC DisksIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $sony 0)
(defconstant $hard20 1)

; 	 Disk Driver Status csCodes 	
(defconstant $kReturnFormatList 6)              ;   .Sony  
(defconstant $kDriveStatus 8)
(defconstant $kMFMStatus 10)

; 	 Disk Driver Control csCodes 	
(defconstant $kVerify 5)
(defconstant $kFormat 6)
(defconstant $kEject 7)
(defconstant $kSetTagBuffer 8)                  ;   .Sony  
(defconstant $kTrackCache 9)                    ;   .Sony  
(defconstant $kDriveIcon 21)
(defconstant $kMediaIcon 22)
(defconstant $kDriveInfo 23)
(defconstant $kRawTrack 18244)                  ;   .Sony: diagnostic raw track dump  

; 	
; 	    Note:
; 	
; 	    qLink is usually the first field in queues, but back in the MacPlus
; 	    days, the DrvSts record needed to be expanded.  In order to do this without
; 	    breaking disk drivers that already added stuff to the end, the fields
; 	    where added to the beginning.  This was originally done in assembly language
; 	    and the record was defined to start at a negative offset, so that the qLink
; 	    field would end up at offset zero.  When the C and pascal interfaces where
; 	    made, they could not support negative record offsets, so qLink was no longer
; 	    the first field.  Universal Interfaces are auto generated and don't support
; 	    negative offsets for any language, so DrvSts in Disks.a has qLinks at a
; 	    none zero offset.  Assembly code which switches to Universal Interfaces will
; 	    need to compensate for that.
; 	
; 		

(def-mactype :drvstsptr (find-mactype '(:pointer :drvsts)))
(defrecord DrvSts 
   (track :signed-integer)                      ;   current track  
   (writeProt :signed-byte)                     ;   bit 7 = 1 if volume is locked  
   (diskInPlace :signed-byte)                   ;   disk in drive  
   (installed :signed-byte)                     ;   drive installed  
   (sides :signed-byte)                         ;   -1 for 2-sided, 0 for 1-sided  
   (qLink (:pointer :qelem))                    ;   next queue entry  
   (qType :signed-integer)                      ;   1 for HD20  
   (dQDrive :signed-integer)                    ;   drive number  
   (dQRefNum :signed-integer)                   ;   driver reference number  
   (dQFSID :signed-integer)                     ;   file system ID  
   (:variant 
      (
      (twoSideFmt :signed-byte)                 ;   after 1st rd/wrt: 0=1 side, -1=2 side  
      (needsFlush :signed-byte)                 ;   -1 for MacPlus drive  
      (diskErrs :signed-integer)                ;   soft error count  
      )
      (
      (driveSize :signed-integer)
      (driveS1 :signed-integer)
      (driveType :signed-integer)
      (driveManf :signed-integer)
      (driveChar :signed-integer)
      (driveMisc :signed-byte)
      )
      )
   )

(%define-record :drvsts2 (find-record-descriptor :drvsts))
(def-mactype :drvsts2ptr (find-mactype '(:pointer :drvsts)))

(defconstant $kdqManualEjectBit 5)

; $IFC CALL_NOT_IN_CARBON 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  DiskEject()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  SetTagBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DiskEject" 
      ((drvNum :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  DriveStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetTagBuffer" 
      ((buffPtr :pointer)) 
  :signed-integer
   () )
(deftrap-inline "_DriveStatus" 
      ((drvNum :signed-integer) (status (:pointer :drvsts))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AddDrive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_AddDrive" 
      ((drvrRefNum :signed-integer) (drvNum :signed-integer) (qEl (:pointer :drvqel))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetDrvQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDrvQHdr" 
      () 
  (:pointer :qhdr)
   (#x2EBC #x0 #x308) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  Obsolete definitions                                                                             
; 
;  Status csCode previously defined in Devices.h/p/a.
;  * This is obsolete and the new name should be used instead.
;  

(defconstant $drvStsCode 8)                     ;   status call code for drive status  

; 	 Control csCodes previously defined in Devices.h/p/a.
; 	 * These are obsolete and the new names should be used instead.
; 	 	
(defconstant $ejectCode 7)                      ;   control call eject code  
(defconstant $tgBuffCode 8)                     ;   set tag buffer code  

; 	 Control csCodes previously defined in DriverGestalt.h/p/a.
; 	 * These are obsolete and the new names should be used instead.
; 	 	
(defconstant $VerifyCmd 5)
(defconstant $FormatCmd 6)
(defconstant $EjectCmd 7)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DisksIncludes

; $ENDC                                         ; __DISKS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Disks)