(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Drag.p"
; at Wednesday May 1,2002 2:39:37 pm.
; 
;      File:       Drag.p
;  
;      Contains:   Drag and Drop Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DRAG__
; $SETC __DRAG__ := 1

; $I+
; $SETC DragIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;   _________________________________________________________________________________________________________
;       
;     DRAG MANAGER DATA TYPES
;   _________________________________________________________________________________________________________
; 

(def-mactype :dragref (find-mactype ':pointer)) ;  an opaque 32-bit type 
(def-mactype :dragrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:DragRef parameter can be nil, it is changed to xx: DragRefPtr 
(def-mactype :dragitemref (find-mactype ':unsigned-long))
(def-mactype :flavortype (find-mactype ':ostype))
; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG ATTRIBUTES
; 	  _________________________________________________________________________________________________________
; 	
(def-mactype :dragattributes (find-mactype ':unsigned-long))

(defconstant $kDragHasLeftSenderWindow #x1)     ;   drag has left the source window since TrackDrag 
(defconstant $kDragInsideSenderApplication #x2) ;   drag is occurring within the sender application 
(defconstant $kDragInsideSenderWindow #x4)      ;   drag is occurring within the sender window 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG BEHAVIORS
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :dragbehaviors (find-mactype ':unsigned-long))

(defconstant $kDragBehaviorNone 0)
(defconstant $kDragBehaviorZoomBackAnimation #x1);   do zoomback animation for failed drags (normally enabled). 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG IMAGE FLAGS
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :dragimageflags (find-mactype ':unsigned-long))

(defconstant $kDragRegionAndImage #x10)         ;   drag region and image 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG IMAGE TRANSLUCENCY LEVELS
; 	  _________________________________________________________________________________________________________
; 	

(defconstant $kDragStandardTranslucency 0)      ;   65% image translucency (standard) 
(defconstant $kDragDarkTranslucency 1)          ;   50% image translucency 
(defconstant $kDragDarkerTranslucency 2)        ;   25% image translucency 
(defconstant $kDragOpaqueTranslucency 3)        ;   0% image translucency (opaque) 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG DRAWING PROCEDURE MESSAGES
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :dragregionmessage (find-mactype ':signed-integer))

(defconstant $kDragRegionBegin 1)               ;   initialize drawing 
(defconstant $kDragRegionDraw 2)                ;   draw drag feedback 
(defconstant $kDragRegionHide 3)                ;   hide drag feedback 
(defconstant $kDragRegionIdle 4)                ;   drag feedback idle time 
(defconstant $kDragRegionEnd 5)                 ;   end of drawing 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    ZOOM ACCELERATION
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :zoomacceleration (find-mactype ':signed-integer))

(defconstant $kZoomNoAcceleration 0)            ;   use linear interpolation 
(defconstant $kZoomAccelerate 1)                ;   ramp up step size 
(defconstant $kZoomDecelerate 2)                ;   ramp down step size 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    FLAVOR FLAGS
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :flavorflags (find-mactype ':unsigned-long))

(defconstant $flavorSenderOnly #x1)             ;   flavor is available to sender only 
(defconstant $flavorSenderTranslated #x2)       ;   flavor is translated by sender 
(defconstant $flavorNotSaved #x4)               ;   flavor should not be saved 
(defconstant $flavorSystemTranslated #x100)     ;   flavor is translated by system 
(defconstant $flavorDataPromised #x200)         ;   flavor data is promised by sender 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    FILE SYSTEM CONSTANTS
; 	  _________________________________________________________________________________________________________
; 	

(defconstant $kDragFlavorTypeHFS :|hfs |)       ;   flavor type for HFS data 
(defconstant $kDragFlavorTypePromiseHFS :|phfs|);   flavor type for promised HFS data 
(defconstant $flavorTypeHFS :|hfs |)            ;   old name 
(defconstant $flavorTypePromiseHFS :|phfs|)     ;   old name 

(defconstant $kDragPromisedFlavorFindFile :|rWm1|);   promisedFlavor value for Find File 
(defconstant $kDragPromisedFlavor :|fssP|)      ;   promisedFlavor value for everything else 

(defconstant $kDragPseudoCreatorVolumeOrDirectory :|MACS|);   "creator code" for volume or directory 
(defconstant $kDragPseudoFileTypeVolume :|disk|);   "file type" for volume 
(defconstant $kDragPseudoFileTypeDirectory :|fold|);   "file type" for directory 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    SPECIAL FLAVORS
; 	  _________________________________________________________________________________________________________
; 	

(defconstant $flavorTypeDirectory :|diry|)      ;   flavor type for AOCE directories 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    FLAVORS FOR FINDER 8.0 AND LATER
; 	  _________________________________________________________________________________________________________
; 	

(defconstant $kFlavorTypeClippingName :|clnm|)  ;   name hint for clipping file (preferred over 'clfn') 
(defconstant $kFlavorTypeClippingFilename :|clfn|);   name for clipping file 
(defconstant $kFlavorTypeDragToTrashOnly :|fdtt|);   for apps that want to allow dragging private data to the trash 
(defconstant $kFlavorTypeFinderNoTrackingBehavior :|fntb|);   Finder completely ignores any drag containing this flavor 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG TRACKING HANDLER MESSAGES
; 	  _________________________________________________________________________________________________________
; 	

(def-mactype :dragtrackingmessage (find-mactype ':signed-integer))

(defconstant $kDragTrackingEnterHandler 1)      ;   drag has entered handler 
(defconstant $kDragTrackingEnterWindow 2)       ;   drag has entered window 
(defconstant $kDragTrackingInWindow 3)          ;   drag is moving within window 
(defconstant $kDragTrackingLeaveWindow 4)       ;   drag has exited window 
(defconstant $kDragTrackingLeaveHandler 5)      ;   drag has exited handler 

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    DRAG ACTIONS
; 	  _________________________________________________________________________________________________________
; 	

(defconstant $kDragActionNothing 0)
(defconstant $kDragActionCopy 1)
(defconstant $kDragActionAlias #x2)
(defconstant $kDragActionGeneric #x4)
(defconstant $kDragActionPrivate #x8)
(defconstant $kDragActionMove #x10)
(defconstant $kDragActionDelete #x20)
(defconstant $kDragActionAll #xFFFFFFFF)

(def-mactype :dragactions (find-mactype ':unsigned-long))
; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    HFS FLAVORS
; 	  _________________________________________________________________________________________________________
; 	
(def-mactype :hfsflavorptr (find-mactype '(:pointer :hfsflavor)))
(defrecord HFSFlavor 
   (fileType :ostype)                           ;   file type  
   (fileCreator :ostype)                        ;   file creator  
   (fdFlags :unsigned-integer)                  ;   Finder flags  
   (fileSpec :fsspec)                           ;   file system specification  
   )

(def-mactype :promisehfsflavorptr (find-mactype '(:pointer :promisehfsflavor)))
(defrecord PromiseHFSFlavor 
   (fileType :ostype)                           ;   file type  
   (fileCreator :ostype)                        ;   file creator  
   (fdFlags :unsigned-integer)                  ;   Finder flags  
   (promisedFlavor :ostype)                     ;   promised flavor containing an FSSpec  
   )

; 
; 	  _________________________________________________________________________________________________________
; 	      
; 	    APPLICATION-DEFINED DRAG HANDLER ROUTINES
; 	  _________________________________________________________________________________________________________
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DragTrackingHandlerProcPtr = FUNCTION(message: DragTrackingMessage; theWindow: WindowRef; handlerRefCon: UNIV Ptr; theDrag: DragRef): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dragtrackinghandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DragReceiveHandlerProcPtr = FUNCTION(theWindow: WindowRef; handlerRefCon: UNIV Ptr; theDrag: DragRef): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dragreceivehandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dragtrackinghandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dragtrackinghandlerupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dragreceivehandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dragreceivehandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDragTrackingHandlerProcInfo #x3FA0)
(defconstant $uppDragReceiveHandlerProcInfo #xFE0)
; 
; 	 *  NewDragTrackingHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewDragTrackingHandlerProc 
(deftrap "_NewDragTrackingHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDragReceiveHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDragReceiveHandlerProc 
(deftrap "_NewDragReceiveHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDragTrackingHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDragTrackingHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDragReceiveHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDragReceiveHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDragTrackingHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDragTrackingHandlerProc 
(deftrap-inline "_InvokeDragTrackingHandlerUPP" 
      ((message :signed-integer) (theWindow (:pointer :windowrecord)) (handlerRefCon :pointer) (theDrag :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeDragReceiveHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDragReceiveHandlerProc 
(deftrap-inline "_InvokeDragReceiveHandlerUPP" 
      ((theWindow (:pointer :windowrecord)) (handlerRefCon :pointer) (theDrag :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;   _________________________________________________________________________________________________________
;       
;     APPLICATION-DEFINED ROUTINES
;   _________________________________________________________________________________________________________
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DragSendDataProcPtr = FUNCTION(theType: FlavorType; dragSendRefCon: UNIV Ptr; theItemRef: DragItemRef; theDrag: DragRef): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dragsenddataprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DragInputProcPtr = FUNCTION(VAR mouse: Point; VAR modifiers: SInt16; dragInputRefCon: UNIV Ptr; theDrag: DragRef): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :draginputprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DragDrawingProcPtr = FUNCTION(message: DragRegionMessage; showRegion: RgnHandle; showOrigin: Point; hideRegion: RgnHandle; hideOrigin: Point; dragDrawingRefCon: UNIV Ptr; theDrag: DragRef): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :dragdrawingprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dragsenddataupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dragsenddataupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :draginputupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :draginputupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dragdrawingupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dragdrawingupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDragSendDataProcInfo #x3FE0)
(defconstant $uppDragInputProcInfo #x3FE0)
(defconstant $uppDragDrawingProcInfo #xFFFA0)
; 
; 	 *  NewDragSendDataUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewDragSendDataProc 
(deftrap "_NewDragSendDataUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDragInputUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDragInputProc 
(deftrap "_NewDragInputUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDragDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDragDrawingProc 
(deftrap "_NewDragDrawingUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDragSendDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDragSendDataUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDragInputUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDragInputUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDragDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDragDrawingUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDragSendDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDragSendDataProc 
(deftrap-inline "_InvokeDragSendDataUPP" 
      ((theType :ostype) (dragSendRefCon :pointer) (theItemRef :unsigned-long) (theDrag :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeDragInputUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDragInputProc 
(deftrap-inline "_InvokeDragInputUPP" 
      ((mouse (:pointer :point)) (modifiers (:pointer :signed-integer)) (dragInputRefCon :pointer) (theDrag :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeDragDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDragDrawingProc 
(deftrap-inline "_InvokeDragDrawingUPP" 
      ((message :signed-integer) (showRegion (:handle :macregion)) (showOrigin :point) (hideRegion (:handle :macregion)) (hideOrigin :point) (dragDrawingRefCon :pointer) (theDrag :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;   _________________________________________________________________________________________________________
;       
;     INSTALLING AND REMOVING HANDLERS API'S
;   _________________________________________________________________________________________________________
; 

; 
;  *  InstallTrackingHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InstallTrackingHandler" 
      ((trackingHandler :pointer) (theWindow (:pointer :windowrecord)) (handlerRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 1 trackingHandler theWindow handlerRefCon))

; 
;  *  InstallReceiveHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InstallReceiveHandler" 
      ((receiveHandler :pointer) (theWindow (:pointer :windowrecord)) (handlerRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 2 receiveHandler theWindow handlerRefCon))

; 
;  *  RemoveTrackingHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveTrackingHandler" 
      ((trackingHandler :pointer) (theWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 3 trackingHandler theWindow))

; 
;  *  RemoveReceiveHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveReceiveHandler" 
      ((receiveHandler :pointer) (theWindow (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 4 receiveHandler theWindow))

; 
;   _________________________________________________________________________________________________________
;       
;     CREATING & DISPOSING
;   _________________________________________________________________________________________________________
; 

; 
;  *  NewDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewDrag" 
      ((theDrag (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 5 theDrag))

; 
;  *  DisposeDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDrag" 
      ((theDrag :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 6 theDrag))

; 
;   _________________________________________________________________________________________________________
;       
;     ADDING DRAG ITEM FLAVORS
;   _________________________________________________________________________________________________________
; 

; 
;     The method for setting Drag Manager promises differs from that for Scrap Manger promises.  This chart
;     describes the method for setting drag promises via AddDragItemFlavor().
;     
;         dataPtr         dataSize                                result
;      pointer value  actual data size    The data of size dataSize pointed to by dataPtr is added to the drag.
;         NULL             ignored        A promise is placed on the drag.
; 
; 
;  *  AddDragItemFlavor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AddDragItemFlavor" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (theType :ostype) (dataPtr :pointer) (dataSize :signed-long) (theFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 7 theDrag theItemRef theType dataPtr dataSize theFlags))

; 
;  *  SetDragItemFlavorData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragItemFlavorData" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (theType :ostype) (dataPtr :pointer) (dataSize :signed-long) (dataOffset :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 9 theDrag theItemRef theType dataPtr dataSize dataOffset))

; 
;   _________________________________________________________________________________________________________
;       
;     PROVIDING CALLBACK PROCEDURES
;   _________________________________________________________________________________________________________
; 

; 
;  *  SetDragSendProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragSendProc" 
      ((theDrag :pointer) (sendProc :pointer) (dragSendRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 10 theDrag sendProc dragSendRefCon))

; 
;  *  SetDragInputProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragInputProc" 
      ((theDrag :pointer) (inputProc :pointer) (dragInputRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 11 theDrag inputProc dragInputRefCon))

; 
;  *  SetDragDrawingProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragDrawingProc" 
      ((theDrag :pointer) (drawingProc :pointer) (dragDrawingRefCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 12 theDrag drawingProc dragDrawingRefCon))

; 
;   _________________________________________________________________________________________________________
;       
;     SETTING THE DRAG IMAGE
;   _________________________________________________________________________________________________________
; 

; 
;  *  SetDragImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragImage" 
      ((theDrag :pointer) (imagePixMap (:handle :pixmap)) (imageRgn (:handle :macregion)) (imageOffsetPt :point) (theImageFlags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 39 theDrag imagePixMap imageRgn imageOffsetPt theImageFlags))

; 
;   _________________________________________________________________________________________________________
;       
;     ALTERING THE BEHAVIOR OF A DRAG
;   _________________________________________________________________________________________________________
; 
; 
;  *  ChangeDragBehaviors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ChangeDragBehaviors" 
      ((theDrag :pointer) (inBehaviorsToSet :unsigned-long) (inBehaviorsToClear :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 40 theDrag inBehaviorsToSet inBehaviorsToClear))

; 
;   _________________________________________________________________________________________________________
;       
;     PERFORMING A DRAG
;   _________________________________________________________________________________________________________
; 
; 
;  *  TrackDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TrackDrag" 
      ((theDrag :pointer) (theEvent (:pointer :eventrecord)) (theRegion (:handle :macregion)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 13 theDrag theEvent theRegion))

; 
;   _________________________________________________________________________________________________________
;       
;     GETTING DRAG ITEM INFORMATION
;   _________________________________________________________________________________________________________
; 

; 
;  *  CountDragItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountDragItems" 
      ((theDrag :pointer) (numItems (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 14 theDrag numItems))

; 
;  *  GetDragItemReferenceNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragItemReferenceNumber" 
      ((theDrag :pointer) (index :unsigned-integer) (theItemRef (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 15 theDrag index theItemRef))

; 
;  *  CountDragItemFlavors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountDragItemFlavors" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (numFlavors (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 16 theDrag theItemRef numFlavors))

; 
;  *  GetFlavorType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFlavorType" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (index :unsigned-integer) (theType (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 17 theDrag theItemRef index theType))

; 
;  *  GetFlavorFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFlavorFlags" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (theType :ostype) (theFlags (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 18 theDrag theItemRef theType theFlags))

; 
;  *  GetFlavorDataSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFlavorDataSize" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (theType :ostype) (dataSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 19 theDrag theItemRef theType dataSize))

; 
;  *  GetFlavorData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFlavorData" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (theType :ostype) (dataPtr :pointer) (dataSize (:pointer :signed-long)) (dataOffset :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 20 theDrag theItemRef theType dataPtr dataSize dataOffset))

; 
;   _________________________________________________________________________________________________________
;       
;     DRAG ITEM BOUNDS
;   _________________________________________________________________________________________________________
; 

; 
;  *  GetDragItemBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragItemBounds" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (itemBounds (:pointer :rect)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 21 theDrag theItemRef itemBounds))

; 
;  *  SetDragItemBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SetDragItemBounds" 
      ((theDrag :pointer) (theItemRef :unsigned-long) (itemBounds (:pointer :rect)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 22 theDrag theItemRef itemBounds))

; 
;   _________________________________________________________________________________________________________
;       
;     DROP LOCATIONS
;   _________________________________________________________________________________________________________
; 

; 
;  *  GetDropLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDropLocation" 
      ((theDrag :pointer) (dropLocation (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 23 theDrag dropLocation))

; 
;  *  SetDropLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SetDropLocation" 
      ((theDrag :pointer) (dropLocation (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 24 theDrag dropLocation))

; 
;   _________________________________________________________________________________________________________
;       
;     GETTING INFORMATION ABOUT A DRAG
;   _________________________________________________________________________________________________________
; 

; 
;  *  GetDragAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragAttributes" 
      ((theDrag :pointer) (flags (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 25 theDrag flags))

; 
;  *  GetDragMouse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragMouse" 
      ((theDrag :pointer) (mouse (:pointer :point)) (globalPinnedMouse (:pointer :point)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 26 theDrag mouse globalPinnedMouse))

; 
;  *  SetDragMouse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDragMouse" 
      ((theDrag :pointer) (globalPinnedMouse :point))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 27 theDrag globalPinnedMouse))

; 
;  *  GetDragOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragOrigin" 
      ((theDrag :pointer) (globalInitialMouse (:pointer :point)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 28 theDrag globalInitialMouse))

; 
;  *  GetDragModifiers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragModifiers" 
      ((theDrag :pointer) (modifiers (:pointer :signed-integer)) (mouseDownModifiers (:pointer :signed-integer)) (mouseUpModifiers (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 29 theDrag modifiers mouseDownModifiers mouseUpModifiers))

; 
;   _________________________________________________________________________________________________________
;       
;     ACCESSING DRAG ACTIONS
;   _________________________________________________________________________________________________________
; 

; 
;  *  GetDragAllowableActions()
;  *  
;  *  Discussion:
;  *    Gets the actions the drag sender has allowed the receiver to
;  *    perform. These are not requirements, but they highly suggested
;  *    actions which allows the drag receiver to improve harmony across
;  *    the system.  The allowable actions received are always those
;  *    local to the caller's process.
;  *  
;  *  Parameters:
;  *    
;  *    theDrag:
;  *      The drag reference from which to retreive the allowable drag
;  *      actions.
;  *    
;  *    outActions:
;  *      A pointer to receive the field of allowable drag actions.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_GetDragAllowableActions" 
      ((theDrag :pointer) (outActions (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SetDragAllowableActions()
;  *  
;  *  Discussion:
;  *    Sets the actions the receiver of the drag is allowed to perform. 
;  *    These are not requirements, but they highly suggested actions
;  *    which allows the drag receiver to improve harmony across the
;  *    system.  The caller may select wether these drag actions apply to
;  *    a local or remote process.
;  *  
;  *  Parameters:
;  *    
;  *    theDrag:
;  *      The drag reference in which to set the allowable drag actions.
;  *    
;  *    inActions:
;  *      A field of allowable drag actions to be set.
;  *    
;  *    isLocal:
;  *      A boolean value allowing the drag sender to distinguish between
;  *      those drag actions allowable by the local receiver versus a
;  *      remote one.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_SetDragAllowableActions" 
      ((theDrag :pointer) (inActions :unsigned-long) (isLocal :boolean)) 
  :osstatus
   () )

; 
;  *  GetDragDropAction()
;  *  
;  *  Discussion:
;  *    Gets the action performed by the receiver of the drag.  More than
;  *    one action may have been performed.
;  *  
;  *  Parameters:
;  *    
;  *    theDrag:
;  *      The drag reference from which to retreive the performed drop
;  *      action.
;  *    
;  *    outAction:
;  *      A pointer to receive the drag action performed.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_GetDragDropAction" 
      ((theDrag :pointer) (outAction (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SetDragDropAction()
;  *  
;  *  Discussion:
;  *    Sets the action performed by the receiver of the drag.  More than
;  *    one action may be performed.
;  *  
;  *  Parameters:
;  *    
;  *    theDrag:
;  *      The drag reference in which to set the performed drop action.
;  *    
;  *    inAction:
;  *      The drop action performed.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_SetDragDropAction" 
      ((theDrag :pointer) (inAction :unsigned-long)) 
  :osstatus
   () )

; 
;   _________________________________________________________________________________________________________
;       
;     DRAG HIGHLIGHTING
;   _________________________________________________________________________________________________________
; 

; 
;  *  ShowDragHilite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ShowDragHilite" 
      ((theDrag :pointer) (hiliteFrame (:handle :macregion)) (inside :boolean))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 30 theDrag hiliteFrame inside))

; 
;  *  HideDragHilite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HideDragHilite" 
      ((theDrag :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 31 theDrag))

; 
;  *  DragPreScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DragPreScroll" 
      ((theDrag :pointer) (dH :signed-integer) (dV :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 32 theDrag dH dV))

; 
;  *  DragPostScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DragPostScroll" 
      ((theDrag :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 33 theDrag))

; 
;  *  UpdateDragHilite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UpdateDragHilite" 
      ((theDrag :pointer) (updateRgn (:handle :macregion)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 34 theDrag updateRgn))

; 
;  *  GetDragHiliteColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDragHiliteColor" 
      ((window (:pointer :windowrecord)) (color (:pointer :rgbcolor)))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 38 window color))

; 
;   _________________________________________________________________________________________________________
;       
;     UTILITIES
;   _________________________________________________________________________________________________________
; 

; 
;  *  WaitMouseMoved()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_WaitMouseMoved" 
      ((initialMouse :point))
   (:stack :boolean)
   (:stack-trap #xABED :d0 35 initialMouse))

; 
;  *  ZoomRects()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_ZoomRects" 
      ((fromRect (:pointer :rect)) (toRect (:pointer :rect)) (zoomSteps :signed-integer) (acceleration :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 36 fromRect toRect zoomSteps acceleration))

; 
;  *  ZoomRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ZoomRegion" 
      ((region (:handle :macregion)) (zoomDistance :point) (zoomSteps :signed-integer) (acceleration :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xABED :d0 37 region zoomDistance zoomSteps acceleration))

; 
;   _________________________________________________________________________________________________________
;     OLD NAMES
;      These are provided for compatiblity with older source bases.  It is recommended to not use them since
;      they may removed from this interface file at any time.
;   _________________________________________________________________________________________________________
; 

#|
; Warning: Patching def of type DragReference from translator table: was :pointer, is now :signed-long
|#
(def-mactype :dragreference (find-mactype :signed-long))
#| 
(def-mactype :dragreference (find-mactype ':pointer)) |#
(def-mactype :itemreference (find-mactype ':unsigned-long))
; $IFC OLDROUTINENAMES 

(defconstant $dragHasLeftSenderWindow #x1)      ;   drag has left the source window since TrackDrag  
(defconstant $dragInsideSenderApplication #x2)  ;   drag is occurring within the sender application  
(defconstant $dragInsideSenderWindow #x4)       ;   drag is occurring within the sender window  

(defconstant $dragTrackingEnterHandler 1)       ;   drag has entered handler  
(defconstant $dragTrackingEnterWindow 2)        ;   drag has entered window  
(defconstant $dragTrackingInWindow 3)           ;   drag is moving within window  
(defconstant $dragTrackingLeaveWindow 4)        ;   drag has exited window  
(defconstant $dragTrackingLeaveHandler 5)       ;   drag has exited handler  

(defconstant $dragRegionBegin 1)                ;   initialize drawing  
(defconstant $dragRegionDraw 2)                 ;   draw drag feedback  
(defconstant $dragRegionHide 3)                 ;   hide drag feedback  
(defconstant $dragRegionIdle 4)                 ;   drag feedback idle time  
(defconstant $dragRegionEnd 5)                  ;   end of drawing  

(defconstant $zoomNoAcceleration 0)             ;   use linear interpolation  
(defconstant $zoomAccelerate 1)                 ;   ramp up step size  
(defconstant $zoomDecelerate 2)                 ;   ramp down step size  

(defconstant $kDragStandardImage 0)             ;   65% image translucency (standard) 
(defconstant $kDragDarkImage 1)                 ;   50% image translucency 
(defconstant $kDragDarkerImage 2)               ;   25% image translucency 
(defconstant $kDragOpaqueImage 3)               ;   0% image translucency (opaque) 

; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DragIncludes

; $ENDC                                         ; __DRAG__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Drag)