(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DriverFamilyMatching.p"
; at Wednesday May 1,2002 2:40:01 pm.
; 
;      File:       DriverFamilyMatching.p
;  
;      Contains:   Interfaces for create native drivers NDRV
;  
;      Version:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DRIVERFAMILYMATCHING__
; $SETC __DRIVERFAMILYMATCHING__ := 1

; $I+
; $SETC DriverFamilyMatchingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;   ##############################################
;    Well known properties in the Name Registry
;   ##############################################
; 
;  CPassThru 
; 
;   #########################################################
;    Descriptor for Drivers and NDRVs
;   #########################################################
; 
;  
;     QuickTime 3.0: "DriverType" has a name collision with cross-platform code.
;     Use Mac prefix to avoid collision 
; 
;  Driver Typing Information Used to Match Drivers With Devices 

(def-mactype :macdrivertypeptr (find-mactype '(:pointer :macdrivertype)))
(defrecord MacDriverType 
   (nameInfoStr (:string 31))                   ;   Driver Name/Info String 
   (version :numversion)                        ;   Driver Version Number 
   )

; $IFC TARGET_OS_MAC 
(%define-record :drivertype (find-record-descriptor :macdrivertype))
(def-mactype :drivertypeptr (find-mactype '(:pointer :macdrivertype)))
; $ENDC                                         ; TARGET_OS_MAC

; 	 OS Runtime Information Used to Setup and Maintain a Driver's Runtime Environment 	
(def-mactype :runtimeoptions (find-mactype ':unsigned-long))

(defconstant $kDriverIsLoadedUponDiscovery #x1) ;   auto-load driver when discovered 
(defconstant $kDriverIsOpenedUponLoad #x2)      ;   auto-open driver when loaded 
(defconstant $kDriverIsUnderExpertControl #x4)  ;   I/O expert handles loads/opens 
(defconstant $kDriverIsConcurrent #x8)          ;   supports concurrent requests 
(defconstant $kDriverQueuesIOPB #x10)           ;   device manager doesn't queue IOPB 
(defconstant $kDriverIsLoadedAtBoot #x20)       ;   Driver is loaded at the boot time  
(defconstant $kDriverIsForVirtualDevice #x40)   ;   Driver is for a virtual Device  
(defconstant $kDriverSupportDMSuspendAndResume #x80);   Driver supports Device Manager Suspend and Resume command  

(def-mactype :driverosruntimeptr (find-mactype '(:pointer :driverosruntime)))
(defrecord DriverOSRuntime 
   (driverRuntime :unsigned-long)               ;   Options for OS Runtime 
   (driverName (:string 31))                    ;   Driver's name to the OS 
   (driverDescReserved (:array :unsigned-long 8));   Reserved area 
   )

; 	 OS Service Information Used To Declare What APIs a Driver Supports 	
(def-mactype :servicecount (find-mactype ':unsigned-long))
(def-mactype :driverserviceinfoptr (find-mactype '(:pointer :driverserviceinfo)))
(defrecord DriverServiceInfo 
   (serviceCategory :ostype)                    ;   Service Category Name 
   (serviceType :ostype)                        ;   Type within Category 
   (serviceVersion :numversion)                 ;   Version of service 
   )

(def-mactype :driverosserviceptr (find-mactype '(:pointer :driverosservice)))
(defrecord DriverOSService 
   (nServices :unsigned-long)                   ;   Number of Services Supported 
   (service (:array :driverserviceinfo 1))      ;   The List of Services (at least one) 
   )

; 	 Categories 	

(defconstant $kServiceCategoryDisplay :|disp|)  ;   Display Manager 
(defconstant $kServiceCategoryOpenTransport :|otan|);   Open Transport 
(defconstant $kServiceCategoryBlockStorage :|blok|);   Block Storage 
(defconstant $kServiceCategoryNdrvDriver :|ndrv|);   Generic Native Driver 
(defconstant $kServiceCategoryScsiSIM :|scsi|)  ;   SCSI  
(defconstant $kServiceCategoryFileManager :|file|);   File Manager  
(defconstant $kServiceCategoryIDE :|ide-|)      ;   ide  
(defconstant $kServiceCategoryADB :|adb-|)      ;   adb  
(defconstant $kServiceCategoryPCI :|pci-|)      ;   pci bus  
;   Nu Bus  
(defconstant $kServiceCategoryDFM :|dfm-|)      ;   DFM  
(defconstant $kServiceCategoryMotherBoard :|mrbd|);   mother Board  
(defconstant $kServiceCategoryKeyboard :|kybd|) ;   Keyboard  
(defconstant $kServiceCategoryPointing :|poit|) ;   Pointing  
(defconstant $kServiceCategoryRTC :|rtc-|)      ;   RTC  
(defconstant $kServiceCategoryNVRAM :|nram|)    ;   NVRAM  
(defconstant $kServiceCategorySound :|sond|)    ;   Sound (1/3/96 MCS)  
(defconstant $kServiceCategoryPowerMgt :|pgmt|) ;   Power Management  
(defconstant $kServiceCategoryGeneric :|genr|)  ;   Generic Service Category to receive general Events  

; 	 Ndrv ServiceCategory Types 	
(defconstant $kNdrvTypeIsGeneric :|genr|)       ;   generic 
(defconstant $kNdrvTypeIsVideo :|vido|)         ;   video 
(defconstant $kNdrvTypeIsBlockStorage :|blok|)  ;   block storage 
(defconstant $kNdrvTypeIsNetworking :|netw|)    ;   networking 
(defconstant $kNdrvTypeIsSerial :|serl|)        ;   serial 
(defconstant $kNdrvTypeIsParallel :|parl|)      ;   parallel  
(defconstant $kNdrvTypeIsSound :|sond|)         ;   sound 
(defconstant $kNdrvTypeIsBusBridge :|brdg|)
(defconstant $kNdrvTypeIsFWConference :|crsh|)  ;   FireWire conference camera  
(defconstant $kNdrvTypeIsAVC :|avc |)           ;   FireWire AVC devices (DV cameras)  

(def-mactype :driverdescversion (find-mactype ':unsigned-long))
; 	  The Driver Description 	

(defconstant $kTheDescriptionSignature :|mtej|)
(defconstant $kDriverDescriptionSignature :|pdes|)

(defconstant $kInitialDriverDescriptor 0)
(defconstant $kVersionOneDriverDescriptor 1)

(def-mactype :driverdescriptionptr (find-mactype '(:pointer :driverdescription)))
(defrecord DriverDescription 
   (driverDescSignature :ostype)                ;   Signature field of this structure 
   (DriverDescVersion :unsigned-long)           ;   Version of this data structure 
   (driverType :macdrivertype)                  ;   Type of Driver 
   (driverOSRuntimeInfo :driverosruntime)       ;   OS Runtime Requirements of Driver 
   (driverServices :driverosservice)            ;   Apple Service API Membership 
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DriverFamilyMatchingIncludes

; $ENDC                                         ; __DRIVERFAMILYMATCHING__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'DriverFamilyMatching)