(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DriverGestalt.p"
; at Wednesday May 1,2002 2:41:20 pm.
; 
;      File:       DriverGestalt.p
;  
;      Contains:   Driver Gestalt interfaces
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DRIVERGESTALT__
; $SETC __DRIVERGESTALT__ := 1

; $I+
; $SETC DriverGestaltIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SCSI__
|#

(require-interface 'SCSI)
#|                                              ; $I SCSI.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __USB__

(require-interface 'USB)                        ; $I USB.p
; $ENDC
#|                                              ; $IFC UNDEFINED __DISKS__
|#

(require-interface 'Disks)
#|                                              ; $I Disks.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; __________________________________________________________________________________
;  The Driver Gestalt bit in the dCtlFlags 

(defconstant $kbDriverGestaltEnable 2)
(defconstant $kmDriverGestaltEnableMask #x4)

; 	__________________________________________________________________________________	
; 	 Driver Gestalt related csCodes 	
(defconstant $kDriverGestaltCode 43)            ;   various uses  
(defconstant $kDriverConfigureCode 43)          ;   various uses  
(defconstant $kcsSetBootPartitionCode 44)       ;   Set Startup Partition Control Call  
(defconstant $kcsGetBootPartitionStatus 44)     ;   Get Startup Partition Status Call  
(defconstant $kdgLowPowerMode 70)               ;   Sets/Returns the current energy consumption level  
(defconstant $kdgReturnDeviceID 120)            ;   returns SCSI DevID in csParam[0]  
(defconstant $kdgGetCDDeviceInfo 121)           ;   returns CDDeviceCharacteristics in csParam[0]  

; 	__________________________________________________________________________________	
; 	 Driver Gestalt selectors 	
(defconstant $kdgVersion :|vers|)               ;   Version number of the driver in standard Apple format  
(defconstant $kdgDeviceType :|devt|)            ;   The type of device the driver is driving.  
(defconstant $kdgInterface :|intf|)             ;   The underlying interface that the driver is using (if any)  
(defconstant $kdgSync :|sync|)                  ;   True if driver only behaves synchronously.  
(defconstant $kdgBoot :|boot|)                  ;   value to place in PRAM for this drive (long)  
(defconstant $kdgWide :|wide|)                  ;   True if driver supports ioWPosOffset  
(defconstant $kdgPurge :|purg|)                 ;   Driver purge permission (True = purge; False = no purge)  
(defconstant $kdgSupportsSwitching :|lpwr|)     ;   True if driver supports power switching  
(defconstant $kdgMin3VPower :|pmn3|)            ;   Minimum 3.3V power consumption in microWatts  
(defconstant $kdgMin5VPower :|pmn5|)            ;   Minimum 5V power consumption in microWatts  
(defconstant $kdgMax3VPower :|pmx3|)            ;   Maximum 3.3V power consumption in microWatts  
(defconstant $kdgMax5VPower :|pmx5|)            ;   Maximum 5V power consumption in microWatts  
(defconstant $kdgInHighPower :|psta|)           ;   True if device is currently in high power mode  
(defconstant $kdgSupportsPowerCtl :|psup|)      ;   True if driver supports following five calls  
(defconstant $kdgAPI :|dAPI|)                   ;   API support for PC Exchange  
(defconstant $kdgEject :|ejec|)                 ;   Eject options for shutdown/restart (Shutdown Mgr)  
(defconstant $kdgFlush :|flus|)                 ;   Determine if disk driver supports flush and if it needs a flush  
(defconstant $kdgVMOptions :|vmop|)             ;   Disk drive's Virtual Memory options  
(defconstant $kdgMediaInfo :|minf|)             ;   return media specific information  
(defconstant $kdgPhysDriveIconSuite :|dics|)    ;   Return a pointer to a IconFamily ('icns') data structure for  
;   Disk Driver physical drive (formerly in csCode 21) in driverGestaltResponse.  
(defconstant $kdgMediaIconSuite :|mics|)        ;   Return a pointer to a IconFamily ('icns') data structure for  
;   Disk Driver media (formerly in csCode 22) in driverGestaltResponse.  
;   See IconServices.r for information detailing the 'icns' resource data format  
(defconstant $kdgMediaName :|mnam|)             ;   Return a pointer to a pascal string describing the Disk Driver (formerly in csCode 21) in driverGestaltResponse.  
(defconstant $kdgGetDriveAddInfo :|digt|)       ;   Get a disk driver's add-drive information record  
(defconstant $kdcAddDriveWithInfo :|diad|)      ;   Tell disk driver to add the drive specified with the drive information record  
;   DriverGestalt selector for ATA drivers to signify that they are device 0/1 compliant.  
;   see http://developer.apple.com/techpubs/hardware/Developer_Notes/System_Software/ATA_Device_Zero_One.pdf  
(defconstant $kdgATADev1 :|dev1|)
(defconstant $kdgDeviceReference :|dvrf|)       ;   Returns a 32-bit reference number for the device, format is interface specific  
(defconstant $kdgNameRegistryEntry :|nmrg|)     ;   Returns a pointer to the Name Registry ID for the device  
(defconstant $kdgDeviceModelInfo :|info|)       ;   Returns a pointer to a Device Model Info structure  
(defconstant $kdgSupportedMediaTypes :|mdty|)   ;   Returns a count and a pointer to list of all media types supported by the device  
(defconstant $kdgOpenFirmwareBootSupport :|ofpt|);   Returns information that Open Firmware needs to support booting from the device  
(defconstant $kdgOpenFirmwareBootingSupport :|ofbt|);   Returns same information as kdgOpenFirmwareBootSupport, but is only used during booting 

; 	__________________________________________________________________________________	
; 	 Driver Configure selectors 	
(defconstant $kdcFlush :|flus|)                 ;   Tell a disk driver to flush its cache and any hardware caches  
(defconstant $kdcVMOptions :|vmop|)             ;   Change the disk driver's Virtual Memory options  

; 	__________________________________________________________________________________	
; 	 control parameter block for Driver Configure calls 	

(def-mactype :driverconfigparamptr (find-mactype '(:pointer :driverconfigparam)))
(defrecord DriverConfigParam 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)                  ;   refNum for I/O operation  
   (csCode :signed-integer)                     ;   == kDriverConfigureCode  
   (driverConfigureSelector :ostype)
   (driverConfigureParameter :unsigned-long)
   )

; 	__________________________________________________________________________________	
; 	 status parameter block for Driver Gestalt calls 	
(def-mactype :drivergestaltparamptr (find-mactype '(:pointer :drivergestaltparam)))
(defrecord DriverGestaltParam 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)                  ;   refNum for I/O operation  
   (csCode :signed-integer)                     ;      == kDriverGestaltCode  
   (driverGestaltSelector :ostype)              ;   'sync', 'vers', etc.  
   (driverGestaltResponse :unsigned-long)       ;   Could be a pointer, bit field or other format  
   (driverGestaltResponse1 :unsigned-long)      ;   Could be a pointer, bit field or other format  
   (driverGestaltResponse2 :unsigned-long)      ;   Could be a pointer, bit field or other format  
   (driverGestaltResponse3 :unsigned-long)      ;   Could be a pointer, bit field or other format  
   (driverGestaltfiller :unsigned-integer)      ;   To pad out to the size of a controlPB  
   )

; 	__________________________________________________________________________________	
; 	 Device Types response 	
(def-mactype :drivergestaltdevtresponseptr (find-mactype '(:pointer :drivergestaltdevtresponse)))
(defrecord DriverGestaltDevTResponse 
   (deviceType :ostype)
   )

(defconstant $kdgDiskType :|disk|)              ;   standard r/w disk drive  
(defconstant $kdgTapeType :|tape|)              ;   tape drive  
(defconstant $kdgPrinterType :|prnt|)           ;   printer  
(defconstant $kdgProcessorType :|proc|)         ;   processor  
(defconstant $kdgWormType :|worm|)              ;   write-once  
(defconstant $kdgCDType :|cdrm|)                ;   cd-rom drive  
(defconstant $kdgFloppyType :|flop|)            ;   floppy disk drive  
(defconstant $kdgScannerType :|scan|)           ;   scanner  
(defconstant $kdgFileType :|file|)              ;   Logical Partition type based on a file (Drive Container)  
(defconstant $kdgRemovableType :|rdsk|)         ;   A removable media hard disk drive ie. Syquest, Bernioulli  

; 	__________________________________________________________________________________	
; 	 Device Interfaces response 	

(def-mactype :drivergestaltintfresponseptr (find-mactype '(:pointer :drivergestaltintfresponse)))
(defrecord DriverGestaltIntfResponse 
   (interfaceType :ostype)
   )

(defconstant $kdgScsiIntf :|scsi|)
(defconstant $kdgPcmciaIntf :|pcmc|)
(defconstant $kdgATAIntf :|ata |)
(defconstant $kdgUSBIntf :|usb |)
(defconstant $kdgFireWireIntf :|fire|)
(defconstant $kdgExtBus :|card|)
(defconstant $kdgNetworkIntf :|net |)

; 	__________________________________________________________________________________	
; 	 Power Saving 	

(def-mactype :drivergestaltpowerresponseptr (find-mactype '(:pointer :drivergestaltpowerresponse)))
(defrecord DriverGestaltPowerResponse 
   (powerValue :unsigned-long)                  ;   Power consumed in Watts  
   )

; 	__________________________________________________________________________________	
; 	 Disk Specific 	
(def-mactype :drivergestaltsyncresponseptr (find-mactype '(:pointer :drivergestaltsyncresponse)))
(defrecord DriverGestaltSyncResponse 
   (behavesSynchronously :boolean)
   (pad (:array :unsigned-byte 3 :packed))
   )

(def-mactype :drivergestaltbootresponseptr (find-mactype '(:pointer :drivergestaltbootresponse)))
(defrecord DriverGestaltBootResponse 
   (extDev :signed-byte)                        ;    Packed target (upper 5 bits) LUN (lower 3 bits)  
   (partition :signed-byte)                     ;    Unused  
   (SIMSlot :signed-byte)                       ;    Slot  
   (SIMsRSRC :signed-byte)                      ;    sRsrcID  
   )

(def-mactype :drivergestaltapiresponseptr (find-mactype '(:pointer :drivergestaltapiresponse)))
(defrecord DriverGestaltAPIResponse 
   (partitionCmds :signed-integer)              ;   if bit 0 is nonzero, supports partition control and status calls  
;         prohibitMounting (control, kProhibitMounting)  
;        partitionToVRef (status, kGetPartitionStatus)  
;        getPartitionInfo (status, kGetPartInfo)  
   (unused1 :signed-integer)                    ;   all the unused fields should be zero  
   (unused2 :signed-integer)
   (unused3 :signed-integer)
   (unused4 :signed-integer)
   (unused5 :signed-integer)
   (unused6 :signed-integer)
   (unused7 :signed-integer)
   (unused8 :signed-integer)
   (unused9 :signed-integer)
   (unused10 :signed-integer)
   )

(def-mactype :drivergestaltflushresponseptr (find-mactype '(:pointer :drivergestaltflushresponse)))
(defrecord DriverGestaltFlushResponse 
   (canFlush :boolean)                          ;   Return true if driver supports the  
;   kdcFlush Driver Configure _Control call  
   (needsFlush :boolean)                        ;   Return true if driver/device has data cached  
;   and needs to be flushed when the disk volume  
;   is flushed by the File Manager  
   (pad (:array :unsigned-byte 2 :packed))
   )

; 	 Flags for purge permissions 	

(defconstant $kbCloseOk 0)                      ;   Ok to call Close  
(defconstant $kbRemoveOk 1)                     ;   Ok to call RemoveDrvr  
(defconstant $kbPurgeOk 2)                      ;   Ok to call DisposePtr  
(defconstant $kmNoCloseNoPurge 0)
(defconstant $kmOkCloseNoPurge #x3)
(defconstant $kmOkCloseOkPurge #x7)

; 	 Driver purge permission structure 	

(def-mactype :drivergestaltpurgeresponseptr (find-mactype '(:pointer :drivergestaltpurgeresponse)))
(defrecord DriverGestaltPurgeResponse 
   (purgePermission :unsigned-integer)          ;   0 = Do not change the state of the driver  
;   3 = Do Close() and DrvrRemove() this driver  
;   but don't deallocate driver code  
;   7 = Do Close(), DrvrRemove(), and DisposePtr()  
   (purgeReserved :unsigned-integer)
   (purgeDriverPointer :pointer)                ;   pointer to the start of the driver block (valid  
;   only of DisposePtr permission is given  
   )

(def-mactype :drivergestaltejectresponseptr (find-mactype '(:pointer :drivergestaltejectresponse)))
(defrecord DriverGestaltEjectResponse 
   (ejectFeatures :unsigned-long)               ;     
   )

; 	 Flags for Ejection Features field 	

(defconstant $kRestartDontEject 0)              ;   Dont Want eject during Restart  
(defconstant $kShutDownDontEject 1)             ;   Dont Want eject during Shutdown  
(defconstant $kRestartDontEject_Mask #x1)
(defconstant $kShutDownDontEject_Mask #x2)

; 	
; 	    The DriverGestaltVMOptionsResponse is returned by a disk driver in response to a
; 	    kdgVMOptions Driver Gestalt request. This allows a disk driver to tell VM a few
; 	    things about a disk drive. For example:
; 	    
; 	     A drive that should never be in the page fault path should return kAllowVMNoneMask.
; 	      Examples of this are drives that have manual eject buttons that are not disabled by
; 	      software, drives with very slow throughput, or drives that depend on
; 	      a network connection.
; 	     A drive that should never be written to but is safe for read-only file mapping
; 	      should return kAllowVMReadOnlyMask. Examples of this are WORM drives where each write
; 	      eats write-once space on the disk and CD-ROM drives which are read-only media.
; 	     A drive that should allow VM to create its main backing store file should return
; 	      kAllowVMReadWriteMask. Examples of this are fast read/write drives that don't allow
; 	      manual eject and don't use a network connection.
; 	    
; 	    A disk driver must look at the ioVRefNum field of the DriverGestaltParam to determine
; 	    what disk drive this call is for. This is a per-drive call, not a per-driver call.
; 	    
; 	    The only three valid responses to kdgVMOptions at this time are kAllowVMNoneMask,
; 	    kAllowVMReadOnlyMask, and kAllowVMReadWriteMask (i.e., setting only kAllowVMWriteBit
; 	    is not valid).
; 	    
; 	    Important: All bits not defined here are reserved and should be set to zero until
; 	    they are defined for a specific purpose.
; 	    
; 	    The kdcVMOptions Driver Configure _Control call provides the ability to change a driver's
; 	    response to kdgVMOptions Driver Gestalt requests. A driver should return controlErr if
; 	    it doesn't want to provide the ability to change the kdgVMOptions response. If a driver
; 	    supports the kdcVMOptions Driver Configure _Control call, but is asked to set an option bit
; 	    that it doesn't support (for example, if a read-only device is asked to set the kAllowVMWriteBit),
; 	    it should return paramErr.
; 		

(def-mactype :drivergestaltvmoptionsresponseptr (find-mactype '(:pointer :drivergestaltvmoptionsresponse)))
(defrecord DriverGestaltVMOptionsResponse 
   (vmOptions :unsigned-long)
   )

; 	 Bits and masks for DriverGestaltVMOptionsResponse.vmOptions field 	

(defconstant $kAllowVMReadBit 0)                ;   Allow VM to use this drive for read access  
(defconstant $kAllowVMWriteBit 1)               ;   Allow VM to use this drive for write access  
(defconstant $kAllowVMNoneMask 0)
(defconstant $kAllowVMReadOnlyMask #x1)
(defconstant $kAllowVMReadWriteMask #x3)

; 	 
; 	kdgGetDriveAddInfo/kdcAddDriveWithInfo is used by the Alias Manager to
; 	assist in the  remounting of container files. eg DiskCopy.  The driver
; 	can use it to store whatever information it needs to remount a drive
; 	For example the Volume name and FileID..  What is in here is entirely 
; 	dependant on the driver, we never interpret it.
; 	
; 	This extension to the Alias Manager works as such:
; 	   
; 	When creating an alias 
; 	----------------------
; 	    
; 	If driver supports Driver Gestalt, the Alias Mgr calls the driver with a 
; 	 kdgGetDriveAddInfo DriverGestalt request. 
; 	        
; 	Inputs to DriverGestalt:
; 	    ioVRefNum   = drive number
; 	    ioCRefNum   = driver refNum
; 	    csCode      = kDriverGestaltCode
; 	    driverGestaltSelector = kdgGetDriveAddInfo
; 	 
; 	If the driver supports kdgGetDriveAddInfo, it returns a pointer to the drive's
; 	drive  information record (DriverGestaltDriveAddInfoResponse*) in the 
; 	driverGestaltResponse field and returns noErr. 
; 	
; 	  The memory used by the DriverGestaltDriveAddInfoResponse and it's pointed 
; 	to data, must be previously held by the disk driver with HoldMemory. 
; 	        
; 	If the driver doesn't support kdgGetDriveAddInfo,  it returns statusErr.
; 	
; 	If noErr, the Alias Mgr stores the drive information record in the alias record 
; 	(the length of the drive information record data is in the length field).
; 	
; 	
; 	When resolving an alias:
; 	------------------------
; 	
; 	If driver supports Driver Gestalt, the Alias Mgr holds the drive information record 
; 	in the alias with HoldMemory and then calls the driver with a kdcAddDriveWithInfo
; 	DriverConfigure request. 
; 	        
; 	Inputs to DriverConfigure:
; 	    ioCRefNum   = driver refNum
; 	    csCode      = kDriverConfigureCode
; 	    driverGestaltSelector = pointer to DriverGestaltDriveAddInfoResponse
; 	            
; 	
; 	If the driver supports kdcAddDriveWithInfo, it uses the information in the drive 
; 	information record to add a drive to the drive queue. If the drive is added,
; 	the driver returns noErr and returns the drive number in the ioVRefNum field of 
; 	the parameter block. 
; 	
; 	If the drive cannot be added  (but kdcAddDriveWithInfo is supported), the driver 
; 	returns nsDrvErr. 
; 	
; 	If the driver doesn't  support kdcAddDriveWithInfo, it returns controlErr. 
; 	
; 	If noErr is returned, but the data in the  drive information record is not 
; 	up-to-date, the driver should set driveInfoChangedBit in the options field of the 
; 	drive information record. 
; 	
; 	If driveInfoInteractBit in the options field  is set at input, the driver 
; 	may perform user interaction to mount the drive.
; 	
; 	If noErr, the Alias Mgr tries to resolve the alias the rest of the way.
; 	 	
; 	 drive info option flags 	
(defconstant $driveInfoInteractBit 31)          ;   Input to kdcAddDriveWithInfo: If set, it's OK for the driver  
(defconstant $driveInfoInteractMask #x80000000) ;    to perform user interaction to add the drive  
(defconstant $driveInfoChangedBit 30)           ;   Output from kdgGetDriveInfo: If set, the drive was mounted, but  
(defconstant $driveInfoChangedMask #x40000000)  ;    the drive information record needs to be updated.  
(defconstant $driveInfoDriverReservedMask #xFFFF);   bits 0-15 are defined by each driver for its own use  
(defconstant $driveInfoSystemReservedMask #xFFFF0000);   bits 16-31 are reserved for Apple system use  

(def-mactype :drivergestaltdriveaddinforesponseptr (find-mactype '(:pointer :drivergestaltdriveaddinforesponse)))
(defrecord DriverGestaltDriveAddInfoResponse 
   (options :unsigned-long)                     ;   option flags.  
   (length :unsigned-long)                      ;   length of data  
   (data :pointer)                              ;   this data must be held with HoldMemory  
   )

; 	
; 	    The DriverGestaltMediaInfoResponse is returned by a disk driver in response to a
; 	    kdgMediaInfo DriverGestalt request. This allows a disk driver to tell callers the
; 	    physical block size, the number of blocks that are of that size, and the media type
; 	    for a given device.
; 	    
; 	    A disk driver must look at the ioVRefNum field of the DriverGestaltParam to determine
; 	    what disk drive this call is for. This is a per-drive call, not a per-driver call.
; 	    
; 	    On drives that support ejectable media, the response can change depending on what
; 	    media is currently in the drive.
; 		
(def-mactype :drivergestaltmediainforesponseptr (find-mactype '(:pointer :drivergestaltmediainforesponse)))
(defrecord DriverGestaltMediaInfoResponse 
   (numberBlocks :unsigned-long)                ;   number of blocks  
   (blockSize :unsigned-long)                   ;   physical size of blocks  
   (mediaType :signed-integer)                  ;   media type identifier  
   )

; 	 DriverGestaltMediaInfoResponse.mediaType constants 	

(defconstant $kMediaTypeUnknown 128)            ;   media type is unknown  
(defconstant $kMediaTypeCDROM 129)              ;   media type is a CD-ROM  
(defconstant $kMediaTypeDVDROM 130)             ;   media type is a DVD-ROM  
(defconstant $kMediaTypeDVDRAM 131)             ;   media type is a DVD-RAM  
(defconstant $kMediaTypeDVDR 132)               ;   media type is a DVD-RW  
(defconstant $kMediaTypeReadOnly 133)           ;   basic read only type  
(defconstant $kMediaTypeWriteOnce 134)          ;   basic write once type  
(defconstant $kMediaTypeRewritable 135)         ;   rewritable media, i.e CD-RW  
(defconstant $kMediaTypeOverwritable 136)       ;   random access read write media  
(defconstant $kMediaTypeNoMedia -1)             ;   no media is present  

(def-mactype :drivergestaltatadev1responseptr (find-mactype '(:pointer :drivergestaltatadev1response)))
(defrecord DriverGestaltATADev1Response 
   (dev1Support :unsigned-long)                 ;   1 = supports devices 0 and 1 
   )

; 	__________________________________________________________________________________	
; 	 Device Reference 	
; 	
; 	    The driver will return a 32-bit device reference number in the driverGestaltResponse
; 	    field of the DriverGestaltParam structure. The device refernce number will be interpreted 
; 	    differently depending on the interface retrieved by using the 'intf' Driver Gestalt call.
; 		
; 	The union for the kdgDeviceReference Gestalt 	
(def-mactype :drivergestaltdevicereferenceresponseptr (find-mactype '(:pointer :drivergestaltdevicereferenceresponse)))
(defrecord DriverGestaltDeviceReferenceResponse 
   (:variant 
      (
      (devRef :unsigned-long)                   ;   Generic reference number for interfaces not specified  
      )
      (
      (scsiID :deviceident)                     ;   kdgScsiIntf devices will return a DeviceIdent  
      )
      (
      (ataID :deviceident)                      ;   kdgATAIntf devices will return a DeviceIdent  
      )
      (
      (usbRef :signed-long)                     ;   kdgUSBIntf devices will return a USBDeviceRef 
      )
      )
   )

; 	__________________________________________________________________________________	
; 	 Name Registry ID 	
; 	
; 	    The driver will pass back in the driverGestaltResponse field of the DriverGestaltParam
; 	    a pointer to the Name Registry Entry ID for the device that it controls
; 		
; 	 The structure for the kdgNameRegistryEntry Gestalt 	
(def-mactype :drivergestaltnameregistryresponseptr (find-mactype '(:pointer :drivergestaltnameregistryresponse)))
(defrecord DriverGestaltNameRegistryResponse 
   (entryID (:pointer :regentryid))
   )

; 	__________________________________________________________________________________	
; 	 Device Model Information 	
; 	
; 	    The driver will pass a pointer to the DriverGestaltDeviceModelInfoResponse in the
; 	    driverGestaltResponse field of the DriverGestaltParam structure
; 	
; 	    The structure for the kdgDeviceModelInfo Gestalt
; 	    If any of theses pointers are nil, that means that the device doesn't provide that information
; 		
(def-mactype :drivergestaltdevicemodelinforesponseptr (find-mactype '(:pointer :drivergestaltdevicemodelinforesponse)))
(defrecord DriverGestaltDeviceModelInfoResponse 
   (infoStructVersion :unsigned-long)
   (vendorName (:pointer (:string 255)))
   (productName (:pointer (:string 255)))
   (revisionNumber (:pointer (:string 255)))
   (subRevisionNumber (:pointer (:string 255)))
   (serialNumber (:pointer (:string 255)))
   )

; 	 infoStructVersion field values 	
; 	 NOTE: May need/want to add a UniCode version of the InfoStruct at some point 	

(defconstant $kInfoStructStringPtrsVers1 1)

; 	__________________________________________________________________________________	
; 	 Supported Media Types 	
; 	
; 	    The driver will return the number of media types supported by the device in the 
; 	    driverGestaltResponse field of the DriverGestaltParam structure and an array of 
; 	    'devt' values for the supported media types will be returned in the driverGestaltResponse1
; 	    field of the DriverGestaltParam.
; 	
; 	    This call will return the number of media types supported by the device, and an array
; 	    of 'devt' values for the media types (i.e. if a device supports floppy disks
; 	    and large capacity removables, the driver would return that 2 media types are supported,
; 	    and the array would contain kdgFloppyType ('flop') and kdgRemovableType ('rdsk')).
; 		
; 	 The structure for the kdgSupportedMediaTypes Gestalt 	

(def-mactype :drivergestaltsupportedmediatypesresponseptr (find-mactype '(:pointer :drivergestaltsupportedmediatypesresponse)))
(defrecord DriverGestaltSupportedMediaTypesResponse 
   (supportTypesCount :unsigned-long)           ;   The number of Media Types in the array  
   (supportedTypesArray (:array :ostype 1))     ;   Array of supported media types   
   )

; 	__________________________________________________________________________________	
; 	 Open Firmware Boot support  and Open Firmware Booting support 	
; 	
; 	    The kdgOpenFirmwareBootSupport selector is used to get information about boot support 
; 	    for the driver/device.  The kdgOpenFirmwareBootingSupport is used during the boot
; 	    process to allow booting from partitions that Open Firmware may not be able to read
; 	    directly (i.e. Disk Array partitions, encrypted partitions, compressed partitions, etc..)
; 	    
; 	    The driver will return the bootPartitionQualifier value in the driverGestaltResponse 
; 	    field of the DriverGestaltParam and will return the exact partition map entry for
; 	    the boot partition in the driverGestaltResponse1 field of the DriverGestaltParam if
; 	    kOFBootSpecifiedPartition is returned in the driverGestaltResponse.
; 	    The number that is returned for the bootPartitionMapEntry field if the kOFBootSpecifiedPartition 
; 	    is returned is the partition map entry number for the partition. (i.e. If the partition map entry
; 	    for the boot partition is the 2nd partition entry in the partition map, the bootPartitionMapEntry
; 	    field would be set to 2.  If the partition map entry for the boot partition is the 3rd partition 
; 	    map, the bootPartitionMapEntry field would be set to 3 and etc.)
; 		
(def-mactype :drivergestaltofbootsupportresponseptr (find-mactype '(:pointer :drivergestaltofbootsupportresponse)))
(defrecord DriverGestaltOFBootSupportResponse 
   (bootPartitionQualifier :unsigned-long)      ;      The exact level of booting that the driver and device supports  
   (bootPartitionMapEntry :unsigned-long)       ;      The Partition Map entry for the boot partition if applicable  
   )

; 	 Levels of boot support that the driver/device supports 	
; 	 These values are used in the bootPartitionQualifier field of the DriverGestaltOFBootSupportResponse 	

(defconstant $kOFBootAnyPartition 1)
(defconstant $kOFBootSpecifiedPartition 2)
(defconstant $kOFBootNotBootable 3)
(defconstant $kOFBootNotPartitioned 4)

; 	__________________________________________________________________________________	
; 	 CD-ROM Specific 	
; 	 The CDDeviceCharacteristics result is returned in csParam[0..2] of a 
; 	   standard CntrlParam parameter block called with csCode kdgGetCDDeviceInfo.
; 		

(def-mactype :cddevicecharacteristicsptr (find-mactype '(:pointer :cddevicecharacteristics)))
(defrecord CDDeviceCharacteristics 
   (speedMajor :signed-byte)                    ;   High byte of fixed point number containing drive speed  
   (speedMinor :signed-byte)                    ;   Low byte of "" CD 300 == 2.2, CD_SC == 1.0 etc.  
   (cdFeatures :unsigned-integer)               ;   Flags field for features and transport type of this CD-ROM  
   (extendedCdFeatures :unsigned-integer)       ;   extended flags to support new DVD-ROM/DVD-R etc.  
   )

(defconstant $cdFeatureFlagsMask #xFFFC)        ;   The Flags are in the first 14 bits of the cdFeatures field  
(defconstant $cdTransportMask #x3)              ;   The transport type is in the last 2 bits of the cdFeatures field  

; 	 Flags for cdFeatures field 	
(defconstant $cdPowerInject 0)                  ;   device supports power inject of media 
(defconstant $cdNotPowerEject 1)                ;   device does not support power eject of media 
(defconstant $cdMute 2)                         ;   device supports audio channels muting 
(defconstant $cdLeftToChannel 3)                ;   device supports left channel only mono audio 
(defconstant $cdRightToChannel 4)               ;   device supports right channel only mono audio 
(defconstant $cdLeftPlusRight 5)                ;   device supports left + right channels mono audio 
(defconstant $cdSCSI_2 10)                      ;   device supports SCSI2 command set (SCSI only) 
(defconstant $cdStereoVolume 11)                ;   device supports independent volume per channel 
(defconstant $cdDisconnect 12)                  ;   device supports disconnect / reconnect (SCSI only) 
(defconstant $cdWriteOnce 13)                   ;   device is a write-once type of drive 
(defconstant $cdLockableButton 14)              ;   device drawer/tray can be locked 
(defconstant $cdExtendedFeatures 15)            ;   extendedCdFeatures field is used 
(defconstant $cdPowerInject_Mask #x1)
(defconstant $cdNotPowerEject_Mask #x2)
(defconstant $cdMute_Mask #x4)
(defconstant $cdLeftToChannel_Mask #x8)
(defconstant $cdRightToChannel_Mask #x10)
(defconstant $cdLeftPlusRight_Mask #x20)
(defconstant $cdSCSI_2_Mask #x400)
(defconstant $cdStereoVolume_Mask #x800)
(defconstant $cdDisconnect_Mask #x1000)
(defconstant $cdWriteOnce_Mask #x2000)
(defconstant $cdLockableButton_Mask #x4000)
(defconstant $cdExtendedFeatures_Mask #x8000)

; 	 Transport types 	
(defconstant $cdCaddy 0)                        ;   CD_SC,CD_SC_PLUS,CD-300 etc. - power eject only 
(defconstant $cdTray #x1)                       ;   CD_300_PLUS etc. - power inject only 
(defconstant $cdLid #x2)                        ;   Power CD - no power inject/no power eject 

; 
; 	    Flags for extendedCdFeatures field
; 	    Only valid when cdExtendedFeatures_Mask bit of cdFeatures field is set
; 	
(defconstant $cdDVDROM 0)                       ;   device reads DVD-ROM media 
(defconstant $cdDVDR 1)                         ;   device writes DVD-R media 
(defconstant $cdDVDRAM 2)                       ;   device writes DVD-RAM media 
(defconstant $cdDVDAudio 3)                     ;   device reads DVD-Audio media 
(defconstant $cdDVDRW 4)                        ;   device writes DVD-RW media 
(defconstant $cdCDRom 5)                        ;   device reads CD-ROM media 
(defconstant $cdCDR 6)                          ;   device writes CD-R media 
(defconstant $cdCDRW 7)                         ;   device writes CD-RW media 
(defconstant $cdDVDROM_Mask #x1)
(defconstant $cdDVDR_Mask #x2)
(defconstant $cdDVDRAM_Mask #x4)
(defconstant $cdDVDAudio_Mask #x8)
(defconstant $cdDVDRW_Mask #x10)
(defconstant $cdCDRom_Mask #x20)
(defconstant $cdCDR_Mask #x40)
(defconstant $cdCDRW_Mask #x80)

;   the following are used by PC Exchange (and Apple DOS/PC Compatibility Card) 

;   Control Codes 
(defconstant $kRegisterPartition 50)            ;   PCX needs a new Drive (for a non-macintosh partition found on the disk) 
(defconstant $OLD_REGISTER_PARTITION 301)       ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $THE_DRIVE 0)                      ;   DrvQElPtr for the partition to register 
(defconstant $THE_PHYS_START 1)                 ;   The start of the partition in logical blocks 
(defconstant $THE_PHYS_SIZE 2)                  ;   The size of the partition in logical blocks 
(defconstant $kGetADrive 51)                    ;   control call to ask the driver to create a drive 
(defconstant $OLD_GET_A_DRIVE 302)              ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $THE_VAR_QUEL 0)                   ;   a VAR parameter for the returned DrvQElPtr 
(defconstant $kProhibitMounting 52)             ;   Dont allow mounting of the following drives 
(defconstant $kOldProhibitMounting 2100)        ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $kProhibitDevice 0)                ;   CS Param 0 and 1 (partInfoRecPtr) 
(defconstant $kIsContainerMounted 53)
(defconstant $kOldIsContainerMounted 2201)      ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card          
(defconstant $kContainerVRef 0)                 ;   CS Param 0 and 1 (VRefNum) 
(defconstant $kContainerParID 1)                ;   CS Param 2 and 3 (Parent ID) 
(defconstant $kContainerName 2)                 ;   CS Param 4 and 5 (File Name) 
(defconstant $kContainerResponse 3)             ;   CS Param 6 and 7 (VAR pointer to short result) 
(defconstant $kMountVolumeImg 54)
(defconstant $OLD_MOUNT_VOLUME_IMG 2000)
(defconstant $MV_HOST_VREFNUM 0)
(defconstant $MV_HOST_PAR_ID 1)
(defconstant $MV_HOST_NAME 2)
(defconstant $MV_REQ_PERM 3)

;   Status Codes 

(defconstant $kGetPartitionStatus 50)           ;   what is the status of this partition? 
(defconstant $kOldGetPartitionStatus 2200)      ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $kDeviceToQuery 0)                 ;   CS Param 0 and 1 (partInfoRecPtr) 
(defconstant $kDeviceResponse 1)                ;   CS Param 2 and 3 (VAR pointer to short result) 
(defconstant $kGetPartInfo 51)                  ;   Get a partition info record based on the provided vrefnum 
(defconstant $kOldGetPartInfo 2300)             ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $kPartInfoResponse 0)              ;   var parameter (pointer to partInfoRec) CSParam [0-1] 
(defconstant $kGetContainerAlias 52)            ;   Get the alias that describes the file this drive was mounted from. 
(defconstant $kOldGetContainerAlias 2400)       ;   left in for compatibility with shipping Apple DOS/PC Compatibility Card 
(defconstant $kGetAliasResponse 0)              ;      var parameter (pointer to a Handle) CSParam [0-1] 

;   the result codes to come from the driver interface  

(defconstant $DRIVER_NOT_INSTALLED -1)
(defconstant $DRIVER_BUSY -2)
(defconstant $CANT_MOUNT_WITHIN_THIS_FS -3)     ;   can only mount container within residing on HFS volume 
(defconstant $VOLUME_ALREADY_MOUNTED -4)        ;   Already Mounted 

;   requisite structures for PCX control and status calls 

(defconstant $kMaxProhibted 2)                  ;   the max number of volumes the PC can possibly have mounted 

;   GestaltSelector for Finding Driver information 

(defconstant $kGetDriverInfo :|vdrc|)

; 	 VerifyCmd, FormatCmd and EjectCmd are now defined in Disks.h/p/a 	
;   Partition information passed back and forth between PCX and the driver 

(def-mactype :partinforecptr (find-mactype '(:pointer :partinforec)))
(defrecord partInfoRec 
   (SCSIID :deviceident)                        ;   DeviceIdent for the device 
   (physPartitionLoc :unsigned-long)            ;   physical block number of beginning of partition 
   (partitionNumber :unsigned-long)             ;   the partition number of this partition 
   )

(def-mactype :vpartinforecptr (find-mactype '(:pointer :vpartinforec)))
(defrecord vPartInfoRec 
   (VPRTVers :signed-byte)                      ;   Virtual partition version number 
   (VPRTType :signed-byte)                      ;   virtual partition type (DOS, HFS, etc) 
   (drvrRefNum :signed-integer)                 ;   Driver Reference number of partition driver 
   )

;   Information related to DOS partitions 

(defconstant $kDOSSigLow #x1FE)                 ;   offset into boot block for DOS signature 
(defconstant $kDOSSigHi #x1FF)                  ;   offset into boot block for DOS signature 
(defconstant $kDOSSigValLo #x55)                ;   DOS signature value in low byte 
(defconstant $kDOSSigValHi #xAA)                ;   DOS signature value in high byte 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DriverGestaltIncludes

; $ENDC                                         ; __DRIVERGESTALT__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DriverGestalt)