(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Endian.p"
; at Wednesday May 1,2002 2:38:49 pm.
; 
;      File:       Endian.p
;  
;      Contains:   QuickTime Interfaces
;  
;      Version:    Technology: QuickTime 3.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ENDIAN__
; $SETC __ENDIAN__ := 1

; $I+
; $SETC EndianIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     This file provides Endian Flipping routines for dealing with converting data
;     between Big-Endian and Little-Endian machines.  These routines are useful
;     when writing code to compile for both Big and Little Endian machines and  
;     which must handle other endian number formats, such as reading or writing 
;     to a file or network packet.
;     
;     These routines are named as follows:
;     
;         Endian<U><W>_<S>to<D>
; 
;     where
;         <U> is whether the integer is signed ('S') or unsigned ('U')
;         <W> is integer bit width: 16, 32, or 64 
;         <S> is the source endian format: 'B' for big, 'L' for little, or 'N' for native
;         <D> is the destination endian format: 'B' for big, 'L' for little, or 'N' for native
;     
;     For example, to convert a Big Endian 32-bit unsigned integer to the current native format use:
;         
;         long i = EndianU32_BtoN(data);
;         
;     This file is set up so that the function macro to nothing when the target runtime already
;     is the desired format (e.g. on Big Endian machines, EndianU32_BtoN() macros away).
;             
;     If long long's are not supported, you cannot get 64-bit quantities as a single value.
;     The macros are not defined in that case.
;     
;     
;     
;                                 <<< W A R N I N G >>>
;     
;     It is very important not to put any autoincrements inside the macros.  This 
;     will produce erroneous results because each time the address is accessed in the macro, 
;     the increment occurs.
;     
;  
; 
;    Note: These functions are currently not implemented in any library
;          and are only listed here as function prototypes to document the macros
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  EndianS16_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_BtoN" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianS16_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_NtoB" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianS16_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_LtoN" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianS16_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_NtoL" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianS16_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_LtoB" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianS16_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS16_BtoL" 
      ((value :signed-integer)) 
  :signed-integer
   () )

; 
;  *  EndianU16_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_BtoN" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianU16_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_NtoB" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianU16_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_LtoN" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianU16_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_NtoL" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianU16_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_LtoB" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianU16_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU16_BtoL" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  EndianS32_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_BtoN" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianS32_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_NtoB" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianS32_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_LtoN" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianS32_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_NtoL" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianS32_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_LtoB" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianS32_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS32_BtoL" 
      ((value :signed-long)) 
  :signed-long
   () )

; 
;  *  EndianU32_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_BtoN" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  EndianU32_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_NtoB" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  EndianU32_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_LtoN" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  EndianU32_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_NtoL" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  EndianU32_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_LtoB" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  EndianU32_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU32_BtoL" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC NOT TYPE_LONGLONG 
; 
;    Note: If these Int64 functions ever were implemented in a library,
;          we would need two libraries, one for compilers that
;          support long long and one for other compilers.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  EndianS64_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_BtoN" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianS64_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_NtoB" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianS64_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_LtoN" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianS64_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_NtoL" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianS64_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_LtoB" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianS64_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianS64_BtoL" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  EndianU64_BtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_BtoN" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  EndianU64_NtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_NtoB" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  EndianU64_LtoN()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_LtoN" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  EndianU64_NtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_NtoL" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  EndianU64_LtoB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_LtoB" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  EndianU64_BtoL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianU64_BtoL" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; 
;    These types are used for structures that contain data that is
;    always in BigEndian format.  This extra typing prevents little
;    endian code from directly changing the data, thus saving much
;    time in the debugger.
; 

#|                                              ; $IFC TARGET_RT_LITTLE_ENDIAN 

(def-mactype :bigendianlongptr (find-mactype '(:pointer :signed-long)))
(defrecord BigEndianLong 
   (bigEndianValue :signed-long)
   )

(def-mactype :bigendianunsignedlongptr (find-mactype '(:pointer :bigendianunsignedlong)))
(defrecord BigEndianUnsignedLong 
   (bigEndianValue :unsigned-long)
   )

(def-mactype :bigendianshortptr (find-mactype '(:pointer :signed-integer)))
(defrecord BigEndianShort 
   (bigEndianValue :signed-integer)
   )

(def-mactype :bigendianunsignedshortptr (find-mactype '(:pointer :bigendianunsignedshort)))
(defrecord BigEndianUnsignedShort 
   (bigEndianValue :unsigned-integer)
   )

(def-mactype :bigendianfixedptr (find-mactype '(:pointer :signed-long)))
(defrecord BigEndianFixed 
   (bigEndianValue :signed-long)
   )

(def-mactype :bigendianunsignedfixedptr (find-mactype '(:pointer :unsigned-long)))
(defrecord BigEndianUnsignedFixed 
   (bigEndianValue :unsigned-long)
   )

(def-mactype :bigendianostypeptr (find-mactype '(:pointer :ostype)))
(defrecord BigEndianOSType 
   (bigEndianValue :ostype)
   )

 |#                                             ; $ELSEC

(def-mactype :bigendianlong (find-mactype ':signed-long))
(def-mactype :bigendianunsignedlong (find-mactype ':unsigned-long))
(def-mactype :bigendianshort (find-mactype ':signed-integer))
(def-mactype :bigendianunsignedshort (find-mactype ':unsigned-integer))
(def-mactype :bigendianfixed (find-mactype ':signed-long))
(def-mactype :bigendianunsignedfixed (find-mactype ':unsigned-long))
(def-mactype :bigendianostype (find-mactype ':ostype))
; $ENDC                                         ; TARGET_RT_LITTLE_ENDIAN

; 	
; 	    Implement low level _Swap functions.
; 	    
; 	        extern UInt16 Endian16_Swap(UInt16 value);
; 	        extern UInt32 Endian32_Swap(UInt32 value);
; 	        extern UInt64 Endian64_Swap(UInt64 value);
; 	        
; 	    Note: Depending on the processor, you might want to implement
; 	          these as function calls instead of macros.
; 	    
; 		
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Endian16_Swap()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_Endian16_Swap" 
      ((value :unsigned-integer))
   (:d0 :unsigned-integer)
   (:register-trap #xE158 :d0 value))

; 
;  *  Endian32_Swap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Endian32_Swap" 
      ((value :unsigned-long)) 
  :unsigned-long
   (#x201F #xE158 #x4840 #xE158 #x2E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPE_LONGLONG 
 |#                                             ; $ELSEC
;  
;     Note: When using compilers that don't support "long long",
;           Endian64_Swap must be implemented as glue. 
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Endian64_Swap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Endian64_Swap" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TYPE_LONGLONG

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := EndianIncludes

; $ENDC                                         ; __ENDIAN__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Endian)