(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Events.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       Events.p
;  
;      Contains:   Event Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __EVENTS__
; $SETC __EVENTS__ := 1

; $I+
; $SETC EventsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __QUICKDRAW__

(require-interface 'Quickdraw)                  ; $I Quickdraw.p
; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC NOT TARGET_OS_MAC OR NOT TARGET_API_MAC_OS8 
#|                                              ; $IFC UNDEFINED __ENDIAN__
|#

(require-interface 'Endian)
#|                                              ; $I Endian.p
 |#                                             ; $ENDC
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :eventkind (find-mactype ':unsigned-integer))
(def-mactype :eventmask (find-mactype ':unsigned-integer))

(defconstant $nullEvent 0)
(defconstant $mouseDown 1)
(defconstant $mouseUp 2)
(defconstant $keyDown 3)
(defconstant $keyUp 4)
(defconstant $autoKey 5)
(defconstant $updateEvt 6)
(defconstant $diskEvt 7)                        ;   Not sent in Carbon. See kEventClassVolume in CarbonEvents.h 
(defconstant $activateEvt 8)
(defconstant $osEvt 15)
(defconstant $kHighLevelEvent 23)

(defconstant $mDownMask #x2)                    ;   mouse button pressed 
(defconstant $mUpMask #x4)                      ;   mouse button released 
(defconstant $keyDownMask #x8)                  ;   key pressed 
(defconstant $keyUpMask #x10)                   ;   key released 
(defconstant $autoKeyMask #x20)                 ;   key repeatedly held down 
(defconstant $updateMask #x40)                  ;   window needs updating 
(defconstant $diskMask #x80)                    ;   disk inserted 
(defconstant $activMask #x100)                  ;   activate/deactivate window 
(defconstant $highLevelEventMask #x400)         ;   high-level events (includes AppleEvents) 
(defconstant $osMask #x8000)                    ;   operating system events (suspend, resume) 
(defconstant $everyEvent #xFFFF)                ;   all of the above 

(defconstant $charCodeMask #xFF)
(defconstant $keyCodeMask #xFF00)
(defconstant $adbAddrMask #xFF0000)
(defconstant $osEvtMessageMask #xFF000000)

;   OS event messages.  Event (sub)code is in the high byte of the message field. 
(defconstant $mouseMovedMessage #xFA)
(defconstant $suspendResumeMessage #x1)

(defconstant $resumeFlag 1)                     ;   Bit 0 of message indicates resume vs suspend 

; $IFC CALL_NOT_IN_CARBON 
; 	  convertClipboardFlag is not ever set under Carbon. This is because scrap conversion is  	
; 	  not tied to suspend/resume events any longer. Your application should instead use the   	
; 	  scrap promise mechanism and fulfill scrap requests only when your promise keeper proc   	
; 	  is called. If you need to know if the scrap has changed, you can cache the last         	
; 	  ScrapRef you received and compare it with the current ScrapRef                          	
(defconstant $convertClipboardFlag 2)           ;   Bit 1 in resume message indicates clipboard change 

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 	
; 	    CARBON ALERT! BATTLESTATIONS!
; 	    
; 	    The EventModifiers bits defined here are also used in the newer Carbon Event
; 	    key modifiers parameters. There are two main differences:
; 	    
; 	    1)  The Carbon key modifiers parameter is a UInt32, not a UInt16. Never try to
; 	        extract the key modifiers parameter from a Carbon Event into an EventModifiers
; 	        type. You will probably get your stack trashed.
; 	    2)  The Carbon key modifiers is just that: key modifiers. That parameter will
; 	        never contain the button state bit.
; 		

(def-mactype :eventmodifiers (find-mactype ':unsigned-integer))

;   modifiers  
(defconstant $activeFlagBit 0)                  ;   activate? (activateEvt and mouseDown) 
(defconstant $btnStateBit 7)                    ;   state of button? 
(defconstant $cmdKeyBit 8)                      ;   command key down? 
(defconstant $shiftKeyBit 9)                    ;   shift key down? 
(defconstant $alphaLockBit 10)                  ;   alpha lock down? 
(defconstant $optionKeyBit 11)                  ;   option key down? 
(defconstant $controlKeyBit 12)                 ;   control key down? 
(defconstant $rightShiftKeyBit 13)              ;   right shift key down? 
(defconstant $rightOptionKeyBit 14)             ;   right Option key down? 
(defconstant $rightControlKeyBit 15)            ;   right Control key down? 

(defconstant $activeFlag #x1)
(defconstant $btnState #x80)
(defconstant $cmdKey #x100)
(defconstant $shiftKey #x200)
(defconstant $alphaLock #x400)
(defconstant $optionKey #x800)
(defconstant $controlKey #x1000)
(defconstant $rightShiftKey #x2000)
(defconstant $rightOptionKey #x4000)
(defconstant $rightControlKey #x8000)

;   MacRoman character codes 
(defconstant $kNullCharCode 0)
(defconstant $kHomeCharCode 1)
(defconstant $kEnterCharCode 3)
(defconstant $kEndCharCode 4)
(defconstant $kHelpCharCode 5)
(defconstant $kBellCharCode 7)
(defconstant $kBackspaceCharCode 8)
(defconstant $kTabCharCode 9)
(defconstant $kLineFeedCharCode 10)
(defconstant $kVerticalTabCharCode 11)
(defconstant $kPageUpCharCode 11)
(defconstant $kFormFeedCharCode 12)
(defconstant $kPageDownCharCode 12)
(defconstant $kReturnCharCode 13)
(defconstant $kFunctionKeyCharCode 16)
(defconstant $kCommandCharCode 17)              ;   glyph available only in system fonts 
(defconstant $kCheckCharCode 18)                ;   glyph available only in system fonts 
(defconstant $kDiamondCharCode 19)              ;   glyph available only in system fonts 
(defconstant $kAppleLogoCharCode 20)            ;   glyph available only in system fonts 
(defconstant $kEscapeCharCode 27)
(defconstant $kClearCharCode 27)
(defconstant $kLeftArrowCharCode 28)
(defconstant $kRightArrowCharCode 29)
(defconstant $kUpArrowCharCode 30)
(defconstant $kDownArrowCharCode 31)
(defconstant $kSpaceCharCode 32)
(defconstant $kDeleteCharCode 127)
(defconstant $kBulletCharCode 165)
(defconstant $kNonBreakingSpaceCharCode 202)

;   useful Unicode code points 
(defconstant $kShiftUnicode #x21E7)             ;   Unicode UPWARDS WHITE ARROW 
(defconstant $kControlUnicode #x2303)           ;   Unicode UP ARROWHEAD 
(defconstant $kOptionUnicode #x2325)            ;   Unicode OPTION KEY 
(defconstant $kCommandUnicode #x2318)           ;   Unicode PLACE OF INTEREST SIGN 
(defconstant $kPencilUnicode #x270E)            ;   Unicode LOWER RIGHT PENCIL 
(defconstant $kCheckUnicode #x2713)             ;   Unicode CHECK MARK 
(defconstant $kDiamondUnicode #x25C6)           ;   Unicode BLACK DIAMOND 
(defconstant $kBulletUnicode #x2022)            ;   Unicode BULLET 
(defconstant $kAppleLogoUnicode #xF8FF)         ;   Unicode APPLE LOGO 

(def-mactype :eventrecordptr (find-mactype '(:pointer :eventrecord)))
(defrecord EventRecord 
   (what :unsigned-integer)
   (message :unsigned-long)
   (when :unsigned-long)
   (where :point)
   (modifiers :unsigned-integer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FKEYProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :fkeyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fkeyupp (find-mactype ':pointer)) ;  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fkeyupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFKEYProcInfo #x0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewFKEYUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewFKEYProc 
(deftrap "_NewFKEYUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFKEYUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFKEYUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFKEYUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFKEYProc 
(deftrap "_InvokeFKEYUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetMouse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMouse" 
      ((mouseLoc (:pointer :point)))
   nil
   (:stack-trap #xA972))

; 
;  *  Button()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Button" 
      ()
   (:stack :boolean)
   (:stack-trap #xA974))

; 
;  *  StillDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StillDown" 
      ()
   (:stack :boolean)
   (:stack-trap #xA973))

; 
;  *  WaitMouseUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_WaitMouseUp" 
      ()
   (:stack :boolean)
   (:stack-trap #xA977))

; 
;  *  KeyTranslate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_KeyTranslate" 
      ((transData :pointer) (keycode :unsigned-integer) (state (:pointer :unsigned-long)))
   (:stack :unsigned-long)
   (:stack-trap #xA9C3))

; 
;  *  GetCaretTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCaretTime" 
      ()
   (:no-trap :unsigned-long)
   (:no-trap (%get-unsigned-long (%int-to-ptr 756))))

(defrecord KeyMap (array (:array :boolean 128 :packed)))
; 
;  *  GetKeys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetKeys" 
      ((theKeys :keymap))
   nil
   (:stack-trap #xA976))

;  Obsolete event types & masks 

(defconstant $networkEvt 10)
(defconstant $driverEvt 11)
(defconstant $app1Evt 12)
(defconstant $app2Evt 13)
(defconstant $app3Evt 14)
(defconstant $app4Evt 15)
(defconstant $networkMask #x400)
(defconstant $driverMask #x800)
(defconstant $app1Mask #x1000)
(defconstant $app2Mask #x2000)
(defconstant $app3Mask #x4000)
(defconstant $app4Mask #x8000)

(def-mactype :evqelptr (find-mactype '(:pointer :evqel)))
(defrecord EvQEl 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (evtQWhat :unsigned-integer)                 ;   this part is identical to the EventRecord as defined above  
   (evtQMessage :unsigned-long)
   (evtQWhen :unsigned-long)
   (evtQWhere :point)
   (evtQModifiers :unsigned-integer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetNextEventFilterProcPtr = PROCEDURE(VAR theEvent: EventRecord; VAR result: BOOLEAN);

|#
 |#                                             ; $ELSEC
(def-mactype :getnexteventfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :getnexteventfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :getnexteventfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppGetNextEventFilterProcInfo #xBF)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewGetNextEventFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewGetNextEventFilterProc 
(deftrap "_NewGetNextEventFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeGetNextEventFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeGetNextEventFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeGetNextEventFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallGetNextEventFilterProc 
(deftrap-inline "_InvokeGetNextEventFilterUPP" 
      ((theEvent (:pointer :eventrecord)) (result (:pointer :boolean)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(def-mactype :gnefilterupp (find-mactype ':pointer))
; 
; 	 *  GetDblTime()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_GetDblTime" 
      ()
   (:no-trap :unsigned-long)
   (:no-trap (%get-unsigned-long (%int-to-ptr 752))))

; 
;  *  SetEventMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetEventMask" 
      ((value :unsigned-integer)) 
  nil
   (#x31DF #x144) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetEvQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetEvQHdr" 
      () 
  (:pointer :qhdr)
   (#x2EBC #x0 #x14A) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PPostEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PPostEvent" 
      ((eventCode :unsigned-integer) (eventMsg :unsigned-long) (qEl (:pointer (:pointer :evqel)))) 
  :signed-integer
   (#x225F #x201F #x305F #xA12F #x2288 #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetNextEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNextEvent" 
      ((EventMask :unsigned-integer) (theEvent (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xA970))

; 
;  *  WaitNextEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_WaitNextEvent" 
      ((EventMask :unsigned-integer) (theEvent (:pointer :eventrecord)) (sleep :unsigned-long) (mouseRgn (:handle :macregion)))
   (:stack :boolean)
   (:stack-trap #xA860))

; 
;  *  EventAvail()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EventAvail" 
      ((EventMask :unsigned-integer) (theEvent (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xA971))

; 
;  *  PostEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_PostEvent" 
      ((eventNum :unsigned-integer) (eventMsg :unsigned-long)) 
  :signed-integer
   (#x201F #x305F #xA02F #x3E80) )

; 
;     For Carbon, use EventAvail, TickCount, GetGlobalMouse,
;     GetKeys, or GetCurrentKeyModifiers instead of
;     OSEventAvail, and use GetNextEvent or WaitNextEvent
;     instead of GetOSEvent.
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OSEventAvail()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OSEventAvail" 
      ((mask :unsigned-integer) (theEvent (:pointer :eventrecord))) 
  :boolean
   (#x205F #x301F #xA030 #x5240 #x1E80) )

; 
;  *  GetOSEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetOSEvent" 
      ((mask :unsigned-integer) (theEvent (:pointer :eventrecord))) 
  :boolean
   (#x205F #x301F #xA031 #x5240 #x1E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  FlushEvents()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FlushEvents" 
      ((whichMask :unsigned-integer) (stopMask :unsigned-integer)) 
  nil
   (#x201F #xA032) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SystemClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SystemClick" 
      ((theEvent (:pointer :eventrecord)) (theWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xA9B3))

; 
;  *  SystemTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SystemTask" 
      ()
   nil
   (:stack-trap #xA9B4))

; 
;  *  SystemEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SystemEvent" 
      ((theEvent (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xA9B2))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  KeyTrans()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KeyTrans" 
      ((transData :pointer) (keycode :unsigned-integer) (state (:pointer :unsigned-long)))
   (:stack :unsigned-long)
   (:stack-trap #xA9C3))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; 
;     GetGlobalMouse, GetCurrentKeyModifiers, and CheckEventQueueForUserCancel
;     are only available as part of the Carbon API.
; 

; 
;  *  GetGlobalMouse()
;  *  
;  *  Summary:
;  *    Returns the position of the mouse in global coordinates.
;  *  
;  *  Parameters:
;  *    
;  *    globalMouse:
;  *      On exit, contains the mouse position in global coordinates.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetCurrentKeyModifiers()
;  *  
;  *  Summary:
;  *    Returns the current state of the keyboard modifier keys.
;  *  
;  *  Discussion:
;  *    The format of the return value is the same as the modifiers field
;  *    of the EventRecord.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetGlobalMouse" 
      ((globalMouse (:pointer :point))) 
  nil
   () )                                         ; 
;  *  CheckEventQueueForUserCancel()
;  *  
;  *  Summary:
;  *    Determines if there is a cancel event in the event queue.
;  *  
;  *  Discussion:
;  *    This API supports two cancel events: Escape and Cmd-Period. Mouse
;  *    or keyboard events in front of the cancel event in the event
;  *    queue will be removed.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCurrentKeyModifiers" 
      () 
  :unsigned-long
   () )                                         ; 
;     The core data structure for the Carbon event system. It is declared here instead of
;     in CarbonEvents.h to avoid recursive include problems.
; 
(deftrap-inline "_CheckEventQueueForUserCancel" 
      () 
  :boolean
   () )
(def-mactype :eventref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :eventrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EventRef parameter can be nil, it is changed to xx: EventRefPtr 
; 
; 	 *  KeyScript()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_KeyScript" 
      ((code :signed-integer))
   nil
   (:stack-trap #xA8B5 code ((+ (ash 32770 16) 4) :signed-longint)))

; 
;  *  IsCmdChar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_IsCmdChar" 
      ((event (:pointer :eventrecord)) (test :signed-integer))
   (:stack :boolean)
   (:stack-trap #xA8B5 event test ((+ (ash 33286 16) 65488) :signed-longint)))

;  
;     LowMem accessor functions previously in LowMem.h
; 
; 
;  *  LMGetKeyThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetKeyThresh" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 398))))

; 
;  *  LMSetKeyThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetKeyThresh" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x18E) )

; 
;  *  LMGetKeyRepThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetKeyRepThresh" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 400))))

; 
;  *  LMSetKeyRepThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetKeyRepThresh" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x190) )

; 
;  *  LMGetKbdLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetKbdLast" 
      () 
  :uint8
   (#x1EB8 #x218) )

; 
;  *  LMSetKbdLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetKbdLast" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x218) )

; 
;  *  LMGetKbdType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetKbdType" 
      () 
  :uint8
   (#x1EB8 #x21E) )

; 
;  *  LMSetKbdType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetKbdType" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x21E) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := EventsIncludes

; $ENDC                                         ; __EVENTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Events)