(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FileMapping.p"
; at Wednesday May 1,2002 2:41:25 pm.
; 
;      File:       FileMapping.p
;  
;      Contains:   File Mapping APIs
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FILEMAPPING__
; $SETC __FILEMAPPING__ := 1

; $I+
; $SETC FileMappingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PROCESSES__
|#

(require-interface 'Processes)
#|                                              ; $I Processes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  *  BackingFileID
;  *  
;  *  Discussion:
;  *    A BackingFileID is used to access a mapped file fork.
;  

(def-mactype :backingfileid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :backingfileidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:BackingFileID parameter can be nil, it is changed to xx: BackingFileIDPtr 

; 
; 	 *  MappingPrivileges
; 	 *  
; 	 *  Discussion:
; 	 *    A set of flags that describe what operations can be performed on
; 	 *    a mapped file fork.
; 	 	
(def-mactype :mappingprivileges (find-mactype ':unsigned-long))

(defconstant $kInvalidMappedPrivileges #x0)
(defconstant $kCanReadMappedFile #x1)           ;   mapped file fork has read access  
(defconstant $kCanWriteMappedFile #x2)          ;   mapped file fork has write access  
(defconstant $kNoProcessMappedFile #x80000000)  ;   mapped file fork and views are not tracked by process  
(defconstant $kValidMappingPrivilegesMask #x80000003)

; 
; 	 *  MappedFileAttributes
; 	 *  
; 	 *  Discussion:
; 	 *    A set of flags returned by GetMappedFileInformation that describe
; 	 *    the attributes of a mapped file fork.
; 	 	

(def-mactype :mappedfileattributes (find-mactype ':unsigned-long))

(defconstant $kIsMappedScratchFile #x1)         ;   mapped file fork is scratch file  

; 
; 	 	
(defconstant $kMappedFileInformationVersion1 1) ;   version 1 of MappedFileInformation  

; 
; 	 *  MappedFileInformation
; 	 *  
; 	 *  Discussion:
; 	 *    Receives the information supplied by GetMappedFileInformation.
; 	 *    The current version of this struct is
; 	 *    kMappedFileInformationVersion1.
; 	 	

(def-mactype :mappedfileinformationptr (find-mactype '(:pointer :mappedfileinformation)))
(defrecord MappedFileInformation 
   (owningProcess :processserialnumber)         ;   owning process  
   (ref (:pointer :fsref))                      ;   pointer to FSRef or NULL  
   (forkName (:pointer :hfsunistr255))          ;   pointer to HFSUniStr255 or NULL  
   (privileges :unsigned-long)                  ;   mapping privileges  
   (currentSize :unsignedwide)                  ;   size in bytes  
   (attributes :unsigned-long)                  ;   attributes  
   )

; 
; 	 *  FileViewAccess
; 	 *  
; 	 *  Discussion:
; 	 *    Values of type FileViewAccess represent allowable access to the
; 	 *    memory in a mapped file view.
; 	 	
(def-mactype :fileviewaccess (find-mactype ':unsigned-long))

(defconstant $kFileViewAccessReadBit 0)         ;   Reads allowed  
(defconstant $kFileViewAccessWriteBit 1)        ;   Writes allowed  
(defconstant $kFileViewAccessExecuteBit 2)      ;   Instruction execution permitted  
(defconstant $kFileViewAccessReadMask #x1)      ;   Reads allowed  
(defconstant $kFileViewAccessWriteMask #x2)     ;   Writes allowed  
(defconstant $kFileViewAccessExecuteMask #x4)   ;   Instruction execution permitted  
(defconstant $kFileViewAccessExcluded 0)        ;   All access is prohibited  
(defconstant $kFileViewAccessReadOnly #x5)
(defconstant $kFileViewAccessReadWrite #x7)

; 
; 	 *  FileViewOptions
; 	 *  
; 	 *  Discussion:
; 	 *    Values of type FileViewOptions specify desired characteristics of
; 	 *    the mapped file view being created. At this time, only
; 	 *    kNilOptions is supported.
; 	 	

(def-mactype :fileviewoptions (find-mactype ':unsigned-long))

; 
; 	 	

(defconstant $kMapEntireFork -1)                ;   map from backingBase to logical end-of-file  

; 
; 	 *  FileViewID
; 	 *  
; 	 *  Discussion:
; 	 *    A FileViewID is used to access a mapped file view.
; 	 	

(def-mactype :fileviewid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :fileviewidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:FileViewID parameter can be nil, it is changed to xx: FileViewIDPtr 

; 
; 	 	

(defconstant $kFileViewInformationVersion1 1)   ;   version 1 of MappedFileInformation  

; 
; 	 *  FileViewInformation
; 	 *  
; 	 *  Discussion:
; 	 *    Receives the information supplied by GetFileViewInformation. The
; 	 *    current version of this struct is kFileViewInformationVersion1.
; 	 	

(def-mactype :fileviewinformationptr (find-mactype '(:pointer :fileviewinformation)))
(defrecord FileViewInformation 
   (owningProcess :processserialnumber)         ;   owning process  
   (viewBase :pointer)                          ;   starting address of mapped file view  
   (viewLength :unsigned-long)                  ;   length of the mapped file view  
   (backingFile :pointer)                       ;   the mapped file fork  
   (backingBase :unsignedwide)                  ;   offset into mapped file fork  
   (access :unsigned-long)                      ;   the FileViewAccess  
   (guardLength :unsigned-long)                 ;   size of the guard ranges  
   (options :unsigned-long)                     ;   the FileViewOptions  
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OpenMappedFile()
; 	 *  
; 	 *  Summary:
; 	 *    Opens a file fork with the privileges requested for use as
; 	 *    backing storage.
; 	 *  
; 	 *  Discussion:
; 	 *    The OpenMappedFile function opens the fork specified by the
; 	 *    forkNameLength and forkName parameters of the file specified by
; 	 *    the ref parameter and returns a BackingFileID in the backingFile
; 	 *    parameter. You can pass the BackingFileID to other routines which
; 	 *    accept a BackingFileID as an input parameter. The privileges
; 	 *    parameter specifies what operations you want to perform on the
; 	 *    mapped file fork. Programs can request either kCanReadMappedFile
; 	 *    privileges, or both kCanReadMappedFile and kCanWriteMappedFile
; 	 *    privileges. To disable Process Manager tracking of the mapped
; 	 *    file fork and its mapped file views, you may also request
; 	 *    kNoProcessMappedFile privileges.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    ref:
; 	 *      The file to map.
; 	 *    
; 	 *    forkNameLength:
; 	 *      The fork name length in Unicode characters.
; 	 *    
; 	 *    forkName:
; 	 *      The fork name in Unicode (NULL = data fork).
; 	 *    
; 	 *    privileges:
; 	 *      The requested MappingPrivileges.
; 	 *    
; 	 *    backingFile:
; 	 *      Receives a BackingFileID which you can use to access the mapped
; 	 *      file fork.
; 	 *  
; 	 *  Result:
; 	 *    An operating system result code: noErr, paramErr,
; 	 *    vmMappingPrivilegesErr, or various File Manager and Memory
; 	 *    Manager errors.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ; CONST
(deftrap "_OpenMappedFile" 
      ((ref (:pointer :fsref)) (forkNameLength :unsigned-long) (forkName (:pointer :unsigned-integer)) (privileges :unsigned-long) (backingFile (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 0 ref forkNameLength forkName privileges backingFile))

; 
;  *  FSpOpenMappedFile()
;  *  
;  *  Summary:
;  *    Opens a file fork with the privileges requested for use as
;  *    backing storage.
;  *  
;  *  Discussion:
;  *    The FSpOpenMappedFile function opens the fork specified by the
;  *    mapResFork parameter of the file specified by the spec parameter
;  *    and returns a BackingFileID in the backingFile parameter. You can
;  *    pass the BackingFileID to other routines which accept a
;  *    BackingFileID as an input parameter. The privileges parameter
;  *    specifies what operations you want to perform on the mapped file
;  *    fork. Programs can request either kCanReadMappedFile privileges,
;  *    or both kCanReadMappedFile and kCanWriteMappedFile privileges. To
;  *    disable Process Manager tracking of the mapped file fork and its
;  *    mapped file views, you may also request kNoProcessMappedFile
;  *    privileges.
;  *  
;  *  Parameters:
;  *    
;  *    spec:
;  *      The file to map.
;  *    
;  *    mapResFork:
;  *      Fork to map: false = data fork; true = resource fork.
;  *    
;  *    privileges:
;  *      The requested MappingPrivileges.
;  *    
;  *    backingFile:
;  *      Receives a BackingFileID which you can use to access the mapped
;  *      file fork.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmMappingPrivilegesErr, or various File Manager and Memory
;  *    Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_FSpOpenMappedFile" 
      ((spec (:pointer :fsspec)) (mapResFork :boolean) (privileges :unsigned-long) (backingFile (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 1 spec mapResFork privileges backingFile))

; 
;  *  OpenMappedScratchFile()
;  *  
;  *  Summary:
;  *    Creates and opens a scratch file with the privileges requested
;  *    for use as backing storage.
;  *  
;  *  Discussion:
;  *    The OpenMappedScratchFile function creates a file with the size
;  *    specified by the fileSize parameter on the volume specified by
;  *    the volume parameter. If kFSInvalidVolumeRefNum is passed as the
;  *    volume parameter, the system code will choose the location of the
;  *    file. OpenMappedScratchFile then opens the file and returns a
;  *    BackingFileID in the backingFile parameter. You can pass the
;  *    BackingFileID to other routines which accept a BackingFileID as
;  *    an input parameter. The privileges parameter specifies what
;  *    operations you want to perform on the mapped file fork. Programs
;  *    can request either kCanReadMappedFile privileges, or both
;  *    kCanReadMappedFile and kCanWriteMappedFile privileges. To disable
;  *    Process Manager tracking of the mapped file fork and its mapped
;  *    file views, you may also request kNoProcessMappedFile privileges.
;  *    The data for a scratch file is only valid in an open mapped file
;  *    view. When a mapped file view is first created for a scratch file
;  *    with MapFileView, data on disk is not paged into memory. When
;  *    that mapped file view is unmapped with UnmapFileView, changes are
;  *    not flushed from memory to disk.
;  *  
;  *  Parameters:
;  *    
;  *    volume:
;  *      The volume where scratch file should be created or
;  *      kFSInvalidVolumeRefNum to let the system choose the volume.
;  *    
;  *    fileSize:
;  *      The size of the scratch file.
;  *    
;  *    privileges:
;  *      The requested MappingPrivileges.
;  *    
;  *    backingFile:
;  *      Receives a BackingFileID which you can use to access the mapped
;  *      file fork.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmMappingPrivilegesErr, or various File Manager and Memory
;  *    Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OpenMappedScratchFile" 
      ((volume :signed-integer) (fileSize :unsigned-long) (privileges :unsigned-long) (backingFile (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 2 volume fileSize privileges backingFile))

; 
;  *  CloseMappedFile()
;  *  
;  *  Summary:
;  *    Closes a mapped file fork.
;  *  
;  *  Discussion:
;  *    The CloseMappedFile function closes the mapped file fork
;  *    specified by the backingFile parameter. All mapped file views
;  *    using the BackingFileID must be closed before closing the mapped
;  *    file fork. If the BackingFileID is for a scratch file created
;  *    with OpenMappedScratchFile, the scratch file is deleted by
;  *    CloseMappedFile after it is closed.
;  *  
;  *  Parameters:
;  *    
;  *    backingFile:
;  *      The mapped file fork to close.
;  *  
;  *  Result:
;  *    An operating system result code: noErr,
;  *    vmInvalidBackingFileIDErr, vmInvalidOwningProcessErr,
;  *    vmBusyBackingFileErr, or various File Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseMappedFile" 
      ((backingFile :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 3 backingFile))

; 
;  *  GetMappedFileInformation()
;  *  
;  *  Summary:
;  *    Returns information about a mapped file fork.
;  *  
;  *  Discussion:
;  *    The GetMappedFileInformation function returns information about
;  *    the mapped file fork specified by the backingFile parameter. The
;  *    struct version of the mappedFileInfo parameter is passed in the
;  *    version parameter. The mapped file fork information is returned
;  *    in the mappedFileInfo parameter.
;  *  
;  *  Parameters:
;  *    
;  *    backingFile:
;  *      The mapped file fork.
;  *    
;  *    version:
;  *      The version of the MappedFileInformation struct passed.
;  *    
;  *    mappedFileInfo:
;  *      A pointer to the MappedFileInformation struct where the
;  *      information about a mapped file fork is returned.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmInvalidBackingFileIDErr, or various File Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetMappedFileInformation" 
      ((backingFile :pointer) (version :unsigned-long) (mappedFileInfo (:pointer :mappedfileinformation)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 4 backingFile version mappedFileInfo))

; 
;  *  GetNextMappedFile()
;  *  
;  *  Summary:
;  *    Gets a list of mapped file forks.
;  *  
;  *  Discussion:
;  *    The GetNextMappedFile function returns the BackingFileID of the
;  *    mapped file fork next in the list of mapped file forks. You can
;  *    enumerate through the list of mapped file forks by passing
;  *    kInvalidID as the backingFile parameter and then repetitively
;  *    calling GetNextMappedFile with the last BackingFileID returned
;  *    until the result code vmNoMoreBackingFilesErr is returned.
;  *  
;  *  Parameters:
;  *    
;  *    backingFile:
;  *      Input: The last BackingFileID returned by GetNextMappedFile, or
;  *      kInvalidID to get the first mapped file fork. Output: If noErr,
;  *      receives the BackingFileID of the next mapped file fork.
;  *  
;  *  Result:
;  *    An operating system result code: noErr,
;  *    vmInvalidBackingFileIDErr, or vmNoMoreBackingFilesErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetNextMappedFile" 
      ((backingFile (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 5 backingFile))

; 
;  *  SetMappedFileSize()
;  *  
;  *  Summary:
;  *    Changes the size (logical end-of-file) of a mapped file fork.
;  *  
;  *  Discussion:
;  *    The SetMappedFileSize function sets the logical end-of-file of
;  *    the mapped file fork specified by backingFile. The new logical
;  *    end-of-file is specified by the positionMode and positionOffset
;  *    parameters.
;  *  
;  *  Parameters:
;  *    
;  *    backingFile:
;  *      The mapped file fork to change the size of.
;  *    
;  *    positionMode:
;  *      The base location for the new size: fsAtMark, fsFromStart,
;  *      fsFromLEOF, or fsFromMark.
;  *    
;  *    positionOffset:
;  *      Pointer to a SInt64 which contains the offset of the size from
;  *      the base.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr, or various File
;  *    Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SetMappedFileSize" 
      ((backingFile :pointer) (positionMode :unsigned-integer) (positionOffset (:pointer :wide)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 6 backingFile positionMode positionOffset))

; 
;  *  GetFileViewAccessOptions()
;  *  
;  *  Summary:
;  *    Returns the valid FileViewAccess and FileViewOptions bits.
;  *  
;  *  Discussion:
;  *    The GetFileViewAccessOptions function returns the valid
;  *    FileViewAccess and FileViewOptions bits. Programs can use it to
;  *    determine what FileViewAccess and FileViewOptions are available.
;  *  
;  *  Parameters:
;  *    
;  *    access:
;  *      Receives the valid memory access flags.
;  *    
;  *    options:
;  *      Receives the valid view options.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, or paramErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetFileViewAccessOptions" 
      ((access (:pointer :unsigned-long)) (options (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 7 access options))

; 
;  *  MapFileView()
;  *  
;  *  Summary:
;  *    Creates a mapped file view into a mapped file fork.
;  *  
;  *  Discussion:
;  *    The MapFileView function creates a mapped file view into the
;  *    mapped file fork specified by the backingFile parameter.
;  *    MapFileView returns a FileViewID in the theView parameter. You
;  *    can pass the FileViewID to other routines which accept a
;  *    FileViewID as an input parameter. The backingBase and
;  *    backingLength parameters specify what part of the mapped file
;  *    fork will be mapped to memory. The access parameter specifies the
;  *    allowable access to the memory in a mapped file view. The
;  *    guardLength parameter specifies the size, in bytes, of the
;  *    excluded logical address ranges to place adjacent to each end of
;  *    the mapped file view. The options parameter specifies the desired
;  *    characteristics of the mapped file view. The viewBase parameter,
;  *    as an optional input, specifies the requested viewBase. The
;  *    backingBase parameter must be a whole multiple of the logical
;  *    page size. If kMapEntireFork is passed as backingLength, accesses
;  *    past the mapped file fork's logical end-of-file will not cause
;  *    exceptions, but will have undefined behavior. Only accesses up to
;  *    viewLength should be considered valid. The starting address of
;  *    the mapped file view is returned in the viewBase parameter. The
;  *    length of the mapped file view is returned in the viewLength
;  *    parameter.
;  *  
;  *  Parameters:
;  *    
;  *    backingFile:
;  *      The mapped file fork to create a mapped file view from.
;  *    
;  *    backingBase:
;  *      Pointer to the offset into mapped file fork. Passing a NULL
;  *      pointer is the same as passing an offset of zero.
;  *    
;  *    backingLength:
;  *      The number of bytes to map, or kMapEntireFork to map from
;  *      backingBase to the mapped file fork's logical end-of-file.
;  *    
;  *    access:
;  *      The FileViewAccess.
;  *    
;  *    guardLength:
;  *      The size, in bytes, of the excluded logical address ranges to
;  *      place adjacent to each end of the mapped file view.
;  *    
;  *    options:
;  *      The desired characteristics of the mapped file view.
;  *    
;  *    viewBase:
;  *      Input: The requested viewBase. Output: Receives the starting
;  *      address of mapped file view.
;  *    
;  *    viewLength:
;  *      Receives the mapped file view length.
;  *    
;  *    theView:
;  *      Receives a FileViewID which you can use to access the mapped
;  *      file view.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmInvalidBackingFileIDErr, vmInvalidOwningProcessErr,
;  *    vmFileViewAccessErr, or various File Manager and Memory Manager
;  *    errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; Const
(deftrap "_MapFileView" 
      ((backingFile :pointer) (backingBase (:pointer :unsignedwide)) (backingLength :unsigned-long) (access :unsigned-long) (guardLength :unsigned-long) (options :unsigned-long) (viewBase (:pointer :pointer)) (viewLength (:pointer :unsigned-long)) (theView (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 8 backingFile backingBase backingLength access guardLength options viewBase viewLength theView))

; 
;  *  UnmapFileView()
;  *  
;  *  Summary:
;  *    Unmaps a mapped file view.
;  *  
;  *  Discussion:
;  *    The UnmapFileView function unmaps a mapped file view specified by
;  *    the theView parameter from memory. All modified memory is flushed
;  *    to the mapped file fork before the mapped file view is unmapped
;  *    unless the mapped file view is to a scratch file.
;  *  
;  *  Parameters:
;  *    
;  *    theView:
;  *      The mapped file view to unmap.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, vmInvalidFileViewIDErr,
;  *    vmInvalidOwningProcessErr, or various File Manager and Memory
;  *    Manager errors.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UnmapFileView" 
      ((theView :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 9 theView))

; 
;  *  GetFileViewInformation()
;  *  
;  *  Summary:
;  *    Returns information about a mapped file view.
;  *  
;  *  Discussion:
;  *    The GetFileViewInformation function returns information about the
;  *    mapped file view specified by the theView parameter. The struct
;  *    version of the fileViewInfo parameter is passed in the version
;  *    parameter. The mapped file view information is returned in the
;  *    fileViewInfo parameter.
;  *  
;  *  Parameters:
;  *    
;  *    theView:
;  *      The mapped file view.
;  *    
;  *    version:
;  *      The version of the FileViewInformation struct passed.
;  *    
;  *    fileViewInfo:
;  *      A pointer to the FileViewInformation struct where the
;  *      information about a mapped file view is returned.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr, or
;  *    vmInvalidFileViewIDErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetFileViewInformation" 
      ((theView :pointer) (version :unsigned-long) (fileViewInfo (:pointer :fileviewinformation)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 10 theView version fileViewInfo))

; 
;  *  GetFileViewFromAddress()
;  *  
;  *  Summary:
;  *    Returns the FileViewID for a given address.
;  *  
;  *  Discussion:
;  *    The GetFileViewFromAddress function returns the FileViewID for
;  *    address specified in the address parameter.
;  *  
;  *  Parameters:
;  *    
;  *    address:
;  *      The memory address.
;  *    
;  *    theView:
;  *      Receives a FileViewID for the given memory address.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr, or
;  *    vmAddressNotInFileViewErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetFileViewFromAddress" 
      ((address :pointer) (theView (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 11 address theView))

; 
;  *  GetNextFileView()
;  *  
;  *  Summary:
;  *    Gets a list of mapped file views.
;  *  
;  *  Discussion:
;  *    The GetNextView function returns the FileViewID of the mapped
;  *    file view next in the list of mapped file views. You can
;  *    enumerate through the list of mapped file views by passing
;  *    kInvalidID as the theView parameter and then repetitively calling
;  *    GetNextView with the last FileViewID returned until the result
;  *    code vmNoMoreFileViewsErr is returned.
;  *  
;  *  Parameters:
;  *    
;  *    theView:
;  *      Input: The last FileViewID returned by GetNextView, or
;  *      kInvalidID to get the first mapped file view. Output: If noErr,
;  *      receives the FileViewID of the next mapped file view.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmInvalidFileViewIDErr, or vmNoMoreFileViewsErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetNextFileView" 
      ((theView (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 12 theView))

; 
;  *  SetFileViewAccess()
;  *  
;  *  Summary:
;  *    Changes a mapped file view's FileViewAccess.
;  *  
;  *  Discussion:
;  *    The SetViewAccess function changes the FileViewAccess of the
;  *    mapped file view specified by the theView parameter. The new
;  *    FileViewAccess is specified by the accessLevel parameter.
;  *  
;  *  Parameters:
;  *    
;  *    theView:
;  *      The mapped file view.
;  *    
;  *    access:
;  *      The new FileViewAccess.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, paramErr,
;  *    vmInvalidFileViewIDErr, or vmFileViewAccessErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetFileViewAccess" 
      ((theView :pointer) (access :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 13 theView access))

; 
;  *  SetFileViewBackingBase()
;  *  
;  *  Summary:
;  *    Changes the backing base of a mapped file view.
;  *  
;  *  Discussion:
;  *    The SetFileViewBackingBase function changes the backing base of
;  *    the mapped file view specified by theView. The new backing base
;  *    is specified by the newBackingBase parameter.
;  *  
;  *  Parameters:
;  *    
;  *    theView:
;  *      The mapped file view.
;  *    
;  *    newBackingBase:
;  *      Pointer to the offset into mapped file fork. Passing a NULL
;  *      pointer is the same as passing an offset of zero.
;  *  
;  *  Result:
;  *    An operating system result code: noErr, vmInvalidFileViewIDErr,
;  *    or paramErr.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; Const
(deftrap "_SetFileViewBackingBase" 
      ((theView :pointer) (newBackingBase (:pointer :unsignedwide)))
   (:stack :signed-integer)
   (:stack-trap #xAA81 :d0 14 theView newBackingBase))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FileMappingIncludes

; $ENDC                                         ; __FILEMAPPING__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FileMapping)