(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FileSigning.p"
; at Wednesday May 1,2002 2:41:25 pm.
; 
;      File:       FileSigning.p
;  
;      Contains:   Apple File Signing Interfaces.
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FILESIGNING__
; $SETC __FILESIGNING__ := 1

; $I+
; $SETC FileSigningIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __KEYCHAIN__

(require-interface 'Keychain)                   ; $I Keychain.p
; $ENDC

#|                                              ; $IFC UNDEFINED __CRYPTOMESSAGESYNTAX__
|#

(require-interface 'CryptoMessageSyntax)
#|                                              ; $I CryptoMessageSyntax.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Data structures and types 

(def-mactype :secoptions (find-mactype ':signed-long))

(defconstant $kSecOptionProgress #x1)
(defconstant $kSecOptionShowVerifyUI #x2)
(defconstant $kSecOptionNeverShowUI #x4)
(defconstant $kCertUsageReserved #x7FFFFF00)    ;   Last 3 bytes reserved for SecOptions flags  

(def-mactype :secsignaturetype (find-mactype ':unsigned-long))

(defconstant $kSecSignatureTypeRawPKCS7 0)
(defconstant $kSecSignatureTypeCMS 1)
(defconstant $kSecSignatureTypePGP 2)           ;   reserved but not implemented  

(def-mactype :sectrustpolicy (find-mactype ':unsigned-long))

(defconstant $kSecTrustPolicyCodeSigning 0)
(defconstant $kSecTrustPolicyPersonalFileSigning 1)

(def-mactype :secprogresscallbackinfoptr (find-mactype '(:pointer :secprogresscallbackinfo)))
(defrecord SecProgressCallbackInfo 
   (version :unsigned-long)
   (bytesProcessed :unsigned-long)
   (totalBytes :unsigned-long)
   (itemsRemainingToSign :unsigned-long)
   (totalItemsToSign :unsigned-long)
   (secondsRemaining :unsigned-long)
   (secondsElapsed :unsigned-long)
   (microSecondsPerByte :unsigned-long)
   (fileName (:string 255))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SecProgressCallbackProcPtr = FUNCTION(VAR callbackInfo: SecProgressCallbackInfo; userContext: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :secprogresscallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :secprogresscallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :secprogresscallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSecProgressCallbackProcInfo #x3F0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewSecProgressCallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewSecProgressCallbackProc 
(deftrap "_NewSecProgressCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSecProgressCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSecProgressCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSecProgressCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallSecProgressCallbackProc 
(deftrap-inline "_InvokeSecProgressCallbackUPP" 
      ((callbackInfo (:pointer :secprogresscallbackinfo)) (userContext :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SecSetProgressCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  SecRemoveProgressCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecSetProgressCallback" 
      ((callbackProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  DefaultSecProgressCallbackProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecRemoveProgressCallback" 
      ((callbackProc :pointer)) 
  :osstatus
   () )
(deftrap-inline "_DefaultSecProgressCallbackProc" 
      ((info (:pointer :secprogresscallbackinfo)) (userContext :pointer)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $kSecDefaultSignatureResID 1)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SecMacSignFile()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  SecMacSignFileSimple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacSignFile" 
      ((theFile (:pointer :fsspec)) (signingCertificate :pointer) (sigH :handle) (options :signed-long) (progressProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SecMacLoadSigPound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacSignFileSimple" 
      ((theFile (:pointer :fsspec)) (signingCertificate :pointer) (options :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  SecMacRemoveSignature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacLoadSigPound" 
      ((theFile (:pointer :fsspec)) (resHandle (:pointer :handle))) 
  :osstatus
   () )                                         ; 
;  *  SecMacRemoveAllSignatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacRemoveSignature" 
      ((theFile (:pointer :fsspec)) (signatureType :unsigned-long) (signatureToRemove :signed-integer)) 
  :osstatus
   () )                                         ; 
;  *  SecMacVerifyFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacRemoveAllSignatures" 
      ((theFile (:pointer :fsspec)) (signatureType :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  SecMacVerifyFileSimple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacVerifyFile" 
      ((theFile (:pointer :fsspec)) (options :signed-long) (progressProc :pointer) (userContext :pointer) (signatureToVerify :signed-integer) (policyOIDs :pointer) (stopOn :unsigned-integer) (signer (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  SecMacHasSignature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacVerifyFileSimple" 
      ((theFile (:pointer :fsspec)) (options :signed-long) (trustPolicy :unsigned-long) (signer (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  SecMacFindSignatureToVerify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacHasSignature" 
      ((theFile (:pointer :fsspec)) (signatureType :unsigned-long)) 
  :boolean
   () )                                         ; 
;  *  SecMacGetDefaultPolicyOIDs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacFindSignatureToVerify" 
      ((theFile (:pointer :fsspec)) (signatureType :unsigned-long) (signatureToVerify (:pointer :signed-integer))) 
  :osstatus
   () )                                         ; 
;  *  SecMacDisplaySigner()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FileSigningLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecMacGetDefaultPolicyOIDs" 
      ((trustPolicy :unsigned-long)) 
  :pointer
   () )                                         ;  Errors Codes 
(deftrap-inline "_SecMacDisplaySigner" 
      ((inputErr :signed-long) (signer :pointer) (alwaysShowUI :boolean) (theFile (:pointer :fsspec))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $errSecTooManySigners -13839)
(defconstant $errSecSigningFailed -13838)
(defconstant $errSecCorruptSigPound -13837)
(defconstant $errSecNoSignatureFound -13836)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FileSigningIncludes

; $ENDC                                         ; __FILESIGNING__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FileSigning)