(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FileTypesAndCreators.p"
; at Wednesday May 1,2002 2:41:28 pm.
; 
;      File:       FileTypesAndCreators.p
;  
;      Contains:   Symbolic constants for FileTypes and signatures of popular documents.
;  
;      Version:    Technology: Macintosh Easy Open 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FILETYPESANDCREATORS__
; $SETC __FILETYPESANDCREATORS__ := 1

; $I+
; $SETC FileTypesAndCreatorsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
; 
; Motivation for FileTypesAndCreators.h
; 
;     The TranslationMgr (Macintosh Easy Open) uses FileTypes to express and manage
;     translation capabilities.  This works well for most Macintosh applications.  It
;     simply uses the file type stored in the catalog info by HFS.  But, the TranslationMgr
;     needs to work with non-Macintosh files.  These do not have file types (or creators).
;     Another problem is some Macintosh applications keep the same file type for a file
;     after changing the file format from one version to the next.  Thus, the HFS file type
;     cannot be used to distinguish between formats.
; 
;     This file is an effort to define FileTypes and creator codes for non-Macintosh file
;     formats and define FileTypes that distinguish between formats.
; 
; 
; There are two main categories of constants defined in FileTypesAndCreators.h.  One is
; creator signatures of applications the other is file types.  To make this easier to use,
; some style guidelines are provided.
; 
; Creators:
; 
;     The symbolic constant for all creator codes begin with sig. Following sig is the
;     application name.  Example:
; 
;         sigSurfWriter = 'SURF'
; 
;     If the application name is localized for different markets, the name of the U.S.
;     version is always used. It is optional to make symbolic constants for localized names.
;     If a U.S. is not available, another Roman name is used (this is for ease of editing
;     in MPW.)  Example:
; 
;         sigSurfWriter = 'SURF',
;         sigSkiWriter =  'SURF'  // optional definition of Canadian name of app
; 
;     If multiple versions of an application exist, and the creator codes are different,
;     then the version number is added to the end of the symbolic name, for the first version
;     in which the signature changed.  Example:
; 
;         sigDirtWriter =     'DIRT', // version 1 and 2 used same signature
;         sigDirtWriter3 =    'DRT3'
; 
;     If a developer has the same application on another platform as is on the Mac, then the
;     creator for a file from the other platform should be the same as the creator of the
;     Macintosh application.   Example:
; 
;         sigMicrosoftWord =  'MSWD'  // used for Mac and Windows documents
; 
;     If there is no similar Macintosh product, then the signature of the platform is used.
;     Example:
; 
;         sigPCDOS =          'mdos', // for DOS and Windows
;         sigAppleProDos =    'pdos'
; 
; 
; FileTypes:
; 
;     The symbolic constant for all file types begin with ft. Following ft is the ideal
;     kind for that document.  Example:
; 
;         ftSurfWriterDocument =  'SRFD'
; 
;     If the application name is localized for different markets, the kind string of the U.S.
;     version is always used. It is optional to make symbolic constants for localized kind
;     strings.  If a U.S. is not available, another Roman kind string is used (this is for
;     ease of editing in MPW.)  Example:
; 
;         ftSurfWriterDocument =  'SRFD,
;         ftSkiWriterDocument =   'SRFD'  // optional Canadian name
; 
;     If multiple versions of an application exist, and the document for files created by each
;     are different (meaning one version of the app can not read the documents of a newer
;     version), then the version number is added to the end of the symbolic name, for the
;     first version in which the format changed.  Example:
; 
;        // version 1 and 2 docs have same format, version 3 has a different format
;         ftDirtWriterDocument =          'DDRT',
;         ftDirtWriter3Document =         '3DRT'
; 
;     If multiple versions of an application exist, and the document for files created by each
;     are different, but the catInfo file type has always been the same, then constants are
;     made for each unique format and one is made for the catInfo type actually used.
; 
;         ftWordDocument =        'WDBN',
;         ftWord3Document =       'WDB3',
;         ftWord4Document =       'WDB4',
;         ftWord5Document =       'WDB5'
; 
;     If a

; ************* Macintosh applications and FileTypes *************

;   Mac word processors  
(defconstant $sigWord :|MSWD|)
(defconstant $ftWord3Document :|MSW3|)
(defconstant $ftWord4Document :|MSW4|)
(defconstant $ftWord5Document :|MSW5|)
(defconstant $ftWordDocument :|WDBN|)
(defconstant $ftWordDocumentPC :|MWPC|)         ;   not registered  
(defconstant $ftWord1DocumentWindows :|WW1 |)   ;   not registered  
(defconstant $ftWord2DocumentWindows :|WW2 |)   ;   not registered  
(defconstant $ftRTFDocument :|RTF |)            ;   not registered  
(defconstant $sigWordPerfect :|SSIW|)
(defconstant $ftWordPerfectDocument :|WPD0|)
(defconstant $sigWordPerfect2 :|WPC2|)
(defconstant $ftWordPerfect2Document :|WPD1|)
(defconstant $ftWordPerfect21Document :|WPD2|)
(defconstant $ftWordPerfect42DocumentPC :|.WP4|);   not registered  
(defconstant $ftWordPerfect50DocumentPC :|.WP5|);   not registered  
(defconstant $ftWordPerfect51DocumentPC :|WP51|);   not registered  
(defconstant $ftWordPerfectGraphicsPC :|WPGf|)  ;   not registered  
(defconstant $sigMacWriteII :|MWII|)
(defconstant $ftMacWriteIIDocument :|MW2D|)
(defconstant $sigWriteNow :|nX^n|)
(defconstant $ftWriteNow2Document :|nX^d|)
(defconstant $ftWriteNow3Document :|nX^2|)
(defconstant $sigMacWrite :|MACA|)
(defconstant $ftMacWrite5Document :|WORD|)
(defconstant $sigFrameMaker :|Fram|)
(defconstant $ftFrameMakerDocument :|FASL|)
(defconstant $ftFrameMakerMIFDocument :|MIF |)
(defconstant $ftFrameMakerMIF2Document :|MIF2|)
(defconstant $ftFrameMakerMIF3Document :|MIF3|)
(defconstant $sigMSWrite :|MSWT|)
(defconstant $sigActa :|ACTA|)
(defconstant $sigTHINKPascal :|PJMM|)
(defconstant $sigTHINKC :|KAHL|)
(defconstant $sigFullWrite :|FWRT|)
(defconstant $sigTeachText :|ttxt|)
(defconstant $ftTeachTextDocument :|ttro|)
(defconstant $sigSimpleText :|ttxt|)
(defconstant $ftSimpleTextDocument :|ttro|)
(defconstant $sigMPWShell :|MPS |)
(defconstant $sigQuarkXPress :|XPR3|)
(defconstant $sigNisus :|NISI|)
(defconstant $sigOmniPage :|PRTC|)
(defconstant $sigPersonalPress :|SCPG|)
(defconstant $sigPublishItEZ :|2CTY|)
(defconstant $sigReadySetGo :|MEMR|)
(defconstant $sigRagTime :|R#+A|)
(defconstant $sigLetraStudio :|LSTP|)
(defconstant $sigLetterPerfect :|WPCI|)
(defconstant $sigTheWritingCenter #xA1A5750)    ;   this 'unprintable unprintable WP' One of the unprintables is a line feed.   
(defconstant $sigInstantUpdate :|IUA0|)

;   databases  
(defconstant $sig4thDimension :|4D03|)
(defconstant $ft4thDimensionDB :|BAS3|)
(defconstant $sigFileMakerPro :|FMPR|)
(defconstant $ftFileMakerProDatabase :|FMPR|)
(defconstant $sigHyperCard :|WILD|)
(defconstant $ftHyperCard :|STAK|)
(defconstant $sigSmartFormAsst :|KCFM|)
(defconstant $ftSmartFormAsst :|STCK|)
(defconstant $sigSmartFormDesign :|KCFD|)
(defconstant $ftSmartFormDesign :|CFRM|)
(defconstant $sigFileForce :|4D93|)
(defconstant $ftFileForceDatabase :|FIL3|)
(defconstant $sigFileMaker2 :|FMK4|)
(defconstant $ftFileMaker2Database :|FMK$|)
(defconstant $sigSuperCard :|RUNT|)
(defconstant $sigDoubleHelix :|HELX|)
(defconstant $sigGeoQuery :|RGgq|)
(defconstant $sigFoxBASE :|FOX+|)
(defconstant $sigINSPIRATION :|CER3|)
(defconstant $sigPanorama :|KAS1|)
(defconstant $sigSilverrunLDM :|CDML|)
(defconstant $sigSilverrunDFD :|CDDF|)          ;   finance  
(defconstant $sigQuicken :|INTU|)
(defconstant $sigMacInTax91 :|MIT1|)
(defconstant $ftMacInTax91 :|MITF|)
(defconstant $sigAccountantInc :|APRO|)
(defconstant $sigAtOnce :|KISS|)
(defconstant $sigCAT3 :|tCat|)
(defconstant $sigDollarsNSense :|EAGP|)
(defconstant $sigInsightExpert :|LSGL|)
(defconstant $sigMYOB :|MYOB|)
(defconstant $sigMacMoney :|SSLA|)
(defconstant $sigManagingYourMoney :|MYMC|)
(defconstant $sigPlainsAndSimple :|PEGG|)       ;   scheduling  
(defconstant $sigMacProject2 :|MPRX|)
(defconstant $ftMacProject :|MPRD|)
(defconstant $sigMSProject :|MSPJ|)
(defconstant $sigMacProjectPro :|MPRP|)         ;   utilities  
(defconstant $sigStuffIt :|SIT!|)
(defconstant $ftStuffItArchive :|SIT!|)
(defconstant $sigCompactPro :|CPCT|)
(defconstant $ftCompactProArchive :|PACT|)
(defconstant $sigFontographer :|aCa2|)
(defconstant $sigMetamorphosis :|MEtP|)
(defconstant $sigCorrectGrammar :|LsCG|)
(defconstant $sigDynodex :|DYNO|)
(defconstant $sigMariah :|MarH|)
(defconstant $sigAddressBook :|AdBk|)
(defconstant $sigThePrintShop :|PSHP|)
(defconstant $sigQuicKeys2 :|Qky2|)
(defconstant $sigReadStar2Plus :|INOV|)
(defconstant $sigSoftPC :|PCXT|)
(defconstant $sigMacMenlo :|MNLO|)
(defconstant $sigDisinfectant :|D2CT|)          ;   communications  
(defconstant $sigSmartcom2 :|SCOM|)
(defconstant $sigVersaTermPRO :|VPRO|)
(defconstant $sigVersaTerm :|VATM|)
(defconstant $sigWhiteKnight :|WK11|)
(defconstant $sigNCSATelnet :|NCSA|)
(defconstant $sigDynaComm :|PAR2|)
(defconstant $sigQMForms :|MLTM|)               ;   math and statistics  
(defconstant $sigMathematica :|OMEG|)
(defconstant $sigMathCAD :|MCAD|)
(defconstant $sigStatView2 :|STAT|)
(defconstant $sigDataDesk :|DDSK|)
(defconstant $sigPowerMath2 :|MATH|)
(defconstant $sigSuperANOVA :|SupA|)
(defconstant $sigSystat :|SYT1|)
(defconstant $sigTheorist :|Theo|)

;   spreadsheets  
(defconstant $sigExcel :|XCEL|)
(defconstant $ftExcel2Spreadsheet :|XLS |)
(defconstant $ftExcel2Macro :|XLM |)
(defconstant $ftExcel2Chart :|XLC |)
(defconstant $ftExcel3Spreadsheet :|XLS3|)
(defconstant $ftExcel3Macro :|XLM3|)
(defconstant $ftExcel3Chart :|XLC3|)
(defconstant $ftExcel4Spreadsheet :|XLS4|)
(defconstant $ftExcel4Macro :|XLM4|)
(defconstant $ftSYLKSpreadsheet :|SYLK|)
(defconstant $sigLotus123 :|L123|)
(defconstant $ft123Spreadsheet :|LWKS|)
(defconstant $sigWingz :|WNGZ|)
(defconstant $ftWingzSpreadsheet :|WZSS|)
(defconstant $ftWingzScript :|WZSC|)
(defconstant $sigResolve :|Rslv|)
(defconstant $ftResolve :|RsWs|)
(defconstant $ftResolveScript :|RsWc|)
(defconstant $sigFullImpact2 :|Flv2|)

;   graphics  
(defconstant $sigIllustrator :|ART5|)
(defconstant $ftPostScriptMac :|EPSF|)
(defconstant $sigMacPaint :|MPNT|)
(defconstant $ftMacPaintGraphic :|PNTG|)
(defconstant $sigSuperPaint :|SPNT|)
(defconstant $ftSuperPaintGraphic :|SPTG|)
(defconstant $sigCanvas :|DAD2|)
(defconstant $ftCanvasGraphic :|drw2|)
(defconstant $sigUltraPaint :|ULTR|)
(defconstant $ftUltraPaint :|UPNT|)
(defconstant $sigPhotoshop :|8BIM|)
(defconstant $ftPhotoshopGraphic :|8BIM|)
(defconstant $sigMacDrawPro :|dPro|)
(defconstant $ftMacDrawProDrawing :|dDoc|)
(defconstant $sigPageMaker :|ALD4|)
(defconstant $ftPageMakerPublication :|ALB4|)
(defconstant $sigFreeHand :|FHA3|)
(defconstant $ftFreeHandDrawing :|FHD3|)
(defconstant $sigClarisCAD :|CCAD|)
(defconstant $ftClarisCAD :|CAD2|)
(defconstant $sigMacDrawII :|MDPL|)
(defconstant $ftMacDrawIIDrawing :|DRWG|)
(defconstant $sigMacroMindDirector :|MMDR|)
(defconstant $ftMMDirectorMovie :|VWMD|)
(defconstant $ftMMDirectorSound :|MMSD|)
(defconstant $sigOptix :|PIXL|)                 ;   was previously PixelPerfect  
(defconstant $sigPixelPaint :|PIXR|)
(defconstant $ftPixelPaint :|PX01|)
(defconstant $sigAldusSuper3D :|SP3D|)
(defconstant $ftSuper3DDrawing :|3DBX|)
(defconstant $sigSwivel3D :|SWVL|)
(defconstant $ftSwivel3DDrawing :|SMDL|)
(defconstant $sigCricketDraw :|CRDW|)
(defconstant $ftCricketDrawing :|CKDT|)
(defconstant $sigCricketGraph :|CGRF|)
(defconstant $ftCricketChart :|CGPC|)
(defconstant $sigDesignCAD :|ASBC|)
(defconstant $ftDesignCADDrawing :|DCAD|)
(defconstant $sigImageStudio :|FSPE|)
(defconstant $ftImageStudioGraphic :|RIFF|)
(defconstant $sigVersaCad :|VCAD|)
(defconstant $ftVersaCADDrawing :|2D  |)
(defconstant $sigAdobePremiere :|PrMr|)         ;   was previously misspelled as sigAdobePremier 
(defconstant $ftAdobePremiereMovie :|MooV|)     ;   was previously misspelled as ftAdobePremierMovie 
(defconstant $sigAfterDark :|ADrk|)
(defconstant $ftAfterDarkModule :|ADgm|)
(defconstant $sigClip3D :|EZ3E|)
(defconstant $ftClip3Dgraphic :|EZ3D|)
(defconstant $sigKaleidaGraph :|QKPT|)
(defconstant $ftKaleidaGraphGraphic :|QPCT|)
(defconstant $sigMacFlow :|MCFL|)
(defconstant $ftMacFlowChart :|FLCH|)
(defconstant $sigMoviePlayer :|TVOD|)
(defconstant $ftMoviePlayerMovie :|MooV|)
(defconstant $sigMacSpin :|D2SP|)
(defconstant $ftMacSpinDataSet :|D2BN|)
(defconstant $sigAutoCAD :|ACAD|)
(defconstant $sigLabVIEW :|LBVW|)
(defconstant $sigColorMacCheese :|CMC|)
(defconstant $sigMiniCad :|CDP3|)
(defconstant $sigDreams :|PHNX|)
(defconstant $sigOmnis5 :|Q2$$|)
(defconstant $sigPhotoMac :|PMAC|)
(defconstant $sigGraphMaster :|GRAM|)
(defconstant $sigInfiniD :|SID|)
(defconstant $sigOfoto :|APLS|)
(defconstant $sigMacDraw :|MDRW|)
(defconstant $sigDeltagraphPro :|DGRH|)
(defconstant $sigDesign2 :|DESG|)
(defconstant $sigDesignStudio :|MRJN|)
(defconstant $sigDynaperspective :|PERS|)
(defconstant $sigGenericCADD :|CAD3|)
(defconstant $sigMacDraft :|MD20|)
(defconstant $sigModelShop :|MDSP|)
(defconstant $sigOasis :|TAOA|)
(defconstant $sigOBJECTMASTER :|BROW|)
(defconstant $sigMovieRecorder :|mrcr|)
(defconstant $sigPictureCompressor :|ppxi|)
(defconstant $sigPICTViewer :|MDTS|)
(defconstant $sigSmoothie :|Smoo|)
(defconstant $sigScreenPlay :|SPLY|)
(defconstant $sigStudio1 :|ST/1|)
(defconstant $sigStudio32 :|ST32|)
(defconstant $sigStudio8 :|ST/8|)
(defconstant $sigKidPix :|Kid2|)
(defconstant $sigDigDarkroom :|DIDR|)

;   presentations  
(defconstant $sigMore :|MOR2|)
(defconstant $ftMore3Document :|MOR3|)
(defconstant $ftMore2Document :|MOR2|)
(defconstant $sigPersuasion :|PLP2|)
(defconstant $ftPersuasion1Presentation :|PRS1|)
(defconstant $ftPersuasion2Presentation :|PRS2|)
(defconstant $sigPowerPoint :|PPNT|)
(defconstant $ftPowerPointPresentation :|SLDS|)
(defconstant $sigCricketPresents :|CRPR|)
(defconstant $ftCricketPresentation :|PRDF|)    ;   works  
(defconstant $sigMSWorks :|PSI2|)
(defconstant $sigMSWorks3 :|MSWK|)
(defconstant $ftMSWorksWordProcessor :|AWWP|)
(defconstant $ftMSWorksSpreadsheet :|AWSS|)
(defconstant $ftMSWorksDataBase :|AWDB|)
(defconstant $ftMSWorksComm :|AWDC|)
(defconstant $ftMSWorksMacros :|AWMC|)
(defconstant $ftMSWorks1WordProcessor :|AWW1|)  ;   not registered  
(defconstant $ftMSWorks1Spreadsheet :|AWS1|)    ;   not registered  
(defconstant $ftMSWorks1DataBase :|AWD1|)       ;   not registered  
(defconstant $ftMSWorks2WordProcessor :|AWW2|)  ;   not registered  
(defconstant $ftMSWorks2Spreadsheet :|AWS2|)    ;   not registered  
(defconstant $ftMSWorks2DataBase :|AWD2|)       ;   not registered  
(defconstant $ftMSWorks3WordProcessor :|AWW3|)  ;   not registered  
(defconstant $ftMSWorks3Spreadsheet :|AWS3|)    ;   not registered  
(defconstant $ftMSWorks3DataBase :|AWD3|)       ;   not registered  
(defconstant $ftMSWorks3Comm :|AWC3|)           ;   not registered  
(defconstant $ftMSWorks3Macro :|AWM3|)          ;   not registered  
(defconstant $ftMSWorks3Draw :|AWR3|)           ;   not registered  
(defconstant $ftMSWorks2WordProcessorPC :|PWW2|);   not registered  
(defconstant $ftMSWorks2DatabasePC :|PWDB|)     ;   not registered  
(defconstant $sigGreatWorks :|ZEBR|)
(defconstant $ftGreatWorksWordProcessor :|ZWRT|)
(defconstant $ftGreatWorksSpreadsheet :|ZCAL|)
(defconstant $ftGreatWorksPaint :|ZPNT|)
(defconstant $sigClarisWorks :|BOBO|)
(defconstant $ftClarisWorksWordProcessor :|CWWP|)
(defconstant $ftClarisWorksSpreadsheet :|CWSS|)
(defconstant $ftClarisWorksGraphics :|CWGR|)
(defconstant $sigBeagleWorks :|BWks|)
(defconstant $ftBeagleWorksWordProcessor :|BWwp|)
(defconstant $ftBeagleWorksDatabase :|BWdb|)
(defconstant $ftBeagleWorksSpreadsheet :|BWss|)
(defconstant $ftBeagleWorksComm :|BWcm|)
(defconstant $ftBeagleWorksDrawing :|BWdr|)
(defconstant $ftBeagleWorksGraphic :|BWpt|)
(defconstant $ftPICTFile :|PICT|)

;   entertainment  
(defconstant $sigPGATourGolf :|gOLF|)
(defconstant $sigSimCity :|MCRP|)
(defconstant $sigHellCats :|HELL|)              ;   education  
(defconstant $sigReaderRabbit3 :|RDR3|)         ;   Translation applications  
(defconstant $sigDataVizDesktop :|DVDT|)
(defconstant $sigSotwareBridge :|mdos|)
(defconstant $sigWordForWord :|MSTR|)
(defconstant $sigAppleFileExchange :|PSPT|)     ;   Apple software  
(defconstant $sigAppleLink :|GEOL|)
(defconstant $ftAppleLinkAddressBook :|ADRS|)
(defconstant $ftAppleLinkImageFile :|SIMA|)
(defconstant $ftAppleLinkPackage :|HBSF|)
(defconstant $ftAppleLinkConnFile :|PETE|)
(defconstant $ftAppleLinkHelp :|HLPF|)
(defconstant $sigInstaller :|bjbc|)
(defconstant $ftInstallerScript :|bjbc|)
(defconstant $sigDiskCopy :|dCpy|)
(defconstant $ftDiskCopyImage :|dImg|)
(defconstant $sigResEdit :|RSED|)
(defconstant $ftResEditResourceFile :|rsrc|)
(defconstant $sigAardvark :|AARD|)
(defconstant $sigCompatibilityChkr :|wkrp|)
(defconstant $sigMacTerminal :|Term|)
(defconstant $sigSADE :|sade|)
(defconstant $sigCurare :|Cura|)
(defconstant $sigPCXChange :|dosa|)
(defconstant $sigAtEase :|mfdr|)
(defconstant $sigStockItToMe :|SITM|)
(defconstant $sigAppleSearch :|asis|)
(defconstant $sigAppleSearchToo :|hobs|)        ;   the following are files types for system files  
(defconstant $ftScriptSystemResourceCollection :|ifil|)
(defconstant $ftSoundFile :|sfil|)
(defconstant $ftFontFile :|ffil|)
(defconstant $ftTrueTypeFontFile :|tfil|)
(defconstant $ftKeyboardLayout :|kfil|)
(defconstant $ftFontSuitcase :|FFIL|)
(defconstant $ftDASuitcase :|DFIL|)
(defconstant $ftSystemExtension :|INIT|)
(defconstant $ftDAMQueryDocument :|qery|)

; 	************* Special FileTypes and creators *************	
(defconstant $ftApplicationName :|apnm|)        ;   this is the type used to define the application name in a kind resource  
(defconstant $sigIndustryStandard :|istd|)      ;   this is the creator used to define a kind string in a kind resource for a FileType that has many creators   
(defconstant $ftXTND13TextImport :|xt13|)       ;   this is a pseduo-format used by "XTND for Apps". The taDstIsAppTranslation bit is set  

; 	************* Apple][ applications and FileTypes *************	
(defconstant $sigAppleProDOS :|pdos|)           ;   not registered  
(defconstant $ftAppleWorksWordProcessor :|1A  |);   not registered  
(defconstant $ftAppleWorks1WordProcessor :|1A1 |);   not registered  
(defconstant $ftAppleWorks2WordProcessor :|1A2 |);   not registered  
(defconstant $ftAppleWorks3WordProcessor :|1A3 |);   not registered  
(defconstant $ftAppleWorksDataBase :|19  |)     ;   not registered  
(defconstant $ftAppleWorks1DataBase :|191 |)    ;   not registered  
(defconstant $ftAppleWorks2DataBase :|192 |)    ;   not registered  
(defconstant $ftAppleWorks3DataBase :|193 |)    ;   not registered  
(defconstant $ftAppleWorksSpreadsheet :|1B  |)  ;   not registered  
(defconstant $ftAppleWorks1Spreadsheet :|1B1 |) ;   not registered  
(defconstant $ftAppleWorks2Spreadsheet :|1B2 |) ;   not registered  
(defconstant $ftAppleWorks3Spreadsheet :|1B3 |) ;   not registered  
(defconstant $ftAppleWorksWordProcessorGS :|50  |);   not registered  
(defconstant $ftApple2GS_SuperHiRes :|A2SU|)    ;   not registered  
(defconstant $ftApple2GS_SuperHiResPacked :|A2SP|);   not registered  
(defconstant $ftApple2GS_PaintWorks :|A2PW|)    ;   not registered  
(defconstant $ftApple2_DoubleHiRes :|A2DU|)     ;   not registered  
(defconstant $ftApple2_DoubleHiResPacked :|A2DP|);   not registered  
(defconstant $ftApple2_DoubleHiRes16colors :|A2DC|);   not registered  
(defconstant $ftApple2_SingleHiRes :|A2HU|)     ;   not registered  
(defconstant $ftApple2_SingleHiResPacked :|A2HP|);   not registered  
(defconstant $ftApple2_SingleHiRes8colors :|A2HC|);   not registered  

; 	************* PC-DOS applications and FileTypes *************	
(defconstant $sigPCDOS :|mdos|)                 ;   not registered  
(defconstant $ftGenericDocumentPC :|TEXT|)      ;      word processor formats  
(defconstant $ftWordStarDocumentPC :|WStr|)     ;   not registered  
(defconstant $ftWordStar4DocumentPC :|WSt4|)    ;   not registered  
(defconstant $ftWordStar5DocumentPC :|WSt5|)    ;   not registered  
(defconstant $ftWordStar55DocumentPC :|WS55|)   ;   not registered  
(defconstant $ftWordStar6DocumentPC :|WSt6|)    ;   not registered  
(defconstant $ftWordStar2000DocumentPC :|WS20|) ;   not registered  
(defconstant $ftXyWriteIIIDocumentPC :|XyWr|)   ;   registered???  
(defconstant $ftDecDXDocumentPC :|DX  |)        ;   registered???  
(defconstant $ftDecWPSPlusDocumentPC :|WPS+|)   ;   registered???  
(defconstant $ftDisplayWrite3DocumentPC :|DW3 |);   registered???  
(defconstant $ftDisplayWrite4DocumentPC :|DW4 |);   registered???  
(defconstant $ftDisplayWrite5DocumentPC :|DW5 |);   registered???  
(defconstant $ftIBMWritingAsstDocumentPC :|ASST|);   registered???  
(defconstant $ftManuscript1DocumentPC :|MAN1|)  ;   registered???  
(defconstant $ftManuscript2DocumentPC :|MAN2|)  ;   registered???  
(defconstant $ftMass11PCDocumentPC :|M11P|)     ;   registered???  
(defconstant $ftMass11VaxDocumentPC :|M11V|)    ;   registered???  
(defconstant $ftMultiMateDocumentPC :|MMAT|)    ;   registered???  
(defconstant $ftMultiMate36DocumentPC :|MM36|)  ;   registered???  
(defconstant $ftMultiMate40DocumentPC :|MM40|)  ;   registered???  
(defconstant $ftMultiMateAdvDocumentPC :|MMAD|) ;   registered???  
(defconstant $ftMultiMateNoteDocumentPC :|MMNT|);   registered???  
(defconstant $ftOfficeWriterDocumentPC :|OFFW|) ;   registered???  
(defconstant $ftPCFileLetterDocumentPC :|PCFL|) ;   registered???  
(defconstant $ftPFSWriteADocumentPC :|PFSA|)    ;   registered???  
(defconstant $ftPFSWriteBDocumentPC :|PFSB|)    ;   registered???  
(defconstant $ftPFSPlanDocumentPC :|PFSP|)      ;   registered???  
(defconstant $ftProWrite1DocumentPC :|PW1 |)    ;   registered???  
(defconstant $ftProWrite2DocumentPC :|PW2 |)    ;   registered???  
(defconstant $ftProWritePlusDocumentPC :|PW+ |) ;   registered???  
(defconstant $ftFirstChoiceDocumentPC :|FCH |)  ;   registered???  
(defconstant $ftFirstChoice3DocumentPC :|FCH3|) ;   registered???  
(defconstant $ftDCARFTDocumentPC :|RFT |)       ;   registered???  
(defconstant $ftSamnaDocumentPC :|SAMN|)        ;   registered???  
(defconstant $ftSmartDocumentPC :|SMRT|)        ;   registered???  
(defconstant $ftSprintDocumentPC :|SPRT|)       ;   registered???  
(defconstant $ftTotalWordDocumentPC :|TOTL|)    ;   registered???  
(defconstant $ftVolksWriterDocumentPC :|VOLK|)  ;   registered???  
(defconstant $ftWangWPSDocumentPC :|WPS |)      ;   registered???  
(defconstant $ftWordMarcDocumentPC :|MARC|)     ;   registered???  
(defconstant $ftAmiDocumentPC :|AMI |)          ;   registered???  
(defconstant $ftAmiProDocumentPC :|APRO|)       ;   registered???  
(defconstant $ftAmiPro2DocumentPC :|APR2|)      ;   registered???  
(defconstant $ftEnableDocumentPC :|ENWP|)       ;   registered???  
;      data base formats  
(defconstant $ftdBaseDatabasePC :|DBF |)        ;   registered???  
(defconstant $ftdBase3DatabasePC :|DB3 |)       ;   registered???  
(defconstant $ftdBase4DatabasePC :|DB4 |)       ;   registered???  
(defconstant $ftDataEaseDatabasePC :|DTEZ|)     ;   registered???  
(defconstant $ftFrameWorkIIIDatabasePC :|FWK3|) ;   registered???  
(defconstant $ftRBaseVDatabasePC :|RBsV|)       ;   registered???  
(defconstant $ftRBase5000DatabasePC :|RB50|)    ;   registered???  
(defconstant $ftRBaseFile1DatabasePC :|RBs1|)   ;   registered???  
(defconstant $ftRBaseFile3DatabasePC :|RBs3|)   ;   registered???  
(defconstant $ftReflexDatabasePC :|RFLX|)       ;   registered???  
(defconstant $ftQAWriteDatabasePC :|QAWT|)      ;   registered???  
(defconstant $ftQADBaseDatabasePC :|QADB|)      ;   registered???  
(defconstant $ftSmartDataBasePC :|SMTD|)        ;   registered???  
(defconstant $ftFirstChoiceDataBasePC :|FCDB|)  ;   registered???  

;      spread sheet formats  
(defconstant $ftDIFSpreadsheetPC :|DIF |)       ;   registered???  
(defconstant $ftEnableSpreadsheetPC :|ENAB|)    ;   registered???  
(defconstant $ft123R1SpreadsheetPC :|WKS1|)     ;   registered???  
(defconstant $ft123R2SpreadsheetPC :|WKS2|)     ;   registered???  
(defconstant $ft123R3SpreadsheetPC :|WKS3|)     ;   registered???  
(defconstant $ftParadox3SpreadsheetPC :|PDX3|)  ;   registered???  
(defconstant $ftParadox35SpreadsheetPC :|PD35|) ;   registered???  
(defconstant $ftQuattroSpreadsheetPC :|QTRO|)   ;   registered???  
(defconstant $ftQuattroProSpreadsheetPC :|QTR5|);   registered???  
(defconstant $ftSuperCalc5SpreadsheetPC :|SPC5|);   registered???  
(defconstant $ftSymphony1SpreadsheetPC :|SYM1|) ;   registered???  
(defconstant $ftTwinSpreadsheetPC :|TWIN|)      ;   registered???  
(defconstant $ftVPPlannerSpreadsheetPC :|VPPL|) ;   registered???  
(defconstant $ftSmartSpeadsheetPC :|SMSH|)      ;   registered???  
(defconstant $ftFirstChoiceSpeadsheetPC :|FCSS|);   registered???  
;      graphics formats  
(defconstant $ftPCPaintBrushGraphicPC :|PCX |)  ;   not registered  
(defconstant $ftLotusPICGraphicPC :|.PIC|)      ;   not registered  
(defconstant $ftCGMGraphicPC :|.CGM|)           ;   not registered  
(defconstant $ftGEMGraphicPC :|.GEM|)           ;   not registered  
(defconstant $ftIMGGraphicPC :|.IMG|)           ;   not registered  
(defconstant $ftDXFGraphicPC :|.DXF|)           ;   not registered  
(defconstant $ftBitmapWindows :|.BMP|)          ;   not registered  
(defconstant $ftMetaFileWindows :|.WMF|)        ;   not registered  
(defconstant $ftTIFFGraphic :|TIFF|)            ;   not registered  
(defconstant $ftPostScriptPC :|EPSP|)
(defconstant $ftPostScriptWindows :|EPSW|)      ;   not registered  
(defconstant $ftDigitalFX_TitleMan :|TDIM|)     ;   registered???  
(defconstant $ftDigitalFX_VideoFX :|GRAF|)      ;   registered???  
(defconstant $ftAutodeskFLIandFLC :|FLIC|)      ;   registered???  
(defconstant $ftGIF :|GIFf|)                    ;   registered???  
(defconstant $ftIFF :|ILBM|)                    ;   registered???  
(defconstant $ftMicrosoftPaint :|.MSP|)         ;   registered???  
(defconstant $ftPixar :|PXAR|)                  ;   registered???  
(defconstant $ftQDV :|.QDV|)                    ;   registered???  
(defconstant $ftRLE_Compuserve :|RLEC|)         ;   registered???  
;      Generic vector formats  
(defconstant $ftIGESGraphicPC :|IGES|)          ;   not registered  
(defconstant $ftDDES2GraphicPC :|DDES|)         ;   not registered  
(defconstant $ft3DGFGraphicPC :|3DGF|)          ;   not registered  
;      Plotter formats  
(defconstant $ftHPGLGraphicPC :|HPGL|)          ;   not registered  
(defconstant $ftDMPLGraphicPC :|DMPL|)          ;   not registered  
(defconstant $ftCalComp906GraphicPC :|C906|)    ;   not registered  
(defconstant $ftCalComp907GraphicPC :|C907|)    ;   not registered  
;      Vendor-specific formats  
(defconstant $ftStereoLithographyGraphicPC :|STL |);      3D Systems     - not registered  
(defconstant $ftZoomGraphicPC :|ZOOM|)          ;      Abvent          - not registered  
(defconstant $ftFocusGraphicPC :|FOCS|)         ;      Abvent          - not registered  
(defconstant $ftWaveFrontGraphicPC :|WOBJ|)     ;      WaveFront      - not registered  
(defconstant $ftSculpt4DGraphicPC :|Scn2|)      ;      Byte By Byte   - not registered  
(defconstant $ftMiniPascal3GraphicPC :|MPT3|)   ;      Graphsoft      - not registered  
(defconstant $ftMiniPascal4GraphicPC :|MPT4|)   ;      Graphsoft      - not registered  
(defconstant $ftWalkThroughGraphicPC :|VWLK|)   ;      Virtus          - not registered  
(defconstant $ftSiliconGraphics :|.SGI|)        ;   registered???  
(defconstant $ftSunRaster :|.SUN|)              ;   registered???  
(defconstant $ftTarga :|TPIC|)                  ;   registered???  
;   misc DOS   
(defconstant $ftDOSComPC :|.COM|)               ;   registered???  
(defconstant $ftDOSExecutablePC :|.EXE|)        ;   registered???  
(defconstant $ftDOSArcPC :|.ARC|)               ;   registered???  
(defconstant $ftAbekas :|ABEK|)                 ;   registered???  
(defconstant $ftDrHaloCUT :|.CUT|)              ;   registered???  
;   misc Atari  
(defconstant $ftDegas :|DEGA|)                  ;   not registered  
(defconstant $ftNEO :|.NEO|)                    ;   not registered  

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FileTypesAndCreatorsIncludes

; $ENDC                                         ; __FILETYPESANDCREATORS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FileTypesAndCreators)