(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FindByContent.p"
; at Wednesday May 1,2002 2:40:45 pm.
; 
;      File:       FindByContent.p
;  
;      Contains:   Public search interface for the Find by Content shared library
;  
;      Version:    Technology: 2.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FINDBYCONTENT__
; $SETC __FINDBYCONTENT__ := 1

; $I+
; $SETC FindByContentIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    ***************************************************************************
;    Language constants used with FBCIndexItemsInLanguages: these numbers are bits
;    in a 64-bit array that consists of two UInt32 words.  In the current implementation
;    the low word is always 0, so values for the high word are given.  If both UInt32
;    words are 0, the default value of kDefaultLanguagesHighWord is used.
;    ***************************************************************************
; 

;   languages that use the Roman character mapping 
(defconstant $englishHighWord #x80000000)
(defconstant $dutchHighWord #x40000000)         ;   also Afrikaans 
(defconstant $germanHighWord #x20000000)
(defconstant $swedishHighWord #x10000000)       ;   also Norwegian 
(defconstant $danishHighWord #x8000000)
(defconstant $spanishHighWord #x4000000)        ;   also Catalan 
(defconstant $portugueseHighWord #x2000000)
(defconstant $italianHighWord #x1000000)
(defconstant $frenchHighWord #x800000)
(defconstant $romanHighWord #x400000)           ;   other languages using Roman alphabet 
;   Languages that use other mappings 
(defconstant $icelandicHighWord #x200000)       ;   also Faroese 
(defconstant $hebrewHighWord #x100000)          ;   also Yiddish 
(defconstant $arabicHighWord #x80000)           ;   also Farsi, Urdu 
(defconstant $centeuroHighWord #x40000)         ;   Central European languages not using Cyrillic 
(defconstant $croatianHighWord #x20000)
(defconstant $turkishHighWord #x10000)
(defconstant $romanianHighWord #x8000)
(defconstant $greekHighWord #x4000)
(defconstant $cyrillicHighWord #x2000)          ;   all languages using Cyrillic 
(defconstant $devanagariHighWord #x1000)
(defconstant $gujuratiHighWord #x800)
(defconstant $gurmukhiHighWord #x400)
(defconstant $japaneseHighWord #x200)
(defconstant $koreanHighWord #x100)
(defconstant $kDefaultLanguagesHighWord #xFF800000);   sum of first 9 

; 
; 	   ***************************************************************************
; 	   Phase values
; 	   These values are passed to the client's callback function to indicate what
; 	   the FBC code is doing.
; 	   ***************************************************************************
; 	
;   indexing phases 
(defconstant $kFBCphIndexing 0)
(defconstant $kFBCphFlushing 1)
(defconstant $kFBCphMerging 2)
(defconstant $kFBCphMakingIndexAccessor 3)
(defconstant $kFBCphCompacting 4)
(defconstant $kFBCphIndexWaiting 5)             ;   access phases 
(defconstant $kFBCphSearching 6)
(defconstant $kFBCphMakingAccessAccessor 7)
(defconstant $kFBCphAccessWaiting 8)            ;   summarization 
(defconstant $kFBCphSummarizing 9)              ;   indexing or access 
(defconstant $kFBCphIdle 10)
(defconstant $kFBCphCanceling 11)

; 
; 	   ***************************************************************************
; 	   Pointer types
; 	   These point to memory allocated by the FBC shared library, and must be deallocated
; 	   by calls that are defined below.
; 	   ***************************************************************************
; 	

;   A collection of state information for searching 

(def-mactype :fbcsearchsession (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :fbcsearchsessionptr (find-mactype '(:pointer :pointer)));  when a VAR xx:FBCSearchSession parameter can be nil, it is changed to xx: FBCSearchSessionPtr 
;   a FBCWordList is a pointer to an array of pointers to c-strings 
(def-mactype :fbcwordlistrecptr (find-mactype '(:pointer :fbcwordlistrec)))
(defrecord FBCWordListRec 
   (words (:array :pointer 1))                  ;   array of pointers to c-strings 
   )

(def-mactype :fbcwordlist (find-mactype '(:pointer :fbcwordlistrec)))
; 
; 	   ***************************************************************************
; 	   Callback function type for progress reporting and cancelation during
; 	   searching and indexing.  The client's callback function should call
; 	   WaitNextEvent; a "sleep" value of 1 is suggested.  If the callback function
; 	   wants to cancel the current operation (indexing, search, or doc-terms
; 	   retrieval) it should return true.
; 	   ***************************************************************************
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FBCCallbackProcPtr = FUNCTION(phase: UInt16; percentDone: Single; data: UNIV Ptr): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :fbccallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fbccallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fbccallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFBCCallbackProcInfo #xF91)
; 
; 	 *  NewFBCCallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewFBCCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFBCCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeFBCCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFBCCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;    ***************************************************************************
;    Set the callback function for progress reporting and cancelation during
;    searching and indexing, and set the amount of heap space to reserve for
;    the client's use when FBC allocates memory.
;    ***************************************************************************
;                                               ; 
;  *  FBCSetCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeFBCCallbackUPP" 
      ((phase :unsigned-integer) (percentDone :single-float) (data :pointer) (userRoutine :pointer)) 
  :boolean
   () )
(deftrap-inline "_FBCSetCallback" 
      ((fn :pointer) (data :pointer)) 
  nil
   () )

; 
;  *  FBCSetHeapReservation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCSetHeapReservation" 
      ((bytes :unsigned-long)) 
  nil
   () )

; 
;    ***************************************************************************
;    Find out whether a volume is indexed, the date & time of its last
;    completed  update, and its physical size.
;    ***************************************************************************
; 

; 
;  *  FBCVolumeIsIndexed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCVolumeIsIndexed" 
      ((theVRefNum :signed-integer)) 
  :boolean
   () )

; 
;  *  FBCVolumeIsRemote()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCVolumeIsRemote" 
      ((theVRefNum :signed-integer)) 
  :boolean
   () )

; 
;  *  FBCVolumeIndexTimeStamp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCVolumeIndexTimeStamp" 
      ((theVRefNum :signed-integer) (timeStamp (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  FBCVolumeIndexPhysicalSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCVolumeIndexPhysicalSize" 
      ((theVRefNum :signed-integer) (size (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Create & configure a search session
;    ***************************************************************************
; 

; 
;  *  FBCCreateSearchSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCCreateSearchSession" 
      ((searchSession (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  FBCAddAllVolumesToSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCAddAllVolumesToSession" 
      ((theSession :pointer) (includeRemote :boolean)) 
  :signed-integer
   () )

; 
;  *  FBCSetSessionVolumes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FBCSetSessionVolumes" 
      ((theSession :pointer) (vRefNums (:pointer :signed-integer)) (numVolumes :unsigned-integer)) 
  :signed-integer
   () )

; 
;  *  FBCAddVolumeToSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCAddVolumeToSession" 
      ((theSession :pointer) (vRefNum :signed-integer)) 
  :signed-integer
   () )

; 
;  *  FBCRemoveVolumeFromSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCRemoveVolumeFromSession" 
      ((theSession :pointer) (vRefNum :signed-integer)) 
  :signed-integer
   () )

; 
;  *  FBCGetSessionVolumeCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetSessionVolumeCount" 
      ((theSession :pointer) (count (:pointer :unsigned-integer))) 
  :signed-integer
   () )

; 
;  *  FBCGetSessionVolumes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetSessionVolumes" 
      ((theSession :pointer) (vRefNums (:pointer :signed-integer)) (numVolumes (:pointer :unsigned-integer))) 
  :signed-integer
   () )

; 
;  *  FBCCloneSearchSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCCloneSearchSession" 
      ((original :pointer) (clone (:pointer :pointer))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Execute a search
;    ***************************************************************************
; 

; 
;  *  FBCDoQuerySearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FBCDoQuerySearch" 
      ((theSession :pointer) (queryText :pointer) (targetDirs (:pointer :fsspec)) (numTargets :unsigned-long) (maxHits :unsigned-long) (maxHitWords :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  FBCDoCFStringSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FBCDoCFStringSearch" 
      ((theSession :pointer) (queryString :pointer) (targetDirs (:pointer :fsspec)) (numTargets :unsigned-long) (maxHits :unsigned-long) (maxHitWords :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  FBCDoExampleSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_FBCDoExampleSearch" 
      ((theSession :pointer) (exampleHitNums (:pointer :unsigned-long)) (numExamples :unsigned-long) (targetDirs (:pointer :fsspec)) (numTargets :unsigned-long) (maxHits :unsigned-long) (maxHitWords :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  FBCBlindExampleSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FBCBlindExampleSearch" 
      ((examples (:pointer :fsspec)) (numExamples :unsigned-long) (targetDirs (:pointer :fsspec)) (numTargets :unsigned-long) (maxHits :unsigned-long) (maxHitWords :unsigned-long) (allIndexes :boolean) (includeRemote :boolean) (theSession (:pointer :pointer))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Get information about hits [wrapper for THitItem C++ API]
;    ***************************************************************************
; 

; 
;  *  FBCGetHitCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetHitCount" 
      ((theSession :pointer) (count (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  FBCGetHitDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetHitDocument" 
      ((theSession :pointer) (hitNumber :unsigned-long) (theDocument (:pointer :fsspec))) 
  :signed-integer
   () )

; 
;  *  FBCGetHitDocumentRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetHitDocumentRef" 
      ((theSession :pointer) (hitNumber :unsigned-long) (theDocument (:pointer :fsref))) 
  :signed-integer
   () )

; 
;  *  FBCGetHitScore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetHitScore" 
      ((theSession :pointer) (hitNumber :unsigned-long) (score (:pointer :single-float))) 
  :signed-integer
   () )

; 
;  *  FBCGetMatchedWords()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetMatchedWords" 
      ((theSession :pointer) (hitNumber :unsigned-long) (wordCount (:pointer :unsigned-long)) (list (:pointer (:pointer :fbcwordlistrec)))) 
  :signed-integer
   () )

; 
;  *  FBCGetTopicWords()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCGetTopicWords" 
      ((theSession :pointer) (hitNumber :unsigned-long) (wordCount (:pointer :unsigned-long)) (list (:pointer (:pointer :fbcwordlistrec)))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Summarize a buffer of text
;    ***************************************************************************
; 

; 
;  *  FBCSummarize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCSummarize" 
      ((inBuf :pointer) (inLength :unsigned-long) (outBuf :pointer) (outLength (:pointer :unsigned-long)) (numSentences (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Deallocate hit lists, word arrays, and search sessions
;    ***************************************************************************
; 

; 
;  *  FBCReleaseSessionHits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCReleaseSessionHits" 
      ((theSession :pointer)) 
  :signed-integer
   () )

; 
;  *  FBCDestroyWordList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCDestroyWordList" 
      ((theList (:pointer :fbcwordlistrec)) (wordCount :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  FBCDestroySearchSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCDestroySearchSession" 
      ((theSession :pointer)) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    Index one or more files and/or folders
;    ***************************************************************************
; 

; 
;  *  FBCIndexItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FindByContent 9.0 and later
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCIndexItems" 
      ((theItems (:pointer :fsspecarray)) (itemCount :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  FBCIndexItemsInLanguages()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCIndexItemsInLanguages" 
      ((theItems (:pointer :fsspecarray)) (itemCount :unsigned-long) (languageHighBits :unsigned-long) (languageLowBits :unsigned-long)) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    (OS X only) Given a folder, find the folder that contains the index file
;    of the given index
;    ***************************************************************************
; 

; 
;  *  FBCFindIndexFileFolderForFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FBCFindIndexFileFolderForFolder" 
      ((inFolder (:pointer :fsref)) (outFolder (:pointer :fsref))) 
  :signed-integer
   () )

; 
;    ***************************************************************************
;    (OS X only) Given a folder, delete the index file that indexes it
;    ***************************************************************************
; 

; 
;  *  FBCDeleteIndexFileForFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FBCDeleteIndexFileForFolder" 
      ((folder (:pointer :fsref))) 
  :signed-integer
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FindByContentIncludes

; $ENDC                                         ; __FINDBYCONTENT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'FindByContent)