(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Folders.p"
; at Wednesday May 1,2002 2:40:07 pm.
; 
;      File:       Folders.p
;  
;      Contains:   Folder Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FOLDERS__
; $SETC __FOLDERS__ := 1

; $I+
; $SETC FoldersIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kOnSystemDisk -32768)             ;   previously was 0x8000 but that is an unsigned value whereas vRefNum is signed 
(defconstant $kOnAppropriateDisk -32767)        ;   Generally, the same as kOnSystemDisk, but it's clearer that this isn't always the 'boot' disk. 
;   Folder Domains - Carbon only.  The constants above can continue to be used, but the folder/volume returned will 
;   be from one of the domains below. 
(defconstant $kSystemDomain -32766)             ;   Read-only system hierarchy. 
(defconstant $kLocalDomain -32765)              ;   All users of a single machine have access to these resources. 
(defconstant $kNetworkDomain -32764)            ;   All users configured to use a common network server has access to these resources. 
(defconstant $kUserDomain -32763)               ;   Read/write. Resources that are private to the user. 
(defconstant $kClassicDomain -32762)            ;   Domain referring to the currently configured Classic System Folder 

(defconstant $kCreateFolder #$true)
(defconstant $kDontCreateFolder #$false)

(defconstant $kSystemFolderType :|macs|)        ;   the system folder  
(defconstant $kDesktopFolderType :|desk|)       ;   the desktop folder; objects in this folder show on the desk top.  
(defconstant $kSystemDesktopFolderType :|sdsk|) ;   the desktop folder at the root of the hard drive, never the redirected user desktop folder  
(defconstant $kTrashFolderType :|trsh|)         ;   the trash folder; objects in this folder show up in the trash  
(defconstant $kSystemTrashFolderType :|strs|)   ;   the trash folder at the root of the drive, never the redirected user trash folder  
(defconstant $kWhereToEmptyTrashFolderType :|empt|);   the "empty trash" folder; Finder starts empty from here down  
(defconstant $kPrintMonitorDocsFolderType :|prnt|);   Print Monitor documents  
(defconstant $kStartupFolderType :|strt|)       ;   Finder objects (applications, documents, DAs, aliases, to...) to open at startup go here  
(defconstant $kShutdownFolderType :|shdf|)      ;   Finder objects (applications, documents, DAs, aliases, to...) to open at shutdown go here  
(defconstant $kAppleMenuFolderType :|amnu|)     ;   Finder objects to put into the Apple menu go here  
(defconstant $kControlPanelFolderType :|ctrl|)  ;   Control Panels go here (may contain INITs)  
(defconstant $kSystemControlPanelFolderType :|sctl|);   System control panels folder - never the redirected one, always "Control Panels" inside the System Folder  
(defconstant $kExtensionFolderType :|extn|)     ;   System extensions go here  
(defconstant $kFontsFolderType :|font|)         ;   Fonts go here  
(defconstant $kPreferencesFolderType :|pref|)   ;   preferences for applications go here  
(defconstant $kSystemPreferencesFolderType :|sprf|);   System-type Preferences go here - this is always the system's preferences folder, never a logged in user's  
(defconstant $kTemporaryFolderType :|temp|)     ;   temporary files go here (deleted periodically, but don't rely on it.)  

; 
; 	 *  FindFolder()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_FindFolder" 
      ((vRefNum :signed-integer) (folderType :ostype) (createFolder :boolean) (foundVRefNum (:pointer :signed-integer)) (foundDirID (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 0 vRefNum folderType createFolder foundVRefNum foundDirID))

; 
;  *  FindFolderExtended()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindFolderExtended" 
      ((vol :signed-integer) (foldType :ostype) (createFolder :boolean) (flags :unsigned-long) (data :pointer) (vRefNum (:pointer :signed-integer)) (dirID (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 2860 vol foldType createFolder flags data vRefNum dirID))

; 
;  *  ReleaseFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReleaseFolder" 
      ((vRefNum :signed-integer) (folderType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 11 vRefNum folderType))

#|                                              ; $IFC NOT TARGET_OS_MAC 
;  Since non-mac targets don't know about VRef's or DirID's, the Ex version returns
;    the found folder path.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  FindFolderEx()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FindFolderEx" 
      ((vRefNum :signed-integer) (folderType :ostype) (createFolder :boolean) (foundVRefNum (:pointer :signed-integer)) (foundDirID (:pointer :signed-long)) (foundFolder :pointer)) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;  *  FSFindFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FSFindFolder" 
      ((vRefNum :signed-integer) (folderType :ostype) (createFolder :boolean) (foundRef (:pointer :fsref)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 52 vRefNum folderType createFolder foundRef))

; 
;  *  FSFindFolderExtended()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FSFindFolderExtended" 
      ((vol :signed-integer) (foldType :ostype) (createFolder :boolean) (flags :unsigned-long) (data :pointer) (foundRef (:pointer :fsref)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 53 vol foldType createFolder flags data foundRef))

; ****************************************
;  Extensible Folder Manager declarations 
; ****************************************

; **************************
;  Folder Manager constants 
; **************************

(defconstant $kExtensionDisabledFolderType :|extD|)
(defconstant $kControlPanelDisabledFolderType :|ctrD|)
(defconstant $kSystemExtensionDisabledFolderType :|macD|)
(defconstant $kStartupItemsDisabledFolderType :|strD|)
(defconstant $kShutdownItemsDisabledFolderType :|shdD|)
(defconstant $kApplicationsFolderType :|apps|)
(defconstant $kDocumentsFolderType :|docs|)

;   new constants  
(defconstant $kVolumeRootFolderType :|root|)    ;   root folder of a volume  
(defconstant $kChewableItemsFolderType :|flnt|) ;   items deleted at boot  
(defconstant $kApplicationSupportFolderType :|asup|);   third-party items and folders  
(defconstant $kTextEncodingsFolderType :|tex|) ;   encoding tables  
(defconstant $kStationeryFolderType :|odst|)    ;   stationery  
(defconstant $kOpenDocFolderType :|odod|)       ;   OpenDoc root  
(defconstant $kOpenDocShellPlugInsFolderType :|odsp|);   OpenDoc Shell Plug-Ins in OpenDoc folder  
(defconstant $kEditorsFolderType :|oded|)       ;   OpenDoc editors in MacOS Folder  
(defconstant $kOpenDocEditorsFolderType :|odf|);   OpenDoc subfolder of Editors folder  
(defconstant $kOpenDocLibrariesFolderType :|odlb|);   OpenDoc libraries folder  
(defconstant $kGenEditorsFolderType :|edi|)    ;   CKH general editors folder at root level of Sys folder  
(defconstant $kHelpFolderType :|hlp|)          ;   CKH help folder currently at root of system folder  
(defconstant $kInternetPlugInFolderType :|net|);   CKH internet plug ins for browsers and stuff  
(defconstant $kModemScriptsFolderType :|mod|)  ;   CKH modem scripts, get 'em OUT of the Extensions folder  
(defconstant $kPrinterDescriptionFolderType :|ppdf|);   CKH new folder at root of System folder for printer descs.  
(defconstant $kPrinterDriverFolderType :|prd|) ;   CKH new folder at root of System folder for printer drivers  
(defconstant $kScriptingAdditionsFolderType :|scr|);   CKH at root of system folder  
(defconstant $kSharedLibrariesFolderType :|lib|);   CKH for general shared libs.  
(defconstant $kVoicesFolderType :|fvoc|)        ;   CKH macintalk can live here  
(defconstant $kControlStripModulesFolderType :|sdev|);   CKH for control strip modules  
(defconstant $kAssistantsFolderType :|ast|)    ;   SJF for Assistants (MacOS Setup Assistant, etc)  
(defconstant $kUtilitiesFolderType :|uti|)     ;   SJF for Utilities folder  
(defconstant $kAppleExtrasFolderType :|aex|)   ;   SJF for Apple Extras folder  
(defconstant $kContextualMenuItemsFolderType :|cmnu|);   SJF for Contextual Menu items  
(defconstant $kMacOSReadMesFolderType :|mor|)  ;   SJF for MacOS ReadMes folder  
(defconstant $kALMModulesFolderType :|walk|)    ;   EAS for Location Manager Module files except type 'thng' (within kExtensionFolderType)  
(defconstant $kALMPreferencesFolderType :|trip|);   EAS for Location Manager Preferences (within kPreferencesFolderType; contains kALMLocationsFolderType)  
(defconstant $kALMLocationsFolderType :|fall|)  ;   EAS for Location Manager Locations (within kALMPreferencesFolderType)  
(defconstant $kColorSyncProfilesFolderType :|prof|);   for ColorSync Profiles  
(defconstant $kThemesFolderType :|thme|)        ;   for Theme data files  
(defconstant $kFavoritesFolderType :|favs|)     ;   Favorties folder for Navigation Services  
(defconstant $kInternetFolderType :|int|)      ;   Internet folder (root level of startup volume)  
(defconstant $kAppearanceFolderType :|appr|)    ;   Appearance folder (root of system folder)  
(defconstant $kSoundSetsFolderType :|snds|)     ;   Sound Sets folder (in Appearance folder)  
(defconstant $kDesktopPicturesFolderType :|dtp|);   Desktop Pictures folder (in Appearance folder)  
(defconstant $kInternetSearchSitesFolderType :|issf|);   Internet Search Sites folder  
(defconstant $kFindSupportFolderType :|fnds|)   ;   Find support folder  
(defconstant $kFindByContentFolderType :|fbcf|) ;   Find by content folder  
(defconstant $kInstallerLogsFolderType :|ilgf|) ;   Installer Logs folder  
(defconstant $kScriptsFolderType :|scr|)       ;   Scripts folder  
(defconstant $kFolderActionsFolderType :|fasf|) ;   Folder Actions Scripts folder  
(defconstant $kLauncherItemsFolderType :|laun|) ;   Launcher Items folder  
(defconstant $kRecentApplicationsFolderType :|rapp|);   Recent Applications folder  
(defconstant $kRecentDocumentsFolderType :|rdoc|);   Recent Documents folder  
(defconstant $kRecentServersFolderType :|rsvr|) ;   Recent Servers folder  
(defconstant $kSpeakableItemsFolderType :|spki|);   Speakable Items folder  
(defconstant $kKeychainFolderType :|kchn|)      ;   Keychain folder  
(defconstant $kQuickTimeExtensionsFolderType :|qtex|);   QuickTime Extensions Folder (in Extensions folder)  
(defconstant $kDisplayExtensionsFolderType :|dspl|);   Display Extensions Folder (in Extensions folder)  
(defconstant $kMultiprocessingFolderType :|mpxf|);   Multiprocessing Folder (in Extensions folder)  
(defconstant $kPrintingPlugInsFolderType :|pplg|);   Printing Plug-Ins Folder (in Extensions folder)  

; 	 New Folder Types to accommodate the Mac OS X Folder Manager 	
; 	 These folder types are not applicable on Mac OS 9.          	
(defconstant $kDomainTopLevelFolderType :|dtop|);   The top-level of a Folder domain, e.g. "/System" 
(defconstant $kDomainLibraryFolderType :|dlib|) ;   the Library subfolder of a particular domain 
(defconstant $kColorSyncFolderType :|sync|)     ;   Contains ColorSync-related folders 
(defconstant $kColorSyncCMMFolderType :|ccmm|)  ;   ColorSync CMMs 
(defconstant $kColorSyncScriptingFolderType :|cscr|);   ColorSync Scripting support 
(defconstant $kPrintersFolderType :|impr|)      ;   Contains Printing-related folders 
(defconstant $kSpeechFolderType :|spch|)        ;   Contains Speech-related folders 
(defconstant $kCarbonLibraryFolderType :|carb|) ;   Contains Carbon-specific file 
(defconstant $kDocumentationFolderType :|info|) ;   Contains Documentation files (not user documents) 
(defconstant $kDeveloperDocsFolderType :|ddoc|) ;   Contains Developer Documentation files and folders 
(defconstant $kDeveloperHelpFolderType :|devh|) ;   Contains Developer Help related files 
(defconstant $kISSDownloadsFolderType :|issd|)  ;   Contains Internet Search Sites downloaded from the Internet 
(defconstant $kUserSpecificTmpFolderType :|utmp|);   Contains temporary items created on behalf of the current user 
(defconstant $kCachedDataFolderType :|cach|)    ;   Contains various cache files for different clients 
(defconstant $kFrameworksFolderType :|fram|)    ;   Contains MacOS X Framework folders      
(defconstant $kPrivateFrameworksFolderType :|pfrm|);   Contains MacOS X Private Framework folders      
(defconstant $kClassicDesktopFolderType :|sdsk|);   MacOS 9 compatible desktop folder - same as  
;   kSystemDesktopFolderType but with a more appropriate 
;   name for Mac OS X code. 
(defconstant $kDeveloperFolderType :|devf|)     ;   Contains MacOS X Developer Resources 
(defconstant $kSystemSoundsFolderType :|ssnd|)  ;   Contains Mac OS X System Sound Files 
(defconstant $kComponentsFolderType :|cmpd|)    ;   Contains Mac OS X components 
(defconstant $kQuickTimeComponentsFolderType :|wcmp|);   Contains QuickTime components for Mac OS X 
(defconstant $kCoreServicesFolderType :|csrv|)  ;   Refers to the "CoreServices" folder on Mac OS X 
(defconstant $kPictureDocumentsFolderType :|pdoc|);   Refers to the "Pictures" folder in a users home directory 
(defconstant $kMovieDocumentsFolderType :|mdoc|);   Refers to the "Movies" folder in a users home directory 
(defconstant $kMusicDocumentsFolderType :|doc|);   Refers to the "Music" folder in a users home directory 
(defconstant $kInternetSitesFolderType :|site|) ;   Refers to the "Sites" folder in a users home directory 
(defconstant $kPublicFolderType :|pubb|)        ;   Refers to the "Public" folder in a users home directory 
(defconstant $kAudioSupportFolderType :|adio|)  ;   Refers to the Audio support folder for Mac OS X 
(defconstant $kAudioSoundsFolderType :|asnd|)   ;   Refers to the Sounds subfolder of Audio Support 
(defconstant $kAudioSoundBanksFolderType :|bank|);   Refers to the Banks subfolder of the Sounds Folder 
(defconstant $kAudioAlertSoundsFolderType :|alrt|);   Refers to the Alert Sounds subfolder of the Sound Folder 
(defconstant $kAudioPlugInsFolderType :|aplg|)  ;   Refers to the Plug-ins subfolder of the Audio Folder    
(defconstant $kAudioComponentsFolderType :|acmp|);   Refers to the Components subfolder of the Audio Plug-ins Folder     
(defconstant $kKernelExtensionsFolderType :|kext|);   Refers to the Kernel Extensions Folder on Mac OS X 
(defconstant $kDirectoryServicesFolderType :|dsrv|);   Refers to the Directory Services folder on Mac OS X 
(defconstant $kDirectoryServicesPlugInsFolderType :|dplg|);   Refers to the Directory Services Plug-Ins folder on Mac OS X  
(defconstant $kInstallerReceiptsFolderType :|rcpt|);   Refers to the "Receipts" folder in Mac OS X 
(defconstant $kFileSystemSupportFolderType :|fsys|);   Refers to the [domain]/Library/Filesystems folder in Mac OS X 
(defconstant $kAppleShareSupportFolderType :|shar|);   Refers to the [domain]/Library/Filesystems/AppleShare folder in Mac OS X 
(defconstant $kAppleShareAuthenticationFolderType :|auth|);   Refers to the [domain]/Library/Filesystems/AppleShare/Authentication folder in Mac OS X 
(defconstant $kMIDIDriversFolderType :|midi|)   ;   Refers to the MIDI Drivers folder on Mac OS X 

(defconstant $kLocalesFolderType :|loc|)       ;   PKE for Locales folder  
(defconstant $kFindByContentPluginsFolderType :|fbcp|);   Find By Content Plug-ins  

(defconstant $kUsersFolderType :|usrs|)         ;   "Users" folder, contains one folder for each user.  
(defconstant $kCurrentUserFolderType :|cusr|)   ;   The folder for the currently logged on user.  
(defconstant $kCurrentUserRemoteFolderLocation :|rusf|);   The remote folder for the currently logged on user  
(defconstant $kCurrentUserRemoteFolderType :|rusr|);   The remote folder location for the currently logged on user  
(defconstant $kSharedUserDataFolderType :|sdat|);   A Shared "Documents" folder, readable & writeable by all users  
(defconstant $kVolumeSettingsFolderType :|vsfd|);   Volume specific user information goes here  

(defconstant $kAppleshareAutomountServerAliasesFolderType :|srv|);   Appleshare puts volumes to automount inside this folder.  
(defconstant $kPreMacOS91ApplicationsFolderType :|pps|);   The "Applications" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91InstallerLogsFolderType :|lgf|);   The "Installer Logs" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91AssistantsFolderType :|st|);   The "Assistants" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91UtilitiesFolderType :|ti|);   The "Utilities" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91AppleExtrasFolderType :|ex|);   The "Apple Extras" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91MacOSReadMesFolderType :|or|);   The "Mac OS ReadMes" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91InternetFolderType :|nt|);   The "Internet" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91AutomountedServersFolderType :|rv|);   The "Servers" folder, pre Mac OS 9.1  
(defconstant $kPreMacOS91StationeryFolderType :|dst|);   The "Stationery" folder, pre Mac OS 9.1  

; 	 FolderDescFlags values 	
(defconstant $kCreateFolderAtBoot #x2)
(defconstant $kCreateFolderAtBootBit 1)
(defconstant $kFolderCreatedInvisible #x4)
(defconstant $kFolderCreatedInvisibleBit 2)
(defconstant $kFolderCreatedNameLocked #x8)
(defconstant $kFolderCreatedNameLockedBit 3)
(defconstant $kFolderCreatedAdminPrivs #x10)
(defconstant $kFolderCreatedAdminPrivsBit 4)

(defconstant $kFolderInUserFolder #x20)
(defconstant $kFolderInUserFolderBit 5)
(defconstant $kFolderTrackedByAlias #x40)
(defconstant $kFolderTrackedByAliasBit 6)
(defconstant $kFolderInRemoteUserFolderIfAvailable #x80)
(defconstant $kFolderInRemoteUserFolderIfAvailableBit 7)
(defconstant $kFolderNeverMatchedInIdentifyFolder #x100)
(defconstant $kFolderNeverMatchedInIdentifyFolderBit 8)
(defconstant $kFolderMustStayOnSameVolume #x200)
(defconstant $kFolderMustStayOnSameVolumeBit 9)
(defconstant $kFolderManagerFolderInMacOS9FolderIfMacOSXIsInstalledMask #x400)
(defconstant $kFolderManagerFolderInMacOS9FolderIfMacOSXIsInstalledBit 10)
(defconstant $kFolderInLocalOrRemoteUserFolder #xA0)

(def-mactype :folderdescflags (find-mactype ':unsigned-long))
; 	 FolderClass values 	

(defconstant $kRelativeFolder :|relf|)
(defconstant $kSpecialFolder :|spcf|)

(def-mactype :folderclass (find-mactype ':ostype))
; 	 special folder locations 	

(defconstant $kBlessedFolder :|blsf|)
(defconstant $kRootFolder :|rotf|)

(defconstant $kCurrentUserFolderLocation :|cusf|);      the magic 'Current User' folder location 

(def-mactype :foldertype (find-mactype ':ostype))
(def-mactype :folderlocation (find-mactype ':ostype))

(def-mactype :folderdescptr (find-mactype '(:pointer :folderdesc)))
(defrecord FolderDesc 
   (descSize :signed-long)
   (foldType :ostype)
   (flags :unsigned-long)
   (foldClass :ostype)
   (foldLocation :ostype)
   (badgeSignature :ostype)
   (badgeType :ostype)
   (reserved :unsigned-long)
   (name (:string 63))                          ;   Str63 on MacOS 
   )

(def-mactype :routingflags (find-mactype ':unsigned-long))
(def-mactype :folderroutingptr (find-mactype '(:pointer :folderrouting)))
(defrecord FolderRouting 
   (descSize :signed-long)
   (fileType :ostype)
   (routeFromFolder :ostype)
   (routeToFolder :ostype)
   (flags :unsigned-long)
   )

; 	 routing constants 	
;    These are bits in the .flags field of the FindFolderUserRedirectionGlobals struct 

;      Set this bit to 1 in the .flags field of a FindFolderUserRedirectionGlobals 
;      structure if the userName in the struct should be used as the current 
;      "User" name 
(defconstant $kFindFolderRedirectionFlagUseDistinctUserFoldersBit 0);      Set this bit to 1 and the currentUserFolderVRefNum and currentUserFolderDirID 
;      fields of the user record will get used instead of finding the user folder 
;      with the userName field. 
(defconstant $kFindFolderRedirectionFlagUseGivenVRefAndDirIDAsUserFolderBit 1);      Set this bit to 1 and the remoteUserFolderVRefNum and remoteUserFolderDirID 
;      fields of the user record will get used instead of finding the user folder 
;      with the userName field. 
(defconstant $kFindFolderRedirectionFlagsUseGivenVRefNumAndDirIDAsRemoteUserFolderBit 2)

(def-mactype :findfolderuserredirectionglobalsptr (find-mactype '(:pointer :findfolderuserredirectionglobals)))
(defrecord FindFolderUserRedirectionGlobals 
   (version :unsigned-long)
   (flags :unsigned-long)
   (userName (:string 31))
   (userNameScript :signed-integer)
   (currentUserFolderVRefNum :signed-integer)
   (currentUserFolderDirID :signed-long)
   (remoteUserFolderVRefNum :signed-integer)
   (remoteUserFolderDirID :signed-long)
   )

(defconstant $kFolderManagerUserRedirectionGlobalsCurrentVersion 1)

; 
; 	    These are passed into FindFolderExtended(), FindFolderInternalExtended(), and
; 	    FindFolderNewInstallerEntryExtended() in the flags field. 
; 	
(defconstant $kFindFolderExtendedFlagsDoNotFollowAliasesBit 0)
(defconstant $kFindFolderExtendedFlagsDoNotUseUserFolderBit 1)
(defconstant $kFindFolderExtendedFlagsUseOtherUserRecord #x1000000)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FolderManagerNotificationProcPtr = FUNCTION(message: OSType; arg: UNIV Ptr; userRefCon: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :foldermanagernotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :foldermanagernotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :foldermanagernotificationupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFolderManagerNotificationProcInfo #xFF0)
; 
; 	 *  NewFolderManagerNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewFolderManagerNotificationProc 
(deftrap "_NewFolderManagerNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFolderManagerNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeFolderManagerNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFolderManagerNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallFolderManagerNotificationProc 
(deftrap-inline "_InvokeFolderManagerNotificationUPP" 
      ((message :ostype) (arg :pointer) (userRefCon :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

(defconstant $kFolderManagerNotificationMessageUserLogIn :|log+|);      Sent by system & third party software after a user logs in.  arg should point to a valid FindFolderUserRedirectionGlobals structure or nil for the owner 
(defconstant $kFolderManagerNotificationMessagePreUserLogIn :|logj|);      Sent by system & third party software before a user logs in.  arg should point to a valid FindFolderUserRedirectionGlobals structure or nil for the owner 
(defconstant $kFolderManagerNotificationMessageUserLogOut :|log-|);      Sent by system & third party software before a user logs out.  arg should point to a valid FindFolderUserRedirectionGlobals structure or nil for the owner 
(defconstant $kFolderManagerNotificationMessagePostUserLogOut :|logp|);      Sent by system & third party software after a user logs out.  arg should point to a valid FindFolderUserRedirectionGlobals structure or nil for the owner 
(defconstant $kFolderManagerNotificationDiscardCachedData :|dche|);      Sent by system & third party software when the entire Folder Manager cache should be flushed 
(defconstant $kFolderManagerNotificationMessageLoginStartup :|stup|);      Sent by 'Login' application the first time it starts up after each boot 

;    These get used in the options parameter of FolderManagerRegisterNotificationProc() 
(defconstant $kDoNotRemoveWhenCurrentApplicationQuitsBit 0)
(defconstant $kDoNotRemoveWheCurrentApplicationQuitsBit 0);      Going away soon, use kDoNotRemoveWheCurrentApplicationQuitsBit 

;    These get used in the options parameter of FolderManagerCallNotificationProcs() 
(defconstant $kStopIfAnyNotificationProcReturnsErrorBit 31)

; 	*************************	
; 	 Folder Manager routines 	
; 	*************************	
; 	 Folder Manager administration routines 	
; 
; 	 *  AddFolderDescriptor()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FoldersLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_AddFolderDescriptor" 
      ((foldType :ostype) (flags :unsigned-long) (foldClass :ostype) (foldLocation :ostype) (badgeSignature :ostype) (badgeType :ostype) (name (:string 63)) (replaceFlag :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 32 foldType flags foldClass foldLocation badgeSignature badgeType name replaceFlag))

; 
;  *  GetFolderDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFolderDescriptor" 
      ((foldType :ostype) (descSize :signed-long) (foldDesc (:pointer :folderdesc)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 35 foldType descSize foldDesc))

; 
;  *  GetFolderTypes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFolderTypes" 
      ((requestedTypeCount :unsigned-long) (totalTypeCount (:pointer :unsigned-long)) (theTypes (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 36 requestedTypeCount totalTypeCount theTypes))

; 
;  *  RemoveFolderDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveFolderDescriptor" 
      ((foldType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 33 foldType))

;  legacy routines 
; 
;  *  GetFolderName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFolderName" 
      ((vRefNum :signed-integer) (foldType :ostype) (foundVRefNum (:pointer :signed-integer)) (name (:pointer (:string 63))))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 14 vRefNum foldType foundVRefNum name))

;  routing routines 
; 
;  *  AddFolderRouting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AddFolderRouting" 
      ((fileType :ostype) (routeFromFolder :ostype) (routeToFolder :ostype) (flags :unsigned-long) (replaceFlag :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 2342 fileType routeFromFolder routeToFolder flags replaceFlag))

; 
;  *  RemoveFolderRouting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveFolderRouting" 
      ((fileType :ostype) (routeFromFolder :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 1063 fileType routeFromFolder))

; 
;  *  FindFolderRouting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindFolderRouting" 
      ((fileType :ostype) (routeFromFolder :ostype) (routeToFolder (:pointer :ostype)) (flags (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 2082 fileType routeFromFolder routeToFolder flags))

; 
;  *  GetFolderRoutings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFolderRoutings" 
      ((requestedRoutingCount :unsigned-long) (totalRoutingCount (:pointer :unsigned-long)) (routingSize :signed-long) (theRoutings (:pointer :folderrouting)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 2078 requestedRoutingCount totalRoutingCount routingSize theRoutings))

; 
;  *  InvalidateFolderDescriptorCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InvalidateFolderDescriptorCache" 
      ((vRefNum :signed-integer) (dirID :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 805 vRefNum dirID))

; 
;  *  IdentifyFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FoldersLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IdentifyFolder" 
      ((vRefNum :signed-integer) (dirID :signed-long) (foldType (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 1311 vRefNum dirID foldType))

; 
;  *  FolderManagerRegisterNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FolderManagerRegisterNotificationProc" 
      ((notificationProc :pointer) (refCon :pointer) (options :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 1583 notificationProc refCon options))

; 
;  *  FolderManagerUnregisterNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FolderManagerUnregisterNotificationProc" 
      ((notificationProc :pointer) (refCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA823 :d0 1072 notificationProc refCon))

; 
;  *  FolderManagerRegisterCallNotificationProcs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FolderManagerRegisterCallNotificationProcs" 
      ((message :ostype) (arg :pointer) (options :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xA823 :d0 1585 message arg options))

; *****************************
;  MultiUser (At Ease) globals 
; *****************************
; 
;    This structure has been through some evolution since the early days of At Ease 1.0.  The structure
;    has been expanded (and developers should assume that it will continue this way into the future).  Older
;    fields have been obsoleted as the features have changed in newer versions of the code.
; 

;   Some fields in here are really only valid for the network version of Macintosh Manager 

(def-mactype :multiusergestaltptr (find-mactype '(:pointer :multiusergestalt)))
(defrecord MultiUserGestalt 
;      Version 1 fields. 
   (giVersion :signed-integer)                  ;   structure version: 0 = invalid, 6 = OS 9 
   (giReserved0 :signed-integer)                ;   [OBSOLETE with v3] giIsActive: if true then At Ease is currently running 
   (giReserved1 :signed-integer)                ;   [OBSOLETE] if true then auto create alias 
   (giReserved2 :signed-integer)                ;   [OBSOLETE with v6]  if true then request floppy on new saves 
   (giReserved3 :signed-integer)                ;   [OBSOLETE] if true then hypercard stacks are shown on Applications panel 
   (giReserved4 :fsspec)                        ;   [OBSOLETE with v6] location of At Ease Items folder 
;      Version 2 fields. 
   (giDocsVRefNum :signed-integer)              ;   vrefnum of user's documents location (only valid if not on floppy) 
   (giDocsDirID :signed-long)                   ;   directory id of user's documents folder (only valid if not on floppy) 
   (giForceSaves :signed-integer)               ;   true if user is forced to save to their documents folder 
   (giForceOpens :signed-integer)               ;   true if user is forced to open from their documents folder 
   (giSetupName (:string 31))                   ;   name of current setup 
   (giUserName (:string 31))                    ;   name of current user 
   (giFrontAppName (:string 31))                ;   name of the frontmost application 
   (giReserved5 :signed-integer)                ;   [OBSOLETE with v6] true if user has Go To Finder menu item 
   (giIsOn :signed-integer)                     ;   true if Multiple Users/Macintosh Manager is on right now 
;      Version 3 fields. 
;    There were no additional fields for version 3.x 
;      Version 4 fields. 
   (giUserLoggedInType :signed-integer)         ;   0 = normal user, 1 = workgroup admin, 2 = global admin 
   (giUserEncryptPwd (:array :character 16 :packed));   encrypted user password (our digest form) 
   (giUserEnvironment :signed-integer)          ;   0 = panels, 1 = normal Finder, 2 = limited/restricted Finder 
   (giReserved6 :signed-long)                   ;   [OBSOLETE] 
   (giReserved7 :signed-long)                   ;   [OBSOLETE] 
   (giDisableScrnShots :boolean)                ;   true if screen shots are not allowed 
;      Version 5 fields. 
   (giSupportsAsyncFSCalls :boolean)            ;   Finder uses this to tell if our patches support async trap patches 
   (giPrefsVRefNum :signed-integer)             ;   vrefnum of preferences 
   (giPrefsDirID :signed-long)                  ;   dirID of the At Ease Items folder on preferences volume 
   (giUserLogInTime :unsigned-long)             ;   time in seconds we've been logged in (0 or 1 mean not logged in) 
   (giUsingPrintQuotas :boolean)                ;   true if logged in user is using printer quotas 
   (giUsingDiskQuotas :boolean)                 ;   true if logged in user has disk quotas active 
;   Version 6 fields - As of Mac OS 9's "Multiple Users 1.0" 
   (giInSystemAccess :boolean)                  ;   true if system is in System Access (i.e., owner logged in) 
   (giUserFolderEnabled :boolean)               ;   true if FindFolder is redirecting folders (uses giUserName for user) 
   (giReserved8 :signed-integer)
   (giReserved9 :signed-long)
   (giInLoginScreen :boolean)                   ;   true if no user has logged in (including owner) 
;   May have more fields added in future, so never check for sizeof(GestaltRec) 
   )

(def-mactype :multiusergestalthandle (find-mactype '(:handle :multiusergestalt)))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FoldersIncludes

; $ENDC                                         ; __FOLDERS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Folders)