(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FontSync.p"
; at Wednesday May 1,2002 2:40:41 pm.
; 
;      File:       FontSync.p
;  
;      Contains:   Public interface for FontSync
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FONTSYNC__
; $SETC __FONTSYNC__ := 1

; $I+
; $SETC FontSyncIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FONTS__
|#

(require-interface 'Fonts)
#|                                              ; $I Fonts.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SFNTTYPES__
|#

(require-interface 'SFNTTypes)
#|                                              ; $I SFNTTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

;  Matching Options 

(def-mactype :fnsmatchoptions (find-mactype ':unsigned-long))

(defconstant $kFNSMatchNames #x1)               ;   font names must match  
(defconstant $kFNSMatchTechnology #x2)          ;   scaler technology must match  
(defconstant $kFNSMatchGlyphs #x4)              ;   glyph data must match  
(defconstant $kFNSMatchEncodings #x8)           ;   cmaps must match  
(defconstant $kFNSMatchQDMetrics #x10)          ;   QuickDraw Text metrics must match  
(defconstant $kFNSMatchATSUMetrics #x20)        ;   ATSUI metrics (incl. vertical) must match  
(defconstant $kFNSMatchKerning #x40)            ;   kerning data must match  
(defconstant $kFNSMatchWSLayout #x80)           ;   WorldScript layout tables must match  
(defconstant $kFNSMatchAATLayout #x100)         ;   AAT (incl. OpenType) layout tables must match  
(defconstant $kFNSMatchPrintEncoding #x200)     ;   PostScript font and glyph names and re-encoding vector must match  
(defconstant $kFNSMissingDataNoMatch #x80000000);   treat missing data as mismatch  
(defconstant $kFNSMatchAll #xFFFFFFFF)          ;   everything must match  
(defconstant $kFNSMatchDefaults 0)              ;   use global default match options  

; 
; 	 *  FNSMatchDefaultsGet()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_FNSMatchDefaultsGet" 
      () 
  :unsigned-long
   () )

;  Version control 

(def-mactype :fnsobjectversion (find-mactype ':unsigned-long))

(defconstant $kFNSVersionDontCare 0)
(defconstant $kFNSCurSysInfoVersion 1)

;   No features defined yet. 

(def-mactype :fnsfeatureflags (find-mactype ':unsigned-long))
; 
; 	   The FontSync library version number is binary-coded decimal:
; 	   8 bits of major version, 4 minor version and 4 bits revision.
; 	
(def-mactype :fnssysinfoptr (find-mactype '(:pointer :fnssysinfo)))
(defrecord FNSSysInfo 
   (iSysInfoVersion :unsigned-long)             ;   fill this in before calling FNSSysInfoGet 
   (oFeatures :unsigned-long)
   (oCurRefVersion :unsigned-long)
   (oMinRefVersion :unsigned-long)
   (oCurProfileVersion :unsigned-long)
   (oMinProfileVersion :unsigned-long)
   (oFontSyncVersion :unsigned-integer)
   )

; 
; 	 *  FNSSysInfoGet()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_FNSSysInfoGet" 
      ((ioInfo (:pointer :fnssysinfo))) 
  nil
   () )

;  FontSync References 

(def-mactype :fnsfontreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :fnsfontreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:FNSFontReference parameter can be nil, it is changed to xx: FNSFontReferencePtr 
; 
; 	 *  FNSReferenceGetVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_FNSReferenceGetVersion" 
      ((iReference :pointer) (oVersion (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceDispose" 
      ((iReference :pointer)) 
  :osstatus
   () )

; 
;  *  FNSReferenceMatch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceMatch" 
      ((iReference1 :pointer) (iReference2 :pointer) (iOptions :unsigned-long) (oFailedMatchOptions (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceFlattenedSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceFlattenedSize" 
      ((iReference :pointer) (oFlattenedSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceFlatten()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceFlatten" 
      ((iReference :pointer) (oFlatReference :pointer) (oFlattenedSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceUnflatten()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceUnflatten" 
      ((iFlatReference :pointer) (iFlattenedSize :unsigned-long) (oReference (:pointer :pointer))) 
  :osstatus
   () )

;  FontSync Profiles 

(defconstant $kFNSCreatorDefault 0)
(defconstant $kFNSProfileFileType :|fnsp|)

(def-mactype :fnsfontprofile (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :fnsfontprofileptr (find-mactype '(:pointer :pointer)));  when a VAR xx:FNSFontProfile parameter can be nil, it is changed to xx: FNSFontProfilePtr 
; 
; 	 *  FNSProfileCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap-inline "_FNSProfileCreate" 
      ((iFile (:pointer :fsspec)) (iCreator :ostype) (iEstNumRefs :unsigned-long) (iDesiredVersion :unsigned-long) (oProfile (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSProfileOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_FNSProfileOpen" 
      ((iFile (:pointer :fsspec)) (iOpenForWrite :boolean) (oProfile (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSProfileCreateWithFSRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_FNSProfileCreateWithFSRef" 
      ((iParentDirectory (:pointer :fsref)) (iNameLength :unsigned-long) (iName (:pointer :unsigned-integer)) (iCreator :ostype) (iEstNumRefs :unsigned-long) (iDesiredVersion :unsigned-long) (oProfile (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSProfileOpenWithFSRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap-inline "_FNSProfileOpenWithFSRef" 
      ((iFile (:pointer :fsref)) (iOpenForWrite :boolean) (oProfile (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSProfileGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileGetVersion" 
      ((iProfile :pointer) (oVersion (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSProfileCompact()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileCompact" 
      ((iProfile :pointer)) 
  :osstatus
   () )

; 
;  *  FNSProfileClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileClose" 
      ((iProfile :pointer)) 
  :osstatus
   () )

; 
;  *  FNSProfileAddReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileAddReference" 
      ((iProfile :pointer) (iReference :pointer)) 
  :osstatus
   () )

; 
;  *  FNSProfileRemoveReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileRemoveReference" 
      ((iProfile :pointer) (iReference :pointer)) 
  :osstatus
   () )

; 
;  *  FNSProfileRemoveIndReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileRemoveIndReference" 
      ((iProfile :pointer) (iIndex :unsigned-long)) 
  :osstatus
   () )

; 
;  *  FNSProfileClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileClear" 
      ((iProfile :pointer)) 
  :osstatus
   () )

; 
;  *  FNSProfileCountReferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileCountReferences" 
      ((iProfile :pointer) (oCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSProfileGetIndReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileGetIndReference" 
      ((iProfile :pointer) (iWhichReference :unsigned-long) (oReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSProfileMatchReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSProfileMatchReference" 
      ((iProfile :pointer) (iReference :pointer) (iMatchOptions :unsigned-long) (iOutputSize :unsigned-long) (oIndices :pointer) (oNumMatches (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Mapping to and from Font Objects 
; 
;  *  FNSReferenceCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceCreate" 
      ((iFont :unsigned-long) (iDesiredVersion :unsigned-long) (oReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  FNSReferenceMatchFonts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceMatchFonts" 
      ((iReference :pointer) (iMatchOptions :unsigned-long) (iOutputSize :unsigned-long) (oFonts :pointer) (oNumMatches (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Mapping to and from Font Families 
; 
;  *  FNSReferenceCreateFromFamily()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceCreateFromFamily" 
      ((iFamily :signed-integer) (iStyle :signed-integer) (iDesiredVersion :unsigned-long) (oReference (:pointer :pointer)) (oActualStyle (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FNSReferenceMatchFamilies()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceMatchFamilies" 
      ((iReference :pointer) (iMatchOptions :unsigned-long) (iOutputSize :unsigned-long) (oFonts (:pointer :fmfontfamilyinstance)) (oNumMatches (:pointer :unsigned-long))) 
  :osstatus
   () )

;  UI Support 
; 
;  *  FNSReferenceGetFamilyInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceGetFamilyInfo" 
      ((iReference :pointer) (oFamilyName (:pointer (:string 255))) (oFamilyNameScript (:pointer :signed-integer)) (oActualStyle (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FNSReferenceCountNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceCountNames" 
      ((iReference :pointer) (oNameCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceGetIndName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceGetIndName" 
      ((iReference :pointer) (iFontNameIndex :unsigned-long) (iMaximumNameLength :unsigned-long) (oName :pointer) (oActualNameLength (:pointer :unsigned-long)) (oFontNameCode (:pointer :unsigned-long)) (oFontNamePlatform (:pointer :unsigned-long)) (oFontNameScript (:pointer :unsigned-long)) (oFontNameLanguage (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FNSReferenceFindName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSReferenceFindName" 
      ((iReference :pointer) (iFontNameCode :unsigned-long) (iFontNamePlatform :unsigned-long) (iFontNameScript :unsigned-long) (iFontNameLanguage :unsigned-long) (iMaximumNameLength :unsigned-long) (oName :pointer) (oActualNameLength (:pointer :unsigned-long)) (oFontNameIndex (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Miscellany 
; 
;  *  FNSEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontSyncLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FNSEnabled" 
      () 
  :boolean
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FontSyncIncludes

; $ENDC                                         ; __FONTSYNC__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'FontSync)