(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:HFSVolumes.p"
; at Wednesday May 1,2002 2:40:11 pm.
; 
;      File:       HFSVolumes.p
;  
;      Contains:   On-disk data structures for HFS and HFS Plus volumes.
;  
;      Version:    Technology: Mac OS 8.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1984-2001 by Apple Computer, Inc.  All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __HFSVOLUMES__
; $SETC __HFSVOLUMES__ := 1

; $I+
; $SETC HFSVolumesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FINDER__
|#

(require-interface 'Finder)
#|                                              ; $I Finder.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Signatures used to differentiate between HFS and HFS Plus volumes 

(defconstant $kHFSSigWord #x4244)               ;   'BD' in ASCII  
(defconstant $kHFSPlusSigWord #x482B)           ;   'H+' in ASCII  
(defconstant $kHFSPlusVersion #x4)              ;   will change as format changes (version 4 shipped with Mac OS 8.1)  
(defconstant $kHFSPlusMountVersion :|8.10|)     ;   will change as implementations change ('8.10' in Mac OS 8.1)  

; 	 CatalogNodeID is used to track catalog objects 	

(def-mactype :hfscatalognodeid (find-mactype ':unsigned-long))

(defconstant $kHFSMaxVolumeNameChars 27)
(defconstant $kHFSMaxFileNameChars 31)
(defconstant $kHFSPlusMaxFileNameChars 255)

; 	 Extent overflow file data structures 	
; 	 HFS Extent key 	

(def-mactype :hfsextentkeyptr (find-mactype '(:pointer :hfsextentkey)))
(defrecord HFSExtentKey 
   (keyLength :signed-byte)                     ;   length of key, excluding this field  
   (forkType :signed-byte)                      ;   0 = data fork, FF = resource fork  
   (fileID :unsigned-long)                      ;   file ID  
   (startBlock :unsigned-integer)               ;   first file allocation block number in this extent  
   )

; 	 HFS Plus Extent key 	
(def-mactype :hfsplusextentkeyptr (find-mactype '(:pointer :hfsplusextentkey)))
(defrecord HFSPlusExtentKey 
   (keyLength :unsigned-integer)                ;   length of key, excluding this field  
   (forkType :signed-byte)                      ;   0 = data fork, FF = resource fork  
   (pad :signed-byte)                           ;   make the other fields align on 32-bit boundary  
   (fileID :unsigned-long)                      ;   file ID  
   (startBlock :unsigned-long)                  ;   first file allocation block number in this extent  
   )

; 	 Number of extent descriptors per extent record 	

(defconstant $kHFSExtentDensity 3)
(defconstant $kHFSPlusExtentDensity 8)

; 	 HFS extent descriptor 	

(def-mactype :hfsextentdescriptorptr (find-mactype '(:pointer :hfsextentdescriptor)))
(defrecord HFSExtentDescriptor 
   (startBlock :unsigned-integer)               ;   first allocation block  
   (blockCount :unsigned-integer)               ;   number of allocation blocks  
   )

; 	 HFS Plus extent descriptor 	
(def-mactype :hfsplusextentdescriptorptr (find-mactype '(:pointer :hfsplusextentdescriptor)))
(defrecord HFSPlusExtentDescriptor 
   (startBlock :unsigned-long)                  ;   first allocation block  
   (blockCount :unsigned-long)                  ;   number of allocation blocks  
   )

; 	 HFS extent record 	
(defrecord HFSExtentRecord (array (:array :hfsextentdescriptor 3)))
; 	 HFS Plus extent record 	
(defrecord HFSPlusExtentRecord (array (:array :hfsplusextentdescriptor 8)))

; 	 Fork data info (HFS Plus only) - 80 bytes 	
(def-mactype :hfsplusforkdataptr (find-mactype '(:pointer :hfsplusforkdata)))
(defrecord HFSPlusForkData 
   (logicalSize :unsignedwide)                  ;   fork's logical size in bytes  
   (clumpSize :unsigned-long)                   ;   fork's clump size in bytes  
   (totalBlocks :unsigned-long)                 ;   total blocks used by this fork  
   (extents :hfsplusextentrecord)               ;   initial set of extents  
   )

; 	 Permissions info (HFS Plus only) - 16 bytes 	
(def-mactype :hfspluspermissionsptr (find-mactype '(:pointer :hfspluspermissions)))
(defrecord HFSPlusPermissions 
   (ownerID :unsigned-long)                     ;   user or group ID of file/folder owner  
   (groupID :unsigned-long)                     ;   additional user of group ID  
   (permissions :unsigned-long)                 ;   permissions (bytes: unused, owner, group, everyone)  
   (specialDevice :unsigned-long)               ;   UNIX: device for character or block special file  
   )

; 	 Catalog file data structures 	

(defconstant $kHFSRootParentID 1)               ;   Parent ID of the root folder  
(defconstant $kHFSRootFolderID 2)               ;   Folder ID of the root folder  
(defconstant $kHFSExtentsFileID 3)              ;   File ID of the extents file  
(defconstant $kHFSCatalogFileID 4)              ;   File ID of the catalog file  
(defconstant $kHFSBadBlockFileID 5)             ;   File ID of the bad allocation block file  
(defconstant $kHFSAllocationFileID 6)           ;   File ID of the allocation file (HFS Plus only)  
(defconstant $kHFSStartupFileID 7)              ;   File ID of the startup file (HFS Plus only)  
(defconstant $kHFSAttributesFileID 8)           ;   File ID of the attribute file (HFS Plus only)  
(defconstant $kHFSBogusExtentFileID 15)         ;   Used for exchanging extents in extents file  
(defconstant $kHFSFirstUserCatalogNodeID 16)

; 	 HFS catalog key 	

(def-mactype :hfscatalogkeyptr (find-mactype '(:pointer :hfscatalogkey)))
(defrecord HFSCatalogKey 
   (keyLength :signed-byte)                     ;   key length (in bytes)  
   (reserved :signed-byte)                      ;   reserved (set to zero)  
   (parentID :unsigned-long)                    ;   parent folder ID  
   (nodeName (:string 31))                      ;   catalog node name  
   )

; 	 HFS Plus catalog key 	
(def-mactype :hfspluscatalogkeyptr (find-mactype '(:pointer :hfspluscatalogkey)))
(defrecord HFSPlusCatalogKey 
   (keyLength :unsigned-integer)                ;   key length (in bytes)  
   (parentID :unsigned-long)                    ;   parent folder ID  
   (nodeName :hfsunistr255)                     ;   catalog node name  
   )

; 	 Catalog record types 	

;   HFS Catalog Records  
(defconstant $kHFSFolderRecord #x100)           ;   Folder record  
(defconstant $kHFSFileRecord #x200)             ;   File record  
(defconstant $kHFSFolderThreadRecord #x300)     ;   Folder thread record  
(defconstant $kHFSFileThreadRecord #x400)       ;   File thread record  
;   HFS Plus Catalog Records  
(defconstant $kHFSPlusFolderRecord 1)           ;   Folder record  
(defconstant $kHFSPlusFileRecord 2)             ;   File record  
(defconstant $kHFSPlusFolderThreadRecord 3)     ;   Folder thread record  
(defconstant $kHFSPlusFileThreadRecord 4)       ;   File thread record  

; 	 Catalog file record flags 	
(defconstant $kHFSFileLockedBit #x0)            ;   file is locked and cannot be written to  
(defconstant $kHFSFileLockedMask #x1)
(defconstant $kHFSThreadExistsBit #x1)          ;   a file thread record exists for this file  
(defconstant $kHFSThreadExistsMask #x2)

; 	 HFS catalog folder record - 70 bytes 	

(def-mactype :hfscatalogfolderptr (find-mactype '(:pointer :hfscatalogfolder)))
(defrecord HFSCatalogFolder 
   (recordType :signed-integer)                 ;   record type  
   (flags :unsigned-integer)                    ;   folder flags  
   (valence :unsigned-integer)                  ;   folder valence  
   (folderID :unsigned-long)                    ;   folder ID  
   (createDate :unsigned-long)                  ;   date and time of creation  
   (modifyDate :unsigned-long)                  ;   date and time of last modification  
   (backupDate :unsigned-long)                  ;   date and time of last backup  
   (userInfo :dinfo)                            ;   Finder information  
   (finderInfo :dxinfo)                         ;   additional Finder information  
   (reserved (:array :unsigned-long 4))         ;   reserved - set to zero  
   )

; 	 HFS Plus catalog folder record - 88 bytes 	
(def-mactype :hfspluscatalogfolderptr (find-mactype '(:pointer :hfspluscatalogfolder)))
(defrecord HFSPlusCatalogFolder 
   (recordType :signed-integer)                 ;   record type = HFS Plus folder record  
   (flags :unsigned-integer)                    ;   file flags  
   (valence :unsigned-long)                     ;   folder's valence (limited to 2^16 in Mac OS)  
   (folderID :unsigned-long)                    ;   folder ID  
   (createDate :unsigned-long)                  ;   date and time of creation  
   (contentModDate :unsigned-long)              ;   date and time of last content modification  
   (attributeModDate :unsigned-long)            ;   date and time of last attribute modification  
   (accessDate :unsigned-long)                  ;   date and time of last access (Rhapsody only)  
   (backupDate :unsigned-long)                  ;   date and time of last backup  
   (permissions :hfspluspermissions)            ;   permissions (for Rhapsody)  
   (userInfo :dinfo)                            ;   Finder information  
   (finderInfo :dxinfo)                         ;   additional Finder information  
   (textEncoding :unsigned-long)                ;   hint for name conversions  
   (reserved :unsigned-long)                    ;   reserved - set to zero  
   )

; 	 HFS catalog file record - 102 bytes 	
(def-mactype :hfscatalogfileptr (find-mactype '(:pointer :hfscatalogfile)))
(defrecord HFSCatalogFile 
   (recordType :signed-integer)                 ;   record type  
   (flags :signed-byte)                         ;   file flags  
   (fileType :signed-byte)                      ;   file type (unused ?)  
   (userInfo :finfo)                            ;   Finder information  
   (fileID :unsigned-long)                      ;   file ID  
   (dataStartBlock :unsigned-integer)           ;   not used - set to zero  
   (dataLogicalSize :signed-long)               ;   logical EOF of data fork  
   (dataPhysicalSize :signed-long)              ;   physical EOF of data fork  
   (rsrcStartBlock :unsigned-integer)           ;   not used - set to zero  
   (rsrcLogicalSize :signed-long)               ;   logical EOF of resource fork  
   (rsrcPhysicalSize :signed-long)              ;   physical EOF of resource fork  
   (createDate :unsigned-long)                  ;   date and time of creation  
   (modifyDate :unsigned-long)                  ;   date and time of last modification  
   (backupDate :unsigned-long)                  ;   date and time of last backup  
   (finderInfo :fxinfo)                         ;   additional Finder information  
   (clumpSize :unsigned-integer)                ;   file clump size (not used)  
   (dataExtents :hfsextentrecord)               ;   first data fork extent record  
   (rsrcExtents :hfsextentrecord)               ;   first resource fork extent record  
   (reserved :unsigned-long)                    ;   reserved - set to zero  
   )

; 	 HFS Plus catalog file record - 248 bytes 	
(def-mactype :hfspluscatalogfileptr (find-mactype '(:pointer :hfspluscatalogfile)))
(defrecord HFSPlusCatalogFile 
   (recordType :signed-integer)                 ;   record type = HFS Plus file record  
   (flags :unsigned-integer)                    ;   file flags  
   (reserved1 :unsigned-long)                   ;   reserved - set to zero  
   (fileID :unsigned-long)                      ;   file ID  
   (createDate :unsigned-long)                  ;   date and time of creation  
   (contentModDate :unsigned-long)              ;   date and time of last content modification  
   (attributeModDate :unsigned-long)            ;   date and time of last attribute modification  
   (accessDate :unsigned-long)                  ;   date and time of last access (Rhapsody only)  
   (backupDate :unsigned-long)                  ;   date and time of last backup  
   (permissions :hfspluspermissions)            ;   permissions (for Rhapsody)  
   (userInfo :finfo)                            ;   Finder information  
   (finderInfo :fxinfo)                         ;   additional Finder information  
   (textEncoding :unsigned-long)                ;   hint for name conversions  
   (reserved2 :unsigned-long)                   ;   reserved - set to zero  
;   start on double long (64 bit) boundry  
   (dataFork :hfsplusforkdata)                  ;   size and block data for data fork  
   (resourceFork :hfsplusforkdata)              ;   size and block data for resource fork  
   )

; 	 HFS catalog thread record - 46 bytes 	
(def-mactype :hfscatalogthreadptr (find-mactype '(:pointer :hfscatalogthread)))
(defrecord HFSCatalogThread 
   (recordType :signed-integer)                 ;   record type  
   (reserved (:array :signed-long 2))           ;   reserved - set to zero  
   (parentID :unsigned-long)                    ;   parent ID for this catalog node  
   (nodeName (:string 31))                      ;   name of this catalog node  
   )

; 	 HFS Plus catalog thread record -- 264 bytes 	
(def-mactype :hfspluscatalogthreadptr (find-mactype '(:pointer :hfspluscatalogthread)))
(defrecord HFSPlusCatalogThread 
   (recordType :signed-integer)                 ;   record type  
   (reserved :signed-integer)                   ;   reserved - set to zero  
   (parentID :unsigned-long)                    ;   parent ID for this catalog node  
   (nodeName :hfsunistr255)                     ;   name of this catalog node (variable length)  
   )

; 
; 	    These are the types of records in the attribute B-tree.  The values were chosen
; 	    so that they wouldn't conflict with the catalog record types.
; 	

(defconstant $kHFSPlusAttrInlineData #x10)      ;   if size <  kAttrOverflowSize  
(defconstant $kHFSPlusAttrForkData #x20)        ;   if size >= kAttrOverflowSize  
(defconstant $kHFSPlusAttrExtents #x30)         ;   overflow extents for large attributes  

; 
; 	    HFSPlusAttrInlineData
; 	    For small attributes, whose entire value is stored within this one
; 	    B-tree record.
; 	    There would not be any other records for this attribute.
; 	

(def-mactype :hfsplusattrinlinedataptr (find-mactype '(:pointer :hfsplusattrinlinedata)))
(defrecord HFSPlusAttrInlineData 
   (recordType :unsigned-long)                  ;      = kHFSPlusAttrInlineData 
   (reserved :unsigned-long)
   (logicalSize :unsigned-long)                 ;      size in bytes of userData 
   (userData (:array :unsigned-byte 2 :packed)) ;      variable length; space allocated is a multiple of 2 bytes 
   )

; 
; 	    HFSPlusAttrForkData
; 	    For larger attributes, whose value is stored in allocation blocks.
; 	    If the attribute has more than 8 extents, there will be additonal
; 	    records (of type HFSPlusAttrExtents) for this attribute.
; 	
(def-mactype :hfsplusattrforkdataptr (find-mactype '(:pointer :hfsplusattrforkdata)))
(defrecord HFSPlusAttrForkData 
   (recordType :unsigned-long)                  ;      = kHFSPlusAttrForkData 
   (reserved :unsigned-long)
   (theFork :hfsplusforkdata)                   ;      size and first extents of value 
   )

; 
; 	    HFSPlusAttrExtents
; 	    This record contains information about overflow extents for large,
; 	    fragmented attributes.
; 	
(def-mactype :hfsplusattrextentsptr (find-mactype '(:pointer :hfsplusattrextents)))
(defrecord HFSPlusAttrExtents 
   (recordType :unsigned-long)                  ;      = kHFSPlusAttrExtents 
   (reserved :unsigned-long)
   (extents :hfsplusextentrecord)               ;      additional extents 
   )

;    A generic Attribute Record 
(def-mactype :hfsplusattrrecordptr (find-mactype '(:pointer :hfsplusattrrecord)))
(defrecord HFSPlusAttrRecord 
   (:variant 
      (
      (recordType :unsigned-long)
      )
      (
      (inlineData :hfsplusattrinlinedata)
      )
      (
      (forkData :hfsplusattrforkdata)
      )
      (
      (overflowExtents :hfsplusattrextents)
      )
      )
   )

; 	 Key and node lengths 	

(defconstant $kHFSPlusExtentKeyMaximumLength 10)
(defconstant $kHFSExtentKeyMaximumLength 7)
(defconstant $kHFSPlusCatalogKeyMaximumLength 516)
(defconstant $kHFSPlusCatalogKeyMinimumLength 6)
(defconstant $kHFSCatalogKeyMaximumLength 37)
(defconstant $kHFSCatalogKeyMinimumLength 6)
(defconstant $kHFSPlusCatalogMinNodeSize 4096)
(defconstant $kHFSPlusExtentMinNodeSize 512)
(defconstant $kHFSPlusAttrMinNodeSize 4096)

; 	 HFS and HFS Plus volume attribute bits 	
;   Bits 0-6 are reserved (always cleared by MountVol call)  
(defconstant $kHFSVolumeHardwareLockBit 7)      ;   volume is locked by hardware  
(defconstant $kHFSVolumeUnmountedBit 8)         ;   volume was successfully unmounted  
(defconstant $kHFSVolumeSparedBlocksBit 9)      ;   volume has bad blocks spared  
(defconstant $kHFSVolumeNoCacheRequiredBit 10)  ;   don't cache volume blocks (i.e. RAM or ROM disk)  
(defconstant $kHFSBootVolumeInconsistentBit 11) ;   boot volume is inconsistent (System 7.6 and later)  
;   Bits 12-14 are reserved for future use  
(defconstant $kHFSVolumeSoftwareLockBit 15)     ;   volume is locked by software  
(defconstant $kHFSVolumeHardwareLockMask #x80)
(defconstant $kHFSVolumeUnmountedMask #x100)
(defconstant $kHFSVolumeSparedBlocksMask #x200)
(defconstant $kHFSVolumeNoCacheRequiredMask #x400)
(defconstant $kHFSBootVolumeInconsistentMask #x800)
(defconstant $kHFSVolumeSoftwareLockMask #x8000)
(defconstant $kHFSMDBAttributesMask #x8380)

(defconstant $kHFSCatalogNodeIDsReusedBit 12)   ;   nextCatalogID wrapped around  
(defconstant $kHFSCatalogNodeIDsReusedMask #x1000)

; 	 Master Directory Block (HFS only) - 162 bytes 	
; 	 Stored at sector #2 (3rd sector) 	

(def-mactype :hfsmasterdirectoryblockptr (find-mactype '(:pointer :hfsmasterdirectoryblock)))
(defrecord HFSMasterDirectoryBlock 
;   These first fields are also used by MFS  
   (drSigWord :unsigned-integer)                ;   volume signature  
   (drCrDate :unsigned-long)                    ;   date and time of volume creation  
   (drLsMod :unsigned-long)                     ;   date and time of last modification  
   (drAtrb :unsigned-integer)                   ;   volume attributes  
   (drNmFls :unsigned-integer)                  ;   number of files in root folder  
   (drVBMSt :unsigned-integer)                  ;   first block of volume bitmap  
   (drAllocPtr :unsigned-integer)               ;   start of next allocation search  
   (drNmAlBlks :unsigned-integer)               ;   number of allocation blocks in volume  
   (drAlBlkSiz :unsigned-long)                  ;   size (in bytes) of allocation blocks  
   (drClpSiz :unsigned-long)                    ;   default clump size  
   (drAlBlSt :unsigned-integer)                 ;   first allocation block in volume  
   (drNxtCNID :unsigned-long)                   ;   next unused catalog node ID  
   (drFreeBks :unsigned-integer)                ;   number of unused allocation blocks  
   (drVN (:string 27))                          ;   volume name  
;   Master Directory Block extensions for HFS  
   (drVolBkUp :unsigned-long)                   ;   date and time of last backup  
   (drVSeqNum :unsigned-integer)                ;   volume backup sequence number  
   (drWrCnt :unsigned-long)                     ;   volume write count  
   (drXTClpSiz :unsigned-long)                  ;   clump size for extents overflow file  
   (drCTClpSiz :unsigned-long)                  ;   clump size for catalog file  
   (drNmRtDirs :unsigned-integer)               ;   number of directories in root folder  
   (drFilCnt :unsigned-long)                    ;   number of files in volume  
   (drDirCnt :unsigned-long)                    ;   number of directories in volume  
   (drFndrInfo (:array :signed-long 8))         ;   information used by the Finder  
   (drEmbedSigWord :unsigned-integer)           ;   embedded volume signature (formerly drVCSize)  
   (drEmbedExtent :hfsextentdescriptor)         ;   embedded volume location and size (formerly drVBMCSize and drCtlCSize)  
   (drXTFlSize :unsigned-long)                  ;   size of extents overflow file  
   (drXTExtRec :hfsextentrecord)                ;   extent record for extents overflow file  
   (drCTFlSize :unsigned-long)                  ;   size of catalog file  
   (drCTExtRec :hfsextentrecord)                ;   extent record for catalog file  
   )

; 	 HFSPlusVolumeHeader (HFS Plus only) - 512 bytes 	
; 	 Stored at sector #2 (3rd sector) and second-to-last sector. 	
(def-mactype :hfsplusvolumeheaderptr (find-mactype '(:pointer :hfsplusvolumeheader)))
(defrecord HFSPlusVolumeHeader 
   (signature :unsigned-integer)                ;   volume signature == 'H+'  
   (version :unsigned-integer)                  ;   current version is kHFSPlusVersion  
   (attributes :unsigned-long)                  ;   volume attributes  
   (lastMountedVersion :unsigned-long)          ;   implementation version which last mounted volume  
   (reserved :unsigned-long)                    ;   reserved - set to zero  
   (createDate :unsigned-long)                  ;   date and time of volume creation  
   (modifyDate :unsigned-long)                  ;   date and time of last modification  
   (backupDate :unsigned-long)                  ;   date and time of last backup  
   (checkedDate :unsigned-long)                 ;   date and time of last disk check  
   (fileCount :unsigned-long)                   ;   number of files in volume  
   (folderCount :unsigned-long)                 ;   number of directories in volume  
   (blockSize :unsigned-long)                   ;   size (in bytes) of allocation blocks  
   (totalBlocks :unsigned-long)                 ;   number of allocation blocks in volume (includes this header and VBM 
   (freeBlocks :unsigned-long)                  ;   number of unused allocation blocks  
   (nextAllocation :unsigned-long)              ;   start of next allocation search  
   (rsrcClumpSize :unsigned-long)               ;   default resource fork clump size  
   (dataClumpSize :unsigned-long)               ;   default data fork clump size  
   (nextCatalogID :unsigned-long)               ;   next unused catalog node ID  
   (writeCount :unsigned-long)                  ;   volume write count  
   (encodingsBitmap :unsignedwide)              ;   which encodings have been use  on this volume  
   (finderInfo (:array :unsigned-byte 32 :packed));   information used by the Finder  
   (allocationFile :hfsplusforkdata)            ;   allocation bitmap file  
   (extentsFile :hfsplusforkdata)               ;   extents B-tree file  
   (catalogFile :hfsplusforkdata)               ;   catalog B-tree file  
   (attributesFile :hfsplusforkdata)            ;   extended attributes B-tree file  
   (startupFile :hfsplusforkdata)               ;   boot file  
   )

; 	 ---------- HFS and HFS Plus B-tree structures ---------- 	
; 	 BTNodeDescriptor -- Every B-tree node starts with these fields. 	
(def-mactype :btnodedescriptorptr (find-mactype '(:pointer :btnodedescriptor)))
(defrecord BTNodeDescriptor 
   (fLink :unsigned-long)                       ;      next node at this level 
   (bLink :unsigned-long)                       ;      previous node at this level 
   (kind :signed-byte)                          ;      kind of node (leaf, index, header, map) 
   (height :signed-byte)                        ;      zero for header, map; child is one more than parent 
   (numRecords :unsigned-integer)               ;      number of records in this node 
   (reserved :unsigned-integer)                 ;      reserved; set to zero 
   )

; 	 Constants for BTNodeDescriptor kind 	

(defconstant $kBTLeafNode -1)
(defconstant $kBTIndexNode 0)
(defconstant $kBTHeaderNode 1)
(defconstant $kBTMapNode 2)

; 	 BTHeaderRec -- The first record of a B-tree header node 	

(def-mactype :btheaderrecptr (find-mactype '(:pointer :btheaderrec)))
(defrecord BTHeaderRec 
   (treeDepth :unsigned-integer)                ;      maximum height (usually leaf nodes) 
   (rootNode :unsigned-long)                    ;      node number of root node 
   (leafRecords :unsigned-long)                 ;      number of leaf records in all leaf nodes 
   (firstLeafNode :unsigned-long)               ;      node number of first leaf node 
   (lastLeafNode :unsigned-long)                ;      node number of last leaf node 
   (nodeSize :unsigned-integer)                 ;      size of a node, in bytes 
   (maxKeyLength :unsigned-integer)             ;      reserved 
   (totalNodes :unsigned-long)                  ;      total number of nodes in tree 
   (freeNodes :unsigned-long)                   ;      number of unused (free) nodes in tree 
   (reserved1 :unsigned-integer)                ;      unused 
   (clumpSize :unsigned-long)                   ;      reserved 
   (btreeType :signed-byte)                     ;      reserved 
   (reserved2 :signed-byte)                     ;      reserved 
   (attributes :unsigned-long)                  ;      persistent attributes about the tree 
   (reserved3 (:array :unsigned-long 16))       ;      reserved 
   )

; 	 Constants for BTHeaderRec attributes 	

(defconstant $kBTBadCloseMask #x1)              ;      reserved 
(defconstant $kBTBigKeysMask #x2)               ;      key length field is 16 bits 
(defconstant $kBTVariableIndexKeysMask #x4)     ;      keys in index nodes are variable length 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := HFSVolumesIncludes

; $ENDC                                         ; __HFSVOLUMES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'HFSVolumes)