(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:HID.p"
; at Wednesday May 1,2002 2:41:38 pm.
; 
;      File:       HID.p
;  
;      Contains:   Definition of the interfaces to the HIDLib shared library and
;  
;      Version:    Technology: HID 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __HID__
; $SETC __HID__ := 1

; $I+
; $SETC HIDIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    
;     Interfaces for HIDLib
; 

;   types of HID reports (input, output, feature) 

(defconstant $kHIDInputReport 1)
(defconstant $kHIDOutputReport 2)
(defconstant $kHIDFeatureReport 3)
(defconstant $kHIDUnknownReport 255)

;   constants used in HIDButtonCapabilities and HIDValueCapabilities structures 
;   While HIDButtonCaps and HIDValueCaps have no version #, they can be 
;   thought of as version 1 of HIDButtonCapabilities and HIDValueCapabilities. 
(defconstant $kHIDCurrentCapabilitiesPBVersion 2)

;   flags passed to HIDOpenReportDescriptor 
(defconstant $kHIDFlag_StrictErrorChecking #x1)

(def-mactype :hidreporttype (find-mactype ':unsigned-long))
(def-mactype :hidusage (find-mactype ':unsigned-long))
(def-mactype :hidpreparseddataref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :hidpreparseddatarefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:HIDPreparsedDataRef parameter can be nil, it is changed to xx: HIDPreparsedDataRefPtr 
(def-mactype :hidusageandpageptr (find-mactype '(:pointer :hidusageandpage)))
(defrecord HIDUsageAndPage 
   (usage :unsigned-long)
   (usagePage :unsigned-long)
   )

(def-mactype :hidcapsptr (find-mactype '(:pointer :hidcaps)))
(defrecord HIDCaps 
   (usage :unsigned-long)
   (usagePage :unsigned-long)
   (inputReportByteLength :unsigned-long)
   (outputReportByteLength :unsigned-long)
   (featureReportByteLength :unsigned-long)
   (numberCollectionNodes :unsigned-long)
   (numberInputButtonCaps :unsigned-long)
   (numberInputValueCaps :unsigned-long)
   (numberOutputButtonCaps :unsigned-long)
   (numberOutputValueCaps :unsigned-long)
   (numberFeatureButtonCaps :unsigned-long)
   (numberFeatureValueCaps :unsigned-long)
   )

(def-mactype :hidcapabilitiesptr (find-mactype '(:pointer :hidcapabilities)))
(defrecord HIDCapabilities 
   (usage :unsigned-long)
   (usagePage :unsigned-long)
   (inputReportByteLength :unsigned-long)
   (outputReportByteLength :unsigned-long)
   (featureReportByteLength :unsigned-long)
   (numberCollectionNodes :unsigned-long)
   (numberInputButtonCaps :unsigned-long)
   (numberInputValueCaps :unsigned-long)
   (numberOutputButtonCaps :unsigned-long)
   (numberOutputValueCaps :unsigned-long)
   (numberFeatureButtonCaps :unsigned-long)
   (numberFeatureValueCaps :unsigned-long)
   )

(def-mactype :hidcollectionnodeptr (find-mactype '(:pointer :hidcollectionnode)))
(defrecord HIDCollectionNode 
   (collectionUsage :unsigned-long)
   (collectionUsagePage :unsigned-long)
   (parent :unsigned-long)
   (numberOfChildren :unsigned-long)
   (nextSibling :unsigned-long)
   (firstChild :unsigned-long)
   )

(def-mactype :hidbuttoncapsptr (find-mactype '(:pointer :hidbuttoncaps)))
(defrecord HIDButtonCaps 
   (usagePage :unsigned-long)
   (reportID :unsigned-long)
   (bitField :unsigned-long)
   (collection :unsigned-long)
   (collectionUsage :unsigned-long)
   (collectionUsagePage :unsigned-long)
   (isRange :boolean)
   (isStringRange :boolean)
   (isDesignatorRange :boolean)
   (isAbsolute :boolean)
   (:variant 
      (
      (usageMin :unsigned-long)
      (usageMax :unsigned-long)
      (stringMin :unsigned-long)
      (stringMax :unsigned-long)
      (designatorMin :unsigned-long)
      (designatorMax :unsigned-long)
      )
      (
      (usage :unsigned-long)
      (reserved1 :unsigned-long)
      (stringIndex :unsigned-long)
      (reserved2 :unsigned-long)
      (designatorIndex :unsigned-long)
      (reserved3 :unsigned-long)
      )
      )
   )

(def-mactype :hidbuttoncapabilitiesptr (find-mactype '(:pointer :hidbuttoncapabilities)))
(defrecord HIDButtonCapabilities 
   (usagePage :unsigned-long)
   (reportID :unsigned-long)
   (bitField :unsigned-long)
   (collection :unsigned-long)
   (collectionUsage :unsigned-long)
   (collectionUsagePage :unsigned-long)
   (isRange :boolean)
   (isStringRange :boolean)
   (isDesignatorRange :boolean)
   (isAbsolute :boolean)
   (unitExponent :signed-long)
   (units :signed-long)
   (reserved :unsigned-long)
   (pbVersion :unsigned-long)
   (:variant 
      (
      (usageMin :unsigned-long)
      (usageMax :unsigned-long)
      (stringMin :unsigned-long)
      (stringMax :unsigned-long)
      (designatorMin :unsigned-long)
      (designatorMax :unsigned-long)
      )
      (
      (usage :unsigned-long)
      (reserved1 :unsigned-long)
      (stringIndex :unsigned-long)
      (reserved2 :unsigned-long)
      (designatorIndex :unsigned-long)
      (reserved3 :unsigned-long)
      )
      )
   )

(def-mactype :hidvaluecapsptr (find-mactype '(:pointer :hidvaluecaps)))
(defrecord HIDValueCaps 
   (usagePage :unsigned-long)
   (reportID :unsigned-long)
   (bitField :unsigned-long)
   (collection :unsigned-long)
   (collectionUsage :unsigned-long)
   (collectionUsagePage :unsigned-long)
   (isRange :boolean)
   (isStringRange :boolean)
   (isDesignatorRange :boolean)
   (isAbsolute :boolean)
   (bitSize :unsigned-long)
   (reportCount :unsigned-long)
   (logicalMin :signed-long)
   (logicalMax :signed-long)
   (physicalMin :signed-long)
   (physicalMax :signed-long)
   (:variant 
      (
      (usageMin :unsigned-long)
      (usageMax :unsigned-long)
      (stringMin :unsigned-long)
      (stringMax :unsigned-long)
      (designatorMin :unsigned-long)
      (designatorMax :unsigned-long)
      )
      (
      (usage :unsigned-long)
      (reserved1 :unsigned-long)
      (stringIndex :unsigned-long)
      (reserved2 :unsigned-long)
      (designatorIndex :unsigned-long)
      (reserved3 :unsigned-long)
      )
      )
   )

(def-mactype :hidvaluecapabilitiesptr (find-mactype '(:pointer :hidvaluecapabilities)))
(defrecord HIDValueCapabilities 
   (usagePage :unsigned-long)
   (reportID :unsigned-long)
   (bitField :unsigned-long)
   (collection :unsigned-long)
   (collectionUsage :unsigned-long)
   (collectionUsagePage :unsigned-long)
   (isRange :boolean)
   (isStringRange :boolean)
   (isDesignatorRange :boolean)
   (isAbsolute :boolean)
   (bitSize :unsigned-long)
   (reportCount :unsigned-long)
   (logicalMin :signed-long)
   (logicalMax :signed-long)
   (physicalMin :signed-long)
   (physicalMax :signed-long)
   (unitExponent :signed-long)
   (units :signed-long)
   (reserved :unsigned-long)
   (pbVersion :unsigned-long)
   (:variant 
      (
      (usageMin :unsigned-long)
      (usageMax :unsigned-long)
      (stringMin :unsigned-long)
      (stringMax :unsigned-long)
      (designatorMin :unsigned-long)
      (designatorMax :unsigned-long)
      )
      (
      (usage :unsigned-long)
      (reserved1 :unsigned-long)
      (stringIndex :unsigned-long)
      (reserved2 :unsigned-long)
      (designatorIndex :unsigned-long)
      (reserved3 :unsigned-long)
      )
      )
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  HIDGetHIDLibVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_HIDGetHIDLibVersion" 
      () 
  :unsigned-long
   () )

; 
;  *  HIDOpenReportDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDOpenReportDescriptor" 
      ((hidReportDescriptor :pointer) (descriptorLength :unsigned-long) (preparsedDataRef (:pointer :pointer)) (flags :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDCloseReportDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDCloseReportDescriptor" 
      ((preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetCaps" 
      ((preparsedDataRef :pointer) (capabilities (:pointer :hidcaps))) 
  :osstatus
   () )

; 
;  *  HIDGetCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetCapabilities" 
      ((preparsedDataRef :pointer) (capabilities (:pointer :hidcapabilities))) 
  :osstatus
   () )

; 
;  *  HIDGetCollectionNodes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetCollectionNodes" 
      ((collectionNodes (:pointer :hidcollectionnode)) (collectionNodesSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetButtonCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetButtonCaps" 
      ((reportType :unsigned-long) (buttonCaps (:pointer :hidbuttoncaps)) (buttonCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetButtonCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetButtonCapabilities" 
      ((reportType :unsigned-long) (buttonCaps (:pointer :hidbuttoncapabilities)) (buttonCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetValueCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetValueCaps" 
      ((reportType :unsigned-long) (valueCaps (:pointer :hidvaluecaps)) (valueCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetValueCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetValueCapabilities" 
      ((reportType :unsigned-long) (valueCaps (:pointer :hidvaluecapabilities)) (valueCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetSpecificButtonCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetSpecificButtonCaps" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (buttonCaps (:pointer :hidbuttoncaps)) (buttonCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetSpecificButtonCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetSpecificButtonCapabilities" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (buttonCaps (:pointer :hidbuttoncapabilities)) (buttonCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetSpecificValueCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetSpecificValueCaps" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (valueCaps (:pointer :hidvaluecaps)) (valueCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetSpecificValueCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetSpecificValueCapabilities" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (valueCaps (:pointer :hidvaluecapabilities)) (valueCapsSize (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetNextButtonInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetNextButtonInfo" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (usage :unsigned-long) (collection (:pointer :unsigned-long)) (reportID (:pointer :unsigned-byte)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDGetNextUsageValueInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetNextUsageValueInfo" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (usage :unsigned-long) (collection (:pointer :unsigned-long)) (reportID (:pointer :unsigned-byte)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDMaxUsageListLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDMaxUsageListLength" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (preparsedDataRef :pointer)) 
  :unsigned-long
   () )

; 
;  *  HIDGetReportLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetReportLength" 
      ((reportType :unsigned-long) (reportID :signed-byte) (reportLength (:pointer :unsigned-long)) (preparsedDataRef :pointer)) 
  :osstatus
   () )

; 
;  *  HIDInitReport()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDInitReport" 
      ((reportType :unsigned-long) (reportID :signed-byte) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDGetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetButtons" 
      ((reportType :unsigned-long) (collection :unsigned-long) (usageList (:pointer :hidusageandpage)) (usageListSize (:pointer :unsigned-long)) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDGetButtonsOnPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetButtonsOnPage" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usageList (:pointer :unsigned-long)) (usageListSize (:pointer :unsigned-long)) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDGetScaledUsageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetScaledUsageValue" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValue (:pointer :signed-long)) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDGetUsageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetUsageValue" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValue (:pointer :signed-long)) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDGetUsageValueArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDGetUsageValueArray" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValueBuffer (:pointer :unsigned-byte)) (usageValueBufferSize :unsigned-long) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDSetButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDSetButton" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDSetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDSetButtons" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usageList (:pointer :unsigned-long)) (usageListSize (:pointer :unsigned-long)) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDSetScaledUsageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDSetScaledUsageValue" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValue :signed-long) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDSetUsageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDSetUsageValue" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValue :signed-long) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDSetUsageValueArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDSetUsageValueArray" 
      ((reportType :unsigned-long) (usagePage :unsigned-long) (collection :unsigned-long) (usage :unsigned-long) (usageValueBuffer (:pointer :unsigned-byte)) (usageValueBufferLength :unsigned-long) (preparsedDataRef :pointer) (report :pointer) (reportLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDUsageListDifference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HIDLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDUsageListDifference" 
      ((previousUsageList (:pointer :unsigned-long)) (currentUsageList (:pointer :unsigned-long)) (breakUsageList (:pointer :unsigned-long)) (makeUsageList (:pointer :unsigned-long)) (usageListsSize :unsigned-long)) 
  :osstatus
   () )

; 
;    
;     Interfaces for a HID device driver
; 

;   these are the constants to be passed to HIDGetDeviceInfo 
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kHIDGetInfo_VendorID 1)
(defconstant $kHIDGetInfo_ProductID 2)
(defconstant $kHIDGetInfo_VersionNumber 3)
(defconstant $kHIDGetInfo_InterfaceRef 4)
(defconstant $kHIDGetInfo_MaxReportSize #x10)
(defconstant $kHIDGetInfo_GetManufacturerString #x100)
(defconstant $kHIDGetInfo_GetProductString #x101)
(defconstant $kHIDGetInfo_GetSerialNumberString #x102)
(defconstant $kHIDGetInfo_VendorSpecificStart #x10000)

;   these are the valid permissions to pass to HIDOpenDevice 
(defconstant $kHIDPerm_ReadOnly #x1)
(defconstant $kHIDPerm_ReadWriteShared #x3)
(defconstant $kHIDPerm_ReadWriteExclusive #x13)

;   these are flags used in HIDInstallReportHandler 
(defconstant $kHIDFlag_CallbackIsResident #x1)

;   these are the constants to be passed to HIDControlDevice 
(defconstant $kHIDVendorSpecificControlStart #x10000)

;   these constant versions are used in the HIDDeviceDispatchTable structure 
(defconstant $kHIDCurrentDispatchTableVersion 3)
(defconstant $kHIDOldestCompatableDispatchTableVersion 1)
(defconstant $kHIDDispatchTableVersion1 1)
(defconstant $kHIDDispatchTableVersion2 2)
(defconstant $kHIDDispatchTableVersion1OldestCompatible 1)

(def-mactype :hiddeviceconnectionref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :hiddeviceconnectionrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:HIDDeviceConnectionRef parameter can be nil, it is changed to xx: HIDDeviceConnectionRefPtr 
;   HIDGetDeviceInfo is used to get specific information about a HID Device 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDGetDeviceInfoProcPtr = FUNCTION(inInfoSelector: UInt32; outInfo: UNIV Ptr; VAR ioSize: ByteCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidgetdeviceinfoprocptr (find-mactype ':pointer))
; $ENDC

;   HIDGetHIDDescriptor is used to get a specific HID descriptor from a HID device (such as a report descriptor) 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDGetHIDDescriptorProcPtr = FUNCTION(inDescriptorType: UInt32; inDescriptorIndex: UInt32; outDescriptor: UNIV Ptr; VAR ioBufferSize: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidgethiddescriptorprocptr (find-mactype ':pointer))
; $ENDC

;   You must first 'open' a device before using it 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDOpenDeviceProcPtr = FUNCTION(VAR outConnectionRef: HIDDeviceConnectionRef; permissions: UInt32; reserved: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidopendeviceprocptr (find-mactype ':pointer))
; $ENDC

;   When finished, 'close' a device 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDCloseDeviceProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidclosedeviceprocptr (find-mactype ':pointer))
; $ENDC

;   User provided ProcPtr to be called when HID report is received 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDReportHandlerProcPtr = PROCEDURE(inHIDReport: UNIV Ptr; inHIDReportLength: UInt32; inRefcon: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidreporthandlerprocptr (find-mactype ':pointer))
; $ENDC

;   User provided ProcPtr to be called when indexed string is received 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDStringHandlerProcPtr = PROCEDURE(inHIDReport: UNIV Ptr; inHIDReportLength: UInt32; inRefcon: UInt32; inStatus: OSStatus); C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidstringhandlerprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   When installed, a report handler is called at defered task time (unless kHIDFlag_CallbackIsResident is passed) 
; 	   whenever an interrupt packet is recieved on the first interrupt in pipe. The supplied refcon is also passed thru.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDInstallReportHandlerProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; flags: UInt32; inReportHandlerProc: HIDReportHandlerProcPtr; inRefcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidinstallreporthandlerprocptr (find-mactype ':pointer))
; $ENDC

;   When finished, remove the report handler. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDRemoveReportHandlerProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidremovereporthandlerprocptr (find-mactype ':pointer))
; $ENDC

;   If there was a HIDReportHandler installed previous to the one from this connection, pass that one this report 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDCallPreviousReportHandlerProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inHIDReport: UNIV Ptr; inHIDReportLength: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidcallpreviousreporthandlerprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   HIDGetReport is used to get a report (of type input, output, or feature) directly from a HID device
; 	   the HIDReportHandler will be called with the report when it is received.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDGetReportProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inReportType: UInt32; inReportID: UInt32; inReportHandlerProc: HIDReportHandlerProcPtr; inRefcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidgetreportprocptr (find-mactype ':pointer))
; $ENDC

;   HIDGetSizedReport is used like HIDGetReport, but for devices that require exact size to return report. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDGetSizedReportProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inReportType: UInt32; inReportID: UInt32; inSize: ByteCount; inReportHandlerProc: HIDReportHandlerProcPtr; inRefcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidgetsizedreportprocptr (find-mactype ':pointer))
; $ENDC

;   HIDSetReport is used to send a report (of type input, output, or feature) directly to a HID device 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDSetReportProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inReportType: UInt32; inReportID: UInt32; inInfo: UNIV Ptr; inSize: ByteCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidsetreportprocptr (find-mactype ':pointer))
; $ENDC

;   HIDControlDevice is used to send misc control messages to a device 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDControlDeviceProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inControlSelector: UInt32; ioControlData: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidcontroldeviceprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   HIDGetIndexedString is used to get a string directly from a HID device.
; 	   The HIDStringHandler will be called with the string when it is received or nil string if completed with an error.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDGetIndexedStringProcPtr = FUNCTION(inConnectionRef: HIDDeviceConnectionRef; inStringIndex: UInt32; inStringLanguage: UInt32; inStringHandlerProc: HIDStringHandlerProcPtr; inRefcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidgetindexedstringprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   dispatchTableCurrentVersion is kHIDCurrentDispatchTableVersion
; 	   dispatchTableOldestVersion is kHIDOldestCompatableDispatchTableVersion
; 	        (the oldest built client using this API that this HID device driver will work with)
; 	   vendorID is who wrote this HID device driver (hi word of 0 and USB vendorID is valid)
; 	
(def-mactype :hiddevicedispatchtableptr (find-mactype '(:pointer :hiddevicedispatchtable)))
(defrecord HIDDeviceDispatchTable 
   (dispatchTableCurrentVersion :unsigned-long)
   (dispatchTableOldestVersion :unsigned-long)
   (vendorID :unsigned-long)
   (vendorSpecific :unsigned-long)
   (reserved :unsigned-long)
   (pHIDGetDeviceInfo :pointer)
   (pHIDGetHIDDescriptor :pointer)
   (pHIDOpenDevice :pointer)
   (pHIDCloseDevice :pointer)
   (pHIDInstallReportHandler :pointer)
   (pHIDRemoveReportHandler :pointer)
   (pHIDCallPreviousReportHandler :pointer)
   (pHIDGetReport :pointer)                     ;   new for vers 2, was reserved in version 1 
   (pHIDSetReport :pointer)                     ;   new for vers 2, was reserved in version 1 
   (pHIDControlDevice :pointer)
   (pHIDGetIndexedString :pointer)              ;   new for vers 3 
   (pHIDGetSizedReport :pointer)                ;   new for vers 3 
   )

; 	 A USB HIDDevice driver should export a HIDDeviceDispatchTable symbol 	
; 	 in it's PEF container, with the name "\pTheHIDDeviceDispatchTable" 	

; 	 ****************************************************************************************** 	
; 	 HID Usage Tables                                                                           	
; 	                                                                                            	
; 	 The following constants are from the USB 'HID Usage Tables' specification, revision 1.1rc3 	
; 	 ****************************************************************************************** 	

; 	 Usage Pages 	

(defconstant $kHIDPage_Undefined #x0)
(defconstant $kHIDPage_GenericDesktop #x1)
(defconstant $kHIDPage_Simulation #x2)
(defconstant $kHIDPage_VR #x3)
(defconstant $kHIDPage_Sport #x4)
(defconstant $kHIDPage_Game #x5)                ;   Reserved 0x06  
(defconstant $kHIDPage_KeyboardOrKeypad #x7)    ;   USB Device Class Definition for Human Interface Devices (HID). Note: the usage type for all key codes is Selector (Sel).  
(defconstant $kHIDPage_LEDs #x8)
(defconstant $kHIDPage_Button #x9)
(defconstant $kHIDPage_Ordinal #xA)
(defconstant $kHIDPage_Telephony #xB)
(defconstant $kHIDPage_Consumer #xC)
(defconstant $kHIDPage_Digitizer #xD)           ;   Reserved 0x0E  
(defconstant $kHIDPage_PID #xF)                 ;   USB Physical Interface Device definitions for force feedback and related devices.  
(defconstant $kHIDPage_Unicode #x10)            ;   Reserved 0x11 - 0x13  
(defconstant $kHIDPage_AlphanumericDisplay #x14);   Reserved 0x15 - 0x7F  
;   Monitor 0x80 - 0x83     USB Device Class Definition for Monitor Devices  
;   Power 0x84 - 0x87   USB Device Class Definition for Power Devices  
;   Reserved 0x88 - 0x8B  
(defconstant $kHIDPage_BarCodeScanner #x8C)     ;   (Point of Sale) USB Device Class Definition for Bar Code Scanner Devices  
(defconstant $kHIDPage_Scale #x8D)              ;   (Point of Sale) USB Device Class Definition for Scale Devices  
;   ReservedPointofSalepages 0x8E - 0x8F  
(defconstant $kHIDPage_CameraControl #x90)      ;   USB Device Class Definition for Image Class Devices  
(defconstant $kHIDPage_Arcade #x91)             ;   OAAF Definitions for arcade and coinop related Devices  
;   Reserved 0x92 - 0xFEFF  
;   VendorDefined 0xFF00 - 0xFFFF  
(defconstant $kHIDPage_VendorDefinedStart #xFF00)

; 	 Undefined Usage for all usage pages 	
(defconstant $kHIDUsage_Undefined #x0)

; 	 GenericDesktop Page (0x01) 	
(defconstant $kHIDUsage_GD_Pointer #x1)         ;   Physical Collection  
(defconstant $kHIDUsage_GD_Mouse #x2)           ;   Application Collection  
;   0x03 Reserved  
(defconstant $kHIDUsage_GD_Joystick #x4)        ;   Application Collection  
(defconstant $kHIDUsage_GD_GamePad #x5)         ;   Application Collection  
(defconstant $kHIDUsage_GD_Keyboard #x6)        ;   Application Collection  
(defconstant $kHIDUsage_GD_Keypad #x7)          ;   Application Collection  
(defconstant $kHIDUsage_GD_MultiAxisController #x8);   Application Collection  
;   0x09 - 0x2F Reserved  
(defconstant $kHIDUsage_GD_X #x30)              ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Y #x31)              ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Z #x32)              ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Rx #x33)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Ry #x34)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Rz #x35)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Slider #x36)         ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Dial #x37)           ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Wheel #x38)          ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Hatswitch #x39)      ;   Dynamic Value  
(defconstant $kHIDUsage_GD_CountedBuffer #x3A)  ;   Logical Collection  
(defconstant $kHIDUsage_GD_ByteCount #x3B)      ;   Dynamic Value  
(defconstant $kHIDUsage_GD_MotionWakeup #x3C)   ;   One-Shot Control  
(defconstant $kHIDUsage_GD_Start #x3D)          ;   On/Off Control  
(defconstant $kHIDUsage_GD_Select #x3E)         ;   On/Off Control  
;   0x3F Reserved  
(defconstant $kHIDUsage_GD_Vx #x40)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vy #x41)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vz #x42)             ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vbrx #x43)           ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vbry #x44)           ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vbrz #x45)           ;   Dynamic Value  
(defconstant $kHIDUsage_GD_Vno #x46)            ;   Dynamic Value  
;   0x47 - 0x7F Reserved  
(defconstant $kHIDUsage_GD_SystemControl #x80)  ;   Application Collection  
(defconstant $kHIDUsage_GD_SystemPowerDown #x81);   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemSleep #x82)    ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemWakeUp #x83)   ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemContextMenu #x84);   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemMainMenu #x85) ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemAppMenu #x86)  ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemMenuHelp #x87) ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemMenuExit #x88) ;   One-Shot Control  
(defconstant $kHIDUsage_GD_SystemMenu #x89)     ;   Selector  
(defconstant $kHIDUsage_GD_SystemMenuRight #x8A);   Re-Trigger Control  
(defconstant $kHIDUsage_GD_SystemMenuLeft #x8B) ;   Re-Trigger Control  
(defconstant $kHIDUsage_GD_SystemMenuUp #x8C)   ;   Re-Trigger Control  
(defconstant $kHIDUsage_GD_SystemMenuDown #x8D) ;   Re-Trigger Control  
;   0x8E - 0x8F Reserved  
(defconstant $kHIDUsage_GD_DPadUp #x90)         ;   On/Off Control  
(defconstant $kHIDUsage_GD_DPadDown #x91)       ;   On/Off Control  
(defconstant $kHIDUsage_GD_DPadRight #x92)      ;   On/Off Control  
(defconstant $kHIDUsage_GD_DPadLeft #x93)       ;   On/Off Control  
;   0x94 - 0xFFFF Reserved  
(defconstant $kHIDUsage_GD_Reserved #xFFFF)

; 	 Simulation Page (0x02) 	
; 	 This section provides detailed descriptions of the usages employed by simulation devices. 	
(defconstant $kHIDUsage_Sim_FlightSimulationDevice #x1);   Application Collection  
(defconstant $kHIDUsage_Sim_AutomobileSimulationDevice #x2);   Application Collection  
(defconstant $kHIDUsage_Sim_TankSimulationDevice #x3);   Application Collection  
(defconstant $kHIDUsage_Sim_SpaceshipSimulationDevice #x4);   Application Collection  
(defconstant $kHIDUsage_Sim_SubmarineSimulationDevice #x5);   Application Collection  
(defconstant $kHIDUsage_Sim_SailingSimulationDevice #x6);   Application Collection  
(defconstant $kHIDUsage_Sim_MotorcycleSimulationDevice #x7);   Application Collection  
(defconstant $kHIDUsage_Sim_SportsSimulationDevice #x8);   Application Collection  
(defconstant $kHIDUsage_Sim_AirplaneSimulationDevice #x9);   Application Collection  
(defconstant $kHIDUsage_Sim_HelicopterSimulationDevice #xA);   Application Collection  
(defconstant $kHIDUsage_Sim_MagicCarpetSimulationDevice #xB);   Application Collection  
(defconstant $kHIDUsage_Sim_BicycleSimulationDevice #xC);   Application Collection  
;   0x0D - 0x1F Reserved  
(defconstant $kHIDUsage_Sim_FlightControlStick #x20);   Application Collection  
(defconstant $kHIDUsage_Sim_FlightStick #x21)   ;   Application Collection  
(defconstant $kHIDUsage_Sim_CyclicControl #x22) ;   Physical Collection  
(defconstant $kHIDUsage_Sim_CyclicTrim #x23)    ;   Physical Collection  
(defconstant $kHIDUsage_Sim_FlightYoke #x24)    ;   Application Collection  
(defconstant $kHIDUsage_Sim_TrackControl #x25)  ;   Physical Collection  
;   0x26 - 0xAF Reserved  
(defconstant $kHIDUsage_Sim_Aileron #xB0)       ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_AileronTrim #xB1)   ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_AntiTorqueControl #xB2);   Dynamic Value  
(defconstant $kHIDUsage_Sim_AutopilotEnable #xB3);   On/Off Control  
(defconstant $kHIDUsage_Sim_ChaffRelease #xB4)  ;   One-Shot Control  
(defconstant $kHIDUsage_Sim_CollectiveControl #xB5);   Dynamic Value  
(defconstant $kHIDUsage_Sim_DiveBrake #xB6)     ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_ElectronicCountermeasures #xB7);   On/Off Control  
(defconstant $kHIDUsage_Sim_Elevator #xB8)      ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_ElevatorTrim #xB9)  ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Rudder #xBA)        ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Throttle #xBB)      ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_FlightCommunications #xBC);   On/Off Control  
(defconstant $kHIDUsage_Sim_FlareRelease #xBD)  ;   One-Shot Control  
(defconstant $kHIDUsage_Sim_LandingGear #xBE)   ;   On/Off Control  
(defconstant $kHIDUsage_Sim_ToeBrake #xBF)      ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Trigger #xC0)       ;   Momentary Control  
(defconstant $kHIDUsage_Sim_WeaponsArm #xC1)    ;   On/Off Control  
(defconstant $kHIDUsage_Sim_Weapons #xC2)       ;   Selector  
(defconstant $kHIDUsage_Sim_WingFlaps #xC3)     ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Accelerator #xC4)   ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Brake #xC5)         ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Clutch #xC6)        ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Shifter #xC7)       ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Steering #xC8)      ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_TurretDirection #xC9);   Dynamic Value  
(defconstant $kHIDUsage_Sim_BarrelElevation #xCA);   Dynamic Value  
(defconstant $kHIDUsage_Sim_DivePlane #xCB)     ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_Ballast #xCC)       ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_BicycleCrank #xCD)  ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_HandleBars #xCE)    ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_FrontBrake #xCF)    ;   Dynamic Value  
(defconstant $kHIDUsage_Sim_RearBrake #xD0)     ;   Dynamic Value  
;   0xD1 - 0xFFFF Reserved  
(defconstant $kHIDUsage_Sim_Reserved #xFFFF)

; 	 VR Page (0x03) 	
; 	 Virtual Reality controls depend on designators to identify the individual controls. Most of the following are 	
; 	 usages are applied to the collections of entities that comprise the actual device. 	
(defconstant $kHIDUsage_VR_Belt #x1)            ;   Application Collection  
(defconstant $kHIDUsage_VR_BodySuit #x2)        ;   Application Collection  
(defconstant $kHIDUsage_VR_Flexor #x3)          ;   Physical Collection  
(defconstant $kHIDUsage_VR_Glove #x4)           ;   Application Collection  
(defconstant $kHIDUsage_VR_HeadTracker #x5)     ;   Physical Collection  
(defconstant $kHIDUsage_VR_HeadMountedDisplay #x6);   Application Collection  
(defconstant $kHIDUsage_VR_HandTracker #x7)     ;   Application Collection  
(defconstant $kHIDUsage_VR_Oculometer #x8)      ;   Application Collection  
(defconstant $kHIDUsage_VR_Vest #x9)            ;   Application Collection  
(defconstant $kHIDUsage_VR_AnimatronicDevice #xA);   Application Collection  
;   0x0B - 0x1F Reserved  
(defconstant $kHIDUsage_VR_StereoEnable #x20)   ;   On/Off Control  
(defconstant $kHIDUsage_VR_DisplayEnable #x21)  ;   On/Off Control  
;   0x22 - 0xFFFF Reserved  
(defconstant $kHIDUsage_VR_Reserved #xFFFF)

; 	 Sport Page (0x04) 	
(defconstant $kHIDUsage_Sprt_BaseballBat #x1)   ;   Application Collection  
(defconstant $kHIDUsage_Sprt_GolfClub #x2)      ;   Application Collection  
(defconstant $kHIDUsage_Sprt_RowingMachine #x3) ;   Application Collection  
(defconstant $kHIDUsage_Sprt_Treadmill #x4)     ;   Application Collection  
;   0x05 - 0x2F Reserved  
(defconstant $kHIDUsage_Sprt_Oar #x30)          ;   Dynamic Value  
(defconstant $kHIDUsage_Sprt_Slope #x31)        ;   Dynamic Value  
(defconstant $kHIDUsage_Sprt_Rate #x32)         ;   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickSpeed #x33)   ;   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickFaceAngle #x34);   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickHeelOrToe #x35);   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickFollowThrough #x36);   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickTempo #x37)   ;   Dynamic Value  
(defconstant $kHIDUsage_Sprt_StickType #x38)    ;   Named Array  
(defconstant $kHIDUsage_Sprt_StickHeight #x39)  ;   Dynamic Value  
;   0x3A - 0x4F Reserved  
(defconstant $kHIDUsage_Sprt_Putter #x50)       ;   Selector  
(defconstant $kHIDUsage_Sprt_1Iron #x51)        ;   Selector  
(defconstant $kHIDUsage_Sprt_2Iron #x52)        ;   Selector  
(defconstant $kHIDUsage_Sprt_3Iron #x53)        ;   Selector  
(defconstant $kHIDUsage_Sprt_4Iron #x54)        ;   Selector  
(defconstant $kHIDUsage_Sprt_5Iron #x55)        ;   Selector  
(defconstant $kHIDUsage_Sprt_6Iron #x56)        ;   Selector  
(defconstant $kHIDUsage_Sprt_7Iron #x57)        ;   Selector  
(defconstant $kHIDUsage_Sprt_8Iron #x58)        ;   Selector  
(defconstant $kHIDUsage_Sprt_9Iron #x59)        ;   Selector  
(defconstant $kHIDUsage_Sprt_10Iron #x5A)       ;   Selector  
(defconstant $kHIDUsage_Sprt_11Iron #x5B)       ;   Selector  
(defconstant $kHIDUsage_Sprt_SandWedge #x5C)    ;   Selector  
(defconstant $kHIDUsage_Sprt_LoftWedge #x5D)    ;   Selector  
(defconstant $kHIDUsage_Sprt_PowerWedge #x5E)   ;   Selector  
(defconstant $kHIDUsage_Sprt_1Wood #x5F)        ;   Selector  
(defconstant $kHIDUsage_Sprt_3Wood #x60)        ;   Selector  
(defconstant $kHIDUsage_Sprt_5Wood #x61)        ;   Selector  
(defconstant $kHIDUsage_Sprt_7Wood #x62)        ;   Selector  
(defconstant $kHIDUsage_Sprt_9Wood #x63)        ;   Selector  
;   0x64 - 0xFFFF Reserved  
(defconstant $kHIDUsage_Sprt_Reserved #xFFFF)

; 	 Game Page (0x05) 	
(defconstant $kHIDUsage_Game_3DGameController #x1);   Application Collection  
(defconstant $kHIDUsage_Game_PinballDevice #x2) ;   Application Collection  
(defconstant $kHIDUsage_Game_GunDevice #x3)     ;   Application Collection  
;   0x04 - 0x1F Reserved  
(defconstant $kHIDUsage_Game_PointofView #x20)  ;   Physical Collection  
(defconstant $kHIDUsage_Game_TurnRightOrLeft #x21);   Dynamic Value  
(defconstant $kHIDUsage_Game_PitchUpOrDown #x22);   Dynamic Value  
(defconstant $kHIDUsage_Game_RollRightOrLeft #x23);   Dynamic Value  
(defconstant $kHIDUsage_Game_MoveRightOrLeft #x24);   Dynamic Value  
(defconstant $kHIDUsage_Game_MoveForwardOrBackward #x25);   Dynamic Value  
(defconstant $kHIDUsage_Game_MoveUpOrDown #x26) ;   Dynamic Value  
(defconstant $kHIDUsage_Game_LeanRightOrLeft #x27);   Dynamic Value  
(defconstant $kHIDUsage_Game_LeanForwardOrBackward #x28);   Dynamic Value  
(defconstant $kHIDUsage_Game_HeightOfPOV #x29)  ;   Dynamic Value  
(defconstant $kHIDUsage_Game_Flipper #x2A)      ;   Momentary Control  
(defconstant $kHIDUsage_Game_SecondaryFlipper #x2B);   Momentary Control  
(defconstant $kHIDUsage_Game_Bump #x2C)         ;   Momentary Control  
(defconstant $kHIDUsage_Game_NewGame #x2D)      ;   One-Shot Control  
(defconstant $kHIDUsage_Game_ShootBall #x2E)    ;   One-Shot Control  
(defconstant $kHIDUsage_Game_Player #x2F)       ;   One-Shot Control  
(defconstant $kHIDUsage_Game_GunBolt #x30)      ;   On/Off Control  
(defconstant $kHIDUsage_Game_GunClip #x31)      ;   On/Off Control  
(defconstant $kHIDUsage_Game_Gun #x32)          ;   Selector  
(defconstant $kHIDUsage_Game_GunSingleShot #x33);   Selector  
(defconstant $kHIDUsage_Game_GunBurst #x34)     ;   Selector  
(defconstant $kHIDUsage_Game_GunAutomatic #x35) ;   Selector  
(defconstant $kHIDUsage_Game_GunSafety #x36)    ;   On/Off Control  
(defconstant $kHIDUsage_Game_GamepadFireOrJump #x37);   Logical Collection  
(defconstant $kHIDUsage_Game_GamepadTrigger #x39);   Logical Collection  
;   0x3A - 0xFFFF Reserved  
(defconstant $kHIDUsage_Game_Reserved #xFFFF)

; 	 KeyboardOrKeypad Page (0x07) 	
; 	 This section is the Usage Page for key codes to be used in implementing a USB keyboard.  	
; 	 A Boot Keyboard (84-, 101- or 104-key) should at a minimum support all associated usage codes as 	
; 	 indicated in the Boot column below. 	
; 	 The usage type of all key codes is Selectors (Sel), except for the modifier keys Keyboard Left Control (0x224) 	
; 	 to Keyboard Right GUI (0x231) which are Dynamic Flags (DV). 	
; 	 Note: A general note on Usages and languages: 	
; 	 Due to the variation of keyboards from language to language, it is not feasible to specify exact key mappings 	
; 	 for every language. Where this list is not specific for a key function in a language, the closest equivalent key 	
; 	 position should be used, so that a keyboard may be modified for a different language by simply printing different 	
; 	 keycaps. One example is the Y key on a North American keyboard. In Germany this is typically Z. Rather than changing 	
; 	 the keyboard firmware to put the Z Usage into that place in the descriptor list, the vendor should use the Y Usage on 	
; 	 both the North American and German keyboards. This continues to be the existing practice in the industry, in order to 	
; 	 minimize the number of changes to the electronics to accommodate otherlanguages. 	
(defconstant $kHIDUsage_KeyboardErrorRollOver #x1);   ErrorRollOver  
(defconstant $kHIDUsage_KeyboardPOSTFail #x2)   ;   POSTFail  
(defconstant $kHIDUsage_KeyboardErrorUndefined #x3);   ErrorUndefined  
(defconstant $kHIDUsage_KeyboardA #x4)          ;   a or A  
(defconstant $kHIDUsage_KeyboardB #x5)          ;   b or B  
(defconstant $kHIDUsage_KeyboardC #x6)          ;   c or C  
(defconstant $kHIDUsage_KeyboardD #x7)          ;   d or D  
(defconstant $kHIDUsage_KeyboardE #x8)          ;   e or E  
(defconstant $kHIDUsage_KeyboardF #x9)          ;   f or F  
(defconstant $kHIDUsage_KeyboardG #xA)          ;   g or G  
(defconstant $kHIDUsage_KeyboardH #xB)          ;   h or H  
(defconstant $kHIDUsage_KeyboardI #xC)          ;   i or I  
(defconstant $kHIDUsage_KeyboardJ #xD)          ;   j or J  
(defconstant $kHIDUsage_KeyboardK #xE)          ;   k or K  
(defconstant $kHIDUsage_KeyboardL #xF)          ;   l or L  
(defconstant $kHIDUsage_KeyboardM #x10)         ;   m or M  
(defconstant $kHIDUsage_KeyboardN #x11)         ;   n or N  
(defconstant $kHIDUsage_KeyboardO #x12)         ;   o or O  
(defconstant $kHIDUsage_KeyboardP #x13)         ;   p or P  
(defconstant $kHIDUsage_KeyboardQ #x14)         ;   q or Q  
(defconstant $kHIDUsage_KeyboardR #x15)         ;   r or R  
(defconstant $kHIDUsage_KeyboardS #x16)         ;   s or S  
(defconstant $kHIDUsage_KeyboardT #x17)         ;   t or T  
(defconstant $kHIDUsage_KeyboardU #x18)         ;   u or U  
(defconstant $kHIDUsage_KeyboardV #x19)         ;   v or V  
(defconstant $kHIDUsage_KeyboardW #x1A)         ;   w or W  
(defconstant $kHIDUsage_KeyboardX #x1B)         ;   x or X  
(defconstant $kHIDUsage_KeyboardY #x1C)         ;   y or Y  
(defconstant $kHIDUsage_KeyboardZ #x1D)         ;   z or Z  
(defconstant $kHIDUsage_Keyboard1 #x1E)         ;   1 or !  
(defconstant $kHIDUsage_Keyboard2 #x1F)         ;   2 or @  
(defconstant $kHIDUsage_Keyboard3 #x20)         ;   3 or #  
(defconstant $kHIDUsage_Keyboard4 #x21)         ;   4 or $  
(defconstant $kHIDUsage_Keyboard5 #x22)         ;   5 or %  
(defconstant $kHIDUsage_Keyboard6 #x23)         ;   6 or ^  
(defconstant $kHIDUsage_Keyboard7 #x24)         ;   7 or &  
(defconstant $kHIDUsage_Keyboard8 #x25)         ;   8 or *  
(defconstant $kHIDUsage_Keyboard9 #x26)         ;   9 or (  
(defconstant $kHIDUsage_Keyboard0 #x27)         ;   0 or )  
(defconstant $kHIDUsage_KeyboardReturnOrEnter #x28);   Return (Enter)  
(defconstant $kHIDUsage_KeyboardEscape #x29)    ;   Escape  
(defconstant $kHIDUsage_KeyboardDeleteOrBackspace #x2A);   Delete (Backspace)  
(defconstant $kHIDUsage_KeyboardTab #x2B)       ;   Tab  
(defconstant $kHIDUsage_KeyboardSpacebar #x2C)  ;   Spacebar  
(defconstant $kHIDUsage_KeyboardHyphen #x2D)    ;   - or _  
(defconstant $kHIDUsage_KeyboardEqualSign #x2E) ;   = or +  
(defconstant $kHIDUsage_KeyboardOpenBracket #x2F);   [ or (  
(defconstant $kHIDUsage_KeyboardCloseBracket #x30);   ] or )  
(defconstant $kHIDUsage_KeyboardBackslash #x31) ;   \ or |  
(defconstant $kHIDUsage_KeyboardNonUSPound #x32);   Non-US # or _  
(defconstant $kHIDUsage_KeyboardSemicolon #x33) ;   ; or :  
(defconstant $kHIDUsage_KeyboardQuote #x34)     ;   ' or "  
(defconstant $kHIDUsage_KeyboardGraveAccentAndTilde #x35);   Grave Accent and Tilde  
(defconstant $kHIDUsage_KeyboardComma #x36)     ;   , or <  
(defconstant $kHIDUsage_KeyboardPeriod #x37)    ;   . or >  
(defconstant $kHIDUsage_KeyboardSlash #x38)     ;   / or ?  
(defconstant $kHIDUsage_KeyboardCapsLock #x39)  ;   Caps Lock  
(defconstant $kHIDUsage_KeyboardF1 #x3A)        ;   F1  
(defconstant $kHIDUsage_KeyboardF2 #x3B)        ;   F2  
(defconstant $kHIDUsage_KeyboardF3 #x3C)        ;   F3  
(defconstant $kHIDUsage_KeyboardF4 #x3D)        ;   F4  
(defconstant $kHIDUsage_KeyboardF5 #x3E)        ;   F5  
(defconstant $kHIDUsage_KeyboardF6 #x3F)        ;   F6  
(defconstant $kHIDUsage_KeyboardF7 #x40)        ;   F7  
(defconstant $kHIDUsage_KeyboardF8 #x41)        ;   F8  
(defconstant $kHIDUsage_KeyboardF9 #x42)        ;   F9  
(defconstant $kHIDUsage_KeyboardF10 #x43)       ;   F10  
(defconstant $kHIDUsage_KeyboardF11 #x44)       ;   F11  
(defconstant $kHIDUsage_KeyboardF12 #x45)       ;   F12  
(defconstant $kHIDUsage_KeyboardPrintScreen #x46);   Print Screen  
(defconstant $kHIDUsage_KeyboardScrollLock #x47);   Scroll Lock  
(defconstant $kHIDUsage_KeyboardPause #x48)     ;   Pause  
(defconstant $kHIDUsage_KeyboardInsert #x49)    ;   Insert  
(defconstant $kHIDUsage_KeyboardHome #x4A)      ;   Home  
(defconstant $kHIDUsage_KeyboardPageUp #x4B)    ;   Page Up  
(defconstant $kHIDUsage_KeyboardDeleteForward #x4C);   Delete Forward  
(defconstant $kHIDUsage_KeyboardEnd #x4D)       ;   End  
(defconstant $kHIDUsage_KeyboardPageDown #x4E)  ;   Page Down  
(defconstant $kHIDUsage_KeyboardRightArrow #x4F);   Right Arrow  
(defconstant $kHIDUsage_KeyboardLeftArrow #x50) ;   Left Arrow  
(defconstant $kHIDUsage_KeyboardDownArrow #x51) ;   Down Arrow  
(defconstant $kHIDUsage_KeyboardUpArrow #x52)   ;   Up Arrow  
(defconstant $kHIDUsage_KeypadNumLock #x53)     ;   Keypad NumLock or Clear  
(defconstant $kHIDUsage_KeypadSlash #x54)       ;   Keypad /  
(defconstant $kHIDUsage_KeypadAsterisk #x55)    ;   Keypad *  
(defconstant $kHIDUsage_KeypadHyphen #x56)      ;   Keypad -  
(defconstant $kHIDUsage_KeypadPlus #x57)        ;   Keypad +  
(defconstant $kHIDUsage_KeypadEnter #x58)       ;   Keypad Enter  
(defconstant $kHIDUsage_Keypad1 #x59)           ;   Keypad 1 or End  
(defconstant $kHIDUsage_Keypad2 #x5A)           ;   Keypad 2 or Down Arrow  
(defconstant $kHIDUsage_Keypad3 #x5B)           ;   Keypad 3 or Page Down  
(defconstant $kHIDUsage_Keypad4 #x5C)           ;   Keypad 4 or Left Arrow  
(defconstant $kHIDUsage_Keypad5 #x5D)           ;   Keypad 5  
(defconstant $kHIDUsage_Keypad6 #x5E)           ;   Keypad 6 or Right Arrow  
(defconstant $kHIDUsage_Keypad7 #x5F)           ;   Keypad 7 or Home  
(defconstant $kHIDUsage_Keypad8 #x60)           ;   Keypad 8 or Up Arrow  
(defconstant $kHIDUsage_Keypad9 #x61)           ;   Keypad 9 or Page Up  
(defconstant $kHIDUsage_Keypad0 #x62)           ;   Keypad 0 or Insert  
(defconstant $kHIDUsage_KeypadPeriod #x63)      ;   Keypad . or Delete  
(defconstant $kHIDUsage_KeyboardNonUSBackslash #x64);   Non-US \ or |  
(defconstant $kHIDUsage_KeyboardApplication #x65);   Application  
(defconstant $kHIDUsage_KeyboardPower #x66)     ;   Power  
(defconstant $kHIDUsage_KeypadEqualSign #x67)   ;   Keypad =  
(defconstant $kHIDUsage_KeyboardF13 #x68)       ;   F13  
(defconstant $kHIDUsage_KeyboardF14 #x69)       ;   F14  
(defconstant $kHIDUsage_KeyboardF15 #x6A)       ;   F15  
(defconstant $kHIDUsage_KeyboardF16 #x6B)       ;   F16  
(defconstant $kHIDUsage_KeyboardF17 #x6C)       ;   F17  
(defconstant $kHIDUsage_KeyboardF18 #x6D)       ;   F18  
(defconstant $kHIDUsage_KeyboardF19 #x6E)       ;   F19  
(defconstant $kHIDUsage_KeyboardF20 #x6F)       ;   F20  
(defconstant $kHIDUsage_KeyboardF21 #x70)       ;   F21  
(defconstant $kHIDUsage_KeyboardF22 #x71)       ;   F22  
(defconstant $kHIDUsage_KeyboardF23 #x72)       ;   F23  
(defconstant $kHIDUsage_KeyboardF24 #x73)       ;   F24  
(defconstant $kHIDUsage_KeyboardExecute #x74)   ;   Execute  
(defconstant $kHIDUsage_KeyboardHelp #x75)      ;   Help  
(defconstant $kHIDUsage_KeyboardMenu #x76)      ;   Menu  
(defconstant $kHIDUsage_KeyboardSelect #x77)    ;   Select  
(defconstant $kHIDUsage_KeyboardStop #x78)      ;   Stop  
(defconstant $kHIDUsage_KeyboardAgain #x79)     ;   Again  
(defconstant $kHIDUsage_KeyboardUndo #x7A)      ;   Undo  
(defconstant $kHIDUsage_KeyboardCut #x7B)       ;   Cut  
(defconstant $kHIDUsage_KeyboardCopy #x7C)      ;   Copy  
(defconstant $kHIDUsage_KeyboardPaste #x7D)     ;   Paste  
(defconstant $kHIDUsage_KeyboardFind #x7E)      ;   Find  
(defconstant $kHIDUsage_KeyboardMute #x7F)      ;   Mute  
(defconstant $kHIDUsage_KeyboardVolumeUp #x80)  ;   Volume Up  
(defconstant $kHIDUsage_KeyboardVolumeDown #x81);   Volume Down  
(defconstant $kHIDUsage_KeyboardLockingCapsLock #x82);   Locking Caps Lock  
(defconstant $kHIDUsage_KeyboardLockingNumLock #x83);   Locking Num Lock  
(defconstant $kHIDUsage_KeyboardLockingScrollLock #x84);   Locking Scroll Lock  
(defconstant $kHIDUsage_KeypadComma #x85)       ;   Keypad Comma  
(defconstant $kHIDUsage_KeypadEqualSignAS400 #x86);   Keypad Equal Sign for AS/400  
(defconstant $kHIDUsage_KeyboardInternational1 #x87);   International1  
(defconstant $kHIDUsage_KeyboardInternational2 #x88);   International2  
(defconstant $kHIDUsage_KeyboardInternational3 #x89);   International3  
(defconstant $kHIDUsage_KeyboardInternational4 #x8A);   International4  
(defconstant $kHIDUsage_KeyboardInternational5 #x8B);   International5  
(defconstant $kHIDUsage_KeyboardInternational6 #x8C);   International6  
(defconstant $kHIDUsage_KeyboardInternational7 #x8D);   International7  
(defconstant $kHIDUsage_KeyboardInternational8 #x8E);   International8  
(defconstant $kHIDUsage_KeyboardInternational9 #x8F);   International9  
(defconstant $kHIDUsage_KeyboardLANG1 #x90)     ;   LANG1  
(defconstant $kHIDUsage_KeyboardLANG2 #x91)     ;   LANG2  
(defconstant $kHIDUsage_KeyboardLANG3 #x92)     ;   LANG3  
(defconstant $kHIDUsage_KeyboardLANG4 #x93)     ;   LANG4  
(defconstant $kHIDUsage_KeyboardLANG5 #x94)     ;   LANG5  
(defconstant $kHIDUsage_KeyboardLANG6 #x95)     ;   LANG6  
(defconstant $kHIDUsage_KeyboardLANG7 #x96)     ;   LANG7  
(defconstant $kHIDUsage_KeyboardLANG8 #x97)     ;   LANG8  
(defconstant $kHIDUsage_KeyboardLANG9 #x98)     ;   LANG9  
(defconstant $kHIDUsage_KeyboardAlternateErase #x99);   AlternateErase  
(defconstant $kHIDUsage_KeyboardSysReqOrAttention #x9A);   SysReq/Attention  
(defconstant $kHIDUsage_KeyboardCancel #x9B)    ;   Cancel  
(defconstant $kHIDUsage_KeyboardClear #x9C)     ;   Clear  
(defconstant $kHIDUsage_KeyboardPrior #x9D)     ;   Prior  
(defconstant $kHIDUsage_KeyboardReturn #x9E)    ;   Return  
(defconstant $kHIDUsage_KeyboardSeparator #x9F) ;   Separator  
(defconstant $kHIDUsage_KeyboardOut #xA0)       ;   Out  
(defconstant $kHIDUsage_KeyboardOper #xA1)      ;   Oper  
(defconstant $kHIDUsage_KeyboardClearOrAgain #xA2);   Clear/Again  
(defconstant $kHIDUsage_KeyboardCrSelOrProps #xA3);   CrSel/Props  
(defconstant $kHIDUsage_KeyboardExSel #xA4)     ;   ExSel  
;   0xA5-0xDF Reserved  
(defconstant $kHIDUsage_KeyboardLeftControl #xE0);   Left Control  
(defconstant $kHIDUsage_KeyboardLeftShift #xE1) ;   Left Shift  
(defconstant $kHIDUsage_KeyboardLeftAlt #xE2)   ;   Left Alt  
(defconstant $kHIDUsage_KeyboardLeftGUI #xE3)   ;   Left GUI  
(defconstant $kHIDUsage_KeyboardRightControl #xE4);   Right Control  
(defconstant $kHIDUsage_KeyboardRightShift #xE5);   Right Shift  
(defconstant $kHIDUsage_KeyboardRightAlt #xE6)  ;   Right Alt  
(defconstant $kHIDUsage_KeyboardRightGUI #xE7)  ;   Right GUI  
;   0xE8-0xFFFF Reserved  
(defconstant $kHIDUsage_Keyboard_Reserved #xFFFF)

; 	 LEDs Page (0x08) 	
; 	 An LED or indicator is implemented as an On/Off Control (OOF) using the Single button toggle mode, 
; 	/* where a value of 1 will turn on the indicator, and a value of 0 will turn it off. The exceptions are described below. 	
(defconstant $kHIDUsage_LED_NumLock #x1)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_CapsLock #x2)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_ScrollLock #x3)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_Compose #x4)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_Kana #x5)           ;   On/Off Control  
(defconstant $kHIDUsage_LED_Power #x6)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_Shift #x7)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_DoNotDisturb #x8)   ;   On/Off Control  
(defconstant $kHIDUsage_LED_Mute #x9)           ;   On/Off Control  
(defconstant $kHIDUsage_LED_ToneEnable #xA)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_HighCutFilter #xB)  ;   On/Off Control  
(defconstant $kHIDUsage_LED_LowCutFilter #xC)   ;   On/Off Control  
(defconstant $kHIDUsage_LED_EqualizerEnable #xD);   On/Off Control  
(defconstant $kHIDUsage_LED_SoundFieldOn #xE)   ;   On/Off Control  
(defconstant $kHIDUsage_LED_SurroundOn #xF)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_Repeat #x10)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_Stereo #x11)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_SamplingRateDetect #x12);   On/Off Control  
(defconstant $kHIDUsage_LED_Spinning #x13)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_CAV #x14)           ;   On/Off Control  
(defconstant $kHIDUsage_LED_CLV #x15)           ;   On/Off Control  
(defconstant $kHIDUsage_LED_RecordingFormatDetect #x16);   On/Off Control  
(defconstant $kHIDUsage_LED_OffHook #x17)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_Ring #x18)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_MessageWaiting #x19);   On/Off Control  
(defconstant $kHIDUsage_LED_DataMode #x1A)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_BatteryOperation #x1B);   On/Off Control  
(defconstant $kHIDUsage_LED_BatteryOK #x1C)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_BatteryLow #x1D)    ;   On/Off Control  
(defconstant $kHIDUsage_LED_Speaker #x1E)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_HeadSet #x1F)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_Hold #x20)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_Microphone #x21)    ;   On/Off Control  
(defconstant $kHIDUsage_LED_Coverage #x22)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_NightMode #x23)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_SendCalls #x24)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_CallPickup #x25)    ;   On/Off Control  
(defconstant $kHIDUsage_LED_Conference #x26)    ;   On/Off Control  
(defconstant $kHIDUsage_LED_StandBy #x27)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_CameraOn #x28)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_CameraOff #x29)     ;   On/Off Control  
(defconstant $kHIDUsage_LED_OnLine #x2A)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_OffLine #x2B)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_Busy #x2C)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_Ready #x2D)         ;   On/Off Control  
(defconstant $kHIDUsage_LED_PaperOut #x2E)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_PaperJam #x2F)      ;   On/Off Control  
(defconstant $kHIDUsage_LED_Remote #x30)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_Forward #x31)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_Reverse #x32)       ;   On/Off Control  
(defconstant $kHIDUsage_LED_Stop #x33)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_Rewind #x34)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_FastForward #x35)   ;   On/Off Control  
(defconstant $kHIDUsage_LED_Play #x36)          ;   On/Off Control  
(defconstant $kHIDUsage_LED_Pause #x37)         ;   On/Off Control  
(defconstant $kHIDUsage_LED_Record #x38)        ;   On/Off Control  
(defconstant $kHIDUsage_LED_Error #x39)         ;   On/Off Control  
(defconstant $kHIDUsage_LED_Usage #x3A)         ;   Selector  
(defconstant $kHIDUsage_LED_UsageInUseIndicator #x3B);   Usage Switch  
(defconstant $kHIDUsage_LED_UsageMultiModeIndicator #x3C);   Usage Modifier  
(defconstant $kHIDUsage_LED_IndicatorOn #x3D)   ;   Selector  
(defconstant $kHIDUsage_LED_IndicatorFlash #x3E);   Selector  
(defconstant $kHIDUsage_LED_IndicatorSlowBlink #x3F);   Selector  
(defconstant $kHIDUsage_LED_IndicatorFastBlink #x40);   Selector  
(defconstant $kHIDUsage_LED_IndicatorOff #x41)  ;   Selector  
(defconstant $kHIDUsage_LED_FlashOnTime #x42)   ;   Dynamic Value  
(defconstant $kHIDUsage_LED_SlowBlinkOnTime #x43);   Dynamic Value  
(defconstant $kHIDUsage_LED_SlowBlinkOffTime #x44);   Dynamic Value  
(defconstant $kHIDUsage_LED_FastBlinkOnTime #x45);   Dynamic Value  
(defconstant $kHIDUsage_LED_FastBlinkOffTime #x46);   Dynamic Value  
(defconstant $kHIDUsage_LED_UsageIndicatorColor #x47);   Usage Modifier  
(defconstant $kHIDUsage_LED_IndicatorRed #x48)  ;   Selector  
(defconstant $kHIDUsage_LED_IndicatorGreen #x49);   Selector  
(defconstant $kHIDUsage_LED_IndicatorAmber #x4A);   Selector  
(defconstant $kHIDUsage_LED_GenericIndicator #x4B);   On/Off Control  
(defconstant $kHIDUsage_LED_SystemSuspend #x4C) ;   On/Off Control  
(defconstant $kHIDUsage_LED_ExternalPowerConnected #x4D);   On/Off Control  
;   0x4E - 0xFFFF Reserved  
(defconstant $kHIDUsage_LED_Reserved #xFFFF)

; 	 Button Page (0x09) 	
; 	 The Button page is the first place an application should look for user selection controls. System graphical user 	
; 	 interfaces typically employ a pointer and a set of hierarchical selectors to select, move and otherwise manipulate 	
; 	 their environment. For these purposes the following assignment of significance can be applied to the Button usages: 	
; 	  Button 1, Primary Button. Used for object selecting, dragging, and double click activation. On MacOS, this is the 
; 	/*   only button. Microsoft operating systems call this a logical left button, because it 	
; 	   is not necessarily physically located on the left of the pointing device. 	
; 	  Button 2, Secondary Button. Used by newer graphical user interfaces to browse object properties. Exposed by systems 	
; 	   to applications that typically assign application-specific functionality. 	
; 	  Button 3, Tertiary Button. Optional control. Exposed to applications, but seldom assigned functionality due to prevalence 	
; 	   of two- and one-button devices. 	
; 	  Buttons 4 -55. As the button number increases, its significance as a selector decreases. 	
; 	 In many ways the assignment of button numbers is similar to the assignment of Effort in Physical descriptors. 	
; 	 Button 1 would be used to define the button a finger rests on when the hand is in the at rest position, that is, virtually 	
; 	 no effort is required by the user to activate the button. Button values increment as the finger has to stretch to reach a 	
; 	 control. See Section 6.2.3, Physical Descriptors, in the HID Specification for methods of further qualifying buttons. 	
(defconstant $kHIDUsage_Button_1 #x1)           ;   (primary/trigger)  
(defconstant $kHIDUsage_Button_2 #x2)           ;   (secondary)  
(defconstant $kHIDUsage_Button_3 #x3)           ;   (tertiary)  
(defconstant $kHIDUsage_Button_4 #x4)           ;   4th button  
;   ...  
(defconstant $kHIDUsage_Button_65535 #xFFFF)

; 	 Ordinal Page (0x0A) 	
; 	 The Ordinal page allows multiple instances of a control or sets of controls to be declared without requiring individual 	
; 	 enumeration in the native usage page. For example, it is not necessary to declare usages of Pointer 1, Pointer 2, and so 	
; 	 forth on the Generic Desktop page. When parsed, the ordinal instance number is, in essence, concatenated to the usages 	
; 	 attached to the encompassing collection to create Pointer 1, Pointer 2, and so forth. 	
; 	 For an example, see Section A.5, Multiple Instances of a Control, in Appendix A, Usage Examples. By convention, 	
; 	 an Ordinal collection is placed inside the collection for which it is declaring multiple instances. 	
; 	 Instances do not have to be identical. 	
;   0x00 Reserved  
(defconstant $kHIDUsage_Ord_Instance1 #x1)      ;   Usage Modifier  
(defconstant $kHIDUsage_Ord_Instance2 #x2)      ;   Usage Modifier  
(defconstant $kHIDUsage_Ord_Instance3 #x3)      ;   Usage Modifier  
(defconstant $kHIDUsage_Ord_Instance4 #x4)      ;   Usage Modifier  
(defconstant $kHIDUsage_Ord_Instance65535 #xFFFF);   Usage Modifier  

; 	 Telephony Page (0x0B) 	
; 	 This usage page defines the keytop and control usages for telephony devices. 	
; 	 Indicators on a phone are handled by wrapping them in LED: Usage In Use Indicator and LED: Usage Selected Indicator 	
; 	 usages. For example, a message-indicator LED would be identified by a Telephony: Message usage declared as a Feature 	
; 	 or Output in a LED: Usage In Use Indicator collection. 	
; 	 See Section 14, Consumer Page (0x0C), for audio volume and tone controls. 	
(defconstant $kHIDUsage_Tfon_Phone #x1)         ;   Application Collection  
(defconstant $kHIDUsage_Tfon_AnsweringMachine #x2);   Application Collection  
(defconstant $kHIDUsage_Tfon_MessageControls #x3);   Logical Collection  
(defconstant $kHIDUsage_Tfon_Handset #x4)       ;   Logical Collection  
(defconstant $kHIDUsage_Tfon_Headset #x5)       ;   Logical Collection  
(defconstant $kHIDUsage_Tfon_TelephonyKeyPad #x6);   Named Array  
(defconstant $kHIDUsage_Tfon_ProgrammableButton #x7);   Named Array  
;   0x08 - 0x1F Reserved  
(defconstant $kHIDUsage_Tfon_HookSwitch #x20)   ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_Flash #x21)        ;   Momentary Control  
(defconstant $kHIDUsage_Tfon_Feature #x22)      ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_Hold #x23)         ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_Redial #x24)       ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_Transfer #x25)     ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_Drop #x26)         ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_Park #x27)         ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_ForwardCalls #x28) ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_AlternateFunction #x29);   Momentary Control  
(defconstant $kHIDUsage_Tfon_Line #x2A)         ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_SpeakerPhone #x2B) ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_Conference #x2C)   ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_RingEnable #x2D)   ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_Ring #x2E)         ;   Selector  
(defconstant $kHIDUsage_Tfon_PhoneMute #x2F)    ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_CallerID #x30)     ;   Momentary Control  
;   0x31 - 0x4F Reserved  
(defconstant $kHIDUsage_Tfon_SpeedDial #x50)    ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_StoreNumber #x51)  ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_RecallNumber #x52) ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneDirectory #x53);   On/Off Control  
;   0x54 - 0x6F Reserved  
(defconstant $kHIDUsage_Tfon_VoiceMail #x70)    ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_ScreenCalls #x71)  ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_DoNotDisturb #x72) ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_Message #x73)      ;   One-Shot Control  
(defconstant $kHIDUsage_Tfon_AnswerOnOrOff #x74);   On/Off Control  
;   0x75 - 0x8F Reserved  
(defconstant $kHIDUsage_Tfon_InsideDialTone #x90);   Momentary Control  
(defconstant $kHIDUsage_Tfon_OutsideDialTone #x91);   Momentary Control  
(defconstant $kHIDUsage_Tfon_InsideRingTone #x92);   Momentary Control  
(defconstant $kHIDUsage_Tfon_OutsideRingTone #x93);   Momentary Control  
(defconstant $kHIDUsage_Tfon_PriorityRingTone #x94);   Momentary Control  
(defconstant $kHIDUsage_Tfon_InsideRingback #x95);   Momentary Control  
(defconstant $kHIDUsage_Tfon_PriorityRingback #x96);   Momentary Control  
(defconstant $kHIDUsage_Tfon_LineBusyTone #x97) ;   Momentary Control  
(defconstant $kHIDUsage_Tfon_ReorderTone #x98)  ;   Momentary Control  
(defconstant $kHIDUsage_Tfon_CallWaitingTone #x99);   Momentary Control  
(defconstant $kHIDUsage_Tfon_ConfirmationTone1 #x9A);   Momentary Control  
(defconstant $kHIDUsage_Tfon_ConfirmationTone2 #x9B);   Momentary Control  
(defconstant $kHIDUsage_Tfon_TonesOff #x9C)     ;   On/Off Control  
(defconstant $kHIDUsage_Tfon_OutsideRingback #x9D);   Momentary Control  
;   0x9E - 0xAF Reserved  
(defconstant $kHIDUsage_Tfon_PhoneKey0 #xB0)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey1 #xB1)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey2 #xB2)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey3 #xB3)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey4 #xB4)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey5 #xB5)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey6 #xB6)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey7 #xB7)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey8 #xB8)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKey9 #xB9)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyStar #xBA) ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyPound #xBB);   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyA #xBC)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyB #xBD)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyC #xBE)    ;   Selector/One-Shot Control  
(defconstant $kHIDUsage_Tfon_PhoneKeyD #xBF)    ;   Selector/One-Shot Control  
;   0xC0 - 0xFFFF Reserved  
(defconstant $kHIDUsage_TFon_Reserved #xFFFF)

; 	 Consumer Page (0x0C) 	
; 	 All controls on the Consumer page are application-specific. That is, they affect a specific device, not the system as a whole. 	
(defconstant $kHIDUsage_Csmr_ConsumerControl #x1);   Application Collection  
(defconstant $kHIDUsage_Csmr_NumericKeyPad #x2) ;   Named Array  
(defconstant $kHIDUsage_Csmr_ProgrammableButtons #x3);   Named Array  
;   0x03 - 0x1F Reserved  
(defconstant $kHIDUsage_Csmr_Plus10 #x20)       ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Plus100 #x21)      ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_AMOrPM #x22)       ;   One-Shot Control  
;   0x23 - 0x3F Reserved  
(defconstant $kHIDUsage_Csmr_Power #x30)        ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_Reset #x31)        ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Sleep #x32)        ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SleepAfter #x33)   ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SleepMode #x34)    ;   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_Illumination #x35) ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_FunctionButtons #x36);   Named Array  
;   0x37 - 0x3F Reserved  
(defconstant $kHIDUsage_Csmr_Menu #x40)         ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_MenuPick #x41)     ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuUp #x42)       ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuDown #x43)     ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuLeft #x44)     ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuRight #x45)    ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuEscape #x46)   ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuValueIncrease #x47);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_MenuValueDecrease #x48);   One-Shot Control  
;   0x49 - 0x5F Reserved  
(defconstant $kHIDUsage_Csmr_DataOnScreen #x60) ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_ClosedCaption #x61);   On/Off Control  
(defconstant $kHIDUsage_Csmr_ClosedCaptionSelect #x62);   Selector  
(defconstant $kHIDUsage_Csmr_VCROrTV #x63)      ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_BroadcastMode #x64);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Snapshot #x65)     ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Still #x66)        ;   One-Shot Control  
;   0x67 - 0x7F Reserved  
(defconstant $kHIDUsage_Csmr_Selection #x80)    ;   Named Array  
(defconstant $kHIDUsage_Csmr_Assign #x81)       ;   Selector  
(defconstant $kHIDUsage_Csmr_ModeStep #x82)     ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_RecallLast #x83)   ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_EnterChannel #x84) ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_OrderMovie #x85)   ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Channel #x86)      ;   Linear Control  
(defconstant $kHIDUsage_Csmr_MediaSelection #x87);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectComputer #x88);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectTV #x89);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectWWW #x8A);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectDVD #x8B);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectTelephone #x8C);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectProgramGuide #x8D);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectVideoPhone #x8E);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectGames #x8F);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectMessages #x90);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectCD #x91);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectVCR #x92);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectTuner #x93);   Selector  
(defconstant $kHIDUsage_Csmr_Quit #x94)         ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Help #x95)         ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_MediaSelectTape #x96);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectCable #x97);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectSatellite #x98);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectSecurity #x99);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectHome #x9A);   Selector  
(defconstant $kHIDUsage_Csmr_MediaSelectCall #x9B);   Selector  
(defconstant $kHIDUsage_Csmr_ChannelIncrement #x9C);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_ChannelDecrement #x9D);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Media #x9E)        ;   Selector  
;   0x9F Reserved  
(defconstant $kHIDUsage_Csmr_VCRPlus #xA0)      ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Once #xA1)         ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Daily #xA2)        ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Weekly #xA3)       ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Monthly #xA4)      ;   One-Shot Control  
;   0xA5 - 0xAF Reserved  
(defconstant $kHIDUsage_Csmr_Play #xB0)         ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_Pause #xB1)        ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_Record #xB2)       ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_FastForward #xB3)  ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_Rewind #xB4)       ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_ScanNextTrack #xB5);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_ScanPreviousTrack #xB6);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Stop #xB7)         ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Eject #xB8)        ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_RandomPlay #xB9)   ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_SelectDisc #xBA)   ;   Named Array  
(defconstant $kHIDUsage_Csmr_EnterDisc #xBB)    ;   Momentary Control  
(defconstant $kHIDUsage_Csmr_Repeat #xBC)       ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Tracking #xBD)     ;   Linear Control  
(defconstant $kHIDUsage_Csmr_TrackNormal #xBE)  ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SlowTracking #xBF) ;   Linear Control  
(defconstant $kHIDUsage_Csmr_FrameForward #xC0) ;   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_FrameBack #xC1)    ;   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_Mark #xC2)         ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_ClearMark #xC3)    ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_RepeatFromMark #xC4);   On/Off Control  
(defconstant $kHIDUsage_Csmr_ReturnToMark #xC5) ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SearchMarkForward #xC6);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SearchMarkBackwards #xC7);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_CounterReset #xC8) ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_ShowCounter #xC9)  ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_TrackingIncrement #xCA);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_TrackingDecrement #xCB);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_StopOrEject #xCC)  ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_PlayOrPause #xCD)  ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_PlayOrSkip #xCE)   ;   One-Shot Control  
;   0xCF - 0xDF Reserved  
(defconstant $kHIDUsage_Csmr_Volume #xE0)       ;   Linear Control  
(defconstant $kHIDUsage_Csmr_Balance #xE1)      ;   Linear Control  
(defconstant $kHIDUsage_Csmr_Mute #xE2)         ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_Bass #xE3)         ;   Linear Control  
(defconstant $kHIDUsage_Csmr_Treble #xE4)       ;   Linear Control  
(defconstant $kHIDUsage_Csmr_BassBoost #xE5)    ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_SurroundMode #xE6) ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_Loudness #xE7)     ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_MPX #xE8)          ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_VolumeIncrement #xE9);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_VolumeDecrement #xEA);   Re-Trigger Control  
;   0xEB - 0xEF Reserved  
(defconstant $kHIDUsage_Csmr_Speed #xF0)        ;   Selector  
(defconstant $kHIDUsage_Csmr_PlaybackSpeed #xF1);   Named Array  
(defconstant $kHIDUsage_Csmr_StandardPlay #xF2) ;   Selector  
(defconstant $kHIDUsage_Csmr_LongPlay #xF3)     ;   Selector  
(defconstant $kHIDUsage_Csmr_ExtendedPlay #xF4) ;   Selector  
(defconstant $kHIDUsage_Csmr_Slow #xF5)         ;   One-Shot Control  
;   0xF6 - 0xFF Reserved  
(defconstant $kHIDUsage_Csmr_FanEnable #x100)   ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_FanSpeed #x101)    ;   Linear Control  
(defconstant $kHIDUsage_Csmr_LightEnable #x102) ;   On/Off Control  
(defconstant $kHIDUsage_Csmr_LightIlluminationLevel #x103);   Linear Control  
(defconstant $kHIDUsage_Csmr_ClimateControlEnable #x104);   On/Off Control  
(defconstant $kHIDUsage_Csmr_RoomTemperature #x105);   Linear Control  
(defconstant $kHIDUsage_Csmr_SecurityEnable #x106);   On/Off Control  
(defconstant $kHIDUsage_Csmr_FireAlarm #x107)   ;   One-Shot Control  
(defconstant $kHIDUsage_Csmr_PoliceAlarm #x108) ;   One-Shot Control  
;   0x109 - 0x14F Reserved  
(defconstant $kHIDUsage_Csmr_BalanceRight #x150);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_BalanceLeft #x151) ;   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_BassIncrement #x152);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_BassDecrement #x153);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_TrebleIncrement #x154);   Re-Trigger Control  
(defconstant $kHIDUsage_Csmr_TrebleDecrement #x155);   Re-Trigger Control  
;   0x156 - 0x15F Reserved  
(defconstant $kHIDUsage_Csmr_SpeakerSystem #x160);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelLeft #x161) ;   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelRight #x162);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelCenter #x163);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelFront #x164);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelCenterFront #x165);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelSide #x166) ;   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelSurround #x167);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelLowFrequencyEnhancement #x168);   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelTop #x169)  ;   Logical Collection  
(defconstant $kHIDUsage_Csmr_ChannelUnknown #x16A);   Logical Collection  
;   0x16B - 0x16F Reserved  
(defconstant $kHIDUsage_Csmr_SubChannel #x170)  ;   Linear Control  
(defconstant $kHIDUsage_Csmr_SubChannelIncrement #x171);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_SubChannelDecrement #x172);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_AlternateAudioIncrement #x173);   One-Shot Control  
(defconstant $kHIDUsage_Csmr_AlternateAudioDecrement #x174);   One-Shot Control  
;   0x175 - 0x17F Reserved  
(defconstant $kHIDUsage_Csmr_ApplicationLaunchButtons #x180);   Named Array  
(defconstant $kHIDUsage_Csmr_ALLaunchButtonConfigurationTool #x181);   Selector  
(defconstant $kHIDUsage_Csmr_ALProgrammableButtonConfiguration #x182);   Selector  
(defconstant $kHIDUsage_Csmr_ALConsumerControlConfiguration #x183);   Selector  
(defconstant $kHIDUsage_Csmr_ALWordProcessor #x184);   Selector  
(defconstant $kHIDUsage_Csmr_ALTextEditor #x185);   Selector  
(defconstant $kHIDUsage_Csmr_ALSpreadsheet #x186);   Selector  
(defconstant $kHIDUsage_Csmr_ALGraphicsEditor #x187);   Selector  
(defconstant $kHIDUsage_Csmr_ALPresentationApp #x188);   Selector  
(defconstant $kHIDUsage_Csmr_ALDatabaseApp #x189);   Selector  
(defconstant $kHIDUsage_Csmr_ALEmailReader #x18A);   Selector  
(defconstant $kHIDUsage_Csmr_ALNewsreader #x18B);   Selector  
(defconstant $kHIDUsage_Csmr_ALVoicemail #x18C) ;   Selector  
(defconstant $kHIDUsage_Csmr_ALContactsOrAddressBook #x18D);   Selector  
(defconstant $kHIDUsage_Csmr_ALCalendarOrSchedule #x18E);   Selector  
(defconstant $kHIDUsage_Csmr_ALTaskOrProjectManager #x18F);   Selector  
(defconstant $kHIDUsage_Csmr_ALLogOrJournalOrTimecard #x190);   Selector  
(defconstant $kHIDUsage_Csmr_ALCheckbookOrFinance #x191);   Selector  
(defconstant $kHIDUsage_Csmr_ALCalculator #x192);   Selector  
(defconstant $kHIDUsage_Csmr_ALAOrVCaptureOrPlayback #x193);   Selector  
(defconstant $kHIDUsage_Csmr_ALLocalMachineBrowser #x194);   Selector  
(defconstant $kHIDUsage_Csmr_ALLANOrWANBrowser #x195);   Selector  
(defconstant $kHIDUsage_Csmr_ALInternetBrowser #x196);   Selector  
(defconstant $kHIDUsage_Csmr_ALRemoteNetworkingOrISPConnect #x197);   Selector  
(defconstant $kHIDUsage_Csmr_ALNetworkConference #x198);   Selector  
(defconstant $kHIDUsage_Csmr_ALNetworkChat #x199);   Selector  
(defconstant $kHIDUsage_Csmr_ALTelephonyOrDialer #x19A);   Selector  
(defconstant $kHIDUsage_Csmr_ALLogon #x19B)     ;   Selector  
(defconstant $kHIDUsage_Csmr_ALLogoff #x19C)    ;   Selector  
(defconstant $kHIDUsage_Csmr_ALLogonOrLogoff #x19D);   Selector  
(defconstant $kHIDUsage_Csmr_ALTerminalLockOrScreensaver #x19E);   Selector  
(defconstant $kHIDUsage_Csmr_ALControlPanel #x19F);   Selector  
(defconstant $kHIDUsage_Csmr_ALCommandLineProcessorOrRun #x1A0);   Selector  
(defconstant $kHIDUsage_Csmr_ALProcessOrTaskManager #x1A1);   Selector  
(defconstant $kHIDUsage_Csmr_AL #x1A2)          ;   Selector  
(defconstant $kHIDUsage_Csmr_ALNextTaskOrApplication #x143);   Selector  
(defconstant $kHIDUsage_Csmr_ALPreviousTaskOrApplication #x1A4);   Selector  
(defconstant $kHIDUsage_Csmr_ALPreemptiveHaltTaskOrApplication #x1A5);   Selector  
;   0x1A6 - 0x1FF Reserved  
(defconstant $kHIDUsage_Csmr_GenericGUIApplicationControls #x200);   Named Array  
(defconstant $kHIDUsage_Csmr_ACNew #x201)       ;   Selector  
(defconstant $kHIDUsage_Csmr_ACOpen #x202)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACClose #x203)     ;   Selector  
(defconstant $kHIDUsage_Csmr_ACExit #x204)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACMaximize #x205)  ;   Selector  
(defconstant $kHIDUsage_Csmr_ACMinimize #x206)  ;   Selector  
(defconstant $kHIDUsage_Csmr_ACSave #x207)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPrint #x208)     ;   Selector  
(defconstant $kHIDUsage_Csmr_ACProperties #x209);   Selector  
(defconstant $kHIDUsage_Csmr_ACUndo #x21A)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACCopy #x21B)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACCut #x21C)       ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPaste #x21D)     ;   Selector  
(defconstant $kHIDUsage_Csmr_AC #x21E)          ;   Selector  
(defconstant $kHIDUsage_Csmr_ACFind #x21F)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACFindandReplace #x220);   Selector  
(defconstant $kHIDUsage_Csmr_ACSearch #x221)    ;   Selector  
(defconstant $kHIDUsage_Csmr_ACGoTo #x222)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACHome #x223)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACBack #x224)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACForward #x225)   ;   Selector  
(defconstant $kHIDUsage_Csmr_ACStop #x226)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACRefresh #x227)   ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPreviousLink #x228);   Selector  
(defconstant $kHIDUsage_Csmr_ACNextLink #x229)  ;   Selector  
(defconstant $kHIDUsage_Csmr_ACBookmarks #x22A) ;   Selector  
(defconstant $kHIDUsage_Csmr_ACHistory #x22B)   ;   Selector  
(defconstant $kHIDUsage_Csmr_ACSubscriptions #x22C);   Selector  
(defconstant $kHIDUsage_Csmr_ACZoomIn #x22D)    ;   Selector  
(defconstant $kHIDUsage_Csmr_ACZoomOut #x22E)   ;   Selector  
(defconstant $kHIDUsage_Csmr_ACZoom #x22F)      ;   Selector  
(defconstant $kHIDUsage_Csmr_ACFullScreenView #x230);   Selector  
(defconstant $kHIDUsage_Csmr_ACNormalView #x231);   Selector  
(defconstant $kHIDUsage_Csmr_ACViewToggle #x232);   Selector  
(defconstant $kHIDUsage_Csmr_ACScrollUp #x233)  ;   Selector  
(defconstant $kHIDUsage_Csmr_ACScrollDown #x234);   Selector  
(defconstant $kHIDUsage_Csmr_ACScroll #x235)    ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPanLeft #x236)   ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPanRight #x237)  ;   Selector  
(defconstant $kHIDUsage_Csmr_ACPan #x238)       ;   Selector  
(defconstant $kHIDUsage_Csmr_ACNewWindow #x239) ;   Selector  
(defconstant $kHIDUsage_Csmr_ACTileHorizontally #x23A);   Selector  
(defconstant $kHIDUsage_Csmr_ACTileVertically #x23B);   Selector  
(defconstant $kHIDUsage_Csmr_ACFormat #x23C)    ;   Selector  
;   0x23D - 0xFFFF Reserved  
(defconstant $kHIDUsage_Csmr_Reserved #xFFFF)

; 	 Digitizer Page (0x0D) 	
; 	 This section provides detailed descriptions of the usages employed by Digitizer Devices. 	
(defconstant $kHIDUsage_Dig_Digitizer #x1)      ;   Application Collection  
(defconstant $kHIDUsage_Dig_Pen #x2)            ;   Application Collection  
(defconstant $kHIDUsage_Dig_LightPen #x3)       ;   Application Collection  
(defconstant $kHIDUsage_Dig_TouchScreen #x4)    ;   Application Collection  
(defconstant $kHIDUsage_Dig_TouchPad #x5)       ;   Application Collection  
(defconstant $kHIDUsage_Dig_WhiteBoard #x6)     ;   Application Collection  
(defconstant $kHIDUsage_Dig_CoordinateMeasuringMachine #x7);   Application Collection  
(defconstant $kHIDUsage_Dig_3DDigitizer #x8)    ;   Application Collection  
(defconstant $kHIDUsage_Dig_StereoPlotter #x9)  ;   Application Collection  
(defconstant $kHIDUsage_Dig_ArticulatedArm #xA) ;   Application Collection  
(defconstant $kHIDUsage_Dig_Armature #xB)       ;   Application Collection  
(defconstant $kHIDUsage_Dig_MultiplePointDigitizer #xC);   Application Collection  
(defconstant $kHIDUsage_Dig_FreeSpaceWand #xD)  ;   Application Collection  
;   0x0E - 0x1F Reserved  
(defconstant $kHIDUsage_Dig_Stylus #x20)        ;   Logical Collection  
(defconstant $kHIDUsage_Dig_Puck #x21)          ;   Logical Collection  
(defconstant $kHIDUsage_Dig_Finger #x22)        ;   Logical Collection  
;   0x23 - 0x2F Reserved  
(defconstant $kHIDUsage_Dig_TipPressure #x30)   ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_BarrelPressure #x31);   Dynamic Value  
(defconstant $kHIDUsage_Dig_InRange #x32)       ;   Momentary Control  
(defconstant $kHIDUsage_Dig_Touch #x33)         ;   Momentary Control  
(defconstant $kHIDUsage_Dig_Untouch #x34)       ;   One-Shot Control  
(defconstant $kHIDUsage_Dig_Tap #x35)           ;   One-Shot Control  
(defconstant $kHIDUsage_Dig_Quality #x36)       ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_DataValid #x37)     ;   Momentary Control  
(defconstant $kHIDUsage_Dig_TransducerIndex #x38);   Dynamic Value  
(defconstant $kHIDUsage_Dig_TabletFunctionKeys #x39);   Logical Collection  
(defconstant $kHIDUsage_Dig_ProgramChangeKeys #x3A);   Logical Collection  
(defconstant $kHIDUsage_Dig_BatteryStrength #x3B);   Dynamic Value  
(defconstant $kHIDUsage_Dig_Invert #x3C)        ;   Momentary Control  
(defconstant $kHIDUsage_Dig_XTilt #x3D)         ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_YTilt #x3E)         ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_Azimuth #x3F)       ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_Altitude #x40)      ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_Twist #x41)         ;   Dynamic Value  
(defconstant $kHIDUsage_Dig_TipSwitch #x42)     ;   Momentary Control  
(defconstant $kHIDUsage_Dig_SecondaryTipSwitch #x43);   Momentary Control  
(defconstant $kHIDUsage_Dig_BarrelSwitch #x44)  ;   Momentary Control  
(defconstant $kHIDUsage_Dig_Eraser #x45)        ;   Momentary Control  
(defconstant $kHIDUsage_Dig_TabletPick #x46)    ;   Momentary Control  
;   0x47 - 0xFFFF Reserved  
(defconstant $kHIDUsage_Dig_Reserved #xFFFF)

; 	 AlphanumericDisplay Page (0x14) 	
; 	 The Alphanumeric Display page is intended for use by simple alphanumeric displays that are used on consumer devices. 	
(defconstant $kHIDUsage_AD_AlphanumericDisplay #x1);   Application Collection  
;   0x02 - 0x1F Reserved  
(defconstant $kHIDUsage_AD_DisplayAttributesReport #x20);   Logical Collection  
(defconstant $kHIDUsage_AD_ASCIICharacterSet #x21);   Static Flag  
(defconstant $kHIDUsage_AD_DataReadBack #x22)   ;   Static Flag  
(defconstant $kHIDUsage_AD_FontReadBack #x23)   ;   Static Flag  
(defconstant $kHIDUsage_AD_DisplayControlReport #x24);   Logical Collection  
(defconstant $kHIDUsage_AD_ClearDisplay #x25)   ;   Dynamic Flag  
(defconstant $kHIDUsage_AD_DisplayEnable #x26)  ;   Dynamic Flag  
(defconstant $kHIDUsage_AD_ScreenSaverDelay #x27);   Static Value  
(defconstant $kHIDUsage_AD_ScreenSaverEnable #x28);   Dynamic Flag  
(defconstant $kHIDUsage_AD_VerticalScroll #x29) ;   Static Flag  
(defconstant $kHIDUsage_AD_HorizontalScroll #x2A);   Static Flag  
(defconstant $kHIDUsage_AD_CharacterReport #x2B);   Logical Collection  
(defconstant $kHIDUsage_AD_DisplayData #x2C)    ;   Dynamic Value  
(defconstant $kHIDUsage_AD_DisplayStatus #x2D)  ;   Logical Collection  
(defconstant $kHIDUsage_AD_StatNotReady #x2E)   ;   Selector  
(defconstant $kHIDUsage_AD_StatReady #x2F)      ;   Selector  
(defconstant $kHIDUsage_AD_ErrNotaloadablecharacter #x30);   Selector  
(defconstant $kHIDUsage_AD_ErrFontdatacannotberead #x31);   Selector  
(defconstant $kHIDUsage_AD_CursorPositionReport #x32);   Logical Collection  
(defconstant $kHIDUsage_AD_Row #x33)            ;   Dynamic Value  
(defconstant $kHIDUsage_AD_Column #x34)         ;   Dynamic Value  
(defconstant $kHIDUsage_AD_Rows #x35)           ;   Static Value  
(defconstant $kHIDUsage_AD_Columns #x36)        ;   Static Value  
(defconstant $kHIDUsage_AD_CursorPixelPositioning #x37);   Static Flag  
(defconstant $kHIDUsage_AD_CursorMode #x38)     ;   Dynamic Flag  
(defconstant $kHIDUsage_AD_CursorEnable #x39)   ;   Dynamic Flag  
(defconstant $kHIDUsage_AD_CursorBlink #x3A)    ;   Dynamic Flag  
(defconstant $kHIDUsage_AD_FontReport #x3B)     ;   Logical Collection  
(defconstant $kHIDUsage_AD_FontData #x3C)       ;   Buffered Byte  
(defconstant $kHIDUsage_AD_CharacterWidth #x3D) ;   Static Value  
(defconstant $kHIDUsage_AD_CharacterHeight #x3E);   Static Value  
(defconstant $kHIDUsage_AD_CharacterSpacingHorizontal #x3F);   Static Value  
(defconstant $kHIDUsage_AD_CharacterSpacingVertical #x40);   Static Value  
(defconstant $kHIDUsage_AD_UnicodeCharacterSet #x41);   Static Flag  
;   0x42 - 0xFFFF Reserved  
(defconstant $kHIDUsage_AD_Reserved #xFFFF)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := HIDIncludes

; $ENDC                                         ; __HID__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'HID)