(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:InternetConfig.p"
; at Wednesday May 1,2002 2:41:01 pm.
; 
;      File:       InternetConfig.p
;  
;      Contains:   Internet Config interfaces
;  
;      Version:    Technology: based on IC 2.5 alpha
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
; *********************************************************************************************

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __INTERNETCONFIG__
; $SETC __INTERNETCONFIG__ := 1

; $I+
; $SETC InternetConfigIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __ALIASES__
|#

(require-interface 'Aliases)
#|                                              ; $I Aliases.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ***********************************************************************************************
;   IC error codes
;  ***********************************************************************************************

(defconstant $icPrefNotFoundErr -666)           ;   preference not found (duh!)   
(defconstant $icPermErr -667)                   ;   cannot set preference   
(defconstant $icPrefDataErr -668)               ;   problem with preference data   
(defconstant $icInternalErr -669)               ;   hmm, this is not good   
(defconstant $icTruncatedErr -670)              ;   more data was present than was returned   
(defconstant $icNoMoreWritersErr -671)          ;   you cannot begin a write session because someone else is already doing it   
(defconstant $icNothingToOverrideErr -672)      ;   no component for the override component to capture   
(defconstant $icNoURLErr -673)                  ;   no URL found   
(defconstant $icConfigNotFoundErr -674)         ;   no configuration was found   
(defconstant $icConfigInappropriateErr -675)    ;   incorrect manufacturer code   
(defconstant $icProfileNotFoundErr -676)        ;   profile not found   
(defconstant $icTooManyProfilesErr -677)        ;   too many profiles in database   

; 	***********************************************************************************************
; 	  IC versions (not necessarily, but historically, from a component)
; 	 ***********************************************************************************************	

(defconstant $kICComponentInterfaceVersion0 #x0);   IC >= 1.0   
(defconstant $kICComponentInterfaceVersion1 #x10000);   IC >= 1.1   
(defconstant $kICComponentInterfaceVersion2 #x20000);   IC >= 1.2   
(defconstant $kICComponentInterfaceVersion3 #x30000);   IC >= 2.0   
(defconstant $kICComponentInterfaceVersion4 #x40000);   IC >= 2.5   
(defconstant $kICComponentInterfaceVersion #x40000);   current version number is 4   

; 	***********************************************************************************************
; 	  opaque type for preference reference
; 	 ***********************************************************************************************	

(def-mactype :icinstance (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :icinstanceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ICInstance parameter can be nil, it is changed to xx: ICInstancePtr 

; 	***********************************************************************************************
; 	  a record that specifies a folder, an array of such records, and a pointer to such an array
; 	 ***********************************************************************************************	
(def-mactype :icdirspecptr (find-mactype '(:pointer :icdirspec)))
(defrecord ICDirSpec 
   (vRefNum :signed-integer)
   (dirID :signed-long)
   )

(defrecord ICDirSpecArray (array (:array :icdirspec 4)))
(def-mactype :icdirspecarrayptr (find-mactype '(:pointer :icdirspecarray)))

; 	***********************************************************************************************
; 	  preference attributes type, bit number constants, and mask constants
; 	 ***********************************************************************************************	
(def-mactype :icattr (find-mactype ':unsigned-long))

(defconstant $kICAttrLockedBit 0)
(defconstant $kICAttrVolatileBit 1)

(defconstant $kICAttrNoChange #xFFFFFFFF)       ;   pass this to ICSetPref to tell it not to change the attributes   
(defconstant $kICAttrLockedMask #x1)
(defconstant $kICAttrVolatileMask #x2)

; 	***********************************************************************************************
; 	  permissions for use with ICBegin
; 	 ***********************************************************************************************	

(def-mactype :icperm (find-mactype ':unsigned-byte))

(defconstant $icNoPerm 0)
(defconstant $icReadOnlyPerm 1)
(defconstant $icReadWritePerm 2)

; 	***********************************************************************************************
; 	  a reference to an instance's current configuration
; 	 ***********************************************************************************************	

; $IFC CALL_NOT_IN_CARBON 

(def-mactype :icconfigrefptr (find-mactype '(:pointer :icconfigref)))
(defrecord ICConfigRef 
   (manufacturer :ostype)
;   other private data follows   
   )

(def-mactype :icconfigrefhandle (find-mactype '(:handle :icconfigref)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; ***********************************************************************************************
;   profile IDs
;  ***********************************************************************************************

(def-mactype :icprofileid (find-mactype ':signed-long))
(def-mactype :icprofileidptr (find-mactype '(:pointer :signed-long)))

(defconstant $kICNilProfileID 0)

; 	***********************************************************************************************
; 	  other constants
; 	 ***********************************************************************************************	

(defconstant $kICNoUserInteractionBit 0)

(defconstant $kICNoUserInteractionMask #x1)

(defconstant $kICFileType :|ICAp|)
(defconstant $kICCreator :|ICAp|)

; 	***********************************************************************************************
; 	  Apple event constants
; 	 ***********************************************************************************************	

(defconstant $kInternetEventClass :|GURL|)
(defconstant $kAEGetURL :|GURL|)
(defconstant $kAEFetchURL :|FURL|)
(defconstant $keyAEAttaching :|Atch|)

; 	 AERegistry.i defines a compatible keyAEDestination 	

(defconstant $kICEditPreferenceEventClass :|ICAp|)
(defconstant $kICEditPreferenceEvent :|ICAp|)
(defconstant $keyICEditPreferenceDestination :|dest|)

; 	***********************************************************************************************
; 	  constants for use with ICGetVersion
; 	 ***********************************************************************************************	

(defconstant $kICComponentVersion 0)            ;   Return a component version, comparable to kICComponentInterfaceVersion   
(defconstant $kICNumVersion 1)                  ;   Return a NumVersion structure   

; 	***********************************************************************************************
; 	  types and constants for use with kICDocumentFont, et. al.
; 	 ***********************************************************************************************	

(def-mactype :icfontrecordptr (find-mactype '(:pointer :icfontrecord)))
(defrecord ICFontRecord 
   (size :signed-integer)
   (face :signed-byte)
   (pad :signed-byte)
   (font (:string 255))
   )

(def-mactype :icfontrecordhandle (find-mactype '(:handle :icfontrecord)))

; 	***********************************************************************************************
; 	  types and constants for use with kICCharacterSet, et. al.
; 	 ***********************************************************************************************	
(def-mactype :icchartableptr (find-mactype '(:pointer :icchartable)))
(defrecord ICCharTable 
   (netToMac (:array :unsigned-byte 256 :packed))
   (macToNet (:array :unsigned-byte 256 :packed))
   )

(def-mactype :icchartablehandle (find-mactype '(:handle :icchartable)))

; 	***********************************************************************************************
; 	  types and constants for use with kICHelper, et. al.
; 	 ***********************************************************************************************	
(def-mactype :icappspecptr (find-mactype '(:pointer :icappspec)))
(defrecord ICAppSpec 
   (fCreator :ostype)
   (name (:string 63))
   )

(def-mactype :icappspechandle (find-mactype '(:handle :icappspec)))
(def-mactype :icappspeclistptr (find-mactype '(:pointer :icappspeclist)))
(defrecord ICAppSpecList 
   (numberOfItems :signed-integer)
   (appSpecs (:array :icappspec 1))
   )

(def-mactype :icappspeclisthandle (find-mactype '(:handle :icappspeclist)))

; 	***********************************************************************************************
; 	  types and constants for use with kICDownloadFolder, et. al.
; 	 ***********************************************************************************************	

#|                                              ; $IFC NOT OLDROUTINENAMES 
(def-mactype :icfilespecptr (find-mactype '(:pointer :icfilespec)))
(defrecord ICFileSpec 
   (volName (:string 31))
   (volCreationDate :signed-long)
   (fss :fsspec)
   (alias :aliasrecord)
;   plus extra data, aliasSize 0 means no alias manager present when 
;   ICFileSpecification was created 
   )

(def-mactype :icfilespechandle (find-mactype '(:pointer :icfilespecptr)))
 |#                                             ; $ELSEC
(def-mactype :icfilespecptr (find-mactype '(:pointer :icfilespec)))
(defrecord ICFileSpec 
   (vol_name (:string 31))
   (vol_creation_date :signed-long)
   (fss :fsspec)
   (alias :aliasrecord)
   )

(def-mactype :icfilespechandle (find-mactype '(:handle :icfilespec)))
; $ENDC

(defconstant $kICFileSpecHeaderSize 106)

; 	***********************************************************************************************
; 	  types and constants for use with ICMapFilename, et. al.
; 	 ***********************************************************************************************	

(def-mactype :icmapentryflags (find-mactype ':signed-long))
(def-mactype :icfixedlength (find-mactype ':signed-integer))

#|                                              ; $IFC NOT OLDROUTINENAMES 
(def-mactype :icmapentryptr (find-mactype '(:pointer :icmapentry)))
(defrecord ICMapEntry 
   (totalLength :signed-integer)
   (fixedLength :signed-integer)
   (version :signed-integer)
   (fileType :ostype)
   (fileCreator :ostype)
   (postCreator :ostype)
   (flags :signed-long)
;   variable part starts here 
   (extension (:string 255))
   (creatorAppName (:string 255))
   (postAppName (:string 255))
   (MIMEType (:string 255))
   (entryName (:string 255))
   )

(def-mactype :icmapentryhandle (find-mactype '(:pointer :icmapentryptr)))

 |#                                             ; $ELSEC
(def-mactype :icmapentryptr (find-mactype '(:pointer :icmapentry)))
(defrecord ICMapEntry 
   (total_length :signed-integer)
   (fixed_length :signed-integer)
   (version :signed-integer)
   (file_type :ostype)
   (file_creator :ostype)
   (post_creator :ostype)
   (flags :signed-long)
   (extension (:string 255))
   (creator_app_name (:string 255))
   (post_app_name (:string 255))
   (MIME_type (:string 255))
   (entry_name (:string 255))
   )

(def-mactype :icmapentryhandle (find-mactype '(:handle :icmapentry)))
; $ENDC

(defconstant $kICMapFixedLength 22)             ;   number in fixedLength field 

(defconstant $kICMapBinaryBit 0)                ;   file should be transfered in binary as opposed to text mode 
(defconstant $kICMapResourceForkBit 1)          ;   the resource fork of the file is significant 
(defconstant $kICMapDataForkBit 2)              ;   the data fork of the file is significant 
(defconstant $kICMapPostBit 3)                  ;   post process using post fields 
(defconstant $kICMapNotIncomingBit 4)           ;   ignore this mapping for incoming files 
(defconstant $kICMapNotOutgoingBit 5)           ;   ignore this mapping for outgoing files 

(defconstant $kICMapBinaryMask #x1)             ;   file should be transfered in binary as opposed to text mode 
(defconstant $kICMapResourceForkMask #x2)       ;   the resource fork of the file is significant 
(defconstant $kICMapDataForkMask #x4)           ;   the data fork of the file is significant 
(defconstant $kICMapPostMask #x8)               ;   post process using post fields 
(defconstant $kICMapNotIncomingMask #x10)       ;   ignore this mapping for incoming files 
(defconstant $kICMapNotOutgoingMask #x20)       ;   ignore this mapping for outgoing files 

; 	***********************************************************************************************
; 	  types and constants for use with kICServices, et. al.
; 	 ***********************************************************************************************	

(def-mactype :icserviceentryflags (find-mactype ':signed-integer))
(def-mactype :icserviceentryptr (find-mactype '(:pointer :icserviceentry)))
(defrecord ICServiceEntry 
   (name (:string 255))
   (port :signed-integer)
   (flags :signed-integer)
   )

(def-mactype :icserviceentryhandle (find-mactype '(:handle :icserviceentry)))

(defconstant $kICServicesTCPBit 0)
(defconstant $kICServicesUDPBit 1)              ;   both bits can be set, which means the service is both TCP and UDP, eg daytime 

(defconstant $kICServicesTCPMask #x1)
(defconstant $kICServicesUDPMask #x2)           ;   both bits can be set, which means the service is both TCP and UDP, eg daytime 

(def-mactype :icservicesptr (find-mactype '(:pointer :icservices)))
(defrecord ICServices 
   (count :signed-integer)
   (services (:array :icserviceentry 1))
   )

(def-mactype :icserviceshandle (find-mactype '(:handle :icservices)))

; 	***********************************************************************************************
; 	  default file name, for internal use, overridden by a component resource
; 	 ***********************************************************************************************	

; $IFC CALL_NOT_IN_CARBON 

(defconstant $kICDefaultFileName "Internet Preferences")
; $ENDC                                         ; CALL_NOT_IN_CARBON

; ***********************************************************************************************
;   keys
;  ***********************************************************************************************
;  
;     key reserved for use by Internet Config 
; 

(defconstant $kICReservedKey "kICReservedKey")
; 	
; 	    STR# -- formatted, list of Archie servers  
; 		
(defconstant $kICArchieAll "ArchieAll")
; 	
; 	    PString -- formatted, preferred Archie server   
; 		
(defconstant $kICArchiePreferred "ArchiePreferred")
; 	
; 	    ICCharTable -- Mac-to-Net and Net-to-Mac character translation   
; 		
(defconstant $kICCharacterSet "CharacterSet")
; 	
; 	    ICFontRecord -- font used for proportional text   
; 		
(defconstant $kICDocumentFont "DocumentFont")
; 	
; 	    ICFileSpec -- where to put newly downloaded files   
; 		
(defconstant $kICDownloadFolder "DownloadFolder")
; 	
; 	    PString -- user@host.domain, email address of user, ie return address   
; 		
(defconstant $kICEmail "Email")
; 	
; 	    PString -- host.domain, default FTP server   
; 		
(defconstant $kICFTPHost "FTPHost")
; 	
; 	    PString -- second level FTP proxy authorisation   
; 		
(defconstant $kICFTPProxyAccount "FTPProxyAccount")
; 	
; 	    PString -- host.domain   
; 		
(defconstant $kICFTPProxyHost "FTPProxyHost")
; 	
; 	    PString -- scrambled, password for FTPProxyUser   
; 		
(defconstant $kICFTPProxyPassword "FTPProxyPassword")
; 	
; 	    PString -- first level FTP proxy authorisation   
; 		
(defconstant $kICFTPProxyUser "FTPProxyUser")
; 	
; 	    PString -- host.domain, default finger server   
; 		
(defconstant $kICFingerHost "FingerHost")
; 	
; 	    PString -- host.domain, default Gopher server   
; 		
(defconstant $kICGopherHost "GopherHost")
; 	
; 	    PString -- host.domain, see note in Prog Docs   
; 		
(defconstant $kICGopherProxy "GopherProxy")
; 	
; 	    PString -- host.domain   
; 		
(defconstant $kICHTTPProxyHost "HTTPProxyHost")
; 	
; 	    ICAppSpec -- helpers for URL schemes   
; 		
(defconstant $kICHelper "Helper")
; 	
; 	    PString -- description for URL scheme   
; 		
(defconstant $kICHelperDesc "HelperDesc")
; 	
; 	    ICAppSpecList -- list of common helpers for URL schemes   
; 		
(defconstant $kICHelperList "HelperList")
; 	
; 	    PString -- host.domain, Internet Relay Chat server   
; 		
(defconstant $kICIRCHost "IRCHost")
; 	
; 	    STR# -- formatted, list of Info-Mac servers   
; 		
(defconstant $kICInfoMacAll "InfoMacAll")
; 	
; 	    PString -- formatted, preferred Info-Mac server   
; 		
(defconstant $kICInfoMacPreferred "InfoMacPreferred")
; 	
; 	    PString -- string LDAP thing   
; 		
(defconstant $kICLDAPSearchbase "LDAPSearchbase")
; 	
; 	    PString -- host.domain   
; 		
(defconstant $kICLDAPServer "LDAPServer")
; 	
; 	    ICFontRecord -- font used for lists of items (eg news article lists)   
; 		
(defconstant $kICListFont "ListFont")
; 	
; 	    PString -- host for MacSearch queries   
; 		
(defconstant $kICMacSearchHost "MacSearchHost")
; 	
; 	    PString -- user@host.domain, account from which to fetch mail   
; 		
(defconstant $kICMailAccount "MailAccount")
; 	
; 	    TEXT -- extra headers for mail messages   
; 		
(defconstant $kICMailHeaders "MailHeaders")
; 	
; 	    PString -- scrambled, password for MailAccount   
; 		
(defconstant $kICMailPassword "MailPassword")
; 	
; 	    ICMapEntries -- file type mapping, see documentation   
; 		
(defconstant $kICMapping "Mapping")
; 	
; 	    PString -- host.domain, NNTP server   
; 		
(defconstant $kICNNTPHost "NNTPHost")
; 	
; 	    PString -- host.domain, Network Time Protocol (NTP)   
; 		
(defconstant $kICNTPHost "NTPHost")
; 	
; 	    Boolean   
; 		
(defconstant $kICNewMailDialog "NewMailDialog")
; 	
; 	    Boolean -- how to announce new mail   
; 		
(defconstant $kICNewMailFlashIcon "NewMailFlashIcon")
; 	
; 	    Boolean   
; 		
(defconstant $kICNewMailPlaySound "NewMailPlaySound")
; 	
; 	    PString   
; 		
(defconstant $kICNewMailSoundName "NewMailSoundName")
; 	
; 	    PString -- scrambled, password for NewsAuthUsername   
; 		
(defconstant $kICNewsAuthPassword "NewsAuthPassword")
; 	
; 	    PString -- user name for authorised news servers   
; 		
(defconstant $kICNewsAuthUsername "NewsAuthUsername")
; 	
; 	    TEXT -- extra headers for news messages   
; 		
(defconstant $kICNewsHeaders "NewsHeaders")
; 	
; 	    STR# -- list of domains not to be proxied   
; 		
(defconstant $kICNoProxyDomains "NoProxyDomains")
; 	
; 	    PString -- for X-Organization string   
; 		
(defconstant $kICOrganization "Organization")
; 	
; 	    PString -- host.domain, default Ph server   
; 		
(defconstant $kICPhHost "PhHost")
; 	
; 	    TEXT -- default response for finger servers   
; 		
(defconstant $kICPlan :|Plan|)
; 	
; 	    ICFontRecord -- font used to print ScreenFont   
; 		
(defconstant $kICPrinterFont "PrinterFont")
; 	
; 	    PString -- used to quote responses in news and mail   
; 		
(defconstant $kICQuotingString "QuotingString")
; 	
; 	    PString -- real name of user   
; 		
(defconstant $kICRealName "RealName")
; 	
; 	    PString -- RTSP Proxy Host
; 		
(defconstant $kICRTSPProxyHost "RTSPProxyHost")
; 	
; 	    PString -- host.domain, SMTP server   
; 		
(defconstant $kICSMTPHost "SMTPHost")
; 	
; 	    ICFontRecord -- font used for monospaced text (eg news articles)   
; 		
(defconstant $kICScreenFont "ScreenFont")
; 	
; 	    ICServices -- TCP and IP port-to-name mapping   
; 		
(defconstant $kICServices "Services")
; 	
; 	    TEXT -- append to news and mail messages   
; 		
(defconstant $kICSignature "Signature")
; 	
; 	    TEXT -- preferred mailing address   
; 		
(defconstant $kICSnailMailAddress "SnailMailAddress")
; 	
; 	    PString -- host.domain, remember that host.domain format allows ":port" and " port"  
; 		
(defconstant $kICSocksHost "SocksHost")
; 	
; 	    PString -- host.domain, default Telnet address   
; 		
(defconstant $kICTelnetHost "TelnetHost")
; 	
; 	    STR# -- formatted, list of UMich servers   
; 		
(defconstant $kICUMichAll "UMichAll")
; 	
; 	    PString -- formatted, preferred UMich server   
; 		
(defconstant $kICUMichPreferred "UMichPreferred")
; 	
; 	    Boolean   
; 		
(defconstant $kICUseFTPProxy "UseFTPProxy")
; 	
; 	    Boolean   
; 		
(defconstant $kICUseGopherProxy "UseGopherProxy")
; 	
; 	    Boolean   
; 		
(defconstant $kICUseHTTPProxy "UseHTTPProxy")
; 	
; 	    Boolean -- use PASV command for FTP transfers   
; 		
(defconstant $kICUsePassiveFTP "UsePassiveFTP")
; 	
; 	    Boolean
; 		
(defconstant $kICUseRTSPProxy "UseRTSPProxy")
; 	
; 	    Boolean   
; 		
(defconstant $kICUseSocks "UseSocks")
; 	
; 	    PString -- no idea   
; 		
(defconstant $kICWAISGateway "WAISGateway")
; 	
; 	    PString -- URL, users default WWW page   
; 		
(defconstant $kICWWWHomePage "WWWHomePage")
; 	
; 	    RGBColor -- background colour for web pages   
; 		
(defconstant $kICWebBackgroundColour "WebBackgroundColour")
; 	
; 	    RGBColor -- colour for read links   
; 		
(defconstant $kICWebReadColor "646F6777WebReadColor")
; 	
; 	    PString -- URL, users default search page   
; 		
(defconstant $kICWebSearchPagePrefs "WebSearchPagePrefs")
; 	
; 	    RGBColor -- colour for normal text   
; 		
(defconstant $kICWebTextColor "WebTextColor")
; 	
; 	    Boolean -- whether to underline links   
; 		
(defconstant $kICWebUnderlineLinks "646F6777WebUnderlineLinks")
; 	
; 	    RGBColor -- colour for unread links   
; 		
(defconstant $kICWebUnreadColor "646F6777WebUnreadColor")
; 	
; 	    PString -- host.domain, default whois server   
; 		
(defconstant $kICWhoisHost "WhoisHost")

; 	***********************************************************************************************
; 	
; 	      FUNCTIONS
; 	
; 	      What do the annotations after each API mean?
; 	      --------------------------------------------
; 	
; 	      [r1] Requires IC 1.1 or higher.
; 	      [r2] Requires IC 1.2 or higher.
; 	      [r3] Requires IC 2.0 or higher.
; 	      [r4] Requires IC 2.5 or higher.
; 	      
; 	      IMPORTANT:
; 	
; 	      In IC 2.5, instances automatically use the default configuration.
; 	      You no longer need to configure an instance explicitly, except
; 	      if your code might run with an older version of IC.  So the following
; 	      notes only apply to IC 2.0 and earlier.
; 	
; 	      [c1]  You must have specified a configuration before calling this routine.
; 	      
; 	      [c2]  You must have specified the default configuration before calling this
; 	            routine.
; 	      
; 	      [c3]  You do not need to specify a configuration before calling this routine.
; 	      
; 	      [b1]  You must be inside a Begin/End pair when calling this routine.
; 	      
; 	      [b2]  You must be inside a Begin/End read/write pair when calling this routine.
; 	      
; 	      [b3]  You do not need to be inside a Begin/End pair when calling this routine.
; 	      
; 	      [b4]  If you are getting or setting multiple preferences, you should make this
; 	            call inside a Begin/End pair. If you do not make this call inside a Begin/End
; 	            pair, the call will automatically do it for you.
; 	      
; 	      [b5]  It is illegal to call this routine inside a Begin/End pair.
; 	
; 	 ***********************************************************************************************	

; 	 ***** Starting Up and Shutting Down *****  	
; 
; 	 *  ICStart()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InternetConfig 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  Call this at application initialisation. Set signature to a value
;    * which has been regsitered with DTS to allow for future expansion
;    * of the IC system. Returns inst as a connection to the IC system.
;                                               ; 
;  *  ICStop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICStart" 
      ((inst (:pointer :pointer)) (signature :ostype)) 
  :osstatus
   () )                                         ;  [b5] 
;    * Call this at application initialisation, after which inst
;    * is no longer valid connection to IC.
;                                               ; 
;  *  ICGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICStop" 
      ((inst :pointer)) 
  :osstatus
   () )
(deftrap "_ICGetVersion" 
      ((inst :pointer) (whichVersion :signed-long) (version (:pointer :unsigned-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst whichVersion version ((+ (ash 8 16) 50) :signed-longint)))

;  [r4] [c3] [b3] 
;    * Returns the version of Internet Config.  Pass kICComponentVersion
;    * to get the version as previously returned by GetComponenVerson.
;    * Pass kICNumVersion to get a NumVersion structure.
;    
;  ***** Specifying a Configuration *****  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ICFindConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICFindConfigFile" 
      ((inst :pointer) (count :signed-integer) (folders (:pointer :icdirspecarray)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count folders ((+ (ash 6 16) 2) :signed-longint)))

;  [b5] 
;    * Call to configure this connection to IC.
;    * Set count as the number of valid elements in folders.
;    * Set folders to a pointer to the folders to search.
;    * Setting count to 0 and folders to nil is OK.
;    * Searches the specified folders and then the Preferences folder
;    * in a unspecified manner.
;    
; 
;  *  ICFindUserConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICFindUserConfigFile" 
      ((inst :pointer) (where (:pointer :icdirspec)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst where ((+ (ash 4 16) 14) :signed-longint)))

;  [r1] [b5] 
;    * Similar to ICFindConfigFile except that it only searches the folder
;    * specified in where.  If the input parameters are valid the routine
;    * will always successful configure the instance, creating an
;    * empty configuration if necessary
;    * For use with double-clickable preference files.
;    
; 
;  *  ICGeneralFindConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICGeneralFindConfigFile" 
      ((inst :pointer) (searchPrefs :boolean) (canCreate :boolean) (count :signed-integer) (folders (:pointer :icdirspecarray)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst searchPrefs canCreate count folders ((+ (ash 10 16) 30) :signed-longint)))

;  [r2] [b5] 
;    * Call to configure this connection to IC.
;    * This routine acts as a more general replacement for
;    * ICFindConfigFile and ICFindUserConfigFile.
;    * Set search_prefs to true if you want it to search the preferences folder.
;    * Set can_create to true if you want it to be able to create a new config.
;    * Set count as the number of valid elements in folders.
;    * Set folders to a pointer to the folders to search.
;    * Setting count to 0 and folders to nil is OK.
;    * Searches the specified folders and then optionally the Preferences folder
;    * in a unspecified manner.
;    
; 
;  *  ICChooseConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICChooseConfig" 
      ((inst :pointer))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 33) :signed-longint)))

;  [r2] [b5] 
;    * Requests the user to choose a configuration, typically using some
;    * sort of modal dialog. If the user cancels the dialog the configuration
;    * state will be unaffected.
;    
; 
;  *  ICChooseNewConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICChooseNewConfig" 
      ((inst :pointer))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 34) :signed-longint)))

;  [r2] [b5] 
;    * Requests the user to create a new configuration, typically using some
;    * sort of modal dialog. If the user cancels the dialog the configuration
;    * state will be unaffected.
;    
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ICGetConfigName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetConfigName" 
      ((inst :pointer) (longname :boolean) (name (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst longname name ((+ (ash 6 16) 35) :signed-longint)))

;  [r2] [c1] [b3] 
;    * Returns a string that describes the current configuration at a user
;    * level. Set longname to true if you want a long name, up to 255
;    * characters, or false if you want a short name, typically about 32
;    * characters.
;    * The returned string is for user display only. If you rely on the
;    * exact format of it, you will conflict with any future IC
;    * implementation that doesn't use explicit preference files.
;    
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ICGetConfigReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICGetConfigReference" 
      ((inst :pointer) (ref (:handle :icconfigref)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ref ((+ (ash 4 16) 31) :signed-longint)))

;  [r2] [c1] [b3] 
;    * Returns a self-contained reference to the instance's current
;    * configuration.
;    * ref must be a valid non-nil handle and it will be resized to fit the
;    * resulting data.
;    
; 
;  *  ICSetConfigReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICSetConfigReference" 
      ((inst :pointer) (ref (:handle :icconfigref)) (flags :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ref flags ((+ (ash 8 16) 32) :signed-longint)))

;  [r2] [b5] 
;    * Reconfigures the instance using a configuration reference that was
;    * got using ICGetConfigReference reference. Set the
;    * icNoUserInteraction_bit in flags if you require that this routine
;    * not present a modal dialog. Other flag bits are reserved and should
;    * be set to zero.
;    * ref must not be nil.
;    
;  ***** Private Routines *****
;  * 
;  * If you are calling these routines, you are most probably doing something
;  * wrong.  Please read the documentation for more details.
;   
; 
;  *  ICSpecifyConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICSpecifyConfigFile" 
      ((inst :pointer) (config (:pointer :fsspec)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst config ((+ (ash 4 16) 3) :signed-longint)))

;  [b5] 
;    * For use only by the IC application.
;    * If you call this routine yourself, you will conflict with any
;    * future IC implementation that doesn't use explicit preference files.
;    
; 
;  *  ICRefreshCaches()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICRefreshCaches" 
      ((inst :pointer))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 47) :signed-longint)))

;  [r3] [c1] [b3] 
;    * For use only by the IC application.
;    * If you call this routine yourself, you will conflict with any
;    * future IC implementation that doesn't use explicit preference files.
;    
;  ***** Getting Information *****  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ICGetSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetSeed" 
      ((inst :pointer) (seed (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst seed ((+ (ash 4 16) 4) :signed-longint)))

;  [c3] [b3] 
;    * Returns the current seed for the IC prefs database.
;    * This seed changes each time a non-volatile preference is changed.
;    * You can poll this to determine if any cached preferences change.
;    
; 
;  *  ICGetPerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetPerm" 
      ((inst :pointer) (perm (:pointer :unsigned-byte)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst perm ((+ (ash 4 16) 13) :signed-longint)))

;  [c3] [b3] 
;    * Returns the access permissions currently associated with this instance.
;    * While applications normally know what permissions they have,
;    * this routine is designed for use by override components.
;    
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ICDefaultFileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICDefaultFileName" 
      ((inst :pointer) (name (:pointer (:string 63))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst name ((+ (ash 4 16) 11) :signed-longint)))

;  [c3] [b3] 
;    * Returns the default file name for IC preference files.
;    * Applications should never need to call this routine.
;    * If you rely on information returned by this routine yourself,
;    * you may conflict with any future IC implementation that doesn't use
;    * explicit preference files.
;    * The component calls this routine to set up the default IC file name.
;    * This allows this operation to be intercepted by a component that has
;    * captured us. It currently gets it from the component resource file.
;    * The glue version is hardwired to "Internet Preferences".
;    
; 
;  *  ICGetComponentInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  [c3] [b3] 
;    * Returns noErr and the connection to the IC component,
;    * if we're using the component.
;    * Returns badComponenInstance and nil if we're operating with glue.
;                                               ;  ***** Reading and Writing Preferences *****  
(deftrap-inline "_ICGetComponentInstance" 
      ((inst :pointer) (componentInst (:pointer (:pointer :componentinstancerecord)))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  ICBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICBegin" 
      ((inst :pointer) (perm :signed-byte))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst perm ((+ (ash 2 16) 5) :signed-longint)))

;  [c1] [b5] 
;    * Starting reading or writing multiple preferences.
;    * A call to this must be balanced by a call to ICEnd.
;    * Do not call WaitNextEvent between these calls.
;    * The perm specifies whether you intend to read or read/write.
;    * Only one writer is allowed per instance.
;    * Note that this may open resource files that are not closed
;    * until you call ICEnd.
;    
; 
;  *  ICGetPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetPref" 
      ((inst :pointer) (key (:string 255)) (attr (:pointer :unsigned-long)) (buf :pointer) (size (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr buf size ((+ (ash 16 16) 6) :signed-longint)))

;  [c1] [b4] 
;    * Reads the preference specified by key from the IC database to the
;    * buffer pointed to by buf and size.
;    * key must not be the empty string.
;    * If buf is nil then no data is returned.
;    * size must be non-negative.
;    * attr and size are always set on return. On errors (except icTruncatedErr)
;    * attr is set to ICattr_no_change and size is set to 0.
;    * size is the actual size of the data.
;    * attr is set to the attributes associated with the preference.
;    * If this routine returns icTruncatedErr then the other returned
;    * values are valid except that only the first size bytes have been
;    * return. size is adjusted to reflect the true size of the preference.
;    * Returns icPrefNotFound if there is no preference for the key.
;    
; 
;  *  ICSetPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICSetPref" 
      ((inst :pointer) (key (:string 255)) (attr :unsigned-long) (buf :pointer) (size :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr buf size ((+ (ash 16 16) 7) :signed-longint)))

;  [c1] [b4] 
;    * Sets the preference specified by key from the IC database to the
;    * value pointed to by buf and size.
;    * key must not be the empty string.
;    * size must be non-negative. 
;    * If buf is nil then the preference value is not set and size is ignored.
;    * If buf is not nil then the preference value is set to the size
;    * bytes pointed to by buf.
;    * If attr is ICattr_no_change then the preference attributes are not set.
;    * Otherwise the preference attributes are set to attr.
;    * Returns icPermErr if the previous ICBegin was passed icReadOnlyPerm.
;    * Returns icPermErr if current attr is locked, new attr is locked and buf <> nil.
;    
; 
;  *  ICFindPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICFindPrefHandle" 
      ((inst :pointer) (key (:string 255)) (attr (:pointer :unsigned-long)) (prefh :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 36) :signed-longint)))

;  [r2] [c1] [b4] 
;    * This routine effectively replaces ICGetPrefHandle.
;    * Reads the preference specified by key from the IC database into
;    * a handle, prefh.
;    * key must not be the empty string.
;    * attr is set to the attributes associated with the preference.
;    * You must set prefh to a non-nil handle before calling this routine.
;    * If the preference does not exist, icPrefNotFoundErr is returned.
;    
; 
;  *  ICGetPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetPrefHandle" 
      ((inst :pointer) (key (:string 255)) (attr (:pointer :unsigned-long)) (prefh (:pointer :handle)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 26) :signed-longint)))

;  [r1] [c1] [b4] 
;    * This routine is now obsolete. Use ICFindPrefHandle instead.
;    * Reads the preference specified by key from the IC database into
;    * a newly created handle, prefh.
;    * key must not be the empty string.
;    * attr is set to the attributes associated with the preference.
;    * The incoming value of prefh is ignored.
;    * A new handle is created in the current heap and returned in prefh.
;    * If the routine returns an error, prefh is set to nil.
;    * If the preference does not exist, no error is returned and prefh is set
;    * to an empty handle.
;    
; 
;  *  ICSetPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICSetPrefHandle" 
      ((inst :pointer) (key (:string 255)) (attr :unsigned-long) (prefh :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 27) :signed-longint)))

;  [r1] [c1] [b4] 
;    * Sets the preference specified by key from the IC database to the
;    * value contained in prefh.
;    * key must not be the empty string.
;    * If prefh is nil then the preference value is not set.
;    * If buf is not nil then the preference value is set to the data
;    * contained in it.
;    * If attr is ICattr_no_change then the preference attributes are not set.
;    * Otherwise the preference attributes are set to attr.
;    * Returns icPermErr if the previous ICBegin was passed icReadOnlyPerm.
;    * Returns icPermErr if current attr is locked, new attr is locked and prefh <> nil.
;    
; 
;  *  ICCountPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICCountPref" 
      ((inst :pointer) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count ((+ (ash 4 16) 8) :signed-longint)))

;  [c1] [b1] 
;    * Counts the total number of preferences.
;    * If the routine returns an error, count is set to 0.
;    
; 
;  *  ICGetIndPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetIndPref" 
      ((inst :pointer) (index :signed-long) (key (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst index key ((+ (ash 8 16) 9) :signed-longint)))

;  [c1] [b1] 
;    * Returns the key of the index'th preference.
;    * index must be positive.
;    * Returns icPrefNotFoundErr if index is greater than the total number of preferences.
;    * If the routine returns an error, key is undefined.
;    
; 
;  *  ICDeletePref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICDeletePref" 
      ((inst :pointer) (key (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key ((+ (ash 4 16) 12) :signed-longint)))

;  [c1] [b2] 
;    * Deletes the preference specified by key.
;    * key must not be the empty string.
;    * Returns icPrefNotFound if the preference specified by key is not present.
;    
; 
;  *  ICEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICEnd" 
      ((inst :pointer))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 10) :signed-longint)))

;  [c1] [b1] 
;    * Terminates a preference session, as started by ICBegin.
;    * You must have called ICBegin before calling this routine.
;    
; 
;  *  ICGetDefaultPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetDefaultPref" 
      ((inst :pointer) (key (:string 255)) (prefH :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key prefH ((+ (ash 8 16) 49) :signed-longint)))

;  [r4] [c3] [b5] 
;    * Returns a default preference value for the specified key.  You
;    * must pass in a valid prefH, which is resized to fit the data.
;    
;  ***** User Interface Stuff *****  
; 
;  *  ICEditPreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICEditPreferences" 
      ((inst :pointer) (key (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key ((+ (ash 4 16) 15) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Instructs IC to display the user interface associated with editing
;    * preferences and focusing on the preference specified by key.
;    * If key is the empty string then no preference should be focused upon.
;    * You must have specified a configuration before calling this routine.
;    * You do not need to call ICBegin before calling this routine.
;    * In the current implementation this launches the IC application
;    * (or brings it to the front) and displays the window containing
;    * the preference specified by key.
;    * It may have a radically different implementation in future
;    * IC systems.
;    
;  ***** URL Handling *****  
; 
;  *  ICLaunchURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICLaunchURL" 
      ((inst :pointer) (hint (:string 255)) (data :pointer) (len :signed-long) (selStart (:pointer :signed-long)) (selEnd (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst hint data len selStart selEnd ((+ (ash 20 16) 17) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Parses a URL out of the specified text and feeds it off to the
;    * appropriate helper.
;    * hint indicates the default scheme for URLs of the form "name@address".
;    * If hint is the empty string then URLs of that form are not allowed.
;    * data points to the start of the text. It must not be nil.
;    * len indicates the length of the text. It must be non-negative.
;    * selStart and selEnd should be passed in as the current selection of
;    * the text. This selection is given in the same manner as TextEdit,
;    * ie if selStart = selEnd then there is no selection only an insertion
;    * point. Also selStart  selEnd and 0  selStart  len and 0  selEnd  len.
;    * selStart and selEnd are returned as the bounds of the URL. If the
;    * routine returns an error then these new boundaries may be
;    * invalid but they will be close.
;    * The URL is parsed out of the text and passed off to the appropriate
;    * helper using the GURL AppleEvent.
;    
; 
;  *  ICParseURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICParseURL" 
      ((inst :pointer) (hint (:string 255)) (data :pointer) (len :signed-long) (selStart (:pointer :signed-long)) (selEnd (:pointer :signed-long)) (url :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst hint data len selStart selEnd url ((+ (ash 24 16) 16) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Parses a URL out of the specified text and returns it in a canonical form
;    * in a handle.
;    * hint indicates the default scheme for URLs of the form "name@address".
;    * If hint is the empty string then URLs of that form are not allowed.
;    * data points to the start of the text. It must not be nil.
;    * len indicates the length of the text. It must be non-negative.
;    * selStart and selEnd should be passed in as the current selection of
;    * the text. This selection is given in the same manner as TextEdit,
;    * ie if selStart = selEnd then there is no selection only an insertion
;    * point. Also selStart  selEnd and 0  selStart  len and 0  selEnd  len.
;    * selStart and selEnd are returned as the bounds of the URL. If the
;    * routine returns an error then these new boundaries may be
;    * invalid but they will be close.
;    * The incoming url handle must not be nil.  The resulting URL is normalised
;    * and copied into the url handle, which is resized to fit.
;    
; 
;  *  ICCreateGURLEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICCreateGURLEvent" 
      ((inst :pointer) (helperCreator :ostype) (urlH :handle) (theEvent (:pointer :aedesc)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst helperCreator urlH theEvent ((+ (ash 12 16) 51) :signed-longint)))

;  [r4] [c1] [b3] 
;    * Creates a GURL Apple event, targetted at the application whose creator
;    * code is helperCreator, with a direct object containing the URL text from urlH.
;    
; 
;  *  ICSendGURLEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICSendGURLEvent" 
      ((inst :pointer) (theEvent (:pointer :aedesc)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst theEvent ((+ (ash 4 16) 52) :signed-longint)))

;  [r4] [c1] [b3] 
;    * Sends theEvent to the target application.
;    
;  ***** Mappings Routines *****
;  * 
;  * Routines for interrogating mappings database.
;  * 
;  * ----- High Level Routines -----
;   
; 
;  *  ICMapFilename()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICMapFilename" 
      ((inst :pointer) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst filename entry ((+ (ash 8 16) 24) :signed-longint)))

;  [r1] [c1] [b4] 
;    * Takes the name of an incoming file and returns the most appropriate
;    * mappings database entry, based on its extension.
;    * filename must not be the empty string.
;    * Returns icPrefNotFoundErr if no suitable entry is found.
;    
; 
;  *  ICMapTypeCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICMapTypeCreator" 
      ((inst :pointer) (fType :ostype) (fCreator :ostype) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst fType fCreator filename entry ((+ (ash 16 16) 25) :signed-longint)))

;  [r1] [c1] [b4] 
;    * Takes the type and creator (and optionally the name) of an outgoing
;    * file and returns the most appropriate mappings database entry.
;    * The filename may be either the name of the outgoing file or
;    * the empty string.
;    * Returns icPrefNotFoundErr if no suitable entry found.
;    
;  ----- Mid Level Routines -----  
; 
;  *  ICMapEntriesFilename()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICMapEntriesFilename" 
      ((inst :pointer) (entries :handle) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries filename entry ((+ (ash 12 16) 28) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Takes the name of an incoming file and returns the most appropriate
;    * mappings database entry, based on its extension.
;    * entries must be a handle to a valid IC mappings database preference.
;    * filename must not be the empty string.
;    * Returns icPrefNotFoundErr if no suitable entry is found.
;    
; 
;  *  ICMapEntriesTypeCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICMapEntriesTypeCreator" 
      ((inst :pointer) (entries :handle) (fType :ostype) (fCreator :ostype) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries fType fCreator filename entry ((+ (ash 20 16) 29) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Takes the type and creator (and optionally the name) of an outgoing
;    * file and returns the most appropriate mappings database entry.
;    * entries must be a handle to a valid IC mappings database preference.
;    * The filename may be either the name of the outgoing file or
;    * the empty string.
;    * Returns icPrefNotFoundErr if no suitable entry found.
;    
;  ----- Low Level Routines -----  
; 
;  *  ICCountMapEntries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICCountMapEntries" 
      ((inst :pointer) (entries :handle) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries count ((+ (ash 8 16) 18) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Counts the number of entries in the mappings database.
;    * entries must be a handle to a valid IC mappings database preference.
;    * count is set to the number of entries.
;    
; 
;  *  ICGetIndMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetIndMapEntry" 
      ((inst :pointer) (entries :handle) (index :signed-long) (pos (:pointer :signed-long)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries index pos entry ((+ (ash 16 16) 19) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Gets the index'th entry in the mappings database.
;    * entries must be a handle to a valid IC mappings database preference.
;    * index must be in the range from 1 to the number of entries in the database.
;    * The value of pos is ignored on input. pos is set to the position of
;    * the index'th entry in the database and is suitable for passing back
;    * into ICSetMapEntry.
;    * Does not return any user data associated with the entry.
;    
; 
;  *  ICGetMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetMapEntry" 
      ((inst :pointer) (entries :handle) (pos :signed-long) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos entry ((+ (ash 12 16) 20) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Returns the entry located at position pos in the mappings database.
;    * entries must be a handle to a valid IC mappings database preference.
;    * pos should be 0 to get the first entry. To get the subsequent entries, add
;    * entry.total_size to pos and iterate.
;    * Does not return any user data associated with the entry.
;    
; 
;  *  ICSetMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ICSetMapEntry" 
      ((inst :pointer) (entries :handle) (pos :signed-long) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos entry ((+ (ash 12 16) 21) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Sets the entry located at position pos in the mappings database.
;    * entries must be a handle to a valid IC mappings database preference.
;    * pos should be either a value returned from ICGetIndMapEntry or a value
;    * calculated using ICGetMapEntry.
;    * entry is a var parameter purely for stack space reasons. It is not
;    * modified in any way.
;    * Any user data associated with the entry is unmodified.
;    
; 
;  *  ICDeleteMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICDeleteMapEntry" 
      ((inst :pointer) (entries :handle) (pos :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos ((+ (ash 8 16) 22) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Deletes the mappings database entry at pos.
;    * entries must be a handle to a valid IC mappings database preference.
;    * pos should be either a value returned from ICGetIndMapEntry or a value
;    * calculated using ICGetMapEntry.
;    * Also deletes any user data associated with the entry.
;    
; 
;  *  ICAddMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ICAddMapEntry" 
      ((inst :pointer) (entries :handle) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries entry ((+ (ash 8 16) 23) :signed-longint)))

;  [r1] [c1] [b3] 
;    * Adds an entry to the mappings database.
;    * entries must be a handle to a valid IC mappings database preference.
;    * The entry is added to the end of the entries database.
;    * No user data is added.
;    
;  ***** Profile Management Routines *****  
; 
;  *  ICGetCurrentProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetCurrentProfile" 
      ((inst :pointer) (currentID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst currentID ((+ (ash 4 16) 37) :signed-longint)))

;  [r3] [c1] [b3] 
;    * Returns the profile ID of the current profile.
;    
; 
;  *  ICSetCurrentProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICSetCurrentProfile" 
      ((inst :pointer) (newID :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst newID ((+ (ash 4 16) 38) :signed-longint)))

;  [r3] [c1] [b3] 
;    * Sets the current profile to the profile specified in newProfile.
;    
; 
;  *  ICCountProfiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICCountProfiles" 
      ((inst :pointer) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count ((+ (ash 4 16) 39) :signed-longint)))

;  [r3] [c1] [b1] 
;    * Returns the total number of profiles.
;    
; 
;  *  ICGetIndProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetIndProfile" 
      ((inst :pointer) (index :signed-long) (thisID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst index thisID ((+ (ash 8 16) 40) :signed-longint)))

;  [r3] [c1] [b1] 
;    * Returns the profile ID of the index'th profile.  index must be positive.
;    * Returns icProfileNotFoundErr if index is greater than the total number
;    * of profiles.
;    
; 
;  *  ICGetProfileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICGetProfileName" 
      ((inst :pointer) (thisID :signed-long) (name (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID name ((+ (ash 8 16) 41) :signed-longint)))

;  [r3] [c1] [b3] 
;    * Returns the name of a profile given its ID.  The name may not uniquely
;    * identify the profile.  [That's what the profile ID is for!]  The name
;    * is assumed to be in the system script.
;    
; 
;  *  ICSetProfileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICSetProfileName" 
      ((inst :pointer) (thisID :signed-long) (name (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID name ((+ (ash 8 16) 42) :signed-longint)))

;  [r3] [c1] [b3] 
;    * This routine sets the name of the specified profile.  Profile names
;    * need not be unique.  The name should be in the system script.
;    
; 
;  *  ICAddProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICAddProfile" 
      ((inst :pointer) (prototypeID :signed-long) (newID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst prototypeID newID ((+ (ash 8 16) 43) :signed-longint)))

;  [r3] [c1] [b2] 
;    * If prototypeID = kICNilProfileID, this routine
;    * creates a default profile, otherwise it creates a
;    * profile by cloning the prototype profile.  The ID
;    * of the new profile is returned in newID.
;    * The new profile will be give a new, unique, name.
;    * This does not switch to the new profile.
;    
; 
;  *  ICDeleteProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ICDeleteProfile" 
      ((inst :pointer) (thisID :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID ((+ (ash 4 16) 44) :signed-longint)))

;  [r3] [c1] [b2] 
;    * This routine deletes the profile specified by
;    * thisID.  Attempting to delete the current profile
;    * or the last profile will return error.
;    
; ***********************************************************************************************
;   NOTHING BELOW THIS DIVIDER IS IN CARBON
;  ***********************************************************************************************
;  ***** Interrupt Safe Routines *****  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ICRequiresInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICRequiresInterruptSafe" 
      ((inst :pointer))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 45) :signed-longint)))

;  [r3] [c2] [b3] 
;    * You must call this routine before calling GetMapEntryInterruptSafe
;    * to give IC chance to cache the mappings data in memory.  The only
;    * way to clear this state is to close the instance.  You can not reconfigure
;    * the instance after calling this routine.
;    
; 
;  *  ICGetMappingInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICGetMappingInterruptSafe" 
      ((inst :pointer) (mappingPref (:pointer :pointer)) (mappingPrefSize (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst mappingPref mappingPrefSize ((+ (ash 8 16) 46) :signed-longint)))

;  [r3] [c2] [b3] 
;    * Returns the "Mapping" preference in an interrupt safe fashion.
;    * The preference returned pointer is valid until the next
;    * non-interrupt safe call to IC.  Typically this API is used
;    * by software that needs to map extensions to type and creator
;    * at interrupt time, eg foreign file systems.
;    
; 
;  *  ICGetSeedInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICGetSeedInterruptSafe" 
      ((inst :pointer) (seed (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst seed ((+ (ash 4 16) 48) :signed-longint)))

;  [r3] [c2] [b3] 
;    * An interrupt safe version of ICGetSeed.
;    
;  ***** Starting Up and Shutting Down *****  
; 
;  *  ICCStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  See comment for ICCStart.                    ; 
;  *  ICCStop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ICCStart" 
      ((inst (:pointer (:pointer :componentinstancerecord))) (creator :ostype)) 
  :osstatus
   () )                                         ;  See comment for ICCStop.  ; 
;  *  ICCGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ICCStop" 
      ((inst (:pointer :componentinstancerecord))) 
  :osstatus
   () )
(deftrap "_ICCGetVersion" 
      ((inst (:pointer :componentinstancerecord)) (whichVersion :signed-long) (version (:pointer :unsigned-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst whichVersion version ((+ (ash 8 16) 50) :signed-longint)))

;  See comment for ICCGetVersion.  
;  ***** Specifying a Configuration *****  
; 
;  *  ICCFindConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCFindConfigFile" 
      ((inst (:pointer :componentinstancerecord)) (count :signed-integer) (folders (:pointer :icdirspecarray)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count folders ((+ (ash 6 16) 2) :signed-longint)))

;  See comment for ICCFindConfigFile.  
; 
;  *  ICCFindUserConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCFindUserConfigFile" 
      ((inst (:pointer :componentinstancerecord)) (where (:pointer :icdirspec)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst where ((+ (ash 4 16) 14) :signed-longint)))

;  See comment for ICCFindUserConfigFile.  
; 
;  *  ICCGeneralFindConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGeneralFindConfigFile" 
      ((inst (:pointer :componentinstancerecord)) (searchPrefs :boolean) (canCreate :boolean) (count :signed-integer) (folders (:pointer :icdirspecarray)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst searchPrefs canCreate count folders ((+ (ash 10 16) 30) :signed-longint)))

;  See comment for ICCGeneralFindConfigFile.  
; 
;  *  ICCChooseConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCChooseConfig" 
      ((inst (:pointer :componentinstancerecord)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 33) :signed-longint)))

;  See comment for ICCChooseConfig.  
; 
;  *  ICCChooseNewConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCChooseNewConfig" 
      ((inst (:pointer :componentinstancerecord)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 34) :signed-longint)))

;  See comment for ICCChooseNewConfig.  
; 
;  *  ICCGetConfigName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetConfigName" 
      ((inst (:pointer :componentinstancerecord)) (longname :boolean) (name (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst longname name ((+ (ash 6 16) 35) :signed-longint)))

;  See comment for ICCGetConfigName.  
; 
;  *  ICCGetConfigReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetConfigReference" 
      ((inst (:pointer :componentinstancerecord)) (ref (:handle :icconfigref)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ref ((+ (ash 4 16) 31) :signed-longint)))

;  See comment for ICCGetConfigReference.  
; 
;  *  ICCSetConfigReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetConfigReference" 
      ((inst (:pointer :componentinstancerecord)) (ref (:handle :icconfigref)) (flags :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ref flags ((+ (ash 8 16) 32) :signed-longint)))

;  See comment for ICCSetConfigReference.  
;  ***** Private Routines *****
;  * 
;  * If you are calling these routines, you are most probably doing something
;  * wrong.  Please read the documentation for more details.
;   
; 
;  *  ICCSpecifyConfigFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSpecifyConfigFile" 
      ((inst (:pointer :componentinstancerecord)) (config (:pointer :fsspec)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst config ((+ (ash 4 16) 3) :signed-longint)))

;  See comment for ICCSpecifyConfigFile.  
; 
;  *  ICCRefreshCaches()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCRefreshCaches" 
      ((inst (:pointer :componentinstancerecord)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 47) :signed-longint)))

;  See comment for ICCRefreshCaches.  
;  ***** Getting Information *****  
; 
;  *  ICCGetSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetSeed" 
      ((inst (:pointer :componentinstancerecord)) (seed (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst seed ((+ (ash 4 16) 4) :signed-longint)))

;  See comment for ICCGetSeed.  
; 
;  *  ICCGetPerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetPerm" 
      ((inst (:pointer :componentinstancerecord)) (perm (:pointer :unsigned-byte)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst perm ((+ (ash 4 16) 13) :signed-longint)))

;  See comment for ICCGetPerm.  
; 
;  *  ICCDefaultFileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCDefaultFileName" 
      ((inst (:pointer :componentinstancerecord)) (name (:pointer (:string 63))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst name ((+ (ash 4 16) 11) :signed-longint)))

;  See comment for ICCDefaultFileName.  
; 
;  *  ICCGetComponentInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  See comment for ICCGetComponentInstance.     ;  ***** Reading and Writing Preferences *****  ; 
;  *  ICCBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ICCGetComponentInstance" 
      ((inst (:pointer :componentinstancerecord)) (componentInst (:pointer (:pointer :componentinstancerecord)))) 
  :osstatus
   () )
(deftrap "_ICCBegin" 
      ((inst (:pointer :componentinstancerecord)) (perm :signed-byte))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst perm ((+ (ash 2 16) 5) :signed-longint)))

;  See comment for ICCBegin.  
; 
;  *  ICCGetPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetPref" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (attr (:pointer :unsigned-long)) (buf :pointer) (size (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr buf size ((+ (ash 16 16) 6) :signed-longint)))

;  See comment for ICCGetPref.  
; 
;  *  ICCSetPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetPref" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (attr :unsigned-long) (buf :pointer) (size :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr buf size ((+ (ash 16 16) 7) :signed-longint)))

;  See comment for ICCSetPref.  
; 
;  *  ICCFindPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCFindPrefHandle" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (attr (:pointer :unsigned-long)) (prefh :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 36) :signed-longint)))

;  See comment for ICCFindPrefHandle.  
; 
;  *  ICCGetPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetPrefHandle" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (attr (:pointer :unsigned-long)) (prefh (:pointer :handle)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 26) :signed-longint)))

;  See comment for ICCGetPrefHandle.  
; 
;  *  ICCSetPrefHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetPrefHandle" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (attr :unsigned-long) (prefh :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key attr prefh ((+ (ash 12 16) 27) :signed-longint)))

;  See comment for ICCSetPrefHandle.  
; 
;  *  ICCCountPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCCountPref" 
      ((inst (:pointer :componentinstancerecord)) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count ((+ (ash 4 16) 8) :signed-longint)))

;  See comment for ICCCountPref.  
; 
;  *  ICCGetIndPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetIndPref" 
      ((inst (:pointer :componentinstancerecord)) (index :signed-long) (key (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst index key ((+ (ash 8 16) 9) :signed-longint)))

;  See comment for ICCGetIndPref.  
; 
;  *  ICCDeletePref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCDeletePref" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key ((+ (ash 4 16) 12) :signed-longint)))

;  See comment for ICCDeletePref.  
; 
;  *  ICCEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCEnd" 
      ((inst (:pointer :componentinstancerecord)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 10) :signed-longint)))

;  See comment for ICCEnd.  
; 
;  *  ICCGetDefaultPref()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetDefaultPref" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)) (prefH :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key prefH ((+ (ash 8 16) 49) :signed-longint)))

;  See comment for ICCGetDefaultPref.  
;  ***** User Interface Stuff *****  
; 
;  *  ICCEditPreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCEditPreferences" 
      ((inst (:pointer :componentinstancerecord)) (key (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst key ((+ (ash 4 16) 15) :signed-longint)))

;  See comment for ICCEditPreferences.  
;  ***** URL Handling *****  
; 
;  *  ICCLaunchURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCLaunchURL" 
      ((inst (:pointer :componentinstancerecord)) (hint (:string 255)) (data :pointer) (len :signed-long) (selStart (:pointer :signed-long)) (selEnd (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst hint data len selStart selEnd ((+ (ash 20 16) 17) :signed-longint)))

;  See comment for ICCLaunchURL.  
; 
;  *  ICCParseURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCParseURL" 
      ((inst (:pointer :componentinstancerecord)) (hint (:string 255)) (data :pointer) (len :signed-long) (selStart (:pointer :signed-long)) (selEnd (:pointer :signed-long)) (url :handle))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst hint data len selStart selEnd url ((+ (ash 24 16) 16) :signed-longint)))

;  See comment for ICCParseURL.  
; 
;  *  ICCCreateGURLEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCCreateGURLEvent" 
      ((inst (:pointer :componentinstancerecord)) (helperCreator :ostype) (urlH :handle) (theEvent (:pointer :aedesc)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst helperCreator urlH theEvent ((+ (ash 12 16) 51) :signed-longint)))

;  See comment for ICCCreateGURLEvent.  
; 
;  *  ICCSendGURLEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSendGURLEvent" 
      ((inst (:pointer :componentinstancerecord)) (theEvent (:pointer :aedesc)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst theEvent ((+ (ash 4 16) 52) :signed-longint)))

;  See comment for ICCSendGURLEvent.  
;  ***** Mappings Routines *****
;  * 
;  * Routines for interrogating mappings database.
;  * 
;  * ----- High Level Routines -----
;   
; 
;  *  ICCMapFilename()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCMapFilename" 
      ((inst (:pointer :componentinstancerecord)) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst filename entry ((+ (ash 8 16) 24) :signed-longint)))

;  See comment for ICCMapFilename.  
; 
;  *  ICCMapTypeCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCMapTypeCreator" 
      ((inst (:pointer :componentinstancerecord)) (fType :ostype) (fCreator :ostype) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst fType fCreator filename entry ((+ (ash 16 16) 25) :signed-longint)))

;  See comment for ICCMapTypeCreator.  
;  ----- Mid Level Routines -----  
; 
;  *  ICCMapEntriesFilename()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCMapEntriesFilename" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries filename entry ((+ (ash 12 16) 28) :signed-longint)))

;  See comment for ICCMapEntriesFilename.  
; 
;  *  ICCMapEntriesTypeCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCMapEntriesTypeCreator" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (fType :ostype) (fCreator :ostype) (filename (:string 255)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries fType fCreator filename entry ((+ (ash 20 16) 29) :signed-longint)))

;  See comment for ICCMapEntriesTypeCreator.  
;  ----- Low Level Routines -----  
; 
;  *  ICCCountMapEntries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCCountMapEntries" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries count ((+ (ash 8 16) 18) :signed-longint)))

;  See comment for ICCCountMapEntries.  
; 
;  *  ICCGetIndMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetIndMapEntry" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (index :signed-long) (pos (:pointer :signed-long)) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries index pos entry ((+ (ash 16 16) 19) :signed-longint)))

;  See comment for ICCGetIndMapEntry.  
; 
;  *  ICCGetMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetMapEntry" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (pos :signed-long) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos entry ((+ (ash 12 16) 20) :signed-longint)))

;  See comment for ICCGetMapEntry.  
; 
;  *  ICCSetMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetMapEntry" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (pos :signed-long) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos entry ((+ (ash 12 16) 21) :signed-longint)))

;  See comment for ICCSetMapEntry.  
; 
;  *  ICCDeleteMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCDeleteMapEntry" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (pos :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries pos ((+ (ash 8 16) 22) :signed-longint)))

;  See comment for ICCDeleteMapEntry.  
; 
;  *  ICCAddMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCAddMapEntry" 
      ((inst (:pointer :componentinstancerecord)) (entries :handle) (entry (:pointer :icmapentry)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst entries entry ((+ (ash 8 16) 23) :signed-longint)))

;  See comment for ICCAddMapEntry.  
;  ***** Profile Management Routines *****  
; 
;  *  ICCGetCurrentProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetCurrentProfile" 
      ((inst (:pointer :componentinstancerecord)) (currentID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst currentID ((+ (ash 4 16) 37) :signed-longint)))

;  See comment for ICCGetCurrentProfile.  
; 
;  *  ICCSetCurrentProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetCurrentProfile" 
      ((inst (:pointer :componentinstancerecord)) (newID :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst newID ((+ (ash 4 16) 38) :signed-longint)))

;  See comment for ICCSetCurrentProfile.  
; 
;  *  ICCCountProfiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCCountProfiles" 
      ((inst (:pointer :componentinstancerecord)) (count (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst count ((+ (ash 4 16) 39) :signed-longint)))

;  See comment for ICCCountProfiles.  
; 
;  *  ICCGetIndProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetIndProfile" 
      ((inst (:pointer :componentinstancerecord)) (index :signed-long) (thisID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst index thisID ((+ (ash 8 16) 40) :signed-longint)))

;  See comment for ICCGetIndProfile.  
; 
;  *  ICCGetProfileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetProfileName" 
      ((inst (:pointer :componentinstancerecord)) (thisID :signed-long) (name (:pointer (:string 255))))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID name ((+ (ash 8 16) 41) :signed-longint)))

;  See comment for ICCGetProfileName.  
; 
;  *  ICCSetProfileName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCSetProfileName" 
      ((inst (:pointer :componentinstancerecord)) (thisID :signed-long) (name (:string 255)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID name ((+ (ash 8 16) 42) :signed-longint)))

;  See comment for ICCSetProfileName.  
; 
;  *  ICCAddProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCAddProfile" 
      ((inst (:pointer :componentinstancerecord)) (prototypeID :signed-long) (newID (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst prototypeID newID ((+ (ash 8 16) 43) :signed-longint)))

;  See comment for ICCAddProfile.  
; 
;  *  ICCDeleteProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCDeleteProfile" 
      ((inst (:pointer :componentinstancerecord)) (thisID :signed-long))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst thisID ((+ (ash 4 16) 44) :signed-longint)))

;  See comment for ICCDeleteProfile.  
;  ***** Interrupt Safe Routines *****  
; 
;  *  ICCRequiresInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCRequiresInterruptSafe" 
      ((inst (:pointer :componentinstancerecord)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst ((+ (ash 0 16) 45) :signed-longint)))

;  See comment for ICCRequiresInterruptSafe.  
; 
;  *  ICCGetMappingInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetMappingInterruptSafe" 
      ((inst (:pointer :componentinstancerecord)) (mappingPref (:pointer :pointer)) (mappingPrefSize (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst mappingPref mappingPrefSize ((+ (ash 8 16) 46) :signed-longint)))

;  See comment for ICCGetMappingInterruptSafe.  
; 
;  *  ICCGetSeedInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InternetConfig 2.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ICCGetSeedInterruptSafe" 
      ((inst (:pointer :componentinstancerecord)) (seed (:pointer :signed-long)))
   (:stack :osstatus)
   (:stack-trap #xA82A :d0 0 inst seed ((+ (ash 4 16) 48) :signed-longint)))

;  See comment for ICCGetSeedInterruptSafe.  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 

; ***********************************************************************************************
;   component selectors
;  ***********************************************************************************************

(defconstant $kICCStart 0)
(defconstant $kICCStop 1)
(defconstant $kICCGetVersion 50)
(defconstant $kICCFindConfigFile 2)
(defconstant $kICCFindUserConfigFile 14)
(defconstant $kICCGeneralFindConfigFile 30)
(defconstant $kICCChooseConfig 33)
(defconstant $kICCChooseNewConfig 34)
(defconstant $kICCGetConfigName 35)
(defconstant $kICCGetConfigReference 31)
(defconstant $kICCSetConfigReference 32)
(defconstant $kICCSpecifyConfigFile 3)
(defconstant $kICCRefreshCaches 47)
(defconstant $kICCGetSeed 4)
(defconstant $kICCGetPerm 13)
(defconstant $kICCDefaultFileName 11)
(defconstant $kICCBegin 5)
(defconstant $kICCGetPref 6)
(defconstant $kICCSetPref 7)
(defconstant $kICCFindPrefHandle 36)
(defconstant $kICCGetPrefHandle 26)
(defconstant $kICCSetPrefHandle 27)
(defconstant $kICCCountPref 8)
(defconstant $kICCGetIndPref 9)
(defconstant $kICCDeletePref 12)
(defconstant $kICCEnd 10)
(defconstant $kICCGetDefaultPref 49)
(defconstant $kICCEditPreferences 15)
(defconstant $kICCLaunchURL 17)
(defconstant $kICCParseURL 16)
(defconstant $kICCCreateGURLEvent 51)
(defconstant $kICCSendGURLEvent 52)
(defconstant $kICCMapFilename 24)
(defconstant $kICCMapTypeCreator 25)
(defconstant $kICCMapEntriesFilename 28)
(defconstant $kICCMapEntriesTypeCreator 29)
(defconstant $kICCCountMapEntries 18)
(defconstant $kICCGetIndMapEntry 19)
(defconstant $kICCGetMapEntry 20)
(defconstant $kICCSetMapEntry 21)
(defconstant $kICCDeleteMapEntry 22)
(defconstant $kICCAddMapEntry 23)
(defconstant $kICCGetCurrentProfile 37)
(defconstant $kICCSetCurrentProfile 38)
(defconstant $kICCCountProfiles 39)
(defconstant $kICCGetIndProfile 40)
(defconstant $kICCGetProfileName 41)
(defconstant $kICCSetProfileName 42)
(defconstant $kICCAddProfile 43)
(defconstant $kICCDeleteProfile 44)
(defconstant $kICCRequiresInterruptSafe 45)
(defconstant $kICCGetMappingInterruptSafe 46)
(defconstant $kICCGetSeedInterruptSafe 48)
(defconstant $kICCFirstSelector 0)
(defconstant $kICCLastSelector 52)

; 	***********************************************************************************************
; 	  component selector proc infos
; 	 ***********************************************************************************************	

(defconstant $kICCStartProcInfo 1008)
(defconstant $kICCStopProcInfo 240)
(defconstant $kICCGetVersionProcInfo 4080)
(defconstant $kICCFindConfigFileProcInfo 3824)
(defconstant $kICCFindUserConfigFileProcInfo 1008)
(defconstant $kICCGeneralFindConfigFileProcInfo 58864)
(defconstant $kICCChooseConfigProcInfo 240)
(defconstant $kICCChooseNewConfigProcInfo 240)
(defconstant $kICCGetConfigNameProcInfo 3568)
(defconstant $kICCGetConfigReferenceProcInfo 1008)
(defconstant $kICCSetConfigReferenceProcInfo 4080)
(defconstant $kICCSpecifyConfigFileProcInfo 1008)
(defconstant $kICCRefreshCachesProcInfo 240)
(defconstant $kICCGetSeedProcInfo 1008)
(defconstant $kICCGetPermProcInfo 1008)
(defconstant $kICCDefaultFileNameProcInfo 1008)
(defconstant $kICCGetComponentInstanceProcInfo 1008)
(defconstant $kICCBeginProcInfo 496)
(defconstant $kICCGetPrefProcInfo 65520)
(defconstant $kICCSetPrefProcInfo 65520)
(defconstant $kICCFindPrefHandleProcInfo 16368)
(defconstant $kICCGetPrefHandleProcInfo 16368)
(defconstant $kICCSetPrefHandleProcInfo 16368)
(defconstant $kICCCountPrefProcInfo 1008)
(defconstant $kICCGetIndPrefProcInfo 4080)
(defconstant $kICCDeletePrefProcInfo 1008)
(defconstant $kICCEndProcInfo 240)
(defconstant $kICCGetDefaultPrefProcInfo 4080)
(defconstant $kICCEditPreferencesProcInfo 1008)
(defconstant $kICCLaunchURLProcInfo 262128)
(defconstant $kICCParseURLProcInfo 1048560)
(defconstant $kICCCreateGURLEventProcInfo 16368)
(defconstant $kICCSendGURLEventProcInfo 1008)
(defconstant $kICCMapFilenameProcInfo 4080)
(defconstant $kICCMapTypeCreatorProcInfo 65520)
(defconstant $kICCMapEntriesFilenameProcInfo 16368)
(defconstant $kICCMapEntriesTypeCreatorProcInfo 262128)
(defconstant $kICCCountMapEntriesProcInfo 4080)
(defconstant $kICCGetIndMapEntryProcInfo 65520)
(defconstant $kICCGetMapEntryProcInfo 16368)
(defconstant $kICCSetMapEntryProcInfo 16368)
(defconstant $kICCDeleteMapEntryProcInfo 4080)
(defconstant $kICCAddMapEntryProcInfo 4080)
(defconstant $kICCGetCurrentProfileProcInfo 1008)
(defconstant $kICCSetCurrentProfileProcInfo 1008)
(defconstant $kICCCountProfilesProcInfo 1008)
(defconstant $kICCGetIndProfileProcInfo 4080)
(defconstant $kICCGetProfileNameProcInfo 4080)
(defconstant $kICCSetProfileNameProcInfo 4080)
(defconstant $kICCAddProfileProcInfo 4080)
(defconstant $kICCDeleteProfileProcInfo 1008)
(defconstant $kICCRequiresInterruptSafeProcInfo 240)
(defconstant $kICCGetMappingInterruptSafeProcInfo 4080)
(defconstant $kICCGetSeedInterruptSafeProcInfo 1008)

; 	***********************************************************************************************
; 	  component identifiers
; 	 ***********************************************************************************************	

(defconstant $kICComponentType :|PREF|)
(defconstant $kICComponentSubType :|ICAp|)
(defconstant $kICComponentManufacturer :|JPQE|)

; 	***********************************************************************************************
; 	  The following type is now obsolete.
; 	  If you're using it, please switch to ComponentInstance or ICInstance.
; 	 ***********************************************************************************************	

; $IFC OLDROUTINENAMES 

(def-mactype :internetconfigurationcomponent (find-mactype '(:pointer :componentinstancerecord)))

; $ENDC                                         ; OLDROUTINENAMES
; $ENDC                                         ; CALL_NOT_IN_CARBON

; ***********************************************************************************************
;   old names for stuff declared above
;  ***********************************************************************************************

; $IFC OLDROUTINENAMES 

(def-mactype :icerror (find-mactype ':signed-long))

(defconstant $ICattr_no_change #xFFFFFFFF)
(defconstant $ICattr_locked_bit 0)
(defconstant $ICattr_locked_mask #x1)
(defconstant $ICattr_volatile_bit 1)
(defconstant $ICattr_volatile_mask #x2)
(defconstant $icNoUserInteraction_bit 0)
(defconstant $icNoUserInteraction_mask #x1)
(defconstant $ICfiletype :|ICAp|)
(defconstant $ICcreator :|ICAp|)

; 	
; 	    ICFileInfo was originally used to define the format of a key.
; 	    That key was removed, but we forgot to remove ICFileInfo.
; 	    I hope to remove it entirely, but for the moment it's available
; 	    if you define OLDROUTINENAMES.
; 		

(def-mactype :icfileinfoptr (find-mactype '(:pointer :icfileinfo)))
(defrecord ICFileInfo 
   (fType :ostype)
   (fCreator :ostype)
   (name (:string 63))
   )

(def-mactype :icfileinfohandle (find-mactype '(:handle :icfileinfo)))

(defconstant $ICfile_spec_header_size 106)

(defconstant $ICmap_binary_bit 0)
(defconstant $ICmap_binary_mask #x1)
(defconstant $ICmap_resource_fork_bit 1)
(defconstant $ICmap_resource_fork_mask #x2)
(defconstant $ICmap_data_fork_bit 2)
(defconstant $ICmap_data_fork_mask #x4)
(defconstant $ICmap_post_bit 3)
(defconstant $ICmap_post_mask #x8)
(defconstant $ICmap_not_incoming_bit 4)
(defconstant $ICmap_not_incoming_mask #x10)
(defconstant $ICmap_not_outgoing_bit 5)
(defconstant $ICmap_not_outgoing_mask #x20)
(defconstant $ICmap_fixed_length 22)

(defconstant $ICservices_tcp_bit 0)
(defconstant $ICservices_tcp_mask #x1)
(defconstant $ICservices_udp_bit 1)
(defconstant $ICservices_udp_mask #x2)

; 	    This definitions are a) very long, and b) don't conform
; 	    to Mac OS standards for naming constants, so I've put
; 	    them in only if you're using OLDROUTINENAMES.  Please switch
; 	    to the new names given above.
; 		
(defconstant $internetConfigurationComponentType :|PREF|);   the component type  
(defconstant $internetConfigurationComponentSubType :|ICAp|);   the component subtype  
(defconstant $internetConfigurationComponentInterfaceVersion0 #x0);   IC >= 1.0  
(defconstant $internetConfigurationComponentInterfaceVersion1 #x10000);   IC >= 1.1  
(defconstant $internetConfigurationComponentInterfaceVersion2 #x20000);   IC >= 1.2  
(defconstant $internetConfigurationComponentInterfaceVersion3 #x30000);   IC >= 2.0  
;   current version number is version 3  
(defconstant $internetConfigurationComponentInterfaceVersion #x30000)

; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := InternetConfigIncludes

; $ENDC                                         ; __INTERNETCONFIG__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'InternetConfig)