(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MIDI.p"
; at Wednesday May 1,2002 2:42:08 pm.
; 
;      File:       MIDI.p
;  
;      Contains:   MIDI Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __MIDI__
; $SETC __MIDI__ := 1

; $I+
; $SETC MIDIIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;                         * * *  N O T E  * * * 
; 
;     This file has been updated to include MIDI 2.0 interfaces.  
;     
;     The MIDI 2.0 interfaces were developed for the classic 68K runtime.
;     Since then, Apple has created the PowerPC and CFM 68K runtimes.
;     Currently, the extra functions in MIDI 2.0 are not in InterfaceLib
;     and thus not callable from PowerPC and CFM 68K runtimes (you'll
;     get a linker error).  
; 

(defconstant $midiMaxNameLen 31)                ;  maximum number of characters in port and client names 

;   Time formats  
(defconstant $midiFormatMSec 0)                 ;  milliseconds 
(defconstant $midiFormatBeats 1)                ;  beats 
(defconstant $midiFormat24fpsBit 2)             ;  24 frames/sec. 
(defconstant $midiFormat25fpsBit 3)             ;  25 frames/sec. 
(defconstant $midiFormat30fpsDBit 4)            ;  30 frames/sec. drop-frame 
(defconstant $midiFormat30fpsBit 5)             ;  30 frames/sec. 
(defconstant $midiFormat24fpsQF 6)              ;  24 frames/sec. longInt format  
(defconstant $midiFormat25fpsQF 7)              ;  25 frames/sec. longInt format  
(defconstant $midiFormat30fpsDQF 8)             ;  30 frames/sec. drop-frame longInt format  
(defconstant $midiFormat30fpsQF 9)              ;  30 frames/sec. longInt format  

(defconstant $midiInternalSync 0)               ;  internal sync 
(defconstant $midiExternalSync 1)               ;  external sync 

;   Port types 
(defconstant $midiPortTypeTime 0)               ;  time port 
(defconstant $midiPortTypeInput 1)              ;  input port 
(defconstant $midiPortTypeOutput 2)             ;  output port 
(defconstant $midiPortTypeTimeInv 3)            ;  invisible time port 
(defconstant $midiPortInvisible #x8000)         ;  logical OR this to other types to make invisible ports 
(defconstant $midiPortTypeMask #x7)             ;  logical AND with this to convert new port types to old, i.e. to strip the property bits 

;   OffsetTimes   
(defconstant $midiGetEverything #x7FFFFFFF)     ;  get all packets, regardless of time stamps 
(defconstant $midiGetNothing #x80000000)        ;  get no packets, regardless of time stamps 
(defconstant $midiGetCurrent #x0)               ;  get current packets only 

; 	    MIDI data and messages are passed in MIDIPacket records (see below).
; 	    The first byte of every MIDIPacket contains a set of flags
; 	
; 	    bits 0-1    00 = new MIDIPacket, not continued
; 	                     01 = begining of continued MIDIPacket
; 	                     10 = end of continued MIDIPacket
; 	                     11 = continuation
; 	    bits 2-3     reserved
; 	
; 	    bits 4-6      000 = packet contains MIDI data
; 	
; 	                  001 = packet contains MIDI Manager message
; 	
; 	    bit 7         0 = MIDIPacket has valid stamp
; 	                  1 = stamp with current clock
; 		
(defconstant $midiContMask #x3)
(defconstant $midiNoCont #x0)
(defconstant $midiStartCont #x1)
(defconstant $midiMidCont #x3)
(defconstant $midiEndCont #x2)
(defconstant $midiTypeMask #x70)
(defconstant $midiMsgType #x0)
(defconstant $midiMgrType #x10)
(defconstant $midiTimeStampMask #x80)
(defconstant $midiTimeStampCurrent #x80)
(defconstant $midiTimeStampValid #x0)

;   MIDIPacket command words (the first word in the data field for midiMgrType messages)  
(defconstant $midiOverflowErr #x1)
(defconstant $midiSCCErr #x2)
(defconstant $midiPacketErr #x3)                ;  all command words less than this value are error indicators 
(defconstant $midiMaxErr #xFF)

;   Valid results to be returned by readHooks  
(defconstant $midiKeepPacket 0)
(defconstant $midiMorePacket 1)
(defconstant $midiNoMorePacket 2)
(defconstant $midiHoldPacket 3)

;   Driver calls  
(defconstant $midiOpenDriver 1)
(defconstant $midiCloseDriver 2)

(defconstant $mdvrAbortNotesOff 0)              ;  abort previous mdvrNotesOff request 
(defconstant $mdvrChanNotesOff 1)               ;  generate channel note off messages 
(defconstant $mdvrAllNotesOff 2)                ;  generate all note off messages 

(defconstant $mdvrStopOut 0)                    ;  stop calling MDVROut temporarily 
(defconstant $mdvrStartOut 1)                   ;  resume calling MDVROut 

(def-mactype :midipacketptr (find-mactype '(:pointer :midipacket)))
(defrecord MIDIPacket 
   (flags :unsigned-byte)
   (len :unsigned-byte)
   (tStamp :signed-long)
   (data (:array :unsigned-byte 249 :packed))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MIDIReadHookProcPtr = FUNCTION(myPacket: MIDIPacketPtr; myRefCon: LONGINT): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :midireadhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MIDITimeProcPtr = PROCEDURE(curTime: LONGINT; myRefCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :miditimeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MIDIConnectionProcPtr = PROCEDURE(refnum: INTEGER; refcon: LONGINT; portType: INTEGER; clientID: OSType; portID: OSType; connect: BOOLEAN; direction: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :midiconnectionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MDVRCommProcPtr = FUNCTION(refnum: INTEGER; request: INTEGER; refCon: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :mdvrcommprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MDVRTimeCodeProcPtr = PROCEDURE(refnum: INTEGER; newFormat: INTEGER; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :mdvrtimecodeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MDVRReadProcPtr = PROCEDURE(midiChars: CStringPtr; length: INTEGER; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :mdvrreadprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :midireadhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :midireadhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :miditimeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :miditimeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :midiconnectionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :midiconnectionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mdvrcommupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mdvrcommupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mdvrtimecodeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mdvrtimecodeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mdvrreadupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mdvrreadupp (find-mactype ':pointer))
; $ENDC
(def-mactype :midiclkinfoptr (find-mactype '(:pointer :midiclkinfo)))
(defrecord MIDIClkInfo 
   (syncType :signed-integer)                   ;  synchronization external/internal 
   (curTime :signed-long)                       ;  current value of port's clock 
   (format :signed-integer)                     ;  time code format 
   )

(def-mactype :midiidrecptr (find-mactype '(:pointer :midiidrec)))
(defrecord MIDIIDRec 
   (clientID :ostype)
   (portID :ostype)
   )

(def-mactype :midiportinfoptr (find-mactype '(:pointer :midiportinfo)))
(defrecord (MIDIPortInfo :handle) 
   (portType :signed-integer)                   ;  type of port 
   (timeBase :midiidrec)                        ;  MIDIIDRec for time base 
   (numConnects :signed-integer)                ;  number of connections 
   (cList (:array :midiidrec 1))                ;  ARRAY [1..numConnects] of MIDIIDRec 
   )

(def-mactype :midiportinfohdl (find-mactype '(:handle :midiportinfo)))
(def-mactype :midiportinfohandle (find-mactype '(:handle :midiportinfo)))
(def-mactype :midiportparamsptr (find-mactype '(:pointer :midiportparams)))
(defrecord MIDIPortParams 
   (portID :ostype)                             ;  ID of port, unique within client 
   (portType :signed-integer)                   ;  Type of port - input, output, time, etc. 
   (timeBase :signed-integer)                   ;  refnum of time base, 0 if none 
   (offsetTime :signed-long)                    ;  offset for current time stamps 
   (readHook :pointer)                          ;  routine to call when input data is valid 
   (refCon :signed-long)                        ;  refcon for port (for client use) 
   (initClock :midiclkinfo)                     ;  initial settings for a time base 
   (name (:string 255))                         ;  name of the port, This is a real live string, not a ptr. 
   )

(def-mactype :midiidlistptr (find-mactype '(:pointer :midiidlist)))
(defrecord (MIDIIDList :handle) 
   (numIDs :signed-integer)
   (list (:array :ostype 1))
   )

(def-mactype :midiidlisthdl (find-mactype '(:handle :midiidlist)))
(def-mactype :midiidlisthandle (find-mactype '(:handle :midiidlist)))
;   MDVR Control structs 
(def-mactype :mdvrinctlrecptr (find-mactype '(:pointer :mdvrinctlrec)))
(defrecord MDVRInCtlRec 
   (timeCodeClock :signed-integer)              ;  refnum of time base for time code 
   (timeCodeFormat :signed-integer)             ;  format of time code output 
   (readProc :pointer)                          ;  proc to call with intput characters 
   (commProc :pointer)                          ;  proc to call for handshaking 
   (refCon :signed-long)                        ;  refCon passed to readProc, commProc 
   )

(def-mactype :mdvrinctlptr (find-mactype '(:pointer :mdvrinctlrec)))
(def-mactype :mdvroutctlrecptr (find-mactype '(:pointer :mdvroutctlrec)))
(defrecord MDVROutCtlRec 
   (timeCodeClock :signed-integer)              ;  time base driven by time code 
   (timeCodeFormat :signed-integer)             ;  format of time code to listen to 
   (timeCodeProc :pointer)                      ;  proc called on time code fmt change 
   (commProc :pointer)                          ;  proc called for handshaking 
   (refCon :signed-long)                        ;  refCon passed to timeCodeProc 
   (timeCodeFilter :boolean)                    ;  filter time code if true 
   (padding :signed-byte)                       ;  unused pad byte 
   (midiMsgTicks :signed-long)                  ;  value of Ticks when MIDI msg rcvd 
   (timeCodeTicks :signed-long)                 ;  value of Ticks when time code rcvd 
   )

(def-mactype :mdvroutctlptr (find-mactype '(:pointer :mdvroutctlrec)))
(def-mactype :mdvrptr (find-mactype ':pointer))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  MIDIVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_MIDIVersion" 
      ()
   (:stack :numversion)
   (:stack-trap #xA800 :d0 (+ (ash 0 16) 4)))

; 
;  *  MIDISignIn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISignIn" 
      ((clientID :ostype) (refCon :signed-long) (icon :handle) (name (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 4 16) 4) clientID refCon icon name))

; 
;  *  MIDISignOut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISignOut" 
      ((clientID :ostype))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 8 16) 4) clientID))

; 
;  *  MIDIGetClients()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetClients" 
      ()
   (:stack (:handle :midiidlist))
   (:stack-trap #xA800 :d0 (+ (ash 12 16) 4)))

; 
;  *  MIDIGetClientName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetClientName" 
      ((clientID :ostype) (name (:pointer (:string 255))))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 16 16) 4) clientID name))

; 
;  *  MIDISetClientName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetClientName" 
      ((clientID :ostype) (name (:string 255)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 20 16) 4) clientID name))

; 
;  *  MIDIGetPorts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetPorts" 
      ((clientID :ostype))
   (:stack (:handle :midiidlist))
   (:stack-trap #xA800 :d0 (+ (ash 24 16) 4) clientID))

; 
;  *  MIDIAddPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIAddPort" 
      ((clientID :ostype) (BufSize :signed-integer) (refnum (:pointer :signed-integer)) (init (:pointer :midiportparams)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 28 16) 4) clientID BufSize refnum init))

; 
;  *  MIDIGetPortInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetPortInfo" 
      ((clientID :ostype) (portID :ostype))
   (:stack (:handle :midiportinfo))
   (:stack-trap #xA800 :d0 (+ (ash 32 16) 4) clientID portID))

; 
;  *  MIDIConnectData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIConnectData" 
      ((srcClID :ostype) (srcPortID :ostype) (dstClID :ostype) (dstPortID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 36 16) 4) srcClID srcPortID dstClID dstPortID))

; 
;  *  MIDIUnConnectData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIUnConnectData" 
      ((srcClID :ostype) (srcPortID :ostype) (dstClID :ostype) (dstPortID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 40 16) 4) srcClID srcPortID dstClID dstPortID))

; 
;  *  MIDIConnectTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIConnectTime" 
      ((srcClID :ostype) (srcPortID :ostype) (dstClID :ostype) (dstPortID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 44 16) 4) srcClID srcPortID dstClID dstPortID))

; 
;  *  MIDIUnConnectTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIUnConnectTime" 
      ((srcClID :ostype) (srcPortID :ostype) (dstClID :ostype) (dstPortID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 48 16) 4) srcClID srcPortID dstClID dstPortID))

; 
;  *  MIDIFlush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIFlush" 
      ((refnum :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 52 16) 4) refnum))

; 
;  *  MIDIGetReadHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetReadHook" 
      ((refnum :signed-integer))
   (:stack :pointer)
   (:stack-trap #xA800 :d0 (+ (ash 56 16) 4) refnum))

; 
;  *  MIDISetReadHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetReadHook" 
      ((refnum :signed-integer) (hook :pointer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 60 16) 4) refnum hook))

; 
;  *  MIDIGetPortName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetPortName" 
      ((clientID :ostype) (portID :ostype) (name (:pointer (:string 255))))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 64 16) 4) clientID portID name))

; 
;  *  MIDISetPortName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetPortName" 
      ((clientID :ostype) (portID :ostype) (name (:string 255)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 68 16) 4) clientID portID name))

; 
;  *  MIDIWakeUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIWakeUp" 
      ((refnum :signed-integer) (time :signed-long) (period :signed-long) (timeProc :pointer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 72 16) 4) refnum time period timeProc))

; 
;  *  MIDIRemovePort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIRemovePort" 
      ((refnum :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 76 16) 4) refnum))

; 
;  *  MIDIGetSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetSync" 
      ((refnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 80 16) 4) refnum))

; 
;  *  MIDISetSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetSync" 
      ((refnum :signed-integer) (sync :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 84 16) 4) refnum sync))

; 
;  *  MIDIGetCurTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetCurTime" 
      ((refnum :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA800 :d0 (+ (ash 88 16) 4) refnum))

; 
;  *  MIDISetCurTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetCurTime" 
      ((refnum :signed-integer) (time :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 92 16) 4) refnum time))

; 
;  *  MIDIStartTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIStartTime" 
      ((refnum :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 96 16) 4) refnum))

; 
;  *  MIDIStopTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIStopTime" 
      ((refnum :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 100 16) 4) refnum))

; 
;  *  MIDIPoll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIPoll" 
      ((refnum :signed-integer) (offsetTime :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 104 16) 4) refnum offsetTime))

; 
;  *  MIDIWritePacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIWritePacket" 
      ((refnum :signed-integer) (packet (:pointer :midipacket)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 108 16) 4) refnum packet))

; 
;  *  MIDIWorldChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIWorldChanged" 
      ((clientID :ostype))
   (:stack :boolean)
   (:stack-trap #xA800 :d0 (+ (ash 112 16) 4) clientID))

; 
;  *  MIDIGetOffsetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetOffsetTime" 
      ((refnum :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA800 :d0 (+ (ash 116 16) 4) refnum))

; 
;  *  MIDISetOffsetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetOffsetTime" 
      ((refnum :signed-integer) (offsetTime :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 120 16) 4) refnum offsetTime))

; 
;  *  MIDIConvertTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIConvertTime" 
      ((srcFormat :signed-integer) (dstFormat :signed-integer) (time :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA800 :d0 (+ (ash 124 16) 4) srcFormat dstFormat time))

; 
;  *  MIDIGetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetRefCon" 
      ((refnum :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA800 :d0 (+ (ash 128 16) 4) refnum))

; 
;  *  MIDISetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetRefCon" 
      ((refnum :signed-integer) (refCon :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 132 16) 4) refnum refCon))

; 
;  *  MIDIGetClRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetClRefCon" 
      ((clientID :ostype))
   (:stack :signed-long)
   (:stack-trap #xA800 :d0 (+ (ash 136 16) 4) clientID))

; 
;  *  MIDISetClRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetClRefCon" 
      ((clientID :ostype) (refCon :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 140 16) 4) clientID refCon))

; 
;  *  MIDIGetTCFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetTCFormat" 
      ((refnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 144 16) 4) refnum))

; 
;  *  MIDISetTCFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetTCFormat" 
      ((refnum :signed-integer) (format :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 148 16) 4) refnum format))

; 
;  *  MIDISetRunRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetRunRate" 
      ((refnum :signed-integer) (rate :signed-integer) (time :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 152 16) 4) refnum rate time))

; 
;  *  MIDIGetClientIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetClientIcon" 
      ((clientID :ostype))
   (:stack :handle)
   (:stack-trap #xA800 :d0 (+ (ash 156 16) 4) clientID))

; 
;  *  MIDICallAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDICallAddress" 
      ((callNum :signed-integer))
   (:stack :pointer)
   (:stack-trap #xA800 :d0 (+ (ash 164 16) 4) callNum))

; 
;  *  MIDISetConnectionProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDISetConnectionProc" 
      ((refNum :signed-integer) (connectionProc :pointer) (refCon :signed-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 168 16) 4) refNum connectionProc refCon))

; 
;  *  MIDIGetConnectionProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIGetConnectionProc" 
      ((refnum :signed-integer) (connectionProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 172 16) 4) refnum connectionProc refCon))

; 
;  *  MIDIDiscardPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MIDIDiscardPacket" 
      ((refnum :signed-integer) (packet (:pointer :midipacket)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 176 16) 4) refnum packet))

; 
;  *  MDVRSignIn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRSignIn" 
      ((clientID :ostype) (refCon :signed-long) (icon :handle) (name (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 180 16) 4) clientID refCon icon name))

; 
;  *  MDVRSignOut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRSignOut" 
      ((clientID :ostype))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 184 16) 4) clientID))

; 
;  *  MDVROpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVROpen" 
      ((portType :signed-integer) (refnum :signed-integer))
   (:stack :pointer)
   (:stack-trap #xA800 :d0 (+ (ash 188 16) 4) portType refnum))

; 
;  *  MDVRClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRClose" 
      ((driverPtr :pointer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 192 16) 4) driverPtr))

; 
;  *  MDVRControlIn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRControlIn" 
      ((portPtr :pointer) (inputCtl (:pointer :mdvrinctlrec)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 196 16) 4) portPtr inputCtl))

; 
;  *  MDVRControlOut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRControlOut" 
      ((portPtr :pointer) (outputCtl (:pointer :mdvroutctlrec)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 200 16) 4) portPtr outputCtl))

; 
;  *  MDVRIn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRIn" 
      ((portPtr :pointer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 204 16) 4) portPtr))

; 
;  *  MDVROut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVROut" 
      ((portPtr :pointer) (dataPtr :pointer) (length :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 208 16) 4) portPtr dataPtr length))

; 
;  *  MDVRNotesOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MDVRNotesOff" 
      ((portPtr :pointer) (mode :signed-integer))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 212 16) 4) portPtr mode))

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $uppMIDIReadHookProcInfo #x3E0)
(defconstant $uppMIDITimeProcInfo #x3C0)
(defconstant $uppMIDIConnectionProcInfo #x9FB80)
(defconstant $uppMDVRCommProcInfo #xEB0)
(defconstant $uppMDVRTimeCodeProcInfo #xE80)
(defconstant $uppMDVRReadProcInfo #xEC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewMIDIReadHookUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewMIDIReadHookProc 
(deftrap "_NewMIDIReadHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMIDITimeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMIDITimeProc 
(deftrap "_NewMIDITimeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMIDIConnectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMIDIConnectionProc 
(deftrap "_NewMIDIConnectionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMDVRCommUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMDVRCommProc 
(deftrap "_NewMDVRCommUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMDVRTimeCodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMDVRTimeCodeProc 
(deftrap "_NewMDVRTimeCodeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMDVRReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMDVRReadProc 
(deftrap "_NewMDVRReadUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeMIDIReadHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMIDIReadHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMIDITimeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMIDITimeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMIDIConnectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMIDIConnectionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMDVRCommUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMDVRCommUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMDVRTimeCodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMDVRTimeCodeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMDVRReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMDVRReadUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeMIDIReadHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMIDIReadHookProc 
(deftrap-inline "_InvokeMIDIReadHookUPP" 
      ((myPacket (:pointer :midipacket)) (myRefCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeMIDITimeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMIDITimeProc 
(deftrap-inline "_InvokeMIDITimeUPP" 
      ((curTime :signed-long) (myRefCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeMIDIConnectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMIDIConnectionProc 
(deftrap-inline "_InvokeMIDIConnectionUPP" 
      ((refnum :signed-integer) (refcon :signed-long) (portType :signed-integer) (clientID :ostype) (portID :ostype) (connect :boolean) (direction :signed-integer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeMDVRCommUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMDVRCommProc 
(deftrap-inline "_InvokeMDVRCommUPP" 
      ((refnum :signed-integer) (request :signed-integer) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeMDVRTimeCodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMDVRTimeCodeProc 
(deftrap-inline "_InvokeMDVRTimeCodeUPP" 
      ((refnum :signed-integer) (newFormat :signed-integer) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeMDVRReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMDVRReadProc 
(deftrap-inline "_InvokeMDVRReadUPP" 
      ((midiChars :pointer) (length :signed-integer) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MIDIIncludes

; $ENDC                                         ; __MIDI__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'MIDI)