(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacLocales.p"
; at Wednesday May 1,2002 2:39:59 pm.
; 
;      File:       MacLocales.p
;  
;      Contains:   Types & prototypes for locale functions
;  
;      Version:    Technology: Mac OS 9.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACLOCALES__
; $SETC __MACLOCALES__ := 1

; $I+
; $SETC MacLocalesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    -------------------------------------------------------------------------------------------------
;    TYPES & CONSTANTS
;    -------------------------------------------------------------------------------------------------
; 

(def-mactype :localeref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :localerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:LocaleRef parameter can be nil, it is changed to xx: LocaleRefPtr 
(def-mactype :localepartmask (find-mactype ':unsigned-long))

;   bit set requests the following: 
(defconstant $kLocaleLanguageMask #x1)          ;   ISO 639-1 or -2 language code (2 or 3 letters) 
(defconstant $kLocaleLanguageVariantMask #x2)   ;   custom string for language variant 
(defconstant $kLocaleScriptMask #x4)            ;   ISO 15924 script code (2 letters) 
(defconstant $kLocaleScriptVariantMask #x8)     ;   custom string for script variant 
(defconstant $kLocaleRegionMask #x10)           ;   ISO 3166 country/region code (2 letters) 
(defconstant $kLocaleRegionVariantMask #x20)    ;   custom string for region variant 
(defconstant $kLocaleAllPartsMask #x3F)         ;   all of the above 

(def-mactype :localeoperationclass (find-mactype ':ostype))
;   constants for LocaleOperationClass are in UnicodeUtilities interfaces 
(def-mactype :localeoperationvariant (find-mactype ':ostype))
(def-mactype :localeandvariantptr (find-mactype '(:pointer :localeandvariant)))
(defrecord LocaleAndVariant 
   (locale :pointer)
   (opVariant :ostype)
   )

(def-mactype :localenamemask (find-mactype ':unsigned-long))

;   bit set requests the following: 
(defconstant $kLocaleNameMask #x1)              ;   name of locale 
(defconstant $kLocaleOperationVariantNameMask #x2);   name of LocaleOperationVariant 
(defconstant $kLocaleAndVariantNameMask #x3)    ;   all of the above 

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   FUNCTION PROTOTYPES
; 	   -------------------------------------------------------------------------------------------------
; 	

;   Convert to or from LocaleRefs (and related utilities) 

; 
; 	 *  LocaleRefFromLangOrRegionCode()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in LocalesLib 8.6 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_LocaleRefFromLangOrRegionCode" 
      ((lang :signed-integer) (region :signed-integer) (locale (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  LocaleRefFromLocaleString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_LocaleRefFromLocaleString" 
      ((localeString (:pointer :character)) (locale (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  LocaleRefGetPartString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleRefGetPartString" 
      ((locale :pointer) (partMask :unsigned-long) (maxStringLen :unsigned-long) (partString (:pointer :character))) 
  :osstatus
   () )

; 
;  *  LocaleStringToLangAndRegionCodes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_LocaleStringToLangAndRegionCodes" 
      ((localeString (:pointer :character)) (lang (:pointer :signed-integer)) (region (:pointer :signed-integer))) 
  :osstatus
   () )

;   Enumerate locales for a LocaleOperationClass  
; 
;  *  LocaleOperationCountLocales()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleOperationCountLocales" 
      ((opClass :ostype) (localeCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  LocaleOperationGetLocales()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleOperationGetLocales" 
      ((opClass :ostype) (maxLocaleCount :unsigned-long) (actualLocaleCount (:pointer :unsigned-long)) (localeVariantList (:pointer :localeandvariant))) 
  :osstatus
   () )

;   Get names for a locale (or a region's language) 

; 
;  *  LocaleGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleGetName" 
      ((locale :pointer) (opVariant :ostype) (nameMask :unsigned-long) (displayLocale :pointer) (maxNameLen :unsigned-long) (actualNameLen (:pointer :unsigned-long)) (displayName (:pointer :unsigned-integer))) 
  :osstatus
   () )

; 
;  *  LocaleCountNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleCountNames" 
      ((locale :pointer) (opVariant :ostype) (nameMask :unsigned-long) (nameCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  LocaleGetIndName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleGetIndName" 
      ((locale :pointer) (opVariant :ostype) (nameMask :unsigned-long) (nameIndex :unsigned-long) (maxNameLen :unsigned-long) (actualNameLen (:pointer :unsigned-long)) (displayName (:pointer :unsigned-integer)) (displayLocale (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  LocaleGetRegionLanguageName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleGetRegionLanguageName" 
      ((region :signed-integer) (languageName (:pointer (:string 255)))) 
  :osstatus
   () )

;   Get names for a LocaleOperationClass 
; 
;  *  LocaleOperationGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleOperationGetName" 
      ((opClass :ostype) (displayLocale :pointer) (maxNameLen :unsigned-long) (actualNameLen (:pointer :unsigned-long)) (displayName (:pointer :unsigned-integer))) 
  :osstatus
   () )

; 
;  *  LocaleOperationCountNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleOperationCountNames" 
      ((opClass :ostype) (nameCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  LocaleOperationGetIndName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LocalesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LocaleOperationGetIndName" 
      ((opClass :ostype) (nameIndex :unsigned-long) (maxNameLen :unsigned-long) (actualNameLen (:pointer :unsigned-long)) (displayName (:pointer :unsigned-integer)) (displayLocale (:pointer :pointer))) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MacLocalesIncludes

; $ENDC                                         ; __MACLOCALES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MacLocales)