(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacTCP.p"
; at Wednesday May 1,2002 2:42:06 pm.
; 
;      File:       MacTCP.p
;  
;      Contains:   TCP Manager Interfaces.
;  
;      Version:    Technology: MacTCP 2.0.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __MACTCP__
; $SETC __MACTCP__ := 1

; $I+
; $SETC MacTCPIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLETALK__
|#

(require-interface 'AppleTalk)
#|                                              ; $I AppleTalk.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
; Developer Notes:
;         0. This MacTCP header replaces what used to be defined in the following header files
;             MacTCPCommonTypes.h
;             GetMyIPAddr.h
;             MiscIPPB.h
;             TCPPB.h
;             UDPPB.h 
;             
;             When the various control calls are made to the ip driver, you must set up a 
;             NewRoutineDescriptor for every non-nil completion routine and/or notifyProc parameter.  
;             Otherwise, the 68K driver code, will not correctly call your routine.
;         1. For ipctlGetAddr Control calls, use NewGetIPIOCompletionProc
;             to set up a GetIPIOCompletionUPP universal procptr to pass as
;             the ioCompletion parameter.
;         2. For the ipctlEchoICMP and ipctlLAPStats Control calls, use 
;             NewIPIOCompletion to set up a IPIOCompletionUPP universal procptr
;             to pass in the ioCompletion field of the parameter block.
;         3. For TCPCreatePB Control calls, use NewTCPNotifyProc to set up a
;             TCPNotifyUPP universal procptr to pass in the notifyProc field
;             of the parameter block
;         4. For all of the TCP Control calls using the TCPiopb parameter block,
;             use NewTCPIOCompletionProc to set up a TCPIOCompletionUPP
;             universal procptr to pass in the ioCompletion field of the paramter
;             block.
;         5. For UDBCreatePB Control calls, use NewUDPNotifyProc to set up a
;             UDPNotifyUPP universal procptr to pass in the notifyProc field
;             of the parameter block
;         6. For all of the UDP Control calls using the UDPiopb parameter block,
;             use NewUDPIOCompletionProc to set up a UDPIOCompletionUPP
;             universal procptr to pass in the ioCompletion field of the paramter
;             block.
;         7. For all calls implementing a notifyProc or ioCompletion routine
;             which was set up using a NewTCPRoutineProc call, do not call
;             DisposeRoutineSDescriptor on the universal procptr until
;             after the completion or notify proc has completed.
; 

;  MacTCP return Codes in the range -23000 through -23049 

(defconstant $inProgress 1)                     ;   I/O in progress  
(defconstant $ipBadLapErr -23000)               ;   bad network configuration  
(defconstant $ipBadCnfgErr -23001)              ;   bad IP configuration error  
(defconstant $ipNoCnfgErr -23002)               ;   missing IP or LAP configuration error  
(defconstant $ipLoadErr -23003)                 ;   error in MacTCP load  
(defconstant $ipBadAddr -23004)                 ;   error in getting address  
(defconstant $connectionClosing -23005)         ;   connection is closing  
(defconstant $invalidLength -23006)
(defconstant $connectionExists -23007)          ;   request conflicts with existing connection  
(defconstant $connectionDoesntExist -23008)     ;   connection does not exist  
(defconstant $insufficientResources -23009)     ;   insufficient resources to perform request  
(defconstant $invalidStreamPtr -23010)
(defconstant $streamAlreadyOpen -23011)
(defconstant $connectionTerminated -23012)
(defconstant $invalidBufPtr -23013)
(defconstant $invalidRDS -23014)
(defconstant $invalidWDS -23014)
(defconstant $openFailed -23015)
(defconstant $commandTimeout -23016)
(defconstant $duplicateSocket -23017)

; 	 Error codes from internal IP functions 	
(defconstant $ipDontFragErr -23032)             ;   Packet too large to send w/o fragmenting  
(defconstant $ipDestDeadErr -23033)             ;   destination not responding  
(defconstant $icmpEchoTimeoutErr -23035)        ;   ICMP echo timed-out  
(defconstant $ipNoFragMemErr -23036)            ;   no memory to send fragmented pkt  
(defconstant $ipRouteErr -23037)                ;   can't route packet off-net  
(defconstant $nameSyntaxErr -23041)
(defconstant $cacheFault -23042)
(defconstant $noResultProc -23043)
(defconstant $noNameServer -23044)
(defconstant $authNameErr -23045)
(defconstant $noAnsErr -23046)
(defconstant $dnrErr -23047)
(defconstant $outOfMemory -23048)

(defconstant $BYTES_16WORD 2)                   ;   bytes per = 16, bit ip word  
(defconstant $BYTES_32WORD 4)                   ;   bytes per = 32, bit ip word  
(defconstant $BYTES_64WORD 8)                   ;   bytes per = 64, bit ip word  

; 	 8-bit quantity 	

(def-mactype :b_8 (find-mactype ':unsigned-byte))
; 	 16-bit quantity 	
(def-mactype :b_16 (find-mactype ':unsigned-integer))
; 	 32-bit quantity 	
(def-mactype :b_32 (find-mactype ':unsigned-long))
; 	 IP address is 32-bits 	
(def-mactype :ip_addr (find-mactype ':unsigned-long))
(def-mactype :ip_addrbytesptr (find-mactype '(:pointer :ip_addrbytes)))
(defrecord ip_addrbytes 
   (:variant 
      (
      (addr :unsigned-long)
      )
      (
      (byte (:array :unsigned-byte 4 :packed))
      )
      )
   )

(def-mactype :wdsentryptr (find-mactype '(:pointer :wdsentry)))
(defrecord wdsEntry 
   (length :unsigned-integer)                   ;   length of buffer  
   (Ptr :pointer)                               ;   pointer to buffer  
   )

(def-mactype :rdsentryptr (find-mactype '(:pointer :rdsentry)))
(defrecord rdsEntry 
   (length :unsigned-integer)                   ;   length of buffer  
   (Ptr :pointer)                               ;   pointer to buffer  
   )

(def-mactype :bufferptr (find-mactype ':unsigned-long))
(def-mactype :streamptr (find-mactype ':unsigned-long))

(defconstant $netUnreach 0)
(defconstant $hostUnreach 1)
(defconstant $protocolUnreach 2)
(defconstant $portUnreach 3)
(defconstant $fragReqd 4)
(defconstant $sourceRouteFailed 5)
(defconstant $timeExceeded 6)
(defconstant $parmProblem 7)
(defconstant $missingOption 8)
(defconstant $lastICMPMsgType 32767)

(def-mactype :icmpmsgtype (find-mactype ':unsigned-integer))
(def-mactype :ip_port (find-mactype ':unsigned-integer))
(def-mactype :icmpreportptr (find-mactype '(:pointer :icmpreport)))
(defrecord ICMPReport 
   (StreamPtr :unsigned-long)
   (localHost :unsigned-long)
   (localPort :unsigned-integer)
   (remoteHost :unsigned-long)
   (remotePort :unsigned-integer)
   (reportType :signed-integer)
   (optionalAddlInfo :unsigned-integer)
   (optionalAddlInfoPtr :unsigned-long)
   )

; 	 csCode to get our IP address 	

(defconstant $ipctlGetAddr 15)

(def-mactype :getaddrparamblockptr (find-mactype '(:pointer :getaddrparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetIPIOCompletionProcPtr = PROCEDURE(iopb: GetAddrParamBlockPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :getipiocompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :getipiocompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :getipiocompletionupp (find-mactype ':pointer))
; $ENDC
(defrecord GetAddrParamBlock 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)
   (csCode :signed-integer)
   (ourAddress :unsigned-long)                  ;   our IP address  
   (ourNetMask :signed-long)                    ;   our IP net mask  
   )

; 	 control codes 	

(defconstant $ipctlEchoICMP 17)                 ;   send icmp echo  
(defconstant $ipctlLAPStats 19)                 ;   get lap stats  

(def-mactype :icmpparamblockptr (find-mactype '(:pointer :icmpparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	IPIOCompletionProcPtr = PROCEDURE(iopb: ICMPParamBlockPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :ipiocompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :ipiocompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :ipiocompletionupp (find-mactype ':pointer))
; $ENDC
(defrecord ICMPParamBlock 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)
   (csCode :signed-integer)
   (params (:array :signed-integer 11))
   (echoRequestOut :unsigned-long)              ;   time in ticks of when the echo request went out  
   (echoReplyIn :unsigned-long)                 ;   time in ticks of when the reply was received  
   (echoedData :rdsentry)                       ;   data received in responce  
   (options :pointer)
   (userDataPtr :unsigned-long)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ICMPEchoNotifyProcPtr = PROCEDURE(VAR iopb: ICMPParamBlock); C;

|#
 |#                                             ; $ELSEC
(def-mactype :icmpechonotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :icmpechonotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :icmpechonotifyupp (find-mactype ':pointer))
; $ENDC
(def-mactype :lapstatsptr (find-mactype '(:pointer :lapstats)))
(def-mactype :ipparamblockptr (find-mactype '(:pointer :ipparamblock)))
(defrecord IPParamBlock 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)
   (csCode :signed-integer)
   (:variant 
      (
      (dest :unsigned-long)                     ;   echo to IP address  
      (data :wdsentry)
      (timeout :signed-integer)
      (options :pointer)
      (optLength :unsigned-integer)
      (icmpCompletion :pointer)
      (userDataPtr :unsigned-long)
      )
      (
      (LAPStatsPtr (:pointer :lapstats))
      )
      )
   )

(def-mactype :nbp_entryptr (find-mactype '(:pointer :nbp_entry)))
(defrecord nbp_entry 
   (ip_address :unsigned-long)                  ;   IP address  
   (at_address :addrblock)                      ;   matching AppleTalk address  
   (gateway :boolean)                           ;   TRUE if entry for a gateway  
   (valid :boolean)                             ;   TRUE if LAP address is valid  
   (probing :boolean)                           ;   TRUE if NBP lookup pending  
   (afiller :signed-byte)                       ;   Filler for proper byte alignment     
   (age :signed-long)                           ;   ticks since cache entry verified  
   (access :signed-long)                        ;   ticks since last access  
   (filler (:array :signed-byte 116))           ;   for internal use only !!!  
   )

(def-mactype :enet_addrptr (find-mactype '(:pointer :enet_addr)))
(defrecord Enet_addr 
   (en_hi :unsigned-integer)
   (en_lo :unsigned-long)
   )

(def-mactype :arp_entryptr (find-mactype '(:pointer :arp_entry)))
(defrecord arp_entry 
   (age :signed-integer)                        ;   cache aging field  
   (protocol :unsigned-integer)                 ;   Protocol type  
   (ip_address :unsigned-long)                  ;   IP address  
   (en_address :enet_addr)                      ;   matching Ethernet address  
   )

(def-mactype :lapstatsaddrxlationptr (find-mactype '(:pointer :lapstatsaddrxlation)))
(defrecord LAPStatsAddrXlation 
   (:variant 
      (
      (arp_table (:pointer :arp_entry))
      )
      (
      (nbp_table (:pointer :nbp_entry))
      )
      )
   )

(defrecord LAPStats 
   (ifType :signed-integer)
   (ifString :pointer)
   (ifMaxMTU :signed-integer)
   (ifSpeed :signed-long)
   (ifPhyAddrLength :signed-integer)
   (ifPhysicalAddress :pointer)
   (AddrXlation :lapstatsaddrxlation)
   (slotNumber :signed-integer)
   )

; 	 number of ARP table entries 	

(defconstant $ARP_TABLE_SIZE 20)

(defconstant $NBP_TABLE_SIZE 20)                ;   number of NBP table entries  
(defconstant $NBP_MAX_NAME_SIZE 28)

; 	 Command codes 	
(defconstant $TCPCreate 30)
(defconstant $TCPPassiveOpen 31)
(defconstant $TCPActiveOpen 32)
(defconstant $TCPSend 34)
(defconstant $TCPNoCopyRcv 35)
(defconstant $TCPRcvBfrReturn 36)
(defconstant $TCPRcv 37)
(defconstant $TCPClose 38)
(defconstant $TCPAbort 39)
(defconstant $TCPStatus 40)
(defconstant $TCPExtendedStat 41)
(defconstant $TCPRelease 42)
(defconstant $TCPGlobalInfo 43)
(defconstant $TCPCtlMax 49)

(defconstant $TCPClosing 1)
(defconstant $TCPULPTimeout 2)
(defconstant $TCPTerminate 3)
(defconstant $TCPDataArrival 4)
(defconstant $TCPUrgent 5)
(defconstant $TCPICMPReceived 6)
(defconstant $lastEvent 32767)

(def-mactype :tcpeventcode (find-mactype ':unsigned-integer))

(defconstant $TCPRemoteAbort 2)
(defconstant $TCPNetworkFailure 3)
(defconstant $TCPSecPrecMismatch 4)
(defconstant $TCPULPTimeoutTerminate 5)
(defconstant $TCPULPAbort 6)
(defconstant $TCPULPClose 7)
(defconstant $TCPServiceError 8)
(defconstant $lastReason 32767)

(def-mactype :tcpterminationreason (find-mactype ':unsigned-integer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TCPNotifyProcPtr = PROCEDURE(tcpStream: StreamPtr; eventCode: UInt16; userDataPtr: Ptr; terminReason: UInt16; VAR icmpMsg: ICMPReport);

|#
 |#                                             ; $ELSEC
(def-mactype :tcpnotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tcpnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tcpnotifyupp (find-mactype ':pointer))
; $ENDC
(def-mactype :tcp_port (find-mactype ':unsigned-integer))
; 	 ValidityFlags 	

(defconstant $timeoutValue #x80)
(defconstant $timeoutAction #x40)
(defconstant $typeOfService #x20)
(defconstant $precedence #x10)

; 	 TOSFlags 	
(defconstant $lowDelay #x1)
(defconstant $throughPut #x2)
(defconstant $reliability #x4)

(def-mactype :tcpcreatepbptr (find-mactype '(:pointer :tcpcreatepb)))
(defrecord TCPCreatePB 
   (rcvBuff :pointer)
   (rcvBuffLen :unsigned-long)
   (notifyProc :pointer)
   (userDataPtr :pointer)
   )

(def-mactype :tcpopenpbptr (find-mactype '(:pointer :tcpopenpb)))
(defrecord TCPOpenPB 
   (ulpTimeoutValue :signed-byte)
   (ulpTimeoutAction :signed-byte)
   (validityFlags :signed-byte)
   (commandTimeoutValue :signed-byte)
   (remoteHost :unsigned-long)
   (remotePort :unsigned-integer)
   (localHost :unsigned-long)
   (localPort :unsigned-integer)
   (tosFlags :signed-byte)
   (precedence :signed-byte)
   (dontFrag :boolean)
   (timeToLive :signed-byte)
   (security :signed-byte)
   (optionCnt :signed-byte)
   (options (:array :signed-byte 40))
   (userDataPtr :pointer)
   )

(def-mactype :tcpsendpbptr (find-mactype '(:pointer :tcpsendpb)))
(defrecord TCPSendPB 
   (ulpTimeoutValue :signed-byte)
   (ulpTimeoutAction :signed-byte)
   (validityFlags :signed-byte)
   (pushFlag :boolean)
   (urgentFlag :boolean)
   (filler :signed-byte)                        ;   Filler for proper byte alignment     
   (wdsPtr :pointer)
   (sendFree :unsigned-long)
   (sendLength :unsigned-integer)
   (userDataPtr :pointer)
   )

; 	 for receive and return rcv buff calls 	
; 	   Note: the filler in the following structure is in a different location than 	
; 	         that specified in the Programmer's Guide.  	
(def-mactype :tcpreceivepbptr (find-mactype '(:pointer :tcpreceivepb)))
(defrecord TCPReceivePB 
   (commandTimeoutValue :signed-byte)
   (markFlag :boolean)
   (urgentFlag :boolean)
   (filler :signed-byte)                        ;   Filler for proper byte alignment   
   (rcvBuff :pointer)
   (rcvBuffLen :unsigned-integer)
   (rdsPtr :pointer)
   (rdsLength :unsigned-integer)
   (secondTimeStamp :unsigned-integer)
   (userDataPtr :pointer)
   )

(def-mactype :tcpclosepbptr (find-mactype '(:pointer :tcpclosepb)))
(defrecord TCPClosePB 
   (ulpTimeoutValue :signed-byte)
   (ulpTimeoutAction :signed-byte)
   (validityFlags :signed-byte)
   (filler :signed-byte)                        ;   Filler for proper byte alignment     
   (userDataPtr :pointer)
   )

(def-mactype :histobucketptr (find-mactype '(:pointer :histobucket)))
(defrecord HistoBucket 
   (value :unsigned-integer)
   (counter :unsigned-long)
   )

(defconstant $NumOfHistoBuckets 7)

(def-mactype :tcpconnectionstatsptr (find-mactype '(:pointer :tcpconnectionstats)))
(defrecord TCPConnectionStats 
   (dataPktsRcvd :unsigned-long)
   (dataPktsSent :unsigned-long)
   (dataPktsResent :unsigned-long)
   (bytesRcvd :unsigned-long)
   (bytesRcvdDup :unsigned-long)
   (bytesRcvdPastWindow :unsigned-long)
   (bytesSent :unsigned-long)
   (bytesResent :unsigned-long)
   (numHistoBuckets :unsigned-integer)
   (sentSizeHisto (:array :histobucket 7))
   (lastRTT :unsigned-integer)
   (tmrSRTT :unsigned-integer)
   (rttVariance :unsigned-integer)
   (tmrRTO :unsigned-integer)
   (sendTries :signed-byte)
   (sourchQuenchRcvd :signed-byte)
   )

(def-mactype :tcpstatuspbptr (find-mactype '(:pointer :tcpstatuspb)))
(defrecord TCPStatusPB 
   (ulpTimeoutValue :signed-byte)
   (ulpTimeoutAction :signed-byte)
   (unused :signed-long)
   (remoteHost :unsigned-long)
   (remotePort :unsigned-integer)
   (localHost :unsigned-long)
   (localPort :unsigned-integer)
   (tosFlags :signed-byte)
   (precedence :signed-byte)
   (connectionState :signed-byte)
   (filler :signed-byte)                        ;   Filler for proper byte alignment     
   (sendWindow :unsigned-integer)
   (rcvWindow :unsigned-integer)
   (amtUnackedData :unsigned-integer)
   (amtUnreadData :unsigned-integer)
   (securityLevelPtr :pointer)
   (sendUnacked :unsigned-long)
   (sendNext :unsigned-long)
   (congestionWindow :unsigned-long)
   (rcvNext :unsigned-long)
   (srtt :unsigned-long)
   (lastRTT :unsigned-long)
   (sendMaxSegSize :unsigned-long)
   (connStatPtr (:pointer :tcpconnectionstats))
   (userDataPtr :pointer)
   )

(def-mactype :tcpabortpbptr (find-mactype '(:pointer :tcpabortpb)))
(defrecord TCPAbortPB 
   (userDataPtr :pointer)
   )

(def-mactype :tcpparamptr (find-mactype '(:pointer :tcpparam)))
(defrecord TCPParam 
   (tcpRtoA :unsigned-long)
   (tcpRtoMin :unsigned-long)
   (tcpRtoMax :unsigned-long)
   (tcpMaxSegSize :unsigned-long)
   (tcpMaxConn :unsigned-long)
   (tcpMaxWindow :unsigned-long)
   )

(def-mactype :tcpstatsptr (find-mactype '(:pointer :tcpstats)))
(defrecord TCPStats 
   (tcpConnAttempts :unsigned-long)
   (tcpConnOpened :unsigned-long)
   (tcpConnAccepted :unsigned-long)
   (tcpConnClosed :unsigned-long)
   (tcpConnAborted :unsigned-long)
   (tcpOctetsIn :unsigned-long)
   (tcpOctetsOut :unsigned-long)
   (tcpOctetsInDup :unsigned-long)
   (tcpOctetsRetrans :unsigned-long)
   (tcpInputPkts :unsigned-long)
   (tcpOutputPkts :unsigned-long)
   (tcpDupPkts :unsigned-long)
   (tcpRetransPkts :unsigned-long)
   )

(def-mactype :streampptr (find-mactype '(:pointer :unsigned-long)))
(def-mactype :tcpglobalinfopbptr (find-mactype '(:pointer :tcpglobalinfopb)))
(defrecord TCPGlobalInfoPB 
   (TCPParamPtr (:pointer :tcpparam))
   (TCPStatsPtr (:pointer :tcpstats))
   (tcpCDBTable (:array (:pointer :unsigned-long) 1))
   (userDataPtr :pointer)
   (maxTCPConnections :unsigned-integer)
   )

(def-mactype :tcpiopbptr (find-mactype '(:pointer :tcpiopb)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TCPIOCompletionProcPtr = PROCEDURE(iopb: TCPiopbPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tcpiocompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tcpiocompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tcpiocompletionupp (find-mactype ':pointer))
; $ENDC
(defrecord TCPiopb 
   (fill12 (:array :signed-byte 12))
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr :pointer)
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)
   (csCode :signed-integer)
   (tcpStream :unsigned-long)
   (:variant 
      (
      (create :tcpcreatepb)
      )
      (
      (open :tcpopenpb)
      )
      (
      (send :tcpsendpb)
      )
      (
      (receive :tcpreceivepb)
      )
      (
      (close :tcpclosepb)
      )
      (
      (abort :tcpabortpb)
      )
      (
      (status :tcpstatuspb)
      )
      (
      (globalInfo :tcpglobalinfopb)
      )
      )
   )

(defconstant $UDPCreate 20)
(defconstant $UDPRead 21)
(defconstant $UDPBfrReturn 22)
(defconstant $UDPWrite 23)
(defconstant $UDPRelease 24)
(defconstant $UDPMaxMTUSize 25)
(defconstant $UDPStatus 26)
(defconstant $UDPMultiCreate 27)
(defconstant $UDPMultiSend 28)
(defconstant $UDPMultiRead 29)
(defconstant $UDPCtlMax 29)

(defconstant $UDPDataArrival 1)
(defconstant $UDPICMPReceived 2)
(defconstant $lastUDPEvent 32767)

(def-mactype :udpeventcode (find-mactype ':unsigned-integer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UDPNotifyProcPtr = PROCEDURE(udpStream: StreamPtr; eventCode: UInt16; userDataPtr: Ptr; VAR icmpMsg: ICMPReport);

|#
 |#                                             ; $ELSEC
(def-mactype :udpnotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :udpnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :udpnotifyupp (find-mactype ':pointer))
; $ENDC
(def-mactype :udp_port (find-mactype ':unsigned-integer))
; 	 for create and release calls 	
(def-mactype :udpcreatepbptr (find-mactype '(:pointer :udpcreatepb)))
(defrecord UDPCreatePB 
   (rcvBuff :pointer)
   (rcvBuffLen :unsigned-long)
   (notifyProc :pointer)
   (localPort :unsigned-integer)
   (userDataPtr :pointer)
   (endingPort :unsigned-integer)
   )

(def-mactype :udpsendpbptr (find-mactype '(:pointer :udpsendpb)))
(defrecord UDPSendPB 
   (reserved :unsigned-integer)
   (remoteHost :unsigned-long)
   (remotePort :unsigned-integer)
   (wdsPtr :pointer)
   (checkSum :boolean)
   (filler :signed-byte)                        ;   Filler for proper byte alignment     
   (sendLength :unsigned-integer)
   (userDataPtr :pointer)
   (localPort :unsigned-integer)
   )

; 	 for receive and buffer return calls 	
(def-mactype :udpreceivepbptr (find-mactype '(:pointer :udpreceivepb)))
(defrecord UDPReceivePB 
   (timeOut :unsigned-integer)
   (remoteHost :unsigned-long)
   (remotePort :unsigned-integer)
   (rcvBuff :pointer)
   (rcvBuffLen :unsigned-integer)
   (secondTimeStamp :unsigned-integer)
   (userDataPtr :pointer)
   (destHost :unsigned-long)                    ;   only for use with multi rcv  
   (destPort :unsigned-integer)                 ;   only for use with multi rcv  
   )

(def-mactype :udpmtupbptr (find-mactype '(:pointer :udpmtupb)))
(defrecord UDPMTUPB 
   (mtuSize :unsigned-integer)
   (remoteHost :unsigned-long)
   (userDataPtr :pointer)
   )

(def-mactype :udpiopbptr (find-mactype '(:pointer :udpiopb)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UDPIOCompletionProcPtr = PROCEDURE(iopb: UDPiopbPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :udpiocompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :udpiocompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :udpiocompletionupp (find-mactype ':pointer))
; $ENDC
(defrecord UDPiopb 
   (fill12 (:array :signed-byte 12))
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr :pointer)
   (ioVRefNum :signed-integer)
   (ioCRefNum :signed-integer)
   (csCode :signed-integer)
   (udpStream :unsigned-long)
   (:variant 
      (
      (create :udpcreatepb)
      )
      (
      (send :udpsendpb)
      )
      (
      (receive :udpreceivepb)
      )
      (
      (mtu :udpmtupb)
      )
      )
   )

(defconstant $uppGetIPIOCompletionProcInfo #xC1)
(defconstant $uppIPIOCompletionProcInfo #xC1)
(defconstant $uppICMPEchoNotifyProcInfo #xC1)
(defconstant $uppTCPNotifyProcInfo #xEEC0)
(defconstant $uppTCPIOCompletionProcInfo #xC1)
(defconstant $uppUDPNotifyProcInfo #x3EC0)
(defconstant $uppUDPIOCompletionProcInfo #xC1)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewGetIPIOCompletionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewGetIPIOCompletionProc 
(deftrap "_NewGetIPIOCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewIPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewIPIOCompletionProc 
(deftrap "_NewIPIOCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewICMPEchoNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewICMPEchoNotifyProc 
(deftrap "_NewICMPEchoNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTCPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTCPNotifyProc 
(deftrap "_NewTCPNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTCPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTCPIOCompletionProc 
(deftrap "_NewTCPIOCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewUDPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewUDPNotifyProc 
(deftrap "_NewUDPNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewUDPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewUDPIOCompletionProc 
(deftrap "_NewUDPIOCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeGetIPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeGetIPIOCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeIPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeIPIOCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeICMPEchoNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeICMPEchoNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTCPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTCPNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTCPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTCPIOCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeUDPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeUDPNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeUDPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeUDPIOCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeGetIPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallGetIPIOCompletionProc       ; 
;  *  InvokeIPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeGetIPIOCompletionUPP" 
      ((iopb (:pointer :getaddrparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallIPIOCompletionProc ; 
;  *  InvokeICMPEchoNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeIPIOCompletionUPP" 
      ((iopb (:pointer :icmpparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallICMPEchoNotifyProc ; 
;  *  InvokeTCPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeICMPEchoNotifyUPP" 
      ((iopb (:pointer :icmpparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallTCPNotifyProc 
(deftrap-inline "_InvokeTCPNotifyUPP" 
      ((tcpStream :unsigned-long) (eventCode :unsigned-integer) (userDataPtr :pointer) (terminReason :unsigned-integer) (icmpMsg (:pointer :icmpreport)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTCPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTCPIOCompletionProc         ; 
;  *  InvokeUDPNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeTCPIOCompletionUPP" 
      ((iopb (:pointer :tcpiopb)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallUDPNotifyProc 
(deftrap-inline "_InvokeUDPNotifyUPP" 
      ((udpStream :unsigned-long) (eventCode :unsigned-integer) (userDataPtr :pointer) (icmpMsg (:pointer :icmpreport)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeUDPIOCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallUDPIOCompletionProc 
(deftrap-inline "_InvokeUDPIOCompletionUPP" 
      ((iopb (:pointer :udpiopb)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MacTCPIncludes

; $ENDC                                         ; __MACTCP__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'MacTCP)