(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MachineExceptions.p"
; at Wednesday May 1,2002 2:40:02 pm.
; 
;      File:       MachineExceptions.p
;  
;      Contains:   Processor Exception Handling Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACHINEEXCEPTIONS__
; $SETC __MACHINEEXCEPTIONS__ := 1

; $I+
; $SETC MachineExceptionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

;  Some basic declarations used throughout the kernel 

(def-mactype :areaid (find-mactype ':pointer))  ;  an opaque 32-bit type 
(def-mactype :areaidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:AreaID parameter can be nil, it is changed to xx: AreaIDPtr 
; $IFC TARGET_OS_MAC 
; 	 Machine Dependent types for PowerPC: 	
(def-mactype :machineinformationpowerpcptr (find-mactype '(:pointer :machineinformationpowerpc)))
(defrecord MachineInformationPowerPC 
   (CTR :unsignedwide)
   (LR :unsignedwide)
   (PC :unsignedwide)
   (CR :unsigned-long)
   (XER :unsigned-long)
   (MSR :unsigned-long)
   (MQ :unsigned-long)
   (ExceptKind :unsigned-long)
   (DSISR :unsigned-long)
   (DAR :unsignedwide)
   (Reserved :unsignedwide)
   )

(def-mactype :registerinformationpowerpcptr (find-mactype '(:pointer :registerinformationpowerpc)))
(defrecord RegisterInformationPowerPC 
   (R0 :unsignedwide)
   (R1 :unsignedwide)
   (R2 :unsignedwide)
   (R3 :unsignedwide)
   (R4 :unsignedwide)
   (R5 :unsignedwide)
   (R6 :unsignedwide)
   (R7 :unsignedwide)
   (R8 :unsignedwide)
   (R9 :unsignedwide)
   (R10 :unsignedwide)
   (R11 :unsignedwide)
   (R12 :unsignedwide)
   (R13 :unsignedwide)
   (R14 :unsignedwide)
   (R15 :unsignedwide)
   (R16 :unsignedwide)
   (R17 :unsignedwide)
   (R18 :unsignedwide)
   (R19 :unsignedwide)
   (R20 :unsignedwide)
   (R21 :unsignedwide)
   (R22 :unsignedwide)
   (R23 :unsignedwide)
   (R24 :unsignedwide)
   (R25 :unsignedwide)
   (R26 :unsignedwide)
   (R27 :unsignedwide)
   (R28 :unsignedwide)
   (R29 :unsignedwide)
   (R30 :unsignedwide)
   (R31 :unsignedwide)
   )

(def-mactype :fpuinformationpowerpcptr (find-mactype '(:pointer :fpuinformationpowerpc)))
(defrecord FPUInformationPowerPC 
   (Registers (:array :unsignedwide 32))
   (FPSCR :unsigned-long)
   (Reserved :unsigned-long)
   )

(def-mactype :vector128ptr (find-mactype '(:pointer :vector128)))
(defrecord Vector128 
   (:variant 
      (
      (l (:array :unsigned-long 4))
      )
      (
      (s (:array :unsigned-integer 8))
      )
      (
      (c (:array :unsigned-byte 16 :packed))
      )
      )
   )

(def-mactype :vectorinformationpowerpcptr (find-mactype '(:pointer :vectorinformationpowerpc)))
(defrecord VectorInformationPowerPC 
   (Registers (:array :vector128 32))
   (VSCR :vector128)
   (VRsave :unsigned-long)
   )

; 	 Exception related declarations 	

(defconstant $kWriteReference 0)
(defconstant $kReadReference 1)
(defconstant $kFetchReference 2)
(defconstant $writeReference 0)                 ;   Obsolete name 
(defconstant $readReference 1)                  ;   Obsolete name 
(defconstant $fetchReference 2)                 ;   Obsolete name 

(def-mactype :memoryreferencekind (find-mactype ':unsigned-long))
(def-mactype :memoryexceptioninformationptr (find-mactype '(:pointer :memoryexceptioninformation)))
(defrecord MemoryExceptionInformation 
   (theArea :pointer)                           ;   The area related to the execption, same as MPAreaID. 
   (theAddress :pointer)                        ;   The 32-bit address of the exception. 
   (theError :signed-long)                      ;   See enum below. 
   (theReference :unsigned-long)                ;   read, write, instruction fetch. 
   )

(defconstant $kUnknownException 0)
(defconstant $kIllegalInstructionException 1)
(defconstant $kTrapException 2)
(defconstant $kAccessException 3)
(defconstant $kUnmappedMemoryException 4)
(defconstant $kExcludedMemoryException 5)
(defconstant $kReadOnlyMemoryException 6)
(defconstant $kUnresolvablePageFaultException 7)
(defconstant $kPrivilegeViolationException 8)
(defconstant $kTraceException 9)
(defconstant $kInstructionBreakpointException 10);   Optional 
(defconstant $kDataBreakpointException 11)      ;   Optional 
(defconstant $kIntegerException 12)
(defconstant $kFloatingPointException 13)
(defconstant $kStackOverflowException 14)       ;   Optional, may be implemented as kAccessException on some systems. 
(defconstant $kTaskTerminationException 15)     ;   Obsolete 
(defconstant $kTaskCreationException 16)        ;   Obsolete 
(defconstant $kDataAlignmentException 17)       ;   May occur when a task is in little endian mode or created with kMPTaskTakesAllExceptions. 

; $IFC OLDROUTINENAMES 
(defconstant $unknownException 0)               ;   Obsolete name 
(defconstant $illegalInstructionException 1)    ;   Obsolete name 
(defconstant $trapException 2)                  ;   Obsolete name 
(defconstant $accessException 3)                ;   Obsolete name 
(defconstant $unmappedMemoryException 4)        ;   Obsolete name 
(defconstant $excludedMemoryException 5)        ;   Obsolete name 
(defconstant $readOnlyMemoryException 6)        ;   Obsolete name 
(defconstant $unresolvablePageFaultException 7) ;   Obsolete name 
(defconstant $privilegeViolationException 8)    ;   Obsolete name 
(defconstant $traceException 9)                 ;   Obsolete name 
(defconstant $instructionBreakpointException 10);   Obsolete name 
(defconstant $dataBreakpointException 11)       ;   Obsolete name 
(defconstant $integerException 12)              ;   Obsolete name 
(defconstant $floatingPointException 13)        ;   Obsolete name 
(defconstant $stackOverflowException 14)        ;   Obsolete name 
(defconstant $terminationException 15)          ;   Obsolete name 
(defconstant $kTerminationException 15)         ;   Obsolete name 

; $ENDC                                         ; OLDROUTINENAMES

(def-mactype :exceptionkind (find-mactype ':unsigned-long))
(def-mactype :exceptioninfoptr (find-mactype '(:pointer :exceptioninfo)))
(defrecord ExceptionInfo 
   (:variant 
      (
      (memoryInfo (:pointer :memoryexceptioninformation))
      )
      )
   )

(def-mactype :exceptioninformationpowerpcptr (find-mactype '(:pointer :exceptioninformationpowerpc)))
(defrecord ExceptionInformationPowerPC 
   (theKind :unsigned-long)
   (machineState (:pointer :machineinformationpowerpc))
   (registerImage (:pointer :registerinformationpowerpc))
   (FPUImage (:pointer :fpuinformationpowerpc))
   (info :exceptioninfo)
   (vectorImage (:pointer :vectorinformationpowerpc))
   )

; $IFC TARGET_CPU_PPC OR TARGET_CPU_68K 
(%define-record :exceptioninformation (find-record-descriptor :exceptioninformationpowerpc))
(def-mactype :exceptioninformationptr (find-mactype '(:pointer :exceptioninformationpowerpc)))
(%define-record :machineinformation (find-record-descriptor :machineinformationpowerpc))
(def-mactype :machineinformationptr (find-mactype '(:pointer :machineinformationpowerpc)))
(%define-record :registerinformation (find-record-descriptor :registerinformationpowerpc))
(def-mactype :registerinformationptr (find-mactype '(:pointer :registerinformationpowerpc)))
(%define-record :fpuinformation (find-record-descriptor :fpuinformationpowerpc))
(def-mactype :fpuinformationptr (find-mactype '(:pointer :fpuinformationpowerpc)))
(%define-record :vectorinformation (find-record-descriptor :vectorinformationpowerpc))
(def-mactype :vectorinformationptr (find-mactype '(:pointer :vectorinformationpowerpc)))
; $ENDC
; 	 
; 	    Note:   An ExceptionHandler is NOT a UniversalProcPtr, except in Carbon.
; 	            It must be a PowerPC function pointer with NO routine descriptor, 
; 	            except on Carbon, where it must be a UniversalProcPtr (TPP actually)
; 	            to allow the interface to work from both CFM and Mach-O.
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExceptionHandlerProcPtr = FUNCTION(VAR theException: ExceptionInformation): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :exceptionhandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :exceptionhandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :exceptionhandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppExceptionHandlerProcInfo #xF1)
; 
; 	 *  NewExceptionHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewExceptionHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeExceptionHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeExceptionHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeExceptionHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;    ExceptionHandler function pointers (TPP):
;    on classic PowerPC, use raw function pointers
;    on classic PowerPC with OPAQUE_UPP_TYPES=1, use UPP's
;    on Carbon, use UPP's
;                                               ; $IFC TARGET_OS_MAC AND NOT OPAQUE_UPP_TYPES ;   use raw function pointers 
(deftrap-inline "_InvokeExceptionHandlerUPP" 
      ((theException (:pointer :exceptioninformationpowerpc)) (userRoutine :pointer)) 
  :osstatus
   () )
(def-mactype :exceptionhandlertpp (find-mactype ':pointer))
#|                                              ; $ELSEC
;   use UPP's 

(def-mactype :exceptionhandlertpp (find-mactype ':pointer))
 |#                                             ; $ENDC
(def-mactype :exceptionhandler (find-mactype ':pointer))
; 	 Routine for installing per-process exception handlers 	
; 
; 	 *  InstallExceptionHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_InstallExceptionHandler" 
      ((theHandler :pointer)) 
  :pointer
   () )                                         ; $ENDC; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MachineExceptionsIncludes

; $ENDC                                         ; __MACHINEEXCEPTIONS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MachineExceptions)