(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Math64.p"
; at Wednesday May 1,2002 2:39:58 pm.
; 
;      File:       Math64.p
;  
;      Contains:   64-bit integer math Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MATH64__
; $SETC __MATH64__ := 1

; $I+
; $SETC Math64Includes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  *  S64Max()
;  *  
;  *  Discussion:
;  *    Returns largest possible SInt64 value
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Max" 
      () 
  :wide
   () )

; 
;  *  S64Min()
;  *  
;  *  Discussion:
;  *    Returns smallest possible SInt64 value
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Min" 
      () 
  :wide
   () )

; 
;  *  S64Add()
;  *  
;  *  Discussion:
;  *    Adds two integers, producing an integer result.  If an overflow
;  *    occurs the result is congruent mod (2^64) as if the operands and
;  *    result were unsigned.  No overflow is signaled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Add" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; 
;  *  S64Subtract()
;  *  
;  *  Discussion:
;  *    Subtracts two integers, producing an integer result.  If an
;  *    overflow occurs the result is congruent mod (2^64) as if the
;  *    operands and result were unsigned.  No overflow is signaled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Subtract" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; 
;  *  S64Negate()
;  *  
;  *  Discussion:
;  *    Returns the additive inverse of a signed number (i.e. it returns
;  *    0 - the number).  S64Negate (S64Min) is not representable (in
;  *    fact, it returns S64Min).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Negate" 
      ((value :wide)) 
  :wide
   () )

; $IFC NOT TYPE_LONGLONG 
; 
;  *  S64Absolute()
;  *  
;  *  Discussion:
;  *    Returns the absolute value of the number (i.e. the number if it
;  *    is positive, or 0 - the number if it is negative). Disabled for
;  *    compilers that support long long until llabs() is available
;  *    everywhere.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Absolute" 
      ((value :wide)) 
  :wide
   () )

; $ENDC

; 
;  *  S64Multiply()
;  *  
;  *  Discussion:
;  *    Multiplies two signed numbers, producing a signed result. 
;  *    Overflow is ignored and the low-order part of the product is
;  *    returned.  The sign of the result is not guaranteed to be correct
;  *    if the magnitude of the product is not representable.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Multiply" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  S64Mod()
;  *  
;  *  Discussion:
;  *    Returns the remainder of divide of dividend by divisor.  The sign
;  *    of the remainder is the same as the sign of the dividend (i.e.,
;  *    it takes the absolute values of the operands, does the division,
;  *    then fixes the sign of the quotient and remainder).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_S64Mod" 
      ((dividend :wide) (divisor :wide)) 
  :wide
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  S64Divide()
;  *  
;  *  Discussion:
;  *    Divides dividend by divisor, returning the quotient.  The
;  *    remainder is returned in *remainder if remainder (the pointer) is
;  *    non-NULL. The sign of the remainder is the same as the sign of
;  *    the dividend (i.e. it takes the absolute values of the operands,
;  *    does the division, then fixes the sign of the quotient and
;  *    remainder).  If the divisor is zero, then S64Max() will be
;  *    returned (or S64Min() if the dividend is negative), and the
;  *    remainder will be the dividend; no error is reported.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Divide" 
      ((dividend :wide) (divisor :wide) (remainder (:pointer :wide))) 
  :wide
   () )

; 
;  *  S64Set()
;  *  
;  *  Discussion:
;  *    Given an SInt32, returns an SInt64 with the same value.  Use this
;  *    routine instead of coding 64-bit constants (at least when the
;  *    constant will fit in an SInt32).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Set" 
      ((value :signed-long)) 
  :wide
   () )

; 
;  *  S64SetU()
;  *  
;  *  Discussion:
;  *    Given a UInt32, returns a SInt64 with the same value.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64SetU" 
      ((value :unsigned-long)) 
  :wide
   () )

; 
;  *  S32Set()
;  *  
;  *  Discussion:
;  *    Given an SInt64, returns an SInt32 by discarding the high-order
;  *    32 bits.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S32Set" 
      ((value :wide)) 
  :signed-long
   () )

; 
;  *  S64And()
;  *  
;  *  Discussion:
;  *    Returns one if left and right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64And" 
      ((left :wide) (right :wide)) 
  :boolean
   () )

; 
;  *  S64Or()
;  *  
;  *  Discussion:
;  *    Returns one if left or right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Or" 
      ((left :wide) (right :wide)) 
  :boolean
   () )

; 
;  *  S64Eor()
;  *  
;  *  Discussion:
;  *    Returns one if left xor right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Eor" 
      ((left :wide) (right :wide)) 
  :boolean
   () )

; 
;  *  S64Not()
;  *  
;  *  Discussion:
;  *    Returns one if value is non-zero, otherwisze returns zero.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Not" 
      ((value :wide)) 
  :boolean
   () )

; 
;  *  S64Compare()
;  *  
;  *  Discussion:
;  *    Given two signed numbers, left and right, returns an SInt32 that
;  *    compares with zero the same way left compares with right.  If you
;  *    wanted to perform a comparison on 64-bit integers of the
;  *    form:
;  *    operand_1 <operation> operand_2
;  *    then you could use an expression of the form:
;  *     xxxS64Compare(operand_1,operand_2) <operation> 0
;  *    to test for the same condition. CAUTION: DO NOT depend on the
;  *    exact value returned by this routine. Only the sign (i.e.
;  *    positive, zero, or negative) of the result is guaranteed.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64Compare" 
      ((left :wide) (right :wide)) 
  :signed-long
   () )

; 
;  *  S64BitwiseAnd()
;  *  
;  *  Discussion:
;  *    bitwise AND
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64BitwiseAnd" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; 
;  *  S64BitwiseOr()
;  *  
;  *  Discussion:
;  *    bitwise OR
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64BitwiseOr" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; 
;  *  S64BitwiseEor()
;  *  
;  *  Discussion:
;  *    bitwise XOR
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64BitwiseEor" 
      ((left :wide) (right :wide)) 
  :wide
   () )

; 
;  *  S64BitwiseNot()
;  *  
;  *  Discussion:
;  *    bitwise negate
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64BitwiseNot" 
      ((value :wide)) 
  :wide
   () )

; 
;  *  S64ShiftRight()
;  *  
;  *  Discussion:
;  *    Arithmetic shift of value by the lower 7 bits of the shift.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64ShiftRight" 
      ((value :wide) (shift :unsigned-long)) 
  :wide
   () )

; 
;  *  S64ShiftLeft()
;  *  
;  *  Discussion:
;  *    Logical shift of value by the lower 7 bits of the shift.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_S64ShiftLeft" 
      ((value :wide) (shift :unsigned-long)) 
  :wide
   () )

; 
;  *  U64Max()
;  *  
;  *  Discussion:
;  *    Returns largest possible UInt64 value
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Max" 
      () 
  :unsignedwide
   () )

; 
;  *  U64Add()
;  *  
;  *  Discussion:
;  *    Adds two unsigned integers, producing an integer result.  If an
;  *    overflow occurs the result is congruent mod (2^64) as if the
;  *    operands and result were unsigned.  No overflow is signaled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Add" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64Subtract()
;  *  
;  *  Discussion:
;  *    Subtracts two unsigned integers, producing an integer result.  If
;  *    an overflow occurs the result is congruent mod (2^64) as if the
;  *    operands and result were unsigned.  No overflow is signaled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Subtract" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64Multiply()
;  *  
;  *  Discussion:
;  *    Multiplies two unsigned numbers, producing a signed result. 
;  *    Overflow is ignored and the low-order part of the product is
;  *    returned.  The sign of the result is not guaranteed to be correct
;  *    if the magnitude of the product is not representable.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Multiply" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  U64Mod()
;  *  
;  *  Discussion:
;  *    Returns the remainder of divide of dividend by divisor.  The sign
;  *    of the remainder is the same as the sign of the dividend (i.e.,
;  *    it takes the absolute values of the operands, does the division,
;  *    then fixes the sign of the quotient and remainder).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_U64Mod" 
      ((dividend :unsignedwide) (divisor :unsignedwide)) 
  :unsignedwide
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  U64Divide()
;  *  
;  *  Discussion:
;  *    Divides dividend by divisor, returning the quotient.  The
;  *    remainder is returned in *remainder if remainder (the pointer) is
;  *    non-NULL. The sign of the remainder is the same as the sign of
;  *    the dividend (i.e. it takes the absolute values of the operands,
;  *    does the division, then fixes the sign of the quotient and
;  *    remainder).  If the divisor is zero, then U64Max() will be
;  *    returned (or U64Min() if the dividend is negative), and the
;  *    remainder will be the dividend; no error is reported.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Divide" 
      ((dividend :unsignedwide) (divisor :unsignedwide) (remainder (:pointer :unsignedwide))) 
  :unsignedwide
   () )

; 
;  *  U64Set()
;  *  
;  *  Discussion:
;  *    Given an SInt32, returns an UInt64 with the same value.  Use this
;  *    routine instead of coding 64-bit constants (at least when the
;  *    constant will fit in an SInt32).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Set" 
      ((value :signed-long)) 
  :unsignedwide
   () )

; 
;  *  U64SetU()
;  *  
;  *  Discussion:
;  *    Given a UInt32, returns a UInt64 with the same value.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64SetU" 
      ((value :unsigned-long)) 
  :unsignedwide
   () )

; 
;  *  U32SetU()
;  *  
;  *  Discussion:
;  *    Given an UInt64, returns an UInt32 by discarding the high-order
;  *    32 bits.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U32SetU" 
      ((value :unsignedwide)) 
  :unsigned-long
   () )

; 
;  *  U64And()
;  *  
;  *  Discussion:
;  *    Returns one if left and right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64And" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :boolean
   () )

; 
;  *  U64Or()
;  *  
;  *  Discussion:
;  *    Returns one if left or right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Or" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :boolean
   () )

; 
;  *  U64Eor()
;  *  
;  *  Discussion:
;  *    Returns one if left xor right are non-zero, otherwise returns zero
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Eor" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :boolean
   () )

; 
;  *  U64Not()
;  *  
;  *  Discussion:
;  *    Returns one if value is non-zero, otherwisze returns zero.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Not" 
      ((value :unsignedwide)) 
  :boolean
   () )

; 
;  *  U64Compare()
;  *  
;  *  Discussion:
;  *    Given two unsigned numbers, left and right, returns an SInt32
;  *    that compares with zero the same way left compares with right. 
;  *    If you wanted to perform a comparison on 64-bit integers of the
;  *    form:
;  *    operand_1 <operation> operand_2
;  *    then you could use an expression of the form:
;  *     xxxU64Compare(operand_1,operand_2) <operation> 0
;  *    to test for the same condition. CAUTION: DO NOT depend on the
;  *    exact value returned by this routine. Only the sign (i.e.
;  *    positive, zero, or negative) of the result is guaranteed.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64Compare" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :signed-long
   () )

; 
;  *  U64BitwiseAnd()
;  *  
;  *  Discussion:
;  *    bitwise AND
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64BitwiseAnd" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64BitwiseOr()
;  *  
;  *  Discussion:
;  *    bitwise OR
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64BitwiseOr" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64BitwiseEor()
;  *  
;  *  Discussion:
;  *    bitwise XOR
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64BitwiseEor" 
      ((left :unsignedwide) (right :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64BitwiseNot()
;  *  
;  *  Discussion:
;  *    bitwise negate
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64BitwiseNot" 
      ((value :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  U64ShiftRight()
;  *  
;  *  Discussion:
;  *    Arithmetic shift of value by the lower 7 bits of the shift.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64ShiftRight" 
      ((value :unsignedwide) (shift :unsigned-long)) 
  :unsignedwide
   () )

; 
;  *  U64ShiftLeft()
;  *  
;  *  Discussion:
;  *    Logical shift of value by the lower 7 bits of the shift.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_U64ShiftLeft" 
      ((value :unsignedwide) (shift :unsigned-long)) 
  :unsignedwide
   () )

; 
;  *  UInt64ToSInt64()
;  *  
;  *  Discussion:
;  *    converts UInt64 -> SInt64
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UInt64ToSInt64" 
      ((value :unsignedwide)) 
  :wide
   () )

; 
;  *  SInt64ToUInt64()
;  *  
;  *  Discussion:
;  *    converts SInt64 -> UInt64
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SInt64ToUInt64" 
      ((value :wide)) 
  :unsignedwide
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := Math64Includes

; $ENDC                                         ; __MATH64__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Math64)