(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Menus.p"
; at Wednesday May 1,2002 2:39:38 pm.
; 
;      File:       Menus.p
;  
;      Contains:   Menu Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MENUS__
; $SETC __MENUS__ := 1

; $I+
; $SETC MenusIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __FONTS__

(require-interface 'Fonts)                      ; $I Fonts.p
; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __PROCESSES__

(require-interface 'Processes)                  ; $I Processes.p
; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COLLECTIONS__
|#

(require-interface 'Collections)
#|                                              ; $I Collections.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __CFUUID__

(require-interface 'CFUUID)                     ; $I CFUUID.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  *  Menu Manager
;  
; 
;    Menu Constants                                                                    
; 

(defconstant $noMark 0)                         ;   mark symbol for SetItemMark; other mark symbols are defined in Fonts.h  

; 	
; 	    A Short Course on Menu Definition Functions
; 	    
; 	    A menu definition function is used to implement a custom visual appearance for a menu.
; 	    Menu definition functions are still supported in Carbon, but the messages sent to a
; 	    menu definition function in Carbon are different than for a non-Carbon application.
; 	    
; 	    In general, Apple recommends using the system menu definition whenever possible.
; 	    Menu definition functions will continue to be supported, but it is not easy to write
; 	    a correct menu definition, especially one that attempts to imitate the standard system
; 	    menu appearance. If you require special features in your menu that the system menu
; 	    definition does not support, please mail <toolbox@apple.com> and describe your requirements;
; 	    we would much rather enhance the system menu definition than have you write a custom one.
; 	    
; 	    Menu definition functions before Carbon used the following messages:
; 	    
; 	        kMenuDrawMsg
; 	        kMenuChooseMsg
; 	        kMenuSizeMsg
; 	        kMenuPopUpMsg
; 	        kMenuDrawItemMsg
; 	        kMenuCalcItemMsg
; 	        kMenuThemeSavvyMsg
; 	        
; 	    kMenuChooseMsg and kMenuDrawItemMsg are not supported in Carbon and are not sent to
; 	    Carbon menu definitions. In Carbon, kMenuChooseMsg is replaced by kMenuFindItemMsg and
; 	    kMenuHiliteItemMsg. Menu definition functions in Carbon use the following messages:
; 	    
; 	        kMenuInitMsg
; 	        kMenuDisposeMsg
; 	        kMenuFindItemMsg
; 	        kMenuHiliteItemMsg
; 	        kMenuDrawItemsMsg
; 	        kMenuDrawMsg
; 	        kMenuSizeMsg
; 	        kMenuPopUpMsg
; 	        kMenuCalcItemMsg
; 	        kMenuThemeSavvyMsg
; 	        
; 	    The rest of this documentation will focus on Carbon menu definitions only.
; 	    
; 	    Menu Definition Messages
; 	    
; 	        Carbon menu definition functions should support the following messages:
; 	        
; 	        kMenuInitMsg
; 	            
; 	            menuRect        unused
; 	            hitPt           unused
; 	            whichItem       OSErr*
; 	        
; 	            Sent when a menu is created. This message gives the menu definition an opportunity
; 	            to initialize its own state. If the menu definition encounters an error while
; 	            initializing, it should set *whichItem to a non-zero error code; this will cause the
; 	            Menu Manager to destroy the menu and return an error back from the API that was used
; 	            to create the menu.
; 	        
; 	        kMenuDisposeMsg
; 	            
; 	            menuRect        unused
; 	            hitPt           unused
; 	            whichItem       unused
; 	            
; 	            Sent when a menu is destroyed. This message gives the menu definition an opportunity
; 	            to destroy its own data.
; 	            
; 	        kMenuFindItemMsg
; 	            
; 	            menuRect        menu bounds
; 	            hitPt           point to hit-test
; 	            whichItem       MDEFFindItemData*
; 	            
; 	            Sent when the Menu Manager is displaying a menu and needs to know what item is under
; 	            the mouse. The whichItem parameter is actually a pointer to a MenuTrackingData structure.
; 	            On entry, the menu, virtualMenuTop, and virtualMenuBottom fields of this structure are
; 	            valid. The menu definition should determine which item containst the given point, if any,
; 	            and fill in the itemUnderMouse, itemSelected, and itemRect fields. If an item is found,
; 	            the menu definition should always fill in the itemUnderMouse and itemRect fields. The
; 	            menu definition should only fill in the itemSelected field if the item is available for
; 	            selection; if it is unavailable (because it is disabled, or for some other reason), the
; 	            menu definition should set the itemSelected field to zero.
; 	            
; 	            The values placed in the itemUnderMouse and item
;   menu defProc messages  
(defconstant $kMenuDrawMsg 0)
(defconstant $kMenuSizeMsg 2)
(defconstant $kMenuPopUpMsg 3)
(defconstant $kMenuCalcItemMsg 5)
(defconstant $kMenuThemeSavvyMsg 7)             ;   is your MDEF theme-savvy?  If so, return kThemeSavvyMenuResponse in the whichItem parameter 
(defconstant $mDrawMsg 0)
(defconstant $mSizeMsg 2)
(defconstant $mPopUpMsg 3)                      ;   position the popup menu rect appropriately  
(defconstant $mCalcItemMsg 5)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	   Carbon MDEFs must replace mChooseMsg with the new messages kMenuFindItemMsg and kMenuHiliteItemMsg. 
; 	   mDrawItemMsg was used by the popup menu control before 8.5, but is no longer used. 
; 	
(defconstant $mChooseMsg 1)
(defconstant $mDrawItemMsg 4)
(defconstant $kMenuChooseMsg 1)
(defconstant $kMenuDrawItemMsg 4)

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kThemeSavvyMenuResponse #x7473)   ;   should be returned in *whichItem when handling kMenuThemeSavvyMsg 

;   these MDEF messages are only supported in Carbon 
(defconstant $kMenuInitMsg 8)
(defconstant $kMenuDisposeMsg 9)
(defconstant $kMenuFindItemMsg 10)
(defconstant $kMenuHiliteItemMsg 11)
(defconstant $kMenuDrawItemsMsg 12)

(defconstant $textMenuProc 0)
(defconstant $hMenuCmd 27)                      ;  itemCmd == 0x001B ==> hierarchical menu 
(defconstant $hierMenu -1)                      ;  a hierarchical menu - for InsertMenu call 
(defconstant $kInsertHierarchicalMenu -1)       ;  a better name for hierMenu  
(defconstant $mctAllItems -98)                  ;  search for all Items for the given ID 
(defconstant $mctLastIDIndic -99)               ;  last color table entry has this in ID field 

;   Constants for use with MacOS 8.0 (Appearance 1.0) and later 
(defconstant $kMenuStdMenuProc 63)
(defconstant $kMenuStdMenuBarProc 63)

;   For use with Get/SetMenuItemModifiers 
(defconstant $kMenuNoModifiers 0)               ;   Mask for no modifiers 
(defconstant $kMenuShiftModifier #x1)           ;   Mask for shift key modifier 
(defconstant $kMenuOptionModifier #x2)          ;   Mask for option key modifier 
(defconstant $kMenuControlModifier #x4)         ;   Mask for control key modifier 
(defconstant $kMenuNoCommandModifier #x8)       ;   Mask for no command key modifier 

;   For use with Get/SetMenuItemIconHandle 
(defconstant $kMenuNoIcon 0)                    ;   No icon 
(defconstant $kMenuIconType 1)                  ;   Type for ICON 
(defconstant $kMenuShrinkIconType 2)            ;   Type for ICON plotted 16 x 16 
(defconstant $kMenuSmallIconType 3)             ;   Type for SICN 
(defconstant $kMenuColorIconType 4)             ;   Type for cicn 
(defconstant $kMenuIconSuiteType 5)             ;   Type for Icon Suite 
(defconstant $kMenuIconRefType 6)               ;   Type for Icon Ref 
(defconstant $kMenuCGImageRefType 7)            ;   Type for a CGImageRef (Mac OS X only) 
(defconstant $kMenuSystemIconSelectorType 8)    ;   Type for an IconRef registered with Icon Services under kSystemIconsCreator (after Mac OS X 10.0.x only) 
(defconstant $kMenuIconResourceType 9)          ;   Type for a CFStringRef naming a resource in the main bundle of the process (after Mac OS X 10.0.x only) 

;   For use with Get/SetMenuItemKeyGlyph 
(defconstant $kMenuNullGlyph #x0)               ;   Null (always glyph 1) 
(defconstant $kMenuTabRightGlyph #x2)           ;   Tab to the right key (for left-to-right script systems) 
(defconstant $kMenuTabLeftGlyph #x3)            ;   Tab to the left key (for right-to-left script systems) 
(defconstant $kMenuEnterGlyph #x4)              ;   Enter key 
(defconstant $kMenuShiftGlyph #x5)              ;   Shift key 
(defconstant $kMenuControlGlyph #x6)            ;   Control key 
(defconstant $kMenuOptionGlyph #x7)             ;   Option key 
(defconstant $kMenuSpaceGlyph #x9)              ;   Space (always glyph 3) key 
(defconstant $kMenuDeleteRightGlyph #xA)        ;   Delete to the right key (for right-to-left script systems) 
(defconstant $kMenuReturnGlyph #xB)             ;   Return key (for left-to-right script systems) 
(defconstant $kMenuReturnR2LGlyph #xC)          ;   Return key (for right-to-left script systems) 
(defconstant $kMenuNonmarkingReturnGlyph #xD)   ;   Nonmarking return key 
(defconstant $kMenuPencilGlyph #xF)             ;   Pencil key 
(defconstant $kMenuDownwardArrowDashedGlyph #x10);   Downward dashed arrow key 
(defconstant $kMenuCommandGlyph #x11)           ;   Command key 
(defconstant $kMenuCheckmarkGlyph #x12)         ;   Checkmark key 
(defconstant $kMenuDiamondGlyph #x13)           ;   Diamond key 
(defconstant $kMenuAppleLogoFilledGlyph #x14)   ;   Apple logo key (filled) 
(defconstant $kMenuParagraphKoreanGlyph #x15)   ;   Unassigned (paragraph in Korean) 
(defconstant $kMenuDeleteLeftGlyph #x17)        ;   Delete to the left key (for left-to-right script systems) 
(defconstant $kMenuLeftArrowDashedGlyph #x18)   ;   Leftward dashed arrow key 
(defconstant $kMenuUpArrowDashedGlyph #x19)     ;   Upward dashed arrow key 
(defconstant $kMenuRightArrowDashedGlyph #x1A)  ;   Rightward dashed arrow key 
(defconstant $kMenuEscapeGlyph #x1B)            ;   Escape key 
(defconstant $kMenuClearGlyph #x1C)             ;   Clear key 
(defconstant $kMenuLeftDoubleQuotesJapaneseGlyph #x1D);   Unassigned (left double quotes in Japanese) 
(defconstant $kMenuRightDoubleQuotesJapaneseGlyph #x1E);   Unassigned (right double quotes in Japanese) 
(defconstant $kMenuTrademarkJapaneseGlyph #x1F) ;   Unassigned (trademark in Japanese) 
(defconstant $kMenuBlankGlyph #x61)             ;   Blank key 
(defconstant $kMenuPageUpGlyph #x62)            ;   Page up key 
(defconstant $kMenuCapsLockGlyph #x63)          ;   Caps lock key 
(defconstant $kMenuLeftArrowGlyph #x64)         ;   Left arrow key 
(defconstant $kMenuRightArrowGlyph #x65)        ;   Right arrow key 
(defconstant $kMenuNorthwestArrowGlyph #x66)    ;   Northwest arrow key 
(defconstant $kMenuHelpGlyph #x67)              ;   Help key 
(defconstant $kMenuUpArrowGlyph #x68)           ;   Up arrow key 
(defconstant $kMenuSoutheastArrowGlyph #x69)    ;   Southeast arrow key 
(defconstant $kMenuDownArrowGlyph #x6A)         ;   Down arrow key 
(defconstant $kMenuPageDownGlyph #x6B)          ;   Page down key 
(defconstant $kMenuAppleLogoOutlineGlyph #x6C)  ;   Apple logo key (outline) 
(defconstant $kMenuContextualMenuGlyph #x6D)    ;   Contextual menu key 
(defconstant $kMenuPowerGlyph #x6E)             ;   Power key 
(defconstant $kMenuF1Glyph #x6F)                ;   F1 key 
(defconstant $kMenuF2Glyph #x70)                ;   F2 key 
(defconstant $kMenuF3Glyph #x71)                ;   F3 key 
(defconstant $kMenuF4Glyph #x72)                ;   F4 key 
(defconstant $kMenuF5Glyph #x73)                ;   F5 key 
(defconstant $kMenuF6Glyph #x74)                ;   F6 key 
(defconstant $kMenuF7Glyph #x75)                ;   F7 key 
(defconstant $kMenuF8Glyph #x76)                ;   F8 key 
(defconstant $kMenuF9Glyph #x77)                ;   F9 key 
(defconstant $kMenuF10Glyph #x78)               ;   F10 key 
(defconstant $kMenuF11Glyph #x79)               ;   F11 key 
(defconstant $kMenuF12Glyph #x7A)               ;   F12 key 
(defconstant $kMenuF13Glyph #x87)               ;   F13 key 
(defconstant $kMenuF14Glyph #x88)               ;   F14 key 
(defconstant $kMenuF15Glyph #x89)               ;   F15 key 
(defconstant $kMenuControlISOGlyph #x8A)        ;   Control key (ISO standard) 

; 
; 	 *  MenuAttributes
; 	 *  
; 	 *  Summary:
; 	 *    Menu attributes control behavior of the entire menu. They are
; 	 *    used with the Get/ChangeMenuAttributes APIs.
; 	 	

(def-mactype :menuattributes (find-mactype ':unsigned-long))

(defconstant $kMenuAttrExcludesMarkColumn #x1)
(defconstant $kMenuAttrAutoDisable #x4)
(defconstant $kMenuAttrUsePencilGlyph #x8)

; 
; 	 *  MenuItemAttributes
; 	 *  
; 	 *  Summary:
; 	 *    Menu item attributes control behavior of individual menu items.
; 	 *    They are used with the Get/ChangeMenuItemAttributes APIs.
; 	 	

(def-mactype :menuitemattributes (find-mactype ':unsigned-long))

(defconstant $kMenuItemAttrDisabled #x1)
(defconstant $kMenuItemAttrIconDisabled #x2)
(defconstant $kMenuItemAttrSubmenuParentChoosable #x4)
(defconstant $kMenuItemAttrDynamic #x8)
(defconstant $kMenuItemAttrNotPreviousAlternate #x10)
(defconstant $kMenuItemAttrHidden #x20)
(defconstant $kMenuItemAttrSeparator #x40)
(defconstant $kMenuItemAttrSectionHeader #x80)
(defconstant $kMenuItemAttrIgnoreMeta #x100)
(defconstant $kMenuItemAttrAutoRepeat #x200)
(defconstant $kMenuItemAttrUseVirtualKey #x400)
(defconstant $kMenuItemAttrCustomDraw #x800)

; 
; 	 *  MenuTrackingMode
; 	 *  
; 	 *  Summary:
; 	 *    A menu tracking mode constant is part of the
; 	 *    kEventMenuBeginTracking and kEventMenuChangeTrackingMode Carbon
; 	 *    events. It indicates whether menus are being tracked using the
; 	 *    mouse or keyboard.
; 	 	

(def-mactype :menutrackingmode (find-mactype ':unsigned-long))

(defconstant $kMenuTrackingModeMouse 1)
(defconstant $kMenuTrackingModeKeyboard 2)

; 
; 	 *  MenuEventOptions
; 	 *  
; 	 *  Summary:
; 	 *    Menu event options control how the menus are searched for an item
; 	 *    matching a particular keyboard event. They are used with the
; 	 *    IsMenuKeyEvent API.
; 	 	

(def-mactype :menueventoptions (find-mactype ':unsigned-long))

(defconstant $kMenuEventIncludeDisabledItems #x1)
(defconstant $kMenuEventQueryOnly #x2)
(defconstant $kMenuEventDontCheckSubmenus #x4)

; 		
; 	   Menu Types                                                                        	
; 		

(def-mactype :menuid (find-mactype ':signed-integer))
(def-mactype :menuitemindex (find-mactype ':unsigned-integer))
(def-mactype :menucommand (find-mactype ':unsigned-long))
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :menuinfoptr (find-mactype '(:pointer :menuinfo)))
(defrecord (MenuInfo :handle) 
   (MenuID :signed-integer)                     ;   in Carbon use Get/SetMenuID 
   (menuWidth :signed-integer)                  ;   in Carbon use Get/SetMenuWidth 
   (menuHeight :signed-integer)                 ;   in Carbon use Get/SetMenuHeight 
   (menuProc :handle)                           ;   not supported in Carbon 
   (enableFlags :signed-long)                   ;   in Carbon use Enable/DisableMenuItem, IsMenuItemEnable 
   (menuData (:string 255))                     ;   in Carbon use Get/SetMenuTitle 
   )

(def-mactype :menuptr (find-mactype '(:pointer :menuinfo)))
(def-mactype :menuhandle (find-mactype '(:handle :menuinfo)))
#|                                              ; $ELSEC
(def-mactype :menuhandle (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :menuhandleptr (find-mactype '(:pointer (:handle :menuinfo))));  when a VAR xx:MenuHandle parameter can be nil, it is changed to xx: MenuHandlePtr 
 |#                                             ; $ENDC

;   MenuRef and MenuHandle are equivalent. Use either. We don't care. 
(def-mactype :menuref (find-mactype '(:handle :menuinfo)))
(def-mactype :menubarhandle (find-mactype ':handle))
(def-mactype :mcentryptr (find-mactype '(:pointer :mcentry)))
(defrecord MCEntry 
   (mctID :signed-integer)                      ;  menu ID.  ID = 0 is the menu bar 
   (mctItem :signed-integer)                    ;  menu Item. Item = 0 is a title 
   (mctRGB1 :rgbcolor)                          ;  usage depends on ID and Item 
   (mctRGB2 :rgbcolor)                          ;  usage depends on ID and Item 
   (mctRGB3 :rgbcolor)                          ;  usage depends on ID and Item 
   (mctRGB4 :rgbcolor)                          ;  usage depends on ID and Item 
   (mctReserved :signed-integer)                ;  reserved for internal use 
   )

(defrecord (MCTable :handle) (array (:array :mcentry 1)))
(def-mactype :mctableptr (find-mactype '(:pointer :mctable)))
(def-mactype :mctablehandle (find-mactype '(:handle :mctable)))
(def-mactype :menucrsrcptr (find-mactype '(:pointer :menucrsrc)))
(defrecord (MenuCRsrc :handle) 
   (numEntries :signed-integer)                 ;  number of entries 
   (mcEntryRecs :mctable)                       ;  ARRAY [1..numEntries] of MCEntry 
   )

(def-mactype :menucrsrchandle (find-mactype '(:handle :menucrsrc)))
#|                                              ; $IFC TARGET_OS_WIN32 
; 	 QuickTime 3.0 	
(def-mactype :menuaccesskeyrecptr (find-mactype '(:pointer :menuaccesskeyrec)))
(defrecord MenuAccessKeyRec 
   (count :signed-integer)
   (flags :signed-long)
   ;;Changing field keys from signed-byte to unsigned-byte to match C header (educated-guess)
   (keys :unsigned-byte)
   )

(def-mactype :menuaccesskeyptr (find-mactype '(:pointer :menuaccesskeyrec)))
(def-mactype :menuaccesskeyhandle (find-mactype '(:pointer :menuaccesskeyptr)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SetMenuItemHotKey()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SetMenuItemHotKey" 
      ((menu (:handle :menuinfo)) (itemID :signed-integer) (hotKey :signed-byte) (flags :signed-long)) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_OS_WIN32

; 
;  *  MenuTrackingData
;  *  
;  *  Summary:
;  *    The MenuTrackingData structure contains information about a menu
;  *    currently being displayed. It is used with the
;  *    GetMenuTrackingData API.
;  

(def-mactype :menutrackingdataptr (find-mactype '(:pointer :menutrackingdata)))
(defrecord MenuTrackingData 
   (menu (:handle :menuinfo))
   (itemSelected :unsigned-integer)
   (itemUnderMouse :unsigned-integer)
   (itemRect :rect)
   (virtualMenuTop :signed-long)
   (virtualMenuBottom :signed-long)
   )

; 
; 	 *  MDEFHiliteItemData
; 	 *  
; 	 *  Summary:
; 	 *    The MDEFHiliteItemData structure contains information about which
; 	 *    menu items should be hilited and unhilited as the user moves
; 	 *    through the menus. It is used by menu definition functions, which
; 	 *    receive a pointer to an MDEFHiliteItemData structure as the
; 	 *    whichItem parameter during kMenuHiliteItemMsg.
; 	 	
(def-mactype :mdefhiliteitemdataptr (find-mactype '(:pointer :mdefhiliteitemdata)))
(defrecord MDEFHiliteItemData 
   (previousItem :unsigned-integer)
   (newItem :unsigned-integer)
   (context :pointer)
   )

(%define-record :hilitemenuitemdata (find-record-descriptor :mdefhiliteitemdata))
(def-mactype :hilitemenuitemdataptr (find-mactype '(:pointer :mdefhiliteitemdata)))

; 
; 	 *  MDEFDrawData
; 	 *  
; 	 *  Summary:
; 	 *    The MDEFDrawData structure contains information needed to draw a
; 	 *    menu. It is used by menu definition functions, which receive a
; 	 *    pointer to an MDEFDrawData structure as the whichItem parameter
; 	 *    during kMenuDrawMsg.
; 	 	
(def-mactype :mdefdrawdataptr (find-mactype '(:pointer :mdefdrawdata)))
(defrecord MDEFDrawData 
   (trackingData :menutrackingdata)
   (context :pointer)
   )

; 
; 	 *  MDEFFindItemData
; 	 *  
; 	 *  Summary:
; 	 *    The MDEFFindItemData structure contains information needed to
; 	 *    determine which item is currently selected by the user. It is
; 	 *    used by menu definition functions, which receive a pointer to an
; 	 *    MDEFDrawData structure as the whichItem parameter during
; 	 *    kMenuFindItemMsg.
; 	 	
(def-mactype :mdeffinditemdataptr (find-mactype '(:pointer :mdeffinditemdata)))
(defrecord MDEFFindItemData 
   (trackingData :menutrackingdata)
   (context :pointer)
   )

; 
; 	 *  MDEFDrawItemsData
; 	 *  
; 	 *  Summary:
; 	 *    The MDEFDrawItemsData structure contains information about which
; 	 *    menu items to redraw. It is used by menu definition functions,
; 	 *    which receive a pointer to an MDEFDrawItemsData structure as the
; 	 *    whichItem parameter during kMenuDrawItemsMsg.
; 	 	
(def-mactype :mdefdrawitemsdataptr (find-mactype '(:pointer :mdefdrawitemsdata)))
(defrecord MDEFDrawItemsData 
   (firstItem :unsigned-integer)
   (lastItem :unsigned-integer)
   (trackingData (:pointer :menutrackingdata))
   (context :pointer)
   )

; 
; 	 *  Summary:
; 	 *    A MenuItemDataFlags value indicates which fields of a
; 	 *    MenuItemDataRec structure should be used by the
; 	 *    Copy/SetMenuItemData APIs. All MenuItemDataFlags may be used when
; 	 *    getting or setting the contents of a menu item; some may also be
; 	 *    used when getting or setting information about the menu itself,
; 	 *    if the item index given to Copy/SetMenuItemData is 0.
; 	 	

(defconstant $kMenuItemDataText #x1)
(defconstant $kMenuItemDataMark #x2)
(defconstant $kMenuItemDataCmdKey #x4)
(defconstant $kMenuItemDataCmdKeyGlyph #x8)
(defconstant $kMenuItemDataCmdKeyModifiers #x10)
(defconstant $kMenuItemDataStyle #x20)
(defconstant $kMenuItemDataEnabled #x40)
(defconstant $kMenuItemDataIconEnabled #x80)
(defconstant $kMenuItemDataIconID #x100)
(defconstant $kMenuItemDataIconHandle #x200)
(defconstant $kMenuItemDataCommandID #x400)
(defconstant $kMenuItemDataTextEncoding #x800)
(defconstant $kMenuItemDataSubmenuID #x1000)
(defconstant $kMenuItemDataSubmenuHandle #x2000)
(defconstant $kMenuItemDataFontID #x4000)
(defconstant $kMenuItemDataRefcon #x8000)
(defconstant $kMenuItemDataAttributes #x10000)
(defconstant $kMenuItemDataCFString #x20000)
(defconstant $kMenuItemDataProperties #x40000)
(defconstant $kMenuItemDataIndent #x80000)
(defconstant $kMenuItemDataCmdVirtualKey #x100000)
(defconstant $kMenuItemDataAllDataVersionOne #xFFFFF)
(defconstant $kMenuItemDataAllDataVersionTwo #x1FFFFF)

(%define-record :menuitemdataflags (find-record-descriptor :unsignedwide))
(def-mactype :menuitemdataflagsptr (find-mactype '(:pointer :unsignedwide)))

; 
; 	 *  MenuItemDataRec
; 	 *  
; 	 *  Summary:
; 	 *    The MenuItemDataRec structure is used to get and change aspects
; 	 *    of a menu item. It is used with the Copy/SetMenuItemData APIs.
; 	 *  
; 	 *  Discussion:
; 	 *    When using this structure with Copy/SetMenuItemData, the caller
; 	 *    must first set the whichData field to a combination of
; 	 *    MenuItemDataFlags indicating which specific data should be
; 	 *    retrieved or set. Some fields also require initialization before
; 	 *    calling CopyMenuItemData; see the individual MenuItemDataFlags
; 	 *    documentation for details.
; 	 	
(def-mactype :menuitemdatarecptr (find-mactype '(:pointer :menuitemdatarec)))
(defrecord MenuItemDataRec 
   (whichData :unsignedwide)
   (text (:pointer (:string 255)))
   (mark :unsigned-integer)
   (cmdKey :unsigned-integer)
   (cmdKeyGlyph :unsigned-long)
   (cmdKeyModifiers :unsigned-long)
   (style :signed-byte)
   (enabled :boolean)
   (iconEnabled :boolean)
   (filler1 :signed-byte)
   (iconID :signed-long)
   (iconType :unsigned-long)
   (iconHandle :handle)
   (cmdID :unsigned-long)
   (encoding :unsigned-long)
   (submenuID :signed-integer)
   (submenuHandle (:handle :menuinfo))
   (fontID :signed-long)
   (refcon :unsigned-long)
   (attr :unsigned-long)
   (cfText :pointer)
   (properties :pointer)
   (indent :unsigned-long)
   (cmdVirtualKey :unsigned-integer)
   )

(def-mactype :menuitemdataptr (find-mactype '(:pointer :menuitemdatarec)))
(def-mactype :menuitemid (find-mactype ':unsigned-long))
; 		
; 	   Menu ProcPtrs                                                                     	
; 	                                                                                      	
; 	  All of these procs are considered deprecated.  Developers interested in portability 	
; 	  to Carbon should avoid them entirely, if at all possible.                           	
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MenuDefProcPtr = PROCEDURE(message: INTEGER; theMenu: MenuRef; VAR menuRect: Rect; hitPt: Point; VAR whichItem: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :menudefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :menudefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :menudefupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppMenuDefProcInfo #xFF80)
; 
; 	 *  NewMenuDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewMenuDefProc 
(deftrap "_NewMenuDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeMenuDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMenuDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeMenuDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallMenuDefProc 
(deftrap-inline "_InvokeMenuDefUPP" 
      ((message :signed-integer) (theMenu (:handle :menuinfo)) (menuRect (:pointer :rect)) (hitPt :point) (whichItem (:pointer :signed-integer)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MenuBarDefProcPtr = FUNCTION(selector: INTEGER; message: INTEGER; parameter1: INTEGER; parameter2: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :menubardefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MenuHookProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :menuhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MBarHookProcPtr = FUNCTION(VAR menuRect: Rect): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :mbarhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :menubardefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :menubardefupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :menuhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :menuhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mbarhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mbarhookupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppMenuBarDefProcInfo #x3AB0)
(defconstant $uppMenuHookProcInfo #x0)
(defconstant $uppMBarHookProcInfo #xCF)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewMenuBarDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewMenuBarDefProc 
(deftrap "_NewMenuBarDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMenuHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMenuHookProc 
(deftrap "_NewMenuHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMBarHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMBarHookProc 
(deftrap "_NewMBarHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeMenuBarDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMenuBarDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMenuHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMenuHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMBarHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMBarHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeMenuBarDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMenuBarDefProc 
(deftrap-inline "_InvokeMenuBarDefUPP" 
      ((selector :signed-integer) (message :signed-integer) (parameter1 :signed-integer) (parameter2 :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeMenuHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMenuHookProc 
(deftrap "_InvokeMenuHookUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; 
;  *  InvokeMBarHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallMBarHookProc 
(deftrap-inline "_InvokeMBarHookUPP" 
      ((menuRect (:pointer :rect)) (userRoutine :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $kMenuDefProcPtr 0)                ;   raw proc-ptr access based on old MDEF  

(def-mactype :menudeftype (find-mactype ':unsigned-long))
(def-mactype :menudefspecptr (find-mactype '(:pointer :menudefspec)))
(defrecord MenuDefSpec 
   (defType :unsigned-long)
   (:variant 
      (
      (defProc :pointer)
      )
      )
   )

; 		
; 	   Menu Manager Initialization                                                       	
; 		
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  InitProcMenu()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_InitProcMenu" 
      ((resID :signed-integer))
   nil
   (:stack-trap #xA808))

; 
;  *  InitMenus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InitMenus" 
      ()
   nil
   (:stack-trap #xA930))

; 
;    Menu Manipulation                                                                 
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewMenu" 
      ((MenuID :signed-integer) (menuTitle (:string 255)))
   (:stack (:handle :menuinfo))
   (:stack-trap #xA931))

; 
;  *  [Mac]GetMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenu" 
      ((resourceID :signed-integer))
   (:stack (:handle :menuinfo))
   (:stack-trap #xA9BF))

; 
;  *  DisposeMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMenu" 
      ((theMenu (:handle :menuinfo)))
   nil
   (:stack-trap #xA932))

; 
;  *  CalcMenuSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CalcMenuSize" 
      ((theMenu (:handle :menuinfo)))
   nil
   (:stack-trap #xA948))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CountMItems()
;  *  
;  *  Summary:
;  *    Renamed to CountMenuItems in Carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CountMItems" 
      ((theMenu (:handle :menuinfo)))
   (:stack :unsigned-integer)
   (:stack-trap #xA950))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CountMenuItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.3 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountMenuItems" 
      ((theMenu (:handle :menuinfo)))
   (:stack :unsigned-integer)
   (:stack-trap #xA950))

;   Routines available in Mac OS 8.5 and later, and on Mac OS 8.1 and later using CarbonLib 1.1 and later 

; 
;  *  GetMenuFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  SetMenuFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuFont" 
      ((menu (:handle :menuinfo)) (outFontID (:pointer :signed-integer)) (outFontSize (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuExcludesMarkColumn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuFont" 
      ((menu (:handle :menuinfo)) (inFontID :signed-integer) (inFontSize :unsigned-integer)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuExcludesMarkColumn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuExcludesMarkColumn" 
      ((menu (:handle :menuinfo))) 
  :boolean
   () )                                         ; 
;  *  RegisterMenuDefinition()
;  *  
;  *  Summary:
;  *    Registers or unregisters a binding between a resource ID and a
;  *    menu definition function.
;  *  
;  *  Discussion:
;  *    In the Mac OS 8.x Menu Manager, a 'MENU' resource can contain an
;  *    embedded MDEF procID that is used by the Menu Manager as the
;  *    resource ID of an 'MDEF' resource to measure and draw the menu.
;  *    The 'MDEF' resource is loaded by the Menu Manager when you load
;  *    the menu with GetMenu. Since MDEFs can no longer be packaged as
;  *    code resources on Carbon, the procID can no longer refer directly
;  *    to an MDEF resource. However, using RegisterMenuDefinition you
;  *    can instead specify a UniversalProcPtr pointing to code in your
;  *    application code fragment.
;  *  
;  *  Parameters:
;  *    
;  *    inResID:
;  *      An MDEF proc ID, as used in a 'MENU' resource.
;  *    
;  *    inDefSpec:
;  *      Specifies the MenuDefUPP that should be used for menus with the
;  *      given MDEF proc ID. Passing NULL allows you to unregister the
;  *      menu definition that had been associated with the given MDEF
;  *      proc ID.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuExcludesMarkColumn" 
      ((menu (:handle :menuinfo)) (excludesMark :boolean)) 
  :osstatus
   () )                                         ; 
;  *  CreateNewMenu()
;  *  
;  *  Summary:
;  *    Creates a new, untitled, empty menu.
;  *  
;  *  Discussion:
;  *    CreateNewMenu is preferred over NewMenu because it allows you to
;  *    specify the menu's attributes and it does not require you to
;  *    specify a Str255-based menu title. To set the menu title, you can
;  *    use either SetMenuTitle or SetMenuTitleWithCFString.
;  *  
;  *  Parameters:
;  *    
;  *    inMenuID:
;  *      The menu ID to use for the new menu.
;  *    
;  *    inMenuAttributes:
;  *      The menu attributes to use for the new menu.
;  *    
;  *    outMenuRef:
;  *      On exit, contains the new menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RegisterMenuDefinition" 
      ((inResID :signed-integer) (inDefSpec (:pointer :menudefspec))) 
  :osstatus
   () )                                         ; 
;  *  CreateCustomMenu()
;  *  
;  *  Summary:
;  *    Creates a new, untitled, empty menu using a custom menu
;  *    definition function.
;  *  
;  *  Discussion:
;  *    Similar to CreateNewMenu, but also allows you to specify a custom
;  *    menu definition function.
;  *  
;  *  Parameters:
;  *    
;  *    inDefSpec:
;  *      Specifies a custom menu definition function. defSpec->defType
;  *      must be kMenuDefProcPtr.
;  *    
;  *    inMenuID:
;  *      The menu ID to use for the new menu.
;  *    
;  *    inMenuAttributes:
;  *      The menu attributes to use for the new menu.
;  *    
;  *    outMenuRef:
;  *      On exit, contains the new menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateNewMenu" 
      ((inMenuID :signed-integer) (inMenuAttributes :unsigned-long) (outMenuRef (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )                                         ; CONST; 
;  *  IsValidMenu()
;  *  
;  *  Summary:
;  *    Determines if a menu is valid.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu to check for validity.
;  *  
;  *  Result:
;  *    Indicates whether the menu is valid.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateCustomMenu" 
      ((inDefSpec (:pointer :menudefspec)) (inMenuID :signed-integer) (inMenuAttributes :unsigned-long) (outMenuRef (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuRetainCount()
;  *  
;  *  Summary:
;  *    Returns the retain count of this menu.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose retain count to increment.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsValidMenu" 
      ((inMenu (:handle :menuinfo))) 
  :boolean
   () )                                         ; 
;  *  RetainMenu()
;  *  
;  *  Summary:
;  *    Increments the retain count of a menu.
;  *  
;  *  Discussion:
;  *    RetainMenu does not create a new menu. It simply adds one to the
;  *    retain count. If called on a menu that was not created by
;  *    CarbonLib, it will not affect the menu's retain count.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose retain count to increment.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuRetainCount" 
      ((inMenu (:handle :menuinfo))) 
  :unsigned-long
   () )                                         ; 
;  *  ReleaseMenu()
;  *  
;  *  Summary:
;  *    Decrements the retain count of a menu.
;  *  
;  *  Discussion:
;  *    If called on a menu that was not created by CarbonLib, it will
;  *    not affect the menu's retain count.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose retain count to decrement. If the retain count
;  *      falls to zero, the menu is destroyed.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RetainMenu" 
      ((inMenu (:handle :menuinfo))) 
  :osstatus
   () )                                         ; 
;  *  DuplicateMenu()
;  *  
;  *  Summary:
;  *    Creates a new menu that is a copy of another menu.
;  *  
;  *  Discussion:
;  *    Unlike CloneMenu, DuplicateMenu creates an entirely new menu that
;  *    is an exact copy of the original menu. The MDEF for the new menu
;  *    will receive an init message after the menu has been fully
;  *    created.
;  *  
;  *  Parameters:
;  *    
;  *    inSourceMenu:
;  *      The menu to duplicate.
;  *    
;  *    outMenu:
;  *      On exit, a copy of the source menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ReleaseMenu" 
      ((inMenu (:handle :menuinfo))) 
  :osstatus
   () )                                         ; 
;  *  CopyMenuTitleAsCFString()
;  *  
;  *  Summary:
;  *    Returns a CFString containing the title of a menu.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose title to return.
;  *    
;  *    outString:
;  *      On exit, a CFString containing the menu's title. This string
;  *      must be released by the caller.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DuplicateMenu" 
      ((inSourceMenu (:handle :menuinfo)) (outMenu (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )                                         ; 
;  *  SetMenuTitleWithCFString()
;  *  
;  *  Summary:
;  *    Sets the title of a menu to the text contained in a CFString.
;  *  
;  *  Discussion:
;  *    The Menu Manager will either make its own copy or just increment
;  *    the refcount of the CFString before returning from
;  *    SetMenuTitleWithCFString, depending on whether the string is
;  *    mutable or immutable. If the string is mutable, modifying the
;  *    string after calling SetMenuTitleWithCFString will have no effect
;  *    on the menu's actual title. The caller may release the string
;  *    after calling SetMenuTitleWithCFString.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose title to set.
;  *    
;  *    inString:
;  *      The string containing the new menu title text.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyMenuTitleAsCFString" 
      ((inMenu (:handle :menuinfo)) (outString (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  SetMenuTitleIcon()
;  *  
;  *  Summary:
;  *    Sets the title of a menu to be an icon.
;  *  
;  *  Discussion:
;  *    The Menu Manager takes ownership of the supplied icon after this
;  *    call. When a menu with an title icon is disposed, the Menu
;  *    Manager will dispose the icon also; the Menu Manager will also
;  *    dispose of the current title icon when a new text or icon title
;  *    is supplied for a menu. If an IconRef is specified, the Menu
;  *    Manager will increment its refcount, so you may freely release
;  *    your reference to the IconRef without invalidating the Menu
;  *    Manager's copy. The menubar will be invalidated by this call, and
;  *    redrawn at the next opportunity.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose title to set.
;  *    
;  *    inType:
;  *      The type of icon being used to specify the icon title; use
;  *      kMenuNoIcon to remove the icon from the menu title. The
;  *      supported types are kMenuIconSuiteType and kMenuIconRefType.
;  *    
;  *    inIcon:
;  *      The icon; must be NULL if inType is kMenuNoIcon. The supported
;  *      icon formats are IconSuiteRef and IconRef.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuTitleWithCFString" 
      ((inMenu (:handle :menuinfo)) (inString :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetMenuTitleIcon()
;  *  
;  *  Summary:
;  *    Retrieves the icon, if any, being used as the title of a menu.
;  *  
;  *  Discussion:
;  *    This API does not increment a refcount on the returned icon. The
;  *    caller should not release the icon.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose icon title to retrieve.
;  *    
;  *    outType:
;  *      On exit, contains the type of icon being used as the title of
;  *      the menu. Contains kMenuNoIcon if the menu does not have an
;  *      icon title.
;  *    
;  *    outIcon:
;  *      On exit, contains the IconSuiteRef or IconRef being used as the
;  *      title of the menu, or NULL if the menu does not have an icon
;  *      title. May be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuTitleIcon" 
      ((inMenu (:handle :menuinfo)) (inType :unsigned-long) (inIcon :pointer)) 
  :osstatus
   () )                                         ; 
;  *  InvalidateMenuSize()
;  *  
;  *  Summary:
;  *    Invalidates the menu size so that it will be recalculated when
;  *    next displayed.
;  *  
;  *  Discussion:
;  *    The pre-Carbon technique for invalidating the menu size was to
;  *    set the width and height to -1. Although this technique still
;  *    works, for best compatibility it's preferable to use the
;  *    InvalidateMenuSize API so that the Menu Manager has explicit
;  *    notification that the menu is invalid.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose size to invalidate.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuTitleIcon" 
      ((inMenu (:handle :menuinfo)) (outType (:pointer :unsigned-long)) (outIcon :pointer)) 
  :osstatus
   () )                                         ; 
;  *  IsMenuSizeInvalid()
;  *  
;  *  Summary:
;  *    Determines if a menu's size is invalid and should be recalculated.
;  *  
;  *  Discussion:
;  *    The pre-Carbon technique for determining if a menu's size is
;  *    invalid was to check if the width or height was -1. This
;  *    technique is not always reliable on Carbon due to implementation
;  *    changes in the Menu Manager. You should now use IsMenuSizeInvalid
;  *    instead.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose size to examine.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvalidateMenuSize" 
      ((inMenu (:handle :menuinfo))) 
  :osstatus
   () )                                         ; ;   MDEF support                                                                      ; ; 
;  *  EraseMenuBackground()
;  *  
;  *  Summary:
;  *    Erases a portion of a menu background in preparation for further
;  *    drawing.
;  *  
;  *  Discussion:
;  *    It is necessary to erase the menu background before calling
;  *    DrawThemeMenuBackground because some themes (such as Aqua on Mac
;  *    OS X) draw the menu background using the alpha channel, and if
;  *    the area underneath the menu background is not erased, portions
;  *    of the old image will show through the menu background.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose background to erase.
;  *    
;  *    inEraseRect:
;  *      The bounds of the area to erase, in local coordinates to the
;  *      current port.
;  *    
;  *    inContext:
;  *      The CG context to erase. If NULL, EraseMenuBackground will
;  *      create a context based on the current port.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_IsMenuSizeInvalid" 
      ((inMenu (:handle :menuinfo))) 
  :boolean
   () )                                         ; CONST
(deftrap-inline "_EraseMenuBackground" 
      ((inMenu (:handle :menuinfo)) (inEraseRect (:pointer :rect)) (inContext :pointer)) 
  :osstatus
   () )

; 
;  *  ScrollMenuImage()
;  *  
;  *  Summary:
;  *    Scrolls a portion of the menu image.
;  *  
;  *  Discussion:
;  *    Menus on Mac OS X use an alpha channel, and QuickDraw does not
;  *    support alpha channels. Therefore, scrolling a menu image with
;  *    ScrollRect or other QuickDraw APIs does not work correctly; it
;  *    results in the destruction of the alpha channel data. The
;  *    ScrollMenuImage API uses CoreGraphics to move the menu image,
;  *    preserving the alpha channel.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu whose image to scroll.
;  *    
;  *    inScrollRect:
;  *      The bounds of the rect to scroll.
;  *    
;  *    inHScroll:
;  *      The distance to scroll horizontally.
;  *    
;  *    inVScroll:
;  *      The distance to scroll vertically.
;  *    
;  *    inContext:
;  *      The CG context to erase. If NULL, ScrollMenuImage will create a
;  *      context based on the current port.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap-inline "_ScrollMenuImage" 
      ((inMenu (:handle :menuinfo)) (inScrollRect (:pointer :rect)) (inHScroll :signed-long) (inVScroll :signed-long) (inContext :pointer)) 
  :osstatus
   () )

; 
;    Menu Item Insertion                                                               
; 
; 
;  *  [Mac]AppendMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AppendMenu" 
      ((menu (:handle :menuinfo)) (data (:string 255)))
   nil
   (:stack-trap #xA933))

; 
;  *  InsertResMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsertResMenu" 
      ((theMenu (:handle :menuinfo)) (theType :ostype) (afterItem :signed-integer))
   nil
   (:stack-trap #xA951))

; 
;  *  AppendResMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AppendResMenu" 
      ((theMenu (:handle :menuinfo)) (theType :ostype))
   nil
   (:stack-trap #xA94D))

; 
;  *  [Mac]InsertMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsertMenuItem" 
      ((theMenu (:handle :menuinfo)) (itemString (:string 255)) (afterItem :signed-integer))
   nil
   (:stack-trap #xA826))

; 
;  *  DeleteMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeleteMenuItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer))
   nil
   (:stack-trap #xA952))

; 
;  *  InsertFontResMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsertFontResMenu" 
      ((theMenu (:handle :menuinfo)) (afterItem :signed-integer) (scriptFilter :signed-integer))
   nil
   (:stack-trap #xA825 :d0 1024 theMenu afterItem scriptFilter))

; 
;  *  InsertIntlResMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsertIntlResMenu" 
      ((theMenu (:handle :menuinfo)) (theType :ostype) (afterItem :signed-integer) (scriptFilter :signed-integer))
   nil
   (:stack-trap #xA825 :d0 1537 theMenu theType afterItem scriptFilter))

; 
;  *  AppendMenuItemText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  InsertMenuItemText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AppendMenuItemText" 
      ((menu (:handle :menuinfo)) (inString (:string 255))) 
  :osstatus
   () )                                         ; 
;  *  CopyMenuItems()
;  *  
;  *  Summary:
;  *    Copies menu items from one menu to another.
;  *  
;  *  Parameters:
;  *    
;  *    inSourceMenu:
;  *      The menu from which to copy items.
;  *    
;  *    inFirstItem:
;  *      The first item to copy.
;  *    
;  *    inNumItems:
;  *      The number of items to copy.
;  *    
;  *    inDestMenu:
;  *      The menu to which to copy items.
;  *    
;  *    inInsertAfter:
;  *      The menu item in the destination menu after which to insert the
;  *      copied items.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InsertMenuItemText" 
      ((menu (:handle :menuinfo)) (inString (:string 255)) (afterItem :unsigned-integer)) 
  :osstatus
   () )                                         ; 
;  *  DeleteMenuItems()
;  *  
;  *  Summary:
;  *    Deletes multiple menu items.
;  *  
;  *  Discussion:
;  *    This API is more efficient than calling DeleteMenuItem multiple
;  *    times.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu from which to delete items.
;  *    
;  *    inFirstItem:
;  *      The first item to delete.
;  *    
;  *    inNumItems:
;  *      The number of items to delete.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyMenuItems" 
      ((inSourceMenu (:handle :menuinfo)) (inFirstItem :unsigned-integer) (inNumItems :unsigned-long) (inDestMenu (:handle :menuinfo)) (inInsertAfter :unsigned-integer)) 
  :osstatus
   () )                                         ; 
;  *  AppendMenuItemTextWithCFString()
;  *  
;  *  Summary:
;  *    Appends a new menu item with text from a CFString.
;  *  
;  *  Discussion:
;  *    The Menu Manager will either make its own copy or just increment
;  *    the refcount of the CFString before returning from
;  *    AppendMenuItemWithTextCFString, depending on whether the string
;  *    is mutable or immutable. If the string is mutable, modifying the
;  *    string after calling AppendMenuItemTextWithCFString will have no
;  *    effect on the menu item's actual text. The caller may release the
;  *    string after calling AppendMenuItemTextWithCFString.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu to which to append the new item.
;  *    
;  *    inString:
;  *      The text of the new item.
;  *    
;  *    inAttributes:
;  *      The attributes of the new item.
;  *    
;  *    inCommandID:
;  *      The command ID of the new item.
;  *    
;  *    outNewItem:
;  *      On exit, the index of the new item. May be NULL if the caller
;  *      does not need this information.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DeleteMenuItems" 
      ((inMenu (:handle :menuinfo)) (inFirstItem :unsigned-integer) (inNumItems :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  InsertMenuItemTextWithCFString()
;  *  
;  *  Summary:
;  *    Inserts a new menu item with text from a CFString.
;  *  
;  *  Discussion:
;  *    The Menu Manager will either make its own copy or just increment
;  *    the refcount of the CFString before returning from
;  *    InsertMenuItemWithCFString, depending on whether the string is
;  *    mutable or immutable. If the string is mutable, modifying the
;  *    string after calling InsertMenuItemWithCFString will have no
;  *    effect on the menu item's actual text. The caller may release the
;  *    string after calling InsertMenuItemWithCFString.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to insert the new item.
;  *    
;  *    inString:
;  *      The text of the new item.
;  *    
;  *    inAfterItem:
;  *      The item after which to insert the new item.
;  *    
;  *    inAttributes:
;  *      The attributes of the new item.
;  *    
;  *    inCommandID:
;  *      The command ID of the new item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AppendMenuItemTextWithCFString" 
      ((inMenu (:handle :menuinfo)) (inString :pointer) (inAttributes :unsigned-long) (inCommandID :unsigned-long) (outNewItem (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; ;    Menu Events                                                                       ; ; 
;  *  MenuKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InsertMenuItemTextWithCFString" 
      ((inMenu (:handle :menuinfo)) (inString :pointer) (inAfterItem :unsigned-integer) (inAttributes :unsigned-long) (inCommandID :unsigned-long)) 
  :osstatus
   () )
(deftrap "_MenuKey" 
      ((ch :character))
   (:stack :signed-long)
   (:stack-trap #xA93E))

; 
;  *  MenuSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MenuSelect" 
      ((startPt :point))
   (:stack :signed-long)
   (:stack-trap #xA93D))

; 
;  *  PopUpMenuSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PopUpMenuSelect" 
      ((menu (:handle :menuinfo)) (top :signed-integer) (left :signed-integer) (popUpItem :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA80B))

; 
;  *  MenuChoice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MenuChoice" 
      ()
   (:stack :signed-long)
   (:stack-trap #xAA66))

; 
;  *  MenuEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_MenuEvent" 
      ((inEvent (:pointer :eventrecord)))
   (:stack :unsigned-long)
   (:stack-trap #xA825 :d0 524 inEvent))

; 
;  *  IsMenuKeyEvent()
;  *  
;  *  Summary:
;  *    Determines if an event corresponds to a menu command key.
;  *  
;  *  Discussion:
;  *    By default, IsMenuKeyEvent searches the menus in the current menu
;  *    bar and hilites the menu title of the menu containing the
;  *    selected item.
;  *  
;  *  Parameters:
;  *    
;  *    inStartMenu:
;  *      IsMenuKeyEvent searches for matching menu items in this menu
;  *      and all of its submenus. May be NULL to search the current menu
;  *      bar contents.
;  *    
;  *    inEvent:
;  *      The event to match against. Non-keyboard events are ignored.
;  *    
;  *    inOptions:
;  *      Options controlling how to search. Pass kNilOptions for the
;  *      default behavior.
;  *    
;  *    outMenu:
;  *      On exit, the menu containing the matching item. May be NULL.
;  *    
;  *    outMenuItem:
;  *      On exit, the menu item that matched. May be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  InvalidateMenuEnabling()
;  *  
;  *  Summary:
;  *    Causes the menu enable state to be recalculated at the next
;  *    convenient opportunity.
;  *  
;  *  Discussion:
;  *    It is common for state changes in an application (for example,
;  *    selection of text) to cause a change in the enabling of items in
;  *    the application's menu (for example, the Copy menu item might
;  *    become enabled). In a Carbon-event-savvy application, menu items
;  *    are enabled or disabled in response to an
;  *    kEventCommandUpdateStatus event; however, this event is normally
;  *    only sent before a command key press or a click in the menubar.
;  *    You can request an explicit recalculation of a menu's enable
;  *    state with the InvalidateMenuEnabling API. The Carbon Event
;  *    Manager will automatically invalidate the enable state of all
;  *    top-level menus when a user event is dispatched, the user focus
;  *    changes, or the active window changes, so in many cases you will
;  *    not need to explicitly invalidate the menu enabling state.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      A menu to re-enable, or NULL if all menus in the root menu
;  *      should be re-enabled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuKeyEvent" 
      ((inStartMenu (:handle :menuinfo)) (inEvent :pointer) (inOptions :unsigned-long) (outMenu (:pointer (:handle :menuinfo))) (outMenuItem (:pointer :unsigned-integer))) 
  :boolean
   () )                                         ; ;    Menu Bar                                                                          ; ; 
;  *  GetMBarHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvalidateMenuEnabling" 
      ((inMenu (:handle :menuinfo))) 
  :osstatus
   () )
(deftrap "_GetMBarHeight" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2986))))

; 
;  *  [Mac]DrawMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawMenuBar" 
      ()
   nil
   (:stack-trap #xA937))

; 
;  *  InvalMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InvalMenuBar" 
      ()
   nil
   (:stack-trap #xA81D))

; 
;  *  IsMenuBarInvalid()
;  *  
;  *  Summary:
;  *    Determines if the menubar is invalid and should be redrawn.
;  *  
;  *  Parameters:
;  *    
;  *    rootMenu:
;  *      The root menu for the menubar to be examined. Pass NULL to
;  *      check the state of the current menubar.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  HiliteMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuBarInvalid" 
      ((rootMenu (:handle :menuinfo))) 
  :boolean
   () )
(deftrap "_HiliteMenu" 
      ((MenuID :signed-integer))
   nil
   (:stack-trap #xA938))

; 
;  *  GetNewMBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNewMBar" 
      ((menuBarID :signed-integer))
   (:stack :handle)
   (:stack-trap #xA9C0))

; 
;  *  GetMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuBar" 
      ()
   (:stack :handle)
   (:stack-trap #xA93B))

; 
;  *  SetMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuBar" 
      ((mbar :handle))
   nil
   (:stack-trap #xA93C))

; 
;  *  DuplicateMenuBar()
;  *  
;  *  Summary:
;  *    Duplicates a menubar handle.
;  *  
;  *  Discussion:
;  *    This API should be used in Carbon applications when duplicating a
;  *    handle returned from GetMenuBar or GetNewMBar. You should not use
;  *    Memory Manager APIs (HandToHand, NewHandle, etc) to duplicate
;  *    such a handle. This is necessary in Carbon so that the refcounts
;  *    of the menus in the menubar handle can be incremented when the
;  *    handle is duplicated.
;  *  
;  *  Parameters:
;  *    
;  *    inMbar:
;  *      The menubar handle to duplicate.
;  *    
;  *    outMbar:
;  *      On exit, contains the new menubar handle.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  DisposeMenuBar()
;  *  
;  *  Summary:
;  *    Releases a menubar handle.
;  *  
;  *  Discussion:
;  *    This API should be used in Carbon applications when releasing a
;  *    handle returned from GetMenuBar or GetNewMBar. You should not use
;  *    DisposeHandle to release such a handle. This is necessary in
;  *    Carbon so that the refcounts of the menus in the menubar handle
;  *    can be decremented when the handle is released.
;  *  
;  *  Parameters:
;  *    
;  *    inMbar:
;  *      The menubar handle to release.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DuplicateMenuBar" 
      ((inMbar :handle) (outMbar (:pointer :handle))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeMenuBar" 
      ((inMbar :handle)) 
  :osstatus
   () )
(deftrap "_GetMenuHandle" 
      ((MenuID :signed-integer))
   (:stack (:handle :menuinfo))
   (:stack-trap #xA949))

; 
;  *  [Mac]InsertMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsertMenu" 
      ((theMenu (:handle :menuinfo)) (beforeID :signed-integer))
   nil
   (:stack-trap #xA935))

; 
;  *  [Mac]DeleteMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeleteMenu" 
      ((MenuID :signed-integer))
   nil
   (:stack-trap #xA936))

; 
;  *  ClearMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ClearMenuBar" 
      ()
   nil
   (:stack-trap #xA934))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetMenuFlash()
;  *  
;  *  Summary:
;  *    Renamed to SetMenuFlashCount in Carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetMenuFlash" 
      ((count :signed-integer))
   nil
   (:stack-trap #xA94A))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetMenuFlashCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.3 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuFlashCount" 
      ((count :signed-integer))
   nil
   (:stack-trap #xA94A))

; 
;  *  FlashMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FlashMenuBar" 
      ((MenuID :signed-integer))
   nil
   (:stack-trap #xA94C))

;   These are obsolete because Carbon does not support desk accessories. 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SystemEdit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SystemEdit" 
      ((editCmd :signed-integer))
   (:stack :boolean)
   (:stack-trap #xA9C2))

; 
;  *  SystemMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SystemMenu" 
      ((menuResult :signed-long))
   nil
   (:stack-trap #xA9B5))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  IsMenuBarVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  ShowMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuBarVisible" 
      () 
  :boolean
   () )                                         ; 
;  *  HideMenuBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ShowMenuBar" 
      () 
  nil
   () )                                         ; 
;  *  AcquireRootMenu()
;  *  
;  *  Summary:
;  *    Get the menu whose contents are displayed in the menubar.
;  *  
;  *  Discussion:
;  *    The refcount of the root menu is incremented by this API. The
;  *    caller should release a refcount with ReleaseMenu when its done
;  *    with the menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HideMenuBar" 
      () 
  nil
   () )                                         ; 
;  *  SetRootMenu()
;  *  
;  *  Summary:
;  *    Sets the menu whose contents are displayed in the menubar.
;  *  
;  *  Discussion:
;  *    The refcount of the root menu is incremented by this API. The
;  *    caller may release the menu after calling SetRootMenu.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The new root menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AcquireRootMenu" 
      () 
  (:handle :menuinfo)
   () )                                         ; ;    Menu Item Accessors                                                               ; ; $IFC CALL_NOT_IN_CARBON ; 
;  *  CheckItem()
;  *  
;  *  Summary:
;  *    Renamed to CheckMenuItem in Carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetRootMenu" 
      ((inMenu (:handle :menuinfo))) 
  :osstatus
   () )
(deftrap "_CheckItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (checked :boolean))
   nil
   (:stack-trap #xA945))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  [Mac]CheckMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.3 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CheckMenuItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (checked :boolean))
   nil
   (:stack-trap #xA945))

; 
;  *  SetMenuItemText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemText" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (itemString (:string 255)))
   nil
   (:stack-trap #xA947))

; 
;  *  GetMenuItemText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemText" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (itemString (:pointer (:string 255))))
   nil
   (:stack-trap #xA946))

; 
;  *  SetItemMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetItemMark" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (markChar :character))
   nil
   (:stack-trap #xA944))

; 
;  *  GetItemMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetItemMark" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (markChar (:pointer :character)))
   nil
   (:stack-trap #xA943))

; 
;  *  SetItemCmd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetItemCmd" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (cmdChar :character))
   nil
   (:stack-trap #xA84F))

; 
;  *  GetItemCmd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetItemCmd" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (cmdChar (:pointer :character)))
   nil
   (:stack-trap #xA84E))

; 
;  *  SetItemIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetItemIcon" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (iconIndex :signed-integer))
   nil
   (:stack-trap #xA940))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetItemIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetItemIcon" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (iconIndex (:pointer :unsigned-byte)))
   nil
   (:stack-trap #xA93F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetItemStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetItemStyle" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (chStyle (:unsigned-byte :set (#:bold #:italic #:underline #:outline shadow #:condense #:extend))))
   nil
   (:stack-trap #xA942))

; 
;  *  GetItemStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  These APIs are not supported in Carbon. Please use EnableMenuItem and ;  DisableMenuItem (available back through Mac OS 8.5) instead.          ; $IFC CALL_NOT_IN_CARBON ; 
;  *  DisableItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetItemStyle" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (chStyle (:pointer (:unsigned-byte :set (#:bold #:italic #:underline #:outline shadow #:condense #:extend))))) 
  nil
   () )
(deftrap "_DisableItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer))
   nil
   (:stack-trap #xA93A))

; 
;  *  EnableItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_EnableItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer))
   nil
   (:stack-trap #xA939))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetMenuItemCommandID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemCommandID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inCommandID :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1282 inMenu inItem inCommandID))

; 
;  *  GetMenuItemCommandID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemCommandID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outCommandID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1283 inMenu inItem outCommandID))

; 
;  *  SetMenuItemModifiers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemModifiers" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inModifiers :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1028 inMenu inItem inModifiers))

; 
;  *  GetMenuItemModifiers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemModifiers" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outModifiers (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1285 inMenu inItem outModifiers))

; 
;  *  SetMenuItemIconHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemIconHandle" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inIconType :signed-byte) (inIconHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1542 inMenu inItem inIconType inIconHandle))

; 
;  *  GetMenuItemIconHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemIconHandle" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outIconType (:pointer :unsigned-byte)) (outIconHandle (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1799 inMenu inItem outIconType outIconHandle))

; 
;  *  SetMenuItemTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemTextEncoding" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inScriptID :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1032 inMenu inItem inScriptID))

; 
;  *  GetMenuItemTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemTextEncoding" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outScriptID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1289 inMenu inItem outScriptID))

; 
;  *  SetMenuItemHierarchicalID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemHierarchicalID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inHierID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1037 inMenu inItem inHierID))

; 
;  *  GetMenuItemHierarchicalID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemHierarchicalID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outHierID (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1294 inMenu inItem outHierID))

; 
;  *  SetMenuItemFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemFontID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inFontID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1039 inMenu inItem inFontID))

; 
;  *  GetMenuItemFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemFontID" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outFontID (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1296 inMenu inItem outFontID))

; 
;  *  SetMenuItemRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemRefCon" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inRefCon :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1290 inMenu inItem inRefCon))

; 
;  *  GetMenuItemRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemRefCon" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outRefCon (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1291 inMenu inItem outRefCon))

;   Please use the menu item property APIs in Carbon. 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetMenuItemRefCon2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetMenuItemRefCon2" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inRefCon2 :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1297 inMenu inItem inRefCon2))

; 
;  *  GetMenuItemRefCon2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetMenuItemRefCon2" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outRefCon2 (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1298 inMenu inItem outRefCon2))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetMenuItemKeyGlyph()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMenuItemKeyGlyph" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (inGlyph :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1299 inMenu inItem inGlyph))

; 
;  *  GetMenuItemKeyGlyph()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMenuItemKeyGlyph" 
      ((inMenu (:handle :menuinfo)) (inItem :signed-integer) (outGlyph (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA825 :d0 1300 inMenu inItem outGlyph))

;   Routines available in Mac OS 8.5 and later (supporting enabling/disabling of > 31 items) 

; 
;  *  [Mac]EnableMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  DisableMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EnableMenuItem" 
      ((theMenu (:handle :menuinfo)) (item :unsigned-integer)) 
  nil
   () )                                         ; 
;  *  IsMenuItemEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableMenuItem" 
      ((theMenu (:handle :menuinfo)) (item :unsigned-integer)) 
  nil
   () )                                         ; 
;  *  EnableMenuItemIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuItemEnabled" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer)) 
  :boolean
   () )
(deftrap "_EnableMenuItemIcon" 
      ((theMenu (:handle :menuinfo)) (item :unsigned-integer))
   nil
   (:stack-trap #xA825 :d0 25 theMenu item))

; 
;  *  DisableMenuItemIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisableMenuItemIcon" 
      ((theMenu (:handle :menuinfo)) (item :unsigned-integer))
   nil
   (:stack-trap #xA825 :d0 32 theMenu item))

; 
;  *  IsMenuItemIconEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsMenuItemIconEnabled" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer))
   (:stack :boolean)
   (:stack-trap #xA825 :d0 24 menu item))

; 
;  *  SetMenuItemHierarchicalMenu()
;  *  
;  *  Summary:
;  *    Attaches a submenu to a menu item.
;  *  
;  *  Discussion:
;  *    Using SetMenuItemHierarchicalMenu, it is possible to directly
;  *    specify the submenu for a menu item without specifying its menu
;  *    ID. It is not necessary to insert the submenu into the
;  *    hierarchical portion of the menubar, and it is not necessary for
;  *    the submenu to have a unique menu ID; it is recommended that you
;  *    use 0 as the menu ID for the submenu, and identify selections
;  *    from the menu by command ID. The Menu Manager will increment the
;  *    refcount of the submenu that you specify, and the submenu's
;  *    refcount will be decremented automatically when the parent menu
;  *    item is deleted or the parent menu is disposed.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The parent menu.
;  *    
;  *    inItem:
;  *      The parent item.
;  *    
;  *    inHierMenu:
;  *      The submenu. You may pass NULL to remove any existing submenu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetMenuItemHierarchicalMenu()
;  *  
;  *  Summary:
;  *    Returns the submenu attached to a menu item.
;  *  
;  *  Discussion:
;  *    GetMenuItemHierarchicalMenu will return the submenu attached to a
;  *    menu item regardless of how the submenu was specified. If the
;  *    submenu was specified by menu ID (using SetItemCmd or
;  *    SetMenuItemHierarchicalID), GetMenuItemHierarchicalMenu will
;  *    return the currently installed menu with that ID, if any. The
;  *    only case where GetMenuItemHierarchicalMenu will fail to return
;  *    the item's submenu is when the submenu is specified by menu ID,
;  *    but the submenu is not currently inserted in the menu bar.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The parent menu.
;  *    
;  *    inItem:
;  *      The parent item.
;  *    
;  *    outHierMenu:
;  *      On exit, the item's submenu, or NULL if it does not have one.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemHierarchicalMenu" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inHierMenu (:handle :menuinfo))) 
  :osstatus
   () )                                         ; 
;  *  CopyMenuItemTextAsCFString()
;  *  
;  *  Summary:
;  *    Returns a CFString containing the text of a menu item.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose text to return.
;  *    
;  *    outString:
;  *      On exit, a CFString containing the item's text. This string
;  *      must be released by the caller.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemHierarchicalMenu" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (outHierMenu (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )                                         ; 
;  *  SetMenuItemTextWithCFString()
;  *  
;  *  Summary:
;  *    Sets the text of a menu item to the text contained in a CFString.
;  *  
;  *  Discussion:
;  *    The Menu Manager will either make its own copy or just increment
;  *    the refcount of the CFString before returning from
;  *    SetMenuItemTextWithCFString, depending on whether the string is
;  *    mutable or immutable. If the string is mutable, modifying the
;  *    string after calling SetMenuItemTextWithCFString will have no
;  *    effect on the menu item's actual text. The caller may release the
;  *    string after calling SetMenuItemTextWithCFString.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose text to return.
;  *    
;  *    inString:
;  *      The string containing the new menu item text.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyMenuItemTextAsCFString" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (outString (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuItemIndent()
;  *  
;  *  Summary:
;  *    Gets the indent level of a menu item.
;  *  
;  *  Discussion:
;  *    The indent level of an item is an amount of extra space added to
;  *    the left of the item's icon or checkmark. The level is simply a
;  *    number, starting at zero, which the Menu Manager multiplies by a
;  *    constant to get the indent in pixels. The default indent level is
;  *    zero.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose indent to retrieve.
;  *    
;  *    outIndent:
;  *      On exit, the indent level of the item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemTextWithCFString" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inString :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuItemIndent()
;  *  
;  *  Summary:
;  *    Sets the indent level of a menu item.
;  *  
;  *  Discussion:
;  *    The indent level of an item is an amount of extra space added to
;  *    the left of the item's icon or checkmark. The level is simply a
;  *    number, starting at zero, which the Menu Manager multiplies by a
;  *    constant to get the indent in pixels. The default indent level is
;  *    zero.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose indent to set.
;  *    
;  *    inIndent:
;  *      The new indent level of the item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemIndent" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (outIndent (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuItemCommandKey()
;  *  
;  *  Summary:
;  *    Gets the keyboard equivalent of a menu item.
;  *  
;  *  Discussion:
;  *    A menu item's keyboard equivalent may be either a character code
;  *    or a virtual keycode. An item's character code and virtual
;  *    keycode are stored separately and may contain different values,
;  *    but only one is used by the Menu Manager at any given time. When
;  *    requesting a menu item's virtual keycode equivalent, you should
;  *    first check that the item is using a virtual keycode by testing
;  *    the kMenuItemAttrUseVirtualKey attribute for that item. If this
;  *    attribute is not set, the item's virtual keycode is ignored by
;  *    the Menu Manager. Note that zero is a valid virtual keycode, so
;  *    you cannot test the returned keycode against zero to determine if
;  *    the item is using a virtual keycode equivalent. You must test the
;  *    kMenuItemAttrUseVirtualKey attribute.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose keyboard equivalent to retrieve.
;  *    
;  *    inGetVirtualKey:
;  *      Indicates whether to retrieve the item's character code or
;  *      virtual keycode equivalent.
;  *    
;  *    outKey:
;  *      On exit, the keyboard equivalent of the item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemIndent" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inIndent :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuItemCommandKey()
;  *  
;  *  Summary:
;  *    Sets the keyboard equivalent of a menu item.
;  *  
;  *  Discussion:
;  *    A menu item's keyboard equivalent may be either a character code
;  *    or a virtual keycode. The character code is always used to draw
;  *    the item's keyboard equivalent in the menu, but either may be
;  *    used for keyboard equivalent matching by MenuEvent and
;  *    IsMenuKeyEvent, depending on whether the
;  *    kMenuItemAttrUseVirtualKey item attribute is set. If
;  *    SetMenuItemCommandKey is used to set the virtual keycode
;  *    equivalent for a menu item, it also automatically sets the
;  *    kMenuItemAttrUseVirtualKey item attribute. To make the menu item
;  *    stop using the virtual keycode equivalent and use the character
;  *    code equivalent instead, use ChangeMenuItemAttributes to clear
;  *    the kMenuItemAttrUseVirtualKey item attribute.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu containing the item.
;  *    
;  *    inItem:
;  *      The item whose keyboard equivalent to set.
;  *    
;  *    inSetVirtualKey:
;  *      Indicates whether to set the item's character code or virtual
;  *      keycode equivalent.
;  *    
;  *    inKey:
;  *      The item's new character code or virtual keycode equivalent.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemCommandKey" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inGetVirtualKey :boolean) (outKey (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; ;    Menu Item Color Tables                                                            ;                                                                                       ;   Menu color manipulation is considered deprecated with the advent of the Appearance  ;   Manager.  Avoid using these routines if possible                                    ; ; 
;  *  DeleteMCEntries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemCommandKey" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inSetVirtualKey :boolean) (inKey :unsigned-integer)) 
  :osstatus
   () )
(deftrap "_DeleteMCEntries" 
      ((MenuID :signed-integer) (menuItem :signed-integer))
   nil
   (:stack-trap #xAA60))

; 
;  *  GetMCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMCInfo" 
      ()
   (:stack (:handle :mctable))
   (:stack-trap #xAA61))

; 
;  *  SetMCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMCInfo" 
      ((menuCTbl (:handle :mctable)))
   nil
   (:stack-trap #xAA62))

; 
;  *  DisposeMCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMCInfo" 
      ((menuCTbl (:handle :mctable)))
   nil
   (:stack-trap #xAA63))

; 
;  *  GetMCEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMCEntry" 
      ((MenuID :signed-integer) (menuItem :signed-integer))
   (:stack (:pointer :mcentry))
   (:stack-trap #xAA64))

; 
;  *  SetMCEntries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetMCEntries" 
      ((numEntries :signed-integer) (menuCEntries (:pointer :mctable)))
   nil
   (:stack-trap #xAA65))

; 
;   Properties  (Mac OS 8.5 and later)                                                 
;                                                                                       
;  With the following property APIs, you can attach any piece of data you'd like to a   
;  menu or menu item. Passing zero for the item number parameter indicates you'd like   
;  to attach the data to the menu itself, and not to any specific menu item.            
; 

(defconstant $kMenuPropertyPersistent #x1)      ;   whether this property gets saved when flattening the menu 

; 
; 	 *  GetMenuItemProperty()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MenusLib 8.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetMenuItemPropertySize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemProperty" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype) (bufferSize :unsigned-long) (actualSize (:pointer :unsigned-long)) (propertyBuffer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuItemProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemPropertySize" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype) (size (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  RemoveMenuItemProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MenusLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemProperty" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype) (propertySize :unsigned-long) (propertyData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetMenuItemPropertyAttributes()
;  *  
;  *  Summary:
;  *    Gets the attributes of a menu item property.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    item:
;  *      The menu item.
;  *    
;  *    propertyCreator:
;  *      The creator code of the property.
;  *    
;  *    propertyTag:
;  *      The property tag.
;  *    
;  *    attributes:
;  *      On exit, contains the attributes of the property.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveMenuItemProperty" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype)) 
  :osstatus
   () )                                         ; 
;  *  ChangeMenuItemPropertyAttributes()
;  *  
;  *  Summary:
;  *    Changes the attributes of a menu item property.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    item:
;  *      The menu item.
;  *    
;  *    propertyCreator:
;  *      The creator code of the property.
;  *    
;  *    propertyTag:
;  *      The property tag.
;  *    
;  *    attributesToSet:
;  *      The attributes to add to the menu item property.
;  *    
;  *    attributesToClear:
;  *      The attributes to remove from the menu item property.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemPropertyAttributes" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype) (attributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; ;    Attributes (Carbon and later)                                                     ;                                                                                       ;   Each menu and menu item has attribute flags.                                        ; ; 
;  *  GetMenuAttributes()
;  *  
;  *  Summary:
;  *    Gets the attributes of a menu.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    outAttributes:
;  *      On exit, contains the attributes of the menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeMenuItemPropertyAttributes" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (propertyCreator :ostype) (propertyTag :ostype) (attributesToSet :unsigned-long) (attributesToClear :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  ChangeMenuAttributes()
;  *  
;  *  Summary:
;  *    Changes the attributes of a menu.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    setTheseAttributes:
;  *      The attributes to add to the menu.
;  *    
;  *    clearTheseAttributes:
;  *      The attributes to remove from the menu.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuAttributes" 
      ((menu (:handle :menuinfo)) (outAttributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuItemAttributes()
;  *  
;  *  Summary:
;  *    Gets the attributes of a menu item.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    item:
;  *      The menu item.
;  *    
;  *    outAttributes:
;  *      On exit, contains the attributes of the menu item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeMenuAttributes" 
      ((menu (:handle :menuinfo)) (setTheseAttributes :unsigned-long) (clearTheseAttributes :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  ChangeMenuItemAttributes()
;  *  
;  *  Summary:
;  *    Changes the attributes of a menu item.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu.
;  *    
;  *    item:
;  *      The menu item.
;  *    
;  *    setTheseAttributes:
;  *      The attributes to add to the menu item.
;  *    
;  *    clearTheseAttributes:
;  *      The attributes to remove from the menu item.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuItemAttributes" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (outAttributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; ;    Mass menu item enabling and disabling (Carbon and later)                          ;                                                                                       ;   Useful when rewriting code that modifies the enableFlags field directly.            ; ; 
;  *  DisableAllMenuItems()
;  *  
;  *  Summary:
;  *    Disables all items in a menu.
;  *  
;  *  Discussion:
;  *    This API is equivalent to pre-Carbon code that masked the
;  *    enableFlags field of the MenuInfo with 0x01. It disables all
;  *    items (including items past item 31) but does not affect the
;  *    state of the menu title.
;  *  
;  *  Parameters:
;  *    
;  *    theMenu:
;  *      The menu whose items to disable.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeMenuItemAttributes" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (setTheseAttributes :unsigned-long) (clearTheseAttributes :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  EnableAllMenuItems()
;  *  
;  *  Summary:
;  *    Enables all items in a menu.
;  *  
;  *  Discussion:
;  *    This API is equivalent to pre-Carbon code that or'd the
;  *    enableFlags field of the MenuInfo with 0xFFFFFFFE. It enables all
;  *    items (including items past item 31) but does not affect the
;  *    state of the menu title.
;  *  
;  *  Parameters:
;  *    
;  *    theMenu:
;  *      The menu whose items to enable.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableAllMenuItems" 
      ((theMenu (:handle :menuinfo))) 
  nil
   () )                                         ; 
;  *  MenuHasEnabledItems()
;  *  
;  *  Summary:
;  *    Determines if any items in a menu are enabled.
;  *  
;  *  Discussion:
;  *    This API is equivalent to pre-Carbon code that compared the
;  *    enableFlags field of the MenuInfo with 0. It checks the enable
;  *    state of all items to see if any are enabled, but ignores the
;  *    state of the menu title. It will return true even if the menu
;  *    title is disabled.
;  *  
;  *  Parameters:
;  *    
;  *    theMenu:
;  *      The menu whose items to examine.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EnableAllMenuItems" 
      ((theMenu (:handle :menuinfo))) 
  nil
   () )                                         ; ;    Menu tracking status (Carbon and later)                                           ;                                                                                       ;   Get info about the selected menu item during menu tracking. Replaces direct access  ;   to low-mem globals that previously held this info.                                  ; ; 
;  *  GetMenuTrackingData()
;  *  
;  *  Summary:
;  *    Gets information about the menu currently selected by the user.
;  *  
;  *  Discussion:
;  *    This API replaces direct access to the low-memory globals
;  *    TopMenuItem, AtMenuBottom, MenuDisable, and mbSaveLoc. It is only
;  *    valid to call this API while menu tracking is occurring. This API
;  *    will most commonly be used by custom MDEFs.
;  *  
;  *  Parameters:
;  *    
;  *    theMenu:
;  *      The menu about which to get tracking information. May be NULL
;  *      to get information about the menu that the user is currently
;  *      selecting. If the menu is not currently open, menuNotFoundErr
;  *      is returned.
;  *    
;  *    outData:
;  *      On exit, contains tracking data about the menu. On CarbonLib,
;  *      the itemRect field is not supported and is always set to an
;  *      empty rect.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_MenuHasEnabledItems" 
      ((theMenu (:handle :menuinfo))) 
  :boolean
   () )                                         ; 
;  *  GetMenuType()
;  *  
;  *  Summary:
;  *    Gets the display type (pulldown, hierarchical, or popup) of a
;  *    menu.
;  *  
;  *  Discussion:
;  *    This API may only be called when the menu is displayed. If the
;  *    menu is not currently open, an error is returned. The display
;  *    type of a menu may vary from one menu tracking session to
;  *    another; for example, the same menu might be displayed as a
;  *    pulldown menu and as a popup menu.
;  *  
;  *  Parameters:
;  *    
;  *    theMenu:
;  *      The menu whose type to get.
;  *    
;  *    outType:
;  *      On exit, the type of the menu. The returned value will be one
;  *      of the ThemeMenuType constants: kThemeMenuTypePullDown, PopUp,
;  *      or Hierarchical. The kThemeMenuTypeInactive bit will never be
;  *      set.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuTrackingData" 
      ((theMenu (:handle :menuinfo)) (outData (:pointer :menutrackingdata))) 
  :osstatus
   () )                                         ; ;   Universal command ID access (Carbon and later)                                    ;                                                                                       ;   These APIs allow you to operate on menu items strictly by command ID, with no       ;   knowledge of a menu item's index.                                                   ; ; 
;  *  CountMenuItemsWithCommandID()
;  *  
;  *  Summary:
;  *    Counts the menu items with a specified command ID.
;  *  
;  *  Discussion:
;  *    In CarbonLib 1.0.x and 1.1, this API will always return zero or
;  *    one; it stops after finding the first menu item with the
;  *    specified command ID. In CarbonLib 1.2 and Mac OS X 1.0, it will
;  *    count all menu items with the specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for items with the
;  *      specified command ID. Pass NULL to hegin searching with the
;  *      root menu. The search will descend into all submenus of this
;  *      menu.
;  *    
;  *    inCommandID:
;  *      The command ID for which to search.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuType" 
      ((theMenu (:handle :menuinfo)) (outType (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  GetIndMenuItemWithCommandID()
;  *  
;  *  Summary:
;  *    Finds a menu item with a specified command ID.
;  *  
;  *  Discussion:
;  *    This API searches the specified menu and its submenus for the
;  *    n'th menu item with the specified command ID. In CarbonLib 1.0.x
;  *    and 1.1, only the first menu item will be returned. In CarbonLib
;  *    1.2 and Mac OS X 1.0, this API will iterate over all menu items
;  *    with the specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for items with the
;  *      specified command ID. Pass NULL to hegin searching with the
;  *      root menu. The search will descend into all submenus of this
;  *      menu.
;  *    
;  *    inCommandID:
;  *      The command ID for which to search.
;  *    
;  *    inItemIndex:
;  *      The 1-based index of the menu item to retrieve. In CarbonLib
;  *      1.0.x and 1.1, this parameter must be 1. In CarbonLib 1.2 and
;  *      Mac OS X 1.0, this parameter may vary from 1 to the number of
;  *      menu items with the specified command ID.
;  *    
;  *    outMenu:
;  *      On exit, the menu containing the menu item with the specified
;  *      command ID.
;  *    
;  *    outIndex:
;  *      On exit, the item index of the menu item with the specified
;  *      command ID.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CountMenuItemsWithCommandID" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long)) 
  :unsigned-long
   () )                                         ; 
;  *  EnableMenuCommand()
;  *  
;  *  Summary:
;  *    Enables the menu item with a specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item to be enabled. If more than one
;  *      item has this command ID, only the first will be enabled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetIndMenuItemWithCommandID" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inItemIndex :unsigned-long) (outMenu (:pointer (:handle :menuinfo))) (outIndex (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  DisableMenuCommand()
;  *  
;  *  Summary:
;  *    Disables the menu item with a specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item to be disabled. If more than
;  *      one item has this command ID, only the first will be disabled.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EnableMenuCommand" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long)) 
  nil
   () )                                         ; 
;  *  IsMenuCommandEnabled()
;  *  
;  *  Summary:
;  *    Determines if the menu item with a specified command ID is
;  *    enabled.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item to examine. If more than one
;  *      item has this command ID, only the first will be examined.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableMenuCommand" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long)) 
  nil
   () )                                         ; 
;  *  SetMenuCommandMark()
;  *  
;  *  Summary:
;  *    Locates the menu item with a specified command ID and sets its
;  *    mark character.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item to be modified. If more than
;  *      one item has this command ID, only the first will be modified.
;  *    
;  *    inMark:
;  *      The new mark character. This is a Unicode character. On Mac OS
;  *      8.x, the low byte of this character will be used as the mark
;  *      character. On Mac OS X, the entire UniChar will be used and
;  *      drawn.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuCommandEnabled" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long)) 
  :boolean
   () )                                         ; 
;  *  GetMenuCommandMark()
;  *  
;  *  Summary:
;  *    Locates the menu item with a specified command ID and returns its
;  *    mark character.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item to be examined. If more than
;  *      one item has this command ID, only the first will be examined.
;  *    
;  *    outMark:
;  *      On exit, the menu item's mark character.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuCommandMark" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inMark :unsigned-integer)) 
  :osstatus
   () )                                         ; 
;  *  GetMenuCommandProperty()
;  *  
;  *  Summary:
;  *    Retrives property data for a menu item with a specified command
;  *    ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item containing the property. If
;  *      more than one item has this command ID, only the first will be
;  *      used.
;  *    
;  *    inPropertyCreator:
;  *      The property creator.
;  *    
;  *    inPropertyTag:
;  *      The property tag.
;  *    
;  *    inBufferSize:
;  *      The size of the output buffer, in bytes.
;  *    
;  *    outActualSize:
;  *      On exit, contains the actual size of the property data. May be
;  *      NULL if you do not need this information.
;  *    
;  *    inPropertyBuffer:
;  *      The address of a buffer in which to place the property data.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuCommandMark" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (outMark (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  GetMenuCommandPropertySize()
;  *  
;  *  Summary:
;  *    Retrives the size of property data for a menu item with a
;  *    specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item containing the property. If
;  *      more than one item has this command ID, only the first will be
;  *      used.
;  *    
;  *    inPropertyCreator:
;  *      The property creator.
;  *    
;  *    inPropertyTag:
;  *      The property tag.
;  *    
;  *    outSize:
;  *      On exit, contains the size of the property data.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuCommandProperty" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inPropertyCreator :ostype) (inPropertyTag :ostype) (inBufferSize :unsigned-long) (outActualSize (:pointer :unsigned-long)) (inPropertyBuffer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuCommandProperty()
;  *  
;  *  Summary:
;  *    Sets property data for a menu item with a specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item that will receive the property.
;  *      If more than one item has this command ID, only the first will
;  *      be modified.
;  *    
;  *    inPropertyCreator:
;  *      The property creator.
;  *    
;  *    inPropertyTag:
;  *      The property tag.
;  *    
;  *    inPropertySize:
;  *      The size of the property data, in bytes.
;  *    
;  *    inPropertyData:
;  *      The address of the property data.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuCommandPropertySize" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inPropertyCreator :ostype) (inPropertyTag :ostype) (outSize (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  RemoveMenuCommandProperty()
;  *  
;  *  Summary:
;  *    Removes a property from a menu item with a specified command ID.
;  *  
;  *  Parameters:
;  *    
;  *    inMenu:
;  *      The menu in which to begin searching for the item. Pass NULL to
;  *      begin searching with the root menu. The search will descend
;  *      into all submenus of this menu.
;  *    
;  *    inCommandID:
;  *      The command ID of the menu item from which the property will be
;  *      removed. If more than one item has this command ID, only the
;  *      first will be modified.
;  *    
;  *    inPropertyCreator:
;  *      The property creator.
;  *    
;  *    inPropertyTag:
;  *      The property tag.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuCommandProperty" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inPropertyCreator :ostype) (inPropertyTag :ostype) (inPropertySize :unsigned-long) (inPropertyData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  CopyMenuItemData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveMenuCommandProperty" 
      ((inMenu (:handle :menuinfo)) (inCommandID :unsigned-long) (inPropertyCreator :ostype) (inPropertyTag :ostype)) 
  :osstatus
   () )                                         ; 
;  *  SetMenuItemData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyMenuItemData" 
      ((menu (:handle :menuinfo)) (item :unsigned-long) (isCommandID :boolean) (outData (:pointer :menuitemdatarec))) 
  :osstatus
   () )                                         ; CONST; ;    Dynamic menu item support (CarbonLib 1.1 and Carbon for Mac OS X, and later)      ;                                                                                       ;   Dynamic menu item support allows a menu item to be redrawn while the menu is open   ;   and visible to the user. Carbon contains automatic support for dynamic items based  ;   on keyboard modifier state. If you need to implement your own variable item state   ;   based on other system state, you can use these APIs to implement it.                ;                                                                                       ;   To use the built-in support for dynamic items, you should create a menu containing  ;   several contiguous items with the same command key but different text and modifier  ;   keys. For example, you might have:                                                  ;                                                                                       ;       Close       cmd-W                                                               ;       Close All   cmd-option-W                                                        ;                                                                                       ;   In your MENU resource, you would create the Close and Close All items and give      ;   them each the letter 'W' as the command key; using an associated xmnu resource,     ;   you would specify kMenuOptionModifier as the modifier for the Close All item.       ;                                                                                       ;   After loading your menu from the resource, you must set the kMenuItemAttrDynamic    ;   flag for each dynamic item. In this example, you would use:                         ;                                                                                       ;       ChangeMenuItemAttributes( menu, kCloseItem, kMenuItemAttrDynamic, 0 );          ;       ChangeMenuItemAttributes( menu, kCloseAllItem, kMenuItemAttrDynamic, 0 );       ;                                                                                       ;   The Menu Manager will now automatically display the correct item depending on       ;   whether the Option key is pressed. The result from MenuSelect will be the item      ;   number of the item that was visible when the menu closed.                           ;                                                                                       ;   If the Menu Manager's built-in support is not sufficient, you can also change the   ;   attributes of an item yourself and use the UpdateInvalidMenuItems API to cause      ;   the menu to redraw. Changes to a menu item (changing text, command key, style,      ;   etc.) that occur while the menu is open will cause the menu item to be invalidated, ;   but not redrawn. If you need to invalidate the item explicitly yourself, perhaps    ;   because you have a custom MDEF that depends on state not accessed using Menu        ;   Manager APIs, you can use the InvalidateMenuItems API. UpdateInvalidMenuItems will  ;   scan the menu for invalid items and redraw each, clearing its invalid flag          ;   afterwards.                                                                         ;                                                                                       ;   If you need to change menu contents based on modifier key state without using the   ;   built-in support in the Menu Manager, we recommend that you install a Carbon event  ;   handler on your menu for the [kEventClassKeyboard, kEventRawKeyModifiersChanged]    ;   event. Modifier key events are passed to the currently open menu before being sent  ;   to the user focus target.                                                           ; ; 
;  *  IsMenuItemInvalid()
;  *  
;  *  Summary:
;  *    Determines if a menu item is invalid and should be redrawn.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu whose item to examine.
;  *    
;  *    item:
;  *      The item to examine.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuItemData" 
      ((menu (:handle :menuinfo)) (item :unsigned-long) (isCommandID :boolean) (data (:pointer :menuitemdatarec))) 
  :osstatus
   () )                                         ; 
;  *  InvalidateMenuItems()
;  *  
;  *  Summary:
;  *    Invalidates a group of menu items so that they will be redrawn
;  *    when UpdateInvalidMenuItems is next called.
;  *  
;  *  Discussion:
;  *    Menu items are automatically invalidated when their contents are
;  *    changed using Menu Manager APIs while the menu is open. However,
;  *    you might need to use this API if you have a custom MDEF that
;  *    draws using state not contained in the menu.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu whose items to invalidate.
;  *    
;  *    firstItem:
;  *      The first item to invalidate.
;  *    
;  *    numItems:
;  *      The number of items to invalidate.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsMenuItemInvalid" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer)) 
  :boolean
   () )                                         ; 
;  *  UpdateInvalidMenuItems()
;  *  
;  *  Summary:
;  *    Redraws the invalid items of an open menu.
;  *  
;  *  Discussion:
;  *    It is not necessary to use UpdateInvalidMenuItems if you are
;  *    using Carbon's built-in support for dynamic items based on
;  *    modifier key state. However, if you are modifying items
;  *    dynamically using your own implementation, you should call
;  *    UpdateInvalidMenuItems after completing your modifications for a
;  *    single menu. It will redraw any items that have been marked as
;  *    invalid, and clear the invalid flag for those items.
;  *  
;  *  Parameters:
;  *    
;  *    menu:
;  *      The menu to update.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvalidateMenuItems" 
      ((menu (:handle :menuinfo)) (firstItem :unsigned-integer) (numItems :unsigned-long)) 
  :osstatus
   () )                                         ; ;   Standard font menu (Carbon and later)                                             ;                                                                                       ;   These APIs allow you to create and use the standard font menu.                      ; 
(deftrap-inline "_UpdateInvalidMenuItems" 
      ((menu (:handle :menuinfo))) 
  :osstatus
   () )
(defconstant $kHierarchicalFontMenuOption #x1)

; 
; 	 *  CreateStandardFontMenu()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  UpdateStandardFontMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateStandardFontMenu" 
      ((menu (:handle :menuinfo)) (afterItem :unsigned-integer) (firstHierMenuID :signed-integer) (options :unsigned-long) (outHierMenuCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  GetFontFamilyFromMenuSelection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_UpdateStandardFontMenu" 
      ((menu (:handle :menuinfo)) (outHierMenuCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; ;    Contextual Menu routines and constants                                            ;   available with Conxtextual Menu extension 1.0 and later                             ; ;  Gestalt Selector for classic 68K apps only. ;  CFM apps should weak link and check the symbols. 
(deftrap-inline "_GetFontFamilyFromMenuSelection" 
      ((menu (:handle :menuinfo)) (item :unsigned-integer) (outFontFamily (:pointer :signed-integer)) (outStyle (:pointer :signed-integer))) 
  :osstatus
   () )
(defconstant $gestaltContextualMenuAttr :|cmnu|)
(defconstant $gestaltContextualMenuUnusedBit 0)
(defconstant $gestaltContextualMenuTrapAvailable 1)

; 	 Values indicating what kind of help the application supports 	
(defconstant $kCMHelpItemNoHelp 0)
(defconstant $kCMHelpItemAppleGuide 1)
(defconstant $kCMHelpItemOtherHelp 2)

; 	 Values indicating what was chosen from the menu 	
(defconstant $kCMNothingSelected 0)
(defconstant $kCMMenuItemSelected 1)
(defconstant $kCMShowHelpSelected 3)

; 
; 	 *  InitContextualMenus()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ContextualMenu 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_InitContextualMenus" 
      ()
   (:stack :osstatus)
   (:stack-trap #xAA72 :d0 1))

; 
;  *  IsShowContextualMenuClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ContextualMenu 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_IsShowContextualMenuClick" 
      ((inEvent (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xAA72 :d0 2 inEvent))

; 
;  *  IsShowContextualMenuEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  ContextualMenuSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ContextualMenu 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsShowContextualMenuEvent" 
      ((inEvent :pointer)) 
  :boolean
   () )                                         ; Const
(deftrap "_ContextualMenuSelect" 
      ((inMenu (:handle :menuinfo)) (inGlobalLocation :point) (inReserved :boolean) (inHelpType :unsigned-long) (inHelpItemString (:pointer (:string 255))) (inSelection (:pointer :aedesc)) (outUserSelectionType (:pointer :unsigned-long)) (outMenuID (:pointer :signed-integer)) (outMenuItem (:pointer :unsigned-integer)))
   (:stack :osstatus)
   (:stack-trap #xAA72 :d0 3 inMenu inGlobalLocation inReserved inHelpType inHelpItemString inSelection outUserSelectionType outMenuID outMenuItem))

; 
;  *  ProcessIsContextualMenuClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ContextualMenu 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ProcessIsContextualMenuClient" 
      ((inPSN (:pointer :processserialnumber)))
   (:stack :boolean)
   (:stack-trap #xAA72 :d0 4 inPSN))

; 
;   Contextual Menu Plugin Interface                                                    
;                                                                                       
;   For Mac OS X, we will support a new type of Contextual Menu Plugin: the CFPlugIn    
;   based plugin.  Each plugin must be in a CFPlugIn in the Contextual Menu Items       
;   folder in one of these paths:                                                       
;       /System/Library/Contextual Menu Items/                                          
;       /Library/Contextual Menu Items/                                                 
;       ~/Library/Contextual Menu Items/                                                
;                                                                                       
;   It must export the following functions using the following interface or a C++       
;   interface inheriting from IUnknown and including similar functions.                 
; 
; 
;  *  CMPluginExamineContext()
;  *  
;  *  Availability:
;  *    Implemented by client
;  
; CONST
(deftrap-inline "_CMPluginExamineContext" 
      ((thisInstance :pointer) (inContext (:pointer :aedesc)) (outCommandPairs (:pointer :aedesc))) 
  :osstatus
   () )

; 
;  *  CMPluginHandleSelection()
;  *  
;  *  Availability:
;  *    Implemented by client
;  

(deftrap-inline "_CMPluginHandleSelection" 
      ((thisInstance :pointer) (inContext (:pointer :aedesc)) (inCommandID :signed-long)) 
  :osstatus
   () )

; 
;  *  CMPluginPostMenuCleanup()
;  *  
;  *  Availability:
;  *    Implemented by client
;  

(deftrap-inline "_CMPluginPostMenuCleanup" 
      ((thisInstance :pointer)) 
  nil
   () )

;  previously in LowMem.h.  This functions return the menu ID of the hilited menu 
; 
;  *  LMGetTheMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetTheMenu" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2598))))

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AddResMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AddResMenu" 
      ((theMenu (:handle :menuinfo)) (theType :ostype))
   nil
   (:stack-trap #xA94D))

; 
;  *  InsMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InsMenuItem" 
      ((theMenu (:handle :menuinfo)) (itemString (:string 255)) (afterItem :signed-integer))
   nil
   (:stack-trap #xA826))

; 
;  *  DelMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DelMenuItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer))
   nil
   (:stack-trap #xA952))

; 
;  *  SetItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (itemString (:string 255)))
   nil
   (:stack-trap #xA947))

; 
;  *  GetItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetItem" 
      ((theMenu (:handle :menuinfo)) (item :signed-integer) (itemString (:pointer (:string 255))))
   nil
   (:stack-trap #xA946))

; 
;  *  GetMHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetMHandle" 
      ((MenuID :signed-integer))
   (:stack (:handle :menuinfo))
   (:stack-trap #xA949))

; 
;  *  DelMCEntries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DelMCEntries" 
      ((MenuID :signed-integer) (menuItem :signed-integer))
   nil
   (:stack-trap #xAA60))

; 
;  *  DispMCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DispMCInfo" 
      ((menuCTbl (:handle :mctable)))
   nil
   (:stack-trap #xAA63))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $IFC ACCESSOR_CALLS_ARE_FUNCTIONS 
;  Getters 
; 
;  *  GetMenuID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetMenuWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuID" 
      ((menu (:handle :menuinfo))) 
  :menuid
   () )                                         ; 
;  *  GetMenuHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuWidth" 
      ((menu (:handle :menuinfo))) 
  :signed-integer
   () )                                         ; 
;  *  GetMenuTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuHeight" 
      ((menu (:handle :menuinfo))) 
  :signed-integer
   () )                                         ; 
;  *  GetMenuDefinition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuTitle" 
      ((menu (:handle :menuinfo)) (title (:pointer (:string 255)))) 
  (:pointer (:string 255))
   () )                                         ;  Setters ; 
;  *  SetMenuID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetMenuDefinition" 
      ((menu (:handle :menuinfo)) (outDefSpec (:pointer :menudefspec))) 
  :osstatus
   () )                                         ; 
;  *  SetMenuWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuID" 
      ((menu (:handle :menuinfo)) (MenuID :signed-integer)) 
  nil
   () )                                         ; 
;  *  SetMenuHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuWidth" 
      ((menu (:handle :menuinfo)) (width :signed-integer)) 
  nil
   () )                                         ; 
;  *  SetMenuTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuHeight" 
      ((menu (:handle :menuinfo)) (height :signed-integer)) 
  nil
   () )                                         ; 
;  *  SetMenuDefinition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetMenuTitle" 
      ((menu (:handle :menuinfo)) (title (:string 255))) 
  :osstatus
   () )                                         ; CONST
(deftrap-inline "_SetMenuDefinition" 
      ((menu (:handle :menuinfo)) (defSpec (:pointer :menudefspec))) 
  :osstatus
   () )                                         ; $ENDC; ACCESSOR_CALLS_ARE_FUNCTIONS

#|                                              ; $IFC TARGET_OS_WIN32 
 |#                                             ; $ENDC; TARGET_OS_WIN32

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MenusIncludes

; $ENDC                                         ; __MENUS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Menus)#|
; Warning: Did not recognize these types or records: (menuaccesskeyrec menuaccesskeyptr)
|#