(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Multiprocessing.p"
; at Wednesday May 1,2002 2:39:42 pm.
; 
;      File:       Multiprocessing.p
;  
;      Contains:   Multiprocessing interfaces
;  
;      Version:    Technology: Multiprocessing API version 2.4, integrated NanoKernel support
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 DayStar Digital, Inc.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

; 
;    ===========================================================================================
;    *** WARNING: You must properly check the availability of MP services before calling them!
;    See the section titled "Checking API Availability".
;    ===========================================================================================
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MULTIPROCESSING__
; $SETC __MULTIPROCESSING__ := 1

; $I+
; $SETC MultiprocessingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; 
;    ===========================================================================================
;    This is the header file for version 2.4 of the Mac OS multiprocessing support.  This version
;    has been totally reimplemented and has significant new services.  The main goal of the
;    reimplementation has been to transfer task management into the core operating system to provide
;    much more reliable and more efficient operation, including on single processor machines.
;    The memory management has also been massively improved, it is much faster and wastes much
;    less space.  New services include POSIX style per-task storage, timers with millisecond and
;    microsecond resolutions, memory allocation at a specified alignment, and system pageable
;    and RAM resident memory pools.  See the MP API documentation for details.
;    The old "DayStar" debugging services (whose names began with an underscore) have been
;    removed from this header.  A very few are still implemented for binary compatibility, or in
;    cases where they happened to be exposed inappropriately.  (E.g. _MPIsFullyInitialized must
;    be called to see if the MP API is ReallyTruly usable.)  New code and recompiles of old
;    code should avoid use of these defunct services, except for _MPIsFullyInitialized.
;    ===========================================================================================
; 

; 
;    ===========================================================================================
;    The following services are from the original MP API and remain supported in version 2.0:
;     MPProcessors
;     MPCreateTask
;     MPTerminateTask
;     MPCurrentTaskID
;     MPYield
;     MPExit
;     MPCreateQueue
;     MPDeleteQueue
;     MPNotifyQueue
;     MPWaitOnQueue
;     MPCreateSemaphore
;     MPCreateBinarySemaphore     (In C only, a macro that calls MPCreateSemaphore.)
;     MPDeleteSemaphore
;     MPSignalSemaphore
;     MPWaitOnSemaphore
;     MPCreateCriticalRegion
;     MPDeleteCriticalRegion
;     MPEnterCriticalRegion
;     MPExitCriticalRegion
;     MPAllocate                  (Deprecated, use MPAllocateAligned for new builds.)
;     MPFree
;     MPBlockCopy
;     MPLibraryIsLoaded           (In C only, a macro.)
;     _MPIsFullyInitialized       (See comments about checking for MP API availability.)
;    ===========================================================================================
; 

; 
;    ===========================================================================================
;    The following services are new in version 2.0:
;     MPProcessorsScheduled
;     MPSetTaskWeight
;     MPTaskIsPreemptive
;     MPAllocateTaskStorageIndex
;     MPDeallocateTaskStorageIndex
;     MPSetTaskStorageValue
;     MPGetTaskStorageValue
;     MPSetQueueReserve
;     MPCreateEvent
;     MPDeleteEvent
;     MPSetEvent
;     MPWaitForEvent
;     UpTime
;     DurationToAbsolute
;     AbsoluteToDuration
;     MPDelayUntil
;     MPCreateTimer
;     MPDeleteTimer
;     MPSetTimerNotify
;     MPArmTimer
;     MPCancelTimer
;     MPSetExceptionHandler
;     MPThrowException
;     MPDisposeTaskException
;     MPExtractTaskState
;     MPSetTaskState
;     MPRegisterDebugger
;     MPUnregisterDebugger
;     MPAllocateAligned           (Preferred over MPAllocate.)
;     MPGetAllocatedBlockSize
;     MPBlockClear
;     MPDataToCode
;     MPRemoteCall                (Preferred over _MPRPC.)
;    ===========================================================================================
; 

; 
;    ===========================================================================================
;    The following services are new in version 2.1:
;     MPCreateNotification
;     MPDeleteNotification
;     MPModifyNotification
;     MPCauseNotification
;     MPGetNextTaskID
;     MPGetNextCpuID
;    ===========================================================================================
; 

; 
;    ===========================================================================================
;    The following services are "unofficial" extensions to the original API.  They are not in
;    the multiprocessing API documentation, but were in previous versions of this header.  They
;    remain supported in version 2.0.  They may not be supported in other environments.
;     _MPRPC                      (Deprecated, use MPRemoteCall for new builds.)
;     _MPAllocateSys              (Deprecated, use MPAllocateAligned for new builds.)
;     _MPTaskIsToolboxSafe
;     _MPLibraryVersion
;     _MPLibraryIsCompatible
;    ===========================================================================================
; 

; 
;    ===========================================================================================
;    The following services were in previous versions of this header for "debugging only" use.
;    They are NOT implemented in version 2.0.  For old builds they can be accessed by defining
;    the symbol MPIncludeDefunctServices to have a nonzero value.
;     _MPInitializePrintf
;     _MPPrintf
;     _MPDebugStr
;     _MPStatusPString
;     _MPStatusCString
;    ===========================================================================================
; 

; 
;    
;    ===========================================================================================
;    General Types and Constants
;    ===========================
; 

(defconstant $MPLibrary_MajorVersion 2)         ;   ! When these change be sure to update the build versions 
(defconstant $MPLibrary_MinorVersion 4)         ;   !  used in the startup check in MPInitializeAPI! 
(defconstant $MPLibrary_Release 1)
(defconstant $MPLibrary_DevelopmentRevision 1)

(def-mactype :mpprocessid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpprocessidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPProcessID parameter can be nil, it is changed to xx: MPProcessIDPtr 
(def-mactype :mptaskid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mptaskidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPTaskID parameter can be nil, it is changed to xx: MPTaskIDPtr 
(def-mactype :mpqueueid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpqueueidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPQueueID parameter can be nil, it is changed to xx: MPQueueIDPtr 
(def-mactype :mpsemaphoreid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpsemaphoreidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPSemaphoreID parameter can be nil, it is changed to xx: MPSemaphoreIDPtr 
(def-mactype :mpcriticalregionid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpcriticalregionidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPCriticalRegionID parameter can be nil, it is changed to xx: MPCriticalRegionIDPtr 
(def-mactype :mptimerid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mptimeridptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPTimerID parameter can be nil, it is changed to xx: MPTimerIDPtr 
(def-mactype :mpeventid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpeventidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPEventID parameter can be nil, it is changed to xx: MPEventIDPtr 
(def-mactype :mpaddressspaceid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpaddressspaceidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPAddressSpaceID parameter can be nil, it is changed to xx: MPAddressSpaceIDPtr 
(def-mactype :mpnotificationid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpnotificationidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPNotificationID parameter can be nil, it is changed to xx: MPNotificationIDPtr 
(def-mactype :mpcoherenceid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpcoherenceidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPCoherenceID parameter can be nil, it is changed to xx: MPCoherenceIDPtr 
(def-mactype :mpcpuid (find-mactype ':pointer)) ;  an opaque 32-bit type 
(def-mactype :mpcpuidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPCpuID parameter can be nil, it is changed to xx: MPCpuIDPtr 
(def-mactype :mpareaid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpareaidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPAreaID parameter can be nil, it is changed to xx: MPAreaIDPtr 
(def-mactype :mpconsoleid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpconsoleidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPConsoleID parameter can be nil, it is changed to xx: MPConsoleIDPtr 
(def-mactype :mpopaqueid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mpopaqueidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MPOpaqueID parameter can be nil, it is changed to xx: MPOpaqueIDPtr 

;   Values for MPOpaqueIDClass. 
(defconstant $kOpaqueAnyID 0)
(defconstant $kOpaqueProcessID 1)
(defconstant $kOpaqueTaskID 2)
(defconstant $kOpaqueTimerID 3)
(defconstant $kOpaqueQueueID 4)
(defconstant $kOpaqueSemaphoreID 5)
(defconstant $kOpaqueCriticalRegionID 6)
(defconstant $kOpaqueCpuID 7)
(defconstant $kOpaqueAddressSpaceID 8)
(defconstant $kOpaqueEventID 9)
(defconstant $kOpaqueCoherenceID 10)
(defconstant $kOpaqueAreaID 11)
(defconstant $kOpaqueNotificationID 12)
(defconstant $kOpaqueConsoleID 13)

(def-mactype :mpopaqueidclass (find-mactype ':unsigned-long))

(defconstant $kMPNoID 0)                        ;   New code should use kInvalidID everywhere. 

(def-mactype :mptaskoptions (find-mactype ':unsigned-long))
(def-mactype :taskstorageindex (find-mactype ':unsigned-long))
(def-mactype :taskstoragevalue (find-mactype ':unsigned-long))
(def-mactype :mpsemaphorecount (find-mactype ':unsigned-long))
(def-mactype :mptaskweight (find-mactype ':unsigned-long))
(def-mactype :mpeventflags (find-mactype ':unsigned-long))
(def-mactype :mpexceptionkind (find-mactype ':unsigned-long))
(def-mactype :mptaskstatekind (find-mactype ':unsigned-long))
(def-mactype :mppagesizeclass (find-mactype ':unsigned-long))

(defconstant $kDurationImmediate 0)
(defconstant $kDurationForever #x7FFFFFFF)
(defconstant $kDurationMillisecond 1)
(defconstant $kDurationMicrosecond -1)

; 
; 	   
; 	   ===========================================================================================
; 	   Process/Processor Services
; 	   ==========================
; 	

; 
; 	 *  MPProcessors()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPProcessors" 
      () 
  :unsigned-long
   () )

;   The physical total. 

; 
;  *  MPProcessorsScheduled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPProcessorsScheduled" 
      () 
  :unsigned-long
   () )

;   Those currently in use. 

; 
;    
;    ===========================================================================================
;    Tasking Services
;    ================
; 

;   For MPCreateTask options 
(defconstant $kMPCreateTaskTakesAllExceptionsMask #x2)
(defconstant $kMPCreateTaskNotDebuggableMask #x4)
(defconstant $kMPCreateTaskValidOptionsMask #x6)

;   ------------------------------------------------------------------------------------------- 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TaskProc = FUNCTION(parameter: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :taskproc (find-mactype ':pointer))
; $ENDC

; 
; 	 *  MPCreateTask()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPCreateTask" 
      ((entryPoint :pointer) (parameter :pointer) (stackSize :unsigned-long) (notifyQueue :pointer) (terminationParameter1 :pointer) (terminationParameter2 :pointer) (options :unsigned-long) (task (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPTerminateTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPTerminateTask" 
      ((task :pointer) (terminationStatus :signed-long)) 
  :osstatus
   () )

; 
;  *  MPSetTaskWeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetTaskWeight" 
      ((task :pointer) (weight :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPTaskIsPreemptive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPTaskIsPreemptive" 
      ((taskID :pointer)) 
  :boolean
   () )

;   May be kInvalidID. 

; 
;  *  MPExit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPExit" 
      ((status :signed-long)) 
  nil
   () )

; 
;  *  MPYield()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPYield" 
      () 
  nil
   () )

; 
;  *  MPCurrentTaskID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCurrentTaskID" 
      () 
  :pointer
   () )

; 
;  *  MPSetTaskType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.3 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetTaskType" 
      ((task :pointer) (taskType :ostype)) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;    ---------------------------------------------------
;    ! The task storage services are new in version 2.0.
; 

; 
;  *  MPAllocateTaskStorageIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPAllocateTaskStorageIndex" 
      ((index (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  MPDeallocateTaskStorageIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeallocateTaskStorageIndex" 
      ((index :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPSetTaskStorageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetTaskStorageValue" 
      ((index :unsigned-long) (value :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPGetTaskStorageValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPGetTaskStorageValue" 
      ((index :unsigned-long)) 
  :unsigned-long
   () )

; 
;    
;    ===========================================================================================
;    Synchronization Services
;    ========================
; 

; 
;  *  MPCreateQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCreateQueue" 
      ((queue (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPDeleteQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeleteQueue" 
      ((queue :pointer)) 
  :osstatus
   () )

; 
;  *  MPNotifyQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPNotifyQueue" 
      ((queue :pointer) (param1 :pointer) (param2 :pointer) (param3 :pointer)) 
  :osstatus
   () )

; 
;  *  MPWaitOnQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPWaitOnQueue" 
      ((queue :pointer) (param1 :pointer) (param2 :pointer) (param3 :pointer) (timeout :signed-long)) 
  :osstatus
   () )

; 
;  *  MPSetQueueReserve()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetQueueReserve" 
      ((queue :pointer) (count :unsigned-long)) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;  *  MPCreateSemaphore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCreateSemaphore" 
      ((maximumValue :unsigned-long) (initialValue :unsigned-long) (semaphore (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPDeleteSemaphore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeleteSemaphore" 
      ((semaphore :pointer)) 
  :osstatus
   () )

; 
;  *  MPSignalSemaphore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSignalSemaphore" 
      ((semaphore :pointer)) 
  :osstatus
   () )

; 
;  *  MPWaitOnSemaphore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPWaitOnSemaphore" 
      ((semaphore :pointer) (timeout :signed-long)) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;  *  MPCreateCriticalRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCreateCriticalRegion" 
      ((criticalRegion (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPDeleteCriticalRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeleteCriticalRegion" 
      ((criticalRegion :pointer)) 
  :osstatus
   () )

; 
;  *  MPEnterCriticalRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPEnterCriticalRegion" 
      ((criticalRegion :pointer) (timeout :signed-long)) 
  :osstatus
   () )

; 
;  *  MPExitCriticalRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPExitCriticalRegion" 
      ((criticalRegion :pointer)) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;  *  MPCreateEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  MPDeleteEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_MPCreateEvent" 
      ((event (:pointer :pointer))) 
  :osstatus
   () )
(deftrap-inline "_MPDeleteEvent" 
      ((event :pointer)) 
  :osstatus
   () )

; 
;  *  MPSetEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetEvent" 
      ((event :pointer) (flags :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPWaitForEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;    
;    ===========================================================================================
;    Notification Services (API)
;    =====================
;                                               ; 
;  *  MPCreateNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_MPWaitForEvent" 
      ((event :pointer) (flags (:pointer :unsigned-long)) (timeout :signed-long)) 
  :osstatus
   () )
(deftrap-inline "_MPCreateNotification" 
      ((notificationID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPDeleteNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeleteNotification" 
      ((notificationID :pointer)) 
  :osstatus
   () )

; 
;  *  MPModifyNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPModifyNotification" 
      ((notificationID :pointer) (anID :pointer) (notifyParam1 :pointer) (notifyParam2 :pointer) (notifyParam3 :pointer)) 
  :osstatus
   () )

; 
;  *  MPModifyNotificationParameters()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.3 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPModifyNotificationParameters" 
      ((notificationID :pointer) (kind :unsigned-long) (notifyParam1 :pointer) (notifyParam2 :pointer) (notifyParam3 :pointer)) 
  :osstatus
   () )

; 
;  *  MPCauseNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCauseNotification" 
      ((notificationID :pointer)) 
  :osstatus
   () )

; 
;    
;    ===========================================================================================
;    Timer Services
;    ==============
; 

; 
;    --------------------------------------------
;    ! The timer services are new in version 2.0.
; 

#|                                              ; $IFC false 
;   For now these are taken from DriverServices, should be in a better place. 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  UpTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_UpTime" 
      () 
  :unsignedwide
   () )

; 
;  *  DurationToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DurationToAbsolute" 
      ((Duration :signed-long)) 
  :unsignedwide
   () )

; 
;  *  AbsoluteToDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_AbsoluteToDuration" 
      ((time :unsignedwide)) 
  :duration
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; 0

;   For MPArmTimer options 
(defconstant $kMPPreserveTimerIDMask #x1)
(defconstant $kMPTimeIsDeltaMask #x2)
(defconstant $kMPTimeIsDurationMask #x4)

; 
; 	 *  MPDelayUntil()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 2.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPDelayUntil" 
      ((expirationTime (:pointer :unsignedwide))) 
  :osstatus
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPDelayUntilSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPDelayUntilSys" 
      ((expirationTime (:pointer :unsignedwide))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  MPCreateTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCreateTimer" 
      ((timerID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPDeleteTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDeleteTimer" 
      ((timerID :pointer)) 
  :osstatus
   () )

; 
;  *  MPSetTimerNotify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetTimerNotify" 
      ((timerID :pointer) (anID :pointer) (notifyParam1 :pointer) (notifyParam2 :pointer) (notifyParam3 :pointer)) 
  :osstatus
   () )

; 
;  *  MPArmTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPArmTimer" 
      ((timerID :pointer) (expirationTime (:pointer :unsignedwide)) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPCancelTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPCancelTimer" 
      ((timerID :pointer) (timeRemaining (:pointer :unsignedwide))) 
  :osstatus
   () )

; 
;    
;    ===========================================================================================
;    Memory Services
;    ===============
; 

;   Maximum allocation request size is 1GB. 
(defconstant $kMPMaxAllocSize 1073741824)

;   Values for the alignment parameter to MPAllocateAligned. 
(defconstant $kMPAllocateDefaultAligned 0)
(defconstant $kMPAllocate8ByteAligned 3)
(defconstant $kMPAllocate16ByteAligned 4)
(defconstant $kMPAllocate32ByteAligned 5)
(defconstant $kMPAllocate1024ByteAligned 10)
(defconstant $kMPAllocate4096ByteAligned 12)
(defconstant $kMPAllocateMaxAlignment 16)       ;   Somewhat arbitrary limit on expectations. 
(defconstant $kMPAllocateAltiVecAligned 4)      ;   The P.C. name. 
(defconstant $kMPAllocateVMXAligned 4)          ;   The older, common name. 
(defconstant $kMPAllocateVMPageAligned 254)     ;   Pseudo value, converted at runtime. 
(defconstant $kMPAllocateInterlockAligned 255)  ;   Pseudo value, converted at runtime. 

;   Values for the options parameter to MPAllocateAligned. 
(defconstant $kMPAllocateClearMask #x1)         ;   Zero the allocated block. 
(defconstant $kMPAllocateGloballyMask #x2)      ;   Allocate from the globally visible pool. 
(defconstant $kMPAllocateResidentMask #x4)      ;   Allocate from the RAM-resident pool. 
(defconstant $kMPAllocateNoGrowthMask #x10)     ;   Do not attempt to grow the pool. 
(defconstant $kMPAllocateNoCreateMask #x20)     ;   Do not attempt to create the pool if it doesn't exist yet. 

;   ------------------------------------------------------------------------------------------- 

; 
; 	 *  MPAllocateAligned()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 2.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPAllocateAligned" 
      ((size :unsigned-long) (alignment :signed-byte) (options :unsigned-long)) 
  :pointer
   () )

;   ! MPAllocateAligned is new in version 2.0. 

; 
;  *  MPAllocate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPAllocate" 
      ((size :unsigned-long)) 
  :pointer
   () )

;   Use MPAllocateAligned instead. 

; 
;  *  MPFree()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPFree" 
      ((object :pointer)) 
  nil
   () )

; 
;  *  MPGetAllocatedBlockSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPGetAllocatedBlockSize" 
      ((object :pointer)) 
  :unsigned-long
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;  *  MPBlockCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPBlockCopy" 
      ((source :pointer) (destination :pointer) (size :unsigned-long)) 
  nil
   () )

; 
;  *  MPBlockClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPBlockClear" 
      ((address :pointer) (size :unsigned-long)) 
  nil
   () )

;   ! MPBlockClear is new in version 2.0. 

; 
;  *  MPDataToCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDataToCode" 
      ((address :pointer) (size :unsigned-long)) 
  nil
   () )

;   ! MPDataToCode is new in version 2.0. 
; 
;    
;    ===========================================================================================
;    Exception/Debugging Services
;    ============================
; 

; 
;    -------------------------------------------------------------------------------------------
;    *** Important Note ***
;    ----------------------
;    
;    The functions MPExtractTaskState and MPSetTaskState infer the size of the "info" buffer
;    from the "kind" parameter.  A given value for MPTaskStateKind will always refer to a
;    single specific physical buffer layout.  Should new register sets be added, or the size
;    or number of any registers change, new values of MPTaskStateKind will be introduced to
;    refer to the new buffer layouts.
;    
;    The following types for the buffers are in MachineExceptions. The correspondence between
;    MPTaskStateKind values and MachineExceptions types is:
;    
;         kMPTaskStateRegisters               -> RegisterInformation
;         kMPTaskStateFPU                     -> FPUInformation
;         kMPTaskStateVectors                 -> VectorInformation
;         kMPTaskStateMachine                 -> MachineInformation
;         kMPTaskState32BitMemoryException    -> ExceptionInfo for old-style 32-bit memory exceptions
;    
;     For reference, on PowerPC the MachineExceptions types contain:
;    
;         RegisterInformation -> The GPRs, 32 values of 64 bits each.
;         FPUInformation      -> The FPRs plus FPSCR, 32 values of 64 bits each, one value of
;                                 32 bits.
;         VectorInformation   -> The AltiVec vector registers plus VSCR and VRSave, 32 values
;                                 of 128 bits each, one value of 128 bits, and one 32 bit value.
;         MachineInformation  -> The CTR, LR, PC, each of 64 bits.  The CR, XER, MSR, MQ,
;                                 exception kind, and DSISR, each of 32 bits.  The 64 bit DAR.
;         ExceptionInfo       -> Only memory exceptions are specified, 4 fields of 32 bits each.
;                                 Note that this type only covers memory exceptions on 32-bit CPUs!
;    The following types are declared here:
;         kMPTaskStateTaskInfo                -> MPTaskInfo
; 

;   Values for the TaskStateKind to MPExtractTaskState and MPSetTaskState. 
(defconstant $kMPTaskStateRegisters 0)          ;   The task general registers. 
(defconstant $kMPTaskStateFPU 1)                ;   The task floating point registers 
(defconstant $kMPTaskStateVectors 2)            ;   The task vector registers 
(defconstant $kMPTaskStateMachine 3)            ;   The task machine registers 
(defconstant $kMPTaskState32BitMemoryException 4);   The task memory exception information for 32-bit CPUs. 
(defconstant $kMPTaskStateTaskInfo 5)           ;   Static and dynamic information about the task. 

;   Option bits and numbers for MPDisposeTaskException. 
(defconstant $kMPTaskPropagate 0)               ;   The exception is propagated. 
(defconstant $kMPTaskResumeStep 1)              ;   The task is resumed and single step is enabled. 
(defconstant $kMPTaskResumeBranch 2)            ;   The task is resumed and branch stepping is enabled. 
(defconstant $kMPTaskResumeMask #x0)            ;   The task is resumed. 
(defconstant $kMPTaskPropagateMask #x1)         ;   The exception is propagated. 
(defconstant $kMPTaskResumeStepMask #x2)        ;   The task is resumed and single step is enabled. 
(defconstant $kMPTaskResumeBranchMask #x4)      ;   The task is resumed and branch stepping is enabled. 

;   For kMPTaskStateTaskInfo, the task's runState 
(defconstant $kMPTaskBlocked 0)                 ;   Task is blocked (queued on resource) 
(defconstant $kMPTaskReady 1)                   ;   Task is runnable 
(defconstant $kMPTaskRunning 2)                 ;   Task is running 

;   For kMPTaskStateTaskInfo, the version of the MPTaskInfo structure requested. 
(defconstant $kMPTaskInfoVersion 3)

(def-mactype :mptaskinfoptr (find-mactype '(:pointer :mptaskinfo)))
(defrecord MPTaskInfo 
   (version :unsigned-long)                     ;   Version 3 of the data structure requested 
   (name :ostype)                               ;   Task name 
   (queueName :ostype)                          ;   Task's queue owner name 
   (runState :unsigned-integer)                 ;   Running, ready, blocked 
   (lastCPU :unsigned-integer)                  ;   Address of CPU where task previously ran 
   (weight :unsigned-long)                      ;   Processing weight: 1 - 10,000 
   (processID :pointer)                         ;   Owning process ID 
   (cpuTime :unsignedwide)                      ;   Accumulated task time 
   (schedTime :unsignedwide)                    ;   Time when last scheduled 
   (creationTime :unsignedwide)                 ;   Time when task created 
   (codePageFaults :unsigned-long)              ;   Page faults from code execution 
   (dataPageFaults :unsigned-long)              ;   Page faults from data access 
   (preemptions :unsigned-long)                 ;   Number of times task was preempted 
   (cpuID :pointer)                             ;   ID of CPU where task previously ran. 
   (blockedObject :pointer)                     ;   ID of blocked object. 
   (spaceID :pointer)                           ;   Address space ID of this task. 
   (stackBase :pointer)                         ;   Base of stack (lowest address). 
   (stackLimit :pointer)                        ;   Stack limit (highest address). 
   (stackCurr :pointer)                         ;   Current stack address. 
   )

; 
; 	    Upon a task exception, the following message is sent to the designated queue:
; 	      1. The MPTaskID, 
; 	      2. The exception kind. These are enumerated in the interfaces header MachineExceptions.h 
; 	      3. N/A
; 	

;   ------------------------------------------------------------------------------------------- 

; 
; 	 *  MPSetExceptionHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 2.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPSetExceptionHandler" 
      ((task :pointer) (exceptionQ :pointer)) 
  :osstatus
   () )

; 
;  *  MPDisposeTaskException()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPDisposeTaskException" 
      ((task :pointer) (action :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPExtractTaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPExtractTaskState" 
      ((task :pointer) (kind :unsigned-long) (info :pointer)) 
  :osstatus
   () )

; 
;  *  MPSetTaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPSetTaskState" 
      ((task :pointer) (kind :unsigned-long) (info :pointer)) 
  :osstatus
   () )

; 
;  *  MPThrowException()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPThrowException" 
      ((task :pointer) (kind :unsigned-long)) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

(def-mactype :mpdebuggerlevel (find-mactype ':unsigned-long))

(defconstant $kMPLowLevelDebugger #x0)          ;   MacsBug-like 
(defconstant $kMPMidLevelDebugger #x10000000)   ;   Jasik-like 
(defconstant $kMPHighLevelDebugger #x20000000)  ;   Metrowerks-like 

; 
; 	 *  MPRegisterDebugger()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 2.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPRegisterDebugger" 
      ((queue :pointer) (level :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MPUnregisterDebugger()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MPUnregisterDebugger" 
      ((queue :pointer)) 
  :osstatus
   () )

; 
;    
;    ===========================================================================================
;    Remote Call Services
;    ====================
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MPRemoteProcedure = FUNCTION(parameter: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :mpremoteprocedure (find-mactype ':pointer))
; $ENDC

(def-mactype :mpremotecontext (find-mactype ':unsigned-byte))

(defconstant $kMPAnyRemoteContext 0)
(defconstant $kMPOwningProcessRemoteContext 1)
(defconstant $kMPInterruptRemoteContext 2)
(defconstant $kMPAsyncInterruptRemoteContext 3)

; 
; 	 *  MPRemoteCall()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPLibrary 2.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_MPRemoteCall" 
      ((remoteProc :pointer) (parameter :pointer) (context :signed-byte)) 
  :pointer
   () )

;   ! MPRemoteCall is new in version 2.0. 
; 
;    
;    ===========================================================================================
;    Checking API Availability
;    =========================
; 

; 
;    ===========================================================================================
;    *** WARNING: You must properly check the availability of MP services before calling them!
;    ===========================================================================================
;    
;    Checking for the availability of the MP API is rather ugly.  This is a historical problem,
;    caused by the original implementation letting itself get prepared when it really wasn't
;    usable and complicated by some important clients then depending on weak linking to "work".
;    (And further complicated by CFM not supporting "deferred" imports, which is how many
;    programmers think weak imports work.)
;    
;    The end result is that the MP API library may get prepared by CFM but be totally unusable.
;    This means that if you import from the MP API library, you cannot simply check for a
;    resolved import to decide if MP services are available.  Worse, if you explicitly prepare
;    the MP API library you cannot assume that a noErr result from GetSharedLibrary means that
;    MP services are available.
;    
;     If you import from the MP API library you MUST:
;    
;         Use the MPLibraryIsLoaded macro (or equivalent code in languages other than C) to tell
;         if the MP API services are available.  It is not sufficient to simply check that an
;         imported symbol is resolved as is commonly done for other libraries.  The macro expands
;         to the expression:
;    
;             ( ( (UInt32)_MPIsFullyInitialized != (UInt32)kUnresolvedCFragSymbolAddress ) &&
;               ( _MPIsFullyInitialized () ) )
;    
;         This checks if the imported symbol _MPIsFullyInitialized is resolved and if resolved
;         calls it.  Both parts must succeed for the MP API services to be available.
;    
;     If you explicitly prepare the MP API library you MUST:
;    
;         Use code similar to the following example to tell if the MP API services are available.
;         It is not sufficient to depend on just a noErr result from GetSharedLibrary.
;    
;             OSErr                       err;
;             Boolean                     mpIsAvailable           = false;
;             CFragConnectionID           connID                  = kInvalidID;
;             MPIsFullyInitializedProc    mpIsFullyInitialized    = NULL;
;    
;             err = GetSharedLibrary  ( "\pMPLibrary", kCompiledCFragArch, kReferenceCFrag,
;                                       &connID, NULL, NULL );
;    
;             if ( err == noErr ) (
;                 err = FindSymbol    ( connID, "\p_MPIsFullyInitialized",
;                                       (Ptr *) &mpIsFullyInitialized, NULL );
;             )
;    
;             if ( err == noErr ) (
;                 mpIsAvailable = (* mpIsFullyInitialized) ();
;             )
;    
;    ===========================================================================================
; 

; 
;  *  _MPIsFullyInitialized()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "__MPIsFullyInitialized" 
      () 
  :boolean
   () )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MPIsFullyInitializedProc = FUNCTION: BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :mpisfullyinitializedproc (find-mactype ':pointer))
; $ENDC

; 
; 	   ===========================================================================================
; 	   The MPLibraryIsLoaded service is a macro under C that expands to the logical expression:
; 	        ( (UInt32)MPProcessors != (UInt32)kUnresolvedCFragSymbolAddress )
; 	   The intention is to check if the imported symbol MPProcessors is resolved.  For other
; 	   languages use the equivalent expression.
; 	   ===========================================================================================
; 	
; 
; 	   
; 	   ===========================================================================================
; 	   Miscellaneous Services
; 	   ======================
; 	

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  _MPLibraryVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "__MPLibraryVersion" 
      ((versionCString (:pointer :pointer)) (major (:pointer :unsigned-long)) (minor (:pointer :unsigned-long)) (release (:pointer :unsigned-long)) (revision (:pointer :unsigned-long))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;    
;    ===========================================================================================
;    Unofficial Services
;    ===================
; 

; 
;    ===========================================================================================
;    *** WARNING ***
;    These services are not part of the officially documented multiprocessing API.  They may not
;    be avaliable in future versions of Mac OS multiprocessing support, or in environments that
;    have a different underlying OS architecture such as Mac OS on top of a microkernel, the
;    Mac OS Blue Box under Mac OS X, native MP support in Mac OS X, etc.
;    ===========================================================================================
; 

; $IFC CALL_NOT_IN_CARBON 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  _MPAllocateSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPAllocateSys" 
      ((size :unsigned-long)) 
  :pointer
   () )

;   Use MPAllocateAligned instead. 
; 
;  *  _MPRPC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPRPC" 
      ((remoteProc :pointer) (parameter :pointer)) 
  :pointer
   () )

;   Use _MPRemoteCall instead. 
; 
;  *  _MPTaskIsToolboxSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPTaskIsToolboxSafe" 
      ((task :pointer)) 
  :boolean
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  _MPLibraryIsCompatible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibrary 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "__MPLibraryIsCompatible" 
      ((versionCString :pointer) (major :unsigned-long) (minor :unsigned-long) (release :unsigned-long) (revision :unsigned-long)) 
  :boolean
   () )

; 
;    
;    ===========================================================================================
;    Defunct Services
;    ================
; 

; $IFC CALL_NOT_IN_CARBON 
; $IFC UNDEFINED MPIncludeDefunctServices 
; $SETC MPIncludeDefunctServices := 0 
; $ENDC
#|                                              ; $IFC MPIncludeDefunctServices 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  _MPDebugStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibraryObsolete 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPDebugStr" 
      ((msg (:string 255))) 
  nil
   () )

; 
;  *  _MPStatusPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibraryObsolete 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPStatusPString" 
      ((status :signed-long)) 
  (:pointer (:string 255))
   () )

; 
;  *  _MPStatusCString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPLibraryObsolete 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "__MPStatusCString" 
      ((status :signed-long)) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; MPIncludeDefunctServices
; $ENDC                                         ; CALL_NOT_IN_CARBON

;   =========================================================================================== 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MultiprocessingIncludes

; $ENDC                                         ; __MULTIPROCESSING__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Multiprocessing)
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:multiprocessing.patch;; has the dots disease - inherited from form above

(deftrap-inline "__MPDebugStr" 
      ((msg (:string 255))) 
  nil
   () )