(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:NSLCore.p"
; at Wednesday May 1,2002 2:40:26 pm.
; 
;      File:       NSLCore.p
;  
;      Contains:   Interface to API for using the NSL Manager
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __NSLCORE__
; $SETC __NSLCORE__ := 1

; $I+
; $SETC NSLCoreIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __THREADS__
|#

(require-interface 'Threads)
#|                                              ; $I Threads.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kNSLMinSystemVersion #x900)       ;   equivalent to 9.0 
(defconstant $kNSLMinOTVersion #x130)           ;   equivalent to 1.3 

(defconstant $kNSLDefaultListSize 256)          ;   default list size for service and protocol lists 

(defconstant $kNSLURLDelimiter 44)              ;   delimits URL's within memory buffers 

(defconstant $kNSLNoContext 0)                  ;   the default context for NSLError structs 

(def-mactype :nslerrorptr (find-mactype '(:pointer :nslerror)))
(defrecord NSLError 
   (theErr :signed-long)
   (theContext :unsigned-long)
   )

;   Constants to use with NSLPrepareRequest 
;   kNSLDuplicateSearchInProgress is not strictly an error.  The client is free to ignore 
;   this result, and nothing bad will happen if it does.  It is 
;   informational only. 
(defconstant $kNSLDuplicateSearchInProgress 100)
(defconstant $kNSLUserCanceled -128)            ;   User hit cancel from the NSLStandardGetURL dialog  
;   Invalid enumeratorRef   
(defconstant $kNSLInvalidEnumeratorRef 0)       ;   this is not an error; it is the equiv to a NULL ptr 

(def-mactype :nslsearchstate (find-mactype ':unsigned-integer))

;   State codes for notifiers. 
(defconstant $kNSLSearchStateBufferFull 1)
(defconstant $kNSLSearchStateOnGoing 2)
(defconstant $kNSLSearchStateComplete 3)
(defconstant $kNSLSearchStateStalled 4)
(defconstant $kNSLWaitingForContinue 5)

(def-mactype :nsleventcode (find-mactype ':unsigned-long))

;   Event codes 
(defconstant $kNSLServicesLookupDataEvent 6)
(defconstant $kNSLNeighborhoodLookupDataEvent 7)
(defconstant $kNSLNewDataEvent 8)
(defconstant $kNSLContinueLookupEvent 9)

(def-mactype :nslclientref (find-mactype ':unsigned-long))
(def-mactype :nslrequestref (find-mactype ':unsigned-long))
(def-mactype :nslonebasedindex (find-mactype ':unsigned-long))
(def-mactype :nslpath (find-mactype '(:pointer :character)))
(def-mactype :nslservicetype (find-mactype '(:pointer :character)))
(def-mactype :nslserviceslist (find-mactype ':handle))
(def-mactype :nslneighborhood (find-mactype '(:pointer :unsigned-byte)))
; 
; 	   cstring which is a comma delimited list of protocols which can be used to
; 	   create a NSLProtocolList internally
; 	
;   the async information block for client<->manager interaction 
(def-mactype :nslclientasyncinfoptr (find-mactype '(:pointer :nslclientasyncinfo)))
(defrecord NSLClientAsyncInfo 
   (clientContextPtr :pointer)                  ;   set by the client for its own use 
   (mgrContextPtr :pointer)                     ;   set by NSL mgr; ptr to request object ptr 
   (resultBuffer :pointer)
   (bufferLen :signed-long)
   (maxBufferSize :signed-long)
   (startTime :unsigned-long)                   ;   when the search starts, to use with maxSearchTime to determine time-out condition 
   (intStartTime :unsigned-long)                ;   used with alertInterval 
   (maxSearchTime :unsigned-long)               ;   total time for search, in ticks (0 == no time limit) 
   (alertInterval :unsigned-long)               ;   call client's notifier or return, every this many ticks ( 0 == don't use this param) 
   (totalItems :unsigned-long)                  ;   total number of tuples currently in buffer 
   (alertThreshold :unsigned-long)              ;   call client's notifier or return, every this many items found ( 0 == don't use this param) 
   (searchState :unsigned-integer)
   (searchResult :nslerror)
   (searchDataType :unsigned-long)              ;   this is a data type code which allows the client's asyncNotifier to properly 
;   handle the data in resultBuffer. 
   )

;   the async information block plugin<->manager interaction 
(def-mactype :nslpluginasyncinfoptr (find-mactype '(:pointer :nslpluginasyncinfo)))
(defrecord NSLPluginAsyncInfo 
   (mgrContextPtr :pointer)                     ;   set by NSL mgr; ptr to request object ptr 
   (pluginContextPtr :pointer)                  ;   set/used by individual plugins 
   (pluginPtr :pointer)                         ;   ptr to the plugin object waiting for continue lookup call 
   (resultBuffer :pointer)                      ;   set by plugin to point at data 
   (bufferLen :signed-long)
   (maxBufferSize :signed-long)
   (maxSearchTime :unsigned-long)               ;   total time for search, in ticks (0 == no time limit) 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   (clientRef :unsigned-long)
   (requestRef :unsigned-long)
   (searchState :unsigned-integer)
   (searchResult :signed-long)
   )

;   the manager asynchronous notifier routine. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSLMgrNotifyProcPtr = PROCEDURE(VAR thePluginAsyncInfo: NSLPluginAsyncInfo);

|#
 |#                                             ; $ELSEC
(def-mactype :nslmgrnotifyprocptr (find-mactype ':pointer))
; $ENDC

;   the client asynchronous notifier routine. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSLClientNotifyProcPtr = PROCEDURE(VAR theClientAsyncInfo: NSLClientAsyncInfo);

|#
 |#                                             ; $ELSEC
(def-mactype :nslclientnotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nslmgrnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nslmgrnotifyupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nslclientnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nslclientnotifyupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppNSLMgrNotifyProcInfo #xC0)
(defconstant $uppNSLClientNotifyProcInfo #xC0)
; 
; 	 *  NewNSLMgrNotifyUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewNSLMgrNotifyProc 
(deftrap "_NewNSLMgrNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNSLClientNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewNSLClientNotifyProc 
(deftrap "_NewNSLClientNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeNSLMgrNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNSLMgrNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNSLClientNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNSLClientNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeNSLMgrNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNSLMgrNotifyProc 
(deftrap-inline "_InvokeNSLMgrNotifyUPP" 
      ((thePluginAsyncInfo (:pointer :nslpluginasyncinfo)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeNSLClientNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNSLClientNotifyProc 
(deftrap-inline "_InvokeNSLClientNotifyUPP" 
      ((theClientAsyncInfo (:pointer :nslclientasyncinfo)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;    this struct is a format for dealing with our internal data representation.  Typed data will be contiguous chunk of
;    memory, with the first 4 bytes being a data "descriptor".
; 

(def-mactype :nsltypeddataptr (find-mactype '(:pointer :nsltypeddata)))
(defrecord NSLTypedData 
   (dataType :unsigned-long)
   (lengthOfData :unsigned-long)
   )

; 
; 	   This is just a header at the beginning of a handle that stores our list of service types.
; 	   Each service type is a pascal string, so each service type starts after the end of the
; 	   previous one.
; 	
(def-mactype :nslserviceslistheaderptr (find-mactype '(:pointer :nslserviceslistheader)))
(defrecord NSLServicesListHeader 
   (numServices :unsigned-long)
   (logicalLen :unsigned-long)                  ;   length of all usable data in handle 
   )

;   some defs for common protocols 
; 
; 	   general information from a plug-in.  Includes supported protocols, data types and services,
; 	   as well as an info/comment string describing the function of the plug-in in human-readable
; 	   form.  The offsets point to the beginning of each list of data returned, and the protocol
; 	   data offset is the startOfData member of the struct
; 	
(def-mactype :nslplugindataptr (find-mactype '(:pointer :nslplugindata)))
(defrecord NSLPluginData 
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   (reserved3 :signed-long)
   (supportsRegistration :boolean)
   (isPurgeable :boolean)
   (totalLen :unsigned-integer)                 ;   length of everything, including header 
   (dataTypeOffset :unsigned-integer)
   (serviceListOffset :unsigned-integer)
   (protocolListOffset :unsigned-integer)
   (commentStringOffset :unsigned-integer)
;   protocol data is first on the list 
   )

; 
; 	  -----------------------------------------------------------------------------
; 	    Finding out if the library is present and getting its version
; 	  -----------------------------------------------------------------------------
; 	

; 
; 	 *  NSLLibraryVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;     NSLLibraryPresent() is a macro available only in C/C++.  
;                                               ; 
;   -----------------------------------------------------------------------------
;     High level API calls: the following two calls are ALL an application needs
;     to register/deregister its service.
;     If you use these, you don't need to make any of the other calls to NSLAPI 
;     (including NSLOpenNavigationAPI) 
;   -----------------------------------------------------------------------------
;                                               ;  <--- error code from registration ;  ---> urlToRegister is a null terminated url that has only legal characters defined for URLs.  Use HexEncodeText to encode;           portions of the url that have illegal characters ;  ---> neighborhoodToRegisterIn is an optional parameter for explicitly defining a neighborhood to register in.
;             If parameter is NULL, then the plugins will determine where to register the service ; 
;  *  NSLStandardRegisterURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLLibraryVersion" 
      () 
  :unsigned-long
   () )                                         ;  <--- error code from registration ;  ---> urlToRegister is a null terminated url that has only legal characters defined for URLs.  Use HexEncodeText to encode;           portions of the url that have illegal characters ;  ---> neighborhoodToDeregisterIn is an optional parameter for explicitly defining a neighborhood to register in.
;             If parameter is NULL, then the plugins will determine where to register the service ; 
;  *  NSLStandardDeregisterURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLStandardRegisterURL" 
      ((urlToRegister (:pointer :character)) (neighborhoodToRegisterIn (:pointer :unsigned-byte))) 
  :nslerror
   () )                                         ;  ----------------------------------------------------------------------------- ; 
;  *  NSLHexEncodeText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLStandardDeregisterURL" 
      ((urlToDeregister (:pointer :character)) (neighborhoodToDeregisterIn (:pointer :unsigned-byte))) 
  :nslerror
   () )                                         ; 
;  *  NSLHexDecodeText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLHexEncodeText" 
      ((rawText :pointer) (rawTextLen :unsigned-integer) (newTextBuffer :pointer) (newTextBufferLen (:pointer :unsigned-integer)) (textChanged (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;   -----------------------------------------------------------------------------
;     Basic API Utility calls: sufficient to create, and parse data structures
;   -----------------------------------------------------------------------------
;                                               ; 
;  *  NSLMakeNewServicesList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLHexDecodeText" 
      ((encodedText :pointer) (encodedTextLen :unsigned-integer) (decodedTextBuffer :pointer) (decodedTextBufferLen (:pointer :unsigned-integer)) (textChanged (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  NSLAddServiceToServicesList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLMakeNewServicesList" 
      ((initialServiceList :pointer)) 
  :handle
   () )                                         ; 
;  *  NSLDisposeServicesList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLAddServiceToServicesList" 
      ((serviceList :handle) (serviceType (:pointer :character))) 
  :nslerror
   () )                                         ; 
;     The name reflects the name of the Neighborhood, i.e. "apple.com." or "AppleTalk Zone One".
;     The protocolList is a comma delimited list of protocols that the Neighborhood might exist in.
;     If the user passes in NULL, then all protocols will be queried.  The result must be disposed
;     of by the user by calling NSLFreeNeighborhood.
;                                               ; 
;  *  NSLMakeNewNeighborhood()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLDisposeServicesList" 
      ((theList :handle)) 
  nil
   () )                                         ;  creates an exact copy of an existing neighborhood ; 
;  *  NSLCopyNeighborhood()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLMakeNewNeighborhood" 
      ((name :pointer) (protocolList :pointer)) 
  (:pointer :unsigned-byte)
   () )                                         ; 
;  *  NSLFreeNeighborhood()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLCopyNeighborhood" 
      ((neighborhood (:pointer :unsigned-byte))) 
  (:pointer :unsigned-byte)
   () )                                         ; 
;  *  NSLGetNameFromNeighborhood()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLFreeNeighborhood" 
      ((neighborhood (:pointer :unsigned-byte))) 
  (:pointer :unsigned-byte)
   () )                                         ; 
;    create a block of formatted data, pointed to by newDataPtr.  This will be used
;    in calls (typically request-related calls) for plug-ins that handle the NSL data type.
;                                               ; 
;  *  NSLMakeServicesRequestPB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetNameFromNeighborhood" 
      ((neighborhood (:pointer :unsigned-byte)) (name (:pointer :pointer)) (length (:pointer :signed-long))) 
  nil
   () )                                         ;   releases any storage created with MakeXXXPB calls, associated with TypedData. ; 
;  *  NSLFreeTypedDataPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLMakeServicesRequestPB" 
      ((serviceList :handle) (newDataPtr (:pointer (:pointer :nsltypeddata)))) 
  :osstatus
   () )                                         ; 
;    utility function that returns whether a url was found, a pointer to the beginning
;    of the url, and the length of the URL.
;                                               ; 
;  *  NSLGetNextUrl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLFreeTypedDataPtr" 
      ((nslTypeData (:pointer :nsltypeddata))) 
  (:pointer :nsltypeddata)
   () )                                         ; 
;    utility function that returns whether a Neighborhood was found, a pointer to the beginning
;    of the Neighborhood, and the length of the Neighborhood.
;                                               ; 
;  *  NSLGetNextNeighborhood()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetNextUrl" 
      ((infoPtr (:pointer :nslclientasyncinfo)) (urlPtr (:pointer :pointer)) (urlLength (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;    NSLErrorToString:    convert a numeric error code to its string equivalent.  Caller must
;                         have allocated sufficient space to store both strings.  (Max 255 chars each)
;                                 
;                         The errorString parameter will return a textual explanation of what is wrong,
;                         while the solutionString returns a possible solution to get around the problem
;                                               ; 
;  *  NSLErrorToString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetNextNeighborhood" 
      ((infoPtr (:pointer :nslclientasyncinfo)) (neighborhood (:pointer (:pointer :unsigned-byte))) (neighborhoodLength (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;   -----------------------------------------------------------------------------
;     Basic API calls: sufficient to create simple requests, and receive answers
;   -----------------------------------------------------------------------------
;                                               ; 
;  *  NSLOpenNavigationAPI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLErrorToString" 
      ((theErr :nslerror) (errorString :pointer) (solutionString :pointer)) 
  :osstatus
   () )                                         ; 
;  *  NSLCloseNavigationAPI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLOpenNavigationAPI" 
      ((newRef (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     NSLPrepareRequest:  creates an NSLRequestRef, sets up some internal data
;     notifier is an NSLClientNotifyUPP that will be called when data is available, when the lookup has
;     completed, or if an error occurs.  When the notifier is called, the cookie will be the NSLRequestRef.
;     If notifier is NULL, then the NSLManager will assume that the request is made synchronously.  This
;     should only be used while in a separate thread, so that the client app can still process events, etc.
;     
;     contextPtr is a void* which is passed as the contextPtr argument when the notifier is called.  
;     
;     upon exit:
;     1) ref will contain a pointer to a NSLRequestRef which must be passed to all other functions
;     which require a NSLRequestRef.
;     2) infoPtr will point to a newly created ClientAsycnInfoPtr which will be disposed by the manager when the search is completed
;     NOTE: Only one search can be running at a time per clientRef.
;                                               ; 
;  *  NSLPrepareRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLCloseNavigationAPI" 
      ((theClient :unsigned-long)) 
  nil
   () )                                         ; 
;    NSLStartNeighborhoodLookup: looking for neighborhoods associated with or neighboring a particular neighborhood
;     Passing in NULL for neighborhood will generate a list of a default neighborhood(s)
;    
;                                               ; 
;  *  NSLStartNeighborhoodLookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLPrepareRequest" 
      ((notifier :pointer) (contextPtr :pointer) (theClient :unsigned-long) (ref (:pointer :unsigned-long)) (bufPtr :pointer) (bufLen :unsigned-long) (infoPtr (:pointer (:pointer :nslclientasyncinfo)))) 
  :nslerror
   () )                                         ; 
;    NSLStartServicesLookup: starts looking for entities if the specified type in the specified neighborhood
;    
;                                               ; 
;  *  NSLStartServicesLookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLStartNeighborhoodLookup" 
      ((ref :unsigned-long) (neighborhood (:pointer :unsigned-byte)) (asyncInfo (:pointer :nslclientasyncinfo))) 
  :nslerror
   () )                                         ;   NSLContinueLookup:  continues a paused/outstanding lookup ; 
;  *  NSLContinueLookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLStartServicesLookup" 
      ((ref :unsigned-long) (neighborhood (:pointer :unsigned-byte)) (requestData (:pointer :nsltypeddata)) (asyncInfo (:pointer :nslclientasyncinfo))) 
  :nslerror
   () )                                         ;   NSLCancelRequest: cancels an ongoing search ; 
;  *  NSLCancelRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLContinueLookup" 
      ((asyncInfo (:pointer :nslclientasyncinfo))) 
  :nslerror
   () )                                         ; 
;    NSLDeleteRequest: deletes info associated with this ref.  The ClientAsyncInfoPtr will no longer be valid
;     This must be called when the client is no longer using this requestRef.
;                                               ; 
;  *  NSLDeleteRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLCancelRequest" 
      ((ref :unsigned-long)) 
  :nslerror
   () )                                         ; 
;   -----------------------------------------------------------------------------
;    Utility API calls: use these accessors to manipulate NSL's typed data
;   -----------------------------------------------------------------------------
;                                               ;   NSLParseServicesRequestPB provides the inverse of NSLMakeRequestPB, filling out the offsets found within newDataPtr ;  <--- returns an OSStatus if any errors occur parsing the data ;  <--- newDataPtr is the construct passed to the plugin ;  ---> serviceListPtr is the address of a pointer which will be set to point at the portion of the newDataPtr that holds the serviceList to be searched ;  ---> serviceListLen is the length of the serviceListPtr data pointed to by serviceListPtr ; 
;  *  NSLParseServicesRequestPB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLDeleteRequest" 
      ((ref :unsigned-long)) 
  :nslerror
   () )                                         ;  NSLParseServiceRegistrationPB provides for breaking apart a registration request from a client to a plugin ;  <--- returns an OSStatus if any errors occur parsing the data ;  <--- newDataPtr is the construct passed to the plugin ;  ---> neighborhoodPtr gets set to point at the portion of the newDataPtr that contains the neighborhood ;  ---> neighborhoodLen is the length of the neighborhood pointed to by neighborhoodPtr ;  ---> urlPtr is the address of a pointer which will be set to point at the portion of the newDataPtr that holds the url to be registered ;  ---> urlLen is the length of the url data pointed to by urlPtr ; 
;  *  NSLParseServiceRegistrationPB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLParseServicesRequestPB" 
      ((newDataPtr (:pointer :nsltypeddata)) (serviceListPtr (:pointer :pointer)) (serviceListLen (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ;  NSLGetErrorStringsFromResource is obsolete in X.  It will ignore the fileSpecPtr ;  and errorResID parameters and return the standard error strings. ;  NSLGetErrorStringsFromResource makes a basic assumption: ;  errorString and solutionString both point to valid memory of at least 256 bytes! ;  <--- returns an OSStatus if any errors occur ;  ---> theErr is an OSStatus to be matched against a resource list of errors ;  ---> fileSpecPtr is a FSSpecPtr to the resource containing the list of errors ;  ---> errorResID is the resourceID of the NSLI resource of the list of errors ;  <--> errorString is a pointer to valid memory of at least 256 bytes which will be filled out by the error portion of the error string ;  <--> solutionString is a pointer to valid memory of at least 256 bytes which will be filled out by the solution portion of the error string ; 
;  *  NSLGetErrorStringsFromResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLParseServiceRegistrationPB" 
      ((newDataPtr (:pointer :nsltypeddata)) (neighborhoodPtr (:pointer (:pointer :unsigned-byte))) (neighborhoodLen (:pointer :unsigned-integer)) (urlPtr (:pointer :pointer)) (urlLen (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; CONST;  <--- Returns true if given service is in the given service list ;  ---> serviceList is a valid NSLServicesList containing information about services to be searched ;  ---> svcToFind is an NSLServiceType of a particular service to check if it is in the serviceList ; 
;  *  NSLServiceIsInServiceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetErrorStringsFromResource" 
      ((theErr :signed-long) (fileSpecPtr (:pointer :fsspec)) (errorResID :signed-integer) (errorString :pointer) (solutionString :pointer)) 
  :osstatus
   () )                                         ;  <--- returns an OSStatus if any errors occur parsing the data ;  ---> svcString is the address of a pointer which will be set to point at the portion of theURL that holds the serviceType of theURL ;  ---> svcLen is the length of the serviceType pointed to by svcString ; 
;  *  NSLGetServiceFromURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLServiceIsInServiceList" 
      ((serviceList :handle) (svcToFind (:pointer :character))) 
  :boolean
   () )                                         ;  <--- returns the length of a Neighborhood data structure ;  ---> neighborhood is a valid NSLNeighborhood ; 
;  *  NSLGetNeighborhoodLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetServiceFromURL" 
      ((theURL :pointer) (svcString (:pointer :pointer)) (svcLen (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;   -------------------------------------------------------------------------------------
;    Utility API calls: use these routines to separate plugin threads from client threads
;   -------------------------------------------------------------------------------------
;                                               ;  this routine works the same as the Thread manager's routine NewThread, except ;  that the thread is added to the NSL manager's thread list. ; 
;  *  NSLNewThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetNeighborhoodLength" 
      ((neighborhood (:pointer :unsigned-byte))) 
  :signed-long
   () )                                         ;  this routine works the same as the Thread manager's routine DisposeThread, except ;  that the thread is removed from the NSL manager's thread list. ; 
;  *  NSLDisposeThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLNewThread" 
      ((ThreadStyle :unsigned-long) (threadEntry :pointer) (threadParam :pointer) (stackSize :signed-long) (options :unsigned-long) (threadResult (:pointer :pointer)) (threadMade (:pointer :unsigned-long))) 
  :signed-integer
   () )                                         ; $IFC OLDROUTINENAMES 
(deftrap-inline "_NSLDisposeThread" 
      ((threadToDump :unsigned-long) (threadResult :pointer) (recycleThread :boolean)) 
  :signed-integer
   () )
(%define-record :clientasyncinfo (find-record-descriptor :nslclientasyncinfo))
(def-mactype :clientasyncinfoptr (find-mactype '(:pointer :nslclientasyncinfo)))
(%define-record :pluginasyncinfo (find-record-descriptor :nslpluginasyncinfo))
(def-mactype :pluginasyncinfoptr (find-mactype '(:pointer :nslpluginasyncinfo)))
(%define-record :typeddata (find-record-descriptor :nsltypeddata))
(def-mactype :typeddataptr (find-mactype '(:pointer :nsltypeddata)))
(%define-record :plugindata (find-record-descriptor :nslplugindata))
(def-mactype :plugindataptr (find-mactype '(:pointer :nslplugindata)))
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NSLCoreIncludes

; $ENDC                                         ; __NSLCORE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'NSLCore)