(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Navigation.p"
; at Wednesday May 1,2002 2:41:07 pm.
; 
;      File:       Navigation.p
;  
;      Contains:   Navigation Services Interfaces
;  
;      Version:    Technology: Navigation 3.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __NAVIGATION__
; $SETC __NAVIGATION__ := 1

; $I+
; $SETC NavigationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TRANSLATION__
|#

(require-interface 'Translation)
#|                                              ; $I Translation.p
 |#                                             ; $ENDC
; $I+
#|                                              ; $IFC UNDEFINED __MACWINDOWS__
|#

(require-interface 'MacWindows)
#|                                              ; $I MacWindows.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFARRAY__
|#

(require-interface 'CFArray)
#|                                              ; $I CFArray.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :navasksavechangesaction (find-mactype ':unsigned-long))

;   input action codes for NavAskSaveChanges()  
(defconstant $kNavSaveChangesClosingDocument 1)
(defconstant $kNavSaveChangesQuittingApplication 2)
(defconstant $kNavSaveChangesOther 0)

(def-mactype :navasksavechangesresult (find-mactype ':unsigned-long))

;   result codes for NavAskSaveChanges()  
(defconstant $kNavAskSaveChangesSave 1)
(defconstant $kNavAskSaveChangesCancel 2)
(defconstant $kNavAskSaveChangesDontSave 3)

(def-mactype :navaskdiscardchangesresult (find-mactype ':unsigned-long))

;   result codes for NavAskDiscardChanges()  
(defconstant $kNavAskDiscardChanges 1)
(defconstant $kNavAskDiscardChangesCancel 2)

(def-mactype :navfiltermodes (find-mactype ':signed-integer))

;   which elements are being filtered for objects:  
(defconstant $kNavFilteringBrowserList 0)
(defconstant $kNavFilteringFavorites 1)
(defconstant $kNavFilteringRecents 2)
(defconstant $kNavFilteringShortCutVolumes 3)
(defconstant $kNavFilteringLocationPopup 4)     ;   for v1.1 or greater  

(defconstant $kNavFileOrFolderVersion 1)

(def-mactype :navfileorfolderinfoptr (find-mactype '(:pointer :navfileorfolderinfo)))
(defrecord NavFileOrFolderInfo 
   (version :unsigned-integer)
   (isFolder :boolean)
   (visible :boolean)
   (creationDate :unsigned-long)
   (modificationDate :unsigned-long)
   (:variant 
      (
      (locked :boolean)                         ;   file is locked  
      (resourceOpen :boolean)                   ;   resource fork is opened  
      (dataOpen :boolean)                       ;   data fork is opened  
      (reserved1 :boolean)
      (dataSize :unsigned-long)                 ;   size of the data fork  
      (resourceSize :unsigned-long)             ;   size of the resource fork  
      (finderInfo :finfo)                       ;   more file info:  
      (finderXInfo :fxinfo)
      )
      (
      (shareable :boolean)
      (sharePoint :boolean)
      (mounted :boolean)
      (readable :boolean)
      (writeable :boolean)
      (reserved2 :boolean)
      (numberOfFiles :unsigned-long)
      (finderDInfo :dinfo)
      (finderDXInfo :dxinfo)
      (folderType :ostype)                      ;   package type, For struct version >= 1  
      (folderCreator :ostype)                   ;   package creator, For struct version >= 1  
      (reserved3 (:array :character 206 :packed))
      )
      )
   )

(def-mactype :naveventdatainfoptr (find-mactype '(:pointer :naveventdatainfo)))
(defrecord NavEventDataInfo 
   (:variant 
      (
      (event (:pointer :eventrecord))           ;   for event processing  
      )
      (
      (param :pointer)                          ;   points to event specific data  
      )
      )
   )

(def-mactype :naveventdataptr (find-mactype '(:pointer :naveventdata)))
(defrecord NavEventData 
   (eventDataParms :naveventdatainfo)           ;   the event data  
   (itemHit :signed-integer)                    ;   the dialog item number, for v1.1 or greater  
   )

; 
; 	 *  NavDialogRef
; 	 *  
; 	 *  Summary:
; 	 *    Opaque Navigation Services dialog identifier
; 	 *  
; 	 *  Discussion:
; 	 *    A NavDialogRef is an opaque reference to an instance of a
; 	 *    Navigation Services dialog. A new NavDialogRef is returned from
; 	 *    any of the NavCreate*Dialog functions and is later disposed with
; 	 *    the NavDialogDispose function. NavDialogRef is the new name for
; 	 *    the NavContext type, and thus when a client's event proc is
; 	 *    called, the value of the NavCBRec.context field is the same as
; 	 *    the NavDialogRef returned from the corresponding
; 	 *    NavCreate*Dialog. A NavDialogRef is distinct from, and is not
; 	 *    interchangable with, a Dialog Manager DialogRef.
; 	 	
(def-mactype :navdialogref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :navdialogrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NavDialogRef parameter can be nil, it is changed to xx: NavDialogRefPtr 
; $IFC CALL_NOT_IN_CARBON 
; 	 NavContext is the old name for NavDialogRef 	
#|
; Warning: Patching def of type NavContext from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :navcontext (find-mactype :unsigned-long))
#| 
(def-mactype :navcontext (find-mactype ':pointer)) |#
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
; 	 *  NavUserAction
; 	 *  
; 	 *  Summary:
; 	 *    Indicates an action taken by the user
; 	 *  
; 	 *  Discussion:
; 	 *    When the user clicks a button at the bottom of a Nav Services
; 	 *    dialog (or makes an equivalent mouse or key gesture), a
; 	 *    kNavCBUserAction event is sent to the client's event proc
; 	 *    indicating which action was taken. Often, the action also
; 	 *    dismisses the dialog. User action events are only generated when
; 	 *    using dialogs created from a NavCreate*Dialog function. In the
; 	 *    special case of a modeless GetFile dialog (supported only on Mac
; 	 *    OS X), the user can option-click on the open button to keep the
; 	 *    dialog from being dismissed, but the kNavCBUserAction event is
; 	 *    sent so the client can get the reply record and open the selected
; 	 *    files.
; 	 	
(def-mactype :navuseraction (find-mactype ':unsigned-long))

(defconstant $kNavUserActionNone 0)
(defconstant $kNavUserActionCancel 1)
(defconstant $kNavUserActionOpen 2)
(defconstant $kNavUserActionSaveAs 3)
(defconstant $kNavUserActionChoose 4)
(defconstant $kNavUserActionNewFolder 5)
(defconstant $kNavUserActionSaveChanges 6)
(defconstant $kNavUserActionDontSaveChanges 7)
(defconstant $kNavUserActionDiscardChanges 8)
(defconstant $kNavUserActionReviewDocuments 9)
(defconstant $kNavUserActionDiscardDocuments 10)

(defconstant $kNavCBRecVersion 1)

; 
; 	 *  NavCBRec
; 	 *  
; 	 *  Summary:
; 	 *    A structure passed to event and preview callbacks
; 	 *  
; 	 *  Discussion:
; 	 *    The NavCBRec structure is passed to the client's event proc or
; 	 *    custom preview proc. It provides information that is specific to
; 	 *    each event type. New for Carbon: the userAction field.
; 	 	

(def-mactype :navcbrecptr (find-mactype '(:pointer :navcbrec)))
(defrecord NavCBRec 
   (version :unsigned-integer)
   (context :pointer)
   (window (:pointer :windowrecord))
   (customRect :rect)
   (previewRect :rect)
   (eventData :naveventdata)
   (userAction :unsigned-long)
   (reserved (:array :character 218 :packed))
   )

; 
; 	 *  NavEventCallbackMessage
; 	 *  
; 	 *  Summary:
; 	 *    Identifies the message type being sent to the client's event proc
; 	 	
(def-mactype :naveventcallbackmessage (find-mactype ':signed-long))

(defconstant $kNavCBEvent 0)
(defconstant $kNavCBCustomize 1)
(defconstant $kNavCBStart 2)
(defconstant $kNavCBTerminate 3)
(defconstant $kNavCBAdjustRect 4)
(defconstant $kNavCBNewLocation 5)
(defconstant $kNavCBShowDesktop 6)
(defconstant $kNavCBSelectEntry 7)
(defconstant $kNavCBPopupMenuSelect 8)
(defconstant $kNavCBAccept 9)
(defconstant $kNavCBCancel 10)
(defconstant $kNavCBAdjustPreview 11)
(defconstant $kNavCBUserAction 12)
(defconstant $kNavCBOpenSelection #x80000000)

#|
; Warning: Patching def of type NavCallBackUserData from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :navcallbackuserdata (find-mactype :unsigned-long))
#| 
(def-mactype :navcallbackuserdata (find-mactype ':pointer)) |#
; 	 for events and customization: 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NavEventProcPtr = PROCEDURE(callBackSelector: NavEventCallbackMessage; callBackParms: NavCBRecPtr; callBackUD: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :naveventprocptr (find-mactype ':pointer))
; $ENDC

; 	 for preview support: 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NavPreviewProcPtr = FUNCTION(callBackParms: NavCBRecPtr; callBackUD: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :navpreviewprocptr (find-mactype ':pointer))
; $ENDC

; 	 filtering callback information: 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NavObjectFilterProcPtr = FUNCTION(VAR theItem: AEDesc; info: UNIV Ptr; callBackUD: UNIV Ptr; filterMode: NavFilterModes): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :navobjectfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :naveventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :naveventupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :navpreviewupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :navpreviewupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :navobjectfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :navobjectfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppNavEventProcInfo #xFC0)
(defconstant $uppNavPreviewProcInfo #x3D0)
(defconstant $uppNavObjectFilterProcInfo #x2FD0)
; 
; 	 *  NewNavEventUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewNavEventProc 
(deftrap "_NewNavEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNavPreviewUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewNavPreviewProc 
(deftrap "_NewNavPreviewUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNavObjectFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewNavObjectFilterProc 
(deftrap "_NewNavObjectFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeNavEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNavEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNavPreviewUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNavPreviewUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNavObjectFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNavObjectFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeNavEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNavEventProc 
(deftrap-inline "_InvokeNavEventUPP" 
      ((callBackSelector :signed-long) (callBackParms (:pointer :navcbrec)) (callBackUD :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeNavPreviewUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNavPreviewProc 
(deftrap-inline "_InvokeNavPreviewUPP" 
      ((callBackParms (:pointer :navcbrec)) (callBackUD :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeNavObjectFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNavObjectFilterProc 
(deftrap-inline "_InvokeNavObjectFilterUPP" 
      ((theItem (:pointer :aedesc)) (info :pointer) (callBackUD :pointer) (filterMode :signed-integer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

(def-mactype :navcustomcontrolmessage (find-mactype ':signed-long))

(defconstant $kNavCtlShowDesktop 0)             ;      show desktop,           parms = nil  
(defconstant $kNavCtlSortBy 1)                  ;      sort key field,       parms->NavSortKeyField  
(defconstant $kNavCtlSortOrder 2)               ;      sort order,              parms->NavSortOrder  
(defconstant $kNavCtlScrollHome 3)              ;      scroll list home,       parms = nil  
(defconstant $kNavCtlScrollEnd 4)               ;      scroll list end,      parms = nil  
(defconstant $kNavCtlPageUp 5)                  ;      page list up,          parms = nil  
(defconstant $kNavCtlPageDown 6)                ;      page list down,          parms = nil  
(defconstant $kNavCtlGetLocation 7)             ;      get current location,   parms<-AEDesc*  
(defconstant $kNavCtlSetLocation 8)             ;      set current location,   parms->AEDesc*  
(defconstant $kNavCtlGetSelection 9)            ;      get current selection,     parms<-AEDescList*  
(defconstant $kNavCtlSetSelection 10)           ;      set current selection,     parms->AEDescList*  
(defconstant $kNavCtlShowSelection 11)          ;      make selection visible,       parms = nil  
(defconstant $kNavCtlOpenSelection 12)          ;      open view of selection,       parms = nil  
(defconstant $kNavCtlEjectVolume 13)            ;      eject volume,          parms->vRefNum  
(defconstant $kNavCtlNewFolder 14)              ;      create a new folder,     parms->StringPtr  
(defconstant $kNavCtlCancel 15)                 ;      cancel dialog,          parms = nil  
(defconstant $kNavCtlAccept 16)                 ;      accept dialog default,     parms = nil  
(defconstant $kNavCtlIsPreviewShowing 17)       ;      query preview status,   parms<-Boolean  
(defconstant $kNavCtlAddControl 18)             ;    add one control to dialog,    parms->ControlHandle  
(defconstant $kNavCtlAddControlList 19)         ;      add control list to dialog,    parms->Handle (DITL rsrc)  
(defconstant $kNavCtlGetFirstControlID 20)      ;      get 1st control ID,         parms<-UInt16  
(defconstant $kNavCtlSelectCustomType 21)       ;      select a custom menu item  parms->NavMenuItemSpec*  
(defconstant $kNavCtlSelectAllType 22)          ;    select an "All" menu item parms->SInt16  
(defconstant $kNavCtlGetEditFileName 23)        ;      get save dlog's file name  parms<-StringPtr  
(defconstant $kNavCtlSetEditFileName 24)        ;      set save dlog's file name  parms->StringPtr  
(defconstant $kNavCtlSelectEditFileName 25)     ;      select save dlog file name parms->ControlEditTextSelectionRec*, v1.1 or greater  
(defconstant $kNavCtlBrowserSelectAll 26)       ;    re-scan the browser list  parms = nil, v2.0 or greater  
(defconstant $kNavCtlGotoParent 27)             ;    navigate to parent         parms = nil, v2.0 or greater  
(defconstant $kNavCtlSetActionState 28)         ;    restrict navigation      parms->NavActionState (flags), v2.0 or greater  
(defconstant $kNavCtlBrowserRedraw 29)          ;    rescan browser list      parms = nil, v2.0 or greater  
(defconstant $kNavCtlTerminate 30)              ;    terminate/dismiss dialog  parms = nil, v2.0 or greater  

(def-mactype :navactionstate (find-mactype ':unsigned-long))

(defconstant $kNavNormalState #x0)              ;   normal/default state  
(defconstant $kNavDontOpenState #x1)            ;   disallow opening files/folders  
(defconstant $kNavDontSaveState #x2)            ;   disallow saving files  
(defconstant $kNavDontChooseState #x4)          ;   disallow choosing objects  
(defconstant $kNavDontNewFolderState #x10)      ;   disallow creating new folders  

(def-mactype :navpopupmenuitem (find-mactype ':unsigned-integer))

(defconstant $kNavAllKnownFiles 0)
(defconstant $kNavAllReadableFiles 1)
(defconstant $kNavAllFiles 2)

(def-mactype :navsortkeyfield (find-mactype ':unsigned-integer))

(defconstant $kNavSortNameField 0)
(defconstant $kNavSortDateField 1)

(def-mactype :navsortorder (find-mactype ':unsigned-integer))

(defconstant $kNavSortAscending 0)
(defconstant $kNavSortDescending 1)

(def-mactype :navdialogoptionflags (find-mactype ':unsigned-long))

(defconstant $kNavDefaultNavDlogOptions #xE4)   ;   use defaults for all the options  
(defconstant $kNavNoTypePopup #x1)              ;   don't show file type/extension popup on Open/Save  
(defconstant $kNavDontAutoTranslate #x2)        ;   don't automatically translate on Open  
(defconstant $kNavDontAddTranslateItems #x4)    ;   don't add translation choices on Open/Save  
(defconstant $kNavAllFilesInPopup #x10)         ;   "All Files" menu item in the type popup on Open  
(defconstant $kNavAllowStationery #x20)         ;   allow saving of stationery files  
(defconstant $kNavAllowPreviews #x40)           ;   allow preview to show  
(defconstant $kNavAllowMultipleFiles #x80)      ;   allow multiple items to be selected  
(defconstant $kNavAllowInvisibleFiles #x100)    ;   allow invisible items to be shown  
(defconstant $kNavDontResolveAliases #x200)     ;   don't resolve aliases  
(defconstant $kNavSelectDefaultLocation #x400)  ;   make the default location the browser selection  
(defconstant $kNavSelectAllReadableItem #x800)  ;   make the dialog select "All Readable Documents" on open  
(defconstant $kNavSupportPackages #x1000)       ;   recognize file system packages, v2.0 or greater  
(defconstant $kNavAllowOpenPackages #x2000)     ;   allow opening of packages, v2.0 or greater  
(defconstant $kNavDontAddRecents #x4000)        ;   don't add chosen objects to the recents list, v2.0 or greater  
(defconstant $kNavDontUseCustomFrame #x8000)    ;   don't draw the custom area bevel frame, v2.0 or greater  
(defconstant $kNavDontConfirmReplacement #x10000);   don't show the "Replace File?" alert on save conflict, v3.0 or greater  
(defconstant $kNavPreserveSaveFileExtension #x20000);   extension in default file name is preserved and initially hidden, v3.1 or greater  

(def-mactype :navtranslationoptions (find-mactype ':unsigned-long))

(defconstant $kNavTranslateInPlace 0)           ;      translate in place, replacing translation source file (default for Save)  
(defconstant $kNavTranslateCopy 1)              ;      translate to a copy of the source file (default for Open)  

(defconstant $kNavMenuItemSpecVersion 0)

(def-mactype :navmenuitemspecptr (find-mactype '(:pointer :navmenuitemspec)))
(defrecord NavMenuItemSpec 
   (version :unsigned-integer)
   (menuCreator :ostype)
   (menuType :ostype)
   (menuItemName (:string 255))
   (reserved (:array :character 245 :packed))
   )

(defrecord NavMenuItemSpecArray (array (:array :navmenuitemspec 1)))
(def-mactype :navmenuitemspecarrayptr (find-mactype '(:pointer :navmenuitemspecarray)))
(def-mactype :navmenuitemspecarrayhandle (find-mactype '(:handle :navmenuitemspecarray)))
(def-mactype :navmenuitemspechandle (find-mactype '(:handle :navmenuitemspecarray)))

(defconstant $kNavGenericSignature :|****|)

(def-mactype :navtypelistptr (find-mactype '(:pointer :navtypelist)))
(defrecord NavTypeList 
   (componentSignature :ostype)
   (reserved :signed-integer)
   (osTypeCount :signed-integer)
   (OSType (:array :ostype 1))
   )

(def-mactype :navtypelisthandle (find-mactype '(:handle :navtypelist)))

(defconstant $kNavDialogOptionsVersion 0)

(def-mactype :navdialogoptionsptr (find-mactype '(:pointer :navdialogoptions)))
(defrecord NavDialogOptions 
   (version :unsigned-integer)
   (dialogOptionFlags :unsigned-long)           ;   option flags for affecting the dialog's behavior  
   (location :point)                            ;   top-left location of the dialog, or (-1,-1) for default position  
   (clientName (:string 255))
   (windowTitle (:string 255))
   (actionButtonLabel (:string 255))            ;   label of the default button (or null string for default)  
   (cancelButtonLabel (:string 255))            ;   label of the cancel button (or null string for default)  
   (savedFileName (:string 255))                ;   default name for text box in NavPutFile (or null string for default)  
   (message (:string 255))                      ;   custom message prompt (or null string for default)  
   (preferenceKey :unsigned-long)               ;   a key for to managing preferences for using multiple utility dialogs  
   (popupExtension (:handle :navmenuitemspecarray));   extended popup menu items, an array of NavMenuItemSpecs  
   (reserved (:array :character 494 :packed))
   )

(defconstant $kNavReplyRecordVersion 2)

; 
; 	 *  NavReplyRecord
; 	 *  
; 	 *  Summary:
; 	 *    A structure describing the results of a Nav Services dialog
; 	 *  
; 	 *  Discussion:
; 	 *    A reply record is the result of a Nav Services file dialog. Using
; 	 *    the older API, which is always modal, the client passes the
; 	 *    address of a reply record when invoking the dialog. In the Carbon
; 	 *    API, dialogs may also be window modal or modeless, so the client
; 	 *    requests the reply record by calling NavDialogGetReply when a
; 	 *    kNavCBUserAction event is received. Either way, a reply record
; 	 *    should be disposed of using NavDisposeReply.
; 	 	

(def-mactype :navreplyrecordptr (find-mactype '(:pointer :navreplyrecord)))
(defrecord NavReplyRecord 
   (version :unsigned-integer)
   (validRecord :boolean)
   (replacing :boolean)
   (isStationery :boolean)
   (translationNeeded :boolean)
   (selection :aedesc)
   (keyScript :signed-integer)
   (fileTranslation (:handle :filetranslationspecarray))
   (reserved1 :unsigned-long)
   (saveFileName :pointer)
   (saveFileExtensionHidden :boolean)
   (reserved2 :signed-byte)
   (reserved (:array :character 225 :packed))
   )

; 
; 	 *  NavLoad()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NavigationLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  NavUnload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NavLoad" 
      () 
  :signed-integer
   () )                                         ; 
;  *  NavLibraryVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavUnload" 
      () 
  :signed-integer
   () )                                         ; 
;  *  NavGetDefaultDialogOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavLibraryVersion" 
      () 
  :unsigned-long
   () )                                         ; 
;  *  NavGetFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavGetDefaultDialogOptions" 
      ((dialogOptions (:pointer :navdialogoptions))) 
  :signed-integer
   () )                                         ; 
;  *  NavPutFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavGetFile" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (previewProc :pointer) (filterProc :pointer) (typeList (:handle :navtypelist)) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavAskSaveChanges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:navigation.patch
#|(deftrap-inline "_NavPutFile" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (fileType :ostype) (fileCreator :ostype) (callBackUD :pointer)) 
  :signed-integer
   () )|#

(deftrap-inline "_NavPutFile" 
      ((defaultLocation (:pointer :aedesc))
       (reply (:pointer :navreplyrecord)) 
       (dialogOptions (:pointer :navdialogoptions)) 
       (eventProc :pointer) (fileType :ostype) (fileCreator :ostype)
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavCustomAskSaveChanges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavAskSaveChanges" 
      ((dialogOptions (:pointer :navdialogoptions)) (action :unsigned-long) (reply (:pointer :unsigned-long)) (eventProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavAskDiscardChanges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavCustomAskSaveChanges" 
      ((dialogOptions (:pointer :navdialogoptions)) (reply (:pointer :unsigned-long)) (eventProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavChooseFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavAskDiscardChanges" 
      ((dialogOptions (:pointer :navdialogoptions)) (reply (:pointer :unsigned-long)) (eventProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavChooseFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:navigation.patch
#|(deftrap-inline "_NavChooseFile" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (previewProc :pointer) (filterProc :pointer) (typeList (:handle :navtypelist)) (callBackUD :pointer)) 
  :signed-integer
   () )|#

;; new interfaces have callbackud being :pointer - i dunno long works


(deftrap-inline "_NavChooseFile" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord))
       (dialogOptions (:pointer :navdialogoptions)) 
       (eventProc :pointer) (previewProc :pointer) 
       (filterProc :pointer) (typeList (:handle :navtypelist))
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavChooseVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:navigation.patch
#|(deftrap-inline "_NavChooseFolder" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (filterProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )|#

(deftrap-inline "_NavChooseFolder" 
      ((defaultLocation (:pointer :aedesc))
       (reply (:pointer :navreplyrecord))
       (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer) (filterProc :pointer)
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavChooseObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavChooseVolume" 
      ((defaultSelection (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (filterProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavNewFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavChooseObject" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (filterProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavTranslateFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavNewFolder" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (callBackUD :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavCompleteSave()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavTranslateFile" 
      ((reply (:pointer :navreplyrecord)) (howToTranslate :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavCustomControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavCompleteSave" 
      ((reply (:pointer :navreplyrecord)) (howToTranslate :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavCreatePreview()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavCustomControl" 
      ((dialog :pointer) (selector :signed-long) (parms :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  NavDisposeReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NavCreatePreview" 
      ((theObject (:pointer :aedesc)) (previewDataType :ostype) (previewData :pointer) (previewDataSize :signed-long)) 
  :signed-integer
   () )                                         ; 
;  *  NavServicesCanRun()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NavigationLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NavDisposeReply" 
      ((reply (:pointer :navreplyrecord))) 
  :signed-integer
   () )                                         ; $IFC TARGET_RT_MAC_CFM ; 
;         NavServicesAvailable() is a macro available only in C/C++.
;         To get the same functionality from pascal or assembly, you need
;         to test if NavigationLib functions are not NULL and call NavServicesCanRun()
;         which will test if NavServices is properly installed.  For instance:
; 
;             gNavServicesAvailable = FALSE;
;             IF @NavLibraryVersion <> kUnresolvedCFragSymbolAddress THEN
;                 gNavServicesAvailable = NavServicesCanRun;
;             END
; 
; 
#|                                              ; $ELSEC; $IFC TARGET_RT_MAC_MACHO ;  Navigation is always available on OS X ; $ELSEC;   NavServicesAvailable() is implemented in Navigation.o for classic 68K clients ; $IFC CALL_NOT_IN_CARBON ; 
;  *  NavServicesAvailable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NavServicesCanRun" 
      () 
  :boolean
   () )
(deftrap-inline "_NavServicesAvailable" 
      () 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC
 |#                                             ; $ENDC

;  Carbon API 
;  Includes support for Unicode and long file names (where available). 

(defconstant $kNavDialogCreationOptionsVersion 0)

; 
; 	 *  NavDialogCreationOptions
; 	 *  
; 	 *  Summary:
; 	 *    Options used to control the appearance and operation of a Nav
; 	 *    Services dialog
; 	 *  
; 	 *  Discussion:
; 	 *    NavDialogCreationOptions is a preferred replacement for
; 	 *    NavDialogOptions. The new structure uses CFStrings in place of
; 	 *    Pascal strings, and adds fields for setting the dialog modality
; 	 *    and the parent window (for sheet dialogs). A
; 	 *    NavDialogCreationOptions structure can be initialized using
; 	 *    NavDialogGetDefaultCreationOptions. Each of the NavCreate*Dialog
; 	 *    functions accepts a pointer to the client's
; 	 *    NavDialogCreationOptions structure.
; 	 	

(def-mactype :navdialogcreationoptionsptr (find-mactype '(:pointer :navdialogcreationoptions)))
(defrecord NavDialogCreationOptions 
   (version :unsigned-integer)
   (optionFlags :unsigned-long)
   (location :point)
   (clientName :pointer)
   (windowTitle :pointer)
   (actionButtonLabel :pointer)
   (cancelButtonLabel :pointer)
   (saveFileName :pointer)
   (message :pointer)
   (preferenceKey :unsigned-long)
   (popupExtension :pointer)
   (modality :unsigned-long)
   (parentWindow (:pointer :windowrecord))
   (reserved (:array :character 16 :packed))
   )

; 
; 	 *  NavGetDefaultDialogCreationOptions()
; 	 *  
; 	 *  Summary:
; 	 *    Initialize the input structure to default values
; 	 *  
; 	 *  Discussion:
; 	 *    Provided as a convenience to obtain the preferred default options
; 	 *    for use in creating any Nav Services dialog.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    outOptions:
; 	 *      A pointer to the client-allocated options structure to
; 	 *      initialize
; 	 *  
; 	 *  Result:
; 	 *    A status code
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_NavGetDefaultDialogCreationOptions" 
      ((outOptions (:pointer :navdialogcreationoptions))) 
  :osstatus
   () )

; 
;  *  NavCreateGetFileDialog()
;  *  
;  *  Summary:
;  *    Create a GetFile dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for opening
;  *    document files. This function replaces NavGetFile, allowing new
;  *    window modalities, and adding Unicode support. Upon successful
;  *    creation, the dialog is not visible. Present and run the dialog
;  *    with NavDialogRun. After the dialog is complete, dispose of it
;  *    with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inTypeList:
;  *      A creator signature and list of file types to show in the
;  *      dialog file browser. If NULL, show all files.
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inPreviewProc:
;  *      The UPP for the client's custom file preview callback, or NULL
;  *      for standard previews
;  *    
;  *    inFilterProc:
;  *      The UPP for the client's custom filter callback, or NULL for no
;  *      custom file filtering
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateGetFileDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inTypeList (:handle :navtypelist)) (inEventProc :pointer) (inPreviewProc :pointer) (inFilterProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreatePutFileDialog()
;  *  
;  *  Summary:
;  *    Create a PutFile dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for setting the
;  *    name and location of a document file prior to saving. This
;  *    function replaces NavPutFile, allowing new window modalities, and
;  *    adding Unicode support. Upon successful creation, the dialog is
;  *    not visible. Present and run the dialog with NavDialogRun. After
;  *    the dialog is complete, dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inFileType:
;  *      The type of the file to be saved. This parameter is used in
;  *      conjunction with the inFileCreator parameter to look up the
;  *      kind string for the Format popup menu, and to drive the
;  *      identification of translation options.
;  *    
;  *    inFileCreator:
;  *      The creator signature of the file to be saved (see inFileType
;  *      parameter)
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreatePutFileDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inFileType :ostype) (inFileCreator :ostype) (inEventProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateAskReviewDocumentsDialog()
;  *  
;  *  Summary:
;  *    Create an AskReviewDocumentsDialog dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog which tells the user how
;  *    many unsaved documents there are, and asks the user to start
;  *    reviewing the documents, don't save any documents, or cancel.
;  *    This dialog is appropriate to use when an application is quitting
;  *    and there is more than one unsaved document. It is supported only
;  *    on Mac OS X because the HI guidelines for earlier versions of Mac
;  *    OS do not include this dialog as part of the application quit
;  *    sequence. Upon successful creation, the dialog is not visible.
;  *    Present and run the dialog with NavDialogRun. After the dialog is
;  *    complete, dispose of it with NavDialogDispose. Upon dismissal of
;  *    the dialog, this dialog's user action will be set to one of the
;  *    following: kNavUserActionReviewDocuments,
;  *    kNavUserActionDiscardDocuments, or kNavUserActionCancel.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inDocumentCount:
;  *      Indicates the number of documents needing review. This number
;  *      appears in the text presented to the user. If for any reason
;  *      the total number of unsaved documents is unknown, specify 0,
;  *      and an ambiguous message will appear. Do not specifiy 1, since
;  *      the HI guidelines call for this alert only when there is more
;  *      than one document to be reviewed.
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap-inline "_NavCreateAskReviewDocumentsDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inDocumentCount :unsigned-long) (inEventProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateAskSaveChangesDialog()
;  *  
;  *  Summary:
;  *    Create an AskSaveChanges dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog which asks the user to save,
;  *    don't save or cancel closing a document with unsaved changes.
;  *    This function replaces NavAskSaveChanges and
;  *    NavCustomAskSaveChanges, allowing new window modalities, and
;  *    adding Unicode support. Upon successful creation, the dialog is
;  *    not visible. Present and run the dialog with NavDialogRun. After
;  *    the dialog is complete, dispose of it with NavDialogDispose. To
;  *    provide a customized message for the alert, specify an non-NULL
;  *    message value in the options structure.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inAction:
;  *      Indicates this usage context for this dialog: closing a
;  *      document or quitting an application. This setting affects the
;  *      message text displayed to the user.
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_NavCreateAskSaveChangesDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inAction :unsigned-long) (inEventProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateAskDiscardChangesDialog()
;  *  
;  *  Summary:
;  *    Create an AskDiscardChanges dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog which asks the user to
;  *    discard changes to a document or cancel. This is most often use
;  *    when the user wants to revert a a document to the last saved
;  *    revision. This function replaces NavAskDiscardChanges, allowing
;  *    new window modalities, and adding Unicode support. Upon
;  *    successful creation, the dialog is not visible. Present and run
;  *    the dialog with NavDialogRun. After the dialog is complete,
;  *    dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_NavCreateAskDiscardChangesDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inEventProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateChooseFileDialog()
;  *  
;  *  Summary:
;  *    Create a ChooseFile dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for selecting one
;  *    file as the target of an operation. A ChooseFile dialog is a
;  *    simple version a GetFile dialog. This function replaces
;  *    NavChooseFile, allowing new window modalities, and adding Unicode
;  *    support. Upon successful creation, the dialog is not visible.
;  *    Present and run the dialog with NavDialogRun. After the dialog is
;  *    complete, dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inTypeList:
;  *      A creator signature and list of file types to show in the
;  *      dialog file browser. If NULL, show all files.
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inPreviewProc:
;  *      The UPP for the client's custom file preview callback, or NULL
;  *      for standard previews
;  *    
;  *    inFilterProc:
;  *      The UPP for the client's custom filter callback, or NULL for no
;  *      custom file filtering
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateChooseFileDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inTypeList (:handle :navtypelist)) (inEventProc :pointer) (inPreviewProc :pointer) (inFilterProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateChooseFolderDialog()
;  *  
;  *  Summary:
;  *    Create a ChooseFolder dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for selecting a
;  *    folder as the target of an operation. This function replaces
;  *    NavChooseFolder, allowing new window modalities, and adding
;  *    Unicode support. Upon successful creation, the dialog is not
;  *    visible. Present and run the dialog with NavDialogRun. After the
;  *    dialog is complete, dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inFilterProc:
;  *      The UPP for the client's custom filter callback, or NULL for no
;  *      custom file filtering
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateChooseFolderDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inEventProc :pointer) (inFilterProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateChooseVolumeDialog()
;  *  
;  *  Summary:
;  *    Create a ChooseVolume dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for selecting a
;  *    volume as the target of an operation. This function replaces
;  *    NavChooseVolume, allowing new window modalities, and adding
;  *    Unicode support. Upon successful creation, the dialog is not
;  *    visible. Present and run the dialog with NavDialogRun. After the
;  *    dialog is complete, dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inFilterProc:
;  *      The UPP for the client's custom filter callback, or NULL for no
;  *      custom file filtering
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateChooseVolumeDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inEventProc :pointer) (inFilterProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateChooseObjectDialog()
;  *  
;  *  Summary:
;  *    Create a ChooseObject dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for selecting a
;  *    file, folder, or volume as the target of an operation. This
;  *    function replaces NavChooseObject, allowing new window
;  *    modalities, and adding Unicode support. Upon successful creation,
;  *    the dialog is not visible. Present and run the dialog with
;  *    NavDialogRun. After the dialog is complete, dispose of it with
;  *    NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inPreviewProc:
;  *      The UPP for the client's custom file preview callback, or NULL
;  *      for standard previews
;  *    
;  *    inFilterProc:
;  *      The UPP for the client's custom filter callback, or NULL for no
;  *      custom file filtering
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateChooseObjectDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inEventProc :pointer) (inPreviewProc :pointer) (inFilterProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavCreateNewFolderDialog()
;  *  
;  *  Summary:
;  *    Create a NewFolder dialog
;  *  
;  *  Discussion:
;  *    Use this function to create a dialog designed for creating a new
;  *    folder. Nav Services creates the folder as specified by the user
;  *    and returns a reference to the folder in the selection field of
;  *    the reply record. This function replaces NavNewFolder, allowing
;  *    new window modalities, and adding Unicode support. Upon
;  *    successful creation, the dialog is not visible. Present and run
;  *    the dialog with NavDialogRun. After the dialog is complete,
;  *    dispose of it with NavDialogDispose.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Options controlling the appearance and behavior of the dialog
;  *    
;  *    inEventProc:
;  *      The UPP for the client's event callack, or NULL for no event
;  *      callback
;  *    
;  *    inClientData:
;  *      A client-defined context value passed to all callback functions
;  *    
;  *    outDialog:
;  *      Upon successful completion, a reference to the created dialog
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_NavCreateNewFolderDialog" 
      ((inOptions (:pointer :navdialogcreationoptions)) (inEventProc :pointer) (inClientData :pointer) (outDialog (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NavDialogRun()
;  *  
;  *  Summary:
;  *    Show and run a Nav Services dialog
;  *  
;  *  Discussion:
;  *    After a dialog is created with a NavCreate*Dialog function, the
;  *    client can modify the dialog target folder or save file name
;  *    using NavCustomControl with the appropriate selectors. The dialog
;  *    is presented to the user by calling NavDialogRun. If the dialog
;  *    is system modal or application modal (kWindowModalitySystemModal,
;  *    kWindowModalityAppModal), NavDialogRun does not return until the
;  *    dialog has been dismissed. If the dialog is modeless or window
;  *    modal (kWindowModalityNone, kWindowModalityWindowModal),
;  *    NavDialogRun shows the dialog and returns immediately. In order
;  *    to know when the dialog has been dismissed, the client must watch
;  *    for the kNavCBUserAction event sent to the client event proc.
;  *    Note that on Mac OS 9 and earlier, all dialogs are modal, even if
;  *    a modeless or window modal dialog is requested. However, the
;  *    kNavCBUserAction event is still sent to the event proc, so it's
;  *    possible to use a single programming model on OS 9 and OS X
;  *    provided the client assumes NavDialogRun returns immediately
;  *    after showing the dialog.
;  *  
;  *  Parameters:
;  *    
;  *    inDialog:
;  *      The dialog to run
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogRun" 
      ((inDialog :pointer)) 
  :osstatus
   () )

; 
;  *  NavDialogDispose()
;  *  
;  *  Summary:
;  *    Dispose of a Nav Services dialog
;  *  
;  *  Discussion:
;  *    Call this function when completely finished with a Nav Services
;  *    dialog. After calling NavDialogDispose, the dialog reference is
;  *    no longer valid. NavDialogDispose is safe to call from within a
;  *    callback to the client's Nav Services event proc.
;  *  
;  *  Parameters:
;  *    
;  *    inDialog:
;  *      The dialog to dispose
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogDispose" 
      ((inDialog :pointer)) 
  nil
   () )

; 
;  *  NavDialogGetWindow()
;  *  
;  *  Summary:
;  *    Return the window in which a Nav Services dialog appears
;  *  
;  *  Discussion:
;  *    Note that a valid NavDialogRef may not have a window until
;  *    NavDialogRun has been called. If no window exists for the dialog,
;  *    NavDialogGetWindow returns NULL.
;  *  
;  *  Parameters:
;  *    
;  *    inDialog:
;  *      Which dialog
;  *  
;  *  Result:
;  *    The window reference
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogGetWindow" 
      ((inDialog :pointer)) 
  (:pointer :windowrecord)
   () )

; 
;  *  NavDialogGetUserAction()
;  *  
;  *  Summary:
;  *    Return the current user action taken by the user
;  *  
;  *  Discussion:
;  *    A user action occurs when the user dismisses the dialog or
;  *    otherwise does something generating a reply record that the
;  *    client needs to act upon. If the user has not taken such an
;  *    action, NavDialogGetUserAction returns kNavUserActionNone. If the
;  *    dialog is terminated using the NavCustomControl selector
;  *    kNavCtlTerminate, the final user action is kNavUserActionNone.
;  *    For file dialogs, if the final user action is not
;  *    kNavUserActionCancel, then there is a valid reply record which
;  *    can be obtained with NavDialogGetReply. Although the user action
;  *    is sent to the client event proc as a kNavCBUserAction event,
;  *    this function is provided as a convenience for clients of modal
;  *    dialogs who may find it easier to get the user action immediately
;  *    after NavDialogRun returns.
;  *  
;  *  Parameters:
;  *    
;  *    inDialog:
;  *      Which dialog
;  *  
;  *  Result:
;  *    The user action
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogGetUserAction" 
      ((inDialog :pointer)) 
  :unsigned-long
   () )

; 
;  *  NavDialogGetReply()
;  *  
;  *  Summary:
;  *    Fill in the provided reply record with the results of a user
;  *    action such as kNavUserActionOpen, kNavUserActionSaveAs, or
;  *    kNavUserActionChoose.
;  *  
;  *  Discussion:
;  *    Call this function when a file dialog receives a user action
;  *    other that implies an item or items to open, save, etc. Upon
;  *    successful completion, the reply record describes the item(s)
;  *    that the client needs to act upon. The reply record should later
;  *    be disposed of with NavDisposeReply.
;  *  
;  *  Parameters:
;  *    
;  *    inDialog:
;  *      Which dialog
;  *    
;  *    outReply:
;  *      A pointer to the client-allocated reply record to be filled in
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogGetReply" 
      ((inDialog :pointer) (outReply (:pointer :navreplyrecord))) 
  :osstatus
   () )

; 
;  *  NavDialogGetSaveFileName()
;  *  
;  *  Summary:
;  *    Return the current value of the file name to be saved in a
;  *    PutFile dialog
;  *  
;  *  Discussion:
;  *    This function can be called at any time on a valid PutFile dialog
;  *    to obtain the current value of the save file name. This function
;  *    is a Unicode-based replacement for the kNavCtlGetEditFileName
;  *    NavCustomControl selector. On Mac OS X, the full file name is
;  *    returned, including any extenison that may be hidden from the
;  *    user.
;  *  
;  *  Parameters:
;  *    
;  *    inPutFileDialog:
;  *      Which dialog
;  *  
;  *  Result:
;  *    The save file name as a CFStringRef. The string is immutable. The
;  *    client should retain the string if the reference is to be held
;  *    beyond the life of the dialog (standard CF retain/release
;  *    semantics).
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogGetSaveFileName" 
      ((inPutFileDialog :pointer)) 
  :pointer
   () )

; 
;  *  NavDialogSetSaveFileName()
;  *  
;  *  Summary:
;  *    Set the current value of the file name to be saved in a PutFile
;  *    dialog
;  *  
;  *  Discussion:
;  *    This function can be called at any time to set the current save
;  *    file name. Use it to set an initial name before calling
;  *    NavDialogRun or to change the file name dynamically while a
;  *    dialog is running. This function is a Unicode-based replacement
;  *    for the kNavCtlSetEditFileName NavCustomControl selector.
;  *  
;  *  Parameters:
;  *    
;  *    inPutFileDialog:
;  *      Which PutFile dialog
;  *    
;  *    inFileName:
;  *      The file name to use
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NavDialogSetSaveFileName" 
      ((inPutFileDialog :pointer) (inFileName :pointer)) 
  :osstatus
   () )

; 
;  *  NavDialogGetSaveFileExtensionHidden()
;  *  
;  *  Summary:
;  *    Get the current state of the extension hiding in a PutFile dialog
;  *  
;  *  Discussion:
;  *    This function can be called at any time to determine if a PutFile
;  *    dialog is hiding the file extesion (if any) of the file to be
;  *    saved.
;  *  
;  *  Parameters:
;  *    
;  *    inPutFileDialog:
;  *      Which PutFile dialog
;  *  
;  *  Result:
;  *    True if the extension is hidden, false if the extension is
;  *    visible or there is no extension.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_NavDialogGetSaveFileExtensionHidden" 
      ((inPutFileDialog :pointer)) 
  :boolean
   () )

; 
;  *  NavDialogSetSaveFileExtensionHidden()
;  *  
;  *  Summary:
;  *    Set the current state of the extension hiding in a PutFile dialog
;  *  
;  *  Discussion:
;  *    This function can be called at any time to hide or show the
;  *    extension of the file to be saved in a PutFile dialog. If the
;  *    current file name has no extension, then hiding the extension has
;  *    no effect.
;  *  
;  *  Parameters:
;  *    
;  *    inPutFileDialog:
;  *      Which PutFile dialog
;  *    
;  *    inHidden:
;  *      The new value for the hidden extension state
;  *  
;  *  Result:
;  *    A status code
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_NavDialogSetSaveFileExtensionHidden" 
      ((inPutFileDialog :pointer) (inHidden :boolean)) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NavigationIncludes

; $ENDC                                         ; __NAVIGATION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Navigation)
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:navigation.patch;; some bozo thought this could be conditionalized out if not macho. I think he has his ass backwards.

(deftrap-inline "_NavServicesCanRun" 
      () 
  :boolean
   () )