(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:NetworkSetup.p"
; at Wednesday May 1,2002 2:42:10 pm.
; 
;      File:       NetworkSetup.p
;  
;      Contains:   Network Setup Interfaces
;  
;      Version:    Technology: 1.3.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __NETWORKSETUP__
; $SETC __NETWORKSETUP__ := 1

; $I+
; $SETC NetworkSetupIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(def-mactype :cfgdatabaseref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfgdatabaserefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CfgDatabaseRef parameter can be nil, it is changed to xx: CfgDatabaseRefPtr 

(defconstant $kInvalidCfgAreaID 0)

(def-mactype :cfgareaid (find-mactype ':unsigned-long))
(def-mactype :cfgentityclass (find-mactype ':ostype))
(def-mactype :cfgentitytype (find-mactype ':ostype))
(def-mactype :cfgentityrefptr (find-mactype '(:pointer :cfgentityref)))
(defrecord CfgEntityRef 
   (fLoc :unsigned-long)
   (fReserved :unsigned-long)
   (fID (:string 255))
   )

(def-mactype :cfgresourcelocatorptr (find-mactype '(:pointer :cfgresourcelocator)))
(defrecord CfgResourceLocator 
   (fFile :fsspec)
   (fResID :signed-integer)
   )

(def-mactype :cfgentityinfoptr (find-mactype '(:pointer :cfgentityinfo)))
(defrecord CfgEntityInfo 
   (fClass :ostype)
   (fType :ostype)
   (fName (:string 255))
   (fIcon :cfgresourcelocator)
   )

(def-mactype :cfgentityaccessid (find-mactype ':pointer))
(def-mactype :cfgprefsheaderptr (find-mactype '(:pointer :cfgprefsheader)))
(defrecord CfgPrefsHeader 
   (fSize :unsigned-integer)                    ;   size, in bytes, does not include this header  
   (fVersion :unsigned-integer)
   (fType :ostype)
   )

; 	    -------------------------------------------------------------------------
; 	    Error codes
; 	    ------------------------------------------------------------------------- 	

(defconstant $kCfgErrDatabaseChanged -3290)     ;   database has changed since last call - close and reopen DB 
(defconstant $kCfgErrAreaNotFound -3291)        ;   Area doesn't exist 
(defconstant $kCfgErrAreaAlreadyExists -3292)   ;   Area already exists 
(defconstant $kCfgErrAreaNotOpen -3293)         ;   Area needs to open first 
(defconstant $kCfgErrConfigLocked -3294)        ;   Access conflict - retry later 
(defconstant $kCfgErrEntityNotFound -3295)      ;   An entity with this name doesn't exist 
(defconstant $kCfgErrEntityAlreadyExists -3296) ;   An entity with this name already exists 
(defconstant $kCfgErrPrefsTypeNotFound -3297)   ;   A preference with this prefsType doesn't exist 
(defconstant $kCfgErrDataTruncated -3298)       ;   Data truncated when read buffer too small 
(defconstant $kCfgErrFileCorrupted -3299)       ;   The database format appears to be corrupted. 
(defconstant $kCfgErrFirst -3290)
(defconstant $kCfgErrLast -3299)

;    reserve a 'free' tag for free blocks 
(defconstant $kCfgFreePref :|free|)

; 	    -------------------------------------------------------------------------
; 	    CfgEntityClass / CfgEntityType
; 	
; 	    The database can distinguish between several classes of objects and 
; 	    several types withing each class
; 	    Use of different classes allow to store type of information in the same database
; 	
; 	    Other entity classes and types can be defined by developers.
; 	    they should be unique and registered with Developer Tech Support (DTS)
; 	    ------------------------------------------------------------------------- 	
(defconstant $kCfgClassAnyEntity :|****|)
(defconstant $kCfgClassUnknownEntity :|????|)
(defconstant $kCfgTypeAnyEntity :|****|)
(defconstant $kCfgTypeUnknownEntity :|????|)

; 	    -------------------------------------------------------------------------
; 	    For CfgIsSameEntityRef
; 	    ------------------------------------------------------------------------- 	
(defconstant $kCfgIgnoreArea #$true)
(defconstant $kCfgDontIgnoreArea #$false)

; 	******************************************************************************
; 	**  Configuration Information Access API 
; 	*******************************************************************************	
; 	    -------------------------------------------------------------------------
; 	    Database access
; 	    ------------------------------------------------------------------------- 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCfgOpenDatabase()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;     OTCfgOpenDatabase()
; 
;     Inputs:     none
;     Outputs:    CfgDatabaseRef* dbRef           Reference to opened database
;     Returns:    OSStatus                        *** list errors ***
; 
;     Opens Network Setup for a given client. This call should be made prior to any other call.
;                                               ; 
;  *  OTCfgCloseDatabase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgOpenDatabase" 
      ((dbRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     OTCfgCloseDatabase()
; 
;     Inputs:     CfgDatabaseRef* dbRef           Reference to opened database
;     Outputs:    CfgDatabaseRef* dbRef           Reference to opened database is cleared
;     Returns:    OSStatus                        *** list errors ***
; 
;     Closes Network Setup for a given client. This call should be made when the client no 
;     longer wants to use Network Setup.  
;                                               ;     -------------------------------------------------------------------------
;     Area management
;     ------------------------------------------------------------------------- ; 
;  *  OTCfgGetAreasCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgCloseDatabase" 
      ((dbRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetAreasCount()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;     Outputs:    ItemCount* itemCount            Number of entities defined
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns the number of areas currently defined.
;                                               ; 
;  *  OTCfgGetAreasList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetAreasCount" 
      ((dbRef :pointer) (ItemCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetAreasList()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 ItemCount* itemCount            Number of entities requested
;                 CfgAreaID areaID[]              Pointer to array of *itemCount area IDs
;                 Str255 areaName[]               Pointer to array of *itemCount area names
;     Outputs:    ItemCount* itemCount            Number of entities defined
;                 CfgAreaID areaID[]              Filled in array of area IDs
;                 Str255 areaName[]               Filled in array of area names
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns a list of area IDs and names. On entry, count should be set to whatever OTCfgGetAreasCount 
;     returned.  On exit, count contains the actual number of areas found. This can be less than the 
;     initial count value if areas were deleted in the meantime.  The id and name parameters are stored 
;     in arrays that should each be able to contain count values.
;                                               ; 
;  *  OTCfgGetCurrentArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetAreasList" 
      ((dbRef :pointer) (ItemCount (:pointer :unsigned-long)) (areaID :pointer) (areaName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetCurrentArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;     Outputs:    CfgAreaID* areaID               ID of current area
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns the id of the current area.
;                                               ; 
;  *  OTCfgSetCurrentArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetCurrentArea" 
      ((dbRef :pointer) (areaID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgSetCurrentArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to make active
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Sets the current area. If the area doesnt exist kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgCreateArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgSetCurrentArea" 
      ((dbRef :pointer) (areaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgCreateArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 ConstStr255Param areaName       Name of area to create
;     Outputs:    CfgAreaID* areaID               ID of newly created area
;     Returns:    OSStatus                        *** list errors ***
; 
;     Creates a new area with the specified name. Then name must be unique or kCfgErrAreaAlreadyExists 
;     will be returned.
;                                               ; 
;  *  OTCfgDeleteArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgCreateArea" 
      ((dbRef :pointer) (areaName (:string 255)) (areaID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgDeleteArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to delete
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Deletes the specified area. If the area doesnt exist kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgDuplicateArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgDeleteArea" 
      ((dbRef :pointer) (areaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgDuplicateArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID sourceAreaID          Area to duplicate
;                 CfgAreaID destAreaID            Area to contain duplicate
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Duplicates the source area content into the destination area. Both areas should exist prior to 
;     making this call. If either area doesnt exist kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgSetAreaName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgDuplicateArea" 
      ((dbRef :pointer) (sourceAreaID :unsigned-long) (destAreaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgSetAreaName()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area being named
;                 ConstStr255Param areaName       New name for area
;     Outputs:    CfgAreaID* newAreaID            ID of renamed area
;     Returns:    OSStatus                        *** list errors ***
; 
;     Renames the specified area. A new id is returned: it should be used from now on. If the area 
;     doesnt exist kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgGetAreaName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgSetAreaName" 
      ((dbRef :pointer) (areaID :unsigned-long) (areaName (:string 255)) (newAreaID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetAreaName()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area being queried
;     Outputs:    Str255 areaName                 Name of area
;     Returns:    OSStatus                        *** list errors ***
; 
;     Gets the name of the specified area. If the area doesnt exist kCfgErrAreaNotFound is returned.
;     
;     Requires Network Setup 1.0.1 or higher.
;                                               ;     -------------------------------------------------------------------------
;     Configuration Database API
;     
;     Single Writer ONLY!!!
;     ------------------------------------------------------------------------- ;     -------------------------------------------------------------------------
;     Opening an area for reading
;     ------------------------------------------------------------------------- ; 
;  *  OTCfgOpenArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetAreaName" 
      ((dbRef :pointer) (areaID :unsigned-long) (areaName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;     OTCfgOpenArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to open
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Opens the specified area for reading. If the area doesnt exist kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgCloseArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgOpenArea" 
      ((dbRef :pointer) (areaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgCloseArea()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to close
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Closes an area opened for reading. If the area doesnt exist kCfgErrAreaNotFound is returned.  
;                                               ; 
;     For write access
;                                               ; 
;  *  OTCfgBeginAreaModifications()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgCloseArea" 
      ((dbRef :pointer) (areaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgBeginAreaModifications()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID readAreaID            ID of area opened for reading
;     Outputs:    CfgAreaID* writeAreaID          ID of area opened for modification
;     Returns:    OSStatus                        *** list errors ***
; 
;     Opens the specified area for writing. A new area id is provided.  This area id should be used to 
;     enumerate, add, delete, read and write to the modified data. The original id can still be used to 
;     access the original unmodified data. If the area doesnt exist, kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgCommitAreaModifications()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgBeginAreaModifications" 
      ((dbRef :pointer) (readAreaID :unsigned-long) (writeAreaID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgCommitAreaModifications()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID readAreaID            ID of area opened for reading
;                 CfgAreaID writeAreaID           ID of area opened for modification
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Closes an area opened for writing.  All modifications are committed and readers are informed that 
;     the database changed state.  The readAreaID should be the ID of the original area passed to
;     OTCfgBeginAreaModifications.  The writeAreaID should be the ID returned by OTCfgBeginAreaModifications.
;     If either area doesnt exist or there is a mismatch between readAreaID and writeAreaID,
;     kCfgErrAreaNotFound is returned.
;                                               ; 
;  *  OTCfgAbortAreaModifications()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgCommitAreaModifications" 
      ((dbRef :pointer) (readAreaID :unsigned-long) (writeAreaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgAbortAreaModifications()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID readAreaID            ID of area opened for reading
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Closes an area opened for writing, discarding any modification. The areaID should be the id of 
;     the original area. If the area doesnt exist or the wrong id is passed kCfgErrAreaNotFound is 
;     returned.
;                                               ; 
;     Working with entities
; 
;     Entities can be manipulated as soon as an area has been opened.  The same calls work both for 
;     areas opened for reading or for modification. In the latter case, the calls can be used on the 
;     original or new area id to access the original data or the modified data.
;                                               ; 
;     For everybody
;     Count receives the actual number of entities
;                                               ; 
;  *  OTCfgGetEntitiesCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgAbortAreaModifications" 
      ((dbRef :pointer) (readAreaID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgGetEntitiesCount()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to count
;                 CfgEntityClass entityClass      Class of entities to count
;                 CfgEntityType entityType        Type of entities to count
;     Outputs:    ItemCount* itemCount            Count of matching entities
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns the number of entities of the specified class and type in the specified area. To obtain 
;     all entities regardless of their class or type pass kCfgClassAnyEntity or kCfgTypeAnyEntity. If 
;     the area doesnt exist, kCfgErrAreaNotFound is returned.
;                                               ; 
;     Count as input, is the number of entities to read;
;     count as output, receives the actual number of entities or the number you specified. 
;                                               ; 
;  *  OTCfgGetEntitiesList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetEntitiesCount" 
      ((dbRef :pointer) (areaID :unsigned-long) (entityClass :ostype) (entityType :ostype) (ItemCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetEntitiesList()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to list
;                 CfgEntityClass entityClass      Class of entities to list
;                 CfgEntityType entityType        Type of entities to list
;                 ItemCount* itemCount            Count of entities requested
;                 CfgEntityRef entityRef[]        Pointer to array of *itemCount entity refs
;                 CfgEntityInfo entityInfo[]      Pointer to array of *itemCount entity infos
;     Outputs:    ItemCount* itemCount            Count of entities listed
;                 CfgEntityRef entityRef[]        Filled in array of *itemCount entity refs
;                 CfgEntityInfo entityInfo[]      Filled in array of *itemCount entity infos
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns the list of entities of the specified class and type in the specified area. To obtain all 
;     entities regardless of their class or type pass kCfgClassAnyEntity or kCfgTypeAnyEntity. The 
;     count parameter should have the value obtained by CfgGetEntitiesCount.  On exit count may be less 
;     if some entities were deleted in the meantime. The id and info parameters should be arrays large 
;     enough to hold count entries. If the area doesnt exist, 
;     kCfgErrAreaNotFound is returned.  The info array contains information about each entity, 
;     including its class, type, name and the area of its icon:
; 
;     struct CfgEntityInfo
;     (
;         CfgEntityClass      fClass;
;         CfgEntityType       fType;
;         ConstStr255Param    fName;
;         CfgResourceLocator  fIcon;
;     );
;                                               ; 
;  *  OTCfgCreateEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetEntitiesList" 
      ((dbRef :pointer) (areaID :unsigned-long) (entityClass :ostype) (entityType :ostype) (ItemCount (:pointer :unsigned-long)) (entityRef (:pointer :cfgentityref)) (entityInfo (:pointer :cfgentityinfo))) 
  :osstatus
   () )                                         ; CONST; 
;     OTCfgCreateEntity()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgAreaID areaID                ID of area to contain entity
;                 CfgEntityInfo* entityInfo       Information that defines the entity
;     Outputs:    CfgEntityRef* entityRef         Reference to entity created
;     Returns:    OSStatus                        *** list errors ***
; 
;     Creates a new entity with the specified class, type and name and returns an id for it. If the 
;     area doesnt exist, kCfgErrAreaNotFound is returned. If there is already 
;     an entity with the same name kCfgErrEntityAlreadyExists is returned.
;                                               ; 
;  *  OTCfgDeleteEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgCreateEntity" 
      ((dbRef :pointer) (areaID :unsigned-long) (entityInfo (:pointer :cfgentityinfo)) (entityRef (:pointer :cfgentityref))) 
  :osstatus
   () )                                         ; CONST; 
;     OTCfgDeleteEntity()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityRef* entityRef         Reference to entity to delete
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Deletes the specified entity. If there is no entity with this id, kCfgEntityNotfoundErr is returned
;                                               ; 
;  *  OTCfgDuplicateEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgDeleteEntity" 
      ((dbRef :pointer) (entityRef (:pointer :cfgentityref))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;     OTCfgDuplicateEntity()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityRef* entityRef         Reference to entity to duplicate
;                 CfgEntityRef* newEntityRef      Reference to destination entity
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Copies the contents of entityRef into newEntityRef. Both entities must exit.
;     If either entity doesnt exist kCfgErrEntityNotFound is returned.
;                                               ; 
;  *  OTCfgSetEntityName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgDuplicateEntity" 
      ((dbRef :pointer) (entityRef (:pointer :cfgentityref)) (newEntityRef (:pointer :cfgentityref))) 
  :osstatus
   () )                                         ; CONST; 
;     OTCfgSetEntityName()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityRef* entityRef         Reference to entity to rename
;                 ConstStr255Param entityName     New name for entity
;     Outputs:    CfgEntityRef* newEntityRef      Reference to renamed entity
;     Returns:    OSStatus                        *** list errors ***
; 
;     Renames the specified entity. If the entity doesnt exist kCfgEntityNotfoundErr is returned. If 
;     there is already an entity with that name kCfgErrEntityAlreadyExists is returned.
;                                               ; 
;  *  OTCfgGetEntityArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgSetEntityName" 
      ((dbRef :pointer) (entityRef (:pointer :cfgentityref)) (entityName (:string 255)) (newEntityRef (:pointer :cfgentityref))) 
  :osstatus
   () )                                         ; CONST; 
;     OTCfgGetEntityArea()
; 
;     Inputs:     CfgEntityRef *entityRef         Reference to an entity
;     Outputs:    CfgAreaID *areaID               ID of area that contains the entity
;     Returns:    none
; 
;     Returns the area ID associated with the specified entity reference.
;                                               ; 
;  *  OTCfgGetEntityName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetEntityArea" 
      ((entityRef (:pointer :cfgentityref)) (areaID (:pointer :unsigned-long))) 
  nil
   () )                                         ; CONST; 
;     OTCfgGetEntityName()
; 
;     Inputs:     CfgEntityRef *entityRef         Reference to an entity
;     Outputs:    Str255 entityName               Name of the entity
;     Returns:    none
; 
;     Returns the entity name associated with the specified entity reference.
; 
(deftrap-inline "_OTCfgGetEntityName" 
      ((entityRef (:pointer :cfgentityref)) (entityName (:pointer (:string 255)))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgGetEntityLogicalName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; 
;     OTCfgGetEntityName()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityRef *entityRef         Reference to an entity
;     Outputs:    Str255 entityName               Logical Name of the entity
;     Returns:    none
; 
;     Returns the logical name associated with the specified entity reference.
; 
(deftrap-inline "_OTCfgGetEntityLogicalName" 
      ((dbRef :pointer) (entityRef (:pointer :cfgentityref)) (entityName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgChangeEntityArea()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;     OTCfgChangeEntityArea()
; 
;     Inputs:     CfgEntityRef *entityRef         Reference to an entity
;                 CfgAreaID newAreaID             ID of area to contain moved entity
;     Outputs:    none
;     Returns:    none
; 
;     Changes the area ID associated with the specified entity reference.
;                                               ;     -------------------------------------------------------------------------
;     These API calls are for the protocol developers to compare the IDs.
;     ------------------------------------------------------------------------- ;     -------------------------------------------------------------------------
;     For OTCfgIsSameEntityRef
;     ------------------------------------------------------------------------- 
(deftrap-inline "_OTCfgChangeEntityArea" 
      ((entityRef (:pointer :cfgentityref)) (newAreaID :unsigned-long)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $kOTCfgIgnoreArea 1)
(defconstant $kOTCfgDontIgnoreArea 0)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCfgIsSameEntityRef()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ; CONST; 
;     OTCfgIsSameEntityRef()
; 
;     Inputs:     CfgEntityRef* entityRef1        Reference to an entity
;                 CfgEntityRef* entityRef2        Reference to another entity
;                 Boolean ignoreArea              If true, ignore the area ID
;     Outputs:    none
;     Returns:    Boolean                         If true, entity references match
; 
;     Compare two entity references. If ignoreArea is true, and the two entity names are the same, then return 
;     true. If ignoreArea is false, then the area IDs must be the same, as well as the entity names 
;     must be the same, then can return true.
;                                               ; 
;  *  OTCfgIsSameAreaID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgIsSameEntityRef" 
      ((entityRef1 (:pointer :cfgentityref)) (entityRef2 (:pointer :cfgentityref)) (ignoreArea :boolean)) 
  :boolean
   () )                                         ; 
;     OTCfgIsSameAreaID()
; 
;     Inputs:     CfgAreaID areaID1               ID of an area
;                 CfgAreaID areaID2               ID of another area
;     Outputs:    none
;     Returns:    Boolean                         If true, area IDs match
; 
;     Compare two area IDs. Return true for matching area IDs, and return false for the different area IDs.
;                                               ;     -------------------------------------------------------------------------
;     Dealing with individual preferences
;     ------------------------------------------------------------------------- ;     -------------------------------------------------------------------------
;     Open Preferences
;     if writer = true, GetPrefs and SetPrefs are allowed, else only GetPrefs is allowed.
;     ------------------------------------------------------------------------- ; 
;  *  OTCfgOpenPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgIsSameAreaID" 
      ((areaID1 :unsigned-long) (areaID2 :unsigned-long)) 
  :boolean
   () )                                         ; CONST; 
;     OTCfgOpenPrefs()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityRef* entityRef         Reference to an entity
;                 Boolean writer                  If true, open for write
;     Outputs:    CfgEntityAccessID* accessID     ID for entity access
;     Returns:    OSStatus                        *** list errors ***
; 
;     Open the specified entity and return the CfgEntityAccessID for the following access of the 
;     content of the entity. If writer is true, CfgGetPrefs and CfgSetPrefs are allowed, otherwise only 
;     CfgGetPrefs is allowed.
;                                               ; 
;  *  OTCfgClosePrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgOpenPrefs" 
      ((dbRef :pointer) (entityRef (:pointer :cfgentityref)) (writer :boolean) (accessID (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     OTCfgClosePrefs()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID for entity to close
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Close the entity with the specified CfgEntityAccessID.
;                                               ;     -------------------------------------------------------------------------
;     Get/Set Preferences
; 
;     Accessing the content of an entity
; 
;     These API calls are for the protocol developers. It supports multiple preferences per entity. Each 
;     preference is identified by an OSType (typically called prefsType). The structure of the
;     preference data is protocol stack dependent.
;     ------------------------------------------------------------------------- ; 
;  *  OTCfgSetPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgClosePrefs" 
      ((accessID :pointer)) 
  :osstatus
   () )                                         ; 
;     OTCfgSetPrefs()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;                 OSType prefsType                Preference type to set
;                 void* data                      Address of data
;                 ByteCount length                Number of bytes of data
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Write the data to the specified preference, creating the preference if necessary.
;     The preference is identified by the prefsType. If the entity is not opened for
;     the writer, an error code is returned.
; 
(deftrap-inline "_OTCfgSetPrefs" 
      ((accessID :pointer) (prefsType :ostype) (data :pointer) (length :unsigned-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgDeletePrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;     OTCfgDeletePrefs()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;                 OSType prefsType                Preference type to get
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Delete the specified preference. The preference is identified by the prefsType. 
; 
(deftrap-inline "_OTCfgDeletePrefs" 
      ((accessID :pointer) (prefsType :ostype)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgGetPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;     OTCfgGetPrefs()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;                 OSType prefsType                Preference type to get
;                 void* data                      Address for data
;                 ByteCount length                Number of bytes of data requested
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Read the data from the specified preference to the passed buffer. The preference is identified by the 
;     prefsType. If the passed buffer is too small, kCfgErrDataTruncated is returned, but will copy as 
;     many data as possible to the buffer.
;                                               ; 
;  *  OTCfgGetPrefsSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetPrefs" 
      ((accessID :pointer) (prefsType :ostype) (data :pointer) (length :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     OTCfgGetPrefsSize()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;                 OSType prefsType                Preference type to get
;                 ByteCount length                Number of bytes of data available
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Returns the length, in bytes, of the specified preference. The preference is identified by the prefsType.
; 
(deftrap-inline "_OTCfgGetPrefsSize" 
      ((accessID :pointer) (prefsType :ostype) (length (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgGetTemplate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;     OTCfgGetDefault()
; 
;     Inputs:     OSType      entityClass         entityClass
;                 OSType      entityType          entityType
;                 OSType      prefsType           prefsType
;                 ByteCount*  dataSize            maximum length of buffer
;     Outputs:    void*       data                template for the preference class/type/prefsType
;                 ByteCount*  dataSize            actual length of template
;     Returns:    OSStatus                        *** list errors ***
; 
;     This routine returns the template for the specified preference class, type, and prefsType.
;                                               ; 
;     Due to a human error, OTCfgGetDefault was published with the entity type and class parameters reversed, 
;     with respect to the other calls that take these same parameters.  Please, use OTCfgGetTemplate instead.  
; 
(deftrap-inline "_OTCfgGetTemplate" 
      ((entityClass :ostype) (entityType :ostype) (prefsType :ostype) (data :pointer) (dataSize (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTCfgGetDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;     OTCfgGetDefault()
; 
;     Inputs:     OSType  entityType              entityType
;                 OSType  entityClass             entityClass
;                 OSType  prefsType               prefsType
;     Outputs:    none
;     Returns:    Handle                          default preference for the preference type/class/prefsType
; 
;     This routine returns the default preference value for the specified preference type, class, and prefsType.
;                                               ;     -------------------------------------------------------------------------
;     Get table of contents for prefs
;     ------------------------------------------------------------------------- ; 
;  *  OTCfgGetPrefsTOCCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetDefault" 
      ((entityType :ostype) (entityClass :ostype) (prefsType :ostype)) 
  :handle
   () )                                         ; 
;     OTCfgGetPrefsTOCCount()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;     Outputs:    ItemCount* itemCount            Number of entries available
;     Returns:    OSStatus                        *** list errors ***
; 
;     Get the count of all the preference in the entity.
;                                               ; 
;  *  OTCfgGetPrefsTOC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgGetPrefsTOCCount" 
      ((accessID :pointer) (ItemCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     OTCfgGetPrefsTOC()
; 
;     Inputs:     CfgEntityAccessID* accessID     ID of entity to access
;                 ItemCount* itemCount            Number of entries requested
;                 CfgPrefsHeader prefsTOC[]       Pointer to array of *itemCount pref headers
;     Outputs:    ItemCount* itemCount            Number of entries returned
;                 CfgPrefsHeader prefsTOC[]       Filled in array of *itemCount pref headers
;     Returns:    OSStatus                        *** list errors ***
; 
;     Get the list of all the preference in the entity. Return the number of preferences in the count. 
;     prefsTOC has to be big enough to hold information about all the preference.
; 
;     Current versions of Network Setup dont read the input value of itemCount to ensure
;     that the returned preference information doesn't write off the end of the prefsTOC array.
;     This is too be fixed in a future version.  The upshot is that:
;     
;      a) always call OTCfgGetPrefsTOCCount before calling this routine and then allocate
;         an appropriate sized array to pass to prefsTOC
;      b) before calling this routine, always set up itemCount to the size of the prefsTOC
;         array so that your code will run on future systems
;                                               ;     -------------------------------------------------------------------------
;     Database Change Notification
;     ------------------------------------------------------------------------- 
(deftrap-inline "_OTCfgGetPrefsTOC" 
      ((accessID :pointer) (ItemCount (:pointer :unsigned-long)) (prefsTOC (:pointer :cfgprefsheader))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OTCfgNotifyProcPtr = PROCEDURE(contextPtr: UNIV Ptr; code: UInt32; result: SInt32; cookie: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :otcfgnotifyprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :otcfgnotifierentryptr (find-mactype '(:pointer :otcfgnotifierentry)))
(defrecord OTCfgNotifierEntry 
   (dbRef :pointer)
   (theClass :ostype)
   (theType :ostype)
   (notifier :pointer)
   (contextPtr :pointer)
   (theArea :unsigned-long)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCfgInstallNotifier()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;     OTCfgInstallNotifier()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityClass theClass         receives notifications about changes to this class
;                 CfgEntityType theType           receives notifications about changes to this type
;                 OTCfgNotifyProcPtr notifier     address of callback routine
;                 void* contextPtr                refCon for callback routine
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Installs a notifier that Network Setup will call when interesting things happen.
; 
;     Requires Network Setup 1.1 or higher.
;                                               ; 
;  *  OTCfgRemoveNotifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgInstallNotifier" 
      ((dbRef :pointer) (theClass :ostype) (theType :ostype) (notifier :pointer) (contextPtr :pointer)) 
  :osstatus
   () )                                         ; 
;     OTCfgRemoveNotifier()
; 
;     Inputs:     CfgDatabaseRef dbRef            Reference to opened database
;                 CfgEntityClass theClass         remove notifier for this class
;                 CfgEntityType theType           remove notifier for this type
;     Outputs:    none
;     Returns:    OSStatus                        *** list errors ***
; 
;     Removes a notifier previously installed with OTCfgRemoveNotifier.
; 
;     Requires Network Setup 1.1 or higher.
;                                               ;   Constants for the code parameter of the notifier installed by OTCfgInstallNotifier. 
(deftrap-inline "_OTCfgRemoveNotifier" 
      ((dbRef :pointer) (theClass :ostype) (theType :ostype)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $kOTCfgDatabaseChanged #x10000000) ;   result will be kCfgErrDatabaseChanged, cookie is meaningless 

; 	    -------------------------------------------------------------------------
; 	    Remote Access Preference Utilities
; 	    ------------------------------------------------------------------------- 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCfgEncrypt()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;     OTCfgEncrypt()
; 
;     Inputs:     UInt8 *key                      encryption key ( user name )
;                 UInt8 *data                     data to encrypt ( password )
;                 SInt16 dataLen                  length of data to encrypt
;     Outputs:    UInt8 *data                     encrypted data
;     Returns:    SInt16                          length of encrypted data
; 
;     Encrypt the password, using the user name as the encryption key.  Return the encrypted password and its length.  
;     
;     Requires Network Setup 1.1 or higher.
;                                               ; 
;  *  OTCfgDecrypt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CfgOpenTpt 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCfgEncrypt" 
      ((key (:pointer :unsigned-byte)) (data (:pointer :unsigned-byte)) (dataLen :signed-integer)) 
  :signed-integer
   () )                                         ; 
;     OTCfgDecrypt()
; 
;     Inputs:     UInt8 *key                      encryption key ( user name )
;                 UInt8 *data                     data to decrypt ( password )
;                 SInt16 dataLen                  length of data to decrypt
;     Outputs:    UInt8 *data                     decrypted data
;     Returns:    SInt16                          length of decrypted data
; 
;     Decrypt the password, using the user name as the encryption key.  Return the decrypted password and its length.  
; 
;     Requires Network Setup 1.1 or higher.
;                                               ;     -------------------------------------------------------------------------
;     CfgEntityClass / CfgEntityType
; 
;     The database can distinguish between several classes of objects and 
;     several types withing each class
;     Use of different classes allow to store type of information in the same database
; 
;     Other entity classes and types can be defined by developers.
;     they should be unique and registered with Developer Tech Support (DTS)
;     ------------------------------------------------------------------------- 
(deftrap-inline "_OTCfgDecrypt" 
      ((key (:pointer :unsigned-byte)) (data (:pointer :unsigned-byte)) (dataLen :signed-integer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $kOTCfgClassNetworkConnection :|otnc|)
(defconstant $kOTCfgClassGlobalSettings :|otgl|)
(defconstant $kOTCfgClassServer :|otsv|)
(defconstant $kOTCfgTypeGeneric :|otan|)
(defconstant $kOTCfgTypeAppleTalk :|atlk|)
(defconstant $kOTCfgTypeTCPv4 :|tcp4|)
(defconstant $kOTCfgTypeTCPv6 :|tcp6|)
(defconstant $kOTCfgTypeDNS :|dns |)
(defconstant $kOTCfgTypeRemote :|ara |)
(defconstant $kOTCfgTypeDial :|dial|)
(defconstant $kOTCfgTypeModem :|modm|)
(defconstant $kOTCfgTypeInfrared :|infr|)
(defconstant $kOTCfgClassSetOfSettings :|otsc|)
(defconstant $kOTCfgTypeSetOfSettings :|otst|)

; 	    *****************************************************
; 	    *************** Preference Structures ***************
; 	    *****************************************************
; 		

; 	  ------------------ Network Setup ------------------ 	

(defconstant $kOTCfgSetsStructPref :|stru|)     ;   CfgSetsStruct 
(defconstant $kOTCfgSetsElementPref :|elem|)    ;   CfgSetsElement 
(defconstant $kOTCfgSetsVectorPref :|vect|)     ;   CfgSetsVector 

; 
; 	   Bits and masks for the fFlags field of CfgSetsStruct.
; 	   Second line.
; 	
(defconstant $kOTCfgSetsFlagActiveBit 0)

(defconstant $kOTCfgSetsFlagActiveMask #x1)

;   Indexes for the fTimes field of CfgSetsStruct. 
(defconstant $kOTCfgIndexSetsActive 0)
(defconstant $kOTCfgIndexSetsEdit 1)
(defconstant $kOTCfgIndexSetsLimit 2)           ;      last value, no comma 

(def-mactype :cfgsetsstructptr (find-mactype '(:pointer :cfgsetsstruct)))
(defrecord CfgSetsStruct 
   (fFlags :unsigned-long)
   (fTimes (:array :unsigned-long 2))
   )

(def-mactype :cfgsetselementptr (find-mactype '(:pointer :cfgsetselement)))
(defrecord CfgSetsElement 
   (fEntityRef :cfgentityref)
   (fEntityInfo :cfgentityinfo)
   )

(def-mactype :cfgsetsvectorptr (find-mactype '(:pointer :cfgsetsvector)))
(defrecord CfgSetsVector 
   (fCount :unsigned-long)
   (fElements (:array :cfgsetselement 1))
   )

(defconstant $kOTCfgFlagRecordVersion #x1200120)
(defconstant $kOTCfgProtocolActive #x1)
(defconstant $kOTCfgProtocolMultihoming #x10000)
(defconstant $kOTCfgProtocolLimit #x10001)

(def-mactype :otcfgflagrecordptr (find-mactype '(:pointer :otcfgflagrecord)))
(defrecord OTCfgFlagRecord 
   (fVersion :unsigned-long)
   (fFlags :unsigned-long)
   )

; 	  ------------------ Common ------------------    	

;   Per-connection preference types 

(defconstant $kOTCfgUserVisibleNamePref :|pnam|);   Pascal string 
(defconstant $kOTCfgVersionPref :|cvrs|)        ;   UInt16, values should be 1 
(defconstant $kOTCfgPortUserVisibleNamePref :|port|);   Pascal string 
(defconstant $kOTCfgPortUIName :|otgn|)         ;   Pascal String 
(defconstant $kOTCfgProtocolUserVisibleNamePref :|prot|);   C string (TCP/IP = "tcp", AppleTalk = "ddp", n/a for others) 
(defconstant $kOTCfgAdminPasswordPref :|pwrd|)  ;   not to be documented 
(defconstant $kOTCfgProtocolOptionsPref :|opts|);   UInt32, protocol specific flags 

;   Global preference types 

(defconstant $kOTCfgUserModePref :|ulvl|)       ;   OTCfgUserMode, TCP/IP and AppleTalk only 
(defconstant $kOTCfgPrefWindowPositionPref :|wpos|);   Point, global coordinates, TCP/IP, AppleTalk, Infrared only 

;   Per-connection backward compatibility preference types 

(defconstant $kOTCfgCompatNamePref :|cnam|)
(defconstant $kOTCfgCompatResourceNamePref :|resn|)

;   Global backward compatibility preference types 

(defconstant $kOTCfgCompatSelectedPref :|ccfg|)
(defconstant $kOTCfgCompatResourceIDPref :|resi|)

; 
; 	   For most control panels that support a concept of "user mode",
; 	   the OTCfgUserMode preference holds (or is used as a field in 
; 	   another preference to hold) the current user mode.
; 	

(def-mactype :otcfgusermode (find-mactype ':unsigned-integer))

(defconstant $kOTCfgBasicUserMode 1)
(defconstant $kOTCfgAdvancedUserMode 2)
(defconstant $kOTCfgAdminUserMode 3)            ;   admin mode is never valid in a preference, here for completeness only 

; 
; 	   The exceptions (and there has to be exceptions, right) are Remote
; 	   Access and Modem, where the user mode is always stored as a UInt32
; 	   instead of a UInt16.  The constant values from OTCfgUserMode apply though.
; 	

(def-mactype :otcfgusermode32 (find-mactype ':unsigned-long))

; 	  ------------------ AppleTalk ------------------ 	

;   Per-connection preference types 

(defconstant $kOTCfgATalkGeneralPref :|atpf|)   ;   OTCfgATalkGeneral 
(defconstant $kOTCfgATalkLocksPref :|lcks|)     ;   OTCfgATalkLocks 
(defconstant $kOTCfgATalkPortDeviceTypePref :|ptfm|);   OTCfgATalkPortDeviceType 

;   Global preference types 

(defconstant $kOTCfgATalkNetworkArchitecturePref :|neta|);   OTCfgATalkNetworkArchitecture 

; 
; 	   OTCfgATalkGeneralAARP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the AppleTalk Address Resolution Protocol
; 	   (AARP) component of the AppleTalk protocol stack.
; 	

(def-mactype :otcfgatalkgeneralaarpptr (find-mactype '(:pointer :otcfgatalkgeneralaarp)))
(defrecord OTCfgATalkGeneralAARP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralAARP) 
   (fAgingCount :unsigned-long)                 ;   default of 8 
   (fAgingInterval :unsigned-long)              ;   ms, default of 10000 
   (fProtAddrLen :unsigned-long)                ;   bytes, must be 4, ignored by current versions of OT 
   (fHWAddrLen :unsigned-long)                  ;   bytes, must be 6, ignored by current versions of OT 
   (fMaxEntries :unsigned-long)                 ;   default of 100 
   (fProbeInterval :unsigned-long)              ;   ms, default of 200 
   (fProbeRetryCount :unsigned-long)            ;   default of 10 
   (fRequestInterval :unsigned-long)            ;   ms, default of 200 
   (fRequestRetryCount :unsigned-long)          ;   default of 8 
   )

; 
; 	   OTCfgATalkUnloadOptions controls whether AppleTalk is active or not.
; 	   The various constants deserve some explanation.  The original definition
; 	   of this field was as an inactivity timeout (in minutes), similar to that
; 	   implemented by TCP/IP in current versions of OT.  However, before OT 1.0
; 	   shipped Apple realised that loading and unloading AppleTalk on demand
; 	   was not possible, so this was redefined as a flag, with zero meaning
; 	   inactive and not-zero meaning active.  However, the default preferences
; 	   were not updated to reflect this change.  So, it is possible to see
; 	   the values defined below stored in this field.
; 	   When reading, you should treat zero as inactive, and all non-zero values
; 	   as active.  When writing, you should write either kOTCfgATalkInactive
; 	   or kOTCfgATalkActive, never kOTCfgATalkDefaultUnloadTimeout.
; 	
(def-mactype :otcfgatalkunloadoptions (find-mactype ':unsigned-byte))

(defconstant $kOTCfgATalkInactive 0)
(defconstant $kOTCfgATalkDefaultUnloadTimeout 5)
(defconstant $kOTCfgATalkActive #xFF)

; 
; 	   OTCfgATalkGeneralDDP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the Datagram Deliver Protocol
; 	   (DDP) component of the AppleTalk protocol stack.
; 	

(def-mactype :otcfgatalkgeneralddpptr (find-mactype '(:pointer :otcfgatalkgeneralddp)))
(defrecord OTCfgATalkGeneralDDP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralDDP) 
   (fTSDUSize :unsigned-long)                   ;   must be 586 
   (fLoadType :signed-byte)                     ;   whether AppleTalk is active, see the discussion above 
   (fNode :signed-byte)                         ;   last acquired node number, or fixed node to use 
   (fNetwork :unsigned-integer)                 ;   last acquired network, or fixed network to use 
   (fRTMPRequestLimit :unsigned-integer)        ;   must be 3, ignored by current versions of OT 
   (fRTMPRequestInterval :unsigned-integer)     ;   ms, must be 200, ignored by current versions of OT 
   (fAddressGenLimit :unsigned-long)            ;   default of 250 
   (fBRCAgingInterval :unsigned-long)           ;   ms, must be 40000, BRC = best routing cache, ignored by current versions of OT 
   (fRTMPAgingInterval :unsigned-long)          ;   ms, must be 50000, ignored by current versions of OT 
   (fMaxAddrTries :unsigned-long)               ;   default of 4096 
   (fDefaultChecksum :boolean)                  ;   default of false, does DDP checksum by default 
   (fIsFixedNode :boolean)                      ;   default of false, using fixed net/node 
   (fMyZone (:array :unsigned-byte 33 :packed)) ;   last acquired zone 
   )

; 
; 	   OTCfgATalkGeneralNBP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the Name Binding Protocol 
; 	   (NBP) component of the AppleTalk protocol stack.
; 	
(def-mactype :otcfgatalkgeneralnbpptr (find-mactype '(:pointer :otcfgatalkgeneralnbp)))
(defrecord OTCfgATalkGeneralNBP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralNBP) 
   (fTSDUSize :unsigned-long)                   ;   default of 584 
   (fDefaultRetryInterval :unsigned-long)       ;   ms, default of 800 
   (fDefaultRetryCount :unsigned-long)          ;   default of 3 
   (fCaseSensitiveCompare :boolean)             ;   default of false 
   (fPad :signed-byte)                          ;   must be 0 
   )

; 
; 	   OTCfgATalkGeneralZIP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the Zone Information Protocol
; 	   (ZIP) component of the AppleTalk protocol stack.
; 	
(def-mactype :otcfgatalkgeneralzipptr (find-mactype '(:pointer :otcfgatalkgeneralzip)))
(defrecord OTCfgATalkGeneralZIP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralZIP) 
   (fGetZoneInterval :unsigned-long)            ;   ms, default of 2000 
   (fZoneListInterval :unsigned-long)           ;   ms, defalut of 2000 
   (fDDPInfoTimeout :unsigned-integer)          ;   ms, default of 4000; 
   (fGetZoneRetries :signed-byte)               ;   default of 4 
   (fZoneListRetries :signed-byte)              ;   default of 4 
   (fChecksumFlag :boolean)                     ;   default of 0 
   (fPad :signed-byte)                          ;   must be 0 
   )

; 
; 	   OTCfgATalkGeneralATP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the AppleTalk Transaction Protocol
; 	   (ATP) component of the AppleTalk protocol stack.
; 	
(def-mactype :otcfgatalkgeneralatpptr (find-mactype '(:pointer :otcfgatalkgeneralatp)))
(defrecord OTCfgATalkGeneralATP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralATP) 
   (fTSDUSize :unsigned-long)                   ;   default of 578 
   (fDefaultRetryInterval :unsigned-long)       ;   ms, default of 2000 
   (fDefaultRetryCount :unsigned-long)          ;   default of 8 
   (fDefaultReleaseTimer :signed-byte)          ;   default of 0, same format as ATP_OPT_RELTIMER option 
   (fDefaultALOSetting :boolean)                ;   default of false 
   )

; 
; 	   OTCfgATalkGeneralADSP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the AppleTalk Data Stream Protocol
; 	   (ADSP) component of the AppleTalk protocol stack.
; 	
(def-mactype :otcfgatalkgeneraladspptr (find-mactype '(:pointer :otcfgatalkgeneraladsp)))
(defrecord OTCfgATalkGeneralADSP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralADSP) 
   (fDefaultSendBlocking :unsigned-long)        ;   bytes, default of 16 
   (fTSDUSize :unsigned-long)                   ;   default of 572 
   (fETSDUSize :unsigned-long)                  ;   default of 572 
   (fDefaultOpenInterval :unsigned-long)        ;   ms, default of 3000 
   (fDefaultProbeInterval :unsigned-long)       ;   ms, default of 30000 
   (fMinRoundTripTime :unsigned-long)           ;   ms, default of 100 
   (fDefaultSendInterval :unsigned-long)        ;   ms, default of 100 
   (fDefaultRecvWindow :unsigned-long)          ;   bytes, must be 27648, ignored by current versions of OT 
   (fDefaultOpenRetries :signed-byte)           ;   default of 3 
   (fDefaultBadSeqMax :signed-byte)             ;   default of 3 
   (fDefaultProbeRetries :signed-byte)          ;   default of 4 
   (fMaxConsecutiveDataPackets :signed-byte)    ;   default of 48 
   (fDefaultChecksum :boolean)                  ;   default of false 
   (fDefaultEOM :boolean)                       ;   default of false 
   )

; 
; 	   OTCfgATalkGeneralPAP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the Printer Access Protocol
; 	   (PAP) component of the AppleTalk protocol stack.
; 	
(def-mactype :otcfgatalkgeneralpapptr (find-mactype '(:pointer :otcfgatalkgeneralpap)))
(defrecord OTCfgATalkGeneralPAP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralPAP) 
   (fDefaultOpenInterval :unsigned-long)        ;   ms, default of 2000 
   (fDefaultTickleInterval :unsigned-long)      ;   ms, default of 15000 
   (fDefaultOpenRetries :signed-byte)           ;   default of 0 
   (fDefaultTickleRetries :signed-byte)         ;   default of 8 
   (fDefaultReplies :signed-byte)               ;   must be 8, ignored by current versions of OT 
   (fDefaultPAPEOMEnabled :boolean)             ;   default of false 
   )

; 
; 	   OTCfgATalkGeneralASP is a sub-structure of OTCfgATalkGeneral.
; 	   It defines parameters for the AppleTalk Session Protocol
; 	   (ASP) component of the AppleTalk protocol stack.
; 	   IMPORTANT:  Open Transport does not currently include a native
; 	   ASP implemention, and the classic AppleTalk ASP implementation
; 	   does not heed these preferences.
; 	
(def-mactype :otcfgatalkgeneralaspptr (find-mactype '(:pointer :otcfgatalkgeneralasp)))
(defrecord OTCfgATalkGeneralASP 
   (fVersion :unsigned-integer)                 ;   must be 1 
   (fSize :unsigned-integer)                    ;   must be sizeof(OTCfgATalkGeneralASP) 
   (fDefaultTickleInterval :unsigned-long)      ;   ms, must be 30000, ignored by current versions of OT 
   (fDefaultTickleRetries :signed-byte)         ;   must be 8, ignored by current versions of OT 
   (fDefaultReplies :signed-byte)               ;   must be 8, ignored by current versions of OT 
   )

; 
; 	   The OTCfgATalkGeneral structure is a conglomeration of the above structures
; 	   and is used to access the kOTCfgATalkGeneralPref preference.
; 	
(def-mactype :otcfgatalkgeneralptr (find-mactype '(:pointer :otcfgatalkgeneral)))
(defrecord OTCfgATalkGeneral 
   (fVersion :unsigned-integer)                 ;   must be 0 
   (fNumPrefs :unsigned-integer)                ;   must be 0 
   (fPort :unsigned-long)                       ;   a reference to the port over which this configuration is running 
   (fLink :pointer)                             ;   run-time use only, must be nil 
   (fPrefs (:array :pointer 8))                 ;   run-time use only, initialise to nil 
   (aarpPrefs :otcfgatalkgeneralaarp)
   (ddpPrefs :otcfgatalkgeneralddp)
   (nbpPrefs :otcfgatalkgeneralnbp)
   (zipPrefs :otcfgatalkgeneralzip)
   (atpPrefs :otcfgatalkgeneralatp)
   (adspPrefs :otcfgatalkgeneraladsp)
   (papPrefs :otcfgatalkgeneralpap)
   (aspPrefs :otcfgatalkgeneralasp)
   )

; 
; 	   OTCfgATalkLocks determines which preferences have been
; 	   locked by the administrator mode of the control panel.
; 	
(def-mactype :otcfgatalklocksptr (find-mactype '(:pointer :otcfgatalklocks)))
(defrecord OTCfgATalkLocks 
   (fLocks :unsigned-integer)                   ;   a bit field, see the definitions below 
   )

(defconstant $kOTCfgATalkPortLockMask #x1)
(defconstant $kOTCfgATalkZoneLockMask #x2)
(defconstant $kOTCfgATalkAddressLockMask #x4)
(defconstant $kOTCfgATalkConnectionLockMask #x8)
(defconstant $kOTCfgATalkSharingLockMask #x10)

; 
; 	   OTCfgATalkPortDeviceType holds either the OT device type (eg kOTEthernetDevice)
; 	   or an ADEV ID for the current port.  It is not used by the AppleTalk
; 	   protocol stack, but it is used by the AppleTalk control panel.
; 	

(def-mactype :otcfgatalkportdevicetypeptr (find-mactype '(:pointer :otcfgatalkportdevicetype)))
(defrecord OTCfgATalkPortDeviceType 
   (fDeviceType :unsigned-integer)
   )

; 
; 	   OTCfgATalkNetworkArchitecture is a vestigial remnent of the
; 	   "Network Software Selector" in System 7.5.3 through 7.5.5.
; 	
(def-mactype :otcfgatalknetworkarchitectureptr (find-mactype '(:pointer :otcfgatalknetworkarchitecture)))
(defrecord OTCfgATalkNetworkArchitecture 
   (fVersion :unsigned-long)                    ;   must be 0 
   (fNetworkArchitecture :ostype)               ;   must be 'OTOn' 
   )

;   Masks for the kOTCfgProtocolOptionsPref preference. 

(defconstant $kOTCfgATalkNoBadRouterUpNotification #x1)
(defconstant $kOTCfgATalkNoAllNodesTakenNotification #x2)
(defconstant $kOTCfgATalkNoFixedNodeTakenNotification #x4)
(defconstant $kOTCfgATalkNoInternetAvailableNotification #x8)
(defconstant $kOTCfgATalkNoCableRangeChangeNotification #x10)
(defconstant $kOTCfgATalkNoRouterDownNotification #x20)
(defconstant $kOTCfgATalkNoRouterUpNotification #x40)
(defconstant $kOTCfgATalkNoFixedNodeBadNotification #x80)

; 	  ------------------ Infrared ------------------  	

;   Per-connection preference types 

(defconstant $kOTCfgIRGeneralPref :|atpf|)      ;   OTCfgIRGeneral 

(def-mactype :otcfgirportsetting (find-mactype ':unsigned-integer))

(defconstant $kOTCfgIRIrDA 0)
(defconstant $kOTCfgIRIRTalk 1)

(def-mactype :otcfgirgeneralptr (find-mactype '(:pointer :otcfgirgeneral)))
(defrecord OTCfgIRGeneral 
   (fVersion :unsigned-long)                    ;   must be 0 
   (fPortRef :unsigned-long)                    ;   reference to IR port 
   (fPortSetting :unsigned-integer)             ;   IrDA or IRTalk, use constants defined above 
   (fNotifyOnDisconnect :boolean)
   (fDisplayIRControlStrip :boolean)
   )

; 	  ------------------ TCP/IP (v4) ------------------   	

;   Per-connection preference types 

(defconstant $kOTCfgTCPInterfacesPref :|iitf|)  ;   OTCfgTCPInterfaces (packed) 
(defconstant $kOTCfgTCPDeviceTypePref :|dtyp|)  ;   UInt16 (device type) 
(defconstant $kOTCfgTCPRoutersListPref :|irte|) ;   OTCfgTCPRoutersList 
(defconstant $kOTCfgTCPSearchListPref :|ihst|)  ;   OTCfgTCPSearchList (packed) 
(defconstant $kOTCfgTCPDNSServersListPref :|idns|);   OTCfgTCPDNSServersList 
(defconstant $kOTCfgTCPSearchDomainsPref :|isdm|);   OTCfgTCPSearchDomains 
(defconstant $kOTCfgTCPDHCPLeaseInfoPref :|dclt|);   OTCfgTCPDHCPLeaseInfo 
(defconstant $kOTCfgTCPDHCPClientIDPref :|dcid|);   DHCP client ID, Pascal string 
(defconstant $kOTCfgTCPUnloadAttrPref :|unld|)  ;   OTCfgTCPUnloadAttr 
(defconstant $kOTCfgTCPLocksPref :|stng|)       ;   OTCfgTCPLocks 
(defconstant $kOTCfgTCPPushBelowIPPref :|crpt|) ;   single module to push below IP, Pascal string 
(defconstant $kOTCfgTCPPushBelowIPListPref :|blip|);   list of modules to push below IP (Mac OS 9.0 and higher), 'STR#' format 

; 
; 	   OTCfgTCPConfigMethod is used as a field of OTCfgTCPInterfacesUnpacked
; 	   to denote how TCP/IP should acquire an address.
; 	

(def-mactype :otcfgtcpconfigmethod (find-mactype ':unsigned-byte))

(defconstant $kOTCfgManualConfig 0)
(defconstant $kOTCfgRARPConfig 1)
(defconstant $kOTCfgBOOTPConfig 2)
(defconstant $kOTCfgDHCPConfig 3)
(defconstant $kOTCfgMacIPConfig 4)

; 
; 	   The OTCfgTCPInterfacesPacked structure holds information
; 	   about the TCP/IP interfaces configured on the computer.
; 	   IMPORTANT: You must pack this structure when writing it to the
; 	   database and unpack it when reading it from the database.
; 	    The OTCfgTCPInterfacesPacked structure is a complex case, consisting of 
; 	    a fixed size structure, appended after a variable length string.
; 	

(def-mactype :otcfgtcpinterfacespackedpartptr (find-mactype '(:pointer :otcfgtcpinterfacespackedpart)))
(defrecord OTCfgTCPInterfacesPackedPart 
   (path (:array :unsigned-byte 36 :packed))
   (module (:array :unsigned-byte 32 :packed))
   (framing :unsigned-long)
   )

; 
; 	    This structure also contains an IP address and subnet mask that are not aligned on a four byte boundary.  
; 	    In order to avoid compiler warnings, and the possibility of code that won't work, 
; 	    these fields are defined here as four character arrays.  
; 	    It is suggested that BlockMoveData be used to copy to and from a field of type InetHost.  
; 	
(def-mactype :otcfgtcpinterfacespackedptr (find-mactype '(:pointer :otcfgtcpinterfacespacked)))
(defrecord OTCfgTCPInterfacesPacked 
   (fCount :unsigned-integer)
   (fConfigMethod :unsigned-byte)
   (fIPAddress (:array :unsigned-byte 4 :packed))
   (fSubnetMask (:array :unsigned-byte 4 :packed))
   (fAppleTalkZone (:array :unsigned-byte 256 :packed))
   (part (:array :unsigned-byte 72 :packed))
   )

; 
; 	   The OTCfgTCPInterfacesUnpacked structure holds information
; 	   about the TCP/IP interfaces configured on the computer.
; 	   IMPORTANT: You must pack this structure when writing it to the
; 	   database and unpack it when reading it from the database.
; 	
(def-mactype :otcfgtcpinterfacesunpackedptr (find-mactype '(:pointer :otcfgtcpinterfacesunpacked)))
(defrecord OTCfgTCPInterfacesUnpacked 
   (fCount :unsigned-integer)                   ;   always 1 in current versions of OT 
   (pad1 :signed-byte)                          ;   remove this pad byte when packing 
   (fConfigMethod :signed-byte)
   (fIPAddress :unsigned-long)
   (fSubnetMask :unsigned-long)
   (fAppleTalkZone (:string 32))                ;   remove bytes beyond end of string when packing 
   (pad2 :signed-byte)                          ;   remove this pad byte when packing 
   (path (:array :unsigned-byte 36 :packed))
   (module (:array :unsigned-byte 32 :packed))
   (framing :unsigned-long)
   )

; 
; 	   The OTCfgTCPRoutersListEntry structure is an array element
; 	   in the OTCfgTCPRoutersList preference.
; 	
(def-mactype :otcfgtcprouterslistentryptr (find-mactype '(:pointer :otcfgtcprouterslistentry)))
(defrecord OTCfgTCPRoutersListEntry 
   (fToHost :unsigned-long)                     ;      must be 0 
   (fViaHost :unsigned-long)                    ;      router address 
   (fLocal :unsigned-integer)                   ;      must be 0 
   (fHost :unsigned-integer)                    ;      must be 0 
   )

; 
; 	   The OTCfgTCPRoutersList preferences is used to hold the
; 	   configured list of routers.
; 	
(def-mactype :otcfgtcprouterslistptr (find-mactype '(:pointer :otcfgtcprouterslist)))
(defrecord OTCfgTCPRoutersList 
   (fCount :unsigned-integer)
   (fList (:array :otcfgtcprouterslistentry 1))
   )

; 
; 	   The OTCfgTCPSearchList preference holds some basic information
; 	   about the DNS configuration.
; 	   IMPORTANT: You must pack this structure when writing it to the
; 	   database and unpack it when reading it from the database.
; 	
(def-mactype :otcfgtcpsearchlistptr (find-mactype '(:pointer :otcfgtcpsearchlist)))
(defrecord OTCfgTCPSearchList 
   (fPrimaryInterfaceIndex :unsigned-byte)      ;   always 1 in current versions of OT 
   (fLocalDomainName (:array :unsigned-byte 256 :packed));   in the file, these strings are packed 
   (fAdmindomain (:array :unsigned-byte 256 :packed))
   )

; 
; 	   The OTCfgTCPDNSServersList preference holds the configured
; 	   list of name servers.
; 	
(def-mactype :otcfgtcpdnsserverslistptr (find-mactype '(:pointer :otcfgtcpdnsserverslist)))
(defrecord OTCfgTCPDNSServersList 
   (fCount :unsigned-integer)
   (fAddressesList (:array :unsigned-long 1))
   )

; 
; 	   The OTCfgTCPSearchDomains preference holds the configured
; 	   list additional search domains.
; 	   IMPORTANT: This preference is actually stored in string list
; 	   format, ie the same format as a 'STR#' resource.
; 	
(def-mactype :otcfgtcpsearchdomainsptr (find-mactype '(:pointer :otcfgtcpsearchdomains)))
(defrecord OTCfgTCPSearchDomains 
   (fCount :unsigned-integer)
   (fFirstSearchDomains (:string 255))          ;   subsequent search domains are packed after this one 
   )

; 
; 	   The OTCfgTCPDHCPLeaseInfo preference holds information about
; 	   the DHCP lease.
; 	
(def-mactype :otcfgtcpdhcpleaseinfoptr (find-mactype '(:pointer :otcfgtcpdhcpleaseinfo)))
(defrecord OTCfgTCPDHCPLeaseInfo 
   (ipIPAddr :unsigned-long)
   (ipConfigServer :unsigned-long)
   (ipLeaseGrantTime :unsigned-long)
   (ipLeaseExpirationTime :unsigned-long)
   )

; 
; 	   The OTCfgTCPUnloadAttr preference determines whether TCP/IP is
; 	   active or inactive and, if active, whether it will
; 	   unload after 2 minutes of inactivity.
; 	
(def-mactype :otcfgtcpunloadattr (find-mactype ':unsigned-integer))

(defconstant $kOTCfgTCPActiveLoadedOnDemand 1)
(defconstant $kOTCfgTCPActiveAlwaysLoaded 2)
(defconstant $kOTCfgTCPInactive 3)

; 
; 	   OTCfgTCPLocks determines which preferences have been
; 	   locked by the administrator mode of the control panel.
; 	   
; 	   IMPORTANT: This structure has an odd size.  See notes below.
; 	

(def-mactype :otcfgtcplocksptr (find-mactype '(:pointer :otcfgtcplocks)))
(defrecord OTCfgTCPLocks 
   (pad1 :signed-byte)                          ;   Set this and all other pad fields to 0. 
   (lockConnectViaPopup :signed-byte)
   (pad2 :signed-byte)
   (lockConfigurePopup :signed-byte)
   (pad3 :signed-byte)
   (lockAppleTalkZone :signed-byte)
   (pad4 :signed-byte)
   (lockIPAddress :signed-byte)
   (pad5 :signed-byte)
   (lockLocalDomainName :signed-byte)
   (pad6 :signed-byte)
   (lockSubnetMask :signed-byte)
   (pad7 :signed-byte)
   (lockRoutersList :signed-byte)
   (pad8 :signed-byte)
   (lockDNSServersList :signed-byte)
   (pad9 :signed-byte)
   (lockAdminDomainName :signed-byte)
   (pad10 :signed-byte)
   (lockSearchDomains :signed-byte)
   (pad11 :signed-byte)
   (lockUnknown :signed-byte)
   (pad12 :signed-byte)
   (lock8023 :signed-byte)
   (pad13 :signed-byte)
   (lockDHCPClientID :signed-byte)              ;   this field added in OT 2.0 
   (pad14 :signed-byte)                         ;   this field added in OT 2.0 
   )

; 
; 	   The OTCfgTCPLocks preference has an odd size, either 25 or
; 	   27 bytes depending on the verson on OT.  It is impossible
; 	   to represent an odd size structure in 68K aligned C structures,
; 	   because the compiler always pads structures to an even size.
; 	   So, when reading and writing this preference you should use one
; 	   of the constants defined below.
; 	

(defconstant $kOTCfgTCPLocksPrefPre2_0Size 25)
(defconstant $kOTCfgTCPLocksPref2_0Size 27)
(defconstant $kOTCfgTCPLocksPrefCurrentSize 27)

;   Masks for the kOTCfgProtocolOptionsPref preference. 

(defconstant $kOTCfgDontDoPMTUDiscoveryMask #x1);   Turns off Path MTU Discovery 
(defconstant $kOTCfgDontShutDownOnARPCollisionMask #x2);   To be able to Disable ARP Collision ShutDown  
(defconstant $kOTCfgDHCPInformMask #x4)         ;   Enables DHCPINFORM instead of DHCPREQUEST 
(defconstant $kOTCfgOversizeOffNetPacketsMask #x8);   With PMTU off, don't limit off-net packet to 576 bytes 
(defconstant $kOTCfgDHCPDontPreserveLeaseMask #x10);   Turns off DHCP INIT-REBOOT capability. 

; 	  ------------------ DNS ------------------   	

;   Per-connection preference types 

(defconstant $kOTCfgTypeDNSidns :|idns|)
(defconstant $kOTCfgTypeDNSisdm :|isdm|)
(defconstant $kOTCfgTypeDNSihst :|ihst|)
(defconstant $kOTCfgTypeDNSstng :|stng|)

; 	  ------------------ Modem ------------------ 	

;   Per-connection preference types 

(defconstant $kOTCfgModemGeneralPrefs :|ccl |)  ;   OTCfgModemGeneral 
(defconstant $kOTCfgModemLocksPref :|lkmd|)     ;   OTCfgModemLocks 
(defconstant $kOTCfgModemAdminPasswordPref :|mdpw|);   not to be documented 

;   Global preference types 

(defconstant $kOTCfgModemApplicationPref :|mapt|);   OTCfgModemApplication 

; 
; 	   OTCfgModemDialogToneMode specifies the handling of the dial
; 	   tone within a OTCfgModemGeneral preference.
; 	

(def-mactype :otcfgmodemdialogtonemode (find-mactype ':unsigned-long))

(defconstant $kOTCfgModemDialToneNormal 0)
(defconstant $kOTCfgModemDialToneIgnore 1)
(defconstant $kOTCfgModemDialToneManual 2)

; 
; 	   The OTCfgModemGeneral preference holds the important
; 	   per-connection preferences for Modem.
; 	

(def-mactype :otcfgmodemgeneralptr (find-mactype '(:pointer :otcfgmodemgeneral)))
(defrecord OTCfgModemGeneral 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, below 
   (useModemScript :boolean)                    ;   whether to use a modem script, must be true 
   (pad :signed-byte)                           ;   must be 0 
   (modemScript :fsspec)                        ;   the modem script (CCL) to use 
   (modemSpeakerOn :boolean)                    ;   whether to dial with the speaker on 
   (modemPulseDial :boolean)                    ;   true if pulse dial, false if tone dial 
   (modemDialToneMode :unsigned-long)           ;   constants are given above 
   (lowerLayerName (:array :character 36 :packed));   C string, name of underlying serial port 
   )

; 
; 	   OTCfgModemLocks determines which preferences have been
; 	   locked by the administrator mode of the control panel.
; 	
(def-mactype :otcfgmodemlocksptr (find-mactype '(:pointer :otcfgmodemlocks)))
(defrecord OTCfgModemLocks 
   (version :unsigned-long)                     ;   must be 1 
   (port :unsigned-long)                        ;   the underlying serial port is locked (1) or not locked (0) 
   (script :unsigned-long)                      ;   the modem script (CCL) is locked (1) or not locked (0) 
   (speaker :unsigned-long)                     ;   the speaker settings are locked (1) or not locked (0) 
   (dialing :unsigned-long)                     ;   the pulse/tone dial setting is locked (1) or not locked (0) 
   )

;   Preferences for the modem application itself. 
(def-mactype :otcfgmodemapplicationptr (find-mactype '(:pointer :otcfgmodemapplication)))
(defrecord OTCfgModemApplication 
   (version :unsigned-long)                     ;   must be 1 
   (windowPos :point)                           ;   global coordinates, window position 
   (userMode :unsigned-long)                    ;   must be kOTCfgBasicUserMode, Modem control panel has no "advance" mode 
   )

; 	  ------------------ Remote Access ------------------ 	

; 	
; 	    Remote Access Versions
; 	    ----------------------
; 	    Many Remote Access preferences include a version number.  Depending
; 	    on how the preferences were constructed, the version might either
; 	    be kOTCfgRemoteDefaultVersion or kOTCfgRemoteAcceptedVersion.  It
; 	    turns out that Remote Access doesn't actually check the version,
; 	    so both versions work equally well.  However, you should abide by
; 	    the following rules:
; 	    
; 	      o When reading the version number field, accept both
; 	        kOTCfgRemoteDefaultVersion and kOTCfgRemoteAcceptedVersion.
; 	      o When writing the version number field, write kOTCfgRemoteDefaultVersion.
; 		

(defconstant $kOTCfgRemoteDefaultVersion #x20003)
(defconstant $kOTCfgRemoteAcceptedVersion #x10000)

;   Per-connection preference types 

(defconstant $kOTCfgRemoteARAPPref :|arap|)     ;   OTCfgRemoteARAP 
(defconstant $kOTCfgRemoteAddressPref :|cadr|)  ;   'TEXT' format, max 255 characters, see also OTCfgRemoteConnect 
(defconstant $kOTCfgRemoteChatPref :|ccha|)     ;   'TEXT', see also OTCfgRemoteConnect 
(defconstant $kOTCfgRemoteDialingPref :|cdia|)  ;   OTCfgRemoteDialing 
(defconstant $kOTCfgRemoteAlternateAddressPref :|cead|);   OTCfgRemoteAlternateAddress 
(defconstant $kOTCfgRemoteClientLocksPref :|clks|);   OTCfgRemoteClientLocks 
(defconstant $kOTCfgRemoteClientMiscPref :|cmsc|);   OTCfgRemoteClientMisc 
(defconstant $kOTCfgRemoteConnectPref :|conn|)  ;   OTCfgRemoteConnect 
(defconstant $kOTCfgRemoteUserPref :|cusr|)     ;   user name, Pascal string 
(defconstant $kOTCfgRemoteDialAssistPref :|dass|);   OTCfgRemoteDialAssist 
(defconstant $kOTCfgRemoteIPCPPref :|ipcp|)     ;   OTCfgRemoteIPCP 
(defconstant $kOTCfgRemoteLCPPref :|lcp |)      ;   OTCfgRemoteLCP 
(defconstant $kOTCfgRemoteLogOptionsPref :|logo|);   OTCfgRemoteLogOptions 
(defconstant $kOTCfgRemotePasswordPref :|pass|) ;   OTCfgRemotePassword 
(defconstant $kOTCfgRemoteTerminalPref :|term|) ;   OTCfgRemoteTerminal 
(defconstant $kOTCfgRemoteUserModePref :|usmd|) ;   OTCfgRemoteUserMode 
(defconstant $kOTCfgRemoteSecurityDataPref :|csec|);   untyped data for external security modules 
(defconstant $kOTCfgRemoteX25Pref :|x25 |)      ;   OTCfgRemoteX25 

;   Global preference types 

(defconstant $kOTCfgRemoteServerPortPref :|port|);   OTCfgRemoteServerPort 
(defconstant $kOTCfgRemoteServerPref :|srvr|)   ;   OTCfgRemoteServer 
(defconstant $kOTCfgRemoteApplicationPref :|capt|);   OTCfgRemoteApplication 

; 
; 	   The OTCfgRemoteARAP preference holds connection information
; 	   for the ARAP protocol modules.
; 	   Also used as part of a Remote Access server configuration.
; 	

(def-mactype :otcfgremotearapptr (find-mactype '(:pointer :otcfgremotearap)))
(defrecord OTCfgRemoteARAP 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (lowerLayerName (:array :character 36 :packed));   C string, name of underlying modem port, must be "Script" 
   )

; 
; 	   OTCfgRemoteRedialMode specifies the handling of redial
; 	   within a OTCfgRemoteDialing preference.
; 	
(def-mactype :otcfgremoteredialmode (find-mactype ':unsigned-long))

(defconstant $kOTCfgRemoteRedialNone 2)
(defconstant $kOTCfgRemoteRedialMain 3)
(defconstant $kOTCfgRemoteRedialMainAndAlternate 4)

; 
; 	   The OTCfgRemoteDialing controls the dialing characteristics
; 	   of outgoing connections.
; 	

(def-mactype :otcfgremotedialingptr (find-mactype '(:pointer :otcfgremotedialing)))
(defrecord OTCfgRemoteDialing 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (fType :unsigned-long)                       ;   must be 'dial' 
   (additionalPtr :unsigned-long)               ;   must be 0 
   (dialMode :unsigned-long)                    ;   constants are given above 
   (redialTries :unsigned-long)                 ;   only valid if dialMode != kOTCfgRemoteRedialNone 
   (redialDelay :unsigned-long)                 ;   ms, only valid if dialMode != kOTCfgRemoteRedialNone 
   (pad :unsigned-long)                         ;   must be zero 
   )

; 
; 	   The OTCfgRemoteAlternateAddress holds the alternate phone number
; 	   to dial if the dialMode field of the OTCfgRemoteDialing 
; 	   preference is kOTCfgRemoteRedialMainAndAlternate.
; 	
(def-mactype :otcfgremotealternateaddressptr (find-mactype '(:pointer :otcfgremotealternateaddress)))
(defrecord OTCfgRemoteAlternateAddress 
   (pad :unsigned-long)                         ;   must be zero 
   (alternateAddress (:string 255))
   )

; 
; 	   OTCfgRemoteClientLocks determines which preferences have been
; 	   locked by the administrator mode of the control panel.
; 	
(def-mactype :otcfgremoteclientlocksptr (find-mactype '(:pointer :otcfgremoteclientlocks)))
(defrecord OTCfgRemoteClientLocks 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (name :unsigned-long)                        ;   "Name" field is locked (1) or unlocked (0) 
   (password :unsigned-long)                    ;   "Password" field is locked (1) or unlocked (0) 
   (number :unsigned-long)                      ;   "Number" field is locked (1) or unlocked (0) 
   (errorCheck :unsigned-long)                  ;   "Allow error correction and compression in modem" checkbox is locked (1) or unlocked (0) 
   (headerCompress :unsigned-long)              ;   "Use TCP header compression" checkbox is locked (1) or unlocked (0) 
   (termWindow :unsigned-long)                  ;   "Connect to a command-line host" options are locked (1) or unlocked (0) 
   (reminder :unsigned-long)                    ;   "Reminders" options are locked (1) or unlocked (0) 
   (autoConn :unsigned-long)                    ;   "Connect automatically when starting TCP/IP applications" checkbox is locked (1) or unlocked (0) 
   (redial :unsigned-long)                      ;   "Redialing" panel is locked (1) or unlocked (0) 
   (useProtocolLock :unsigned-long)             ;   "Use protocol" popup is locked (1) or unlocked (0) 
   (useVerboseLogLock :unsigned-long)           ;   "Use verbose logging" checkbox is locked (1) or unlocked (0) 
   (regUserOrGuestLock :unsigned-long)          ;   "Register User"/"Guest" radio buttons are locked (1) or unlocked (0) 
   (dialAssistLock :unsigned-long)              ;   "Use DialAssist" checkbox is locked (1) or unlocked (0) 
   (savePasswordLock :unsigned-long)            ;   "Save password" checkbox is locked (1) or unlocked (0) 
   (useOpenStatusAppLock :unsigned-long)        ;   "Open Status Application" checkbox is locked (1) or unlocked (0) 
   (reserved (:array :unsigned-long 1))         ;   must be 0 
   )

; 
; 	   The OTCfgRemoteClientMisc preference holds, as you might guess,
; 	   one miscellaneous preference.
; 	
(def-mactype :otcfgremoteclientmiscptr (find-mactype '(:pointer :otcfgremoteclientmisc)))
(defrecord OTCfgRemoteClientMisc 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (connectAutomatically :unsigned-long)        ;   connect automatically when starting TCP/IP applications (1), or not (0) 
   )

;   The following types are used by the OTCfgRemoteConnect preference. 
(def-mactype :otcfgremotepppconnectscript (find-mactype ':unsigned-long))

(defconstant $kOTCfgRemotePPPConnectScriptNone 0);   no chat script 
(defconstant $kOTCfgRemotePPPConnectScriptTerminalWindow 1);   use a terminal window 
(defconstant $kOTCfgRemotePPPConnectScriptScript 2);   use save chat script (OTCfgRemoteChat) 

(def-mactype :otcfgremoteprotocol (find-mactype ':unsigned-long))

(defconstant $kOTCfgRemoteProtocolPPP 1)        ;   PPP only 
(defconstant $kOTCfgRemoteProtocolARAP 2)       ;   ARAP only 
(defconstant $kOTCfgRemoteProtocolAuto 3)       ;   auto-detect PPP or ARAP (not support in ARA 3.5 and above) 

; 
; 	   The OTCfgRemoteConnect holds the core connection information
; 	   for a Remote Access configuration.
; 	

(def-mactype :otcfgremoteconnectptr (find-mactype '(:pointer :otcfgremoteconnect)))
(defrecord OTCfgRemoteConnect 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (fType :unsigned-long)                       ;   must be 0 
   (isGuest :unsigned-long)                     ;   registered user (0) or guest (1) login 
   (canInteract :unsigned-long)                 ;   must be 1 
   (showStatus :unsigned-long)                  ;   must be 0 
   (passwordSaved :unsigned-long)               ;   use saved password (1) or not (0) 
   (flashConnectedIcon :unsigned-long)          ;   flash menu bar reminder icon (1) or not (0) 
   (issueConnectedReminders :unsigned-long)     ;   issue Notification Manager reminders (1) or not (0) 
   (reminderMinutes :signed-long)               ;   minutes, time between each reminder 
   (connectManually :unsigned-long)             ;   must be 0 
   (allowModemDataCompression :unsigned-long)   ;   allow modem data compression (1) or not (0), only valid for PPP connections 
   (chatMode :unsigned-long)                    ;   constants are given above 
   (serialProtocolMode :unsigned-long)          ;   constants are given above 
   (passwordPtr :unsigned-long)                 ;   run-time use only, initialise to 0, read ignore & preserve 
   (userNamePtr :unsigned-long)                 ;   run-time use only, initialise to 0, read ignore & preserve 
   (addressLength :unsigned-long)               ;   length of phone number (OTCfgRemoteAddress) 
   (addressPtr :unsigned-long)                  ;   run-time use only, initialise to 0, read ignore & preserve 
   (chatScriptName (:string 63))                ;   user-visible name of chat script 
   (chatScriptLength :unsigned-long)            ;   length of chat script (OTCfgRemoteChat) 
   (chatScriptPtr :unsigned-long)               ;   run-time use only, initialise to 0, read ignore & preserve 
   (additional :unsigned-long)                  ;   run-time use only, initialise to 0, read ignore & preserve 
   (useSecurityModule :unsigned-long)           ;   must be 0 
   (securitySignature :ostype)                  ;   must be 0 
   (securityDataLength :unsigned-long)          ;   must be 0 
   (securityDataPtr :unsigned-long)             ;   must be 0 
   )

;   OTCfgRemoteDialAssist 
(def-mactype :otcfgremotedialassistptr (find-mactype '(:pointer :otcfgremotedialassist)))
(defrecord OTCfgRemoteDialAssist 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (isAssisted :unsigned-long)                  ;   0 for no assist (default), 1 for assist 
   (areaCodeStr (:string 31))
   (countryCodeStr (:string 31))
   )

; 
; 	   The OTCfgRemoteIPCP preference holds configuration information
; 	   for the Internet Protocol Control Protocol (IPCP) layer of PPP.
; 	   The contents of this record only make sense for PPP connections
; 	   and are ignored for ARAP connections.
; 	   Also used as part of a Remote Access server configuration.
; 	
(def-mactype :otcfgremoteipcpptr (find-mactype '(:pointer :otcfgremoteipcp)))
(defrecord OTCfgRemoteIPCP 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (reserved (:array :unsigned-long 2))         ;   must be 0 
   (maxConfig :unsigned-long)                   ;   must be 10 
   (maxTerminate :unsigned-long)                ;   must be 10 
   (maxFailureLocal :unsigned-long)             ;   must be 10 
   (maxFailureRemote :unsigned-long)            ;   must be 10 
   (timerPeriod :unsigned-long)                 ;   ms, must be 10000 
   (localIPAddress :unsigned-long)              ;   must be 0 
   (remoteIPAddress :unsigned-long)             ;   must be 0 
   (allowAddressNegotiation :unsigned-long)     ;   must be 1 
   (idleTimerEnabled :unsigned-integer)         ;   disconnect if line idle (1) or not (0) 
   (compressTCPHeaders :unsigned-integer)       ;   Van Jacobsen header compression allowed (1) or not (0) 
   (idleTimerMilliseconds :unsigned-long)       ;   ms, if idleTimerEnabled, disconnect if idle for 
   )

; 
; 	   The OTCfgRemoteLCP preference holds configuration information
; 	   for the Link Control Protocol (LCP) layer of PPP.  The contents
; 	   of this record only make sense for PPP connections and are
; 	   ignored for ARAP connections.
; 	   Also used as part of a Remote Access server configuration.
; 	
(def-mactype :otcfgremotelcpptr (find-mactype '(:pointer :otcfgremotelcp)))
(defrecord OTCfgRemoteLCP 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (reserved (:array :unsigned-long 2))         ;   must be 0 
   (lowerLayerName (:array :character 36 :packed));   C string, name of underlying modem port, must be "Script" 
   (maxConfig :unsigned-long)                   ;   must be 10 
   (maxTerminate :unsigned-long)                ;   must be 10 
   (maxFailureLocal :unsigned-long)             ;   must be 10 
   (maxFailureRemote :unsigned-long)            ;   must be 10 
   (timerPeriod :unsigned-long)                 ;   ms, must be 10000 
   (echoTrigger :unsigned-long)                 ;   ms, must be 10000 
   (echoTimeout :unsigned-long)                 ;   ms, must be 10000 
   (echoRetries :unsigned-long)                 ;   5 
   (compressionType :unsigned-long)             ;   3 
   (mruSize :unsigned-long)                     ;   must be 1500 
   (upperMRULimit :unsigned-long)               ;   must be 4500 
   (lowerMRULimit :unsigned-long)               ;   must be 0 
   (txACCMap :unsigned-long)                    ;   must be 0        
   (rcACCMap :unsigned-long)                    ;   must be 0 
   (isNoLAPB :unsigned-long)                    ;   must be 0 
   )

;   OTCfgRemoteLogLevel is used as a field in OTCfgRemoteLogOptions. 
(def-mactype :otcfgremoteloglevel (find-mactype ':unsigned-long))

(defconstant $kOTCfgRemoteLogLevelNormal 0)
(defconstant $kOTCfgRemoteLogLevelVerbose 1)

; 
; 	   The OTCfgRemoteLogOptions preference controls the level
; 	   of logging done by ARA.
; 	

(def-mactype :otcfgremotelogoptionsptr (find-mactype '(:pointer :otcfgremotelogoptions)))
(defrecord OTCfgRemoteLogOptions 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (fType :ostype)                              ;   must be 'lgop' 
   (additionalPtr :unsigned-long)               ;   run-time use only, initialise to 0, read ignore & preserve 
   (logLevel :unsigned-long)                    ;   constants are given above 
   (launchStatusApp :unsigned-long)             ;   0 for not launch, 1 for launch, Remote Access 3.5 and higher  
   (reserved (:array :unsigned-long 3))         ;   must be zero 
   )

; 
; 	   OTCfgRemotePassword holds the user's dialup password, in a scrambled
; 	   form.  You can use OTCfgEncrypt to scramble a password and OTCfgDecrypt
; 	   to descramble it.
; 	
(def-mactype :otcfgremotepasswordptr (find-mactype '(:pointer :otcfgremotepassword)))
(defrecord OTCfgRemotePassword 
   (data (:array :unsigned-byte 256 :packed))
   )

;   OTCfgRemoteTerminal holds preferences used by the PPP terminal window. 
(def-mactype :otcfgremoteterminalptr (find-mactype '(:pointer :otcfgremoteterminal)))
(defrecord OTCfgRemoteTerminal 
   (fVersion :unsigned-long)                    ;   must be 1 
   (fLocalEcho :boolean)                        ;   whether to echo typed characters, default false 
   (fNonModal :boolean)                         ;   must be false 
   (fPowerUser :boolean)                        ;   must be false 
   (fQuitWhenPPPStarts :boolean)                ;   as set in the options dialog, default true 
   (fDontAskVarStr :boolean)                    ;   default false 
   (fNoVarStrReplace :boolean)                  ;   must be false 
   (fLFAfterCR :boolean)                        ;   must be false 
   (fAskToSaveOnQuit :boolean)                  ;   as set in the options dialog, default false 
   (fWindowRect :rect)                          ;   must be zero 
   (fTypedCharStyle :signed-byte)               ;   style used for characters type,    default to bold   (2) 
   (fPrintedCharStyle :signed-byte)             ;   style used for characters printed, default to normal (0) 
   (fEchoedCharStyle :signed-byte)              ;   style used for characters echoed,  default to italic (1) 
   (pad :signed-byte)                           ;   must be zero 
   (fFontSize :signed-integer)                  ;   default is 9 
   (fFontName (:string 255))                    ;   default is "\pMonaco" on Roman systems 
   )

; 
; 	   The OTCfgRemoteUserMode holds user mode preferences, such
; 	   as the current user mode and the admin password.
; 	

(def-mactype :otcfgremoteusermodeptr (find-mactype '(:pointer :otcfgremoteusermode)))
(defrecord OTCfgRemoteUserMode 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (userMode :unsigned-long)                    ;   current user mode 
   (adminPassword (:string 255))                ;   format not to be documented 
   )

; 
; 	   The OTCfgRemoteX25 preference is used to hold information
; 	   about X.25 connections.  For standard dial-up connections,
; 	   all fields (except version) must be filled with zeroes.
; 	
(def-mactype :otcfgremotex25ptr (find-mactype '(:pointer :otcfgremotex25)))
(defrecord OTCfgRemoteX25 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (fType :unsigned-long)                       ;   this and remaining fields must be 0 
   (additionalPtr :unsigned-long)
   (script :fsspec)
   (address (:array :unsigned-byte 256 :packed))
   (userName (:array :unsigned-byte 256 :packed))
   (closedUserGroup (:array :unsigned-byte 5 :packed))
   (reverseCharge :boolean)
   )

; 
; 	   OTCfgRemoteServer is a meta-preference that points to the other active
; 	   preferences for the Remote Access server.
; 	
(def-mactype :otcfgremoteserverptr (find-mactype '(:pointer :otcfgremoteserver)))
(defrecord OTCfgRemoteServer 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (configCount :signed-integer)                ;   number of active configurations, must be 1 for personal server 
   (configIDs (:array :signed-integer 1))       ;   array of IDs of active configurations, must have one entry containing 0 for personal server 
   )

;   The following types are used in the OTCfgRemoteServerPort preference. 
(def-mactype :otcfgremoteanswermode (find-mactype ':unsigned-long))

(defconstant $kOTCfgAnswerModeOff 0)            ;   answering disabled 
(defconstant $kOTCfgAnswerModeNormal 1)         ;   answering enabled 
(defconstant $kOTCfgAnswerModeTransfer 2)       ;   answering as a callback server, not valid for personal server 
(defconstant $kOTCfgAnswerModeCallback 3)       ;   answering enabled in callback mode 

(def-mactype :otcfgremotenetworkprotocol (find-mactype ':unsigned-long))

(defconstant $kOTCfgNetProtoNone 0)
(defconstant $kOTCfgNetProtoIP 1)               ;   allow IPCP connections 
(defconstant $kOTCfgNetProtoAT 2)               ;   allow AppleTalk connections (ATCP, ARAP) 
(defconstant $kOTCfgNetProtoAny 3)              ;   allow connections of either type 

(def-mactype :otcfgremotenetaccessmode (find-mactype ':unsigned-byte))

(defconstant $kOTCfgNetAccessModeUnrestricted 0);   connected client can see things on server and things on server's network 
(defconstant $kOTCfgNetAccessModeThisMacOnly 1) ;   connected client can only see things on server machine 

; 
; 	   OTCfgRemoteServerPort holds the primary configuration information for
; 	   the personal server.
; 	

(def-mactype :otcfgremoteserverportptr (find-mactype '(:pointer :otcfgremoteserverport)))
(defrecord OTCfgRemoteServerPort 
   (version :unsigned-long)                     ;   see "Remote Access Versions" note, above 
   (configID :signed-integer)                   ;   ID of this port config, matches element of configIDs array in OTCfgRemoteServer, must be 0 for personal server 
   (password (:string 255))                     ;   security zone bypass password, plain text 
   (answerMode :unsigned-long)                  ;   see values defined above 
   (limitConnectTime :boolean)                  ;   if true, following field limits duration of client connections 
   (pad :signed-byte)                           ;   must be 0 
   (maxConnectSeconds :unsigned-long)           ;   seconds, default is 3600 
   (serialProtoFlags :unsigned-long)            ;   see values defined above 
   (networkProtoFlags :unsigned-long)           ;   see values defined above 
   (netAccessMode :signed-byte)                 ;   see values defined above 
   (requiresCCL :boolean)                       ;   must be true 
   (portName (:array :character 64 :packed))    ;   C string, must be zero for personal server 
   (serialLayerName (:array :character 36 :packed));   C string, OT port name of serial port 
   (localIPAddress :unsigned-long)              ;   IP address to offer to client 
   )

; 
; 	   The OTCfgRemoteApplication preference holds preferences for the
; 	   Remote Access (or OT/PPP) application.
; 	
(def-mactype :otcfgremoteapplicationptr (find-mactype '(:pointer :otcfgremoteapplication)))
(defrecord OTCfgRemoteApplication 
   (version :unsigned-long)                     ;   IMPORTANT: NOT a standard Remote Access version number, must be 3 for ARA, 1 for OT/PPP 
   (fWindowPosition :point)                     ;   global coordinates, window position 
   (tabChoice :unsigned-long)                   ;   currently chosen tab in Options dialog, 1 for Redialing, 2 for Connection, 3 for Protocol 
   (fUserMode :unsigned-long)                   ;   current user mode 
   (fSetupVisible :unsigned-long)               ;   "Setup" is disclosed (1) or not (0) 
   )

; 	  ------------------ OLDROUTINENAMES ------------------   	

; 
; 	   Older versions of this header file defined a lot of types and constants
; 	   that were inconsistently named and confusing.  This new version of the header
; 	   file has tidied up all of these definitions, as shown above.  For the
; 	   sake of source code compatibility, the previous definitions are still available,
; 	   but you have to define the compiler variable OLDROUTINENAMES to get them.
; 	   This is a temporary measure.  Apple will remove these definitions in a future
; 	   version of this header file.  You should start transitioning your source code
; 	   to the new definitions are soon as possible.
; 	

; $IFC OLDROUTINENAMES 

(defconstant $kOTCfgTypeStruct :|stru|)
(defconstant $kOTCfgTypeElement :|elem|)
(defconstant $kOTCfgTypeVector :|vect|)

;   OLDROUTINENAMES 

;   Old, confusing names for common preference types. 

(defconstant $kOTCfgTypeConfigName :|cnam|)
(defconstant $kOTCfgTypeConfigSelected :|ccfg|)
(defconstant $kOTCfgTypeUserLevel :|ulvl|)
(defconstant $kOTCfgTypeWindowPosition :|wpos|)

;   OLDROUTINENAMES 

; 
; 	   Old, protocol-specific names for common preferences.  If the preference
; 	   is still supported, the old name is just an alias for the new name.
; 	   If the preference isn't support, the old name is a straight constant,
; 	   and you should stop using it.
; 	

(defconstant $kOTCfgTypeAppleTalkVersion :|cvrs|)
(defconstant $kOTCfgTypeTCPcvrs :|cvrs|)
(defconstant $kOTCfgTypeTCPVersion :|cvrs|)
(defconstant $kOTCfgTypeTCPPort :|port|)
(defconstant $kOTCfgTypeAppleTalkPort :|port|)
(defconstant $kOTCfgTypeTCPProtocol :|prot|)
(defconstant $kOTCfgTypeAppleTalkProtocol :|prot|)
(defconstant $kOTCfgTypeAppleTalkPassword :|pwrd|)
(defconstant $kOTCfgTypeDNSPassword :|pwrd|)
(defconstant $kOTCfgTypeTCPPassword :|pwrd|)
(defconstant $kOTCfgTypeRemoteARAP :|arap|)
(defconstant $kOTCfgTypeRemoteAddress :|cadr|)
(defconstant $kOTCfgTypeRemoteChat :|ccha|)
(defconstant $kOTCfgTypeRemoteDialing :|cdia|)
(defconstant $kOTCfgTypeRemoteExtAddress :|cead|)
(defconstant $kOTCfgTypeRemoteClientLocks :|clks|)
(defconstant $kOTCfgTypeRemoteClientMisc :|cmsc|)
(defconstant $kOTCfgTypeRemoteConnect :|conn|)
(defconstant $kOTCfgTypeRemoteUser :|cusr|)
(defconstant $kOTCfgTypeRemoteDialAssist :|dass|)
(defconstant $kOTCfgTypeRemoteIPCP :|ipcp|)
(defconstant $kOTCfgTypeRemoteLCP :|lcp |)
(defconstant $kOTCfgTypeRemoteLogOptions :|logo|)
(defconstant $kOTCfgTypeRemotePassword :|pass|)
(defconstant $kOTCfgTypeRemoteServer :|srvr|)
(defconstant $kOTCfgTypeRemoteTerminal :|term|)
(defconstant $kOTCfgTypeRemoteUserMode :|usmd|)
(defconstant $kOTCfgTypeRemoteX25 :|x25 |)
(defconstant $kOTCfgTypeRemoteApp :|capt|)
(defconstant $kOTCfgTypeRemotePort :|port|)
(defconstant $kOTCfgTypeAppleTalkPrefs :|atpf|)
(defconstant $kOTCfgTypeAppleTalkLocks :|lcks|)
(defconstant $kOTCfgTypeAppleTalkPortFamily :|ptfm|)
(defconstant $kOTCfgTypeInfraredPrefs :|atpf|)
(defconstant $kOTCfgTypeInfraredGlobal :|irgo|)
(defconstant $kOTCfgTypeTCPdclt :|dclt|)
(defconstant $kOTCfgTypeTCPSearchList :|ihst|)
(defconstant $kOTCfgTypeTCPihst :|ihst|)
(defconstant $kOTCfgTypeTCPidns :|idns|)
(defconstant $kOTCfgTypeTCPServersList :|idns|)
(defconstant $kOTCfgTypeTCPiitf :|iitf|)
(defconstant $kOTCfgTypeTCPPrefs :|iitf|)
(defconstant $kOTCfgTypeTCPisdm :|isdm|)
(defconstant $kOTCfgTypeTCPDomainsList :|isdm|)
(defconstant $kOTCfgTypeTCPdcid :|dcid|)
(defconstant $kOTCfgTypeTCPdtyp :|dtyp|)
(defconstant $kOTCfgTypeTCPRoutersList :|irte|)
(defconstant $kOTCfgTypeTCPirte :|irte|)
(defconstant $kOTCfgTypeTCPstng :|stng|)
(defconstant $kOTCfgTypeTCPLocks :|stng|)
(defconstant $kOTCfgTypeTCPunld :|unld|)
(defconstant $kOTCfgTypeTCPUnloadType :|unld|)
(defconstant $kOTCfgTypeTCPalis :|alis|)
(defconstant $kOTCfgTypeTCPara :|ipcp|)         ;   defining this as 'ipcp' makes no sense, 
;   but changing it to kOTCfgRemoteIPCPPref could break someone 
(defconstant $kOTCfgTypeTCPDevType :|dvty|)
(defconstant $kOTCfgTypeModemModem :|ccl |)
(defconstant $kOTCfgTypeModemLocks :|lkmd|)
(defconstant $kOTCfgTypeModemAdminPswd :|mdpw|)
(defconstant $kOTCfgTypeModemApp :|mapt|)

;   OLDROUTINENAMES 

(defconstant $kOTCfgIndexAppleTalkAARP 0)
(defconstant $kOTCfgIndexAppleTalkDDP 1)
(defconstant $kOTCfgIndexAppleTalkNBP 2)
(defconstant $kOTCfgIndexAppleTalkZIP 3)
(defconstant $kOTCfgIndexAppleTalkATP 4)
(defconstant $kOTCfgIndexAppleTalkADSP 5)
(defconstant $kOTCfgIndexAppleTalkPAP 6)
(defconstant $kOTCfgIndexAppleTalkASP 7)
(defconstant $kOTCfgIndexAppleTalkLast 7)

;   OLDROUTINENAMES 

;   See OTCfgATalkGeneral. 

(def-mactype :otcfgappletalkprefsptr (find-mactype '(:pointer :otcfgappletalkprefs)))
(defrecord OTCfgAppleTalkPrefs 
   (fVersion :unsigned-integer)
   (fNumPrefs :unsigned-integer)
   (fPort :unsigned-long)
   (fLink :pointer)
   (fPrefs (:array :pointer 8))
   )

;   OLDROUTINENAMES 
(%define-record :otcfgaarpprefs (find-record-descriptor :otcfgatalkgeneralaarp))
(def-mactype :otcfgaarpprefsptr (find-mactype '(:pointer :otcfgatalkgeneralaarp)))
;   OLDROUTINENAMES 
(%define-record :otcfgddpprefs (find-record-descriptor :otcfgatalkgeneralddp))
(def-mactype :otcfgddpprefsptr (find-mactype '(:pointer :otcfgatalkgeneralddp)))
;   OLDROUTINENAMES 
;   See OTCfgATalkGeneral. 
(def-mactype :otcfgatpfprefsptr (find-mactype '(:pointer :otcfgatpfprefs)))
(defrecord OTCfgATPFPrefs 
   (fAT :otcfgappletalkprefs)
   (fAARP :otcfgatalkgeneralaarp)
   (fDDP :otcfgatalkgeneralddp)
   (fFill (:array :character 122 :packed))
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgirprefsptr (find-mactype '(:pointer :otcfgirprefs)))
(defrecord OTCfgIRPrefs 
   (fHdr :cfgprefsheader)
   (fPort :unsigned-long)
   (fPortSetting :unsigned-integer)
   (fNotifyOnDisconnect :boolean)
   (fDisplayIRControlStrip :boolean)
   (fWindowPosition :point)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgirglobalptr (find-mactype '(:pointer :otcfgirglobal)))
(defrecord OTCfgIRGlobal 
   (fHdr :cfgprefsheader)                       ;   standard prefererences header 
   (fOptions :unsigned-long)                    ;   options bitmask 
   (fNotifyMask :unsigned-long)                 ;   Notification options. 
   (fUnloadTimeout :unsigned-long)              ;   Unload timeout (in milliseconds) 
   )

;   OLDROUTINENAMES 
(%define-record :otcfgdhcprecord (find-record-descriptor :otcfgtcpdhcpleaseinfo))
(def-mactype :otcfgdhcprecordptr (find-mactype '(:pointer :otcfgtcpdhcpleaseinfo)))
(%define-record :otcfghstfprefs (find-record-descriptor :otcfgtcpsearchlist))
(def-mactype :otcfghstfprefsptr (find-mactype '(:pointer :otcfgtcpsearchlist)))
(%define-record :otcfgirteentry (find-record-descriptor :otcfgtcprouterslistentry))
(def-mactype :otcfgirteentryptr (find-mactype '(:pointer :otcfgtcprouterslistentry)))
(%define-record :otcfgirteprefs (find-record-descriptor :otcfgtcprouterslist))
(def-mactype :otcfgirteprefsptr (find-mactype '(:pointer :otcfgtcprouterslist)))
;   OLDROUTINENAMES 
;   Use OTCfgTCPDNSServersList instead of OTCfgIDNSPrefs. 

(def-mactype :otcfgidnsprefsptr (find-mactype '(:pointer :otcfgidnsprefs)))
(defrecord OTCfgIDNSPrefs 
   (fCount :signed-integer)
   (fAddressesList :unsigned-long)
   )

;   OLDROUTINENAMES 
;    This is your worst case, a fixed size structure, tacked on after a variable length string. 
; 
; 	    This structure also contains an IP address and subnet mask that are not aligned on a four byte boundary.  
; 	    In order to avoid compiler warnings, and the possibility of code that won't work, 
; 	    these fields are defined here as four character arrays.  
; 	    It is suggested that BlockMoveData be used to copy to and from a field of type InetHost.  
; 	
;   OLDROUTINENAMES 

(def-mactype :otcfgiitfprefspartptr (find-mactype '(:pointer :otcfgiitfprefspart)))
(defrecord OTCfgIITFPrefsPart 
   (path (:array :character 36 :packed))
   (module (:array :character 32 :packed))
   (framing :unsigned-long)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgiitfprefsptr (find-mactype '(:pointer :otcfgiitfprefs)))
(defrecord OTCfgIITFPrefs 
   (fCount :signed-integer)
   (fConfigMethod :unsigned-byte)
;      this structure IS packed! 
;      Followed by: 
   (fIPAddress (:array :unsigned-byte 4 :packed))
   (fSubnetMask (:array :unsigned-byte 4 :packed))
   (fAppleTalkZone (:array :unsigned-byte 256 :packed))
;      this structure IS packed! 
   (fFiller :unsigned-byte)
   (part :otcfgiitfprefspart)
   )

;   OLDROUTINENAMES 
;   Use OTCfgTCPSearchDomains instead of OTCfgIDNSPrefs. 

(def-mactype :otcfgisdmprefsptr (find-mactype '(:pointer :otcfgisdmprefs)))
(defrecord OTCfgISDMPrefs 
   (fCount :signed-integer)
   (fDomainsList (:string 255))
   )

;   OLDROUTINENAMES 
(%define-record :otcfgremoteconfigmodem (find-record-descriptor :otcfgmodemgeneral))
(def-mactype :otcfgremoteconfigmodemptr (find-mactype '(:pointer :otcfgmodemgeneral)))
(%define-record :otcfgmodemappprefs (find-record-descriptor :otcfgmodemapplication))
(def-mactype :otcfgmodemappprefsptr (find-mactype '(:pointer :otcfgmodemapplication)))
;   OLDROUTINENAMES 

(defconstant $kOTCfgRemoteMaxPasswordLength 255)
(defconstant $kOTCfgRemoteMaxPasswordSize 256)
(defconstant $kOTCfgRemoteMaxUserNameLength 255)
(defconstant $kOTCfgRemoteMaxUserNameSize 256)
(defconstant $kOTCfgRemoteMaxAddressLength 255)
(defconstant $kOTCfgRemoteMaxAddressSize 256)
(defconstant $kOTCfgRemoteMaxServerNameLength 32)
(defconstant $kOTCfgRemoteMaxServerNameSize 33)
(defconstant $kOTCfgRemoteMaxMessageLength 255)
(defconstant $kOTCfgRemoteMaxMessageSize 256)
(defconstant $kOTCfgRemoteMaxX25ClosedUserGroupLength 4)
(defconstant $kOTCfgRemoteInfiniteSeconds #xFFFFFFFF)
(defconstant $kOTCfgRemoteMinReminderMinutes 1)
(defconstant $kOTCfgRemoteChatScriptFileCreator :|ttxt|)
(defconstant $kOTCfgRemoteChatScriptFileType :|TEXT|)
(defconstant $kOTCfgRemoteMaxChatScriptLength #x8000)

;   OLDROUTINENAMES 

(%define-record :otcfgremoteaddress (find-record-descriptor :otcfgremotealternateaddress))
(def-mactype :otcfgremoteaddressptr (find-mactype '(:pointer :otcfgremotealternateaddress)))
;   OLDROUTINENAMES 
(def-mactype :otcfgremotescriptptr (find-mactype '(:pointer :otcfgremotescript)))
(defrecord OTCfgRemoteScript 
   (version :unsigned-long)
   (fType :unsigned-long)
   (additional :pointer)
   (scriptType :unsigned-long)
   (scriptLength :unsigned-long)
   (scriptData :pointer)
   )

;   OLDROUTINENAMES 
(%define-record :otcfgremotex25info (find-record-descriptor :otcfgremotex25))
(def-mactype :otcfgremotex25infoptr (find-mactype '(:pointer :otcfgremotex25)))
;   OLDROUTINENAMES 
(%define-record :otcfgremoteconfigcapt (find-record-descriptor :otcfgremoteapplication))
(def-mactype :otcfgremoteconfigcaptptr (find-mactype '(:pointer :otcfgremoteapplication)))
;   OLDROUTINENAMES 

(def-mactype :otcfgremoteusermessageptr (find-mactype '(:pointer :otcfgremoteusermessage)))
(defrecord OTCfgRemoteUserMessage 
   (version :unsigned-long)
   (messageID :signed-long)
   (userMessage (:array :unsigned-byte 256 :packed))
   (userDiagnostic (:array :unsigned-byte 256 :packed))
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgremotedisconnectptr (find-mactype '(:pointer :otcfgremotedisconnect)))
(defrecord OTCfgRemoteDisconnect 
   (whenSeconds :unsigned-long)
   (showStatus :unsigned-long)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgremoteisremoteptr (find-mactype '(:pointer :otcfgremoteisremote)))
(defrecord OTCfgRemoteIsRemote 
   (net :unsigned-long)
   (node :unsigned-long)
   (isRemote :unsigned-long)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgremoteconnectinfoptr (find-mactype '(:pointer :otcfgremoteconnectinfo)))
(defrecord OTCfgRemoteConnectInfo 
   (connectInfo (:pointer :otcfgremoteconnect))
   )

;   OLDROUTINENAMES 

(defconstant $kOTCfgRemoteStatusIdle 1)
(defconstant $kOTCfgRemoteStatusConnecting 2)
(defconstant $kOTCfgRemoteStatusConnected 3)
(defconstant $kOTCfgRemoteStatusDisconnecting 4)

;   OLDROUTINENAMES 

(def-mactype :otcfgremotestatusptr (find-mactype '(:pointer :otcfgremotestatus)))
(defrecord OTCfgRemoteStatus 
   (status :unsigned-long)
   (answerEnabled :boolean)
   (pad00 :signed-byte)
   (secondsConnected :unsigned-long)
   (secondsRemaining :unsigned-long)
   (userName (:array :unsigned-byte 256 :packed))
   (serverName (:array :unsigned-byte 33 :packed))
   (pad01 :signed-byte)
   (messageIndex :unsigned-long)
   (message (:array :unsigned-byte 256 :packed))
   (serialProtocolMode :unsigned-long)
   (baudMessage (:array :unsigned-byte 256 :packed))
   (isServer :boolean)
   (pad02 :signed-byte)
   (bytesIn :unsigned-long)
   (bytesOut :unsigned-long)
   (linkSpeed :unsigned-long)
   (localIPAddress :unsigned-long)
   (remoteIPAddress :unsigned-long)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgremoteeventcode (find-mactype ':unsigned-long))
;   OLDROUTINENAMES 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	RANotifyProcPtr = PROCEDURE(contextPtr: UNIV Ptr; code: OTCfgRemoteEventCode; result: OSStatus; cookie: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :ranotifyprocptr (find-mactype ':pointer))
; $ENDC

;   OLDROUTINENAMES 
(def-mactype :otcfgremotenotifierptr (find-mactype '(:pointer :otcfgremotenotifier)))
(defrecord OTCfgRemoteNotifier 
   (procPtr :pointer)
   (contextPtr :pointer)
   )

;   OLDROUTINENAMES 
(def-mactype :otcfgremoterequestptr (find-mactype '(:pointer :otcfgremoterequest)))
(defrecord OTCfgRemoteRequest 
   (reserved1 (:array :signed-byte 16))
   (result :signed-integer)
   (reserved2 (:array :signed-byte 8))
   (requestCode :signed-integer)
   (portId :signed-integer)
   (:variant 
      (
      (Notifier :otcfgremotenotifier)
      )
      (
      (Connect :otcfgremoteconnect)
      )
      (
      (Disconnect :otcfgremotedisconnect)
      )
      (
      (Status :otcfgremotestatus)
      )
      (
      (IsRemote :otcfgremoteisremote)
      )
      (
      (ConnectInfo :otcfgremoteconnectinfo)
      )
      )
   )

; $ENDC                                         ; OLDROUTINENAMES
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NetworkSetupIncludes

; $ENDC                                         ; __NETWORKSETUP__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'NetworkSetup)