(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PCCardAdapterPlugin.p"
; at Wednesday May 1,2002 2:42:16 pm.
; 
;      File:       PCCardAdapterPlugin.p
;  
;      Contains:   PC Card Socket Service Plug-In Programming Interface
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc. and SystemSoft Corporation. All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __PCCARDADAPTERPLUGIN__
; $SETC __PCCARDADAPTERPLUGIN__ := 1

; $I+
; $SETC PCCardAdapterPluginIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __INTERRUPTS__
|#

(require-interface 'Interrupts)
#|                                              ; $I Interrupts.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PCCARD__
|#

(require-interface 'PCCard)
#|                                              ; $I PCCard.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; ------------------------------------------------------------------------------------
;   Types
; ------------------------------------------------------------------------------------
;    Interrupt Status Change bits 

(defconstant $kSCBatteryDead #x1)               ;   Battery Dead Status Change 
(defconstant $kSCBatteryLow #x2)                ;   Battery Warning Status Change 
(defconstant $kSCReady #x4)                     ;   Ready Status Change 
(defconstant $kSCCardDetect #x8)                ;   Card Detect Status Change 
(defconstant $kSCCardEjected #x10)              ;   Card Ejected 
(defconstant $kSCStatusChange #x20)             ;   PC Card Status Change Signal Asserted 
(defconstant $kSCRingIndicate #x40)             ;   PC Card Ring Indicate Signal Asserted 

; 	  IRQ bits 	
(defconstant $kIRQLevelMask #x1F)
(defconstant $kIRQInvalid #x20)
(defconstant $kIRQHigh #x40)
(defconstant $kIRQEnable #x80)

;    bits for adapter characteristics flags 

(defconstant $SS_ADPT_FLG_IND #x1)              ;   indicators for write-protect, card lock, 
;   battery status, busy status, and XIP 
;   are shared for all sockets 
(defconstant $SS_ADPT_FLG_PWR #x2)              ;   if set indicates that the sockets 
;   share the same power control 
(defconstant $SS_ADPT_FLG_DBW #x4)              ;   all windows on the adapter must use 
;   the same Data Bus Width 
(defconstant $SS_ADPT_FLG_CARDBUS #x8)          ;   all sockets are CardBus PC Card capable 
(defconstant $SS_ADPT_FLG_DMA #x10)             ;   the adapter has DMA capability 
;      bits for adapter power characteristics 
(defconstant $SS_ADPT_FLG_V33 #x20)             ;   adapter supports 3.3 volt power to socket 
(defconstant $SS_ADPT_FLG_V50 #x40)             ;   adapter supports 5.0 volt power to socket 
(defconstant $SS_ADPT_FLG_V12 #x80)             ;   adapter supports 12.0 volt power to socket 

; 	------------------------------------------------------------------------------------
; 	  Calls exported by the Family
; 	------------------------------------------------------------------------------------	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CSReportStatusChange()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCard 3.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_CSReportStatusChange" 
      ((adapterRef (:pointer :regentryid)) (whichSocket :unsigned-long) (statusChange :unsigned-long) (socketStatus :unsigned-long)) 
  :osstatus
   () )

; ------------------------------------------------------------------------------------
;   Plugin Dispatch Table
; ------------------------------------------------------------------------------------
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSValidateHardwareProc = FUNCTION({CONST}VAR deviceID: RegEntryID): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssvalidatehardwareproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSInitializeProc = FUNCTION({CONST}VAR deviceID: RegEntryID; replacingOldDriver: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssinitializeproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSSuspendProc = FUNCTION({CONST}VAR deviceID: RegEntryID): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sssuspendproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSResumeProc = FUNCTION({CONST}VAR deviceID: RegEntryID): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssresumeproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSFinalizeProc = FUNCTION({CONST}VAR deviceID: RegEntryID; beingReplaced: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssfinalizeproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSInquireAdapterProc = FUNCTION(VAR numberOfSockets: ItemCount; VAR numberOfWindows: ItemCount; VAR numberOfBridgeWindow: ItemCount; VAR capabilities: PCCardAdapterCapabilities): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssinquireadapterproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSInquireSocketProc = FUNCTION(socket: PCCardSocket; VAR numberOfWindows: ItemCount; VAR supportedSocketStatus: PCCardSocketStatus; VAR supportedStatusChange: PCCardSCEvents): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssinquiresocketproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetSocketProc = FUNCTION(socket: PCCardSocket; VAR Vcc: PCCardVoltage; VAR Vpp: PCCardVoltage; VAR Vs: PCCardVoltage; VAR socketIF: PCCardInterfaceType; VAR customIFID: PCCardCustomInterfaceID; VAR socketStatus: PCCardSocketStatus; VAR SCEventsMask: PCCardSCEvents; VAR IRQ: PCCardIRQ; VAR DMA: PCCardDMA): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetsocketproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSSetSocketProc = FUNCTION(socket: PCCardSocket; Vcc: PCCardVoltage; Vpp: PCCardVoltage; socketIF: PCCardInterfaceType; customIFID: PCCardCustomInterfaceID; statusReset: PCCardSocketStatus; SCEventsMask: PCCardSCEvents; IRQ: PCCardIRQ; DMA: PCCardDMA): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sssetsocketproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSResetSocketProc = FUNCTION(socket: PCCardSocket): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssresetsocketproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetStatusProc = FUNCTION(socket: PCCardSocket; VAR currentStatus: PCCardSocketStatus; VAR changedStatus: PCCardSocketStatus): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetstatusproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSInquireWindowProc = FUNCTION(VAR socket: PCCardSocket; window: PCCardWindow; VAR windowState: PCCardWindowState; VAR windowSize: PCCardWindowSize; VAR windowAlign: PCCardWindowAlign): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssinquirewindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetWindowProc = FUNCTION(VAR socket: PCCardSocket; window: PCCardWindow; VAR windowState: PCCardWindowState; VAR startAddress: PhysicalAddress; VAR windowSize: PCCardWindowSize; VAR windowOffset: PCCardWindowOffset; VAR memSpeed: PCCardAccessSpeed): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetwindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSSetWindowProc = FUNCTION(socket: PCCardSocket; window: PCCardWindow; windowState: PCCardWindowState; startAddress: PhysicalAddress; windowSize: PCCardWindowSize; windowOffset: PCCardWindowOffset; memSpeed: PCCardAccessSpeed): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sssetwindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetWindowOffsetProc = FUNCTION(VAR socket: PCCardSocket; window: PCCardWindow; VAR windowState: PCCardWindowState; VAR windowOffset: PCCardWindowOffset): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetwindowoffsetproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSSetWindowOffsetProc = FUNCTION(socket: PCCardSocket; window: PCCardWindow; windowState: PCCardWindowState; windowOffset: PCCardWindowOffset): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sssetwindowoffsetproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSInquireBridgeWindowProc = FUNCTION(VAR socket: PCCardSocket; window: PCCardWindow; VAR windowState: PCCardWindowState; VAR windowSize: PCCardWindowSize; VAR windowAlign: PCCardWindowAlign): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssinquirebridgewindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetBridgeWindowProc = FUNCTION(VAR socket: PCCardSocket; window: PCCardWindow; VAR windowState: PCCardWindowState; VAR startAddress: PhysicalAddress; VAR windowSize: PCCardWindowSize): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetbridgewindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSSetBridgeWindowProc = FUNCTION(socket: PCCardSocket; window: PCCardWindow; windowState: PCCardWindowState; startAddress: PhysicalAddress; windowSize: PCCardWindowSize): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sssetbridgewindowproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSGetInterruptSetMemberProc = FUNCTION(socket: PCCardSocket; VAR interruptSetMember: InterruptSetMember): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssgetinterruptsetmemberproc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSEjectCardProc = FUNCTION(socket: PCCardSocket): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ssejectcardproc (find-mactype ':pointer))
; $ENDC

(defconstant $kServiceTypePCCardAdapter :|sock|)
(defconstant $kPCCardAdapterPluginVersion #x1)
(defconstant $kPCCardAdapterPluginCurrentVersion #x1)

(def-mactype :pccardadapterpluginheaderptr (find-mactype '(:pointer :pccardadapterpluginheader)))
(defrecord PCCardAdapterPluginHeader 
   (version :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

(def-mactype :pccardadapterplugindispatchtableptr (find-mactype '(:pointer :pccardadapterplugindispatchtable)))
(defrecord PCCardAdapterPluginDispatchTable 
   (header :pccardadapterpluginheader)
   (validateHardware :pointer)
   (initialize :pointer)
   (suspend :pointer)
   (resume :pointer)
   (finalize :pointer)
   (inquireAdapter :pointer)
   (inquireSocket :pointer)
   (getSocket :pointer)
   (setSocket :pointer)
   (resetSocket :pointer)
   (getStatus :pointer)
   (inquireWindow :pointer)
   (getWindow :pointer)
   (setWindow :pointer)
   (getWindowOffset :pointer)
   (setWindowOffset :pointer)
   (inquireBridgeWindow :pointer)
   (getBridgeWindow :pointer)
   (setBridgeWindow :pointer)
   (getInterruptSetMember :pointer)
   (ejectCard :pointer)
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PCCardAdapterPluginIncludes

; $ENDC                                         ; __PCCARDADAPTERPLUGIN__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'PCCardAdapterPlugin)