(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PCCardTuples.p"
; at Wednesday May 1,2002 2:41:12 pm.
; 
;      File:       PCCardTuples.p
;  
;      Contains:   List of PCMCIA tuple types and definitions of tuple contents.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc.  All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PCCARDTUPLES__
; $SETC __PCCARDTUPLES__ := 1

; $I+
; $SETC PCCardTuplesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $MAX_TUPLE_SIZE 256)

; 	
; 	    Defines for Tuple codes
; 		
(defconstant $CISTPL_NULL #x0)
(defconstant $CISTPL_DEVICE #x1)
(defconstant $CISTPL_LONGLINK_CB #x2)
(defconstant $CISTPL_INDIRECT #x3)
(defconstant $CISTPL_CONFIG_CB #x4)
(defconstant $CISTPL_CFTABLE_ENTRY_CB #x5)
(defconstant $CISTPL_LONGLINK_MFC #x6)
(defconstant $CISTPL_BAR #x7)
(defconstant $CISTPL_CHECKSUM #x10)
(defconstant $CISTPL_LONGLINK_A #x11)
(defconstant $CISTPL_LONGLINK_C #x12)
(defconstant $CISTPL_LINKTARGET #x13)
(defconstant $CISTPL_NO_LINK #x14)
(defconstant $CISTPL_VERS_1 #x15)
(defconstant $CISTPL_ALTSTR #x16)
(defconstant $CISTPL_DEVICE_A #x17)
(defconstant $CISTPL_JEDEC_C #x18)
(defconstant $CISTPL_JEDEC_A #x19)
(defconstant $CISTPL_CONFIG #x1A)
(defconstant $CISTPL_CFTABLE_ENTRY #x1B)
(defconstant $CISTPL_DEVICE_OC #x1C)
(defconstant $CISTPL_DEVICE_OA #x1D)
(defconstant $CISTPL_DEVICE_GEO #x1E)
(defconstant $CISTPL_DEVICE_GEO_A #x1F)
(defconstant $CISTPL_MANFID #x20)
(defconstant $CISTPL_FUNCID #x21)
(defconstant $CISTPL_FUNCE #x22)
(defconstant $CISTPL_SWIL #x23)
(defconstant $CISTPL_VERS_2 #x40)
(defconstant $CISTPL_FORMAT #x41)
(defconstant $CISTPL_GEOMETRY #x42)
(defconstant $CISTPL_BYTEORDER #x43)
(defconstant $CISTPL_DATE #x44)
(defconstant $CISTPL_BATTERY #x45)
(defconstant $CISTPL_ORG #x46)
(defconstant $CISTPL_VENDOR #xFE)
(defconstant $CISTPL_END #xFF)

; 	
; 	    Tuple Data Block Definitions
; 		

;  ------------    Device Information Tuple (01H, 17H)    -----------                             

(def-mactype :deviceidtupleptr (find-mactype '(:pointer :deviceidtuple)))
(defrecord DeviceIDTuple 
   (TPLDEV_TYPE_WPS_SPEED :signed-byte)         ;   Device Type Code: 7-4, WPS: 3,  Device Speed: 2-0 
   (deviceData (:array :unsigned-byte 253 :packed))
   )

(defconstant $TPLDEV_TYPE_MASK #xF0)            ;   device type mask for TPLDEV_TYPE_WPS_SPEED 
(defconstant $TPLDEV_TYPE_EXTENDED #xE0)        ;   device type value for extended type 
(defconstant $TPLDEV_WPS_MASK #x8)              ;   write-protect switch mask for TPLDEV_TYPE_WPS_SPEED 
(defconstant $TPLDEV_SPEED_MASK #x7)            ;   device speed mask for TPLDEV_TYPE_WPS_SPEED 
(defconstant $TPLDEV_DSPEED_NULL #x0)           ;   speed for null device type 
(defconstant $TPLDEV_DSPEED_250NS #x1)          ;   250ns card access time 
(defconstant $TPLDEV_DSPEED_200NS #x2)          ;   200ns card access time 
(defconstant $TPLDEV_DSPEED_150NS #x3)          ;   150ns card access time 
(defconstant $TPLDEV_DSPEED_100NS #x4)          ;   100ns card access time 
(defconstant $TPLDEV_EXTENDED_SPEED #x7)        ;   device speed value for extended speed 
(defconstant $TPLDEV_SPEED_EXPONENT #x7)        ;   extended byte exponent mask 
(defconstant $TPLDEV_SPEED_MANTISSA #x78)       ;   extended byte mantissa mask 
(defconstant $TPLDEV_SPEED_EXTENDED_MASK #x80)  ;   bit set if more extended speed data follows 

;    device ID types 

(defconstant $DTYPE_NULL 0)
(defconstant $DTYPE_ROM 1)
(defconstant $DTYPE_OTPROM 2)
(defconstant $DTYPE_EPROM 3)
(defconstant $DTYPE_EEPROM 4)
(defconstant $DTYPE_FLASH 5)
(defconstant $DTYPE_SRAM 6)
(defconstant $DTYPE_DRAM 7)
(defconstant $DTYPE_FUNCSPEC #xD)
(defconstant $DTYPE_EXTEND #xE)

;  ---------------    Checksum Control Tuple (10H)    ---------------                             

(def-mactype :checksumcontroltupleptr (find-mactype '(:pointer :checksumcontroltuple)))
(defrecord ChecksumControlTuple 
   (TPLCKS_ADDR :signed-integer)                ;   offset to region to be checksummed, LSB first 
   (TPLCKS_LEN :signed-integer)                 ;   length of region to be checksummed, LSB first 
   (TPLCKS_CS :signed-byte)                     ;   checksum of the region 
   (reserved :signed-byte)                      ;   padding 
   )

;  ----------------    Long Link Multi-Function Tuple (06H)    ------                     

(def-mactype :longlinkmfctupleptr (find-mactype '(:pointer :longlinkmfctuple)))
(defrecord LongLinkMFCTuple 
   (TPLMFC_NUM :unsigned-byte)                  ;   Number of sets of config registers for individual functions 
   (TPLMFC_TAS1 :unsigned-byte)                 ;   CIS target address space for first function (00 = Attr, 01 = Common) 
   (TPLMFC_ADDR1 :unsigned-long)                ;   Target address of first CIS, unsigned long, lsb first 
   (TPLMFC_TAS2 :unsigned-byte)                 ;   CIS target address space for second function (00 = Attr, 01 = Common) 
   (TPLMFC_ADDR2 (:array :unsigned-byte 4 :packed));   [MISALIGNED!] Target address of second CIS, unsigned long, lsb first 
;   the following fields are of undetermined length and should be calculated at runtime 
;    
;   UInt8   TPLMFC_TASn; 
;   UInt32     TPLMFC_ADDRn; 
   )

;  ----------------    Long Link Tuple (11H, 12H)    ----------------                             

(def-mactype :longlinktupleptr (find-mactype '(:pointer :longlinktuple)))
(defrecord LongLinkTuple 
   (TPLL_ADDR :unsigned-long)                   ;   target address, LSB first 
   )

;  -----------------    Link Target Tuple (13H)    ------------------                             

(def-mactype :linktargettupleptr (find-mactype '(:pointer :linktargettuple)))
(defrecord LinkTargetTuple 
   (TPLL_TAG (:array :unsigned-byte 3 :packed)) ;   tag: should be 'C', 'I', 'S' 
   )

;  ----------------    Level 1 Version Tuple (15H)    ---------------                             

(def-mactype :level1versiontupleptr (find-mactype '(:pointer :level1versiontuple)))
(defrecord Level1VersionTuple 
   (TPLLV1_MAJOR :signed-byte)                  ;   major version number (0x04) 
   (TPLLV1_MINOR :signed-byte)                  ;   minor version number (0x01 for release 2.0 and 2.01) 
   (TPLLV1_INFO :signed-byte)                   ;   product information string, zero-terminated 
   )

;  -------------    JEDEC Identifier Tuple (18H, 19H)    ------------                             

(def-mactype :jedecdeviceinfoptr (find-mactype '(:pointer :jedecdeviceinfo)))
(defrecord JEDECDeviceInfo 
   (manufacturerID :signed-byte)
   (manufacturerInfo :signed-byte)
   )

(def-mactype :jedecidentifiertupleptr (find-mactype '(:pointer :jedecidentifiertuple)))
(defrecord JEDECIdentifierTuple 
   (device (:array :jedecdeviceinfo 1))
   )

;  ---------    Configuration Tuple (1AH)    ----------                           

(def-mactype :configtupleptr (find-mactype '(:pointer :configtuple)))
(defrecord ConfigTuple 
   (TPCC_SZ :signed-byte)                       ;   size of fields byte 
   (TPCC_LAST :signed-byte)                     ;   index number of last config entry 
   (TPCC_RADR :signed-byte)                     ;   config reg's base addr in reg. space 
   (reserved :signed-byte)                      ;   padding 
;   the following fields are of undetermined length and should be calculated at runtime 
;  UInt32       TPCC_RMSK; 
;  UInt32       TPCC_RSVD; 
;  UInt32       TPCC_SBTPL; 
   )

;    TPCC_RADR field definitions 

(defconstant $TPCC_RASZ #x3)                    ;   bits 1-0 
(defconstant $TPCC_RMSZ #x3C)                   ;   bits 5-2 
(defconstant $TPCC_RFSZ #xC0)                   ;   bits 7-6 

;  ---------    Device Geometry Tuple (1EH, 1FH)    ---------- 

(def-mactype :devicegeometryptr (find-mactype '(:pointer :devicegeometry)))
(defrecord DeviceGeometry 
   (DGTPL_BUS :signed-byte)                     ;   system bus width = 2^(n-1), n>0 
   (DGTPL_EBS :signed-byte)                     ;   erase block size = 2^(n-1), n>0 
   (DGTPL_RBS :signed-byte)                     ;   read block size = 2^(n-1), n>0 
   (DGTPL_WBS :signed-byte)                     ;   write block size = 2^(n-1), n>0 
   (DGTPL_PART :signed-byte)                    ;   partitioning size = 2^(n-1), n>0 
   (DGTPL_HWIL :signed-byte)                    ;   hardware interleave = 2^(n-1), n>0 
   )

(def-mactype :devicegeometrytupleptr (find-mactype '(:pointer :devicegeometrytuple)))
(defrecord DeviceGeometryTuple 
   (device (:array :devicegeometry 42))
   )

;  ---------    Manufacturer Identification Tuple (20H)    ----------                             

(def-mactype :manufidtupleptr (find-mactype '(:pointer :manufidtuple)))
(defrecord ManufIDTuple 
   (TPLMID_MANF :signed-integer)                ;   PCMCIA PC Card manufacturer code 
   (TPLMID_CARD :signed-integer)                ;   manufacturer information (part number and/or revision) 
   )

;  -----------    Function Identification Tuple (21H)    ------------                             

(def-mactype :functionidtupleptr (find-mactype '(:pointer :functionidtuple)))
(defrecord FunctionIDTuple 
   (TPLFID_FUNCTION :signed-byte)               ;   PC card function code 
   (TPLFID_SYSINIT :signed-byte)                ;   system initialization bit mask 
   )

;    function codes 

(defconstant $TPLFID_MultiFunction 0)
(defconstant $TPLFID_Memory 1)
(defconstant $TPLFID_SerialPort 2)
(defconstant $TPLFID_ParallelPort 3)
(defconstant $TPLFID_FixedDisk 4)
(defconstant $TPLFID_VideoAdapter 5)
(defconstant $TPLFID_NetworkLANAdapter 6)
(defconstant $TPLFID_AIMS 7)
(defconstant $TPLFID_SCSI 8)
(defconstant $TPLFID_Security 9)

;  ------------    Software Interleave Tuple (23H)    ---------------                             

(def-mactype :softwareinterleavetupleptr (find-mactype '(:pointer :softwareinterleavetuple)))
(defrecord SoftwareInterleaveTuple 
   (TPLSWIL_INTRLV :signed-byte)                ;   software interleave 
   )

;  -------    Level 2 Version and Information Tuple (40H)    --------                             

(def-mactype :level2versiontupleptr (find-mactype '(:pointer :level2versiontuple)))
(defrecord Level2VersionTuple 
   (TPLLV2_VERS :signed-byte)                   ;   structure version (0x00) 
   (TPLLV2_COMPLY :signed-byte)                 ;   level of compliance with the standard (0x00) 
   (TPLLV2_DINDEX :unsigned-integer)            ;   byte address of first data byte in card, LSB first 
   (TPLLV2_RSV6 :signed-byte)                   ;   reserved, must be zero 
   (TPLLV2_RSV7 :signed-byte)                   ;   reserved, must be zero 
   (TPLLV2_VSPEC8 :signed-byte)                 ;   vendor specific byte 
   (TPLLV2_VSPEC9 :signed-byte)                 ;   vendor specific byte 
   (TPLLV2_NHDR :signed-byte)                   ;   number of copies of CIS present on this device 
   (TPLLV2_OEM :signed-byte)                    ;   vendor of software that formatted card, zero-terminated 
   (TPLLV2_INFO :signed-byte)                   ;   informational message about the card, zero-terminated 
   (reserved :signed-byte)                      ;   padding 
   )

;  --------------------    Format Tuple (41H)    --------------------                             

;   additional information for disk type: 

(def-mactype :formatdisktupleptr (find-mactype '(:pointer :formatdisktuple)))
(defrecord FormatDiskTuple 
   (TPLFMT_BKSZ :unsigned-integer)              ;      block size, or zero if unblocked format 
   (TPLFMT_NBLOCKS :unsigned-long)              ;      number of data blocks in this partition 
   (TPLFMT_EDCLOC :unsigned-long)               ;      location of error detection code, or zero if interleaved 
   )

;   additional information for disk type: 
(def-mactype :formatmemtupleptr (find-mactype '(:pointer :formatmemtuple)))
(defrecord FormatMemTuple 
   (TPLFMT_FLAGS :signed-byte)                  ;      various flags 
   (TPLFMT_RESERVED :signed-byte)               ;      reserved, set to zero 
   (TPLFMT_ADDRESS :unsigned-long)              ;      physical location at which this memory partion must be mapped 
   (TPLFMT_EDCLOC :unsigned-long)               ;      location of error detection code, or zero if interleaved 
   )

(def-mactype :formattupleptr (find-mactype '(:pointer :formattuple)))
(defrecord FormatTuple 
   (TPLFMT_TYPE :signed-byte)                   ;   format type code 
   (TPLFMT_EDC :signed-byte)                    ;   error detection method and length of error detection code 
   (TPLFMT_OFFSET :signed-long)                 ;   offset to first data byte in this partition 
   (TPLFMT_NBYTES :signed-long)                 ;   number of data bytes in this partition 
   (:variant 
      (
      (TPLFMT_DISK :formatdisktuple)
      )
      (
      (TPLFMT_MEM :formatmemtuple)
      )
      )
   )

;    format types 

(defconstant $TPLFMTTYPE_DISK 0)
(defconstant $TPLFMTTYPE_MEM 1)
(defconstant $TPLFMTTYPE_VS #x80)

;    error detection types 

(defconstant $TPLFMTEDC_NONE 0)
(defconstant $TPLFMTEDC_CKSUM 1)
(defconstant $TPLFMTEDC_CRC 2)
(defconstant $TPLFMTEDC_PCC 3)
(defconstant $TPLFMTEDC_VS 8)

;    bits in TPLFMT_FLAGS 

(defconstant $TPLFMTFLAGS_ADDR 0)
(defconstant $TPLFMTFLAGS_AUTO 1)

;  ------------------    Geometry Tuple (42H)    --------------------                             

(def-mactype :geometrytupleptr (find-mactype '(:pointer :geometrytuple)))
(defrecord GeometryTuple 
   (TPLGEO_SPT :signed-byte)                    ;   number of sectors per track 
   (TPLGEO_TPC :signed-byte)                    ;   number of tracks per cylinder 
   (TPLGEO_NCYL :signed-integer)                ;   number of cylinders, total 
   )

;  -----------------    Byte-Order Tuple (43H)    -------------------                             

(def-mactype :byteordertupleptr (find-mactype '(:pointer :byteordertuple)))
(defrecord ByteOrderTuple 
   (TPLBYTE_ORDER :signed-byte)                 ;   byte order code 
   (TPLBYTE_MAP :signed-byte)                   ;   byte mapping code 
   )

;    byte order codes 

(defconstant $TYPBYTEORD_LOW 0)
(defconstant $TYPBYTEORD_HIGH 1)
(defconstant $TYPBYTEORD_VS #x80)

;    byte mapping codes 

(defconstant $TYPBYTEMAP_LOW 0)
(defconstant $TYPBYTEMAP_HIGH 1)
(defconstant $TYPBYTEMAP_VS #x80)

;  ----------    Card Initialization Date Tuple (44H)    ------------                             

(def-mactype :cardinitdatetupleptr (find-mactype '(:pointer :cardinitdatetuple)))
(defrecord CardInitDateTuple 
   (TPLDATE_TIME :unsigned-integer)             ;   hours, minutes, seconds 
   (TPLDATE_DAY :unsigned-integer)              ;   year, month, day 
   )

;  ----------    Battery-Replacement Date Tuple (45H)    ------------                             

(def-mactype :batteryreplacedatetupleptr (find-mactype '(:pointer :batteryreplacedatetuple)))
(defrecord BatteryReplaceDateTuple 
   (TPLBATT_RDAY :unsigned-integer)             ;   last replacement date (year, month, day) 
   (TPLBATT_XDAY :unsigned-integer)             ;   battery expiration date (year, month, day) 
   )

;  ----------------------    General Tuple    -----------------------                             

(def-mactype :tuplebodyptr (find-mactype '(:pointer :tuplebody)))
(defrecord TupleBody 
   (:variant 
      (
      (deviceID :deviceidtuple)
      )
      (
      (checksum :checksumcontroltuple)
      )
      (
      (link :longlinktuple)
      )
      (
      (target :linktargettuple)
      )
      (
      (level1 :level1versiontuple)
      )
      (
      (jedecID :jedecidentifiertuple)
      )
      (
      (config :configtuple)
      )
      (
      (devGeo :devicegeometrytuple)
      )
      (
      (manufID :manufidtuple)
      )
      (
      (funcID :functionidtuple)
      )
      (
      (swil :softwareinterleavetuple)
      )
      (
      (level2 :level2versiontuple)
      )
      (
      (format :formattuple)
      )
      (
      (geometry :geometrytuple)
      )
      (
      (order :byteordertuple)
      )
      (
      (initDate :cardinitdatetuple)
      )
      (
      (battDate :batteryreplacedatetuple)
      )
      (
      (tupleData (:array :unsigned-byte 254 :packed))
      )
      )
   )

(def-mactype :tupleptr (find-mactype '(:pointer :tuple)))
(defrecord Tuple 
   (TPL_CODE :signed-byte)
   (TPL_LINK :signed-byte)
   (TPL_BODY :tuplebody)
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PCCardTuplesIncludes

; $ENDC                                         ; __PCCARDTUPLES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PCCardTuples)