(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PEFBinaryFormat.p"
; at Wednesday May 1,2002 2:40:11 pm.
; 
;      File:       PEFBinaryFormat.p
;  
;      Contains:   PEF Types and Macros
;  
;      Version:    Technology: Master Interfaces
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PEFBINARYFORMAT__
; $SETC __PEFBINARYFORMAT__ := 1

; $I+
; $SETC PEFBinaryFormatIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  -------------------------------------------------------------------------------------------- 
;  Almost all types are padded for natural alignment.  However the PEFExportedSymbol type is    
;  10 bytes long, containing two 32 bit fields and one 16 bit field.  Arrays of it must be      
;  packed, so it requires "68K" alignment.  Setting this globally to 68K should also help       
;  ensure consistent treatment across compilers.                                                

;  ======================================================================================== 
;  Overall Structure 
;  ================= 

;  -------------------------------------------------------------------------------------------- 
;  This header contains a complete set of types and macros for dealing with the PEF executable  
;  format.  While some description is provided, this header is not meant as a primary source    
;  of documentation on PEF.  An excellent specification of PEF can be found in the Macintosh    
;  Runtime Architectures book.  This header is primarily a physical format description.  Thus   
;  it depends on as few other headers as possible and structure fields have obvious sizes.      
;                                                                                               
;  The physical storage for a PEF executable is known as a "container".  This refers to just    
;  the executable itself, not the file etc.  E.g. if five DLLs are packaged in a single file's  
;  data fork, that one data fork has five containers within it.                                 
;                                                                                               
;  A PEF container consists of an overall header, followed by one or more section headers,      
;  followed by the section name table, followed by the contents for the sections.  Some kinds   
;  of sections have specific internal representation.  The "loader" section is the most common  
;  of these special sections.  It contains information on the exports, imports, and runtime     
;  relocations required to prepare the executable.  PEF containers are self contained, all      
;  portions are located via relative offsets.                                                   
;                                                                                               
;                                                                                               
;           +-------------------------------+                                                   
;           |       Container Header        |   40 bytes                                        
;           +-------------------------------+                                                   
;           |       Section 0 header        |   28 bytes each                                   
;           |...............................|                                                   
;           |           - - - -             |                                                   
;           |...............................|                                                   
;           |       Section n-1 header      |                                                   
;           +-------------------------------+                                                   
;           |       Section Name Table      |                                                   
;           +-------------------------------+                                                   
;           |       Section x raw data      |                                                   
;           +-------------------------------+                                                   
;           |           - - - -             |                                                   
;           +-------------------------------+                                                   
;           |       Section y raw data      |                                                   
;           +-------------------------------+                                                   
;                                                                                               
;                                                                                               
;  The sections are implicitly numbered from 0 to n according to the order of their headers.    
;  The headers of the instantiated sections must precede those of the non-instantiated          
;  sections.  The ordering of the raw data is independent of the section header ordering.       
;  Each section header contains the offset for that section's raw data.                         

;  =========================================================================================== 
;  Container Header 
;  ================ 

(def-mactype :pefcontainerheaderptr (find-mactype '(:pointer :pefcontainerheader)))
(defrecord PEFContainerHeader 
   (tag1 :ostype)                               ;   Must contain 'Joy!'. 
   (tag2 :ostype)                               ;   Must contain 'peff'.  (Yes, with two 'f's.) 
   (architecture :ostype)                       ;   The ISA for code sections.  Constants in CodeFragments.h. 
   (formatVersion :unsigned-long)               ;   The physical format version. 
   (dateTimeStamp :unsigned-long)               ;   Macintosh format creation/modification stamp. 
   (oldDefVersion :unsigned-long)               ;   Old definition version number for the code fragment. 
   (oldImpVersion :unsigned-long)               ;   Old implementation version number for the code fragment. 
   (currentVersion :unsigned-long)              ;   Current version number for the code fragment. 
   (sectionCount :unsigned-integer)             ;   Total number of section headers that follow. 
   (instSectionCount :unsigned-integer)         ;   Number of instantiated sections. 
   (reservedA :unsigned-long)                   ;   Reserved, must be written as zero. 
   )

(defconstant $kPEFTag1 :|Joy!|)                 ;   For non-Apple compilers: 0x4A6F7921. 
(defconstant $kPEFTag2 :|peff|)                 ;   For non-Apple compilers: 0x70656666. 
(defconstant $kPEFVersion #x1)

(defconstant $kPEFFirstSectionHeaderOffset 40)

; 	 =========================================================================================== 	
; 	 Section Headers 	
; 	 =============== 	

(def-mactype :pefsectionheaderptr (find-mactype '(:pointer :pefsectionheader)))
(defrecord PEFSectionHeader 
   (nameOffset :signed-long)                    ;   Offset of name within the section name table, -1 => none. 
   (defaultAddress :unsigned-long)              ;   Default address, affects relocations. 
   (totalLength :unsigned-long)                 ;   Fully expanded size in bytes of the section contents. 
   (unpackedLength :unsigned-long)              ;   Size in bytes of the "initialized" part of the contents. 
   (containerLength :unsigned-long)             ;   Size in bytes of the raw data in the container. 
   (containerOffset :unsigned-long)             ;   Offset of section's raw data. 
   (sectionKind :signed-byte)                   ;   Kind of section contents/usage. 
   (shareKind :signed-byte)                     ;   Sharing level, if a writeable section. 
   (alignment :signed-byte)                     ;   Preferred alignment, expressed as log 2. 
   (reservedA :signed-byte)                     ;   Reserved, must be zero. 
   )

;   Values for the sectionKind field. 
;      Section kind values for instantiated sections. 
(defconstant $kPEFCodeSection 0)                ;   Code, presumed pure & position independent. 
(defconstant $kPEFUnpackedDataSection 1)        ;   Unpacked writeable data. 
(defconstant $kPEFPackedDataSection 2)          ;   Packed writeable data. 
(defconstant $kPEFConstantSection 3)            ;   Read-only data. 
(defconstant $kPEFExecDataSection 6)            ;   Intermixed code and writeable data. 
;   Section kind values for non-instantiated sections. 
(defconstant $kPEFLoaderSection 4)              ;   Loader tables. 
(defconstant $kPEFDebugSection 5)               ;   Reserved for future use. 
(defconstant $kPEFExceptionSection 7)           ;   Reserved for future use. 
(defconstant $kPEFTracebackSection 8)           ;   Reserved for future use. 

;   Values for the shareKind field. 
(defconstant $kPEFProcessShare 1)               ;   Shared within a single process. 
(defconstant $kPEFGlobalShare 4)                ;   Shared across the entire system. 
(defconstant $kPEFProtectedShare 5)             ;   Readable across the entire system, writeable only to privileged code. 

; 	 =========================================================================================== 	
; 	 Packed Data Contents 	
; 	 ==================== 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The raw contents of a packed data section are a sequence of byte codes.  The basic format    	
; 	 has a 3 bit opcode followed by a 5 bit count.  Additional bytes might be used to contain     	
; 	 counts larger than 31, and to contain a second or third count.  Further additional bytes     	
; 	 contain actual data values to transfer.                                                      	
; 	                                                                                              	
; 	 All counts are represented in a variable length manner.  A zero in the initial 5 bit count   	
; 	 indicates the actual value follows.  In this case, and for the second and third counts, the  	
; 	 count is represented as a variable length sequence of bytes.  The bytes are stored in big    	
; 	 endian manner, most significant part first.  The high order bit is set in all but the last   	
; 	 byte.  The value is accumulated by shifting the current value up 7 bits and adding in the    	
; 	 low order 7 bits of the next byte.                                                           	

;   The packed data opcodes. 
(defconstant $kPEFPkDataZero 0)                 ;   Zero fill "count" bytes. 
(defconstant $kPEFPkDataBlock 1)                ;   Block copy "count" bytes. 
(defconstant $kPEFPkDataRepeat 2)               ;   Repeat "count" bytes "count2"+1 times. 
(defconstant $kPEFPkDataRepeatBlock 3)          ;   Interleaved repeated and unique data. 
(defconstant $kPEFPkDataRepeatZero 4)           ;   Interleaved zero and unique data. 

(defconstant $kPEFPkDataOpcodeShift 5)
(defconstant $kPEFPkDataCount5Mask #x1F)
(defconstant $kPEFPkDataMaxCount5 31)
(defconstant $kPEFPkDataVCountShift 7)
(defconstant $kPEFPkDataVCountMask #x7F)
(defconstant $kPEFPkDataVCountEndMask #x80)

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The following code snippet can be used to input a variable length count.                     	
; 	                                                                                              	
; 	      count = 0;                                                                              	
; 	      do (                                                                                    	
; 	          byte = *bytePtr++;                                                                  	
; 	          count = (count << kPEFPkDataVCountShift) | (byte & kPEFPkDataVCountMask);           	
; 	      ) while ( (byte & kPEFPkDataVCountEndMask) != 0 );                                      	
; 	                                                                                              	
; 	 The following code snippet can be used to output a variable length count to a byte array.    	
; 	 This is more complex than the input code because the chunks are output in big endian order.  	
; 	 Think about handling values like 0 or 0x030000.                                              	
; 	                                                                                              	
; 	      count = 1;.                                                                             	
; 	      tempValue = value >> kPEFPkDataCountShift;                                              	
; 	      while ( tempValue != 0 ) (                                                              	
; 	          count += 1;                                                                         	
; 	          tempValue = tempValue >> kPEFPkDataCountShift;                                      	
; 	      )                                                                                       	
; 	                                                                                              	
; 	      bytePtr += count;                                                                       	
; 	      tempPtr = bytePtr - 1;                                                                  	
; 	      *tempPtr-- = value;     // ! No need to mask, only the low order byte is stored.        	
; 	      for ( count -= 1; count != 0; count -= 1 ) (                                            	
; 	          value = value >> kPEFPkDataCountShift;                                              	
; 	          *tempPtr-- = value | kPEFPkDataCountEndMask;                                        	
; 	      )                                                                                       	

; 	 =========================================================================================== 	
; 	 Loader Section 	
; 	 ============== 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The loader section contains information needed to prepare the code fragment for execution.   	
; 	 This includes this fragment's exports, the import libraries and the imported symbols from    	
; 	 each library, and the relocations for the writeable sections.                                	
; 	                                                                                              	
; 	          +-----------------------------------+               <-- containerOffset --------+   	
; 	          |       Loader Info Header          |   56 bytes                                |   	
; 	          |-----------------------------------|                                           |   	
; 	          |       Imported Library 0          |   24 bytes each                           |   	
; 	          |...................................|                                           |   	
; 	          |           - - -                   |                                           |   	
; 	          |...................................|                                           |   	
; 	          |       Imported Library l-1        |                                           |   	
; 	          |-----------------------------------|                                           |   	
; 	          |       Imported Symbol 0           |   4 bytes each                            |   	
; 	          |...................................|                                           |   	
; 	          |           - - -                   |                                           |   	
; 	          |...................................|                                           |   	
; 	          |       Imported Symbol i-1         |                                           |   	
; 	          |-----------------------------------|                                           |   	
; 	          |       Relocation Header 0         |   12 bytes each                           |   	
; 	          |...................................|                                           |   	
; 	          |           - - -                   |                                           |   	
; 	          |...................................|                                           |   	
; 	          |       Relocation Header r-1       |                                           |   	
; 	          |-----------------------------------|               <-- + relocInstrOffset -----|   	
; 	          |       Relocation Instructions     |                                           |   	
; 	          |-----------------------------------|               <-- + loaderStringsOffset --|   	
; 	          |       Loader String Table         |                                           |   	
; 	          |-----------------------------------|               <-- + exportHashOffset -----+   	
; 	          |       Export Hash Slot 0          |   4 bytes each                                	
; 	          |...................................|                                               	
; 	          |           - - -                   |                                               	
; 	          |...................................|                                               	
; 	          |       Export Hash Slot h-1        |                                               	
; 	          |-----------------------------------|                                               	
; 	          |       Export Symbol Key 0         |   4 bytes each                                	
; 	          |...................................|                                               	
; 	          |           - - -                   |                                               	
; 	          |...................................|                                               	
; 	          |       Export Symbol Key e-1       |                                               	
; 	          |-----------------------------------|                                               	
; 	          |       Export Symbol 0             |   10 bytes each                               	
; 	          |...................................|                                               	
; 	          |           - - -                   |                                               	
; 	          |...................................|                                               	
; 	          |       Export Symbol e-1           |                                               	
; 	          +-----------------------------------+                                               	

(def-mactype :pefloaderinfoheaderptr (find-mactype '(:pointer :pefloaderinfoheader)))
(defrecord PEFLoaderInfoHeader 
   (mainSection :signed-long)                   ;   Section containing the main symbol, -1 => none. 
   (mainOffset :unsigned-long)                  ;   Offset of main symbol. 
   (initSection :signed-long)                   ;   Section containing the init routine's TVector, -1 => none. 
   (initOffset :unsigned-long)                  ;   Offset of the init routine's TVector. 
   (termSection :signed-long)                   ;   Section containing the term routine's TVector, -1 => none. 
   (termOffset :unsigned-long)                  ;   Offset of the term routine's TVector. 
   (importedLibraryCount :unsigned-long)        ;   Number of imported libraries.  ('l') 
   (totalImportedSymbolCount :unsigned-long)    ;   Total number of imported symbols.  ('i') 
   (relocSectionCount :unsigned-long)           ;   Number of sections with relocations.  ('r') 
   (relocInstrOffset :unsigned-long)            ;   Offset of the relocation instructions. 
   (loaderStringsOffset :unsigned-long)         ;   Offset of the loader string table. 
   (exportHashOffset :unsigned-long)            ;   Offset of the export hash table. 
   (exportHashTablePower :unsigned-long)        ;   Export hash table size as log 2.  (Log2('h')) 
   (exportedSymbolCount :unsigned-long)         ;   Number of exported symbols.  ('e') 
   )

; 	 =========================================================================================== 	
; 	 Imported Libraries 	
; 	 ------------------ 	
(def-mactype :pefimportedlibraryptr (find-mactype '(:pointer :pefimportedlibrary)))
(defrecord PEFImportedLibrary 
   (nameOffset :unsigned-long)                  ;   Loader string table offset of library's name. 
   (oldImpVersion :unsigned-long)               ;   Oldest compatible implementation version. 
   (currentVersion :unsigned-long)              ;   Current version at build time. 
   (importedSymbolCount :unsigned-long)         ;   Imported symbol count for this library. 
   (firstImportedSymbol :unsigned-long)         ;   Index of first imported symbol from this library. 
   (options :signed-byte)                       ;   Option bits for this library. 
   (reservedA :signed-byte)                     ;   Reserved, must be zero. 
   (reservedB :unsigned-integer)                ;   Reserved, must be zero. 
   )

;   Bits for the PEFImportedLibrary options field. 
(defconstant $kPEFWeakImportLibMask #x40)       ;   The imported library is allowed to be missing. 
(defconstant $kPEFInitLibBeforeMask #x80)       ;   The imported library must be initialized first. 

; 	 =========================================================================================== 	
; 	 Imported Symbols 	
; 	 ---------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The PEFImportedSymbol type has the following bit field layout.                               	
; 	                                                                                              	
; 	                                                                     3                        	
; 	       0             7 8                                             1                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      | symbol class  | offset of symbol name in loader string table  |                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      |<-- 8 bits --->|<-- 24 bits ---------------------------------->|                       	

(def-mactype :pefimportedsymbolptr (find-mactype '(:pointer :pefimportedsymbol)))
(defrecord PEFImportedSymbol 
   (classAndName :unsigned-long)
   )

(defconstant $kPEFImpSymClassShift 24)
(defconstant $kPEFImpSymNameOffsetMask #xFFFFFF)
(defconstant $kPEFImpSymMaxNameOffset #xFFFFFF) ;   16,777,215 

;   Imported and exported symbol classes. 
(defconstant $kPEFCodeSymbol #x0)
(defconstant $kPEFDataSymbol #x1)
(defconstant $kPEFTVectorSymbol #x2)
(defconstant $kPEFTOCSymbol #x3)
(defconstant $kPEFGlueSymbol #x4)
(defconstant $kPEFUndefinedSymbol #xF)
(defconstant $kPEFWeakImportSymMask #x80)

; 	 =========================================================================================== 	
; 	 Exported Symbol Hash Table 	
; 	 -------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 Exported symbols are described in four parts, optimized for speed of lookup.  These parts    	
; 	 are the "export hash table", the "export key table", the "export symbol table", and the      	
; 	 "export name table".  Overall they contain a flattened representation of a fairly normal     	
; 	 hashed symbol table.                                                                         	
; 	                                                                                              	
; 	 The export hash table is an array of small fixed size elements.  The number of elements is   	
; 	 a power of 2.  A 32 bit hash word for a symbol is converted into an index into this array.   	
; 	 Each hash slot contains a count of the number of exported symbols that map to this slot and  	
; 	 the index of the first of those symbols in the key and symbol tables.  Of course some hash   	
; 	 slots will have a zero count.                                                                	
; 	                                                                                              	
; 	 The key and symbol tables are also arrays of fixed size elements, one for each exported      	
; 	 symbol.  Their entries are grouped by hash slot, those elements mapping to the same hash     	
; 	 slot are contiguous.  The key table contains just the full 32 bit hash word for each         	
; 	 exported symbol.  The symbol table contains the offset of the symbol's name in the string    	
; 	 table and other information about the exported symbol.                                       	
; 	                                                                                              	
; 	 To look up an export you take the hashword and compute the hash slot index.  You then scan   	
; 	 the indicated portion of the key table for matching hashwords.  If a hashword matches, you   	
; 	 look at the corresponding symbol table entry to find the full symbol name.  If the names     	
; 	 match the symbol is found.                                                                   	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The following function may be used to compute the hash table size.  Signed values are used   	
; 	 just to avoid potential code generation overhead for unsigned division.                      	
; 	                                                                                              	
; 	      UInt8   PEFComputeHashTableExponent ( SInt32    exportCount )                           	
; 	      (                                                                                       	
; 	          SInt32  exponent;                                                                   	
; 	                                                                                              	
; 	          const SInt32    kExponentLimit      = 16;   // Arbitrary, but must not exceed 30.   	
; 	          const SInt32    kAverageChainLimit  = 10;   // Arbitrary, for space/time tradeoff.  	
; 	                                                                                              	
; 	          for ( exponent = 0; exponent < kExponentLimit; exponent += 1 ) (                    	
; 	              if ( (exportCount / (1 << exponent)) < kAverageChainLimit ) break;              	
; 	          )                                                                                   	
; 	                                                                                              	
; 	          return exponent;                                                                    	
; 	                                                                                              	
; 	      )   // PEFComputeHashTableExponent ()                                                   	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The PEFExportedSymbolHashSlot type has the following bit field layout.                       	
; 	                                                                                              	
; 	                                 1 1                                 3                        	
; 	       0                         3 4                                 1                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      | symbol count              | index of first export key         |                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      |<-- 14 bits -------------->|<-- 18 bits ---------------------->|                       	

(def-mactype :pefexportedsymbolhashslotptr (find-mactype '(:pointer :pefexportedsymbolhashslot)))
(defrecord PEFExportedSymbolHashSlot 
   (countAndStart :unsigned-long)
   )

(defconstant $kPEFHashSlotSymCountShift 18)
(defconstant $kPEFHashSlotFirstKeyMask #x3FFFF)
(defconstant $kPEFHashSlotMaxSymbolCount #x3FFF);    16,383 
(defconstant $kPEFHashSlotMaxKeyIndex #x3FFFF)  ;   262,143 

; 	 =========================================================================================== 	
; 	 Exported Symbol Hash Key 	
; 	 ------------------------ 	

(def-mactype :pefsplithashwordptr (find-mactype '(:pointer :pefsplithashword)))
(defrecord PEFSplitHashWord 
   (nameLength :unsigned-integer)
   (hashValue :unsigned-integer)
   )

(def-mactype :pefexportedsymbolkeyptr (find-mactype '(:pointer :pefexportedsymbolkey)))
(defrecord PEFExportedSymbolKey 
   (:variant 
      (
      (fullHashWord :unsigned-long)
      )
      (
      (splitHashWord :pefsplithashword)
      )
      )
   )

(defconstant $kPEFHashLengthShift 16)
(defconstant $kPEFHashValueMask #xFFFF)
(defconstant $kPEFHashMaxLength #xFFFF)         ;   65,535 

; 	 ---------------------------------------------------------------------------------------------------- 	
; 	 The following function computes the full 32 bit hash word.                                           	
; 	                                                                                                      	
; 	      UInt32  PEFComputeHashWord  ( BytePtr   nameText,       // ! First "letter", not length byte.   	
; 	                                    UInt32    nameLength )    // ! The text may be zero terminated.   	
; 	      (                                                                                               	
; 	          BytePtr charPtr     = nameText;                                                             	
; 	          SInt32  hashValue   = 0;        // ! Signed to match old published algorithm.               	
; 	          UInt32  length      = 0;                                                                    	
; 	          UInt32  limit;                                                                              	
; 	          UInt32  result;                                                                             	
; 	          UInt8   currChar;                                                                           	
; 	                                                                                                      	
; 	          #define PseudoRotate(x)  ( ( (x) << 1 ) - ( (x) >> 16 ) )                                   	
; 	                                                                                                      	
; 	          for ( limit = nameLength; limit > 0; limit -= 1 ) (                                         	
; 	              currChar = *charPtr++;                                                                  	
; 	              if ( currChar == NULL ) break;                                                          	
; 	              length += 1;                                                                            	
; 	              hashValue = PseudoRotate ( hashValue ) ^ currChar;                                      	
; 	          )                                                                                           	
; 	                                                                                                      	
; 	          result  = (length << kPEFHashLengthShift) |                                                 	
; 	                    ((UInt16) ((hashValue ^ (hashValue >> 16)) & kPEFHashValueMask));                 	
; 	                                                                                                      	
; 	          return result;                                                                              	
; 	                                                                                                      	
; 	      )   // PEFComputeHashWord ()                                                                    	

; 	 =========================================================================================== 	
; 	 Exported Symbols 	
; 	 ---------------- 	

(def-mactype :pefexportedsymbolptr (find-mactype '(:pointer :pefexportedsymbol)))
(defrecord PEFExportedSymbol 
;   ! This structure is 10 bytes long and arrays are packed. 
   (classAndName :unsigned-long)                ;   A combination of class and name offset. 
   (symbolValue :unsigned-long)                 ;   Typically the symbol's offset within a section. 
   (sectionIndex :signed-integer)               ;   The index of the section, or pseudo-section, for the symbol. 
   )

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The classAndName field of the PEFExportedSymbol type has the following bit field layout.     	
; 	                                                                                              	
; 	                                                                     3                        	
; 	       0             7 8                                             1                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      | symbol class  | offset of symbol name in loader string table  |                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                       	
; 	      |<-- 8 bits --->|<-- 24 bits ---------------------------------->|                       	

(defconstant $kPEFExpSymClassShift 24)
(defconstant $kPEFExpSymNameOffsetMask #xFFFFFF)
(defconstant $kPEFExpSymMaxNameOffset #xFFFFFF) ;   16,777,215 

;   Negative section indices indicate pseudo-sections. 
(defconstant $kPEFAbsoluteExport -2)            ;   The symbol value is an absolute address. 
(defconstant $kPEFReexportedImport -3)          ;   The symbol value is the index of a reexported import. 

; 	 =========================================================================================== 	
; 	 Loader Relocations 	
; 	 ================== 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The relocations for a section are defined by a sequence of instructions for an abstract      	
; 	 machine that is specifically geared to performing relocations commonly needed for the "CFM"  	
; 	 code generation model.  These instructions occur in 16 bit chunks.  Most instructions have   	
; 	 just a single chunk.  Instructions that are larger than 16 bits have an opcode and some of   	
; 	 the operands in the first chunk, with other operands in following chunks.                    	
; 	                                                                                              	
; 	 ! Note that the multi-chunk relocations have separate "Compose" macros for each chunk.  The  	
; 	 ! macros have the same basic name with a positional suffix of "_1st", "_2nd", etc.           	

(def-mactype :pefrelocchunk (find-mactype ':unsigned-integer))
(def-mactype :pefloaderrelocationheaderptr (find-mactype '(:pointer :pefloaderrelocationheader)))
(defrecord PEFLoaderRelocationHeader 
   (sectionIndex :unsigned-integer)             ;   Index of the section to be fixed up. 
   (reservedA :unsigned-integer)                ;   Reserved, must be zero. 
   (relocCount :unsigned-long)                  ;   Number of 16 bit relocation chunks. 
   (firstRelocOffset :unsigned-long)            ;   Offset of first relocation instruction. 
   )

; 	 -------------------------------------------------------------------------------------------- 	
; 	 ! Note that the relocCount field is the number of 16 bit relocation chunks, i.e. 1/2 the     	
; 	 ! total number of bytes of relocation instructions.  While most relocation instructions are  	
; 	 ! 16 bits long, some are longer so the number of complete relocation instructions may be     	
; 	 ! less than the relocCount value.                                                            	

; 	 ------------------------------------------------------------------------------------ 	
; 	 The PEFRelocField macro is a utility for extracting relocation instruction fields.   	

; 	 =========================================================================================== 	
; 	 Basic Relocation Opcodes 	
; 	 ------------------------ 	
; 	 -------------------------------------------------------------------------------------------- 	
; 	 The number of opcode bits varies from 2 to 7.  The enumeration and switch table given here   	
; 	 are defined in terms of the most significant 7 bits of the first instruction chunk.  An      	
; 	 instruction is decoded by using the most significant 7 bits as an index into the opcode      	
; 	 table, which in turn contains appropriately masked forms of the most significant 7 bits.     	
; 	 The macro PEFRelocBasicOpcode assumes a declaration of the form.                             	
; 	                                                                                              	
; 	      UInt8 kPEFRelocBasicOpcodes [kPEFRelocBasicOpcodeRange] = ( PEFMaskedBasicOpcodes );    	

(defconstant $kPEFRelocBasicOpcodeRange 128)

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The relocation opcodes, clustered by major and minor groups.  The instructions within a      	
; 	 cluster all have the same bit field layout.  The enumeration values use the high order 7     	
; 	 bits of the relocation instruction.  Unused low order bits are set to zero.                  	
(defconstant $kPEFRelocBySectDWithSkip #x0)     ;   Binary: 00x_xxxx 
(defconstant $kPEFRelocBySectC #x20)            ;   Binary: 010_0000, group is "RelocRun" 
(defconstant $kPEFRelocBySectD #x21)            ;   Binary: 010_0001 
(defconstant $kPEFRelocTVector12 #x22)          ;   Binary: 010_0010 
(defconstant $kPEFRelocTVector8 #x23)           ;   Binary: 010_0011 
(defconstant $kPEFRelocVTable8 #x24)            ;   Binary: 010_0100 
(defconstant $kPEFRelocImportRun #x25)          ;   Binary: 010_0101 
(defconstant $kPEFRelocSmByImport #x30)         ;   Binary: 011_0000, group is "RelocSmIndex" 
(defconstant $kPEFRelocSmSetSectC #x31)         ;   Binary: 011_0001 
(defconstant $kPEFRelocSmSetSectD #x32)         ;   Binary: 011_0010 
(defconstant $kPEFRelocSmBySection #x33)        ;   Binary: 011_0011 
(defconstant $kPEFRelocIncrPosition #x40)       ;   Binary: 100_0xxx 
(defconstant $kPEFRelocSmRepeat #x48)           ;   Binary: 100_1xxx 
(defconstant $kPEFRelocSetPosition #x50)        ;   Binary: 101_000x 
(defconstant $kPEFRelocLgByImport #x52)         ;   Binary: 101_001x 
(defconstant $kPEFRelocLgRepeat #x58)           ;   Binary: 101_100x 
(defconstant $kPEFRelocLgSetOrBySection #x5A)   ;   Binary: 101_101x 
(defconstant $kPEFRelocUndefinedOpcode #xFF)    ;   Used in masking table for all undefined values. 

; 	 ---------------------------------------------------------------------------- 	
; 	 The RelocLgSetOrBySection instruction has an additional 4 bits of subopcode  	
; 	 beyond the 7 used by the dispatch table.  To be precise it has 6 plus 4 but  	
; 	 the dispatch table ignores the 7th bit, so the subdispatch is on all 4 extra 	
; 	 subopcode bits.                                                              	
(defconstant $kPEFRelocLgBySectionSubopcode #x0);   Binary: 0000 
(defconstant $kPEFRelocLgSetSectCSubopcode #x1) ;   Binary: 0001 
(defconstant $kPEFRelocLgSetSectDSubopcode #x2) ;   Binary: 0010 

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The initial values for the opcode "masking" table.  This has the enumeration values from     	
; 	 above with appropriate replications for "don't care" bits.  It is almost certainly shorter   	
; 	 and faster to look up the masked value in a table than to use a branch tree.                 	

; 	 =========================================================================================== 	
; 	 RelocBySectDWithSkip Instruction (DDAT) 	
; 	 --------------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocBySectDWithSkip" (DDAT) instruction has the following bit field layout.            	
; 	                                                                                              	
; 	                           1         1                                                        	
; 	       0 1 2             9 0         5                                                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |0 0| skip count    | rel count |                                                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      | 2 |<-- 8 bits --->|<--  6 --->|                                                       	
; 	                                                                                              	
; 	 ! Note that the stored skip count and reloc count are the actual values!                     	
(defconstant $kPEFRelocWithSkipMaxSkipCount 255)
(defconstant $kPEFRelocWithSkipMaxRelocCount 63)

; 	 =========================================================================================== 	
; 	 RelocRun Group (CODE, DATA, DESC, DSC2, VTBL, SYMR) 	
; 	 --------------------------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocRun" group includes the "RelocBySectC" (CODE), "RelocBySectD" (DATA),              	
; 	 "RelocTVector12" (DESC), "RelocTVector8" (DSC2), "RelocVTable8" (VTBL), and                  	
; 	 "RelocImportRun" (SYMR) instructions.  This group has the following bit field layout.        	
; 	                                                                                              	
; 	                                     1                                                        	
; 	       0   2 3     6 7               5                                                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |0 1 0| subop.| run length      |                                                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |  3  |<- 4 ->|<-- 9 bits ----->|                                                       	
; 	                                                                                              	
; 	 ! Note that the stored run length is the actual value minus 1, but the macros deal with the  	
; 	 ! actual value!                                                                              	
(defconstant $kPEFRelocRunMaxRunLength 512)

; 	 =========================================================================================== 	
; 	 RelocSmIndex Group (SYMB, CDIS, DTIS, SECN) 	
; 	 ------------------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocSmIndex" group includes the "RelocSmByImport" (SYMB), "RelocSmSetSectC" (CDIS),    	
; 	 "RelocSmSetSectD" (DTIS) and "RelocSmBySection" (SECN) instructions.  This group has the     	
; 	 following bit field layout.                                                                  	
; 	                                                                                              	
; 	                                     1                                                        	
; 	       0   2 3     6 7               5                                                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |0 1 1| subop.| index           |                                                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |  3  |<- 4 ->|<-- 9 bits ----->|                                                       	
; 	                                                                                              	
; 	 ! Note that the stored index is the actual value!                                            	
(defconstant $kPEFRelocSmIndexMaxIndex 511)

; 	 =========================================================================================== 	
; 	 RelocIncrPosition Instruction (DELT) 	
; 	 ------------------------------------ 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocIncrPosition" (DELT) instruction has the following bit field layout.               	
; 	                                                                                              	
; 	                                     1                                                        	
; 	       0     3 4                     5                                                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |1 0 0 0| offset                |                                                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |<- 4 ->|<-- 12 bits ---------->|                                                       	
; 	                                                                                              	
; 	 ! Note that the stored offset is the actual value minus 1, but the macros deal with the      	
; 	 ! actual value!                                                                              	
(defconstant $kPEFRelocIncrPositionMaxOffset 4096)

; 	 =========================================================================================== 	
; 	 RelocSmRepeat Instruction (RPT) 	
; 	 ------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocSmRepeat" (RPT) instruction has the following bit field layout.                    	
; 	                                                                                              	
; 	                                     1                                                        	
; 	       0     3 4     7 8             5                                                        	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |1 0 0 1| chnks | repeat count  |                                                       	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                                                       	
; 	      |<- 4 ->|<- 4 ->|<-- 8 bits --->|                                                       	
; 	                                                                                              	
; 	 ! Note that the stored chunk count and repeat count are the actual values minus 1, but the   	
; 	 ! macros deal with the actual values!                                                        	
(defconstant $kPEFRelocSmRepeatMaxChunkCount 16)
(defconstant $kPEFRelocSmRepeatMaxRepeatCount 256)

; 	 =========================================================================================== 	
; 	 RelocSetPosition Instruction (LABS) 	
; 	 ----------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocSetPosition" (LABS) instruction has the following bit field layout.                	
; 	                                                                                              	
; 	                                     1                                   1                    	
; 	       0         5 6                 5     0                             5                    	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |1 0 1 0 0 0| offset (high)     |   | offset (low)                  |                   	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |<-- 6 ---->|<-- 10 bits ------>|   |<-- 16 bits ------------------>|                   	
; 	                                                                                              	
; 	 ! Note that the stored offset is the actual value!                                           	
(defconstant $kPEFRelocSetPosMaxOffset #x3FFFFFF);   67,108,863 

; 	 =========================================================================================== 	
; 	 RelocLgByImport Instruction (LSYM) 	
; 	 ---------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocLgByImport" (LSYM) instruction has the following bit field layout.                 	
; 	                                                                                              	
; 	                                     1                                   1                    	
; 	       0         5 6                 5     0                             5                    	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |1 0 1 0 0 1| index (high)      |   | index (low)                   |                   	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |<-- 6 ---->|<-- 10 bits ------>|   |<-- 16 bits ------------------>|                   	
; 	                                                                                              	
; 	 ! Note that the stored offset is the actual value!                                           	
(defconstant $kPEFRelocLgByImportMaxIndex #x3FFFFFF);   67,108,863 

; 	 =========================================================================================== 	
; 	 RelocLgRepeat Instruction (LRPT) 	
; 	 -------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocLgRepeat" (LRPT) instruction has the following bit field layout.                   	
; 	                                                                                              	
; 	                           1         1                                   1                    	
; 	       0         5 6     9 0         5     0                             5                    	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |1 0 1 1 0 0| chnks | rpt (high)|   | repeat count (low)            |                   	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |<--  6 --->|<- 4 ->|<--  6 --->|   |<-- 16 bits ------------------>|                   	
; 	                                                                                              	
; 	 ! Note that the stored chunk count is the actual value minus 1, but the macros deal with     	
; 	 ! the actual value!  The stored repeat count is the actual value!                            	
(defconstant $kPEFRelocLgRepeatMaxChunkCount 16)
(defconstant $kPEFRelocLgRepeatMaxRepeatCount #x3FFFFF);   4,194,303 

; 	 =========================================================================================== 	
; 	 RelocLgSetOrBySection Group (LSEC) 	
; 	 ---------------------------------- 	

; 	 -------------------------------------------------------------------------------------------- 	
; 	 The "RelocLgSetOrBySection" (LSEC) instruction is a group including the "RelocLgBySection",  	
; 	 "RelocLgSetSectC" and "RelocLgSetSectD" instructions.  This group has the following bit      	
; 	 field layout.                                                                                	
; 	                                                                                              	
; 	                           1         1                                   1                    	
; 	       0         5 6     9 0         5     0                             5                    	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |1 0 1 1 0 1| subop | idx (high)|   | index (low)                   |                   	
; 	      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                   	
; 	      |<--  6 --->|<- 4 ->|<--  6 --->|   |<-- 16 bits ------------------>|                   	
; 	                                                                                              	
; 	 ! Note that the stored index is the actual value!                                            	
(defconstant $kPEFRelocLgSetOrBySectionMaxIndex #x3FFFFF);   4,194,303 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PEFBinaryFormatIncludes

; $ENDC                                         ; __PEFBINARYFORMAT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PEFBinaryFormat)