(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PictUtils.p"
; at Wednesday May 1,2002 2:40:31 pm.
; 
;      File:       PictUtils.p
;  
;      Contains:   Picture Utilities Interfaces.
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PICTUTILS__
; $SETC __PICTUTILS__ := 1

; $I+
; $SETC PictUtilsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PALETTES__
|#

(require-interface 'Palettes)
#|                                              ; $I Palettes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  verbs for the GetPictInfo, GetPixMapInfo, and NewPictInfo calls 

(defconstant $returnColorTable #x1)
(defconstant $returnPalette #x2)
(defconstant $recordComments #x4)
(defconstant $recordFontInfo #x8)
(defconstant $suppressBlackAndWhite #x10)

;   color pick methods  
(defconstant $systemMethod 0)                   ;   system color pick method  
(defconstant $popularMethod 1)                  ;   method that chooses the most popular set of colors  
(defconstant $medianMethod 2)                   ;   method that chooses a good average mix of colors  

;   color bank types  
(defconstant $ColorBankIsCustom -1)
(defconstant $ColorBankIsExactAnd555 0)
(defconstant $ColorBankIs555 1)

(def-mactype :pictinfoid (find-mactype ':signed-long))
(def-mactype :commentspecptr (find-mactype '(:pointer :commentspec)))
(defrecord CommentSpec 
   (count :signed-integer)                      ;   number of occurrances of this comment ID  
   (ID :signed-integer)                         ;   ID for the comment in the picture  
   )

(def-mactype :commentspechandle (find-mactype '(:handle :commentspec)))
(def-mactype :fontspecptr (find-mactype '(:pointer :fontspec)))
(defrecord FontSpec 
   (pictFontID :signed-integer)                 ;   ID of the font in the picture  
   (sysFontID :signed-integer)                  ;   ID of the same font in the current system file  
   (size (:array :signed-long 4))               ;   bit array of all the sizes found (1..127) (bit 0 means > 127)  
   (style :signed-integer)                      ;   combined style of all occurrances of the font  
   (nameOffset :signed-long)                    ;   offset into the fontNamesHdl handle for the fonts name  
   )

(def-mactype :fontspechandle (find-mactype '(:handle :fontspec)))
(def-mactype :pictinfoptr (find-mactype '(:pointer :pictinfo)))
(defrecord PictInfo 
   (version :signed-integer)                    ;   this is always zero, for now  
   (uniqueColors :signed-long)                  ;   the number of actual colors in the picture(s)/pixmap(s)  
   (thePalette (:handle :palette))              ;   handle to the palette information  
   (theColorTable (:handle :colortable))        ;   handle to the color table  
   (hRes :signed-long)                          ;   maximum horizontal resolution for all the pixmaps  
   (vRes :signed-long)                          ;   maximum vertical resolution for all the pixmaps  
   (depth :signed-integer)                      ;   maximum depth for all the pixmaps (in the picture)  
   (sourceRect :rect)                           ;   the picture frame rectangle (this contains the entire picture)  
   (textCount :signed-long)                     ;   total number of text strings in the picture  
   (lineCount :signed-long)                     ;   total number of lines in the picture  
   (rectCount :signed-long)                     ;   total number of rectangles in the picture  
   (rRectCount :signed-long)                    ;   total number of round rectangles in the picture  
   (ovalCount :signed-long)                     ;   total number of ovals in the picture  
   (arcCount :signed-long)                      ;   total number of arcs in the picture  
   (polyCount :signed-long)                     ;   total number of polygons in the picture  
   (regionCount :signed-long)                   ;   total number of regions in the picture  
   (bitMapCount :signed-long)                   ;   total number of bitmaps in the picture  
   (pixMapCount :signed-long)                   ;   total number of pixmaps in the picture  
   (commentCount :signed-long)                  ;   total number of comments in the picture  
   (uniqueComments :signed-long)                ;   the number of unique comments in the picture  
   (commentHandle (:handle :commentspec))       ;   handle to all the comment information  
   (uniqueFonts :signed-long)                   ;   the number of unique fonts in the picture  
   (fontHandle (:handle :fontspec))             ;   handle to the FontSpec information  
   (fontNamesHandle :handle)                    ;   handle to the font names  
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   )

(def-mactype :pictinfohandle (find-mactype '(:handle :pictinfo)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	InitPickMethodProcPtr = FUNCTION(colorsRequested: SInt16; VAR dataRef: UInt32; VAR colorBankType: SInt16): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :initpickmethodprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	RecordColorsProcPtr = FUNCTION(dataRef: UInt32; VAR colorsArray: RGBColor; colorCount: SInt32; VAR uniqueColors: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :recordcolorsprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CalcColorTableProcPtr = FUNCTION(dataRef: UInt32; colorsRequested: SInt16; colorBankPtr: UNIV Ptr; VAR resultPtr: CSpecArray): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :calccolortableprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DisposeColorPickMethodProcPtr = FUNCTION(dataRef: UInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :disposecolorpickmethodprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :initpickmethodupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :initpickmethodupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :recordcolorsupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :recordcolorsupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :calccolortableupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :calccolortableupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :disposecolorpickmethodupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :disposecolorpickmethodupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppInitPickMethodProcInfo #xFA0)
(defconstant $uppRecordColorsProcInfo #x3FE0)
(defconstant $uppCalcColorTableProcInfo #x3EE0)
(defconstant $uppDisposeColorPickMethodProcInfo #xE0)
; 
; 	 *  NewInitPickMethodUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewInitPickMethodProc 
(deftrap "_NewInitPickMethodUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewRecordColorsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewRecordColorsProc 
(deftrap "_NewRecordColorsUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCalcColorTableUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewCalcColorTableProc 
(deftrap "_NewCalcColorTableUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDisposeColorPickMethodUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDisposeColorPickMethodProc 
(deftrap "_NewDisposeColorPickMethodUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeInitPickMethodUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeInitPickMethodUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeRecordColorsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeRecordColorsUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCalcColorTableUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCalcColorTableUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDisposeColorPickMethodUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDisposeColorPickMethodUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeInitPickMethodUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallInitPickMethodProc 
(deftrap-inline "_InvokeInitPickMethodUPP" 
      ((colorsRequested :signed-integer) (dataRef (:pointer :unsigned-long)) (colorBankType (:pointer :signed-integer)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeRecordColorsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallRecordColorsProc 
(deftrap-inline "_InvokeRecordColorsUPP" 
      ((dataRef :unsigned-long) (colorsArray (:pointer :rgbcolor)) (colorCount :signed-long) (uniqueColors (:pointer :signed-long)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeCalcColorTableUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallCalcColorTableProc 
(deftrap-inline "_InvokeCalcColorTableUPP" 
      ((dataRef :unsigned-long) (colorsRequested :signed-integer) (colorBankPtr :pointer) (resultPtr (:pointer :cspecarray)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeDisposeColorPickMethodUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDisposeColorPickMethodProc 
(deftrap-inline "_InvokeDisposeColorPickMethodUPP" 
      ((dataRef :unsigned-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  GetPictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPictInfo" 
      ((thePictHandle (:handle :picture)) (thePictInfo (:pointer :pictinfo)) (verb :signed-integer) (colorsRequested :signed-integer) (colorPickMethod :signed-integer) (version :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 2048 thePictHandle thePictInfo verb colorsRequested colorPickMethod version))

; 
;  *  GetPixMapInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPixMapInfo" 
      ((thePixMapHandle (:handle :pixmap)) (thePictInfo (:pointer :pictinfo)) (verb :signed-integer) (colorsRequested :signed-integer) (colorPickMethod :signed-integer) (version :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 2049 thePixMapHandle thePictInfo verb colorsRequested colorPickMethod version))

; 
;  *  NewPictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewPictInfo" 
      ((thePictInfoID (:pointer :signed-long)) (verb :signed-integer) (colorsRequested :signed-integer) (colorPickMethod :signed-integer) (version :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 1538 thePictInfoID verb colorsRequested colorPickMethod version))

; 
;  *  RecordPictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RecordPictInfo" 
      ((thePictInfoID :signed-long) (thePictHandle (:handle :picture)))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 1027 thePictInfoID thePictHandle))

; 
;  *  RecordPixMapInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RecordPixMapInfo" 
      ((thePictInfoID :signed-long) (thePixMapHandle (:handle :pixmap)))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 1028 thePictInfoID thePixMapHandle))

; 
;  *  RetrievePictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RetrievePictInfo" 
      ((thePictInfoID :signed-long) (thePictInfo (:pointer :pictinfo)) (colorsRequested :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 1285 thePictInfoID thePictInfo colorsRequested))

; 
;  *  DisposePictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposePictInfo" 
      ((thePictInfoID :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 518 thePictInfoID))

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DisposPictInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposPictInfo" 
      ((thePictInfoID :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA831 :d0 518 thePictInfoID))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PictUtilsIncludes

; $ENDC                                         ; __PICTUTILS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PictUtils)