(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3D.p"
; at Wednesday May 1,2002 2:42:18 pm.
; 
;      File:       QD3D.p
;  
;      Contains:   Base types for Quickdraw 3D
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3D__
; $SETC __QD3D__ := 1

; $I+
; $SETC QD3DIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

; $IFC TARGET_OS_MAC 
; $SETC OS_MACINTOSH := 1 
; $SETC OS_WIN32 := 0 
; $SETC OS_UNIX := 0 
; $SETC OS_NEXT := 0 
; $SETC WINDOW_SYSTEM_MACINTOSH := 1 
; $SETC WINDOW_SYSTEM_WIN32 := 0 
; $SETC WINDOW_SYSTEM_X11 := 0 
; $SETC WINDOW_SYSTEM_NEXT := 0 
; $ENDC                                         ; TARGET_OS_MAC

; *****************************************************************************
;  **                                                                          **
;  **                             NULL definition                              **
;  **                                                                          **
;  ****************************************************************************
; *****************************************************************************
;  **                                                                          **
;  **                                 Objects                                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  * Everything in QuickDraw 3D is an OBJECT: a bunch of data with a type,
;  * deletion, duplication, and i/o methods.
;  

(def-mactype :tq3objecttype (find-mactype ':signed-long))
(def-mactype :tq3objecttypeptr (find-mactype '(:pointer :signed-long)))
(def-mactype :tq3object (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3objectptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3Object parameter can be nil, it is changed to xx: TQ3ObjectPtr 
;    
; 	
; 	 * There are four subclasses of OBJECT:
; 	 *  an ELEMENT, which is data that is placed in a SET
; 	 *  a SHAREDOBJECT, which is reference-counted data that is shared
; 	 *  VIEWs, which maintain state information for an image
; 	 *  a PICK, which used to query a VIEW
; 	 	
(def-mactype :tq3elementobject (find-mactype ':pointer))
(def-mactype :tq3sharedobject (find-mactype ':pointer))
(def-mactype :tq3viewobject (find-mactype ':pointer))
(def-mactype :tq3pickobject (find-mactype ':pointer))
; 	
; 	 * There are several types of SharedObjects:
; 	 *  RENDERERs, which paint to a drawContext
; 	 *  DRAWCONTEXTs, which are an interface to a device 
; 	 *  SETs, which maintains "mathematical sets" of ELEMENTs
; 	 *  FILEs, which maintain state information for a metafile
; 	 *  SHAPEs, which affect the state of the View
; 	 *  SHAPEPARTs, which contain geometry-specific data about a picking hit
; 	 *  CONTROLLERSTATEs, which hold state of the output channels for a CONTROLLER
; 	 *  TRACKERs, which represent a position and orientation in the user interface
; 	 *  STRINGs, which are abstractions of text string data.
; 	 *  STORAGE, which is an abstraction for stream-based data storage (files, memory)
; 	 *  TEXTUREs, for sharing bitmap information for TEXTURESHADERS
; 	 *  VIEWHINTs, which specifies viewing preferences in FILEs
; 	 	
(def-mactype :tq3rendererobject (find-mactype ':pointer))
(def-mactype :tq3drawcontextobject (find-mactype ':pointer))
(def-mactype :tq3setobject (find-mactype ':pointer))
(def-mactype :tq3fileobject (find-mactype ':pointer))
(def-mactype :tq3shapeobject (find-mactype ':pointer))
(def-mactype :tq3shapepartobject (find-mactype ':pointer))
(def-mactype :tq3controllerstateobject (find-mactype ':pointer))
(def-mactype :tq3trackerobject (find-mactype ':pointer))
(def-mactype :tq3stringobject (find-mactype ':pointer))
(def-mactype :tq3storageobject (find-mactype ':pointer))
(def-mactype :tq3textureobject (find-mactype ':pointer))
(def-mactype :tq3viewhintsobject (find-mactype ':pointer))
; 	
; 	 * There is one types of SET:
; 	 *  ATTRIBUTESETs, which contain ATTRIBUTEs which are inherited 
; 	 	
(def-mactype :tq3attributeset (find-mactype ':pointer))
(def-mactype :tq3attributesetptr (find-mactype '(:pointer :pointer)))
; 	
; 	 * There are many types of SHAPEs:
; 	 *  LIGHTs, which affect how the RENDERER draws 3-D cues
; 	 *  CAMERAs, which affects the location and orientation of the RENDERER in space
; 	 *  GROUPs, which may contain any number of SHARED OBJECTS
; 	 *  GEOMETRYs, which are representations of three-dimensional data
; 	 *  SHADERs, which affect how colors are drawn on a geometry
; 	 *  STYLEs, which affect how the RENDERER paints to the DRAWCONTEXT
; 	 *  TRANSFORMs, which affect the coordinate system in the VIEW
; 	 *  REFERENCEs, which are references to objects in FILEs
; 	 *  UNKNOWN, which hold unknown objects read from a metafile.
; 	 	
(def-mactype :tq3groupobject (find-mactype ':pointer))
(def-mactype :tq3geometryobject (find-mactype ':pointer))
(def-mactype :tq3shaderobject (find-mactype ':pointer))
(def-mactype :tq3styleobject (find-mactype ':pointer))
(def-mactype :tq3transformobject (find-mactype ':pointer))
(def-mactype :tq3lightobject (find-mactype ':pointer))
(def-mactype :tq3cameraobject (find-mactype ':pointer))
(def-mactype :tq3unknownobject (find-mactype ':pointer))
(def-mactype :tq3referenceobject (find-mactype ':pointer))
(def-mactype :tq3stateoperatorobject (find-mactype ':pointer))
; 	
; 	 * For now, there is only one type of SHAPEPARTs:
; 	 *  MESHPARTs, which describe some part of a mesh
; 	 	
(def-mactype :tq3meshpartobject (find-mactype ':pointer))
; 	
; 	 * There are three types of MESHPARTs:
; 	 *  MESHFACEPARTs, which describe a face of a mesh
; 	 *  MESHEDGEPARTs, which describe a edge of a mesh
; 	 *  MESHVERTEXPARTs, which describe a vertex of a mesh
; 	 	
(def-mactype :tq3meshfacepartobject (find-mactype ':pointer))
(def-mactype :tq3meshedgepartobject (find-mactype ':pointer))
(def-mactype :tq3meshvertexpartobject (find-mactype ':pointer))
; 	
; 	 * A DISPLAY Group can be drawn to a view
; 	 	
(def-mactype :tq3displaygroupobject (find-mactype ':pointer))
; 	
; 	 * There are many types of SHADERs:
; 	 *  SURFACESHADERs, which affect how the surface of a geometry is painted
; 	 *  ILLUMINATIONSHADERs, which affect how lights affect the color of a surface
; 	 	
(def-mactype :tq3surfaceshaderobject (find-mactype ':pointer))
(def-mactype :tq3illuminationshaderobject (find-mactype ':pointer))
; 	
; 	 * A handle to an object in a group
; 	 	
(def-mactype :tq3groupposition (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3grouppositionptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3GroupPosition parameter can be nil, it is changed to xx: TQ3GroupPositionPtr 
; 	 
; 	 * TQ3ObjectClassNameString is used for the class name of an object
; 	 	

(defconstant $kQ3StringMaximumLength 1024)

(defrecord TQ3ObjectClassNameString (array (:array :character 1024 :packed)))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Client/Server Things                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3controllerref (find-mactype ':pointer))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Flags and Switches                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3boolean (find-mactype ':signed-long))

(defconstant $kQ3False 0)
(defconstant $kQ3True 1)

(def-mactype :tq3switch (find-mactype ':signed-long))

(defconstant $kQ3Off 0)
(defconstant $kQ3On 1)

(def-mactype :tq3status (find-mactype ':signed-long))

(defconstant $kQ3Failure 0)
(defconstant $kQ3Success 1)

(def-mactype :tq3axis (find-mactype ':signed-long))

(defconstant $kQ3AxisX 0)
(defconstant $kQ3AxisY 1)
(defconstant $kQ3AxisZ 2)

(def-mactype :tq3pixeltype (find-mactype ':signed-long))

(defconstant $kQ3PixelTypeRGB32 0)              ;   Alpha:8 (ignored), R:8, G:8, B:8    
(defconstant $kQ3PixelTypeARGB32 1)             ;   Alpha:8, R:8, G:8, B:8           
(defconstant $kQ3PixelTypeRGB16 2)              ;   Alpha:1 (ignored), R:5, G:5, B:5    
(defconstant $kQ3PixelTypeARGB16 3)             ;   Alpha:1, R:5, G:5, B:5           
(defconstant $kQ3PixelTypeRGB16_565 4)          ;   Win32 only: 16 bits/pixel, R:5, G:6, B:5      
(defconstant $kQ3PixelTypeRGB24 5)              ;   Win32 only: 24 bits/pixel, R:8, G:8, B:8      

(def-mactype :tq3endian (find-mactype ':signed-long))

(defconstant $kQ3EndianBig 0)
(defconstant $kQ3EndianLittle 1)

(def-mactype :tq3endcapmasks (find-mactype ':signed-long))

(defconstant $kQ3EndCapNone 0)
(defconstant $kQ3EndCapMaskTop #x1)
(defconstant $kQ3EndCapMaskBottom #x2)
(defconstant $kQ3EndCapMaskInterior #x4)

(def-mactype :tq3endcap (find-mactype ':unsigned-long))

(defconstant $kQ3ArrayIndexNULL -1)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Point and Vector Definitions                         **
; 	 **                                                                          **
; 	 ****************************************************************************	

(def-mactype :tq3vector2dptr (find-mactype '(:pointer :tq3vector2d)))
(defrecord TQ3Vector2D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
   )

(def-mactype :tq3vector3dptr (find-mactype '(:pointer :tq3vector3d)))
(defrecord TQ3Vector3D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)
   )

(def-mactype :tq3point2dptr (find-mactype '(:pointer :tq3point2d)))
(defrecord TQ3Point2D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
   )

(def-mactype :tq3point3dptr (find-mactype '(:pointer :tq3point3d)))
(defrecord TQ3Point3D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)
   )

(def-mactype :tq3rationalpoint4dptr (find-mactype '(:pointer :tq3rationalpoint4d)))
(defrecord TQ3RationalPoint4D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (w :single-float)
   )

(def-mactype :tq3rationalpoint3dptr (find-mactype '(:pointer :tq3rationalpoint3d)))
(defrecord TQ3RationalPoint3D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (w :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Quaternion                                   **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3quaternionptr (find-mactype '(:pointer :tq3quaternion)))
(defrecord TQ3Quaternion 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (w :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Ray Definition                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3ray3dptr (find-mactype '(:pointer :tq3ray3d)))
(defrecord TQ3Ray3D 
   (origin :tq3point3d)
   (direction :tq3vector3d)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Parameterization Data Structures                     **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3param2dptr (find-mactype '(:pointer :tq3param2d)))
(defrecord TQ3Param2D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (u :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (v :single-float)
   )

(def-mactype :tq3param3dptr (find-mactype '(:pointer :tq3param3d)))
(defrecord TQ3Param3D 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (u :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (v :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (w :single-float)
   )

(def-mactype :tq3tangent2dptr (find-mactype '(:pointer :tq3tangent2d)))
(defrecord TQ3Tangent2D 
   (uTangent :tq3vector3d)
   (vTangent :tq3vector3d)
   )

(def-mactype :tq3tangent3dptr (find-mactype '(:pointer :tq3tangent3d)))
(defrecord TQ3Tangent3D 
   (uTangent :tq3vector3d)
   (vTangent :tq3vector3d)
   (wTangent :tq3vector3d)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Polar and Spherical Coordinates                      **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3polarpointptr (find-mactype '(:pointer :tq3polarpoint)))
(defrecord TQ3PolarPoint 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (r :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (theta :single-float)
   )

(def-mactype :tq3sphericalpointptr (find-mactype '(:pointer :tq3sphericalpoint)))
(defrecord TQ3SphericalPoint 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (rho :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (theta :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (phi :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Color Definition                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3colorrgbptr (find-mactype '(:pointer :tq3colorrgb)))
(defrecord TQ3ColorRGB 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (r :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (g :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (b :single-float)
   )

(def-mactype :tq3colorargbptr (find-mactype '(:pointer :tq3colorargb)))
(defrecord TQ3ColorARGB 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (a :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (r :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (g :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (b :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                 Vertices                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3vertex3dptr (find-mactype '(:pointer :tq3vertex3d)))
(defrecord TQ3Vertex3D 
   (point :tq3point3d)
   (attributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                 Matrices                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3matrix3x3ptr (find-mactype '(:pointer :tq3matrix3x3)))
(defrecord TQ3Matrix3x3 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (value (:array :single-float 3 3))
   )

(def-mactype :tq3matrix4x4ptr (find-mactype '(:pointer :tq3matrix4x4)))
(defrecord TQ3Matrix4x4 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (value (:array :single-float 4 4))
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Bitmap/Pixmap                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3pixmapptr (find-mactype '(:pointer :tq3pixmap)))
(defrecord TQ3Pixmap 
   (image :pointer)
   (width :unsigned-long)
   (height :unsigned-long)
   (rowBytes :unsigned-long)
   (pixelSize :unsigned-long)                   ;   MUST be 16 or 32 to use with the   Interactive Renderer on Mac OS 
   (pixelType :signed-long)
   (bitOrder :signed-long)
   (byteOrder :signed-long)
   )

(def-mactype :tq3storagepixmapptr (find-mactype '(:pointer :tq3storagepixmap)))
(defrecord TQ3StoragePixmap 
   (image :pointer)
   (width :unsigned-long)
   (height :unsigned-long)
   (rowBytes :unsigned-long)
   (pixelSize :unsigned-long)                   ;   MUST be 16 or 32 to use with the   Interactive Renderer on Mac OS 
   (pixelType :signed-long)
   (bitOrder :signed-long)
   (byteOrder :signed-long)
   )

(def-mactype :tq3bitmapptr (find-mactype '(:pointer :tq3bitmap)))
(defrecord TQ3Bitmap 
   (image :pointer)
   (width :unsigned-long)
   (height :unsigned-long)
   (rowBytes :unsigned-long)
   (bitOrder :signed-long)
   )

(def-mactype :tq3mipmapimageptr (find-mactype '(:pointer :tq3mipmapimage)))
(defrecord TQ3MipmapImage 
;   An image for use as a texture mipmap   
   (width :unsigned-long)                       ;   Width of mipmap, must be power of 2    
   (height :unsigned-long)                      ;   Height of mipmap, must be power of 2   
   (rowBytes :unsigned-long)                    ;   Rowbytes of mipmap                     
   (offset :unsigned-long)                      ;   Offset from image base to this mipmap  
   )

(def-mactype :tq3mipmapptr (find-mactype '(:pointer :tq3mipmap)))
(defrecord TQ3Mipmap 
   (image :pointer)                             ;   Data containing the texture map and      
;   if (useMipmapping==kQ3True) the        
;   mipmap data                   
   (useMipmapping :signed-long)                 ;   True if mipmapping should be used    
;   and all mipmaps have been provided     
   (pixelType :signed-long)
   (bitOrder :signed-long)
   (byteOrder :signed-long)
   (reserved :unsigned-long)                    ;   leave NULL for next version           
   (mipmaps (:array :tq3mipmapimage 32))        ;   The actual number of mipmaps is determined from the size of the first mipmap  
   )

(def-mactype :tq3compressedpixmapptr (find-mactype '(:pointer :tq3compressedpixmap)))
(defrecord TQ3CompressedPixmap 
   (compressedImage :pointer)                   ;   storage obj containing compressed image data  
   (imageDescByteOrder :signed-long)            ;   endianness of the data in the imageDesc  
   (imageDesc :pointer)                         ;   storage obj containing image description created by Quicktime to store info about compressed image  
   (makeMipmaps :signed-long)
   (width :unsigned-long)
   (height :unsigned-long)
   (pixelSize :unsigned-long)
   (pixelType :signed-long)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Higher dimension quantities                          **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3areaptr (find-mactype '(:pointer :tq3area)))
(defrecord TQ3Area 
   (min :tq3point2d)
   (max :tq3point2d)
   )

(def-mactype :tq3planeequationptr (find-mactype '(:pointer :tq3planeequation)))
(defrecord TQ3PlaneEquation 
   (normal :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (constant :single-float)
   )

(def-mactype :tq3boundingboxptr (find-mactype '(:pointer :tq3boundingbox)))
(defrecord TQ3BoundingBox 
   (min :tq3point3d)
   (max :tq3point3d)
   (isEmpty :signed-long)
   )

(def-mactype :tq3boundingsphereptr (find-mactype '(:pointer :tq3boundingsphere)))
(defrecord TQ3BoundingSphere 
   (origin :tq3point3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (radius :single-float)
   (isEmpty :signed-long)
   )

; 	
; 	 *  The TQ3ComputeBounds flag passed to StartBoundingBox or StartBoundingSphere
; 	 *  calls in the View. It's a hint to the system as to how it should 
; 	 *  compute the bbox of a shape:
; 	 *
; 	 *  kQ3ComputeBoundsExact:  
; 	 *      Vertices of shapes are transformed into world space and
; 	 *      the world space bounding box is computed from them.  Slow!
; 	 *  
; 	 *  kQ3ComputeBoundsApproximate: 
; 	 *      A local space bounding box is computed from a shape's
; 	 *      vertices.  This bbox is then transformed into world space,
; 	 *      and its bounding box is taken as the shape's approximate
; 	 *      bbox.  Fast but the bbox is larger than optimal.
; 	 	
(def-mactype :tq3computebounds (find-mactype ':signed-long))

(defconstant $kQ3ComputeBoundsExact 0)
(defconstant $kQ3ComputeBoundsApproximate 1)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Object System Types                              **
; 	 **                                                                          **
; 	 ****************************************************************************	

(def-mactype :tq3xobjectclass (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3xobjectclassptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3XObjectClass parameter can be nil, it is changed to xx: TQ3XObjectClassPtr 
(def-mactype :tq3xmethodtype (find-mactype ':unsigned-long))
; 	
; 	 * Object methods
; 	 	
; 	 
; 	 *  Return true from the metahandler if this 
; 	 *  object can be submitted in a rendering loop 
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XFunctionPointer = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xfunctionpointer (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XMetaHandler = FUNCTION(methodType: TQ3XMethodType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xmetahandler (find-mactype ':pointer))
; $ENDC

; 	
; 	 * MetaHandler:
; 	 *      When you give a metahandler to QuickDraw 3D, it is called multiple 
; 	 *      times to build method tables, and then is thrown away. You are 
; 	 *      guaranteed that your metahandler will never be called again after a 
; 	 *      call that was passed a metahandler returns.
; 	 *
; 	 *      Your metahandler should contain a switch on the methodType passed to it
; 	 *      and should return the corresponding method as an TQ3XFunctionPointer.
; 	 *
; 	 *      IMPORTANT: A metaHandler MUST always "return" a value. If you are
; 	 *      passed a methodType that you do not understand, ALWAYS return NULL.
; 	 *
; 	 *      These types here are prototypes of how your functions should look.
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectUnregisterMethod = FUNCTION(objectClass: TQ3XObjectClass): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjectunregistermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 * See QD3DIO.h for the IO method types: 
; 	 *      ObjectReadData, ObjectTraverse, ObjectWrite
; 	 	

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Set Types                                    **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3elementtype (find-mactype ':signed-long))

(defconstant $kQ3ElementTypeNone 0)
(defconstant $kQ3ElementTypeUnknown 32)
(defconstant $kQ3ElementTypeSet 33)

; 	 
; 	 *  kQ3ElementTypeUnknown is a TQ3Object. 
; 	 *  
; 	 *      Do Q3Set_Add(s, ..., &obj) or Q3Set_Get(s, ..., &obj);
; 	 *      
; 	 *      Note that the object is always referenced when copying around. 
; 	 *      
; 	 *      Generally, it is an Unknown object, a Group of Unknown objects, or a 
; 	 *      group of other "objects" which have been found in the metafile and
; 	 *      have no attachment method to their parent. Be prepared to handle
; 	 *      any or all of these cases if you actually access the set on a shape.
; 	 *
; 	 *  kQ3ElementTypeSet is a TQ3SetObject. 
; 	 *  
; 	 *      Q3Shape_GetSet(s,&o) is eqivalent to 
; 	 *          Q3Shape_GetElement(s, kQ3ElementTypeSet, &o)
; 	 *          
; 	 *      Q3Shape_SetSet(s,o)  is eqivalent to 
; 	 *          Q3Shape_SetElement(s, kQ3ElementTypeSet, &o)
; 	 *  
; 	 *      Note that the object is always referenced when copying around. 
; 	 *      
; 	 *  See the note below about the Set and Shape changes.
; 	 	

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Object System Macros                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Object Types                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 * Note:    a call to Q3Foo_GetType will return a value kQ3FooTypeBar
; 	 *          e.g. Q3Shared_GetType(object) returns kQ3SharedTypeShape, etc.
; 	 	
(defconstant $kQ3ObjectTypeInvalid 0)
(defconstant $kQ3ObjectTypeView :|view|)
(defconstant $kQ3ObjectTypeElement :|elmn|)
(defconstant $kQ3ElementTypeAttribute :|eatt|)
(defconstant $kQ3ObjectTypePick :|pick|)
(defconstant $kQ3PickTypeWindowPoint :|pkwp|)
(defconstant $kQ3PickTypeWindowRect :|pkwr|)
(defconstant $kQ3PickTypeWorldRay :|pkry|)
(defconstant $kQ3ObjectTypeShared :|shrd|)
(defconstant $kQ3SharedTypeRenderer :|rddr|)
(defconstant $kQ3RendererTypeWireFrame :|wrfr|)
(defconstant $kQ3RendererTypeGeneric :|gnrr|)
(defconstant $kQ3RendererTypeInteractive :|ctwn|)
(defconstant $kQ3SharedTypeShape :|shap|)
(defconstant $kQ3ShapeTypeGeometry :|gmtr|)
(defconstant $kQ3GeometryTypeBox :|box |)
(defconstant $kQ3GeometryTypeGeneralPolygon :|gpgn|)
(defconstant $kQ3GeometryTypeLine :|line|)
(defconstant $kQ3GeometryTypeMarker :|mrkr|)
(defconstant $kQ3GeometryTypePixmapMarker :|mrkp|)
(defconstant $kQ3GeometryTypeMesh :|mesh|)
(defconstant $kQ3GeometryTypeNURBCurve :|nrbc|)
(defconstant $kQ3GeometryTypeNURBPatch :|nrbp|)
(defconstant $kQ3GeometryTypePoint :|pnt |)
(defconstant $kQ3GeometryTypePolygon :|plyg|)
(defconstant $kQ3GeometryTypePolyLine :|plyl|)
(defconstant $kQ3GeometryTypeTriangle :|trng|)
(defconstant $kQ3GeometryTypeTriGrid :|trig|)
(defconstant $kQ3GeometryTypeCone :|cone|)
(defconstant $kQ3GeometryTypeCylinder :|cyln|)
(defconstant $kQ3GeometryTypeDisk :|disk|)
(defconstant $kQ3GeometryTypeEllipse :|elps|)
(defconstant $kQ3GeometryTypeEllipsoid :|elpd|)
(defconstant $kQ3GeometryTypePolyhedron :|plhd|)
(defconstant $kQ3GeometryTypeTorus :|tors|)
(defconstant $kQ3GeometryTypeTriMesh :|tmsh|)
(defconstant $kQ3ShapeTypeShader :|shdr|)
(defconstant $kQ3ShaderTypeSurface :|sush|)
(defconstant $kQ3SurfaceShaderTypeTexture :|txsu|)
(defconstant $kQ3ShaderTypeIllumination :|ilsh|)
(defconstant $kQ3IlluminationTypePhong :|phil|)
(defconstant $kQ3IlluminationTypeLambert :|lmil|)
(defconstant $kQ3IlluminationTypeNULL :|nuil|)
(defconstant $kQ3ShapeTypeStyle :|styl|)
(defconstant $kQ3StyleTypeBackfacing :|bckf|)
(defconstant $kQ3StyleTypeInterpolation :|intp|)
(defconstant $kQ3StyleTypeFill :|fist|)
(defconstant $kQ3StyleTypePickID :|pkid|)
(defconstant $kQ3StyleTypeReceiveShadows :|rcsh|)
(defconstant $kQ3StyleTypeHighlight :|high|)
(defconstant $kQ3StyleTypeSubdivision :|sbdv|)
(defconstant $kQ3StyleTypeOrientation :|ofdr|)
(defconstant $kQ3StyleTypePickParts :|pkpt|)
(defconstant $kQ3StyleTypeAntiAlias :|anti|)
(defconstant $kQ3StyleTypeFog :|fogg|)
(defconstant $kQ3ShapeTypeTransform :|xfrm|)
(defconstant $kQ3TransformTypeMatrix :|mtrx|)
(defconstant $kQ3TransformTypeScale :|scal|)
(defconstant $kQ3TransformTypeTranslate :|trns|)
(defconstant $kQ3TransformTypeRotate :|rott|)
(defconstant $kQ3TransformTypeRotateAboutPoint :|rtap|)
(defconstant $kQ3TransformTypeRotateAboutAxis :|rtaa|)
(defconstant $kQ3TransformTypeQuaternion :|qtrn|)
(defconstant $kQ3TransformTypeReset :|rset|)
(defconstant $kQ3ShapeTypeLight :|lght|)
(defconstant $kQ3LightTypeAmbient :|ambn|)
(defconstant $kQ3LightTypeDirectional :|drct|)
(defconstant $kQ3LightTypePoint :|pntl|)
(defconstant $kQ3LightTypeSpot :|spot|)
(defconstant $kQ3ShapeTypeCamera :|cmra|)
(defconstant $kQ3CameraTypeOrthographic :|orth|)
(defconstant $kQ3CameraTypeViewPlane :|vwpl|)
(defconstant $kQ3CameraTypeViewAngleAspect :|vana|)
(defconstant $kQ3ShapeTypeStateOperator :|stop|)
(defconstant $kQ3StateOperatorTypePush :|push|)
(defconstant $kQ3StateOperatorTypePop :|pop |)
(defconstant $kQ3ShapeTypeGroup :|grup|)
(defconstant $kQ3GroupTypeDisplay :|dspg|)
(defconstant $kQ3DisplayGroupTypeOrdered :|ordg|)
(defconstant $kQ3DisplayGroupTypeIOProxy :|iopx|)
(defconstant $kQ3GroupTypeLight :|lghg|)
(defconstant $kQ3GroupTypeInfo :|info|)
(defconstant $kQ3ShapeTypeUnknown :|unkn|)
(defconstant $kQ3UnknownTypeText :|uktx|)
(defconstant $kQ3UnknownTypeBinary :|ukbn|)
(defconstant $kQ3ShapeTypeReference :|rfrn|)
(defconstant $kQ3ReferenceTypeExternal :|rfex|)
(defconstant $kQ3SharedTypeSet :|set |)
(defconstant $kQ3SetTypeAttribute :|attr|)
(defconstant $kQ3SharedTypeDrawContext :|dctx|)
(defconstant $kQ3DrawContextTypePixmap :|dpxp|)
(defconstant $kQ3DrawContextTypeMacintosh :|dmac|)
(defconstant $kQ3DrawContextTypeWin32DC :|dw32|)
(defconstant $kQ3DrawContextTypeDDSurface :|ddds|)
(defconstant $kQ3DrawContextTypeX11 :|dx11|)
(defconstant $kQ3SharedTypeTexture :|txtr|)
(defconstant $kQ3TextureTypePixmap :|txpm|)
(defconstant $kQ3TextureTypeMipmap :|txmm|)
(defconstant $kQ3TextureTypeCompressedPixmap :|txcp|)
(defconstant $kQ3SharedTypeFile :|file|)
(defconstant $kQ3SharedTypeStorage :|strg|)
(defconstant $kQ3StorageTypeMemory :|mems|)
(defconstant $kQ3MemoryStorageTypeHandle :|hndl|)
(defconstant $kQ3StorageTypeUnix :|uxst|)
(defconstant $kQ3UnixStorageTypePath :|unix|)
(defconstant $kQ3StorageTypeMacintosh :|macn|)
(defconstant $kQ3MacintoshStorageTypeFSSpec :|macp|)
(defconstant $kQ3StorageTypeWin32 :|wist|)
(defconstant $kQ3SharedTypeString :|strn|)
(defconstant $kQ3StringTypeCString :|strc|)
(defconstant $kQ3SharedTypeShapePart :|sprt|)
(defconstant $kQ3ShapePartTypeMeshPart :|spmh|)
(defconstant $kQ3MeshPartTypeMeshFacePart :|mfac|)
(defconstant $kQ3MeshPartTypeMeshEdgePart :|medg|)
(defconstant $kQ3MeshPartTypeMeshVertexPart :|mvtx|)
(defconstant $kQ3SharedTypeControllerState :|ctst|)
(defconstant $kQ3SharedTypeTracker :|trkr|)
(defconstant $kQ3SharedTypeViewHints :|vwhn|)
(defconstant $kQ3SharedTypeEndGroup :|endg|)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         QuickDraw 3D System Routines                     **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Initialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Initialize" 
      () 
  :tq3status
   () )

; 
;  *  Q3Exit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Exit" 
      () 
  :tq3status
   () )

; 
;  *  Q3IsInitialized()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3IsInitialized" 
      () 
  :tq3boolean
   () )

; 
;  *  Q3GetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GetVersion" 
      ((majorRevision (:pointer :unsigned-long)) (minorRevision (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3GetReleaseVersion returns the release version number,
;  *  in the format of the first four bytes of a 'vers' resource
;  *  (e.g. 0x01518000 ==> 1.5.1 release).
;  
; 
;  *  Q3GetReleaseVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GetReleaseVersion" 
      ((releaseRevision (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         ObjectClass Routines                             **
;  **                                                                          **
;  ****************************************************************************
;  
;  *  New object system calls to query the object system.
;  *
;  *  These comments to move to the stubs file before final release, they 
;  *  are here for documentation for developers using early seeds.
;  
; 
;  *  Given a class name as a string return the associated class type for the 
;  *  class, may return kQ3Failure if the string representing the class is 
;  *  invalid.
;  
; 
;  *  Q3ObjectHierarchy_GetTypeFromString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ObjectHierarchy_GetTypeFromString" 
      ((objectClassString (:pointer :tq3objectclassnamestring)) (objectClassType (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Given a class type as return the associated string for the class name, 
;  *  may return kQ3Failure if the type representing the class is invalid.
;  
; 
;  *  Q3ObjectHierarchy_GetStringFromType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ObjectHierarchy_GetStringFromType" 
      ((objectClassType :signed-long) (objectClassString (:pointer :tq3objectclassnamestring))) 
  :tq3status
   () )

;  
;  *  Return true if the class with this type is registered, false if not 
;  
; 
;  *  Q3ObjectHierarchy_IsTypeRegistered()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ObjectHierarchy_IsTypeRegistered" 
      ((objectClassType :signed-long)) 
  :tq3boolean
   () )

;  
;  *  Return true if the class with this name is registered, false if not 
;  
; 
;  *  Q3ObjectHierarchy_IsNameRegistered()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ObjectHierarchy_IsNameRegistered" 
      ((objectClassName :pointer)) 
  :tq3boolean
   () )

; 
;  * TQ3SubClassData is used when querying the object system for
;  * the subclasses of a particular parent type:
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3subclassdataptr (find-mactype '(:pointer :tq3subclassdata)))
(defrecord TQ3SubClassData 
   (numClasses :unsigned-long)                  ;   the # of subclass types found for a parent class  
   (classTypes (:pointer :signed-long))         ;   an array containing the class types  
   )

; 	
; 	 *  Given a parent type and an instance of the TQ3SubClassData struct fill
; 	 *  it in with the number and class types of all of the subclasses immediately
; 	 *  below the parent in the class hierarchy.  Return kQ3Success to indicate no
; 	 *  errors occurred, else kQ3Failure.
; 	 *
; 	 *  NOTE:  This function will allocate memory for the classTypes array.  Be 
; 	 *  sure to call Q3ObjectClass_EmptySubClassData to free this memory up.
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3ObjectHierarchy_GetSubClassData()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3ObjectHierarchy_GetSubClassData" 
      ((objectClassType :signed-long) (subClassData (:pointer :tq3subclassdata))) 
  :tq3status
   () )

; 
;  *  Given an instance of the TQ3SubClassData struct free all memory allocated 
;  *  by the Q3ObjectClass_GetSubClassData call.
;  *
;  *  NOTE: This call MUST be made after a call to Q3ObjectClass_GetSubClassData
;  *  to avoid memory leaks.
;  
; 
;  *  Q3ObjectHierarchy_EmptySubClassData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ObjectHierarchy_EmptySubClassData" 
      ((subClassData (:pointer :tq3subclassdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Object Routines                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Object_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_Dispose" 
      ((object :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Object_Duplicate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_Duplicate" 
      ((object :pointer)) 
  :pointer
   () )

; 
;  *  Q3Object_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_Submit" 
      ((object :pointer) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Object_IsDrawable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_IsDrawable" 
      ((object :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3Object_IsWritable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_IsWritable" 
      ((object :pointer) (theFile :pointer)) 
  :tq3boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Object Type Routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Object_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_GetType" 
      ((object :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Object_GetLeafType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_GetLeafType" 
      ((object :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Object_IsType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Object_IsType" 
      ((object :pointer) (theType :signed-long)) 
  :tq3boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Shared Object Routines                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Shared_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_GetType" 
      ((sharedObject :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Shared_GetReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_GetReference" 
      ((sharedObject :pointer)) 
  :pointer
   () )

;  
;  *  Q3Shared_IsReferenced
;  *      Returns kQ3True if there is more than one reference to sharedObject.
;  *      Returns kQ3False if there is ONE reference to sharedObject.
;  *  
;  *  This call is intended to allow applications and plug-in objects to delete
;  *  objects of which they hold THE ONLY REFERENCE. This is useful when
;  *  caching objects, etc.
;  *  
;  *  Although many may be tempted, DO NOT DO THIS:
;  *      while (Q3Shared_IsReferenced(foo)) ( Q3Object_Dispose(foo); )
;  *  
;  *  Your application will crash and no one will buy it. Chapter 11 is 
;  *  never fun (unless you short the stock). Thanks.
;  
; 
;  *  Q3Shared_IsReferenced()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_IsReferenced" 
      ((sharedObject :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3Shared_GetEditIndex
;  *      Returns the "serial number" of sharedObject. Usefuly for caching 
;  *      object information. Returns 0 on error.
;  *      
;  *      Hold onto this number to determine if an object has changed since you
;  *      last built your caches... To validate, do:
;  *      
;  *      if (Q3Shared_GetEditIndex(foo) == oldFooEditIndex) (
;  *          // Cache is valid
;  *      ) else (
;  *          // Cache is invalid
;  *          RebuildSomeSortOfCache(foo);
;  *          oldFooEditIndex = Q3Shared_GetEditIndex(foo);
;  *      )
;  
; 
;  *  Q3Shared_GetEditIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_GetEditIndex" 
      ((sharedObject :pointer)) 
  :unsigned-long
   () )

; 
;  *  Q3Shared_Edited
;  *      Bumps the "serial number" of sharedObject to a different value. This
;  *      call is intended to be used solely from a plug-in object which is 
;  *      shared. Call this whenever your private instance data changes.
;  *      
;  *      Returns kQ3Failure iff sharedObject is not a shared object, OR
;  *          QuickDraw 3D isn't initialized.
;  
; 
;  *  Q3Shared_Edited()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_Edited" 
      ((sharedObject :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Shape Routines                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  QuickDraw 3D 1.5 Note:
;  *
;  *  Shapes and Sets are now (sort of) polymorphic.
;  *
;  *      You may call Q3Shape_Foo or Q3Set_Foo on a shape or a set.
;  *      The following calls are identical, in implementation:
;  *
;  *          Q3Shape_GetElement          =   Q3Set_Get
;  *          Q3Shape_AddElement          =   Q3Set_Add
;  *          Q3Shape_ContainsElement     =   Q3Set_Contains
;  *          Q3Shape_GetNextElementType  =   Q3Set_GetNextElementType
;  *          Q3Shape_EmptyElements       =   Q3Set_Empty
;  *          Q3Shape_ClearElement        =   Q3Set_Clear
;  *
;  *  All of these calls accept a shape or a set as their first parameter.
;  *
;  *  The Q3Shape_GetSet and Q3ShapeSetSet calls are implemented via a new
;  *  element type kQ3ElementTypeSet. See the note above about 
;  *  kQ3ElementTypeSet;
;  *
;  *  It is important to note that the new Q3Shape_...Element... calls do not
;  *  create a set on a shape and then add the element to it. This data is
;  *  attached directly to the shape. Therefore, it is possible for an element
;  *  to exist on a shape without a set existing on it as well. 
;  *
;  *  In your application, if you attach an element to a shape like this:
;  *      (this isn't checking for errors for simplicity)
;  *
;  *      set = Q3Set_New();
;  *      Q3Set_AddElement(set, kMyElemType, &data);
;  *      Q3Shape_SetSet(shape, set);
;  *
;  *  You should retrieve it in the same manner:
;  *
;  *      Q3Shape_GetSet(shape, &set);
;  *      if (Q3Set_Contains(set, kMyElemType) == kTrue) (
;  *          Q3Set_Get(set, kMyElemType, &data);
;  *      )
;  *
;  *  Similarly, if you attach data to a shape with the new calls:
;  *
;  *      Q3Shape_AddElement(shape, kMyElemType, &data);
;  *
;  *  You should retrieve it in the same manner:
;  *
;  *      if (Q3Shape_ContainsElement(set, kMyElemType) == kTrue) (
;  *          Q3Shape_GetElement(set, kMyElemType, &data);
;  *      )
;  *
;  *  This really becomes an issue when dealing with version 1.0 and version 1.1 
;  *  metafiles.
;  *
;  *  When attempting to find a particular element on a shape, you should
;  *  first check with Q3Shape_GetNextElementType or Q3Shape_GetElement, then,
;  *  Q3Shape_GetSet(s, &set) (or Q3Shape_GetElement(s, kQ3ElementTypeSet, &set))
;  *  and then Q3Shape_GetElement(set, ...).
;  *
;  *  In terms of implementation, Q3Shape_SetSet and Q3Shape_GetSet should only be
;  *  used for sets of information that are shared among multiple shapes.
;  *  
;  *  Q3Shape_AddElement, Q3Shape_GetElement, etc. calls should only be used
;  *  for elements that are unique for a particular shape.
;  *  
;  
; 
;  *  Q3Shape_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_GetType" 
      ((shape :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Shape_GetSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_GetSet" 
      ((shape :pointer) (theSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Shape_SetSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_SetSet" 
      ((shape :pointer) (theSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shape_AddElement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_AddElement" 
      ((shape :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shape_GetElement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_GetElement" 
      ((shape :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shape_ContainsElement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_ContainsElement" 
      ((shape :pointer) (theType :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3Shape_GetNextElementType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_GetNextElementType" 
      ((shape :pointer) (theType (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Shape_EmptyElements()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_EmptyElements" 
      ((shape :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shape_ClearElement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shape_ClearElement" 
      ((shape :pointer) (theType :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Color Table Routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Bitmap_Empty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Bitmap_Empty" 
      ((bitmap (:pointer :tq3bitmap))) 
  :tq3status
   () )

; 
;  *  Q3Bitmap_GetImageSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Bitmap_GetImageSize" 
      ((width :unsigned-long) (height :unsigned-long)) 
  :unsigned-long
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DIncludes

; $ENDC                                         ; __QD3D__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3D)