(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DCamera.p"
; at Wednesday May 1,2002 2:42:19 pm.
; 
;      File:       QD3DCamera.p
;  
;      Contains:   Generic camera routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DCAMERA__
; $SETC __QD3DCAMERA__ := 1

; $I+
; $SETC QD3DCameraIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Data Structure Definitions                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  The placement of the camera.
;  

(def-mactype :tq3cameraplacementptr (find-mactype '(:pointer :tq3cameraplacement)))
(defrecord TQ3CameraPlacement 
   (cameraLocation :tq3point3d)                 ;    Location point of the camera   
   (pointOfInterest :tq3point3d)                ;    Point of interest            
   (upVector :tq3vector3d)                      ;    "up" vector              
   )

; 	
; 	 *  The range of the camera.
; 	 	
(def-mactype :tq3camerarangeptr (find-mactype '(:pointer :tq3camerarange)))
(defrecord TQ3CameraRange 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (hither :single-float)                       ;    Hither plane, measured from "from" towards "to"    
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (yon :single-float)                          ;    Yon  plane, measured from "from" towards "to"      
   )

; 	
; 	 *  Viewport specification.  Origin is (-1, 1), and corresponds to the 
; 	 *  upper left-hand corner; width and height maximum is (2.0, 2.0),
; 	 *  corresponding to the lower left-hand corner of the window.  The
; 	 *  TQ3Viewport specifies a part of the viewPlane that gets displayed 
; 	 *  on the window that is to be drawn.
; 	 *  Normally, it is set with an origin of (-1.0, 1.0), and a width and
; 	 *  height of both 2.0, specifying that the entire window is to be
; 	 *  drawn.  If, for example, an exposure event of the window exposed
; 	 *  the right half of the window, you would set the origin to (0, 1),
; 	 *  and the width and height to (1.0) and (2.0), respectively.
; 	 *
; 	 	
(def-mactype :tq3cameraviewportptr (find-mactype '(:pointer :tq3cameraviewport)))
(defrecord TQ3CameraViewPort 
   (origin :tq3point2d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (width :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (height :single-float)
   )

(def-mactype :tq3cameradataptr (find-mactype '(:pointer :tq3cameradata)))
(defrecord TQ3CameraData 
   (placement :tq3cameraplacement)
   (range :tq3camerarange)
   (viewPort :tq3cameraviewport)
   )

; 	
; 	 *  An orthographic camera.
; 	 *
; 	 *  The lens characteristics are set with the dimensions of a
; 	 *  rectangular viewPort in the frame of the camera.
; 	 	
(def-mactype :tq3orthographiccameradataptr (find-mactype '(:pointer :tq3orthographiccameradata)))
(defrecord TQ3OrthographicCameraData 
   (cameraData :tq3cameradata)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (left :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (top :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (right :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (bottom :single-float)
   )

; 	
; 	 *  A perspective camera specified in terms of an arbitrary view plane.
; 	 *
; 	 *  This is most useful when setting the camera to look at a particular
; 	 *  object.  The viewPlane is set to distance from the camera to the object.
; 	 *  The halfWidth is set to half the width of the cross section of the object,
; 	 *  and the halfHeight equal to the halfWidth divided by the aspect ratio
; 	 *  of the viewPort.
; 	 * 
; 	 *  This is the only perspective camera with specifications for off-axis
; 	 *  viewing, which is desirable for scrolling.
; 	 	
(def-mactype :tq3viewplanecameradataptr (find-mactype '(:pointer :tq3viewplanecameradata)))
(defrecord TQ3ViewPlaneCameraData 
   (cameraData :tq3cameradata)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (viewPlane :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (halfWidthAtViewPlane :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (halfHeightAtViewPlane :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (centerXOnViewPlane :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (centerYOnViewPlane :single-float)
   )

; 	
; 	 *  A view angle aspect camera is a perspective camera specified in 
; 	 *  terms of the minimum view angle and the aspect ratio of X to Y.
; 	 *
; 	 	
(def-mactype :tq3viewangleaspectcameradataptr (find-mactype '(:pointer :tq3viewangleaspectcameradata)))
(defrecord TQ3ViewAngleAspectCameraData 
   (cameraData :tq3cameradata)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fov :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (aspectRatioXToY :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Generic Camera routines                          **
; 	 **                                                                          **
; 	 ****************************************************************************	

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Camera_GetType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Camera_GetType" 
      ((camera :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Camera_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Camera_SetData" 
      ((camera :pointer) (cameraData (:pointer :tq3cameradata))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetData" 
      ((camera :pointer) (cameraData (:pointer :tq3cameradata))) 
  :tq3status
   () )

; 
;  *  Q3Camera_SetPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Camera_SetPlacement" 
      ((camera :pointer) (placement (:pointer :tq3cameraplacement))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetPlacement" 
      ((camera :pointer) (placement (:pointer :tq3cameraplacement))) 
  :tq3status
   () )

; 
;  *  Q3Camera_SetRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Camera_SetRange" 
      ((camera :pointer) (range (:pointer :tq3camerarange))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetRange" 
      ((camera :pointer) (range (:pointer :tq3camerarange))) 
  :tq3status
   () )

; 
;  *  Q3Camera_SetViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Camera_SetViewPort" 
      ((camera :pointer) (viewPort (:pointer :tq3cameraviewport))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetViewPort" 
      ((camera :pointer) (viewPort (:pointer :tq3cameraviewport))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetWorldToView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetWorldToView" 
      ((camera :pointer) (worldToView (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetWorldToFrustum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetWorldToFrustum" 
      ((camera :pointer) (worldToFrustum (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; 
;  *  Q3Camera_GetViewToFrustum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Camera_GetViewToFrustum" 
      ((camera :pointer) (viewToFrustum (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Specific Camera Routines                         **
;  **                                                                          **
;  ****************************************************************************
; *****************************************************************************
;  **                                                                          **
;  **                         Orthographic Camera                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3OrthographicCamera_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3OrthographicCamera_New" 
      ((orthographicData (:pointer :tq3orthographiccameradata))) 
  :pointer
   () )

; 
;  *  Q3OrthographicCamera_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_GetData" 
      ((camera :pointer) (cameraData (:pointer :tq3orthographiccameradata))) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3OrthographicCamera_SetData" 
      ((camera :pointer) (cameraData (:pointer :tq3orthographiccameradata))) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_SetLeft()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_SetLeft" 
      ((camera :pointer) (left :single-float)) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_GetLeft()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_GetLeft" 
      ((camera :pointer) (left (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_SetTop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_SetTop" 
      ((camera :pointer) (top :single-float)) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_GetTop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_GetTop" 
      ((camera :pointer) (top (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_SetRight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_SetRight" 
      ((camera :pointer) (right :single-float)) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_GetRight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_GetRight" 
      ((camera :pointer) (right (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_SetBottom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_SetBottom" 
      ((camera :pointer) (bottom :single-float)) 
  :tq3status
   () )

; 
;  *  Q3OrthographicCamera_GetBottom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrthographicCamera_GetBottom" 
      ((camera :pointer) (bottom (:pointer :single-float))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         ViewPlane Camera                                 **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewPlaneCamera_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewPlaneCamera_New" 
      ((cameraData (:pointer :tq3viewplanecameradata))) 
  :pointer
   () )

; 
;  *  Q3ViewPlaneCamera_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetData" 
      ((camera :pointer) (cameraData (:pointer :tq3viewplanecameradata))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewPlaneCamera_SetData" 
      ((camera :pointer) (cameraData (:pointer :tq3viewplanecameradata))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetViewPlane()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_SetViewPlane" 
      ((camera :pointer) (viewPlane :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_GetViewPlane()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetViewPlane" 
      ((camera :pointer) (viewPlane (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetHalfWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_SetHalfWidth" 
      ((camera :pointer) (halfWidthAtViewPlane :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_GetHalfWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetHalfWidth" 
      ((camera :pointer) (halfWidthAtViewPlane (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetHalfHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_SetHalfHeight" 
      ((camera :pointer) (halfHeightAtViewPlane :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_GetHalfHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetHalfHeight" 
      ((camera :pointer) (halfHeightAtViewPlane (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetCenterX()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_SetCenterX" 
      ((camera :pointer) (centerXOnViewPlane :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_GetCenterX()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetCenterX" 
      ((camera :pointer) (centerXOnViewPlane (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_SetCenterY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_SetCenterY" 
      ((camera :pointer) (centerYOnViewPlane :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewPlaneCamera_GetCenterY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewPlaneCamera_GetCenterY" 
      ((camera :pointer) (centerYOnViewPlane (:pointer :single-float))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         View Angle Aspect Camera                         **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewAngleAspectCamera_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewAngleAspectCamera_New" 
      ((cameraData (:pointer :tq3viewangleaspectcameradata))) 
  :pointer
   () )

; 
;  *  Q3ViewAngleAspectCamera_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewAngleAspectCamera_SetData" 
      ((camera :pointer) (cameraData (:pointer :tq3viewangleaspectcameradata))) 
  :tq3status
   () )

; 
;  *  Q3ViewAngleAspectCamera_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewAngleAspectCamera_GetData" 
      ((camera :pointer) (cameraData (:pointer :tq3viewangleaspectcameradata))) 
  :tq3status
   () )

; 
;  *  Q3ViewAngleAspectCamera_SetFOV()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewAngleAspectCamera_SetFOV" 
      ((camera :pointer) (fov :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewAngleAspectCamera_GetFOV()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewAngleAspectCamera_GetFOV" 
      ((camera :pointer) (fov (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3ViewAngleAspectCamera_SetAspectRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewAngleAspectCamera_SetAspectRatio" 
      ((camera :pointer) (aspectRatioXToY :single-float)) 
  :tq3status
   () )

; 
;  *  Q3ViewAngleAspectCamera_GetAspectRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewAngleAspectCamera_GetAspectRatio" 
      ((camera :pointer) (aspectRatioXToY (:pointer :single-float))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DCameraIncludes

; $ENDC                                         ; __QD3DCAMERA__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DCamera)