(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DIO.p"
; at Wednesday May 1,2002 2:42:29 pm.
; 
;      File:       QD3DIO.p
;  
;      Contains:   QuickDraw 3D IO API
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DIO__
; $SETC __QD3DIO__ := 1

; $I+
; $SETC QD3DIOIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __QD3DDRAWCONTEXT__
|#

(require-interface 'QD3DDrawContext)
#|                                              ; $I QD3DDrawContext.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __QD3DVIEW__

(require-interface 'QD3DView)                   ; $I QD3DView.p
; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                                 Basic Types                              **                                                 
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3uns8 (find-mactype ':unsigned-byte))
(def-mactype :tq3int8 (find-mactype ':signed-byte))
(def-mactype :tq3uns16 (find-mactype ':unsigned-integer))
(def-mactype :tq3int16 (find-mactype ':signed-integer))
(def-mactype :tq3uns32 (find-mactype ':unsigned-long))
(def-mactype :tq3int32 (find-mactype ':signed-long))
; $IFC TARGET_RT_BIG_ENDIAN 
(def-mactype :tq3uns64ptr (find-mactype '(:pointer :tq3uns64)))
(defrecord TQ3Uns64 
   (hi :unsigned-long)
   (lo :unsigned-long)
   )

(def-mactype :tq3int64ptr (find-mactype '(:pointer :tq3int64)))
(defrecord TQ3Int64 
   ;;Changing field hi from signed-long to unsigned-long to match C header (pretty-darn-sure)
   (hi :unsigned-long)
   (lo :unsigned-long)
   )

#|                                              ; $ELSEC
(defrecord TQ3Uns64 
   (lo :unsigned-long)
   (hi :unsigned-long)
   )

(defrecord TQ3Int64 
   (lo :unsigned-long)
   ;;Changing field hi from signed-long to unsigned-long to match C header (pretty-darn-sure)
   (hi :unsigned-long)
   )

 |#                                             ; $ENDC; TARGET_RT_BIG_ENDIAN

(def-mactype :tq3float32 (find-mactype ':single-float))
(def-mactype :tq3float64 (find-mactype ':double-float))
(def-mactype :tq3size (find-mactype ':unsigned-long))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                 File Types                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3filemodemasks (find-mactype ':signed-long))

(defconstant $kQ3FileModeNormal 0)
(defconstant $kQ3FileModeStream #x1)
(defconstant $kQ3FileModeDatabase #x2)
(defconstant $kQ3FileModeText #x4)

(def-mactype :tq3filemode (find-mactype ':unsigned-long))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                 Method Types                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  IO Methods
; 	 *
; 	 *  The IO system treats all objects as groups of typed information.
; 	 *  When you register your element or attribute, the "elementType" is the 
; 	 *  binary type of your object, the "elementName" the ascii type.
; 	 *  
; 	 *  All objects in the metafile are made up of a "root" or parent object which
; 	 *  defines the instantiated object type. You may define the format of your 
; 	 *  data any way you wish as long as you use the primitives types above and the
; 	 *  routines below.
; 	 *
; 	 *  Root Objects are often appended with additional child objects, called 
; 	 *  subobjects. You may append your object with other QuickDraw 3D objects.
; 	 *  
; 	 *  Writing is straightforward: an object traverses itself any other objects 
; 	 *  that make it up, then writes its own data. Writing uses two methods: 
; 	 *  TQ3XObjectTraverseMethod and TQ3XObjectWriteMethod.
; 	 *
; 	 *  The TQ3XObjectTraverseMethod method should:
; 	 *  + First, Determine if the data should be written 
; 	 *      - if you don't want to write out your object after examining your
; 	 *          data, return kQ3Success in your Traverse method without calling
; 	 *          any other submit calls.
; 	 *  + Next, calculate the size of your object on disk
; 	 *  + Gather whatever state from the view you need to preserve
; 	 *      - you may access the view state NOW, as the state of the
; 	 *          view duing your TQ3XObjectWriteMethod will not be valid. You may
; 	 *          pass a temporary buffer to your write method.
; 	 *  + Submit your view write data using Q3View_SubmitWriteData
; 	 *      - note that you MUST call this before any other "_Submit" call.
; 	 *      - you may pass in a "deleteMethod" for your data. This method
; 	 *          will be called whether or not your write method succeeds or fails.
; 	 *  + Submit your subobjects to the view
; 	 *  
; 	 *  The TQ3XObjectWriteMethod method should:
; 	 *  + Write your data format to the file using the primitives routines below.
; 	 *      - If you passed a "deleteMethod" in your Q3View_SubmitWriteData, that
; 	 *          method will be called upon exit of your write method.
; 	 *
; 	 *  Reading is less straightforward because your root object and
; 	 *  any subobjects must be read inside of your TQ3XObjectReadDataMethod. There 
; 	 *  is an implicit state contained in the file while reading, which you must 
; 	 *  be aware of. When you first enter the read method, you must physically 
; 	 *  read in your data format using the primitives routines until
; 	 *  
; 	 *  Q3File_IsEndOfData(file) == kQ3True
; 	 *  
; 	 *  Generally, your data format should be self-descriptive such that you do not
; 	 *  need to call Q3File_IsEndOfData to determine if you are done reading. 
; 	 *  However, this call is useful for determining zero-sized object or 
; 	 *  determining the end of an object's data.
; 	 *  
; 	 *  Once you have read in all the data, you may collect subobjects. A metafile
; 	 *  object ONLY has subobjects if it is in a container. The call
; 	 *  
; 	 *  Q3File_IsEndOfContainer(file)
; 	 *  
; 	 *  returns kQ3False if subobjects exist, and kQ3True if subobjects do not 
; 	 *  exist.
; 	 *  
; 	 *  At this point, you may use
; 	 *  
; 	 *  Q3File_GetNextObjectType
; 	 *  Q3File_IsNextObjectOfType
; 	 *  Q3File_ReadObject
; 	 *  Q3File_SkipObject
; 	 *  
; 	 *  to iterate through the subobjects until Q3File_IsEndOfContainer(file) 
; 	 *  is kQ3True.
; 	 * 
; 	 	

; 	
; 	 * IO Methods
; 	 	

(defconstant $kQ3XMethodTypeObjectFileVersion :|vers|);   version  
(defconstant $kQ3XMethodTypeObjectTraverse :|trvs|);   byte count  
(defconstant $kQ3XMethodTypeObjectTraverseData :|trvd|);   byte count  
(defconstant $kQ3XMethodTypeObjectWrite :|writ|);   Dump info to file  
(defconstant $kQ3XMethodTypeObjectReadData :|rddt|);   Read info from file into buffer or, attach read data to parent  
(defconstant $kQ3XMethodTypeObjectRead :|read|)
(defconstant $kQ3XMethodTypeObjectAttach :|attc|)

; 	
; 	 *  TQ3XObjectTraverseMethod
; 	 *
; 	 *  For "elements" (meaning "attributes, too), you will be passed NULL for 
; 	 *  object. Sorry, custom objects will be available in the next major revision.
; 	 *
; 	 *  The "data" is a pointer to your internal element data.
; 	 *
; 	 *  The view is the current traversal view.
; 	 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectTraverseMethod = FUNCTION(object: TQ3Object; data: UNIV Ptr; view: TQ3ViewObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjecttraversemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  TQ3XObjectTraverseDataMethod
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectTraverseDataMethod = FUNCTION(object: TQ3Object; data: UNIV Ptr; view: TQ3ViewObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjecttraversedatamethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  TQ3XObjectWriteMethod
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectWriteMethod = FUNCTION(object: UNIV Ptr; theFile: TQ3FileObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjectwritemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Custom object writing 
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XDataDeleteMethod = PROCEDURE(data: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xdatadeletemethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XView_SubmitWriteData()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XView_SubmitWriteData" 
      ((view :pointer) (size :unsigned-long) (data :pointer) (deleteData :pointer)) 
  :tq3status
   () )

; 
;  *  Q3XView_SubmitSubObjectData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XView_SubmitSubObjectData" 
      ((view :pointer) (objectClass :pointer) (size :unsigned-long) (data :pointer) (deleteData :pointer)) 
  :tq3status
   () )

; 
;  *  TQ3XObjectReadMethod
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectReadMethod = FUNCTION(theFile: TQ3FileObject): TQ3Object; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjectreadmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  TQ3XObjectReadDataMethod
; 	 *
; 	 *  For "elements" (meaning "attributes", too), you must allocate stack space 
; 	 *  and call Q3Set_Add on "parentObject", which is an TQ3SetObject.
; 	 *
; 	 *  Otherwise, parentObject is whatever object your element is a subobject of...
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectReadDataMethod = FUNCTION(parentObject: TQ3Object; theFile: TQ3FileObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjectreaddatamethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  TQ3XObjectAttachMethod
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XObjectAttachMethod = FUNCTION(childObject: TQ3Object; parentObject: TQ3Object): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xobjectattachmethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Versioning                                   **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3fileversion (find-mactype ':unsigned-long))

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             File Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 * Creation and accessors
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3File_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3File_New" 
      () 
  :pointer
   () )

; 
;  *  Q3File_GetStorage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetStorage" 
      ((theFile :pointer) (storage (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3File_SetStorage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_SetStorage" 
      ((theFile :pointer) (storage :pointer)) 
  :tq3status
   () )

; 
;  * Opening, and accessing "open" state, closing/cancelling
;  
; 
;  *  Q3File_OpenRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_OpenRead" 
      ((theFile :pointer) (mode (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3File_OpenWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_OpenWrite" 
      ((theFile :pointer) (mode :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3File_IsOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_IsOpen" 
      ((theFile :pointer) (isOpen (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3File_GetMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetMode" 
      ((theFile :pointer) (mode (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3File_GetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetVersion" 
      ((theFile :pointer) (version (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3File_Close()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_Close" 
      ((theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3File_Cancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_Cancel" 
      ((theFile :pointer)) 
  :tq3status
   () )

; 
;  * Writing (Application)
;  
; 
;  *  Q3View_StartWriting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_StartWriting" 
      ((view :pointer) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_EndWriting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_EndWriting" 
      ((view :pointer)) 
  :tq3viewstatus
   () )

; 
;  * Reading (Application)
;  
; 
;  *  Q3File_GetNextObjectType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetNextObjectType" 
      ((theFile :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3File_IsNextObjectOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_IsNextObjectOfType" 
      ((theFile :pointer) (ofType :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3File_ReadObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_ReadObject" 
      ((theFile :pointer)) 
  :pointer
   () )

; 
;  *  Q3File_SkipObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_SkipObject" 
      ((theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3File_IsEndOfData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_IsEndOfData" 
      ((theFile :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3File_IsEndOfContainer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_IsEndOfContainer" 
      ((theFile :pointer) (rootObject :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3File_IsEndOfFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_IsEndOfFile" 
      ((theFile :pointer)) 
  :tq3boolean
   () )

;     
;  *  External file references
;  
; 
;  *  Q3File_MarkAsExternalReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_MarkAsExternalReference" 
      ((theFile :pointer) (sharedObject :pointer)) 
  :tq3status
   () )

; 
;  *  Q3File_GetExternalReferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetExternalReferences" 
      ((theFile :pointer)) 
  :pointer
   () )

;     
;  *  Tracking editing in read-in objects with custom elements
;  
; 
;  *  Q3Shared_ClearEditTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_ClearEditTracking" 
      ((sharedObject :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shared_GetEditTrackingState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shared_GetEditTrackingState" 
      ((sharedObject :pointer)) 
  :tq3boolean
   () )

;     
;  *  Reading objects inside a group one-by-one
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3filereadgroupstatemasks (find-mactype ':signed-long))

(defconstant $kQ3FileReadWholeGroup 0)
(defconstant $kQ3FileReadObjectsInGroup #x1)
(defconstant $kQ3FileCurrentlyInsideGroup #x2)

(def-mactype :tq3filereadgroupstate (find-mactype ':unsigned-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3File_SetReadInGroup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3File_SetReadInGroup" 
      ((theFile :pointer) (readGroupState :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3File_GetReadInGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3File_GetReadInGroup" 
      ((theFile :pointer) (readGroupState (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  * Idling
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3FileIdleMethod = FUNCTION(theFile: TQ3FileObject; idlerData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3fileidlemethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3File_SetIdleMethod()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3File_SetIdleMethod" 
      ((theFile :pointer) (idle :pointer) (idleData :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Primitives Routines                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3NewLine_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NewLine_Write" 
      ((theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns8_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns8_Read" 
      ((data (:pointer :unsigned-byte)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns8_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns8_Write" 
      ((data :signed-byte) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns16_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns16_Read" 
      ((data (:pointer :unsigned-integer)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns16_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns16_Write" 
      ((data :unsigned-integer) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns32_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns32_Read" 
      ((data (:pointer :unsigned-long)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns32_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns32_Write" 
      ((data :unsigned-long) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int8_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int8_Read" 
      ((data (:pointer :signed-byte)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int8_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int8_Write" 
      ((data :signed-byte) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int16_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int16_Read" 
      ((data (:pointer :signed-integer)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int16_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int16_Write" 
      ((data :signed-integer) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int32_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int32_Read" 
      ((data (:pointer :signed-long)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int32_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int32_Write" 
      ((data :signed-long) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns64_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns64_Read" 
      ((data (:pointer :tq3uns64)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Uns64_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Uns64_Write" 
      ((data :tq3uns64) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int64_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int64_Read" 
      ((data (:pointer :tq3int64)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Int64_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Int64_Write" 
      ((data :tq3int64) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Float32_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Float32_Read" 
      ((data (:pointer :single-float)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Float32_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Float32_Write" 
      ((data :single-float) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Float64_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Float64_Read" 
      ((data (:pointer :double-float)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Float64_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Float64_Write" 
      ((data :double-float) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Size_Pad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Size_Pad" 
      ((size :unsigned-long)) 
  :unsigned-long
   () )

; 
;  * Pass a pointer to a buffer of kQ3StringMaximumLength bytes
;  
; 
;  *  Q3String_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3String_Read" 
      ((data :pointer) (length (:pointer :unsigned-long)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3String_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3String_Write" 
      ((data :pointer) (theFile :pointer)) 
  :tq3status
   () )

;  
;  * This call will read Q3Size_Pad(size) bytes,
;  *  but only place size bytes into data.
;  
; 
;  *  Q3RawData_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RawData_Read" 
      ((data (:pointer :unsigned-byte)) (size :unsigned-long) (theFile :pointer)) 
  :tq3status
   () )

;  
;  * This call will write Q3Size_Pad(size) bytes,
;  *  adding 0's to pad to the nearest 4 byte boundary.
;  
; 
;  *  Q3RawData_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RawData_Write" 
      ((data (:pointer :unsigned-byte)) (size :unsigned-long) (theFile :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Convenient Primitives Routines                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point2D_Read" 
      ((point2D (:pointer :tq3point2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Point2D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point2D_Write" 
      ((point2D (:pointer :tq3point2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Point3D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point3D_Read" 
      ((point3D (:pointer :tq3point3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Point3D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point3D_Write" 
      ((point3D (:pointer :tq3point3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RationalPoint3D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RationalPoint3D_Read" 
      ((point3D (:pointer :tq3rationalpoint3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RationalPoint3D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RationalPoint3D_Write" 
      ((point3D (:pointer :tq3rationalpoint3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RationalPoint4D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RationalPoint4D_Read" 
      ((point4D (:pointer :tq3rationalpoint4d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RationalPoint4D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RationalPoint4D_Write" 
      ((point4D (:pointer :tq3rationalpoint4d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Vector2D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Vector2D_Read" 
      ((vector2D (:pointer :tq3vector2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Vector2D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_Write" 
      ((vector2D (:pointer :tq3vector2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Vector3D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Vector3D_Read" 
      ((vector3D (:pointer :tq3vector3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Vector3D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_Write" 
      ((vector3D (:pointer :tq3vector3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Matrix4x4_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_Read" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Matrix4x4_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_Write" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Tangent2D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tangent2D_Read" 
      ((tangent2D (:pointer :tq3tangent2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Tangent2D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tangent2D_Write" 
      ((tangent2D (:pointer :tq3tangent2d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Tangent3D_Read()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tangent3D_Read" 
      ((tangent3D (:pointer :tq3tangent3d)) (theFile :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Tangent3D_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tangent3D_Write" 
      ((tangent3D (:pointer :tq3tangent3d)) (theFile :pointer)) 
  :tq3status
   () )

;   This call affects only text Files - it is a no-op in binary files 
; 
;  *  Q3Comment_Write()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Comment_Write" 
      ((comment :pointer) (theFile :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Unknown Object                               **
;  **                                                                          **
;  **     Unknown objects are generated when reading files which contain       **
;  **     custom data which has not been registered in the current             **
;  **     instantiation of QuickDraw 3D.                                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Unknown_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Unknown_GetType" 
      ((unknownObject :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Unknown_GetDirtyState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Unknown_GetDirtyState" 
      ((unknownObject :pointer) (isDirty (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Unknown_SetDirtyState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Unknown_SetDirtyState" 
      ((unknownObject :pointer) (isDirty :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Unknown Text Routines                            **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3unknowntextdataptr (find-mactype '(:pointer :tq3unknowntextdata)))
(defrecord TQ3UnknownTextData 
   (objectName :pointer)                        ;   '\0' terminated  
   (contents :pointer)                          ;   '\0' terminated  
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3UnknownText_GetData()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3UnknownText_GetData" 
      ((unknownObject :pointer) (unknownTextData (:pointer :tq3unknowntextdata))) 
  :tq3status
   () )

; 
;  *  Q3UnknownText_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnknownText_EmptyData" 
      ((unknownTextData (:pointer :tq3unknowntextdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Unknown Binary Routines                          **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3unknownbinarydataptr (find-mactype '(:pointer :tq3unknownbinarydata)))
(defrecord TQ3UnknownBinaryData 
   (objectType :signed-long)
   (size :unsigned-long)
   (byteOrder :signed-long)
   (contents :pointer)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3UnknownBinary_GetData()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3UnknownBinary_GetData" 
      ((unknownObject :pointer) (unknownBinaryData (:pointer :tq3unknownbinarydata))) 
  :tq3status
   () )

; 
;  *  Q3UnknownBinary_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnknownBinary_EmptyData" 
      ((unknownBinaryData (:pointer :tq3unknownbinarydata))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3UnknownBinary_GetTypeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnknownBinary_GetTypeString" 
      ((unknownObject :pointer) (typeString (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3UnknownBinary_EmptyTypeString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnknownBinary_EmptyTypeString" 
      ((typeString (:pointer :pointer))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                         ViewHints routines                               **
;  **                                                                          **
;  **     ViewHints are an object in a metafile to give you some hints on how  **
;  **     to render a scene.  You may create a view with any of the objects    **
;  **     retrieved from it, or you can just throw it away.                    **
;  **                                                                          **
;  **     To write a view hints to a file, create a view hints object from a   **
;  **     view and write the view hints.                                       **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3ViewHints_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_New" 
      ((view :pointer)) 
  :pointer
   () )

; 
;  *  Q3ViewHints_SetRenderer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetRenderer" 
      ((viewHints :pointer) (renderer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetRenderer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetRenderer" 
      ((viewHints :pointer) (renderer (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetCamera()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetCamera" 
      ((viewHints :pointer) (camera :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetCamera()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetCamera" 
      ((viewHints :pointer) (camera (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetLightGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetLightGroup" 
      ((viewHints :pointer) (lightGroup :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetLightGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetLightGroup" 
      ((viewHints :pointer) (lightGroup (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetAttributeSet" 
      ((viewHints :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetAttributeSet" 
      ((viewHints :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetDimensionsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetDimensionsState" 
      ((viewHints :pointer) (isValid :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetDimensionsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetDimensionsState" 
      ((viewHints :pointer) (isValid (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetDimensions" 
      ((viewHints :pointer) (width :unsigned-long) (height :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetDimensions" 
      ((viewHints :pointer) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetMaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetMaskState" 
      ((viewHints :pointer) (isValid :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetMaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetMaskState" 
      ((viewHints :pointer) (isValid (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewHints_SetMask" 
      ((viewHints :pointer) (mask (:pointer :tq3bitmap))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetMask" 
      ((viewHints :pointer) (mask (:pointer :tq3bitmap))) 
  :tq3status
   () )

;  Call Q3Bitmap_Empty when done with the mask  
; 
;  *  Q3ViewHints_SetClearImageMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_SetClearImageMethod" 
      ((viewHints :pointer) (clearMethod :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetClearImageMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetClearImageMethod" 
      ((viewHints :pointer) (clearMethod (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_SetClearImageColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ViewHints_SetClearImageColor" 
      ((viewHints :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; 
;  *  Q3ViewHints_GetClearImageColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewHints_GetClearImageColor" 
      ((viewHints :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DIOIncludes

; $ENDC                                         ; __QD3DIO__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DIO)