(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DStorage.p"
; at Wednesday May 1,2002 2:42:40 pm.
; 
;      File:       QD3DStorage.p
;  
;      Contains:   Abstraction to deal with various types of stream-based storage devices
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DSTORAGE__
; $SETC __QD3DSTORAGE__ := 1

; $I+
; $SETC QD3DStorageIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                             Storage Routines                             **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Storage_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Storage_GetType" 
      ((storage :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Storage_GetSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Storage_GetSize" 
      ((storage :pointer) (size (:pointer :unsigned-long))) 
  :tq3status
   () )

;  
;  *  Reads "dataSize" bytes starting at offset in storage, copying into data. 
;  *  sizeRead returns the number of bytes filled in. 
;  *  
;  *  You may assume if *sizeRead < dataSize, then EOF is at offset + *sizeRead
;  
; 
;  *  Q3Storage_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Storage_GetData" 
      ((storage :pointer) (offset :unsigned-long) (dataSize :unsigned-long) (data (:pointer :unsigned-byte)) (sizeRead (:pointer :unsigned-long))) 
  :tq3status
   () )

;  
;  *  Write "dataSize" bytes starting at offset in storage, copying from data. 
;  *  sizeWritten returns the number of bytes filled in. 
;  *  
;  *  You may assume if *sizeRead < dataSize, then EOF is at offset + *sizeWritten
;  
; 
;  *  Q3Storage_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Storage_SetData" 
      ((storage :pointer) (offset :unsigned-long) (dataSize :unsigned-long) (data (:pointer :unsigned-byte)) (sizeWritten (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                          Memory Storage Prototypes                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3MemoryStorage_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MemoryStorage_GetType" 
      ((storage :pointer)) 
  :tq3objecttype
   () )

; 
;  * These calls COPY the buffer into QD3D space
;  
; 
;  *  Q3MemoryStorage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MemoryStorage_New" 
      ((buffer (:pointer :unsigned-byte)) (validSize :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3MemoryStorage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MemoryStorage_Set" 
      ((storage :pointer) (buffer (:pointer :unsigned-byte)) (validSize :unsigned-long)) 
  :tq3status
   () )

; 
;  * These calls use the pointer given - you must dispose it when you're through
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3MemoryStorage_NewBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MemoryStorage_NewBuffer" 
      ((buffer :pointer) (validSize :unsigned-long) (bufferSize :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3MemoryStorage_SetBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MemoryStorage_SetBuffer" 
      ((storage :pointer) (buffer :pointer) (validSize :unsigned-long) (bufferSize :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3MemoryStorage_GetBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MemoryStorage_GetBuffer" 
      ((storage :pointer) (buffer (:pointer :pointer)) (validSize (:pointer :unsigned-long)) (bufferSize (:pointer :unsigned-long))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
; *****************************************************************************
;  **                                                                          **
;  **                             Macintosh Handles Prototypes                 **
;  **                                                                          **
;  ****************************************************************************
;  Handle Storage is a subclass of Memory Storage 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3HandleStorage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HandleStorage_New" 
      ((Handle :handle) (validSize :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3HandleStorage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HandleStorage_Set" 
      ((storage :pointer) (Handle :handle) (validSize :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3HandleStorage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HandleStorage_Get" 
      ((storage :pointer) (Handle (:pointer :handle)) (validSize (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Macintosh Storage Prototypes                 **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3MacintoshStorage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacintoshStorage_New" 
      ((fsRefNum :signed-integer)) 
  :pointer
   () )

;  Note: This storage is assumed open 
; 
;  *  Q3MacintoshStorage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacintoshStorage_Set" 
      ((storage :pointer) (fsRefNum :signed-integer)) 
  :tq3status
   () )

; 
;  *  Q3MacintoshStorage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacintoshStorage_Get" 
      ((storage :pointer) (fsRefNum (:pointer :signed-integer))) 
  :tq3status
   () )

; 
;  *  Q3MacintoshStorage_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacintoshStorage_GetType" 
      ((storage :pointer)) 
  :tq3objecttype
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Macintosh FSSpec Storage Prototypes              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3FSSpecStorage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3FSSpecStorage_New" 
      ((fs (:pointer :fsspec))) 
  :pointer
   () )

; 
;  *  Q3FSSpecStorage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3FSSpecStorage_Set" 
      ((storage :pointer) (fs (:pointer :fsspec))) 
  :tq3status
   () )

; 
;  *  Q3FSSpecStorage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3FSSpecStorage_Get" 
      ((storage :pointer) (fs (:pointer :fsspec))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

#|                                              ; $IFC TARGET_OS_WIN32 
; *****************************************************************************
;  **                                                                          **
;  **                         Win32 HANDLE Storage Prototypes                  **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Win32Storage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Win32Storage_New" 
      ((hFile :handle)) 
  :pointer
   () )

; 
;  *  Q3Win32Storage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Win32Storage_Set" 
      ((storage :pointer) (hFile :handle)) 
  :tq3status
   () )

; 
;  *  Q3Win32Storage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Win32Storage_Get" 
      ((storage :pointer) (hFile (:pointer :handle))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_OS_WIN32

; *****************************************************************************
;  **                                                                          **
;  **                                 Unix Prototypes                          **
;  **             The Unix Storage prototypes have been obsoleted.             **
;  **                                                                          **
;  ****************************************************************************

; *****************************************************************************
;  **                                                                          **
;  **                             Unix Path Prototypes                         **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3UnixPathStorage_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnixPathStorage_New" 
      ((pathName :pointer)) 
  :pointer
   () )

;  C string 
; 
;  *  Q3UnixPathStorage_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnixPathStorage_Set" 
      ((storage :pointer) (pathName :pointer)) 
  :tq3status
   () )

;  C string 
; 
;  *  Q3UnixPathStorage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3UnixPathStorage_Get" 
      ((storage :pointer) (pathName :pointer)) 
  :tq3status
   () )

;  pathName is a buffer 

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DStorageIncludes

; $ENDC                                         ; __QD3DSTORAGE__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DStorage)