(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SCSI.p"
; at Wednesday May 1,2002 2:40:22 pm.
; 
;      File:       SCSI.p
;  
;      Contains:   SCSI Family Interfaces.
;  
;      Version:    Technology: SCSI 4.3
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1986-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SCSI__
; $SETC __SCSI__ := 1

; $I+
; $SETC SCSIIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __APPLEDISKPARTITIONS__
|#

(require-interface 'AppleDiskPartitions)
#|                                              ; $I AppleDiskPartitions.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  SCSI Manager errors. These are generated by Inside Mac IV calls only. 

(defconstant $scCommErr 2)                      ;   communications error, operation timeout  
(defconstant $scArbNBErr 3)                     ;   arbitration timeout waiting for not BSY  
(defconstant $scBadParmsErr 4)                  ;   bad parameter or TIB opcode  
(defconstant $scPhaseErr 5)                     ;   SCSI bus not in correct phase for attempted operation  
(defconstant $scCompareErr 6)                   ;   data compare error  
(defconstant $scMgrBusyErr 7)                   ;   SCSI Manager busy   
(defconstant $scSequenceErr 8)                  ;   attempted operation is out of sequence  
(defconstant $scBusTOErr 9)                     ;   CPU bus timeout  
(defconstant $scComplPhaseErr 10)               ;   SCSI bus wasn't in Status phase  

; 	 TIB opcodes 	
(defconstant $scInc 1)
(defconstant $scNoInc 2)
(defconstant $scAdd 3)
(defconstant $scMove 4)
(defconstant $scLoop 5)
(defconstant $scNop 6)
(defconstant $scStop 7)
(defconstant $scComp 8)

; 	 
; 	 * All disk partition structures and definitions are now in the 
; 	 * AppleDiskPartitions.h/p/a files.
; 	 	
; 	 TIB instruction 	

(def-mactype :scsiinstrptr (find-mactype '(:pointer :scsiinstr)))
(defrecord SCSIInstr 
   (scOpcode :unsigned-integer)
   (scParam1 :signed-long)
   (scParam2 :signed-long)
   )

; 	 SCSI Phases (used by SIMs to support the Original SCSI Manager 	

(defconstant $kDataOutPhase 0)                  ;   Encoded MSG, C/D, I/O bits  
(defconstant $kDataInPhase 1)
(defconstant $kCommandPhase 2)
(defconstant $kStatusPhase 3)
(defconstant $kPhaseIllegal0 4)
(defconstant $kPhaseIllegal1 5)
(defconstant $kMessageOutPhase 6)
(defconstant $kMessageInPhase 7)
(defconstant $kBusFreePhase 8)                  ;   Additional Phases  
(defconstant $kArbitratePhase 9)
(defconstant $kSelectPhase 10)
(defconstant $kMessageInPhaseNACK 11)           ;   Message In Phase with ACK hanging on the bus  

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SCSIReset()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SCSIReset" 
      () 
  :signed-integer
   (#x4267 #xA815) )

; 
;  *  SCSIGet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIGet" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA815 (1 :signed-integer)))

; 
;  *  SCSISelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSISelect" 
      ((targetID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA815 targetID (2 :signed-integer)))

; 
;  *  SCSICmd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSICmd" 
      ((buffer :pointer) (count :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA815 buffer count (3 :signed-integer)))

; 
;  *  SCSIRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIRead" 
      ((tibPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA815 tibPtr (5 :signed-integer)))

; 
;  *  SCSIRBlind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIRBlind" 
      ((tibPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA815 tibPtr (8 :signed-integer)))

; 
;  *  SCSIWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIWrite" 
      ((tibPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA815 tibPtr (6 :signed-integer)))

; 
;  *  SCSIWBlind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIWBlind" 
      ((tibPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA815 tibPtr (9 :signed-integer)))

; 
;  *  SCSIComplete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIComplete" 
      ((stat (:pointer :signed-integer)) (message (:pointer :signed-integer)) (wait :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA815 stat message wait (4 :signed-integer)))

; 
;  *  SCSIStat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIStat" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA815 (10 :signed-integer)))

; 
;  *  SCSISelAtn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSISelAtn" 
      ((targetID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA815 targetID (11 :signed-integer)))

; 
;  *  SCSIMsgIn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIMsgIn" 
      ((message (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA815 message (12 :signed-integer)))

; 
;  *  SCSIMsgOut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIMsgOut" 
      ((message :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA815 message (13 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $scsiVERSION 43)

; 	
; 	 * SCSI Callback Procedure Prototypes. Several of these are only callable
; 	 * from SCSI Manager 4.3 SIM and XPT contexts. 
; 	 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AENCallbackProcPtr = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :aencallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SIMInitProcPtr = FUNCTION(SIMinfoPtr: Ptr): OSErr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :siminitprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SIMActionProcPtr = PROCEDURE(scsiPB: UNIV Ptr; SIMGlobals: Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :simactionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SCSIProcPtr = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :scsiprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SCSIMakeCallbackProcPtr = PROCEDURE(scsiPB: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :scsimakecallbackprocptr (find-mactype ':pointer))
; $ENDC

; 	 SCSIInterruptPollProcPtr is obsolete (use SCSIInterruptProcPtr) but still here for compatibility 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SCSIInterruptPollProcPtr = FUNCTION(SIMGlobals: Ptr): LONGINT; C;

|#
 |#                                             ; $ELSEC
(def-mactype :scsiinterruptpollprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SCSIInterruptProcPtr = FUNCTION(SIMGlobals: Ptr): LONGINT; C;

|#
 |#                                             ; $ELSEC
(def-mactype :scsiinterruptprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aencallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aencallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :siminitupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :siminitupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :simactionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :simactionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scsiupp (find-mactype ':pointer)) ;  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scsiupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scsimakecallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scsimakecallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scsiinterruptpollupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scsiinterruptpollupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scsiinterruptupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scsiinterruptupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppAENCallbackProcInfo #x1)
(defconstant $uppSIMInitProcInfo #xE1)
(defconstant $uppSIMActionProcInfo #x3C1)
(defconstant $uppSCSIProcInfo #x1)
(defconstant $uppSCSIMakeCallbackProcInfo #xC1)
(defconstant $uppSCSIInterruptPollProcInfo #xF1)
(defconstant $uppSCSIInterruptProcInfo #xF1)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewAENCallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewAENCallbackProc 
(deftrap "_NewAENCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSIMInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSIMInitProc 
(deftrap "_NewSIMInitUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSIMActionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSIMActionProc 
(deftrap "_NewSIMActionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSCSIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSCSIProc 
(deftrap "_NewSCSIUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSCSIMakeCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSCSIMakeCallbackProc 
(deftrap "_NewSCSIMakeCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSCSIInterruptPollUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSCSIInterruptPollProc 
(deftrap "_NewSCSIInterruptPollUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSCSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewSCSIInterruptProc 
(deftrap "_NewSCSIInterruptUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAENCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeAENCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSIMInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSIMInitUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSIMActionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSIMActionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSCSIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSCSIUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSCSIMakeCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSCSIMakeCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSCSIInterruptPollUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSCSIInterruptPollUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSCSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSCSIInterruptUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAENCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallAENCallbackProc             ; 
;  *  InvokeSIMInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeAENCallbackUPP" 
      ((userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallSIMInitProc ; 
;  *  InvokeSIMActionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeSIMInitUPP" 
      ((SIMinfoPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   () )                                         ;  old name was CallSIMActionProc ; 
;  *  InvokeSCSIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeSIMActionUPP" 
      ((scsiPB :pointer) (SIMGlobals :pointer) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallSCSIProc ; 
;  *  InvokeSCSIMakeCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeSCSIUPP" 
      ((userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallSCSIMakeCallbackProc ; 
;  *  InvokeSCSIInterruptPollUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeSCSIMakeCallbackUPP" 
      ((scsiPB :pointer) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallSCSIInterruptPollProc ; 
;  *  InvokeSCSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeSCSIInterruptPollUPP" 
      ((SIMGlobals :pointer) (userRoutine :pointer)) 
  :signed-long
   () )                                         ;  old name was CallSCSIInterruptProc 
(deftrap-inline "_InvokeSCSIInterruptUPP" 
      ((SIMGlobals :pointer) (userRoutine :pointer)) 
  :signed-long
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  * SCSI Completion routine callback for SCSIAction.
;  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SCSICallbackProcPtr = PROCEDURE(scsiPB: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :scsicallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scsicallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scsicallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSCSICallbackProcInfo #xC0)
; 
; 	 *  NewSCSICallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSCSICallbackProc 
(deftrap "_NewSCSICallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSCSICallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSCSICallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSCSICallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSCSICallbackProc 
(deftrap-inline "_InvokeSCSICallbackUPP" 
      ((scsiPB :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

;  
;    SCSI Manager 4.3 function codes 
;  

(defconstant $SCSINop #x0)                      ;   Execute nothing                           
(defconstant $SCSIExecIO #x1)                   ;   Execute the specified IO                   
(defconstant $SCSIBusInquiry #x3)               ;   Get parameters for entire path of HBAs            
(defconstant $SCSIReleaseQ #x4)                 ;   Release the frozen SIM queue for particular LUN       
(defconstant $SCSIAbortCommand #x10)            ;   Abort the selected Control Block              
(defconstant $SCSIResetBus #x11)                ;   Reset the SCSI bus                          
(defconstant $SCSIResetDevice #x12)             ;   Reset the SCSI device                       
(defconstant $SCSITerminateIO #x13)             ;   Terminate any pending IO                     

; 	 Not available in Carbon on X 	
(defconstant $SCSIGetVirtualIDInfo #x80)        ;   Find out which bus old ID is on                 
(defconstant $SCSILoadDriver #x82)              ;   Load a driver for a device ident              
(defconstant $SCSIOldCall #x84)                 ;   XPT->SIM private call for old-API             
(defconstant $SCSICreateRefNumXref #x85)        ;   Register a DeviceIdent to drvr RefNum xref           
(defconstant $SCSILookupRefNumXref #x86)        ;   Get DeviceIdent to drvr RefNum xref               
(defconstant $SCSIRemoveRefNumXref #x87)        ;   Remove a DeviceIdent to drvr RefNum xref         
(defconstant $SCSIRegisterWithNewXPT #x88)      ;   XPT has changed - SIM needs to re-register itself   

(defconstant $vendorUnique #xC0)                ;   0xC0 thru 0xFF  

; 	 Allocation length defines for some of the fields 	
(defconstant $handshakeDataLength 8)            ;   Handshake data length  
(defconstant $maxCDBLength 16)                  ;   Space for the CDB bytes/pointer  
(defconstant $vendorIDLength 16)                ;   ASCII string len for Vendor ID   

; 	 Define DeviceIdent structure 	

(def-mactype :deviceidentptr (find-mactype '(:pointer :deviceident)))
(defrecord DeviceIdent 
   (diReserved :unsigned-byte)                  ;   reserved            
   (bus :unsigned-byte)                         ;   SCSI - Bus Number    
   (targetID :unsigned-byte)                    ;   SCSI - Target SCSI ID   
   (LUN :unsigned-byte)                         ;   SCSI - LUN             
   )

; 	 Constants for the diReserved field of DeviceIdent 	
; 	 used to distinguish whether the DeviceIdent holds 	
; 	 information about a SCSI device (kBusTypeSCSI)    	
; 	 or an ATA device (kBusTypeATA).  The other        	
; 	 constants are pretty much deprecated.  Let me     	
; 	 know if you see any.                              	

(defconstant $kBusTypeSCSI 0)
(defconstant $kBusTypeATA 1)
(defconstant $kBusTypePCMCIA 2)
(defconstant $kBusTypeMediaBay 3)

; 	 If diReserved indicates that a DeviceIdent is     	
; 	 really for ATA, you can cast it to DeviceIdentATA 	
; 	 to get at the important fields.                   	

(def-mactype :deviceidentataptr (find-mactype '(:pointer :deviceidentata)))
(defrecord DeviceIdentATA 
   (diReserved :signed-byte)
   (busNum :signed-byte)
   (devNum :signed-byte)
   (diReserved2 :signed-byte)
   )

;   for use with Apple Patch Driver used during booting 
(def-mactype :patchdescriptorptr (find-mactype '(:pointer :patchdescriptor)))
(defrecord PatchDescriptor 
   (patchSig :ostype)                           ;   The patches signature                 
   (majorVers :unsigned-integer)                ;   The major version number of the       
;   patch                                 
   (minorVers :unsigned-integer)                ;   The minor version number of the       
;   patch                                 
   (flags :unsigned-long)                       ;   Reqired/Optional, etc.                
   (patchOffset :unsigned-long)                 ;   Block offset to the beginning of      
;   the patch                             
   (patchSize :unsigned-long)                   ;   Actual size of the patch in bytes     
   (patchCRC :unsigned-long)                    ;   As calculated by the SCSI drivers     
;   CRC code                              
   (patchDescriptorLen :unsigned-long)          ;   Total length of the descriptor        
;   (must be >= 61 bytes)                 
   (patchName (:string 32))                     ;   Pascal string with a short            
;   description of the patch              
   (patchVendor :signed-byte)                   ;   The first byte of a pascal string     
;   for the patch Vendor. Any amount      
;   of data may follow the string.        
   )

; 	 Constants for the flags field of PatchDescriptor. 	

(defconstant $kRequiredPatch #x1)               ;   Patch must succeed to continue booting.  

(def-mactype :patchlistptr (find-mactype '(:pointer :patchlist)))
(defrecord PatchList 
   (numPatchBlocks :unsigned-integer)           ;   The number of disk blocks         
;   to hold patch descriptions        
   (numPatches :unsigned-integer)               ;   The number of patches             
   (thePatch (:array :patchdescriptor 1))       ;   An array with one patch           
;   per element                       
   )

;   signature of a Patch entry point 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PatchEntryPoint = FUNCTION(VAR myPatch: PatchDescriptor; myDevID: DeviceIdent): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :patchentrypoint (find-mactype ':pointer))
; $ENDC

; 	 Command Descriptor Block structure 	
(def-mactype :cdbptr (find-mactype '(:pointer :cdb)))
(defrecord CDB 
   (:variant 
      (
      (cdbPtr (:pointer :unsigned-byte))        ;   pointer to the CDB, or  
      )
      (
      (cdbBytes (:array :unsigned-byte 16 :packed));   the actual CDB to send  
      )
      )
   )

; 	 Scatter/gather list element (Deprecated for MacOS8) 	
(def-mactype :sgrecordptr (find-mactype '(:pointer :sgrecord)))
(defrecord SGRecord 
   (SGAddr :pointer)
   (SGCount :unsigned-long)
   )

(def-mactype :scsihdrptr (find-mactype '(:pointer :scsihdr)))
(defrecord SCSIHdr 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   )

(def-mactype :scsi_pbptr (find-mactype '(:pointer :scsi_pb)))
(defrecord SCSI_PB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   )

(def-mactype :scsi_ioptr (find-mactype '(:pointer :scsi_io)))
(defrecord SCSI_IO 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiResultFlags :unsigned-integer)          ;   <- Flags which modify the scsiResult field      
   (scsiReserved3pt5 :unsigned-integer)         ;   -> Reserved                            
   (scsiDataPtr (:pointer :unsigned-byte))      ;   -> Pointer to the data buffer or the S/G list       
   (scsiDataLength :unsigned-long)              ;   -> Data transfer length                    
   (scsiSensePtr (:pointer :unsigned-byte))     ;   -> Ptr to autosense data buffer             
   (scsiSenseLength :signed-byte)               ;   -> size of the autosense buffer               
   (scsiCDBLength :signed-byte)                 ;   -> Number of bytes for the CDB                
   (scsiSGListCount :unsigned-integer)          ;   -> num of scatter gather list entries            
   (scsiReserved4 :unsigned-long)               ;   <-     reserved for output                    
   (scsiSCSIstatus :signed-byte)                ;   <- Returned scsi device status                
   (scsiSenseResidual :signed-byte)             ;   <- Autosense residual length              
   (scsiReserved5 :unsigned-integer)            ;   <-     reserved for output                  
   (scsiDataResidual :signed-long)              ;   <- Returned Transfer residual length           
   (scsiCDB :cdb)                               ;   -> Actual CDB or pointer to CDB             
   (scsiTimeout :signed-long)                   ;   -> Timeout value (Time Mgr format) (CAM timeout)  
   (scsiReserved5pt5 (:pointer :unsigned-byte)) ;   -> Reserved                            
   (scsiReserved5pt6 :unsigned-integer)         ;   -> Reserved                            
   (scsiIOFlags :unsigned-integer)              ;   -> additional I/O flags                       
   (scsiTagAction :signed-byte)                 ;   -> What to do for tag queuing                 
   (scsiReserved6 :signed-byte)                 ;   ->     reserved for input                    
   (scsiReserved7 :unsigned-integer)            ;   ->     reserved for input                    
   (scsiSelectTimeout :unsigned-integer)        ;   -> Select timeout value                  
   (scsiDataType :signed-byte)                  ;   -> Data description type (i.e. buffer, TIB, S/G)    
   (scsiTransferType :signed-byte)              ;   -> Transfer type (i.e. Blind vs Polled)        
   (scsiReserved8 :unsigned-long)               ;   ->     reserved for input                   
   (scsiReserved9 :unsigned-long)               ;   ->     reserved for input                   
   (scsiHandshake (:array :unsigned-integer 8)) ;   -> handshaking points (null term'd)     
   (scsiReserved10 :unsigned-long)              ;   ->     reserved for input                   
   (scsiReserved11 :unsigned-long)              ;   ->   reserved for input                    
   (scsiCommandLink (:pointer :scsi_io))        ;   -> Ptr to the next PB in linked cmd chain       
   (scsiSIMpublics (:array :unsigned-byte 8 :packed));   ->     reserved for input to 3rd-party SIMs      
   (scsiAppleReserved6 (:array :unsigned-byte 8 :packed));   -> reserved for input                      
;   XPT layer privates (for old-API emulation)  
   (scsiCurrentPhase :unsigned-integer)         ;   <- phase upon completing old call             
   (scsiSelector :signed-integer)               ;   -> selector specified in old calls             
   (scsiOldCallResult :signed-integer)          ;   <- result of old call                      
   (scsiSCSImessage :signed-byte)               ;   <- Returned scsi device message (for SCSIComplete) 
   (XPTprivateFlags :signed-byte)               ;   <> various flags                        
   (XPTextras (:array :unsigned-byte 12 :packed));                                 
   )

(%define-record :scsiexeciopb (find-record-descriptor :scsi_io))
(def-mactype :scsiexeciopbptr (find-mactype '(:pointer :scsi_io)))
; 	 Bus inquiry PB 	
(def-mactype :scsibusinquirypbptr (find-mactype '(:pointer :scsibusinquirypb)))
(defrecord SCSIBusInquiryPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiEngineCount :unsigned-integer)          ;   <- Number of engines on HBA                 
   (scsiMaxTransferType :unsigned-integer)      ;   <- Number of transfer types for this HBA       
   (scsiDataTypes :unsigned-long)               ;   <- which data types are supported by this SIM   
   (scsiIOpbSize :unsigned-integer)             ;   <- Size of SCSI_IO PB for this SIM/HBA           
   (scsiMaxIOpbSize :unsigned-integer)          ;   <- Size of max SCSI_IO PB for all SIM/HBAs         
   (scsiFeatureFlags :unsigned-long)            ;   <- Supported features flags field            
   (scsiVersionNumber :signed-byte)             ;   <- Version number for the SIM/HBA            
   (scsiHBAInquiry :signed-byte)                ;   <- Mimic of INQ byte 7 for the HBA            
   (scsiTargetModeFlags :signed-byte)           ;   <- Flags for target mode support            
   (scsiScanFlags :signed-byte)                 ;   <- Scan related feature flags             
   (scsiSIMPrivatesPtr :unsigned-long)          ;   <- Ptr to SIM private data area               
   (scsiSIMPrivatesSize :unsigned-long)         ;   <- Size of SIM private data area            
   (scsiAsyncFlags :unsigned-long)              ;   <- Event cap. for Async Callback            
   (scsiHiBusID :signed-byte)                   ;   <- Highest path ID in the subsystem          
   (scsiInitiatorID :signed-byte)               ;   <- ID of the HBA on the SCSI bus            
   (scsiBIReserved0 :unsigned-integer)          ;                                     
   (scsiBIReserved1 :unsigned-long)             ;   <-                                 
   (scsiFlagsSupported :unsigned-long)          ;   <- which scsiFlags are supported            
   (scsiIOFlagsSupported :unsigned-integer)     ;   <- which scsiIOFlags are supported            
   (scsiWeirdStuff :unsigned-integer)           ;   <-                                
   (scsiMaxTarget :unsigned-integer)            ;   <- maximum Target number supported            
   (scsiMaxLUN :unsigned-integer)               ;   <- maximum Logical Unit number supported     
   (scsiSIMVendor (:array :character 16 :packed));   <- Vendor ID of SIM (or XPT if bus<FF)         
   (scsiHBAVendor (:array :character 16 :packed));   <- Vendor ID of the HBA                 
   (scsiControllerFamily (:array :character 16 :packed));   <- Family of SCSI Controller            
   (scsiControllerType (:array :character 16 :packed));   <- Specific Model of SCSI Controller used   
   (scsiXPTversion (:array :character 4 :packed));   <- version number of XPT               
   (scsiSIMversion (:array :character 4 :packed));   <- version number of SIM               
   (scsiHBAversion (:array :character 4 :packed));   <- version number of HBA               
   (scsiHBAslotType :signed-byte)               ;   <- type of "slot" that this HBA is in        
   (scsiHBAslotNumber :signed-byte)             ;   <- slot number of this HBA                   
   (scsiSIMsRsrcID :unsigned-integer)           ;   <- resource ID of this SIM                   
   (scsiBIReserved3 :unsigned-integer)          ;   <-                                
   (scsiAdditionalLength :unsigned-integer)     ;   <- additional BusInquiry PB len               
   )

; 	 Abort SIM Request PB 	
(def-mactype :scsiabortcommandpbptr (find-mactype '(:pointer :scsiabortcommandpb)))
(defrecord SCSIAbortCommandPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiIOptr (:pointer :scsi_io))              ;   Pointer to the PB to abort         
   )

; 	 Terminate I/O Process Request PB 	
(def-mactype :scsiterminateiopbptr (find-mactype '(:pointer :scsiterminateiopb)))
(defrecord SCSITerminateIOPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiIOptr (:pointer :scsi_io))              ;   Pointer to the PB to terminate         
   )

; 	 Reset SCSI Bus PB 	
(def-mactype :scsiresetbuspbptr (find-mactype '(:pointer :scsiresetbuspb)))
(defrecord SCSIResetBusPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   )

; 	 Reset SCSI Device PB 	
(def-mactype :scsiresetdevicepbptr (find-mactype '(:pointer :scsiresetdevicepb)))
(defrecord SCSIResetDevicePB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   )

; 	 Release SIM Queue PB 	
(def-mactype :scsireleaseqpbptr (find-mactype '(:pointer :scsireleaseqpb)))
(defrecord SCSIReleaseQPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage (:pointer :unsigned-byte));   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   )

; 	 SCSI Get Virtual ID Info PB 	
(def-mactype :scsigetvirtualidinfopbptr (find-mactype '(:pointer :scsigetvirtualidinfopb)))
(defrecord SCSIGetVirtualIDInfoPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage :pointer)                 ;   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiOldCallID :unsigned-integer)            ;   -> SCSI ID of device in question    
   (scsiExists :boolean)                        ;   <- true if device exists         
   (filler :signed-byte)
   )

; 	 Create/Lookup/Remove RefNum for Device PB 	
(def-mactype :scsidriverpbptr (find-mactype '(:pointer :scsidriverpb)))
(defrecord SCSIDriverPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage :pointer)                 ;   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiDriver :signed-integer)                 ;   -> DriverRefNum, For SetDriver, <- For GetNextDriver  
   (scsiDriverFlags :unsigned-integer)          ;   <> Details of driver/device        
   (scsiNextDevice :deviceident)                ;   <- DeviceIdent of the NEXT Item in the list   
   )

; 	 Load Driver PB 	
(def-mactype :scsiloaddriverpbptr (find-mactype '(:pointer :scsiloaddriverpb)))
(defrecord SCSILoadDriverPB 
   (qLink (:pointer :scsihdr))                  ;   (internal use, must be nil on entry)    
   (scsiReserved1 :signed-integer)              ;   ->     reserved for input           
   (scsiPBLength :unsigned-integer)             ;   -> Length of the entire PB         
   (scsiFunctionCode :signed-byte)              ;   -> function selector            
   (scsiReserved2 :signed-byte)                 ;   <-     reserved for output           
   (scsiResult :signed-integer)                 ;   <- Returned result                
   (scsiDevice :deviceident)                    ;   -> Device Identifier (bus+target+lun) 
   (scsiCompletion :pointer)                    ;   -> Callback on completion function      
   (scsiFlags :unsigned-long)                   ;   -> assorted flags             
   (scsiDriverStorage :pointer)                 ;   <> Ptr for driver private use    
   (scsiXPTprivate :pointer)                    ;   private field for use in XPT       
   (scsiReserved3 :signed-long)                 ;   reserved                     
   (scsiLoadedRefNum :signed-integer)           ;   <- SIM returns refnum of driver       
   (scsiDiskLoadFailed :boolean)                ;   -> if true, indicates call after failure to load  
   (filler :signed-byte)
   )

; 	 Defines for the scsiTransferType field 	

(defconstant $scsiTransferBlind 0)
(defconstant $scsiTransferPolled 1)

(defconstant $scsiErrorBase -7936)

(defconstant $scsiRequestInProgress 1)          ;   1   = PB request is in progress           
;   Execution failed  00-2F  
(defconstant $scsiRequestAborted -7934)         ;   -7934 = PB request aborted by the host         
(defconstant $scsiUnableToAbort -7933)          ;   -7933 = Unable to Abort PB request           
(defconstant $scsiNonZeroStatus -7932)          ;   -7932 = PB request completed with an err    
(defconstant $scsiUnused05 -7931)               ;   -7931 =                         
(defconstant $scsiUnused06 -7930)               ;   -7930 =                         
(defconstant $scsiUnused07 -7929)               ;   -7929 =                         
(defconstant $scsiUnused08 -7928)               ;   -7928 =                         
(defconstant $scsiUnableToTerminate -7927)      ;   -7927 = Unable to Terminate I/O PB req         
(defconstant $scsiSelectTimeout -7926)          ;   -7926 = Target selection timeout         
(defconstant $scsiCommandTimeout -7925)         ;   -7925 = Command timeout               
(defconstant $scsiIdentifyMessageRejected -7924);   -7924 =                         
(defconstant $scsiMessageRejectReceived -7923)  ;   -7923 = Message reject received            
(defconstant $scsiSCSIBusReset -7922)           ;   -7922 = SCSI bus reset sent/received     
(defconstant $scsiParityError -7921)            ;   -7921 = Uncorrectable parity error occured      
(defconstant $scsiAutosenseFailed -7920)        ;   -7920 = Autosense: Request sense cmd fail   
(defconstant $scsiUnused11 -7919)               ;   -7919 =                         
(defconstant $scsiDataRunError -7918)           ;   -7918 = Data overrun/underrun error      
(defconstant $scsiUnexpectedBusFree -7917)      ;   -7917 = Unexpected BUS free               
(defconstant $scsiSequenceFailed -7916)         ;   -7916 = Target bus phase sequence failure   
(defconstant $scsiWrongDirection -7915)         ;   -7915 = Data phase was in wrong direction   
(defconstant $scsiUnused16 -7914)               ;   -7914 =                         
(defconstant $scsiBDRsent -7913)                ;   -7913 = A SCSI BDR msg was sent to target   
(defconstant $scsiTerminated -7912)             ;   -7912 = PB request terminated by the host   
(defconstant $scsiNoNexus -7911)                ;   -7911 = Nexus is not established         
(defconstant $scsiCDBReceived -7910)            ;   -7910 = The SCSI CDB has been received         
;   Couldn't begin execution  30-3F  
(defconstant $scsiTooManyBuses -7888)           ;   -7888 = Register failed because we're full  
(defconstant $scsiBusy -7887)                   ;   -7887 = SCSI subsystem is busy            
(defconstant $scsiProvideFail -7886)            ;   -7886 = Unable to provide requ. capability  
(defconstant $scsiDeviceNotThere -7885)         ;   -7885 = SCSI device not installed/there     
(defconstant $scsiNoHBA -7884)                  ;   -7884 = No HBA detected Error            
(defconstant $scsiDeviceConflict -7883)         ;   -7883 = sorry, max 1 refNum per DeviceIdent     
(defconstant $scsiNoSuchXref -7882)             ;   -7882 = no such RefNum xref               
(defconstant $scsiQLinkInvalid -7881)           ;   -7881 = pre-linked PBs not supported       
;     (The QLink field was nonzero)           
;   Parameter errors  40-7F  
(defconstant $scsiPBLengthError -7872)          ;   -7872 = (scsiPBLength is insuf'ct/invalid   
(defconstant $scsiFunctionNotAvailable -7871)   ;   -7871 = The requ. func is not available     
(defconstant $scsiRequestInvalid -7870)         ;   -7870 = PB request is invalid            
(defconstant $scsiBusInvalid -7869)             ;   -7869 = Bus ID supplied is invalid         
(defconstant $scsiTIDInvalid -7868)             ;   -7868 = Target ID supplied is invalid       
(defconstant $scsiLUNInvalid -7867)             ;   -7867 = LUN supplied is invalid          
(defconstant $scsiIDInvalid -7866)              ;   -7866 = The initiator ID is invalid      
(defconstant $scsiDataTypeInvalid -7865)        ;   -7865 = scsiDataType requested not supported  
(defconstant $scsiTransferTypeInvalid -7864)    ;   -7864 = scsiTransferType field is too high      
(defconstant $scsiCDBLengthInvalid -7863)       ;   -7863 = scsiCDBLength field is too big         

; 	 New errors for SCSI Family         	
(defconstant $scsiUnused74 -7862)               ;   -7862 =                           
(defconstant $scsiUnused75 -7861)               ;   -7861 =                           
(defconstant $scsiBadDataLength -7860)          ;   -7860 = a zero data length in PB         
(defconstant $scsiPartialPrepared -7859)        ;   -7859 = could not do full prepare mem for I/O 
(defconstant $scsiInvalidMsgType -7858)         ;   -7858 = Invalid message type (internal)        
(defconstant $scsiUnused79 -7857)               ;   -7857 =                               
(defconstant $scsiBadConnID -7856)              ;   -7856 = Bad Connection ID                 
(defconstant $scsiUnused81 -7855)               ;   -7855 =                           
(defconstant $scsiIOInProgress -7854)           ;   -7854 = Can't close conn, IO in prog       
(defconstant $scsiTargetReserved -7853)         ;   -7853 = Target already reserved           
(defconstant $scsiUnused84 -7852)               ;   -7852 =                           
(defconstant $scsiUnused85 -7851)               ;   -7851 =                           
(defconstant $scsiBadConnType -7850)            ;   -7850 = Bad connection type               
(defconstant $scsiCannotLoadPlugin -7849)       ;   -7849 = No matching service category       

; 	 +++ 	
; 	
; 	 * scsiFamilyInternalError and scsiPluginInternalError are intended to handle consistency check failures.
; 	 * For example, if the family stores a record on a lookaside queue, but does not find that record
; 	 * it can use this error to report this failure. SCSI Manager 4.3 uses dsIOCoreErr in a few places,
; 	 * but this is probably not the best error. In general, internal errors should be reported as bugs.
; 	 *
; 	 * The following range of errors is provided for third-party (non-Apple) SCSI SIM and device driver vendors.
; 	 * In general, they would be used for error conditions that are not covered by the standardized errors.
; 	 * They should not normally be conveyed to normal applications, but might be used for communication between
; 	 * a plug-in and a vendor-provided device driver (for example, to manage RAID hot-swapping).
; 	 *
; 	 * Note: I don't know how many SCSI errors are reserved in the error code architecture. Don't assume that
; 	 * we'll actually get sixteen, but we should reserve at least one.
; 	 	
(defconstant $scsiFamilyInternalError -7849)    ;   -7849 = Internal consistency check failed   
(defconstant $scsiPluginInternalError -7848)    ;   -7848 = Internal consistency check failed   
(defconstant $scsiVendorSpecificErrorBase -7808);   ??    = Start of third-party error range      
(defconstant $scsiVendorSpecificErrorCount 16)  ;   Number of third-party errors              

; 	 --- 	
(defconstant $scsiExecutionErrors -7936)
(defconstant $scsiNotExecutedErrors -7888)
(defconstant $scsiParameterErrors -7872)

; 	 Defines for the scsiResultFlags field 	
(defconstant $scsiSIMQFrozen #x1)               ;   The SIM queue is frozen w/this err         
(defconstant $scsiAutosenseValid #x2)           ;   Autosense data valid for target          
(defconstant $scsiBusNotFree #x4)               ;   At time of callback, SCSI bus is not free   

; 	 Defines for the bit numbers of the scsiFlags field in the PB header for the SCSIExecIO function 	
(defconstant $kbSCSIDisableAutosense 29)        ;   Disable auto sense feature                
(defconstant $kbSCSIFlagReservedA 28)           ;                                
(defconstant $kbSCSIFlagReserved0 27)           ;                                
(defconstant $kbSCSICDBLinked 26)               ;   The PB contains a linked CDB              
(defconstant $kbSCSIQEnable 25)                 ;   Target queue actions are enabled           
(defconstant $kbSCSICDBIsPointer 24)            ;   The CDB field contains a pointer           
(defconstant $kbSCSIFlagReserved1 23)           ;                                  
(defconstant $kbSCSIInitiateSyncData 22)        ;   Attempt Sync data xfer and SDTR           
(defconstant $kbSCSIDisableSyncData 21)         ;   Disable sync, go to async             
(defconstant $kbSCSISIMQHead 20)                ;   Place PB at the head of SIM Q           
(defconstant $kbSCSISIMQFreeze 19)              ;   Return the SIM Q to frozen state           
(defconstant $kbSCSISIMQNoFreeze 18)            ;   Disallow SIM Q freezing                  
(defconstant $kbSCSIDoDisconnect 17)            ;   Definitely do disconnect                
(defconstant $kbSCSIDontDisconnect 16)          ;   Definitely don't disconnect               
(defconstant $kbSCSIDataReadyForDMA 15)         ;   Data buffer(s) are ready for DMA           
(defconstant $kbSCSIFlagReserved3 14)           ;                                  
(defconstant $kbSCSIDataPhysical 13)            ;   SG/Buffer data ptrs are physical           
(defconstant $kbSCSISensePhysical 12)           ;   Autosense buffer ptr is physical           
(defconstant $kbSCSIFlagReserved5 11)           ;                                  
(defconstant $kbSCSIFlagReserved6 10)           ;                                  
(defconstant $kbSCSIFlagReserved7 9)            ;                                  
(defconstant $kbSCSIFlagReserved8 8)            ;                                  
(defconstant $kbSCSIDataBufferValid 7)          ;   Data buffer valid                  
(defconstant $kbSCSIStatusBufferValid 6)        ;   Status buffer valid                  
(defconstant $kbSCSIMessageBufferValid 5)       ;   Message buffer valid                 
(defconstant $kbSCSIFlagReserved9 4)            ;                                

; 	 Defines for the bit masks of the scsiFlags field 	
(defconstant $scsiDirectionMask #xC0000000)     ;   Data direction mask                  
(defconstant $scsiDirectionNone #xC0000000)     ;   Data direction (11: no data)           
(defconstant $scsiDirectionReserved #x0)        ;   Data direction (00: reserved)        
(defconstant $scsiDirectionOut #x80000000)      ;   Data direction (10: DATA OUT)        
(defconstant $scsiDirectionIn #x40000000)       ;   Data direction (01: DATA IN)           
(defconstant $scsiDisableAutosense #x20000000)  ;   Disable auto sense feature           
(defconstant $scsiFlagReservedA #x10000000)     ;                              
(defconstant $scsiFlagReserved0 #x8000000)      ;                              
(defconstant $scsiCDBLinked #x4000000)          ;   The PB contains a linked CDB           
(defconstant $scsiQEnable #x2000000)            ;   Target queue actions are enabled       
(defconstant $scsiCDBIsPointer #x1000000)       ;   The CDB field contains a pointer       
(defconstant $scsiFlagReserved1 #x800000)       ;                              
(defconstant $scsiInitiateSyncData #x400000)    ;   Attempt Sync data xfer and SDTR          
(defconstant $scsiDisableSyncData #x200000)     ;   Disable sync, go to async           
(defconstant $scsiSIMQHead #x100000)            ;   Place PB at the head of SIM Q        
(defconstant $scsiSIMQFreeze #x80000)           ;   Return the SIM Q to frozen state       
(defconstant $scsiSIMQNoFreeze #x40000)         ;   Disallow SIM Q freezing               
(defconstant $scsiDoDisconnect #x20000)         ;   Definitely do disconnect              
(defconstant $scsiDontDisconnect #x10000)       ;   Definitely don't disconnect           
(defconstant $scsiDataReadyForDMA #x8000)       ;   Data buffer(s) are ready for DMA       
(defconstant $scsiFlagReserved3 #x4000)         ;     
(defconstant $scsiDataPhysical #x2000)          ;   SG/Buffer data ptrs are physical       
(defconstant $scsiSensePhysical #x1000)         ;   Autosense buffer ptr is physical       
(defconstant $scsiFlagReserved5 #x800)          ;                            
(defconstant $scsiFlagReserved6 #x400)          ;                              
(defconstant $scsiFlagReserved7 #x200)          ;                              
(defconstant $scsiFlagReserved8 #x100)          ;                              

; 	 bit masks for the scsiIOFlags field in SCSIExecIOPB 	
(defconstant $scsiNoParityCheck #x2)            ;   disable parity checking                  
(defconstant $scsiDisableSelectWAtn #x4)        ;   disable select w/Atn                     
(defconstant $scsiSavePtrOnDisconnect #x8)      ;   do SaveDataPointer upon Disconnect msg           
(defconstant $scsiNoBucketIn #x10)              ;   dont bit bucket in during this I/O            
(defconstant $scsiNoBucketOut #x20)             ;   dont bit bucket out during this I/O         
(defconstant $scsiDisableWide #x40)             ;   disable wide transfer negotiation            
(defconstant $scsiInitiateWide #x80)            ;   initiate wide transfer negotiation            
(defconstant $scsiRenegotiateSense #x100)       ;   renegotiate sync/wide before issuing autosense      
(defconstant $scsiDisableDiscipline #x200)      ;   disable parameter checking on SCSIExecIO calls  
(defconstant $scsiIOFlagReserved0080 #x80)      ;                                   
(defconstant $scsiIOFlagReserved8000 #x8000)    ;                                     

; 	 Defines for the Bus Inquiry PB fields. 	
; 	 scsiHBAInquiry field bits 	
(defconstant $scsiBusMDP #x80)                  ;   Supports Modify Data Pointer message                
(defconstant $scsiBusWide32 #x40)               ;   Supports 32 bit wide SCSI                     
(defconstant $scsiBusWide16 #x20)               ;   Supports 16 bit wide SCSI                     
(defconstant $scsiBusSDTR #x10)                 ;   Supports Sync Data Transfer Req message               
(defconstant $scsiBusLinkedCDB #x8)             ;   Supports linked CDBs                          
(defconstant $scsiBusTagQ #x2)                  ;   Supports tag queue message                     
(defconstant $scsiBusSoftReset #x1)             ;   Supports soft reset                            

; 	 Defines for the scsiDataType field 	
(defconstant $scsiDataBuffer 0)                 ;   single contiguous buffer supplied             
(defconstant $scsiDataTIB 1)                    ;   TIB supplied (ptr in scsiDataPtr)            
(defconstant $scsiDataSG 2)                     ;   scatter/gather list supplied              
(defconstant $scsiDataIOTable 3)                ;  #(7/11/95) Prepared by Block Storage          

; 	 scsiDataTypes field bits  	
; 	  bits 0->15 Apple-defined, 16->30 3rd-party unique, 31 = reserved 	
(defconstant $scsiBusDataTIB #x2)               ;   TIB supplied (ptr in scsiDataPtr)    
(defconstant $scsiBusDataBuffer #x1)            ;   single contiguous buffer supplied       
(defconstant $scsiBusDataSG #x4)                ;   scatter/gather list supplied         
(defconstant $scsiBusDataIOTable #x8)           ;   (2/6/95) Prepare Memory for IO 
(defconstant $scsiBusDataReserved #x80000000)   ;                               

; 	 scsiScanFlags field bits 	
(defconstant $scsiBusScansDevices #x80)         ;   Bus scans for and maintains device list          
(defconstant $scsiBusScansOnInit #x40)          ;   Bus scans performed at power-up/reboot         
(defconstant $scsiBusLoadsROMDrivers #x20)      ;   may load ROM drivers to support targets        

; 	 scsiFeatureFlags field bits 	
(defconstant $scsiBusUltra4SCSI #x800)          ;   HBA supports Ultra4(Ultra320) SCSI         
(defconstant $scsiBusLVD #x400)                 ;   HBA is Low Voltage Differential Bus          
(defconstant $scsiBusUltra3SCSI #x200)          ;   HBA supports Ultra3 SCSI                
(defconstant $scsiBusUltra2SCSI #x100)          ;   HBA supports Ultra2 SCSI                
(defconstant $scsiBusInternalExternalMask #xC0) ;   bus internal/external mask            
(defconstant $scsiBusInternalExternalUnknown #x0);   not known whether bus is inside or outside      
(defconstant $scsiBusInternalExternal #xC0)     ;   bus goes inside and outside the box        
(defconstant $scsiBusInternal #x80)             ;   bus goes inside the box                 
(defconstant $scsiBusExternal #x40)             ;   bus goes outside the box              
(defconstant $scsiBusCacheCoherentDMA #x20)     ;   DMA is cache coherent                 
(defconstant $scsiBusOldCallCapable #x10)       ;   SIM is old call capable                 
(defconstant $scsiBusUltraSCSI #x8)             ;   HBA supports Ultra SCSI                  
(defconstant $scsiBusDifferential #x4)          ;   Single Ended (0) or Differential (1)     
(defconstant $scsiBusFastSCSI #x2)              ;   HBA supports fast SCSI                   
(defconstant $scsiBusDMAavailable #x1)          ;   DMA is available                   

; 	 scsiWeirdStuff field bits 	
(defconstant $scsiOddDisconnectUnsafeRead1 #x1) ;   Disconnects on odd byte boundries are unsafe with DMA and/or blind reads  
(defconstant $scsiOddDisconnectUnsafeWrite1 #x2);   Disconnects on odd byte boundries are unsafe with DMA and/or blind writes  
(defconstant $scsiBusErrorsUnsafe #x4)          ;   Non-handshaked delays or disconnects during blind transfers may cause a crash  
(defconstant $scsiRequiresHandshake #x8)        ;   Non-handshaked delays or disconnects during blind transfers may cause data corruption  
(defconstant $scsiTargetDrivenSDTRSafe #x10)    ;   Targets which initiate synchronous negotiations are supported  
(defconstant $scsiOddCountForPhysicalUnsafe #x20);   If using physical addrs all counts must be even, and disconnects must be on even boundries  
(defconstant $scsiAbortCmdFixed #x40)           ;   Set if abort command is fixed to properly make callbacks  
(defconstant $scsiMeshACKTimingFixed #x80)      ;   Set if bug allowing Mesh to release ACK prematurely is fixed  

; 	 scsiHBAslotType values 	
(defconstant $scsiMotherboardBus #x0)           ;   A built in Apple supplied bus             
(defconstant $scsiNuBus #x1)                    ;   A SIM on a NuBus card                    
(defconstant $scsiPDSBus #x3)                   ;      "  on a PDS card                     
(defconstant $scsiPCIBus #x4)                   ;      "  on a PCI bus card                    
(defconstant $scsiPCMCIABus #x5)                ;      "  on a PCMCIA card                   
(defconstant $scsiFireWireBridgeBus #x6)        ;      "  connected through a FireWire bridge    
(defconstant $scsiUSBBus #x7)                   ;      "  connected on a USB bus                

; 	 Defines for the scsiDriverFlags field (in SCSIDriverPB) 	
(defconstant $scsiDeviceSensitive #x1)          ;   Only driver should access this device           
(defconstant $scsiDeviceNoOldCallAccess #x2)    ;   no old call access to this device             

; 	  SIMInitInfo PB 	
; 	 directions are for SCSIRegisterBus call ( -> parm, <- result)            	

(def-mactype :siminitinfoptr (find-mactype '(:pointer :siminitinfo)))
(defrecord SIMInitInfo 
   (SIMstaticPtr :pointer)                      ;   <- alloc. ptr to the SIM's static vars            
   (staticSize :signed-long)                    ;   -> num bytes SIM needs for static vars            
   (SIMInit :pointer)                           ;   -> pointer to the SIM init routine                
   (SIMAction :pointer)                         ;   -> pointer to the SIM action routine            
   (SIM_ISR :pointer)                           ;        reserved                            
   (SIMInterruptPoll :pointer)                  ;   -> pointer to the SIM interrupt poll routine       
   (NewOldCall :pointer)                        ;   -> pointer to the SIM NewOldCall routine           
   (ioPBSize :unsigned-integer)                 ;   -> size of SCSI_IO_PBs required for this SIM       
   (oldCallCapable :boolean)                    ;   -> true if this SIM can handle old-API calls       
   (simInfoUnused1 :signed-byte)                ;        reserved                              
   (simInternalUse :signed-long)                ;   xx not affected or viewed by XPT                
   (XPT_ISR :pointer)                           ;      reserved                              
   (EnteringSIM :pointer)                       ;   <- ptr to the EnteringSIM routine             
   (ExitingSIM :pointer)                        ;   <- ptr to the ExitingSIM routine                
   (MakeCallback :pointer)                      ;   <- the XPT layers SCSIMakeCallback routine             
   (busID :unsigned-integer)                    ;   <- bus number for the registered bus              
   (simSlotNumber :signed-byte)                 ;   <- Magic cookie to place in scsiHBASlotNumber (PCI)     
   (simSRsrcID :signed-byte)                    ;   <- Magic cookie to place in scsiSIMsRsrcID  (PCI)   
   (simRegEntry :pointer)                       ;   -> The SIM's RegEntryIDPtr            (PCI)   
   )

; 	 Glue between SCSI calls and SCSITrap format 	

(defconstant $xptSCSIAction #x1)
(defconstant $xptSCSIRegisterBus #x2)
(defconstant $xptSCSIDeregisterBus #x3)
(defconstant $xptSCSIReregisterBus #x4)
(defconstant $xptSCSIKillXPT #x5)               ;   kills Mini-XPT after transition  
(defconstant $xptSCSIInitialize #xA)            ;   Initialize the SCSI manager  

; 	
; 	 * SCSI bus status. These values are returned by the SCSI target in the status phase.
; 	 * They are not related to Macintosh status values (except that values other than
; 	 * scsiStatusGood will result in scsiResult set to scsiNonZeroStatus).
; 	 	
(defconstant $scsiStatGood #x0)                 ;   Good Status 
(defconstant $scsiStatCheckCondition #x2)       ;   Check Condition 
(defconstant $scsiStatConditionMet #x4)         ;   Condition Met 
(defconstant $scsiStatBusy #x8)                 ;   Busy 
(defconstant $scsiStatIntermediate #x10)        ;   Intermediate 
(defconstant $scsiStatIntermedMet #x14)         ;   Intermediate - Condition Met 
(defconstant $scsiStatResvConflict #x18)        ;   Reservation conflict 
(defconstant $scsiStatTerminated #x22)          ;   Command terminated 
(defconstant $scsiStatQFull #x28)               ;   Queue full 

;   SCSI messages 
(defconstant $kCmdCompleteMsg 0)
(defconstant $kExtendedMsg 1)                   ;   0x01 
(defconstant $kSaveDataPointerMsg 2)            ;   0x02 
(defconstant $kRestorePointersMsg 3)            ;   0x03 
(defconstant $kDisconnectMsg 4)                 ;   0x04 
(defconstant $kInitiatorDetectedErrorMsg 5)     ;   0x05 
(defconstant $kAbortMsg 6)                      ;   0x06 
(defconstant $kMsgRejectMsg 7)                  ;   0x07 
(defconstant $kNoOperationMsg 8)                ;   0x08 
(defconstant $kMsgParityErrorMsg 9)             ;   0x09 
(defconstant $kLinkedCmdCompleteMsg 10)         ;   0x0a 
(defconstant $kLinkedCmdCompleteWithFlagMsg 11) ;   0x0b 
(defconstant $kBusDeviceResetMsg 12)            ;   0x0c 
(defconstant $kAbortTagMsg 13)                  ;   0x0d 
(defconstant $kClearQueueMsg 14)                ;   0x0e 
(defconstant $kInitiateRecoveryMsg 15)          ;   0x0f 
(defconstant $kReleaseRecoveryMsg 16)           ;   0x10 
(defconstant $kTerminateIOProcessMsg 17)        ;   0x11 
(defconstant $kSimpleQueueTag #x20)             ;   0x20 
(defconstant $kHeadOfQueueTagMsg #x21)          ;   0x21 
(defconstant $kOrderedQueueTagMsg #x22)         ;   0x22 
(defconstant $kIgnoreWideResidueMsg #x23)       ;   0x23 

; 	 moveq #kSCSIx, D0;  _SCSIAtomic 	
; 
; 	 *  SCSIAction()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_SCSIAction" 
      ((parameterBlock (:pointer :scsi_pb)))
   (:d0 :signed-integer)
   (:register-trap #xA089 :a0 parameterBlock :d0 1))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SCSIRegisterBus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIRegisterBus" 
      ((parameterBlock (:pointer :siminitinfo)))
   (:d0 :signed-integer)
   (:register-trap #xA089 :a0 parameterBlock :d0 2))

; 
;  *  SCSIDeregisterBus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIDeregisterBus" 
      ((parameterBlock (:pointer :scsi_pb)))
   (:d0 :signed-integer)
   (:register-trap #xA089 :a0 parameterBlock :d0 3))

; 
;  *  SCSIReregisterBus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIReregisterBus" 
      ((parameterBlock (:pointer :siminitinfo)))
   (:d0 :signed-integer)
   (:register-trap #xA089 :a0 parameterBlock :d0 4))

; 
;  *  SCSIKillXPT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCSIKillXPT" 
      ((parameterBlock (:pointer :siminitinfo)))
   (:d0 :signed-integer)
   (:register-trap #xA089 :a0 parameterBlock :d0 5))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SCSIIncludes

; $ENDC                                         ; __SCSI__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'SCSI)