(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ScalerStreamTypes.p"
; at Wednesday May 1,2002 2:40:30 pm.
; 
;      File:       ScalerStreamTypes.p
;  
;      Contains:   Scaler streaming data structures and constants for OFA 1.x
;  
;      Version:    Technology: Quickdraw GX 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SCALERSTREAMTYPES__
; $SETC __SCALERSTREAMTYPES__ := 1

; $I+
; $SETC ScalerStreamTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SFNTTYPES__
|#

(require-interface 'SFNTTypes)
#|                                              ; $I SFNTTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  ScalerStream input/output types 

(defconstant $cexec68K #x1)
(defconstant $truetypeStreamType #x1)
(defconstant $type1StreamType #x2)
(defconstant $type3StreamType #x4)
(defconstant $type42StreamType #x8)
(defconstant $type42GXStreamType #x10)
(defconstant $portableStreamType #x20)
(defconstant $flattenedStreamType #x40)
(defconstant $cidType2StreamType #x80)
(defconstant $cidType0StreamType #x100)
(defconstant $type1CFFStreamType #x200)
(defconstant $evenOddModifierStreamType #x8000)
(defconstant $eexecBinaryModifierStreamType #x10000);   encrypted portion of Type1Stream to be binary  
(defconstant $unicodeMappingModifierStreamType #x20000);   include glyph ID to unicode mapping info for PDF  
(defconstant $scalerSpecifcModifierMask #xF000) ;   for scaler's internal use  
(defconstant $streamTypeModifierMask #xFFFFF000);   16 bits for Apple, 4 bits for scaler  

; 	 Possible streamed font formats 	

#|
; Warning: Patching def of type scalerStreamTypeFlag from translator table: was :unsigned-long, is now :unsigned-word
|#
(def-mactype :scalerstreamtypeflag (find-mactype :unsigned-word))
#| 
(def-mactype :scalerstreamtypeflag (find-mactype ':unsigned-long)) |#

(defconstant $downloadStreamAction 0)           ;   Transmit the (possibly sparse) font data  
(defconstant $asciiDownloadStreamAction 1)      ;   Transmit font data to a 7-bit ASCII destination  
(defconstant $fontSizeQueryStreamAction 2)      ;   Estimate in-printer memory used if the font were downloaded  
(defconstant $encodingOnlyStreamAction 3)       ;   Transmit only the encoding for the font  
(defconstant $prerequisiteQueryStreamAction 4)  ;   Return a list of prerequisite items needed for the font  
(defconstant $prerequisiteItemStreamAction 5)   ;   Transmit a specified prerequisite item  
(defconstant $variationQueryStreamAction 6)     ;   Return information regarding support for variation streaming  
(defconstant $variationPSOperatorStreamAction 7);   Transmit Postscript code necessary to effect variation of a font  

(def-mactype :scalerstreamaction (find-mactype ':signed-long))

(defconstant $selectAllVariations -1)           ;   Special variationCount value meaning include all variation data  

(def-mactype :scalerprerequisiteitemptr (find-mactype '(:pointer :scalerprerequisiteitem)))
(defrecord scalerPrerequisiteItem 
   (enumeration :signed-long)                   ;   Shorthand tag identifying the item  
   (size :signed-long)                          ;   Worst case vm in printer item requires  
   ;;Changing field name from signed-byte to unsigned-byte to match C header (educated-guess)
   (name :unsigned-byte)                        ;   Name to be used by the client when emitting the item (Pascal string)  
   )

(def-mactype :scalerstreamptr (find-mactype '(:pointer :scalerstream)))
(defrecord scalerStream 
   (streamRefCon :pointer)                      ;   <- private reference for client  
   (targetVersion :pointer)                     ;   <- e.g. Postscript printer name (C string)  
   (types :unsigned-word)                       ;   <->    Data stream formats desired/supplied  
   (action :signed-long)                        ;   <-     What action to take  
   (memorySize :unsigned-long)                  ;   -> Worst case memory use (vm) in printer or as sfnt  
   (variationCount :signed-long)                ;   <- The number of variations, or selectAllVariations  
   (variations :pointer)                        ;   <- A pointer to an array of the variations (gxFontVariation)  
   (:variant 
;   Normal font streaming information 
      (
      (encoding (:pointer :signed-integer))     ;   <- Intention is * unsigned short[256]  
      (glyphBits :pointer)                      ;   <->    Bitvector: a bit for each glyph, 1 = desired/supplied  
      (name :pointer)                           ;   <->    The printer font name to use/used (C string)  
      )
;   Used to obtain a list of prerequisites from the scaler 
      (
      (size :signed-long)                       ;   ->     Size of the prereq. list in bytes (0 indicates no prerequisites) 
      (list :pointer)                           ;   <- Pointer to client block to hold list (nil = list size query only)  
      )
      (
      (prerequisiteItem :signed-long)           ;   <-     Enumeration value for the prerequisite item to be streamed. 
      )
      (
      (variationQueryResult :signed-long)       ;   -> Output from the variationQueryStreamAction  
      )
      )
   )

(def-mactype :scalerstreamdataptr (find-mactype '(:pointer :scalerstreamdata)))
(defrecord scalerStreamData 
   (hexFlag :signed-long)                       ;   Indicates that the data is to be interpreted as hex, versus binary  
   (byteCount :signed-long)                     ;   Number of bytes in the data being streamed  
   (data :pointer)                              ;   Pointer to the data being streamed  
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ScalerStreamTypesIncludes

; $ENDC                                         ; __SCALERSTREAMTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ScalerStreamTypes)