(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Scrap.p"
; at Wednesday May 1,2002 2:40:54 pm.
; 
;      File:       Scrap.p
;  
;      Contains:   Scrap Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SCRAP__
; $SETC __SCRAP__ := 1

; $I+
; $SETC ScrapIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     ________________________________________________________________
;     UNIVERSAL SCRAP MANAGER INTERFACES
;     ________________________________________________________________
;     The following interfaces are available when compiling for BOTH
;     Carbon AND Mac OS 8.
;     ________________________________________________________________
; 
; 
;     While we're in here mucking about, we defined a new type to
;     to put some confusion to rest. The old calls, as well as the
;     new calls, use the new type. Existing clients should be
;     blissfully ignorant.
; 

(def-mactype :scrapflavortype (find-mactype ':ostype))
; 
; 	    Newsflash! After 15 years of arduous toil, it's finally possible
; 	    for specially trained typists wielding advanced text editing
; 	    technology to define symbolic names for commonly used scrap
; 	    flavor type constants! Apple triumphs again!
; 	

(defconstant $kScrapFlavorTypePicture :|PICT|)  ;   contents of a PicHandle 
(defconstant $kScrapFlavorTypeText :|TEXT|)     ;   stream of characters 
(defconstant $kScrapFlavorTypeTextStyle :|styl|);   see TEGetStyleScrapHandle 
(defconstant $kScrapFlavorTypeMovie :|moov|)    ;   reference to a movie 
(defconstant $kScrapFlavorTypeSound :|snd |)    ;   see SndRecord and SndPlay 
(defconstant $kScrapFlavorTypeUnicode :|utxt|)  ;   stream of UTF16 characters 
(defconstant $kScrapFlavorTypeUnicodeStyle :|ustl|);   ATSUI defines; Textension uses 

; 
; 	    If you are a Carbon client and you need to run on Mac OS 8,
; 	    you may still need to load and unload the scrap. Under Mac OS
; 	    X, the scrap is held by the pasteboard server instead of in a
; 	    handle in your app's heap, so LoadScrap and UnloadScrap do
; 	    nothing when called under Mac OS X.
; 	

; 
; 	 *  LoadScrap()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_LoadScrap" 
      ()
   (:stack :osstatus)
   (:stack-trap #xA9FB))

; 
;  *  UnloadScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UnloadScrap" 
      ()
   (:stack :osstatus)
   (:stack-trap #xA9FA))

; $IFC CALL_NOT_IN_CARBON 
; 
;     ________________________________________________________________
;     MAC OS 8 SCRAP MANAGER INTERFACES
;     ________________________________________________________________
;     The following interfaces are available only when compiling for
;     plain vanilla Mac OS 8. We didn't add comments to them because
;     Inside Mac covers them in detail.
;     ________________________________________________________________
; 

(def-mactype :scrapstuffptr (find-mactype '(:pointer :scrapstuff)))
(defrecord ScrapStuff 
   (scrapSize :signed-long)
   (scrapHandle :handle)
   (scrapCount :signed-integer)
   (scrapState :signed-integer)
   (scrapName (:pointer (:string 255)))
   )

(def-mactype :pscrapstuff (find-mactype '(:pointer :scrapstuff)))
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InfoScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InfoScrap" 
      ()
   (:stack (:pointer :scrapstuff))
   (:stack-trap #xA9F9))

; 
;  *  GetScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetScrap" 
      ((destination :handle) (flavorType :ostype) (offset (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA9FD))

; 
;  *  ZeroScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ZeroScrap" 
      ()
   (:stack :osstatus)
   (:stack-trap #xA9FC))

; 
;  *  PutScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PutScrap" 
      ((sourceBufferByteCount :signed-long) (flavorType :ostype) (sourceBuffer :pointer))
   (:stack :osstatus)
   (:stack-trap #xA9FE))

; 
;     ________________________________________________________________
;     CARBON SCRAP MANAGER INTERFACES
;     ________________________________________________________________
;     The following interfaces are available only when compiling for
;     Carbon.
;     ________________________________________________________________
; 

; 
;     When promising a scrap flavor, it's OK if you
;     don't yet know how big the flavor data will be.
;     In this case, just pass kScrapFlavorSizeUnknown
;     for the flavor data size.
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kScrapFlavorSizeUnknown -1)

; 
; 	    kScrapReservedFlavorType is a flavor type which is reserved
; 	    for use by Scrap Manager. If you pass it to Scrap Manager,
; 	    it will be rejected.
; 	

(defconstant $kScrapReservedFlavorType :|srft|)

; 	
; 	    We've added scrap flavor flags ala Drag Manager.
; 	
; 	    kScrapFlavorMaskNone means you want none of the flags.
; 	
; 	    kScrapFlavorSenderOnlyMask means only the process which
; 	    put the flavor on the scrap can see it. If some other
; 	    process put a flavor with this flag on the scrap,
; 	    your process will never see the flavor, so there's
; 	    no point in testing for this flag.
; 	
; 	    kScrapFlavorTranslated means the flavor was translated
; 	    from some other flavor in the scrap by Translation Manager.
; 	    Most callers should not care about this bit.
; 		
(defconstant $kScrapFlavorMaskNone #x0)
(defconstant $kScrapFlavorMaskSenderOnly #x1)
(defconstant $kScrapFlavorMaskTranslated #x2)

(def-mactype :scrapflavorflags (find-mactype ':unsigned-long))
; 
; 	    ScrapFlavorInfo describes a single flavor within
; 	    a scrap.
; 	
(def-mactype :scrapflavorinfoptr (find-mactype '(:pointer :scrapflavorinfo)))
(defrecord ScrapFlavorInfo 
   (flavorType :ostype)
   (flavorFlags :unsigned-long)
   )

#|
; Warning: Patching def of type ScrapRef from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :scrapref (find-mactype :unsigned-long))
#| 
(def-mactype :scrapref (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :scraprefptr (find-mactype '(:pointer :unsigned-long)));  when a VAR xx:ScrapRef parameter can be nil, it is changed to xx: ScrapRefPtr 
; 
; 	    Defined Apple scrap names for GetScrapByName
; 	    kScrapClipboardScrap    traditional clipboard scrap
; 	    kScrapFindScrap         compatable with Cocoa's global find scrap
; 	
;  kScrapClipboardScrap = CFSTR("com.apple.scrap.clipboard"); 
;  kScrapFindScrap = CFSTR("com.apple.scrap.find"); 

;    Enumerated options to be passed to GetScrapByName 

(defconstant $kScrapGetNamedScrap 0)            ;   get current named scrap without bumping 
(defconstant $kScrapClearNamedScrap #x1)        ;   aquire the named scrap, bumping and clearing 

; 	
; 	    GetScrapByName allows access to an indefinite number of public or private
; 	    scraps.  The constant kScrapClipboardScrap refers to the "current" scrap
; 	    we've all come to know and love.  kScrapFindScrap allows Carbon apps to
; 	    interact seamlessly with Cocoa's global find scrap.  Note that calling:
; 	
; 	        GetScrapByName( kScrapClipboardScrap, kScrapGetNamedScrap, &scrap );
; 	
; 	    is an exact match to the call:
; 	    
; 	        GetCurrentScrap( &scrap );
; 	
; 	    Additionally, a call to:
; 	
; 	        GetScrapByName( kScrapClipboardScrap, kScrapClearNamedScrap, &scrap );
; 	
; 	    is a replacement for the sequence:
; 	    
; 	        ClearCurrentScrap();
; 	        GetCurrentScrap( &scrap );
; 	
; 	    You can use this API to generate your own private scraps to use as a high
; 	    level interprocess communication between your main and helper apps.  The Java
; 	    naming convention is suggested for your scraps ( ie. com.joeco.scrap.secret ).
; 	    
; 	    CarbonLib does not support arbitrary named scraps; when calling this API on
; 	    CarbonLib, kScrapClipboardScrap is the only supported value for the name parameter.
; 		
; 
; 	 *  GetScrapByName()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.5 and later
; 	 *    Mac OS X:         in version 10.1 and later
; 	 	
; 
;     GetCurrentScrap obtains a reference to the current scrap.
;     The ScrapRef obtained via GetCurrentScrap will become
;     invalid and unusable after the scrap is cleared.
;                                               ; 
;  *  GetCurrentScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapByName" 
      ((name :pointer) (options :unsigned-long) (scrap (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     GetScrapFlavorFlags tells you [a] whether the scrap contains
;     data for a particular flavor and [b] some things about that
;     flavor if it exists. This call never blocks, and is useful
;     for deciding whether to enable the Paste item in your Edit
;     menu, among other things.
;                                               ; 
;  *  GetScrapFlavorFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCurrentScrap" 
      ((scrap (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     GetScrapFlavorSize gets the size of the data of the specified
;     flavor. This function blocks until the specified flavor
;     data is available. GetScrapFlavorSize is intended as a prelude
;     to allocating memory and calling GetScrapFlavorData.
;                                               ; 
;  *  GetScrapFlavorSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapFlavorFlags" 
      ((scrap :unsigned-long) (flavorType :ostype) (flavorFlags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     GetScrapFlavorData gets the data from the specified flavor in the
;     specified scrap. This function blocks until the specified flavor
;     data is available. Specify the maximum size your buffer can contain;
;     on output, this function produces the number of bytes that were
;     available (even if this is more than you requested).
;                                               ; 
;  *  GetScrapFlavorData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapFlavorSize" 
      ((scrap :unsigned-long) (flavorType :ostype) (byteCount (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;     ClearCurrentScrap clears the current scrap. Call this
;     first when the user requests a Copy or Cut operation --
;     even if you maintain a private scrap! You should not wait
;     until receiving a suspend event to call ClearCurrentScrap. Call
;     it immediately after the user requests a Copy or Cut operation.
;     You don't need to put any data on the scrap immediately (although
;     it's perfectly fine to do so). You DO need to call GetCurrentScrap
;     after ClearCurrentScrap so you'll have a valid ScrapRef to pass
;     to other functions.
;                                               ; 
;  *  ClearCurrentScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapFlavorData" 
      ((scrap :unsigned-long) (flavorType :ostype) (byteCount (:pointer :signed-long)) (destination :pointer)) 
  :osstatus
   () )                                         ; 
;         ClearScrap will clear the scrap passed in and return the bumped
;         ScrapRef value. ClearScrap behaves similarly to GetScrapByName
;         when called with the kScrapClearNamedScrap option with the
;         benefit of not requiring a name in the event one is not available.
;         
;         CarbonLib does not support arbitrary named scraps; when calling this
;         API on CarbonLib, only clearing the current scrap is supported.
;                                               ; 
;  *  ClearScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_ClearCurrentScrap" 
      () 
  :osstatus
   () )                                         ; 
;         PutScrapFlavor is a lot like PutScrap, with two differences:
;         we added a ScrapRef parameter at the beginning and you can
;         "promise" various aspects of a flavor. If you pass a NIL
;         data pointer, this is a promise that in the future you
;         will provide data for this flavor. Provide the data
;         through a subsequent call to PutScrapFlavor, either later
;         in the same code flow or during a scrap promise keeper proc.
;         If you know how big the data is, you can pass the size as
;         well, and this may allow subsequent callers of GetScrapFlavorInfo
;         to avoid blocking. If you don't know the size, pass -1.
;         If you pass a 0 size, you are telling Scrap Manager not to
;         expect any data for this flavor. In this case, the flavor
;         data pointer is ignored. NOTE: the last time you can provide
;         scrap flavor data is when your scrap promise keeper gets
;         called. It is NOT possible to call PutScrapFlavor while
;         handling a suspend event; suspend events under Carbon
;         simply don't work the way they do under Mac OS 8.
; 
;         The method for setting Scrap Manager promises differs from that for Drag Manger promises.
;         This chart describes the method for setting scrap promises via PutScrapFlavor().
;     
;         dataPtr         dataSize                                result
;      pointer value  actual data size    The data of size dataSize pointed to by dataPtr is added to the scrap.
;            0        actual data size    A promise for data of size dataSize is placed on the scrap.
;            0               -1           A promise for data of an undetermined size is placed on the scrap.
;         ignored             0           A flavor with no data expected is placed on the scrap.  This is not a promise.
;                                               ; 
;  *  PutScrapFlavor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ClearScrap" 
      ((inOutScrap (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     ScrapPromiseKeeper is a function you write which is called by
;     Scrap Manager as needed to keep your earlier promise of a
;     particular scrap flavor. When your function is called, deliver
;     the requested data by calling PutScrapFlavor.
; 
(deftrap-inline "_PutScrapFlavor" 
      ((scrap :unsigned-long) (flavorType :ostype) (flavorFlags :unsigned-long) (flavorSize :signed-long) (flavorData :pointer)) 
  :osstatus
   () )
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ScrapPromiseKeeperProcPtr = FUNCTION(scrap: ScrapRef; flavorType: ScrapFlavorType; userData: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :scrappromisekeeperprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :scrappromisekeeperupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :scrappromisekeeperupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppScrapPromiseKeeperProcInfo #xFF0)
; 
; 	 *  NewScrapPromiseKeeperUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewScrapPromiseKeeperProc 
(deftrap "_NewScrapPromiseKeeperUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeScrapPromiseKeeperUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeScrapPromiseKeeperUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeScrapPromiseKeeperUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallScrapPromiseKeeperProc 
(deftrap-inline "_InvokeScrapPromiseKeeperUPP" 
      ((scrap :unsigned-long) (flavorType :ostype) (userData :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;     SetScrapPromiseKeeper associates a ScrapPromiseKeeper with a
;     scrap. You can remove a ScrapPromiseKeeper from a scrap by
;     passing a NIL ScrapPromiseKeeper to SetScrapPromiseKeeper.
;     Pass whatever you like in the last parameter; its value will
;     be passed to your ScrapPromiseKeeper, which can do whatever
;     it likes with the value. You might choose to pass a pointer
;     or handle to some private scrap data which the
;     ScrapPromiseKeeper could use in fabricating one or more
;     promised flavors.
; 
; 
;  *  SetScrapPromiseKeeper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;     GetScrapFlavorCount produces the number of
;     items which can be obtained by GetScrapFlavorInfoList.
;                                               ; 
;  *  GetScrapFlavorCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetScrapPromiseKeeper" 
      ((scrap :unsigned-long) (upp :pointer) (userData :pointer)) 
  :osstatus
   () )                                         ; 
;     GetScrapFlavorInfoList fills a list (array)
;     of items which each describe the corresponding
;     flavor in the scrap. It fills no more array
;     elements as are specified. On exit, it produces
;     the count of elements it filled (which may be
;     smaller than the count requested). Yes, YOU
;     must provide the memory for the array.
;                                               ; 
;  *  GetScrapFlavorInfoList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapFlavorCount" 
      ((scrap :unsigned-long) (infoCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     CallInScrapPromises forces all promises to be kept.
;     If your application promises at least one flavor
;     AND it does NOT adopt the new event model, you
;     should call this function when your application
;     is about to quit. If your app promises no flavors,
;     there is no need to call this function, and if
;     your app adopts the new event model, this function
;     will be called automagically for you. It doesn't
;     hurt to call this function more than once, though
;     promise keepers may be asked to keep promises
;     they already tried and failed.
;                                               ; 
;  *  CallInScrapPromises()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetScrapFlavorInfoList" 
      ((scrap :unsigned-long) (infoCount (:pointer :unsigned-long)) (info (:pointer :scrapflavorinfo))) 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := ScrapIncludes
(deftrap-inline "_CallInScrapPromises" 
      () 
  :osstatus
   () )                                         ; $ENDC; __SCRAP__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Scrap)