(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TextCommon.p"
; at Wednesday May 1,2002 2:38:53 pm.
; 
;      File:       TextCommon.p
;  
;      Contains:   TextEncoding-related types and constants, and prototypes for related functions
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TEXTCOMMON__
; $SETC __TEXTCOMMON__ := 1

; $I+
; $SETC TextCommonIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  TextEncodingBase type & values 
;  (values 0-32 correspond to the Script Codes defined in Inside Macintosh: Text pages 6-52 and 6-53 

(def-mactype :textencodingbase (find-mactype ':unsigned-long))

;   Mac OS encodings 
(defconstant $kTextEncodingMacRoman 0)
(defconstant $kTextEncodingMacJapanese 1)
(defconstant $kTextEncodingMacChineseTrad 2)
(defconstant $kTextEncodingMacKorean 3)
(defconstant $kTextEncodingMacArabic 4)
(defconstant $kTextEncodingMacHebrew 5)
(defconstant $kTextEncodingMacGreek 6)
(defconstant $kTextEncodingMacCyrillic 7)
(defconstant $kTextEncodingMacDevanagari 9)
(defconstant $kTextEncodingMacGurmukhi 10)
(defconstant $kTextEncodingMacGujarati 11)
(defconstant $kTextEncodingMacOriya 12)
(defconstant $kTextEncodingMacBengali 13)
(defconstant $kTextEncodingMacTamil 14)
(defconstant $kTextEncodingMacTelugu 15)
(defconstant $kTextEncodingMacKannada 16)
(defconstant $kTextEncodingMacMalayalam 17)
(defconstant $kTextEncodingMacSinhalese 18)
(defconstant $kTextEncodingMacBurmese 19)
(defconstant $kTextEncodingMacKhmer 20)
(defconstant $kTextEncodingMacThai 21)
(defconstant $kTextEncodingMacLaotian 22)
(defconstant $kTextEncodingMacGeorgian 23)
(defconstant $kTextEncodingMacArmenian 24)
(defconstant $kTextEncodingMacChineseSimp 25)
(defconstant $kTextEncodingMacTibetan 26)
(defconstant $kTextEncodingMacMongolian 27)
(defconstant $kTextEncodingMacEthiopic 28)
(defconstant $kTextEncodingMacCentralEurRoman 29)
(defconstant $kTextEncodingMacVietnamese 30)
(defconstant $kTextEncodingMacExtArabic 31)     ;   The following use script code 0, smRoman 
(defconstant $kTextEncodingMacSymbol 33)
(defconstant $kTextEncodingMacDingbats 34)
(defconstant $kTextEncodingMacTurkish 35)
(defconstant $kTextEncodingMacCroatian 36)
(defconstant $kTextEncodingMacIcelandic 37)
(defconstant $kTextEncodingMacRomanian 38)
(defconstant $kTextEncodingMacCeltic 39)
(defconstant $kTextEncodingMacGaelic 40)
(defconstant $kTextEncodingMacKeyboardGlyphs 41)

;   The following are older names for backward compatibility 
(defconstant $kTextEncodingMacTradChinese 2)
(defconstant $kTextEncodingMacRSymbol 8)
(defconstant $kTextEncodingMacSimpChinese 25)
(defconstant $kTextEncodingMacGeez 28)
(defconstant $kTextEncodingMacEastEurRoman 29)
(defconstant $kTextEncodingMacUninterp 32)

; 
; 	   Beginning in Mac OS 8.5, the following meta-value is used to indicate Unicode in some parts
; 	   of the Mac OS which previously only expected a Mac OS script code. In some of these places,
; 	   only 7 bits are available to indicate encoding (script code), so kTextEncodingUnicodeDefault
; 	   cannot be used. For example, kTextEncodingMacUnicode can be used to indicate Unicode in the
; 	   7-bit script code field of a Unicode input method's ComponentDescription.componentFlags field;
; 	   it can also be used to indicate Unicode in the 16-bit script code field of an AppleEvent's
; 	   typeIntlWritingCode text tag.
; 	
(defconstant $kTextEncodingMacUnicode #x7E)     ;   Meta-value, Unicode as a Mac encoding 

;   Variant Mac OS encodings that use script codes other than 0 
;   The following use script code 4, smArabic 
(defconstant $kTextEncodingMacFarsi #x8C)       ;   Like MacArabic but uses Farsi digits 
;   The following use script code 7, smCyrillic 
(defconstant $kTextEncodingMacUkrainian #x98)   ;   Meta-value in TEC 1.5 & later; maps to kTextEncodingMacCyrillic variant     
;   The following use script code 28, smEthiopic 
(defconstant $kTextEncodingMacInuit #xEC)       ;   The following use script code 32, smUnimplemented 
(defconstant $kTextEncodingMacVT100 #xFC)       ;   VT100/102 font from Comm Toolbox: Latin-1 repertoire + box drawing etc 

;   Special Mac OS encodings 
(defconstant $kTextEncodingMacHFS #xFF)         ;   Meta-value, should never appear in a table. 

;   Unicode & ISO UCS encodings begin at 0x100 
(defconstant $kTextEncodingUnicodeDefault #x100);   Meta-value, should never appear in a table. 
(defconstant $kTextEncodingUnicodeV1_1 #x101)
(defconstant $kTextEncodingISO10646_1993 #x101) ;   Code points identical to Unicode 1.1 
(defconstant $kTextEncodingUnicodeV2_0 #x103)   ;   New location for Korean Hangul 
(defconstant $kTextEncodingUnicodeV2_1 #x103)   ;   We treat both Unicode 2.0 and Unicode 2.1 as 2.1 
(defconstant $kTextEncodingUnicodeV3_0 #x104)
(defconstant $kTextEncodingUnicodeV3_1 #x105)   ;   Adds characters requiring surrogate pairs in UTF-16 
(defconstant $kTextEncodingUnicodeV3_2 #x106)

;   ISO 8-bit and 7-bit encodings begin at 0x200 
(defconstant $kTextEncodingISOLatin1 #x201)     ;   ISO 8859-1 
(defconstant $kTextEncodingISOLatin2 #x202)     ;   ISO 8859-2 
(defconstant $kTextEncodingISOLatin3 #x203)     ;   ISO 8859-3 
(defconstant $kTextEncodingISOLatin4 #x204)     ;   ISO 8859-4 
(defconstant $kTextEncodingISOLatinCyrillic #x205);   ISO 8859-5 
(defconstant $kTextEncodingISOLatinArabic #x206);   ISO 8859-6, = ASMO 708, =DOS CP 708 
(defconstant $kTextEncodingISOLatinGreek #x207) ;   ISO 8859-7 
(defconstant $kTextEncodingISOLatinHebrew #x208);   ISO 8859-8 
(defconstant $kTextEncodingISOLatin5 #x209)     ;   ISO 8859-9 
(defconstant $kTextEncodingISOLatin6 #x20A)     ;   ISO 8859-10                            
(defconstant $kTextEncodingISOLatin7 #x20D)     ;   ISO 8859-13, Baltic Rim                    
(defconstant $kTextEncodingISOLatin8 #x20E)     ;   ISO 8859-14, Celtic                     
(defconstant $kTextEncodingISOLatin9 #x20F)     ;   ISO 8859-15, 8859-1 changed for EURO & CP1252 letters   

;   MS-DOS & Windows encodings begin at 0x400 
(defconstant $kTextEncodingDOSLatinUS #x400)    ;   code page 437 
(defconstant $kTextEncodingDOSGreek #x405)      ;   code page 737 (formerly code page 437G) 
(defconstant $kTextEncodingDOSBalticRim #x406)  ;   code page 775 
(defconstant $kTextEncodingDOSLatin1 #x410)     ;   code page 850, "Multilingual" 
(defconstant $kTextEncodingDOSGreek1 #x411)     ;   code page 851 
(defconstant $kTextEncodingDOSLatin2 #x412)     ;   code page 852, Slavic 
(defconstant $kTextEncodingDOSCyrillic #x413)   ;   code page 855, IBM Cyrillic 
(defconstant $kTextEncodingDOSTurkish #x414)    ;   code page 857, IBM Turkish 
(defconstant $kTextEncodingDOSPortuguese #x415) ;   code page 860 
(defconstant $kTextEncodingDOSIcelandic #x416)  ;   code page 861 
(defconstant $kTextEncodingDOSHebrew #x417)     ;   code page 862 
(defconstant $kTextEncodingDOSCanadianFrench #x418);   code page 863 
(defconstant $kTextEncodingDOSArabic #x419)     ;   code page 864 
(defconstant $kTextEncodingDOSNordic #x41A)     ;   code page 865 
(defconstant $kTextEncodingDOSRussian #x41B)    ;   code page 866 
(defconstant $kTextEncodingDOSGreek2 #x41C)     ;   code page 869, IBM Modern Greek 
(defconstant $kTextEncodingDOSThai #x41D)       ;   code page 874, also for Windows 
(defconstant $kTextEncodingDOSJapanese #x420)   ;   code page 932, also for Windows; Shift-JIS with additions 
(defconstant $kTextEncodingDOSChineseSimplif #x421);   code page 936, also for Windows; was EUC-CN, now GBK (EUC-CN extended) 
(defconstant $kTextEncodingDOSKorean #x422)     ;   code page 949, also for Windows; Unified Hangul Code (EUC-KR extended) 
(defconstant $kTextEncodingDOSChineseTrad #x423);   code page 950, also for Windows; Big-5 
(defconstant $kTextEncodingWindowsLatin1 #x500) ;   code page 1252 
(defconstant $kTextEncodingWindowsANSI #x500)   ;   code page 1252 (alternate name) 
(defconstant $kTextEncodingWindowsLatin2 #x501) ;   code page 1250, Central Europe 
(defconstant $kTextEncodingWindowsCyrillic #x502);   code page 1251, Slavic Cyrillic 
(defconstant $kTextEncodingWindowsGreek #x503)  ;   code page 1253 
(defconstant $kTextEncodingWindowsLatin5 #x504) ;   code page 1254, Turkish 
(defconstant $kTextEncodingWindowsHebrew #x505) ;   code page 1255 
(defconstant $kTextEncodingWindowsArabic #x506) ;   code page 1256 
(defconstant $kTextEncodingWindowsBalticRim #x507);   code page 1257 
(defconstant $kTextEncodingWindowsVietnamese #x508);   code page 1258 
(defconstant $kTextEncodingWindowsKoreanJohab #x510);   code page 1361, for Windows NT 

;   Various national standards begin at 0x600 
(defconstant $kTextEncodingUS_ASCII #x600)
(defconstant $kTextEncodingJIS_X0201_76 #x620)  ;   JIS Roman and 1-byte katakana (halfwidth) 
(defconstant $kTextEncodingJIS_X0208_83 #x621)
(defconstant $kTextEncodingJIS_X0208_90 #x622)
(defconstant $kTextEncodingJIS_X0212_90 #x623)
(defconstant $kTextEncodingJIS_C6226_78 #x624)
(defconstant $kTextEncodingShiftJIS_X0213_00 #x628);   Shift-JIS format encoding of JIS X0213 planes 1 and 2 
(defconstant $kTextEncodingGB_2312_80 #x630)
(defconstant $kTextEncodingGBK_95 #x631)        ;   annex to GB 13000-93; for Windows 95; EUC-CN extended 
(defconstant $kTextEncodingGB_18030_2000 #x632)
(defconstant $kTextEncodingKSC_5601_87 #x640)   ;   same as KSC 5601-92 without Johab annex 
(defconstant $kTextEncodingKSC_5601_92_Johab #x641);   KSC 5601-92 Johab annex 
(defconstant $kTextEncodingCNS_11643_92_P1 #x651);   CNS 11643-1992 plane 1 
(defconstant $kTextEncodingCNS_11643_92_P2 #x652);   CNS 11643-1992 plane 2 
(defconstant $kTextEncodingCNS_11643_92_P3 #x653);   CNS 11643-1992 plane 3 (was plane 14 in 1986 version) 

;   ISO 2022 collections begin at 0x800 
(defconstant $kTextEncodingISO_2022_JP #x820)   ;   RFC 1468 
(defconstant $kTextEncodingISO_2022_JP_2 #x821) ;   RFC 1554 
(defconstant $kTextEncodingISO_2022_JP_1 #x822) ;   RFC 2237 
(defconstant $kTextEncodingISO_2022_JP_3 #x823) ;   JIS X0213 
(defconstant $kTextEncodingISO_2022_CN #x830)
(defconstant $kTextEncodingISO_2022_CN_EXT #x831)
(defconstant $kTextEncodingISO_2022_KR #x840)

;   EUC collections begin at 0x900 
(defconstant $kTextEncodingEUC_JP #x920)        ;   ISO 646, 1-byte katakana, JIS 208, JIS 212 
(defconstant $kTextEncodingEUC_CN #x930)        ;   ISO 646, GB 2312-80 
(defconstant $kTextEncodingEUC_TW #x931)        ;   ISO 646, CNS 11643-1992 Planes 1-16 
(defconstant $kTextEncodingEUC_KR #x940)        ;   ISO 646, KS C 5601-1987 

;   Misc standards begin at 0xA00 
(defconstant $kTextEncodingShiftJIS #xA01)      ;   plain Shift-JIS 
(defconstant $kTextEncodingKOI8_R #xA02)        ;   Russian internet standard 
(defconstant $kTextEncodingBig5 #xA03)          ;   Big-5 (has variants) 
(defconstant $kTextEncodingMacRomanLatin1 #xA04);   Mac OS Roman permuted to align with ISO Latin-1 
(defconstant $kTextEncodingHZ_GB_2312 #xA05)    ;   HZ (RFC 1842, for Chinese mail & news) 
(defconstant $kTextEncodingBig5_HKSCS_1999 #xA06);   Big-5 with Hong Kong special char set supplement 

;   Other platform encodings 
(defconstant $kTextEncodingNextStepLatin #xB01) ;   NextStep encoding 

;   EBCDIC & IBM host encodings begin at 0xC00 
(defconstant $kTextEncodingEBCDIC_US #xC01)     ;   basic EBCDIC-US 
(defconstant $kTextEncodingEBCDIC_CP037 #xC02)  ;   code page 037, extended EBCDIC (Latin-1 set) for US,Canada... 

;   Special values 
(defconstant $kTextEncodingMultiRun #xFFF)      ;   Multi-encoding text with external run info 
(defconstant $kTextEncodingUnknown #xFFFF)      ;   Unknown or unspecified                   

; 	 TextEncodingVariant type & values 	

(def-mactype :textencodingvariant (find-mactype ':unsigned-long))
;   Default TextEncodingVariant, for any TextEncodingBase 

(defconstant $kTextEncodingDefaultVariant 0)

;   Variants of kTextEncodingMacRoman                                                         
(defconstant $kMacRomanDefaultVariant 0)        ;   meta value, maps to 1 or 2 depending on System  
(defconstant $kMacRomanCurrencySignVariant 1)   ;   Mac OS version < 8.5, 0xDB is CURRENCY SIGN 
(defconstant $kMacRomanEuroSignVariant 2)       ;   Mac OS version >= 8.5, 0xDB is EURO SIGN       

;   Variants of kTextEncodingMacCyrillic (for TEC 1.5 and later)                              
(defconstant $kMacCyrillicDefaultVariant 0)     ;   meta value, maps to 1, 2, or 3 depending on System 
(defconstant $kMacCyrillicCurrSignStdVariant 1) ;   Mac OS < 9.0 (RU,BG), 0xFF = CURRENCY SIGN, 0xA2/0xB6 = CENT / PARTIAL DIFF. 
(defconstant $kMacCyrillicCurrSignUkrVariant 2) ;   Mac OS < 9.0 (UA,LangKit), 0xFF = CURRENCY SIGN, 0xA2/0xB6 = GHE WITH UPTURN 
(defconstant $kMacCyrillicEuroSignVariant 3)    ;   Mac OS >= 9.0, 0xFF is EURO SIGN, 0xA2/0xB6 = GHE WITH UPTURN 

;   Variants of kTextEncodingMacIcelandic                                                     
(defconstant $kMacIcelandicStdDefaultVariant 0) ;   meta value, maps to 2 or 4 depending on System  
(defconstant $kMacIcelandicTTDefaultVariant 1)  ;   meta value, maps to 3 or 5 depending on System  
;   The following are for Mac OS version < 8.5, 0xDB is CURRENCY SIGN              
(defconstant $kMacIcelandicStdCurrSignVariant 2);   0xBB/0xBC are fem./masc. ordinal indicators 
(defconstant $kMacIcelandicTTCurrSignVariant 3) ;   0xBB/0xBC are fi/fl ligatures 
;   The following are for Mac OS version >= 8.5, 0xDB is EURO SIGN                   
(defconstant $kMacIcelandicStdEuroSignVariant 4);   0xBB/0xBC are fem./masc. ordinal indicators 
(defconstant $kMacIcelandicTTEuroSignVariant 5) ;   0xBB/0xBC are fi/fl ligatures 

;   Variants of kTextEncodingMacCroatian                                                      
(defconstant $kMacCroatianDefaultVariant 0)     ;   meta value, maps to 1 or 2 depending on System  
(defconstant $kMacCroatianCurrencySignVariant 1);   Mac OS version < 8.5, 0xDB is CURRENCY SIGN        
(defconstant $kMacCroatianEuroSignVariant 2)    ;   Mac OS version >= 8.5, 0xDB is EURO SIGN       

;   Variants of kTextEncodingMacRomanian                                                      
(defconstant $kMacRomanianDefaultVariant 0)     ;   meta value, maps to 1 or 2 depending on System  
(defconstant $kMacRomanianCurrencySignVariant 1);   Mac OS version < 8.5, 0xDB is CURRENCY SIGN        
(defconstant $kMacRomanianEuroSignVariant 2)    ;   Mac OS version >= 8.5, 0xDB is EURO SIGN       

;   Variants of kTextEncodingMacJapanese 
(defconstant $kMacJapaneseStandardVariant 0)
(defconstant $kMacJapaneseStdNoVerticalsVariant 1)
(defconstant $kMacJapaneseBasicVariant 2)
(defconstant $kMacJapanesePostScriptScrnVariant 3)
(defconstant $kMacJapanesePostScriptPrintVariant 4)
(defconstant $kMacJapaneseVertAtKuPlusTenVariant 5)

;   Variants of kTextEncodingMacArabic 
(defconstant $kMacArabicStandardVariant 0)      ;   0xC0 is 8-spoke asterisk, 0x2A & 0xAA are asterisk (e.g. Cairo) 
(defconstant $kMacArabicTrueTypeVariant 1)      ;   0xC0 is asterisk, 0x2A & 0xAA are multiply signs (e.g. Baghdad) 
(defconstant $kMacArabicThuluthVariant 2)       ;   0xC0 is Arabic five-point star, 0x2A & 0xAA are multiply signs 
(defconstant $kMacArabicAlBayanVariant 3)       ;   8-spoke asterisk, multiply sign, Koranic ligatures & parens 

;   Variants of kTextEncodingMacFarsi 
(defconstant $kMacFarsiStandardVariant 0)       ;   0xC0 is 8-spoke asterisk, 0x2A & 0xAA are asterisk (e.g. Tehran) 
(defconstant $kMacFarsiTrueTypeVariant 1)       ;   asterisk, multiply signs, Koranic ligatures, geometric shapes 

;   Variants of kTextEncodingMacHebrew 
(defconstant $kMacHebrewStandardVariant 0)
(defconstant $kMacHebrewFigureSpaceVariant 1)

;   Variants of kTextEncodingMacVT100                                                         
(defconstant $kMacVT100DefaultVariant 0)        ;   meta value, maps to 1 or 2 depending on System  
(defconstant $kMacVT100CurrencySignVariant 1)   ;   Mac OS version < 8.5, 0xDB is CURRENCY SIGN        
(defconstant $kMacVT100EuroSignVariant 2)       ;   Mac OS version >= 8.5, 0xDB is EURO SIGN       

;   Variants of Unicode & ISO 10646 encodings 
(defconstant $kUnicodeNoSubset 0)
(defconstant $kUnicodeCanonicalDecompVariant 2) ;   canonical decomposition; excludes composed characters 

;   Variants of Big-5 encoding 
(defconstant $kBig5_BasicVariant 0)
(defconstant $kBig5_StandardVariant 1)          ;   0xC6A1-0xC7FC: kana, Cyrillic, enclosed numerics 
(defconstant $kBig5_ETenVariant 2)              ;   adds kana, Cyrillic, radicals, etc with hi bytes C6-C8,F9 

;   Variants of MacRomanLatin1                                                                
(defconstant $kMacRomanLatin1DefaultVariant 0)  ;   meta value, maps to others depending on System 
(defconstant $kMacRomanLatin1StandardVariant 2) ;   permuted MacRoman, EuroSignVariant 
(defconstant $kMacRomanLatin1TurkishVariant 6)  ;   permuted MacTurkish 
(defconstant $kMacRomanLatin1CroatianVariant 8) ;   permuted MacCroatian, EuroSignVariant 
(defconstant $kMacRomanLatin1IcelandicVariant 11);   permuted MacIcelandic, StdEuroSignVariant 
(defconstant $kMacRomanLatin1RomanianVariant 14);   permuted MacRomanian, EuroSignVariant 

;   Unicode variants not yet supported (and not fully defined) 
(defconstant $kUnicodeNoCompatibilityVariant 1)
(defconstant $kUnicodeNoComposedVariant 3)
(defconstant $kUnicodeNoCorporateVariant 4)

;   The following are older names for backward compatibility 
(defconstant $kMacRomanStandardVariant 0)
(defconstant $kMacIcelandicStandardVariant 0)
(defconstant $kMacIcelandicTrueTypeVariant 1)
(defconstant $kJapaneseStandardVariant 0)
(defconstant $kJapaneseStdNoVerticalsVariant 1)
(defconstant $kJapaneseBasicVariant 2)
(defconstant $kJapanesePostScriptScrnVariant 3)
(defconstant $kJapanesePostScriptPrintVariant 4)
(defconstant $kJapaneseVertAtKuPlusTenVariant 5);   kJapaneseStdNoOneByteKanaVariant = 6,  // replaced by kJapaneseNoOneByteKanaOption 
;   kJapaneseBasicNoOneByteKanaVariant = 7,    // replaced by kJapaneseNoOneByteKanaOption     
(defconstant $kHebrewStandardVariant 0)
(defconstant $kHebrewFigureSpaceVariant 1)
(defconstant $kUnicodeMaxDecomposedVariant 2)   ;   replaced by kUnicodeCanonicalDecompVariant 
;   The following Japanese variant options were never supported and are now deprecated. 
;   In TEC 1.4 and later their functionality is replaced by the Unicode Converter options listed. 
(defconstant $kJapaneseNoOneByteKanaOption #x20);   replaced by UnicodeConverter option kUnicodeNoHalfwidthCharsBit 
(defconstant $kJapaneseUseAsciiBackslashOption #x40);   replaced by UnicodeConverter option kUnicodeForceASCIIRangeBit 

; 	 TextEncodingFormat type & values 	

(def-mactype :textencodingformat (find-mactype ':unsigned-long))

;   Default TextEncodingFormat for any TextEncodingBase 
(defconstant $kTextEncodingDefaultFormat 0)     ;   Formats for Unicode & ISO 10646 
(defconstant $kUnicode16BitFormat 0)
(defconstant $kUnicodeUTF7Format 1)
(defconstant $kUnicodeUTF8Format 2)
(defconstant $kUnicode32BitFormat 3)

; 	 TextEncoding type 	

(def-mactype :textencoding (find-mactype ':unsigned-long))
;   name part selector for GetTextEncodingName 
(def-mactype :textencodingnameselector (find-mactype ':unsigned-long))

(defconstant $kTextEncodingFullName 0)
(defconstant $kTextEncodingBaseName 1)
(defconstant $kTextEncodingVariantName 2)
(defconstant $kTextEncodingFormatName 3)

; 	 Types used in conversion 	

(def-mactype :textencodingrunptr (find-mactype '(:pointer :textencodingrun)))
(defrecord TextEncodingRun 
   (offset :unsigned-long)
   (TextEncoding :unsigned-long)
   )

(def-mactype :consttextencodingrunptr (find-mactype '(:pointer :textencodingrun)))
(def-mactype :scriptcoderunptr (find-mactype '(:pointer :scriptcoderun)))
(defrecord ScriptCodeRun 
   (offset :unsigned-long)
   (script :signed-integer)
   )

(def-mactype :constscriptcoderunptr (find-mactype '(:pointer :scriptcoderun)))
(def-mactype :textptr (find-mactype '(:pointer :unsigned-byte)))
(def-mactype :consttextptr (find-mactype '(:pointer :unsigned-byte)))
;   Basic types for Unicode characters and strings: 
(def-mactype :unichararrayptr (find-mactype '(:pointer :unsigned-integer)))
(def-mactype :constunichararrayptr (find-mactype '(:pointer :unsigned-integer)))
; 
; 	   UniCharArrayHandle is a handle type to correspond to UniCharArrayPtr,
; 	   i.e. a handle to an array of UniChars (UInt16s).
; 	
(def-mactype :unichararrayhandle (find-mactype '(:handle :unsigned-integer)))
; 
; 	   UniCharArrayOffset is used to indicate an edge offset in an array
; 	   of UniChars (UInt16s).  
; 	
(def-mactype :unichararrayoffset (find-mactype ':unsigned-long))
;   enums for TextEncoding Conversion routines 

(defconstant $kTextScriptDontCare -128)
(defconstant $kTextLanguageDontCare -128)
(defconstant $kTextRegionDontCare -128)

;   struct for TECGetInfo 

(def-mactype :tecinfoptr (find-mactype '(:pointer :tecinfo)))
(defrecord TECInfo 
   (format :unsigned-integer)                   ;   format code for this struct 
   (tecVersion :unsigned-integer)               ;   TEC version in BCD, e.g. 0x0121 for 1.2.1 
   (tecTextConverterFeatures :unsigned-long)    ;   bitmask indicating TEC features/fixes 
   (tecUnicodeConverterFeatures :unsigned-long) ;   bitmask indicating UnicodeConverter features/fixes 
   (tecTextCommonFeatures :unsigned-long)       ;   bitmask indicating TextCommon features/fixes 
   (tecTextEncodingsFolderName (:string 31))    ;   localized name of Text Encodings folder (pascal string) 
   (tecExtensionFileName (:string 31))          ;   localized name of TEC extension (pascal string) 
   (tecLowestTEFileVersion :unsigned-integer)   ;   Lowest version (BCD) of all files in Text Encodings folder 
   (tecHighestTEFileVersion :unsigned-integer)  ;   Highest version (BCD) of all files in Text Encodings folder 
   )

(def-mactype :tecinfohandle (find-mactype '(:handle :tecinfo)))
;   Value for TECInfo format code 

(defconstant $kTECInfoCurrentFormat 2)          ;   any future formats will just add fields at the end 

; 
; 	   Defined feature/fix bits for tecUnicodeConverterFeatures field
; 	   Bit:                             Meaning if set:
; 	   ----                             ---------------
; 	   kTECKeepInfoFixBit               Unicode Converter no longer ignores other control flags if
; 	                                    kUnicodeKeepInfoBit is set. Bug fix in TEC Manager 1.2.1.
; 	   kTECFallbackTextLengthFixBit     Unicode Converter honors the *srcConvLen and *destConvLen
; 	                                    returned by caller-supplied fallback handler for any status it
; 	                                    returns except for kTECUnmappableElementErr (previously it only
; 	                                    honored these values if noErr was returned). Bug fix in TEC
; 	                                    Manager 1.2.1.
; 	   kTECTextRunBitClearFixBit        ConvertFromUnicodeToTextRun & ConvertFromUnicodeToScriptCodeRun
; 	                                    function correctly if the kUnicodeTextRunBit is set (previously
; 	                                    their determination of best target encoding was incorrect). Bug
; 	                                    fix in TEC Manager 1.3.
; 	   kTECTextToUnicodeScanFixBit      ConvertFromTextToUnicode uses an improved scanner and maintains
; 	                                    some resulting state information, which it uses for mapping.
; 	                                    This has several effects:
; 	                                    - Improved mapping of 0x30-0x39 digits in Mac OS Arabic, fewer
; 	                                      direction overrides when mapping Mac OS Arabic & Hebrew, and
; 	                                      improved mapping of certain characters in Indic encodings.
; 	                                    - Malformed input produces kTextMalformedInputErr.
; 	                                    - ConvertFromTextToUnicode accepts and uses the control flags
; 	                                      kUnicodeKeepInfoMask and kUnicodeStringUnterminatedMask.
; 	                                    Bug fix and enhancement in TEC Manager 1.3.
; 	   kTECAddForceASCIIChangesBit      Define new control flag bits kUnicodeForceASCIIRangeBit and
; 	                                    kUnicodeNoHalfwidthCharsBit for use with
; 	                                    ConvertFromTextToUnicode, ConvertFromUnicodeToText, etc.
; 	                                    Enhancement in TEC Manager 1.4.
; 	   kTECPreferredEncodingFixBit      CreateUnicodeToTextRunInfo and related functions fix a problem
; 	                                    that occurred when a preferred encoding was specified that did
; 	                                    not match the System script; the preferred script was not
; 	                                    actually placed first in the ordered list of encodings to use.
; 	                                    Bug fix in TEC Manager 1.4.
; 	   kTECAddTextRunHeuristicsBit      Define new control flag bit kUnicodeTextRunHeuristicsBit for
; 	                                    use with ConvertFromUnicodeToTextRun.
; 	   kTECAddFallbackInterruptBit      Define new option kUnicodeFallbackInterruptSafeMask for use
; 	                                    with SetFallbackUnicodeToText. If a client fallback handler is
; 	                                    installed without specifying this bit, ConvertFromUnicodeToText
; 	                                    will HLock the tables it uses (in case the fallback handler
; 	                                    moves memory); otherwise, it won't.
; 	

(defconstant $kTECKeepInfoFixBit 0)
(defconstant $kTECFallbackTextLengthFixBit 1)
(defconstant $kTECTextRunBitClearFixBit 2)
(defconstant $kTECTextToUnicodeScanFixBit 3)
(defconstant $kTECAddForceASCIIChangesBit 4)
(defconstant $kTECPreferredEncodingFixBit 5)
(defconstant $kTECAddTextRunHeuristicsBit 6)
(defconstant $kTECAddFallbackInterruptBit 7)

(defconstant $kTECKeepInfoFixMask #x1)
(defconstant $kTECFallbackTextLengthFixMask #x2)
(defconstant $kTECTextRunBitClearFixMask #x4)
(defconstant $kTECTextToUnicodeScanFixMask #x8)
(defconstant $kTECAddForceASCIIChangesMask #x10)
(defconstant $kTECPreferredEncodingFixMask #x20)
(defconstant $kTECAddTextRunHeuristicsMask #x40)
(defconstant $kTECAddFallbackInterruptMask #x80)

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   CONSTANTS for common and special Unicode code values
; 	   -------------------------------------------------------------------------------------------------
; 	

(defconstant $kUnicodeByteOrderMark #xFEFF)
(defconstant $kUnicodeObjectReplacement #xFFFC) ;   placeholder for non-text object 
(defconstant $kUnicodeReplacementChar #xFFFD)   ;   Unicode replacement for unconvertable input char 
(defconstant $kUnicodeSwappedByteOrderMark #xFFFE);   not a Unicode char; byte-swapped version of FEFF 
(defconstant $kUnicodeNotAChar #xFFFF)          ;   not a Unicode char; may be used as a terminator 

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   CONSTANTS & DATA STRUCTURES for Unicode Properties
; 	   -------------------------------------------------------------------------------------------------
; 	

(def-mactype :uccharpropertytype (find-mactype ':signed-long))

(defconstant $kUCCharPropTypeGenlCategory 1)    ;   requests enumeration value 
(defconstant $kUCCharPropTypeCombiningClass 2)  ;   requests numeric value 0..255 
(defconstant $kUCCharPropTypeBidiCategory 3)    ;   requests enumeration value 

(def-mactype :uccharpropertyvalue (find-mactype ':unsigned-long))
;   General Category enumeration values (requested by kUCCharPropTypeGenlCategory) 

;   Normative categories: 
(defconstant $kUCGenlCatOtherNotAssigned 0)     ;   Cn Other, Not Assigned 
(defconstant $kUCGenlCatOtherControl 1)         ;   Cc Other, Control 
(defconstant $kUCGenlCatOtherFormat 2)          ;   Cf Other, Format 
(defconstant $kUCGenlCatOtherSurrogate 3)       ;   Cs Other, Surrogate 
(defconstant $kUCGenlCatOtherPrivateUse 4)      ;   Co Other, Private Use 
(defconstant $kUCGenlCatMarkNonSpacing 5)       ;   Mn Mark, Non-Spacing 
(defconstant $kUCGenlCatMarkSpacingCombining 6) ;   Mc Mark, Spacing Combining 
(defconstant $kUCGenlCatMarkEnclosing 7)        ;   Me Mark, Enclosing 
(defconstant $kUCGenlCatNumberDecimalDigit 8)   ;   Nd Number, Decimal Digit 
(defconstant $kUCGenlCatNumberLetter 9)         ;   Nl Number, Letter 
(defconstant $kUCGenlCatNumberOther 10)         ;   No Number, Other 
(defconstant $kUCGenlCatSeparatorSpace 11)      ;   Zs Separator, Space 
(defconstant $kUCGenlCatSeparatorLine 12)       ;   Zl Separator, Line 
(defconstant $kUCGenlCatSeparatorParagraph 13)  ;   Zp Separator, Paragraph 
(defconstant $kUCGenlCatLetterUppercase 14)     ;   Lu Letter, Uppercase 
(defconstant $kUCGenlCatLetterLowercase 15)     ;   Ll Letter, Lowercase 
(defconstant $kUCGenlCatLetterTitlecase 16)     ;   Lt Letter, Titlecase 
;   Informative categories: 
(defconstant $kUCGenlCatLetterModifier 17)      ;   Lm Letter, Modifier 
(defconstant $kUCGenlCatLetterOther 18)         ;   Lo Letter, Other 
(defconstant $kUCGenlCatPunctConnector 20)      ;   Pc Punctuation, Connector 
(defconstant $kUCGenlCatPunctDash 21)           ;   Pd Punctuation, Dash 
(defconstant $kUCGenlCatPunctOpen 22)           ;   Ps Punctuation, Open 
(defconstant $kUCGenlCatPunctClose 23)          ;   Pe Punctuation, Close 
(defconstant $kUCGenlCatPunctInitialQuote 24)   ;   Pi Punctuation, Initial quote 
(defconstant $kUCGenlCatPunctFinalQuote 25)     ;   Pf Punctuation, Final quote 
(defconstant $kUCGenlCatPunctOther 26)          ;   Po Punctuation, Other 
(defconstant $kUCGenlCatSymbolMath 28)          ;   Sm Symbol, Math 
(defconstant $kUCGenlCatSymbolCurrency 29)      ;   Sc Symbol, Currency 
(defconstant $kUCGenlCatSymbolModifier 30)      ;   Sk Symbol, Modifier 
(defconstant $kUCGenlCatSymbolOther 31)         ;   So Symbol, Other 

;   Bidirectional Category enumeration values (requested by kUCCharPropTypeBidiCategory) 
(defconstant $kUCBidiCatNotApplicable 0)        ;   for now use this for unassigned 
;   Strong types: 
(defconstant $kUCBidiCatLeftRight 1)            ;   L  Left-to-Right 
(defconstant $kUCBidiCatRightLeft 2)            ;   R  Right-to-Left 
;   Weak types: 
(defconstant $kUCBidiCatEuroNumber 3)           ;   EN European Number 
(defconstant $kUCBidiCatEuroNumberSeparator 4)  ;   ES European Number Separator 
(defconstant $kUCBidiCatEuroNumberTerminator 5) ;   ET European Number Terminator 
(defconstant $kUCBidiCatArabicNumber 6)         ;   AN Arabic Number 
(defconstant $kUCBidiCatCommonNumberSeparator 7);   CS Common Number Separator 
;   Separators: 
(defconstant $kUCBidiCatBlockSeparator 8)       ;   B  Paragraph Separator (was Block Separator) 
(defconstant $kUCBidiCatSegmentSeparator 9)     ;   S  Segment Separator 
;   Neutrals: 
(defconstant $kUCBidiCatWhitespace 10)          ;   WS Whitespace 
(defconstant $kUCBidiCatOtherNeutral 11)        ;   ON Other Neutrals (unassigned codes could use this) 
;   New categories for Unicode 3.0 
(defconstant $kUCBidiCatRightLeftArabic 12)     ;   AL Right-to-Left Arabic (was Arabic Letter) 
(defconstant $kUCBidiCatLeftRightEmbedding 13)  ;   LRE    Left-to-Right Embedding 
(defconstant $kUCBidiCatRightLeftEmbedding 14)  ;   RLE    Right-to-Left Embedding 
(defconstant $kUCBidiCatLeftRightOverride 15)   ;   LRO    Left-to-Right Override 
(defconstant $kUCBidiCatRightLeftOverride 16)   ;   RLO    Right-to-Left Override 
(defconstant $kUCBidiCatPopDirectionalFormat 17);   PDF    Pop Directional Format 
(defconstant $kUCBidiCatNonSpacingMark 18)      ;   NSM    Non-Spacing Mark 
(defconstant $kUCBidiCatBoundaryNeutral 19)     ;   BN Boundary Neutral 

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   Prototypes for TextEncoding functions
; 	   -------------------------------------------------------------------------------------------------
; 	

; 
; 	 *  CreateTextEncoding()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in TextCommon 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetTextEncodingBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateTextEncoding" 
      ((encodingBase :unsigned-long) (encodingVariant :unsigned-long) (encodingFormat :unsigned-long)) 
  :unsigned-long
   () )                                         ; 
;  *  GetTextEncodingVariant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTextEncodingBase" 
      ((encoding :unsigned-long)) 
  :unsigned-long
   () )                                         ; 
;  *  GetTextEncodingFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTextEncodingVariant" 
      ((encoding :unsigned-long)) 
  :unsigned-long
   () )                                         ; 
;  *  ResolveDefaultTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTextEncodingFormat" 
      ((encoding :unsigned-long)) 
  :unsigned-long
   () )                                         ; 
;  *  GetTextEncodingName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ResolveDefaultTextEncoding" 
      ((encoding :unsigned-long)) 
  :unsigned-long
   () )
(deftrap-inline "_GetTextEncodingName" 
      ((iEncoding :unsigned-long) (iNamePartSelector :unsigned-long) (iPreferredRegion :signed-integer) (iPreferredEncoding :unsigned-long) (iOutputBufLen :unsigned-long) (oNameLength (:pointer :unsigned-long)) (oActualRegion (:pointer :signed-integer)) (oActualEncoding (:pointer :unsigned-long)) (oEncodingName (:pointer :unsigned-byte))) 
  :osstatus
   () )

; 
;  *  TECGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  UpgradeScriptInfoToTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetInfo" 
      ((tecInfo (:pointer (:handle :tecinfo)))) 
  :osstatus
   () )                                         ; 
;  *  RevertTextEncodingToScriptInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_UpgradeScriptInfoToTextEncoding" 
      ((iTextScriptID :signed-integer) (iTextLanguageID :signed-integer) (iRegionID :signed-integer) (iTextFontname (:string 255)) (oEncoding (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  NearestMacTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RevertTextEncodingToScriptInfo" 
      ((iEncoding :unsigned-long) (oTextScriptID (:pointer :signed-integer)) (oTextLanguageID (:pointer :signed-integer)) (oTextFontname (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;  *  UCGetCharProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextCommon 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NearestMacTextEncodings" 
      ((generalEncoding :unsigned-long) (bestMacEncoding (:pointer :unsigned-long)) (alternateMacEncoding (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST
(deftrap-inline "_UCGetCharProperty" 
      ((charPtr (:pointer :unsigned-integer)) (textLength :unsigned-long) (propType :signed-long) (propValue (:pointer :unsigned-long))) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TextCommonIncludes

; $ENDC                                         ; __TEXTCOMMON__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TextCommon)