(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Translation.p"
; at Wednesday May 1,2002 2:41:01 pm.
; 
;      File:       Translation.p
;  
;      Contains:   Translation Manager (Macintosh Easy Open) Interfaces.
;  
;      Version:    Technology: Macintosh Easy Open 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TRANSLATION__
; $SETC __TRANSLATION__ := 1

; $I+
; $SETC TranslationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TRANSLATIONEXTENSIONS__
|#

(require-interface 'TranslationExtensions)
#|                                              ; $I TranslationExtensions.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   enumerated types on how a document can be opened 

(def-mactype :docopenmethod (find-mactype ':signed-integer))

(defconstant $domCannot 0)
(defconstant $domNative 1)
(defconstant $domTranslateFirst 2)
(defconstant $domWildcard 3)

;   0L terminated array of OSTypes, or FileTypes 

(defrecord TypesBlock (array (:array :ostype 64)))
(def-mactype :typesblockptr (find-mactype '(:pointer :ostype)))
;   Progress dialog resource ID 

(defconstant $kTranslationScrapProgressDialogID -16555)

;   block of data that describes how to translate 

(def-mactype :filetranslationspecptr (find-mactype '(:pointer :filetranslationspec)))
(defrecord FileTranslationSpec 
   (componentSignature :ostype)
   (translationSystemInfo :pointer)
   (src :filetypespec)
   (dst :filetypespec)
   )

(defrecord FileTranslationSpecArray (array (:array :filetranslationspec 1)))
(def-mactype :filetranslationspecarrayptr (find-mactype '(:pointer :filetranslationspecarray)))
(def-mactype :filetranslationspecarrayhandle (find-mactype '(:handle :filetranslationspecarray)))

; 	****************************************************************************************
; 	* 
; 	*   GetFileTypesThatAppCanNativelyOpen
; 	* 
; 	*  This routine returns a list of all FileTypes that an application can open by itself
; 	* 
; 	*  Enter:   appVRefNumHint      volume where application resides (can be wrong, and if is, will be used as a starting point)
; 	*           appSignature        signature (creator) of application
; 	*           nativeTypes         pointer to a buffer to be filled with up to 64 FileTypes
; 	* 
; 	*  Exit:    nativeTypes         zero terminated array of FileTypes that can be opened by app
; 		
; 
; 	 *  GetFileTypesThatAppCanNativelyOpen()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in Translation 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_GetFileTypesThatAppCanNativelyOpen" 
      ((appVRefNumHint :signed-integer) (appSignature :ostype) (nativeTypes (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 28 appVRefNumHint appSignature nativeTypes))

; ****************************************************************************************
; * 
; *  ExtendFileTypeList
; * 
; *  This routine makes a new list of file types that can be translated into a type in the given list
; *  Used by StandardFile
; * 
; *  Enter:   originalTypeList        pointer to list of file types that can be opened
; *           numberOriginalTypes     number of file types in orgTypeList
; *           extendedTypeList        pointer to a buffer to be filled with file types
; *           numberExtendedTypes     max number of file types that can be put in extendedTypeList
; * 
; *  Exit:    extendedTypeList        buffer filled in with file types that can be translated
; *           numberExtendedTypes     number of file types put in extendedTypeList
; 
; 
;  *  ExtendFileTypeList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ExtendFileTypeList" 
      ((originalTypeList (:pointer :ostype)) (numberOriginalTypes :signed-integer) (extendedTypeList (:pointer :ostype)) (numberExtendedTypes (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 9 originalTypeList numberOriginalTypes extendedTypeList numberExtendedTypes))

; ****************************************************************************************
; * 
; * 
; *  This routine checks if a file can be opened by a particular application.
; *  If so, it returns if it needs to be translated first, and if so then how.
; *  The FileTypes that the app can open are specified by nativelyOpenableTypes,
; *  or if it is NULL, GetFileTypesThatAppCanNativelyOpen is called.
; * 
; *  Enter:   targetDocument      document to check if it can be opened
; *           appVRefNumHint      vRefNum of application to open doc ( can be wrong, and if is, will be used as a starting point)
; *           appSignature        signature (creator) of application to open doc
; *           nativeTypes         zero terminated list of FileTypes app can open natively, or NULL to use default list
; *           onlyNative          whether to consider if document can be translated before opening
; *           howToOpen           pointer to buffer in which to put how the document can be opened
; *           howToTranslate      pointer to buffer in which to put a FileTranslationSpec record
; * 
; *  Exit:    howToOpen           whether file needs to be translated to be read
; *           howToTranslate      if file can be translated, buffer filled in with how to translate
; *           returns             noErr, noPrefAppErr
; 
; 
;  *  CanDocBeOpened()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_CanDocBeOpened" 
      ((targetDocument (:pointer :fsspec)) (appVRefNumHint :signed-integer) (appSignature :ostype) (nativeTypes (:pointer :ostype)) (onlyNative :boolean) (howToOpen (:pointer :signed-integer)) (howToTranslate (:pointer :filetranslationspec)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 30 targetDocument appVRefNumHint appSignature nativeTypes onlyNative howToOpen howToTranslate))

; ****************************************************************************************
; * 
; *  GetFileTranslationPaths
; * 
; *  This routine returns a list of all ways a translation can occure to or from a FileType.
; *  The app is checked to exist.  The hint for each app is the VRefNum and DTRefNum
; * 
; *  Enter:   srcDoc          source file or NULL for all matches
; *           dstDoc          destination FileType or 0 for all matches
; *           maxResultCount
; *           resultBuffer
; *  Exit:    number of paths
; 
; 
;  *  GetFileTranslationPaths()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetFileTranslationPaths" 
      ((srcDocument (:pointer :fsspec)) (dstDocType :ostype) (maxResultCount :unsigned-integer) (resultBuffer (:pointer :filetranslationspecarray)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 56 srcDocument dstDocType maxResultCount resultBuffer))

; ****************************************************************************************
; * 
; *  GetPathFromTranslationDialog
; * 
; *  This routine, with a given document, application, and a passed typelist will display the
; *  Macintosh Easy Open translation dialog allowing the user to make a choice.  The choice
; *  made will be written as a preference (so the next call to CanDocBeOpened() will work).
; *  The routine returns the translation path information.
; * 
; *  Enter:   theDocument         FSSpec to document to open
; *           theApplication      FSSpec to application to open document
; *           typeList            Nil terminated list of FileType's (e.g. SFTypeList-like) of types
; *                               you would like the documented translated to.  Order most perferred
; *                               to least.
; * 
; *  Exit:    howToOpen           Translation method needed to open document
; *           howToTranslate      Translation specification
; *           returns             Any errors that might occur.
; 
; 
;  *  GetPathFromTranslationDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_GetPathFromTranslationDialog" 
      ((theDocument (:pointer :fsspec)) (theApplication (:pointer :fsspec)) (typeList (:pointer :ostype)) (howToOpen (:pointer :signed-integer)) (howToTranslate (:pointer :filetranslationspec)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 55 theDocument theApplication typeList howToOpen howToTranslate))

; ****************************************************************************************
; * 
; *   TranslateFile
; * 
; *  This routine reads a file of one format and writes it to another file in another format. 
; *  The information on how to translated is generated by the routine CanDocBeOpened.
; *  TranslateFile calls through to the TranslateFile Extension's DoTranslateFile routine.  
; *  The destination file must not exist.  It is created by this routine.  
; * 
; *  Enter:   sourceDocument          input file to translate
; *           destinationDocument     output file of translation
; *           howToTranslate          pointer to info on how to translate
; *  Exit:    returns                 noErr, badTranslationSpecErr 
; 
; 
;  *  TranslateFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap "_TranslateFile" 
      ((sourceDocument (:pointer :fsspec)) (destinationDocument (:pointer :fsspec)) (howToTranslate (:pointer :filetranslationspec)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 12 sourceDocument destinationDocument howToTranslate))

; ****************************************************************************************
; * 
; *   GetDocumentKindString
; * 
; *  This routine returns the string the Finder should show for the "kind" of a document
; *  in the GetInfo window and in the kind column of a list view.  
; * 
; *  Enter:   docVRefNum      The volume containing the document
; *           docType         The catInfo.fdType of the document
; *           docCreator      The catInfo.fdCreator of the document
; *           kindString      pointer to where to return the string
; * 
; *  Exit:    kindString      pascal string.  Ex: "\pSurfCalc spreadsheet"
; *           returns         noErr, or afpItemNoFound if kind could not be determined
; 
; 
;  *  GetDocumentKindString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDocumentKindString" 
      ((docVRefNum :signed-integer) (docType :ostype) (docCreator :ostype) (kindString (:pointer (:string 63))))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 22 docVRefNum docType docCreator kindString))

; ****************************************************************************************
; * 
; *  GetTranslationExtensionName
; * 
; *  This routine returns the translation system name from a specified TranslationSpec
; * 
; *  Enter:   translationMethod   The translation path to get the translation name from
; * 
; *  Exit:    extensionName       The name of the translation system
; *           returns             Any errors that might occur
; 
; 
;  *  GetTranslationExtensionName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetTranslationExtensionName" 
      ((translationMethod (:pointer :filetranslationspec)) (extensionName (:pointer (:string 31))))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 54 translationMethod extensionName))

; ****************************************************************************************
; * 
; *  GetScrapDataProcPtr
; * 
; *  This is a prototype for the function you must supply to TranslateScrap. It is called to 
; *  get the data to be translated.  The first call TranslateScrap will make to this is to
; *  ask for the 'fmts' data.  That is a special.   You should resize and fill in the handle
; *  with a list all the formats that you have available to be translated, and the length of each.
; *  (See I.M. VI 4-23 for details of 'fmts').  It will then be called again asking for one of  
; *  the formats that 'fmts' list said was available.
; * 
; *  Enter:   requestedFormat         Format of data that TranslateScrap needs.
; *           dataH                   Handle in which to put the requested data
; *           srcDataGetterRefCon     Extra parameter for you passed to TranslateScrap
; *           
; *  Exit:    dataH                   Handle is resized and filled with data in requested format
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetScrapDataProcPtr = FUNCTION(requestedFormat: ScrapType; dataH: Handle; srcDataGetterRefCon: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :getscrapdataprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :getscrapdataupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :getscrapdataupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppGetScrapDataProcInfo #xFE0)
; 
; 	 *  NewGetScrapDataUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewGetScrapDataProc 
(deftrap "_NewGetScrapDataUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeGetScrapDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeGetScrapDataUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeGetScrapDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallGetScrapDataProc 
(deftrap-inline "_InvokeGetScrapDataUPP" 
      ((requestedFormat :ostype) (dataH :handle) (srcDataGetterRefCon :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

(def-mactype :getscrapdata (find-mactype ':pointer))
; 	****************************************************************************************
; 	* 
; 	*  TranslateScrap
; 	* 
; 	*  This routine resizes the destination handle and fills it with data of the requested format.
; 	*  The data is generated by translated one or more source formats of data supplied by
; 	*  the procedure srcDataGetter.  
; 	*  This routine is automatically called by GetScrap and ReadEdition.  You only need to call
; 	*  this if you need to translated scrap style data, but are not using the ScrapMgr or EditionMgr.
; 	* 
; 	*  Enter:   sourceDataGetter            Pointer to routine that can get src data
; 	*           sourceDataGetterRefCon      Extra parameter for dataGetter
; 	*           destinationFormat           Format of data desired
; 	*           destinationData             Handle in which to store translated data
; 	*           
; 	*  Exit:    dstData                     Handle is resized and filled with data in requested format
; 		
; 
; 	 *  TranslateScrap()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in Translation 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_TranslateScrap" 
      ((sourceDataGetter :pointer) (sourceDataGetterRefCon :pointer) (destinationFormat :ostype) (destinationData :handle) (progressDialogID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 14 sourceDataGetter sourceDataGetterRefCon destinationFormat destinationData progressDialogID))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TranslationIncludes

; $ENDC                                         ; __TRANSLATION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Translation)