(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:USB.p"
; at Wednesday May 1,2002 2:41:20 pm.
; 
;      File:       USB.p
;  
;      Contains:   Public API for USB Services Library (and associated components)
;  
;      Version:    Technology: USB 1.4
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __USB__
; $SETC __USB__ := 1

; $I+
; $SETC USBIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DEVICES__
|#

(require-interface 'Devices)
#|                                              ; $I Devices.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  ************* Constants ************* 

;   Flags  
(defconstant $kUSBTaskTimeFlag 1)
(defconstant $kUSBHubPower 2)
(defconstant $kUSBPowerReset 4)
(defconstant $kUSBHubReaddress 8)
(defconstant $kUSBAddressRequest 16)
(defconstant $kUSBReturnOnException 32)
(defconstant $kUSBNo5SecTimeout 64)
(defconstant $kUSBTimeout 128)
(defconstant $kUSBNoDataTimeout 256)
(defconstant $kUSBDebugAwareFlag 512)
(defconstant $kUSBResetDescriptorCache 1024)
(defconstant $kUSBHighSpeedFlag 2048)
(defconstant $kUSBDevZeroDetatch 4096)
(defconstant $kUSBLowSpeedFlag 8192)
(defconstant $kUSBTaskTimeSetAddressFlag 16384)

;   Hub messages  
(defconstant $kUSBHubPortResetRequest 1)
(defconstant $kUSBHubPortSuspendRequest 2)
(defconstant $kUSBHubPortStatusRequest 3)

(defconstant $kVendorID_AppleComputer #x5AC)

; 	 ************* types ************* 	

(def-mactype :usbreference (find-mactype ':signed-long))
(def-mactype :usbdeviceref (find-mactype ':signed-long))
(def-mactype :usbdevicerefptr (find-mactype '(:pointer :signed-long)))
(def-mactype :usbinterfaceref (find-mactype ':signed-long))
(def-mactype :usbpiperef (find-mactype ':signed-long))
(def-mactype :usbbusref (find-mactype ':signed-long))
(def-mactype :usbpipestate (find-mactype ':unsigned-long))
(def-mactype :usbcount (find-mactype ':unsigned-long))
(def-mactype :usbflags (find-mactype ':unsigned-long))
(def-mactype :usbrequest (find-mactype ':unsigned-byte))
(def-mactype :usbdirection (find-mactype ':unsigned-byte))
(def-mactype :usbrqrecipient (find-mactype ':unsigned-byte))
(def-mactype :usbrqtype (find-mactype ':unsigned-byte))
(def-mactype :usbrqindex (find-mactype ':unsigned-integer))
(def-mactype :usbrqvalue (find-mactype ':unsigned-integer))

(def-mactype :usbcontrolbitsptr (find-mactype '(:pointer :usbcontrolbits)))
(defrecord usbControlBits 
   (BMRequestType :signed-byte)
   (BRequest :signed-byte)
   (WValue :unsigned-integer)
   (WIndex :unsigned-integer)
   (reserved4 :unsigned-integer)
   )

(def-mactype :usbisocframeptr (find-mactype '(:pointer :usbisocframe)))
(defrecord USBIsocFrame 
   (frStatus :signed-long)
   (frReqCount :unsigned-integer)
   (frActCount :unsigned-integer)
   )

(defconstant $kUSBMaxIsocFrameReqCount 1023)    ;   maximum size (bytes) of any one Isoc frame 

(def-mactype :usbisocbitsptr (find-mactype '(:pointer :usbisocbits)))
(defrecord usbIsocBits 
   (FrameList (:pointer :usbisocframe))
   (NumFrames :unsigned-long)
   )

(def-mactype :usbhubbitsptr (find-mactype '(:pointer :usbhubbits)))
(defrecord usbHubBits 
   (Request :unsigned-long)
   (Spare :unsigned-long)
   )

(def-mactype :usbpbptr (find-mactype '(:pointer :usbpb)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBCompletion = PROCEDURE(pb: USBPBPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbcompletion (find-mactype ':pointer))
; $ENDC

(def-mactype :usbvariantbitsptr (find-mactype '(:pointer :usbvariantbits)))
(defrecord USBVariantBits 
   (:variant 
      (
      (cntl :usbcontrolbits)
      )
      (
      (isoc :usbisocbits)
      )
      (
      (hub :usbhubbits)
      )
      )
   )

(defrecord USBPB 
   (qlink :pointer)
   (qType :unsigned-integer)
   (pbLength :unsigned-integer)
   (pbVersion :unsigned-integer)
   (reserved1 :unsigned-integer)
   (reserved2 :unsigned-long)
   (usbStatus :signed-long)
   (USBCompletion :pointer)
   (usbRefcon :unsigned-long)
   (USBReference :signed-long)
   (usbBuffer :pointer)
   (usbReqCount :unsigned-long)
   (usbActCount :unsigned-long)
   (USBFlags :unsigned-long)
   (usb :usbvariantbits)
   (usbFrame :unsigned-long)
   (usbClassType :unsigned-byte)
   (usbSubclass :unsigned-byte)
   (usbProtocol :unsigned-byte)
   (usbOther :unsigned-byte)
   (reserved6 :unsigned-long)
   (reserved7 :unsigned-integer)
   (reserved8 :unsigned-integer)
   )

(def-mactype :uslreqptr (find-mactype '(:pointer :uslreq)))
(defrecord uslReq 
   (usbDirection :signed-byte)
   (usbType :signed-byte)
   (usbRecipient :signed-byte)
   (usbRequest :signed-byte)
   )

;   BT 19Aug98, bump up to v1.10 for Isoc 
(defconstant $kUSBCurrentPBVersion #x100)       ;   v1.00 
(defconstant $kUSBIsocPBVersion #x109)          ;   v1.10 
(defconstant $kUSBCurrentHubPB #x109)

(defconstant $kUSBNoCallBack -1)

(def-mactype :bcdusb (find-mactype ':unsigned-byte))

(defconstant $kUSBControl 0)
(defconstant $kUSBIsoc 1)
(defconstant $kUSBBulk 2)
(defconstant $kUSBInterrupt 3)
(defconstant $kUSBAnyType #xFF)

; 	 endpoint type 	
(defconstant $kUSBOut 0)
(defconstant $kUSBIn 1)
(defconstant $kUSBNone 2)
(defconstant $kUSBAnyDirn 3)

; 	USBDirection	
(defconstant $kUSBStandard 0)
(defconstant $kUSBClass 1)
(defconstant $kUSBVendor 2)

; 	USBRqType	
(defconstant $kUSBDevice 0)
(defconstant $kUSBInterface 1)
(defconstant $kUSBEndpoint 2)
(defconstant $kUSBOther 3)

; 	USBRqRecipient	
(defconstant $kUSBRqGetStatus 0)
(defconstant $kUSBRqClearFeature 1)
(defconstant $kUSBRqReserved1 2)
(defconstant $kUSBRqSetFeature 3)
(defconstant $kUSBRqReserved2 4)
(defconstant $kUSBRqSetAddress 5)
(defconstant $kUSBRqGetDescriptor 6)
(defconstant $kUSBRqSetDescriptor 7)
(defconstant $kUSBRqGetConfig 8)
(defconstant $kUSBRqSetConfig 9)
(defconstant $kUSBRqGetInterface 10)
(defconstant $kUSBRqSetInterface 11)
(defconstant $kUSBRqSyncFrame 12)

; 	USBRequest	

(defconstant $kUSBDeviceDesc 1)
(defconstant $kUSBConfDesc 2)
(defconstant $kUSBStringDesc 3)
(defconstant $kUSBInterfaceDesc 4)
(defconstant $kUSBEndpointDesc 5)
(defconstant $kUSBHIDDesc #x21)
(defconstant $kUSBReportDesc #x22)
(defconstant $kUSBPhysicalDesc #x23)
(defconstant $kUSBHUBDesc #x29)

; 	 descriptorType 	

(defconstant $kUSBFeatureDeviceRemoteWakeup 1)
(defconstant $kUSBFeatureEndpointStall 0)

; 	 Feature selectors 	
(defconstant $kUSBActive 0)                     ;   Pipe can accept new transactions 
(defconstant $kUSBIdle 1)                       ;   Pipe will not accept new transactions 
(defconstant $kUSBStalled 2)                    ;   An error occured on the pipe 
(defconstant $kUSBSuspended 4)                  ;   Device is suspended 
(defconstant $kUSBNoBandwidth 8)                ;   (Isoc or Int) Pipe could not be initialised due to bandwidth constraint 

(defconstant $kUSB100mAAvailable 50)
(defconstant $kUSB500mAAvailable 250)
(defconstant $kUSB100mA 50)
(defconstant $kUSBAtrBusPowered #x80)
(defconstant $kUSBAtrSelfPowered #x40)
(defconstant $kUSBAtrRemoteWakeup #x20)

(defconstant $kUSBRel10 #x100)
(defconstant $kUSBRel11 #x110)
(defconstant $kUSBRel20 #x200)

(defconstant $kUSBDeviceDescriptorLength #x12)
(defconstant $kUSBInterfaceDescriptorLength #x9)
(defconstant $kUSBConfigDescriptorLength #x9)

(def-mactype :usbdevicedescriptorptr (find-mactype '(:pointer :usbdevicedescriptor)))
(defrecord USBDeviceDescriptor 
   (length :signed-byte)
   (descType :signed-byte)
   (usbRel :unsigned-integer)
   (deviceClass :signed-byte)
   (deviceSubClass :signed-byte)
   (protocol :signed-byte)
   (maxPacketSize :signed-byte)
   (vendor :unsigned-integer)
   (product :unsigned-integer)
   (devRel :unsigned-integer)
   (manuIdx :signed-byte)
   (prodIdx :signed-byte)
   (serialIdx :signed-byte)
   (numConf :signed-byte)
   )

(def-mactype :usbdescriptorheaderptr (find-mactype '(:pointer :usbdescriptorheader)))
(defrecord USBDescriptorHeader 
   (length :signed-byte)
   (descriptorType :signed-byte)
   )

(def-mactype :usbconfigurationdescriptorptr (find-mactype '(:pointer :usbconfigurationdescriptor)))
(defrecord USBConfigurationDescriptor 
   (length :unsigned-byte)
   (descriptorType :unsigned-byte)
   (totalLength :unsigned-integer)
   (numInterfaces :unsigned-byte)
   (configValue :unsigned-byte)
   (configStrIndex :unsigned-byte)
   (attributes :unsigned-byte)
   (maxPower :unsigned-byte)
   )

(def-mactype :usbinterfacedescriptorptr (find-mactype '(:pointer :usbinterfacedescriptor)))
(defrecord USBInterfaceDescriptor 
   (length :unsigned-byte)
   (descriptorType :unsigned-byte)
   (interfaceNumber :unsigned-byte)
   (alternateSetting :unsigned-byte)
   (numEndpoints :unsigned-byte)
   (interfaceClass :unsigned-byte)
   (interfaceSubClass :unsigned-byte)
   (interfaceProtocol :unsigned-byte)
   (interfaceStrIndex :unsigned-byte)
   )

(def-mactype :usbendpointdescriptorptr (find-mactype '(:pointer :usbendpointdescriptor)))
(defrecord USBEndPointDescriptor 
   (length :unsigned-byte)
   (descriptorType :unsigned-byte)
   (endpointAddress :unsigned-byte)
   (attributes :unsigned-byte)
   (maxPacketSize :unsigned-integer)
   (interval :unsigned-byte)
   )

(def-mactype :usbhiddescriptorptr (find-mactype '(:pointer :usbhiddescriptor)))
(defrecord USBHIDDescriptor 
   (descLen :unsigned-byte)
   (descType :unsigned-byte)
   (descVersNum :unsigned-integer)
   (hidCountryCode :unsigned-byte)
   (hidNumDescriptors :unsigned-byte)
   (hidDescriptorType :unsigned-byte)
   (hidDescriptorLengthLo :unsigned-byte)       ;   can't make this a single 16bit value or the compiler will add a filler byte 
   (hidDescriptorLengthHi :unsigned-byte)
   )

(def-mactype :usbhidreportdescptr (find-mactype '(:pointer :usbhidreportdesc)))
(defrecord USBHIDReportDesc 
   (hidDescriptorType :unsigned-byte)
   (hidDescriptorLengthLo :unsigned-byte)       ;   can't make this a single 16bit value or the compiler will add a filler byte 
   (hidDescriptorLengthHi :unsigned-byte)
   )

(def-mactype :usbhubportstatusptr (find-mactype '(:pointer :usbhubportstatus)))
(defrecord USBHubPortStatus 
   (portFlags :unsigned-integer)                ;   Port status flags  
   (portChangeFlags :unsigned-integer)          ;   Port changed flags  
   )

; 	 ********* ProtoTypes *************** 	
; 	 For dealing with endianisms 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  HostToUSBWord()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_HostToUSBWord" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  USBToHostWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBToHostWord" 
      ((value :unsigned-integer)) 
  :unsigned-integer
   () )

; 
;  *  HostToUSBLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HostToUSBLong" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  USBToHostLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBToHostLong" 
      ((value :unsigned-long)) 
  :unsigned-long
   () )

;  Main prototypes 
;  Transfer commands 
; 
;  *  USBDeviceRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDeviceRequest" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBBulkWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBBulkWrite" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBBulkRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBBulkRead" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBIntRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBIntRead" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBIntWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBIntWrite" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBIsocRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBIsocRead" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBIsocWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBIsocWrite" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

;  Pipe state control 
; 
;  *  USBClearPipeStallByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBClearPipeStallByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBAbortPipeByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBAbortPipeByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBResetPipeByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBResetPipeByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBSetPipeIdleByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSetPipeIdleByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBSetPipeActiveByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSetPipeActiveByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBClosePipeByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBClosePipeByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBGetPipeStatusByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetPipeStatusByReference" 
      ((ref :signed-long) (state (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Configuration services 
; 
;  *  USBFindNextInterface()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBFindNextInterface" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBOpenDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBOpenDevice" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBSetConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSetConfiguration" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBNewInterfaceRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBNewInterfaceRef" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBDisposeInterfaceRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDisposeInterfaceRef" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBConfigureInterface()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBConfigureInterface" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBFindNextPipe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBFindNextPipe" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBSetPipePolicy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSetPipePolicy" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

;  Dealing with descriptors. 
;  Note most of this is temprorary 
; 
;  *  USBGetConfigurationDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetConfigurationDescriptor" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBGetFullConfigurationDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetFullConfigurationDescriptor" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBGetStringDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetStringDescriptor" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBFindNextEndpointDescriptorImmediate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBFindNextEndpointDescriptorImmediate" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBFindNextInterfaceDescriptorImmediate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBFindNextInterfaceDescriptorImmediate" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBFindNextAssociatedDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBFindNextAssociatedDescriptor" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

;  Utility functions 
; 
;  *  USBResetDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBResetDevice" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBPortStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBPortStatus" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBSuspendDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSuspendDevice" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBResumeDeviceByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBResumeDeviceByReference" 
      ((refIn :signed-long)) 
  :osstatus
   () )

; 
;  *  USBGetBandwidthAvailableByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetBandwidthAvailableByReference" 
      ((ref :signed-long) (avail (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  USBGetFrameNumberImmediate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetFrameNumberImmediate" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBDelay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDelay" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBSAbortQueuesByReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBSAbortQueuesByReference" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBAllocMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBAllocMem" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBDeallocMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDeallocMem" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

;  Expert interface functions 
; 
;  *  USBExpertInstallInterfaceDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertInstallInterfaceDriver" 
      ((ref :signed-long) (desc (:pointer :usbdevicedescriptor)) (interfacePtr (:pointer :usbinterfacedescriptor)) (hubRef :signed-long) (busPowerAvailable :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBExpertRemoveInterfaceDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertRemoveInterfaceDriver" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBExpertInstallDeviceDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertInstallDeviceDriver" 
      ((ref :signed-long) (desc (:pointer :usbdevicedescriptor)) (hubRef :signed-long) (port :unsigned-long) (busPowerAvailable :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBExpertRemoveDeviceDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertRemoveDeviceDriver" 
      ((ref :signed-long)) 
  :osstatus
   () )

; 
;  *  USBExpertStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertStatus" 
      ((ref :signed-long) (pointer :pointer) (value :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBExpertFatalError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertFatalError" 
      ((ref :signed-long) (status :signed-long) (pointer :pointer) (value :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBExpertNotify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBFamilyExpertLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertNotify" 
      ((note :pointer)) 
  :osstatus
   () )

; 
;  *  USBExpertStatusLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertStatusLevel" 
      ((level :unsigned-long) (ref :signed-long) (status (:pointer (:string 255))) (value :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBExpertGetStatusLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertGetStatusLevel" 
      () 
  :unsigned-long
   () )

; 
;  *  USBExpertSetStatusLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertSetStatusLevel" 
      ((level :unsigned-long)) 
  nil
   () )

; 
;  *  USBExpertSetDevicePowerStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertSetDevicePowerStatus" 
      ((ref :signed-long) (reserved1 :unsigned-long) (reserved2 :unsigned-long) (powerStatus :unsigned-long) (busPowerAvailable :unsigned-long) (busPowerNeeded :unsigned-long)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kUSBDevicePower_PowerOK 0)
(defconstant $kUSBDevicePower_BusPowerInsufficient 1)
(defconstant $kUSBDevicePower_BusPowerNotAllFeatures 2)
(defconstant $kUSBDevicePower_SelfPowerInsufficient 3)
(defconstant $kUSBDevicePower_SelfPowerNotAllFeatures 4)
(defconstant $kUSBDevicePower_HubPortOk 5)
(defconstant $kUSBDevicePower_HubPortOverCurrent 6)
(defconstant $kUSBDevicePower_BusPoweredHubOnLowPowerPort 7)
(defconstant $kUSBDevicePower_BusPoweredHubToBusPoweredHub 8)
(defconstant $kUSBDevicePower_Reserved3 9)
(defconstant $kUSBDevicePower_Reserved4 10)

; 	 For hubs only 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  USBHubAddDevice()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_USBHubAddDevice" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBHubConfigurePipeZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHubConfigurePipeZero" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBHubSetAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHubSetAddress" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBHubDeviceRemoved()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHubDeviceRemoved" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; 
;  *  USBMakeBMRequestType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBMakeBMRequestType" 
      ((direction :signed-byte) (reqtype :signed-byte) (recipient :signed-byte)) 
  :uint8
   () )

; 
;  *  USBControlRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBServicesLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBControlRequest" 
      ((pb (:pointer :usbpb))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :usblocationid (find-mactype ':unsigned-long))

(defconstant $kUSBLocationNibbleFormat 0)       ;   Other values are reserved for future types (like when we have more than 16 ports per hub) 

(defconstant $kNoDeviceRef -1)

;   Status Level constants 
; 	
; 	Level 1: Fatal errors
; 	Level 2: General errors that may or may not effect operation
; 	Level 3: General driver messages.  The "AddStatus" call that drivers use comes through as a level 3.  This is also the default level at boot time.
; 	Level 4: Important status messages from the Expert and USL.
; 	Level 5: General status messages from the Expert and USL.
; 		
(defconstant $kUSBStatusLevelFatal 1)
(defconstant $kUSBStatusLevelError 2)
(defconstant $kUSBStatusLevelClient 3)
(defconstant $kUSBStatusLevelGeneral 4)
(defconstant $kUSBStatusLevelVerbose 5)

;   Expert Notification Types 

(def-mactype :usbnotificationtype (find-mactype ':unsigned-byte))

(defconstant $kNotifyAddDevice #x0)
(defconstant $kNotifyRemoveDevice #x1)
(defconstant $kNotifyAddInterface #x2)
(defconstant $kNotifyRemoveInterface #x3)
(defconstant $kNotifyGetDeviceDescriptor #x4)
(defconstant $kNotifyGetInterfaceDescriptor #x5)
(defconstant $kNotifyGetNextDeviceByClass #x6)
(defconstant $kNotifyGetDriverConnectionID #x7)
(defconstant $kNotifyInstallDeviceNotification #x8)
(defconstant $kNotifyRemoveDeviceNotification #x9)
(defconstant $kNotifyDeviceRefToBusRef #xA)
(defconstant $kNotifyDriverNotify #xC)
(defconstant $kNotifyParentNotify #xD)
(defconstant $kNotifyAnyEvent #xFF)
(defconstant $kNotifyPowerState #x17)
(defconstant $kNotifyStatus #x18)
(defconstant $kNotifyFatalError #x19)
(defconstant $kNotifyStatusLevel #x20)

(def-mactype :usbdrivermessage (find-mactype ':unsigned-byte))
; 
; 	   USB Manager wildcard constants for USBGetNextDeviceByClass
; 	   and USBInstallDeviceNotification.
; 	
(def-mactype :usbmanagerwildcard (find-mactype ':unsigned-integer))

(defconstant $kUSBAnyClass #xFFFF)
(defconstant $kUSBAnySubClass #xFFFF)
(defconstant $kUSBAnyProtocol #xFFFF)
(defconstant $kUSBAnyVendor #xFFFF)
(defconstant $kUSBAnyProduct #xFFFF)

(def-mactype :expertnotificationdataptr (find-mactype '(:pointer :expertnotificationdata)))
(defrecord ExpertNotificationData 
   (notification :signed-byte)
   (filler :signed-byte)                        ;   unused due to 2-byte 68k alignment 
   (deviceRef (:pointer :signed-long))
   (busPowerAvailable :unsigned-long)
   (data :pointer)
   (info1 :unsigned-long)
   (info2 :unsigned-long)
   )

;   Definition of function pointer passed in ExpertEntryProc 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExpertNotificationProcPtr = FUNCTION(pNotificationData: ExpertNotificationDataPtr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :expertnotificationprocptr (find-mactype ':pointer))
; $ENDC

;   Definition of expert's callback installation function 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExpertEntryProcPtr = FUNCTION(pExpertNotify: ExpertNotificationProcPtr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :expertentryprocptr (find-mactype ':pointer))
; $ENDC

;   Device Notification Callback Routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDeviceNotificationCallbackProcPtr = PROCEDURE(pb: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdevicenotificationcallbackprocptr (find-mactype ':pointer))
; $ENDC

;   Device Notification Parameter Block 
(def-mactype :usbdevicenotificationparameterblockptr (find-mactype '(:pointer :usbdevicenotificationparameterblock)))
(defrecord USBDeviceNotificationParameterBlock 
   (pbLength :unsigned-integer)
   (pbVersion :unsigned-integer)
   (usbDeviceNotification :signed-byte)
   (reserved1 :signed-byte)                     ;   needed because of 2-byte 68k alignment 
   (USBDeviceRef :signed-long)
   (usbClass :unsigned-integer)
   (usbSubClass :unsigned-integer)
   (usbProtocol :unsigned-integer)
   (usbVendor :unsigned-integer)
   (usbProduct :unsigned-integer)
   (result :signed-long)
   (token :unsigned-long)
   (callback :pointer)
   (refcon :unsigned-long)
   )

;   Definition of USBDriverNotificationCallback Routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDriverNotificationCallbackPtr = PROCEDURE(status: OSStatus; refcon: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdrivernotificationcallbackptr (find-mactype ':pointer))
; $ENDC

;   Public Functions 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  USBGetVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in USBServicesLib 1.3 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_USBGetVersion" 
      () 
  :unsigned-long
   () )

; 
;  *  USBGetNextDeviceByClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetNextDeviceByClass" 
      ((deviceRef (:pointer :signed-long)) (connID (:pointer :unsigned-long)) (theClass :unsigned-integer) (theSubClass :unsigned-integer) (theProtocol :unsigned-integer)) 
  :osstatus
   () )

; 
;  *  USBGetDeviceDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetDeviceDescriptor" 
      ((deviceRef (:pointer :signed-long)) (deviceDescriptor (:pointer :usbdevicedescriptor)) (size :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBGetInterfaceDescriptor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetInterfaceDescriptor" 
      ((interfaceRef (:pointer :signed-long)) (interfaceDescriptor (:pointer :usbinterfacedescriptor)) (size :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBGetDriverConnectionID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBGetDriverConnectionID" 
      ((deviceRef (:pointer :signed-long)) (connID (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  USBInstallDeviceNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBInstallDeviceNotification" 
      ((pb (:pointer :usbdevicenotificationparameterblock))) 
  nil
   () )

; 
;  *  USBRemoveDeviceNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBRemoveDeviceNotification" 
      ((token :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBDeviceRefToBusRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDeviceRefToBusRef" 
      ((deviceRef (:pointer :signed-long)) (busRef (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  USBDriverNotify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBDriverNotify" 
      ((reference :signed-long) (mesg :signed-byte) (refcon :unsigned-long) (callback :pointer)) 
  :osstatus
   () )

; 
;  *  USBExpertNotifyParent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBExpertNotifyParent" 
      ((reference :signed-long) (pointer :pointer)) 
  :osstatus
   () )

; 
;  *  USBAddDriverForFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBAddDriverForFSSpec" 
      ((reference :signed-long) (fileSpec (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  *  USBAddShimFromDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBAddShimFromDisk" 
      ((shimFilePtr (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  *  USBReferenceToRegEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBReferenceToRegEntry" 
      ((parentEntry (:pointer :regentryid)) (parentDeviceRef :signed-long)) 
  :osstatus
   () )

; 
;  *  USBConfigureADBShim()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in USBManagerLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBConfigureADBShim" 
      ((inCommandID :unsigned-long) (arg1 :pointer) (arg2 :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDInterruptProcPtr = PROCEDURE(refcon: UInt32; theData: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidinterruptprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HIDNotificationProcPtr = PROCEDURE(refcon: UInt32; reportSize: UInt32; theReport: UNIV Ptr; theInterfaceRef: USBReference); C;

|#
 |#                                             ; $ELSEC
(def-mactype :hidnotificationprocptr (find-mactype ':pointer))
; $ENDC

;   HID Install Interrupt prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDInstallInterruptProcPtr = FUNCTION(pInterruptProc: HIDInterruptProcPtr; refcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidinstallinterruptprocptr (find-mactype ':pointer))
; $ENDC

;   HID Poll Device prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDPollDeviceProcPtr = FUNCTION: OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidpolldeviceprocptr (find-mactype ':pointer))
; $ENDC

;   HID Control Device prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDControlDeviceProcPtr = FUNCTION(theControlSelector: UInt32; theControlData: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidcontroldeviceprocptr (find-mactype ':pointer))
; $ENDC

;   HID Get Device Info prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDGetDeviceInfoProcPtr = FUNCTION(theInfoSelector: UInt32; theInfo: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidgetdeviceinfoprocptr (find-mactype ':pointer))
; $ENDC

;   HID Enter Polled Mode prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDEnterPolledModeProcPtr = FUNCTION: OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidenterpolledmodeprocptr (find-mactype ':pointer))
; $ENDC

;   HID Exit Polled Mode prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDExitPolledModeProcPtr = FUNCTION: OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidexitpolledmodeprocptr (find-mactype ':pointer))
; $ENDC

;   HID Install Notification prototype 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBHIDInstallNotificationProcPtr = FUNCTION(pNotificationProc: HIDNotificationProcPtr; refcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbhidinstallnotificationprocptr (find-mactype ':pointer))
; $ENDC

(defconstant $kHIDStandardDispatchVersion 0)
(defconstant $kHIDReservedDispatchVersion 1)
(defconstant $kHIDNotificationDispatchVersion 2)
(defconstant $kHIDCurrentDispatchVersion 2)

(def-mactype :usbhidrev2dispatchtableptr (find-mactype '(:pointer :usbhidrev2dispatchtable)))
(defrecord USBHIDRev2DispatchTable 
   (hidDispatchVersion :unsigned-long)
   (pUSBHIDInstallInterrupt :pointer)
   (pUSBHIDPollDevice :pointer)
   (pUSBHIDControlDevice :pointer)
   (pUSBHIDGetDeviceInfo :pointer)
   (pUSBHIDEnterPolledMode :pointer)
   (pUSBHIDExitPolledMode :pointer)
   (pUSBHIDInstallNotification :pointer)
   )

(def-mactype :usbhidmoduledispatchtableptr (find-mactype '(:pointer :usbhidmoduledispatchtable)))
(defrecord USBHIDModuleDispatchTable 
   (hidDispatchVersion :unsigned-long)
   (pUSBHIDInstallInterrupt :pointer)
   (pUSBHIDPollDevice :pointer)
   (pUSBHIDControlDevice :pointer)
   (pUSBHIDGetDeviceInfo :pointer)
   (pUSBHIDEnterPolledMode :pointer)
   (pUSBHIDExitPolledMode :pointer)
   )

; 	  Prototypes Tue, Mar 17, 1998 4:54:30 PM 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  USBHIDInstallInterrupt()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_USBHIDInstallInterrupt" 
      ((HIDInterruptFunction :pointer) (refcon :unsigned-long)) 
  :osstatus
   () )

; 
;  *  USBHIDPollDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDPollDevice" 
      () 
  :osstatus
   () )

; 
;  *  USBHIDControlDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDControlDevice" 
      ((theControlSelector :unsigned-long) (theControlData :pointer)) 
  :osstatus
   () )

; 
;  *  USBHIDGetDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDGetDeviceInfo" 
      ((theInfoSelector :unsigned-long) (theInfo :pointer)) 
  :osstatus
   () )

; 
;  *  USBHIDEnterPolledMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDEnterPolledMode" 
      () 
  :osstatus
   () )

; 
;  *  USBHIDExitPolledMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDExitPolledMode" 
      () 
  :osstatus
   () )

; 
;  *  USBHIDInstallNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_USBHIDInstallNotification" 
      ((HIDNotificationFunction :pointer) (refcon :unsigned-long)) 
  :osstatus
   () )

; 
;  *  HIDNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HIDNotification" 
      ((devicetype :unsigned-long) (NewHIDData (:pointer :unsigned-byte)) (OldHIDData (:pointer :unsigned-byte))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kHIDRqGetReport 1)
(defconstant $kHIDRqGetIdle 2)
(defconstant $kHIDRqGetProtocol 3)
(defconstant $kHIDRqSetReport 9)
(defconstant $kHIDRqSetIdle 10)
(defconstant $kHIDRqSetProtocol 11)

(defconstant $kHIDRtInputReport 1)
(defconstant $kHIDRtOutputReport 2)
(defconstant $kHIDRtFeatureReport 3)

(defconstant $kHIDBootProtocolValue 0)
(defconstant $kHIDReportProtocolValue 1)

(defconstant $kHIDKeyboardInterfaceProtocol 1)
(defconstant $kHIDMouseInterfaceProtocol 2)

(defconstant $kHIDSetLEDStateByBits 1)
(defconstant $kHIDSetLEDStateByBitMask 1)
(defconstant $kHIDSetLEDStateByIDNumber 2)
(defconstant $kHIDRemoveInterruptHandler 3)
(defconstant $kHIDEnableDemoMode 4)
(defconstant $kHIDDisableDemoMode 5)
(defconstant $kHIDRemoveNotification #x1000)

(defconstant $kHIDGetLEDStateByBits 1)          ;   not supported in 1.0 of keyboard module 
(defconstant $kHIDGetLEDStateByBitMask 1)       ;   not supported in 1.0 of keyboard module 
(defconstant $kHIDGetLEDStateByIDNumber 2)
(defconstant $kHIDGetDeviceCountryCode 3)       ;   not supported in 1.0 HID modules 
(defconstant $kHIDGetDeviceUnitsPerInch 4)      ;   only supported in mouse HID module 
(defconstant $kHIDGetInterruptHandler 5)
(defconstant $kHIDGetCurrentKeys 6)             ;   only supported in keyboard HID module 
(defconstant $kHIDGetInterruptRefcon 7)
(defconstant $kHIDGetVendorID 8)
(defconstant $kHIDGetProductID 9)

(defconstant $kNumLockLED 0)
(defconstant $kCapsLockLED 1)
(defconstant $kScrollLockLED 2)
(defconstant $kComposeLED 3)
(defconstant $kKanaLED 4)

(defconstant $kNumLockLEDMask #x1)
(defconstant $kCapsLockLEDMask #x2)
(defconstant $kScrollLockLEDMask #x4)
(defconstant $kComposeLEDMask #x8)
(defconstant $kKanaLEDMask #x10)

(defconstant $kUSBCapsLockKey #x39)
(defconstant $kUSBNumLockKey #x53)
(defconstant $kUSBScrollLockKey #x47)

(def-mactype :usbmousedataptr (find-mactype '(:pointer :usbmousedata)))
(defrecord USBMouseData 
   (buttons :unsigned-integer)
   (XDelta :signed-integer)
   (YDelta :signed-integer)
   )

(def-mactype :usbkeyboarddataptr (find-mactype '(:pointer :usbkeyboarddata)))
(defrecord USBKeyboardData 
   (keycount :unsigned-integer)
   (usbkeycode (:array :unsigned-integer 32))
   )

(def-mactype :usbhiddataptr (find-mactype '(:pointer :usbhiddata)))
(defrecord USBHIDData 
   (:variant 
      (
      (kbd :usbkeyboarddata)
      )
      (
      (mouse :usbmousedata)
      )
      )
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  StartCompoundClassDriver()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_StartCompoundClassDriver" 
      ((device :signed-long) (classID :unsigned-integer) (subClass :unsigned-integer)) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kUSBCompositeClass 0)
(defconstant $kUSBAudioClass 1)
(defconstant $kUSBCommClass 2)
(defconstant $kUSBHIDClass 3)
(defconstant $kUSBDisplayClass 4)
(defconstant $kUSBPrintingClass 7)
(defconstant $kUSBMassStorageClass 8)
(defconstant $kUSBHubClass 9)
(defconstant $kUSBDataClass 10)
(defconstant $kUSBVendorSpecificClass #xFF)

(defconstant $kUSBCompositeSubClass 0)
(defconstant $kUSBHubSubClass 1)
(defconstant $kUSBPrinterSubclass 1)
(defconstant $kUSBVendorSpecificSubClass #xFF)

(defconstant $kUSBHIDInterfaceClass #x3)

(defconstant $kUSBNoInterfaceSubClass #x0)
(defconstant $kUSBBootInterfaceSubClass #x1)

(defconstant $kUSBNoInterfaceProtocol #x0)
(defconstant $kUSBKeyboardInterfaceProtocol #x1)
(defconstant $kUSBMouseInterfaceProtocol #x2)
(defconstant $kUSBVendorSpecificProtocol #xFF)

(defconstant $kUSBPrinterUnidirectionalProtocol #x1)
(defconstant $kUSBPrinterBidirectionalProtocol #x2)

(defconstant $kServiceCategoryUSB :|usb |)      ;   USB 

(defconstant $kUSBDriverFileType :|ndrv|)
(defconstant $kUSBDriverRsrcType :|usbd|)
(defconstant $kUSBShimRsrcType :|usbs|)

(defconstant $kTheUSBDriverDescriptionSignature :|usbd|)

(defconstant $kInitialUSBDriverDescriptor 0)

(def-mactype :usbdriverdescversion (find-mactype ':unsigned-long))
;    Driver Loading Options 
(def-mactype :usbdriverloadingoptions (find-mactype ':unsigned-long))

(defconstant $kUSBDoNotMatchGenericDevice #x1)  ;   Driver's VendorID must match Device's VendorID 
(defconstant $kUSBDoNotMatchInterface #x2)      ;   Do not load this driver as an interface driver. 
(defconstant $kUSBProtocolMustMatch #x4)        ;   Do not load this driver if protocol field doesn't match. 
(defconstant $kUSBInterfaceMatchOnly #x8)       ;   Only load this driver as an interface driver. 

(defconstant $kClassDriverPluginVersion #x1100)

(def-mactype :usbdeviceinfoptr (find-mactype '(:pointer :usbdeviceinfo)))
(defrecord USBDeviceInfo 
   (usbVendorID :unsigned-integer)              ;   USB Vendor ID 
   (usbProductID :unsigned-integer)             ;   USB Product ID. 
   (usbDeviceReleaseNumber :unsigned-integer)   ;   Release Number of Device 
   (usbDeviceProtocol :unsigned-integer)        ;   Protocol Info. 
   )

(def-mactype :usbinterfaceinfoptr (find-mactype '(:pointer :usbinterfaceinfo)))
(defrecord USBInterfaceInfo 
   (usbConfigValue :signed-byte)                ;   Configuration Value 
   (usbInterfaceNum :signed-byte)               ;   Interface Number 
   (usbInterfaceClass :signed-byte)             ;   Interface Class 
   (usbInterfaceSubClass :signed-byte)          ;   Interface SubClass 
   (usbInterfaceProtocol :signed-byte)          ;   Interface Protocol 
   )

(def-mactype :usbdrivertypeptr (find-mactype '(:pointer :usbdrivertype)))
(defrecord USBDriverType 
   (nameInfoStr (:string 31))                   ;   Driver's name when loading into the Name Registry. 
   (usbDriverClass :signed-byte)                ;   USB Class this driver belongs to. 
   (usbDriverSubClass :signed-byte)             ;   Module type 
   (usbDriverVersion :numversion)               ;   Class driver version number. 
   )

(def-mactype :usbdriverdescriptionptr (find-mactype '(:pointer :usbdriverdescription)))
(defrecord USBDriverDescription 
   (usbDriverDescSignature :ostype)             ;   Signature field of this structure. 
   (USBDriverDescVersion :unsigned-long)        ;   Version of this data structure. 
   (USBDeviceInfo :usbdeviceinfo)               ;   Product & Vendor Info 
   (USBInterfaceInfo :usbinterfaceinfo)         ;   Interface info 
   (USBDriverType :usbdrivertype)               ;   Driver Info. 
   (USBDriverLoadingOptions :unsigned-long)     ;   Options for class driver loading. 
   )

; 
; 	   Dispatch Table
; 	   Definition of class driver's HW Validation proc.
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDValidateHWProcPtr = FUNCTION(device: USBDeviceRef; pDesc: USBDeviceDescriptorPtr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdvalidatehwprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   Definition of class driver's device initialization proc.
; 	   Called if the driver is being loaded for a device
; 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDInitializeDeviceProcPtr = FUNCTION(device: USBDeviceRef; pDesc: USBDeviceDescriptorPtr; busPowerAvailable: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdinitializedeviceprocptr (find-mactype ':pointer))
; $ENDC

;   Definition of class driver's interface initialization proc. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDInitializeInterfaceProcPtr = FUNCTION(interfaceNum: UInt32; pInterface: USBInterfaceDescriptorPtr; pDevice: USBDeviceDescriptorPtr; interfaceRef: USBInterfaceRef): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdinitializeinterfaceprocptr (find-mactype ':pointer))
; $ENDC

;   Definition of class driver's finalization proc. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDFinalizeProcPtr = FUNCTION(device: USBDeviceRef; pDesc: USBDeviceDescriptorPtr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbdfinalizeprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :usbdrivernotification (find-mactype ':unsigned-long))

(defconstant $kNotifySystemSleepRequest #x1)
(defconstant $kNotifySystemSleepDemand #x2)
(defconstant $kNotifySystemSleepWakeUp #x3)
(defconstant $kNotifySystemSleepRevoke #x4)
(defconstant $kNotifyHubEnumQuery #x6)
(defconstant $kNotifyChildMessage #x7)
(defconstant $kNotifyExpertTerminating #x8)
(defconstant $kNotifyDriverBeingRemoved #xB)
(defconstant $kNotifyAllowROMDriverRemoval #xE)

; 
; 	   Definition of driver's notification proc.      
; 	   Added refcon for 1.1 version of dispatch table
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	USBDDriverNotifyProcPtr = FUNCTION(notification: USBDriverNotification; pointer: UNIV Ptr; refcon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :usbddrivernotifyprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :usbclassdriverplugindispatchtableptr (find-mactype '(:pointer :usbclassdriverplugindispatchtable)))
(defrecord USBClassDriverPluginDispatchTable 
   (pluginVersion :unsigned-long)
   (validateHWProc :pointer)                    ;   Proc for driver to verify proper HW 
   (initializeDeviceProc :pointer)              ;   Proc that initializes the class driver. 
   (initializeInterfaceProc :pointer)           ;   Proc that initializes a particular interface in the class driver. 
   (finalizeProc :pointer)                      ;   Proc that finalizes the class driver. 
   (notificationProc :pointer)                  ;   Proc to pass notifications to the driver. 
   )

;   Shim Defines 

(defconstant $kTheUSBShimDescriptionSignature :|usbs|)

(def-mactype :usbshimdescversion (find-mactype ':unsigned-long))

(defconstant $kCurrentUSBShimDescVers #x100)

;    Shim Loading Options 

(def-mactype :usbshimloadingoptions (find-mactype ':unsigned-long))

(defconstant $kUSBRegisterShimAsSharedLibrary #x1);   Driver's VendorID must match Device's VendorID 

(def-mactype :usbshimdescriptionptr (find-mactype '(:pointer :usbshimdescription)))
(defrecord USBShimDescription 
   (usbShimDescSignature :ostype)               ;   Signature field of this structure. 
   (USBShimDescVersion :unsigned-long)          ;   Version of this data structure. 
   (usbDriverLoadingOptions :unsigned-long)     ;   Options for shim loading. 
   (libraryName (:string 63))                   ;   For optional shared library registration 
   )

;   Hub defines 

(defconstant $kUSBHubDescriptorType #x29)

;   Hub features  
(defconstant $kUSBHubLocalPowerChangeFeature 0)
(defconstant $kUSBHubOverCurrentChangeFeature 1);   port features  
(defconstant $kUSBHubPortConnectionFeature 0)
(defconstant $kUSBHubPortEnableFeature 1)
(defconstant $kUSBHubPortSuspendFeature 2)
(defconstant $kUSBHubPortOverCurrentFeature 3)
(defconstant $kUSBHubPortResetFeature 4)
(defconstant $kUSBHubPortPowerFeature 8)
(defconstant $kUSBHubPortLowSpeedFeature 9)
(defconstant $kUSBHubPortConnectionChangeFeature 16)
(defconstant $kUSBHubPortEnableChangeFeature 17)
(defconstant $kUSBHubPortSuspendChangeFeature 18)
(defconstant $kUSBHubPortOverCurrentChangeFeature 19)
(defconstant $kUSBHubPortResetChangeFeature 20)

(defconstant $kHubPortConnection 1)
(defconstant $kHubPortEnabled 2)
(defconstant $kHubPortSuspend 4)
(defconstant $kHubPortOverCurrent 8)
(defconstant $kHubPortBeingReset 16)
(defconstant $kHubPortPower #x100)
(defconstant $kHubPortLowSpeed #x200)
(defconstant $kHubPortHighSpeed #x400)
(defconstant $kHubPortTestMode #x800)
(defconstant $kHubPortPortIndicator #x1000)

;   Originally this was a Boolean, (low speed)? 
(defconstant $kUSBFullSpeed 0)
(defconstant $kUSBLowSpeed 1)
(defconstant $kUSBHighSpeed 2)

(defconstant $kHubLocalPowerStatus 1)
(defconstant $kHubOverCurrentIndicator 2)
(defconstant $kHubLocalPowerStatusChange 1)
(defconstant $kHubOverCurrentIndicatorChange 2)

(defconstant $off #$false)
(defconstant $on #$true)

(def-mactype :hubdescriptorptr (find-mactype '(:pointer :hubdescriptor)))
(defrecord hubDescriptor 
;   See usbDoc pg 250??  
   (dummy :unsigned-byte)                       ;   to align charcteristics  
   (length :unsigned-byte)
   (hubType :unsigned-byte)
   (numPorts :unsigned-byte)
   (characteristics :unsigned-integer)
   (powerOnToGood :unsigned-byte)               ;   Port settling time, in 2ms  
   (hubCurrent :unsigned-byte)
;   These are received packed, will have to be unpacked  
   (removablePortFlags (:array :unsigned-byte 8 :packed))
   (pwrCtlPortFlags (:array :unsigned-byte 8 :packed))
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := USBIncludes

; $ENDC                                         ; __USB__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'USB)