(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:UTCUtils.p"
; at Wednesday May 1,2002 2:38:59 pm.
; 
;      File:       UTCUtils.p
;  
;      Contains:   Interface for UTC to Local Time conversion and 64 Bit Clock routines
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __UTCUTILS__
; $SETC __UTCUTILS__ := 1

; $I+
; $SETC UTCUtilsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Options for Set & Get DateTime Routines 

(defconstant $kUTCDefaultOptions 0)

; 	 64 Bit Clock Typedefs 	

(def-mactype :utcdatetimeptr (find-mactype '(:pointer :utcdatetime)))
(defrecord UTCDateTime 
   (highSeconds :unsigned-integer)
   (lowSeconds :unsigned-long)
   (fraction :unsigned-integer)
   )

(def-mactype :utcdatetimehandle (find-mactype '(:handle :utcdatetime)))
(def-mactype :localdatetimeptr (find-mactype '(:pointer :localdatetime)))
(defrecord LocalDateTime 
   (highSeconds :unsigned-integer)
   (lowSeconds :unsigned-long)
   (fraction :unsigned-integer)
   )

(def-mactype :localdatetimehandle (find-mactype '(:handle :localdatetime)))
; 	 Classic 32 bit clock conversion routines 	
; 
; 	 *  ConvertLocalTimeToUTC()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in UTCUtils 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_ConvertLocalTimeToUTC" 
      ((localSeconds :unsigned-long) (utcSeconds (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ConvertUTCToLocalTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ConvertUTCToLocalTime" 
      ((utcSeconds :unsigned-long) (localSeconds (:pointer :unsigned-long))) 
  :osstatus
   () )

;  64 bit clock conversion routines 
; 
;  *  ConvertUTCToLocalDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ConvertUTCToLocalDateTime" 
      ((UTCDateTime (:pointer :utcdatetime)) (LocalDateTime (:pointer :localdatetime))) 
  :osstatus
   () )

; 
;  *  ConvertLocalToUTCDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ConvertLocalToUTCDateTime" 
      ((LocalDateTime (:pointer :localdatetime)) (UTCDateTime (:pointer :utcdatetime))) 
  :osstatus
   () )

;  Getter and Setter Clock routines using 64 Bit values 
; 
;  *  GetUTCDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetUTCDateTime" 
      ((UTCDateTime (:pointer :utcdatetime)) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  SetUTCDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_SetUTCDateTime" 
      ((UTCDateTime (:pointer :utcdatetime)) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  GetLocalDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetLocalDateTime" 
      ((LocalDateTime (:pointer :localdatetime)) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  SetLocalDateTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UTCUtils 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_SetLocalDateTime" 
      ((LocalDateTime (:pointer :localdatetime)) (options :unsigned-long)) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := UTCUtilsIncludes

; $ENDC                                         ; __UTCUTILS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'UTCUtils)