(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:UnicodeUtilities.p"
; at Wednesday May 1,2002 2:40:04 pm.
; 
;      File:       UnicodeUtilities.p
;  
;      Contains:   Types, constants, prototypes for Unicode Utilities (Unicode input and text utils)
;  
;      Version:    Technology: Mac OS 9.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __UNICODEUTILITIES__
; $SETC __UNICODEUTILITIES__ := 1

; $I+
; $SETC UnicodeUtilitiesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __MACLOCALES__
|#

(require-interface 'MacLocales)
#|                                              ; $I MacLocales.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    -------------------------------------------------------------------------------------------------
;    CONSTANTS & DATA STRUCTURES for UCKeyTranslate & UCKeyboardLayout ('uchr' resource)
;    -------------------------------------------------------------------------------------------------
; 

; 
;    -------------------------------------------------------------------------------------------------
;    UCKeyOutput & related stuff
;    The interpretation of UCKeyOutput depends on bits 15-14.
;    If they are 01, then bits 0-13 are an index in UCKeyStateRecordsIndex (resource-wide list).
;    If they are 10, then bits 0-13 are an index in UCKeySequenceDataIndex (resource-wide list),
;      or if UCKeySequenceDataIndex is not present or the index is beyond the end of the list,
;      then bits 0-15 are a single Unicode character.
;    Otherwise, bits 0-15 are a single Unicode character; a value of 0xFFFE-0xFFFF means no character
;      output.
;    UCKeyCharSeq is similar, but does not support indices in UCKeyStateRecordsIndex. For bits 15-14:
;    If they are 10, then bits 0-13 are an index in UCKeySequenceDataIndex (resource-wide list),
;      or if UCKeySequenceDataIndex is not present or the index is beyond the end of the list,
;      then bits 0-15 are a single Unicode character.
;    Otherwise, bits 0-15 are a single Unicode character; a value of 0xFFFE-0xFFFF means no character
;      output.
;    -------------------------------------------------------------------------------------------------
; 

(def-mactype :uckeyoutput (find-mactype ':unsigned-integer))
(def-mactype :uckeycharseq (find-mactype ':unsigned-integer))

(defconstant $kUCKeyOutputStateIndexMask #x4000)
(defconstant $kUCKeyOutputSequenceIndexMask #x8000)
(defconstant $kUCKeyOutputTestForIndexMask #xC000);   test bits 14-15 
(defconstant $kUCKeyOutputGetIndexMask #x3FFF)  ;   get bits 0-13 

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   UCKeyStateRecord & related stuff
; 	   The UCKeyStateRecord information is used as follows. If the current state is zero,
; 	   output stateZeroCharData and set the state to stateZeroNextState. If the current state
; 	   is non-zero and there is an entry for it in stateEntryData, then output the corresponding
; 	   charData and set the state to nextState. Otherwise, output the state terminator from
; 	   UCKeyStateTerminators for the current state (or nothing if there is no UCKeyStateTerminators
; 	   table or it has no entry for the current state), then output stateZeroCharData and set the
; 	   state to stateZeroNextState.
; 	   -------------------------------------------------------------------------------------------------
; 	

(def-mactype :uckeystaterecordptr (find-mactype '(:pointer :uckeystaterecord)))
(defrecord UCKeyStateRecord 
   (stateZeroCharData :unsigned-integer)
   (stateZeroNextState :unsigned-integer)
   (stateEntryCount :unsigned-integer)
   (stateEntryFormat :unsigned-integer)
;   This is followed by an array of stateEntryCount elements 
;   in the specified format. Here we just show a dummy array. 
   (stateEntryData (:array :unsigned-long 1))
   )

; 
; 	   Here are the codes for entry formats currently defined.
; 	   Each entry maps from curState to charData and nextState.
; 	

(defconstant $kUCKeyStateEntryTerminalFormat #x1)
(defconstant $kUCKeyStateEntryRangeFormat #x2)

; 
; 	   For UCKeyStateEntryTerminal -
; 	   nextState is always 0, so we don't have a field for it
; 	

(def-mactype :uckeystateentryterminalptr (find-mactype '(:pointer :uckeystateentryterminal)))
(defrecord UCKeyStateEntryTerminal 
   (curState :unsigned-integer)
   (charData :unsigned-integer)
   )

; 
; 	   For UCKeyStateEntryRange -
; 	   If curState >= curStateStart and curState <= curStateStart+curStateRange,
; 	   then it matches the entry, and we transform charData and nextState as follows:
; 	   If charData < 0xFFFE, then charData += (curState-curStateStart)*deltaMultiplier
; 	   If nextState != 0, then nextState += (curState-curStateStart)*deltaMultiplier
; 	
(def-mactype :uckeystateentryrangeptr (find-mactype '(:pointer :uckeystateentryrange)))
(defrecord UCKeyStateEntryRange 
   (curStateStart :unsigned-integer)
   (curStateRange :signed-byte)
   (deltaMultiplier :signed-byte)
   (charData :unsigned-integer)
   (nextState :unsigned-integer)
   )

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   UCKeyboardLayout & related stuff
; 	   The UCKeyboardLayout struct given here is only for the resource header. It specifies
; 	   offsets to the various subtables which each have their own structs, given below.
; 	   The keyboardTypeHeadList array selects table offsets that depend on keyboardType. The
; 	   first entry in keyboardTypeHeadList is the default entry, which will be used if the
; 	   keyboardType passed to UCKeyTranslate does not match any other entry - i.e. does not fall
; 	   within the range keyboardTypeFirst..keyboardTypeLast for some entry. The first entry
; 	   should have keyboardTypeFirst = keyboardTypeLast = 0.
; 	   -------------------------------------------------------------------------------------------------
; 	
(def-mactype :uckeyboardtypeheaderptr (find-mactype '(:pointer :uckeyboardtypeheader)))
(defrecord UCKeyboardTypeHeader 
   (keyboardTypeFirst :unsigned-long)           ;   first keyboardType in this entry 
   (keyboardTypeLast :unsigned-long)            ;   last keyboardType in this entry 
   (keyModifiersToTableNumOffset :unsigned-long);   required 
   (keyToCharTableIndexOffset :unsigned-long)   ;   required 
   (keyStateRecordsIndexOffset :unsigned-long)  ;   0 => no table 
   (keyStateTerminatorsOffset :unsigned-long)   ;   0 => no table 
   (keySequenceDataIndexOffset :unsigned-long)  ;   0 => no table 
   )

(def-mactype :uckeyboardlayoutptr (find-mactype '(:pointer :uckeyboardlayout)))
(defrecord UCKeyboardLayout 
;   header only; other tables accessed via offsets 
   (keyLayoutHeaderFormat :unsigned-integer)    ;   =kUCKeyLayoutHeaderFormat 
   (keyLayoutDataVersion :unsigned-integer)     ;   0x0100 = 1.0, 0x0110 = 1.1, etc. 
   (keyLayoutFeatureInfoOffset :unsigned-long)  ;   may be 0                        
   (keyboardTypeCount :unsigned-long)           ;   Dimension for keyboardTypeHeadList[]      
   (keyboardTypeList (:array :uckeyboardtypeheader 1))
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeylayoutfeatureinfoptr (find-mactype '(:pointer :uckeylayoutfeatureinfo)))
(defrecord UCKeyLayoutFeatureInfo 
   (keyLayoutFeatureInfoFormat :unsigned-integer);   =kUCKeyLayoutFeatureInfoFormat 
   (reserved :unsigned-integer)
   (maxOutputStringLength :unsigned-long)       ;   longest possible output string 
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeymodifierstotablenumptr (find-mactype '(:pointer :uckeymodifierstotablenum)))
(defrecord UCKeyModifiersToTableNum 
   (keyModifiersToTableNumFormat :unsigned-integer);   =kUCKeyModifiersToTableNumFormat 
   (defaultTableNum :unsigned-integer)          ;   For modifier combos not in tableNum[] 
   (modifiersCount :unsigned-long)              ;   Dimension for tableNum[] 
   (tableNum :signed-byte)
;   Then there is padding to a 4-byte boundary with bytes containing 0, if necessary. 
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeytochartableindexptr (find-mactype '(:pointer :uckeytochartableindex)))
(defrecord UCKeyToCharTableIndex 
   (keyToCharTableIndexFormat :unsigned-integer);   =kUCKeyToCharTableIndexFormat 
   (keyToCharTableSize :unsigned-integer)       ;   Max keyCode (128 for ADB keyboards) 
   (keyToCharTableCount :unsigned-long)         ;   Dimension for keyToCharTableOffsets[] (usually 6 to 12 tables) 
   (keyToCharTableOffsets (:array :unsigned-long 1))
;   Each offset in keyToCharTableOffsets is from the beginning of the resource to a 
;   table as follows: 
;      UCKeyOutput       keyToCharData[keyToCharTableSize]; 
;   These tables follow the UCKeyToCharTableIndex. 
;   Then there is padding to a 4-byte boundary with bytes containing 0, if necessary. 
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeystaterecordsindexptr (find-mactype '(:pointer :uckeystaterecordsindex)))
(defrecord UCKeyStateRecordsIndex 
   (keyStateRecordsIndexFormat :unsigned-integer);   =kUCKeyStateRecordsIndexFormat 
   (keyStateRecordCount :unsigned-integer)      ;   Dimension for keyStateRecordOffsets[] 
   (keyStateRecordOffsets (:array :unsigned-long 1))
;   Each offset in keyStateRecordOffsets is from the beginning of the resource to a 
;   UCKeyStateRecord. These UCKeyStateRecords follow the keyStateRecordOffsets[] array. 
;   Then there is padding to a 4-byte boundary with bytes containing 0, if necessary. 
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeystateterminatorsptr (find-mactype '(:pointer :uckeystateterminators)))
(defrecord UCKeyStateTerminators 
   (keyStateTerminatorsFormat :unsigned-integer);   =kUCKeyStateTerminatorsFormat 
   (keyStateTerminatorCount :unsigned-integer)  ;   Dimension for keyStateTerminators[] (# of nonzero states) 
   (keyStateTerminators (:array :unsigned-integer 1))
;   Note: keyStateTerminators[0] is terminator for state 1, etc. 
;   Then there is padding to a 4-byte boundary with bytes containing 0, if necessary. 
   )

;   ------------------------------------------------------------------------------------------------- 
(def-mactype :uckeysequencedataindexptr (find-mactype '(:pointer :uckeysequencedataindex)))
(defrecord UCKeySequenceDataIndex 
   (keySequenceDataIndexFormat :unsigned-integer);   =kUCKeySequenceDataIndexFormat 
   (charSequenceCount :unsigned-integer)        ;   Dimension of charSequenceOffsets[] is charSequenceCount+1 
   (charSequenceOffsets (:array :unsigned-integer 1))
;   Each offset in charSequenceOffsets is in bytes, from the beginning of 
;   UCKeySequenceDataIndex to a sequence of UniChars; the next offset indicates the 
;   end of the sequence. The UniChar sequences follow the UCKeySequenceDataIndex. 
;   Then there is padding to a 4-byte boundary with bytes containing 0, if necessary. 
   )

;   ------------------------------------------------------------------------------------------------- 
;   Current format codes for the various tables (bits 12-15 indicate which table) 

(defconstant $kUCKeyLayoutHeaderFormat #x1002)
(defconstant $kUCKeyLayoutFeatureInfoFormat #x2001)
(defconstant $kUCKeyModifiersToTableNumFormat #x3001)
(defconstant $kUCKeyToCharTableIndexFormat #x4001)
(defconstant $kUCKeyStateRecordsIndexFormat #x5001)
(defconstant $kUCKeyStateTerminatorsFormat #x6001)
(defconstant $kUCKeySequenceDataIndexFormat #x7001)

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   Constants for keyAction parameter in UCKeyTranslate() 
; 	   -------------------------------------------------------------------------------------------------
; 	

(defconstant $kUCKeyActionDown 0)               ;   key is going down 
(defconstant $kUCKeyActionUp 1)                 ;   key is going up 
(defconstant $kUCKeyActionAutoKey 2)            ;   auto-key down 
(defconstant $kUCKeyActionDisplay 3)            ;   get information for key display (as in Key Caps)       

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   Bit assignments & masks for keyTranslateOptions parameter in UCKeyTranslate() 
; 	   -------------------------------------------------------------------------------------------------
; 	

(defconstant $kUCKeyTranslateNoDeadKeysBit 0)   ;   Prevents setting any new dead-key states 

(defconstant $kUCKeyTranslateNoDeadKeysMask #x1)

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   CONSTANTS & DATA STRUCTURES for Unicode Collation
; 	   -------------------------------------------------------------------------------------------------
; 	
;   constant for LocaleOperationClass 
(defconstant $kUnicodeCollationClass :|ucol|)

(def-mactype :collatorref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :collatorrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CollatorRef parameter can be nil, it is changed to xx: CollatorRefPtr 
(def-mactype :uccollateoptions (find-mactype ':unsigned-long))

;   Sensitivity options 
(defconstant $kUCCollateComposeInsensitiveMask #x2)
(defconstant $kUCCollateWidthInsensitiveMask #x4)
(defconstant $kUCCollateCaseInsensitiveMask #x8)
(defconstant $kUCCollateDiacritInsensitiveMask #x10);   Other general options  
(defconstant $kUCCollatePunctuationSignificantMask #x8000);   Number-handling options  
(defconstant $kUCCollateDigitsOverrideMask #x10000)
(defconstant $kUCCollateDigitsAsNumberMask #x20000)

(defconstant $kUCCollateStandardOptions #x6)

; 
; 	   Special values to specify various invariant orders for UCCompareTextNoLocale.
; 	   These values use the high 8 bits of UCCollateOptions.
; 	
(defconstant $kUCCollateTypeHFSExtended 1)

;   These constants are used for masking and shifting the invariant order type. 
(defconstant $kUCCollateTypeSourceMask #xFF)
(defconstant $kUCCollateTypeShiftBits 24)

(defconstant $kUCCollateTypeMask #xFF000000)

(def-mactype :uccollationvalue (find-mactype ':unsigned-long))
; 
; 	   -------------------------------------------------------------------------------------------------
; 	   CONSTANTS & DATA STRUCTURES for Unicode TextBreak
; 	   -------------------------------------------------------------------------------------------------
; 	
;   constant for LocaleOperationClass 

(defconstant $kUnicodeTextBreakClass :|ubrk|)

(def-mactype :textbreaklocatorref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :textbreaklocatorrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TextBreakLocatorRef parameter can be nil, it is changed to xx: TextBreakLocatorRefPtr 
(def-mactype :uctextbreaktype (find-mactype ':unsigned-long))

(defconstant $kUCTextBreakCharMask #x1)
(defconstant $kUCTextBreakClusterMask #x4)
(defconstant $kUCTextBreakWordMask #x10)
(defconstant $kUCTextBreakLineMask #x40)

(def-mactype :uctextbreakoptions (find-mactype ':unsigned-long))

(defconstant $kUCTextBreakLeadingEdgeMask #x1)
(defconstant $kUCTextBreakGoBackwardsMask #x2)
(defconstant $kUCTextBreakIterateMask #x4)

; 
; 	   -------------------------------------------------------------------------------------------------
; 	   FUNCTION PROTOTYPES
; 	   -------------------------------------------------------------------------------------------------
; 	

; 
; 	 *  UCKeyTranslate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in UnicodeUtilitiesCoreLib 8.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ;   Standard collation functions ; 
;  *  UCCreateCollator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_UCKeyTranslate" 
      ((keyLayoutPtr (:pointer :uckeyboardlayout)) (virtualKeyCode :unsigned-integer) (keyAction :unsigned-integer) (modifierKeyState :unsigned-long) (keyboardType :unsigned-long) (keyTranslateOptions :unsigned-long) (deadKeyState (:pointer :unsigned-long)) (maxStringLength :unsigned-long) (actualStringLength (:pointer :unsigned-long)) (unicodeString (:pointer :unsigned-integer))) 
  :osstatus
   () )
(deftrap-inline "_UCCreateCollator" 
      ((locale :pointer) (opVariant :ostype) (options :unsigned-long) (CollatorRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  UCGetCollationKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_UCGetCollationKey" 
      ((CollatorRef :pointer) (textPtr (:pointer :unsigned-integer)) (textLength :unsigned-long) (maxKeySize :unsigned-long) (actualKeySize (:pointer :unsigned-long)) (collationKey (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  UCCompareCollationKeys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesCoreLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_UCCompareCollationKeys" 
      ((key1Ptr (:pointer :unsigned-long)) (key1Length :unsigned-long) (key2Ptr (:pointer :unsigned-long)) (key2Length :unsigned-long) (equivalent (:pointer :boolean)) (order (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  UCCompareText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_UCCompareText" 
      ((CollatorRef :pointer) (text1Ptr (:pointer :unsigned-integer)) (text1Length :unsigned-long) (text2Ptr (:pointer :unsigned-integer)) (text2Length :unsigned-long) (equivalent (:pointer :boolean)) (order (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  UCDisposeCollator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UCDisposeCollator" 
      ((CollatorRef (:pointer :pointer))) 
  :osstatus
   () )

;   Simple collation using default locale 

; 
;  *  UCCompareTextDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_UCCompareTextDefault" 
      ((options :unsigned-long) (text1Ptr (:pointer :unsigned-integer)) (text1Length :unsigned-long) (text2Ptr (:pointer :unsigned-integer)) (text2Length :unsigned-long) (equivalent (:pointer :boolean)) (order (:pointer :signed-long))) 
  :osstatus
   () )

;   Simple locale-independent collation 

; 
;  *  UCCompareTextNoLocale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesCoreLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_UCCompareTextNoLocale" 
      ((options :unsigned-long) (text1Ptr (:pointer :unsigned-integer)) (text1Length :unsigned-long) (text2Ptr (:pointer :unsigned-integer)) (text2Length :unsigned-long) (equivalent (:pointer :boolean)) (order (:pointer :signed-long))) 
  :osstatus
   () )

;   Standard text break (text boundary) functions 
; 
;  *  UCCreateTextBreakLocator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UCCreateTextBreakLocator" 
      ((locale :pointer) (opVariant :ostype) (breakTypes :unsigned-long) (breakRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  UCFindTextBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_UCFindTextBreak" 
      ((breakRef :pointer) (breakType :unsigned-long) (options :unsigned-long) (textPtr (:pointer :unsigned-integer)) (textLength :unsigned-long) (startOffset :unsigned-long) (breakOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  UCDisposeTextBreakLocator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeUtilitiesLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UCDisposeTextBreakLocator" 
      ((breakRef (:pointer :pointer))) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := UnicodeUtilitiesIncludes

; $ENDC                                         ; __UNICODEUTILITIES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'UnicodeUtilities)