(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ZoomedVideo.p"
; at Wednesday May 1,2002 2:43:00 pm.
; 
;      File:       ZoomedVideo.p
;  
;      Contains:   PC Card Family Zoomed Video Driver Interface
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc.  All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ZOOMEDVIDEO__
; $SETC __ZOOMEDVIDEO__ := 1

; $I+
; $SETC ZoomedVideoIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DEVICES__
|#

(require-interface 'Devices)
#|                                              ; $I Devices.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Control codes  

(defconstant $cscZVVideoEnable 2)               ;   Used to enable or disable ZV Video 
(defconstant $cscZVSetCurrentAnalogValue 3)     ;   Used to set brightness, contrast, etc. 
(defconstant $cscZVSetInput 9)                  ;   Set video source to selected input 
(defconstant $cscZVSetInputStandard 11)         ;   Set the input to NTSC, PAL, or SECAM 
(defconstant $cscZVGetMaxSourceRect 12)         ;   Get Maximum Source Rect 

;   Status codes 
(defconstant $cscZVGetVideoEnable 2)            ;   Indicates whether ZV Video is enabled 
(defconstant $cscZVGetCurrentAnalogValue 3)     ;   Used to get brightness, contrast, etc. 
(defconstant $cscZVGetDefaultAnalogValue 4)
(defconstant $cscZVGetVSyncState 5)             ;   Used to look for a Vertical Sync on ZV Video 
(defconstant $cscZVGetInfo 6)                   ;   Returns the ZV Information 
(defconstant $cscZVGetInputFlags 7)             ;   Returns the input flags. 
(defconstant $cscZVGetNumberOfInputs 8)         ;   Returns the number of video inputs 
(defconstant $cscZVGetInput 9)                  ;   Zero-based input number 
(defconstant $cscZVGetInputFormat 10)           ;   Returns whether input is compsite/s-video 

; 
; 	  -----------------------------------------------------------------
; 	   Additional parameters for csInfoZV control call
; 	    A pointer to ZVInfo is passed in csParam[0] (and csParam[1])
; 	    which must be filled by the driver in response to this call.
; 	

(def-mactype :zvfeatures (find-mactype ':unsigned-long))

(defconstant $kZVHasAudio #x1)
(defconstant $kZVHasTVTuner #x2)
(defconstant $kZVHasContrast #x10000)
(defconstant $kZVHasBrightness #x20000)
(defconstant $kZVHasSharpness #x40000)
(defconstant $kZVHasSaturation #x80000)
(defconstant $kZVHasHue #x100000)

(def-mactype :zvinfoptr (find-mactype '(:pointer :zvinfo)))
(defrecord ZVInfo 
   (features :unsigned-long)
   (currentFlags :unsigned-long)
   (activeRect :rect)
   (isInterlaced :boolean)
   (filler :signed-byte)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :zvflagrecordptr (find-mactype '(:pointer :zvflagrecord)))
(defrecord ZVFlagRecord 
   (csFlag :boolean)
   (filler :signed-byte)
   )

; 
; 	  -----------------------------------------------------------------
; 	   Additional definitions for "AnalogCtlZV" control calls
; 	    A pointer to a ZVSetAnalogControlParam is passed to the driver
; 	    whenever the system needs to adjust one of the analog settings.
; 	
(def-mactype :zvanalogcontrolselector (find-mactype ':unsigned-integer))

(defconstant $kZVContrast 1)                    ;   Range:  0x0 <= no change to image, larger values increase the contrast 
(defconstant $kZVBrightness 2)                  ;   Range:  0x0 <= darkest setting, 0xffff = lightest setting 
(defconstant $kZVSharpness 3)                   ;   Range:  0x0 <= no sharpness filtering, 0xffff <= full sharpness filtering 
(defconstant $kZVSaturation 4)                  ;   Range:  0x0 <= min saturation, 0xffff <= max saturation        
(defconstant $kZVHue 5)                         ;   Range:  0x0 <= -180 shift in hue, 0xffff <= 179 shift, 0x8000 <=0 shift 
(defconstant $kZVBlackLevel 6)                  ;   Range:  0x0 <= max black, 0xffff <= min black level 
(defconstant $kZVWhiteLevel 7)                  ;   Range:  0x0 <= min white, 0xffff <= max white level 

(def-mactype :zvanalogcontrolrecordptr (find-mactype '(:pointer :zvanalogcontrolrecord)))
(defrecord ZVAnalogControlRecord 
   (whichControl :unsigned-integer)
   (value :unsigned-integer)
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ZoomedVideoIncludes

; $ENDC                                         ; __ZOOMEDVIDEO__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ZoomedVideo)