(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:fenv.p"
; at Wednesday May 1,2002 2:40:05 pm.
; 
;      File:       fenv.p
;  
;      Contains:   Floating-Point environment for PowerPC and 68K
;  
;      Version:    Technology: MathLib v2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FENV__
; $SETC __FENV__ := 1

; $I+
; $SETC fenvIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC TARGET_OS_MAC 
; 
;     A collection of functions designed to provide access to the floating
;     point environment for numerical programming. It is modeled after
;     the floating-point requirements in C9X.
;     
;     The file <fenv.h> declares many functions in support of numerical
;     programming.  It provides a set of environmental controls similar to
;     the ones found in <SANE.h>.  Programs that test flags or run under
;     non-default modes must do so under the effect of an enabling
;     "fenv_access" pragma.
; 

; *******************************************************************************
; *                                                                               *
; *    fenv_t         is a type for representing the entire floating-point        *
; *                   environment in a single object.                             *
; *                                                                               *
; *    fexcept_t      is a type for representing the floating-point               *
; *                   exception flag state collectively.                          *
; *                                                                               *
; *******************************************************************************
; $IFC TARGET_CPU_PPC 

(def-mactype :fenv_t (find-mactype ':signed-long))
(def-mactype :fexcept_t (find-mactype ':signed-long))
; 	    Definitions of floating-point exception macros                          	

(defconstant $FE_INEXACT #x2000000)
(defconstant $FE_DIVBYZERO #x4000000)
(defconstant $FE_UNDERFLOW #x8000000)
(defconstant $FE_OVERFLOW #x10000000)
(defconstant $FE_INVALID #x20000000)
(defconstant $FE_ALL_EXCEPT #x3E000000)         ;   FE_INEXACT | FE_DIVBYZERO | FE_UNDERFLOW | FE_OVERFLOW | FE_INVALID 

; 	    Definitions of rounding direction macros                                	
(defconstant $FE_TONEAREST #x0)
(defconstant $FE_TOWARDZERO #x1)
(defconstant $FE_UPWARD #x2)
(defconstant $FE_DOWNWARD #x3)

; $ENDC                                         ; TARGET_CPU_PPC
#|                                              ; $IFC TARGET_CPU_68K 
; $IFC TARGET_RT_MAC_68881 

(def-mactype :fexcept_t (find-mactype ':signed-long))
(def-mactype :fenv_tptr (find-mactype '(:pointer :signed-long)))
(defrecord fenv_t 
   (FPCR :signed-long)
   (FPSR :signed-long)
   )

(defconstant $FE_INEXACT #x8)                   ;   ((long)(8))    
(defconstant $FE_DIVBYZERO #x10)                ;   ((long)(16))   
(defconstant $FE_UNDERFLOW #x20)                ;   ((long)(32))   
(defconstant $FE_OVERFLOW #x40)                 ;   ((long)(64))   
(defconstant $FE_INVALID #x80)                  ;   ((long)(128))  
(defconstant $FE_ALL_EXCEPT #xF8)               ;   FE_INEXACT | FE_DIVBYZERO | FE_UNDERFLOW | FE_OVERFLOW | FE_INVALID 

; $ELSEC

(def-mactype :fexcept_t (find-mactype ':signed-integer))
(def-mactype :fenv_t (find-mactype ':signed-integer))

(defconstant $FE_INVALID #x1)                   ;   ((short)(1))   
(defconstant $FE_UNDERFLOW #x2)                 ;   ((short)(2))   
(defconstant $FE_OVERFLOW #x4)                  ;   ((short)(4))   
(defconstant $FE_DIVBYZERO #x8)                 ;   ((short)(8))   
(defconstant $FE_INEXACT #x10)                  ;   ((short)(16))  
(defconstant $FE_ALL_EXCEPT #x1F)               ;   FE_INEXACT | FE_DIVBYZERO | FE_UNDERFLOW | FE_OVERFLOW | FE_INVALID 

; $ENDC                                         ; TARGET_RT_MAC_68881
(defconstant $FE_TONEAREST #x0)                 ;   ((short)(0))   
(defconstant $FE_UPWARD #x1)                    ;   ((short)(1))   
(defconstant $FE_DOWNWARD #x2)                  ;   ((short)(2))   
(defconstant $FE_TOWARDZERO #x3)                ;   ((short)(3))   

; 	    Definitions of rounding precision macros  (68K only)                    	
(defconstant $FE_LDBLPREC #x0)                  ;   ((short)(0))   
(defconstant $FE_DBLPREC #x1)                   ;   ((short)(1))   
(defconstant $FE_FLTPREC #x2)                   ;   ((short)(2))   

 |#                                             ; $ENDC; TARGET_CPU_68K
;  default environment object        

; $PUSH
; $J+
;  default environment object        
; $POP
; ******************************************************************************
; *     The following functions provide access to the exception flags.  The      *
; *     "int" input argument can be constructed by bitwise ORs of the exception  *
; *     macros: for example: FE_OVERFLOW | FE_INEXACT.                           *
; ******************************************************************************
; ******************************************************************************
; *     The function "feclearexcept" clears the supported exceptions represented *
; *     by its argument.                                                         *
; ******************************************************************************
; 
;  *  feclearexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_feclearexcept" 
      ((excepts :signed-long)) 
  nil
   () )

; ******************************************************************************
; *    The function "fegetexcept" stores a representation of the exception       *
; *     flags indicated by the argument "excepts" through the pointer argument   *
; *     "flagp".                                                                 *
; ******************************************************************************
; 
;  *  fegetexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fegetexcept" 
      ((flagp (:pointer :signed-long)) (excepts :signed-long)) 
  nil
   () )

; ******************************************************************************
; *     The function "feraiseexcept" raises the supported exceptions             *
; *     represented by its argument.                                             *
; ******************************************************************************
; 
;  *  feraiseexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_feraiseexcept" 
      ((excepts :signed-long)) 
  nil
   () )

; ******************************************************************************
; *     The function "fesetexcept" sets or clears the exception flags indicated  *
; *     by the int argument "excepts" according to the representation in the     *
; *     object pointed to by the pointer argument "flagp".  The value of         *
; *     "*flagp" must have been set by a previous call to "fegetexcept".         *
; *     This function does not raise exceptions; it just sets the state of       *
; *     the flags.                                                               *
; ******************************************************************************
; 
;  *  fesetexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_fesetexcept" 
      ((flagp (:pointer :signed-long)) (excepts :signed-long)) 
  nil
   () )

; ******************************************************************************
; *     The function "fetestexcept" determines which of the specified subset of  *
; *     the exception flags are currently set.  The argument "excepts" specifies *
; *     the exception flags to be queried as a bitwise OR of the exception       *
; *     macros.  This function returns the bitwise OR of the exception macros    *
; *     corresponding to the currently set exceptions included in "excepts".     *
; ******************************************************************************
; 
;  *  fetestexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fetestexcept" 
      ((excepts :signed-long)) 
  :signed-long
   () )

; ******************************************************************************
; *     The following functions provide control of rounding direction modes.     *
; ******************************************************************************
; ******************************************************************************
; *     The function "fegetround" returns the value of the rounding direction    *
; *     macro which represents the current rounding direction.                   *
; ******************************************************************************
; 
;  *  fegetround()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fegetround" 
      () 
  :signed-long
   () )

; ******************************************************************************
; *     The function "fesetround" establishes the rounding direction represented *
; *     by its argument.  It returns nonzero if and only if the argument matches *
; *     a rounding direction macro.  If not, the rounding direction is not       *
; *     changed.                                                                 *
; ******************************************************************************
; 
;  *  fesetround()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fesetround" 
      ((round :signed-long)) 
  :signed-long
   () )

; ******************************************************************************
; *    The following functions manage the floating-point environment, exception  *
; *    flags and dynamic modes, as one entity.                                   *
; ******************************************************************************
; ******************************************************************************
; *     The function "fegetenv" stores the current floating-point environment    *
; *     in the object pointed to by its pointer argument "envp".                 *
; ******************************************************************************
; 
;  *  fegetenv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fegetenv" 
      ((envp (:pointer :signed-long))) 
  nil
   () )

; ******************************************************************************
; *     The function "feholdexcept" saves the current environment in the object  *
; *     pointed to by its pointer argument "envp", clears the exception flags,   *
; *     and clears floating-point exception enables.  This function supersedes   *
; *     the SANE function "procentry", but it does not change the current        *
; *     rounding direction mode.                                                 *
; ******************************************************************************
; 
;  *  feholdexcept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_feholdexcept" 
      ((envp (:pointer :signed-long))) 
  :signed-long
   () )

; ******************************************************************************
; *     The function "fesetenv" installs the floating-point environment          *
; *     environment represented by the object pointed to by its argument         *
; *     "envp".  The value of "*envp" must be set by a call to "fegetenv" or     *
; *     "feholdexcept", by an implementation-defined macro of type "fenv_t",     *
; *     or by the use of the pointer macro FE_DFL_ENV as the argument.           *
; ******************************************************************************
; 
;  *  fesetenv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_fesetenv" 
      ((envp (:pointer :signed-long))) 
  nil
   () )

; ******************************************************************************
; *     The function "feupdateenv" saves the current exceptions into its         *
; *     automatic storage, installs the environment represented through its      *
; *     pointer argument "envp", and then re-raises the saved exceptions.        *
; *     This function, which supersedes the SANE function "procexit", can be     *
; *     used in conjunction with "feholdexcept" to write routines which hide     *
; *     spurious exceptions from their callers.                                  *
; ******************************************************************************
; 
;  *  feupdateenv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_feupdateenv" 
      ((envp (:pointer :signed-long))) 
  nil
   () )

#|                                              ; $IFC TARGET_CPU_68K 
; ******************************************************************************
; *     The following functions provide control of rounding precision.           *
; *     Because the PowerPC does not provide this capability, these functions    *  
; *     are available only for the 68K Macintosh.  Rounding precision values     *
; *     are defined by the rounding precision macros.  These functions are       *
; *     equivalent to the SANE functions getprecision and setprecision.          *
; ******************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  fegetprec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fegetprec" 
      () 
  :signed-long
   () )

; 
;  *  fesetprec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fesetprec" 
      ((precision :signed-long)) 
  :signed-long
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := fenvIncludes

; $ENDC                                         ; __FENV__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'fenv)