(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:fp.p"
; at Wednesday May 1,2002 2:40:04 pm.
; 
;      File:       fp.p
;  
;      Contains:   FPCE Floating-Point Definitions and Declarations.
;  
;      Version:    Technology: MathLib v2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FP__
; $SETC __FP__ := 1

; $I+
; $SETC fpIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; *******************************************************************************
; *                                                                               *
; *    A collection of numerical functions designed to facilitate a wide          *
; *    range of numerical programming as required by C9X.                         *
; *                                                                               *
; *    The <fp.h> declares many functions in support of numerical programming.    *
; *    It provides a superset of <math.h> and <SANE.h> functions.  Some           *
; *    functionality previously found in <SANE.h> and not in the FPCE <fp.h>      *
; *    can be found in this <fp.h> under the heading "__NOEXTENSIONS__".          *
; *                                                                               *
; *    All of these functions are IEEE 754 aware and treat exceptions, NaNs,      *
; *    positive and negative zero and infinity consistent with the floating-      *
; *    point standard.                                                            *
; *                                                                               *
; *******************************************************************************

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *******************************************************************************
; *                                                                               *
; *                            Efficient types                                    *
; *                                                                               *
; *    float_t         Most efficient type at least as wide as float              *
; *    double_t        Most efficient type at least as wide as double             *
; *                                                                               *
; *      CPU            float_t(bits)                double_t(bits)               *
; *    --------        -----------------            -----------------             *
; *    PowerPC          float(32)                    double(64)                   *
; *    68K              long double(80/96)           long double(80/96)           *
; *    x86              double(64)                   double(64)                   *
; *                                                                               *
; *******************************************************************************
; $IFC TARGET_CPU_PPC 

(def-mactype :float_t (find-mactype ':single-float))
(def-mactype :double_t (find-mactype ':double-float))
#|                                              ; $ELSEC
; $IFC TARGET_CPU_68K 

(def-mactype :float_t (find-mactype ':pointer))
(def-mactype :double_t (find-mactype ':pointer))
; $ELSEC
; $IFC TARGET_CPU_X86 

(def-mactype :float_t (find-mactype ':double-float))
(def-mactype :double_t (find-mactype ':double-float))
; $ELSEC
; $IFC TARGET_CPU_MIPS 

(def-mactype :float_t (find-mactype ':double-float))
(def-mactype :double_t (find-mactype ':double-float))
; $ELSEC
; $IFC TARGET_CPU_ALPHA 

(def-mactype :float_t (find-mactype ':double-float))
(def-mactype :double_t (find-mactype ':double-float))
; $ELSEC
; $IFC TARGET_CPU_SPARC 

(def-mactype :float_t (find-mactype ':double-float))
(def-mactype :double_t (find-mactype ':double-float))
; $ELSEC
;  Unsupported CPU 
; $ENDC
; $ENDC
; $ENDC
; $ENDC
; $ENDC
 |#                                             ; $ENDC

; *******************************************************************************
; *                                                                               *
; *                              Define some constants.                           *
; *                                                                               *
; *    HUGE_VAL            IEEE 754 value of infinity.                            *
; *    INFINITY            IEEE 754 value of infinity.                            *
; *    NAN                 A generic NaN (Not A Number).                          *
; *    DECIMAL_DIG         Satisfies the constraint that the conversion from      *
; *                        double to decimal and back is the identity function.   *
; *                                                                               *
; *******************************************************************************

; $IFC TARGET_CPU_PPC 
(defconstant $DECIMAL_DIG 17)
#|                                              ; $ELSEC
(defconstant $DECIMAL_DIG 21)
 |#                                             ; $ENDC
; $IFC TARGET_OS_MAC 
; *******************************************************************************
; *                                                                               *
; *                            Trigonometric functions                            *
; *                                                                               *
; *   acos        result is in [0,pi].                                            *
; *   asin        result is in [-pi/2,pi/2].                                      *
; *   atan        result is in [-pi/2,pi/2].                                      *
; *   atan2       Computes the arc tangent of y/x in [-pi,pi] using the sign of   *
; *               both arguments to determine the quadrant of the computed value. *
; *                                                                               *
; *******************************************************************************
; 
;  *  cos()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_cos" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  sin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_sin" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  tan()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_tan" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  acos()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_acos" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  asin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_asin" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  atan()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_atan" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  atan2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_atan2" 
      ((y :double-float) (x :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                              Hyperbolic functions                             *
; *                                                                               *
; *******************************************************************************
; 
;  *  cosh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_cosh" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  sinh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_sinh" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  tanh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_tanh" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  acosh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_acosh" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  asinh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_asinh" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  atanh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_atanh" 
      ((x :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                              Exponential functions                            *
; *                                                                               *
; *   expm1       expm1(x) = exp(x) - 1.  But, for small enough arguments,        *
; *               expm1(x) is expected to be more accurate than exp(x) - 1.       *
; *   frexp       Breaks a floating-point number into a normalized fraction       *
; *               and an integral power of 2.  It stores the integer in the       *
; *               object pointed by *exponent.                                    *
; *   ldexp       Multiplies a floating-point number by an integer power of 2.    *
; *   log1p       log1p = log(1 + x). But, for small enough arguments,            *
; *               log1p is expected to be more accurate than log(1 + x).          *
; *   logb        Extracts the exponent of its argument, as a signed integral     *
; *               value. A subnormal argument is treated as though it were first  *
; *               normalized. Thus:                                               *
; *                                  1   <=   x * 2^(-logb(x))   <   2            *
; *   modf        Returns fractional part of x as function result and returns     *
; *               integral part of x via iptr. Note C9X uses double not double_t. *
; *   scalb       Computes x * 2^n efficently.  This is not normally done by      *
; *               computing 2^n explicitly.                                       *
; *                                                                               *
; *******************************************************************************
; 
;  *  exp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_exp" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  expm1()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_expm1" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  exp2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_exp2" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  frexp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_frexp" 
      ((x :double-float) (exponent (:pointer :signed-long))) 
  :double-float
   () )

; 
;  *  ldexp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ldexp" 
      ((x :double-float) (n :signed-long)) 
  :double-float
   () )

; 
;  *  log()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_log" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  log2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_log2" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  log1p()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_log1p" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  log10()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_log10" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  logb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_logb" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  modf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_modf" 
      ((x :double-float) (iptr (:pointer :double-float))) 
  :double-float
   () )

; 
;  *  modff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_modff" 
      ((x :single-float) (iptrf (:pointer :single-float))) 
  :single-float
   () )

; 
;     Note: For compatiblity scalb(x,n) has n of type
;             int  on Mac OS X 
;             long on Mac OS
; 

(def-mactype :_scalb_n_type (find-mactype ':signed-long))
; 
; 	 *  scalb()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MathLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_scalb" 
      ((x :double-float) (n :signed-long)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                     Power and absolute value functions                        *
; *                                                                               *
; *   hypot       Computes the square root of the sum of the squares of its       *
; *               arguments, without undue overflow or underflow.                 *
; *   pow         Returns x raised to the power of y.  Result is more accurate    *
; *               than using exp(log(x)*y).                                       *
; *                                                                               *
; *******************************************************************************
; 
;  *  fabs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fabs" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  hypot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_hypot" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  pow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_pow" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  sqrt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_sqrt" 
      ((x :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                        Gamma and Error functions                              *
; *                                                                               *
; *   erf         The error function.                                             *
; *   erfc        Complementary error function.                                   *
; *   gamma       The gamma function.                                             *
; *   lgamma      Computes the base-e logarithm of the absolute value of          *
; *               gamma of its argument x, for x > 0.                             *
; *                                                                               *
; *******************************************************************************
; 
;  *  erf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_erf" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  erfc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_erfc" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  gamma()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_gamma" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  lgamma()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_lgamma" 
      ((x :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                        Nearest integer functions                              *
; *                                                                               *
; *   rint        Rounds its argument to an integral value in floating point      *
; *               format, honoring the current rounding direction.                *
; *                                                                               *
; *   nearbyint   Differs from rint only in that it does not raise the inexact    *
; *               exception. It is the nearbyint function recommended by the      *
; *               IEEE floating-point standard 854.                               *
; *                                                                               *
; *   rinttol     Rounds its argument to the nearest long int using the current   *
; *               rounding direction.  NOTE: if the rounded value is outside      *
; *               the range of long int, then the result is undefined.            *
; *                                                                               *
; *   round       Rounds the argument to the nearest integral value in floating   *
; *               point format similar to the Fortran "anint" function. That is:  *
; *               add half to the magnitude and chop.                             *
; *                                                                               *
; *   roundtol    Similar to the Fortran function nint or to the Pascal round.    *
; *               NOTE: if the rounded value is outside the range of long int,    *
; *               then the result is undefined.                                   *
; *                                                                               *
; *   trunc       Computes the integral value, in floating format, nearest to     *
; *               but no larger in magnitude than its argument.   NOTE: on 68K    *
; *               compilers when using -elems881, trunc must return an int        *
; *                                                                               *
; *******************************************************************************
; 
;  *  ceil()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ceil" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  floor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_floor" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  rint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_rint" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  nearbyint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_nearbyint" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  rinttol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_rinttol" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  round()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_round" 
      ((x :double-float)) 
  :double-float
   () )

; 
;  *  roundtol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_roundtol" 
      ((round :double-float)) 
  :signed-long
   () )

; 
;     Note: For compatiblity trunc(x) has a return type of
;             int       for classic 68K with FPU enabled
;             double_t  everywhere else
; 
#|                                              ; $IFC TARGET_RT_MAC_68881 

(def-mactype :_trunc_return_type (find-mactype ':signed-long))
 |#                                             ; $ELSEC

(def-mactype :_trunc_return_type (find-mactype ':double-float))
; $ENDC                                         ; TARGET_RT_MAC_68881
; 
; 	 *  trunc()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MathLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_trunc" 
      ((x :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                            Remainder functions                                *
; *                                                                               *
; *   remainder       IEEE 754 floating point standard for remainder.             *
; *   remquo          SANE remainder.  It stores into 'quotient' the 7 low-order  *
; *                   bits of the integer quotient x/y, such that:                *
; *                       -127 <= quotient <= 127.                                *
; *                                                                               *
; *******************************************************************************
; 
;  *  fmod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fmod" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  remainder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_remainder" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  remquo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_remquo" 
      ((x :double-float) (y :double-float) (quo (:pointer :signed-long))) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                             Auxiliary functions                               *
; *                                                                               *
; *   copysign        Produces a value with the magnitude of its first argument   *
; *                   and sign of its second argument.  NOTE: the order of the    *
; *                   arguments matches the recommendation of the IEEE 754        *
; *                   floating point standard,  which is opposite from the SANE   *
; *                   copysign function.                                          *
; *                                                                               *
; *   nan             The call 'nan("n-char-sequence")' returns a quiet NaN       *
; *                   with content indicated through tagp in the selected         *
; *                   data type format.                                           *
; *                                                                               *
; *   nextafter       Computes the next representable value after 'x' in the      *
; *                   direction of 'y'.  if x == y, then y is returned.           *
; *                                                                               *
; *******************************************************************************
; 
;  *  copysign()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_copysign" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  nan()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_nan" 
      ((tagp :pointer)) 
  :double-float
   () )

; 
;  *  nanf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_nanf" 
      ((tagp :pointer)) 
  :single-float
   () )

; 
;  *  nextafterd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_nextafterd" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  nextafterf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_nextafterf" 
      ((x :single-float) (y :single-float)) 
  :single-float
   () )

; 
;  *  __fpclassifyd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___fpclassifyd" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  __fpclassifyf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___fpclassifyf" 
      ((x :single-float)) 
  :signed-long
   () )

; 
;  *  __isnormald()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isnormald" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  __isnormalf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isnormalf" 
      ((x :single-float)) 
  :signed-long
   () )

; 
;  *  __isfinited()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isfinited" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  __isfinitef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isfinitef" 
      ((x :single-float)) 
  :signed-long
   () )

; 
;  *  __isnand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isnand" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  __isnanf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___isnanf" 
      ((x :single-float)) 
  :signed-long
   () )

; 
;  *  __signbitd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___signbitd" 
      ((x :double-float)) 
  :signed-long
   () )

; 
;  *  __signbitf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___signbitf" 
      ((x :single-float)) 
  :signed-long
   () )

; 
;  *  __inf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "___inf" 
      () 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                              Inquiry macros                                   *
; *                                                                               *
; *   fpclassify      Returns one of the FP_ values.                             *
; *   isnormal        Non-zero if and only if the argument x is normalized.       *
; *   isfinite        Non-zero if and only if the argument x is finite.           *
; *   isnan           Non-zero if and only if the argument x is a NaN.            *
; *   signbit         Non-zero if and only if the sign of the argument x is       *
; *                   negative.  This includes, NaNs, infinities and zeros.       *
; *                                                                               *
; *******************************************************************************

(defconstant $FP_SNAN 0)                        ;        signaling NaN                          
(defconstant $FP_QNAN 1)                        ;        quiet NaN                              
(defconstant $FP_INFINITE 2)                    ;        + or - infinity                        
(defconstant $FP_ZERO 3)                        ;        + or - zero                            
(defconstant $FP_NORMAL 4)                      ;        all normal numbers                     
(defconstant $FP_SUBNORMAL 5)                   ;        denormal numbers                       

; 	*******************************************************************************
; 	*                                                                               *
; 	*                      Max, Min and Positive Difference                         *
; 	*                                                                               *
; 	*   fdim        Determines the 'positive difference' between its arguments:     *
; 	*               ( x - y, if x > y ), ( +0, if x <= y ).  If one argument is     *
; 	*               NaN, then fdim returns that NaN.  if both arguments are NaNs,   *
; 	*               then fdim returns the first argument.                           *
; 	*                                                                               *
; 	*   fmax        Returns the maximum of the two arguments.  Corresponds to the   *
; 	*               max function in FORTRAN.  NaN arguments are treated as missing  *
; 	*               data.  If one argument is NaN and the other is a number, then   *
; 	*               the number is returned.  If both are NaNs then the first        *
; 	*               argument is returned.                                           *
; 	*                                                                               *
; 	*   fmin        Returns the minimum of the two arguments.  Corresponds to the   *
; 	*               min function in FORTRAN.  NaN arguments are treated as missing  *
; 	*               data.  If one argument is NaN and the other is a number, then   *
; 	*               the number is returned.  If both are NaNs then the first        *
; 	*               argument is returned.                                           *
; 	*                                                                               *
; 	*******************************************************************************	
; 
; 	 *  fdim()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MathLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_fdim" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  fmax()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fmax" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; 
;  *  fmin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fmin" 
      ((x :double-float) (y :double-float)) 
  :double-float
   () )

; ******************************************************************************
; *                                Constants                                     *
; ******************************************************************************
; $IFC NOT UNDEFINED MWERKS
#|                                              ; $IFC MWERKS > $1500
(defconstant $pi 3.1415926535)
 |#                                             ; $ENDC
; $ENDC
; *******************************************************************************
; *                                                                               *
; *                              Non NCEG extensions                              *
; *                                                                               *
; *******************************************************************************
; $IFC UNDEFINED __NOEXTENSIONS__ 
; *******************************************************************************
; *                                                                               *
; *                              Financial functions                              *
; *                                                                               *
; *   compound        Computes the compound interest factor "(1 + rate)^periods"  *
; *                   more accurately than the straightforward computation with   *
; *                   the Power function.  This is SANE's compound function.      *
; *                                                                               *
; *   annuity         Computes the present value factor for an annuity            *
; *                   "(1 - (1 + rate)^(-periods)) /rate" more accurately than    *
; *                   the straightforward computation with the Power function.    *
; *                   This is SANE's annuity function.                            *
; *                                                                               *
; *******************************************************************************
; 
;  *  compound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_compound" 
      ((rate :double-float) (periods :double-float)) 
  :double-float
   () )

; 
;  *  annuity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_annuity" 
      ((rate :double-float) (periods :double-float)) 
  :double-float
   () )

; *******************************************************************************
; *                                                                               *
; *                              Random function                                  *
; *                                                                               *
; *   randomx         A pseudorandom number generator.  It uses the iteration:    *
; *                               (7^5*x)mod(2^31-1)                              *
; *                                                                               *
; *******************************************************************************
; 
;  *  randomx()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_randomx" 
      ((x (:pointer :double-float))) 
  :double-float
   () )

; ******************************************************************************
; *                              Relational operator                             *
; ******************************************************************************
;       relational operator      

(def-mactype :relop (find-mactype ':signed-integer))

(defconstant $GREATERTHAN 0)
(defconstant $LESSTHAN 1)
(defconstant $EQUALTO 2)
(defconstant $UNORDERED 3)

; 
; 	 *  relation()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MathLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_relation" 
      ((x :double-float) (y :double-float)) 
  :signed-integer
   () )

; *******************************************************************************
; *                                                                               *
; *                         Binary to decimal conversions                         *
; *                                                                               *
; *   SIGDIGLEN   Significant decimal digits.                                     *
; *                                                                               *
; *   decimal     A record which provides an intermediate unpacked form for       *
; *               programmers who wish to do their own parsing of numeric input   *
; *               or formatting of numeric output.                                *
; *                                                                               *
; *   decform     Controls each conversion to a decimal string.  The style field  *
; *               is either FLOATDECIMAL or FIXEDDECIMAL. If FLOATDECIMAL, the    *
; *               value of the field digits is the number of significant digits.  *
; *               If FIXEDDECIMAL value of the field digits is the number of      *
; *               digits to the right of the decimal point.                       *
; *                                                                               *
; *   num2dec     Converts a double_t to a decimal record using a decform.        *
; *   dec2num     Converts a decimal record d to a double_t value.                *
; *   dec2str     Converts a decform and decimal to a string using a decform.     *
; *   str2dec     Converts a string to a decimal struct.                          *
; *   dec2d       Similar to dec2num except a double is returned (68k only).      *
; *   dec2f       Similar to dec2num except a float is returned.                  *
; *   dec2s       Similar to dec2num except a short is returned.                  *
; *   dec2l       Similar to dec2num except a long is returned.                   *
; *                                                                               *
; *******************************************************************************

; $IFC TARGET_CPU_PPC 
(defconstant $SIGDIGLEN 36)
#|                                              ; $ELSEC
; $IFC TARGET_CPU_68K 
(defconstant $SIGDIGLEN 20)
; $ELSEC
; $IFC TARGET_CPU_X86 
(defconstant $SIGDIGLEN 20)
; $ENDC
; $ENDC
 |#                                             ; $ENDC
(defconstant $DECSTROUTLEN 80)

(def-mactype :decimalkind (find-mactype ':unsigned-byte))
(defconstant $FLOATDECIMAL 0)
(defconstant $FIXEDDECIMAL 1)

(defrecord decimal 
   (sgn (:unsigned-integer :range 0 1))         ;  sign 0 for +, 1 for -  
   (exp :signed-integer)
   (sig (:string #$SIGDIGLEN))
   )

(defrecord decform 
   (style :unsigned-byte)
   (digits :signed-integer)
   )

; 
;  *  num2dec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_num2dec" 
      ((f (:pointer :decform)) (x :double-float) (d (:pointer :decimal))) 
  nil
   () )

; 
;  *  dec2num()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_dec2num" 
      ((d (:pointer :decimal))) 
  :double-float
   () )

; 
;  *  dec2str()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_dec2str" 
      ((f (:pointer :decform)) (d (:pointer :decimal)) (s :pointer)) 
  nil
   () )

; 
;  *  str2dec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_str2dec" 
      ((s :pointer) (ix (:pointer :signed-integer)) (d (:pointer :decimal)) (vp (:pointer :signed-integer))) 
  nil
   () )

#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  dec2d()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_dec2d" 
      ((d (:pointer :decimal))) 
  :double-float
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K
; 
;  *  dec2f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_dec2f" 
      ((d (:pointer :decimal))) 
  :single-float
   () )

; 
;  *  dec2s()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_dec2s" 
      ((d (:pointer :decimal))) 
  :signed-integer
   () )

; 
;  *  dec2l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_dec2l" 
      ((d (:pointer :decimal))) 
  :signed-long
   () )

; *******************************************************************************
; *                                                                               *
; *                         68k-only Transfer Function Prototypes                 *
; *                                                                               *
; *******************************************************************************
#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  x96tox80()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_x96tox80" 
      ((x (:pointer :float96)) (x80 (:pointer :float80))) 
  nil
   () )

; 
;  *  x80tox96()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_x80tox96" 
      ((x80 (:pointer :float80)) (x (:pointer :float96))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K
; $ENDC
; *******************************************************************************
; *                                                                               *
; *                         PowerPC-only Function Prototypes                      *
; *                                                                               *
; *******************************************************************************

; $IFC TARGET_CPU_PPC 

; 
;  *  cosl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_cosl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  sinl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_sinl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  tanl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_tanl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  acosl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_acosl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  asinl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_asinl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  atanl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_atanl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  atan2l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_atan2l" 
      ((y :longdouble) (x :longdouble)) 
  :longdouble
   () )

; 
;  *  coshl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_coshl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  sinhl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_sinhl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  tanhl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_tanhl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  acoshl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_acoshl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  asinhl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_asinhl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  atanhl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_atanhl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  expl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_expl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  expm1l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_expm1l" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  exp2l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_exp2l" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  frexpl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_frexpl" 
      ((x :longdouble) (exponent (:pointer :signed-long))) 
  :longdouble
   () )

; 
;  *  ldexpl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ldexpl" 
      ((x :longdouble) (n :signed-long)) 
  :longdouble
   () )

; 
;  *  logl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_logl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  log1pl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_log1pl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  log10l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_log10l" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  log2l()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_log2l" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  logbl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_logbl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  scalbl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_scalbl" 
      ((x :longdouble) (n :signed-long)) 
  :longdouble
   () )

; 
;  *  fabsl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fabsl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  hypotl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_hypotl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  powl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_powl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  sqrtl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_sqrtl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  erfl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_erfl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  erfcl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_erfcl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  gammal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_gammal" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  lgammal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_lgammal" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  ceill()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 2.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ceill" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  floorl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_floorl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  rintl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_rintl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  nearbyintl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_nearbyintl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  rinttoll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_rinttoll" 
      ((x :longdouble)) 
  :signed-long
   () )

; 
;  *  roundl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_roundl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  roundtoll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_roundtoll" 
      ((x :longdouble)) 
  :signed-long
   () )

; 
;  *  truncl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_truncl" 
      ((x :longdouble)) 
  :longdouble
   () )

; 
;  *  remainderl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_remainderl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  remquol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_remquol" 
      ((x :longdouble) (y :longdouble) (quo (:pointer :signed-long))) 
  :longdouble
   () )

; 
;  *  copysignl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_copysignl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  fdiml()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fdiml" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  fmaxl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fmaxl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; 
;  *  fminl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_fminl" 
      ((x :longdouble) (y :longdouble)) 
  :longdouble
   () )

; $IFC UNDEFINED __NOEXTENSIONS__ 
; 
;  *  relationl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap-inline "_relationl" 
      ((x :longdouble) (y :longdouble)) 
  :signed-integer
   () )

; 
;  *  num2decl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_num2decl" 
      ((f (:pointer :decform)) (x :longdouble) (d (:pointer :decimal))) 
  nil
   () )

; 
;  *  dec2numl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_dec2numl" 
      ((d (:pointer :decimal))) 
  :longdouble
   () )

; $ENDC
; $ENDC                                         ; TARGET_CPU_PPC
; $ENDC                                         ; TARGET_OS_MAC

; $IFC UNDEFINED __NOEXTENSIONS__ 
;     
;         MathLib v2 has two new transfer functions: x80tod and dtox80.  They can 
;         be used to directly transform 68k 80-bit extended data types to double
;         and back for PowerPC based machines without using the functions
;         x80told or ldtox80.  Double rounding may occur. 
;     
; 
;  *  x80tod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_x80tod" 
      ((x80 (:pointer :float80))) 
  :double-float
   () )

; 
;  *  dtox80()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_dtox80" 
      ((x (:pointer :double-float)) (x80 (:pointer :float80))) 
  nil
   () )

; $IFC TARGET_CPU_PPC 
; 
;  *  x80told()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_x80told" 
      ((x80 (:pointer :float80)) (x (:pointer :longdouble))) 
  nil
   () )

; 
;  *  ldtox80()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MathLib 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_ldtox80" 
      ((x (:pointer :longdouble)) (x80 (:pointer :float80))) 
  nil
   () )

; $ENDC                                         ; TARGET_CPU_PPC
; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := fpIncludes

; $ENDC                                         ; __FP__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'fp)#|
; Warning: Did not recognize these types or records: (longdouble)
|#