(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:vDSP.p"
; at Wednesday May 1,2002 2:42:59 pm.
; 
;      File:       vDSP.p
;  
;      Contains:   AltiVec DSP Interfaces
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __VDSP__
; $SETC __VDSP__ := 1

; $I+
; $SETC vDSPIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :dspcomplexptr (find-mactype '(:pointer :dspcomplex)))
(defrecord DSPComplex 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (real :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (imag :single-float)
   )

(def-mactype :dspsplitcomplexptr (find-mactype '(:pointer :dspsplitcomplex)))
(defrecord DSPSplitComplex 
   (realp (:pointer :single-float))
   (imagp (:pointer :single-float))
   )

(def-mactype :fftsetup (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :fftsetupptr (find-mactype '(:pointer :pointer)));  when a VAR xx:FFTSetup parameter can be nil, it is changed to xx: FFTSetupPtr 
(def-mactype :fftdirection (find-mactype ':signed-long))

(defconstant $kFFTDirection_Forward 1)
(defconstant $kFFTDirection_Inverse -1)

(def-mactype :fftradix (find-mactype ':signed-long))

(defconstant $kFFTRadix2 0)
(defconstant $kFFTRadix3 1)
(defconstant $kFFTRadix5 2)

; 	
; 	
; 	    The criteria to invoke the PowerPC vector implementation is subject to     
; 	    change and become less restrictive in the future.                          
; 	
; 		
; 	
; 	
; 	    Functions create_fftsetup and destroy_fftsetup.
; 	
; 	    create_fftsetup will allocate memory and setup a weight array used by      
; 	    the FFT. The call destroy_fftsetup will free the array.                    
; 	
; 		
; 
; 	 *  create_fftsetup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in vecLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_create_fftsetup" 
      ((log2n :unsigned-long) (radix :signed-long)) 
  :pointer
   () )

; 
;  *  destroy_fftsetup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_destroy_fftsetup" 
      ((setup :pointer)) 
  nil
   () )

; 
; 
;     Functions ctoz and ztoc.
;     
;     ctoz converts a complex array to a complex-split array
;     ztoc converts a complex-split array to a complex array
;     
;     Criteria to invoke PowerPC vector code:    
;         1. size > 3
;         2. strideC = 2
;         3. strideZ = 1
;         4. Z.realp and Z.imagp are relatively aligned.
;         5. C is 8-byte aligned if Z.realp and Z.imagp are 4-byte- aligned
;            or C is 16-byte aligned if Z.realp and Z.imagp are at least
;            8-byte aligned.
; 
; 
; 
;  *  ctoz()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ctoz" 
      ((C (:pointer :dspcomplex)) (strideC :signed-long) (Z (:pointer :dspsplitcomplex)) (strideZ :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
;  *  ztoc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ztoc" 
      ((Z (:pointer :dspsplitcomplex)) (strideZ :signed-long) (C (:pointer :dspcomplex)) (strideC :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Functions fft_zip and fft_zipt 
;     
;     In-place Split Complex Fourier Transform with or without temporary memory.
;             
;       Criteria to invoke PowerPC vector code:    
;         
;         1. ioData.realp and ioData.imagp must be 16-byte aligned.
;         2. stride = 1
;         3. 2 <= log2n <= 20
;         4. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  Direction can be either
;       kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft_zip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zip" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (stride :signed-long) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft_zipt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zipt" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (stride :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;      Functions fft_zop and fft_zopt
;      
;      Out-of-place Split Complex Fourier Transform with or without temporary
;      memory
;             
;       Criteria to invoke PowerPC vector code:  
;         
;         1. signal.realp and signal.imagp must be 16-byte aligned.
;         2. signalStride = 1
;         3. result.realp and result.imagp must be 16-byte aligned.
;         4. strideResult = 1
;         5. 2 <= log2n <= 20
;         6. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  Direction can be either
;       kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft_zop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zop" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStride :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft_zopt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zopt" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStride :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft_zrip and fft_zript
;     
;     In-Place Real Fourier Transform with or without temporary memory,
;     split Complex Format
;             
;       Criteria to invoke PowerPC vector code:    
;         1. ioData.realp and ioData.imagp must be 16-byte aligned.
;         2. stride = 1
;         3. 3 <= log2n <= 13
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  Direction can be either
;       kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft_zrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zrip" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (stride :signed-long) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft_zript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zript" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (stride :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft_zrop and fft_zropt
;     
;     Out-of-Place Real Fourier Transform with or without temporary memory,
;     split Complex Format
;             
;       Criteria to invoke PowerPC vector code:  
;         1. signal.realp and signal.imagp must be 16-byte aligned.
;         2. signalStride = 1
;         3. result.realp and result.imagp must be be 16-byte aligned.
;         4. strideResult = 1
;         5. 3 <= log2n <= 13
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  Direction can be either
;       kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft_zrop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zrop" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStride :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft_zropt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft_zropt" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStride :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2n :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft2d_zip and fft2d_zipt
;     
;     In-place two dimensional Split Complex Fourier Transform with or without
;     temporary memory
;             
;       Criteria to invoke PowerPC vector code:  
;         1. ioData.realp and ioData.imagp must be 16-byte aligned.
;         2. strideInRow = 1;
;         3. strideInCol must be a multiple of 4
;         4. 2 <= log2nInRow <= 12
;         5. 2 <= log2nInCol <= 12
;         6. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  ( log2n = log2nInRow + log2nInCol ) 
;       Direction can be either kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft2d_zip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zip" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (strideInRow :signed-long) (strideInCol :signed-long) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft2d_zipt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zipt" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (strideInRow :signed-long) (strideInCol :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft2d_zop and fft2d_zopt
;     
;     Out-of-Place two dimemsional Split Complex Fourier Transform with or
;     without temporary memory
;             
;       Criteria to invoke PowerPC vector code:  
;         
;         1. signal.realp and signal.imagp must be 16-byte aligned.
;         2. signalStrideInRow = 1;
;         3. signalStrideInCol must be a multiple of 4
;         4. result.realp and result.imagp must be 16-byte aligned.
;         5. strideResultInRow = 1;
;         6. strideResultInCol must be a multiple of 4
;         7. 2 <= log2nInRow <= 12
;         8. 2 <= log2nInCol <= 12
;         9. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
; 
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  ( log2n = log2nInRow + log2nInCol ) 
;       Direction can be either kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft2d_zop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zop" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStrideInRow :signed-long) (signalStrideInCol :signed-long) (result (:pointer :dspsplitcomplex)) (strideResultInRow :signed-long) (strideResultInCol :signed-long) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (flag :signed-long)) 
  nil
   () )

; 
;  *  fft2d_zopt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zopt" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStrideInRow :signed-long) (signalStrideInCol :signed-long) (result (:pointer :dspsplitcomplex)) (strideResultInRow :signed-long) (strideResultInCol :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (flag :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft2d_zrip and fft2d_zript
;     
;     In-place two dimensional Real Fourier Transform with or without temporary
;     memory, Split Complex Format
;             
;       Criteria to invoke PowerPC vector code:  
;         1. ioData.realp and ioData.imagp must be 16-byte aligned.
;         2. strideInRow = 1;
;         3. strideInCol must be a multiple of 4
;         4. 3 <= log2nInRow <= 12
;         5. 3 <= log2nInCol <= 13
;         6. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
; 
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  ( log2n = log2nInRow + log2nInCol ) 
;       Direction can be either kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft2d_zrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zrip" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (strideInRow :signed-long) (strideInCol :signed-long) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
;  *  fft2d_zript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zript" 
      ((setup :pointer) (ioData (:pointer :dspsplitcomplex)) (strideInRow :signed-long) (strideInCol :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (direction :signed-long)) 
  nil
   () )

; 
; 
;     Functions fft2d_zrop and fft2d_zropt
;     
;     Out-of-Place Two-Dimemsional Real Fourier Transform with or without
;     temporary memory, Split Complex Format
;             
;       Criteria to invoke PowerPC vector code:  
;         1. signal.realp and signal.imagp must be 16-byte aligned.
;         2. signalStrideInRow = 1;
;         3. signalStrideInCol must be a multiple of 4
;         4. result.realp and result.imagp must be 16-byte aligned.
;         5. strideResultInRow = 1;
;         6. strideResultInCol must be a multiple of 4
;         7. 3 <= log2nInRow <= 12
;         8. 3 <= log2nInCol <= 13
;         9. bufferTemp.realp and bufferTemp.imagp must be 16-byte aligned.
; 
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The size of temporary memory for each part
;       is the lower value of 4*n and 16k.  ( log2n = log2nInRow + log2nInCol ) 
;       Direction can be either kFFTDirection_Forward or kFFTDirection_Inverse.
; 
; 
; 
;  *  fft2d_zrop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zrop" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStrideInRow :signed-long) (signalStrideInCol :signed-long) (result (:pointer :dspsplitcomplex)) (strideResultInRow :signed-long) (strideResultInCol :signed-long) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (flag :signed-long)) 
  nil
   () )

; 
;  *  fft2d_zropt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_fft2d_zropt" 
      ((setup :pointer) (signal (:pointer :dspsplitcomplex)) (signalStrideInRow :signed-long) (signalStrideInCol :signed-long) (result (:pointer :dspsplitcomplex)) (strideResultInRow :signed-long) (strideResultInCol :signed-long) (bufferTemp (:pointer :dspsplitcomplex)) (log2nInCol :unsigned-long) (log2nInRow :unsigned-long) (flag :signed-long)) 
  nil
   () )

; 
; 
;     Function conv
;     
;     Floating Point Convolution and Correlation
;       
;       Criteria to invoke PowerPC vector code:  
;         1. signal and result must have relative alignement.
;         2. 4 <= lenFilter <= 256
;         3. lenResult > 36
;         4. signalStride = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  strideFilter can be positive for
;       correlation or negative for convolution.
; 
; 
; 
;  *  conv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_conv" 
      ((signal (:pointer :single-float)) (signalStride :signed-long) (filter (:pointer :single-float)) (strideFilter :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (lenResult :signed-long) (lenFilter :signed-long)) 
  nil
   () )

; 
; 
;     Function vadd
;     
;     Floating Point Add
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1 and input2 and result are all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vadd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_vadd" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vsub
;     
;      Floating Point Substract
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1 and input2 and result are all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vsub()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_vsub" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vmul
;     
;     Floating Point Multiply
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1 and input2 and result must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vmul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_vmul" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vsmul
;     
;     Floating Point - Scalar Multiply
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1 and result are all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vsmul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_vsmul" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vsq
;     
;     Floating Point Square
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input and result are relatively aligned.
;         2. size >= 8
;         3. strideInput = 1
;         4. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vsq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_vsq" 
      ((input (:pointer :single-float)) (strideInput :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vssq
;     
;     Floating Point Signed Square
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input and result must be all relatively aligned.
;         2. size >= 8
;         3. strideInput = 1
;         4. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vssq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_vssq" 
      ((input (:pointer :single-float)) (strideInput :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function dotpr
;     
;     Floating Point Dot product
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1 and input2 are relatively aligned.
;         2. size >= 20
;         3. stride1 = 1
;         4. stride2 = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  dotpr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_dotpr" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :single-float)) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function vam
;     
;     Floating Point vadd and Multiply
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1, input2, input_3 and result are all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. stride_3 = 1
;         6. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  vam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_vam" 
      ((input1 (:pointer :single-float)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (input3 (:pointer :single-float)) (stride3 :signed-long) (result (:pointer :single-float)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zconv
;     
;     Split Complex Convolution and Correlation
;       
;       Criteria to invoke PowerPC vector code:  
;         1. signal->realp, signal->imagp, result->realp, result->imagp
;            must be relatively aligned.
;         2. 4 <= lenFilter <= 128
;         3. lenResult > 20
;         4. signalStride = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  strideFilter can be positive for correlation
;       or negative for convolution
; 
; 
; 
;  *  zconv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zconv" 
      ((signal (:pointer :dspsplitcomplex)) (signalStride :signed-long) (filter (:pointer :dspsplitcomplex)) (strideFilter :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (lenResult :signed-long) (lenFilter :signed-long)) 
  nil
   () )

; 
; 
;     Function zvadd
;     
;     Split Complex vadd
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp,
;            result.realp, result.imagp must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zvadd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zvadd" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zvsub
;     
;     Split Complex Substract
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp,
;            result.realp, result.imagp must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zvsub()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zvsub" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zvmul
;     
;     Split Complex Multiply
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp,
;            result.realp, result.imagp must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
; 
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.  The conjugate value can be 1 or -1.
; 
; 
; 
;  *  zvmul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zvmul" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long) (conjugate :signed-long)) 
  nil
   () )

; 
; 
;     Function zdotpr
;     
;     Split Complex Dot product
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp are all
;            relatively aligned.
;         2. size >= 20
;         3. stride1 = 1
;         4. stride2 = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zdotpr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zdotpr" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zidotpr
;     
;     Split Complex Inner Dot product
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp must be
;            all relatively aligned.
;         2. size >= 20
;         3. stride1 = 1
;         4. stride2 = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zidotpr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zidotpr" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zrdotpr
;     
;     Split Complex - Real Dot product
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2 are must be relatively aligned.
;         2. size >= 16
;         3. stride1 = 1
;         4. stride2 = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zrdotpr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_zrdotpr" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zvcma
;     
;     Split Complex Conjugate Multiply And vadd
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2.realp, input2.imagp,
;           input_3.realp, input_3.imagp, result.realp, result.imagp
;           must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. stride_3 = 1
;         6. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zvcma()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_zvcma" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :dspsplitcomplex)) (stride2 :signed-long) (input3 (:pointer :dspsplitcomplex)) (stride3 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zrvadd
;     
;     Split Complex - Real Add
;       
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2, result.realp, result.imagp
;            are all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zrvadd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_zrvadd" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zrvsub
;     
;     Split Complex - Real Substract
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2, result.realp, result.imagp
;            must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zrvsub()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_zrvsub" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; 
; 
;     Function zrvmul
;     
;     Split Complex - Real Multiply
;     
;       Criteria to invoke PowerPC vector code:  
;         1. input1.realp, input1.imagp, input2, result.realp, result.imagp
;            must be all relatively aligned.
;         2. size >= 8
;         3. stride1 = 1
;         4. stride2 = 1
;         5. strideResult = 1
;       
;       If any of the above criteria are not satisfied, the PowerPC scalor code
;       implementation will be used.
; 
; 
; 
;  *  zrvmul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in vecLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but vecLib is compatible with Carbon
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_zrvmul" 
      ((input1 (:pointer :dspsplitcomplex)) (stride1 :signed-long) (input2 (:pointer :single-float)) (stride2 :signed-long) (result (:pointer :dspsplitcomplex)) (strideResult :signed-long) (size :unsigned-long)) 
  nil
   () )

; $IFC UNDEFINED USE_NONE_APPLE_STANDARD_DATATYPES 
; $SETC USE_NONE_APPLE_STANDARD_DATATYPES := 1 
; $ENDC

; $IFC USE_NONE_APPLE_STANDARD_DATATYPES 

(defconstant $FFT_FORWARD 1)
(defconstant $FFT_INVERSE -1)

(defconstant $FFT_RADIX2 0)
(defconstant $FFT_RADIX3 1)
(defconstant $FFT_RADIX5 2)

(%define-record :complex (find-record-descriptor :dspcomplex))
(def-mactype :complexptr (find-mactype '(:pointer :dspcomplex)))
(%define-record :complex_split (find-record-descriptor :dspsplitcomplex))
(def-mactype :complex_splitptr (find-mactype '(:pointer :dspsplitcomplex)))
; $ENDC                                         ; USE_NONE_APPLE_STANDARD_DATATYPES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := vDSPIncludes

; $ENDC                                         ; __VDSP__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'vDSP)