(in-package :ccl)
;; 01/06/03 akh event-wdef ignores error when cancel tries to set default directory - may error on OSX
;;  when the chosen thing is an alias to a folder
;; --- 5.0b3
;; 12/20/02 akh also tolerate file type "????" in some cases.
;; ------ 4.4b5
;; clear reply record for NavPutFile
;; forget restoring-dead-keys - busted on Jaguar and doesn't seem to be needed anyway
;; forget fsref for now
;; parse-doclist gets an exists arg - nil from choose-new-file, also want-dir arg passed on to %path-from-fsref
;; ------- 4.4b4
;; akh nav-choose-file-dialog tolerates 0 mac-file-type in some cases
;; -------- 4.4b3
;; akh use probe-file instead of full-pathname to resolve aliases
;;----------------- 4.4b2
;; 06/25/02 akh trying to look at *see-untyped-osx-files*
;; 06/13/01 akh see advise
;;---------- 4.4b1
;; 04/30/01 akh fix calls to aecreatedesc for osx
;; 03/12/01 akh tweak def-ccl-pointers for carbon-compat so NavigationLib not added to search-path
;; carbon goo for aedesc 
;;; 4.3.1b1
;; 02/19/00 akh - lose all this upp stuff - never needed in the first place??
;; 12/26/99 akh add function nav-services-available-p
;; 08/08/99 akh add setting default dir to event-wdef when cancel
;; ---------- 4.3f1c1
;; 07/12/99 akh set-default-dialog-options takes keyword :clientname
;; ----------- 4.3b3
;; 04/04/99 akh don't set default-directory unless it's really a directory
;; ------------- 4.3b1
;; 03/01/99 akh change to avoid compiler-warnings if use new keys - no mo advise of the choosers
;; 02/21/98 akh add allow-multiple-files keyword to nav-choose-file-dialog, defaults to  *choose-allow-multiple-files*
;; 02/19/99 akh fix so if nav-services not available we don't pass thru new keywords to old functions
;; 02/19/99 akh more enhancements from Toomas Altosaar - esp extended-reply see below
;; 02/18/99 akh more options  :window-title etal - from Toomas Altosaar 
;; 02/18/99 akh added nav-choose-new-directory-dialog
;; 02/16/99 akh some defense against errors of one sort or another, try making room on memfull
;; 02/15/99 akh disallow multiple files (from David L.), disallow unadvising the choose-xx fns
;; 02/14/99 akh ignore-errors in case Navigationlib not there
;; 02/08/99 akh do plug name into dialog in choose-new-file-dialog 
;; 02/10/99 akh no mo hiding-windoids


;; Copyright 1999-2001 Digitool, Inc.
#|
The user now has the possibilty to supply two new keywords to
choose-new-file-dialog:

1). :extended-reply-p (default value is nil)
If set to t it indicates that more details from the reply record passed to
navigational services will be returned from the call to
choose-new-file-dialog. If t then a second value is returned - a (key-value
pair list) that can be analyzed using (getf place indicator). The key-value
list looks like:

(:REPLACING-P NIL :STATIONERY-P NIL :TRANSLATION-NEEDED-P NIL
:FILE-TRANSLATION :NOT-IMPLEMENTED-YET :KEYSCRIPT 0)

as per

http://developer.apple.com/techpubs/macos8/Files/NavigationServices/ProgWithNavS
rvcs1.1/NavSvcs.22.html#pgfId=35605


2). :format-query-p (default value is nil)
If set to t causes a popup menu to be included in the dialog to enable
document format selection. The boolean value returned can be read from the
key-value list with the key as :STATIONERY-P. If format-query-p is called
with a value of t but extended-reply-p is unspecified or nil, then an
extended reply is still returned as a second value.
|#
(in-package :traps)
(eval-when (:compile-toplevel :load-toplevel :execute)
(deftrap-inline "_NavChooseFile" 
      ((defaultLocation (:pointer :aedesc))
       (reply (:pointer :navreplyrecord))
       (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer) (previewProc :pointer)
       (filterProc :pointer) (typeList (:handle :navtypelist))
       (callBackUD :pointer)) 
  :signed-integer
   () )

(deftrap-inline "_NavChooseFolder" 
      ((defaultLocation (:pointer :aedesc)) 
       (reply (:pointer :navreplyrecord)) 
       (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer) 
       (filterProc :pointer) 
       (callBackUD :pointer)) 
  :signed-integer
   () )

(deftrap-inline "_NavPutFile" 
      ((defaultLocation (:pointer :aedesc))
       (reply (:pointer :navreplyrecord)) (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer) (fileType :ostype)
       (fileCreator :ostype) 
       (callBackUD :pointer)) 
  :signed-integer
   () )
)


(in-package :ccl)
(eval-when (:compile-toplevel :execute)
  (ignore-errors (add-to-shared-library-search-path "NavigationLib" t)))

(defvar *nav-services-available* nil)
;; P.S. navservices sucks with the version of the lib that I have with OS 7.6.
;;      Choose-new-file-dialog crashes and choose-file-dialog only shows files with creator :ccl2

(defun nav-services-available-p ()
  *nav-services-available*)

(defvar *my-nav-ud* 999)  ;; sometimes (old interfaces) supposed to be :long, sometime supposed to be :pointer
(def-ccl-pointers nav-avail ()
  (setq *nav-services-available* nil)
  (let ((ep #-carbon-compat (get-shared-library "NavigationLib" :error-p nil) #+carbon-compat t))
    ;(setq *nav-services-available* nil)
    #+carbon-compat (setq *my-nav-ud* (%null-ptr)) ; ??
    #-carbon-compat (setq *my-nav-ud* (%null-ptr)) ; huh
    
    (when (and ep)
      #-carbon-compat (add-to-shared-library-search-path "NavigationLib")
      ;; dont do this twice if appearance manager is not available - else crash
      (cond 
       ((osx-p)(setq *nav-services-available* t))
       (t
        (setq *nav-services-available* (#_NavServicesCanRun)) ;; the documentation spells it differently??      
        (when *nav-services-available* 
          (let ((result (#_navload)))
            (unless (eq result #$noerr) 
              (setq *nav-services-available* nil)
              (error "Can't load Navigation Services. Errnum is ~S" result)))))))))




(defvar *event-ptr* nil)
(defvar *choose-allow-multiple-files* nil)  ; should export this
(export '(*choose-allow-multiple-files*) (find-package :ccl))


(eval-when (:compile-toplevel :execute)  ; from choose-file-dialogs
(defmacro restoring-dead-keys (&body body)
  `(progn ,@body))
#|
    (let ((dead-state (gensym)))
      `(let ((,dead-state (get-dead-keys-state)))
         (unwind-protect
           (progn ,@body)
           (set-dead-keys ,dead-state)))))
|#

  ;; because windoids in the nwo seem to mess up sfgetfile and friends
  #|
  (defmacro hiding-windoids (&body body)
    (let ((the-windoids (gensym)))
      `(let ((,the-windoids nil))
         (unwind-protect
           (progn
             (map-windoids #'(lambda (w)(window-hide w)(push w ,the-windoids)))
             (progn ,@body))
           (dolist (w ,the-windoids)
             (window-show w))))))
  |#
)

#|

(defrecord NavReplyRecord 
   (version :unsigned-integer)
   (validRecord :boolean)                       ;   open/save: true if the user confirmed a selection, false on cancel  
   (replacing :boolean)                         ;   save: true if the user is overwriting an existing object for save  
   (isStationery :boolean)                      ;   save: true if the user wants to save an object as stationery  
   (translationNeeded :boolean)                 ;   save: translation is 'needed', open: translation 'has taken place'  
   (selection :aedesc)                          ;   open/save: list of AppleEvent descriptors of the chosen object(s)  
   (keyScript :signed-integer)                  ;   open/save: script in which the name of each item in 'selection' is to be displayed  
   (fileTranslation (:handle :filetranslationspec));   open/save: list of file translation specs of the chosen object(s), if translation is needed  
   (reserved1 :unsigned-long)
   (reserved (:array :character 231 :packed))
   )
(deftrap-inline "_NavChooseFile" 
      ((defaultLocation (:pointer :aedesc)) (reply (:pointer :navreplyrecord))
       (dialogOptions (:pointer :navdialogoptions)) (eventProc :pointer) (previewProc :pointer) 
       (filterProc :pointer) (typeList (:handle :navtypelist)) (callBackUD :unsigned-long)) 
      :signed-integer
   () )

(defrecord NavTypeList 
   (componentSignature :ostype)
   (reserved :signed-integer)
   (osTypeCount :signed-integer)
   (OSType (:array :ostype 1))
   )

(defrecord NavDialogOptions 
   (version :unsigned-integer)
   (dialogOptionFlags :unsigned-long)           ;   option flags for affecting the dialog's behavior  
   (location :point)                            ;   top-left location of the dialog, or (-1,-1) for default position  
   (clientName (:string 255))
   (windowTitle (:string 255))
   (actionButtonLabel (:string 255))            ;   label of the default button (or null string for default)  
   (cancelButtonLabel (:string 255))            ;   label of the cancel button (or null string for default)  
   (savedFileName (:string 255))                ;   default name for text box in  (or null string for default)  
   (message (:string 255))                      ;   custom message prompt (or null string for default)  
   (preferenceKey :unsigned-long)               ;   a key for to managing preferences for using multiple utility dialogs  
   (popupExtension :handle)                     ;   extended popup menu items, an array of NavMenuItemSpecs  
   (reserved (:array :character 494 :packed))
   )
|#



#|
(defun set-default-dialog-options (options)
  (#_navgetDefaultDialogOptions options)
  ;; allow only single selection
  (when (not *choose-allow-multiple-files*)
    (rset options :navDialogOptions.dialogOptionFlags
          (logandc2 (rref options :navDialogOptions.dialogOptionFlags)
                    #$kNavAllowMultipleFiles))))
|#

(defun set-default-dialog-options (options &key location windowTitle
                                           actionButtonLabel cancelButtonLabel
                                           savedFileName message (NavNoTypePopup t)
                                           allowMultipleFiles
                                           clientname)
  (let ((res (#_navgetDefaultDialogOptions options)))
    (if (neq res #$noerr)
      (error "navgetdefaultdialogoptions is unhappy")))
  ;; allow only single selection
  (when (not allowMultipleFiles) ;*choose-allow-multiple-files*)
    (rset options :navDialogOptions.dialogOptionFlags
          (logandc2 (rref options :navDialogOptions.dialogOptionFlags)
                    #$kNavAllowMultipleFiles)))
  (when NavNoTypePopup
    (rset options :navDialogOptions.dialogOptionFlags
          (logior (rref options :navDialogOptions.dialogOptionFlags)
                  #$kNavNoTypePopup)))
  (when location
    (setf (pref options :navdialogoptions.location) location))
  (when windowTitle
    (setf (pref options :navdialogoptions.windowTitle) windowTitle))
  (when actionButtonLabel
    (setf (pref options :navdialogoptions.actionbuttonlabel) actionButtonLabel))
  (when cancelButtonLabel
    (setf (pref options :navdialogoptions.cancelButtonLabel) cancelButtonLabel))
  (when savedFileName
    (setf (pref options :navdialogoptions.savedFileName) savedFileName))
  (when message
    (setf (pref options :navdialogoptions.message) message))
  (when clientname 
    (setf (pref options :navdialogoptions.clientname) clientname)))

(defvar *see-untyped-osx-files* t)
  
(defun nav-choose-file-dialog (&key directory
                                    mac-file-type
                                    mac-file-creator 
                                    (button-string "Open")
                                    (cancel-button-string "Cancel")
                                    (window-title "Choose a File")
                                    (allow-multiple-files *choose-allow-multiple-files*)
                                    prompt
                                    window-position
                                    FILTER  ;; for CLIM??
                                    &aux (ntypes -1) (offset 0))
  
  ;(declare (ignore mac-file-creator))
  ;(declare (ignore button-string)) ;; put in actionbuttonlabel in dialogoptions
  (when directory (setq directory (probe-file directory))) ;; resolve aliases
  (when (or (and directory
                 (pathname-directory directory)
                 (setq directory (directory-namestring directory)))
            (setq directory (choose-file-default-directory)))
    (set-choose-file-default-directory-2 directory)
    )
  ;; something like this to allow looking at OSX .h and .make files
  (when *see-untyped-osx-files* 
    (cond ((and (not (listp mac-file-type))(equalp mac-file-type "TEXT")) ;; i.e just looking for text files 
           (setq mac-file-type (list #.(ff-long-to-ostype 0) "????" mac-file-type)))  ;; aka (ff-long-to-ostype 0)
          ((and (consp mac-file-type) (member "TEXT" mac-file-type :test #'equalp))  ;; for cmd-y
           (setq mac-file-type (list* #.(ff-long-to-ostype 0) "????"  mac-file-type)))))
  (if mac-file-type
    (setq ntypes (if (listp mac-file-type) (length mac-file-type) 1)))
  (progn ;restoring-dead-keys
    (let ((size (+ 8 (%ilsl 2 (%imax 1 ntypes))))
          (tphandle)
          retried)
      (with-aedescs (aedesc)
        (rlet ((fsptr :fsspec))          
          (let ((size (record-length :fsspec)))
            (ae-error (#_aecreatedesc #$typeFSS fsptr size aedesc)))        
          (when directory 
            #-carbon-compat
            (make-fsspec-from-directory-hdl 
             (pref aedesc aedesc.datahandle)
             directory)
            #+carbon-compat
            (make-fsspec-from-directory-aedesc aedesc directory)
            )
          (unwind-protect
            (with-port %original-temp-port%  ;; work around OSX problem that I do not understand
              (setq tphandle (#_newhandle :errchk size))
              (when (%null-ptr-p tphandle)(error "Not enough room for handle size ~s" size))
              (with-dereferenced-handles ((tp tphandle))
                (%put-ostype tp (or mac-file-creator (application-file-creator *application*)) 0) ;; ?? - use dialog options to ignore this - seems to be ignored
                (%put-word tp ntypes 6) 
                (setq offset 8)
                (if (listp mac-file-type)
                  (dolist (type mac-file-type)
                    (%put-ostype tp type offset)
                    (setq offset (%i+ offset 4)))
                  (%put-ostype tp mac-file-type offset))
                (rlet ((reply :navreplyrecord)
                       (options :navdialogoptions))
                  (set-default-dialog-options
                   options  :location window-position :windowtitle window-title
                   :actionbuttonlabel button-string 
                   :cancelbuttonlabel cancel-button-string
                   ;:navnotypepopup nil
                   :message prompt
                   :allowMultipleFiles allow-multiple-files)
                  (unwind-protect
                    (with-foreign-window
                      (prog () ;hiding-windoids ;; my goodness aren't we old fashioned
                        again
                        (let ((result (#_navchoosefile (if directory aedesc *null-ptr*)
                                       ;; navgetfile will do the pop up but fat lotta good it does for accesssing OSX .h files
                                       ;; need translators - thanks a bunch, MPW pukes too.
                                       reply 
                                       options ;(if button-string options *null-ptr*) ;dialogoptions
                                       event-wdef ;(or *event-ptr* *null-ptr*) ;eventproc
                                       *null-ptr* ;previewproc
                                       (OR FILTER *null-ptr*) ;filterproc
                                       (if (or (null mac-file-type)(eq ntypes 0)) *null-ptr* tphandle) 
                                       *my-nav-ud*))) ; callbackud
                          (let ((foo (check-nav-result result retried)))
                            (when (and (eq foo :try-again)(null retried))
                              (setq retried t)
                              (go again)))
                          (when (eq result $noerr)
                            (unless (pref reply navreplyrecord.validrecord)
                              (throw-cancel :cancel))
                            (let ((selection (pref reply navreplyrecord.selection))
                                  result)
                              (setq result (parse-doclist selection))
                              (when result
                                (set-choose-file-default-directory-2 
                                 (if (consp result)(car result) result)))
                              (return result))))))
                    ;; is this kosher given a stack allocated replyrecord??????
                    (#_navdisposereply reply)))))
            (when (and tphandle (not (%null-ptr-p tphandle)))(#_disposehandle tphandle))))))))

(defun check-nav-result (result &optional retried)
  (unless (eq result #$noerr)
    (if (eq result -128) ;; cancelled 
      (throw-cancel :cancel)
      (progn
        (when (and (eq result #$memFullErr)(not retried)) ;; out of memory ?
          (let ()
            (if t  ;; pick a random number
              (let ((new (#_newptr 50000)))
                (when (not (%null-ptr-p new))
                  (#_disposeptr new)
                  (return-from check-nav-result :try-again)))
              (return-from check-nav-result :try-again))))
        (error "Navigation services returned ~S" result)))))

(defun parse-doclist (doclist &optional (does-exist t) want-dir)
  (declare (ignore-if-unused does-exist want-dir))
  (let ((result nil))
    (if t ;(or (not (osx-p))(not does-exist))  ;; forget fsref for now
      (rlet ((items :signed-long)
             (aekeyword :ostype)
             (actual-type :ostype)
             (my-fsspec :fsspec)
             (actual-size :signed-long))      
        (ae-error-str "trying to count the items in navreply" 
          (#_AECountItems doclist items))
        (dotimes (i (%get-signed-long items))
          (ae-error-str "trying to get an item in navreply"
            (#_AEGetNthPtr doclist (+ i 1) #$typeFSS aekeyword actual-type my-fsspec 
             (record-length :fsspec) actual-size))
          (let* ((path (%path-from-fsspec my-fsspec)))
            (push path result)))
        (if (eq (length result) 1) (car result) result))
      (rlet ((items :signed-long)
             (aekeyword :ostype)
             (actual-type :ostype)
             (my-fsref :fsref)
             (actual-size :signed-long))      
        (ae-error-str "trying to count the items in navreply" 
          (#_AECountItems doclist items))
        (dotimes (i (%get-signed-long items))          
          (ae-error-str "trying to get an item in navreply"
            (#_AEGetNthPtr doclist (+ i 1) #$typeFSRef aekeyword actual-type my-fsref 
             (record-length :fsref) actual-size))          
          (let* ((path (%path-from-fsref my-fsref want-dir)))
            (push path result))
          )
        (if (eq (length result) 1) (car result) result)))))



#|
(deftrap-inline "_NavPutFile" 
      ((defaultLocation (:pointer :aedesc))
       (reply (:pointer :navreplyrecord)) 
       (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer)
       (fileType :ostype) 
       (fileCreator :ostype) 
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )
|#
#|
(defrecord NavDialogOptions 
   (version :unsigned-integer)
   (dialogOptionFlags :unsigned-long)           ;   option flags for affecting the dialog's behavior  
   (location :point)                            ;   top-left location of the dialog, or (-1,-1) for default position  
   (clientName (:string 255))
   (windowTitle (:string 255))
   (actionButtonLabel (:string 255))            ;   label of the default button (or null string for default)  
   (cancelButtonLabel (:string 255))            ;   label of the cancel button (or null string for default)  
   (savedFileName (:string 255))                ;   default name for text box in NavPutFile (or null string for default)  
   (message (:string 255))                      ;   custom message prompt (or null string for default)  
   (preferenceKey :unsigned-long)               ;   a key for to managing preferences for using multiple utility dialogs  
   (popupExtension :handle)                     ;   extended popup menu items, an array of NavMenuItemSpecs  
   (reserved (:array :character 494 :packed))
   )
|#

(defun nav-choose-new-file-dialog (&key directory
                                        (prompt "As...")
                                        (button-string "Save")
                                        (mac-file-type :text)  ;; these args are new
                                        (mac-file-creator (application-file-creator *application*))
                                        (cancel-button-string "Cancel")
                                        (window-title "Choose a New File")
                                        window-position
                                        name
                                        extended-reply-p ;user requests more details - returns a second value (key-value pair list)
                                        format-query-p ;include popup in dialog for document format selection
                                        &aux retried)
  (when (and directory (null name))
    (setq name (mac-file-namestring (file-namestring directory)))
    (when (eq (length name) 0)(setq name nil))
    (setq directory (directory-namestring (full-pathname directory)))
    (when (eq (length directory) 0)(setq directory nil))
    )
  (when directory (setq directory (probe-file directory))) ; resolve aliases
  (when (or (and directory
                 (pathname-directory directory)
                 (setq directory (directory-namestring directory)))
            (setq directory (choose-file-default-directory)))
    (set-choose-file-default-directory-2 directory)
    )
  (progn ;restoring-dead-keys
    (with-aedescs (aedesc)
      (rlet ((reply :navreplyrecord)
             (options :navdialogoptions)
             (fsptr :fsspec))
        (%clear-block reply (record-length :navreplyrecord))  ;; paranoia - carbon-list discussion
        (set-default-dialog-options
         options :location window-position :windowtitle window-title
         :actionbuttonlabel button-string :cancelbuttonlabel cancel-button-string
         :savedfilename name :message prompt :NavNoTypePopup (not format-query-p))        
        (let ((size (record-length :fsspec)))
          (ae-error (#_aecreatedesc #$typeFSS fsptr size aedesc)))       
        (when directory 
          #-carbon-compat
          (make-fsspec-from-directory-hdl 
                         (pref aedesc aedesc.datahandle)
                         directory)
          #+carbon-compat
          (make-fsspec-from-directory-aedesc aedesc directory)
          )
        (unwind-protect
          (with-port %original-temp-port% ;; see above
            (with-foreign-window
              (prog () ;hiding-windoids
                (put-external-scrap)
                again
                (let ((result (#_navputfile (if directory aedesc *null-ptr*) ;; defaultlocation
                               reply
                               options ;(if (or button-string prompt name) options *null-ptr*) ;dialogoptions
                               event-wdef ;(or *event-ptr* *null-ptr*) ;*null-ptr* ;eventproc
                               mac-file-type
                               mac-file-creator
                               *my-nav-ud*))) ; callbackud
                  (let ((foo (check-nav-result result retried)))
                    (when (and (eq foo :try-again)(null retried))
                      (setq retried t)
                      (go again)))
                  (when (eq result $noerr)
                    (unless (pref reply navreplyrecord.validrecord)
                      (throw-cancel :cancel))
                    (let ((selection (pref reply navreplyrecord.selection))
                          (result)
                          (extended-results))
                      (setq result (parse-doclist selection nil))
                      (when result
                        (set-choose-file-default-directory-2
                         (if (consp result)(car result) result)))
                      ;;; Extended reply - turn on if user asked for format-query-p
                      (setq extended-reply-p (or extended-reply-p format-query-p))
                      (when extended-reply-p
                        (push (pref reply navreplyrecord.keyScript) extended-results)
                        (push :keyScript extended-results)
                        (push :not-implemented-yet extended-results)
                        (push :file-translation extended-results)
                        (push (pref reply navreplyrecord.translationNeeded) extended-results)
                        (push :translation-Needed-p extended-results)
                        (push (pref reply navreplyrecord.isStationery) extended-results)
                        (push :stationery-p extended-results)
                        (push (pref reply navreplyrecord.replacing) extended-results)
                        (push :replacing-p extended-results))
                      (if extended-reply-p
                        (return (values result extended-results))
                        (return result))))))))
          (#_navdisposereply reply))))))
#|
(defun make-fsspec-from-directory (fsspec directory)
  (rlet ((pb :hparamblockrec))
    (%path-to-iopb directory pb)
    (let ((vrefnum (%get-signed-word pb $iovrefnum))
          (parid (%get-signed-long pb $ioFlParID)))
      (#_fsmakefsspec 
       vrefnum
       parid
       (%null-ptr)
       fsspec))))
|#

#-carbon-compat
(defun make-fsspec-from-directory-hdl (handle directory)
  (with-dereferenced-handles ((fsspec handle))
    (%stack-iopb (pb np)
      (%path-to-iopb directory pb)
      (let ((vrefnum (%get-signed-word pb $iovrefnum))
            (dirid (%get-signed-long pb $iodirid)))
        (#_fsmakefsspec 
         vrefnum
         dirid
         (%null-ptr)
         fsspec)))))

#+carbon-compat
;; put an fsspec for a directory into an aedesc of appropriate type - #$typeFSS
(defun make-fsspec-from-directory-aedesc (aedesc directory)
  (%stack-block ((fsptr (record-length :fsspec)))
    (%stack-iopb (pb np)
      (%path-to-iopb directory pb)
      (let ((vrefnum (%get-signed-word pb $iovrefnum))
            (dirid (%get-signed-long pb $iodirid)))
        (#_fsmakefsspec 
         vrefnum
         dirid
         (%null-ptr)
         fsptr))
      ;; I hope it copies the data -seems to
      (errchk (#_AEReplaceDescData #$typeFSS fsptr (record-length :fsspec) aedesc)))))



(defun set-choose-file-default-directory-2 (path)
  (setq path (full-pathname path))
  (if (not (directory-pathname-p path))
    (setq path (directory-namestring path))) 
  (if (directory-exists-p path)
    (setq *last-choose-file-directory* path)))

#|
(deftrap-inline "_NavChooseFolder" 
      ((defaultLocation (:pointer :aedesc)) 
       (reply (:pointer :navreplyrecord)) 
       (dialogOptions (:pointer :navdialogoptions))
       (eventProc :pointer) 
       (filterProc :pointer) 
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )
|#

(defun nav-choose-directory-dialog (&key directory
                                         (button-string "Choose")
                                         (cancel-button-string "Cancel")
                                         (window-title "Choose a Folder")
                                         prompt
                                         window-position
                                         name  ;; I don't think this buys anything here?
                                         &aux retried)  
  
  ;(declare (ignore button-string prompt)) ;; put in actionbuttonlabel in dialogoptions
  (when directory (setq directory (probe-file directory)))
  (when (or (and directory
                 (pathname-directory directory)
                 (setq directory (directory-namestring directory)))
            (setq directory (choose-file-default-directory)))
    (set-choose-file-default-directory-2 directory)
    )  
  (progn ;restoring-dead-keys    
   (with-aedescs (aedesc)
      (rlet ((reply :navreplyrecord)
             (options :navdialogoptions)
             (fsptr :fsspec))        
        (let ((size (record-length :fsspec)))
          (ae-error (#_aecreatedesc #$typeFSS fsptr size aedesc)))
        (set-default-dialog-options
         options :location window-position :windowtitle window-title
         :actionbuttonlabel button-string :cancelbuttonlabel cancel-button-string
         :savedfilename name :message prompt)
        (when directory 
          #-carbon-compat
          (make-fsspec-from-directory-hdl 
                         (pref aedesc aedesc.datahandle)
                         directory)
          #+carbon-compat
          (make-fsspec-from-directory-aedesc aedesc directory)
          )
        (unwind-protect
          (with-foreign-window
            (with-port %original-temp-port%  ;; see above
              (prog () ;hiding-windoids
                (put-external-scrap)
                again
                (let ((result (#_navchoosefolder (if directory aedesc *null-ptr*) ;; defaultlocation
                               reply 
                               options ;*null-ptr* ;dialogoptions
                               event-wdef ;(or *event-ptr* *null-ptr*) ;*null-ptr* ;eventproc
                               *null-ptr* ; filterproc
                               *my-nav-ud*))) ; callbackud
                  (let ((foo (check-nav-result result retried)))
                    (when (and (eq foo :try-again)(null retried))
                      (setq retried t)
                      (go again)))
                  (when (eq result $noerr)
                    (unless (pref reply navreplyrecord.validrecord)
                      (throw-cancel :cancel))                  
                    (let ((selection (pref reply navreplyrecord.selection))
                          (result))
                      (setq result (parse-doclist selection t t))
                      (when result
                        (set-choose-file-default-directory-2 
                         (if (consp result)(car result) result)))
                      (return result)))))))
          (#_navdisposereply reply))))))

#|
(deftrap-inline "_NavNewFolder" 
      ((defaultLocation (:pointer :aedesc)) 
       (reply (:pointer :navreplyrecord)) 
       (dialogOptions (:pointer :navdialogoptions)) 
       (eventProc :pointer) 
       (callBackUD :unsigned-long)) 
  :signed-integer
   () )
|#

#|
(defun nav-choose-new-directory-dialog (&key directory
                                             (prompt "New Directory Name...")
                                             (button-string "Create")
                                             &aux name retried)  
  
  ;(declare (ignore button-string prompt)) ;; put in actionbuttonlabel in dialogoptions
  (when directory 
    (setq name (mac-file-namestring (file-namestring directory)))
    (when (eq (length name) 0)(setq name nil)))
  (when (or (and directory
                 (pathname-directory directory) ;; <<<
                 (setq directory (directory-namestring (full-pathname directory))))
            (setq directory (choose-file-default-directory)))
    (set-choose-file-default-directory-2 directory)
    )  
  (progn ;restoring-dead-keys    
   (with-aedescs (aedesc)
      (rlet ((reply :navreplyrecord)
             (options :navdialogoptions))
        (set-default-dialog-options options)
        (setf (pref aedesc :aedesc.descriptortype) #$typefss)
        #-carbon-compat 
        (progn 
          (setf (pref aedesc :aedesc.descriptortype) #$typefss)
          (setf (pref aedesc :aedesc.datahandle)(make-record :fsspec)))
        #+carbon-compat 
        (let ((size (record-length :fsspec)))
          (ae-error (#_aecreatedesc #$typeFSS (if (osx-p) (#_newptr size)(%null-ptr)) size aedesc)))        
        (when directory 
          #-carbon-compat
          (make-fsspec-from-directory-hdl 
                         (pref aedesc aedesc.datahandle)
                         directory)
          #+carbon-compat
          (make-fsspec-from-directory-aedesc aedesc directory)
          )
        (if button-string
          (setf (pref options :navdialogoptions.actionbuttonlabel) button-string))
        (if prompt
          (setf (pref options :navdialogoptions.message) prompt))
        (when name ;; this has no effect in this case
          (setf (pref options :navdialogoptions.savedfilename) name))
        (unwind-protect
          (with-foreign-window
            (prog () ;hiding-windoids
              (put-external-scrap)
              again
              (let ((result (#_navnewfolder (if directory aedesc *null-ptr*) ;; defaultlocation
                             reply 
                             options ;dialogoptions
                             (or *event-ptr* *null-ptr*) ;*null-ptr* ;eventproc
                             *my-nav-ud*))) ; callbackud
                (let ((foo (check-nav-result result retried)))
                  (when (and (eq foo :try-again)(null retried))
                    (setq retried t)
                    (go again)))
                (when (eq result $noerr)
                  (unless (pref reply navreplyrecord.validrecord)
                    (throw-cancel :cancel))                  
                  (let ((selection (pref reply navreplyrecord.selection))
                        (result))
                    (setq result (parse-doclist selection))
                    (when result
                      (set-choose-file-default-directory-2 
                        (if (consp result)(car result) result)))
                    (return result))))))
          (#_navdisposereply reply))))))
|#


;; or ?? - we like this better I think
(defun nav-choose-new-directory-dialog (&key directory
                                             (prompt "New Folder Name...")
                                             (button-string "Create")
                                             (window-title "Create Folder")
                                             name
                                             cancel-button-string
                                             window-position)
  (let ((result (nav-choose-new-file-dialog :directory directory :prompt prompt :button-string button-string
                                            :window-title window-title
                                            :window-position window-position
                                            :cancel-button-string cancel-button-string
                                            :name name
                                            )))
    (make-pathname :directory (namestring (if (consp result)(car result) result)))))






#|
(setq foo (make-record :aedesc))
(setf (pref foo :aedesc.datahandle) (make-record :fsspec))
(setf (pref foo :aedesc.descriptortype) #$typefss)
(setq h (#_newhandle (record-length :fsspec)))
(setq poo (make-record :fsspec))  ;; its a handle
(make-fsspec-from-directory-hdl poo "ccl:")

(defun path-from-aedesc (aedesc)
  (let ((hdl (pref aedesc :aedesc.datahandle)))
    (with-dereferenced-handles ((p hdl))
      (%path-from-fsspec p))))

(defun poopoo (hdl)
  (with-dereferenced-handles ((p hdl))
    (%path-from-fsspec p)))
|#

#-CARBON-COMPAT
(defun path-from-aedesc (aedesc)
  (let ((hdl (pref aedesc :aedesc.datahandle)))
    (with-dereferenced-handles ((p hdl))
      (%path-from-fsspec p))))

#+CARBON-COMPAT
(defun path-from-aedesc (aedesc)
  (let ((size (record-length :fsspec)))
   (%stack-block ((ptr size :clear t))
     (ae-error (#_aegetdescdata aedesc ptr size))          ; 
     (%path-from-fsspec ptr))))

(defparameter *keywords-unsupported-in-old-choose*  
  '(:window-title :window-position :cancel-button-string :extended-reply-p :format-query-p :name
    :allow-multiple-files))

(defparameter *keywords-unsupported-in-old-choose-dir*  
  '(:window-title :window-position :cancel-button-string :extended-reply-p :format-query-p :name    
    :button-string :prompt))

;; borrowed from clim
(defun remove-keywords (list keywords)
  (macrolet ((remove-keywords-1 (name-var predicate-form)
	       `(let ((head nil)
		      (tail nil))
		  (do ()
		      ((null list))
		    (let ((,name-var (pop list))
			  (value (pop list)))
		      (unless ,predicate-form
			(setq tail (setq head (list ,name-var value)))
			(return))))
		  (do ()
		      ((null list) head)
		    (let ((,name-var (pop list))
			  (value (pop list)))
		      (unless ,predicate-form
			(setq tail (setf (cddr tail) (list ,name-var value)))))))))
    (cond ((null list) nil)
	  ((null keywords) list)
	  ;; Special case: use EQ instead of MEMBER when only one keyword is supplied.
	  ((null (cdr keywords))
	   (let ((keyword (car keywords)))
	     (remove-keywords-1 name (eq name keyword))))
	  (t
	   (remove-keywords-1 name (member name keywords))))))
#|
(advise choose-directory-dialog
        (if *nav-services-available*
          (apply 'nav-choose-directory-dialog arglist)
          (progn
            (setq arglist (remove-keywords arglist *keywords-unsupported-in-old-choose-dir*))
            (:do-it)))
        :when :around :name :navigation)

(advise choose-file-dialog
        (if *nav-services-available*
          (apply 'nav-choose-file-dialog arglist)
          (progn
            (setq arglist (remove-keywords arglist *keywords-unsupported-in-old-choose*))
            (:do-it)))
        :when :around :name :navigation)

(advise choose-new-file-dialog
        (if *nav-services-available*
          (apply 'nav-choose-new-file-dialog arglist)
          (progn
            (setq arglist (remove-keywords arglist *keywords-unsupported-in-old-choose*))
            (:do-it)))
        :when :around :name :navigation)

(advise choose-new-directory-dialog
        (if *nav-services-available*
          (apply 'nav-choose-new-directory-dialog arglist)
          (progn
            (setq arglist (remove-keywords arglist *keywords-unsupported-in-old-choose*))
            (:do-it)))
        :when :around :name :navigation)

;; prevent unadvising these three/four functions - kind of incestuous in the advise department
(advise %defun-encapsulated-maybe
        (if (memq (car arglist) '(choose-file-dialog choose-new-file-dialog choose-directory-dialog
                                  choose-new-directory-dialog))
          (let ((*loading-files* nil)) ;; this prevents unadvising of functions but not generic functions
            (:do-it))
          (:do-it))
        :when :around :name :navigation)
|#

;;; this way no compiler warnings if call choose-xxx-dialog with new keys

(let ((*warn-if-redefine* nil)
      (*warn-if-redefine-kernel* nil))

(when (not (fboundp 'old-choose-file-dialog))
  (let ((old-def (fboundp 'choose-file-dialog)))
    (defun choose-file-dialog (&rest args &key directory
                                     mac-file-type
                                     mac-file-creator 
                                     button-string 
                                     cancel-button-string
                                     window-title
                                     allow-multiple-files
                                     prompt
                                     window-position)
      (declare (dynamic-extent args))
      (declare (ignore directory mac-file-type mac-file-creator button-string cancel-button-string window-title 
                       allow-multiple-files prompt window-position))
      (if *nav-services-available*
        (apply 'nav-choose-file-dialog args)
        (let ((args (remove-keywords args *keywords-unsupported-in-old-choose*)))
          (apply 'old-choose-file-dialog args))))
    (when old-def
      (setf (symbol-function 'old-choose-file-dialog) old-def)
    )))

(when (not (fboundp 'old-choose-new-file-dialog))
  (let ((old-def (fboundp 'choose-new-file-dialog)))
    (defun choose-new-file-dialog (&rest args &key directory
                                         prompt 
                                         button-string
                                         mac-file-type  ;; does this make any sense?
                                         mac-file-creator
                                         cancel-button-string
                                         window-title 
                                         window-position
                                         name
                                         extended-reply-p ;user requests more details - returns a second value (key-value pair list)
                                         format-query-p ;include popup in dialog for document format selection
                                        )
      (declare (dynamic-extent args))
      (declare (ignore directory prompt button-string mac-file-type mac-file-creator cancel-button-string window-title 
                       window-position name extended-reply-p format-query-p))
      (if *nav-services-available*
        (apply 'nav-choose-new-file-dialog args)
        (let ((args (remove-keywords args *keywords-unsupported-in-old-choose*)))
          (apply 'old-choose-new-file-dialog args))))
    (when old-def
      (setf (symbol-function 'old-choose-new-file-dialog) old-def))
    ))

(when (not (fboundp 'old-choose-directory-dialog))
  (let ((old-def (fboundp 'choose-directory-dialog)))
    (defun choose-directory-dialog (&rest args &key directory
                                          button-string
                                          cancel-button-string
                                          window-title
                                          prompt
                                          window-position
                                          name  ;; I don't think this buys anything here?
                                         )
      (declare (dynamic-extent args))
      (declare (ignore directory button-string cancel-button-string window-title prompt window-position name)) 
      (if *nav-services-available*
        (apply 'nav-choose-directory-dialog args)
        (let ((args (remove-keywords args *keywords-unsupported-in-old-choose-dir*)))
          (apply 'old-choose-directory-dialog args))))
    (when old-def
      (setf (symbol-function 'old-choose-directory-dialog) old-def)
      )))

(when (not (fboundp 'old-choose-new-directory-dialog))
  (let ((old-def (fboundp 'choose-new-directory-dialog)))
    (defun choose-new-directory-dialog (&rest args &key directory
                                              prompt
                                              button-string
                                              window-title 
                                              name
                                              cancel-button-string
                                              window-position)
      (declare (dynamic-extent args))
      (declare (ignore directory prompt button-string window-title name cancel-button-string window-position))
      (if *nav-services-available*
        (apply 'nav-choose-new-directory-dialog args)
        (let ((args (remove-keywords args *keywords-unsupported-in-old-choose*)))
          (apply 'old-choose-new-directory-dialog args))))
    (when old-def
      (setf (symbol-function 'old-choose-new-directory-dialog) old-def)
      )))
)

(defparameter *choose-file-alist*
  '((choose-file-dialog . old-choose-file-dialog)
    (choose-new-file-dialog . old-choose-new-file-dialog)
    (choose-directory-dialog . old-choose-directory-dialog) 
    (choose-new-directory-dialog . old-choose-new-directory-dialog)))

;; this is a nasty thing to do - redefs of choose-xx-dialog actually redefine old-choose-xx-dialog
;; For the benefit of CLIM which contains patched versions of choose-xx-dialog.
;; also I guess in case one loads new-file-dialogs.lisp
#-carbon-compat  ;; if carbon assume using newer CLIM and don't load new-file-dialogs
(advise %defun
        (let* ((name (function-name (car arglist)))
               (pair (assq name *choose-file-alist*)))
          (when pair
            (let ((old-name (cdr pair)))
              (when #-carbon-compat (fboundp old-name) #+carbon-compat t
                (lfun-name (car arglist) old-name))))
          (:do-it))
        :when :around :name :navigation)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; the stuff to make the dialogs movable


;; this business makes the nav-xxx dialogs movable and updates windows newly exposed as needed.
;; I dont know what would happen if a GC was going on but neither can
;; I imagine why a gc would be going on

#|
(eval-when (:compile-toplevel :execute)
(defconstant *event-proc-info*
  #.(make-proc-info '(:word :ptr :long) :long #$kPascalStackBased))
)
|#

(defvar *event-wrapper* nil)
;(defvar *event-ptr*)  ;; its above


(ppc::define-storage-layout event-toc 0
  nilreg                                ; NIL
  call-universal-proc                   ; Address of call-universal-proc transition vector
  event-defpascal                        
)


#|
(defppclapfunction event-proc-1 ()
  (let ((callbackselector 3)
        (callbackparms 4)
        (callbackud 5)
        ;(parameter 6)
        (tmp 7)
        (tmp2 8)
        (nilreg 9))
    (lwz nilreg event-toc.nilreg rnil)
    (lwz tmp (ppc::kernel-global current-cs) nilreg)
    (lwz tmp2 ppc::area.low tmp)
    (cmplw sp tmp2)
    (blt @not-lisp)
    (lwz tmp2 ppc::area.high tmp)
    (cmplw sp tmp2)
    (bge @not-lisp)

    ; The callback is on the Lisp stack, so we can just enter the lisp code
    ;(mr 8 6)  ;; huh
    (mr 7 5)
    (mr 6 4)
    (mr 5 3)
    (lwi 4 #.*event-proc-info*)
    (lwz 3 event-toc.event-defpascal rnil)
    (lwz rnil event-toc.call-universal-proc rnil)
    (lwz 0 0 rnil)
    (mtctr 0)
    (lwz rnil 4 rnil)
    (bctr)

    @not-lisp
    ; We were called from some unknown stack. do nothing
    ; Tell %event-dispatch to redraw all the window frames
    ;(la tmp (ppc::nrs-offset *gc-event-status-bits*) nilreg)
    ;(lwi tmp2 #.(ash 1 (+ $gc-redraw-window-frames-bit ppc::fixnum-shift)))
    ;(lwz 3 ppc::symbol.vcell tmp)
    ;(or 3 3 tmp2)
    ;(stw 3 ppc::symbol.vcell tmp)
    ; return 0 = false for the #$whit command
    (li 3 0)
    (blr)))
|#

#|
(defun make-event-ptr (event-defpascal)
  (let* ((transition-vector (#_newptr :errchk (* 4 (+ 2 ppc::event-toc.size))))
         (upp (cons-routine-descriptor transition-vector *event-proc-info*)))
    (with-macptrs ((toc (%inc-ptr transition-vector 8)))
      (setf (%get-ptr transition-vector 0) *event-wrapper*
            (%get-ptr transition-vector 4) toc)
      (%set-object toc event-toc.nilreg nil)
      (%set-object toc event-toc.call-universal-proc *call-universal-proc-address*)
      (setf (%get-ptr toc event-toc.event-defpascal) event-defpascal)
      )
    upp))
|#

#+carbon-compat  ;; this sucks
(add-pascal-upp-alist 'event-wdef #'(lambda (procptr)(#_newnaveventupp procptr)))

(defpascal event-wdef (:word callbackselector :ptr callbackparms :ptr callbackud) ;#+carbon-compat :ptr #-carbon-compat :long callbackud)   ;; callbackud was :long
  (when (and (eq callbackselector #$knavCBcancel)(eql callbackud *my-nav-ud* ))    
    (with-aedescs (aedesc)
      (if  t ;(not (osx-p))
        (rlet ((fsptr :fsspec))        
          (let ((size (record-length :fsspec)))
            (ae-error (#_aecreatedesc #$typeFSS fsptr size aedesc)))        
          (#_NavCustomControl (pref callbackparms :navcbrec.context) #$kNavCtlGetLocation aedesc) 
          (ignore-errors 
           ;; will error on osx if the chosen thing is an alias to a folder - don't know why
           (let ((path (path-from-aedesc aedesc)))            
             (set-choose-file-default-directory-2 path))))
        (rlet ((fsptr :fsref)
               (fsptr2 :fsref))        
          (let ((size (record-length :fsref)))
            (ae-error (#_aecreatedesc #$typeFsref fsptr size aedesc))        
            (#_NavCustomControl (pref callbackparms :navcbrec.context) #$kNavCtlGetLocation aedesc)
            (ae-error (#_aegetdescdata aedesc fsptr2 size))          
            (let ((path (%path-from-fsref fsptr2))) ;; this pukes
              (set-choose-file-default-directory-2 path)))))))
      
  (when (and (eql callbackud *my-nav-ud*)
             (eq callbackselector #$kNavCBEvent) ;; update or idle or something
             )
    (with-macptrs ((the-data  (pref callbackparms :navcbrec.eventdata))
                   (the-event (rref the-data :eventdata.event))
                   the-wptr)
      (let* ((what (rref the-event :eventrecord.what)))
        (when (eq what #$UpdateEvt)
          (%setf-macptr the-wptr (rref the-event :eventrecord.message)) ;; is that the wptr
          ;; well I'll be darned it seems to work
          (let* ((the-window (window-object the-wptr)))
            (when the-window
              (window-update-event-handler the-window)))
          )))))

#|
(def-ccl-pointers event-ptr ()
  (setq *event-wrapper* (lfun-to-ptr #'event-proc-1))
  (setq *event-ptr* (make-event-ptr event-wdef))) ;; just use this as eventproc ptr? seems to work
|#






#|
;; this crashes horrible given *event-ptr* - doesn't crash given *event-wrapper*
;; newnaveventupp just does newroutinedescriptor of given arg and equiv of *event-proc-info* and isa = ppc
(setq zorch (#_newnaveventupp *event-wrapper*))
|#

#| tests
(nav-choose-new-file-dialog
 :directory "new.lisp"
 :prompt "Prompt message goes here ..."
 :button-string "Create File"
 :mac-file-type :text
 :mac-file-creator (application-file-creator *application*)
 :cancel-button-string "Stop Button"
 :window-title "Create a New File"
 :window-position (make-point 30 120))

(nav-choose-file-dialog
 :directory "ccl:Library;"
 :button-string "Hi!"
 :window-title "This window has a title"
 :cancel-button-string "Stop Now!"
 :prompt "The prompt sentence goes here ..."
 :window-position (make-point 30 100))

(nav-choose-directory-dialog
 :directory "ccl:Library;dialog-macros.lisp"
 :prompt "Prompt message goes here ..."
 :button-string "This one!"
 :cancel-button-string "Bad choice"
 :window-title "This window has a title"
 :window-position (make-point 30 120))

(nav-choose-new-file-dialog
 :directory "new.lisp"
 :prompt "Prompt message goes here ..."
 :button-string "Create File"
 :mac-file-type :text
 :mac-file-creator (application-file-creator *application*)
 :cancel-button-string "Stop Button"
 :window-title "Create a New File"
 :window-position (make-point 30 120)
 :format-query-p t
 :extended-reply-p t
 )
|#







                  