; -*- Mode: Lisp; Package: CCL; -*-

(in-package :ccl)

;;; fp-formats.lisp
;;; 2003-03-17TA - Pulled out from old ff-source.lisp file 
;;; these work - the rest of ff-source does not

#+ppc-target
(progn

(defun %float2x (float ptr)
  (rlet ((float-ptr :double-float))
    (%put-double-float float-ptr float)
    (#_dtox80 float-ptr ptr))
  ptr)

(eval-when (:compile-toplevel :execute)
  ; For %make-dfloat
  (require "NUMBER-MACROS" "ccl:compiler;ppc;number-macros"))

(defun %x2float (ptr float-ptr)
  (let ((float (%make-dfloat)))
    (declare (dynamic-extent float))
    (%x2float-internal ptr float)
    (%put-double float float-ptr))
  float-ptr)

(defun %get-x2float (ptr)
  (%x2float-internal ptr (%make-dfloat)))

(defun %x2float-internal (ptr float)
  (%setf-double-float float (#_x80tod ptr))
  (%df-check-exception-1 '%x2float ptr)
  float)

; Copies the full 12 bytes of an extended to a pointer.
(defun %float2x12 (float ptr)
  (%float2x float ptr)
  (setf (%get-word ptr 10) (%get-word ptr 8)
        (%get-word ptr 8) (%get-word ptr 6)
        (%get-word ptr 6) (%get-word ptr 4)
        (%get-word ptr 4) (%get-word ptr 2)
        (%get-word ptr 2) 0)
  ptr)

; This needs to be uninterruptable until the FMOVE.D instruction in *get-fp0-68k*.
; Otherwise FP0 might be clobberred.
; The *get-fp0-68K* code will get an illegal instruction trap
; unless a 68K FPU emulator is installed. But then the user 68881 code
; can't be running on a PPC unless that is so, so we're not in trouble.

#+ignore
(defun %get-fp0 ()
  (declare (optimize (speed 3) (safety 0)))
  (without-interrupts
   (%stack-block ((double 8))
     (ff-call *get-fp0-68K* :ptr double)
     (%copy-float double))))

(defun %put-double (flt ptr)
  (%copy-ivector-to-ptr flt (* 4 ppc::double-float.value-cell) ptr 0 8))

; Sounds like a bad idea to me ...
(defun %get-double (ptr flt)
  (%copy-ptr-to-ivector ptr 0 flt (* 4 ppc::double-float.value-cell) 8))

) ; #+ppc-target


;;;

(provide :fp-formats)
