(in-package :ccl)

;; do quit with carbon event so detection of command key is reliable on OSX

#|
- install an event handler for kEventClassCommand/kEventCommandProcess 
on the app target
- in your event handler, check the HICommand.commandID field for 
kHICommandQuit
- if it's the quit command, get the kEventParamMenuContext parameter
- if the menu context contains kMenuContextKeyMatching, then the 
command event was sent in response to a command key; otherwise, it was 
selected from the menu with the mouse

-eric
|#


#+carbon-compat
(add-pascal-upp-alist 'quit-handler-proc #'(lambda (procptr)(#_neweventhandlerupp procptr)))

(defpascal quit-handler-proc (:ptr targetref :ptr eventref :word)
  (declare (ignore targetref))
  (let ((res #$eventNotHandledErr)
        (myerr nil))
    (rlet ((hicmd :hicommand)
           (menu-context :uint32))
      (setq myerr (#_geteventparameter eventref #$keventparamdirectobject #$typehicommand *null-ptr* (record-length :hicommand)  *null-ptr* hicmd))
      (when (eq myerr #$noerr) 
        (let (( poo (pref hicmd hicommand.commandid)))
          (when (eql (ff-long-to-ostype poo) #$khicommandquit) ;; got here on OSX
            (setq myerr (#_geteventparameter eventref #$keventparammenucontext #$typelonginteger *null-ptr* (record-length :uint32) *null-ptr* menu-context))
            (when (eq myerr #$noerr)
              (if (neq 0 (logand (%get-unsigned-long menu-context) #$kmenucontextkeymatching))
                (when (y-or-n-dialog (format nil "Do you really want to quit from ~A ?"
                                             (current-app-name))
                                     :yes-text "Quit"
                                     :cancel-text nil
                                     :window-type :double-edge-box
                                     :help-spec '(:dialog 11110 :yes-text 11111 :no-text 11112))
                  (quit))
                (quit))
              (setq res #$noerr))))))
    res))

#+ignore
(defvar *targetref* nil)

(def-ccl-pointers qqquit2 ()
  (when (null *targetref*) (setq *targetref* (#_getapplicationEventTarget)))
  (#_installeventhandler *targetref* quit-handler-proc 1
   (make-record :eventtypespec 
                :eventclass #$kEventClassCommand
                :eventkind #$kEventCommandProcess)
   (%null-ptr) (%null-ptr)))




    
