(in-package :ccl)

;; set font to something sensible in second case.

(let ((*warn-if-redefine* nil)
      (*warn-if-redefine-kernel* nil))

(defun update-key-script-from-click (frec pos leading-edge-p)
  (frec-arg frec)  
  (let ((buf (fr.cursor frec)))
    (when (and (not (eql pos 0))
               (or (eql pos (buffer-size buf))
                   (not (eql #\return (buffer-char buf pos))) ; test was bwds here <<
                   (not leading-edge-p)))
      (decf pos))
    (let* ((index (buffer-char-font-index buf pos))
           (ff (buffer-font-index-codes buf index))
           (script (ff-script ff))
           (keyscript (get-key-script)))
      (unless (eql script keyscript)
        (if *fred-auto-set-keyscript*
          (progn
            (ccl::set-key-script script)
            (setf (fr.keyscript frec) script))
          (progn
            ;; set font to something that makes sense in keyscript
            (multiple-value-bind (ff ms) (buffer-find-font-in-script buf keyscript)
              (buffer-set-font-codes buf ff ms))))))))
)