; -*- package: plasm -*-


;===============================================================================
;
;
;                            PLASM PACKAGE
;
;
;===============================================================================

; Last modified (4/2/94)

(provide 'p_main)

(inpackage plasm)

(export '(use-plasm
	  read-eval-plasm-show-value
	  eval-plasm 
	  trace-plasm
	  untrace-plasm
	  show
	  give-value
	  debug-plasm
	  no-debug-plasm))

;;(mapc #'(lambda (the-package)   ;; *modificato*
;;	  (require the-package) 
;;	  (use-package the-package))
;;	'(kernel io extrusion dvrlib
;;	  bound extrusion 
;;	  #+:APPLE maclib
;;	 ))

(require 'kernel)
(use-package 'kernel)
(require 'io)
(use-package 'io)
(require 'extrusio)
(use-package 'extrusion)

(require 'dvrlib)
(use-package 'dvrlib)

(require 'bound)
(use-package 'bound)

;#+:APPLE (progn (require 'maclib) (use-package 'maclib))


;------------------------------------------------------------------------

(defvar *PLASM-STRING* "") ; it always contains the last plasm string read.


#+:APPLE
(defun EVAL-PLASM (plasm-string)
  (declare (special *PLASM-STRING*))
  ;(WITHOUT-FLOATING-POINT-UNDERFLOW
  (with-simple-restart
    (abort " PLASM ERROR! ")
    (let ((old-package *package*))
      (setf *PLASM-STRING* plasm-string)
      (inpackage  plasm)
      (syn-tree-3  *PLASM-STRING*)
      (setf *package* old-package)))
  ;)
  (progn
    (setf *package* (inpackage user))
    (values)))


#-:APPLE
(defun EVAL-PLASM (plasm-string)
  (declare (special *PLASM-STRING*))
  (restart-case (progn
                  (inpackage  plasm)
                  (WITHOUT-FLOATING-POINT-UNDERFLOW
                   (setf *PLASM-STRING* plasm-string)
                   (syn-tree-3  *PLASM-STRING*)))
   (abort ()
          :report
          (lambda (stream)  (format stream "There was a lisp error. Sorry."))
          (values)))
  (progn
    (setf *package* (inpackage user))
    (values)))

;------------------------------------------------------------------------
;If the form typed is a string the standard value is itself. After a
;call to USE-PLASM function ,if a string is typed from user at lisp prompt
;it is taken to be a PLASM script and it is given to the processor function.
;If what is typed is a cons the standard evaluator of lisp is called.

(defun NEW-EVAL (&rest arg)
  (declare (special *PLASM-STRING*))
  (let ((first-arg (first arg)))
    (if (stringp first-arg) 
      (eval-plasm first-arg) 
      (eval first-arg))))


;-------------------------------------------------------------------------
;This function binds system variable *EVALHOOK* to function new-eval. At this point, 
;when a form is recognized from prompt of lisp, no evaluation is attempt but the 
;new-eval function is called from the READ-EVAL-PRINT evaluator of LISP. 

(defun USE-PLASM () 
  (setf *EVALHOOK* #'new-eval)
  (format t "~%~%    PLASM INTERPRETER ACTIVE !~%~%~%")
  (values))


;-------------------------------------------------------------------------

(defun READ-EVAL-PLASM-SHOW-VALUE ()
  (let (form)
    (loop 
      (setq form (prog2 
		  (progn (fresh-line) (format t "~%Plasm: "))
		  (cond
		   #+:APPLE ((get-next-queued-form ))
		   (T (read)))
		  (fresh-line)))
      (cond
       ((stringp form)
	(eval-plasm form))
       
       ((and form (symbolp form) (or (eq 'plasm::exit form)
				     (eq 'user::exit form)))
	(return (values)))
	      
       (T
	(format t "~%(LISP value:) ~A" (eval form))
	(values))))))





;;(mapcar #'(lambda (package) 
;;          (require package))
;;      '(grm.lsp s_ambig.lsp syntax.lsp lex.lsp struct.lsp error.lsp  
;;        eval_p.lsp eval_def.lsp misc.lsp inout.lsp  fenvs.lsp
;;        ))


(print '==================)


(require 'grm)
(require 's_ambig)
(require 'syntax)
(require 'lex)
(require 'struct)
(require 'error)
(require 'eval_p)
(require 'eval_def)
(require 'p_misc)
(require 'inout)
(require 'anim)

(require 'fenvs)









