(inpackage plasm)

;(setq *STATIINADEGUATI* 
;        infexpr  applic  compos
;      '( 73        76      81
;        112       113     114
;        118       119     120
;        124       126     127
;        131       133     134
;        158
;        159
;        160
;        177
;        181       182     183
;        195
;        239       240     241
;        245       247     248
;        252
;        253))




;---------------------------------------------------------------------
;---------------------------------------------------------------------
;These constants store inadequate states for the automa recognizer.
;They are splitted in three groups because three are the case to solve. 

(defconstant *INFEXPR-INADEQUATE-STATE*
  '(
    73 112 118 124 131 158 159 160 177 181 195 239 245 252 253
    ))

(defconstant *APPLIC-INADEQUATE-STATE*
  '(
    76 113 119 126 133 182 240 247
    ))

(defconstant *COMPOS-INADEQUATE-STATE*
  '(
    81 114 120 127 134 183 241 248
    ))
;---------------------------------------------------------------------
;---------------------------------------------------------------------

(defun BUILD-HASH-INADEQUATE (hash-table objs-list)
  (dolist (x objs-list)
    (setf (gethash x hash-table) T)))

;----------------------------------------------------------------------

(defvar *INFEXPR-INADEQUATE-STATE-HASH-TABLE*
  (make-hash-table :test #'eq))

(build-hash-inadequate *INFEXPR-INADEQUATE-STATE-HASH-TABLE* 
                       *INFEXPR-INADEQUATE-STATE*)

(defun INFEXPR-INADEQUATE-STATE-P (state)
  (declare (special *INFEXPR-INADEQUATE-STATE-HASH-TABLE*))
  (gethash state *INFEXPR-INADEQUATE-STATE-HASH-TABLE*))


(defvar *APPLIC-INADEQUATE-STATE-HASH-TABLE*
  (make-hash-table :test #'eq))

(build-hash-inadequate *APPLIC-INADEQUATE-STATE-HASH-TABLE*
                       *APPLIC-INADEQUATE-STATE*)

(defun APPLIC-INADEQUATE-STATE-P (state)
  (declare (special *APPLIC-INADEQUATE-STATE-HASH-TABLE*))
   (gethash state *APPLIC-INADEQUATE-STATE-HASH-TABLE*))



(defvar *COMPOS-INADEQUATE-STATE-HASH-TABLE*
  (make-hash-table :test #'eq))

(build-hash-inadequate *COMPOS-INADEQUATE-STATE-HASH-TABLE*
                       *COMPOS-INADEQUATE-STATE*)


(defun COMPOS-INADEQUATE-STATE-P (state)
  (declare (special *COMPOS-INADEQUATE-STATE-HASH-TABLE*))
   (gethash state *COMPOS-INADEQUATE-STATE-HASH-TABLE*))

;----------------------------------------------------------------

;-------------------------------------------------------------------------
;this symbols have value equal to a pair: the symbol 'AP and the number 
; of the production rule whose left side is the non-terminal XXXX, where XXXX 
; is taken from symbol name *REDUCE-XXXX-NUMBER* 

(setq *REDUCE-INFEXPR-NUMBER* nil)

(setq *REDUCE-COMPOS-NUMBER* nil)

(setq *REDUCE-APPLIC-NUMBER* nil)


(let ((i 1)
      sx-side)
    (declare (special *PRODUZIONI*
                      *REDUCE-INFEXPR-NUMBER* 
                      *REDUCE-COMPOS-NUMBER* 
                      *REDUCE-APPLIC-NUMBER*))
    (loop 
      (if (and *REDUCE-INFEXPR-NUMBER* 
               *REDUCE-COMPOS-NUMBER* 
               *REDUCE-APPLIC-NUMBER*)
        (return))

      (setq sx-side (first (aref *PRODUZIONI* i)))

      (if (and (not *REDUCE-APPLIC-NUMBER*) (eq 'APPLIC sx-side))
        (setq *REDUCE-APPLIC-NUMBER* `(AP ,i)))

      (if (and (not *REDUCE-COMPOS-NUMBER*) (eq 'COMPOS sx-side))
        (setq *REDUCE-COMPOS-NUMBER* `(AP ,i)))

      (if (and (not *REDUCE-INFEXPR-NUMBER*) (eq 'INFEXPR sx-side))
        (setq *REDUCE-INFEXPR-NUMBER* `(AP ,i)))

      (incf i)))

;-------------------------------------------------------------------------


(defvar *PRED-STACK* '())         
                                  
(defun RESET-PRED-STACK ()
  (declare (special *PRED-STACK*))
  (setq *PRED-STACK* '()))

;-------------------------------------------------------------------------

(defun SOLVE-AMBIGUOUS-STATE (state context prod-seq) 
  (declare (special *PRED-STACK* 
                    *REDUCE-INFEXPR-NUMBER*
                    *REDUCE-APPLIC-NUMBER*
                    *REDUCE-COMPOS-NUMBER*))
   (cond
    ((infexpr-inadequate-state-p state)
     (if (member context '( #\~ #\: ))
       '(SP) ;=== infexpr is left associative 
             ;=== but has lowest precedence
       (cond
        ((eq context '*EPS*)
         (pop *PRED-STACK*) ; since context is *EPS* this form is trivial !?!
         *REDUCE-INFEXPR-NUMBER*)
        ((and *PRED-STACK*         ;if does not exist a stack it must not create one!
              (characterp context)
              (char= #\( context))
         (push nil *PRED-STACK*) ; there is almost a suspended INFEXPR, 
                                 ; then a new stack have to be initialized
         '(SP)) 
        ((characterp context) ; it's certainly at end of an INFEXP
         (pop *PRED-STACK*)
         *REDUCE-INFEXPR-NUMBER*)
        ((and (if (not *PRED-STACK*)
                (let ((top (search-second-expression prod-seq)))
                  (if (and top ; top is set to nil if the second 
                           ; expression is not EXPRES -> TOKENID  !
                           (known-precedence-p top))
                    (push top *PRED-STACK*))) 
                ; here *PRED-STACK* is nil, then 
                ; (push top *PRED-STACK*) == (push-pred-stack top) 
                
                (if (eq nil (first *PRED-STACK*))
                  (let ((top (search-second-expression prod-seq)))
                    (if (and top ; top is set to nil if the second 
                             ; expression is not EXPRES -> TOKENID  !
                             (known-precedence-p top))
                      (setf (first *PRED-STACK*) (list top))))))
              NIL)) ;this cond branch always fails!
        ((not *PRED-STACK*)
         *REDUCE-INFEXPR-NUMBER*)  
        ((<= (precedence (first-pred-stack))
             (precedence context))
         (pop-pred-stack)
         *REDUCE-INFEXPR-NUMBER*)
        (T 
         ; that is (> (precedence (first-pred-stack))
         ;            (precedence context)) 
         ; form is T 
         (if (known-precedence-p context) 
           (push-pred-stack context))
         '(SP)))))
    
    ((applic-inadequate-state-p state)
     *REDUCE-APPLIC-NUMBER*) ;=== application is left associative 
                             ;=== and has higher precedence
    
    ((compos-inadequate-state-p state)
     (if (member context '( #\: #\~ ))
       '(SP)  ;=== composition is rigth associative and has
              ;=== lower precedence than application
       *REDUCE-COMPOS-NUMBER*))))


(defun FIRST-PRED-STACK ()
  (declare (special *PRED-STACK*))
  (let ((the-first (first *PRED-STACK*)))
    (if (consp the-first)
      (first the-first)
      the-first)))


(defun POP-PRED-STACK ()
  (declare (special *PRED-STACK*))
  (let ((the-first (first *PRED-STACK*)))
    (if (consp the-first)
      (setf (first *PRED-STACK*) (rest the-first))
      (pop *PRED-STACK*))))


(defun PUSH-PRED-STACK (item)
  (declare (special *PRED-STACK*))
  (let ((the-first (first *PRED-STACK*)))
    (if (consp the-first)
      (setf (first *PRED-STACK*) (cons item the-first))
      (push item *PRED-STACK*))))


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(setq *PRECEDENCE-TABLE* (make-hash-table :test #'eq))

(defconstant *PRECEDENCE-LIST*
      '(
   ;HIGHEST PRECEDENCE FOR THE FIRST LIST OPERATORS
        (**)
        (/ DIV)             ;IN THE SAME LIST GO EQUAL PRECEDENCE OPERATORS 
        (* POWER MUL)       ;ALL OPERATORS ARE LEFT ASSOCIATIVE
        (+ ADD - SUB MINUS)     
   ;LOWEST PRECEDENCE FOR THE LAST LIST OPERATORS
        ))

(defun BUILD-PRECEDENCE-TABLE ()
  (declare (special *PRECEDENCE-TABLE* *PRECEDENCE-LIST*))
  (dotimes (i (length *PRECEDENCE-LIST*))
    (mapcar #'(lambda (obj) 
                (setf (gethash obj  *PRECEDENCE-TABLE*) i))
            (nth i *PRECEDENCE-LIST*))))

(funcall #'BUILD-PRECEDENCE-TABLE)


(defun PRECEDENCE (obj)
  (declare (special *PRECEDENCE-TABLE*))
  (cond
   ((gethash obj *PRECEDENCE-TABLE*))
   (T -1)))

(defun KNOWN-PRECEDENCE-P (obj)
  (declare (special *PRECEDENCE-TABLE*))
  (and (gethash obj *PRECEDENCE-TABLE*)
       T))

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


(defun SEARCH-SECOND-EXPRESSION (prod-seq)
  (if prod-seq
    (setq prod-seq 
          (scan-a-complex-or-a-simplex-expres 
           (cdr prod-seq)
           (how-many-no-terminal 
            (dx-side-prod (let ((prod-code (first prod-seq)))
                            (if (consp prod-code)
                              (first prod-code)
                              prod-code)))
            0))))
  (if prod-seq
    ; then search a simple *EXPRES*, that is the rule 
    ; EXPRES -> TOKENID
    (setq prod-seq (scan-to-expres prod-seq)))
  (if (not (numberp (first prod-seq)))
    ; in the production list prod-seq a token rule is stored
    ; with a pair: the production number for TOKEINID and the token
    (second (first prod-seq))))


(defun SCAN-TO-EXPRES (prod-seq)
  (declare (special *EXPRES*))
  (cond
   ((null prod-seq) nil)
   ((and (numberp (first prod-seq))
         (eq *EXPRES* (sx-side-prod (first prod-seq))))
    (cdr prod-seq))
   (T (scan-to-expres (cdr prod-seq)))))



(defun SCAN-A-COMPLEX-OR-A-SIMPLEX-EXPRES (prod-seq how)
  (if (= 0 how)
    prod-seq
    (let ((prod-code (first prod-seq)))
      (scan-a-complex-or-a-simplex-expres 
       (cdr prod-seq) 
       (+ (1- how) (how-many-no-terminal 
                    (dx-side-prod (if (consp prod-code)
                                    (first prod-code)
                                    prod-code))
                    0))))))

(defun HOW-MANY-NO-TERMINAL (dx-side how-many)
  (if dx-side
    (how-many-no-terminal (rest dx-side)
                          (+ how-many (if (terminal-p (first dx-side)) 
                                        0
                                        1)))
    how-many))
  
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
