; -*- package: common-lisp-user -*-


(provide 'p_menu)





(in-package common-lisp-user)



(setf plasm-menu (make-instance 'menu

                   :menu-title "PLaSM"))



(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Eval Selection"

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(eval-plasm 

                                     ,(take-string))))

                               :COMMAND-KEY

                               #\`))



(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Eval PLASM File"

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(PLASM::READ-PLASM-SCRIPT)))

                               :COMMAND-KEY

                               #\2))



(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Eval PLASM Buffer"

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(EVAL-PLASM-BUFFER)))

                               :COMMAND-KEY

                               #\3))



(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Export Last_Value"

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (declare (special user::last_value))

                                   (eval-enqueue

                                    `(PLASM::EXPORT-POL-COMPLEX-PLASM 

                                      ',user::last_value)))

                               :COMMAND-KEY

                               #\]))



(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Convert Ver. 1.0 -> 2.0"

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(UPDATE-PLASM-CODE )))

                               :COMMAND-KEY

                               #\>))


(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "Help on function ..."

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(HELP-PLASM-FUNCTION-MAC )))

                               :COMMAND-KEY

                               #\>))


(add-menu-items plasm-menu 

                (MAKE-INSTANCE 'MENU-ITEM

                               :MENU-ITEM-TITLE

                               "About ..."

                               :MENU-ITEM-ACTION

                               #'(LAMBDA NIL

                                   (eval-enqueue

                                    `(PLASM-WELCOME )))
                               ))



(menu-install plasm-menu)


(defun HELP-PLASM-FUNCTION-MAC ()
  (declare (special PLASM::**default-fenv** PLASM::**user-fenv**))
  (plasm::HELP-PLASM-FUNCTION
   (first (select-item-from-list 
           (let (functions)
             (maphash (lambda (k d) (declare (special d))
                              (push k functions))
                      PLASM::**default-fenv**)
             (maphash (lambda (k d) (declare (special d))
                              (push k functions))
                      PLASM::**user-fenv**)
             (sort functions 'string<))
           :window-title "Choose a function for HELP"
           :selection-type :single))))


(defun TAKE-STRING ()

  (let ((start-end 

         (multiple-value-list (SELECTION-RANGE 

                               (FRONT-WINDOW)))))

    (if (apply #'> start-end)

      (setq start-end (reverse start-end)))

    (if (char= #\" 

               (buffer-char (FRED-BUFFER (FRONT-WINDOW))

                            (first start-end)))

      (setq start-end (mapcar #'- start-end '(-1 1))))

    (BUFFER-SUBSTRING  

     (FRED-BUFFER (FRONT-WINDOW))

     (first start-end)

     (second start-end))))





(defun TAKE-BUFFER-STRING ()

  (let ((buffer (fred-buffer (front-window)))

      )

    (buffer-substring buffer 0 (buffer-size buffer))))



(defun EVAL-PLASM-BUFFER ()

  (with-open-stream (in (make-string-input-stream

                         (take-buffer-string)) )

    (let (obj)

      (loop

        (if (setf obj (read  in nil nil nil))

          (progn

            (format T "~%~%~A~%~%" obj)

            (plasm::new-eval obj))

          (return (values)))))))



;------------------------------------------------

; Start Up Function for Listener window settings

;------------------------------------------------



;(when **recompile-p

;  (defun set-listener ()

;    (let* ((listener (find-window "Listener")))

;      (set-view-position listener 5 40)

;      (set-view-size listener 600 300)

;      (values)))

;  (setq *restore-lisp-functions*

;        (append *restore-lisp-functions*

;                (list 'set-listener))))






;-------------------------------------------------------------

(setf vrml-menu (make-instance 'menu :menu-title "VRML"))

(setf export-vrml-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Export VRML Last_Value"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (declare (special user::last_value))
                      (eval-enqueue
                       `(IO::EXPORT-POL-COMPLEX-TO-VRML-FILE-FORMAT-FIRST 
                         ',user::last_value)))
                  :COMMAND-KEY #\Z
                  ))

(add-menu-items vrml-menu export-vrml-item)

(setf export-oiv-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Export OpenInventor Last_Value"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (declare (special user::last_value))
                      (eval-enqueue
                       `(IO::EXPORT-IV-FILE 
                         ',user::last_value)))
                  :COMMAND-KEY #\1
                  ))

(add-menu-items vrml-menu export-oiv-item)


(setf set-ver-1-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Set for VRML 1.0"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (eval-enqueue
                       `(progn 
                          (menu-item-disable set-ver-1-item)
                          (IO::set-vrml-ver 1)
                          (menu-item-enable set-ver-2-item))))
                  ))



(add-menu-items vrml-menu set-ver-1-item)

(setf set-ver-2-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Set for VRML 2.0"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (declare (special user::last_value))
                      (eval-enqueue
                       `(progn 
                          (menu-item-disable set-ver-2-item)
                          (IO::set-vrml-ver 2)
                          (menu-item-enable set-ver-1-item)
                          ;--------------------------------------
                          ;(message-dialog "Sorry, work is in progress for that!")
                          ;(menu-item-enable set-ver-2-item)
                          ;(menu-item-disable set-ver-1-item)
                          ;(IO::set-vrml-ver 1)
                          ;-------------------------
                          )))
                  ))

(add-menu-items vrml-menu set-ver-2-item)


(setf export-doubled-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Export doubled faces"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (eval-enqueue
                       `(progn 
                          (menu-item-disable export-doubled-item)
                          (IO::EXPORT-WITH-DOUBLED-FACES)
                          (menu-item-enable dont-export-doubled-item))))
                  ))

(add-menu-items vrml-menu export-doubled-item)

(setf dont-export-doubled-item
      (MAKE-INSTANCE 
                  'MENU-ITEM
                  :MENU-ITEM-TITLE
                  "Don't Export doubled faces"
                  :MENU-ITEM-ACTION
                  #'(LAMBDA NIL
                      (eval-enqueue
                       `(progn 
                          (menu-item-disable dont-export-doubled-item)
                          (IO::DO-NOT-EXPORT-WITH-DOUBLED-FACES)
                          (menu-item-enable export-doubled-item))))
                  ))

(add-menu-items vrml-menu dont-export-doubled-item)



;set default choice
(menu-item-disable set-ver-2-item)
(IO::set-vrml-ver 2)
(menu-item-enable set-ver-1-item)
(menu-item-disable export-doubled-item)
(IO::EXPORT-WITH-DOUBLED-FACES)
(menu-item-enable dont-export-doubled-item)

(menu-install vrml-menu)




;-------------------------------------------------------------
