(eval-plasm "
% ---------------------------------------------%
% codice estratto dal sito plasm               %
% ---------------------------------------------%

DEF IsRealVect = IsSeqOf:IsReal;
DEF IsPoint = IsSeqOf:IsReal;
DEF IsFunVect  = IsSeqOf:IsFun;
DEF IsVect     = OR ~ [IsRealVect,IsFunVect];

DEF vectSum        = AA:+ ~ TRANS;
DEF vectDiff       = AA:- ~ TRANS;
DEF Sqr            = ID * ID;
DEF VectNorm       = SQRT ~ + ~ AA:Sqr;
DEF InnerProd      = + ~ AA:* ~ TRANS;
DEF scalVectProd   = AA:* ~ DISTL;

DEF UnitVect (v::IsVect) = ScalVectProd:<1 / VectNorm:v, v>;
DEF VectProd (u,v::IsVect) = <w1, w2, w3>
    WHERE
      w1 = (u2 * v3) - (u3 * v2),
      w2 = (u3 * v1) - (u1 * v3),
      w3 = (u1 * v2) - (u2 * v1),
      u1 = s1:u,   u2 = s2:u,   u3 = s3:u,
      v1 = s1:v,   v2 = s2:v,   v3 = s3:v
    END;

% ---------------------------------------------%
% codice ad hoc                                %
% ---------------------------------------------%

DEF p1 = <0,0,0>;
DEF p2 = <5,5,0>;
DEF p3 = <10,4,0>;

DEF v1 = p2 vectDiff p1;
DEF v2 = p3 vectDiff p2;

DEF n = UnitVect:v1 VectProd UnitVect:v2;

% ruoto intorno a x cosi' da annullare ny %

DEF Rx (alpha::IsReal) = <
  <1,0,0>,
  <0,COS:alpha,(-~SIN):alpha>,
  <0,SIN:alpha,COS:alpha>
>;

DEF nn = Rx:(ATAN:< S2:n / S3:n>) * AA:LIST:n;

% ruoto intorno a y cosi' da annullare nx %

DEF Ry (alpha::IsReal) = <
  < COS:alpha,    0,SIN:alpha>,
  <0,            1,0>,
  <(-~SIN):alpha,0,COS:alpha>
>;

DEF nnn = Ry:((-~ATAN):< S1:n / S3:n>) * nn;

% la componente z del prodotto vettore dovrebbe contenere %
% il seno (con segno!) dell'angolo tra i due vettori      %

DEF angoloVettori = ((ASIN~S1~S3):nnn) *180/PI;


DEF Make_Vect_Prod (p1,p2,p3::IsPoint) = 
   UnitVect:v1 VectProd UnitVect:v2
 Where 
   v1 = p2 vectDiff p1,
   v2 = p3 vectDiff p2
 End
;

")




(eval-plasm "
DEF NUBspline (degree::IsInt; KnotSeq::IsSeq) (ControlPoints::IsSeq) 
  = MAP:mapping:domain 
WHERE
  % CONSTRAINT: degree = LEN:KnotSeq - LEN:ControlPoints - 1, !! %
  mapping = 
  Blend:(BsplineBasis:degree:KnotSeq):ControlPoints,
  Start = SEL:(degree+1),
  Stop = (APPLY~[SEL~(LEN - K:degree),ID]), 
  Interval = (Stop - Start):KnotSeq,
  n = Interval * splineSampling,
  domain = (S:1:(1 - 1E-8)~QUOTE):(#:n:(Interval/n))
END;
DEF NUBspline (degree::IsInt; KnotSeq::IsSeq) (ControlPoints::IsSeq) 
  = AA:mapping:domain 
WHERE
  % CONSTRAINT: degree = LEN:KnotSeq - LEN:ControlPoints - 1, !! %
  mapping = 
  Blend:(BsplineBasis:degree:KnotSeq):ControlPoints,
  Start = SEL:(degree+1),
  Stop = (APPLY~[SEL~(LEN - K:degree),ID]), 
  Interval = (Stop - Start):KnotSeq,
  n = Interval * splineSampling,
  domain = AA:[id]:(AA:*:(trans:<(#:n:(Interval/n)),1..n>))
END;
DEF Blend (Basis::IsSeq) (ControlPoints::IsSeq) = 
   (CONS~AA:(+~AA:*~TRANS)~DISTL): 
      <Basis,(AA:(AA:K)~TRANS):ControlPoints>;
DEF BsplineBasis (degree::IsInt) (Knots::IsKnotSeq) = 
  AA:DeBoor:(Segments:degree:Knots);
DEF IsKnotSeq = AND~[IsSeqOf:IsReal, IsNonDecr]
WHERE
  IsNonDecr = AND~AA:MyGE~TRANS~[ButLast,TAIL],
  ButLast   = REVERSE~TAIL~REVERSE,
  MyGE      = APPLY~[GE~S1,S2]
END;
DEF Bi (params::IsKnotSeq) = 
IF:<EQ~[LEN,K:2], BaseCase, RecursiveCase>:params 
WHERE 
  ui0 = s1:params, 
  ui1 = s2:params, 
  ui3 = (LAST~LeftParams):params, 
  ui4 = LAST:params, u = s1,
  BaseCase      = 
    K:(IF:<AND~[GE:ui0~S1, LT:ui1~S1], K:1, K:0>), 
  RecursiveCase = 
    +~[K:((u-K:ui0) MyDiv <ui3,ui0>) RAISE:* (Bi~LeftParams),  
       K:((K:ui4-u) MyDiv <ui4,ui1>) RAISE:* 
       (Bi~RightParams)],
  LeftParams  = REVERSE~TAIL~REVERSE,
  RightParams = TAIL 
END;

DEF DeBoor = Bi;
DEF Segments (degree::IsInt) (Knots::IsKnotSeq) = 
  (select~DISTR):<(AA:group~INTSTO):groupLen,Knots>
WHERE
  group = FROMTO~[s1,s1+K:(degree+1)]~LIST, 
  groupLen = (LEN-k:(degree+1)):Knots,
  select = AA:(APPLY~[(AS:SEL)~s1,s2]) 
END;            
DEF MyDiv (a::IsFun; b::IsSeq) = 
  IF:<EQ~[s1,s2], StrangeValues, K:(a/c)>:b 
WHERE  
  StrangeValues = filter~a,      % precondition   a/0     % 
  filter =                       % IF a = 0 then 1 else 0 %
  IF:<testOnZero, (K~K):1, (K~K):0>,  
  testOnZero = (LT:precision)~(ABS~-~[ID,K:0]),
  precision = 1E-12,
  c = (-~[K~s1,K~s2]):b  
END;
DEF splineSampling = 12;
DEF ControlPoints2D = <<0,0>,<-1,2>,<1,4>,<2,3>,<1,1>,<1,2>,<2.5,1>>;
DEF ControlPoints3D = <<0,0,0>,<-1,2,1>,<1,4,3>,<2,3,0>,<1,1,-1>,<1,2,2>,<1,2,2>,<2.5,1,6>>;

DEF Trajectory = NUBspline:<2,<0,0,0,1,2,3,4,4.5,5,5,5>>:ControlPoints3D;

DEF Scaleit (KK::IsReal) (Value::IsReal) = MUL:<KK,Value>;

DEF Scaleit (KK::TT) (Value::TT) = MUL:<KK,Value>;

DEF Scaled_trajectory = AA:(AA:(*~[ID,K:Kfactor])):Trajectory

  where Kfactor = 2 end ;

DEF Scaled_trajectory = AA:(AA:(Scaleit:Kfactor)):Trajectory

  where Kfactor = 2 end ;


DEF Time (TMax::IsInt;Kfactor::IsReal;TStart::Isreal) = 
    AA:(LIST~(K:TStart + ID)~(Scaleit:Kfactor)):(0..TMax);


DEF JoinRows (sequence::ISSeqOf:IsSeq) = INSL:(AA:CAT~TRANS):sequence;

%
 JoinRows:<<<1,2,3>,<4,5,6>,<7,8,9>>,<<8>,<9>,<45>>,<<1,2>,<4,8>,<4,9>>>
 JoinRows:<<<1,2,3>,<4,5,6>,<7,8,9>>,<<8>,<9>,<45>>>
%

DEF MakeDataMotion (space_congiguration_values::IsSeqOf:IsSeq; 
                    Kfactor::IsReal;
                    TStart::Isreal)= 
      JoinRows:<
                Time:<Len:space_congiguration_values - 1 ,Kfactor,TStart>,
                space_congiguration_values
               >;

DEF MyData_Motion = MakeDataMotion:<Scaled_trajectory,1,0> ;


Move:aa:MyData_Motion

")



