;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Project..........:	Graduation Thesis
;;	Module...........:	bool.lsp
;;	Application......:	BSP Library
;;	Version..........:	1.10
;;
;;	Compiler.........:	Common Lisp (CLISP)
;;	Development by...:	Claudio Baldazzi
;;	Internet.........:	baldazzi@inf.uniroma3.it
;;
;;	Copyright........:	Universita' degli studi di Roma TRE
;;						Dipartimento di Informatica e Automazione
;;
;;	Environment......:	CLISP
;;	Beginning........:	18/10/95
;;	Last update......:	01/09/97
;;
;;	-----------------------------------
;;	Abstract:
;;
;;		Thunk file C++ -- Lisp
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
(inpackage kernel)

(setq filein 'buffer.in)
(setq fileout 'buffer.out)

(require 'polsend)
(require 'polrecv)


;;(export '(_union))					;; Future: | or ||
(defun _union (pol-complex-s)
	(setf os (open filein :direction :output))
	(format T "~%Union...~%")
	(sendp (first pol-complex-s) os)
	(sendp (second pol-complex-s) os)
	(close os)
	(shell "cplasm -u")
	(setq result (receive-pol-complex))
	(format T "~%Bye.~%")
	result
)

;;(export '(_intersection))				;; Future: & or &&
(defun _intersection (pol-complex-s)
	(setf os (open filein :direction :output))
	(format T "~%Intersection...~%")
	(sendp (first pol-complex-s) os)
	(sendp (second pol-complex-s) os)
	(close os)
	(shell "cplasm -i")
	(setq result (receive-pol-complex))
	(format T "~%Bye.~%")
	result
)

;;(export '(_difference))				;; Future: - or -- (??)
(defun _difference (pol-complex-s)
	(setf os (open filein :direction :output))
	(format T "~%Difference...~%")
	(sendp (first pol-complex-s) os)
	(sendp (second pol-complex-s) os)
	(close os)
	(shell "cplasm -d")
	(setq result (receive-pol-complex))
	(format T "~%Bye.~%")
	result
)

;;(export '(_sdifference))				;; Future: ^ or ^^
(defun _sdifference (pol-complex-s)
	(setf os (open filein :direction :output))
	(format T "~%Symmetric Differencereg...~%")
	(sendp (first pol-complex-s) os)
	(sendp (second pol-complex-s) os)
	(close os)
	(shell "cplasm -s")
	(setq result (receive-pol-complex))
	(format T "~%Bye.~%")
	result
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;
;;(inpackage plasm)
;;
;;(defun define-function ()
;;	
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'unionr
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(_unionr arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'intersectr
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(_intersectr arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'differencer
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(_differencer arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'sdifferencer
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(_sdifferencer arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Debug
;;
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_send_pc
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(sendpol arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_send_2pc
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(sendpols arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_recv_pc
;;      (plasm-function-formal-pars ffunc) '()
;;      (plasm-function-body ffunc) '(receive-pol-complex) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_send_obj
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(sendobj arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; For Fabio
;;
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_ex_recv_pc_begin
;;      (plasm-function-formal-pars ffunc) '()
;;      (plasm-function-body ffunc) '(receive-pol-complex-ex-begin) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_ex_recv_pc_end
;;      (plasm-function-formal-pars ffunc) '()
;;      (plasm-function-body ffunc) '(receive-pol-complex-ex-end) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;	(setf ffunc (make-plasm-function)
;;      (plasm-function-name ffunc) 'bool_ex_recv_pc
;;      (plasm-function-formal-pars ffunc) '(arg0)
;;      (plasm-function-body ffunc) '(receive-pol-complex-ex arg0) 
;;      (plasm-function-called-function ffunc) nil
;;      (plasm-function-calling-function ffunc) nil
;;      (plasm-function-value ffunc) nil
;;      (plasm-function-pol-value ffunc) nil
;;	)
;;	(insert-in-user-fenv ffunc)
;;
;;)
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;(define-function)
;;


