; -*- package: kernel -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Proietti Giuseppe  (1/4/1993)
;
; Funzioni per collegare le routines scritte per Simplexn
; per il calcolo dei limiti dei complessi poliedrali
; a PLASM

(provide 'limits)

(inpackage kernel)

(export '(mins maxs mins-maxs))

(require 'mypl)
(require 'pol_c_f)
(require 'pol_c_v)

;
; input  : lista di indici di coordinate
;          complesso poliedrale

; output : lista dei valori minimi delle coordinate specificate
;           che limitano l'occupazione del complesso
(defun mins (coord-list pol-complex)
  (pol-complex-limits pol-complex (mapcar #'1- coord-list) 'min)
  )
;
; input  : lista di indici di coordinate
;          complesso poliedrale

; output : lista dei valori massimi delle coordinate specificate
;           che limitano l'occupazione del complesso
(defun maxs (coord-list pol-complex)
  (pol-complex-limits pol-complex (mapcar #'1- coord-list) 'max)
  )

;
; input  : lista di indici di coordinate
;          complesso poliedrale

; output : lista di 2 sottoliste, contenenti la prima i valori
;           minimi delle coordinate specificate e la seconda i
;           valori massimi delle stesse coordinate che limitano
;           l'occupazione del complesso
(defun mins-maxs (coord-list pol-complex)
  (list
   (pol-complex-limits pol-complex (mapcar #'1- coord-list) 'min)
   (pol-complex-limits pol-complex (mapcar #'1- coord-list) 'max)
   )
  )
