;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Il seg. modulo contiene le funzioni per costruire il poligono ;;
;; di controllo su ogni patch triangolare di un complesso        ;;
;; poliedrale 2,3 in modo da ottenere una superficie c1.         ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(inpackage kernel)

(provide 'fitting)

(export '(Fit-Pol-complex))

(require 'cub_ext)
(require 'mat_c1)
(require 'geometry)
(require 'immersio)
(require 'step1)
(require 'step2)
(require 'step3)
(require 'step4)
(require 'io_ext3)

;-------------------------------------------------------------------------
; La seg. funzione e' la main dell'algoritmo per l'incurvamento dei 
; simplessi.
;-------------------------------------------------------------------------

(defun Fit-Pol-Complex (pol-complex
                        &aux fit-pc)
 
  (let ((tab-v (make-hash-table :test 'equal)))


(print "GO fitting!!!!!!!!!!!!!!!!!!!!!!!")

   ; (if (not (lisp-extension::symbol-equal (get-pol-complex-rep pol-complex)
   ;                                         'On-Vertices))
   ;   (setq fit-pc (coerce-pol-complex pol-complex 'On-Vertices))
      (setq fit-pc pol-complex)
   ;)

    ;immersione in coord mondo
    (setq fit-pc (Eval-Pol-Complex fit-pc))

    (setq fit-pc (split-pol-complex-with-centroid fit-pc))

    (setq fit-pc (alg-c1-pol-complex fit-pc tab-v))

;;(io::print-pol-complex fit-pc)

     fit-pc))


;-------------------------------------------------------------------------
; La seg. funzione visita la struttura di complesso poliedrale
; ------------------------------------------------------------------------

(defun Alg-C1-Pol-Complex (obj tab-v)
  (cond ((polyhedron?      obj) (Alg-C1-Pol obj tab-v))
        ((polyhedra-complex? obj)
          (mapcar  #'(lambda (nodo) (Alg-C1-Pol-Complex nodo tab-v)) obj))
        ((polyhedral-node? obj)
         (progn
           (make-pol-node 
             (Alg-C1-Pol-Complex (get-node-pol-complex obj) tab-v)
             (get-node-matrix obj)
             (get-node-id obj) ))) ))


;-------------------------------------------------------------------------
; La seg. funzione visita le celle del poliedro dato in input
;-------------------------------------------------------------------------

(defun Alg-C1-Pol (pol tab-v)
  (let ((cells (get-cells pol))
        (vlist-pol (polyhedron-VLIST pol)))

    (maphash #'(lambda (id cell)
      (let* ((vlist-id-cell (get-cell-vertices cell))
             ;(vlist-cell (get-coord-vlist vlist-id-cell vlist-pol))
              )
      
        (dotimes (i (length vlist-id-cell))
          (if (not (in-tab? (nth i vlist-id-cell) tab-v))
            (progn
              (put-in-tab (nth i vlist-id-cell) tab-v)
              (setf (gethash id cells) (set-point-type1 (nth i vlist-id-cell) 
                                                         cell 
                                                         pol))))))

        (set-point-type2 cell pol)  ;step3
        (set-point-type3 cell))     ;step4
     cells)
                 ;; restituisce il poliedro modificato
  pol ))

;-------------------------------------------------------------------------
; La seg. funzione mi dice se un vertice era gia' stato visitato
;-------------------------------------------------------------------------
(defun in-tab? (id tab
                &aux (YorN T))
  (if (equal (gethash id tab) nil)
    (setq YorN nil))
  YorN)

;-------------------------------------------------------------------------
; La seg. funzione mette un vertice nella tabella
;-------------------------------------------------------------------------
(defun put-in-tab (id tab)
  (setf (gethash id tab) id))



