
(inpackage kernel)

(provide 'eval)

(require 'matlib)

(use-package 'matlib)

(export '(Eval-Pol-Complex))


;----------------------------------------------------------------------
;La seg. funzione immerge un poliedro complesso in coordinate mondo
;----------------------------------------------------------------------


(defun Eval-Pol-Complex (obj &optional mat)
  (cond ( (polyhedron?      obj) (Eval-Pol obj mat))
	( (polyhedra-complex? obj)
	  (mapcar  #'(lambda (nodo) (Eval-Pol-Complex nodo mat)) obj) )
	( (polyhedral-node? obj)
	  (progn
	    (if (null mat) 
	      (setq mat (get-node-matrix obj))
	      ;else
	      (setq mat  (mat-product-extended mat (get-node-matrix obj)) ) )
	    (make-pol-node 
	     (Eval-Pol-Complex (get-node-pol-complex obj) mat)
	     (mat-identity (car (array-dimensions mat)))
	     (get-node-id obj))))))


;----------------------------------------------------------------------
;La seg. funzione valuta un poliedro rappresentato tramite vertici 
;in base alla matrice passata in mat.
;----------------------------------------------------------------------


(defun Eval-Pol (pol mat)
  (let* ((Vertici (get-vlist pol))
	  newpol)

    ;calcolo dei vertici in base alla matrice specificata
    (if (not (null mat))
      (setq vertici (mapcar 
		   #'(lambda (vertice) 
		      (list 
		       (first vertice)
		       (cdr (coerce (matlib::mat-vet-product 
				mat
				(coerce (cons 1 (second vertice)) 'vector)) 
			       'list)) ))
		      vertici)))
   (setf (polyhedron-VLIST pol) vertici)
   
    pol))


