; -*- package: extrusion -*-

; Intersezione di estrusioni generalizzata (16/4/93)

(provide 'g_int)

(inpackage extrusion)

(require 'eval)

(export '(Intersection-of-Extrusions-on-Complexes))

(defun Intersection-of-Extrusions-on-Complexes (COMPL1 COMPL2 COINCIDENT-COORD-LIST)
    (setq compl1 (Push-Down-Transf-Pol-Complex compl1))  ;valutazione del primo complesso
    (setq compl2 (Push-Down-Transf-Pol-Complex compl2))  ;valutazione del secondo complesso
    (int-of-extr-complex-to-complex compl1 compl2 coincident-coord-list))

(defun Int-of-extr-complex-to-complex ( compl1 compl2 coinc-clist)
  (cond 
   ((polyhedron?      compl1)
    (Int-of-extr-polyhedron-to-complex compl1 compl2 coinc-clist))
   ((polyhedra-complex? compl1)
    (remove '(nil)
            (remove nil (mapcar #'(lambda (nodo) 
                            (Int-of-extr-complex-to-complex nodo compl2 coinc-clist)) compl1)
                    :test 'equalp)
            :test 'equalp))
   ((polyhedral-node? compl1)
    (let ((result (Int-of-extr-complex-to-complex 
                   (get-node-pol-complex compl1)
                   compl2 coinc-clist)))
      (if  (and result
                (polyhedra-complex? result))
        ;(and result
        ;       (not (equalp result '(nil)))) 
        (make-pol-node
         result
         nil
         (get-node-id compl1))
        nil)))))



;------------------------------------------------------------------------------------------------
; Esegue l'intersezione di estrusioni tra' un poliedro ed un complesso poliedrale, ritornando
; il complesso poliedrale in cui ogni poliedro e' stato sottoposto ad intersezione di
; estrusioni con il poliedro fornito.
; Presuppone che il complesso sia gia' stato valutato, ossia che tutte le matrici di trasformazione 
; nel complesso siano state ridotte a matrici identita', in quanto non esegue alcuna trasformazione
; geometrica ed ignora le matrici suddette.

(defun Int-of-extr-polyhedron-to-complex (pol obj coinc-clist)
  (cond ((polyhedron?      obj) 
         (let ((result (Intersection-of-extrusions pol obj coinc-clist)))
           (if (polyhedron? result) result 
               '(filiberto))))
        ((polyhedra-complex? obj)
         (remove '(nil) (remove nil (mapcar  #'(lambda (nodo) (Int-of-extr-polyhedron-to-complex pol nodo coinc-clist)) obj)
                                :test 'equalp)
                 :test 'equalp))
        ((polyhedral-node? obj)
         (let ((result (Int-of-extr-polyhedron-to-complex pol (get-node-pol-complex obj) coinc-clist)))
          (if (and result
                (polyhedra-complex? result))
            ;(and result
            ;  (not (equalp result '(nil))))
            (progn
            (make-pol-node 
             result
             nil
             (get-node-id obj))))))))
