; -*- package: dvrlib -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;           Universita' di Roma "La Sapienza"                               ;
;       Dipartimento di Informatica e Sistemistica                          ;
;            Via Buonarroti 12 - 00185 Roma                                 ;
;                                                                           ;
;                      CAD Group                                            ;                    
;                                                                           ;
; Project: SimpleXn                                                         ;
; Identification: Package Driver Library                                    ;                                
;                                                                           ;
;  Version: 1.0                                                             ;
;                                                                           ;
;  Author: V. Ferrucci                                                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(provide 'dvrlib)                        ;module name

(defpackage dvrlib)

(inpackage dvrlib) ;package name

(export '(prompt-for-a-new-file
	  prompt-for-an-existing-file))

#+:APPLE 
(use-package 'ccl)

;-----------------------------------------------------------------
; File system interaction functions
;-----------------------------------------------------------------

 
  #+:APPLE 
    (setq $$pol-default-pathname "poly;")
  
  #+:RS6000 
    (setq $$pol-default-pathname
      (concatenate 
	     'string user::**simplexn-directory 
	     "/polyhed"))
  
  #+:DOS   
    (setq $$pol-default-pathname
      (concatenate 
	     'string user::**simplexn-directory 
	     "\\polyhed"))
  
  #-:RS6000 
  #+:UNIX 
    (setq $$pol-default-pathname
      (concatenate 
	     'string user::**simplexn-directory 
	     "/polyhed"))
    
  #+:akcl 
    (setq $$pol-default-pathname 
      (concatenate 
	     'string user::**simplexn-directory 
	     "/polyhed"))
  

(setq $$pol-default-name "untitled.pol")


(defun prompt-for-a-new-file 
  (&optional (dirstring  $$pol-default-pathname)
	     (namestring $$pol-default-name))
  
  #+:APPLE 
  (choose-new-file-dialog :directory (concatenate 'string dirstring namestring)
			  :prompt "Save as..")
  
  #+:RS6000 
  (progn
    (format t "~%Type in the name of a non existing file (default is overwrite): ~%")
    (make-pathname 
     :directory $$pol-default-pathname
     :name (read)
     :type "pol"))

  #+:CLISP 
  (progn
    (format t "~%Type in the name of a non existing file (default is overwrite): ~%")
    (make-pathname 
     :directory $$pol-default-pathname
     :name (read)
     :type "pol"))

  #+:akcl 
  (progn
    (format t "~%Type in the name of a non existing file (default is overwrite): ~%")
    (make-pathname 
     :directory (list $$pol-default-pathname)
     :name (read)
     :type "pol"))
  )



(defun prompt-for-a-new-file 
  (&optional (dirstring  $$pol-default-pathname)
	     (namestring $$pol-default-name))
  #+:APPLE 
  (choose-new-file-dialog :directory (concatenate 'string dirstring namestring)
			  :prompt "Save as..")
;  #+:RS6000 
;  (let (new-name)
;    (format t "~%Type in the direct of a non existing file (default is overwrite,~%~
;	       default name is ~A): ~%" 
;	    (concatenate 'string $$pol-default-pathname "/"  $$pol-default-name))
;    (setq new-name (read))
;    (if (and (stringp new-name)
;	     (> (length new-name) 0))
;      nil
;      (setq new-name (concatenate 'string 
;				  $$pol-default-pathname
;				  $$pol-default-name)))
;    (make-pathname 
;     :directory (pathname-directory new-name)
;     :name (pathname-name new-name)
;     :type "pol"))

  #+:DOS 
  (let (new-name)
    (format t "~%Type in the direct of a non existing file (default is overwrite,~%~
	       default name is ~A): ~%" 
	    (concatenate 'string $$pol-default-pathname "\\"  $$pol-default-name))
    (setq new-name (read))
   ; (if (and (stringp new-name)
;	     (> (length new-name) 0))
;      nil
;      (setq new-name (concatenate 'string 
;				  $$pol-default-pathname
;				  $$pol-default-name)))
    (make-pathname 
     :directory (pathname-directory new-name)
     :name (pathname-name new-name)
     :type "pol"))

  
  
  #+:UNIX  
  (let (new-name)
    (format t "~%Type in the direct of a non existing file (default is overwrite,~%~
	       default name is ~A): ~%" 
	    (concatenate 'string $$pol-default-pathname "/"  $$pol-default-name))
    (setq new-name (read))
    ;(if (and (stringp new-name)
;	     (> (length new-name) 0))
;      nil
;      (setq new-name (concatenate 'string 
;				  $$pol-default-pathname
;				  $$pol-default-name)))
    (make-pathname 
     :directory (pathname-directory new-name)
     :name (pathname-name new-name)
     :type "pol"))
	 
  #+:akcl 
  (progn
    (format t "~%Type in the name of a non existing file (default is overwrite): ~%")
    (make-pathname 
     :directory (list $$pol-default-pathname)
     :name (read)
     :type "pol"))
  )







(defun prompt-for-an-existing-file (&optional (dirstring $$pol-default-pathname))
  
  #+:APPLE 
  (choose-file-dialog :directory dirstring)
  
  #+:RS6000 
  (progn
    (format t "~%Type in the name of an existing file: ~%")
    (make-pathname 
     :directory $$pol-default-pathname
     :name (read)
     :type "pol"))
  
  #+:CLISP 
  (progn
    (format t "~%Type in the name of an existing file: ~%")
    (make-pathname 
     :directory $$pol-default-pathname
     :name (read)
     :type "pol"))
  
  
  #+:akcl 
  (progn
    (format t "~%Type in the name of an existing file: ~%")
    (make-pathname 
     :directory (list $$pol-default-pathname)
     :name (read)
     :type "pol"))
  )


(defun PROMPT-FOR-A-NEW-FILE 
  (&optional (dirstring  $$pol-default-pathname)
	     (namestring $$pol-default-name))
  
  #+:APPLE 
  (choose-new-file-dialog :directory  (if (directoryp dirstring)
					(concatenate 'string                                                   
						     dirstring
						     namestring)
					(return-desktop-file))
						   
			  :prompt "Save as..")
  
;  #+:RS6000 
;  (let (new-name)
;    (format t "~%Type in the direct of a non existing file ~%(default is overwrite,~
;	       default name is ~A): " 
;	    (concatenate 'string $$pol-default-pathname "/"   $$pol-default-name))
;    (setq new-name (read))
;    (if (and (stringp new-name)
;	     (> (length new-name) 0))
;      nil
;      (setq new-name (concatenate 'string 
;				  $$pol-default-pathname
;				  $$pol-default-name)))
;    (make-pathname 
;     :directory (pathname-directory new-name)
;     :name (pathname-name new-name)))
  
  #+:DOS 
  (let (new-name)
    (format t "~%Type in the direct of a non existing file ~%(default is overwrite,~
	       default name is ~A): " 
	    (concatenate 'string $$pol-default-pathname "\\"   $$pol-default-name))
    (setq new-name (read))
    (if (and (stringp new-name)
	     (> (length new-name) 0))
      nil
      (setq new-name (concatenate 'string 
				  $$pol-default-pathname
				  $$pol-default-name)))
    (make-pathname 
     :directory (pathname-directory new-name)
     :name (pathname-name new-name)))
  
  
  #+:UNIX 
   (let (new-name)
     (format t "~%Type in the direct of a non existing file ~%(default is overwrite,~
		default name is ~A): " 
	     (concatenate 'string $$pol-default-pathname "/"   $$pol-default-name))
     (setq new-name (read))
  ;   (if (and (stringp new-name)
;	      (> (length new-name) 0))
;       nil
;       (setq new-name (concatenate 'string 
;				   $$pol-default-pathname
;				   $$pol-default-name)))
     (make-pathname 
      :directory (pathname-directory new-name)
      :name (pathname-name new-name)
      :type (pathname-type new-name)))
  
  #+:akcl 
  (progn
    (format t "~%Type in the name of a non existing file (default is overwrite): ~%")
    (make-pathname 
     :directory (list $$pol-default-pathname)
     :name (read)
     :type "pol"))
  )



(defun PROMPT-FOR-AN-EXISTING-FILE (&optional (dirstring $$pol-default-pathname))
  #+:APPLE 
  (choose-file-dialog :directory (if (directory dirstring) 
				   dirstring
				   (return-desktop-path)))
;  #+:RS6000 
;  (progn
;    (format t "~%Type in the name of an existing file: ~%")
;    (let* ((file (read))
;	   (dir (directory-namestring file))
;	   (name (file-namestring file)))
;      (make-pathname 
;	:directory (if (string= "./" dir) $$pol-default-pathname dir)
;	:name name)))
  
  #+:DOS 
  (progn
    (format t "~%Type in the name of an existing file: ~%")
    (let* ((file (read))
	   (dir (directory-namestring file))
	   (name (file-namestring file)))
      (make-pathname 
	:directory (if (string= "" dir) $$pol-default-pathname dir)
	:name name)))
  
  
  #+:UNIX 
   (progn
     (format t "~%Type in the name of an existing file: ~%")
     (let* ((file (read))
	    (dir (directory-namestring file))
	    (name (file-namestring file)))
     (make-pathname 
      :directory (pathname-directory file)
      :name (pathname-name file)
      :type (pathname-type file))))

    ;   (make-pathname 
    ;	 :directory (if (string= "./" dir) $$pol-default-pathname dir)
    ;	 :name name)))

  
  #+:akcl 
  (progn
    (format t "~%Type in the name of an existing file: ~%")
    (make-pathname 
     :directory (list $$pol-default-pathname)
     :name (read)
     :type "pol"))
  )

(defun RETURN-DESKTOP-PATH ()
  (let ((path (mac-directory-namestring  (first (directory "*")))))
    (concatenate 'string
		 (subseq path 0 (position #\: path))
		 ":Desktop Folder:")))
  
(defun RETURN-DESKTOP-FILE (&optional (type ""))
  (concatenate 'string
	       (return-desktop-path)
	       "untitled."
	       type))
  
















