;-----------------------------------------------------------------
;
;  Initialization for SimpleXn.
;  
;  Created  29-03-90
;  Modified May  1997
;
;
;-----------------------------------------------------------------
;(provide 'simplexn.go )  ;;* Modificato *

;-----------------------------------------------------------------------------
#+:APPLE
(load (concatenate 'string (directory-namestring (mac-default-directory))
                   "library:logical-dir-compatibility.lisp"))
;----------------------------------------------------------------------------


#+:APPLE
(DEFPACKAGE COMMON-LISP-USER (:nicknames user))

#+:CLISP 
 (setq *read-default-float-format* 'double-float)

(defpackage plasm)
 
#+:APPLE
(progn
  (setf *autoload-lisp-package* T)
  (setf *.lisp-pathname* (make-pathname :type "lsp"))
  (in-package  COMMON-LISP-USER))


;-----------------------------------------------------------------
; Only this part of the file needs to be changed
; Screen sizes : big      (SuperMac monitor)
;                medium   (Mac II standard monitor)
;                small    (SE/30 or SE standard monitor)
; Color monitor : t or nil
; Hard disk name here (no colon)
;-----------------------------------------------------------------
#+:RS6000 
(import 'inpackage 'lisp)
#+:RS6000
(export 'inpackage  'lisp)

#+:RS6000
(defmacro lisp:inpackage (package-name)
  `(in-package ,package-name))

#+:CLISP
(import 'inpackage 'lisp)
#+:CLISP
(export 'inpackage  'lisp)
#+:CLISP
(defmacro lisp:inpackage (package-name)
  `(in-package (quote ,package-name)))


;versione MCL 3.1
#+:APPLE
(import 'inpackage 'common-lisp)
(export 'inpackage  'common-lisp)
(defmacro common-lisp:inpackage (package-name)
  `(in-package ,package-name))


#+:RS6000 (excl:without-package-locks (in-package common-lisp)) 

#+:RS6000 (excl:without-package-locks (import 'inpackage 'user))

#+:RS6000 (excl:without-package-locks 
             (defmacro inpackage (package-name)
                `(in-package ,package-name)))
#+:RS6000 (excl:without-package-locks (export 'inpackage))
#+:RS6000 (import 'without-floating-point-underflow 'lisp)
#+:RS6000 (export 'without-floating-point-underflow 'lisp)
#+:RS6000 (defun lisp::without-floating-point-underflow (x) x)


#+:APPLE
(progn

  (defvar **screen 'big)
  (defvar **color t)

  (if (not (boundp '*PLASM-COMPILING*))
    (defvar **disk-name 
      (get-string-from-user  "Type the name of your Apple disk:" 
			     :initial-string "Macintosh HD")))
  )
    

; this is the pathname to the SimpleXn directory

(if (not (boundp '*PLASM-COMPILING*))
  (defvar **simplexn-directory
    #+:APPLE
    (get-string-from-user  "Type path to Simplexn directory:" 
			   :initial-string 
			   (concatenate 'string **disk-name ":SimpleXn"))
    
    #+:RS6000 (concatenate 'string **path-to-all-code "simplexn")           
    ;#-:RS6000
    #+:UNIX   (concatenate 'string **path-to-all-code "simplexn")
    #+:DOS    (concatenate 'string **path-to-all-code "simplexn") ))


;-----------------------------------------------------------------
; Image Dumping
;-----------------------------------------------------------------

(if (not (boundp '*PLASM-COMPILING*))
  (setq **recompile-p 
	#+:APPLE (y-or-n-dialog
		  "Do you want to compile SimpleXn and 
substitute the present image on the disk?" :cancel-text nil)
	#+:RS6000 t
        #+:UNIX t
	#+:DOS t
	;  (y-or-n-p
	;   "Do you want to compile SimpleXn and
	;substitute the present image on the disk?  ")
	))




;-----------------------------------------------------------------
; Define package names 
;-----------------------------------------------------------------



   (defpackage triangulation)
 
   (defpackage boole)
 
   (defpackage intersect)   
 
   (defpackage pl)
 
   (defpackage newtriangulation)
 
   (defpackage mapper)
 
   (defpackage newmapper)
 
;   (defpackage newnurbs)




;-----------------------------------------------------------------
; Logical pathnames definitions  - only for Macintosh
;-----------------------------------------------------------------

#+:APPLE
(progn 
  (def-logical-directory "core"  
    (concatenate 'string **simplexn-directory ":kernel"))
  (def-logical-directory "boole" 
    (concatenate 'string **simplexn-directory ":Boole"))
  (def-logical-directory "bool" 
    (concatenate 'string **simplexn-directory ":Bool"))
  (def-logical-directory "integr" 
    (concatenate 'string **simplexn-directory ":Integr"))
  (def-logical-directory "poly;" 
    (concatenate 'string **simplexn-directory ":Polyhedra"))
  (def-logical-directory "mapping" 
    (concatenate 'string **simplexn-directory ":Mapping"))
  (def-logical-directory "open_set" 
    (concatenate 'string **simplexn-directory ":open_set"))
  (def-logical-directory "faces_cc"  
    (concatenate 'string **simplexn-directory ":faces_cc"))
  (def-logical-directory "SimpleXn" **simplexn-directory)
  )



#+:APPLE
(setf *module-search-path* 
      (append  
       '("faces_cc;" "SimpleXn;" "poly;" "core;" "boole;"
         "bool;"  
         "integr;" "mapping;" "open_set;" ":faces_cc;")
       *module-search-path*))

;#+:APPLE
;(load "ccl;font-menus")

;-----------------------------------------------------------------
; Logical pathnames definitions  - only for IBM RISC6000
;-----------------------------------------------------------------
#+:RS6000
(setq system:*require-search-list*
      '(:first
	(:newest-do-compile
	 #.(make-pathname :directory
	  (concatenate 'string **simplexn-directory "/kernel") :type "fasl")

	 #.(make-pathname :directory
	  (concatenate 'string **simplexn-directory "/kernel") :type "lsp")

	 #.(make-pathname :directory
	  (concatenate 'string **simplexn-directory "/boole") :type "lsp")

	;-----------------------------------------
	;aggiunta per integrare funzioni booleane
	;-----------------------------------------
	 #.(make-pathname :directory
	  (concatenate 'string **simplexn-directory "/bool") :type "lsp")

	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/integr") :type
								"lsp")	 
	 
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/mapping") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/patches") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/open_set") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc/int_extr") :type
								 "lsp")

	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc/box") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc/genpol") :type
								 "lsp")
	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc/mapper") :type
								 "lsp")
;	 #.(make-pathname :directory
;	   (concatenate 'string **simplexn-directory "/faces_cc/nurbs") :type
;								 "lsp")	
         #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc/curvext") :type
                                                                 "lsp")

	 #.(make-pathname :directory
	   (concatenate 'string **simplexn-directory "/faces_cc") :type
								 "fasl")
	 )
	excl::*library-code-fasl-pathname*
	excl::*library-code-cl-pathname*
	 excl::*library-code-bin-pathname*))


;#-:RS6000
#+:UNIX
(setq *LOAD-PATHS* 
  (append *LOAD-PATHS*  
	  (list (concatenate 'string **simplexn-directory "/kernel/")
		(concatenate 'string **simplexn-directory "/boole/")
		(concatenate 'string **simplexn-directory "/integr/")
		;AGGIUNTA FUNZIONI BOOLEANE
		(concatenate 'string **simplexn-directory "/bool/")
		(concatenate 'string **simplexn-directory "/mapping/")
		(concatenate 'string **simplexn-directory "/patches/")
		(concatenate 'string **simplexn-directory "/open_set/")
		(concatenate 'string **simplexn-directory "/faces_cc/")
		(concatenate 'string **simplexn-directory "/faces_cc/int_extr/")
		(concatenate 'string **simplexn-directory "/faces_cc/box/")
		(concatenate 'string **simplexn-directory "/faces_cc/genpol/")
		(concatenate 'string **simplexn-directory "/faces_cc/mapper/")
;		(concatenate 'string **simplexn-directory "/faces_cc/nurbs/")
                (concatenate 'string **simplexn-directory "/faces_cc/curvext/")
		(concatenate 'string **simplexn-directory "/faces_cc/"))))

#+:DOS
(setq *LOAD-PATHS* 
  (append *LOAD-PATHS*  
	  (list (concatenate 'string **simplexn-directory "\\kernel\\")
		(concatenate 'string **simplexn-directory "\\boole\\")
		(concatenate 'string **simplexn-directory "\\integr\\")
		;OPERAZIONI BOOLEANE
		(concatenate 'string **simplexn-directory "\\bool\\")
		(concatenate 'string **simplexn-directory "\\mapping\\")
		(concatenate 'string **simplexn-directory "\\patches\\")
		(concatenate 'string **simplexn-directory "\\open_set\\")
		(concatenate 'string **simplexn-directory "\\faces_cc\\")
		(concatenate 'string **simplexn-directory "\\faces_cc\\int_extr\\")
		(concatenate 'string **simplexn-directory "\\faces_cc\\box\\")
		(concatenate 'string **simplexn-directory "\\faces_cc\\genpol\\")
		(concatenate 'string **simplexn-directory "\\faces_cc\\mapper\\")
;		(concatenate 'string **simplexn-directory "\\faces_cc\\nurbs\\")
                (concatenate 'string **simplexn-directory "\\faces_cc\\curvext\\") 
		(concatenate 'string **simplexn-directory "\\faces_cc\\"))))

;-----------------------------------------------------------------
; Window settings  - only for Macintosh
;-----------------------------------------------------------------
;#+:APPLE
;(cond 
; ((equal **screen 'big) ;;window settings  for a Mac II with SuperMac monitor
;  (setq *listener-window-position* (make-point 4 40))
;  (setq *listener-window-size* (make-point 300 700))
;  (setq *fred-window-position* (make-point 320 50))
;  (setq *fred-window-size* (make-point 600 700)))
; ((equal **screen 'medium) ;;window settings  for a Mac II monitor
;  (setq *listener-window-position* (make-point 4 40))
;  (setq *listener-window-size* (make-point 270 400))
;  (setq *fred-window-position* (make-point 0 38))
; (setq *fred-window-size* (make-point 512 190)))
; ((equal **screen 'small) ;;window settings  for a Mac SE/30
;  (setq *listener-window-position* (make-point 0 250))
;  (setq *listener-window-size* (make-point 512 92))
;  (setq *fred-window-position* (make-point 0 38))
;  (setq *fred-window-size* (make-point 512 190)))
; (t "Unknown screen type: check file SimpleXn.start"))

;-----------------------------------------------------------------
; Window zoom position  - only for Macintosh
;-----------------------------------------------------------------
;#+:APPLE
;(ask *fred-window*
;  (setq window-zoom-position
;        (make-point 0  *menubar-bottom*)
;        window-zoom-size
;        (make-point *screen-width* *screen-height*)))
 
;-----------------------------------------------------------------
; Environment settings  - only for Macintosh
;-----------------------------------------------------------------
#+:APPLE
(setq *save-doc-strings* t)
#+:APPLE
(setq *save-fred-window-positions* t)
#+:APPLE
(setq *save-definitions* t)

;; This does not permit the use of apply-hook,
;; but Lisp code run faster

#+:APPLE
(setq *fast-eval* t)

;(preload-all-functions)
;(purge-functions nil)

;(setq *load-verbose* t)
;(setq *warn-if-redefine* nil)
;(setq *print-array* nil)
;(setq *verbose-eval-selection* t)
;(setq *emacs-mode* nil)
;(setq *break-on-errors* nil)
;(setq *next-screen-context-lines* 5)
;(setq *print-case* :downcase)
;(setq *save-local-symbols* t)
;(setq *fasl-save-local-symbols* t)
;(setq *compiler-warnings* t)
;(setq *fasl-compiler-warnings* t)


; Main packages 

;(when **recompile-p
  (proclaim '(optimize speed))
  
  ;;;; This setting does not permit the use of the stepper,
  ;;;; but a lot of memory space is saved
  
  (setq *save-definitions* nil)
  (setq load-verbose t)
  
;;  (mapc #'(lambda (the-package)
;;            (require the-package)
;;            (use-package the-package))
;;        '(kernel io extrusion dvrlib bound #+:APPLE maclib ))
  
(require 'kernel)                ;; * Modificato *
(use-package 'kernel)
(require 'io)
(use-package 'io)
(require 'extrusio)    
(use-package 'extrusion)
(require 'dvrlib)
(use-package 'dvrlib)
(require 'bound)
(use-package 'bound)

;------REMOVED TO GET COMPILED SIMPLEXn INTO MCL 5.0 ON MAC OSX-------------
;#+:APPLE (require 'maclib)        ;versione MCL 3.1
;#+:APPLE (use-package 'maclib)



(setq *save-definitions* t)



  
; Auxiliary packages; new packages must be put here 

(when **recompile-p 
  (defun use-integration ()
    (require 'integr)
    (use-package 'integration))
  (defun use-boole ()
    (require 'boole)
    (use-package 'boole))
  (defun use-mapping ()
    (require 'mapper)
    (use-package 'mapper))
  ; (defun use-nurbs ()
  ;   (require 'nurbs)
  ;   (use-package 'nurbs))
  (defun use-utilities ()
    (require 'utility)))
    ;;(use-package 'utilities)
  
; Start Up Function
#+:APPLE
(if (not (boundp '*PLASM-COMPILING*))
(when **recompile-p
  (defun SimpleXn-welcome ()
    (format t
	    "

	     Welcome in 
	 **** SimpleXn ****
   Simplicial Decompositions for
      Modeling In N Dimensions

	  Version: June 1997

;--------------------------------------
;The following auxiliary packages are 
;currently available: evaluate the 
;corresponding function to use them.;
;
;
;integration          (use-integration)
;boolean operations   (use-boole)
;mapping              (use-mapping)
;nurbs                (use-nurbs)
;utilities            (use-utilities)
;--------------------------------------

"))
  (setq *restore-lisp-functions*
	(append *restore-lisp-functions* 
		(list 'SimpleXn-welcome)))))

; Start Dumping

;#+:APPLE
;(when **recompile-p
;  (cond 
;   ((equal **screen 'big) (big-mac))
;   ((equal **screen 'medium) (medium-mac))
;   ((equal **screen 'small) (little-mac))
;   (t "Unknown screen type: check file SimpleXn.start"))
;  (dumplisp "SimpleXn;SimpleXn.image"))



;-----------------------------------------------------------------------------


(defvar **extension-directory
  #+:APPLE
  (concatenate 'string **simplexn-directory ":faces_cc")
  #+:RS6000 
  (concatenate 'string **simplexn-directory "/faces_cc")
  ;#-:RS6000
  #+:UNIX 
  (concatenate 'string **simplexn-directory "/faces_cc")
  #+:DOS 
  (concatenate 'string **simplexn-directory "\\faces_cc")
  )



#+:APPLE
(def-logical-directory "box"  
  (concatenate 'string **extension-directory ":box"))




#+:APPLE
(def-logical-directory "genpol"  
  (concatenate 'string **extension-directory ":genpol"))



#+:APPLE
(def-logical-directory "inter-extr"  
  (concatenate 'string **extension-directory ":int-extr"))

#+:APPLE
(setf *module-search-path* 
      (append  
       '("box;" "genpol;" "inter-extr;")
       *module-search-path*))

#+:APPLE
(def-logical-directory "mapper"  
  (concatenate 'string **extension-directory ":mapper"))

#+:APPLE
(setf *module-search-path* 
      (append  
       '("mapper;")
       *module-search-path*))

;#+:APPLE
;(def-logical-directory "nurbs"  
;  (concatenate 'string **extension-directory ":nurbs"))

;#+:APPLE
;(setf *module-search-path* 
;      (append  
;       '("nurbs;")
;       *module-search-path*))

#+:APPLE
(def-logical-directory "curvext"  
  (concatenate 'string **extension-directory ":curvext"))

#+:APPLE
(setf *module-search-path* 
      (append  
       '("curvext;")
       *module-search-path*))

#+:APPLE
(def-logical-directory "int_extr"  
  (concatenate 'string **extension-directory ":int_extr"))

#+:APPLE
(setf *module-search-path* 
      (append  
       '("int_extr;")
       *module-search-path*))



(require 'pol_c_ex)
(require 'embed)
;                          (defpackage io)
(require 'io_ext)
(require 'io_ext2)

(require 'new_extr)
(use-package 'extrusion)


(require 'buildpc)

(require 'limits)




(require 'mapping)

(require 'fitting)

(print '---------------------------------)

(require 'int_extr)


;(require 'nurbspol)


(print '---------------------------------)
(require 'bool)
(print '---------------------------------)


;-----------------------------------------------------
; Patches

#+:APPLE
(def-logical-directory "patches"  
  (concatenate 'string **simplexn-directory ":patches"))

#+:APPLE
(setf *module-search-path* 
      (append  
       '("patches;")
       *module-search-path*))

(require 'extpatch)
(require 'matinvp)


;(load (concatenate 'string **simplexn-directory 
;                   #+:APPLE
;                   ":developping:"
;                   #+:RS6000
;                   "/developping/"
;                   "update-simplexn.lisp"))

(require 'math_lib)
(require 'join)
(require 'io_ext2)
(require 'f_to_v3)
(require 'extpatch)
(require 'open_set)
;----------------------------------------------------------------

; Start Dumping


#+:APPLE
(when (and **recompile-p (not (boundp '*PLASM-COMPILING*)))
  (save-application   (make-pathname
		       :directory (mac-directory-namestring 
				   (mac-default-directory ))
		       :name "MAC_SimpleXn")))







 















